<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

// #### load required phrase groups ############################################
$phrase['groups'] = array(
        'watchlist',
        'registration',
        'search',
        'stores',
        'wantads',
        'subscription',
        'preferences',
        'buying',
        'selling',
        'rfp',
        'javascript'
);

// #### setup script location ##################################################
define('LOCATION','ajax');
define('SKIP_SESSION', true);

// #### require backend ########################################################
require_once('./functions/config.php');

// #### INLINE TEXT INPUT EDITOR ###############################################
if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'inlineedit' AND !empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
{
        if (isset($ilance->GPC['action']))
        {
                switch ($ilance->GPC['action'])
                {
                        // #### subscription permissions title #################
                        case 'permission_accesstext':
                        {
                                break;
                        }                
                        // #### subscription permissions description ###########
                        case 'permission_description':
                        {
                                break;
                        }
                        
                        // #### favorite search title ##########################
                        case 'favsearchtitle':
                        {
                                $ilance->GPC['text'] = $ilance->common->js_escaped_to_xhtml_entities($ilance->GPC['text']);
                                $ilance->GPC['text'] = $ilance->common->xhtml_entities_to_numeric_entities($ilance->GPC['text']);
                                
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "search_favorites
                                        SET title = '" . $ilance->db->escape_string($ilance->GPC['text']) . "'
                                        WHERE searchid = '" . intval($ilance->GPC['id']) . "'
                                ");
                                
                                echo $ilance->GPC['text'];
                                break;
                        }
                        
                        // #### portfolio title ################################
                        case 'portfoliotitle':
                        {
                                $ilance->GPC['text'] = $ilance->common->js_escaped_to_xhtml_entities($ilance->GPC['text']);
                                $ilance->GPC['text'] = $ilance->common->xhtml_entities_to_numeric_entities($ilance->GPC['text']);
                                
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "portfolio
                                        SET caption = '" . $ilance->db->escape_string($ilance->GPC['text']) . "'
                                        WHERE portfolio_id = '" . intval($ilance->GPC['id']) . "'
                                ");
                                
                                echo $ilance->GPC['text'];
                                break;
                        }
                        
                        // #### seller updating shipment tracking number #######
                        case 'sellershiptracking':
                        {
                                $ilance->GPC['text'] = $ilance->common->js_escaped_to_xhtml_entities($ilance->GPC['text']);
                                $ilance->GPC['text'] = $ilance->common->xhtml_entities_to_numeric_entities($ilance->GPC['text']);
                                
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "projects
                                        SET ship_trackingnumber = '" . $ilance->db->escape_string($ilance->GPC['text']) . "'
                                        WHERE project_id = '" . intval($ilance->GPC['id']) . "'
                                ");
                                
                                echo $ilance->GPC['text'];
                                break;
                        }
                }
                exit();
        }
}

// #### WATCHLIST ##############################################################
if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'watchlist' AND isset($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
{
        $ilance->xml = construct_object('api.xml');
        
        ($apihook = $ilance->api('ajax_watchlist_start')) ? eval($apihook) : false;        
        
	// #### SAVE WATCHLIST ITEM FOR USER ###################################
	if (isset($ilance->GPC['action']) AND $ilance->GPC['action'] == 'savewatchlist')
	{		
	}
	
	// #### SAVE WATCHLIST SUBSCRIPTION PREFERENCES ########################
        if (!empty($ilance->GPC['value']) AND !empty($ilance->GPC['type']))
        {
                $ilance->GPC['value'] = ($ilance->GPC['value'] == 'on' ? 1 : 0);
                $ilance->GPC['type'] = $ilance->GPC['type'];
                switch ($ilance->GPC['type'])
                {
                        case 'lasthour':
                        {
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "watchlist
                                        SET hourleftnotify = '".intval($ilance->GPC['value'])."', subscribed = '1'
                                        WHERE watchlistid = '".intval($ilance->GPC['watchlistid'])."'
                                ");
                                if ($ilance->GPC['value'])
                                {
                                        $ilance->db->query("
                                                UPDATE " . DB_PREFIX . "watchlist
                                                SET subscribed = '1'
                                                WHERE watchlistid = '".intval($ilance->GPC['watchlistid'])."'
                                        ");
                                        $ilance->xml->add_tag('status', 'on');
                                }
                                else
                                {
                                        $ilance->xml->add_tag('status', 'off');
                                }
                                break;
                        }                
                        case 'lowbid':
                        {
                                $sql = $ilance->db->query("
                                        SELECT watching_project_id
                                        FROM " . DB_PREFIX . "watchlist
                                        WHERE watchlistid = '".intval($ilance->GPC['watchlistid'])."'
                                ");
                                if ($ilance->db->num_rows($sql) > 0)
                                {
                                        $res = $ilance->db->fetch_array($sql);
                                        // did this user already place a bid?
                                        $sql2 = $ilance->db->query("
                                                SELECT bidamount
                                                FROM " . DB_PREFIX . "project_bids
                                                WHERE user_id = '".intval($_SESSION['ilancedata']['user']['userid'])."'
                                                        AND project_id = '".$res['watching_project_id']."'
                                                LIMIT 1
                                        ");
                                        if ($ilance->db->num_rows($sql2) > 0)
                                        {
                                                $ilance->db->query("
                                                        UPDATE " . DB_PREFIX . "watchlist
                                                        SET lowbidnotify = '".intval($ilance->GPC['value'])."', subscribed = '1' WHERE watchlistid = '".intval($ilance->GPC['watchlistid'])."'
                                                ");
                                                if ($ilance->GPC['value'])
                                                {
                                                        $ilance->db->query("UPDATE " . DB_PREFIX . "watchlist SET subscribed = '1' WHERE watchlistid = '".intval($ilance->GPC['watchlistid'])."'");
                                                        $ilance->xml->add_tag('status', 'on');
                                                }
                                                else
                                                {
                                                        $ilance->xml->add_tag('status', 'off');
                                                }
                                        }
                                        else
                                        {
                                                $ilance->xml->add_tag('status', $phrase['_sorry_to_track_lower_bid_amounts_you_will_need_to_place_a_bid_on_this_auction_first']);
                                        }
                                }
                                else
                                {
                                        $ilance->xml->add_tag('status', $phrase['_sorry_to_track_lower_bid_amounts_you_will_need_to_place_a_bid_on_this_auction_first']);
                                }
                                break;
                        }                
                        case 'highbid':
                        {
                                $sql = $ilance->db->query("
                                        SELECT watching_project_id
                                        FROM " . DB_PREFIX . "watchlist
                                        WHERE watchlistid = '".intval($ilance->GPC['watchlistid'])."'
                                ");
                                if ($ilance->db->num_rows($sql) > 0)
                                {
                                        $res = $ilance->db->fetch_array($sql);
                                        
                                        $sql2 = $ilance->db->query("
                                                    SELECT bidamount
                                                    FROM " . DB_PREFIX . "project_bids
                                                    WHERE user_id = '".intval($_SESSION['ilancedata']['user']['userid'])."'
                                                            AND project_id = '".$res['watching_project_id']."'
                                                    LIMIT 1
                                        ");
                                        if ($ilance->db->num_rows($sql2) > 0)
                                        {
                                                $ilance->db->query("
                                                        UPDATE " . DB_PREFIX . "watchlist
                                                        SET highbidnotify = '".intval($ilance->GPC['value'])."',
                                                        subscribed = '1'
                                                        WHERE watchlistid = '".intval($ilance->GPC['watchlistid'])."'
                                                ");
                                                if ($ilance->GPC['value'])
                                                {
                                                        $ilance->db->query("
                                                                UPDATE " . DB_PREFIX . "watchlist
                                                                SET subscribed = '1'
                                                                WHERE watchlistid = '".intval($ilance->GPC['watchlistid'])."'
                                                        ");
                                                        $ilance->xml->add_tag('status', 'on');
                                                }
                                                else
                                                {
                                                        $ilance->xml->add_tag('status', 'off');
                                                }
                                        }
                                        else
                                        {
                                                $ilance->xml->add_tag('status', $phrase['_sorry_to_track_higher_bid_amounts_you_will_need_to_place_a_bid_on_this_auction_first']);
                                        }
                                }
                                else
                                {
                                        $ilance->xml->add_tag('status', $phrase['_sorry_to_track_higher_bid_amounts_you_will_need_to_place_a_bid_on_this_auction_first']);
                                }
                                break;
                        }
                        case 'subscribed':
                        {
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "watchlist
                                        SET subscribed = '".intval($ilance->GPC['value'])."'
                                        WHERE watchlistid = '".intval($ilance->GPC['watchlistid'])."'
                                ");
                                if ($ilance->GPC['value'])
                                {
                                        $ilance->xml->add_tag('status', 'on');
                                }
                                else
                                {
                                        $ilance->xml->add_tag('status', 'off');
                                }
                                break;
                        }
                }
                
                $ilance->xml->print_xml();
                exit();
        }
}

// #### ADD LISTING TO WATCHLIST AND SAVE SELLER AS FAVORTE HANDLER ############
if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'addwatchlist' AND isset($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
{
        $ilance->xml = construct_object('api.xml');
        
        ($apihook = $ilance->api('ajax_addwatchlist_start')) ? eval($apihook) : false;        
        
	// #### SAVE WATCHLIST SUBSCRIPTION PREFERENCES ########################
        if (isset($ilance->GPC['userid']) AND !empty($ilance->GPC['userid']) AND $ilance->GPC['userid'] > 0)
        {
                $ilance->watchlist = construct_object('api.watchlist');
                
                if (isset($ilance->GPC['projectid']) AND $ilance->GPC['projectid'] > 0)
                {
                        $success = $ilance->watchlist->insert_item(intval($ilance->GPC['userid']), intval($ilance->GPC['projectid']), 'auction', 'Added from listing page', 0, 0, 0, 0);
                        if ($success)
                        {
                                $ilance->xml->add_tag('status', 'addeditem');
                        }
                        else
                        {
                                $ilance->xml->add_tag('status', 'alreadyaddeditem');        
                        }
                }
                else if (isset($ilance->GPC['sellerid']) AND $ilance->GPC['sellerid'] > 0)
                {
                        $success = $ilance->watchlist->insert_item(intval($ilance->GPC['userid']), intval($ilance->GPC['sellerid']), 'mprovider', 'Added from listing page', 0, 0, 0, 0);
                        if ($success)
                        {
                                $ilance->xml->add_tag('status', 'addedseller');
                        }
                        else
                        {
                                $ilance->xml->add_tag('status', 'alreadyaddedseller');        
                        }
                }
                else
                {
                        $ilance->xml->add_tag('status', 'error');
                }
                
                $ilance->xml->print_xml();
                exit();
        }
}

// #### SEARCH FAVORITES #######################################################
if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'searchfavorites' AND isset($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
{
        $ilance->xml = construct_object('api.xml');
        
        ($apihook = $ilance->api('ajax_searchfavorites_start')) ? eval($apihook) : false;
        
        $ilance->GPC['searchid'] = intval($ilance->GPC['searchid']);
        $ilance->GPC['value'] = ($ilance->GPC['value'] == 'on' ? 1 : 0);
        
        $ilance->db->query("
                UPDATE " . DB_PREFIX . "search_favorites
                SET subscribed = '" . intval($ilance->GPC['value']) . "',
                added = '" . DATETIME24H . "'
                WHERE searchid = '" . intval($ilance->GPC['searchid']) . "'
                        AND user_id = '" . intval($_SESSION['ilancedata']['user']['userid']) . "'
        ");
        if ($ilance->GPC['value'])
        {
                $ilance->xml->add_tag('status', 'on');
        }
        else
        {
                $ilance->xml->add_tag('status', 'off');
        }
        
        $ilance->xml->print_xml();
        exit();
}

// #### ACP AJAX ENHNACEMENTS ##################################################
if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'acpenhancements' AND isset($_SESSION['ilancedata']['user']['isadmin']) AND $_SESSION['ilancedata']['user']['isadmin'])
{
        $ilance->xml = construct_object('api.xml');
        
        ($apihook = $ilance->api('ajax_acpenhancements_start')) ? eval($apihook) : false;
        
        $ilance->GPC['id'] = intval($ilance->GPC['id']);
        $ilance->GPC['value'] = ($ilance->GPC['value'] == 'on' ? 1 : 0);
        $ilance->GPC['type'] = strip_tags($ilance->GPC['type']);
        
        switch ($ilance->GPC['type'])
        {
                case 'featured':
                {
                        $ilance->db->query("
                                UPDATE " . DB_PREFIX . "projects
                                SET featured = '" . intval($ilance->GPC['value']) . "'
                                WHERE project_id = '" . intval($ilance->GPC['id']) . "'
                                LIMIT 1
                        ");
                        break;
                }
                case 'bold':
                {
                        $ilance->db->query("
                                UPDATE " . DB_PREFIX . "projects
                                SET bold = '" . intval($ilance->GPC['value']) . "'
                                WHERE project_id = '" . intval($ilance->GPC['id']) . "'
                                LIMIT 1
                        ");
                        break;
                }
                case 'highlite':
                {
                        $ilance->db->query("
                                UPDATE " . DB_PREFIX . "projects
                                SET highlite = '" . intval($ilance->GPC['value']) . "'
                                WHERE project_id = '" . intval($ilance->GPC['id']) . "'
                                LIMIT 1
                        ");
                        break;
                }
                case 'autorelist':
                {
                        $ilance->db->query("
                                UPDATE " . DB_PREFIX . "projects
                                SET autorelist = '" . intval($ilance->GPC['value']) . "'
                                WHERE project_id = '" . intval($ilance->GPC['id']) . "'
                                LIMIT 1
                        ");
                        break;
                }
        }
        if ($ilance->GPC['value'])
        {
                $ilance->xml->add_tag('status', 'on');
        }
        else
        {
                $ilance->xml->add_tag('status', 'off');
        }
        
        $ilance->xml->print_xml();
        exit();
}

// #### FLASH GALLERY APPLET ###################################################
if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'flashgallery')
{
        ($apihook = $ilance->api('ajax_flashgallery_start')) ? eval($apihook) : false;
        
        switch ($ilance->GPC['config'])
        {
                case 'portfolio':
                {
                        $xml = '<?xml version="1.0"?>
<gallery>
<config>
<big_thumb type="number">80</big_thumb>
<inc_koef type="number">1.1</inc_koef>
<dec_koef type="number">0.9</dec_koef>
<interval_delay type="number">20</interval_delay>
<fade_in_delay type="number">20</fade_in_delay>
<fade_in_step type="number">5</fade_in_step>
<speed_increment type="number">1</speed_increment>
<speed_up_part type="number">0.2</speed_up_part>
<speed_decrement type="number">1</speed_decrement>
<speed_down_part type="number">0.8</speed_down_part>
<speed_delay type="number">7</speed_delay>
<pager_scroll_alpha type="number">4</pager_scroll_alpha>
<show_thumb_after_scroll_delay type="number">25</show_thumb_after_scroll_delay>
<show_thumb_after_scroll_alpha_step type="number">5</show_thumb_after_scroll_alpha_step>
<pager_controls_alpha type="number">30</pager_controls_alpha>
</config>
<items>
' . fetch_flash_gallery_xml_items($ilance->GPC['config']) . '
</items>
</gallery>';
                        break;
                }        
                case 'favoriteseller':
                {
                        $xml = '<?xml version="1.0"?>
<gallery>
<config>
<big_thumb type="number">80</big_thumb>
<inc_koef type="number">1.1</inc_koef>
<dec_koef type="number">0.9</dec_koef>
<interval_delay type="number">20</interval_delay>
<fade_in_delay type="number">20</fade_in_delay>
<fade_in_step type="number">5</fade_in_step>
<speed_increment type="number">1</speed_increment>
<speed_up_part type="number">0.2</speed_up_part>
<speed_decrement type="number">1</speed_decrement>
<speed_down_part type="number">0.8</speed_down_part>
<speed_delay type="number">7</speed_delay>
<pager_scroll_alpha type="number">4</pager_scroll_alpha>
<show_thumb_after_scroll_delay type="number">25</show_thumb_after_scroll_delay>
<show_thumb_after_scroll_alpha_step type="number">5</show_thumb_after_scroll_alpha_step>
<pager_controls_alpha type="number">30</pager_controls_alpha>
</config>
<items>
' . fetch_flash_gallery_xml_items($ilance->GPC['config'], $ilance->GPC['userid']) . '
</items>
</gallery>';
                        break;
                }        
                case 'recentlyviewed':
                {
                        $xml = '<?xml version="1.0"?>
<gallery>
<config>
<big_thumb type="number">80</big_thumb>
<inc_koef type="number">1.1</inc_koef>
<dec_koef type="number">0.9</dec_koef>
<interval_delay type="number">20</interval_delay>
<fade_in_delay type="number">20</fade_in_delay>
<fade_in_step type="number">5</fade_in_step>
<speed_increment type="number">1</speed_increment>
<speed_up_part type="number">0.2</speed_up_part>
<speed_decrement type="number">1</speed_decrement>
<speed_down_part type="number">0.8</speed_down_part>
<speed_delay type="number">7</speed_delay>
<pager_scroll_alpha type="number">4</pager_scroll_alpha>
<show_thumb_after_scroll_delay type="number">25</show_thumb_after_scroll_delay>
<show_thumb_after_scroll_alpha_step type="number">5</show_thumb_after_scroll_alpha_step>
<pager_controls_alpha type="number">30</pager_controls_alpha>
</config>
<items>
' . fetch_flash_gallery_xml_items($ilance->GPC['config']) . '
</items>
</gallery>';
                        break;
                }
        }
        
        echo $xml;
        exit();
}

// #### STATS GALLERY APPLET ###################################################
if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'stats' AND isset($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0 AND isset($ilance->GPC['config']) AND !empty($ilance->GPC['config']))
{
        $xml = '<?xml version="1.0"?>
<chart>
<config>
<axises_space_left type="number">0</axises_space_left>
<axises_space_top type="number">20</axises_space_top>
<axises_space_right type="number">0</axises_space_right>
<axises_space_bottom type="number">45</axises_space_bottom>
<axises_line_thickness type="number">2</axises_line_thickness>
<axises_marks_thickness type="number">1</axises_marks_thickness>
<axises_marks_length type="number">10</axises_marks_length>
<axises_labels_space type="number">2</axises_labels_space>
<axises_labels_font_size type="number">11</axises_labels_font_size>
<axises_color type="hex">0x000000</axises_color>
<axises_bg_grid_color type="hex">0xCCCCCC</axises_bg_grid_color>
<mouse_pointer_thickness type="number">1</mouse_pointer_thickness>
<mouse_pointer_color type="hex">0x0066ff</mouse_pointer_color>
<date_mouse_pointer_color type="hex">0x0066ff</date_mouse_pointer_color>
<date_mouse_pointer_alpha type="number">100</date_mouse_pointer_alpha>
<date_mouse_pointer_distance_axis type="number">2</date_mouse_pointer_distance_axis>
<date_mouse_pointer_distance_x_arrow type="number">7</date_mouse_pointer_distance_x_arrow>
<date_mouse_pointer_distance_y_arrow type="number">7</date_mouse_pointer_distance_y_arrow>
<date_mouse_pointer_label_dx type="number">1</date_mouse_pointer_label_dx>
<date_mouse_pointer_label_dy type="number">10</date_mouse_pointer_label_dy>
<date_mouse_pointer_bg_dx type="number">10</date_mouse_pointer_bg_dx>
<date_mouse_pointer_bg_dy type="number">1</date_mouse_pointer_bg_dy>
<date_mouse_pointer_date_label_color type="hex">0xFFFFFF</date_mouse_pointer_date_label_color>
<value_mouse_pointer_label_color type="hex">0xFFFFFF</value_mouse_pointer_label_color>
<value_mouse_pointer_distance_x_arrow type="number">7</value_mouse_pointer_distance_x_arrow>
<value_mouse_pointer_distance_y_arrow type="number">7</value_mouse_pointer_distance_y_arrow>
<show_all_btn_dx type="number">100</show_all_btn_dx>
<show_all_btn_dy type="number">30</show_all_btn_dy>
<scroll_bg_color type="hex">0x009966</scroll_bg_color>
<scroll_color type="hex">0x3366ff</scroll_color>
<scroll_height type="number">15</scroll_height>
<scroll_space_bottom type="number">20</scroll_space_bottom>
<pin_bg_color type="hex">0x000000</pin_bg_color>
<pin_text_color type="hex">0xFFFFFF</pin_text_color>
<pin_bg_alpha type="number">100</pin_bg_alpha>
<show_dots_after type="number">50</show_dots_after>
<dots_radius type="number">3</dots_radius>
';
        $xml .= fetch_flash_stats_xml_items($ilance->GPC['config']);
        
        echo $xml;
        exit();
}

if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'stats2' AND isset($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
{
        switch ($ilance->GPC['config'])
        {
                case 'connections':
                {
                        $xml = '<?xml version="1.0"?>
<chart>
<config>
<axises_space_left type="number">0</axises_space_left>
<axises_space_top type="number">15</axises_space_top>
<axises_space_right type="number">0</axises_space_right>
<axises_space_bottom type="number">25</axises_space_bottom>
<axises_font_size type="number">10</axises_font_size>
<axises_font_face type="string">Tahoma</axises_font_face>
<axises_font_bold type="boolean">true</axises_font_bold>
<axises_color type="hex">0x444444</axises_color>
<axises_bg_grid_color type="hex">0xCCCCCC</axises_bg_grid_color>

<axises_line_thickness type="number">2</axises_line_thickness>
<axises_marks_thickness type="number">1</axises_marks_thickness>
<axises_marks_length type="number">8</axises_marks_length>
<axises_marks_font_size type="number">10</axises_marks_font_size>
<axises_marks_font_face type="string">Tahoma</axises_marks_font_face>
<axises_marks_font_bold type="boolean">false</axises_marks_font_bold>
<axises_marks_font_color type="hex">0x333333</axises_marks_font_color>

<axises_labels_space type="number">5</axises_labels_space>
<axises_labels_font_size type="number">10</axises_labels_font_size>
<axises_labels_font_face type="string">Verdana</axises_labels_font_face>
<axises_labels_font_bold type="boolean">false</axises_labels_font_bold>

<value_mouse_pointer_label_color type="hex">0xFFFFFF</value_mouse_pointer_label_color>
<value_mouse_pointer_bg_color type="hex">0x004B95</value_mouse_pointer_bg_color>
<value_mouse_pointer_bg_alpha type="number">100</value_mouse_pointer_bg_alpha>
<value_mouse_pointer_distance_x_arrow type="number">7</value_mouse_pointer_distance_x_arrow>
<value_mouse_pointer_distance_y_arrow type="number">7</value_mouse_pointer_distance_y_arrow>
<value_mouse_pointer_space_left type="number">10</value_mouse_pointer_space_left>
<value_mouse_pointer_space_top type="number">10</value_mouse_pointer_space_top>

<value_bar_color1 type="hex">0x99BBDB</value_bar_color1> 
<value_bar_color2 type="hex">0x4A6E7D</value_bar_color2>

<value_bar_alpha1 type="number">100</value_bar_alpha1>
<value_bar_alpha2 type="number">100</value_bar_alpha2>

<value_bar_gradient_spread1 type="number">0</value_bar_gradient_spread1>
<value_bar_gradient_spread2 type="number">255</value_bar_gradient_spread2>

<value_bar_height type="number">10</value_bar_height>
</config>
<items start_date="' . date('Y') . '-' . date('m') . '-' . date('d') . '">
' . fetch_flash_stats_xml_items($ilance->GPC['config']) . '
</items>
</chart>';
                        break;
                }
        }
        
        echo $xml;
        exit();
}

// #### AJAX CATEGORY SELECTOR #################################################
if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'categories' AND isset($ilance->GPC['mode']))
{
        $modetypes = array('service','product');
        if (!in_array($ilance->GPC['mode'], $modetypes))
        {
                return '';
        }
        
        function print_next_category($cid, $box)
        {
                // $cid: is the category id currently being selected in the box by the user
                // $box: is the box (ie: catbox_1) that the category was selected from
                global $ilance, $phrase, $ilconfig;
                
                list($j, $boxnum) = explode('_', $box);
                $boxnum++;
                $newcontent = '';
                
                // if this is a postable category, popuplate the category input field instead of a new box.
                if (is_last_category($cid))
                {                       
                        $objResponse = new xajaxResponse();
                        $objResponse->addScript("window.top.document.forms['ilform'].cid.value = '$cid';"); // outside iframe
                        
                        for ($i = ($boxnum); $i < 11; $i++)
                        {
                                // this resets all boxes after the currently selected on
                                // just in case we're n'th level deep and user decides to click level 2 (hide 3 and onward)
                                $objResponse->addAssign('catbox_' . $i, 'innerHTML', '');
                        }
                        
                        // now add our you've selected a category table!
                        $newcontent = '<div style="padding-top:55px; padding-left:15px; width:200px; font-family: Arial; font-size:13px"><span style="float:left"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'thumbsup.gif" border="0" alt="" /></span>' . $phrase['_youve_selected_a_category_click_continue_button'] . '</div>';
                        $objResponse->addAssign('catbox_' . ($boxnum + 1), 'innerHTML', $newcontent);

                        $categorynode = $ilance->categories->recursive($cid, $ilance->GPC['mode'], $_SESSION['ilancedata']['user']['slng'], $nourls = 1, $customurl = '', $seourls = 0); 
                        $divcontent = '<div style="padding-top:10px; padding-bottom:5px"><strong>' . $phrase['_you_have_selected_the_following_category'] . '</strong></div>' . $categorynode;
                        //$divcontent .= '<div style="padding-top:10px"><table width="25%" border="0" cellpadding="0" cellspacing="0" class="smaller"><tr><td>Proxy Bid: <strong>Deactivated</strong></td><td>Reserve Price: <strong>Allowed</strong></td><td></td><td></td></tr></table></div>';
                        $div2content = '<div style="padding-top:5px"><input type="submit" value="' . $phrase['_continue'] . '" class="buttons" style="font-size:15px" /></div>';
                        
                        $objResponse->addScript("window.top.document.getElementById('selectedcategory').innerHTML = '$divcontent';");
                        $objResponse->addScript("window.top.document.getElementById('categorybutton').innerHTML = '$div2content';");
                        
                        $objResponse->addScript("window.scrollTo(2500,0);"); // scroll our window right for user
                        
                        return $objResponse->getXML();
                }
                
                // selecting the necessary information based on the Category that is being sent to the function.
                $getcats = $ilance->db->query("
                        SELECT cid, title_" . $_SESSION['ilancedata']['user']['slng'] . " AS title
                        FROM " . DB_PREFIX . "categories
                        WHERE parentid = '" . intval($cid) . "'
                                AND parentid != cid
                                AND cattype = '" . $ilance->db->escape_string($ilance->GPC['mode']) . "'
                                AND visible = '1'
                        ORDER BY sort ASC
                ");
                if ($ilance->db->num_rows($getcats))
                {
                        // if there are categories in here, create the selection box to be populated in the table field.
                        $newcontent .= '<select name="catbox_' . $boxnum . '" onchange="xajax_print_next_category(this[this.selectedIndex].value, \'catbox_' . $boxnum . '\')" size="8" style="position: relative; width:215px; height:212px;">';
                        while ($res = $ilance->db->fetch_array($getcats))
                        {
                                $newcontent .= '<option value="' . $res['cid'] . '">' . $res['title'] . '' . (is_last_category($res['cid']) ? '' : ' >') . '</option>';
                        }
                        $newcontent .= '</select>';
                }
                $objResponse = new xajaxResponse();
                
                // assign the next selection box
                $objResponse->addAssign('catbox_' . $boxnum, 'innerHTML', $newcontent); 
                
                for ($i = ($boxnum + 1); $i < 11; $i++)
                {
                        // this resets all other boxes up to the 10th one in case one clicks on a previous box.
                        $objResponse->addAssign('catbox_' . $i, 'innerHTML', '');
                        $objResponse->addScript("window.top.document.getElementById('categorybutton').innerHTML = '';");
                }
                
                $objResponse->addScript("window.scrollTo(2500,0);");
                
                return $objResponse->getXML();
        }
        
        // show categories for the first box.
        $getcats = $ilance->db->query("
                SELECT cid, title_" . $_SESSION['ilancedata']['user']['slng'] . " AS title
                FROM " . DB_PREFIX . "categories
                WHERE parentid = '0'
                        AND cattype = '" . $ilance->db->escape_string($ilance->GPC['mode']) . "'
                        AND visible = '1'
                ORDER BY sort ASC
        ");
        
        // Start the XAJAX code lines to prepare the requests.
        //$xajax = construct_object('api.xajax');
        require_once(DIR_API . 'class.xajax.inc.php');
        $xajax = new xajax();
        
        $xajax->registerFunction('print_next_category');
        $xajax->processRequests();
?>
        <html>
        <head>
        
        <?php $xajax->printJavascript(); ?>
        
        </head>
        <body bgcolor="#ffffff" style="margin:0px; padding:0px">
            
        <table cellpadding="0" cellspacing="0" border="0">
        <tr valign=top>
            <td id="catbox_1">
                
            <select name="catbox_1" onclick="xajax_print_next_category(this[this.selectedIndex].value, 'catbox_1')" style="position: relative; width:215; height:212px;" size="13">
            <?php
            while ($res = $ilance->db->fetch_array($getcats))
            {
                    echo '<option value="' . $res['cid'] . '">' . $res['title'] . '' . (is_last_category($res['cid']) ? '' : ' >') . '</option>';
            }
            ?>
            </select>
            
            </td>
            <td id="catbox_2" style="padding-left:10px"></td>
            <td id="catbox_3" style="padding-left:10px"></td>
            <td id="catbox_4" style="padding-left:10px"></td>
            <td id="catbox_5" style="padding-left:10px"></td>
            <td id="catbox_6" style="padding-left:10px"></td>
            <td id="catbox_7" style="padding-left:10px"></td>
            <td id="catbox_8" style="padding-left:10px"></td>
            <td id="catbox_9" style="padding-left:10px"></td>
            <td id="catbox_10" style="padding-left:10px"></td>
        </tr>
        </table>
        
        </body>
        </html>      
<?php
}

if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'cbcountries' AND isset($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
{
        $sql = $ilance->db->query("
                SELECT locationid, location_" . $_SESSION['ilancedata']['user']['slng'] . " AS title
                FROM " . DB_PREFIX . "locations
                ORDER BY location_" . $_SESSION['ilancedata']['user']['slng'] . " ASC
        ");
        if ($ilance->db->num_rows($sql) > 0)
        {
                $rc = 0;
                while ($res = $ilance->db->fetch_array($sql))
                {
                        $res['class'] = ($rc % 2) ? 'alt2' : 'alt1';
                        $res['cb'] = '<input type="checkbox" name="locationid[]" value="' . $res['locationid'] . '" />';
                        $res['title'] = stripslashes($res['title']);
                        $countries[] = $res;
                        $rc++;
                }
                
                $ilance->template->load_popup('head', 'popup_header.html');
                $ilance->template->load_popup('main', 'ajax_countries.html');
                $ilance->template->load_popup('foot', 'popup_footer.html');
                $ilance->template->parse_loop('main', 'countries');
                $ilance->template->parse_if_blocks('head');
                $ilance->template->parse_if_blocks('main');
                $ilance->template->parse_if_blocks('foot');
                $ilance->template->pprint('head', array('headinclude','onbeforeunload','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','meta_desc','meta_keyw','official_time') );
                $ilance->template->pprint('main', array('headerstyle','bidamounttype','bidamounttype_pulldown','type','amount','fvf','ins','esc','final_conversion','category_pulldown','category_pulldown2','cid','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                $ilance->template->pprint('foot', array('headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','finaltime','finalqueries'));
                exit();
        }
        else
        {
                echo 'Could not fetch country list at this time.';
        }
        
        exit();
}

// #### SKILLS CHECKBOXES ######################################################
if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'cbskills')
{
        $ilance->categories_skills = construct_object('api.categories_skills');
        
        $headinclude .= '
<script language="javascript" type="text/javascript">
<!--
var newArray = new Array();
var selectedskillbit;
var selectedskills;
var skillhiddenfields;
var skillshidden;

window.top.document.getElementById(\'selectedskills\').innerHTML = \'\';
window.top.document.getElementById(\'skillhiddenfields\').innerHTML = \'\';

function add_skill(cid, title)
{
        selectedskillbit = \'<div style="padding-bottom:3px"><span style="float:right; padding-right:10px; padding-top:8px"><input type="submit" value=" ' . $phrase['_search'] . ' " class="buttons" /></span><strong>' . $phrase['_you_have_selected_the_following_skills'] . '</strong></div>\';
        selectedskills = \'\';
        skillhiddenfields = \'\';
        skillshidden = \'\';
        
        if (newArray[cid] != title)
        {
                newArray[cid] = title;
        }
        else if (newArray[cid] == title)
        {
                newArray[cid] = \'\';
        }
        
        for (i = 0; i <= newArray.length; i++)
        {
                skillshidden = \'\';
                if (newArray[i] != undefined && newArray[i] != \'\')
                {
                        if (selectedskills != \'\')
                        {
                                selectedskills = selectedskills + \', <span class="gray">\' + newArray[i] + \'</span>\';
                                skillshidden = \'<input type="hidden" name="sid[\' + i + \']" value="true" />\';
                                skillhiddenfields = skillhiddenfields + skillshidden;
                        }
                        else
                        {
                                selectedskills = \'<span class="gray">\' + newArray[i] + \'</span>\';
                                skillhiddenfields = \'<input type="hidden" name="sid[\' + i + \']" value="true" />\';
                        }
                }
        }
        
        if (selectedskills == \'\')
        {
                window.top.document.getElementById(\'selectedskills\').innerHTML = \'\';
                window.top.document.getElementById(\'skillhiddenfields\').innerHTML = \'\';
        }
        else
        {
                window.top.document.getElementById(\'selectedskills\').innerHTML = selectedskillbit + " " + selectedskills;
                window.top.document.getElementById(\'skillhiddenfields\').innerHTML = skillhiddenfields;
        }
}
//-->
</script>
';
        
        $cbskills = $ilance->categories_skills->print_skills_columns($_SESSION['ilancedata']['user']['slng'], $showcount = 0, $prepopulate = false, $columns = 4, $doajax = true);
        
        $ilance->template->load_popup('head', 'popup_header.html');
        $ilance->template->load_popup('main', 'ajax_skills.html');
        $ilance->template->load_popup('foot', 'popup_footer.html');
        $ilance->template->parse_if_blocks('head');
        //$ilance->template->parse_if_blocks('main');
        $ilance->template->parse_if_blocks('foot');
        $ilance->template->pprint('head', array('headinclude','onbeforeunload','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','meta_desc','meta_keyw','official_time') );
        $ilance->template->pprint('main', array('cbskills','headerstyle','bidamounttype','bidamounttype_pulldown','type','amount','fvf','ins','esc','final_conversion','category_pulldown','category_pulldown2','cid','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
        $ilance->template->pprint('foot', array('headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','finaltime','finalqueries'));
        exit();
        
        echo $cbskills;
        exit();
}

// #### QUICK REGISTRATION #####################################################
if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'quickregister' AND isset($ilance->GPC['qusername']) AND isset($ilance->GPC['qpassword']) AND isset($ilance->GPC['qemail']))
{
        // some check ups
        $unicode_name = preg_replace('/&#([0-9]+);/esiU', "convert_int2utf8('\\1')", $ilance->GPC['qusername']);
        $unicode_email = preg_replace('/&#([0-9]+);/esiU', "convert_int2utf8('\\1')", $ilance->GPC['qemail']);
                
        // username ban checkup
        if ($ilance->common->is_username_banned($ilance->GPC['qusername']) OR $ilance->common->is_username_banned($unicode_name))
        {
                echo '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'infowarning3.gif" border="0" alt="" /> ' . date('h:i A') . ': <strong>' . $phrase['_registration_problem'] . '</strong>: ' . $phrase['_that_username_is_currently_banned'];
                exit();
        }
        
        // username check
        $sqlusercheck = $ilance->db->query("
                SELECT *
                FROM " . DB_PREFIX . "users
                WHERE username IN ('" . addslashes(htmlspecialchars_uni($ilance->GPC['qusername'])) . "', '" . addslashes(htmlspecialchars_uni($unicode_name)) . "')
        ");
        if ($ilance->db->num_rows($sqlusercheck) > 0)
        {
                echo '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'infowarning3.gif" border="0" alt="" /> ' . date('h:i A') . ': <strong>' . $phrase['_registration_problem'] . '</strong>: ' . $phrase['_that_username_already_exists_in_our_system'];
                exit();
        }
        
        // email address check
        $sqlemailcheck = $ilance->db->query("
                SELECT *
                FROM " . DB_PREFIX . "users
                WHERE email IN ('" . addslashes(htmlspecialchars_uni($ilance->GPC['qemail'])) . "', '" . addslashes(htmlspecialchars_uni($unicode_email)) . "')
        ");
        if ($ilance->db->num_rows($sqlemailcheck) > 0)
        {
                echo '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'infowarning3.gif" border="0" alt="" /> ' . date('h:i A') . ': <strong>' . $phrase['_registration_problem'] . '</strong>: ' . $phrase['_that_email_address_already_exists_in_our_system'];
                exit();
        }
        
        if (isset($ilance->GPC['qemail']) AND isset($ilance->GPC['qemail2']) AND $ilance->GPC['qemail'] != $ilance->GPC['qemail2'])
        {
                echo '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'infowarning3.gif" border="0" alt="" /> ' . date('h:i A') . ': <strong>' . $phrase['_registration_problem'] . '</strong>: ' . $phrase['_email_addresses_do_not_match'];
                exit();
        }
        
        // final email checks (check mx record, check list of banned free emails, etc)
        if ($ilance->common->is_email_banned(trim($ilance->GPC['qemail'])) OR $ilance->common->is_email_valid(trim($ilance->GPC['qemail'])) == false)
        {
                echo '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'infowarning3.gif" border="0" alt="" /> ' . date('h:i A') . ': <strong>' . $phrase['_registration_problem'] . '</strong>: ' . $phrase['_it_appears_this_email_address_is_banned_from_the_marketplace_please_try_another_email_address'];
                exit();
        }
        
        // email is good check if it's duplicate
        $sqlemailcheck = $ilance->db->query("
                SELECT *
                FROM " . DB_PREFIX . "users
                WHERE email = '" . $ilance->db->escape_string($ilance->GPC['qemail']) . "'
        ");
        if ($ilance->db->num_rows($sqlemailcheck) > 0)
        {
                echo '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'infowarning3.gif" border="0" alt="" /> ' . date('h:i A') . ': <strong>' . $phrase['_registration_problem'] . '</strong>: ' . $phrase['_that_email_address_already_exists_in_our_system'];
                exit();
        }
        
        // set new member defaults
        $user = array();
        $subscription = array();
        $preferences = '';
        
        $user['roleid'] = '-1';
        $user['username'] = trim($ilance->GPC['qusername']);
        $user['password'] = $ilance->GPC['qpassword'];
        $user['secretquestion'] = $phrase['_what_is_my_email_address'];
        $user['secretanswer'] = md5($ilance->GPC['qemail']);
        $user['email'] = $ilance->GPC['qemail'];
        $user['firstname'] = $phrase['_unknown'];
        $user['lastname'] = $phrase['_unknown'];
        $user['address'] = $phrase['_unknown'];
        $user['city'] = $phrase['_unknown'];
        $user['state'] = $phrase['_unknown'];
        $user['zipcode'] = $phrase['_unknown'];
        $user['phone'] = '+0';
        $user['countryid'] = '500';
        $user['styleid'] = $_SESSION['ilancedata']['user']['styleid'];
        
        // we must tell the registration system what plan to set as default!
        if (isset($ilance->GPC['subscriptionid']))
        {
                $subscription['subscriptionid'] = intval($ilance->GPC['subscriptionid']);
                // we SHOULD still verify if this plan exists..
        }
        else
        {
                // we should change this to search any available subscriptions (free ones first if applicable)
                $subscription['subscriptionid'] = '1';
        }
        
        if (isset($ilance->GPC['subscriptionpaymethod']))
        {
                // ilance has defined a payment method somewhere in a form..
                $subscription['subscriptionpaymethod'] = $ilance->GPC['subscriptionpaymethod'];
        }
        else
        {
                // when coming from quick register, set default pay method to online account balance
                $subscription['subscriptionpaymethod'] = 'account';
        }
        
        $subscription['promocode'] = '';
    
        // construct registration system
        $ilance->registration = construct_object('api.registration');
        
        $questions = array();
        
        $final = $ilance->registration->build_user_datastore($user, $preferences, $subscription, $questions, 'return_userarray');
        if (!empty($final))
        {
                // set new members cookies
                set_cookie('userid', $ilance->crypt->three_layer_encrypt($final['userid'], $ilconfig['key1'], $ilconfig['key2'], $ilconfig['key3']), true);
                set_cookie('username', $ilance->crypt->three_layer_encrypt($final['username'], $ilconfig['key1'], $ilconfig['key2'], $ilconfig['key3']), true);
                set_cookie('password', $ilance->crypt->three_layer_encrypt($final['password'], $ilconfig['key1'], $ilconfig['key2'], $ilconfig['key3']), true);
                set_cookie('lastvisit', DATETIME24H, true);
                set_cookie('lastactivity', DATETIME24H, true);
                
                switch ($final['status'])
                {
                        case 'active':
                        {
                                // make sure we have a valid password session
                                if (!empty($_SESSION['ilancedata']['user']['password_md5']))
                                {
                                        $_SESSION['ilancedata']['user']['password'] = $_SESSION['ilancedata']['user']['password_md5'];
                                        session_unregister($_SESSION['ilancedata']['user']['password_md5']);
                                }
                                
                                // display final registration information
                                echo '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/picture.gif" border="0" alt="" /> ' . date('h:i A') . ': <strong>' . $phrase['_registration_complete'] . '</strong>';
                                exit();
                                break;        
                        }
                        case 'unverified':
                        {
                                // display email link code information
                                echo '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/picture.gif" border="0" alt="" /> ' . date('h:i A') . ': <strong>' . $phrase['_registration_not_completed'] . '</strong><div style="padding-top:4px">' . $phrase['_thank_you_for_registering_an_email_has_been_dispatched_to_you'] . '</div>';
                                exit();
                                break;
                        }
                }
        }
        else
        {
                echo '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'infowarning3.gif" border="0" alt="" /> ' . date('h:i A') . ': <strong>' .  $phrase['_registration_problem'] . '</strong>: ' . $phrase['_sorry_there_was_a_problem_completing_your_registration_we_apologize'];
                exit();
        }
}

// #### SEARCH PAGE PROFILE FILTER CATEGORY RESULTS ############################
if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'profilefilters')
{
        global $phrase;
        
        $ilance->auction = construct_object('api.auction');
        $ilance->auction_post = construct_object('api.auction_post');
        
        $cid = 0;
        if (isset($ilance->GPC['cid']) AND $ilance->GPC['cid'] > 0)
        {
                $cid = intval($ilance->GPC['cid']);
        }
        
        echo '<div id="profile_filters_text">' . $ilance->auction_post->print_profile_bid_filters($cid, 'input', 'service') . '</div>';
        exit();
}

if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'autocomplete')
{
        //return '';

        global $ilance, $phrase;
        
        function arrfilter(&$item)
        {
                global $ilance;
                
                return preg_match('/^' . utf8_decode($ilance->GPC['q']) . '/', $item);
        }
        
        $xmlDoc  = '<?xml version="1.0" encoding="utf-8"?>';
        $xmlDoc .= '<root>';
        
        if (isset($ilance->GPC['q']) AND !empty($ilance->GPC['q']))
        {
                $available = array();
                
                $sql = $ilance->db->query("
                        SELECT keyword
                        FROM " . DB_PREFIX . "search
                        WHERE count > 10
                                AND keyword LIKE '%" . $ilance->db->escape_string($ilance->GPC['q']) . "%'
                        GROUP BY keyword
                ");
                if ($ilance->db->num_rows($sql) > 0)
                {
                        while ($res = $ilance->db->fetch_array($sql))
                        {
                                $available[] = $res['keyword'];
                        }
                }
                
                $available = array_unique($available);
                $results = array_filter($available, 'arrfilter');
                
                $i = 0;
                foreach ($results AS $key => $label)
                {
                        if ($i <= 10)
                        {
                                $labelformatted = str_replace($ilance->GPC['q'], '<span class="blue"><strong>' . $ilance->GPC['q'] . '</strong></span>', $label);
                                $labelformatted = '<div style="width:353px; padding-top:2px; padding-bottom:2px; padding-left:2px; cursor: hand">' . $labelformatted . '</div>';
                                $xmlDoc .= '<item id="' . $i . '" label="' . ilance_htmlentities($labelformatted) . '" text="' . ilance_htmlentities($label) . '"></item>';
                        }
                        $i++;
                }
        }
        
        $xmlDoc .= '</root>';
        
        header('Content-type: application/xml; charset="' . $ilconfig['template_charset'] . '"');
        echo $xmlDoc;
        exit();
}


// #### REFRESH PROJECT DETAIL PAGE ############################################
if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'refreshprojectdetails' AND isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0)
{
        $ilance->auction = construct_object('api.auction');
        $ilance->auction_expiry = construct_object('api.auction_expiry');
        $ilance->bid = construct_object('api.bid');
        $ilance->subscription = construct_object('api.subscription');
        
        $ilance->GPC['id'] = intval($ilance->GPC['id']);
        
        // run listing expiry logic
        $ilance->auction_expiry->listings();
        
        $timeleft = $ilance->auction->auction_timeleft($ilance->GPC['id'], 'alt1', 'center', $timeintext = 0, $showlivebids = 0, $forcenoflash = 1, $showfullformat = 1);
        $cid = fetch_auction('cid', $ilance->GPC['id']);
        $userid = fetch_auction('user_id', $ilance->GPC['id']);
        $status = fetch_auction('status', $ilance->GPC['id']);
        $bid_details = fetch_auction('bid_details', $ilance->GPC['id']);
        $winner_user_id = fetch_auction('winner_user_id', $ilance->GPC['id']);
        $bids = fetch_auction('bids', $ilance->GPC['id']);
        $declinedbids = $ilance->bid->fetch_declined_bids($ilance->GPC['id']);
        $retractedbids = $ilance->bid->fetch_retracted_bids($ilance->GPC['id']);
        
        $fetchbidstuff = $ilance->bid->fetch_average_lowest_highest_bid_amounts($bid_details, $ilance->GPC['id'], $userid);
        $bidprivacy = $fetchbidstuff['bidprivacy'];
        $average = $ilance->bid->fetch_average_bid($ilance->GPC['id'], false, $bid_details, false);
        $lowest = $fetchbidstuff['lowest'];
        $highest = $fetchbidstuff['highest'];
        unset($fetchbidstuff);
        
        $showplacebidrow = 1;
        $showawardedbidderrow = 0;
        $showendedrow = 0;
        $showlowestactivebidder = 0;
        
        if ($bids > 0)
        {
                // fetch lowest bidder details (will populate $show['lowbidder_active'] also)..
                $lowbidtemp = $ilance->bid->fetch_lowest_bidder_info($ilance->GPC['id'], $userid, $bid_details);
                $lowestbiddertext = $lowbidtemp['lowbidder'];
                if ($show['lowbidder_active'])
                {
                        $showlowestactivebidder = 1;       
                }
                unset($lowbidtemp);
                                
                // awarded bidder username
                $awardedbiddertext = '';
                if ($winner_user_id > 0)
                {
                        $showawardedbidderrow = 1;
                        $awardedbiddertext = fetch_user('username', $winner_user_id);
                        if ($bid_details == 'blind' OR $bid_details == 'full')
                        {
                                $awardedbiddertext = '= ' . $phrase['_blind_bidder'] . ' =';        
                        }
                }
                
                // highest bidder username
                $highestbiddertext = '';
                $highbidderuserid = $ilance->bid->fetch_highest_bidder($ilance->GPC['id']);
                if ($highbidderuserid > 0)
                {
                        $highestbiddertext = fetch_user('username', $highbidderuserid);
                        if ($bid_details == 'blind' OR $bid_details == 'full')
                        {
                                $highestbiddertext = '= ' . $phrase['_blind_bidder'] . ' =';        
                        }
                }
                unset($highbidderuserid);
                
                if ($bid_details == 'sealed' OR $bid_details == 'full')
                {
                        $lowest = '= ' . $phrase['_sealed'] . ' =';
                        $highest = '= ' . $phrase['_sealed'] . ' =';
                }
        }
        else
        {
                $lowestbiddertext = $highestbiddertext = $awardedbiddertext = '';
        }
        
        if ($status != 'open')
        {
                $showplacebidrow = 0;
                $showendedrow = 1;
                $timeleft = $phrase['_ended'];
                
                $date_end = fetch_auction('date_end', $ilance->GPC['id']);
                
                switch ($status)
                {
                        case 'closed':
                        {
                                $projectstatus = $phrase['_closed_since'] . ' ' . print_date($date_end, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 1, 0);
                                break;
                        }				
                        case 'expired':
                        {
                                $projectstatus = $phrase['_expired_since'] . ' ' . print_date($date_end, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 1, 0);
                                break;
                        }				
                        case 'delisted':
                        {
                                $projectstatus = $phrase['_delisted_since'] . ' ' . print_date($date_end, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 1, 0);
                                break;
                        }				
                        case 'approval_accepted':
                        {
                                $projectstatus = $phrase['_vendor_awarded_bidding_for_event_closed'];
                                break;
                        }                        
                        case 'wait_approval':
                        {
                                // fetch days since the provider has been awarded giving more direction to the viewer
                                $close_date = fetch_auction('close_date', $ilance->GPC['id']);
                                $date1split = explode(' ', $close_date);
                                $date2split = explode('-', $date1split[0]);
                                $days = $ilance->datetime->fetch_days_between($date2split[1], $date2split[2], $date2split[0], gmdate('m'), gmdate('d'), gmdate('Y'));
                                if ($days == 0)
                                {
                                        $days = 1;
                                }
                                
                                $projectstatus = $phrase['_waiting_for_awarded_provider_to_accept_the_project'] . ' <div class="smaller gray">(' . $phrase['_day'] . ' ' . $days . ' ' . $phrase['_of'] . ' ' . $ilconfig['servicebid_awardwaitperiod'] . ')</div>';
                                break;
                        }				
                        case 'frozen':
                        {
                                $projectstatus = $phrase['_frozen_event_temporarily_closed'];
                                break;
                        }
                        case 'finished':
                        {
                                $projectstatus = $phrase['_vendor_awarded_event_is_finished'];
                                break;
                        }				
                        case 'archived':
                        {
                                $projectstatus = $phrase['_archived_event'];
                                break;
                        }				
                        case 'draft':
                        {
                                $projectstatus = $phrase['_draft_mode_pending_post_by_owner'];
                                break;
                        }
                }
        }
        else
        {
                $projectstatus = $phrase['_event_open_for_bids'];        
        }
        
        // myString[0]  = timeleft text
        // myString[1]  = bids text
        // myString[2]  = lowest bidder name
        // myString[3]  = highest bidder name
        // myString[4]  = awarded bidder name
        // myString[5]  = average bid amount
        // myString[6]  = project status text
        // myString[7]  = number of declined bids
        // myString[8]  = number of retracted bids
        // myString[9]  = SHOW place a bid row?
        // myString[10] = SHOW awarded bidder row?
        // myString[11] = SHOW block header as ended listing?
        // myString[12] = lowest bid amount
        // myString[13] = highest bid amount
        // myString[14] = SHOW lowest active bidder row?
        
        //   |timeleft    |bids         |ILance                   |mom                       |ILance                    |S$ 18.50        |Ended                 |0                    |0                     |1                       |0                            |0                    |$100.00        |$500.00         |1
        echo $timeleft . '|' . $bids . '|' . $lowestbiddertext . '|' . $highestbiddertext . '|' . $awardedbiddertext . '|' . $average . '|' . $projectstatus . '|' . $declinedbids . '|' . $retractedbids . '|' . $showplacebidrow . '|' . $showawardedbidderrow . '|' . $showendedrow . '|' . $lowest . '|' . $highest . '|' . $showlowestactivebidder;
        exit();
}

// #### REFRESH ITEM DETAIL PAGE ###############################################
if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'refreshitemdetails' AND isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0 AND isset($ilance->GPC['type']) AND !empty($ilance->GPC['type']))
{
        $ilance->auction = construct_object('api.auction');
        $ilance->auction_expiry = construct_object('api.auction_expiry');
        $ilance->bid = construct_object('api.bid');
        $ilance->subscription = construct_object('api.subscription');
        
        // run listing expiry logic
        $ilance->auction_expiry->listings();
        
        $timeleft = $ilance->auction->auction_timeleft(intval($ilance->GPC['id']), 'alt1', 'center', $timeintext = 0, $showlivebids = 0, $forcenoflash = 1, $showfullformat = 1);
        $cid = fetch_auction('cid', intval($ilance->GPC['id']));
        $userid = fetch_auction('user_id', intval($ilance->GPC['id']));
        $purchases = fetch_buynow_ordercount(intval($ilance->GPC['id']));
        
        switch ($ilance->GPC['type'])
        {
                case 'regular':
                {
                        $winningbidder = $winningbid = '';
                        $showwinningbidderrow = $hidebuynowrow = $hideplacebidrow = $showblockheaderended = $hidebuynowactionrow = '0';
                        
                        $status = fetch_auction('status', intval($ilance->GPC['id']));
                        if ($status != 'open')
                        {
                                $showblockheaderended = '1';
                                $hideplacebidrow = '1';
                                $hidebuynowactionrow = '1';
                                $timeleft = $phrase['_ended'];
                                
                                if ($ilance->bid->has_winning_bidder(intval($ilance->GPC['id'])))
                                {
                                        $winningbidder = '';
                                        $winningbidderid = $ilance->bid->fetch_highest_bidder(intval($ilance->GPC['id']));
                                        if ($winningbidderid > 0)
                                        {
                                                $showwinningbidderrow = '1';
                                                $winningbidder = print_username($winningbidderid, 'href', 0, '', '');
                                                
                                                $winningbid = $ilance->bid->fetch_awarded_bid_amount(intval($ilance->GPC['id']));
                                                $winningbid = $ilance->currency->format($winningbid);
                                        }
                                        else
                                        {
                                                
                                        }
                                }
                        }
                        
                        $bids = fetch_auction('bids', intval($ilance->GPC['id']));
                        $startprice = fetch_auction('startprice', intval($ilance->GPC['id']));
                        $startprice_temp = $startprice;
                        $currentbid = fetch_auction('currentprice', intval($ilance->GPC['id']));
                        $isreserve = fetch_auction('reserve', intval($ilance->GPC['id']));
                        $reserve_price = fetch_auction('reserve_price', intval($ilance->GPC['id']));
                        
                        $buynow = fetch_auction('buynow', intval($ilance->GPC['id']));
                        $buynow_price = fetch_auction('buynow_price', intval($ilance->GPC['id']));
                        $buynow_qty = fetch_auction('buynow_qty', intval($ilance->GPC['id']));
                        
                        if ($bids > 0 AND $currentbid > $startprice)
                        {
                                $startprice = '';
                                $currentbid = $ilance->currency->format($currentbid);
                        }
                        else if ($bids > 0 AND $currentbid == $startprice)
                        {
                                $startprice = '';
                                $currentbid = $ilance->currency->format($currentbid);        
                        }
                        else
                        {
                                $startprice = $ilance->currency->format($startprice);
                                $currentbid = '';        
                        }
                        
                        // fetch highest bidder username
                        $highbidder = '';
                        $highbidderid = $ilance->bid->fetch_highest_bidder(intval($ilance->GPC['id']));
                        if ($highbidderid > 0)
                        {
                                $highbidder = print_username($highbidderid, 'href', 0, '', '');
                        }
                        
                        $reservetext = $highest_amount = '';
                        if ($isreserve)
                        {
                                $sql = $ilance->db->query("
                                        SELECT MAX(bidamount) AS highest
                                        FROM " . DB_PREFIX . "project_bids
                                        WHERE project_id = '" . intval($ilance->GPC['id']) . "'
                                        ORDER BY highest
                                        LIMIT 1
                                ");
                                if ($ilance->db->num_rows($sql) > 0)
                                {
                                        $res = $ilance->db->fetch_array($sql);
                
                                        if ($res['highest'] >= $reserve_price)
                                        {
                                                //$hidebuynowrow = '1';
                                                $reservetext = $phrase['_yes_reserve_price_met'];
                                        }
                                        else
                                        {
                                                $reservetext = '<span style="color:#ff6600">' . $phrase['_no_reserve_price_not_met'] . '</span>';
                                        }
                                }
                                else
                                {
                                        $reservetext = '<span style="color:#ff6600">' . $phrase['_no_reserve_price_not_met'] . '</span>';
                                }
                        }
                        else
                        {
                                if ($currentbid != '' AND $bids > 0)
                                {
                                        // no reserve price but bids more than 0 so hide buy now functionality and let the bidding wars begin
                                        //$hidebuynowrow = '1';                
                                }
                        }
                        
                        if ($buynow == 0 OR $buynow_qty <= 0)
                        {
                                $hidebuynowrow = '1';
                        }
                        
                        // #### bid increments in this category ################
                        $increment = '';
                        $cbid = $ilance->bid->fetch_current_bid(intval($ilance->GPC['id']), $noformat = 1);
                        $slng = fetch_user_slng($userid);
                        
                        $ilance->categories->build_array($cattype = 'product', $slng, $mode = 0, $propersort = true);
                        
                        $incrementgroup = $ilance->categories->fetch[$slng]['product'][$cid]['incrementgroup'];
                        $sqlincrements = $ilance->db->query("
                                SELECT amount
                                FROM " . DB_PREFIX . "increments
                                WHERE ((increment_from <= $cbid
                                        AND increment_to >= $cbid)
                                                OR (increment_from < $cbid
                                        AND increment_to < $cbid))
                                        AND groupname = '" . $ilance->db->escape_string($incrementgroup) . "'
                                ORDER BY amount DESC
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($sqlincrements) > 0)
                        {
                                $resincrement = $ilance->db->fetch_array($sqlincrements);
                        }
                        
                        $min_bidamount = sprintf("%.02f", '0.01');
                        $min_bidamountformatted = $ilance->currency->format('0.01');
                        $highestbid = 0;
                                        
                        if ($bids <= 0)
                        {
                                // do we have starting price?
                                if ($startprice_temp > 0)
                                {
                                        $min_bidamount = sprintf("%.02f", $startprice_temp);
                                        $min_bidamountformatted = $ilance->currency->format($startprice_temp);
                                }
                        }
                        else if ($bids > 0)
                        {
                                // highest bid amount placed for this auction
                                $highbid = $ilance->db->query("
                                        SELECT MAX(bidamount) AS maxbidamount
                                        FROM " . DB_PREFIX . "project_bids
                                        WHERE project_id = '" . intval($ilance->GPC['id']) . "'
                                ", 0, null, __FILE__, __LINE__);
                                if ($ilance->db->num_rows($highbid) > 0)
                                {
                                        $reshighbid = $ilance->db->fetch_array($highbid);
                                        $highestbid = sprintf("%.02f", $reshighbid['maxbidamount']);
                                }
                                
                                // if we have more than 1 bid start the bid increments since the first bidder cannot bid against the opening bid
                                if (isset($resincrement['amount']) AND !empty($resincrement['amount']) AND $resincrement['amount'] > 0)
                                {
                                        $min_bidamount = sprintf("%.02f", $highestbid + $resincrement['amount']);
                                        $min_bidamountformatted = $ilance->currency->format($highestbid + $resincrement['amount']);
                                }
                                else
                                {
                                        $min_bidamount = sprintf("%.02f", $highestbid);
                                        $min_bidamountformatted = $ilance->currency->format($highestbid);
                                }
                        }
                        
                        // timeleft       |bids         |US$ 5.00           |US$ 15.00          |Reserve Price Met   |US$ 18.50                      |18.50                 |purchases         |highest bidder     |hidebuynowrow=1 or 0  |hidebuynowactionrow=1 or 0  |0|hidehighbidderrow=1 or 0|0|hideplacebidrow=1 or 0       |0|hideuniqueplacebidrow=1 or 0 |showwinningbidderrow=1 or 0|showuniquewinningbidderrow=1 or 0|showblockheaderended=1 or 0|winning bid amount
                        echo $timeleft . '|' . $bids . '|' . $startprice . '|' . $currentbid . '|' . $reservetext . '|' . $min_bidamountformatted . '|' . $min_bidamount . '|' . $purchases . '|' . $highbidder . '|' . $hidebuynowrow . '|' . $hidebuynowactionrow . '|0|' . $hideplacebidrow . '|0|' . $showwinningbidderrow . '|0|' . $showblockheaderended . '|' . $winningbid;
                        break;
                }        
                case 'fixed':
                {
                        $status = fetch_auction('status', intval($ilance->GPC['id']));
                        $hidebuynowrow = $showblockheaderended = 0;
                        if ($status != 'open')
                        {
                                $hidebuynowrow = 1;
                                $showblockheaderended = '1';
                        }
                        echo $timeleft . '|' . $purchases . '|' . $hidebuynowrow . '|' . $showblockheaderended;
                        break;
                }        
                case 'unique':
                {
                        $ilance->bid_lowest_unique = construct_object('api.bid_lowest_unique');
                        
                        $status = fetch_auction('status', intval($ilance->GPC['id']));
                        
                        $retailprice = $ilance->currency->format(fetch_auction('retailprice', intval($ilance->GPC['id'])));
                        $bids = $ilance->bid_lowest_unique->fetch_bid_count(intval($ilance->GPC['id']));
                        $bidsuntilend = fetch_auction('uniquebidcount', intval($ilance->GPC['id']));
                        $bidsleft = 0;
                        if ($bids > 0 AND $bidsuntilend > 0)
                        {
                                $bidsleft = $bidsuntilend - $bids;
                                if ($bidsleft < 0)
                                {
                                        $bidsleft = 0;
                                }
                        }
                        
                        $uniquewinner = $winningbid = '';
                        $showblockheaderended = $showwinningbidderrow = '0';
                        if (($status != 'open') OR ($bidsuntilend > 0 AND $bids > 0 AND $bids == $bidsleft))
                        {
                                $showblockheaderended = '1';
                                $timeleft = $phrase['_ended'];
                                if ($ilance->bid_lowest_unique->has_unique_bid_winner(intval($ilance->GPC['id'])))
                                {
                                        $showwinningbidderrow = '1';
                                        $uniquewinner = $ilance->bid_lowest_unique->fetch_lowest_unique_bid_winner(intval($ilance->GPC['id']));
                                        $winningbid = $ilance->bid_lowest_unique->fetch_lowest_unique_bid_winner_amount(intval($ilance->GPC['id']), true);
                                }
                        }
                        
                        echo $timeleft . '|' . $bids . '|' . $retailprice . '|' . $bidsleft . '|' . $showblockheaderended . '|' . $showwinningbidderrow . '|' . $uniquewinner . '|' . $winningbid;
                        break;
                }
        }
        exit();
}

// #### SHOW STATES BASED ON COUNTRIES #########################################
if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'showstates' AND isset($ilance->GPC['countryname']) AND !empty($ilance->GPC['countryname']))
{
        global $phrase;
        
	$locationid = fetch_country_id($ilance->GPC['countryname'], $_SESSION['ilancedata']['user']['slng']);
        $html = construct_state_pulldown($locationid);
	
        echo $html;
        exit();
}

// handle %u0000 character conversion
// $description = convert_urlencoded_unicode($description);

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: ajax.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>