<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

// #### setup script location ##################################################
define('LOCATION','attachment');

@ini_set('zlib.output_compression', 'Off');
if (@ini_get('output_handler') == 'ob_gzhandler' AND @ob_get_length() !== false)
{	
	@ob_end_clean();
	header('Content-Encoding:');
}

if (!empty($_SERVER['HTTP_IF_MODIFIED_SINCE']) OR !empty($_SERVER['HTTP_IF_NONE_MATCH']))
{
	// fetch sapi result
	$sapi_name = php_sapi_name();
	if ($sapi_name == 'cgi' OR $sapi_name == 'cgi-fcgi')
	{
		header('Status: 304 Not Modified');
	}
	else
	{
		header('HTTP/1.1 304 Not Modified');
	}
        
	header('Content-Type:');
	header('X-Powered-By:');
        
	if (!empty($_REQUEST['id']))
	{
		header('Etag: "' . $_REQUEST['id'] . '"');
	}
        
	exit();
}

require_once('./functions/config.php');
require_once(DIR_CORE . 'functions_attachment.php');

($apihook = $ilance->api('attachment_start')) ? eval($apihook) : false;

// captcha
if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'captcha')
{
        ($apihook = $ilance->api('attachment_captcha_start')) ? eval($apihook) : false;
        
        print_captcha(5);
}
else
{
        // we don't want the connection activity logging any attachment activity
        define('SKIP_SESSION', true);
}

$ilance->GPC['attachmentid'] = 0;
if (isset($ilance->GPC['crypted']) AND !empty($ilance->GPC['crypted']))
{
	// do we have an attachment id?
	// this would be for members that download digital file attachments
	// so we'll add some extra encryption to the url ..
	$ilance->GPC['uncrypted'] = decrypt_url($ilance->GPC['crypted']);
	if ($ilance->GPC['uncrypted']['id'] > 0)
	{
		$ilance->GPC['id'] = intval($ilance->GPC['uncrypted']['id']);
	}
}

if (isset($ilance->GPC['id']) AND !empty($ilance->GPC['id']))
{
        if (mb_strlen($ilance->GPC['id']) == 32)
        {
                // use new more improved hash method
                $ilance->GPC['attachmentid'] = $ilance->GPC['id'];
                $wheresql = "filehash = '" . $ilance->db->escape_string($ilance->GPC['attachmentid']) . "'";
        }
        else
        {
                // use old method of serving attachment ids
                $ilance->GPC['attachmentid'] = intval($ilance->GPC['id']);
                $wheresql = "attachid = '" . intval($ilance->GPC['attachmentid']) . "'";
        }
}
else
{
        $sapi_name = php_sapi_name();
        if ($sapi_name == 'cgi' OR $sapi_name == 'cgi-fcgi')
        {
                header('Status: 404 Not Found');
        }
        else
        {
                header('HTTP/1.1 404 Not Found');
        }
        
        exit();
}

$ilance->GPC['cmd'] = isset($ilance->GPC['cmd']) ? $ilance->GPC['cmd'] : '';
$ilance->GPC['subcmd'] = isset($ilance->GPC['subcmd']) ? $ilance->GPC['subcmd'] : '';

// update attachment view counter
$ilance->db->query("
        UPDATE " . DB_PREFIX . "attachment
        SET counter = counter + 1
        WHERE $wheresql
        LIMIT 1
");

// #### BEGIN ATTACHMENT LOGIC #################################################
$sql = $ilance->db->query("
        SELECT filename, filetype, filesize, filehash, filedata, filetype, attachtype, project_id, user_id, isexternal
        FROM " . DB_PREFIX . "attachment
        WHERE $wheresql
        LIMIT 1
");
if ($ilance->db->num_rows($sql) > 0)
{
        $attachment = $ilance->db->fetch_array($sql);        
        $attachment['filedata'] = fetch_attachment_rawdata($attachment, $attachment['isexternal']);
        
        // #### THUMBNAIL ITEM #################################################
        if ($ilance->GPC['cmd'] == 'thumb')
        {
                $thumbnail = construct_object('api.phpthumb');
                
                if ($attachment['isexternal'])
                {
                        $thumbnail->sourceFilename = $attachment['filedata'];
                }
                else
                {
                        $thumbnail->rawImageData = $attachment['filedata'];
                }
                
                // thumbnails formatted for admincp defined sizes
                switch ($ilance->GPC['subcmd'])
                {
                        // search result listings
                        case 'results':
                        {
                                $ilance->GPC['w'] = isset($ilance->GPC['w']) ? intval($ilance->GPC['w']) : $ilconfig['attachmentlimit_searchresultsmaxwidth'];
                                $ilance->GPC['h'] = isset($ilance->GPC['h']) ? intval($ilance->GPC['h']) : $ilconfig['attachmentlimit_searchresultsmaxheight'];
                                
                                $thumbnail->w = $ilance->GPC['w'];
                                $thumbnail->h = $ilance->GPC['h'];
                                break;
                        }                
                        // portfolio listings
                        case 'portfolio':
                        {
                                $ilance->GPC['w'] = isset($ilance->GPC['w']) ? intval($ilance->GPC['w']) : $ilconfig['attachmentlimit_portfoliothumbwidth'];
                                $ilance->GPC['h'] = isset($ilance->GPC['h']) ? intval($ilance->GPC['h']) : $ilconfig['attachmentlimit_portfoliothumbheight'];
                                
                                $thumbnail->w = $ilance->GPC['w'];
                                $thumbnail->h = $ilance->GPC['h'];
                                break;
                        }
                        // everything else                
                        default:
                        {
                                $ilance->GPC['w'] = isset($ilance->GPC['w']) ? intval($ilance->GPC['w']) : $ilconfig['attachmentlimit_thumbnailmaxwidth'];
                                $ilance->GPC['h'] = isset($ilance->GPC['h']) ? intval($ilance->GPC['h']) : $ilconfig['attachmentlimit_thumbnailmaxheight'];
                                
                                $thumbnail->w = $ilance->GPC['w'];
                                $thumbnail->h = $ilance->GPC['h'];
                                break;
                        }
                }
                
                // thumbnail image quality
                $thumbnail->q = 95;
                $thumbnail->usa = 160;
                $thumbnail->iar = 0;
                
                // thumbnail output format
                $thumbnail->config_output_format = 'jpeg';
                $thumbnail->config_error_die_on_error = false;
                
                if ($thumbnail->GenerateThumbnail())
                {
                        header('Cache-control: max-age=31536000');
                        header('Expires: ' . gmdate("D, d M Y H:i:s", TIMESTAMPNOW + 31536000) . ' GMT');
                        header('Last-Modified: ' . gmdate('D, d M Y H:i:s', TIMESTAMPNOW) . ' GMT');
                        header('ETag: "' . $ilance->GPC['attachmentid'] . '"');
                        header("Content-disposition: inline; filename=\"" . $attachment['filename'] . "\"");
                        header('Content-transfer-encoding: binary');
                        
                        if (!empty($attachment['filetype']))
                        {
                                header('Content-type: ' . $attachment['filetype']);
                        }
                        else
                        {
                                header('Content-type: unknown/unknown');        
                        }
                        
                        $thumbnail->OutputThumbnail();
                }                
        }
        
        // #### PROFILE LOGO ###################################################
        else if ($ilance->GPC['cmd'] == 'profile')
        {
                $im = imagecreatefromstring($attachment['filedata']);
                
                $width = imagesx($im);
                $height = imagesy($im);
                
                $thumb = imagecreatetruecolor($width, $height);
                
                // resize the image
                imagecopyresized($thumb, $im, 0, 0, 0, 0, $width, $height, imagesx($im), imagesy($im));
                
                // output thumbnail
                if (imagetypes() & IMG_GIF) 
                {
                        header("Content-type: image/gif");
                        $out = imagegif($thumb);
                }
                else if (imagetypes() & IMG_JPG) 
                {
                        header("Content-type: image/jpeg");
                        $out = imagejpeg($thumb);
                }
                else if (imagetypes() & IMG_PNG) 
                {
                        header("Content-type: image/png");
                        $out = imagepng($thumb);
                }
                else if (imagetypes() & IMG_WBMP) 
                {
                        header("Content-type: image/vnd.wap.wbmp");
                        $out = imagewbmp($thumb);
                }
                
                header('Cache-control: max-age=31536000');
                header('Expires: ' . gmdate("D, d M Y H:i:s", TIMESTAMPNOW + 31536000) . ' GMT');
                header('Last-Modified: ' . gmdate('D, d M Y H:i:s', TIMESTAMPNOW) . ' GMT');
                header('ETag: "' . $ilance->GPC['attachmentid'] . '"');
                header("Content-disposition: inline; filename=\"" . $attachment['filename'] . "\"");
                header('Content-transfer-encoding: binary');
                
                if (!empty($attachment['filetype']))
                {
                        header('Content-type: ' . $attachment['filetype']);
                }
                else
                {
                        header('Content-type: unknown/unknown');        
                }
                
                echo $out;
                
                imagedestroy($im);
                imagedestroy($thumb);
        }
        
        // #### PORTFOLIO ITEM #################################################
        else if ($ilance->GPC['cmd'] == 'portfolio')
        {
                header('Cache-control: max-age=31536000');
                header('Expires: ' . gmdate("D, d M Y H:i:s", TIMESTAMPNOW + 31536000) . ' GMT');
                header('Last-Modified: ' . gmdate('D, d M Y H:i:s', TIMESTAMPNOW) . ' GMT');
                header('ETag: "' . $ilance->GPC['attachmentid'] . '"');
                header("Content-disposition: inline; filename=\"" . $attachment['filename'] . "\"");
                header('Content-transfer-encoding: binary');
                
                if (!empty($attachment['filetype']))
                {
                        header('Content-type: ' . $attachment['filetype']);
                }
                else
                {
                        header('Content-type: unknown/unknown');        
                }
                
                echo $attachment['filedata'];
        }
        
        // #### EVERYTHING ELSE ################################################
        else
        {
                $canviewattachment = true;
                
                // is this attachment associated with any auction bids?
                // if so we must check to see if the auction in question is sealed or blind
                // and if this is the case we deny access to the attachment if the viewer
                // does not meet necessary requirements (is not owner, is not uploader or is not admin)
                if ($attachment['project_id'] > 0)
                {
                        // fetch the project owner id
                        $attachment['project_owner_id'] = fetch_project_ownerid($attachment['project_id']);
                        
                        // is this a workspace attachment?
                        if ($attachment['attachtype'] == 'ws')
                        {
                                // fetch the project winner id
                                $attachment['project_winner_id'] = fetch_project_winnerid($attachment['project_id']);
                                
                                // are we allowed to view digital download?
                                $canviewattachment = false;
                                
                                // does the viewing user have access to download the attachment?
                                if ((!empty($_SESSION['ilancedata']['user']['userid'])
                                        // project owner
                                        AND $_SESSION['ilancedata']['user']['userid'] == $attachment['project_owner_id']
                                        // attachment upload user
                                        OR !empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] == $attachment['user_id']
                                        // awarded winner (product or service)
                                        OR !empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] == $attachment['project_winner_id']
                                        // administrator
                                        OR $_SESSION['ilancedata']['user']['isadmin'] == '1'))
                                {
                                        // attachment is a workspace attachment and we've passed the checkup
                                        // we are most likely the owner or admin viewing
                                        // so we'll allow the attachment to be downloaded
                                        $canviewattachment = true;
                                        
                                        if (is_private_workspace_attachment(intval($ilance->GPC['attachmentid'])))
                                        {
                                                // because this attachment is private we should only be
                                                // the uploader or admin!
                                                $canviewattachment = false;
                                                
                                                if ((!empty($_SESSION['ilancedata']['user']['userid'])
                                                        // attachment upload user
                                                        AND $_SESSION['ilancedata']['user']['userid'] == $attachment['user_id']
                                                        // administrator
                                                        OR $_SESSION['ilancedata']['user']['isadmin'] == '1'))
                                                {
                                                        $canviewattachment = true;
                                                }
                                        }
                                }
                        }
                        
                        // is this a digital download attachment?
                        else if ($attachment['attachtype'] == 'digital')
                        {
                                // fetch the project winner id
                                $attachment['project_winner_id'] = fetch_project_winnerid($attachment['project_id']);
                                
                                // are we allowed to view digital download?
                                $canviewattachment = false;
                                
                                // does the viewing user have access to download the attachment?
                                if ((!empty($_SESSION['ilancedata']['user']['userid'])
                                        // project winner
                                        AND $_SESSION['ilancedata']['user']['userid'] == $attachment['project_winner_id']
                                        // project owner
                                        OR !empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] == $attachment['project_owner_id']
                                        // attachment upload user
                                        OR !empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] == $attachment['user_id']
                                        // administrator
                                        OR $_SESSION['ilancedata']['user']['isadmin'] == '1'))
                                {
                                        // attachment is a digital download and we've passed the checkup
                                        // we are most likely the owner or admin viewing
                                        // so we'll allow the attachment to be downloaded
                                        $canviewattachment = true;
                                }
                        }
                        // for everything else (will check if sealed and/or is invite only auction)
                        else
                        {
                                // is this an attachment uploaded by a project owner?
                                if ($attachment['project_owner_id'] > 0)
                                {
                                        // this is an attachment uploaded by a project owner
                                        // we will now check what type of security this auction has such as sealed bids and/or if auction is invite only
                                        // if the auction is invite only the attachments can only be downloaded by the owner, admin and registered invited user(s) (not email invited users)
                                        
                                        // is this a sealed or blind bid auction?
                                        if (is_sealed_auction($attachment['project_id']))
                                        {
                                                $canviewattachment = false;
                                                
                                                // auction event with this bid is sealed or blind
                                                // does the viewing user have access to download the attachment?
                                                if ((!empty($_SESSION['ilancedata']['user']['userid'])
							AND $_SESSION['ilancedata']['user']['userid'] == $attachment['user_id']
                                                                OR $_SESSION['ilancedata']['user']['userid'] == $attachment['project_owner_id']
                                                                OR $_SESSION['ilancedata']['user']['isadmin'] == '1'))
                                                {
                                                        // auction is sealed or blind and we've passed the checkup
                                                        // we are most likely the owner or uploader or admin viewing
                                                        // so we'll allow the attachment to be downloaded
                                                        $canviewattachment = true;
                                                }
                                        }
                                        // is this an invite only auction?
                                        else if (is_inviteonly_auction($attachment['project_id']))
                                        {
                                                $canviewattachment = false;
                                                $attachment['invitedusers'] = array();
                                                
                                                // fetch users invited for this specific auction id
                                                $invited = $ilance->db->query("
                                                        SELECT seller_user_id AS userid
                                                        FROM " . DB_PREFIX . "project_invitations
                                                        WHERE project_id = '" . $attachment['project_id'] . "'
                                                                AND seller_user_id > 0
                                                ");
                                                if ($ilance->db->num_rows($invited) > 0)
                                                {
                                                        while ($resinvited = $ilance->db->fetch_array($invited))
                                                        {
                                                                // build the user invited array to compare against below
                                                                $attachment['invitedusers'][] = $resinvited['userid'];
                                                        }
                                                }
                                                unset($resinvited, $invited);
                                                
                                                // does the viewing user have access to download the attachment?
                                                if ((!empty($_SESSION['ilancedata']['user']['userid'])
							AND $_SESSION['ilancedata']['user']['userid'] == $attachment['user_id']
                                                                OR $_SESSION['ilancedata']['user']['userid'] == $attachment['project_owner_id']
                                                                OR $_SESSION['ilancedata']['user']['isadmin'] == '1'
                                                                OR in_array($_SESSION['ilancedata']['user']['userid'], $attachment['invitedusers'])))
                                                {
                                                        // auction is invite only and we've passed the checkup
                                                        // we are most likely the owner, admin or a invited user viewing
                                                        // so we'll allow the attachment to be downloaded
                                                        $canviewattachment = true;
                                                }
                                        }
                                        else
                                        {
                                                // since this bid does not appear to be placed on a sealed or blind or invite only auction we will let the attachment be downloaded
                                                $canviewattachment = true;
                                        }
                                }	
                        }
                }
                
                if ($canviewattachment)
                {
                        $ext = fetch_extension($attachment['filename']);
                        
                        $isIE = iif($ilance->common->is_webbrowser('ie') OR $ilance->common->is_webbrowser('opera'), true, false);
                        if ($isIE)
                        {
                                $filetype = 'application/octetstream';
                        }
                        else
                        {
                                $filetype = 'application/octet-stream';
                        }
                        
                        if ($ilance->common->is_webbrowser('mozilla'))
                        {
                                $attachment['filename'] = "filename*=utf-8''" . rawurlencode($attachment['filename']);
                        }
                        else
                        {
                                $attachment['filename'] = 'filename="' . rawurlencode($attachment['filename']) . '"';
                        }
                        
                        header('Content-type: ' . $filetype);
                        header('Cache-control: max-age=31536000');
                        header('Expires: ' . gmdate("D, d M Y H:i:s", TIMESTAMPNOW + 31536000) . ' GMT');
                        header('Last-Modified: ' . gmdate('D, d M Y H:i:s', TIMESTAMPNOW) . ' GMT');
                        header('ETag: "' . $ilance->GPC['attachmentid'] . '"');
                        header('Content-Length: ' . mb_strlen($attachment['filedata']));
                        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                        header('Pragma: public');
                        
                        // which image extentions can we view inline?
                        if (in_array($ext, array('jpg', 'jpe', 'jpeg', 'gif', 'png')))
                        {
                                // display images inline
                                header('Content-disposition: inline; ' . $attachment['filename']);
                        }
                        else
                        {
                                // force files to be downloaded
                                header('Content-disposition: attachment; ' . $attachment['filename']);
                        }
                        
                        echo $attachment['filedata'];        
                }
                
                // look's like we cannot view this attachment!
                // download attachment_denied.txt located in the ./uploads/ folder.
                else
                {
                        $attachment['filename'] = 'attachment_denied.txt';
                        $attachment['filedata'] = file_get_contents(DIR_UPLOADS . $attachment['filename']);
                        
                        $isIE = iif($ilance->common->is_webbrowser('ie') OR $ilance->common->is_webbrowser('opera'), true, false);
                        if ($isIE)
                        {
                                $filetype = 'application/octetstream';
                        }
                        else
                        {
                                $filetype = 'application/octet-stream';
                        }
                        
                        if ($ilance->common->is_webbrowser('mozilla'))
                        {
                                $attachment['filename'] = "filename*=utf-8''" . rawurlencode($attachment['filename']);
                        }
                        else
                        {
                                $attachment['filename'] = 'filename="' . rawurlencode($attachment['filename']) . '"';
                        }
                        
                        header('Content-type: ' . $filetype);
                        header('Cache-control: max-age=31536000');
                        header('Expires: ' . gmdate("D, d M Y H:i:s", TIMESTAMPNOW + 31536000) . ' GMT');
                        header('Last-Modified: ' . gmdate('D, d M Y H:i:s', TIMESTAMPNOW) . ' GMT');
                        header('ETag: "' . $ilance->GPC['attachmentid'] . '"');
                        header('Content-Length: ' . mb_strlen($attachment['filedata']));
                        header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
                        header('Pragma: public');
                        header('Content-disposition: attachment; ' . $attachment['filename']);
                        
                        echo $attachment['filedata'];
                }        
        }
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: attachment.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>