<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

// #### load required phrase groups ############################################
$phrase['groups'] = array(
    'rfp',
    'buying',
    'selling',
    'search',
    'feedback'
);

// #### define top header nav ##################################################
$topnavlink = array(
        'feedback'
);

// #### setup script location ##################################################
define('LOCATION','feedback');

// #### require backend ########################################################
require_once('./functions/config.php');

// #### setup default breadcrumb ###############################################
$navcrumb = array("$ilpage[feedback]" => $ilcrumbs["$ilpage[feedback]"]);

$uncrypted = '';
if (isset($ilance->GPC['crypted']) AND !empty($ilance->GPC['crypted']))
{
        $uncrypted = decrypt_url($ilance->GPC['crypted']);
}

// #### LEAVE FEEDBACK #########################################################
if (isset($uncrypted['cmd']) AND $uncrypted['cmd'] == '_leave-feedback' AND isset($uncrypted['type']) AND isset($uncrypted['project_id']) AND $uncrypted['project_id'] > 0 AND isset($uncrypted['for_user_id']) AND $uncrypted['for_user_id'] > 0 AND isset($uncrypted['from_user_id']) AND $uncrypted['from_user_id'] > 0 AND !empty($_SESSION['ilancedata']['user']['userid']))
{
        $area_title = $phrase['_feedback_and_rating_process'];
        $page_title = SITE_NAME . ' - ' . $phrase['_feedback_and_rating_process'];
    
        $ilance->bid = construct_object('api.bid');
        $ilance->feedback = construct_object('api.feedback');
    
        $project_id = intval($uncrypted['project_id']);
        $for_user_id = intval($uncrypted['for_user_id']);
        $from_user_id = intval($uncrypted['from_user_id']);
        $from_type = $uncrypted['type'];
        
        if ($from_type == 'buyer')
        {
                $seller_id = $from_user_id;
                $buyer_id = $for_user_id;
                $from_type_reverse = 'seller';
        }
        else if ($from_type == 'seller')
        {
                $seller_id = $for_user_id;
                $buyer_id = $from_user_id;
                $from_type_reverse = 'buyer';
        }
        
        $project_title = fetch_auction('project_title', $project_id);
        $project_state = fetch_auction('project_state', $project_id);
        $filtered_auctiontype = fetch_auction('filtered_auctiontype', $project_id);
    
        // fetch trading partner name            
        if ($_SESSION['ilancedata']['user']['userid'] == $for_user_id)
        {
                $customer = fetch_user('username', $from_user_id);
        }
        else if ($_SESSION['ilancedata']['user']['userid'] == $from_user_id)
        {
                $customer = fetch_user('username', $for_user_id);
        }
        
        // fetch total payment amount for the awarded bid
        
        // is this feedback for a buynow product item?
        if ($filtered_auctiontype == 'fixed' AND $project_state == 'product')
        {
                // this item may be a buynow or regular fixed priced auction
                // do we have any buynow orders for this user? also, we'll select the mos recent order in case
                // this buyer has already purchased 1 or more qty of this exact same item in the past to ensure
                // we don't grab the value from the original buy now order purchase
                $sql = $ilance->db->query("
                        SELECT qty
                        FROM " . DB_PREFIX . "buynow_orders
                        WHERE project_id = '" . intval($project_id) . "'
                            AND owner_id = '" . intval($seller_id) . "'
                            AND buyer_id = '" . intval($buyer_id) . "'
                        ORDER BY orderid DESC
                        LIMIT 1
                ");
                if ($ilance->db->num_rows($sql) > 0)
                {
                        // we do so lets find out the actual cost of this item for the qty ordered!
                        // and do not include shipping!
                        $res = $ilance->db->fetch_array($sql);
                        
                        $buynowprice = fetch_auction('buynow_price', $project_id);
                        $totalamount = sprintf("%01.2f", ($buynowprice * $res['qty']));
                }
                else
                {
                        $totalamount = $ilance->bid->fetch_awarded_bid_amount($project_id);
                }
        }
        else
        {
                $totalamount = $ilance->bid->fetch_awarded_bid_amount($project_id);
        }
            
        $posres = $neures = $negres = '';
        
        if (!empty($_SESSION['ilancedata']['user']['fbresponse']))
        {
                if ($_SESSION['ilancedata']['user']['fbresponse'] == 'positive')
                {
                        $posres = 'selected="selected"';
                }
                else if ($_SESSION['ilancedata']['user']['fbresponse'] == 'neutral')
                {
                        $neures = 'selected="selected"';
                }
                else if ($_SESSION['ilancedata']['user']['fbresponse'] == 'negative')
                {
                        $negres = 'selected="selected"';
                }
                
                $responsepulldown = '
                <select name="response" style="font-family: verdana">
                   <option value="positive" ' . $posres . '>' . $phrase['_postive'] . ' ' . $phrase['_experience'] . ' (+1)</option>
                   <option value="neutral" ' . $neures . '>' . $phrase['_neutral'] . ' ' . $phrase['_experience'] . ' (0)</option>
                   <option value="negative" ' . $negres . '>' . $phrase['_negative'] . ' ' . $phrase['_experience'] . ' (-1)</option>
                </select>';
        }
        else
        {
                $responsepulldown = '
                <select name="response" style="font-family: verdana">
                   <option value="positive">' . $phrase['_postive'] . ' ' . $phrase['_experience'] . ' (+1)</option>
                   <option value="neutral">' . $phrase['_neutral'] . ' ' . $phrase['_experience'] . ' (0)</option>
                   <option value="negative">' . $phrase['_negative'] . ' ' . $phrase['_experience'] . ' (-1)</option>
                </select>';
        }
                
        $criteria = $ilance->feedback->criteria(0, $_SESSION['ilancedata']['user']['slng']);
            
        $ilance->template->load_file('main', 'feedback.html');
        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
        $ilance->template->parse_loop('main', 'criteria');
        $ilance->template->parse_if_blocks('main');
        $ilance->template->pprint('main', array('for_user_id','from_user_id','from_type_reverse','responsepulldown','totalamount','project_title','customer','project_id','seller_id','buyer_id','from_type','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
        exit();
}

// #### LEAVE FEEDBACK PREVIEW #################################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_do-feedback-preview' AND isset($ilance->GPC['type']) AND isset($ilance->GPC['project_id']) AND $ilance->GPC['project_id'] > 0 AND isset($ilance->GPC['for_user_id']) AND $ilance->GPC['for_user_id'] > 0 AND isset($ilance->GPC['from_user_id']) AND $ilance->GPC['from_user_id'] > 0 AND !empty($_SESSION['ilancedata']['user']['userid']))
{
	$area_title = $phrase['_feedback_and_rating_preview'];
	$page_title = SITE_NAME . ' - ' . $phrase['_feedback_and_rating_preview'];
	
        $ilance->feedback = construct_object('api.feedback');
        
	$project_id = intval($ilance->GPC['project_id']);
        $for_user_id = intval($ilance->GPC['for_user_id']);
	$from_user_id = intval($ilance->GPC['from_user_id']);
	$from_type = $ilance->GPC['type'];
	$response = isset($ilance->GPC['response']) ? $ilance->GPC['response'] : 'neutral';
        $project_title = fetch_auction('project_title', $project_id);
	
	// fetch trading partner name            
        if ($_SESSION['ilancedata']['user']['userid'] == $for_user_id)
        {
                $customer = fetch_user('username', $from_user_id);
        }
        else if ($_SESSION['ilancedata']['user']['userid'] == $from_user_id)
        {
                $customer = fetch_user('username', $for_user_id);
        }
	
	// detailed feedback ratings
        $hiddenfields = print_hidden_fields($string = false, $excluded = array('cmd','comments','project_id','for_user_id','from_user_id','type','response'), $questionmarkfirst = false);
        
        $criteriapreview = "";
        if (isset($ilance->GPC['type']) AND $ilance->GPC['type'] == 'seller')
        {
                $criteriapreview .= "<ul>";
                foreach ($ilance->GPC['criteria'] as $id => $rating)
                {
                        $criteriapreview .= "<li>" . $ilance->feedback->fetch_title($id) . ": <strong>$rating</strong></li>";        
                }
                $criteriapreview .= "</ul>";
        }

        if (empty($ilance->GPC['comments']))
        {
                // user tries to skip feedback comments
                print_notice($phrase['_you_forgot_to_leave_feedback'], $phrase['_in_order_to_keep_an_active_track_record_of_the_feedback_for_your_profile'], "javascript:history.back()", $phrase['_return_to_previous_page']);
                exit();
        }
        
        // feedback comments
        $feedback_comments = stripslashes($ilance->GPC['comments']);
            
        // overall response
        $previewresponse = ucfirst($response) . ' ' . $phrase['_experience'];
        
        $ilance->template->load_file('main', 'feedback_preview.html');
        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
        $ilance->template->parse_if_blocks('main');
        $ilance->template->pprint('main', array('hiddenfields','criteriapreview','for_user_id','from_user_id','previewtotalamount','response','previewresponse','quality_rating','delivery_rating','professionalism_rating','responsiveness_rating','price_rating','feedback_comments','project_title','customer','project_id','seller_id','buyer_id','from_type','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
        exit();
}

// #### LEAVE FEEDBACK HANDLER #################################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_do-feedback-submit' AND isset($ilance->GPC['type']) AND isset($ilance->GPC['project_id']) AND $ilance->GPC['project_id'] > 0 AND isset($ilance->GPC['for_user_id']) AND $ilance->GPC['for_user_id'] > 0 AND isset($ilance->GPC['from_user_id']) AND $ilance->GPC['from_user_id'] > 0 AND !empty($_SESSION['ilancedata']['user']['userid']))
{
	$area_title = $phrase['_feedback_and_rating_submit_process'];
	$page_title = SITE_NAME . ' - ' . $phrase['_feedback_and_rating_submit_process'];

        $project_id = intval($ilance->GPC['project_id']);
        $for_user_id = intval($ilance->GPC['for_user_id']);
	$from_user_id = intval($ilance->GPC['from_user_id']);
        $project_title = fetch_auction('project_title', $project_id);
	$from_type = strip_tags(stripslashes($ilance->GPC['type']));
	$response = strip_tags(stripslashes($ilance->GPC['response']));
        
        $criteria = ((isset($ilance->GPC['criteria']) AND is_array($ilance->GPC['criteria'])) ? $ilance->GPC['criteria'] : array());
        
        // fetch trading partner name            
        if ($_SESSION['ilancedata']['user']['userid'] == $for_user_id)
        {
                $customer = fetch_user('username', $from_user_id);
        }
        else if ($_SESSION['ilancedata']['user']['userid'] == $from_user_id)
        {
                $customer = fetch_user('username', $for_user_id);
        }
	
	// feedback comments / review
	$comments = stripslashes(strip_tags($ilance->GPC['comments']));
	
	$ilance->feedback = construct_object('api.feedback');
	$ilance->feedback_rating = construct_object('api.feedback_rating');
        $success = $ilance->feedback_rating->insert_feedback_rating($project_id, $for_user_id, $from_user_id, $criteria, $comments, $from_type, $response);
        if ($success)
        {
                if (!empty($_SESSION['ilancedata']['user']['fbresponse']))
                {
                        session_unregister($_SESSION['ilancedata']['user']['fbresponse']);
                        unset($_SESSION['ilancedata']['user']['fbresponse']);
                }
                
                print_notice($phrase['_feedback_and_rating_complete'], $phrase['_thank_you_for_taking_a_few_moments_to_rate_this_customer_and_provide_feedback_for_others_to_review']."<br /><br />".$phrase['_please_contact_customer_support'], $ilpage['main'].'?cmd=cp', $phrase['_my_cp']);
                exit();
        }
        else
        {
                if (!empty($_SESSION['ilancedata']['user']['fbresponse']))
                {
                        session_unregister($_SESSION['ilancedata']['user']['fbresponse']);
                        unset($_SESSION['ilancedata']['user']['fbresponse']);
                }
                
                print_notice($phrase['_feedback_and_rating_complete'], $phrase['_feedback_already_submitted__thank_you'], $ilpage['main'] . '?cmd=cp', $phrase['_my_cp']);
                exit();
        }

}
else
{
	$area_title = $phrase['_view_feedback_and_reviews_error'];
	$page_title = SITE_NAME . ' - ' . $phrase['_view_feedback_and_reviews_error'];
        
	print_notice($phrase['_invalid_feedback_user_id'], $phrase['_were_sorry_you_did_not_specify_a_valid_vendor_or_buyer_id'].'</p>', $ilpage['feedback'], $phrase['_return_to_the_previous_menu']);
	exit();
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: feedback.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>