<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

if (!class_exists('auction'))
{
	exit;
}

/**
* Auction award class to perform the majority of functions dealing with anything to do with listing expiry within ILance.
*
* @package      iLance
* @version	$Revision: 1.0.0 $
* @author       ILance
*/
class auction_expiry extends auction
{
        function all()
        {
                global $ilance, $phrase, $ilconfig, $ilpage;
                
                $cronlog = $this->listings();
                $cronlog .= $this->other();
                
                return $cronlog;
        }
        
        function listings_expired_to_finished()
        {
                global $ilance, $phrase, $ilconfig, $ilpage;
                
                $ilance->feedback = construct_object('api.feedback');
                $ilance->accounting = construct_object('api.accounting');
                $ilance->bid = construct_object('api.bid');
                $ilance->bid_lowest_unique = construct_object('api.bid_lowest_unique');
                $ilance->email = construct_dm_object('email', $ilance);
                
                $cronlog = '';
                
                // #### EXPIRED AUCTIONS ESCROW CHECKUP ########################
                if ($ilconfig['escrowsystem_enabled'])
                {
                        // product
                        $sql_items = $ilance->db->query("
                                SELECT filter_escrow, project_id
                                FROM " . DB_PREFIX . "projects
                                WHERE project_state = 'product'
                                    AND status = 'expired'
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($sql_items) > 0)
                        {
                                while ($res_items = $ilance->db->fetch_array($sql_items))
                                {
                                        if ($res_items['filter_escrow'])
                                        {
                                                // is this escrow finished?
                                                $sql_esc = $ilance->db->query("
                                                        SELECT project_id
                                                        FROM " . DB_PREFIX . "projects_escrow
                                                        WHERE date_paid != '0000-00-00 00:00:00'
                                                            AND status = 'finished'
                                                            AND project_id = '" . $res_items['project_id'] . "'
                                                ", 0, null, __FILE__, __LINE__);
                                                if ($ilance->db->num_rows($sql_esc) > 0)
                                                {
                                                        while ($res_esc = $ilance->db->fetch_array($sql_esc))
                                                        {
                                                                // is feedback process finished?
                                                                if ($ilance->feedback->is_feedback_complete($res_esc['project_id']))
                                                                {
                                                                        // update auction as finished
                                                                        $ilance->db->query("
                                                                                UPDATE " . DB_PREFIX . "projects
                                                                                SET status = 'finished'
                                                                                WHERE project_id = '".$res_esc['project_id']."'
                                                                                    AND project_state = 'product'
                                                                                    AND (status != 'archived' OR status != 'delisted')
                                                                        ", 0, null, __FILE__, __LINE__);
                                                                        
                                                                        $cronlog .= '';
                                                                }                                                
                                                        }
                                                }		
                                        }
                                }
                                unset($res_items);
                        }
                    
                        // service
                        $sql_proj = $ilance->db->query("
                                SELECT filter_escrow, project_id
                                FROM " . DB_PREFIX . "projects
                                WHERE project_state = 'service'
                                    AND status = 'expired'
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($sql_proj) > 0)
                        {
                                while ($res_projs = $ilance->db->fetch_array($sql_proj))
                                {
                                        if ($res_projs['filter_escrow'])
                                        {
                                                // is this escrow finished?
                                                $sql_projesc = $ilance->db->query("
                                                        SELECT project_id
                                                        FROM " . DB_PREFIX . "projects_escrow
                                                        WHERE date_paid != '0000-00-00 00:00:00'
                                                            AND status = 'finished'
                                                            AND project_id = '" . $res_projs['project_id'] . "'
                                                ", 0, null, __FILE__, __LINE__);
                                                if ($ilance->db->num_rows($sql_projesc) > 0)
                                                {
                                                        while ($res_projesc = $ilance->db->fetch_array($sql_projesc))
                                                        {
                                                                // is feedback process finished?
                                                                if ($ilance->feedback->is_feedback_complete($res_projesc['project_id']))
                                                                {
                                                                        // update auction as finished
                                                                        $ilance->db->query("
                                                                                UPDATE " . DB_PREFIX . "projects
                                                                                SET status = 'finished'
                                                                                WHERE project_id = '" . $res_projesc['project_id'] . "'
                                                                                    AND project_state = 'service'
                                                                                    AND (status != 'archived' OR status != 'delisted')
                                                                        ", 0, null, __FILE__, __LINE__);
                                                                        
                                                                        $cronlog .= '';
                                                                }
                                                        }
                                                        unset($res_projesc);
                                                }
                                        }
                                }
                                unset($res_projs);
                        }
                }
                else
                {
                        // escrows disabled: check for expired product auctions so we can learn
                        // what is going on with the feedback between both members
                        $sql_items = $ilance->db->query("
                                SELECT project_id 
                                FROM " . DB_PREFIX . "projects
                                WHERE status = 'expired'
                                    AND project_state = 'product'
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($sql_items) > 0)
                        {
                                while ($res_items = $ilance->db->fetch_array($sql_items))
                                {
                                        // is feedback complete?
                                        if ($ilance->feedback->is_feedback_complete($res_items['project_id']))
                                        {
                                                // set auction to finished
                                                $ilance->db->query("
                                                        UPDATE " . DB_PREFIX . "projects
                                                        SET status = 'finished'
                                                        WHERE project_id = '" . $res_items['project_id'] . "'
                                                            AND project_state = 'product'
                                                            AND (status != 'archived' OR status != 'delisted')
                                                ", 0, null, __FILE__, __LINE__);
                                                
                                                $cronlog .= '';
                                        }
                                }
                                unset($res_items);
                        }
                    
                        // expired service auction checkup
                        $sql_proj = $ilance->db->query("
                                SELECT project_id
                                FROM " . DB_PREFIX . "projects
                                WHERE status = 'expired'
                                        AND project_state = 'service'
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($sql_proj) > 0)
                        {
                                while ($res_projs = $ilance->db->fetch_array($sql_proj))
                                {
                                        // is feedback complete?
                                        if ($ilance->feedback->is_feedback_complete($res_projs['project_id']))
                                        {
                                                // update auction as finished
                                                $ilance->db->query("
                                                        UPDATE " . DB_PREFIX . "projects
                                                        SET status = 'finished'
                                                        WHERE project_id = '" . $res_projs['project_id'] . "'
                                                            AND project_state = 'service'
                                                            AND (status != 'archived' OR status != 'delisted')
                                                ", 0, null, __FILE__, __LINE__);
                                                
                                                $cronlog .= '';
                                        }
                                }
                                unset($res_projs);
                        }
                }
                
                return $cronlog;
        }
        
        function listings()
        {
                global $ilance, $phrase, $ilconfig, $ilpage;
                
                $ilance->feedback = construct_object('api.feedback');
                $ilance->accounting = construct_object('api.accounting');
                $ilance->bid = construct_object('api.bid');
                $ilance->bid_lowest_unique = construct_object('api.bid_lowest_unique');
                $ilance->email = construct_dm_object('email', $ilance);
                
                $cronlog = '';
                
                $sql_rfp = $ilance->db->query("
                        SELECT *
                        FROM " . DB_PREFIX . "projects
                        WHERE date_end <= '" . DATETODAY . " " . TIMENOW . "' 
                            AND status = 'open'
                ", 0, null, __FILE__, __LINE__);
                if ($ilance->db->num_rows($sql_rfp) > 0)
                {
                        while ($res_rfp = $ilance->db->fetch_array($sql_rfp))
                        {
                                // #### SERVICE AUCTION EXPIRY #################
                                
                                // this will only expire auctions that have had no winning bids awarded
                                // and will not expire "finished", "wait_approval" or "approval_accepted" ones
                                if ($res_rfp['project_state'] == 'service')
                                {
                                        // determine if seller is auto-relisting this item (if no bids were received)
                                        if (process_auction_relister($res_rfp['project_id']) == false)
                                        {
                                                // subtract auction count
                                                build_category_count($res_rfp['cid'], 'subtract', "class.auction_expiry.inc.php: subtracting increment count category id $res_rfp[cid]");
                                                
                                                // expire this auction
                                                $ilance->db->query("
                                                        UPDATE " . DB_PREFIX . "projects
                                                        SET status = 'expired'
                                                        WHERE project_id = '" . $res_rfp['project_id'] . "'
                                                ", 0, null, __FILE__, __LINE__);
                                    
                                                // select all bidders who placed bids on this auction
                                                $sql_bids = $ilance->db->query("
                                                        SELECT user_id
                                                        FROM " . DB_PREFIX . "project_bids
                                                        WHERE project_user_id = '" . $res_rfp['user_id'] . "'
                                                            AND project_id = '" . $res_rfp['project_id'] . "'
                                                        GROUP BY user_id
                                                ", 0, null, __FILE__, __LINE__);
                                                if ($ilance->db->num_rows($sql_bids) > 0)
                                                {
                                                        while ($res_bids = $ilance->db->fetch_array($sql_bids))
                                                        {
                                                                // fetch bidder information
                                                                $sql_bidder = $ilance->db->query("
                                                                        SELECT email, user_id, username
                                                                        FROM " . DB_PREFIX . "users
                                                                        WHERE user_id = '" . $res_bids['user_id'] . "'
                                                                        LIMIT 1
                                                                ", 0, null, __FILE__, __LINE__);
                                                                if ($ilance->db->num_rows($sql_bidder) > 0)
                                                                {
                                                                        $res_bidder = $ilance->db->fetch_array($sql_bidder);
                                                                        
                                                                        // email user
                                                                        $ilance->email->mail = $res_bidder['email'];
                                                                        $ilance->email->slng = fetch_user_slng($res_bids['user_id']);
                                                                        
                                                                        $ilance->email->get('service_auction_expired_via_cron');		
                                                                        $ilance->email->set(array(
                                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                '{{expiredate}}' => DATETODAY . ' ' . TIMENOW,
                                                                                '{{bidder}}' => ucfirst(stripslashes($res_bidder['username'])),
                                                                                '{{rfpurl}}' => HTTP_SERVER . 'rfp.php?id=' . $res_rfp['project_id'],
                                                                                '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                        ));
                                                                        
                                                                        $ilance->email->send();
                                                                }
                                                        }
                                                }
                                                
                                                // service auction owner information
                                                $sql_owner = $ilance->db->query("
                                                        SELECT email, username
                                                        FROM " . DB_PREFIX . "users
                                                        WHERE user_id = '" . $res_rfp['user_id'] . "'
                                                ", 0, null, __FILE__, __LINE__);
                                                if ($ilance->db->num_rows($sql_owner) > 0)
                                                {
                                                        $res_owner = $ilance->db->fetch_array($sql_owner);
                                            
                                                        // email user
                                                        $ilance->email->mail = $res_owner['email'];
                                                        $ilance->email->slng = fetch_user_slng($res_rfp['user_id']);
                                                        
                                                        $ilance->email->get('service_auction_expired_via_cron_owner');		
                                                        $ilance->email->set(array(
                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                '{{owner}}' => $res_owner['username'],
                                                                '{{rfpurl}}' => HTTP_SERVER . "rfp.php?id=" . $res_rfp['project_id'],
                                                                '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                        ));
                                                        
                                                        $ilance->email->send();
                                                        
                                                        // email admin
                                                        $ilance->email->mail = SITE_EMAIL;
                                                        $ilance->email->slng = fetch_site_slng();
                                                        
                                                        $ilance->email->get('service_auction_expired_via_cron_admin');		
                                                        $ilance->email->set(array(
                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                '{{owner}}' => $res_owner['username'],
                                                                '{{rfpurl}}' => HTTP_SERVER . 'rfp.php?id=' . $res_rfp['project_id'],
                                                                '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                        ));
                                                        
                                                        $ilance->email->send();
                                                        
                                                        $cronlog .= '';
                                                }        
                                        }
                                }
                                
                                // #### PRODUCT AUCTION EXPIRY #################
                                else if ($res_rfp['project_state'] == 'product')
                                {
                                        $sql_owner = $ilance->db->query("
                                                SELECT *
                                                FROM " . DB_PREFIX . "users
                                                WHERE user_id = '" . $res_rfp['user_id'] . "'
                                        ", 0, null, __FILE__, __LINE__);
                                        if ($ilance->db->num_rows($sql_owner) > 0)
                                        {
                                                $res_owner = $ilance->db->fetch_array($sql_owner);
                                                
                                                // determine if seller is auto-relisting this item (if no bids were received)
                                                if (process_auction_relister($res_rfp['project_id']) == false)
                                                {
                                                        // subtract auction count
                                                        build_category_count($res_rfp['cid'], 'subtract', "class.auction_expiry.inc.php: subtracting increment count category id $res_rfp[cid]");
                                                                
                                                        // update open product auctions to expired
                                                        // check for high bidders as well and if the reserve price was met
                                                        $ilance->db->query("
                                                                UPDATE " . DB_PREFIX . "projects
                                                                SET status = 'expired'
                                                                WHERE project_id = '" . $res_rfp['project_id'] . "'
                                                        ", 0, null, __FILE__, __LINE__);
                                        
                                                        // unique bidding event or regular auctions?
                                                        if ($res_rfp['project_details'] == 'unique')
                                                        {
                                                                // #### UNIQUE BIDDING EVENT EXPIRY ########################
                                                                
                                                                // is there a winning lowest unique bid amount placed?
                                                                $uniques = $ilance->db->query("
                                                                        SELECT user_id, uniquebid, date
                                                                        FROM " . DB_PREFIX . "projects_uniquebids
                                                                        WHERE project_id = '" . $res_rfp['project_id'] . "'
                                                                            AND status = 'lowestunique'
                                                                        LIMIT 1
                                                                ", 0, null, __FILE__, __LINE__);
                                                                if ($ilance->db->num_rows($uniques) > 0)
                                                                {
                                                                        // yes
                                                                        $resunique = $ilance->db->fetch_array($uniques);
                                                                        
                                                                        // create unpaid invoice to winning bidder
                                                                        // create new unpaid insertion fee listing invoice to be paid in xx days.
                                                                        $transactionid = construct_transaction_id();
                                                                        $invoiceid = $ilance->accounting->insert_transaction(
                                                                                0,
                                                                                $res_rfp['project_id'],
                                                                                0,
                                                                                $resunique['user_id'],
                                                                                0,
                                                                                0,
                                                                                0,
                                                                                $phrase['_lowest_unique_bid_winning_amount_congratulations'],
                                                                                sprintf("%01.2f", $resunique['uniquebid']),
                                                                                '',
                                                                                'unpaid',
                                                                                'debit',
                                                                                'account',
                                                                                DATETIME24H,
                                                                                DATEINVOICEDUE,
                                                                                '',
                                                                                '',
                                                                                0,
                                                                                0,
                                                                                1,
                                                                                $transactionid,
                                                                                0,
                                                                                0
                                                                        );
                                                                        
                                                                        $ilance->db->query("
                                                                                UPDATE " . DB_PREFIX . "projects
                                                                                SET haswinner = '1',
                                                                                winner_user_id = '" . $resunique['user_id'] . "',
                                                                                status = 'expired'
                                                                                WHERE project_id = '" . $res_rfp['project_id'] . "'
                                                                        ");
                                                                        
                                                                        $ilance->db->query("
                                                                                UPDATE " . DB_PREFIX . "users
                                                                                SET productawards = productawards + 1
                                                                                WHERE user_id = '" . $resunique['user_id'] . "'
                                                                        ");
                                                                        
                                                                        // email user
                                                                        $ilance->email->mail = fetch_user('email', $resunique['user_id']);
                                                                        $ilance->email->slng = fetch_user_slng($resunique['user_id']);
                                                                        
                                                                        $ilance->email->get('cron_low_unique_bid_winner');		
                                                                        $ilance->email->set(array(
                                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                '{{project_id}}' => $res_rfp['project_id'],
                                                                                '{{username}}' => fetch_user('username', $resunique['user_id']),
                                                                                '{{invoiceid}}' => $invoiceid,
                                                                                '{{lowuniquebid}}' => $ilance->currency->format($resunique['uniquebid']),
                                                                                '{{totalbids}}' => $ilance->bid_lowest_unique->fetch_bid_count($res_rfp['project_id']),
                                                                                '{{windate}}' => $resunique['date'],
                                                                                '{{amounttopay}}' => $ilance->currency->format($resunique['uniquebid']),
                                                                                '{{txnid}}' => $transactionid,
                                                                                '{{paymenturl}}' => HTTPS_SERVER . "invoicepayment.php?id=" . $invoiceid,
                                                                        ));
                                                                        
                                                                        $ilance->email->send();
                                                                        
                                                                        // email losing bidders
                                                                        $losers = $ilance->db->query("
                                                                                SELECT user_id, uniquebid, date
                                                                                FROM " . DB_PREFIX . "projects_uniquebids
                                                                                WHERE project_id = '" . $res_rfp['project_id'] . "'
                                                                                    AND status != 'lowestunique'
                                                                                    AND user_id != '" . $resunique['user_id'] . "'
                                                                                GROUP BY user_id
                                                                        ", 0, null, __FILE__, __LINE__);
                                                                        if ($ilance->db->num_rows($losers) > 0)
                                                                        {
                                                                                while ($loser = $ilance->db->fetch_array($losers))
                                                                                {
                                                                                        // email loser
                                                                                        $ilance->email->mail = fetch_user('email', $loser['user_id']);
                                                                                        $ilance->email->slng = fetch_user_slng($resunique['user_id']);
                                                                                        
                                                                                        $ilance->email->get('cron_low_unique_bid_loser');		
                                                                                        $ilance->email->set(array(
                                                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                                '{{project_id}}' => $res_rfp['project_id'],
                                                                                                '{{username}}' => fetch_user('username', $loser['user_id']),
                                                                                                '{{invoiceid}}' => $invoiceid,
                                                                                                '{{lowuniquebid}}' => $ilance->currency->format($resunique['uniquebid']),
                                                                                                '{{totalbids}}' => $ilance->bid_lowest_unique->fetch_bid_count($res_rfp['project_id']),
                                                                                                '{{windate}}' => $resunique['date'],
                                                                                                '{{winner}}' => fetch_user('username', $resunique['user_id']),
                                                                                        ));
                                                                                        
                                                                                        $ilance->email->send();
                                                                                }
                                                                        }
                                                                        
                                                                        // email admin
                                                                        $ilance->email->mail = SITE_EMAIL;
                                                                        $ilance->email->slng = fetch_site_slng();
                                                                        
                                                                        $ilance->email->get('cron_low_unique_bid_admin');		
                                                                        $ilance->email->set(array(
                                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                '{{project_id}}' => $res_rfp['project_id'],
                                                                                '{{invoiceid}}' => $invoiceid,
                                                                                '{{lowuniquebid}}' => $ilance->currency->format($resunique['uniquebid']),
                                                                                '{{totalbids}}' => $ilance->bid_lowest_unique->fetch_bid_count($res_rfp['project_id']),
                                                                                '{{windate}}' => $resunique['date'],
                                                                                '{{winner}}' => fetch_user('username', $resunique['user_id']),
                                                                                '{{amounttopay}}' => $ilance->currency->format($resunique['uniquebid']),
                                                                                '{{txnid}}' => $transactionid,
                                                                        ));
                                                                        
                                                                        $ilance->email->send();
                                                                        
                                                                        $cronlog .= '';
                                                                }
                                                                else
                                                                {
                                                                        // no unique bidder for this auction event!
                                                                        // email all bidders that nobody placed a unique bid for item
                                                                        $losers = $ilance->db->query("
                                                                                SELECT user_id, uniquebid, date
                                                                                FROM " . DB_PREFIX . "projects_uniquebids
                                                                                WHERE project_id = '" . $res_rfp['project_id'] . "'
                                                                                    AND status != 'lowestunique'
                                                                                GROUP BY user_id
                                                                        ", 0, null, __FILE__, __LINE__);
                                                                        if ($ilance->db->num_rows($losers) > 0)
                                                                        {
                                                                                while ($loser = $ilance->db->fetch_array($losers))
                                                                                {
                                                                                        // email user
                                                                                        $ilance->email->mail = fetch_user('email', $loser['user_id']);
                                                                                        $ilance->email->slng = fetch_user_slng($loser['user_id']);
                                                                                        
                                                                                        $ilance->email->get('cron_no_low_unique_bid_bidder');		
                                                                                        $ilance->email->set(array(
                                                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                                '{{project_id}}' => $res_rfp['project_id'],
                                                                                                '{{totalbids}}' => $ilance->bid_lowest_unique->fetch_bid_count($res_rfp['project_id']),
                                                                                        ));
                                                                                        
                                                                                        $ilance->email->send();
                                                                                }
                                                                        }
                                                                        
                                                                        // email admin
                                                                        $ilance->email->mail = SITE_EMAIL;
                                                                        $ilance->email->slng = fetch_site_slng();
                                                                        
                                                                        $ilance->email->get('cron_no_low_unique_bid_bidder');		
                                                                        $ilance->email->set(array(
                                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                '{{project_id}}' => $res_rfp['project_id'],
                                                                                '{{totalbids}}' => $ilance->bid_lowest_unique->fetch_bid_count($res_rfp['project_id']),
                                                                        ));
                                                                        
                                                                        $ilance->email->send();
                                                                        
                                                                        $cronlog .= '';
                                                                }
                                                        }
                                                        else
                                                        {
                                                                // is proxy bidding logic enabled?
                                                                if ($ilconfig['productbid_enableproxybid'] AND $ilance->categories->useproxybid(fetch_user_slng($res_rfp['user_id']), 'product', $res_rfp['cid']))
                                                                {
                                                                        // proxy enabled: fetch highest maximum bid placed
                                                                        $highbid = $ilance->db->query("
                                                                                SELECT bidamount, user_id, bid_id, date_added
                                                                                FROM " . DB_PREFIX . "project_bids
                                                                                WHERE project_id = '" . $res_rfp['project_id'] . "'
                                                                                ORDER BY bidamount DESC
                                                                                LIMIT 1
                                                                        ", 0, null, __FILE__, __LINE__);
                                                                        if ($ilance->db->num_rows($highbid) > 0)
                                                                        {
                                                                                $res_highest = $ilance->db->fetch_array($highbid);
                                                                                
                                                                                $highestbid = $res_highest['bidamount'];
                                                                                $highbidderid = $res_highest['user_id'];
                                                                                $highbiddate = $res_highest['date_added'];
                                                                                $highbidderbidid = $res_highest['bid_id'];
                                                                        }
                                                                        else
                                                                        {
                                                                                // no valid proxy details, use regular format to be safe
                                                                                $sql_highest = $ilance->db->query("
                                                                                        SELECT bidamount, user_id, date_added, bid_id
                                                                                        FROM " . DB_PREFIX . "project_bids
                                                                                        WHERE project_id = '" . $res_rfp['project_id'] . "'
                                                                                        ORDER BY bidamount DESC, date_added ASC
                                                                                        LIMIT 1
                                                                                ", 0, null, __FILE__, __LINE__);
                                                                                if ($ilance->db->num_rows($sql_highest) > 0)
                                                                                {
                                                                                        $res_highest = $ilance->db->fetch_array($sql_highest);
                                                                                        
                                                                                        $highestbid = $res_highest['bidamount'];
                                                                                        $highbidderid = $res_highest['user_id'];
                                                                                        $highbiddate = $res_highest['date_added'];
                                                                                        $highbidderbidid = $res_highest['bid_id'];
                                                                                }
                                                                                else
                                                                                {
                                                                                        $highestbid = '0.00';
                                                                                        $highbidderid = $highbidderbidid = 0;
                                                                                        $highbiddate = '0000-00-00 00:00:00';
                                                                                }
                                                                        }
                                                                }
                                                                
                                                                // no proxy bidding: fetch highest bid placed for auction
                                                                else
                                                                {
                                                                        $sql_highest = $ilance->db->query("
                                                                                SELECT bidamount, user_id, date_added, bid_id
                                                                                FROM " . DB_PREFIX . "project_bids
                                                                                WHERE project_id = '" . $res_rfp['project_id'] . "'
                                                                                ORDER BY bidamount DESC, date_added ASC
                                                                                LIMIT 1
                                                                        ", 0, null, __FILE__, __LINE__);
                                                                        if ($ilance->db->num_rows($sql_highest) > 0)
                                                                        {
                                                                                $res_highest = $ilance->db->fetch_array($sql_highest);
                                                                                
                                                                                $highestbid  = $res_highest['bidamount'];
                                                                                $highbidderid = $res_highest['user_id'];
                                                                                $highbiddate = $res_highest['date_added'];
                                                                                $highbidderbidid = $res_highest['bid_id'];
                                                                        }
                                                                        else
                                                                        {
                                                                                $highestbid = '0.00';
                                                                                $highbidderid = $highbidderbidid = 0;
                                                                                $highbiddate = '0000-00-00 00:00:00';
                                                                        }
                                                                }
                                                
                                                                // do we have a highest bid placed along with a highest bidder?
                                                                if ($highestbid > 0 AND $highbidderid > 0)
                                                                {
                                                                        // check to see if we're using reserve pricing
                                                                        if ($res_rfp['reserve'])
                                                                        {
                                                                                // #### RESERVE PRICE IN EFFECT ########################
                                                                                if ($res_rfp['reserve_price'] <= $highestbid)
                                                                                {
                                                                                        // select all bidders other than our highest bidder
                                                                                        // so we can send expired listing notifications
                                                                                        $sql_bids = $ilance->db->query("
                                                                                                SELECT *
                                                                                                FROM " . DB_PREFIX . "project_bids
                                                                                                WHERE project_user_id = '" . $res_rfp['user_id'] . "'
                                                                                                    AND project_id = '" . $res_rfp['project_id'] . "'
                                                                                                    AND user_id != '" . $highbidderid . "'
                                                                                                GROUP BY user_id
                                                                                        ", 0, null, __FILE__, __LINE__);
                                                                                        if ($ilance->db->num_rows($sql_bids) > 0)
                                                                                        {
                                                                                                while ($res_bids = $ilance->db->fetch_array($sql_bids))
                                                                                                {
                                                                                                        // update all bidders bids to 'outbid'
                                                                                                        $ilance->db->query("
                                                                                                                UPDATE " . DB_PREFIX . "project_bids
                                                                                                                SET bidstatus = 'outbid',
                                                                                                                bidstate = 'expired'
                                                                                                                WHERE user_id = '" . $res_bids['user_id'] . "'
                                                                                                                    AND project_id = '" . $res_bids['project_id'] . "'
                                                                                                        ", 0, null, __FILE__, __LINE__);
                                                                    
                                                                                                        $sql_bidder = $ilance->db->query("
                                                                                                                SELECT *
                                                                                                                FROM " . DB_PREFIX . "users
                                                                                                                WHERE user_id = '" . $res_bids['user_id'] . "'
                                                                                                        ", 0, null, __FILE__, __LINE__);
                                                                                                        if ($ilance->db->num_rows($sql_bidder) > 0)
                                                                                                        {
                                                                                                                $res_bidder = $ilance->db->fetch_array($sql_bidder);
                                                                                                                
                                                                                                                $lowbiddate = $res_bids['date_added'];
                                                                                                                $lowbidamount = number_format($res_bids['bidamount'], 2);
                                                                                                                
                                                                                                                // email user
                                                                                                                $ilance->email->mail = $res_bidder['email'];
                                                                                                                $ilance->email->slng = fetch_user_slng($res_bids['user_id']);
                                                                                                                
                                                                                                                $ilance->email->get('product_auction_expired_another_bidder');		
                                                                                                                $ilance->email->set(array(
                                                                                                                        '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                                                        '{{bidder}}' => $res_bidder['username'],
                                                                                                                        '{{rfpurl}}' => HTTP_SERVER . 'merch.php?id=' . $res_rfp['project_id'],
                                                                                                                        '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                                                                        '{{lowbiddate}}' => $lowbiddate,
                                                                                                                        '{{lowbidamount}}' => $ilance->currency->format($lowbidamount),
                                                                                                                        '{{highbiddate}}' => $highbiddate,
                                                                                                                        '{{highbidamount}}' => $ilance->currency->format($highestbid),
                                                                                                                ));
                                                                                                                
                                                                                                                $ilance->email->send();
                                                                                                        }
                                                                                                        
                                                                                                        $cronlog .= '';
                                                                                                }
                                                                                        }
                                                                                        
                                                                                        // do shipping fees apply?
                                                                                        $shippinginformation  = '';
                                                                                        $ship_handling = fetch_auction('ship_handling', $res_rfp['project_id']);
                                                                                        switch ($ship_handling)
                                                                                        {
                                                                                                case 'flatrate':
                                                                                                {
                                                                                                        $totalescrowamount = $highestbid;
                                                                                                        $shippinginformation = $phrase['_additional_shipping_fees'] . ': ' . $ilance->currency->format($res_rfp['ship_costs']);
                                                                                                        break;
                                                                                                }
                                                                                                case 'digital':
                                                                                                {
                                                                                                        $totalescrowamount = $highestbid;
                                                                                                        break;
                                                                                                }
                                                                                                case 'none':
                                                                                                case 'sellerpays':
                                                                                                {
                                                                                                        $totalescrowamount = $highestbid;
                                                                                                        break;
                                                                                                }                                                                        
                                                                                        }
                                                                                                            
                                                                                        // fetch highest bidders information
                                                                                        $sql_winner = $ilance->db->query("
                                                                                                SELECT *
                                                                                                FROM " . DB_PREFIX . "users
                                                                                                WHERE user_id = '" . $highbidderid . "'
                                                                                        ", 0, null, __FILE__, __LINE__);
                                                                                        if ($ilance->db->num_rows($sql_winner) > 0)
                                                                                        {
                                                                                                $res_winner = $ilance->db->fetch_array($sql_winner);
                                                                                                
                                                                                                // fetch owners information
                                                                                                $sql_owner = $ilance->db->query("
                                                                                                        SELECT *
                                                                                                        FROM " . DB_PREFIX . "users
                                                                                                        WHERE user_id = '" . $res_rfp['user_id'] . "'
                                                                                                ", 0, null, __FILE__, __LINE__);
                                                                                                if ($ilance->db->num_rows($sql_owner) > 0)
                                                                                                {
                                                                                                        $res_owner = $ilance->db->fetch_array($sql_owner);
                                                                                                        
                                                                                                        // is the escrow system enabled?
                                                                                                        if ($ilconfig['escrowsystem_enabled'] AND $res_rfp['filter_escrow'])
                                                                                                        {
                                                                                                                // #### MERCHANT ESCROW FEES ##################################
                                                                                                                // applies fee to tax
                                                                                                                $fee = fetch_merchant_escrow_fee_plus_tax($res_rfp['user_id'], $totalescrowamount);
                                                                                                                
                                                                                                                // #### PRODUCT BIDDER ESCROW FEES ###############################
                                                                                                                // applies fee to tax
                                                                                                                $fee2 = fetch_product_bidder_escrow_fee_plus_tax($highbidderid, $totalescrowamount);
                                                                        
                                                                                                                // amount to forward plus the merchant fee to fund escrow (including any taxes if applicable)
                                                                                                                $totalescrowamount = ($totalescrowamount + $fee2) + $res_rfp['ship_costs'];
                                                                                                                
                                                                                                                // create the escrow invoice to be paid by bidder
                                                                                                                $escrow_invoice_id = $ilance->accounting->insert_transaction(
                                                                                                                        0,
                                                                                                                        intval($res_rfp['project_id']),
                                                                                                                        0,
                                                                                                                        intval($highbidderid),
                                                                                                                        0,
                                                                                                                        0,
                                                                                                                        0,
                                                                                                                        $phrase['_escrow_payment_forward'] . ' (' . intval($res_rfp['project_id']) . '): ' . stripcslashes($res_rfp['project_title']),
                                                                                                                        sprintf("%01.2f", $totalescrowamount),
                                                                                                                        '',
                                                                                                                        'unpaid',
                                                                                                                        'escrow',
                                                                                                                        'account',
                                                                                                                        DATETIME24H,
                                                                                                                        DATEINVOICEDUE,
                                                                                                                        '',
                                                                                                                        $shippinginformation,
                                                                                                                        0,
                                                                                                                        0,
                                                                                                                        1
                                                                                                                );
                                                                                                                
                                                                                                                // create the product escrow account
                                                                                                                $ilance->db->query("
                                                                                                                        INSERT INTO " . DB_PREFIX . "projects_escrow
                                                                                                                        (escrow_id, bid_id, project_id, invoiceid, project_user_id, user_id, date_awarded, bidamount, shipping, total, fee, fee2, status)
                                                                                                                        VALUES(
                                                                                                                        NULL,
                                                                                                                        '" . $highbidderbidid . "',
                                                                                                                        '" . $res_rfp['project_id'] . "',
                                                                                                                        '" . $escrow_invoice_id . "',
                                                                                                                        '" . $res_rfp['user_id'] . "',
                                                                                                                        '" . $highbidderid . "',
                                                                                                                        '" . DATETIME24H . "',
                                                                                                                        '" . sprintf("%01.2f", $highestbid) . "',
                                                                                                                        '" . sprintf("%01.2f", $res_rfp['ship_costs']) . "',
                                                                                                                        '" . sprintf("%01.2f", $totalescrowamount) . "', 
                                                                                                                        '" . sprintf("%01.2f", $fee) . "', 
                                                                                                                        '" . sprintf("%01.2f", $fee2) . "',
                                                                                                                        'pending')
                                                                                                                ", 0, null, __FILE__, __LINE__);
                                                                                                                $escrow_id = $ilance->db->insert_id();
                                                                                
                                                                                                                // tie the escrow account to the project
                                                                                                                $ilance->db->query("
                                                                                                                        UPDATE " . DB_PREFIX . "projects
                                                                                                                        SET escrow_id = '" . $escrow_id . "',
                                                                                                                        haswinner = '1',
                                                                                                                        winner_user_id = '" . $highbidderid . "'
                                                                                                                        WHERE project_id = '" . $res_rfp['project_id'] . "'
                                                                                                                        LIMIT 1
                                                                                                                ", 0, null, __FILE__, __LINE__);
                                                                                                                
                                                                                                                $ilance->db->query("
                                                                                                                        UPDATE " . DB_PREFIX . "users
                                                                                                                        SET productawards = productawards + 1
                                                                                                                        WHERE user_id = '" . $highbidderid . "'
                                                                                                                ");
                                                                                                                
                                                                                                                // email owner
                                                                                                                $ilance->email->mail = $res_owner['email'];
                                                                                                                $ilance->email->slng = fetch_user_slng($res_rfp['user_id']);
                                                                                                                
                                                                                                                $ilance->email->get('product_auction_expired_via_cron_owner');		
                                                                                                                $ilance->email->set(array(
                                                                                                                        '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                                                        '{{owner}}' => ucfirst(stripslashes($res_owner['username'])),
                                                                                                                        '{{rfpurl}}' => HTTP_SERVER . 'merch.php?id=' . $res_rfp['project_id'],
                                                                                                                        '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                                                                        '{{totalamount}}' => $ilance->currency->format($totalescrowamount),
                                                                                                                        '{{winningbidder}}' => $res_winner['username'],
                                                                                                                        '{{winningbidderemail}}' => $res_winner['email'],
                                                                                                                ));
                                                                                                                
                                                                                                                $ilance->email->send();
                                                                                                                
                                                                                                                // email winning bidder
                                                                                                                $ilance->email->mail = $res_winner['email'];
                                                                                                                $ilance->email->slng = fetch_user_slng($highbidderid);
                                                                                                                
                                                                                                                $ilance->email->get('product_auction_expired_via_cron_winner');		
                                                                                                                $ilance->email->set(array(
                                                                                                                        '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                                                        '{{owner}}' => ucfirst(stripslashes($res_owner['username'])),
                                                                                                                        '{{rfpurl}}' => HTTP_SERVER . "merch.php?id=" . $res_rfp['project_id'],
                                                                                                                        '{{datetime}}' => DATETODAY . " " . TIMENOW,
                                                                                                                        '{{totalamount}}' => $ilance->currency->format($totalescrowamount),
                                                                                                                        '{{winningbidder}}' => $res_winner['username'],
                                                                                                                        '{{winningbidderemail}}' => $res_winner['email'],
                                                                                                                ));
                                                                                                                
                                                                                                                $ilance->email->send();
                                                                                                                
                                                                                                                // email admin
                                                                                                                $ilance->email->mail = SITE_EMAIL;
                                                                                                                $ilance->email->slng = fetch_site_slng();
                                                                                                                
                                                                                                                $ilance->email->get('product_auction_expired_via_cron_admin');		
                                                                                                                $ilance->email->set(array(
                                                                                                                        '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                                                        '{{owner}}' => ucfirst(stripslashes($res_owner['username'])),
                                                                                                                        '{{rfpurl}}' => HTTP_SERVER . 'merch.php?id=' . $res_rfp['project_id'],
                                                                                                                        '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                                                                        '{{totalamount}}' => $ilance->currency->format($totalescrowamount),
                                                                                                                        '{{winningbidder}}' => $res_winner['username'],
                                                                                                                        '{{winningbidderemail}}' => $res_winner['email'],
                                                                                                                ));
                                                                                                                
                                                                                                                $ilance->email->send();
                                                                                                                
                                                                                                                $cronlog .= '';
                                                                                                        }
                                                                                                        else
                                                                                                        {
                                                                                                                // no escrow enabled for this product listing
                                                                                                                $ilance->db->query("
                                                                                                                        UPDATE " . DB_PREFIX . "projects
                                                                                                                        SET haswinner = '1',
                                                                                                                        winner_user_id = '" . $highbidderid . "'
                                                                                                                        WHERE project_id = '" . $res_rfp['project_id'] . "'
                                                                                                                        LIMIT 1
                                                                                                                ", 0, null, __FILE__, __LINE__);
                                                                                                                
                                                                                                                $ilance->db->query("
                                                                                                                        UPDATE " . DB_PREFIX . "users
                                                                                                                        SET productawards = productawards + 1
                                                                                                                        WHERE user_id = '" . $highbidderid . "'
                                                                                                                ");
                                                                                                                
                                                                                                                // email owner
                                                                                                                $ilance->email->mail = $res_owner['email'];
                                                                                                                $ilance->email->slng = fetch_user_slng($res_rfp['user_id']);
                                                                                                                
                                                                                                                $ilance->email->get('product_auction_expired_via_cron_no_escrow_owner');		
                                                                                                                $ilance->email->set(array(
                                                                                                                        '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                                                        '{{owner}}' => ucfirst(stripslashes($res_owner['username'])),
                                                                                                                        '{{rfpurl}}' => HTTP_SERVER . 'merch.php?id=' . $res_rfp['project_id'],
                                                                                                                        '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                                                                        '{{totalamount}}' => $ilance->currency->format($totalescrowamount),
                                                                                                                        '{{winningbidder}}' => $res_winner['username'],
                                                                                                                        '{{winningbidderemail}}' => $res_winner['email'],
                                                                                                                ));
                                                                                                                
                                                                                                                $ilance->email->send();
                                                                                                                
                                                                                                                // email winning bidder
                                                                                                                $ilance->email->mail = $res_winner['email'];
                                                                                                                $ilance->email->slng = fetch_user_slng($highbidderid);
                                                                                                                
                                                                                                                $ilance->email->get('product_auction_expired_via_cron_no_escrow_winner');		
                                                                                                                $ilance->email->set(array(
                                                                                                                        '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                                                        '{{owner}}' => ucfirst(stripslashes($res_owner['username'])),
                                                                                                                        '{{owneremail}}' => $res_owner['email'],
                                                                                                                        '{{rfpurl}}' => HTTP_SERVER . 'merch.php?id=' . $res_rfp['project_id'],
                                                                                                                        '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                                                                        '{{totalamount}}' => $ilance->currency->format($totalescrowamount),
                                                                                                                        '{{winningbidder}}' => $res_winner['username'],
                                                                                                                        '{{winningbidderemail}}' => $res_winner['email'],
                                                                                                                ));
                                                                                                                
                                                                                                                $ilance->email->send();
                                                                                                                
                                                                                                                // email admin
                                                                                                                $ilance->email->mail = SITE_EMAIL;
                                                                                                                $ilance->email->slng = fetch_site_slng();
                                                                                                                
                                                                                                                $ilance->email->get('product_auction_expired_via_cron_no_escrow_admin');		
                                                                                                                $ilance->email->set(array(
                                                                                                                        '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                                                        '{{owner}}' => ucfirst(stripslashes($res_owner['username'])),
                                                                                                                        '{{owneremail}}' => $res_owner['email'],
                                                                                                                        '{{rfpurl}}' => HTTP_SERVER . 'merch.php?id=' . $res_rfp['project_id'],
                                                                                                                        '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                                                                        '{{totalamount}}' => $ilance->currency->format($totalescrowamount),
                                                                                                                        '{{winningbidder}}' => $res_winner['username'],
                                                                                                                        '{{winningbidderemail}}' => $res_winner['email'],
                                                                                                                ));
                                                                                                                
                                                                                                                $ilance->email->send();
                                                                                                                
                                                                                                                $cronlog .= '';
                                                                                                        }
                                                                            
                                                                                                        // update highest bidders bid status to 'awarded'
                                                                                                        $ilance->db->query("
                                                                                                                UPDATE " . DB_PREFIX . "project_bids
                                                                                                                SET bidstate = '',
                                                                                                                bidstatus = 'awarded',
                                                                                                                date_awarded = '" . DATETIME24H . "'
                                                                                                                WHERE bid_id = '" . $highbidderbidid . "'
                                                                                                                    AND project_id = '" . $res_rfp['project_id'] . "'
                                                                                                                LIMIT 1
                                                                                                        ", 0, null, __FILE__, __LINE__);
                                                                            
                                                                                                        // update all highest bidders lowest bids to 'outbid'
                                                                                                        $ilance->db->query("
                                                                                                                UPDATE " . DB_PREFIX . "project_bids
                                                                                                                SET bidstate = '',
                                                                                                                bidstatus = 'outbid'
                                                                                                                WHERE user_id = '" . $highbidderid . "'
                                                                                                                    AND bidstatus != 'awarded'
                                                                                                                    AND project_id = '" . $res_rfp['project_id'] . "'
                                                                                                        ", 0, null, __FILE__, __LINE__);
                                                                                                        
                                                                                                        // #### GENERATE UNPAID FINAL VALUE FEE ########
                                                                                                        $ilance->accounting->construct_final_value_fee($highbidderbidid, $res_rfp['cid'], $res_rfp['project_id'], 'charge', 'product');
                                                                                                        
                                                                                                        $cronlog .= '';
                                                                                                }
                                                                                        }
                                                                                }
                                                                                
                                                                                // #### RESERVE PRICE NOT MET #####################################
                                                                                else
                                                                                {
                                                                                        $sql_bids = $ilance->db->query("
                                                                                                SELECT *
                                                                                                FROM " . DB_PREFIX . "project_bids
                                                                                                WHERE project_user_id = '" . $res_rfp['user_id'] . "'
                                                                                                    AND project_id = '" . $res_rfp['project_id'] . "'
                                                                                                GROUP BY user_id
                                                                                        ", 0, null, __FILE__, __LINE__);
                                                                                        if ($ilance->db->num_rows($sql_bids) > 0)
                                                                                        {
                                                                                                while ($res_bids = $ilance->db->fetch_array($sql_bids))
                                                                                                {
                                                                                                        // update all bids placed to outbid/expired
                                                                                                        $ilance->db->query("
                                                                                                                UPDATE " . DB_PREFIX . "project_bids
                                                                                                                SET bidstatus = 'outbid',
                                                                                                                bidstate = 'expired'
                                                                                                                WHERE user_id = '" . $res_bids['user_id'] . "'
                                                                                                                    AND project_id = '" . $res_bids['project_id'] . "'
                                                                                                        ", 0, null, __FILE__, __LINE__);
                                                                                                        
                                                                                                        $sql_bidder = $ilance->db->query("
                                                                                                                SELECT *
                                                                                                                FROM " . DB_PREFIX . "users
                                                                                                                WHERE user_id = '" . $res_bids['user_id'] . "'
                                                                                                                LIMIT 1
                                                                                                        ", 0, null, __FILE__, __LINE__);
                                                                                                        if ($ilance->db->num_rows($sql_bidder))
                                                                                                        {
                                                                                                                $res_bidder = $ilance->db->fetch_array($sql_bidder);
                                                                                                                
                                                                                                                $lowbiddate = $res_bids['date_added'];
                                                                                                                $lowbidamount = number_format($res_bids['bidamount'], 2);
                                                                                                                
                                                                                                                // email owner
                                                                                                                $ilance->email->mail = $res_bidder['email'];
                                                                                                                $ilance->email->slng = fetch_user_slng($res_bids['user_id']);
                                                                                                                
                                                                                                                $ilance->email->get('product_auction_expired_reserve_not_met');		
                                                                                                                $ilance->email->set(array(
                                                                                                                        '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                                                        '{{bidder}}' => ucfirst(stripslashes($res_bidder['username'])),
                                                                                                                        '{{rfpurl}}' => HTTP_SERVER . 'merch.php?id=' . $res_rfp['project_id'],
                                                                                                                        '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                                                                ));
                                                                                                                
                                                                                                                $ilance->email->send();
                                                                                                        }
                                                                                                        
                                                                                                        $cronlog .= '';
                                                                                                }
                                                                                        }
                                                                                }
                                                                        }
                                                                        
                                                                        // #### NO RESERVE PRICE ###############################
                                                                        else
                                                                        {
                                                                                $sql_bids = $ilance->db->query("
                                                                                        SELECT *
                                                                                        FROM " . DB_PREFIX . "project_bids
                                                                                        WHERE project_user_id = '" . $res_rfp['user_id'] . "'
                                                                                            AND project_id = '" . $res_rfp['project_id'] . "'
                                                                                            AND user_id != '" . $highbidderid . "'
                                                                                        GROUP BY user_id
                                                                                ", 0, null, __FILE__, __LINE__);
                                                                                if ($ilance->db->num_rows($sql_bids) > 0)
                                                                                {
                                                                                        while ($res_bids = $ilance->db->fetch_array($sql_bids))
                                                                                        {
                                                                                                // update all bids placed to outbid/expired
                                                                                                $ilance->db->query("
                                                                                                        UPDATE " . DB_PREFIX . "project_bids
                                                                                                        SET bidstatus = 'outbid',
                                                                                                        bidstate = 'expired'
                                                                                                        WHERE user_id = '" . $res_bids['user_id'] . "'
                                                                                                            AND project_id = '" . $res_bids['project_id'] . "'
                                                                                                ", 0, null, __FILE__, __LINE__);
                                                                                                
                                                                                                $sql_bidder = $ilance->db->query("
                                                                                                        SELECT *
                                                                                                        FROM " . DB_PREFIX . "users
                                                                                                        WHERE user_id = '" . $res_bids['user_id'] . "'
                                                                                                ", 0, null, __FILE__, __LINE__);
                                                                                                if ($ilance->db->num_rows($sql_bidder) > 0)
                                                                                                {
                                                                                                        $res_bidder = $ilance->db->fetch_array($sql_bidder);
                                                                                                        
                                                                                                        $lowbiddate = $res_bids['date_added'];
                                                                                                        $lowbidamount = number_format($res_bids['bidamount'], 2);
                                                                                                        
                                                                                                        // email outbid user
                                                                                                        $ilance->email->mail = $res_bidder['email'];
                                                                                                        $ilance->email->slng = fetch_user_slng($res_bids['user_id']);
                                                                                                        
                                                                                                        $ilance->email->get('product_auction_expired_another_bidder');		
                                                                                                        $ilance->email->set(array(
                                                                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                                                '{{bidder}}' => ucfirst(stripslashes($res_bidder['username'])),
                                                                                                                '{{rfpurl}}' => HTTP_SERVER . 'merch.php?id=' . $res_rfp['project_id'],
                                                                                                                '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                                                                '{{lowbiddate}}' => $lowbiddate,
                                                                                                                '{{lowbidamount}}' => $ilance->currency->format($lowbidamount),
                                                                                                                '{{highbiddate}}' => $highbiddate,
                                                                                                                '{{highestbid}}' => $ilance->currency->format($highestbid),
                                                                                                                '{{winningbidder}}' => $res_winner['username'],
                                                                                                        ));
                                                                                                        
                                                                                                        $ilance->email->send();
                                                                                                }
                                                                                                
                                                                                                $cronlog .= '';
                                                                                        }
                                                                                }
                                                                                
                                                                                $shippinginformation = '';
                                                                                $ship_handling = fetch_auction('ship_handling', $res_rfp['project_id']);
                                                                                switch ($ship_handling)
                                                                                {
                                                                                        case 'flatrate':
                                                                                        {
                                                                                                $totalescrowamount = $highestbid;
                                                                                                $shippinginformation = $phrase['_additional_shipping_fees'] . ': ' . $ilance->currency->format($res_rfp['ship_costs']);
                                                                                                break;
                                                                                        }                                                                
                                                                                        case 'digital':
                                                                                        {
                                                                                                $totalescrowamount = $highestbid;
                                                                                                break;
                                                                                        }
                                                                                        case 'none':
                                                                                        case 'sellerpays':
                                                                                        {
                                                                                                $totalescrowamount = $highestbid;
                                                                                                break;
                                                                                        }
                                                                                }
                                                                                
                                                                                // fetch winning bidder
                                                                                $sql_winner = $ilance->db->query("
                                                                                        SELECT *
                                                                                        FROM " . DB_PREFIX . "users
                                                                                        WHERE user_id = '" . $highbidderid . "'
                                                                                        LIMIT 1
                                                                                ", 0, null, __FILE__, __LINE__);
                                                                                if ($ilance->db->num_rows($sql_winner) > 0)
                                                                                {
                                                                                        $res_winner = $ilance->db->fetch_array($sql_winner);
                                                                                        
                                                                                        // fetch winning bidder info
                                                                                        $sql_owner = $ilance->db->query("
                                                                                                SELECT *
                                                                                                FROM " . DB_PREFIX . "users
                                                                                                WHERE user_id = '" . $res_rfp['user_id'] . "'
                                                                                                LIMIT 1
                                                                                        ", 0, null, __FILE__, __LINE__);
                                                                                        if ($ilance->db->num_rows($sql_owner) > 0)
                                                                                        {
                                                                                                $res_owner = $ilance->db->fetch_array($sql_owner);
                                                                                                
                                                                                                // escrow system enabled?
                                                                                                if ($ilconfig['escrowsystem_enabled'] AND $res_rfp['filter_escrow'])
                                                                                                {
                                                                                                        // #### MERCHANT ESCROW FEES ##################################
                                                                                                        // applies tax to fee
                                                                                                        $fee = fetch_merchant_escrow_fee_plus_tax($res_rfp['user_id'], $totalescrowamount);
                                                                                                        
                                                                                                        // #### PRODUCT BIDDER ESCROW FEES ###############################
                                                                                                        // applies tax to fee
                                                                                                        $fee2 = fetch_product_bidder_escrow_fee_plus_tax($highbidderid, $totalescrowamount);
                                                                    
                                                                                                        // amount to forward plus the merchant fee to fund escrow (including any taxes if applicable)
                                                                                                        $totalescrowamount = ($totalescrowamount + $fee2) + $res_rfp['ship_costs'];
                                                                                                        
                                                                                                        ##########################################
                                                                                                        ## ESCROW INVOICE CREATION > PRODUCT AWARD
                                                                                                        $escrow_invoice_id = $ilance->accounting->insert_transaction(
                                                                                                                0,
                                                                                                                intval($res_rfp['project_id']),
                                                                                                                0,
                                                                                                                intval($highbidderid),
                                                                                                                0,
                                                                                                                0,
                                                                                                                0,
                                                                                                                $phrase['_escrow_payment_forward'] . ' (' . intval($res_rfp['project_id']) . '): ' . $res_rfp['project_title'],
                                                                                                                sprintf("%01.2f", $totalescrowamount),
                                                                                                                '',
                                                                                                                'unpaid',
                                                                                                                'escrow',
                                                                                                                'account',
                                                                                                                DATETIME24H,
                                                                                                                DATEINVOICEDUE,
                                                                                                                '',
                                                                                                                $shippinginformation,
                                                                                                                0,
                                                                                                                0,
                                                                                                                1
                                                                                                        );
                                                                                                        
                                                                                                        // create product escrow account
                                                                                                        $ilance->db->query("
                                                                                                                INSERT INTO " . DB_PREFIX . "projects_escrow
                                                                                                                (escrow_id, bid_id, project_id, invoiceid, project_user_id, user_id, date_awarded, bidamount, shipping, total, fee, fee2, status)
                                                                                                                VALUES(
                                                                                                                NULL,
                                                                                                                '" . $highbidderbidid . "',
                                                                                                                '" . $res_rfp['project_id'] . "',
                                                                                                                '" . $escrow_invoice_id . "',
                                                                                                                '" . $res_rfp['user_id'] . "',
                                                                                                                '" . $highbidderid . "',
                                                                                                                '" . DATETIME24H . "',
                                                                                                                '" . sprintf("%01.2f", $highestbid) . "',
                                                                                                                '" . sprintf("%01.2f", $res_rfp['ship_costs']) . "',
                                                                                                                '" . sprintf("%01.2f", $totalescrowamount) . "',
                                                                                                                '" . sprintf("%01.2f", $fee) . "',
                                                                                                                '" . sprintf("%01.2f", $fee2) . "',
                                                                                                                'pending')
                                                                                                        ", 0, null, __FILE__, __LINE__);
                                                                                                        $escrow_id = $ilance->db->insert_id();
                                                                        
                                                                                                        // associate escrow to listing
                                                                                                        $ilance->db->query("
                                                                                                                UPDATE " . DB_PREFIX . "projects
                                                                                                                SET escrow_id = '" . $escrow_id . "',
                                                                                                                haswinner = '1',
                                                                                                                winner_user_id = '" . $highbidderid . "'
                                                                                                                WHERE project_id = '" . $res_rfp['project_id'] . "'
                                                                                                                LIMIT 1
                                                                                                        ", 0, null, __FILE__, __LINE__);
                                                                                                        
                                                                                                        $ilance->db->query("
                                                                                                                UPDATE " . DB_PREFIX . "users
                                                                                                                SET productawards = productawards + 1
                                                                                                                WHERE user_id = '" . $highbidderid . "'
                                                                                                        ");
                                                                                                        
                                                                                                        // email owner
                                                                                                        $ilance->email->mail = $res_owner['email'];
                                                                                                        $ilance->email->slng = fetch_user_slng($res_rfp['user_id']);
                                                                                                        
                                                                                                        $ilance->email->get('product_auction_expired_via_cron_owner');		
                                                                                                        $ilance->email->set(array(
                                                                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                                                '{{owner}}' => ucfirst(stripslashes($res_owner['username'])),
                                                                                                                '{{rfpurl}}' => HTTP_SERVER . 'merch.php?id=' . $res_rfp['project_id'],
                                                                                                                '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                                                                '{{totalamount}}' => $ilance->currency->format($totalescrowamount),
                                                                                                                '{{winningbidder}}' => $res_winner['username'],
                                                                                                                '{{winningbidderemail}}' => $res_winner['email'],
                                                                                                        ));
                                                                                                        
                                                                                                        $ilance->email->send();
                                                                                                        
                                                                                                        // email winning bidder
                                                                                                        $ilance->email->mail = $res_winner['email'];
                                                                                                        $ilance->email->slng = fetch_user_slng($highbidderid);
                                                                                                        
                                                                                                        $ilance->email->get('product_auction_expired_via_cron_winner');		
                                                                                                        $ilance->email->set(array(
                                                                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                                                '{{owner}}' => ucfirst(stripslashes($res_owner['username'])),
                                                                                                                '{{rfpurl}}' => HTTP_SERVER . "merch.php?id=" . $res_rfp['project_id'],
                                                                                                                '{{datetime}}' => DATETODAY . " " . TIMENOW,
                                                                                                                '{{totalamount}}' => $ilance->currency->format($totalescrowamount),
                                                                                                                '{{winningbidder}}' => $res_winner['username'],
                                                                                                                '{{winningbidderemail}}' => $res_winner['email'],
                                                                                                        ));
                                                                                                        
                                                                                                        $ilance->email->send();
                                                                                                        
                                                                                                        // email admin
                                                                                                        $ilance->email->mail = SITE_EMAIL;
                                                                                                        $ilance->email->slng = fetch_site_slng();
                                                                                                        
                                                                                                        $ilance->email->get('product_auction_expired_via_cron_admin');		
                                                                                                        $ilance->email->set(array(
                                                                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                                                '{{owner}}' => ucfirst(stripslashes($res_owner['username'])),
                                                                                                                '{{rfpurl}}' => HTTP_SERVER . 'merch.php?id=' . $res_rfp['project_id'],
                                                                                                                '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                                                                '{{totalamount}}' => $ilance->currency->format($totalescrowamount),
                                                                                                                '{{winningbidder}}' => $res_winner['username'],
                                                                                                                '{{winningbidderemail}}' => $res_winner['email'],
                                                                                                        ));
                                                                                                        
                                                                                                        $ilance->email->send();
                                                                                                        
                                                                                                        $cronlog .= '';
                                                                                                }
                                                                                                else
                                                                                                {
                                                                                                        // no escrow enabled for this product listing
                                                                                                        
                                                                                                        $ilance->db->query("
                                                                                                                UPDATE " . DB_PREFIX . "projects
                                                                                                                SET haswinner = '1',
                                                                                                                winner_user_id = '" . $highbidderid . "'
                                                                                                                WHERE project_id = '" . $res_rfp['project_id'] . "'
                                                                                                                LIMIT 1
                                                                                                        ", 0, null, __FILE__, __LINE__);
                                                                                                        
                                                                                                        $ilance->db->query("
                                                                                                                UPDATE " . DB_PREFIX . "users
                                                                                                                SET productawards = productawards + 1
                                                                                                                WHERE user_id = '" . $highbidderid . "'
                                                                                                        ");
                                                                                                        
                                                                                                        // email owner
                                                                                                        $ilance->email->mail = $res_owner['email'];
                                                                                                        $ilance->email->slng = fetch_user_slng($res_rfp['user_id']);
                                                                                                        
                                                                                                        $ilance->email->get('product_auction_expired_via_cron_no_escrow_owner');		
                                                                                                        $ilance->email->set(array(
                                                                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                                                '{{owner}}' => ucfirst(stripslashes($res_owner['username'])),
                                                                                                                '{{rfpurl}}' => HTTP_SERVER . 'merch.php?id=' . $res_rfp['project_id'],
                                                                                                                '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                                                                '{{totalamount}}' => $ilance->currency->format($totalescrowamount),
                                                                                                                '{{winningbidder}}' => $res_winner['username'],
                                                                                                                '{{winningbidderemail}}' => $res_winner['email'],
                                                                                                        ));
                                                                                                        
                                                                                                        $ilance->email->send();
                                                                                                        
                                                                                                        // email winning bidder
                                                                                                        $ilance->email->mail = $res_winner['email'];
                                                                                                        $ilance->email->slng = fetch_user_slng($highbidderid);
                                                                                                        
                                                                                                        $ilance->email->get('product_auction_expired_via_cron_no_escrow_winner');		
                                                                                                        $ilance->email->set(array(
                                                                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                                                '{{owner}}' => ucfirst(stripslashes($res_owner['username'])),
                                                                                                                '{{owneremail}}' => $res_owner['email'],
                                                                                                                '{{rfpurl}}' => HTTP_SERVER . 'merch.php?id=' . $res_rfp['project_id'],
                                                                                                                '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                                                                '{{totalamount}}' => $ilance->currency->format($totalescrowamount),
                                                                                                                '{{winningbidder}}' => $res_winner['username'],
                                                                                                                '{{winningbidderemail}}' => $res_winner['email'],
                                                                                                        ));
                                                                                                        
                                                                                                        $ilance->email->send();
                                                                                                        
                                                                                                        // email admin
                                                                                                        $ilance->email->mail = SITE_EMAIL;
                                                                                                        $ilance->email->slng = fetch_site_slng();
                                                                                                        
                                                                                                        $ilance->email->get('product_auction_expired_via_cron_no_escrow_admin');		
                                                                                                        $ilance->email->set(array(
                                                                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                                                '{{owner}}' => ucfirst(stripslashes($res_owner['username'])),
                                                                                                                '{{owneremail}}' => $res_owner['email'],
                                                                                                                '{{rfpurl}}' => HTTP_SERVER . 'merch.php?id=' . $res_rfp['project_id'],
                                                                                                                '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                                                                '{{totalamount}}' => $ilance->currency->format($totalescrowamount),
                                                                                                                '{{winningbidder}}' => $res_winner['username'],
                                                                                                                '{{winningbidderemail}}' => $res_winner['email'],
                                                                                                        ));
                                                                                                        
                                                                                                        $ilance->email->send();
                                                                                                        
                                                                                                        $cronlog .= '';
                                                                                                }
                                                                                                
                                                                                                $ilance->db->query("
                                                                                                        UPDATE " . DB_PREFIX . "project_bids
                                                                                                        SET bidstate = '',
                                                                                                        bidstatus = 'awarded',
                                                                                                        date_awarded = '".DATETIME24H."'
                                                                                                        WHERE bid_id = '" . $highbidderbidid . "'
                                                                                                            AND project_id = '" . $res_rfp['project_id'] . "'
                                                                                                        LIMIT 1
                                                                                                ", 0, null, __FILE__, __LINE__);
                                                                                                
                                                                                                // update the highest bidder's low bids to outbid..
                                                                                                $ilance->db->query("
                                                                                                        UPDATE " . DB_PREFIX . "project_bids
                                                                                                        SET bidstate = '',
                                                                                                        bidstatus = 'outbid'
                                                                                                        WHERE user_id = '" . $highbidderid . "'
                                                                                                            AND bidstatus != 'awarded'
                                                                                                            AND project_id = '" . $res_rfp['project_id'] . "'
                                                                                                ", 0, null, __FILE__, __LINE__);
                                                                                                
                                                                                                // #### GENERATE UNPAID FINAL VALUE FEE ########
                                                                                                $ilance->accounting->construct_final_value_fee($highbidderbidid, $res_rfp['cid'], $res_rfp['project_id'], 'charge', 'product');
                                                                                                
                                                                                                $cronlog .= '';
                                                                                        }
                                                                                }
                                                                        }
                                                                }
                                                                
                                                                // #### STOP BIDDING : NO HIGHEST BIDDER ###########################
                                                                else
                                                                {
                                                                        $sql_owner = $ilance->db->query("
                                                                                SELECT *
                                                                                FROM " . DB_PREFIX . "users
                                                                                WHERE user_id = '" . $res_rfp['user_id'] . "'
                                                                        ", 0, null, __FILE__, __LINE__);
                                                                        if ($ilance->db->num_rows($sql_owner) > 0)
                                                                        {
                                                                                $res_owner = $ilance->db->fetch_array($sql_owner);
                                                                                
                                                                                // email owner
                                                                                $ilance->email->mail = $res_owner['email'];
                                                                                $ilance->email->slng = fetch_user_slng($res_rfp['user_id']);
                                                                                
                                                                                $ilance->email->get('product_auction_expired_via_cron_no_bidder_owner');		
                                                                                $ilance->email->set(array(
                                                                                        '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                        '{{owner}}' => ucfirst(stripslashes($res_owner['username'])),
                                                                                        '{{rfpurl}}' => HTTP_SERVER . 'merch.php?id=' . $res_rfp['project_id'],
                                                                                        '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                                ));
                                                                                
                                                                                $ilance->email->send();
                                                                                
                                                                                // email admin
                                                                                $ilance->email->mail = SITE_EMAIL;
                                                                                $ilance->email->slng = fetch_site_slng();
                                                                                
                                                                                $ilance->email->get('product_auction_expired_via_cron_no_bidder_admin');		
                                                                                $ilance->email->set(array(
                                                                                        '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                        '{{owner}}' => ucfirst(stripslashes($res_owner['username'])),
                                                                                        '{{rfpurl}}' => HTTP_SERVER . 'merch.php?id=' . $res_rfp['project_id'],
                                                                                        '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                                ));
                                                                                
                                                                                $ilance->email->send();
                                                                                
                                                                                $cronlog .= '';
                                                                        }
                                                                }    
                                                        }            
                                                }
                                        }
                                }
                        }
                        unset($res_rfp);
                }
                
                // #### EXPIRE PRODUCT AUCTIONS WITH 0 BUY NOW QTY #############
                
                // this will catch product auctions that end early due to the seller having 1 qty
                // left and a buyer purchasing that item via Buy Now (escrow or offline mode). at
                // that point, a trigger will update the project table with buynow_qty = 0 and this
                // task will end the auction early.
                $sql_rfp = $ilance->db->query("
                        SELECT *
                        FROM " . DB_PREFIX . "projects
                        WHERE status = 'open'
                                AND project_state = 'product'
                                AND project_details != 'unique'
                                AND buynow_price > 0
                                AND buynow_qty = '0'
                                AND buynow = '1'
                ", 0, null, __FILE__, __LINE__);
                if ($ilance->db->num_rows($sql_rfp) > 0)
                {
                        $res_owner = array();
                        
                        while ($res_rfp = $ilance->db->fetch_array($sql_rfp))
                        {
                                $sql_owner = $ilance->db->query("
                                        SELECT *
                                        FROM " . DB_PREFIX . "users
                                        WHERE user_id = '" . $res_rfp['user_id'] . "'
                                        LIMIT 1
                                ", 0, null, __FILE__, __LINE__);
                                if ($ilance->db->num_rows($sql_owner) > 0)
                                {
                                        $res_owner = $ilance->db->fetch_array($sql_owner);
                                                
                                        // update open product auctions to expired
                                        $ilance->db->query("
                                                UPDATE " . DB_PREFIX . "projects
                                                SET status = 'expired',
                                                close_date = '" . DATETIME24H . "'
                                                WHERE project_id = '" . $res_rfp['project_id'] . "'
                                                LIMIT 1
                                        ", 0, null, __FILE__, __LINE__);
                                        
                                        // subtract auction count
                                        build_category_count($res_rfp['cid'], 'subtract', "class.auction_expiry.inc.php: subtracting increment count category id $res_rfp[cid]");
                                        
                                        // email owner
                                        $ilance->email->mail = $res_owner['email'];
                                        $ilance->email->slng = fetch_user_slng($res_rfp['user_id']);
                                        
                                        $ilance->email->get('product_auction_ended_early_via_cron_no_buynow_qty');		
                                        $ilance->email->set(array(
                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                '{{project_id}}' => $res_rfp['project_id'],
                                                '{{owner}}' => $res_owner['username'],
                                                '{{rfpurl}}' => HTTP_SERVER . 'merch.php?id=' . $res_rfp['project_id'],
                                                '{{close_date}}' => DATETIME24H,
                                        ));
                                        
                                        $ilance->email->send();
                                        
                                        // email admin
                                        $ilance->email->mail = SITE_EMAIL;
                                        $ilance->email->slng = fetch_site_slng();
                                        
                                        $ilance->email->get('product_auction_ended_early_via_cron_no_buynow_qty_admin');		
                                        $ilance->email->set(array(
                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                '{{project_id}}' => $res_rfp['project_id'],
                                                '{{owner}}' => $res_owner['username'],
                                                '{{rfpurl}}' => HTTP_SERVER . 'merch.php?id=' . $res_rfp['project_id'],
                                                '{{close_date}}' => DATETIME24H,
                                        ));
                                        
                                        $ilance->email->send();
                                        
                                        $cronlog .= '';
                                }
                        }
                        unset($res_rfp, $res_owner);
                }
                
                // #### EXPIRE LOWEST UNIQUE BID AUCTIONS THAT END BASED ON X BIDS PLACED
                // this will catch lowest unique bid product auctions that end early due to the seller
                // specifying that the listing will end based on a total number of bids placed, and that number being met
                $sql_rfp = $ilance->db->query("
                        SELECT *
                        FROM " . DB_PREFIX . "projects
                        WHERE status = 'open'
                                AND project_state = 'product'
                                AND project_details = 'unique'
                                AND uniquebidcount > 0
                ", 0, null, __FILE__, __LINE__);
                if ($ilance->db->num_rows($sql_rfp) > 0)
                {
                        $res_owner = array();
                        
                        while ($res_rfp = $ilance->db->fetch_array($sql_rfp))
                        {
                                $sql_owner = $ilance->db->query("
                                        SELECT *
                                        FROM " . DB_PREFIX . "users
                                        WHERE user_id = '" . $res_rfp['user_id'] . "'
                                        LIMIT 1
                                ", 0, null, __FILE__, __LINE__);
                                if ($ilance->db->num_rows($sql_owner) > 0)
                                {
                                        $res_owner = $ilance->db->fetch_array($sql_owner);
                                        
                                        $bids = $ilance->bid_lowest_unique->fetch_bid_count($res_rfp['project_id']);
                                        $ends = $res_rfp['uniquebidcount'];
                                        $left = ($ends - $bids);
                                        
                                        if ($left <= 0)
                                        {
                                                // #### UNIQUE BIDDING EVENT EXPIRY VIA BIDS LEFT
                                                
                                                // subtract auction count
                                                build_category_count($res_rfp['cid'], 'subtract', "cron.rfp.php: subtracting increment count category id $res_rfp[cid]");
                                                        
                                                // is there a winning lowest unique bid amount placed?
                                                $uniques = $ilance->db->query("
                                                        SELECT user_id, uniquebid, date
                                                        FROM " . DB_PREFIX . "projects_uniquebids
                                                        WHERE project_id = '" . $res_rfp['project_id'] . "'
                                                            AND status = 'lowestunique'
                                                        LIMIT 1
                                                ", 0, null, __FILE__, __LINE__);
                                                if ($ilance->db->num_rows($uniques) > 0)
                                                {
                                                        // yes
                                                        $resunique = $ilance->db->fetch_array($uniques);
                                                        
                                                        // update open product auctions to expired
                                                        $ilance->db->query("
                                                                UPDATE " . DB_PREFIX . "projects
                                                                SET haswinner = '1',
                                                                winner_user_id = '" . $resunique['user_id'] . "'
                                                                WHERE project_id = '" . $res_rfp['project_id'] . "'
                                                        ", 0, null, __FILE__, __LINE__);
                                                        
                                                        $ilance->db->query("
                                                                UPDATE " . DB_PREFIX . "users
                                                                SET productawards = productawards + 1
                                                                WHERE user_id = '" . $resunique['user_id'] . "'
                                                        ");
                                                        
                                                        // create unpaid invoice to winning bidder
                                                        // create new unpaid insertion fee listing invoice to be paid in xx days.
                                                        $transactionid = construct_transaction_id();
                                                        $invoiceid = $ilance->accounting->insert_transaction(
                                                                0,
                                                                $res_rfp['project_id'],
                                                                0,
                                                                $resunique['user_id'],
                                                                0,
                                                                0,
                                                                0,
                                                                $phrase['_lowest_unique_bid_winning_amount_congratulations'],
                                                                sprintf("%01.2f", $resunique['uniquebid']),
                                                                '',
                                                                'unpaid',
                                                                'debit',
                                                                'account',
                                                                DATETIME24H,
                                                                DATEINVOICEDUE,
                                                                '',
                                                                '',
                                                                0,
                                                                0,
                                                                1,
                                                                $transactionid,
                                                                0,
                                                                0
                                                        );
                                                        
                                                        // email winning lowest unique bid user
                                                        $ilance->email->mail = fetch_user('email', $resunique['user_id']);
                                                        $ilance->email->slng = fetch_user_slng($resunique['user_id']);
                                                        
                                                        $ilance->email->get('cron_low_unique_bid_winner');		
                                                        $ilance->email->set(array(
                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                '{{project_id}}' => $res_rfp['project_id'],
                                                                '{{username}}' => fetch_user('username', $resunique['user_id']),
                                                                '{{invoiceid}}' => $invoiceid,
                                                                '{{lowuniquebid}}' => $ilance->currency->format($resunique['uniquebid']),
                                                                '{{totalbids}}' => $ilance->bid_lowest_unique->fetch_bid_count($res_rfp['project_id']),
                                                                '{{windate}}' => $resunique['date'],
                                                                '{{amounttopay}}' => $ilance->currency->format($resunique['uniquebid']),
                                                                '{{txnid}}' => $transactionid,
                                                                '{{paymenturl}}' => HTTPS_SERVER . "invoicepayment.php?id=" . $invoiceid,
                                                        ));
                                                        
                                                        $ilance->email->send();
                                                        
                                                        // email losing bidders
                                                        $losers = $ilance->db->query("
                                                                SELECT user_id, uniquebid, date
                                                                FROM " . DB_PREFIX . "projects_uniquebids
                                                                WHERE project_id = '" . $res_rfp['project_id'] . "'
                                                                    AND status != 'lowestunique'
                                                                    AND user_id != '" . $resunique['user_id'] . "'
                                                                GROUP BY user_id
                                                        ", 0, null, __FILE__, __LINE__);
                                                        if ($ilance->db->num_rows($losers) > 0)
                                                        {
                                                                while ($loser = $ilance->db->fetch_array($losers))
                                                                {
                                                                        // email loser
                                                                        $ilance->email->mail = fetch_user('email', $loser['user_id']);
                                                                        $ilance->email->slng = fetch_user_slng($resunique['user_id']);
                                                                        
                                                                        $ilance->email->get('cron_low_unique_bid_loser');		
                                                                        $ilance->email->set(array(
                                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                '{{project_id}}' => $res_rfp['project_id'],
                                                                                '{{username}}' => fetch_user('username', $loser['user_id']),
                                                                                '{{lowuniquebid}}' => $ilance->currency->format($resunique['uniquebid']),
                                                                                '{{totalbids}}' => $ilance->bid_lowest_unique->fetch_bid_count($res_rfp['project_id']),
                                                                                '{{windate}}' => $resunique['date'],
                                                                                '{{winner}}' => fetch_user('username', $resunique['user_id']),
                                                                        ));
                                                                        
                                                                        $ilance->email->send();
                                                                }
                                                        }
                                                        
                                                        // email admin
                                                        $ilance->email->mail = SITE_EMAIL;
                                                        $ilance->email->slng = fetch_site_slng();
                                                        
                                                        $ilance->email->get('cron_low_unique_bid_admin');		
                                                        $ilance->email->set(array(
                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                '{{project_id}}' => $res_rfp['project_id'],
                                                                '{{invoiceid}}' => $invoiceid,
                                                                '{{lowuniquebid}}' => $ilance->currency->format($resunique['uniquebid']),
                                                                '{{totalbids}}' => $ilance->bid_lowest_unique->fetch_bid_count($res_rfp['project_id']),
                                                                '{{windate}}' => $resunique['date'],
                                                                '{{winner}}' => fetch_user('username', $resunique['user_id']),
                                                                '{{amounttopay}}' => $ilance->currency->format($resunique['uniquebid']),
                                                                '{{txnid}}' => $transactionid,
                                                        ));
                                                        
                                                        $ilance->email->send();
                                                        
                                                        $cronlog .= '';
                                                }
                                                
                                                // #### NO LOWEST UNIQUE BID WINNER ##########################
                                                else
                                                {
                                                        // email all bidders in regards to nobody placing a lowest unique bid for item
                                                        $losers = $ilance->db->query("
                                                                SELECT user_id, uniquebid, date
                                                                FROM " . DB_PREFIX . "projects_uniquebids
                                                                WHERE project_id = '" . $res_rfp['project_id'] . "'
                                                                    AND status != 'lowestunique'
                                                                GROUP BY user_id
                                                        ", 0, null, __FILE__, __LINE__);
                                                        if ($ilance->db->num_rows($losers) > 0)
                                                        {
                                                                while ($loser = $ilance->db->fetch_array($losers))
                                                                {
                                                                        // email user
                                                                        $ilance->email->mail = fetch_user('email', $loser['user_id']);
                                                                        $ilance->email->slng = fetch_user_slng($loser['user_id']);
                                                                        
                                                                        $ilance->email->get('cron_no_low_unique_bid_bidder');		
                                                                        $ilance->email->set(array(
                                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                                '{{project_id}}' => $res_rfp['project_id'],
                                                                                '{{totalbids}}' => $ilance->bid_lowest_unique->fetch_bid_count($res_rfp['project_id']),
                                                                        ));
                                                                        
                                                                        $ilance->email->send();
                                                                }
                                                        }
                                                        
                                                        // email admin
                                                        $ilance->email->mail = SITE_EMAIL;
                                                        $ilance->email->slng = fetch_site_slng();
                                                        
                                                        $ilance->email->get('cron_no_low_unique_bid_bidder');		
                                                        $ilance->email->set(array(
                                                                '{{project_title}}' => stripslashes($res_rfp['project_title']),
                                                                '{{project_id}}' => $res_rfp['project_id'],
                                                                '{{totalbids}}' => $ilance->bid_lowest_unique->fetch_bid_count($res_rfp['project_id']),
                                                        ));
                                                        
                                                        $ilance->email->send();
                                                        
                                                        $cronlog .= '';
                                                }
                                                
                                                $cronlog .= '';
                                        }
                                }
                                
                                // update open product auctions to expired
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "projects
                                        SET status = 'expired',
                                        close_date = '" . DATETIME24H . "'
                                        WHERE project_id = '" . $res_rfp['project_id'] . "'
                                ", 0, null, __FILE__, __LINE__);
                        }
                        unset($res_rfp, $res_owner);
                }
                
                return $cronlog;
        }
        
        function other()
        {
                global $ilance, $phrase, $ilconfig, $ilpage;
                
                $ilance->feedback = construct_object('api.feedback');
                $ilance->accounting = construct_object('api.accounting');
                $ilance->bid = construct_object('api.bid');
                $ilance->bid_lowest_unique = construct_object('api.bid_lowest_unique');
                $ilance->email = construct_dm_object('email', $ilance);
                
                $cronlog = '';
                
                // escrow system enabled?
                if ($ilconfig['escrowsystem_enabled'])
                {
                        // this will run a checkup on escrows that are still pending from "yesterday"
                        // meaning the payer has not forwarded funds into the account yet.
                        $sql_rfp_escrow = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "projects_escrow
                                WHERE date_awarded LIKE '%" . ONEDAYAGO . "%'
                                    AND status = 'pending'
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($sql_rfp_escrow) > 0)
                        {
                                while ($res_rfp_escrow = $ilance->db->fetch_array($sql_rfp_escrow))
                                {
                                        // #### UNPAID RFP ESCROW > OWNER HAS NOT FORWARDED FUNDS YET ######
                                        // #### QUICK EMAIL LOG CHECK > DID USER RECEIVE THIS EMAIL TODAY?
                                        $sql_emaillog = $ilance->db->query("
                                                SELECT *
                                                FROM " . DB_PREFIX . "emaillog
                                                WHERE logtype = 'escrow'
                                                    AND project_id = '" . $res_rfp_escrow['project_id'] . "'
                                                    AND user_id = '" . $res_rfp_escrow['project_user_id'] . "'
                                                    AND date LIKE '%" . DATETODAY . "%'
                                                    AND sent = 'yes'
                                        ", 0, null, __FILE__, __LINE__);
                                        if ($ilance->db->num_rows($sql_emaillog) == 0)
                                        {
                                                $sql_owner = $ilance->db->query("
                                                        SELECT *
                                                        FROM " . DB_PREFIX . "users
                                                        WHERE user_id = '" . $res_rfp_escrow['project_user_id'] . "'
                                                ", 0, null, __FILE__, __LINE__);
                                                if ($ilance->db->num_rows($sql_owner) > 0)
                                                {
                                                        $res_owner = $ilance->db->fetch_array($sql_owner);
                                                        
                                                        $sql_bidder = $ilance->db->query("
                                                                SELECT *
                                                                FROM " . DB_PREFIX . "users
                                                                WHERE user_id = '" . $res_rfp_escrow['user_id'] . "'
                                                        ", 0, null, __FILE__, __LINE__);
                                                        if ($ilance->db->num_rows($sql_bidder) > 0)
                                                        {
                                                                $res_bidder = $ilance->db->fetch_array($sql_bidder);
                                                                
                                                                // email owner
                                                                $ilance->email->mail = $res_owner['email'];
                                                                $ilance->email->slng = fetch_user_slng($res_rfp_escrow['project_user_id']);
                                                                
                                                                $ilance->email->get('unpaid_escrow_reminder');		
                                                                $ilance->email->set(array(
                                                                        '{{days}}' => '1',
                                                                        '{{owner}}' => ucfirst($res_owner['first_name'])." ".ucfirst($res_owner['last_name'])." > ".ucfirst($res_owner['username']),
                                                                        '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                        '{{winningbidder}}' => $res_bidder['username'],
                                                                        '{{winningbidderemail}}' => $res_bidder['email'],
                                                                ));
                                                                
                                                                $ilance->email->send();
                                                                
                                                                #########################################################
                                                                ## LOG EMAIL ENTRY SO NO DUPLICATE EMAILS GET SENT TODAY!
                                                                $ilance->db->query("
                                                                        INSERT INTO " . DB_PREFIX . "emaillog
                                                                        (emaillogid, logtype, user_id, project_id, date, sent)
                                                                        VALUES(
                                                                        NULL,
                                                                        'escrow',
                                                                        '" . $res_owner['user_id'] . "',
                                                                        '" . $res_rfp_escrow['project_id'] . "',
                                                                        '" . DATETODAY . "',
                                                                        'yes')
                                                                ", 0, null, __FILE__, __LINE__);
                                                                
                                                                $sql_emaillog = $ilance->db->query("
                                                                        SELECT *
                                                                        FROM " . DB_PREFIX . "emaillog
                                                                        WHERE logtype = 'escrow'
                                                                            AND project_id = '" . $res_rfp_escrow['project_id'] . "'
                                                                            AND user_id = '" . $res_bidder['user_id'] . "'
                                                                            AND date LIKE '%" . DATETODAY . "%'
                                                                            AND sent = 'yes'
                                                                ", 0, null, __FILE__, __LINE__);
                                                                if ($ilance->db->num_rows($sql_emaillog) == 0)
                                                                {
                                                                        #########################################################
                                                                        ## LOG EMAIL ENTRY SO NO DUPLICATE EMAILS GET SENT TODAY!
                                                                        $ilance->db->query("
                                                                                INSERT INTO " . DB_PREFIX . "emaillog
                                                                                (emaillogid, logtype, user_id, project_id, date, sent)
                                                                                VALUES(
                                                                                NULL,
                                                                                'escrow',
                                                                                '" . $res_bidder['user_id'] . "',
                                                                                '" . $res_rfp_escrow['project_id'] . "',
                                                                                '" . DATETODAY . "',
                                                                                'yes')
                                                                        ", 0, null, __FILE__, __LINE__);
                                                                        
                                                                        // email bidder
                                                                        $ilance->email->mail = $res_bidder['email'];
                                                                        $ilance->email->slng = fetch_user_slng($res_bidder['user_id']);
                                                                        
                                                                        $ilance->email->get('unpaid_escrow_reminder_receiver');		
                                                                        $ilance->email->set(array(
                                                                                '{{days}}' => '1',
                                                                                '{{owner}}' => ucfirst($res_owner['first_name'])." ".ucfirst($res_owner['last_name'])." > ".ucfirst($res_owner['username']),
                                                                                '{{owneremail}}' => $res_owner['email'],
                                                                                '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                                '{{winningbidder}}' => ucfirst($res_bidder['first_name'])." ".ucfirst($res_bidder['last_name'])." > ".ucfirst($res_bidder['username']),
                                                                                '{{winningbidderemail}}' => $res_bidder['email'],
                                                                        ));
                                                                        
                                                                        $ilance->email->send();
                                                                        
                                                                        $cronlog .= '';
                                                                }
                                                                
                                                                // email admin
                                                                $ilance->email->mail = SITE_EMAIL;
                                                                $ilance->email->slng = fetch_site_slng();
                                                                
                                                                $ilance->email->get('unpaid_escrow_reminder_admin');		
                                                                $ilance->email->set(array(
                                                                        '{{days}}' => '1',
                                                                        '{{owner}}' => ucfirst($res_owner['first_name'])." ".ucfirst($res_owner['last_name'])." > ".ucfirst($res_owner['username']),
                                                                        '{{owneremail}}' => $res_owner['email'],
                                                                        '{{datetime}}' => DATETODAY . ' ' . TIMENOW,
                                                                        '{{winningbidder}}' => ucfirst($res_bidder['first_name'])." ".ucfirst($res_bidder['last_name'])." > ".ucfirst($res_bidder['username']),
                                                                        '{{winningbidderemail}}' => $res_bidder['email'],
                                                                ));
                                                                
                                                                $ilance->email->send();
                                                                
                                                                $cronlog .= '';
                                                        }
                                                }
                                        }
                                }
                                unset($res_rfp_escrow);
                        }
                }
                
                // check-up customers rating and update `users` table
                $awardupdate = $ilance->db->query("
                        SELECT user_id
                        FROM " . DB_PREFIX . "users
                ", 0, null, __FILE__, __LINE__);
                if ($ilance->db->num_rows($awardupdate) > 0)
                {
                        while ($res = $ilance->db->fetch_array($awardupdate))
                        {
                                // update service proposal wins / awards
                                fetch_service_bids_awarded($res['user_id'], true);
                                
                                // update product wins / awards
                                fetch_product_bids_awarded($res['user_id'], true);
                                
                                // update feedback, rating and score
                                $ilance->feedback->construct_ratings($res['user_id']);
                                
                                $cronlog .= '';
                        }
                        unset($res);
                }
                
                // In many cases, an admin or developer may remove bids within phpmyadmin
                // for testing purposes if somehow, this bid had an escrow account tied to it,
                // we must cancel the escrow account so no unlinking can occur within the
                // production system.  We will also cancel any invoices that are still unpaid
                $sqlescrowbids = $ilance->db->query("
                        SELECT bid_id, invoiceid, project_id
                        FROM " . DB_PREFIX . "projects_escrow
                        WHERE status != 'finished'
                ", 0, null, __FILE__, __LINE__);
                if ($ilance->db->num_rows($sqlescrowbids) > 0)
                {
                        while ($bids = $ilance->db->fetch_array($sqlescrowbids))
                        {
                                // check for orphan bids
                                $sqlexist = $ilance->db->query("
                                        SELECT user_id
                                        FROM " . DB_PREFIX . "project_bids
                                        WHERE bid_id = '" . $bids['bid_id'] . "'
                                ", 0, null, __FILE__, __LINE__);
                                if ($ilance->db->num_rows($sqlexist) == 0)
                                {
                                        // bid does not exist anymore - cancel escrow account
                                        $ilance->db->query("
                                                UPDATE " . DB_PREFIX . "projects_escrow
                                                SET status = 'cancelled'
                                                WHERE bid_id = '" . $bids['bid_id'] . "'
                                                LIMIT 1
                                        ", 0, null, __FILE__, __LINE__);
                                        
                                        // cancel associated invoice as well (if its not paid)
                                        $ilance->db->query("
                                                UPDATE " . DB_PREFIX . "invoices
                                                SET status = 'cancelled'
                                                WHERE invoiceid = '" . $bids['invoiceid'] . "'
                                                    AND status != 'paid'
                                                LIMIT 1
                                        ", 0, null, __FILE__, __LINE__);
                                        
                                        $cronlog .= '';
                                }
                        }
                        unset($bids);
                        
                        while ($auctions = $ilance->db->fetch_array($sqlescrowbids))
                        {
                                // check for orphan auctions
                                $sqlexist = $ilance->db->query("
                                        SELECT user_id
                                        FROM " . DB_PREFIX . "project_bids
                                        WHERE project_id = '" . $auctions['project_id'] . "'
                                ", 0, null, __FILE__, __LINE__);
                                if ($ilance->db->num_rows($sqlexist) == 0)
                                {
                                        // auction does not exist anymore - remove escrow account
                                        $ilance->db->query("
                                                UPDATE " . DB_PREFIX . "projects_escrow
                                                SET status = 'cancelled'
                                                WHERE project_id = '" . $auctions['invoiceid'] . "'
                                                LIMIT 1
                                        ", 0, null, __FILE__, __LINE__);
                                        
                                        // cancel associated invoice as well (if its not paid)
                                        $ilance->db->query("
                                                UPDATE " . DB_PREFIX . "invoices
                                                SET status = 'cancelled'
                                                WHERE invoiceid = '" . $auctions['invoiceid'] . "'
                                                    AND status != 'paid'
                                                LIMIT 1
                                        ", 0, null, __FILE__, __LINE__);
                                        
                                        $cronlog .= '';
                                }
                        }
                        unset($auctions);
                }
                
                // In some cases, an auction could have a winning bid, but the bid or user
                // becomes removed by an admin or staff resulting in an unlinked awarded
                // auction.  Let's prevent that via search and delist
                $sqlapproved = $ilance->db->query("
                        SELECT project_id
                        FROM " . DB_PREFIX . "projects
                        WHERE status = 'approval_accepted' OR status = 'wait_approval'
                ", 0, null, __FILE__, __LINE__);
                if ($ilance->db->num_rows($sqlapproved) > 0)
                {
                        while ($projects = $ilance->db->fetch_array($sqlapproved))
                        {
                                // check for orphan awards
                                $sqlbidexist = $ilance->db->query("
                                        SELECT bid_id
                                        FROM " . DB_PREFIX . "project_bids
                                        WHERE project_id = '" . $projects['project_id'] . "'
                                ", 0, null, __FILE__, __LINE__);
                                if ($ilance->db->num_rows($sqlbidexist) == 0)
                                {
                                        // bid does not exist anymore - delist auction
                                        $ilance->db->query("
                                                UPDATE " . DB_PREFIX . "projects
                                                SET status = 'delisted'
                                                WHERE project_id = '" . $projects['project_id'] . "'
                                                LIMIT 1
                                        ", 0, null, __FILE__, __LINE__);
                                        
                                        $cronlog .= '';
                                }
                        }
                        unset($projects);
                }
                
                $cronlog .= $this->listings_expired_to_finished();
                
                return $cronlog;
        }
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: class.auction_expiry.inc.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>