<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

/**
* Auction posting class to perform the majority of printing and displaying of filters and other form elements
* for service and product auctions.
*
* @package      iLance
* @version	$Revision: 1.0.0 $
* @author       ILance
*/
class auction_post extends auction
{
        /**
        * Function to print bid filters controlled via radio button and multiple selective options
        * during the post of a new service or product auction.
        *
        * @return      string        HTML representation of the bid filters permitted
        */
        function print_bid_filters()
        {
                global $ilance, $ilconfig, $phrase;
                
                // bid filters: checkboxes
                $filtered_rating0 = $filter_rating1 = $filtered_rating1 = $filtered_rating2 = $filtered_rating3 = $filtered_rating4 = $filtered_rating5 = $filter_country1 = $filter_state1 = $filter_city1 = $filtered_city1 = $filter_zip1 = $filtered_zip1 = $businessnumber = $underage = '';
        
                if (!empty($ilance->GPC['filter_rating']) AND $ilance->GPC['filter_rating'])
                {
                        $filter_rating1 = 'checked="checked"';
                }
                else if (isset($ilance->GPC['filtered_rating']) AND $ilance->GPC['filtered_rating'] == '1')
                {
                        $filtered_rating1 = 'selected="selected"';
                }
                else if (isset($ilance->GPC['filtered_rating']) AND $ilance->GPC['filtered_rating'] == '2')
                {
                        $filtered_rating2 = 'selected="selected"';
                }
                else if (isset($ilance->GPC['filtered_rating']) AND $ilance->GPC['filtered_rating'] == '3')
                {
                        $filtered_rating3 = 'selected="selected"';
                }
                else if (isset($ilance->GPC['filtered_rating']) AND $ilance->GPC['filtered_rating'] == '4')
                {
                        $filtered_rating4 = 'selected="selected"';
                }
                else if (isset($ilance->GPC['filtered_rating']) AND $ilance->GPC['filtered_rating'] == '5')
                {
                        $filtered_rating5 = 'selected="selected"';
                }
                else
                {
                        $filtered_rating0 = 'selected="selected"';        
                }
        
                if (!empty($ilance->GPC['filter_country']) AND $ilance->GPC['filter_country'])
                {
                        $filter_country1 = 'checked="checked"';
                }
        
                if (!empty($ilance->GPC['filter_state']) AND $ilance->GPC['filter_state'])
                {
                        $filter_state1 = 'checked="checked"';
                }
        
                if (!empty($ilance->GPC['filter_city']) AND $ilance->GPC['filter_city'])
                {
                        $filter_city1 = 'checked="checked"';
                }
                if (isset($ilance->GPC['filtered_city']) AND $ilance->GPC['filtered_city'] != '')
                {
                        $filtered_city1 = stripslashes(strip_tags($ilance->GPC['filtered_city']));
                        $filter_city1 = 'checked="checked"';
                }
        
                if (!empty($ilance->GPC['filter_zip']) AND $ilance->GPC['filter_zip'])
                {
                        $filter_zip1 = 'checked="checked"';
                }
                if (isset($ilance->GPC['filtered_zip']) AND $ilance->GPC['filtered_zip'] != '')
                {
                        $filtered_zip1 = str_replace(' ', '', stripslashes(strip_tags($ilance->GPC['filtered_zip'])));
                        $filter_zip1 = 'checked="checked"';
                }
        
                if (isset($ilance->GPC['filter_underage']) AND $ilance->GPC['filter_underage'] > 0)
                {
                        $underage = 'checked="checked"';
                }
        
                if (isset($ilance->GPC['filter_businessnumber']) AND $ilance->GPC['filter_businessnumber'] > 0)
                {
                        $businessnumber = 'checked="checked"';
                }
                
                $html = '
                <table cellpadding="0" cellspacing="0" border="0" width="100%">
                <tr>
                    <td valign="top" width="50%">
                    
                        <table cellpadding="3" cellspacing="0" border="0" width="1%">
                        <tr>
                                <td width="4%" valign="top"><input type="checkbox" name="filter_rating" id="filter_rating" value="1" ' . $filter_rating1 . ' /></td>
                                <td nowrap="nowrap"><div style="padding-bottom:3px" class="gray"><label for="filter_rating">' . $phrase['_requires_bidders_have_at_least_an_overall'] . '&nbsp; </label></div>
                                <div>
                                <select name="filtered_rating" style="font-family: verdana">
                                                <option value="" ' . $filtered_rating0 . ' >-</option>
                                                <option value="1" ' . $filtered_rating1 . ' >' . $phrase['_at_least'] . ' 1.0 / 5.0</option>
                                                <option value="2" ' . $filtered_rating2 . ' >' . $phrase['_at_least'] . ' 2.0 / 5.0</option>
                                                <option value="3" ' . $filtered_rating3 . ' >' . $phrase['_at_least'] . ' 3.0 / 5.0</option>
                                                <option value="4" ' . $filtered_rating4 . ' >' . $phrase['_at_least'] . ' 4.0 / 5.0</option>
                                                <option value="5" ' . $filtered_rating5 . ' >' . $phrase['_at_least'] . ' 5.0 / 5.0</option>
                                </select></div></td>
                        </tr>
                        <tr>
                                <td valign="top"><input type="checkbox" name="filter_city" id="filter_city" value="1" ' . $filter_city1 . ' /></td>
                                <td nowrap="nowrap"><div style="padding-bottom:3px" class="gray"><label for="filter_city"> ' . $phrase['_requires_bidders_reside_or_do_business_city'] . '&nbsp; </label></div>
                                <div><input type="text" id="filtered_city" class="input" name="filtered_city" value="' . $filtered_city1 . '" onkeypress="return noenter()" title="" style="width:175px" /></div></td>
                        </tr>';                
                        if ($ilconfig['registrationdisplay_dob'])
                        {
                                $html .='
                                <tr>
                                        <td valign="bottom"><input type="checkbox" name="filter_underage" id="filter_underage" value="1" ' . $underage . ' /></td>
                                        <td nowrap="nowrap"><span class="gray"><label for="filter_underage"> ' . $phrase['_prevent_under_age_bidders_18_years_and_younger'] . '</label></span></td>
                                </tr>';
                        }
                        else
                        {
                                $html .= '<input type="hidden" name="filter_underage" value="0" />';        
                        }                
                        $html .= '
                        <tr>
                                <td valign="bottom"><input type="checkbox" name="filter_businessnumber" id="filter_businessnumber" value="1" ' . $businessnumber . ' /></td>
                                <td nowrap="nowrap"><span class="gray"><label for="filter_businessnumber"> ' . $phrase['_prevent_bidders_that_have_not_supplied_a_valid_business_or_vat_number'] . '</label></span></td>
                        </tr>
                        </table>
                    
                    </td>
                    <td valign="top" width="50%">
                    
                        <table cellpadding="6" cellspacing="0" border="0" width="100%">
                        <tr>
                                <td valign="top"><input type="checkbox" name="filter_country" id="filter_country" value="1" ' . $filter_country1 . ' /></td>
                                <td valign="top"><div class="gray" style="padding-bottom:3px"><label for="filter_country"> ' . $phrase['_requires_bidders_reside_or_do_business_country'] . '&nbsp; </label></div>
                                <div>{country_js_pulldown}</div></td>
                        </tr>
                        <tr>
                                <td valign="top"><input type="checkbox" name="filter_state" id="filter_state" value="1" ' . $filter_state1 . ' /></td>
                                <td><div class="gray" style="padding-bottom:3px"><label for="filter_state"> ' . $phrase['_requires_bidders_reside_or_do_business_state'] . '&nbsp; </label></div>
                                <div>{state_js_pulldown}</div></td>
                        </tr>
                        <tr>
                                <td valign="top"><input type="checkbox" name="filter_zip" id="filter_zip" value="1" ' . $filter_zip1 . ' /></td>
                                <td nowrap><div class="gray" style="padding-bottom:3px"><label for="filter_zip"> ' . $phrase['_requires_bidders_reside_or_do_business_zip'] . '&nbsp; </label></div>
                                <div><input type="text" id="filtered_zip" class="input" name="filtered_zip" value="' . $filtered_zip1 . '" onkeypress="return noenter()" title="" style="width:100px" /> <span class="gray">(' . $phrase['_no_spaces_or_dashes'] . ')</span></div></td>
                        </tr>
                        </table>
                        
                    </td>
                </tr>
                </table>';
                
                return $html;
        }
        
        /**
        * Function to print profile bid filters controlled via radio button and multiple selective options
        * during the post of a new service or product auction such as ranges (from / to values) and pulldown
        * menu options (including multiple choice selection values).
        *
        * This function is called in the advanced search menu as well as when a user is posting a new listing.
        *
        * @param       integer       category id
        * @param       string        display mode (input, preview, output)
        * @param       string        category type (service)
        * @param       integer       project id (for updating listing)
        * 
        * @return      string        HTML representation of the bid filters permitted
        */
        function print_profile_bid_filters($cid = 0, $displaymode = '', $catype = 'service', $projectid = 0)
        {
                global $ilance, $ilconfig, $phrase, $show;
                
                $show['profile_filters'] = false;
                
                $html = '';
                if ($cid == 0)
                {
	                $sql = $ilance->db->query("
	                        SELECT questionid, description, question, isfilter, filtertype, filtercategory, inputtype, multiplechoice
	                        FROM " . DB_PREFIX . "profile_questions
	                        WHERE isfilter = '1'
                                        AND filtercategory = '-1'
	                        	AND (inputtype = 'int' OR inputtype = 'multiplechoice' OR inputtype = 'pulldown')
	                ");                	
                }
                else 
                {
	                $sql = $ilance->db->query("
	                        SELECT questionid, description, question, isfilter, filtertype, filtercategory, inputtype, multiplechoice
	                        FROM " . DB_PREFIX . "profile_questions
	                        WHERE isfilter = '1'
                                        AND (filtercategory = '" . intval($cid) . "' OR filtercategory = '-1')
                                        AND (inputtype = 'int' OR inputtype = 'multiplechoice' OR inputtype = 'pulldown')
	                ");
                }
                if ($ilance->db->num_rows($sql) > 0)
                {
                        $show['profile_filters'] = true;
                        
                        $html = '
                        <table cellpadding="6" cellspacing="1" border="0" width="100%">
                        <tr>';
                        
                        $i = $q = $m = $n = $g = 0;  
                        while ($res = $ilance->db->fetch_array($sql))
                        {
                                $d = $i % 2;
                                
                                // #### INPUT MODE #############################
                                if ($displaymode == 'input')
                                {
                                        switch ($res['inputtype'])
                                        {
                                        	case 'int':
                                                {
                                                        $html .= '<td width="25%" valign="top"><div><strong>' . $res['question'] . '</strong></div><div class="gray">' . $phrase['_select_range_pattern'] . '</div><div style="padding-top:4px"><strong>' . $phrase['_between_upper'] . '</strong> &nbsp;<input class="input" name="pa[range][' . $res['questionid'] . '][from]" value="" style="width:40px" /> &nbsp;&nbsp;<strong>' . $phrase['_and'] . '</strong> &nbsp;<input name="pa[range][' . $res['questionid'] . '][to]" value="" class="input" style="width:40px" /></div></td>';
                                                        $q++;
                                                        break;
                                                }
                                                case 'multiplechoice':
                                        	case 'pulldown':
                                                {
                                                        $questions = $res['multiplechoice'];
                                                        $choices = explode('|', $questions);
                                                        
                                                        $html_choice = array();
                                                        $k = 0;
                                                        foreach ($choices as $choice)
                                                        {
                                                               $html_choice["$k"] = stripslashes($choice);
                                                               $k++;
                                                        }
                                        
                                                        $html .= '<td width="25%" valign="top"><strong>' . $res['question'] . '</strong><div class="gray" style="padding-bottom:6px">' . $phrase['_select_multiple_choices'] . '</div>';
                                                        
                                                        $j = 0;
                                                        $km = $k + $n;
                                                        while ($n < $km)
                                                        {
                                                                $html .= '<div><label for="pulldown_' . str_replace(' ', '_', mb_strtolower($html_choice["$j"])) . '_' . $j . '"><input type="checkbox" name="pa[choice_' . str_replace(' ', '_', mb_strtolower($html_choice["$j"])) . '][' . $res['questionid'] . '][custom]" value="' . $html_choice["$j"] . '" id="pulldown_' . str_replace(' ', '_', mb_strtolower($html_choice["$j"])) . '_' . $j . '" /> ' . $html_choice["$j"] . '</label></div>';
                                                                $n++;
                                                                $j++;
                                                        }
                                                        
                                                        $html .= '</td>';

                                                        break;
                                                }
                                        }    
                                }
                                
                                // #### UPDATE INPUT MODE ######################
                                else if ($displaymode == 'update')
                                {
                                        switch ($res['inputtype'])
                                        {
                                        	case 'int':
                                                {
                                                        $from = $to = '';
                                                        $fromto = $ilance->db->fetch_field(DB_PREFIX . "profile_filter_auction_answers", "questionid = '" . $res['questionid'] . "'", "answer");
                                                        if (!empty($fromto))
                                                        {
                                                                $fromto = explode('|', $fromto);
                                                                $from = $fromto[0];
                                                                $to = $fromto[1];
                                                        }
                                                        
                                                        $html .= '<td width="25%" valign="top"><div><strong>' . $res['question'] . '</strong></div><div class="gray">' . $phrase['_select_range_pattern'] . '</div><div style="padding-top:4px"><strong>' . $phrase['_between_upper'] . '</strong> &nbsp;<input class="input" name="pa[range][' . $res['questionid'] . '][from]" value="' . $from . '" style="width:40px" /> &nbsp;&nbsp;<strong>' . $phrase['_and'] . '</strong> &nbsp;<input name="pa[range][' . $res['questionid'] . '][to]" value="' . $to . '" class="input" style="width:40px" /></div></td>';
                                                        $q++;
                                                        break;
                                                }
                                                case 'multiplechoice':
                                        	case 'pulldown':
                                                {
                                                        $questions = $res['multiplechoice'];
                                                        $choices = explode('|', $questions);
                                                        
                                                        $existing = $ilance->db->fetch_field(DB_PREFIX . "profile_filter_auction_answers", "questionid = '" . $res['questionid'] . "'", "answer");
                                                        if (!empty($existing))
                                                        {
                                                                $existing = explode('|', $existing);        
                                                        }
                                                        
                                                        $html_choice = array();
                                                        $k = 0;
                                                        foreach ($choices as $choice)
                                                        {
                                                               $html_choice["$k"] = stripslashes($choice);
                                                               $k++;
                                                        }
                                        
                                                        $html .= '<td width="25%" valign="top"><strong>' . $res['question'] . '</strong><div class="gray" style="padding-bottom:6px">' . $phrase['_select_multiple_choices'] . '</div>';
                                                        
                                                        $j = 0;
                                                        $km = $k + $n;
                                                        while ($n < $km)
                                                        {
                                                                $checked = '';
                                                                if (!empty($existing) AND is_array($existing) AND in_array($html_choice["$j"], $existing))
                                                                {
                                                                        $checked = 'checked="checked"';
                                                                }
                                                                
                                                                $html .= '<div><label for="pulldown_' . str_replace(' ', '_', mb_strtolower($html_choice["$j"])) . '_' . $j . '"><input type="checkbox" name="pa[choice_' . str_replace(' ', '_', mb_strtolower($html_choice["$j"])) . '][' . $res['questionid'] . '][custom]" value="' . $html_choice["$j"] . '" id="pulldown_' . str_replace(' ', '_', mb_strtolower($html_choice["$j"])) . '_' . $j . '" ' . $checked . ' /> ' . $html_choice["$j"] . '</label></div>';
                                                                $n++;
                                                                $j++;
                                                        }
                                                        
                                                        $html .= '</td>';

                                                        break;
                                                }
                                        }    
                                }
                                
                                // check if the current column is dividable by two
                                if ($d == 4 && $i != 0)
                                {
                                        $html .= '</tr><tr>';
                                }
                                $i++;
                        }
                        
                        $html .= '
                        </tr>
                        </table>';
                }
                else
                {
                        $html = '<div>' . $phrase['_there_are_currently_no_filters_that_exist_within_the_selected_category'] . '</div>';
                }
                
                return $html;
        }
        
        /**
        * Function to print the available bid amount types for the auction poster to select based on the admin
        * defined bid types for this particular category.
        *
        * @param       integer       category id
        * @param       string        category type
        * 
        * @return      string        HTML representation of the bid amount type form elements
        */
        function print_bid_amount_type($cid = 0, $cattype = '')
        {
                global $ilance, $ilconfig, $phrase, $show;
                
                $bidtype1 = '';
                $bidtype2 = 'checked="checked"';
                if (!empty($ilance->GPC['filter_bidtype']) AND $ilance->GPC['filter_bidtype'])
                {
                        $bidtype1 = 'checked="checked"';
                        $bidtype2 = '';
                }

                $bidamounttype = isset($ilance->GPC['filtered_bidtype']) ? $ilance->GPC['filtered_bidtype'] : '';
                
                // will also provide $show['bidamountgroups'] to true or false
                $bidamounttype_pulldown = $this->construct_bidamounttype_pulldown($bidamounttype, $disable = 0, $dojs = 1, $cid, $cattype);
                
                $html = '<table cellpadding="0" cellspacing="2" border="0" width="100%">';
                
                if ($show['bidamounttypes'])
                {
                        $html .= '
                        <tr>
                                <td width="1%">
                                        <input type="radio" id="biddingtype" name="filter_bidtype" ' . $bidtype1 . ' value="1" />
                                </td>
                                <td align="left"><label for="biddingtype">' . $bidamounttype_pulldown . '</label></td>
                        </tr>';    
                }

                $html .= '
                <tr>
                        <td><input type="radio" id="biddingtype0" name="filter_bidtype" ' . $bidtype2 . ' value="0" /></td>
                        <td align="left"><label for="biddingtype0">' . $phrase['_i_will_accept_various_bidding_types_no_restriction'] . '</label></td>
                </tr>
                </table>';
                
                return $html;
        }
        
        /**
        * Function to print the budget logic selectable options.  For example, the poster could select
        * "I do not wish to disclose my budget" or he/she can select the appropriate budget range to select.
        * Additionally, admins can assign "insertion fees" to any budget group.  Insertion fees will also be
        * shown (their value) if they have been assigned to this category (based on the level of budget).  EX:
        * - Small Project ($100-$500) - Insertion Fee: $3.00
        * - Medium Project ($500-$1000) - Insertion Fee: $5.00
        * etc.
        *
        * @param       integer       category id
        * @param       string        category type (service)
        * @param       bool          do javascript (default true)
        * @param       bool          show insertion fees (default false)
        * 
        * @return      string        HTML representation of the bid amount type form elements
        */
        function print_budget_logic_type($cid = 0, $cattype = 'service', $dojs = 1, $showinsertionfees = false)
        {
                global $ilance, $ilconfig, $phrase, $show;
                
                $budget1 = '';
                $budget2 = 'checked="checked"';
                if (!empty($ilance->GPC['filter_budget']) AND $ilance->GPC['filter_budget'])
                {
                        $budget1 = 'checked="checked"';
                        $budget2 = '';
                }
                $selected = isset($ilance->GPC['filtered_budgetid']) ? intval($ilance->GPC['filtered_budgetid']) : '';
                
                // budget pulldown also sets $show['budgetgroups'] to true or false for logic below
                $show['selectedbudgetlogic'] = 0;
                $budget_pulldown  = $this->construct_budget_pulldown($cid, $selected, 'filtered_budgetid', $dojs, $showselect = 0, $showinsertionfees);
                $hidden = '';

                $html = '<table cellpadding="0" cellspacing="2" border="0" width="100%">';                
                if ($show['budgetgroups'])
                {
                        $html .= '
                        <tr>
                                <td width="1%">
                                        <input type="radio" id="showbudget" name="filter_budget" ' . $budget1 . ' value="1" />
                                </td>
                                <td align="left"><label for="showbudget">' . $budget_pulldown . '</label></td>
                        </tr>
                        <tr>
                                <td width="1%" height="15"><strong>' . $phrase['_or_upper'] . '</strong></td>
                        </tr>';
                }
                else
                {
                        $hidden = '<input type="hidden" name="filtered_budgetid" value="0" />';
                }
                
                $nondisclosefeeamount = $phrase['_free'];
                $amount = $ilance->categories->fetch[$_SESSION['ilancedata']['user']['slng']]["service"]["$cid"]["nondisclosefeeamount"];
                if (!empty($amount) AND $amount > 0)
                {
                        $nondisclosefeeamount = $ilance->currency->format($amount);
                }
                
                if (empty($selected))
                {
                        $show['selectedbudgetlogic'] = $amount;
                }
                
                $html .= '
                <tr>
                        <td width="1%"><input type="radio" id="showbudget0" name="filter_budget" ' . $budget2 . ' value="0" />' . $hidden . '</td>
                        <td align="left"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/nondisclosed.gif" border="0" alt="" /> <label for="showbudget0">' . $phrase['_i_prefer_not_to_disclose_my_budget'] . ' - <strong>' . $nondisclosefeeamount . '</strong></label></td>
                </tr>
                </table>';
                
                return $html;
        }
        
        /**
        * Function to print the budget links
        *
        * @param       integer       category id
        * @param       string        category type (service/product)
        * @param       integer       selected budget id
        *
        * @return      string        HTML representation of the budget as a link
        */
        function print_budget_logic_type_links($cid = 0, $cattype = 'service', $selected = '')
        {
                global $ilance, $ilconfig, $phrase, $show;
                
                $html = $budgetgroup = '';
                $url = PHP_SELF;
                
                if ($cid == 0)
                {
                        $show['budgetgroups'] = false;
                        return;
                }
                
                $query = $ilance->db->query("
                        SELECT budgetgroup
                        FROM " . DB_PREFIX . "categories
                        WHERE cid = '" . intval($cid) . "'
                        LIMIT 1
                ", 0, null, __FILE__, __LINE__);
                if ($ilance->db->num_rows($query) > 0)
                {
                        $res = $ilance->db->fetch_array($query);
                        $budgetgroup = $res['budgetgroup'];
                        
                        $sql = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "budget
                                WHERE budgetgroup = '" . $ilance->db->escape_string($budgetgroup) . "'
                                ORDER BY budgetfrom ASC
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($sql) > 0)
                        {
                                $show['budgetgroups'] = true;
                                $counter = 0;
                                
                                // give user choice to select "any"
                                if (isset($selected) AND $selected == '0')
                                {
                                        $html .= '<div style="padding-bottom:3px"><strong>' . $phrase['_any_budget'] . '</strong></div>';
                                }
                                else
                                {
                                        $html .= '<div style="padding-bottom:3px"><a href="' . $url . '&amp;budget=0">' . $phrase['_any_budget'] . '</a></div>';
                                }
                                
                                if (isset($selected) AND $selected == '-1')
                                {
                                        $html .= '<div style="padding-bottom:3px"><strong>' . $phrase['_non_disclosed'] . '</strong></div>';
                                }
                                else
                                {
                                        $html .= '<div style="padding-bottom:3px"><a href="' . $url . '&amp;budget=-1">' . $phrase['_non_disclosed'] . '</a></div>';
                                }
                                unset($counter);
                                
                                while ($res = $ilance->db->fetch_array($sql))
                                {
                                        $counter = 0;
                                        if (isset($selected) AND $selected == $res['budgetid'])
                                        {
                                                if ($res['budgetto'] == '-1')
                                                {
                                                        $html .= '<div style="padding-bottom:3px"><strong>' . $ilance->currency->format($res['budgetfrom']) . ' ' . $phrase['_or_more'] . '</strong></div>';    
                                                }
                                                else
                                                {
                                                        $html .= '<div style="padding-bottom:3px"><strong>' . $ilance->currency->format($res['budgetfrom']) . ' - ' . $ilance->currency->format($res['budgetto']) . '</strong></div>';
                                                }
                                        }
                                        else 
                                        {
                                                if ($res['budgetto'] == '-1')
                                                {
                                                        $html .= '<div style="padding-bottom:3px"><a href="' . $url . '&amp;budget=' . $res['budgetid'] . '">' . $ilance->currency->format($res['budgetfrom']) . ' ' . $phrase['_or_more'] . '</a></div>';    
                                                }
                                                else
                                                {
                                                        $html .= '<div style="padding-bottom:3px"><a href="' . $url . '&amp;budget=' . $res['budgetid'] . '">' . $ilance->currency->format($res['budgetfrom']) . ' - ' . $ilance->currency->format($res['budgetto']) . '</a></div>';
                                                }
                                        }
                                }
                                unset($counter);
                        }
                }
                
                return $html;
        }
        
        /**
        * Function to print the budget javascript details for the yahoo slider widget
        *
        * @param       integer       category id
        * @param       string        category type (service/product)
        * @param       integer       selected budget id
        *
        * @return      string        array of budgets for yahoo slider widget
        */
        function print_budget_logic_type_js($cid = 0, $cattype = 'service', $selected = '')
        {
                global $ilance, $ilconfig, $phrase, $show;
                
                $htmla = "new Array(";
                $htmlb = "new Array(";
                $budgetgroup = '';
                
                if ($cid == 0 OR $cattype != 'service')
                {
                        $show['budgetgroups'] = false;
                        return;
                }
                
                $query = $ilance->db->query("
                        SELECT budgetgroup
                        FROM " . DB_PREFIX . "categories
                        WHERE cid = '" . intval($cid) . "'
                        LIMIT 1
                ", 0, null, __FILE__, __LINE__);
                if ($ilance->db->num_rows($query) > 0)
                {
                        $res = $ilance->db->fetch_array($query);
                        
                        $show['budgetgroups'] = true;
                                
                        $htmla .= "'" . $phrase['_any_budget'] . "',";
                        $htmlb .= "'0',";
                        
                        $htmla .= "'" . $phrase['_non_disclosed_budget'] . "',";
                        $htmlb .= "'-1',";
                        
                        $budgetgroup = $res['budgetgroup'];
                        
                        $sql2 = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "budget
                                WHERE budgetgroup = '" . $ilance->db->escape_string($budgetgroup) . "'
                                ORDER BY budgetfrom ASC
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($sql2) > 0)
                        {
                                while ($res2 = $ilance->db->fetch_array($sql2))
                                {
                                        $htmla .= "'" . $ilance->currency->format($res2['budgetfrom']) . " " . $phrase['_to'] . " " . $ilance->currency->format($res2['budgetto']) . "',";
                                        //$htmla .= "'" . $res2['title'] . "',";
                                        $htmlb .= "'" . $res2['budgetid'] . "',";
                                }
                        }
                }
                
                $htmla = mb_substr($htmla, 0, -1);
                $htmlb = mb_substr($htmlb, 0, -1);
                
                $htmla .= ");";
                $htmlb .= ");";
                
                return array($htmla, $htmlb);
        }
        
        /**
        * Function to print the escrow filter option so that the auction poster can enable or disable
        * escrow to secure any funds for mentioned services or products during the transaction/delivery
        * process.
        *
        * @param       integer       category id
        * @param       string        category type (service)
        * @param       string        fee type (service, servicebuyer, serviceprovider, productmerchant, productbuyer)
        * 
        * @return      string        HTML representation of the filter form elements
        */
        function print_escrow_filter($cid = 0, $cattype = '', $feetype = '', $disabled = false)
        {
                global $ilance, $ilconfig, $ilpage, $phrase, $onload, $show;
                
                $escrow1 = '';
                $escrow2 = 'checked="checked"';
                if (!empty($ilance->GPC['filter_escrow']) AND $ilance->GPC['filter_escrow'])
                {
                        $escrow1 = 'checked="checked"';
                        $escrow2 = '';
                        
                        $onload .= 'toggle_tr(\'paymentmethods\'); ';
                }
                
                // fetch admin defined escrow fees
                $escrowfee = '<strong>' . $phrase['_free'] . '</strong>';
                
                if ($cattype == 'service')
                {
                        if ($ilconfig['escrowsystem_enabled'] AND $ilconfig['escrowsystem_escrowcommissionfees'])
                        {
                                if ($ilconfig['escrowsystem_servicebuyerfixedprice'] != '0')
                                {
                                        $escrowfee = '(<strong>' . $ilance->currency->format($ilconfig['escrowsystem_servicebuyerfixedprice']) . ' ' . $phrase['_final_value_commission_fee'] . '</strong>)';
                                }
                                else if ($ilconfig['escrowsystem_servicebuyerpercentrate'] != '0.0')
                                {
                                        $escrowfee = '(<strong>' . $ilconfig['escrowsystem_servicebuyerpercentrate'] . '% ' . $phrase['_final_value_commission_fee'] . '</strong>)';
                                }
                        }
                }
                else
                {
                        if ($ilconfig['escrowsystem_enabled'] AND $ilconfig['escrowsystem_escrowcommissionfees'])
                        {
                                if ($ilconfig['escrowsystem_merchantfixedprice'] != '0')
                                {
                                        $escrowfee = '(<strong>' . $ilance->currency->format($ilconfig['escrowsystem_merchantfixedprice']) . ' ' . $phrase['_final_value_commission_fee'] . '</strong>)';
                                }
                                else if ($ilconfig['escrowsystem_merchantpercentrate'] != '0.0')
                                {
                                        $escrowfee = '(<strong>' . $ilconfig['escrowsystem_merchantpercentrate'] . '% ' . $phrase['_final_value_commission_fee'] . '</strong>)';
                                }
                        }
                }

                $html = '
                <div><img src="'.$ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'escrow.gif" border="0" alt="" /> <strong>' . $phrase['_escrow'] . '</strong></div>
		<div class="gray">' . (($cattype == 'product') ? $phrase['_for_large_items_you_may_enable_escrow_to_ensure_funds_are_secure_until_your_item_is_delivered_to_the_winning_bidder'] : $phrase['_for_larger_projects_you_can_enable_escrow_payment_control_ensuring_funds_are_secure_until_your_project_is_complete'])  . '</div>
                
                <table cellpadding="0" cellspacing="2" border="0" width="100%">
                <tr id="enableescrowrow" style="">
                        <td width="1%"><input ' . ($disabled ? 'disabled="disabled"' : '') . ' type="radio" id="enableescrow1" name="filter_escrow" ' . $escrow1 . ' value="1" onclick="toggle_tr(\'paymentmethods\')" /></td>
                        <td align="left"><label for="enableescrow1">' . $phrase['_enable_secure_escrow_trading_for_this_project'] . ' : ' . $escrowfee . '</label></td>
                </tr>
                <tr>
                        <td><input ' . ($disabled ? 'disabled="disabled"' : '') . ' type="radio" id="enableescrow2" name="filter_escrow" ' . $escrow2 . ' value="0" onclick="toggle_paid(\'paymentmethods\')" /></td>
                        <td align="left"><label for="enableescrow2">' . $phrase['_i_prefer_not_to_use_secure_escrow_trading_for_this_project_payments_made_outside_marketplace'] . '</label></td>
                </tr>
                </table>
                <div style="padding-bottom:7px"></div>';
                
                ($apihook = $ilance->api('print_escrow_filter_end')) ? eval($apihook) : false;
                
                return $html;
        }
        
        function print_payment_method_options($selected = '')
        {
                global $ilance, $phrase;
                
                $html = '';
                
                $sql = $ilance->db->query("
                        SELECT id, title
                        FROM " . DB_PREFIX . "payment_methods
                        ORDER BY sort ASC
                ");
                if ($ilance->db->num_rows($sql) > 0)
                {
                        while ($res = $ilance->db->fetch_array($sql))
                        {
                                $bit = '';
                                if (isset($selected) AND isset($phrase["$res[title]"]) AND $selected == $phrase["$res[title]"])
                                {
                                        $bit = 'selected="selected"';
                                }
                                
                                $html .= '<option value="' . $phrase["$res[title]"] . '" ' . $bit . '>' . $phrase["$res[title]"] . '</option>';
                        }
                }
                
                return $html;        
        }
        
        /**
        * Function to print the payment method input field to allow the poster to enter delivery instructions.
        *
        * @return      string        HTML representation of the payment method form elements
        */
        function print_payment_method($fieldname = 'paymethod', $id = 'paymethod')
        {
                global $ilance, $ilconfig, $phrase;
                
                $selected = '';
                if (isset($ilance->GPC["$fieldname"]) AND !empty($ilance->GPC["$fieldname"]))
                {
                        $selected = $ilance->GPC["$fieldname"];
                }
                
                $html = '<select name="' . $fieldname . '" id="' . $id . '" style="font-family: verdana">';
                $html .= $this->print_payment_method_options($selected);
                $html .= '</select>';
                
                return $html;
        }
        
        /**
        * Function to print the auction event type form filtering options.
        *
        * @return      string        HTML representation of the payment method form elements
        */
        function print_event_type_filter($cattype = '', $fieldname = 'project_details', $disabled = false)
        {
                global $ilance, $ilconfig, $phrase, $onload, $js, $retailprice, $invitelist, $memberinvitelist;
                
                $event1 = $event3 = $event4 = $event5 = '';
                if (!empty($ilance->GPC['project_details']) AND $ilance->GPC['project_details'] == 'public')
                {
                        $event1 = 'checked="checked"';
                }
                else if (!empty($ilance->GPC['project_details']) AND $ilance->GPC['project_details'] == 'invite_only')
                {
                        $event3 = 'checked="checked"';
                        $onload .= 'duration_switch(3); ';
                        
                        // at this point, the auction poster could be adding new members
                        // to the currently selected invitation list so lets find out
                        $invitemessage = isset($ilance->GPC['invitemessage']) ? stripslashes(strip_tags($ilance->GPC['invitemessage'])) : '';
                }
                else if (!empty($ilance->GPC['project_details']) AND $ilance->GPC['project_details'] == 'realtime')
                {
                        $event4 = 'checked="checked"';
                        $onload .= 'duration_switch(2); toggle_paid(\'scheduledate\'); ';
                }
                else if (!empty($ilance->GPC['project_details']) AND $ilance->GPC['project_details'] == 'unique' AND $cattype == 'product' AND $ilconfig['enable_uniquebidding'] AND !empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['isadmin'] == '1')
		{
			$event5 = 'checked="checked"';
			$onload .= 'duration_switch(1); toggle_paid(\'uniquebid\'); toggle_free(\'showsellingformat\'); ';
		}
                else
                {
                        // defaults
                        $event1 = 'checked="checked"';
                        $event3 = $event4 = $event5 = '';
                }
                
                // populate realtime bidding scheduled date pulldown data
                
                $ilance->GPC['year'] = isset($ilance->GPC['year']) ? intval($ilance->GPC['year']) : '';
                $ilance->GPC['month'] = isset($ilance->GPC['month']) ? intval($ilance->GPC['month']) : '';
                $ilance->GPC['day'] = isset($ilance->GPC['day']) ? intval($ilance->GPC['day']) : '';
                $ilance->GPC['hour'] = isset($ilance->GPC['hour']) ? intval($ilance->GPC['hour']) : '';
                $ilance->GPC['min'] = isset($ilance->GPC['min']) ? intval($ilance->GPC['min']) : '';
                $ilance->GPC['sec'] = isset($ilance->GPC['sec']) ? intval($ilance->GPC['sec']) : '';
                
                $jsuniquebid = '';
                if ($ilconfig['enable_uniquebidding'] AND !empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['isadmin'] == '1')
                {
                        $jsuniquebid = 'toggle_free(\'uniquebid\');';
                }
                
		$html = '
		<table cellpadding="0" cellspacing="3" border="0" width="100%">
		<tr>
			<td width="3%" valign="top"><input ' . ($disabled ? 'disabled="disabled"' : '') . ' type="radio" name="' . $fieldname . '" id="public" value="public" ' . $event1 . ' onclick="duration_switch(1); toggle_paid(\'showsellingformat\'); toggle_free(\'uniquebid\'); toggle_show(\'enableescrowrow\'); toggle_show(\'donations\');" /></td>
			<td width="97%"> <label for="public"><strong>' . $phrase['_public_event'] . '</strong><div class="gray">' . $phrase['_publically_available_auction'] . '</div></label></td>
		</tr>';
                
                if ($cattype == 'service')
                {
                        $html .= '
                <tr>
			<td valign="top"><input ' . ($disabled ? 'disabled="disabled"' : '') . ' type="radio" name="' . $fieldname . '" id="invite_only" value="invite_only" ' . $event3 . ' onclick="duration_switch(3); toggle_paid(\'showsellingformat\'); toggle_free(\'uniquebid\'); toggle_show(\'enableescrowrow\'); toggle_show(\'donations\');" /></td>
			<td width="100%"><label for="invite_only"><strong>' . $phrase['_invitation_event'] . '</strong> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/invite.gif" border="0" alt="" /><div class="gray">' . $phrase['_invite_vendors_to_place_bids_on_your_auction'] . '</div></label></td>
		</tr>';
                }
                
                $html .= '
		<tr>
			<td valign="top"><input ' . ($disabled ? 'disabled="disabled"' : '') . ' type="radio" name="' . $fieldname . '" id="realtime" value="realtime" ' . $event4 . ' onclick="duration_switch(2); toggle_tr(\'scheduledate\'); toggle_paid(\'showsellingformat\'); toggle_free(\'uniquebid\'); toggle_show(\'enableescrowrow\'); toggle_show(\'donations\');" /></td>
			<td><label for="realtime"><strong>' . $phrase['_invitation_event_realtime'] . '</strong> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'realtime.gif" border="0" alt="" /><div class="gray">' . $phrase['_invite_vendors_to_place_bids_on_your'] . ':</div></label>

				<div id="scheduledate" style="display:none">
                                <div style="padding-top:7px"></div>
                                
                                <div>
                                <table width="100%" border="0" cellpadding="0" cellspacing="0" style="padding:0px 2px 15px 0px;">
                                <tr>
                                <td>
                                <div class="grayborder" style="background:url(' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/bg_gradient_gray_1x1000.gif) repeat-x;"><div class="n"><div class="e"><div class="w"></div></div></div><div>
                                <table border="0" cellpadding="0" cellspacing="0">
                                <tr>
                                        <td style="padding-left:5px;" valign="top"></td>
                                        <td><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'spacer.gif" width="5" height="1" /></td>
                                        <td style="padding-right:5px;">
                                        
                                        <div style="padding-bottom:6px"><strong>' . $phrase['_schedule_a_start_date_and_time'] . '</strong></div>
                                        
                                        <table style="width:100%" border="0" cellspacing="3" cellpadding="2">
                                        <tr>
                                                <td width="100%">
        
                                                        <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                                        <tr>
                                                                <td align="center">' . $this->year($ilance->GPC['year']) . '&nbsp;</td>
                                                                <td align="center">' . $this->month($ilance->GPC['month']) . '&nbsp;</td>
                                                                <td align="center">' . $this->day($ilance->GPC['day']) . '</td>
                                                                <td align="center">&nbsp;&nbsp;&nbsp;&nbsp;</td>
                                                                <td align="center">' . $this->hour($ilance->GPC['hour']) . '&nbsp;</td>
                                                                <td align="center">' . $this->min($ilance->GPC['min']) . '&nbsp;</td>
                                                                <td align="center">' . $this->sec($ilance->GPC['sec']) . '</td>
                                                        </tr>
                                                        <tr>
                                                                <td align="center" class="smaller"><strong>' . $phrase['_year'] . '</strong></td>
                                                                <td align="center" class="smaller"><strong>' . $phrase['_month'] . '</strong></td>
                                                                <td align="center" class="smaller"><strong>' . $phrase['_day'] . '</strong></td>
                                                                <td align="center" class="smaller">&nbsp;</td>
                                                                <td align="center" class="smaller"><strong>' . $phrase['_hour'] . '</strong></td>
                                                                <td align="center" class="smaller"><strong>' . $phrase['_min'] . '</strong></td>
                                                                <td align="center" class="smaller"><strong>' . $phrase['_sec'] . '</strong></td>
                                                        </tr>
                                                        </table>
        
                                                </td>
                                        </tr>
                                        </table>
                                        
                                        </td>
                                </tr>
                                </table>
                                </div><div class="s"><div class="e"><div class="w"></div></div></div></div>
                                </td>
                                </tr>
                                </table>
                                </div>
                                
				
				</div>

			</td>
		</tr>';
                
                if ($cattype == 'product')
                {
                        $retailprice = '';
                        if (isset($ilance->GPC['retailprice']))
                        {
                                $retailprice = sprintf("%01.2f", $ilance->GPC['retailprice']);
                        }
                        
                        $uniquebidcount = '0';
                        if (isset($ilance->GPC['uniquebidcount']))
                        {
                                $uniquebidcount = intval($ilance->GPC['uniquebidcount']);
                        }
                        
                        // ## UNIQUE BIDDING ###################################
                        $cb_uniquebid = '';
                        if ($ilconfig['enable_uniquebidding'])
                        {
                                // are we logged in as admin?
                                if ($_SESSION['ilancedata']['user']['isadmin'] == '0')
                                {
                                        $cb_uniquebid = 'disabled="disabled"';    
                                }
                                $html .= '
                                <tr> 
                                        <td width="1%" valign="top"><input ' . ($disabled ? 'disabled="disabled"' : '') . ' type="radio" name="' . $fieldname . '" id="unique" value="unique" ' . $event5 . ' ' . $cb_uniquebid . ' onclick="duration_switch(1); toggle_tr(\'uniquebid\'); toggle_tr(\'showsellingformat\'); toggle_hide(\'enableescrowrow\'); toggle_hide(\'donations\'); " /></td>
                                        <td width="99%"> <label for="unique"><strong>' . $phrase['_lowest_unique_bid_event'] . '</strong><div class="gray">' . $phrase['_bidders_try_to_place_the_lowest_unique_bid_for_your_item_that_is_unmatched_by_any_other_bidder'] . '</div></label> 
                                                <div id="uniquebid" style="display:none">
                                                
                                                <div style="padding-top:7px"></div>
                                                <div>
                                                <table width="100%" border="0" cellpadding="0" cellspacing="0" style="padding:0px 2px 15px 0px;">
                                                <tr>
                                                <td>
                                                <div class="grayborder" style="background:url(' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/bg_gradient_gray_1x1000.gif) repeat-x;"><div class="n"><div class="e"><div class="w"></div></div></div><div>
                                                
                                                <table style="width:100%" border="0" cellspacing="3" cellpadding="6">
                                                <tr>
                                                        <td>
                                                        
                                                        <div><strong>' . $phrase['_retail_price'] . '</strong></div>
                                                        <div class="gray">' . $phrase['_when_conducting_auction_via_unique_bidding_there_is_no_starting_price'] . '</div>
                                                        <div>' . $ilance->currency->currencies[$ilconfig['globalserverlocale_defaultcurrency']]['symbol_left'] . ' <input type="text" name="retailprice" value="' . $retailprice . '" size="8" style="font-family: verdana" /></div>
                                                        <hr size="1" width="100%" style="color:#cfcfcf; padding-top:3px; padding-bottom:3px" />
                                                        <div style="padding-top:7px"><strong>' . $phrase['_bids_until_lowest_unique_bid_event_ends'] . '</strong></div>
                                                        <div class="gray">' . $phrase['_if_you_would_like_to_end_the_auction_based_on_a_number_of_bids'] . '</div>
                                                        <div><input type="text" name="uniquebidcount" value="' . $uniquebidcount . '" size="5" /></div>
                                                        <hr size="1" width="100%" style="color:#cfcfcf; padding-top:3px; padding-bottom:3px" />
                                                        <div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/nonprofits.gif" border="0" alt="" /> <strong>Benefiting Nonprofit</strong></div>
                                                        <div class="gray">Due to the nature of this listing style, 100% of the lowest unique winning bidders amount must be donated to the nonprofit you select below</div>
                                                        <div style="padding-top:4px">' . print_charities_pulldown(0) . '</div>
                                                        
                                                        </td>
                                                </tr>
                                                </table>
                                                
                                                
                                                </div><div class="s"><div class="e"><div class="w"></div></div></div></div>
                                                </td>
                                                </tr>
                                                </table>
                                                </div>
                                                
                                                
                                                
                                                
                                                
                                                
                                                </div>
                                        </td>
                                </tr>
                                ';
                        }
                }
                
                $html .= '</table>';
                
                ($apihook = $ilance->api('print_event_type_filter')) ? eval($apihook) : false;
                
                return $html;
        }
        
        /**
        * Function to print a duration pulldown menu.
        *
        * @param       string        selected duration value (optional)
        *
        * @return      string        HTML representation of the duration pulldown menu
        */
        function duration($fieldname = 'duration', $disabled = false)
        {
                global $ilance;
                
                $duration = isset($ilance->GPC['duration']) ? intval($ilance->GPC['duration']) : '';
                
                $html = '<select ' . ($disabled ? 'disabled="disabled"' : '') . ' name="' . $fieldname . '" style="font-family: verdana">';
                for ($i = 1; $i <= 30; $i++)
                {
                        if ($i < 10)
                        {
                                $b = $i;
                                $i = "0$i";
                        }
                        else
                        {
                                $b = $i;
                        }
                        if (isset($duration) AND $duration == $i)
                        {
                                $html .= '<option value="' . $i . '" selected="selected">' . $b . '</option>';
                        }
                        else 
                        {
                                $html .= '<option value="' . $i . '">' . $b . '</option>';
                        }
                }
                
                $html .= '</select>';
                
                return $html;
        }
        
        /**
        * Function to print a duration logic menu.
        *
        * @param       string        selected duration value (optional)
        *
        * @return      string        HTML representation of the duration logic form elements
        */
        function print_duration_logic($fieldname = 'duration_unit', $disabled = false)
        {
                global $ilance, $ilconfig, $phrase, $headinclude;
                
                $duration1 = 'checked="checked"';
                $duration2 = $duration3 = '';
                
                $preheadinclude = 'document.ilform.' . $fieldname . '[1].checked=true';
                
                if (isset($ilance->GPC['duration_unit']) AND $ilance->GPC['duration_unit'] == 'D')
                {
                        $duration1 = 'checked="checked"';
                }
                else if (isset($ilance->GPC['duration_unit']) AND $ilance->GPC['duration_unit'] == 'H')
                {
                        $duration2 = 'checked="checked"';
                }
                else if (isset($ilance->GPC['duration_unit']) AND $ilance->GPC['duration_unit'] == 'M')
                {
                        $duration3 = 'checked="checked"';
                }
                
                // specific javascript includes for realtime duration features
                $headinclude .= '
<script type="text/javascript">
<!--
function duration_switch(val)
{
        if (val == "1")
        {
                toggle_free(\'scheduledate\')
        }        
        if (val == "2")
        {
                toggle_free(\'scheduledate\')
        }        
        if (val == "3")
        {
                toggle_free(\'scheduledate\')
        }
}
//-->
</script>';
        
		$html = '
		<table width="1%" border="0" align="left" cellpadding="0" cellspacing="0">
		<tr>
			<td width="6%"><input ' . ($disabled ? 'disabled="disabled"' : '') . ' id="rb_days" type="radio" name="' . $fieldname . '" value="D" ' . $duration1 . ' /></td>
			<td width="17%"><label for="rb_days"><strong>' . $phrase['_days'].'</strong></label>&nbsp;&nbsp;</td>
			<td width="2%"><input ' . ($disabled ? 'disabled="disabled"' : '') . ' id="rb_hours" type="radio" name="' . $fieldname . '" value="H" ' . $duration2 . ' /></td>
			<td width="19%"><label for="rb_hours"><strong>' . $phrase['_hours'] . '</strong></label>&nbsp;&nbsp;</td>
			<td width="6%"><input ' . ($disabled ? 'disabled="disabled"' : '') . ' id="rb_mins" type="radio" name="' . $fieldname . '" value="M" ' . $duration3 . ' /></td>
			<td width="50%"><label for="rb_mins"><strong>' . $phrase['_mins'] . '</strong></label></td>
		</tr>
		</table>';                
                
                return $html;
        }
        
        /**
        * Function to print the invitation boxes and special javascript to let users add more than one row for
        * multiple email addresses
        *
        * @param       string        
        *
        * @return      string        HTML representation of the bid privacy radio options
        */
        function print_invitation_controls()
        {
                global $ilance, $ilconfig, $phrase, $headinclude;
                
                $invitemessage = $sendinvites = '';
                
                // special javascript includes for handling new email rows for invitation control
                $headinclude .= '
<script language="javascript" type="text/javascript">
<!--
function emailcheck(str)
{
        var at = "@"
        var dot = "."
        var lat = str.value.indexOf(at)
        var lstr = str.value.length
        var ldot = str.value.indexOf(dot)
        
        if (str.value.indexOf(at) == -1)
        {
                alert("Invalid E-mail");
                str.value = \'\';
                return false;
        }
        if (str.value.indexOf(at) == -1 || str.value.indexOf(at) == 0 || str.value.indexOf(at) == lstr)
        {
                alert("Invalid E-mail");
                str.value = \'\';
                return false;
        }
        if (str.value.indexOf(dot) == -1 || str.value.indexOf(dot) == 0 || str.value.indexOf(dot) == lstr)
        {
                alert("Invalid E-mail");
                str.value = \'\';
                return false
        }
        if (str.value.indexOf(at,(lat+1)) != -1)
        {
                alert("Invalid E-mail");
                str.value = \'\';
                return false;
        }
        if (str.value.substring(lat-1,lat) == dot || str.value.substring(lat+1, lat+2) == dot)
        {
                alert("Invalid E-mail");
                str.value = \'\';
                return false;
        }
        if (str.value.indexOf(dot,(lat+2)) == -1)
        {
                alert("Invalid E-mail");
                str.value = \'\';
                return false;
        }
        if (str.value.indexOf(" ") != -1)
        {
                alert("Invalid E-mail");
                str.value = \'\';
                return false;
        }
        
        return true					
}

function rem_input_field()
{
        var i = fetch_js_object("invite_emails");
        if (i.rows.length > 1)
        {
                invite_emails.removeChild(invite_emails.lastChild);
        }
}

function add_input_field() 
{
        var tbody = fetch_js_object("invite_emails");
        var ctr = tbody.getElementsByTagName("input").length + 1;
        var input;
        ctr = ctr / 2;
        if (ctr > 5) 
        {
                alert_js(phrase[\'_the_maximum_number_of_people_you_are_sending_this_auction_event_to_has_been_reached\']);
        }
        else
        {
                if (document.all)
                {
                        input = document.createElement(\'<input name="invitelist[email][]" />\');
                        input2 = document.createElement(\'<input name="invitelist[name][]" />\');
                }
                else
                {
                        input = document.createElement("input");
                        input2 = document.createElement("input");
                        
                        input.name = "invitelist[email][]";
                        input2.name = "invitelist[name][]";					
                }
                
                input.id = "inviteemails_" + ctr;
                input.type = "text";
                input.value = "";
                input.className = "input";
                input.size = "25";
                
                input2.id = "invitenames_" + ctr;
                input2.type = "text";
                input2.value = "";
                input2.className = "input";
                
                var tdText1 = document.createTextNode(\'' . $phrase['_email'] . ':\');
                var tdText2 = document.createTextNode(\'' . $phrase['_first_name'] . ':\');
                
                var cell = document.createElement("td");
                    cell.style.height = "30px";
                    cell.appendChild(tdText1);
                    cell.appendChild(document.createElement("BR"));
                    cell.appendChild(input);
                
                var cell3 = document.createElement("td");
                    cell3.style.height = "0px";
                    cell3.appendChild(document.createElement("NBSP"));
                
                var cell2 = document.createElement("td");
                    cell2.style.height = "30px";
                    cell2.appendChild(tdText2);
                    cell2.appendChild(document.createElement("BR"));
                    cell2.appendChild(input2);
                
                var row = document.createElement("tr");
                    row.appendChild(cell);
                    row.appendChild(cell3);
                    row.appendChild(cell2);
                    tbody.appendChild(row);

                window.document.ilform.count.value = ctr;
        }
}
//-->
</script>';
        
                // invitation message
                $invitemessage = '';
                if (isset($ilance->GPC['invitemessage']) AND !empty($ilance->GPC['invitemessage']))
                {
                        $invitemessage = strip_vulgar_words($ilance->GPC['invitemessage']);
                }
                
                $invitelist_row = '<tr><td height="30">' . $phrase['_email'] . ':<br /><input onblur="javascript: emailcheck(this)" size="25" name="invitelist[email][]" type="text" class="input" id="inviteemails_1" /></td><td>&nbsp;&nbsp;</td><td height="30">' . $phrase['_first_name'] . ':<br /><input name="invitelist[name][]" type="text" class="input" id="invitenames_1" /></td></tr>';
                
                // re-populate invitation list                
                if (!empty($ilance->GPC['invitelist']) AND is_array($ilance->GPC['invitelist']))
                {
                        // poster appears to be previewing or updating the auction listing                        
                        //$invitelist_row = '<tr><td>' . $phrase['_email'] . '</td><td>&nbsp;&nbsp;</td><td>' . $phrase['_first_name'] . '</td></tr>';
                        $count = 1;
                        foreach ($ilance->GPC['invitelist']['email'] AS $key => $emailaddress)
                        {
                                if (!empty($emailaddress) AND is_valid_email($emailaddress))
                                {
                                        $invitelist_row .= '<tr id="inviterow_' . $count . '"><td height="30"><input size="25" name="invitelist[email][]" value="' . $emailaddress . '" type="text" class="input" id="inviteemails_' . $count . '" /></td><td>&nbsp;&nbsp;</td><td height="30"><input name="invitelist[name][]" value="' . $ilance->GPC['invitelist']['name']["$key"] . '" type="text" class="input" id="invitenames_' . $count . '" /></td></tr>';
                                        $count++;
                                }
                        }
                        if (empty($invitelist_row))
                        {
                                $invitelist_row = '<tr id="inviterow_' . $count . '"><td height="30"><input onblur="javascript: emailcheck(this)" size="25" name="invitelist[email][]" type="text" class="input" id="inviteemails_1" /></td><td>&nbsp;&nbsp;</td><td height="30"><input name="invitelist[name][]" type="text" class="input" id="invitenames_1" /></td></tr>';       
                        }
                }
                
                // additionally, we'll display any invited users previously selected from the search results page and/or single member invtations
                $inviteduserlist = '';
                if (!empty($_SESSION['ilancedata']['tmp']['invitations']))
                {
                        $invitedusers = unserialize($_SESSION['ilancedata']['tmp']['invitations']);
                        $invitedcount = count($invitedusers);
                        if ($invitedcount > 0)
                        {
                                foreach ($invitedusers AS $userid)
                                {
                                        $inviteduserlist .= '<strong>' . fetch_user('username', $userid) . '</strong>, ';
                                }
                                if (!empty($inviteduserlist))
                                {
                                        $inviteduserlist = '<div class="gray">' . $phrase['_users_from_the_marketplace_you_are_invited_will_appear_below'] . '</div><div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/selectedcat.gif" border="0" alt="" /> ' . $phrase['_inviting'] . ': ' . mb_substr($inviteduserlist, 0, -2) . '</div>';
                                }
                        }
                }
                
		$html = '
                <div style="padding-bottom:10px; padding-top:2px"><span class="blue"><a href="javascript:void(0);" onclick="add_input_field();" id="add">' . $phrase['_add_new_email_contact'] . '</a></span> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/arrowdown.gif" border="0" alt="" /></div>
		<table border="0" cellspacing="0" cellpadding="0">
                <tbody id="invite_emails">
                ' . $invitelist_row . '
                </tbody>
                </table>
                <div style="padding-bottom:7px; padding-top:6px" class="smaller gray"><span class="blue"><a href="javascript:void(0);" onclick="rem_input_field();" id="rem">' . $phrase['_remove'] . '</a></span> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/arrowup.gif" border="0" alt="" /></div>
                <div style="padding-top:6px"></div>
                ' . $inviteduserlist . '
                <input name="count" type="hidden" id="count" value="1" />
                
                <hr size="1" width="100%" style="color:#cccccc" />
                
                <div style="padding-top:3px"><strong>' . $phrase['_enter_invitation_message_to_bidders'] . '</strong></div>
                <div class="gray" style="padding-bottom:3px">' . $phrase['_invitation_messages_will_only_be_sent_during_a_new_project_listing'] . '</div>
                <div class="ilance_wysiwyg">
                <table cellpadding="0" cellspacing="0" border="0">
                <tr>
                <td align="right" height="25">

                        <table cellpadding="0" cellspacing="0" border="0" width="100%">
                        <tr>
                                <td align="left" class="smaller">' . $phrase['_plain_text_only_bbcode_is_currently_not_in_use_for_this_field'] . '</td>
                                <td>
                                                <div class="wysiwygbutton"><a href="javascript:void(0)" onclick="return construct_textarea_height(\'invitemessage\', -100)"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'wysiwyg/resize_0.gif" width="21" height="9" alt="' . $phrase['_decrease_size'] . '" border="0" /></a></div>
                                                <div class="wysiwygbutton"><a href="javascript:void(0)" onclick="return construct_textarea_height(\'invitemessage\', 100)"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'wysiwyg/resize_1.gif" width="21" height="9" alt="' . $phrase['_increase_size'] . '" border="0" /></a></div>
                                </td>
                                <td style="padding-right:15px"></td>
                        </tr>
                        </table>
                </td>
                </tr>
                        <tr>
                                <td><textarea name="invitemessage" id="invitemessage" style="width:380px; height:44px; padding:8px;" wrap="physical" class="wysiwyg">' . $invitemessage . '</textarea></td>
                        </tr>
                </table>
                </div>';
                
                return $html;        
        }
        
        /**
        * Function to print the auction's keywords / tags used for search engine optimization and other functions
        * like displaying ads relevant to the auctions or categories
        *
        * @param       string        selected duration value (optional)
        *
        * @return      string        HTML representation of the keywords input
        */
        function print_keywords_input($fieldname = 'keywords', $disabled = false)
        {
                global $ilance, $ilconfig, $phrase;
                
                $keywords = '';
                if (isset($ilance->GPC['keywords']) AND !empty($ilance->GPC['keywords']))
                {
                        //$keywords = strip_vulgar_words($ilance->GPC['keywords']);
                        $keywords = $ilance->GPC['keywords'];
                }
                
                $html = '<input ' . ($disabled ? 'disabled="disabled"' : '') . ' type="text" class="input" name="' . $fieldname . '" maxsize="75" value="' . $keywords . '" title="" style="width:580px" />';
                
                return $html;
        }
        
        /**
        * Function to print the auction's title input 
        *
        * @param       string        form fieldname
        *
        * @return      string        HTML representation of the keywords input
        */
        function print_title_input($fieldname = 'project_title', $disabled = false)
        {
                global $ilance, $ilconfig, $phrase;
                
                $project_title = '';
                if (isset($ilance->GPC['project_title']) AND !empty($ilance->GPC['project_title']))
                {
                        //$project_title = strip_vulgar_words($ilance->GPC['project_title']);
                        $project_title = $ilance->GPC['project_title'];
                }

                $html = '<input ' . ($disabled ? 'disabled="disabled"' : '') . ' id="' . $fieldname . '" type="text" class="input" name="' . $fieldname . '" maxsize="75" value="' . $project_title . '" style="width:580px" /> <img name="' . $fieldname . 'error" src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif" width="21" height="13" border="0" alt="" />';
                
                return $html;
        }
        
        /**
        * Function to print the auction's title input 
        *
        * @param       string        form fieldname
        *
        * @return      string        HTML representation of the keywords input
        */
        function print_video_description_input($fieldname = 'description_videourl', $disabled = false)
        {
                global $ilance, $ilconfig, $phrase;
                
                $description_videourl = '';
                if (isset($ilance->GPC['description_videourl']) AND !empty($ilance->GPC['description_videourl']))
                {
                        $description_videourl = $ilance->GPC['description_videourl'];
                }

                $html = '<input ' . ($disabled ? 'disabled="disabled"' : '') . ' id="' . $fieldname . '" type="text" class="input" name="' . $fieldname . '" maxsize="75" value="' . $description_videourl . '" style="width:580px" />';
                
                return $html;
        }
        
        /**
        * Function to print the auction's extend features after the listing was posted (update mode)
        *
        * @param       string        form fieldname
        *
        * @return      string        HTML representation of the keywords input
        */
        function print_extend_auction($fieldname = 'extend')
        {
                global $ilance, $ilconfig, $phrase, $headinclude;
                
                $html = '
                <table cellpadding="0" cellspacing="3" border="0" width="100%">
                <tr> 
                        <td width="1%" valign="top"><input type="radio" name="' . $fieldname . '" id="extend1" value="0" checked /></td>
                        <td><label for="extend1">' . $phrase['_no_extention'] . '</label></td>
                        <td width="1%" valign="top"><input type="radio" name="' . $fieldname . '" id="extend2" value="1" /></td>
                        <td><label for="extend2">' . $phrase['_extend_for_1_day'] . '</label></td>
                </tr>
                <tr> 
                        <td width="1%" valign="top"><input type="radio" name="' . $fieldname . '" id="extend3" value="3" /></td>
                        <td><label for="extend3">' . $phrase['_extend_for_3_days'] . '</label></td>
                        <td width="1%" valign="top"><input type="radio" name="' . $fieldname . '" id="extend4" value="7" /></td>
                        <td><label for="extend4">' . $phrase['_extend_for_7_days'] . '</label></td>
                </tr> 
                </table>';
                
                return $html;
        }
        
        
        
        /**
        * Function to print the auction's additional information box
        *
        * @param       string        form fieldname
        *
        * @return      string        HTML representation of the additional info textarea
        */
        function print_additional_info_input($fieldname = 'additional_info', $disabled = false)
        {
                global $ilance, $ilconfig, $phrase;
                
                $additional_info = '';
                if (isset($ilance->GPC['additional_info']) AND !empty($ilance->GPC['additional_info']))
                {
                        $additional_info = strip_vulgar_words($ilance->GPC['additional_info']);
                }
                
                $html = '
                <div class="ilance_wysiwyg">
                <table cellpadding="0" cellspacing="0" border="0" width="580">
                <tr>
                <td class="wysiwyg_wrapper" align="right" height="25">

                                        <table cellpadding="0" cellspacing="0" border="0" width="100%">
                                        <tr>
                                                <td width="100%" align="left" class="smaller">' . $phrase['_plain_text_only_bbcode_is_currently_not_in_use_for_this_field'] . '</td>
                                                <td>
                                                                <div class="wysiwygbutton"><a href="javascript:void(0)" onclick="return construct_textarea_height(\'' . $fieldname . '\', -100)"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'wysiwyg/resize_0.gif" width="21" height="9" alt="' . $phrase['_decrease_size'] . '" border="0" /></a></div>
                                                                <div class="wysiwygbutton"><a href="javascript:void(0)" onclick="return construct_textarea_height(\'' . $fieldname . '\', 100)"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'wysiwyg/resize_1.gif" width="21" height="9" alt="' . $phrase['_increase_size'] . '" border="0" /></a></div>
                                                </td>
                                                <td style="padding-right:15px"></td>
                                        </tr>
                                        </table>
                </td>
                </tr>
                        <tr>
                                <td><textarea ' . ($disabled ? 'disabled="disabled"' : '') . ' name="' . $fieldname . '" id="' . $fieldname . '" style="width:580px; height:84px; padding:8px; font-family: verdana;" wrap="physical" class="wysiwyg">' . $additional_info . '</textarea></td>
                        </tr>
                </table>
                </div>';
                
                return $html;
        }
        
        /**
        * Function to print a the bid privacy form options (open, sealed, blind or full)
        *
        * @param       string        selected duration value (optional)
        *
        * @return      string        HTML representation of the bid privacy radio options
        */
        function print_bid_privacy($fieldname = 'bid_details', $disabled = false)
        {
                global $ilance, $ilconfig, $phrase;
                
                $privacy1 = 'checked="checked"';
		$privacy2 = $privacy3 = $privacy4 = '';
		if (!empty($ilance->GPC['bid_details']) AND $ilance->GPC['bid_details'] == 'open')
		{
			$privacy1 = 'checked="checked"';
		}
		else if (!empty($ilance->GPC['bid_details']) AND $ilance->GPC['bid_details'] == 'sealed')
		{
			$privacy2 = 'checked="checked"';
		}
		else if (!empty($ilance->GPC['bid_details']) AND $ilance->GPC['bid_details'] == 'blind')
		{
			$privacy3 = 'checked="checked"';
		}
		else if (!empty($ilance->GPC['bid_details']) AND $ilance->GPC['bid_details'] == 'full')
		{
			$privacy4 = 'checked="checked"';
		}
                
                // subscription permission checkup for setting filter privacy
                $disabled1 = $disabled2 = $disabled3 = false;
                if ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'cansealbids') == 'no')
                {
                        $disabled1 = true;        
                }
                if ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'canblindbids') == 'no')
                {
                        $disabled2 = true;        
                }
                if ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'canfullprivacybids') == 'no')
                {
                        $disabled3 = true;        
                }

		$html = '
		<table cellpadding="0" cellspacing="3" border="0" width="100%">
                <tr>
                      <td width="3%" valign="top"><input ' . ($disabled ? 'disabled="disabled"' : '') . ' type="radio" name="' . $fieldname . '" id="open" value="open" ' . $privacy1 . ' ' . ($disabled ? 'disabled="disabled"' : '') . ' /></td>
                      <td width="97%"><label for="open"><strong>' . $phrase['_no_bid_privacy_enabled'] . '</strong><div class="gray">' . $phrase['_bidder_names_are_shown_bid_amounts_are_shown_and_listing_available_to_search_engines'] . '</div></label></td>
                </tr>
                <tr>
                      <td valign="top"><input ' . (($disabled OR $disabled1) ? 'disabled="disabled"' : '') . ' type="radio" name="' . $fieldname . '" id="sealed" value="sealed" ' . $privacy2 . ' ' . ($disabled ? 'disabled="disabled"' : '') . ' /></td>
                      <td><label for="sealed"><strong>' . $phrase['_sealed_bidding'] . '</strong><div class="gray">' . $phrase['_bidder_names_are_shown_bid_amounts_are_hidden_optional'] . '</div></label></td>
                </tr>
                <tr>
                      <td valign="top"><input ' . (($disabled OR $disabled2) ? 'disabled="disabled"' : '') . ' type="radio" id="blind" name="' . $fieldname . '" value="blind" ' . $privacy3 . ' ' . ($disabled ? 'disabled="disabled"' : '') . ' /></td>
                      <td><label for="blind"><strong>' . $phrase['_blind_bidding'] . '</strong><div class="gray">' . $phrase['_bid_amounts_are_shown_bidder_names_are_hidden_optional'] . '</div></label></td>
                </tr>
                <tr>
                      <td valign="top"><input ' . (($disabled OR $disabled3) ? 'disabled="disabled"' : '') . ' type="radio" id="full" name="' . $fieldname . '" value="full" ' . $privacy4 . ' ' . ($disabled ? 'disabled="disabled"' : '') . ' /></td>
                      <td><label for="full"><strong>' . $phrase['_full_privacy_sealed_blind_bidding'] . '</strong><div class="gray">' . $phrase['_full_privacy_bidder_names_are_hidden_bid_amounts_are_sealed'] . '</div></label></td>
                </tr>
                </table>';
                
                return $html;
        }
        
        /**
        * Function to print the public message board visibility or hidden options for the auction poster.
        *
        * @return      string        HTML representation of the public board form elements
        */
        function print_public_board($fieldname = 'filter_publicboard', $disabled = false)
        {
                global $ilance, $ilconfig, $phrase;
                
                $publicboard1 = '';
                $publicboard2 = 'checked="checked"';
                if (!empty($ilance->GPC['filter_publicboard']) AND $ilance->GPC['filter_publicboard'])
                {
                        $publicboard1 = 'checked="checked"';
                        $publicboard2 = '';
                }
                
                $html = '
                <table cellpadding="1" cellspacing="2" border="0" width="100%">
                <tr>
                        <td width="1%" valign="top"><input ' . ($disabled ? 'disabled="disabled"' : '') . ' type="radio" name="' . $fieldname . '" id="' . $fieldname . '1" value="1" '.$publicboard1.' /></td>
                        <td width="100%"><label for="' . $fieldname . '1"><strong>'.$phrase['_public_message_board_enabled'].'</strong><br />
                        <div class="gray">' . $phrase['_select_this_option_if_you_will_allow_a_public_message_board_environment_on_your_auction_listing_page'] . '</div></label></td>
                </tr>
                <tr>
                        <td valign="top"><input type="radio" ' . ($disabled ? 'disabled="disabled"' : '') . ' name="' . $fieldname . '" id="' . $fieldname . '0" value="0" '.$publicboard2.' /></td>
                        <td><label for="' . $fieldname . '0"><strong>'.$phrase['_public_message_board_disabled'].'</strong><br />
                        <div class="gray">' . $phrase['_if_you_do_not_want_a_public_message_board_on_your_auction_listing_page_select_this_option'] . '</div></label></td>
                </tr>
                </table>';
                
                return $html;
        }
        
        /**
        * Function to print the available auction enhancement upsell options like bold, highlight background, featured, etc.
        *
        * @param       string        category type (service or product)
        * 
        * @return      string        HTML representation of the listing enhancement form options
        */
        function print_listing_enhancements($cattype = 'service', $extra = '')
        {
                global $ilance, $ilconfig, $phrase, $show;
                
                $sumfees = 0;
		$boldprice_fee = $ilance->currency->format(0);
		$highlite_fee = $ilance->currency->format(0);
		$featured_fee = $ilance->currency->format(0);
                $autorelist_fee = $ilance->currency->format(0);
		$showbold = $showhlite = $showfeatured = $showautorelist = 1;
                
                if ($ilconfig["{$cattype}upsell_boldactive"])
                {
                        if ($ilconfig["{$cattype}upsell_boldfees"])
                        {
                                $boldprice_fee = $ilance->currency->format($ilconfig["{$cattype}upsell_boldfee"]);
                        }
                }
		else
		{
			$showbold = 0;
		}

		if ($ilconfig["{$cattype}upsell_highlightfees"])
                {
			$highlite_fee = $ilance->currency->format($ilconfig["{$cattype}upsell_highlightfee"]);
		}
		else
		{
			$showhlite = 0;
		}

		if ($ilconfig["{$cattype}upsell_featuredfees"])
                {
			$featured_fee = $ilance->currency->format($ilconfig["{$cattype}upsell_featuredfee"]);
		}
		else
		{
			$showfeatured = 0;
		}
                
                if ($ilconfig["{$cattype}upsell_autorelistfees"])
                {
			$autorelist_fee = $ilance->currency->format($ilconfig["{$cattype}upsell_autorelistfee"]);
		}
		else
		{
			$showautorelist = 0;
		}
                
		$cb_bold = $cb_highlight = $cb_featured = $cb_autorelist = '';
                
		if (isset($ilance->GPC['enhancements']))
		{
			foreach ($ilance->GPC['enhancements'] AS $enhancement => $value)
			{
                                // #### BOLD ###################################
				if (isset($enhancement) AND $enhancement == 'bold')
				{
					if ($ilconfig["{$cattype}upsell_boldfees"])
                                        {
						$boldprice_fee = $ilance->currency->format($ilconfig["{$cattype}upsell_boldfee"]);
						$sumfees += $ilconfig["{$cattype}upsell_boldfee"];
					}
                                        if (isset($show['disableselectedenhancements']) AND $show['disableselectedenhancements'])
                                        {
                                                $cb_bold = 'checked="checked" disabled="disabled"';
                                        }
                                        else
                                        {
                                                $cb_bold = 'checked="checked"';        
                                        }
				}
                                
                                // #### BACKGROUND HIGHLIGHT ###################
				if (isset($enhancement) AND $enhancement == 'highlite')
				{
					if ($ilconfig["{$cattype}upsell_highlightfees"])
                                        {
						$highlite_fee = $ilance->currency->format($ilconfig["{$cattype}upsell_highlightfee"]);
						$sumfees += $ilconfig["{$cattype}upsell_highlightfee"];
					}
                                        if (isset($show['disableselectedenhancements']) AND $show['disableselectedenhancements'])
                                        {
                                                $cb_highlight = 'checked="checked" disabled="disabled"';
                                        }
                                        else
                                        {
                                                $cb_highlight = 'checked="checked"';        
                                        }
				}
                                
                                // #### FEATURED ###############################
				if (isset($enhancement) AND $enhancement == 'featured')
				{
					if ($ilconfig["{$cattype}upsell_featuredfees"])
                                        {
						$featured_fee = $ilance->currency->format($ilconfig["{$cattype}upsell_featuredfee"]);
						$sumfees += $ilconfig["{$cattype}upsell_featuredfee"];
					}
                                        if (isset($show['disableselectedenhancements']) AND $show['disableselectedenhancements'])
                                        {
                                                $cb_featured = 'checked="checked" disabled="disabled"';
                                        }
                                        else
                                        {
                                                $cb_featured = 'checked="checked"';
                                        }
				}
                                
                                // #### AUTO-RELIST ############################
				if (isset($enhancement) AND $enhancement == 'autorelist')
				{
					if ($ilconfig["{$cattype}upsell_autorelistfees"])
                                        {
						$autorelist_fee = $ilance->currency->format($ilconfig["{$cattype}upsell_autorelistfee"]);
						$sumfees += $ilconfig["{$cattype}upsell_autorelistfee"];
					}
                                        if (isset($show['disableselectedenhancements']) AND $show['disableselectedenhancements'])
                                        {
                                                $cb_autorelist = 'checked="checked" disabled="disabled"';
                                        }
                                        else
                                        {
                                                $cb_autorelist = 'checked="checked"';        
                                        }
				}
			}
		}

                $jsonclick = 'single';
                if (!empty($extra) AND $extra == 'bulk')
                {
                        $jsonclick = 'bulk';
                }

		// #### listing enhancements html display ######################
		$html = '<table cellpadding="0" cellspacing="3" border="0" width="100%">';
                
		if ($showbold)
		{
			$html .= '
			<tr>
				<td width="3%" valign="top" align="center"><input type="checkbox" name="enhancements[bold]" id="bold" value="1" ' . $cb_bold . ' onclick="return livefeecalculator(\'' . $ilconfig["{$cattype}upsell_boldfee"] . '\', \'' . $jsonclick . '\', \'bold\')" /></td>
				<td width="97%" ><label for="bold">' . $phrase['_bold_title_via_search_results'] . ' &nbsp;&nbsp;<span class="smaller gray">(' . $boldprice_fee . ')</span></label></td>
			</tr>';
		}
		if ($showhlite)
		{
			$html .= '
			<tr>
				<td valign="top" align="center"><input type="checkbox" name="enhancements[highlight]" id="highlight" value="1" ' . $cb_highlight . ' onclick="return livefeecalculator(\'' . $ilconfig["{$cattype}upsell_highlightfee"] . '\', \'' . $jsonclick . '\', \'highlight\')" /></td>
				<td><label for="highlight">' . $phrase['_highlight_listing_via_search_results'] . ' &nbsp;&nbsp;<span class="smaller gray">(' . $highlite_fee . ')</span></label></td>
			</tr>';
		}
		if ($showfeatured)
		{
			$html .= '
			<tr>
				<td valign="top" align="center"><input type="checkbox" id="featured" name="enhancements[featured]" value="1" ' . $cb_featured . ' onclick="return livefeecalculator(\'' . $ilconfig["{$cattype}upsell_featuredfee"] . '\', \'' . $jsonclick . '\', \'featured\')" /></td>
				<td><label for="featured">' . $phrase['_featured_item_presence'] . ' (' . $ilconfig['serviceupsell_featuredlength'] . ' ' . $phrase['_days_lower'] . ') &nbsp;&nbsp;<span class="smaller gray">(' . $featured_fee . ')</span></label></td>
			</tr>';
		}
                
                if ($showautorelist)
		{
			$html .= '
			<tr>
				<td valign="top" align="center"><input type="checkbox" id="autorelist" name="enhancements[autorelist]" value="1" ' . $cb_autorelist . ' onclick="return livefeecalculator(\'' . $ilconfig["{$cattype}upsell_autorelistfee"] . '\', \'' . $jsonclick . '\', \'autorelist\')" /></td>
				<td><label for="autorelist">' . $phrase['_automatic_relist_if_listing_receives_no_bids'] . ' (' . $ilconfig['productupsell_autorelistmaxdays'] . ' ' . $phrase['_days_lower'] . ') &nbsp;&nbsp;<span class="smaller gray">(' . $autorelist_fee . ')</span></label></td>
			</tr>';
		}
		$html .= '</table>';
                
                // will output all fees the user selected for the enhancements
                $show['selectedenhancements'] = 0;
                if (isset($sumfees) AND $sumfees > 0)
                {
			$totalfees = number_format($sumfees, 2);
                        $show['selectedenhancements'] = $totalfees;
			$totalfees_preview = $ilance->currency->format($sumfees);
		}
                
                return $html;
        }
        
        /**
        * Function to print any applicable insertion fees during the posting of an auction.  This function takes into consideration if the viewing user is exempt from insertion fees.
        *
        * @param       integer       category id
        * @param       string        category type (service/product)
        * 
        * @return      string        HTML representation of the insertion fee table
        */
        function print_insertion_fees($cid = 0, $cattype = '')
        {
                global $ilance, $myapi, $phrase, $show;
                
                $htmlinsertionfees = '';
                $show['insertionfees'] = 1;
                
                // #### PRODUCT ################################################
                if ($cattype == 'product')
                {
                        $sqlinsertions = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "insertion_fees
                                WHERE groupname = '".$ilance->categories->fetch[$_SESSION['ilancedata']['user']['slng']][$cattype][$cid]['insertiongroup']."'
                                        AND state = '".$ilance->db->escape_string($cattype)."'
                                ORDER BY sort ASC
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($sqlinsertions) > 0)
                        {
                                while ($rows = $ilance->db->fetch_array($sqlinsertions))
                                {
                                        $from = $ilance->currency->format($rows['insertion_from']);
                                        $to =  ' &ndash; ' . $ilance->currency->format($rows['insertion_to']);
                                        $amount = $ilance->currency->format($rows['amount']);
                                        $show['insertionfeeamount'] = $rows['amount'];
                                        if ($rows['insertion_to'] == '-1')
                                        {
                                                $to = $phrase['_or_more'];
                                        }
                                        
                                        $htmlinsertionfees .= '<tr class="alt1"><td valign="top">' . $from . ' ' . $to . '</td><td valign="top"><b>' . $amount . '</b></td></tr>';
                                }
                                
                                $htmlinsertionfees .= '<tr><td valign="top" colspan="2"><span class="gray">' . $phrase['_depending_on_start_price_or_reserve_price_amount_the_greater'] . '</span></td></tr>';
                        }
                        else 
                        {
                                $show['insertionfees'] = $show['insertionfeeamount'] = 0;
                                $htmlinsertionfees .= '<tr><td valign="top" colspan="2"><span class="gray">' . $phrase['_no_insertion_fees_within_this_category'] . '</span></td></tr>';
                        }
                        
                        // check for subscription insertion fee exemption
                        if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0 AND $ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'insexempt') == 'yes')
                        {
                                $htmlinsertionfees = '<tr><td valign="top" colspan="2"><span class="gray">' . $phrase['_you_are_exempt_from_insertion_fees'] . '</span></td></tr>';
                        }
                        
                        // product listing fees output display
                        $listingfees = '
                        <div class="block-wrapper">

                        <div class="block">
                        
                                        <div class="block-top">
                                                        <div class="block-right">
                                                                        <div class="block-left"></div>
                                                        </div>
                                        </div>
                                        
                                        <div class="block-header">' . $phrase['_insertion_listing_fees'] . '</div>
			
                                        <div class="block-content" style="padding:0px">
                                        <table border="0" cellpadding="9" cellspacing="1" width="100%">
                                        </tr>
                                        <tr class="alt2">
                                                <td valign="top"><strong>' . $phrase['_start_price_or_reserve_amount'] . '</strong></td>
                                                <td valign="top"><strong>' . $phrase['_insertion_fee_amount'] . '</strong></td>
                                        </tr>
                                        ' . $htmlinsertionfees . '
                                        </table></div>
			
                                                <div class="block-footer">
                                                                <div class="block-right">
                                                                                <div class="block-left"></div>
                                                                </div>
                                                </div>
                                                
                                </div>
                        </div>';
                }
                
                // #### SERVICE ################################################
                else if ($cattype == 'service')
                {
                        $sqlinsertions = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "insertion_fees
                                WHERE groupname = '" . $ilance->db->escape_string($ilance->categories->fetch[$_SESSION['ilancedata']['user']['slng']][$cattype][$cid]['insertiongroup']) . "'
                                    AND state = '" . $ilance->db->escape_string($cattype) . "'
                                ORDER BY sort ASC
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($sqlinsertions) > 0)
                        {
                                while ($rows = $ilance->db->fetch_array($sqlinsertions))
                                {
                                        $amount = $ilance->currency->format($rows['amount']);
                                        $show['insertionfeeamount'] = $rows['amount'];
                                        if ($rows['insertion_to'] == '-1')
                                        {
                                                $to = $phrase['_or_more'];
                                        }
                                        $htmlinsertionfees .= '<tr class="alt1"><td valign="top">' . stripslashes($ilance->categories->fetch[$_SESSION['ilancedata']['user']['slng']][$cattype][$cid]['title']) . '</td><td valign="top"><strong>' . $amount . '</strong></td></tr>';
                                }
                                
                                $htmlinsertionfees .= '<tr><td valign="top" colspan="2"><span class="gray">' . $phrase['_you_may_be_required_to_pay_this_fee_in_full_before_public_visibility'] . '</span></td></tr>';
                        }
                        else 
                        {
                                $show['insertionfees'] = $show['insertionfeeamount'] = 0;
                                $htmlinsertionfees .= '<tr><td valign="top" colspan="2"><span class="gray">' . $phrase['_no_insertion_fees_within_this_category'] . '</span></td></tr>';	
                        }
                        
                        // check for subscription insertion fee exemption
                        if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0 AND $ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'insexempt') == 'yes')
                        {
                                $htmlinsertionfees = '<tr><td valign="top" colspan="2"><span class="gray">' . $phrase['_you_are_exempt_from_insertion_fees'] . '</span></td></tr>';
                        }
                        
                        $listingfees = '
                        <div class="block-wrapper">

                        <div class="block2">
                        
                                        <div class="block2-top">
                                                        <div class="block2-right">
                                                                        <div class="block2-left"></div>
                                                        </div>
                                        </div>
                                        
                                        <div class="block2-header">' . $phrase['_insertion_listing_fees'] . '</div>
			
                                        <div class="block2-content" style="padding:0px">
                                        <table cellpadding="9" cellspacing="1" width="100%">
                        </tr>
                        <tr class="alt2">
                                <td valign="top"><strong>' . $phrase['_category'] . '</strong></td>
                                <td valign="top"><strong>' . $phrase['_insertion_fee_amount'] . '</strong></td>
                        </tr>
                        ' . $htmlinsertionfees . '
                        </table></div>
			
                                                <div class="block2-footer">
                                                                <div class="block2-right">
                                                                                <div class="block2-left"></div>
                                                                </div>
                                                </div>
                                                
                                </div>
                        </div>';
                }
                
                return $listingfees;
        }
        
        /**
        * Function to print any applicable service budget insertion fees during the posting of an auction.
        *
        * @param       integer       category id
        * 
        * @return      string        HTML representation of the insertion fee table
        */
        function print_budget_insertion_fees($cid = 0)
        {
                global $ilance, $myapi, $phrase, $show;
                
                $htmlinsertionfees = '';
                $show['budgetinsertionfees'] = 1;
                
                $sqlinsertions = $ilance->db->query("
                        SELECT *
                        FROM " . DB_PREFIX . "budget
                        WHERE budgetgroup = '".$ilance->categories->fetch[$_SESSION['ilancedata']['user']['slng']]['service'][$cid]['budgetgroup']."'
                        ORDER BY budgetfrom ASC
                ", 0, null, __FILE__, __LINE__);
                if ($ilance->db->num_rows($sqlinsertions) > 0)
                {
                        while ($res = $ilance->db->fetch_array($sqlinsertions))
                        {
                                if ($res['budgetto'] == '-1')
                                {
                                        $thefee = $this->calculate_insertion_fee_in_budget_group($res['insertiongroup']);
                                        if ($thefee == 0)
                                        {
                                                $thefee = $phrase['_free'];
                                        }
                                        else
                                        {
                                                $thefee = $ilance->currency->format($this->calculate_insertion_fee_in_budget_group($res['insertiongroup']));
                                        }
                                        $htmlinsertionfees .= '<tr class="alt1"><td valign="top">' . stripslashes($res['title']) . ' (' . $ilance->currency->format($res['budgetfrom']) . ' ' . $phrase['_or_more'] . ')</td><td valign="top"><strong>' . $thefee . '</strong></td></tr>';
                                }
                                else
                                {
                                        $thefee = $this->calculate_insertion_fee_in_budget_group($res['insertiongroup']);
                                        if ($thefee == 0)
                                        {
                                                $thefee = $phrase['_free'];
                                        }
                                        else
                                        {
                                                $thefee = $ilance->currency->format($this->calculate_insertion_fee_in_budget_group($res['insertiongroup']));
                                        }
                                        $htmlinsertionfees .= '<tr class="alt1"><td valign="top">' . stripslashes($res['title']) . ' (' . $ilance->currency->format($res['budgetfrom']) . ' - ' . $ilance->currency->format($res['budgetto']) . ')</td><td valign="top"><strong>' . $thefee . '</strong></td></tr>';
                                }                                        
                        }
                        
                        $htmlinsertionfees .= '<tr><td valign="top" colspan="2"><span class="gray">' . $phrase['_you_may_be_required_to_pay_this_fee_in_full_before_public_visibility'] . '</span></td></tr>';
                }
                else 
                {
                        $show['budgetinsertionfees'] = 0;
                        $htmlinsertionfees .= '<tr><td valign="top" colspan="2"><span class="gray">' . $phrase['_no_insertion_fees_within_this_category'] . '</span></td></tr>';	
                }
                
                $listingfees = '
                <div class="block-wrapper">

                <div class="block2">
                
                                <div class="block2-top">
                                                <div class="block2-right">
                                                                <div class="block2-left"></div>
                                                </div>
                                </div>
                                
                                <div class="block2-header">' . $phrase['_budget'] . ' ' . $phrase['_insertion_listing_fees'] . '</div>
			
                                <div class="block2-content" style="padding:0px">
                                <table border="0" cellpadding="9" cellspacing="1" width="100%">
                                <tr class="alt2">
                                        <td valign="top"><strong>' . $phrase['_budget'] . '</strong></td>
                                        <td valign="top" nowrap="nowrap"><strong>' . $phrase['_insertion_fee_amount'] . '</strong></td>
                                </tr>
                                ' . $htmlinsertionfees . '
                                </table></div>
			
                                                        <div class="block2-footer">
                                                                        <div class="block2-right">
                                                                                        <div class="block2-left"></div>
                                                                        </div>
                                                        </div>
                                                        
                                        </div>
                                </div>';
                
                return $listingfees;
        }
        
        /**
        * Function to print final value fees formatted in a html table.  This function takes into consideration if the viewing user is exempt from final value fees.
        *
        * @param       integer        category id number
        * @param       string         category type (service/product)
        * @param       string         bid amount type
        *
        * @return      string         Returns category id's in comma separate values (ie: 1,3,4,6)
        */
        function print_final_value_fees($cid = 0, $cattype = 'service', $bidamounttype = '')
        {
                global $ilance, $myapi, $phrase, $show;
                
                $ilance->subscription = construct_object('api.subscription');
                
                $htmlfinalvaluefees = '';
                
                // first check if admin uses fixed fees in this category
                if ($ilance->categories->fetch[$_SESSION['ilancedata']['user']['slng']][$cattype][$cid]['usefixedfees'] AND isset($bidamounttype) AND !empty($bidamounttype))
                {
                        // admin charges a fixed fee within this category to service providers
                        // let's determine if the bid amount type logic is configured
                        if ($bidamounttype != 'entire' AND $bidamounttype != 'item' AND $bidamounttype != 'lot')
                        {
                                // bid amount type passes accepted commission types
                                // let's output our final value fee table
                                if ($cattype == 'service')
                                {
                                        $htmlfinalvaluefees .= '<tr><td class="alt1">' . $phrase['_no_awarded_provider'] . '</td><td class="alt1"><strong>' . $phrase['_no_fee'] . '</strong></td></tr>';
                                }
                                else
                                {
                                        $htmlfinalvaluefees .= '<tr><td class="alt1">' . $phrase['_no_winning_bid'] . '</td><td class="alt1"><strong>' . $phrase['_no_fee'] . '</strong></td></tr>';
                                }
                                
                                $htmlfinalvaluefees .= '<tr><td valign="top" nowrap="nowrap" class="alt1">' . $ilance->currency->format(0.01) . ' ' . $phrase['_or_more'] . '</td><td valign="top" class="alt1">' . $ilance->currency->format($ilance->categories->fetch[$_SESSION['ilancedata']['user']['slng']][$cattype][$cid]['fixedfeeamount']) . ' (' . $phrase['_fixed'] . ')</td></tr>';
                        }
                        else
                        {
                                $htmlfinalvaluefees .= '<tr><td valign="top" colspan="2" class="alt1"><span class="gray">' . $phrase['_no_final_value_fees_within_this_category'] . '</span></td></tr>';	    
                        }
                }
                else
                {
                        $show['finalvaluefees'] = 1;
                        
                        $sqlfinalvalues = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "finalvalue
                                WHERE groupname = '" . $ilance->categories->fetch[$_SESSION['ilancedata']['user']['slng']][$cattype][$cid]['finalvaluegroup'] . "'
                                    AND state = '" . $ilance->db->escape_string($cattype) . "'
                                ORDER BY sort ASC
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($sqlfinalvalues) > 0)
                        {
                                $tier = 1;
                                while ($rows = $ilance->db->fetch_array($sqlfinalvalues))
                                {
                                        $from = $ilance->currency->format($rows['finalvalue_from']);
                                        $to =  ' &ndash; ' . $ilance->currency->format($rows['finalvalue_to']);
                                        if ($rows['amountfixed'] > 0)
                                        {
                                                $amountraw = $rows['amountfixed'];
                                                $amount = '<strong>' . $ilance->currency->format($rows['amountfixed']) . '</strong> ' . $phrase['_fixed_price'];
                                        }
                                        else 
                                        {
                                                $amountraw = $rows['amountpercent'];
                                                if ($tier == 1)
                                                {
                                                        $amount = '<strong>' . $rows['amountpercent'] . '%</strong> ' . $phrase['_of_the_closing_value'];
                                                }
                                                else 
                                                {
                                                        $amount = '<strong>' . $rows['amountpercent'] . '%</strong> ' . $phrase['_of_the_remaining_balance_plus_tier_above'];
                                                }
                                        }
                                        
                                        if ($rows['finalvalue_to'] == '-1')
                                        {
                                                $to = $phrase['_or_more'];
                                        }
                                        
                                        $htmlfinalvaluefees .= '<tr><td valign="top" nowrap="nowrap" class="alt1">' . $from . ' ' . $to . '</td><td valign="top" class="alt1">' . $amount . '</td></tr>';
                                        $tier++;
                                }
                                
                                if ($cattype == 'service')
                                {
                                        $htmlfinalvaluefees .= '<tr><td><span class="gray">' . $phrase['_no_awarded_provider'] . '</span></td><td><span class="gray"><strong>' . $phrase['_no_fee'] . '</strong></span></td></tr>';
                                }
                                else 
                                {
                                        $htmlfinalvaluefees .= '<tr><td><span class="gray">' . $phrase['_no_winning_bid'] . '</span></td><td><span class="gray"><strong>' . $phrase['_no_fee'] . '</strong></span></td></tr>';	
                                }
                        }
                        else 
                        {
                                $show['finalvaluefees'] = 0;
                                $htmlfinalvaluefees .= '<tr><td valign="top" colspan="2"><span class="gray">' . $phrase['_no_final_value_fees_within_this_category'] . '</span></td></tr>';	
                        }
                }
                
                // check for subscription fvf exemption
                if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0 AND $ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'fvfexempt') == 'yes')
                {
                        $htmlfinalvaluefees = '<tr><td valign="top" colspan="2" class="alt1"><span class="gray">' . $phrase['_you_are_exempt_from_final_value_fees'] . '</span></td></tr>';
                }
                
                $listingfees = '
                <div class="block-wrapper">

                        <div class="block">
                        
                        <div class="block-top">
                                        <div class="block-right">
                                                        <div class="block-left"></div>
                                        </div>
                        </div>
                        
                        <div class="block-header">' . $phrase['_final_value_fees'] . '</div>
                        
                        <div class="block-content" style="padding:0px">
                                                
                        <table border="0" width="100%" cellpadding="9" cellspacing="1">';
            
                        if ($cattype == 'service')
                        {
                                $listingfees .= '
                                <tr>
                                        <td valign="top" class="alt2"><strong>' . $phrase['_awarded_price'] . '</strong></td>
                                        <td valign="top" class="alt2"><strong>' . $phrase['_final_value_fee'] . '</strong></td>
                                </tr>
                                ' . $htmlfinalvaluefees;
                        }
                        else 
                        {
                                $listingfees .= '
                                <tr>
                                        <td valign="top" class="alt2"><strong>' . $phrase['_closing_price'] . '</strong></td>
                                        <td valign="top" class="alt2"><strong>' . $phrase['_final_value_fee'] . '</strong></td>
                                </tr>
                                ' . $htmlfinalvaluefees;	
                        }
                        
                        $listingfees .= '
                        </table>
                        
                        </div>
                                        
                        <div class="block-footer">
                                        <div class="block-right">
                                                        <div class="block-left"></div>
                                        </div>
                        </div>
                                        
                        </div>
                </div>';
                
                return $listingfees;
        }
        
        /**
        * Function to process the custom auction questions
        *
        * @param       array         custom array
        * @param       integer       project id
        * @param       string        category mode (service or product)
        *
        * @return      null
        */
        function process_custom_questions($custom = array(), $projectid = 0, $mode = '')
        {
                global $ilance;
                
                if (isset($custom) AND !empty($custom))
                {
                        foreach ($custom as $questionid => $answerarray)
                        {
                                foreach ($answerarray as $formname => $answer)
                                {
                                        if ($mode == 'service')
                                        {
                                                $sql2 = $ilance->db->query("
                                                        SELECT *
                                                        FROM " . DB_PREFIX . "project_answers
                                                        WHERE questionid = '".intval($questionid)."'
                                                            AND project_id = '".intval($projectid)."'
                                                ", 0, null, __FILE__, __LINE__);
                                        }
                                        if ($mode == 'product')
                                        {
                                                $sql2 = $ilance->db->query("
                                                        SELECT *
                                                        FROM " . DB_PREFIX . "product_answers
                                                        WHERE questionid = '".intval($questionid)."'
                                                            AND project_id = '".intval($projectid)."'
                                                ", 0, null, __FILE__, __LINE__);
                                        }                        
                                        if ($ilance->db->num_rows($sql2) > 0 AND !empty($answer))
                                        {
                                                if (is_array($answer))
                                                {
                                                        // multiple choice
                                                        $answer = serialize($answer);
                                                }
                                                if ($mode == 'service')
                                                {
                                                        $ilance->db->query("
                                                                UPDATE " . DB_PREFIX . "project_answers
                                                                SET answer = '".$ilance->db->escape_string($answer)."'
                                                                WHERE questionid = '".intval($questionid)."'
                                                                    AND project_id = '".intval($projectid)."'
                                                                LIMIT 1
                                                        ", 0, null, __FILE__, __LINE__);
                                                }
                                                if ($mode == 'product')
                                                {
                                                        $ilance->db->query("
                                                                UPDATE " . DB_PREFIX . "product_answers
                                                                SET answer = '".$ilance->db->escape_string($answer)."'
                                                                WHERE questionid = '".intval($questionid)."'
                                                                    AND project_id = '".intval($projectid)."'
                                                                LIMIT 1
                                                        ", 0, null, __FILE__, __LINE__);   
                                                }                            
                                        }
                                        else
                                        {
                                                if (!empty($answer))
                                                {
                                                        if (is_array($answer))
                                                        {
                                                                // multiple choice
                                                                $answer = serialize($answer);
                                                        }
                                                        if ($mode == 'service')
                                                        {
                                                                $ilance->db->query("
                                                                        INSERT INTO " . DB_PREFIX . "project_answers
                                                                        (answerid, questionid, project_id, answer, date, visible)
                                                                        VALUES(
                                                                        NULL,
                                                                        '".intval($questionid)."',
                                                                        '".intval($projectid)."',
                                                                        '".$ilance->db->escape_string($answer)."',
                                                                        '".DATETIME24H."',
                                                                        '1')
                                                                ", 0, null, __FILE__, __LINE__);    
                                                        }
                                                        if ($mode == 'product')
                                                        {
                                                                $ilance->db->query("
                                                                        INSERT INTO " . DB_PREFIX . "product_answers
                                                                        (answerid, questionid, project_id, answer, date, visible)
                                                                        VALUES(
                                                                        NULL,
                                                                        '".intval($questionid)."',
                                                                        '".intval($projectid)."',
                                                                        '".$ilance->db->escape_string($answer)."',
                                                                        '".DATETIME24H."',
                                                                        '1')
                                                                ", 0, null, __FILE__, __LINE__);    
                                                        }
                                                }
                                        }
                                }
                        }
                }
        }
        
        /**
        * Function to process the custom auction profile filter questions
        *
        * @param       array         custom array
        * @param       integer       project id
        * @param       string        category mode (service or product)
        *
        * @return      null
        */
        function process_custom_profile_questions($custom = array(), $projectid = 0, $userid = 0, $mode = '')
        {
                global $ilance;
                
                if (isset($custom) AND !empty($custom))
                {
                        foreach ($custom as $questionid => $answer)
                        {
                                $sql2 = $ilance->db->query("
                                        SELECT *
                                        FROM " . DB_PREFIX . "profile_filter_auction_answers
                                        WHERE questionid = '".intval($questionid)."'
                                            AND project_id = '".intval($projectid)."'
                                            AND user_id = '".intval($userid)."'
                                ", 0, null, __FILE__, __LINE__);                    
                                if ($ilance->db->num_rows($sql2) > 0 AND !empty($answer))
                                {
                                        if (is_array($answer))
                                        {
                                                // range choices
                                                $answer = serialize($answer);
                                        }
                                        $ilance->db->query("
                                                UPDATE " . DB_PREFIX . "profile_filter_auction_answers
                                                SET answer = '".$ilance->db->escape_string($answer)."'
                                                WHERE questionid = '".intval($questionid)."'
                                                    AND project_id = '".intval($projectid)."'
                                                    AND user_id = '".intval($userid)."'
                                                LIMIT 1
                                        ", 0, null, __FILE__, __LINE__);                            
                                }
                                else
                                {
                                        if (!empty($answer))
                                        {
                                                if (is_array($answer))
                                                {
                                                        // range choices
                                                        $answer = serialize($answer);
                                                }
                                                $ilance->db->query("
                                                        INSERT INTO " . DB_PREFIX . "profile_filter_auction_answers
                                                        (answerid, questionid, project_id, user_id, answer, date, visible)
                                                        VALUES(
                                                        NULL,
                                                        '".intval($questionid)."',
                                                        '".intval($projectid)."',
                                                        '".intval($userid)."',
                                                        '".$ilance->db->escape_string($answer)."',
                                                        '".DATETIME24H."',
                                                        '1')
                                                ", 0, null, __FILE__, __LINE__);    
                                        }
                                }
                        }
                }
        }
        
        /**
        * Function to obtain the email invitation email list line by line using \n as line seperator.
        *
        * @param       integer      auction id
        *
        * @return      string       line by line email list
        */
        function fetch_email_invites($projectid = 0)
        {
                global $ilance, $myapi;
                
                $html = '';
                
                $sql = $ilance->db->query("
                        SELECT email, name
                        FROM " . DB_PREFIX . "project_invitations
                        WHERE project_id = '".intval($projectid)."'
                            AND email != ''
                            AND buyer_user_id = '".$_SESSION['ilancedata']['user']['userid']."'
                ", 0, null, __FILE__, __LINE__);
                if ($ilance->db->num_rows($sql) > 0)
                {
                        while ($res = $ilance->db->fetch_array($sql))
                        {
                                $html .= $res['email'] . "\n";
                        }
                }
                
                return $html;
        }
        
        /**
        * Function to obtain the username invitation list line by line using \n as line seperator.
        *
        * @param       integer      auction id
        *
        * @return      string       line by line username list
        */
        function fetch_member_invites($projectid = 0)
        {
                global $ilance, $myapi;
                
                $html = '';
                
                $sql = $ilance->db->query("
                        SELECT seller_user_id
                        FROM " . DB_PREFIX . "project_invitations
                        WHERE project_id = '".intval($projectid)."'
                            AND buyer_user_id = '".$_SESSION['ilancedata']['user']['userid']."'
                            AND seller_user_id != '-1'
                ", 0, null, __FILE__, __LINE__);
                if ($ilance->db->num_rows($sql) > 0)
                {
                        while ($res = $ilance->db->fetch_array($sql))
                        {
                                $html .= fetch_user('username', $res['seller_user_id']) . "\n";
                        }
                }
                
                return $html;
        }
        
        /**
        * Function to print a year pulldown menu.
        *
        * @param       string        selected year value (optional)
        *
        * @return      string        HTML representation of the year pulldown menu
        */
        function year($year = '')
        {
                global $ilconfig;
                
                $html = '<select name="year" style="font-family: verdana">';
                $html .= '<option value="'.gmdate('Y',time()+3600*($ilconfig['globalserverlocale_officialtimezone']+$ilconfig['globalserverlocale_officialtimezonedst'])).'">'.gmdate('Y',time()+3600*($ilconfig['globalserverlocale_officialtimezone']+$ilconfig['globalserverlocale_officialtimezonedst'])).'</option>';
                if (gmdate('m') == '11')
                {
                        $html .= '<option value="'.(gmdate('Y',time()+3600*($ilconfig['globalserverlocale_officialtimezone']+$ilconfig['globalserverlocale_officialtimezonedst']))+1).'">'.(gmdate('Y',time()+3600*($ilconfig['globalserverlocale_officialtimezone']+$ilconfig['globalserverlocale_officialtimezonedst']))+1).'</option>';
                }
                $html .= '</select>';
                
                return $html;
        }
        
        /**
        * Function to print a month pulldown menu.
        *
        * @param       string        selected month value (optional)
        *
        * @return      string        HTML representation of the month pulldown menu
        */
        function month($month = '')
        {
                global $ilconfig;
                
                $html = '<select name="month" style="font-family: verdana">';
                
                for ($i = 1; $i <= 12; $i++)
                {
                        if ($i < 10)
                        {
                                $i = "0$i";
                        }
                        if (isset($month) AND $month == $i)
                        {
                                $html .= '<option value="'.$i.'" selected="selected">'.$i.'</option>';
                        }
                        else
                        {
                                $html .= '<option value="'.$i.'"';
                                if (empty($month) AND $i == gmdate('m',time()+3600*($ilconfig['globalserverlocale_officialtimezone']+$ilconfig['globalserverlocale_officialtimezonedst'])))
                                {
                                        $html .= ' selected="selected"';
                                }
                                $html .= '>'.$i.'</option>';				
                        }
                }
                $html .= '</select>';
                
                return $html;
        }
        
        /**
        * Function to print a day pulldown menu.
        *
        * @param       string        selected day value (optional)
        *
        * @return      string        HTML representation of the day pulldown menu
        */
        function day($day = '')
        {
                global $ilconfig;
                
                $html = '<select name="day" style="font-family: verdana">';
                for ($i = 1; $i <= 31; $i++)
                {
                        if ($i < 10)
                        {
                                $i = "0$i";
                        }
                            
                        if (isset($day) AND $day == $i)
                        {
                                $html .= '<option value="'.$i.'" selected="selected">'.$i.'</option>';
                        }
                        else 
                        {
                                $html .= '<option value="'.$i.'"';
                                if (empty($day) AND $i == gmdate('d',time()+3600*($ilconfig['globalserverlocale_officialtimezone']+$ilconfig['globalserverlocale_officialtimezonedst'])))
                                {
                                        $html .= ' selected="selected"';
                                }
                                $html .= '>'.$i.'</option>';
                        }
                }
                $html .= '</select>';
                
                return $html;
        }
        
        /**
        * Function to print an hour pulldown menu.
        *
        * @param       string        selected hour value (optional)
        *
        * @return      string        HTML representation of the hour pulldown menu
        */
        function hour($hour = '')
        {
                global $ilconfig;
                
                $html = '<select name="hour" style="font-family: verdana">';                                
                for ($i = 0; $i <= 23; $i++)
                {
                        if ($i < 10)
                        {
                                $i = "0$i";
                        }                                    
                        if (isset($hour) AND $i == $hour)
                        {
                                $html .= '<option value="'.$i.'" selected="selected">'.$i.'</option>';
                        }
                        else 
                        {
                                $html .= '<option value="'.$i.'"';
                                if (empty($hour) AND $i == gmdate('H',time()+3600*($ilconfig['globalserverlocale_officialtimezone']+$ilconfig['globalserverlocale_officialtimezonedst'])))
                                {
                                        $html .= ' selected="selected"';
                                }
                                $html .= '>'.$i.'</option>';
                        }
                }
                $html .= '</select>';
                
                return $html;
        }
        
        /**
        * Function to print a minute pulldown menu.
        *
        * @param       string        selected minute value (optional)
        *
        * @return      string        HTML representation of the minute pulldown menu
        */
        function min($min = '')
        {
                global $ilconfig;
                
                $html = '<select name="min" style="font-family: verdana">';
                for ($i = 0; $i <= 59; $i++)
                {
                        if ($i < 10)
                        {
                                $i = "0$i";
                        }                                    
                        if (isset($min) AND $i == $min)
                        {
                                $html .= '<option value="'.$i.'" selected="selected">'.$i.'</option>';
                        }
                        else 
                        {
                                $html .= '<option value="'.$i.'"';
                                if (empty($min) AND $i == gmdate('i',time()+3600*($ilconfig['globalserverlocale_officialtimezone']+$ilconfig['globalserverlocale_officialtimezonedst'])))
                                {
                                        $html .= ' selected="selected"';
                                }
                                $html .= '>'.$i.'</option>';
                        }
                }
                $html .= '</select>';
                
                return $html;
        }
        
        /**
        * Function to print a seconds pulldown menu.
        *
        * @param       string        selected seconds value (optional)
        *
        * @return      string        HTML representation of the seconds pulldown menu
        */
        function sec($sec = '')
        {
                global $ilconfig;
                
                $html = '<select name="sec" style="font-family: verdana">';
                for ($i = 0; $i <= 59; $i++)
                {
                        if ($i < 10)
                        {
                                $i = "0$i";
                        }
                        if (isset($sec) AND $i == $sec)
                        {
                                $html .= '<option value="'.$i.'" selected="selected">'.$i.'</option>';
                        }
                        else 
                        {
                                $html .= '<option value="'.$i.'"';
                                if (empty($sec) AND $i == gmdate('s',time()+3600*($ilconfig['globalserverlocale_officialtimezone']+$ilconfig['globalserverlocale_officialtimezonedst'])))
                                {
                                        $html .= ' selected="selected"';
                                }
                                $html .= '>'.$i.'</option>';
                        }
                }
                $html .= '</select>';
                
                return $html;
        }
        
        /**
        * Function to print the selling format logic for a product auction.
        *
        * @return      string        HTML representation of the selling format selection menus
        */
        function print_selling_format_logic($disabled = false)
        {
                global $ilance, $ilconfig, $phrase, $tab, $headinclude;
                
                $headinclude .= '
<script type="text/javascript">
<!--
function update_price_fixed()
{
        price = fetch_js_object("buynow_price").value;
        document.ilform.buynow_price_fixed.value = price;
}
function update_buynow_price_fixed()
{
        setTimeout("update_price_fixed()", 500);
}
function update_price()
{
        price = fetch_js_object("buynow_price_fixed").value;
        document.ilform.buynow_price.value = price;
}
function update_buynow_price()
{
        setTimeout("update_price()", 500);
}
function update_qty_fixed()
{
        qty = fetch_js_object("buynow_qty").value;
        document.ilform.buynow_qty_fixed.value = qty;
}
function update_buynow_qty_fixed()
{
        setTimeout("update_qty_fixed()", 500);
}
function update_qty()
{
        qty = fetch_js_object("buynow_qty_fixed").value;
        document.ilform.buynow_qty.value = qty;
}
function update_buynow_qty()
{
        setTimeout("update_qty()", 500);
}
//-->
</script>';
                
                $cb_auctiontype1 = 'checked="checked"';
		$cb_auctiontype2 = '';
                $tab = 0;
		if (isset($ilance->GPC['filtered_auctiontype']) AND $ilance->GPC['filtered_auctiontype'] == 'regular')
		{
			$cb_auctiontype1 = 'checked="checked"';
			$cb_auctiontype2 = '';
                        $tab = 0;
		}
		else if (isset($ilance->GPC['filtered_auctiontype']) AND $ilance->GPC['filtered_auctiontype'] == 'fixed')
		{
			$cb_auctiontype1 = '';
			$cb_auctiontype2 = 'checked="checked"';
                        $tab = 1;
		}
		
                // #### REGULAR AUCTION ########################################
		// starting bid price
		$startprice = '';
		if (!empty($ilance->GPC['startprice']))
		{
			$startprice = sprintf("%01.2f", $ilance->GPC['startprice']);
		}
		
		// reserve price
                $show['usereserveprice'] = $ilance->categories->fetch[$_SESSION['ilancedata']['user']['slng']]['product'][$ilance->GPC['cid']]['usereserveprice'];
		$reserve_price = '';
                $reserve = 0;
		if (!empty($ilance->GPC['reserve_price']) AND $show['usereserveprice'])
		{
			$reserve_price = sprintf("%01.2f", $ilance->GPC['reserve_price']);
                        $reserve = 1;
		}
                
                // reserve price fee
                $reservefee = 0;
                $reservefeeformatted = $phrase['_free'];;
                if ($ilconfig['productupsell_reservepricecost'] > 0)
                {
                        $reservefee = $ilconfig['productupsell_reservepricecost'];
                        $reservefeeformatted = $ilance->currency->format($reservefee);
                }
                
		// buynow price
		$buynow_price = '';
                $buynow_price_fixed = '';
		if (!empty($ilance->GPC['buynow_price']))
		{
			$buynow_price = sprintf("%01.2f", $ilance->GPC['buynow_price']);
                        $buynow_price_fixed = sprintf("%01.2f", $ilance->GPC['buynow_price']);
		}
		
		// buynow qty
		$buynow_qty = 1;
                $buynow_qty_fixed = 1;
		if (!empty($ilance->GPC['buynow_qty']))
		{
			$buynow_qty = intval($ilance->GPC['buynow_qty']);
                        $buynow_qty_fixed = intval($ilance->GPC['buynow_qty']);
		}
		
                // #### FIXED PRICED ONLY ######################################
                // buynow price
		if (!empty($ilance->GPC['buynow_price_fixed']))
		{
			$buynow_price_fixed = sprintf("%01.2f", $ilance->GPC['buynow_price_fixed']);
		}
		
		// buynow qty
		if (!empty($ilance->GPC['buynow_qty_fixed']))
		{
			$buynow_qty_fixed = intval($ilance->GPC['buynow_qty_fixed']);
		}
                
                // buy now fees
                $buynowfee = 0;
                $buynowfeeformatted = $phrase['_free'];
                if ($ilconfig['productupsell_buynowcost'] > 0)
                {
                        $buynowfee = $ilconfig['productupsell_buynowcost'];
                        $buynowfeeformatted = $ilance->currency->format($buynowfee);
                }
                
		$html = '
                <div class="tab-pane" id="sellingformat">
			<div class="tab-page">
				<h2 class="tab" id="0"><a href="javascript:void(0)" onclick="javascript:document.ilform.filtered_auctiontype[0].checked=true">' . $phrase['_auction'] . '</a></h2>
                                
                                <div><strong><input ' . ($disabled ? 'disabled="disabled"' : '') . ' type="radio" name="filtered_auctiontype" id="filtered_auctiontype" value="regular" ' . $cb_auctiontype1 . ' /> <label for="filtered_auctiontype">' . $phrase['_auction'] . '</label></strong></div>
                                <div class="gray">' . $phrase['_this_format_allow_bidding_to_take_place_including_the_ablility'] . '</div>
                                <table border="0" cellpadding="2" cellspacing="0">
                                <tr>
                                        <td width="50%" valign="top">
                                        
                                                <table cellpadding="0" cellspacing="3" border="0" width="10">
                                                <tr>
                                                        <td width="1%" nowrap="nowrap">' . $phrase['_starting_price'] . '</td>
                                                        <td width="1%">&nbsp;&nbsp;'.$ilance->currency->currencies[$ilconfig['globalserverlocale_defaultcurrency']]['symbol_left'].'</td> 
                                                        <td width="1%" nowrap="nowrap"><input ' . ($disabled ? 'disabled="disabled"' : '') . ' type="text" id="startprice" name="startprice" value="' . $startprice . '" onkeypress="return noenter()" onclick="javascript:document.ilform.filtered_auctiontype[0].checked=true" style="width:60px" class="input" /> &nbsp;&nbsp;<a href="javascript:void(0);" onmouseover="Tip(phrase[\'_the_starting_price_is_the_amount_you_set_the_starting_bid_amount_in_your_auction_event_bidders_will_need_to_begin_the_bid_amounts\'], BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a></td>
                                                </tr>
                                                <tr>
                                                        <td align="right" width="1%">' . $phrase['_qty'] . '</td>
                                                        <td width="1%" align="right"><strong>x</strong></td>
                                                        <td width="1%" nowrap="nowrap" colspan="2"><input ' . ($disabled ? 'disabled="disabled"' : '') . ' type="text" id="buynow_qty" name="buynow_qty" value="' . $buynow_qty . '" onkeypress="return update_buynow_qty_fixed()" onclick="javascript:document.ilform.filtered_auctiontype[0].checked=true" style="width:25px; font-family: verdana" /></td>
                                                </tr>
                                                </table>
                                                
                                                
                                        </td>
                                        <td width="50%" valign="top">
                                                <table cellpadding="0" cellspacing="3" border="0" width="10">
                                                <tr>
                                                        <td width="1%" nowrap="nowrap">' . $phrase['_buy_now_price'] . ' &nbsp;&nbsp;<span class="smaller gray">(' . $buynowfeeformatted . ')</span></td> 
                                                        <td width="1%">&nbsp;&nbsp;' . $ilance->currency->currencies[$ilconfig['globalserverlocale_defaultcurrency']]['symbol_left'] . '</td>
                                                        <td width="1%" nowrap="nowrap" align="left"><input ' . ($disabled ? 'disabled="disabled"' : '') . ' type="text" id="buynow_price" name="buynow_price" onkeypress="return update_buynow_price_fixed()" value="' . $buynow_price . '" onclick="javascript:document.ilform.filtered_auctiontype[0].checked=true" style="width:60px" class="input" /> &nbsp;&nbsp;<a href="javascript:void(0);" onmouseover="Tip(phrase[\'_buy_now_price_optional_if_you_would_like_to_offer_buyers_the_chance\'], BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a></td>
                                                </tr>';
                                                
                                                if ($show['usereserveprice'])
                                                {
                                                        $html .= '
                                                        <tr>
                                                                <td align="right" width="1%" nowrap="nowrap">'.$phrase['_reserve_price'] . ' &nbsp;&nbsp;<span class="smaller gray">(' . $reservefeeformatted . ')</span></td>
                                                                <td align="right">&nbsp;&nbsp;' . $ilance->currency->currencies[$ilconfig['globalserverlocale_defaultcurrency']]['symbol_left'] . '</td> 
                                                                <td nowrap="nowrap"><input ' . ($disabled ? 'disabled="disabled"' : '') . ' type="text" id="reserve_price" name="reserve_price" value="' . $reserve_price . '" onkeypress="return noenter()" style="width:60px" class="input" /> &nbsp;&nbsp;<a href="javascript:void(0);" onmouseover="Tip(phrase[\'_a_reserve_price_is_a_hidden_amount_you_can_set_which_no_bidder_can_see\'], BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a></td>
                                                        </tr>';
                                                }
                                                else
                                                {
                                                        $html .= '
                                                        <tr>
                                                                <td align="right" width="1%" nowrap="nowrap"></td>
                                                                <td align="right"></td> 
                                                                <td nowrap="nowrap"><input type="hidden" id="reserve_price" name="reserve_price" value="" /></td>
                                                        </tr>';        
                                                }
                                                
                                                $html .= '
                                                </table>       
                                        </td>
                                </tr>
                                </table>
                                
                        </div>
                        <div class="tab-page">
				<h2 class="tab" id="1"><a href="javascript:void(0)" onclick="javascript:document.ilform.filtered_auctiontype[1].checked=true">' . $phrase['_fixed_price'] . '</a></h2>
                                <table border="0" cellpadding="2" cellspacing="0">
                                <tr>
                                        <td width="50%" valign="top">
                                        
                                                <div><strong><input ' . ($disabled ? 'disabled="disabled"' : '') . ' type="radio" name="filtered_auctiontype" id="filtered_auctiontype0" value="fixed" ' . $cb_auctiontype2 . ' /> <label for="filtered_auctiontype0">' . $phrase['_fixed_price'] . '</label></strong></div>
                                                <div class="gray">' . $phrase['_this_format_does_not_allow_bidding_to_take_place'] . '</div>
                                                <table cellpadding="0" cellspacing="3" border="0" width="10">
                                                <tr>
                                                        <td width="1%" nowrap="nowrap">' . $phrase['_buy_now_price'] . ' &nbsp;&nbsp;<span class="smaller gray">(' . $buynowfeeformatted . ')</span></td> 
                                                        <td width="1%">&nbsp;&nbsp;' . $ilance->currency->currencies[$ilconfig['globalserverlocale_defaultcurrency']]['symbol_left'] . '</td>
                                                        <td width="1%" nowrap="nowrap" align="left"><input ' . ($disabled ? 'disabled="disabled"' : '') . ' type="text" id="buynow_price_fixed" name="buynow_price_fixed" onkeypress="return update_buynow_price()" value="' . $buynow_price_fixed . '" onclick="javascript:document.ilform.filtered_auctiontype[1].checked=true" style="width:60px; font-family: verdana" /> &nbsp;&nbsp;<a href="javascript:void(0);" onmouseover="Tip(phrase[\'_buy_now_price_refers_to_a_fixed_cost_for_items_you_are_selling_for_example\'], BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a></td>
                                                </tr>
                                                <tr>
                                                        <td align="right" width="1%">' . $phrase['_qty'] . '</td>
                                                        <td width="1%" align="right"><strong>x</strong></td>
                                                        <td width="1%" nowrap="nowrap" colspan="2"><input ' . ($disabled ? 'disabled="disabled"' : '') . ' type="text" id="buynow_qty_fixed" name="buynow_qty_fixed" value="' . $buynow_qty_fixed . '" onkeypress="return update_buynow_qty()" onclick="javascript:document.ilform.filtered_auctiontype[1].checked=true" style="width:25px; font-family: verdana" /></td>
                                                </tr>
                                                </table>
                                                
                                                
                                        </td>
                                        <td width="50%" valign="top">
                                                
                                                
                                                
                                        </td>
                                </tr>
                                </table>
                        </div>';
                        
                ($apihook = $ilance->api('print_selling_format_logic_tab_end')) ? eval($apihook) : false;
                        
                $html .= '</div>';
                
                ($apihook = $ilance->api('print_selling_format_logic_end')) ? eval($apihook) : false;
                
                return $html;
        }
        
        /**
        * Function to print the shipping logic within a product auction.
        *
        * @param       string        
        * @param       string
        *
        * @return      nothing
        */
        function print_shipping_logic($disabled = false)
        {
                global $ilance, $ilconfig, $phrase, $onload, $project_id, $cid, $ilpage, $attachment_style;
                
                $ship_costs = '0.00';
		if (isset($ilance->GPC['ship_costs']) AND $ilance->GPC['ship_costs'] > 0)
		{
			$ship_costs = $ilance->GPC['ship_costs'];
		}
		
                // #### handle defaults or when the listing is being updated
		$seldigital = $selsellerpays = $selflatrate = $selnone = '';
                
                $ilance->GPC['ship_handling'] = isset($ilance->GPC['ship_handling']) ? $ilance->GPC['ship_handling'] : '';
		if ($ilance->GPC['ship_handling'] != '')
		{
			if ($ilance->GPC['ship_handling'] == 'digital')
			{
				$seldigital = 'selected="selected"';
				$onload .= 'toggle_free(\'showshippingcost\'); toggle_free(\'showpartners\'); toggle_paid(\'showdigitalupload\'); ';
			}
			if ($ilance->GPC['ship_handling'] == 'sellerpays')
			{
				$selsellerpays = 'selected="selected"';
                                $onload .= 'toggle_free(\'showshippingcost\'); toggle_free(\'showdigitalupload\'); toggle_paid(\'showpartners\'); ';
			}
			if ($ilance->GPC['ship_handling'] == 'flatrate')
			{
				$selflatrate = 'selected="selected"';
				$onload .= 'toggle_paid(\'showshippingcost\'); toggle_free(\'showdigitalupload\'); toggle_paid(\'showpartners\'); ';
			}
                        if ($ilance->GPC['ship_handling'] == 'none')
			{
				$selnone = 'selected="selected"';
				$onload .= 'toggle_free(\'showpartners\'); toggle_free(\'showshippingcost\'); toggle_free(\'showdigitalupload\'); toggle_free(\'shipto\'); toggle_paid(\'shownoshipping\'); ';
			}
		}
		else 
		{
			$seldigital = '';
			$selsellerpays = 'selected="selected"';
			$selflatrate = '';
                        $selnone = '';
		}
		
		$selworldwide = $selpickup = $selcustom = $ship_countries = '';
		if (isset($ilance->GPC['ship_countries']) AND $ilance->GPC['ship_countries'] != '')
		{
			$ship_countries	= strip_tags(stripslashes($ilance->GPC['ship_countries']));
		}
                
		if (isset($ilance->GPC['ship_country']) AND $ilance->GPC['ship_country'] != '' AND $ilance->GPC['ship_handling'] != 'none')
		{
			if ($ilance->GPC['ship_country'] == 'custom')
			{
				$selcustom = 'selected="selected"';
				$onload .= 'toggle_paid(\'showcountries\'); ';
                                if (isset($ilance->GPC['ship_handling']) AND $ilance->GPC['ship_handling'] != 'digital')
                                {
                                        $onload .= 'toggle_paid(\'showpartners\'); ';
                                }
                        }
			if ($ilance->GPC['ship_country'] == 'worldwide')
			{
				$selworldwide = 'selected="selected"';
                                $onload .= 'toggle_free(\'showcountries\'); toggle_paid(\'showpartners\'); ';
			}
			if ($ilance->GPC['ship_country'] == 'pickup')
			{
				$selpickup = 'selected="selected"';
                                $onload .= 'toggle_free(\'showcountries\'); toggle_free(\'showpartners\'); ';
			}
		}
		
                // item photo upload button
		$hiddeninput = array(
                        'attachtype' => 'digital',
                        'project_id' => $project_id,
                        'user_id' => $_SESSION['ilancedata']['user']['userid'],
                        'category_id' => $cid,
                        'filehash' => md5(time()),
                        'max_filesize' => $ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], $accessname = 'uploadlimit'),
                        'attachmentlist' => 'digital_attachmentlist'
                );
                
		$uploadbutton = '<div style="padding-top:5px"><input name="attachment" onclick=Attach("' . $ilpage['upload'] . '?crypted=' . encrypt_url($hiddeninput) . '") type="button" value="' . $phrase['_upload'] . '" class="buttons" ' . $attachment_style . ' /></div>';
                unset($hiddeninput);
                
		$shipping = '
                <div> 
                        <div><strong>'.$phrase['_shipping_and_handling'] . '</strong></div>
                        
                        <div class="gray" style="padding-bottom:4px">' . $phrase['_decide_who_ultimately_pays_for_the_associated_shipping_costs_for_this_item'] . '</div>
                        
                        <select ' . ($disabled ? 'disabled="disabled"' : '') . ' id="ship_handling" style="font-family: verdana" name="ship_handling" onchange="javascript:
                        if (document.ilform.ship_handling[0].selected == true)
                        { // digital item
                                toggle_free(\'showshippingcost\');
                                toggle_free(\'showpartners\');
                                toggle_paid(\'showdigitalupload\');
                                toggle_paid(\'shipto\');
                                toggle_free(\'shownoshipping\');
                        }
                        else if (document.ilform.ship_handling[1].selected == true)
                        { // no cost to buyer, I will pay
                                toggle_free(\'showshippingcost\');
                                toggle_free(\'showdigitalupload\');
                                toggle_paid(\'shipto\');
                                toggle_paid(\'showpartners\');
                                toggle_free(\'shownoshipping\');
                        }
                        else if (document.ilform.ship_handling[2].selected == true)
                        { // flat rate
                                toggle_paid(\'showshippingcost\');
                                toggle_free(\'showdigitalupload\');
                                toggle_paid(\'shipto\');
                                toggle_paid(\'showpartners\');
                                toggle_free(\'shownoshipping\');
                        }
                        else if (document.ilform.ship_handling[3].selected == true)
                        { // none: no shipping or digital download
                                toggle_free(\'showshippingcost\');
                                toggle_free(\'showdigitalupload\');
                                toggle_free(\'showpartners\');
                                toggle_free(\'shipto\');
                                toggle_paid(\'shownoshipping\');
                        }
                        ">
                                <option value="digital" ' . $seldigital . '>' . $phrase['_digital_item_no_shipping_cost_to_buyers'] . '</option>
                                <option value="sellerpays" ' . $selsellerpays . '>' . $phrase['_i_will_pay_no_shipping_cost_to_buyers'] . '</option>
                                <option value="flatrate" ' . $selflatrate . '>' . $phrase['_flat_rate_same_cost_to_all_buyers'] . '</option>
                                <option value="none" ' . $selnone . '>' . $phrase['_none_shipping_or_digital_download_does_not_apply'] . '</option>
                        </select>
                        
                        <div style="padding-top:6px"></div>
                        
                        <div id="showdigitalupload" style="display:none">
                        
                                <div style="padding-top:7px">
                                        <div><strong>' . $phrase['_upload_the_product_or_digital_item_you_will_release_to_the_winner_bidder_upon_payment'] . '</strong></div>
                                        <div class="gray" style="padding-bottom:4px">' . $phrase['_max_files'] . ': <strong>1</strong>, ' . $phrase['_max_filesize'] . ': <strong>' . print_filesize($ilconfig['attachmentlimit_digitalfilemaxsize']) . '</strong><br />' . $phrase['_file_extensions'] . ': <strong>' . $ilconfig['attachmentlimit_digitalfileextensions'] . '</strong></div>
                                        ' . $uploadbutton . '
                                        <div style="padding-top:7px" id="digital_attachmentlist">' . fetch_inline_attachment_filelist($_SESSION['ilancedata']['user']['userid'], $project_id, 'digital', $printimage = false) . '</div>
                                </div>
                                
                        </div>
                        
                        <div id="showshippingcost" style="display:none">
                        
                                <table cellpadding="0" cellspacing="3" border="0">
                                <tr> 
                                        <td nowrap="nowrap">' . $phrase['_shipping_fee_costs'] . ' <a href="javascript:void(0);" onmouseover="Tip(\'' . $phrase['_this_cost_will_be_shown_to_buyers_within_the_search_result_listing'] . '\', BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a></td>
                                        <td width="8">' . $ilance->currency->currencies[$ilconfig['globalserverlocale_defaultcurrency']]['symbol_left'] . '</td>
                                        <td width="347"><input ' . ($disabled ? 'disabled="disabled"' : '') . ' type="text" id="ship_costs" name="ship_costs" onkeypress="return noenter()" value="' . $ship_costs . '" style="width:60px; font-family: verdana" /></td>
                                </tr>
                                </table>
                                
                        </div>				
                        <div style="padding-top:7px"></div>
                        
                        <div id="shipto" style="display:inline">
                        
                                <div><strong>' . $phrase['_countries_item_can_ship_to'] . '</strong></div>
                                <div class="gray" style="padding-bottom:4px">' . $phrase['_decide_the_location_where_this_item_can_be_shipped'] . '</div>
                                
                                <select ' . ($disabled ? 'disabled="disabled"' : '') . ' id="ship_country" style="font-family: verdana" name="ship_country" onchange="javascript:
                                if (document.ilform.ship_country[0].selected == true)
                                { // I will ship worldwide
                                        toggle_free(\'showcountries\');
                                        toggle_paid(\'showpartners\');
                                }
                                else if (document.ilform.ship_country[1].selected == true)
                                { // local pickup only
                                        toggle_free(\'showcountries\');
                                        toggle_free(\'showpartners\');
                                }
                                else if (document.ilform.ship_country[2].selected == true)
                                { // I will ship to the following countries selected
                                        toggle_paid(\'showcountries\');
                                        if (document.ilform.ship_handling[0].selected == false)
                                        {
                                                // show shippers if seller is not selling a digital product
                                                toggle_paid(\'showpartners\');
                                        }
                                }">
                                        <option value="worldwide" ' . $selworldwide . '>' . $phrase['_i_will_ship_worldwide'] . '</option>
                                        <option value="pickup" ' . $selpickup . '>' . $phrase['_i_will_not_ship_local_pickup_only'] . '</option>
                                        <option value="custom" ' . $selcustom . '>' . $phrase['_i_will_ship_to_the_following_countries'] . '</option>
                                </select>
                                
                                <div style="padding-top:6px"></div>
                                
                                <div id="showcountries" style="display:none;">
                                        <div style=" padding-top:5px"></div>
          
                                        
                                        <div class="ilance_wysiwyg">
                                        <table cellpadding="0" cellspacing="0" border="0" width="580">
                                        <tr>
                                        <td class="wysiwyg_wrapper" align="right" height="25">
                        
                                                                <table cellpadding="0" cellspacing="0" border="0" width="100%">
                                                                <tr>
                                                                        <td width="100%" align="left" class="smaller">' . $phrase['_plain_text_only_bbcode_is_currently_not_in_use_for_this_field'] . '</td>
                                                                        <td>
                                                                                        <div class="wysiwygbutton"><a href="javascript:void(0)" onclick="return construct_textarea_height(\'ship_countries\', -100)"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'wysiwyg/resize_0.gif" width="21" height="9" alt="' . $phrase['_decrease_size'] . '" border="0" /></a></div>
                                                                                        <div class="wysiwygbutton"><a href="javascript:void(0)" onclick="return construct_textarea_height(\'ship_countries\', 100)"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'wysiwyg/resize_1.gif" width="21" height="9" alt="' . $phrase['_increase_size'] . '" border="0" /></a></div>
                                                                        </td>
                                                                        <td style="padding-right:15px"></td>
                                                                </tr>
                                                                </table>
                                        </td>
                                        </tr>
                                                <tr>
                                                        <td><textarea ' . ($disabled ? 'disabled="disabled"' : '') . ' id="ship_countries" name="ship_countries" style="width:580px; height:84px; padding:8px; font-family: verdana" wrap="physical" onkeydown="textcount(this.form.ship_countries,this.form.ship_countries_len,250);" onkeyup="textcount(this.form.ship_countries,this.form.ship_countries_len,250);" class="wysiwyg">' . $ship_countries . '</textarea> <input readonly="readonly" type="text" name="ship_countries_len" size="3" maxlength="3" value="250" class="input" style="font-family: verdana" /></td>
                                                </tr>
                                        </table>
                                        </div>
                          
                                        <!--<iframe name="country_iframe" id="country_iframe" width="100%" scrolling-bottom="yes" border="0" frameborder="0" class="" style="height:230px; border-top:1px solid #262626; border-left:1px solid #262626; border-right:1px solid #999; border-bottom:1px solid #999" src="' . HTTPS_SERVER . 'ajax.php?do=cbcountries"></iframe>-->

                                </div>
                        </div>
                        
                        <div id="showpartners" style="display:inline">' . $this->print_shipping_partners() . '</div>
                        <div id="shownoshipping" style="display:none;">' . $phrase['_no_shipping_or_digital_download_delivery_method_enabled_for_this_listing'] . '</div>
                </div>';
                
                return $shipping;
        }
        
        /**
        * Function to print the list of shipping partners
        *
        * @return      string      
        */
        function print_return_policy($disabled = false)
        {
                global $ilance, $phrase, $ilconfig;
                
                $html = $returnpolicy = '';
                
                if (isset($ilance->GPC['returnaccepted']) AND $ilance->GPC['returnaccepted'] == '1')
                {
                        $return1 = 'checked="checked"';
                        $return0 = '';
                        $returnstyle = '';
                }
                else
                {
                        $return1 = '';
                        $return0 = 'checked="checked"';
                        $returnstyle = 'display:none';
                }
                
                if (isset($ilance->GPC['returnshippaidby']) AND $ilance->GPC['returnshippaidby'] == 'seller')
                {
                        $returnship1 = '';
                        $returnship2 = 'checked="checked"';
                }
                else
                {
                        $returnship1 = 'checked="checked"';
                        $returnship2 = '';
                }
                
                if (!empty($ilance->GPC['returnpolicy']))
                {
                        $returnpolicy = $ilance->GPC['returnpolicy'];        
                }
                
                $d0 = $d3 = $d7 = $d14 = $d30 = $d60 = '';
                if (empty($ilance->GPC['returnwithin']))
                {
                        $d0 = 'selected="selected"';
                }
                else
                {
                        if ($ilance->GPC['returnwithin'] == '3')
                        {
                                $d3 = 'selected="selected"';
                        }
                        if ($ilance->GPC['returnwithin'] == '7')
                        {
                                $d7 = 'selected="selected"';
                        }
                        if ($ilance->GPC['returnwithin'] == '14')
                        {
                                $d14 = 'selected="selected"';
                        }
                        if ($ilance->GPC['returnwithin'] == '30')
                        {
                                $d30 = 'selected="selected"';
                        }
                        if ($ilance->GPC['returnwithin'] == '60')
                        {
                                $d60 = 'selected="selected"';
                        }
                }
                
                $e0 = $e1 = $e2 = $e3 = '';
                if (empty($ilance->GPC['returngivenas']))
                {
                        $e0 = 'selected="selected"';
                }
                else
                {
                        if ($ilance->GPC['returngivenas'] == 'exchange')
                        {
                                $e1 = 'selected="selected"';
                        }
                        if ($ilance->GPC['returngivenas'] == 'credit')
                        {
                                $e2 = 'selected="selected"';
                        }
                        if ($ilance->GPC['returngivenas'] == 'moneyback')
                        {
                                $e3 = 'selected="selected"';
                        }
                }
                
                $dis = '';
                if ($disabled)
                {
                        $dis = 'disabled="disabled"';
                }
                
                $html = '
                <div>
                
                
                <div><label for="returnaccepted0"><input type="radio" name="returnaccepted" id="returnaccepted0" value="0" ' . $return0 . ' onclick="toggle_tr(\'returnpolicies\');" ' . $dis . ' /> <strong>' . $phrase['_returns_not_accepted'] . '</strong></label><div class="gray" style="padding-left:23px">Select this option if you will not accept returns or do not have a return policy</div></div>
                <div><label for="returnaccepted1"><input type="radio" name="returnaccepted" id="returnaccepted1" value="1" ' . $return1 . ' onclick="toggle_tr(\'returnpolicies\');" ' . $dis . ' /> <strong>' . $phrase['_returns_accepted'] . '</strong></label><div class="gray" style="padding-left:23px">Select this option if you offer a returns or have a return policy</div></div>
                
                <div id="returnpolicies" style="' . $returnstyle . '">
                
                <div style="padding-top:12px"><strong>' . $phrase['_item_must_be_returned_within'] . '</strong><div class="gray">' . $phrase['_specify_your_return_policy_in_days_a_buyer_has_to_return_the_item'] . '</div></div>
                <div><select name="returnwithin" id="returnwithin" style="font-family: verdana" ' . $dis . '>
                <option value="0" ' . $d0 . '>-</option>
                <option value="3" ' . $d3 . '>3 ' . $phrase['_days'] . '</option>
                <option value="7" ' . $d7 . '>7 ' . $phrase['_days'] . '</option>
                <option value="14" ' . $d14 . '>14 ' . $phrase['_days'] . '</option>
                <option value="30" ' . $d30 . '>30 ' . $phrase['_days'] . '</option>
                <option value="60" ' . $d60 . '>60 ' . $phrase['_days'] . '</option>
                </select></div>
                
                <div style="padding-top:8px"><strong>' . $phrase['_refund_will_be_provided_as'] . '</strong><div class="gray">' . $phrase['_specify_the_type_of_refund_type_the_buyer_will_receive'] . '</div></div>
                <div><select name="returngivenas" id="returngivenas" style="font-family: verdana" ' . $dis . '>
                <option value="" ' . $e0 . '>-</option>
                <option value="exchange" ' . $e1 . '>' . $phrase['_exchange'] . '</option>
                <option value="credit" ' . $e2 . '>' . $phrase['_credit'] . '</option>
                <option value="moneyback" ' . $e3 . '>' . $phrase['_moneyback'] . '</option>
                </select></div>
                
                <div style="padding-top:8px"><strong>' . $phrase['_return_shipping_paid_by'] . '</strong><div class="gray">' . $phrase['_please_decide_who_will_pay_for_return_shipping_costs'] . '</div></div>
                <div><label for="returnshippaidby1"><input type="radio" name="returnshippaidby" id="returnshippaidby1" value="buyer" ' . $returnship1 . ' ' . $dis . ' /> ' . $phrase['_buyer'] . '</label></div>
                <div><label for="returnshippaidby2"><input type="radio" name="returnshippaidby" id="returnshippaidby2" value="seller" ' . $returnship2 . ' ' . $dis . ' /> ' . $phrase['_seller'] . '</label></div>
                
                <div style="padding-top:8px"><strong>' . $phrase['_return_policy_details'] . '</strong></div>
                <div class="ilance_wysiwyg">
                <table cellpadding="0" cellspacing="0" border="0" width="580">
                <tr>
                <td class="wysiwyg_wrapper" align="right" height="25">

                        <table cellpadding="0" cellspacing="0" border="0" width="100%">
                        <tr>
                                <td width="100%" align="left" class="smaller">' . $phrase['_plain_text_only_bbcode_is_currently_not_in_use_for_this_field'] . '</td>
                                <td>
                                                <div class="wysiwygbutton"><a href="javascript:void(0)" onclick="return construct_textarea_height(\'returnpolicy\', -100)"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'wysiwyg/resize_0.gif" width="21" height="9" alt="' . $phrase['_decrease_size'] . '" border="0" /></a></div>
                                                <div class="wysiwygbutton"><a href="javascript:void(0)" onclick="return construct_textarea_height(\'returnpolicy\', 100)"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'wysiwyg/resize_1.gif" width="21" height="9" alt="' . $phrase['_increase_size'] . '" border="0" /></a></div>
                                </td>
                                <td style="padding-right:15px"></td>
                        </tr>
                        </table>
                </td>
                </tr>
                        <tr>
                                <td><textarea name="returnpolicy" id="returnpolicy" style="width:580px; height:84px; padding:8px; font-family: verdana;" wrap="physical" class="wysiwyg" ' . $dis . '>' . $returnpolicy . '</textarea></td>
                        </tr>
                </table>
                </div>
                </div>
                </div>';
                
                return $html;
        }
        
        /**
        * Function to print the list of shipping partners
        *
        * @return      string      
        */
        function print_shipping_partners()
        {
                global $ilance, $phrase, $ilconfig;
                
                $html = '';
                
                $sql = $ilance->db->query("
                        SELECT shipperid, title
                        FROM " . DB_PREFIX . "shippers
                        ORDER BY shipperid ASC
                ");
                if ($ilance->db->num_rows($sql) > 0)
                {
                        $html = '<div style="padding-top:7px"><strong>' . $phrase['_shipping_partner'] . '</strong></div>';
                        $html .= '<div class="gray" style="padding-bottom:4px">' . $phrase['_if_you_are_physically_shipping_this_item_please_select_your_preferred_shipping_partner'] . '</div>';
                        $html .= '<select name="ship_shipperid" id="ship_shipperid" style="font-family: verdana">';
                        $html .= '<option value="">-</option>';
                        
                        while ($res = $ilance->db->fetch_array($sql))
                        {
                                if (isset($ilance->GPC['ship_shipperid']) AND $ilance->GPC['ship_shipperid'] > 0 AND $res['shipperid'] == $ilance->GPC['ship_shipperid'])
                                {	
                                        $html .= '<option value="' . $res['shipperid'] . '" selected="selected">' . $res['title'] . '</option>';
                                }
                                else
                                {
                                        $html .= '<option value="' . $res['shipperid'] . '">' . $res['title'] . '</option>';
                                }
                        }
                        
                        $html .= '</select>';
                }
                
                return $html;
        }
        
        /**
        * Function to fetch the number of filters available for displaying within the auction posting interface.
        *
        * @param       integer      category id   
        *
        * @return      integer      return the count amount
        */
        function get_filters_quantity($cid = 0)
        {
                global $ilance, $show;
                
                $qty = 0;
                $show['advanced_profile_filters'] = false;
                
        	$sql = $ilance->db->query("
                        SELECT *
                        FROM " . DB_PREFIX . "profile_questions
                        WHERE filtercategory = '" . intval($cid) . "'
                                AND visible = '1'
                                AND isfilter = '1'
                ");
                if ($ilance->db->num_rows($sql) > 0)
                {
                	$qty = 1;
                        $show['advanced_profile_filters'] = true;
                }
                
		return $qty;
        }
        
        /**
        * Function to print the auction preview
        *
        * @return      string      
        */
        function print_auction_preview()
        {
                global $ilance;
                
                $html = '<div style="padding-bottom:7px"><iframe name="preview_iframe" id="preview_iframe" width="99.5%" scrolling-bottom="yes" border="0" frameborder="0" class="" style="height:320px; border-top:1px solid blue; border-left:1px solid blue; border-right:1px solid blue; border-bottom:1px solid blue" src="{https_server}ajax.php?do=previewlisting&mode=service"></iframe></div>';
                $html = '';
                
                return $html;
        }
        
        /**
        * Function to print the javascript on this form
        *
        * @return      string      
        */
        function print_js($cattype = '')
        {
                global $ilconfig;
                
                $js_start = '';
                
                if ($cattype == 'service')
                {
                        $js_start = '
<script language="javascript">
<!--
function validate_title(f)
{
        haveerrors = 0;
        
        if (fetch_js_object(\'project_title\').value == \'\')
        {
                haveerrors = 1;
                
                showImage("project_titleerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true);
                alert(phrase[\'_please_enter_a_title_for_this_listing\']);
                return(false);
        }
        else
        {
                showImage("project_titleerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);                
                return(true);
        }
}

function validate_message()
{
        fetch_bbeditor_data();
        
        if (fetch_js_object(\'bbcode_holder\').value == \'\')
        {
                alert(phrase[\'_please_enter_a_description_for_your_listing\']);
                return(false);        
        }
        return(true);
}

function validate_payment_method(f)
{	
        if (';
                        if ($ilconfig['escrowsystem_enabled'])
                        {
                                $js_start .= 'fetch_js_object(\'enableescrow2\').checked == true && ';
                        }
                        
                        $js_start .= 'fetch_js_object(\'paymethod\').value == \'\') 
        {
                alert(phrase[\'_you_have_selected_that_you_will_do_business_outside_the_marketplace\']);
                return(false);
        }
        
        return(true);
}

function validate_all()
{	
        return validate_title() && validate_message() && validatecustomform() && validate_payment_method();
}
//-->
</script>';        
                }
                else if ($cattype == 'product')
                {
                        $js_start = '
<script language="javascript">
<!--
function validate_title()
{
        haveerrors = 0;
        
        if (fetch_js_object(\'project_title\').value == \'\')
        {
                haveerrors = 1;
                
                showImage("project_titleerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true);
                alert(phrase[\'_please_enter_a_title_for_this_listing\']);
                return(false);
        }
        else
        {
                showImage("project_titleerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);                
                return(true);
        }
}

function validate_message()
{
        fetch_bbeditor_data();
        
        if (fetch_js_object(\'bbcode_holder\').value == \'\')
        {
                alert(phrase[\'_please_enter_a_description_for_your_listing\']);
                return(false);        
        }
        return(true);
}

function validate_selling_format()
{
        var Chars = "0123456789.,";
        haveerrors = 0;
        
        if (fetch_js_object(\'unique\').checked && fetch_js_object(\'unique\').value == \'unique\')
        {
                return(true);	
        }
        else
        {
                if (fetch_js_object(\'filtered_auctiontype\').checked && fetch_js_object(\'filtered_auctiontype\').value == \'regular\') 
                {
                        if (fetch_js_object(\'startprice\').value == \'\' || fetch_js_object(\'startprice\').value <= \'0\')
                        {
                                alert(phrase[\'_you_must_enter_the_starting_bid_price_for_your_item\']);
                                return(false);
                        }
                        
                        if (fetch_js_object(\'startprice\').value > 0 && fetch_js_object(\'reserve_price\').value != \'\' && fetch_js_object(\'reserve_price\').value > 0)
                        {
                                if (fetch_js_object(\'startprice\').value >= fetch_js_object(\'reserve_price\').value)
                                {
                                        alert(phrase[\'_your_reserve_price_cannot_be_less_or_equal\']);
                                        return(false);
                                }
                        }
                        
                        if (fetch_js_object(\'buynow_qty\').value == \'\' || fetch_js_object(\'buynow_qty\').value <= \'0\')
                        {
                                alert(phrase[\'_you_must_enter_the_qty_available_for_your_buy_now_item\']);
                                return(false);
                        }
                        
                        for (var i = 0; i < fetch_js_object(\'startprice\').value.length; i++)
                        {
                                if (Chars.indexOf(fetch_js_object(\'startprice\').value.charAt(i)) == -1)
                                {
                                        alert(phrase[\'_invalid_currency_characters_only_numbers_and_a_period_are_allowed_in_this_field\']);
                                        haveerrors = 1;
                                }
                        }
                        
                        return(!haveerrors);                                
                }
                
                if (fetch_js_object(\'filtered_auctiontype0\').checked && fetch_js_object(\'filtered_auctiontype0\').value == \'fixed\') 
                {
                        if (fetch_js_object(\'buynow_price_fixed\').value == \'\' || fetch_js_object(\'buynow_price_fixed\').value <= \'0\')
                        {
                                alert(phrase[\'_you_must_enter_a_buy_now_price_for_your_item\']);
                                return(false);
                        }
                        
                        if (fetch_js_object(\'buynow_qty_fixed\').value == \'\' || fetch_js_object(\'buynow_qty_fixed\').value <= \'0\')
                        {
                                alert(phrase[\'_you_must_enter_the_qty_available_for_your_buy_now_item\']);
                                return(false);
                        }
                        
                        for (var i = 0; i < fetch_js_object(\'buynow_price\').value.length; i++)
                        {
                                if (Chars.indexOf(fetch_js_object(\'buynow_price_fixed\').value.charAt(i)) == -1)
                                {
                                        alert(phrase[\'_invalid_currency_characters_only_numbers_and_a_period_are_allowed_in_this_field\']);
                                        haveerrors = 1;
                                }
                        }
                        
                        return(!haveerrors);
                }
        }
        
        return(true);
}

function validate_bid_filters()
{	
        if (fetch_js_object(\'filter_city\').checked && fetch_js_object(\'filtered_city\').value == \'\') 
        {
                alert(phrase[\'_you_currently_have_city_town_filter_enabled_checkbox_is_on\']);
                return(false);
        }
        
        if (fetch_js_object(\'filter_zip\').checked && fetch_js_object(\'filtered_zip\').value == \'\') 
        {
                alert(phrase[\'_you_currently_have_zip_postal_code_filter_enabled_checkbox_is_on\']);
                return(false);
        }
        
        return(true);
}

function validate_shipping()
{
        if (fetch_js_object(\'ship_handling\')[2].selected == true && fetch_js_object(\'ship_costs\').value <= \'0\') 
        {
                alert(phrase[\'_you_have_selected_that_the_shipping_cost_will_be_a_fixed_flat_rate\']);
                return(false);
        }
        
        if (fetch_js_object(\'ship_handling\')[2].selected == true && fetch_js_object(\'ship_costs\').value == \'\') 
        {
                alert(phrase[\'_you_have_selected_that_the_shipping_cost_will_be_a_fixed_flat_rate\']);
                return(false);
        }
        
        if (fetch_js_object(\'ship_country\')[2].selected == true && fetch_js_object(\'ship_countries\').value == \'\' && fetch_js_object(\'ship_handling\')[3].selected == false) 
        {
                alert(phrase[\'_you_have_selected_that_you_will_ship_to_certain_countries\']);
                return(false);
        }
        
        if (fetch_js_object(\'ship_country\')[0].selected == true && fetch_js_object(\'ship_shipperid\').value == \'\' && fetch_js_object(\'ship_handling\')[3].selected == false) 
        {
                alert(phrase[\'_you_have_selected_that_you_will_be_shipping_worldwide_but_forgot\']);
                return(false);
        }
        
        if (fetch_js_object(\'ship_country\')[2].selected == true && fetch_js_object(\'ship_shipperid\').value == \'\' && fetch_js_object(\'ship_handling\')[3].selected == false) 
        {
                alert(phrase[\'_you_have_selected_that_you_will_be_shipping_worldwide_but_forgot\']);
                return(false);
        }
        
        return(true);
}

function validate_return_policy()
{
        if (fetch_js_object(\'returnaccepted1\').checked == true && fetch_js_object(\'returnwithin\').value <= \'0\') 
        {
                alert(\'You have enabled a return policy for this listing but did not specify how many days a buyer has to return the item.  Please retry by selecting an option from the pulldown.\');
                return(false);
        }
        
        if (fetch_js_object(\'returnaccepted1\').checked == true && fetch_js_object(\'returngivenas\').value == \'\') 
        {
                alert(\'You have enabled a return policy for this listing but did not specify the refund or exchange type.  Please retry by selecting an option from the pulldown.\');
                return(false);
        }
        
        if (fetch_js_object(\'returnaccepted1\').checked == true && fetch_js_object(\'returnpolicy\').value == \'\') 
        {
                alert(\'You have enabled a return policy for this listing but did not provide your return policy instruction message.  In order for buyers to learn about your return policy you must describe it in full.  Please retry.\');
                return(false);
        }
        
        return(true);
}

function validate_payment_method()
{	
        if (';
                        
                        if ($ilconfig['escrowsystem_enabled'])
                        {
                                $js_start .= 'fetch_js_object(\'enableescrow2\').checked == true && ';
                        }
                        
                        $js_start .= 'fetch_js_object(\'paymethod\').value == \'\') 
        {
                alert(phrase[\'_you_have_selected_that_you_will_do_business_outside_the_marketplace\']);
                return(false);
        }
        
        return(true);
}

function validate_all()
{	
        return validate_message() && validate_title() && validate_selling_format() && validate_payment_method() && validatecustomform() && validate_shipping() && validate_bid_filters() && validate_return_policy();
}
//-->
</script>
';        
                }
                
                return $js_start;
        }
        
        /**
        * Function to handle the revision log changes made to an auction event
        *
        * @param       string        category type (service or product)
        * @param       string        extra data to append
        *
        * @return      string      
        */
        function handle_revision_log_changes($cattype = 'service', $appendextra = '')
        {
                global $ilance, $phrase;
                
                $fieldphrases = array(
                        'project_title' => '_title',
                        'description' => '_description',
                        'bbcode_holder' => '_description',
                        'additional_info' => '_additional_information',
                        'keywords' => '_keywords',
                        'bold' => '_bold',
                        'highlite' => '_listing_highlight',
                        'featured' => '_featured',
                        'filter_escrow' => '_escrow',
                        'paymethod' => '_pay_method',
                        'project_details' => '_event_access',
                        'bid_details' => '_bidding_privacy',
                        'filter_publicboard' => '_public_message_board',
                        'filtered_budgetid' => '_budget',
                        'filtered_auctiontype' => '_selling_format',
                        'ship_handling' => '_shipping_and_handling',
                        'ship_country' => '_countries_item_can_ship_to',
                        'ship_costs' => '_shipping_costs',
                        'ship_shipperid' => '_shipping_partner',
                        'reserve' => '_reserve',
                        'reserve_price' => '_reserve_price',
                        'startprice' => '_starting_price',
                        'buynow_price' => '_buy_now_price',
                        'buynow_qty' => '_qty',
                        'buynow_price_fixed' => '_buy_now_price',
                        'buynow_qty_fixed' => '_qty',
                        'retailprice' => '_retail_price',
                        'returngivenas' => '_refund_will_be_provided_as',
                        'returnaccepted' => '_returns_accepted',
                        'returnwithin' => '_item_must_be_returned_within',
                        'returnshippaidby' => '_return_shipping_paid_by',
                        'returnpolicy' => '_return_policy',
                );
                
                if ($cattype == 'service')
                {
                        $updatefields = array('custom','project_title','description','additional_info','keywords','bold','highlite','featured','filter_escrow','paymethod','project_details','bid_details','filter_publicboard','filtered_budgetid');
                }
                else if ($cattype == 'product')
                {
                        $updatefields = array('custom','startprice','reserve','reserve_price','buynow_price_fixed','buynow_price','buynow_qty_fixed','buynow_qty','retailprice','project_title','description','keywords','bold','highlite','featured','filter_escrow','paymethod','project_details','bid_details','filter_publicboard','ship_handling','ship_country','ship_costs','ship_shipperid','filtered_auctiontype','returnaccepted','returnwithin','returngivenas','returnshippaidby','returnpolicy');
                }
                
                $log = '';
                foreach ($updatefields AS $key)
                {
                        if ($key == 'description')
                        { // we need this here because of our custom wysiwyg editor moving text into hidden div called 'bbcode_holder' for posting
                                if (isset($ilance->GPC['old'][$key]) AND isset($ilance->GPC['bbcode_holder']) AND trim($ilance->GPC['old'][$key]) != trim($ilance->GPC['bbcode_holder']))
                                {
                                        $log .= '<div><strong>' . $phrase[$fieldphrases[$key]] . '</strong></div><div style="padding-top:3px">' . $phrase['_from'] . ': <span class="gray">' . $ilance->GPC['old'][$key] . '</span> <br /><br />' . $phrase['_to_upper'] . ': ' . $ilance->GPC['bbcode_holder'] . '</div><hr size="1" width="100%" style="color:#cccccc" />';
                                }
                        }
                        else if ($key == 'buynow_price_fixed')
                        {
                                if (isset($ilance->GPC['old'][$key]) AND isset($ilance->GPC['buynow_price']) AND $ilance->GPC['old'][$key] != $ilance->GPC['buynow_price'])
                                {
                                        $log .= '<div><strong>' . $phrase[$fieldphrases[$key]] . '</strong></div><div style="padding-top:3px">' . $phrase['_from'] . ': <span class="gray">' . $ilance->GPC['old'][$key] . '</span> ' . $phrase['_to_upper'] . ': ' . $ilance->GPC['buynow_price'] . '</div><hr size="1" width="100%" style="color:#cccccc" />';
                                }
                        }
                        else if ($key == 'buynow_qty_fixed')
                        {
                                if (isset($ilance->GPC['old'][$key]) AND isset($ilance->GPC['buynow_qty']) AND $ilance->GPC['old'][$key] != $ilance->GPC['buynow_qty'])
                                {
                                        $log .= '<div><strong>' . $phrase[$fieldphrases[$key]] . '</strong></div><div style="padding-top:3px">' . $phrase['_from'] . ': <span class="gray">' . $ilance->GPC['old'][$key] . '</span> ' . $phrase['_to_upper'] . ': ' . $ilance->GPC['buynow_qty'] . '</div><hr size="1" width="100%" style="color:#cccccc" />';
                                }
                        }
                        else if ($key == 'filter_escrow')
                        {
                                if (isset($ilance->GPC['old'][$key]) AND isset($ilance->GPC[$key]) AND $ilance->GPC['old'][$key] != $ilance->GPC[$key])
                                {
                                        $log .= '<div><strong>' . $phrase[$fieldphrases[$key]] . '</strong></div><div style="padding-top:3px">' . $phrase['_from'] . ': <span class="gray">' . print_boolean($ilance->GPC['old'][$key]) . '</span> ' . $phrase['_to_upper'] . ': ' . print_boolean($ilance->GPC[$key]) . '</div><hr size="1" width="100%" style="color:#cccccc" />';
                                }        
                        }
                        else if ($key == 'ship_handling')
                        {
                                if (isset($ilance->GPC['old'][$key]) AND isset($ilance->GPC[$key]) AND $ilance->GPC['old'][$key] != $ilance->GPC[$key])
                                {
                                        $log .= '<div><strong>' . $phrase[$fieldphrases[$key]] . '</strong></div><div style="padding-top:3px">' . $phrase['_from'] . ': <span class="gray">' . print_boolean($ilance->GPC['old'][$key]) . '</span> ' . $phrase['_to_upper'] . ': ' . print_boolean($ilance->GPC[$key]) . '</div><hr size="1" width="100%" style="color:#cccccc" />';
                                }        
                        }
                        else if ($key == 'ship_shipperid')
                        {
                                if (isset($ilance->GPC['old'][$key]) AND isset($ilance->GPC[$key]) AND $ilance->GPC['old'][$key] != $ilance->GPC[$key])
                                {
                                        $from = $ilance->db->fetch_field(DB_PREFIX . "shippers", "shipperid = '" . intval($ilance->GPC['old'][$key]) . "'", "title");
                                        if (empty($from))
                                        {
                                                $from = $phrase['_none'];
                                        }
                                        $to = $ilance->db->fetch_field(DB_PREFIX . "shippers", "shipperid = '" . intval($ilance->GPC[$key]) . "'", "title");
                                        if (empty($to))
                                        {
                                                $to = $phrase['_none'];
                                        }
                                        $log .= '<div><strong>' . $phrase[$fieldphrases[$key]] . '</strong></div><div style="padding-top:3px">' . $phrase['_from'] . ': <span class="gray">' . $from . '</span> ' . $phrase['_to_upper'] . ': ' . $to . '</div><hr size="1" width="100%" style="color:#cccccc" />';
                                        
                                        unset($from, $to);
                                }        
                        }
                        else if ($key == 'filter_publicboard')
                        {
                                if (isset($ilance->GPC['old'][$key]) AND isset($ilance->GPC[$key]) AND $ilance->GPC['old'][$key] != $ilance->GPC[$key])
                                {
                                        $log .= '<div><strong>' . $phrase[$fieldphrases[$key]] . '</strong></div><div style="padding-top:3px">' . $phrase['_from'] . ': <span class="gray">' . print_boolean($ilance->GPC['old'][$key]) . '</span> ' . $phrase['_to_upper'] . ': ' . print_boolean($ilance->GPC[$key]) . '</div><hr size="1" width="100%" style="color:#cccccc" />';
                                }        
                        }
                        else if ($key == 'returnwithin')
                        {
                                if (isset($ilance->GPC['old'][$key]) AND isset($ilance->GPC[$key]) AND $ilance->GPC['old'][$key] != $ilance->GPC[$key])
                                {
                                        $log .= '<div><strong>' . $phrase[$fieldphrases[$key]] . '</strong></div><div style="padding-top:3px">' . $phrase['_from'] . ': <span class="gray">' . intval($ilance->GPC['old'][$key]) . ' ' . $phrase['_days'] . '</span> ' . $phrase['_to_upper'] . ': ' . intval($ilance->GPC[$key]) . ' ' . $phrase['_days'] . '</div><hr size="1" width="100%" style="color:#cccccc" />';
                                }        
                        }
                        else if ($key == 'returngivenas' OR $key == 'returnshippaidby')
                        {
                                if (isset($ilance->GPC['old'][$key]) AND isset($ilance->GPC[$key]) AND $ilance->GPC['old'][$key] != $ilance->GPC[$key])
                                {
                                        $log .= '<div><strong>' . $phrase[$fieldphrases[$key]] . '</strong></div><div style="padding-top:3px">' . $phrase['_from'] . ': <span class="gray">' . $phrase["_" . $ilance->GPC['old'][$key]] . '</span> ' . $phrase['_to_upper'] . ': ' . $phrase["_" . $ilance->GPC[$key]] . '</div><hr size="1" width="100%" style="color:#cccccc" />';
                                }        
                        }
                        else if ($key == 'custom')
                        {
                                //if (isset($ilance->GPC['old'][$key]) AND $ilance->GPC['old'][$key] != $ilance->GPC[$key])
                                //{
                                        //$log .= '<div><strong>' . $phrase[$fieldphrases[$key]] . '</strong></div><div style="padding-top:3px">' . $phrase['_from'] . ': <span class="gray">' . print_boolean($ilance->GPC['old'][$key]) . '</span> ' . $phrase['_to_upper'] . ': ' . print_boolean($ilance->GPC[$key]) . '</div><hr size="1" width="100%" style="color:#ebebeb" />';
                                //}        
                        }
                        else
                        {
                                if (isset($ilance->GPC['old'][$key]) AND isset($ilance->GPC[$key]) AND $ilance->GPC['old'][$key] != $ilance->GPC[$key])
                                {
                                        $log .= '<div><strong>' . $phrase[$fieldphrases[$key]] . '</strong></div><div style="padding-top:3px">' . $phrase['_from'] . ': <span class="gray">' . $ilance->GPC['old'][$key] . '</span> ' . $phrase['_to_upper'] . ': ' . $ilance->GPC[$key] . '</div><hr size="1" width="100%" style="color:#cccccc" />';
                                }
                        }
                }
                
                if (!empty($log))
                {
                        // remove trailing <hr>
                        $log = mb_substr($log, 0, -50);
                        
                        $ilance->db->query("
                                INSERT INTO " . DB_PREFIX . "projects_changelog
                                (id, project_id, datetime, changelog)
                                VALUES(
                                NULL,
                                '" . intval($ilance->GPC['rfpid']) . "',
                                '" . DATETIME24H . "',
                                '" . $ilance->db->escape_string($log) . "')
                        ");
                }
        }
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: class.auction_post.inc.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>