<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

/**
* BBCode class to perform the majority of BBcode functions within ILance
*
* @package      iLance
* @version	$Revision: 1.0.0 $
* @author       ILance
*/
class bbcode
{
        /**
        * BBCode Constructor.
        */
        function bbcode()
        {            
        }
        
        /**
        * Function to convert a string formatted in BBCode [B]xx[/B] into HTML format <strong>xx</strong>.
        *
        * @param       string       text
        * @param       boolean      do amperstand & conversion? ie: & = &amp; (default false)
        *
        * @return      string       Converted BBcode [B]xx[/B] to HTML -> <strong>xx</strong>
        */
        function bbcode_to_html($text = '', $doamperstand = false)
        {
                global $ilance;
                
                if ($doamperstand)
                {
                        // if we don't do this, auction descriptions show like &amp;#1239; vs. &#1239;
                        $patterns[] = "#&#";
                        $replacements[] = '&amp;';
                }
                
                ($apihook = $ilance->api('bbcode_to_html_start')) ? eval($apihook) : false;
                
                $patterns[] = "#<#";
                $replacements[] = '&lt;';
                
                $patterns[] = "#>#";
                $replacements[] = '&gt;';
                
                $patterns[] = "#  #si";
                $replacements[] = '&nbsp;&nbsp;';
                
                $patterns[] = "#\t#si";
                $replacements[] = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
                
                $patterns[] = "#\r\n#si";
                $replacements[] = "<br />";
                
                $patterns[] = "#\n#si";
                $replacements[] = "<br />";
                
                $patterns[] = "#\[hr\]#si";
                $replacements[] = "<hr class=HR_Color />";	
                
                $patterns[] = "#\[table\]#si";
                $replacements[] = '<table cellpadding="6" cellspacing="1" align="center" style="border-collapse: collapse; border-spacing: 0px; border: 1px solid #ebebeb; background-color: #fff; width: 98%; font-family: verdana,arial,sans-serif,tahoma; font-size: 12px; color: black;">';
                $patterns[] = "#\[\/table\]#si";
                $replacements[] = '</table>';
                $patterns[] = "#\[td\]#si";
                $replacements[] = '<td style="height: 25px; border: 1px solid #ebebeb">';
                $patterns[] = "#\[\/td\]#si";
                $replacements[] = '</td>';
                $patterns[] = "#\[tr\]#si";
                $replacements[] = '<tr>';
                $patterns[] = "#\[\/tr\]#si";
                $replacements[] = '</tr>';
                
                $patterns[] = "#\[p\]#si";
                $replacements[] = "<p>";
                
                $patterns[] = "#\[\/p\]#si";
                $replacements[] = "</p>";
                
                $patterns[] = "#\[(indent|blockquote)\]#si";
                $replacements[] = "<blockquote>";
                
                $patterns[] = "#\[\/(indent|blockquote)\]#si";
                $replacements[] = "</blockquote>";
                
                $patterns[] = "#\[(\/|)sub\]#si";
                $replacements[] = "<$1sub>";
                
                $patterns[] = "#\[(\/|)sup\]#si";
                $replacements[] = "<$1sup>";
                
                $patterns[] = "#\[(\/|)strike\]#si";
                $replacements[] = "<$1strike>";
                
                $patterns[] = "#\[(\/|)u\]#si";
                $replacements[] = "<$1u>";
                
                $patterns[] = "#\[(\/|)b\]#si";
                $replacements[] = "<$1strong>";
                
                $patterns[] = "#\[(\/|)i\]#si";
                $replacements[] = "<$1em>";
                
                $patterns[] = "#\[size=1\]#si";
                $replacements[] = '<span style="font-size: 8pt">';
                $patterns[] = "#\[size=2\]#si";
                $replacements[] = '<span style="font-size: 10pt">';
                $patterns[] = "#\[size=3\]#si";
                $replacements[] = '<span style="font-size: 12pt">';
                $patterns[] = "#\[size=4\]#si";
                $replacements[] = '<span style="font-size: 14pt">';
                $patterns[] = "#\[size=5\]#si";
                $replacements[] = '<span style="font-size: 18pt">';
                $patterns[] = "#\[size=6\]#si";
                $replacements[] = '<span style="font-size: 24pt">';
                $patterns[] = "#\[size=7\]#si";
                $replacements[] = '<span style="font-size: 36pt">';
                
                $patterns[] = "#\[font=(.*?)\]#si";
                $replacements[] = '<span style="font-family: $1">';
                
                $patterns[] = "#\[color=(.*?)\]#si";
                $replacements[] = '<span style="color: $1">';
                
                $patterns[] = "#\[highlight=(.*?)\]#si";
                $replacements[] = '<span style="background-color: $1">';
                
                $patterns[] = "#\[\/(font|color|size|highlight)\]#si";
                $replacements[] = '</span>';
                
                $patterns[] = "#\[(center|left|right|justify)\]#si";
                $replacements[] = "<div align=\"$1\">";
                
                $patterns[] = "#\[\/(center|left|right|justify)\]#si";
                $replacements[] = "</div>";
                
                $patterns[] = "#\[email=(.*?)\]#si";
                $replacements[] = '<a href="mailto:$1">';
                $patterns[] = "#\[email\](.*?)\[\/email\]#si";
                $replacements[] = '<a href="mailto:$1">$1[/email]';
                
                $patterns[] = "#\[url=(.*?)\]#si";
                $replacements[] = '<a href="$1">';
                $patterns[] = "#\[url\](.*?)\[\/url\]#si";
                $replacements[] = '<a href="$1">$1[/url]';
                
                $patterns[] = "#\[\/(email|url)\]#si";
                $replacements[] = "</a>";
                
                $patterns[] = "#\[img\](.*?)\[\/img\]#si";
                $replacements[] = '<img src="$1" alt="" />';
                
                $patterns[] = "#\[list=1\]#si";
                $replacements[] = "<ol>";
                
                $patterns[] = "#\[list\]#si";
                $replacements[] = "<ul>";
                
                $patterns[] = "#\[\*\]#si";
                $replacements[] = "<li>";
                
                $patterns[] = "#<br[^>]*><li>#si";
                $replacements[] = "<li>";
                
                $patterns[] = "#<br[^>]*> <li>#si";
                $replacements[] = "<li>";
                
                $patterns[] = "#<br[^>]*><\/li>#si";
                $replacements[] = "</li>";
                
                $patterns[] = "#\[\/list\]#si";
                $replacements[] = '</list>';
                
                $patterns[] = "#\[FLASH=(.*?),(.*?)\](.*?)\[\/FLASH\]#si";
                $replacements[] = '<object width="$1" height="$2"><param name="movie" value="$3"></param><param name="wmode" value="transparent"></param><embed src="$3" type="application/x-shockwave-flash" wmode="transparent" width="$1" height="$2"></embed></object>';
                
                $text = preg_replace($patterns, $replacements, $text);
                
                if (preg_match("/<ol/si", $text) OR preg_match("/<ul/si", $text))
                {
                        $array = mb_split("<", $text);
                        $output = "";
                        $x = 0;
                        foreach($array as $line)
                        {
                                if ($x > 0) $line = "<" . $line;
                                if (preg_match("/<ol/i", $line))
                                {
                                        $temp = "</ol>";
                                }
                                else if (preg_match("/<ul/i", $line))
                                {
                                        $temp = "</ul>";
                                }
                                if (preg_match("/<\/list>/i", $line))
                                {
                                        $line = str_replace("</list>", $temp, $line);
                                }                                
                                $output .= $line;
                                $x++;
                        }
                }
                else
                {
                        $output = $text;
                }
                
                $output = str_replace("<li>", "</li><li>", $output);
                $output = str_replace("<ul></li>", "<ul>", $output);
                $output = str_replace("<ol></li>", "<ol>", $output);
                $output = str_replace("</ul>", "</li></ul>", $output);
                $output = str_replace("</ol>", "</li></ol>", $output);
                
                ($apihook = $ilance->api('bbcode_to_html_end')) ? eval($apihook) : false;
                
                return $output;
        }
        
        /**
        * Function to strip out any special tags we provide the function and then have them replaced at the very end.  This is useful
        * for stripping out [PHP]xxxx[/PHP] tags so we don't process anything within the [PHP]..[/PHP] tags and other situations that may arise.
        *
        * @param       string       tag to strip (example: PHP)
        * @param       string       text
        * @param       array        matches text
        *
        * @return      string       HTML formatted string
        */
        function strip_special_codes($tag = '', &$text, &$matches)
        {
                preg_match_all("'\[$tag.*\](.*)\[/$tag\]'isU", $text, $matches);
                
                for ($i = 0; $i < count($matches[0]); $i++)
                {
                        $text = str_replace($matches[0][$i], "~~$tag~~$i~~$tag~~", $text);
                }
        }
        
        /**
        * Function to restore any stripped out special tags.
        *
        * @param       string       tag to restore (example: PHP)
        * @param       array        text
        * @param       array        matches text
        * 
        *
        * @return      string       HTML formatted string
        */
        function restore_special_codes($tag = '', &$text, &$matches)
        {
                for ($i = 0; $i < count($matches[0]); $i++)
                {
                        $text = str_replace("~~$tag~~$i~~$tag~~", $matches[0][$i], $text);
                }
        }
        
        /**
        * Function to prepare special tags supplied to the function along with any text ready for dispatching email.
        *
        * @param       string       tag to match
        * @param       string       text
        *
        * @return      string       HTML formatted string
        */
        function prepare_special_codes($tag = '', $html = '')
        {
                preg_match_all("'\[$tag.*\](.*)\[/$tag\]'isU", $html, $matches);
                
                for ($i = 0; $i < count($matches[0]); $i++)
                {
                        $html = str_replace($matches[0][$i], "***$i***", $html);
                        $matches[0][$i] = nl2br(htmlspecialchars(htmlspecialchars($matches[0][$i])));
                        $html = str_replace("***$i***", $matches[0][$i], $html);
                }
                
                return($html);
        }
        
        /**
        * Function to strip out any HTML tags within the supplied text string.
        *
        * @param       array        matches text
        *
        * @return      string       HTML formatted string
        */
        function strip_html_tags($matches = array())
        {
                foreach ($matches as $key => $value)
                {
                        $matches["$key"] = preg_replace("'<[^\?](.*)>'siU", "\n", $value);
                }
        }
        
        /**
        * Function to convert HTML code into BBCode.
        * {@source 16}
        *
        * @param       string       text
        *
        * @return      string       HTML formatted string
        */
        function html_to_bbcode($text = '')
        {
                global $ilance, $myapi, $ilconfig;
                
                $this->strip_special_codes('PHP', $text, $php_matches);
                $this->strip_special_codes('CODE', $text, $code_matches);
                $this->strip_special_codes('HTML', $text, $html_matches);
                $this->strip_special_codes('QUOTE', $text, $quote_matches);
                
                $this->strip_html_tags($php_matches);
                $this->strip_html_tags($code_matches);
                $this->strip_html_tags($html_matches);
                $this->strip_html_tags($quote_matches);
                
                // search all supported html tags to be converted into bbcode
                $search = array(
                        "'<pre>(.*)</pre>'siU",
                        "'<b>(.*)</b>'siU",
                        "'<strong>(.*)</strong>'siU",
                        "'<i>(.*)</i>'siU",
                        "'<em>(.*)</em>'siU",
                        "'<u>(.*)</u>'siU",
                        "'<strike>(.*)</strike>'siU",
                        "'<p align=\"justify\">(.*)</p>'siU",
                        "'<div style=\"text-align: left;\">(.*)</div>'siU",
                        "'<p align=\"left\">(.*)</p>'siU",
                        "'<div style=\"text-align: center;\">(.*)</div>'siU",
                        "'<p align=\"center\">(.*)</p>'siU",
                        "'<div style=\"text-align: right;\">(.*)</div>'siU",
                        "'<p align=\"right\">(.*)</p>'siU",
                        "'<blockquote dir=\"ltr\" style=\"margin-right: 0px\">(.*)</blockquote>'siU",
                        "'<div style=\"margin-left: 40px;\">(.*)</div>'siU",
                        "'<ol>(.*)</ol>'siU",
                        "'<ul>(.*)</ul>'siU",
                        "'<li>(.*)</li>'siU",
                        "'<img(.*)src=\"([^\"]+)\"(.*)>'siU",
                        "'<a href=\"mailto:(.*)\">(.*)</a>'siU",
                        "'<a href=(.*)>(.*)</a>'siU",
                        "'<font size=(.*)>(.*)</font>'siU",
                        "'<font face=(.*) size=(.*)>(.*)</font>'siU",
                        "'<font face=(.*)>(.*)</font>'siU",
                        "'<font color=(.*) size=(.*)>(.*)</font>'siU",
                        "'<font color=(.*)>(.*)</font>'siU",
                        "'<p>(.*)</p>'siU",
                        "'<div>(.*)</div>'siU",
                        "'<p />'siU",
                        "'<(br|br /)>'si",
                        "'<hr />'siU",
                        "'<hr style=\"(.*)\">(.*)'siU",
                        "'<div class=(.*)>(.*)'siU",
                        "'<div class=\"(.*)\">(.*)'siU",
                        "'<h(.*)>(.*)</h(.*)>'siU",
                );
                
                $replace = array(
                        "[PHP]$1[/PHP]",
                        "[B]$1[/B]",
                        "[B]$1[/B]",
                        "[I]$1[/I]",
                        "[I]$1[/I]",
                        "[U]$1[/U]",
                        "[STRIKE]$1[/STRIKE]",
                        "[JUSTIFY]$1[/JUSTIFY]",
                        "[LEFT]$1[/LEFT]",
                        "[LEFT]$1[/LEFT]",
                        "[CENTER]$1[/CENTER]",
                        "[CENTER]$1[/CENTER]",
                        "[RIGHT]$1[/RIGHT]",
                        "[RIGHT]$1[/RIGHT]",
                        "[INDENT]$1[/INDENT]",
                        "[INDENT]$1[/INDENT]",
                        "[list=1]$1[/list]",
                        "[list=a]$1[/list]",
                        "[*]$1",
                        "[IMG]$2[/IMG]",
                        "[EMAIL=\"$1\"]$2[/EMAIL]",
                        "[URL=\"$1\"]$2[/URL]",
                        "[SIZE=\"$1\"]$2[/SIZE]",
                        "[FONT=\"$1\" SIZE=\"$2\"]$3[/FONT]",
                        "[FONT=\"$1\"]$2[/FONT]",
                        "[COLOR=\"$1\" SIZE=\"$2\"]$3[/FONT]",
                        "[COLOR=\"$1\"]$2[/COLOR]",
                        "[P]$1[/P]",
                        "[P]$1[/P]",
                        "",
                        "[BR]",
                        "[HR]",
                        "[HR]",
                        "",
                        "",
                        "[P][B]$2[/B][/P]",
                );
                
                ($apihook = $ilance->api('html_to_bbcode_start')) ? eval($apihook) : false;
                
                $text = preg_replace($search, $replace, $text);
                
                unset($search, $replace);
                
                // find unwanted tags like [P][/P], [B][/B], etc
                $search = array(
                        "[P][/P]",
                        "[B][/B]",
                        "[I][/I]",
                        "[U][/U]",
                        "[STRIKE][/STRIKE]",
                        "[JUSTIFY][/JUSTIFY]",
                        "[LEFT][/LEFT]",
                        "[CENTER][/CENTER]",
                        "[RIGHT][/RIGHT]",
                        "[INDENT][/INDENT]",
                );
                
                $replace = array(
                        "",
                        "",
                        "",
                        "",
                        "",
                        "",
                        "",
                        "",
                        "",
                        "",
                );
                
                ($apihook = $ilance->api('html_to_bbcode_end')) ? eval($apihook) : false;
                
                $text = str_replace($search, $replace, $text);
                unset($search, $replace);
                
                $this->restore_special_codes('QUOTE', $text, $quote_matches);
                $this->restore_special_codes('HTML', $text, $html_matches);
                $this->restore_special_codes('CODE', $text, $code_matches);
                $this->restore_special_codes('PHP', $text, $php_matches);
                
                return $text;
        }
        
        /**
        * Function to strip out any BBCode tags within the supplied text string.
        * {@source 10}
        * 
        * @param       string       text
        * 
        * @return      string       HTML formatted string formatted without any BBCode tags
        * 
        */
        function strip_bb_tags($text = '')
        {
                global $ilconfig;
                
                $this->strip_special_codes('PHP', $text, $php_matches);
                $this->strip_special_codes('CODE', $text, $code_matches);
                $this->strip_special_codes('HTML', $text, $html_matches);
                $this->strip_special_codes('QUOTE', $text, $quote_matches);
                
                $search = array(
                        "'\[B\](.*)\[/B\]'siU",
                        "'\[I\](.*)\[/I\]'siU",
                        "'\[U\](.*)\[/U\]'siU",
                        "'\[STRIKE\](.*)\[/STRIKE\]'siU",
                        "'\[JUSTIFY\](.*)\[/JUSTIFY\]'siU",
                        "'\[LEFT\](.*)\[/LEFT\]'siU",
                        "'\[CENTER\](.*)\[/CENTER\]'siU",
                        "'\[RIGHT\](.*)\[/RIGHT\]'siU",
                        "'\[INDENT\](.*)\[/INDENT\]'siU",
                        "'\[list=1\](.*)\[/list\]'siU",
                        "'\[list=a\](.*)\[/list\]'siU",
                        "'\[\*\]'siU",
                        "'\[IMG\](.*)\[/IMG\]'siU",
                        "'\[EMAIL=(.*)\](.*)\[/EMAIL\]'siU",
                        "'\[URL=(.*)\](.*)\[/URL\]'siU",
                        "'\[FONT=(.*) SIZE=(.*)\](.*)\[/FONT\]'siU",
                        "'\[SIZE=(.*)\](.*)\[/SIZE\]'siU",
                        "'\[FONT=(.*)\](.*)\[/FONT\]'siU",
                        "'\[COLOR=(.*)\](.*)\[/COLOR\]'siU",
                        "'\[P\](.*)\[/P\]'siU",
                        "'\[BR\]'si",
                        "'\[HR\]'si",
                );
                
                $replace = array(
                        "$1",
                        "$1",
                        "$1",
                        "$1",
                        "$1",
                        "$1",
                        "$1",
                        "$1",
                        "$1",
                        "$1",
                        "$1",
                        "\n",
                        "$1",
                        "mailto: $1",
                        "$2 ($1)",
                        "$3",
                        "$2",
                        "$2",
                        "$2",
                        "$1\n",
                        "\n",
                        "**************************************************\n",
                );
                
                $text = preg_replace($search, $replace, $text);
                
                unset($search);
                unset($replace);
                
                $this->restore_special_codes('QUOTE', $text, $quote_matches);
                $this->restore_special_codes('HTML', $text, $html_matches);
                $this->restore_special_codes('CODE', $text, $code_matches);
                $this->restore_special_codes('PHP', $text, $php_matches);
                
                return($text);
        }
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: class.bbcode.inc.php,v $ - $Revision: 2.00 $
|| ####################################################################
\*======================================================================*/
?>