<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

if (!class_exists('categories'))
{
	exit;
}

/**
* Category parser class to perform the majority of category parsing functions within ILance.
*
* @package      iLance
* @version	$Revision: 1.0.0 $
* @author       ILance
*/
class categories_parser extends categories
{
        /**
        * Function to fetch categories recursively
        *
        * @param       integer      parent id
        * @param       integer      level (default 1)
        * @param       string       category type field
        * @param       string       category type
        * @param       string       category database table
        * @param       string       seo category type
        * @param       array        detail page to attach links
        * @param       boolean      show category counters
        * @param       string       short language identifier
        * @param       string       category id field name
        * @param       string       category title
        * @param       boolean      is category map?
        * @param       string       category title style
        * @param       integer      subcategory depth
        * @param       array        category cache (prevents another call to the datastore)
        *
        * @return      string       Returns HTML formatted table with category results
        */
        function fetch_recursive_categories($parentid = 0, $level = 1, $ctypefield = '', $ctype = '', $dbtable = '', $seotype = '', $detailpage = '', $showcount = 1, $slng = 'eng', $cidfield = '', $cidtitle = '', $iscatmap = 0, $titlestyle = '', $subcatdepth = 0, $categorycache = array(), $displaycolumns = 3)
        {
                global $ilance, $myapi, $recursive_html, $ilconfig, $storeid;
                
                //$ilance->timer->start();
                
                $result = $categorycache;
                $this->cats = $result;
                
                $numrows = count($result);
                $divideby = ceil($numrows / $displaycolumns);
                
                if ($level == 1)
                {
                        $recursive_count = 0;
                }
                
                for ($i = 0; $i < $numrows; $i++)
                {
                        if ($this->cats[$i]['visible'])
                        {
                                if ($this->cats[$i]['parentid'] == $parentid)
                                {
                                        if ($level == 1 AND ($recursive_count % $displaycolumns) == 0)
                                        {
                                                $recursive_html .= '<tr><td colspan="' . $displaycolumns . '"><hr size="1" width="100%" style="color:#ebebeb" /></td></tr><tr>';
                                        }
                                        if ($level == 1)
                                        {
                                                $recursive_html .= '<td width="25%" valign="top">';
                                        }
                                        
                                        $catbitcount = ($ilconfig['globalfilters_enablecategorycount'] AND isset($showcount) AND $showcount AND isset($this->cats[$i]['auctioncount'])) ? ' <span class="smaller gray">(' . $this->cats[$i]['auctioncount'] . ')</span>' : '';
                                        if ($level == 1)
                                        {
                                                $recursive_html .= ($ilconfig['globalauctionsettings_seourls']) ? '<div style="padding-top:4px; padding-left:' . $this->fetch_level_padding($level) . 'px"><span style="' . $titlestyle . '" class="blue">' . construct_seo_url($seotype, $this->cats[$i]['cid'], $storeid, stripslashes($this->cats[$i]['title']), $customlink = '', $bold = 1, $searchquestion = '', $questionid = 0, $answerid = 0) . $catbitcount . ' ' . $this->print_category_newicon($this->cats[$i]['cid'], $ctype) . '</span></div>' : '<div style="padding-top:4px; padding-left:' . $this->fetch_level_padding($level) . 'px" class="blue"><a href="' . $detailpage . '?cid=' . $this->cats[$i]['cid'] . '"><span style="' . $titlestyle . '"><strong>' . stripslashes($this->cats[$i]['title']) . '</strong></span></a> ' . $catbitcount . ' ' . $this->print_category_newicon($this->cats[$i]['cid'], $ctype) . '</div>';
                                                if ($ilconfig['globalauctionsettings_catmapgenres'])
                                                {
                                                       $recursive_html .= $this->print_searchable_questions($this->cats[$i]['cid'], $showcount, $level, 0, $forcelinks = true, $this->cats[$i]['cattype'], $this->cats[$i]['title']);
                                                }
                                        }
                                        else if ($level <= $subcatdepth)
                                        {
                                                $recursive_html .= ($ilconfig['globalauctionsettings_seourls']) ? ' <div style="padding-top:4px; padding-left:' . $this->fetch_level_padding($level) . 'px" class="blue">' . construct_seo_url($seotype, $this->cats[$i]['cid'], $storeid, stripslashes($this->cats[$i]['title']), $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) . ' ' . $catbitcount . ' ' . $this->print_category_newicon($this->cats[$i]['cid'], $ctype) . '</div>' : ' <div style="padding-top:4px; padding-left:' . $this->fetch_level_padding($level) . 'px" class="blue"><a href="' . $detailpage . '?cid=' . $this->cats[$i]['cid'] . '">' . stripslashes($this->cats[$i]['title']) . '</a> ' . $catbitcount . ' ' . $this->print_category_newicon($this->cats[$i]['cid'], $ctype) . '</div>';
                                                if ($ilconfig['globalauctionsettings_catmapgenres'] AND $ilconfig['globalauctionsettings_catmapgenredepth'] >= $subcatdepth)
                                                {
                                                       $recursive_html .= $this->print_searchable_questions($this->cats[$i]['cid'], $showcount, $level, $level, $forcelinks = true, $this->cats[$i]['cattype'], $this->cats[$i]['title']);
                                                }
                                        }
                                        
                                        $this->fetch_recursive_categories($this->cats[$i]['cid'], ($level + 1), $ctypefield, $ctype, $dbtable, $seotype, $detailpage, $showcount, $slng, $cidfield, $cidtitle, $iscatmap, $titlestyle, $subcatdepth, $result, $displaycolumns);
                                        
                                        if ($level == 1)
                                        {
                                                $recursive_html .= '</td>';
                                        }
                                        if ($level == 1 AND ($recursive_count % $displaycolumns) == $divideby)
                                        {
                                                $recursive_html .= '</tr>';
                                        }
                                        if ($level == 1)
                                        {
                                                $recursive_count++;
                                        }        
                                }
                        }
                }
                
                //$ilance->timer->stop();
                //DEBUG("fetch_recursive_categories(\$parentid = $parentid) in " . $ilance->timer->get() . " seconds", 'FUNCTION');
        }
        
        /**
	* Function to print the main subcategory columns of a particular category being viewed or selected
	*
	* @param	integer	        number of columns to display (default 1)
	* @param        string          category type (service, product, serviceprovider, portfolio, stores, wantads)
	* @param        bool            show subcategories?
	* @param        string          short language code (default is eng)
	* @param        integer         category id
	* @param        string          extra (optional)
	* @param        boolean         show category counts? (default yes)
	* @param        boolean         showing category map? (default no)
	* @param        string          style css for auction titles (default blank)
	* @param        integer         subcategory depth level to display (default 0 = root)
	* @param        array           category cache (to prevent another db call for categories)
	*/
        function print_subcategory_columns($columns = 1, $cattype = 'service', $dosubcats = 1, $slng = 'eng', $cid = 0, $extra = '', $showcount = 1, $iscatmap = 0, $titlestyle = '', $subcatdepth = 0, $categorycache = array())
        {
                global $ilance, $myapi, $phrase, $ilconfig, $ilpage, $show, $storeid, $storetype, $sqlquery, $categoryfinderhtml, $sqlquery;
                
                $ilance->timer->start();
                
                if ($cattype == 'service' OR $cattype == 'portfolio' OR $cattype == 'serviceprovider' OR $cattype == 'product' OR $cattype == 'stores' OR $cattype == 'storesmain' OR $cattype == 'wantads')
                {
                        // defaults
                        $dbtable = DB_PREFIX . 'categories';
                        $cidfield = 'cid';
                        $cidtitle = "title_$slng";
                        $ctypefield = 'cattype';
                        $counttype = 'auctioncount';
                        $auctionid = 0;
                        $extraquery = '';
                        $show['noquery'] = false;
                        
                        switch ($cattype)
                        {
                                // #### SERVICE ################################
                                case 'service':
                                {
                                        $detailpage = $ilpage['rfp'];
                                        $seotype = ($iscatmap) ? 'servicecatmap' : 'servicecat';
                                        $seotype2 = 'servicecatmap';
                                        $ctype = 'service';
                                        $query = "SELECT * FROM $dbtable WHERE $ctypefield = '$ctype' $extraquery AND visible = '1' ORDER BY sort ASC";
                                        break;        
                                }

                                // #### PRODUCT ################################
                                case 'product':
                                {
                                        $detailpage = $ilpage['merch'];
                                        $seotype = ($iscatmap) ? 'productcatmap' : 'productcat';
                                        $seotype2 = 'productcatmap';
                                        $ctype = 'product';
                                        $query = "SELECT * FROM $dbtable WHERE $ctypefield = '$ctype' $extraquery AND visible = '1' ORDER BY sort ASC";
                                        break;        
                                }
                                
                                // #### EXPERTS ################################
                                case 'serviceprovider':
                                {
                                        $detailpage = $ilpage['members'];
                                        $seotype = 'serviceprovidercat';
                                        $seotype2 = 'serviceprovidercat';
                                        $ctype = 'service';
                                        $query = "SELECT * FROM $dbtable WHERE $ctypefield = '$ctype' $extraquery AND visible = '1' ORDER BY sort ASC";
                                        break;        
                                }
                        
                                // #### PORTFOLIO ##############################
                                case 'portfolio':
                                {
                                        $detailpage = $ilpage['portfolio'];
                                        $seotype = ($iscatmap) ? 'portfoliocatmap' : 'portfoliocat';
                                        $seotype2 = 'portfoliocat';
                                        $ctype = 'service';
                                        $extraquery = "AND portfolio = '1'";
                                        $query = "SELECT * FROM $dbtable WHERE $ctypefield = '$ctype' $extraquery AND visible = '1' ORDER BY sort ASC";
                                        break;        
                                }

                                // #### STORES #################################
                                case 'stores':
                                {
                                        $show['noquery'] = true;
                                        
                                        $detailpage = $ilpage['stores'];
                                        $dbtable = DB_PREFIX . 'stores_category';
                                        //$seotype = ($iscatmap) ? 'storescatmap' : 'storescat';
                                        //$seotype2 = 'storescat';
                                        $seotype = ($iscatmap) ? 'storescatmap' : 'store';
                                        $seotype2 = 'store';
                                        $ctypefield = 'type';
                                        $ctype = $cattype;
                                        $cidtitle = 'category_name';
                                        $counttype = 'itemcount';
                                        $auctionid = intval($ilance->GPC['id']);
                                        //echo $cid. ' - ' . $ilance->GPC['cid'];
                                        //$extraquery = "AND cid = '$cid'";
                                        //$extraquery = "AND (storeid = '" . $auctionid . "' OR cid = '$cid')";
                                        //$query = "SELECT * FROM $dbtable WHERE $ctypefield = '$ctype'  AND visible = '1' ORDER BY sort ASC";
                                        $query = "SELECT * FROM $dbtable WHERE visible = '1' $extraquery ORDER BY sort ASC";
                                        break;        
                                }
                                case 'storesmain':
                                {
                                        $show['noquery'] = true;
                                        
                                        $detailpage = $ilpage['stores'];
                                        $dbtable = DB_PREFIX . 'stores_category';
                                        $seotype = ($iscatmap) ? 'storescatmap' : 'storescat';
                                        $seotype2 = 'storescat';
                                        $ctypefield = 'type';
                                        $ctype = $cattype;
                                        $cidtitle = 'category_name';
                                        $counttype = 'itemcount';
                                        $auctionid = isset($ilance->GPC['id']) ? intval($ilance->GPC['id']) : '';
                                        //$query = "SELECT * FROM $dbtable WHERE $ctypefield = '$ctype' $extraquery AND visible = '1' ORDER BY sort ASC";
                                        $query = "SELECT * FROM $dbtable WHERE visible = '1' AND storeid = '-1' ORDER BY sort ASC";
                                        break;        
                                }
                                // #### WANT ADS ###############################
                                case 'wantads':
                                {
                                        $detailpage = $ilpage['wantads'];
                                        $dbtable = DB_PREFIX . 'wantads_category';
                                        $seotype = ($iscatmap) ? 'wantadscatmap' : 'wantadscat';
                                        $seotype2 = 'wantadscat';
                                        $ctype = 'wantads';
                                        $cidfield = 'cid';
                                        $cidtitle = "title_$slng";
                                        $ctypefield = 'type';
                                        $counttype = 'auctioncount';
                                        //$query = "SELECT * FROM $dbtable WHERE $ctypefield = '$ctype' $extraquery AND visible = '1' ORDER BY sort ASC";
                                        $query = "SELECT * FROM $dbtable WHERE visible = '1' $extraquery ORDER BY sort ASC";
                                        break;        
                                }
                        }    
                }

                switch ($columns)
                {
                        // #### SINGLE COLUMN OUTPUT ###########################
                        case '1':
                        {
                                if (defined('LOCATION') AND LOCATION == 'portfolio')
                                {
                                        // viewing this function from portfolio left nav
                                }
                                else if (defined('LOCATION') AND LOCATION == 'search')
                                {                                        
                                        // viewing this function from search left nav
                                }
                                else if (defined('LOCATION') AND LOCATION == 'stores')
                                {                                        
                                        // viewing this function from stores left nav
                                }
                                else if (defined('LOCATION') AND LOCATION == 'wantads')
                                {                                        
                                        // viewing this function from want ads left nav
                                }

                                $mycats = array();
                                if ($show['noquery'] == false)
                                {
                                        $result = $ilance->db->query($query, 0, null, __FILE__, __LINE__);
                                        while ($row = $ilance->db->fetch_array($result))
                                        {
                                                if ($cattype == 'serviceprovider')
                                                {
                                                        // count providers opt'ed in this category
                                                        $counter = 0;
                                                        $count = $ilance->db->query("
                                                                $sqlquery[select]
                                                                $sqlquery[categories]
                                                                $sqlquery[options]
                                                                $sqlquery[keywords]
                                                                $sqlquery[location]
                                                                $sqlquery[radius]
                                                                $sqlquery[skillsquery]
                                                                $sqlquery[profileanswersquery]
                                                                $sqlquery[pricerange]
                                                                $sqlquery[groupby]
                                                                $sqlquery[orderby]
                                                        ", 0, null, __FILE__, __LINE__);
                                                        if ($ilance->db->num_rows($count) > 0)
                                                        {
                                                                while ($resexclude = $ilance->db->fetch_array($count))
                                                                {
                                                                        // for each user opt'ed, check if they can be listed in search results..
                                                                        if ($ilance->subscription->check_access($resexclude['user_id'], 'searchresults') == 'yes' AND display_profile($resexclude['user_id']))
                                                                        {
                                                                                $counter++;
                                                                        }                                                        
                                                                }
                                                        }
        
                                                        $mycats[] = array(
                                                                'cid' => $row[$cidfield],
                                                                'title' => $row[$cidtitle],
                                                                'parentid' => $row['parentid'],
                                                                'canpost' => $row['canpost'],
                                                                'views' => $row['views'],
                                                                'auctioncount' => $counter,
                                                                'level' => 0
                                                        );
                                                }
                                                else if ($cattype == 'portfolio')
                                                {
                                                        $mycats[] = array(
                                                                'cid' => $row[$cidfield],
                                                                'title' => $row[$cidtitle],
                                                                'parentid' => $row['parentid'],
                                                                'canpost' => $row['canpost'],
                                                                'views' => $row['views'],
                                                                'auctioncount' => $this->fetch_portfolio_count($row[$cidfield]),
                                                                'level' => 0
                                                        );
                                                }
                                                else if ($cattype == 'wantads')
                                                {
                                                        $mycats[] = array(
                                                                'cid' => $row[$cidfield],
                                                                'title' => $row[$cidtitle],
                                                                'parentid' => $row['parentid'],
                                                                'canpost' => $row['canpost'],
                                                                'views' => '0',
                                                                'auctioncount' => $row[$counttype],
                                                                'level' => 0
                                                        );
                                                }
                                                else
                                                {
                                                        $mycats[] = array(
                                                                'cid' => $row[$cidfield],
                                                                'title' => $row[$cidtitle],
                                                                'parentid' => $row['parentid'],
                                                                'canpost' => $row['canpost'],
                                                                'views' => $row['views'],
                                                                'auctioncount' => $row[$counttype],
                                                                'level' => 0
                                                        );    
                                                }
                                        }
        
                                        unset($row);
                                }
                                else
                                {
                                        $mycats = $categorycache[$_SESSION['ilancedata']['user']['slng']]['stores'];         
                                }
                                
                                $this->get_cats($mycats);
                                $catcount = count($this->cats);
                                $this->fetch = $categorycache;
                                
                                $count = $count2 = $thisparentid = 0;
                                $templevel = $currentlevel = 1;
                                $paddingtop = 5;
				
                                $html = $htmlbackto = $htmlallcats = $parentcategory = '';
                                $htmlstart = '<div style="padding:3px">';
				
                                $html2 = $html3 = array();
                                
                                $show['leftnavcategories'] = true;
                                
                                for ($i = 0; $i < $catcount; $i++)
                                {
                                        if (isset($ilance->GPC['cid']) AND $this->cats[$i]['cid'] == $ilance->GPC['cid'])
                                        {
                                                $currentlevel = $this->cats[$i]['level'];
                                                $thisparentid = $this->cats[$i]['parentid'];
                                                $templevel++;
                                                break;
                                        }
                                }

                                if ($ilconfig['globalauctionsettings_showbackto'])
                                {
                                        // find the parent category name for "Back To: Category"
                                        if ($currentlevel > 1 AND !empty($ilance->GPC['cid']))
                                        {
                                                for ($i = 0; $i < $catcount; $i++)
                                                {                                                
                                                        if ($this->cats[$i]['cid'] == $thisparentid)
                                                        {
                                                                $parentcategory = stripslashes($this->cats[$i]['title']);
                                                                break;
                                                        }
                                                }                                                
                                                $auctioncount = '';
                                                $htmlbackto = ($ilconfig['globalauctionsettings_seourls']) ? '<span><span class="smaller gray">' . $phrase['_back_to'] . ':</span> <span class="blue">' . construct_seo_url($seotype, $thisparentid, $auctionid, $parentcategory, $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0, $removevars = 'qid') . '</span></span> ' . $auctioncount . '<hr size="1" style="color:#ebebeb">' : '<span><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'].'icons/selectedcat_back.gif" border="0" alt="' . $phrase['_back_to'] . '" /> <a href="' . $detailpage . '?cid=' . $thisparentid . '"><strong>' . $parentcategory . '</strong></a></span> ' . $auctioncount . '<hr size="1" style="color:#ebebeb">';
                                        }
                                }
                                
                                for ($i = 0; $i < $catcount; $i++)
                                {
                                        $html3[$count2]['html'] = '';

                                        if ($this->cats[$i]['parentid'] == $thisparentid)
                                        {
                                                if (!empty($sqlquery) AND is_array($sqlquery))
                                                {
                                                        // best match - uses existing search params to dig search patterns category by category
                                                        // this variable will make a hit to the db to find results independant of the existing search being performed
                                                        $catbitcounter = $this->bestmatch_auction_count($this->cats[$i]['cid'], $cattype, $sqlquery);
                                                        $catbitcount = ($ilconfig['globalfilters_enablecategorycount'] AND isset($showcount) AND $showcount) ? ' <span class="smaller gray">(' . $catbitcounter . ')</span>' : '';
                                                }
                                                else
                                                {
                                                        // regular auction count
                                                        // this variable will not make another hit to the db
                                                        $catbitcounter = $this->cats[$i]['auctioncount'];
                                                        $catbitcount = ($ilconfig['globalfilters_enablecategorycount'] AND isset($showcount) AND $showcount) ? ' <span class="smaller gray">(' . $catbitcounter . ')</span>' : '';
                                                }
                                                                                                        
                                                // #### MAIN SELECTED CATEGORY ############################################
                                                if (!empty($ilance->GPC['cid']) AND $ilance->GPC['cid'] == $this->cats[$i]['cid'])
                                                {
                                                        // #### CATEGORY FINDER ###########################################
                                                        if ($cattype == 'service' OR $cattype == 'product')
                                                        {
                                                                // will populate $show['categoryfinder'] = true or false
                                                                $categoryfinderhtml = $this->print_searchable_questions($this->cats[$i]['cid'], $showcount, $this->cats[$i]['level'], 0);
                                                        }
                                                        if ($ilconfig['globalauctionsettings_showcurrentcat'])
                                                        {
                                                                $html .= '<div style="padding-top:0px; padding-left:0px"><strong>' . stripslashes($this->cats[$i]['title']) . ' ' . $catbitcount . '</strong> ' . $this->print_category_newicon($this->cats[$i]['cid'], $ctype) . '</div>';
                                                        }
                                                        
                                                        // #### SUBCATEORIES IN MAIN SELECTED CATEGORY #####################
                                                        $html2 = array();
                                                        if ($currentlevel >= 1)
                                                        {
                                                                $count = 0;                                                                
                                                                foreach ($mycats AS $array)
                                                                {
                                                                        $html2[$count]['html'] = '';
                                                                        if ($array['parentid'] == $this->cats[$i]['cid'])
                                                                        {
                                                                                if (is_array($sqlquery))
                                                                                {
                                                                                        // best match - uses existing search params to dig search patterns category by category
                                                                                        // this variable will make a hit to the db to find results independant of the existing search being performed
                                                                                        $catbitcounter2 = $this->bestmatch_auction_count($array['cid'], $cattype, $sqlquery);
                                                                                        $catbitcount2 = ($ilconfig['globalfilters_enablecategorycount'] AND isset($showcount) AND $showcount) ? ' <span class="smaller gray">(' . $catbitcounter2 . ')</span>' : '';
                                                                                }
                                                                                else
                                                                                {
                                                                                        // regular auction count
                                                                                        // this variable not make another hit to the db
                                                                                        $catbitcounter2 = $array['auctioncount'];
                                                                                        $catbitcount2 = ($ilconfig['globalfilters_enablecategorycount'] AND isset($showcount) AND $showcount) ? ' <span class="smaller gray">(' . $catbitcounter2 . ')</span>' : '';
                                                                                }
                                                                                
                                                                                // if we are hiding the main selected category then set the left-padding level to 1
                                                                                if ($ilconfig['globalauctionsettings_showcurrentcat'] == false)
                                                                                {
                                                                                        $templevel = 1;
                                                                                }
                                                                                
                                                                                if ($ilconfig['globalauctionsettings_seourls'])
                                                                                {
                                                                                        if (!empty($ilance->GPC['q']))
                                                                                        {
                                                                                                if ($catbitcounter2 > 0)
                                                                                                {
                                                                                                        $html2[$count]['html'] .= '<div style="padding-top:3px; padding-left:' . $this->fetch_level_padding($templevel) . 'px"><span class="blue">' . construct_seo_url($seotype, $array['cid'], $auctionid, stripslashes($array['title']), $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) . '</span> ' . $catbitcount2 . ' ' . $this->print_category_newicon($array['cid'], $ctype) . '</div>';
                                                                                                        $count++;
                                                                                                }
                                                                                        }
                                                                                        else
                                                                                        {
                                                                                                $html2[$count]['html'] .= '<div style="padding-top:3px; padding-left:' . $this->fetch_level_padding($templevel) . 'px"><span class="blue">' . construct_seo_url($seotype, $array['cid'], $auctionid, stripslashes($array['title']), $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) . '</span> ' . $catbitcount2 . ' ' . $this->print_category_newicon($array['cid'], $ctype) . '</div>';
                                                                                                $count++;
                                                                                        }
                                                                                }
                                                                                else
                                                                                {
                                                                                        $html2[$count]['html'] .= '<div style="padding-top:3px; padding-left:' . $this->fetch_level_padding($templevel) . 'px"><span class="blue"><a href="' . $detailpage . '?cid=' . $array['cid'] . print_hidden_fields($string = true, $excluded = array('page','mode','cid','cmd','state','id'), $questionmarkfirst = false, $prepend_text = '', $append_text = '', $htmlentities = true, $urldecode = true) . '">' . stripslashes($array['title']) . '</a></span> ' . $catbitcount2 . ' ' . $this->print_category_newicon($array['cid'], $ctype) . '</div>';
                                                                                        $count++;
                                                                                }                                                                                
                                                                                        
                                                                        }
                                                                }
                                                        }
                                                        
                                                        $bit['visible'] = $bit['hidden'] = '';
                        
                                                        $templevel = 2;
                                                        if ($ilconfig['globalauctionsettings_showcurrentcat'] == false)
                                                        {
                                                                $templevel = 1;
                                                        }
                                                        $hidden = '<div style="padding-left:' . $this->fetch_level_padding($templevel) . 'px; padding-bottom:6px; padding-top:5px" class="blue"><a href="javascript:void(0)" onclick="toggle_more(\'showmoresubcats_' . $cid . '\', \'moretext_' . $cid . '\', \'' . $phrase['_more'] . '\', \'' . $phrase['_less'] . '\', \'showmoreicon_' . $cid . '\')"><span id="moretext_' . $cid . '" style="font-weight:bold; text-decoration:none">' . (!empty($ilcollapse["showmoresubcats_$cid"]) ? $phrase['_less'] : $phrase['_more']) . '</span></a> <img id="showmoreicon_' . $cid . '" src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/' . (!empty($ilcollapse["showmoresubcats_$cid"]) ? 'arrowup2.gif' : 'arrowdown2.gif') . '" border="0" alt="" /></div>';
                        
                                                        if (!empty($html2) AND is_array($html2))
                                                        {
                                                                $c = 0;
                                                                foreach ($html2 AS $key => $array)
                                                                {
                                                                        $c++;
                                                                        if ($c <= $ilconfig['globalauctionsettings_catcutoff'])
                                                                        {
                                                                                $bit['visible'] .= $html2[$key]['html'];
                                                                        }
                                                                        else
                                                                        {
                                                                                $bit['hidden'] .= $html2[$key]['html'];
                                                                        }
                                                                }
                                                        }
                                                        
                                                        if ($count <= $ilconfig['globalauctionsettings_catcutoff'])
                                                        {
                                                                $hidden = '';
                                                        }
                                                        
                                                        // rebuild display options
                                                        if (!empty($bit['visible']))
                                                        {
                                                                $html .= "$bit[visible] <div id=\"showmoresubcats_$cid\" style=\"" . (!empty($ilcollapse["showmoresubcats_$cid"]) ? $ilcollapse["showmoresubcats_$cid"] : 'display: none;') . "\">$bit[hidden]</div>$hidden";
                                                        }
                                                }
                                                
                                                // #### MAIN UNSELECTED CATEGORIES ###################################
                                                // this block will execute only if:                                                
                                                // 1. main menu is being viewed
                                                // 2. if a user enters keywords but does not select a category
                                                else 
                                                {
                                                        // prevent all other root cats from showing underneat selected category
                                                        if (empty($ilance->GPC['cid']) OR $ilance->GPC['cid'] == 0)
                                                        {
                                                                if ($this->cats[$i]['parentid'] == $thisparentid)
                                                                {
                                                                        if ($this->fetch_children_ids($this->cats[$i]['cid'], $ctype) != '' AND defined('LOCATION') AND LOCATION != 'search')
                                                                        {
                                                                                $html3[$count2]['html'] .= (($ilconfig['globalauctionsettings_seourls'])
                                                                                        ? '<div style="padding-top:3px; padding-left:0px"><span class="blue">' . construct_seo_url($seotype2, $this->cats[$i]['cid'], $auctionid, stripslashes($this->cats[$i]['title']), $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) . '</span> ' . $catbitcount . ' ' . $this->print_category_newicon($this->cats[$i]['cid'], $ctype) . '</div>'
                                                                                        : '<div style="padding-top:3px; padding-left:0px"><span class="blue"><a href="' . $detailpage . '?cmd=listings&amp;cid=' . $this->cats[$i]['cid'] . print_hidden_fields($string = true, $excluded = array('page','mode','cid','cmd','state','id','sort'), $questionmarkfirst = false, $prepend_text = '', $append_text = '', $htmlentities = true, $urldecode = true) . '">' . stripslashes($this->cats[$i]['title']) . '</a></span> ' . $catbitcount . ' ' . $this->print_category_newicon($this->cats[$i]['cid'], $ctype) . '</div>');
                                                                                $count2++;
                                                                        }
                                                                        else
                                                                        {
                                                                                if (!empty($ilance->GPC['q']))
                                                                                {
                                                                                        if ($catbitcounter > 0)
                                                                                        {
                                                                                                $html3[$count2]['html'] .= (($ilconfig['globalauctionsettings_seourls'])
                                                                                                        ? '<div style="padding-top:3px; padding-left:0px"><span class="blue">' . construct_seo_url($seotype, $this->cats[$i]['cid'], $auctionid, stripslashes($this->cats[$i]['title']), $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) . '</span> ' . $catbitcount . ' ' . $this->print_category_newicon($this->cats[$i]['cid'], $ctype) . '</div>'
                                                                                                        : '<div style="padding-top:3px; padding-left:0px"><span class="blue"><a href="' . $detailpage . '?cid=' . $this->cats[$i]['cid'] . print_hidden_fields($string = true, $excluded = array('page','mode','cid','cmd','state','id'), $questionmarkfirst = false, $prepend_text = '', $append_text = '', $htmlentities = false, $urldecode = true) . '">' . stripslashes($this->cats[$i]['title']) . '</a></span> ' . $catbitcount . ' ' . $this->print_category_newicon($this->cats[$i]['cid'], $ctype) . '</div>');
                                                                                                $count2++;
                                                                                        }
                                                                                }
                                                                                else
                                                                                {
                                                                                        $html3[$count2]['html'] .= (($ilconfig['globalauctionsettings_seourls'])
                                                                                                ? '<div style="padding-top:3px; padding-left:0px"><span class="blue">' . construct_seo_url($seotype, $this->cats[$i]['cid'], $auctionid, stripslashes($this->cats[$i]['title']), $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) . '</span> ' . $catbitcount . ' ' . $this->print_category_newicon($this->cats[$i]['cid'], $ctype) . '</div>'
                                                                                                : '<div style="padding-top:3px; padding-left:0px"><span class="blue"><a href="' . $detailpage . '?cid=' . $this->cats[$i]['cid'] . print_hidden_fields($string = true, $excluded = array('page','mode','cid','cmd','state','id'), $questionmarkfirst = false, $prepend_text = '', $append_text = '', $htmlentities = true, $urldecode = true) . '">' . stripslashes($this->cats[$i]['title']) . '</a></span> ' . $catbitcount . ' ' . $this->print_category_newicon($this->cats[$i]['cid'], $ctype) . '</div>');
                                                                                        $count2++;
                                                                                }
                                                                        }
                                                                }
                                                        }
                                                }
                                        }
                                }
                                
                                $bit['visible'] = $bit['hidden'] = '';

                                $templevel = 2;
                                if ($ilconfig['globalauctionsettings_showcurrentcat'] == false OR $count2 > 0)
                                {
                                        $templevel = 1;
                                }
                                
                                $hidden = '<div style="padding-left:' . $this->fetch_level_padding($templevel) . 'px; padding-bottom:6px; padding-top:5px"><span class="blue"><a href="javascript:void(0)" onclick="toggle_more(\'showmorecats_' . $cattype . '\', \'moretext_' . $cattype . '\', \'' . $phrase['_more'] . '\', \'' . $phrase['_less'] . '\', \'showmoreicon_' . $cattype . '\')"><span id="moretext_' . $cattype . '" style="font-weight:bold; text-decoration:none">' . (!empty($ilcollapse["showmorecats_$cattype"]) ? $phrase['_less'] : $phrase['_more']) . '</span></a></span> <img id="showmoreicon_' . $cattype . '" src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/' . (!empty($ilcollapse["showmorecats_$cattype"]) ? 'arrowup2.gif' : 'arrowdown2.gif') . '" border="0" alt="" /></div>';

                                if (!empty($html3) AND is_array($html3))
                                {
                                        $c = 0;
                                        foreach ($html3 AS $key => $array)
                                        {
                                                $c++;
                                                if ($c <= $ilconfig['globalauctionsettings_catcutoff'])
                                                {
                                                        $bit['visible'] .= $html3[$key]['html'];
                                                }
                                                else
                                                {
                                                        $bit['hidden'] .= $html3[$key]['html'];
                                                }
                                        }
                                }
                                
                                if ($count2 <= $ilconfig['globalauctionsettings_catcutoff'])
                                {
                                        $hidden = '';
                                }

                                if ($count2 > 0)
                                {
                                        // rebuild display options
                                        if (!empty($bit['visible']))
                                        {
                                                $html .= "$bit[visible] <div id=\"showmorecats_$cattype\" style=\"" . (!empty($ilcollapse["showmorecats_$cattype"]) ? $ilcollapse["showmorecats_$cattype"] : 'display: none;') . "\">$bit[hidden]</div>$hidden";
                                        }
                                }
                                                                
                                // category map urls
                                if (LOCATION == 'main' OR !isset($ilance->GPC['cid']) OR empty($ilance->GPC['cid']))
                                {
                                        if ($cattype == 'service')
                                        {
                                                $htmlallcats = ($ilconfig['globalauctionsettings_seourls']) ? '<div style="padding-top:6px"><hr size="1" width="100%" style="color:#ebebeb; margin:0px;" /><div class="blue" style="padding-top:6px"><a href="' . HTTP_SERVER . print_seo_url($ilconfig['servicecatmapidentifier']) . '"><span>' . $phrase['_view_all_categories'] . '</span></a></div></div>' : '<div style="padding-top:3px"><hr size="1" width="100%" style="color:#ebebeb; margin:0px; padding-bottom:3px" /><span class="blue"><a href="' . HTTP_SERVER . $ilpage['rfp'] . '?cmd=listings"><span>' . $phrase['_view_all_categories'] . '</span></a></span></div>';
                                        }
                                        else if ($cattype == 'product')
                                        {
                                                $htmlallcats = ($ilconfig['globalauctionsettings_seourls']) ? '<div style="padding-top:6px"><hr size="1" width="100%" style="color:#ebebeb; margin:0px;" /><div class="blue" style="padding-top:6px"><a href="' . HTTP_SERVER . print_seo_url($ilconfig['productcatmapidentifier']) . '"><span>' . $phrase['_view_all_categories'] . '</span></a></div></div>' : '<div style="padding-top:3px"><hr size="1" width="100%" style="color:#ebebeb; margin:0px; padding:0px" /><span class="blue"><a href="' . HTTP_SERVER . $ilpage['merch'] . '?cmd=listings"><span>' . $phrase['_view_all_categories'] . '</span></a></span></div>';
                                        }
                                }                                
                                $htmlend = '</div>';
                                
                                $show['leftnavcategories'] = (empty($html)) ? false : true;
                                
                                $html = "$htmlstart $htmlbackto $html $htmlallcats $htmlend";
                                break;        
                        }
                    
                        // #### TWO COLUMN OUTPUT ##############################
                        case '2':
                        {
                                $mycats = array();
                                $result = $ilance->db->query("
                                        SELECT $cidfield, $cidtitle, $counttype, parentid, canpost, views
                                        FROM $dbtable
                                        WHERE $ctypefield = '$ctype'
                                            AND visible = '1'
                                        ORDER BY sort ASC
                                ", 0, null, __FILE__, __LINE__);
                                while ($row = $ilance->db->fetch_array($result))
                                {
                                        $mycats[] = array(
                                                'cid' => $row[$cidfield],
                                                'title' => $row[$cidtitle],
                                                'parentid' => $row['parentid'],
                                                'canpost' => $row['canpost'],
                                                'views' => $row['views'],
                                                'auctioncount' => $row[$counttype],
                                                'level' => 0
                                        );
                                }
                                unset($row);
                                
                                $this->get_cats($mycats);
                    
                                $html = '<table border="0" cellspacing="6" cellpadding="0" width="100%">';
                                $html .= '<tr>';
                                $html .= '<td width="50%" valign="top">';
                    
                                // fetch total main cats count
                                $totalmaincats = 0;
                                $maincatcount = 0;
                                $catbit = '';
                                $catbitcount = '';
                                
                                $catcount = count($this->cats);
                                for ($i = 0; $i < $catcount; $i++)
                                {
                                        if ($this->cats[$i]['level'] == 1)
                                        {
                                                $totalmaincats++;
                                        }
                                }
                    
                                $splitat = (floor($totalmaincats / 2));
                    
                                for ($i = 0; $i < $catcount; $i++)
                                {
                                        if ($this->cats[$i]['level'] == 1)
                                        {
                                                if ($maincatcount == $splitat)
                                                {
                                                        $catbit .= '</td>';
                                                        $catbit .= '<td width="50%" valign="top">';
                                                }
                    
                                                $catbitcount = ($ilconfig['globalfilters_enablecategorycount'] AND isset($showcount) AND $showcount) ? ' <span class="smaller gray">(' . $this->cats[$i]['auctioncount'] . ')</span>' : '';
                        
                                                // display main category
                                                if ($ilconfig['globalauctionsettings_seourls'])
                                                {
                                                        $catbit .= '<div>' . construct_seo_url($seotype, $this->cats[$i]['cid'], $auctionid, stripslashes($this->cats[$i]['title']), $customlink = '', $bold = 1, $searchquestion = '', $questionid = 0, $answerid = 0) . ' ' . $catbitcount . ' ' . $this->print_category_newicon($this->cats[$i]['cid'], $ctype) . '</div>';
                                                }
                                                else
                                                {
                                                        $catbit .= '<div><a href="' . $detailpage . '?cid=' . $this->cats[$i]['cid'] . '"><strong>' . stripslashes($this->cats[$i]['title']) . '</strong></a> ' . $catbitcount . ' ' . $this->print_category_newicon($this->cats[$i]['cid'], $ctype) . '</div>';
                                                }
                    
                                                // loop through level 1 children subcategories
                                                $maxsubcatcounter = 1;
                                                foreach ($mycats as $array)
                                                {
                                                        if ($array['parentid'] == $this->cats[$i]['cid'])
                                                        {
                                                                if ($maxsubcatcounter <= $ilconfig['globalauctionsettings_catcutoff'])
                                                                {
                                                                        $catbitcount2 = ($ilconfig['globalfilters_enablecategorycount'] AND isset($showcount) AND $showcount) ? ' <span class="smaller gray">(' . $array['auctioncount'] . ')</span>' : '';
                                                                
                                                                        // display sub category
                                                                        if ($ilconfig['globalauctionsettings_seourls'])
                                                                        {
                                                                                $catbit .= '<span>' . construct_seo_url($seotype, $array['cid'], $auctionid, stripslashes($array['title']), $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) . ' ' . $catbitcount2 . '</span>, ';
                                                                        }
                                                                        else
                                                                        {
                                                                                $listurl = '';
                                                                                if ($this->cats[$i]['canpost'])
                                                                                {
                                                                                        $listurl = 'cmd=listings&amp;';
                                                                                }
                                                                                $catbit .= '<span><a href="' . $detailpage . '?' . $listurl . 'cid=' . $array['cid'] . '">' . stripslashes($array['title']) . '</a> ' . $catbitcount2 . '</span>, ';
                                                                        }            
                                                                }
                                                                $maxsubcatcounter++;
                                                        }
                                                }
            
                                                // display ending " ... " to main category listings
                                                if ($ilconfig['globalauctionsettings_seourls'])
                                                {
                                                        $catbit .= ' ' . construct_seo_url($seotype, $this->cats[$i]['cid'], $auctionid, stripslashes($this->cats[$i]['title']), '<span class="smaller">'.$phrase['_see_all'].'</span>', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0);
                                                }
                                                else
                                                {
                                                        $catbit .= ' <a href="' . $detailpage . '?cid=' . $this->cats[$i]['cid'] . '"><span class="smaller">' . $phrase['_see_all'] . '</span></a>';
                                                }
            
                                                if ($this->cats[$i]['level'] == 1)
                                                {
                                                        $catbit .= '<br /><br />';
                                                }
                                                $maincatcount++;
                                        }
                                }
                    
                                $html .= $catbit;
                                $html .= '</tr>';
                                $html .= '</table>';
                                break;        
                        }

                        // #### THREE COLUMN OUTPUT ############################
                        case '3':
                        case '4':
                        case '5':
                        case '6':
                        {
                                if ($ilconfig['categorymapcache'])
                                {
                                        $cache['filename'] = $columns . '_column_cat_map_' . $ctype . '_cid_' . $cid . '.html';
                                        $cache['filepath'] = DIR_TMP . $cache['filename'];
                                        
                                        // check if we need to rewrite cache template
                                        $write_html = false;
                                        if (file_exists($cache['filepath']))
                                        {
                                                $lastmod = filemtime($cache['filepath']);
                                                if (($lastmod + $ilconfig['categorymapcachetimeout'] * 60) < mktime())
                                                {
                                                        // cache template is outdated
                                                        $write_html = true;
                                                }
                                        }
                                        else 
                                        {
                                                // the cache template file does not exist! we need to generate something!
                                                $write_html = true;
                                        }
                                        
                                        if ($write_html)
                                        {
                                                $cache['unique_name'] = '';
                                                do 
                                                {
                                                        $cache['unique_name'] = rand(0, 100000);
                                                }
                                                while (file_exists(DIR_TMP . $cache['unique_name']));
                                                {                                    
                                                        $f = fopen(DIR_TMP . $cache['unique_name'], 'w');
                                                        if ($f === false)
                                                        {
                                                                @unlink(DIR_TMP . $cache['unique_name']);
                                                        }
                                                        else 
                                                        {
                                                                global $recursive_html;
								
                                                                $html = '';
                                                                $recursive_html = '<table border="0" cellspacing="6" cellpadding="1" width="100%">';
                                                                $this->fetch_recursive_categories($cid, $level = 1, $ctypefield, $ctype, $dbtable, $seotype, $detailpage, $showcount, $slng, $cidfield, $cidtitle, $iscatmap, $titlestyle, $subcatdepth, $categorycache, $columns);                                
                                                                $recursive_html .= '</table>';
								$recursive_html .= '<div style="padding-top:12px; padding-left:6px" class="smaller gray">Cached: ' . print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0) . '</div>';
								
                                                                $html .= $recursive_html;
                                                                
                                                                fwrite($f, $html);
                                                                fclose($f);
                                                                @unlink(DIR_TMP . $cache['filename']);
                                                                @rename(DIR_TMP . $cache['unique_name'], DIR_TMP . $cache['filename']);
                                                                @unlink(DIR_TMP . $cache['unique_name']);
                                                        }
                                                }
                                        }
                                        else
                                        {
                                                // template cache exists - read it
                                                $html = file_get_contents($cache['filepath']);
                                        }
                                        break;
                                }
                                else
                                {
                                        global $recursive_html;

                                        $html = '';
                                        $recursive_html = '<table border="0" cellspacing="6" cellpadding="1" width="100%">';
                                        $this->fetch_recursive_categories($cid, 1, $ctypefield, $ctype, $dbtable, $seotype, $detailpage, $showcount, $slng, $cidfield, $cidtitle, $iscatmap, $titlestyle, $subcatdepth, $categorycache, $columns);                                
                                        $recursive_html .= '</table>';                                
                                        $html .= $recursive_html;
                                        break;
                                }
                        }
                }
                
                $ilance->timer->stop();
                DEBUG("print_subcategory_columns(\$columns = $columns, \$cattype = '$cattype') in " . $ilance->timer->get() . " seconds", 'FUNCTION');
                
                return $html;
        }
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: class.categories_parser.inc.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>