<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

if (!class_exists('categories'))
{
	exit;
}

/**
* Category pulldown class to perform the majority of category pulldown menus and other related parsing functions within ILance.
*
* @package      iLance
* @version	$Revision: 1.0.0 $
* @author       ILance
*/
class categories_pulldown extends categories
{
	/**
        * Function to fetch level options for a select menu
        *
        * @param       integer      selected category id
        * @param       array        category result array
        * @param       string       type
        * @param       string       category type
        * @param       boolean      force no category count? (default false)
        * @param       boolean      do javascript? (default false)
        * @param       integer      category id number to skip (if applicable) default 0
        *
        * @return      string       Returns HTML formatted pulldown menu
        */
        function fetch_level_options($selected = '', $result = array(), $type = '', $cattype = '', $forcenocount, $dojs, $hidecid = 0)
        {
                global $ilance, $ilconfig, $phrase, $ilpage;
                
                $html = '';
                $count = count($result);
                for ($i = 0; $i < $count; $i++)
                {
                        if ($result[$i]['visible'] AND $result[$i]['cid'] != $hidecid)
                        {
                                $catbitcount = ($ilconfig['globalfilters_enablecategorycount'] AND $forcenocount == 0) ? '(' . (int)$result[$i]['auctioncount'] . ')' : '';
                                if (isset($selected) AND $selected == $result[$i]['cid'])
                                {
                                        if ($cattype == 'skills')
                                        {
                                                if ($result[$i]['level'] == 1)
                                                {
                                                        $html .= '<option value="' . $result[$i]['cid'] . '" selected="selected">' . stripslashes($result[$i]['title']) . ' ' . $catbitcount . '</option>';
                                                }        
                                        }
                                        else
                                        {
                                                if ($dojs == 0)
                                                {
                                                        $html .= '<option value="' . $result[$i]['cid'] . '" selected="selected">' . (($result[$i]['level'] > 1) ? str_repeat(' &nbsp; ', $result[$i]['level']) : '' ) . stripslashes($result[$i]['title']) . ' ' . $catbitcount . '</option>';
                                                }
                                                else 
                                                {
                                                        $html .= '<option value="' . HTTPS_SERVER . $ilpage['selling'] . '?cmd=profile&amp;cid=' . $result[$i]['cid'] . '#categories" selected="selected">' . (($result[$i]['level'] > 1) ? str_repeat(' &nbsp; ', $result[$i]['level']) : '' ) . stripslashes($result[$i]['title']) . ' ' . $catbitcount . '</option>';
                                                }
                                        }
                                }
                                else 
                                {
                                        if ($cattype == 'skills')
                                        {
                                                if ($result[$i]['level'] == 1)
                                                {
                                                        $html .= '<option value="' . $result[$i]['cid'] . '">' . stripslashes($result[$i]['title']) . ' ' . $catbitcount . '</option>';
                                                }
                                        }
                                        else
                                        {
                                                if ($dojs == 0)
                                                {
                                                        $html .= '<option value="' . $result[$i]['cid'] . '">' . (($result[$i]['level'] > 1) ? str_repeat(' &nbsp; ', $result[$i]['level']) : '' ) . stripslashes($result[$i]['title']) . ' ' . $catbitcount . '</option>';
                                                }
                                                else 
                                                {
                                                        $html .= '<option value="' . HTTPS_SERVER . $ilpage['selling'] . '?cmd=profile&amp;cid=' . $result[$i]['cid'] . '#categories">' . (($result[$i]['level'] > 1) ? str_repeat(' &nbsp; ', $result[$i]['level']) : '' ) . stripslashes($result[$i]['title']) . ' ' . $catbitcount . '</option>';						
                                                }
                                        }
                                }
                        }
                }
                unset($result, $count);                                                
                
                return $html;
        }
        
        
        /**
        * Function to fetch profile level options for a select menu
        *
        * @param       integer      selected category id
        * @param       array        category result array
        * @param       string       type
        * @param       string       category type
        * @param       boolean      force no category count? (default false)
        * @param       boolean      do javascript? (default false)
        * @param       integer      user id (optional)
        *
        * @return      string       Returns HTML formatted pulldown menu
        */
	function fetch_levelprofile_options($selected = '', $result = array(), $type = '', $cattype = '', $forcenocount, $dojs, $uid)
        {
                global $ilance, $ilconfig, $phrase, $ilpage;
                
                $html = '';
                $count = count($result);
                for ($i = 0; $i < $count; $i++)
                {
                        if ($result[$i]['visible'])
                        {
                                $questioncount = $this->fetch_profile_question_count($result[$i]['cid']);
                                if (isset($selected) AND $selected == $result[$i]['cid'])
                                {
                                        if ($questioncount > 0)
                                        {
                                                if ($dojs == 0)
                                                {
                                                        $html .= '<option value="' . $result[$i]['cid'] . '" selected="selected">' . (($result[$i]['level'] > 1) ? str_repeat(' &nbsp; ', $result[$i]['level']) : '' ) . stripslashes($result[$i]['title']) . ' (' . $questioncount . ' ' . mb_strtolower($phrase['_questions']) . ', ' . $this->fetch_profile_answer_count($result[$i]['cid'], $uid).' '.mb_strtolower($phrase['_answered']).', '.$this->fetch_profile_verification_count($result[$i]['cid'], $uid).' '.mb_strtolower($phrase['_verified']).')</option>';
                                                }
                                                else 
                                                {
                                                        $html .= '<option value="' . HTTPS_SERVER . $ilpage['selling'] . '?cmd=profile-specifics&amp;cid=' . $result[$i]['cid'] . '" selected="selected">' . (($result[$i]['level'] > 1) ? str_repeat(' &nbsp; ', $result[$i]['level']) : '' ) . stripslashes($result[$i]['title']) . ' (' . $questioncount . ' ' . mb_strtolower($phrase['_questions']).', '.$this->fetch_profile_answer_count($result[$i]['cid'], $uid).' '.mb_strtolower($phrase['_answered']).', '.$this->fetch_profile_verification_count($result[$i]['cid'], $uid).' '.mb_strtolower($phrase['_verified']).')</option>';
                                                }
                                        }
                                }
                                else 
                                {
                                        if ($questioncount > 0)
                                        {
                                                if ($dojs == 0)
                                                {
                                                        $html .= '<option value="' . $result[$i]['cid'] . '">' . (($result[$i]['level'] > 1) ? str_repeat(' &nbsp; ', $result[$i]['level']) : '' ) . stripslashes($result[$i]['title']) . ' (' . $questioncount . ' ' . mb_strtolower($phrase['_questions']).', '.$this->fetch_profile_answer_count($result[$i]['cid'], $uid).' '.mb_strtolower($phrase['_answered']).', '.$this->fetch_profile_verification_count($result[$i]['cid'], $uid).' '.mb_strtolower($phrase['_verified']).')</option>';
                                                }
                                                else 
                                                {
                                                        $html .= '<option value="' . HTTPS_SERVER . $ilpage['selling'] . '?cmd=profile-specifics&amp;cid=' . $result[$i]['cid'] . '">' . (($result[$i]['level'] > 1) ? str_repeat(' &nbsp; ', $result[$i]['level']) : '' ) . stripslashes($result[$i]['title']) . ' (' . $questioncount . ' ' . mb_strtolower($phrase['_questions']).', '.$this->fetch_profile_answer_count($result[$i]['cid'], $uid).' '.mb_strtolower($phrase['_answered']).', '.$this->fetch_profile_verification_count($result[$i]['cid'], $uid).' '.mb_strtolower($phrase['_verified']).')</option>';						
                                                }
                                        }
                                }
                        }
                }
                
                return $html;
        }
        
        /**
        * Function for fetching the recursive category nodes for a single category pulldown menu.
        *
        * This function is a call-back to the [print_root_category_pulldown()] function.
        *
        * @param       string       currently selected menu option
        * @param       string       category type (service or product)
        * @param       string       language to parse output within (default eng)
        * @param       array        category array cache to construct the pulldown menu (accepts build_array() format only)
        *
        * @return      string       HTML representation of the single pulldown menu <option>'s
        */
        function fetch_recursive_category_options($cid = '', $cattype = '', $slng = 'eng', $categorycache = array())
        {
                global $ilance, $ilconfig, $phrase, $ilpage, $array;
                
                $results = $categorycache;
                $resultscount = count($results);
                
                for ($i = 0; $i < $resultscount; $i++)
                {
                        if ($results[$i]['cid'] == $cid)
                        {
                                //$html .= '<option value="' . $cid . '">&#9492; ' . $results[$i]['title'] . '</option>';
                                $array[$cid] = $results[$i]['title'];
                                $this->fetch_recursive_category_options($results[$i]['parentid'], $cattype, $slng, $results);
                        }
                }
                
                $html = '';
                
                if (isset($array) AND is_array($array))
                {
                        foreach ($array AS $categoryid => $title)
                        {
                                if (!empty($ilance->GPC['cid']) AND $ilance->GPC['cid'] == $categoryid)
                                {
                                        $html .= '<option value="' . $categoryid . '" selected="selected">' . $title . '</option>';
                                }
                                else
                                {
                                        $html .= '<option value="' . $categoryid . '">&#9492; ' . $title . '</option>';
                                }
                        }
                }
                
                return $html;
        }
        
        /**
        * Function for printing a single category pulldown menu only presenting main categories along with a recursive selected category node feature.  This function
        * will provide marketplaces with huge category lists a much faster display and response vs displaying all nodes for all categories.
        *
        * This function requires a call back function [fetch_recursive_category_options()] to fetch and display the selected recursive nodes.
        *
        * @param       string       currently selected menu option
        * @param       string       category type (service or product)
        * @param       string       fieldname of selection output box
        * @param       string       language to parse output within (default eng)
        * @param       array        category array cache to construct the pulldown menu (accepts build_array() format only)
        *
        * @return      string       HTML representation of the single pulldown or multi-selection menu
        */
        function print_root_category_pulldown($selected = '', $cattype = '', $fieldname = 'cid', $slng = 'eng', $categorycache = array())
        {
                global $ilance, $ilconfig, $phrase, $ilpage;
                
                $this->cats = $categorycache;
                $result = $categorycache;
                
                $html = '<select name="' . $fieldname . '" style="font-family: verdana">';
                
                if (isset($selected) AND $selected > 0)
                {
                        $html .= $this->fetch_recursive_category_options($selected, $cattype, $slng, $categorycache);
                        $html .= '<option value="">&#9492; ' . $phrase['_all_categories_upper'] . '</option>';
                        $html .= '<option value="">----------------------------------</option>';
                }
                else
                {
                        $html .= '<option value="">' . $phrase['_all_categories_upper'] . '</option>';
                        $html .= '<option value="">----------------------------------</option>';
                }
                
                $count = count($result);
                for ($i = 0; $i < $count; $i++)
                {
                        if ($result[$i]['visible'] AND $result[$i]['level'] == 1)
                        {
                                $categoryname = stripslashes($result[$i]['title']);
                                $html .= '<option value="' . $result[$i]['cid'] . '">' . $categoryname . '</option>';
                        }
                }
                
                $html .= '</select>';
                
                return $html;
        }
        
        /**
        * Function for printing a category pulldown or selection box.  This function now uses a suitable method to call the category cache without reloading the db.
        *
        * @param       string       parent category id
        * @param       string       category type (service or product)
        * @param       string       type of element (multi-select, single pulldown, etc)
        * @param       string       fieldname of selection output box
        * @param       boolean      show "Please select" option (blank value)
        * @param       string       language to parse output within
        * @param       boolean      show option groups and labels
        * @param       string       enable prepopulate mode? (used in areas like newsletter for retaining selected values)
        * @param       integer      mode switch for various category situations (0 = all, 1 = portfolio, 2 = xml, 3 = newsletter, 4 = skills)
        * @param       boolean      show all categories argument (yes/no)
        * @param       boolean      enable javascript for certain pulldown options (yes/no)
        * @param       string       width of the outputted selection box
        * @param       integer      custom user id to supply this function for various purposes
        * @param       boolean      do we want to force-hide the total auction count in category display even if enabled?
        * @param       boolean      is expert pulldown menu (yes/no)
        * @param       boolean      can we display an option such as -1 for the category to allow "assign to all categories" option?
        * @param       boolean      show best matching text (vs "All Categories") (default true)
        * @param       array        category array cache to construct the pulldown menu (accepts build_array() format only)
        * @param       boolean      determine if we need to use onclick when a category is selected to show content within a innerHTML div (default false) (this argument is valid only when $type == levelmultisearch
        * @param       integer      the category id being selected (if applicable) if this value exists we'll prevent this category pulldown option from showing
        * 
        * @return      string       HTML representation of the pulldown or multi-selection menu
        */
        function print_cat_pulldown($selected = '', $cattype = 'service', $type = '', $fieldname = '', $showpleaseselectoption = 0, $slng = 'eng', $nooptgroups = 0, $prepopulate = 0, $mode = 0, $showallcats = 1, $dojs = 0, $width = '540px', $uid = 0, $forcenocount = 0, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = false, $categorycache = array(), $onclickajax = false, $selectedcid = 0)
        {
                global $ilance, $myapi, $phrase, $ilconfig, $ilpage, $headinclude, $show;

                $this->cats = $categorycache;
                
                $userid = !empty($_SESSION['ilancedata']['user']['userid']) ? intval($_SESSION['ilancedata']['user']['userid']) : 0;            
                $mycats = array();
                $counter = 0;

                if ($mode == 0)
                {
                        $result = array();
                        $results = $categorycache;                        
                        for ($i = 0; $i < count($results); $i++)
                        {
                                $counter = $this->cats[$i]['auctioncount'];
                                
                                // searching for providers
                                if ($expertspulldown)
                                {
                                        // count providers opt'ed in this category
                                        $count = $ilance->db->query("
                                                SELECT user_id
                                                FROM " . DB_PREFIX . "profile_categories
                                                WHERE FIND_IN_SET(" . intval($this->cats[$i]['cid']) . ", cid)
                                        ", 0, null, __FILE__, __LINE__);
                                        if ($ilance->db->num_rows($count) > 0)
                                        {
                                                while ($exclude = $ilance->db->fetch_array($count))
                                                {
                                                        // for each user opt'ed, check if they can be listed in search results..
                                                        if ($ilance->subscription->check_access($exclude['user_id'], 'searchresults') == 'yes' AND display_profile($exclude['user_id']))
                                                        {
                                                                $counter++;
                                                        }                                                        
                                                }
                                        }   
                                }

                                $result[] = array (
                                        'cid' => $this->cats[$i]['cid'],
                                        'title' => $this->cats[$i]['title'],
                                        'parentid' => $this->cats[$i]['parentid'],
                                        'canpost' => $this->cats[$i]['canpost'],
                                        'auctioncount' => $counter,
                                        'level' => $this->cats[$i]['level'],
                                        'visible' => $this->cats[$i]['visible']
                                );
                        }                        
                }
                else
                {
                        $result = $categorycache;
                }
                
                $html = '<select name="' . $fieldname . '" style="font-family: verdana">';                
                if ($dojs)
                {
                        // viewing pulldown menu from the selling profile menu
                        $html = '<select name="' . $fieldname . '" onchange="openURL();" style="font-family: verdana">';
                        
                        // specific javascript include
                        $headinclude .= "
<script language=\"javascript\">
<!--
function openURL()
{
    selInd = document.sellingprofile.$fieldname.selectedIndex;
    if (selInd > 0)
    {
	goURL = document.sellingprofile.$fieldname.options[selInd].value;
	top.location.href = goURL;
    }
}
//-->
</script>";                        
                }
                
                if ($type == 'levelmulti' OR $type == 'levelmultisearch')
                {
                        $onclickjs = $divid = '';
                        if (isset($onclickajax) AND $onclickajax)
                        {
                                $onclickjs = 'onclick="return print_profile_filters();"';
                                $divid = 'id="cid_list"';
                        }
                        
                        // allowing multiple selections of categories within the select menu
                        $html = '<select ' . $divid . ' name="' . $fieldname . (($type == 'levelmulti') ? '[]" multiple' : '"') . ' size="10" style="width:' . $width . '; font-family: verdana" ' . $onclickjs . '>';	
                }
                
                if ($showpleaseselectoption)
                {
                        // showing "please select" or "best matching" as default pulldown menu options
                        if ($showbestmatching)
                        {
                                $phr = $phrase['_best_matching'];
                        }
                        else
                        {
                                if ($cattype == 'skills')
                                {
                                        $phr = $phrase['_none'];       
                                }
                                else
                                {
                                        $phr = '-';
                                }
                        }
                        
                        $html .= '<option value="">' . $phr . '</option>';
                }
                
                if ($canassigntoall AND defined('LOCATION') AND LOCATION == 'admin')
                {
                        // admin control panel options
                        $html .= '<optgroup label="' . $phrase['_all_categories'] . '">';
                        $html .= '<option value="-1" style="background:#ebebeb">' . $phrase['_assign_to_all_available_categories'] . '</option>';
                        $html .= '</optgroup>';
                }
                
                // #### SINGLE LEVEL PULLDOWN MENU #############################
                if ($type == 'level' OR $type == 'levelprofile')
                {
                        switch ($type)
                        {
                                // #### GENERAL LEVEL PULLDOWN #################
                                case 'level':
                                {
                                        $html .= $this->fetch_level_options($selected, $result, $type, $cattype, $forcenocount, $dojs, $selectedcid);                                        
                                        break;        
                                }
                        
                                // #### PROFILE CATEGORY PULLDOWN MENU #########
                                case 'levelprofile':
                                {
                                        $html .= $this->fetch_levelprofile_options($selected, $result, $type, $cattype, $forcenocount, $dojs, $uid);
                                        break;        
                                }                                                        
                        }
    
                }
                
                // #### MULTIPLE SELECT CATEGORY ###############################
                else if ($type == 'levelmulti' OR $type == 'levelmultisearch')
                {
                        if (!empty($prepopulate))
                        {
                                // #### PREPOPULATION LOGIC FOR VARIOUS CONDITIONS ### 
                                switch ($prepopulate)
                                {
                                        case 'notifyservicescats':
                                        {
                                                $popsql = $ilance->db->query("
                                                        SELECT notifyservicescats
                                                        FROM " . DB_PREFIX . "users
                                                        WHERE user_id = '" . intval($userid) . "'
                                                ", 0, null, __FILE__, __LINE__);
                                                if ($ilance->db->num_rows($popsql) > 0)
                                                {
                                                        $cats = $ilance->db->fetch_array($popsql);
                                                        if (!empty($cats['notifyservicescats']))
                                                        {
                                                                $selection = explode(',', $cats['notifyservicescats']);
                                                                foreach ($selection as $catid)
                                                                {
                                                                        if (!empty($catid))
                                                                        {
                                                                                $scats['selected']["$catid"] = '1';
                                                                        }
                                                                }
                                                        }
                                                }
                                                break;        
                                        }                                    
                                        case 'notifyproductscats':
                                        {
                                                $popsql = $ilance->db->query("
                                                        SELECT notifyproductscats
                                                        FROM " . DB_PREFIX . "users
                                                        WHERE user_id = '" . intval($userid) . "'
                                                ", 0, null, __FILE__, __LINE__);
                                                if ($ilance->db->num_rows($popsql) > 0)
                                                {
                                                        $cats = $ilance->db->fetch_array($popsql);
                                                        if (!empty($cats['notifyproductscats']))
                                                        {
                                                                $selection = explode(',', $cats['notifyproductscats']);
                                                                foreach ($selection as $catid)
                                                                {
                                                                        if (!empty($catid))
                                                                        {
                                                                                $scats['selected']["$catid"] = '1';
                                                                        }
                                                                }
                                                        }
                                                }
                                                break;        
                                        }                                    
                                        case 'sellingprofile':
                                        {
                                                $popsql = $ilance->db->query("
                                                        SELECT cid
                                                        FROM " . DB_PREFIX . "profile_categories
                                                        WHERE user_id = '" . intval($userid) . "'
                                                ", 0, null, __FILE__, __LINE__);
                                                if ($ilance->db->num_rows($popsql) > 0)
                                                {
                                                        while ($cats = $ilance->db->fetch_array($popsql))
                                                        {
                                                                if (!empty($cats['cid']) AND $cats['cid'] > 0)
                                                                {
                                                                        $scats['selected'][$cats['cid']] = '1';	
                                                                }
                                                        }
                                                }
                                                break;        
                                        }
                                }
                        }
                        
                        if ($showbestmatching)
                        {
                                $html .= '<option value="0">' . $phrase['_best_matching'] . '</option>';
                        }
                        
                        $count = count($result);
                        for ($i = 0; $i < $count; $i++)
                        {
                                if ($result[$i]['visible'])
                                {
                                        if ($result[$i]['canpost'])
                                        {
                                                if (!empty($prepopulate) AND isset($scats['selected'][$result[$i]['cid']]) AND $scats['selected'][$result[$i]['cid']] == 1)
                                                {
                                                        if ($result[$i]['level'] == 1)
                                                        {
                                                                $categoryname = stripslashes($result[$i]['title']);
                                                        }
                                                        else
                                                        {
                                                                $categoryname = str_repeat('&nbsp; &nbsp; ', $result[$i]['level'] - 1) . stripslashes($result[$i]['title']);	
                                                        }
                                                        $html .= '<option value="' . $result[$i]['cid'] . '" selected="selected">' . $categoryname . '</option>';
                                                }
                                                else 
                                                {
                                                        if ($result[$i]['level'] == 1)
                                                        {
                                                                $categoryname = stripslashes($result[$i]['title']);
                                                        }
                                                        else
                                                        {
                                                                $categoryname = str_repeat('&nbsp; &nbsp; ', $result[$i]['level'] - 1) . stripslashes($result[$i]['title']);	
                                                        }
                                                        $html .= '<option value="' . $result[$i]['cid'] . '">' . $categoryname . '</option>';
                                                }
                                        }
                                        else 
                                        {
                                                if ($nooptgroups == 0)
                                                {
                                                        if ($result[$i]['level'] == 1)
                                                        {
                                                                $categoryname = stripslashes($result[$i]['title']);
                                                        }
                                                        else
                                                        {
                                                                $categoryname = str_repeat('&nbsp; &nbsp; ', $result[$i]['level'] - 1) . stripslashes($result[$i]['title']);	
                                                        }
                                                        $html .= '<optgroup label="' . $categoryname . '"></optgroup>'; 
                                                }
                                                else 
                                                {
                                                        if (!empty($prepopulate) AND isset($scats['selected'][$result[$i]['cid']]) AND $scats['selected'][$result[$i]['cid']] == 1)
                                                        {
                                                                if ($result[$i]['level'] == 1)
                                                                {
                                                                        $categoryname = stripslashes($result[$i]['title']);
                                                                }
                                                                else
                                                                {
                                                                        $categoryname = str_repeat('&nbsp; &nbsp; ', $result[$i]['level'] - 1) . stripslashes($result[$i]['title']);	
                                                                }
                                                                $html .= '<option value="' . $result[$i]['cid'] . '" selected="selected">' . $categoryname . '</option>';
                                                        }
                                                        else 
                                                        {
                                                                if ($result[$i]['level'] == 1)
                                                                {
                                                                        $categoryname = stripslashes($result[$i]['title']);
                                                                }
                                                                else
                                                                {
                                                                        $categoryname = str_repeat('&nbsp; &nbsp; ', $result[$i]['level'] - 1) . stripslashes($result[$i]['title']);	
                                                                }
                                                                $html .= '<option value="' . $result[$i]['cid'] . '">' . $categoryname . '</option>';
                                                        }
                                                }
                                        }
                                }
                        }
                }
                
                $html .= '</select>';
                
                ($apihook = $ilance->api('cat_print_pulldown_end')) ? eval($apihook) : false;
                
                return $html;
        }
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: class.categories_pulldown.inc.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>