<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

/**
* Feedback rating class to perform the majority of feedback and rating functions in ILance.
*
* @package      iLance
* @version	$Revision: 1.0.0 $
* @author       ILance
*/
class feedback_rating extends feedback
{
        /*
        * Function to insert a feedback rating from one user to another
        *
        * @param        integer     project id
        * @param        integer     for user id
        * @param        integer     from user id
        * @param        array       criteria ratings (only when giving feedback to seller)
        * @param        string      feedback comments
        * @param        string      feedback type (seller or buyer)
        * @param        string      feedback response experience (positive/neutral/negative)
        *
        * @return	string      Returns true if feedback was successfully inserted into the database
        */
        function insert_feedback_rating($projectid = 0, $for_user_id = 0, $from_user_id = 0, $criteria = array(), $comments = '', $from_type = '', $response = '')
        {
                global $ilance, $myapi, $phrase, $page_title, $area_title, $ilconfig, $ilpage;
                
                //echo "for_user_id:$for_user_id, from_user_id:$from_user_id, from_type:$from_type";
                //exit;
                
                // service provider rating buyer [for_user_id:1, from_user_id:9, from_type:buyer]
                
                // prevent a user from manipulating the feedback system
                $sql = $ilance->db->query("
                        SELECT id
                        FROM " . DB_PREFIX . "feedback
                        WHERE for_user_id = '" . intval($for_user_id) . "'
                                AND from_user_id = '" . intval($from_user_id) . "'
                                AND project_id = '" . intval($projectid) . "'
                ");
                if ($ilance->db->num_rows($sql) == 0)
                {
                        $ilance->db->query("
                                INSERT INTO " . DB_PREFIX . "feedback
                                (id, for_user_id, project_id, from_user_id, comments, date_added, response, type)
                                VALUES(
                                NULL,
                                '" . intval($for_user_id) . "',
                                '" . intval($projectid) . "',
                                '" . intval($from_user_id) . "',
                                '" . $ilance->db->escape_string($comments) . "',
                                '" . DATETIME24H . "',
                                '" . $ilance->db->escape_string($response) . "',
                                '" . $ilance->db->escape_string($from_type) . "')
                        ");
        
                        $criteriapreview = '--';
                        if ($from_type == 'seller')
                        {
                                $criteriapreview = '';
                                if (isset($criteria) AND is_array($criteria))
                                {
                                        foreach ($criteria AS $id => $rating)
                                        {
                                                $criteriapreview .= "* " . $this->fetch_title($id) . ": $rating\n";
                                                
                                                // insert detailed seller ratings
                                                $ilance->db->query("
                                                        INSERT INTO " . DB_PREFIX . "feedback_ratings
                                                        (id, user_id, project_id, criteria_id, rating)
                                                        VALUES
                                                        (NULL,
                                                        '" . intval($for_user_id) . "',
                                                        '" . intval($projectid) . "',
                                                        '" . intval($id) . "',
                                                        '{$rating}')
                                                ");
                                        }
                                }
                                
                                // #### buyer rating seller for buy now purchase #######
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "buynow_orders
                                        SET buyerfeedback = '1'
                                        WHERE project_id = '" . intval($projectid) . "'
                                                AND owner_id = '" . intval($for_user_id) . "'
                                                AND buyer_id = '" . intval($from_user_id) . "'
                                        LIMIT 1
                                ");
                                
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "projects_escrow
                                        SET buyerfeedback = '1'
                                        WHERE project_id = '" . intval($projectid) . "'
                                                AND project_user_id = '" . intval($for_user_id) . "'
                                                AND user_id = '" . intval($from_user_id) . "'
                                        LIMIT 1
                                ");
                                
                                // #### buyer rating service provider ##################
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "projects
                                        SET buyerfeedback = '1'
                                        WHERE project_id = '" . intval($projectid) . "'
                                                AND user_id = '" . intval($from_user_id) . "'
                                                AND project_state = 'service'
                                        LIMIT 1
                                ");
                                
                                // #### buyer rating seller ############################
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "projects
                                        SET buyerfeedback = '1'
                                        WHERE project_id = '" . intval($projectid) . "'
                                                AND user_id = '" . intval($for_user_id) . "'
                                                AND project_state = 'product'
                                        LIMIT 1
                                ");
                        }
                        else
                        {
                                // #### seller rating buyer for buy now purchase #######
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "buynow_orders
                                        SET sellerfeedback = '1'
                                        WHERE project_id = '" . intval($projectid) . "'
                                                AND owner_id = '" . intval($from_user_id) . "'
                                                AND buyer_id = '" . intval($for_user_id) . "'
                                        LIMIT 1
                                ");
                                
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "projects_escrow
                                        SET sellerfeedback = '1'
                                        WHERE project_id = '" . intval($projectid) . "'
                                                AND project_user_id = '" . intval($from_user_id) . "'
                                                AND user_id = '" . intval($for_user_id) . "'
                                        LIMIT 1
                                ");
                                
                                // #### service provider rating buyer ##################
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "projects
                                        SET sellerfeedback = '1'
                                        WHERE project_id = '" . intval($projectid) . "'
                                                AND user_id = '" . intval($for_user_id) . "'
                                        LIMIT 1
                                ");
                        }
                        
                        $ilance->email = construct_dm_object('email', $ilance);
        
                        $ilance->email->mail = SITE_EMAIL;
                        $ilance->email->slng = fetch_site_slng();
                        
                        $ilance->email->get('feedback_complete_admin');		
                        $ilance->email->set(array(
                                '{{username}}' => fetch_user('username', $from_user_id),
                                '{{customer}}' => fetch_user('username', $for_user_id),
                                '{{project_title}}' => fetch_auction('project_title', $projectid),
                                '{{project_id}}' => $projectid,
                                '{{feedback_comments}}' => $comments,
                                '{{ratings}}' => $criteriapreview                        
                        ));
                        
                        $ilance->email->send();
        
                        $ilance->email->mail = fetch_user('email', $for_user_id);
                        $ilance->email->slng = fetch_user_slng($for_user_id);
                        
                        $ilance->email->get('feedback_complete_buyer');		
                        $ilance->email->set(array(
                                '{{username}}' => fetch_user('username', $from_user_id),
                                '{{customer}}' => fetch_user('username', $for_user_id),
                                '{{project_title}}' => fetch_auction('project_title', $projectid),
                                '{{project_id}}' => $projectid,
                                '{{feedback_comments}}' => $comments,
                                '{{ratings}}' => $criteriapreview
                                
                        ));
                        
                        $ilance->email->send();
                        
                        return true;        
                }
                
                return false;
        }
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: class.feedback_rating.inc.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>