<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

/**
* MyCP class to perform the majority of functions found on the MyCP Control Panel Dashboard
*
* @package      iLance
* @version	$Revision: 1.0.0 $
* @author       ILance
*/
class mycp
{
	/*
	* Function to fetch the referral activity menu block
	*
	* @param      integer      user id
	* @param      integer      days ago range (default 1 year)
	* @param      integer      result limit (default 5)
	*
	* @return     string       Returns HTML formatted details of referral activity   
	*/
	function referal_activity($userid = 0, $daysago = 365, $userlimit = 5)
	{
		global $ilance, $myapi, $ilpage, $phrase, $ilconfig;
		
		$sql = $ilance->db->query("
			SELECT *
			FROM " . DB_PREFIX . "referral_data
			WHERE referred_by = '" . intval($userid) . "'
			ORDER BY date DESC
			LIMIT $userlimit
		", 0, null, __FILE__, __LINE__);
		if ($ilance->db->num_rows($sql) > 0)
		{
			$htmlbit = $html = $sep = '';
			$count = 0;
			while ($row = $ilance->db->fetch_array($sql))
			{
				$count++;
				$user = '<strong>'.fetch_user('username', $row['user_id']).'</strong>';
				$htmlbit .= '<hr size="1" width="100%" style="color:#cccccc" /><div>' . $user . '</div>';
				if ($row['postauction'] > 0)
				{
					$htmlbit .= $phrase['_posted_any_valid_auction'] . ' <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'checked.gif" /> ';
				}
				if ($row['awardauction'] > 0)
				{
					$htmlbit .= $phrase['_awarded_any_valid_bid'] . ' <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'checked.gif" /> ';
				}
				if ($row['paysubscription'] > 0)
				{
					$htmlbit .= $phrase['_paid_subscription'] . ' <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'checked.gif" /> ';
				}
				if ($row['payfvf'] > 0)
				{
					$htmlbit .= $phrase['_paid_final_value_fee'] . ' <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'checked.gif" /> ';
				}
				if ($row['payins'] > 0)
				{
					$htmlbit .= $phrase['_paid_insertion_fee'] . ' <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'checked.gif" /> ';
				}
				if ($row['paylanceads'] > 0)
				{
					$htmlbit .= $phrase['_paid_campaign_fee'] . ' <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'checked.gif" /> ';
				}
				if ($row['payportfolio'] > 0)
				{
					$htmlbit .= $phrase['_paid_portfolio_fee'] . ' <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'checked.gif" /> ';
				}
				if ($row['paycredentials'] > 0)
				{
					$htmlbit .= $phrase['_paid_any_credential_fee'] . ' <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'checked.gif" /> ';
				}
				if ($row['payenhancements'] > 0)
				{
					$htmlbit .= $phrase['_paid_auction_upsell_fee'] . ' <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'checked.gif" /> ';
				}
			}
			
			$html .= '<strong>' . $count . '</strong> ' . mb_strtolower($phrase['_referrals_found']) . ': ';
			$html .= $sep . $htmlbit;
		}
		else
		{
			$html = '0 ' . mb_strtolower($phrase['_referrals_found']);
		}
		
		return $html;
	}
    
	/*
	* Function to fetch the invitation activity for a particular bidder
	*
	* @param      integer      user id
	* @param      integer      days ago range (default 7 days)   
	*
	* @return     string       Returns HTML formatted details of invitation activity    
	*/
	function invitation_activity($userid = 0, $daysago = 7)
	{
		global $ilance, $myapi, $ilpage, $phrase, $ilconfig;
		
		$sql = $ilance->db->query("
			SELECT p.project_id, p.project_title, p.bids, p.status
			FROM " . DB_PREFIX . "projects AS p,
			" . DB_PREFIX . "project_invitations as i
			WHERE i.project_id = p.project_id
			    AND i.seller_user_id = '" . intval($userid) . "'
			    AND p.project_state = 'service'
			    AND i.bid_placed = 'no'
			    AND p.status = 'open'
		", 0, null, __FILE__, __LINE__);
		if ($ilance->db->num_rows($sql) > 0)
		{
			$invites = $ilance->db->num_rows($sql);
			$html = '<div>' . $phrase['_you_currently_have'] . ' <a href="' . $ilpage['selling'] . '?cmd=management&amp;bidsub=invited#servicebidding" title="' . $phrase['_view_my_invitations'] . '"><strong>' . $invites . '</strong></a> ' . $phrase['_buyers_waiting_for_you_to_place_a_bid_on_their_auctions'] . '</div>';
		}
		else
		{
			$html = '<div class="gray">' . $phrase['_you_have_not_been_invited_to_any_recent_auctions'] . '</div>';
		}
		
		return $html;
	}
	
	/*
	* Function to fetch the unread message count for a particular member
	*
	* @param      integer      user id
	*
	* @return     string       Returns HTML formatted details of the unread message count   
	*/
	function fetch_unread_messages($userid = 0)
	{
		global $ilance, $myapi, $ilpage, $phrase, $ilconfig;
		
		$sql = $ilance->db->query("
			SELECT id
			FROM " . DB_PREFIX . "pmb_alerts
			WHERE to_id = '" . intval($userid) . "'
			    AND to_status = 'new'
		", 0, null, __FILE__, __LINE__);
		if ($ilance->db->num_rows($sql) > 0)
		{
			$unreadcount = $ilance->db->num_rows($sql);
			$html = '<div>' . $phrase['_you_currently_have'] . ' <span class="blue"><a href="' . $ilpage['messages'] . '"><strong>' . $unreadcount . ' ' . $phrase['_unread'] . '</strong></a></span> ' . $phrase['_messages_waiting_in_your_inbox'] . '</div>';
		}
		else
		{
			$html = '<div class="gray">' . $phrase['_you_currently_have_no_new_messages_waiting'] . '</div>';
		}
		
		return $html;
	}
    
	/*
	* Function to fetch the scheduled transactions for a particular member
	*
	* @param      integer      user id
	* @param      integer      days ago range (default 7 days)        
	*
	* @return     string       Returns HTML formatted details of scheduled transactions up and coming      
	*/
	function scheduled_transactions($userid = 0, $daysago = 7)
	{
		global $ilance, $myapi, $ilpage, $phrase;
		
		$sql = $ilance->db->query("
			SELECT invoiceid, description, amount
			FROM " . DB_PREFIX . "invoices
			WHERE user_id = '" . intval($userid) . "'
			    AND status = 'scheduled'
			ORDER BY invoiceid DESC
		", 0, null, __FILE__, __LINE__);
		if ($ilance->db->num_rows($sql) > 0)
		{
			$html = '';
			
			while ($res = $ilance->db->fetch_array($sql));
			{
				$html .= '<div>' . $phrase['_scheduled_transaction'] . ': <a href="' . $ilpage['invoicepayment'] . '?id=' . $res['invoiceid'] . '">' . $phrase['_invoice_id'] . ' (' . $res['invoiceid'] . ')</a> - ' . stripslashes($res['description']) . ' - ' . $ilance->currency->format($res['amount']) . '.</div>';
			}
		}
		else
		{
			$html = $phrase['_no_scheduled_transactions_have_been_recorded'];
		}
		
		return $html;
	}
    
	/*
	* Function to fetch any unpaid transactions for a particular member
	*
	* @param      integer      user id
	*
	* @return     string       Returns HTML formatted details of unpaid transactions up and coming      
	*/
	function unpaid_transactions($userid = 0)
	{
		global $ilance, $myapi, $ilpage, $phrase;
		
		$html = '';
		$sql = $ilance->db->query("
			SELECT invoiceid, description
			FROM " . DB_PREFIX . "invoices
			WHERE user_id = '" . intval($userid) . "'
			    AND status = 'unpaid'
			    AND invoicetype != 'escrow'
			    AND isdeposit = '0'
			    AND iswithdraw = '0'
			ORDER BY invoiceid DESC
		", 0, null, __FILE__, __LINE__);
		if ($ilance->db->num_rows($sql) > 0)
		{
			$html .= '<strong>'.$phrase['_unpaid'].'</strong><br />';
			while ($res3 = $ilance->db->fetch_array($sql))
			{
				$html .= '<a href="' . $ilpage['invoicepayment'] . '?id=' . $res3['invoiceid'] . '"><span style="color:#990000"><strong>' . $phrase['_invoice_id'] . ' (' . $res3['invoiceid'] . ')</strong></span></a> - ' . stripslashes($res3['description']) . '<br />';
			}
		}
		else
		{
			$html = '<strong>' . $phrase['_unpaid'] . '</strong><br />' . $phrase['_no_unpaid_transactions_have_been_recorded'];
		}
		
		return $html;
	}
    
	/*
	* Function to fetch and print the accounting activity block for a particular member
	*
	* @param      integer      user id
	*
	* @return     string       Returns HTML formatted details of accounting information
	*/
	function accounting_activity($userid = 0)
	{
		global $ilance, $myapi, $ilpage, $phrase;
		
		$html = '';
		$sql = $ilance->db->query("
			SELECT invoiceid, description
			FROM " . DB_PREFIX . "invoices
			WHERE user_id = '" . intval($userid) . "'
			ORDER BY invoiceid DESC
			LIMIT 1
		", 0, null, __FILE__, __LINE__);
		if ($ilance->db->num_rows($sql) > 0)
		{
			$res = $ilance->db->fetch_array($sql);
			$html = '<div><strong>' . $phrase['_last_transaction_recorded'] . '</strong><br /><a href="' . $ilpage['invoicepayment'] . '?id=' . $res['invoiceid'] . '" title="' . stripslashes($res['description']) . '"><strong>' . $phrase['_invoice_id'] . ' (' . $res['invoiceid'] . ')</strong></a> - ' . stripslashes($res['description']) . '</div>';
			$html .= '<hr size="1" width="100%">';
		}
		else
		{
			$html = '<strong>' . $phrase['_last_transaction_recorded'] . '</strong><br />' . $phrase['_no_transactions_have_been_recorded'];
			$html .= '<hr size="1" width="100%">';
		}
		
		$html .= $this->unpaid_transactions($userid);
		
		return $html;
	}
    
	/*
	* Function to fetch any related escrow activity and notifications for the currently logged in member
	*
	* @param      integer       user id
	* @param      string        viewing type (default buyer)
	* @param      integer       days ago range (default 7)
	*
	* @return     string       Returns HTML formatted details of escrow activity or actions required by member
	*/
	function escrow_activity($userid = 0, $viewtype = 'buying', $daysago = 7)
	{
		global $ilance, $myapi, $ilpage, $phrase, $ilconfig;
		
		$type = ($viewtype == 'buying') ? 'service' : 'product';
		$html = '';
		
		if ($ilconfig['escrowsystem_enabled'])
		{
			switch ($viewtype)
			{
				case 'buying':
				{
					// #### BUYING SERVICES ESCROW NOTIFICATIONS ###################
					if ($ilconfig['globalauctionsettings_serviceauctionsenabled'])
					{
						// AS A BUYER: do we need to PAY any escrow account to any service providers?
						$sql = $ilance->db->query("
							SELECT e.escrow_id, e.project_id, p.project_title
							FROM " . DB_PREFIX . "projects_escrow AS e,
							" . DB_PREFIX . "projects AS p
							WHERE e.project_user_id = '" . intval($userid) . "'
								AND e.status = 'pending'
								AND e.project_id = p.project_id
								AND p.project_state = 'service'
							ORDER BY e.escrow_id DESC
						", 0, null, __FILE__, __LINE__);
						if ($ilance->db->num_rows($sql) > 0)
						{
							while ($res = $ilance->db->fetch_array($sql))
							{
								$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'escrow.gif" border="0" alt="' . $phrase['_escrow'] . '" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/money.gif" border="0" alt="' . $phrase['_payment_action'] . '" /> ' . $phrase['_project'] . ' <span class="blue"><a href="' . $ilpage['rfp'] . '?id=' . $res['project_id'] . '">' . $res['project_title'] . '</a></span> - ' . $phrase['_waiting_for_your_payment_to_fund_escrow_account'] . ' [ <span class="blue"><a href="' . $ilpage['buying'] . '?cmd=management&amp;sub=rfp-escrow"><strong>' . $phrase['_pay_now'] . '</strong></a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
							}
						}

						
						// #### BUYING SERVICES ESCROW NOTIFICATIONS ###################
						// AS A BUYER: do we need to RELEASE any funds in escrow to a service provider?
						$sql = $ilance->db->query("
							SELECT e.escrow_id, e.project_id, p.project_title
							FROM " . DB_PREFIX . "projects_escrow AS e,
							" . DB_PREFIX . "projects AS p
							WHERE e.project_user_id = '" . intval($userid) . "'
								AND e.status = 'confirmed'
								AND e.project_id = p.project_id
								AND p.project_state = 'service'
							ORDER BY e.escrow_id DESC", 0, null, __FILE__, __LINE__);
						if ($ilance->db->num_rows($sql) > 0)
						{
							while ($res = $ilance->db->fetch_array($sql))
							{
								$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'escrow.gif" border="0" alt="' . $phrase['_escrow'] . '" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/money.gif" border="0" alt="' . $phrase['_payment_action'] . '" /> ' . $phrase['_project'] . ' <span class="blue"><a href="' . $ilpage['rfp'] . '?id=' . $res['project_id'] . '">' . $res['project_title'] . '</a></span> - ' . $phrase['_provider_waiting_for_release_of_funds_within_escrow'] . ' [ <span class="blue"><a href="' . $ilpage['buying'] . '?cmd=management&amp;sub=rfp-escrow"><strong>' . $phrase['_release_funds'] . '</strong></a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
							}
						}
					}
					
					
					// #### BUYING PRODUCTS ESCROW NOTIFICATIONS ###################
					if ($ilconfig['globalauctionsettings_productauctionsenabled'])
					{
						// AS A BUYER: do we need to PAY any seller escrow account?
						$sql = $ilance->db->query("
							SELECT e.escrow_id, e.project_id, p.project_title
							FROM " . DB_PREFIX . "projects_escrow AS e,
							" . DB_PREFIX . "projects AS p
							WHERE e.user_id = '" . intval($userid) . "'
								AND e.status = 'pending'
								AND e.project_id = p.project_id
								AND p.project_state = 'product'
							ORDER BY e.escrow_id DESC", 0, null, __FILE__, __LINE__);
						if ($ilance->db->num_rows($sql) > 0)
						{
							while ($res = $ilance->db->fetch_array($sql))
							{
								$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'escrow.gif" border="0" alt="' . $phrase['_escrow'] . '" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/money.gif" border="0" alt="' . $phrase['_payment_action'] . '" /> ' . $phrase['_item'] . ' <span class="blue"><a href="' . $ilpage['merch'] . '?id=' . $res['project_id'] . '">' . $res['project_title'] . '</a></span> - ' . $phrase['_waiting_for_your_payment_to_fund_escrow_account'] . '[ <span class="blue"><a href="' . $ilpage['buying'] . '?cmd=management&amp;sub=product-escrow"><strong>' . $phrase['_pay_now'] . '</strong></a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
							}
						}
						
						// #### BUYING PRODUCTS ESCROW NOTIFICATIONS ###################
						// AS A BUYER: do we need to RELEASE any funds in escrow to a seller?
						$sql5 = $ilance->db->query("
							SELECT e.escrow_id, e.project_id, p.project_title
							FROM " . DB_PREFIX . "projects_escrow AS e,
							" . DB_PREFIX . "projects AS p
							WHERE e.user_id = '" . intval($userid) . "'
								AND e.status = 'confirmed'
								AND e.project_id = p.project_id
								AND p.project_state = 'product'
							ORDER BY e.escrow_id DESC
						", 0, null, __FILE__, __LINE__);
						if ($ilance->db->num_rows($sql5) > 0)
						{
							while ($res = $ilance->db->fetch_array($sql5))
							{
								$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'escrow.gif" border="0" alt="' . $phrase['_escrow'] . '" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/money.gif" border="0" alt="' . $phrase['_payment_action'] . '" /> ' . $phrase['_item'] . ' <span class="blue"><a href="' . $ilpage['merch'] . '?id=' . $res['project_id'] . '">' . $res['project_title'] . '</a></span> - ' . $phrase['_merchant_waiting_for_release_of_funds_within_escrow'] . '[ <span class="blue"><a href="' . $ilpage['buying'] . '?cmd=management&amp;sub=product-escrow"><strong>' . $phrase['_release_funds'] . '</strong></a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
							}
						}
						
						// #### BUYING ITEMS VIA PURCHASE NOW - ESCROW NOTIFICATIONS ##
						// AS A BUYER (we've already paid the cost): do we need to HOUND any merchants for delivery status?
						$sql = $ilance->db->query("
							SELECT e.orderid, e.project_id, p.project_title
							FROM " . DB_PREFIX . "buynow_orders AS e,
							" . DB_PREFIX . "projects AS p
							WHERE e.buyer_id = '" . intval($userid) . "'
								AND e.status = 'paid'
								AND e.project_id = p.project_id
								AND p.project_state = 'product'
							ORDER BY e.orderid DESC
						", 0, null, __FILE__, __LINE__);
						if ($ilance->db->num_rows($sql) > 0)
						{
							while ($res = $ilance->db->fetch_array($sql))
							{
								$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'escrow.gif" border="0" alt="' . $phrase['_escrow'] . '" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/cart.gif" border="0" alt="" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'freeshipping.gif" border="0" alt="" /> ' . $phrase['_item'] . ' <span class="blue"><a href="' . $ilpage['merch'] . '?id=' . $res['project_id'] . '">' . $res['project_title'] . '</a></span> - ' . $phrase['_waiting_for_merchant_to_update_order_as_delivered'] . ' [ <span class="blue"><a href="' . $ilpage['buying'] . '?cmd=management&amp;sub=buynow-escrow#purchasenow">' . $phrase['_click_here_to_view_details'] . '</a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
							}
						}
						
						// #### BUYING ITEMS VIA REGULAR ESCROW
						// AS A BUYER (we've already paid the cost): do we need to HOUND any sellers for delivery status?
						$sql = $ilance->db->query("
							SELECT e.escrow_id, e.project_id, p.project_title
							FROM " . DB_PREFIX . "projects_escrow AS e,
							" . DB_PREFIX . "projects AS p
							WHERE e.user_id = '" . intval($userid) . "'
								AND e.status = 'started'
								AND e.project_id = p.project_id
								AND p.project_state = 'product'
							ORDER BY e.escrow_id DESC
						", 0, null, __FILE__, __LINE__);
						if ($ilance->db->num_rows($sql) > 0)
						{
							while ($res = $ilance->db->fetch_array($sql))
							{
								$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'escrow.gif" border="0" alt="' . $phrase['_escrow'] . '" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/cart.gif" border="0" alt="" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'freeshipping.gif" border="0" alt="" /> ' . $phrase['_item'] . ' <span class="blue"><a href="' . $ilpage['merch'] . '?id=' . $res['project_id'] . '">' . $res['project_title'] . '</a></span> - ' . $phrase['_waiting_for_merchant_to_update_order_as_delivered'] . ' [ <span class="blue"><a href="' . $ilpage['buying'] . '?cmd=management&amp;sub=product-escrow">' . $phrase['_click_here_to_view_details'] . '</a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
							}
						}
						
						// #### BUYING ITEMS VIA PURCHASE NOW - ESCROW NOTIFICATIONS ##
						// AS A BUYER (already paid, and assumed shipped): do we need to RELEASE any funds in escrow to merchants?
						$sql = $ilance->db->query("
							SELECT e.orderid, e.project_id, p.project_title
							FROM " . DB_PREFIX . "buynow_orders as e,
							" . DB_PREFIX . "projects as p
							WHERE e.buyer_id = '" . intval($userid) . "'
								AND e.status = 'pending_delivery'
								AND e.project_id = p.project_id
								AND p.project_state = 'product'
							ORDER BY e.orderid DESC
						", 0, null, __FILE__, __LINE__);
						if ($ilance->db->num_rows($sql) > 0)
						{
							while ($res = $ilance->db->fetch_array($sql))
							{
								$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'escrow.gif" border="0" alt="' . $phrase['_escrow'] . '" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/cart.gif" border="0" alt="" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/money.gif" border="0" alt="" /> ' . $phrase['_item'] . ' <span class="blue"><a href="' . $ilpage['merch'] . '?id=' . $res['project_id'] . '">' . $res['project_title'] . '</a></span> - '.$phrase['_merchant_waiting_for_release_of_funds_within_escrow'].' [ <span class="blue"><a href="' . $ilpage['buying'] . '?cmd=management&amp;sub=buynow-escrow#purchasenow"><strong>'.$phrase['_release_funds'].'</strong></a></span></div><hr size="1" width="100%" style="color:#cccccc" />';
							}
						}
						break;
					}
				}				
				case 'selling':
				{
					// #### SELLING SERVICES ESCROW NOTIFICATIONS ##################
					if ($ilconfig['globalauctionsettings_serviceauctionsenabled'])
					{
						// AS A PROVIDER: are we waiting for buyers to release any funds to us as a service provider?
						$sql = $ilance->db->query("
							SELECT e.escrow_id, e.project_id, p.project_title
							FROM " . DB_PREFIX . "projects_escrow as e,
							" . DB_PREFIX . "projects as p
							WHERE e.user_id = '" . intval($userid) . "'
								AND e.status = 'confirmed'
								AND e.project_id = p.project_id
								AND p.project_state = 'service'
							ORDER BY e.escrow_id DESC
						", 0, null, __FILE__, __LINE__);
						if ($ilance->db->num_rows($sql) > 0)
						{
							while ($res = $ilance->db->fetch_array($sql))
							{
								$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'escrow.gif" border="0" alt="' . $phrase['_escrow'] . '" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/money.gif" border="0" alt="' . $phrase['_payment_action'] . '" /> ' . $phrase['_project'] . ' <span class="blue"><a href="' . $ilpage['rfp'] . '?id=' . $res['project_id'] . '">' . $res['project_title'] . '</a></span> - ' . $phrase['_waiting_for_escrow_release_into_my_account'] . ' [ <span class="blue"><a href="' . $ilpage['selling'] . '?cmd=management&amp;bidsub=rfp-escrow">' . $phrase['_click_here_to_view_details'] . '</a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
							}
						}
						
						// #### SELLING SERVICES ESCROW NOTIFICATIONS ##################
						// AS A PROVIDER: did any buyers release funds to finish the project *within last 7 days?
						$sql = $ilance->db->query("
							SELECT e.escrow_id, e.project_id, p.project_title
							FROM " . DB_PREFIX . "projects_escrow as e,
							" . DB_PREFIX . "projects as p
							WHERE e.user_id = '" . intval($userid) . "'
								AND e.status = 'finished'
								AND e.project_id = p.project_id
								AND p.project_state = 'service'
								AND e.date_awarded > DATE_SUB('" . DATETIME24H . "', INTERVAL 7 DAY)
							ORDER BY e.escrow_id DESC", 0, null, __FILE__, __LINE__);
						if ($ilance->db->num_rows($sql) > 0)
						{
							while ($res = $ilance->db->fetch_array($sql))
							{
								$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'escrow.gif" border="0" alt="' . $phrase['_escrow'] . '" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/money.gif" border="0" alt="' . $phrase['_payment_action'] . '" /> ' . $phrase['_project'] . ' <span class="blue"><a href="' . $ilpage['rfp'] . '?id=' . $res['project_id'] . '">' . $res['project_title'] . '</a></span> - ' . $phrase['_funds_have_been_released_into_your_online_account'] . ' [ <span class="blue"><a href="' . $ilpage['selling'] . '?cmd=management&amp;bidsub=rfp-escrow">' . $phrase['_click_here_to_view_details'] . '</a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
							}
						}
					}
					
					// #### SELLING PRODUCTS ESCROW NOTIFICATIONS ##################
					if ($ilconfig['globalauctionsettings_productauctionsenabled'])
					{
						// AS A MERCHANT: are we waiting for bidders to release any funds to us as a merchant?
						$sql = $ilance->db->query("
							SELECT e.escrow_id, e.project_id, p.project_title
							FROM " . DB_PREFIX . "projects_escrow as e,
							" . DB_PREFIX . "projects as p
							WHERE e.project_user_id = '" . intval($userid) . "'
								AND e.status = 'confirmed'
								AND e.project_id = p.project_id
								AND p.project_state = 'product'
							ORDER BY e.escrow_id DESC", 0, null, __FILE__, __LINE__);
						if ($ilance->db->num_rows($sql) > 0)
						{
							while ($res = $ilance->db->fetch_array($sql))
							{
								$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'escrow.gif" border="0" alt="' . $phrase['_escrow'] . '" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/money.gif" border="0" alt="' . $phrase['_payment_action'] . '" /> ' . $phrase['_item'] . ' <span class="blue"><a href="' . $ilpage['merch'] . '?id=' . $res['project_id'] . '">' . $res['project_title'] . '</a></span> - ' . $phrase['_waiting_for_escrow_release_into_my_account'] . ' [ <span class="blue"><a href="' . $ilpage['selling'] . '?cmd=management&amp;sub=product-escrow">' . $phrase['_click_here_to_view_details'] . '</a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
							}
						}
						
						// #### SELLING PRODUCTS ESCROW NOTIFICATIONS ##################
						// AS A MERCHANT: did any bidders release funds to finish the escrow purchase *within last 7 days?
						$sql = $ilance->db->query("
							SELECT e.escrow_id, e.project_id, p.project_title
							FROM " . DB_PREFIX . "projects_escrow as e,
							" . DB_PREFIX . "projects as p
							WHERE e.project_user_id = '" . intval($userid) . "'
								AND e.status = 'finished'
								AND e.project_id = p.project_id
								AND p.project_state = 'product'
								AND e.date_awarded > DATE_SUB('" . DATETIME24H . "', INTERVAL 7 DAY)
							ORDER BY e.escrow_id DESC", 0, null, __FILE__, __LINE__);
						if ($ilance->db->num_rows($sql) > 0)
						{
							while ($res = $ilance->db->fetch_array($sql))
							{
								$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'escrow.gif" border="0" alt="' . $phrase['_escrow'] . '" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/money.gif" border="0" alt="' . $phrase['_payment_action'] . '" /> ' . $phrase['_item'] . ' <span class="blue"><a href="' . $ilpage['merch'] . '?id=' . $res['project_id'] . '">' . $res['project_title'] . '</a></span> - '.$phrase['_funds_have_been_released_into_your_online_account'] . ' [ <span class="blue"><a href="'.$ilpage['selling'].'?cmd=management&amp;sub=product-escrow">' . $phrase['_click_here_to_view_details'] . '</a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
							}
						}
						
						// #### SELLING PRODUCTS ESCROW NOTIFICATIONS ##################
						// AS A MERCHANT: do we need to confirm any shipment of products or downloads via escrow?
						$sql = $ilance->db->query("
							SELECT e.escrow_id, e.project_id, p.project_title
							FROM " . DB_PREFIX . "projects_escrow as e,
							" . DB_PREFIX . "projects as p
							WHERE e.project_user_id = '" . intval($userid) . "'
								AND e.status = 'started'
								AND e.project_id = p.project_id
								AND p.project_state = 'product'
							ORDER BY e.escrow_id DESC
						", 0, null, __FILE__, __LINE__);
						if ($ilance->db->num_rows($sql) > 0)
						{
							while ($res = $ilance->db->fetch_array($sql))
							{
								$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'escrow.gif" border="0" alt="' . $phrase['_escrow'] . '" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'freeshipping.gif" border="0" alt="" /> ' . $phrase['_item'] . ' <span class="blue"><a href="' . $ilpage['merch'] . '?id=' . $res['project_id'] . '">' . $res['project_title'] . '</a> - '.$phrase['_waiting_for_you_to_update_the_delivery_status_to_confirmed_for_this_order'].' <a href="'.$ilpage['selling'].'?cmd=management&amp;sub=product-escrow">' . $phrase['_click_here_to_view_details'] . '</a></div><hr size="1" width="100%" style="color:#cccccc" />';
							}
						}
						
						// #### SELLING ITEMS VIA PURCHASE NOW - ESCROW NOTIFICATIONS ##
						// AS A PURCHASE NOW MERCHANT (bidder already paid the cost): do we need to set any deliveries to sent/delivered?
						$sql = $ilance->db->query("
							SELECT e.orderid, e.project_id, p.project_title
							FROM " . DB_PREFIX . "buynow_orders as e,
							" . DB_PREFIX . "projects as p
							WHERE e.owner_id = '" . intval($userid) . "'
								AND e.status = 'paid'
								AND e.project_id = p.project_id
								AND p.project_state = 'product'
							ORDER BY e.orderid DESC
						", 0, null, __FILE__, __LINE__);
						if ($ilance->db->num_rows($sql) > 0)
						{
							while ($res = $ilance->db->fetch_array($sql))
							{
								$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'escrow.gif" border="0" alt="' . $phrase['_escrow'] . '" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/cart.gif" border="0" alt="" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'freeshipping.gif" border="0" alt="" /> ' . $phrase['_item'] . ' <span class="blue"><a href="' . $ilpage['merch'] . '?id=' . $res['project_id'] . '">' . $res['project_title'] . '</a></span> - ' . $phrase['_waiting_for_you_to_update_order_as_delivered'] . ' [ <span class="blue"><a href="' . $ilpage['selling'] . '?cmd=management">' . $phrase['_click_here_to_view_details'] . '</a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
							}
						}
						
						// #### SELLING ITEMS VIA PURCHASE NOW - ESCROW NOTIFICATIONS ##
						// AS A PURCHASE NOW MERCHANT (already paid, and assumed shipped): do we need to HOUND any bidders for funds in escrow?
						$sql = $ilance->db->query("
							SELECT e.orderid, e.project_id, p.project_title
							FROM " . DB_PREFIX . "buynow_orders as e,
							" . DB_PREFIX . "projects as p
							WHERE e.owner_id = '" . intval($userid) . "'
								AND e.status = 'pending_delivery'
								AND e.project_id = p.project_id
								AND p.project_state = 'product'
							ORDER BY e.orderid DESC
						", 0, null, __FILE__, __LINE__);
						if ($ilance->db->num_rows($sql) > 0)
						{
							while ($res = $ilance->db->fetch_array($sql))
							{
								$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'escrow.gif" border="0" alt="' . $phrase['_escrow'] . '" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/cart.gif" border="0" alt="" /> <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/money.gif" border="0" alt="" /> ' . $phrase['_item'] . ' <span class="blue"><a href="' . $ilpage['merch'] . '?id=' . $res['project_id'] . '">' . $res['project_title'] . '</a></span> - ' . $phrase['_waiting_for_escrow_release_into_my_account'] . ' [ <span class="blue"><a href="' . $ilpage['selling'] . '?cmd=management&amp;sub=product-escrow">' . $phrase['_click_here_to_view_details'] . '</a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
							}
						}
					}
					break;
				}
			}
			
			return $html;
		}
	}
    
	/*
	* Function to fetch any bids or bidding activity and notifications for the currently logged in member
	*
	* @param      integer       user id
	* @param      string        viewing type (default buying)
	* @param      integer       days ago range (default 7)
	*
	* @return     string       Returns HTML formatted details of bids activity or actions required by member
	*/
	function bids_activity($userid = 0, $viewtype = 'buying', $daysago = 7)
	{
		global $ilconfig, $ilance, $ilpage, $phrase;
	
		$type = ($viewtype == 'buying') ? 'service' : 'product';
		$html = '';
		
		// collect all auctions posted by this member
		$prj = $ilance->db->query("
			SELECT project_details, project_state, project_id, project_title
			FROM " . DB_PREFIX . "projects
			WHERE user_id = '" . intval($userid) . "'
				AND status != 'expired'
				AND status != 'finished'
				AND project_state = '" . $type . "'
			ORDER BY date_added DESC
		", 0, null, __FILE__, __LINE__);
		if ($ilance->db->num_rows($prj) > 0)
		{
			while ($projects = $ilance->db->fetch_array($prj))
			{
				if ($projects['project_details'] == 'unique')
				{
					// fetch all bid counts for this unique bid auction in last 7 days
					$sql = $ilance->db->query("
						SELECT COUNT(*) AS count
						FROM " . DB_PREFIX . "projects_uniquebids
						WHERE project_id = '" . $projects['project_id'] . "'
						    AND date >= DATE_SUB('" . DATETIME24H . "', INTERVAL $daysago DAY)
					", 0, null, __FILE__, __LINE__);
					if ($ilance->db->num_rows($sql) > 0)
					{
						$res = $ilance->db->fetch_array($sql);
						if ($res['count'] > 0)
						{
							$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid.gif" border="0" alt="" /> ' . intval($res['count']) . ' ' . $phrase['_new_bids_were_placed_on_your_unique_bid_auction'] . ' - <span class="blue"><a href="' . $ilpage['merch'] . '?id=' . $projects['project_id'] . '">' . stripslashes($projects['project_title']) . '</a></span></div><hr size="1" width="100%" style="color:#cccccc" />';
						}
					}
				}
				else
				{
						// fetch all bid counts for this members project(s) in last 7 days
						$sql = $ilance->db->query("
							SELECT COUNT(*) AS count
							FROM " . DB_PREFIX . "project_bids
							WHERE project_id = '" . $projects['project_id'] . "'
								AND date_added >= DATE_SUB('" . DATETIME24H . "', INTERVAL $daysago DAY)
								AND bidstatus != 'declined'
								AND bidstate != 'retracted'
						", 0, null, __FILE__, __LINE__);
						if ($ilance->db->num_rows($sql) > 0)
						{
						$res = $ilance->db->fetch_array($sql);
						switch ($type)
						{
							case 'service':
							{
								if ($res['count'] > 0)
								{
									$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid.gif" border="0" alt="" /> ' . intval($res['count']) . ' ' . $phrase['_new_bids_were_placed_on_your_service_auction'] . ' <span class="blue"><a href="' . $ilpage['rfp'] . '?id=' . $projects['project_id'] . '">' . stripslashes($projects['project_title']) . '</a></span></div><hr size="1" width="100%" style="color:#cccccc" />';
								}
								break;
							}							
							case 'product':
							{
								if ($res['count'] > 0)
								{
									$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid.gif" border="0" alt="" /> ' . intval($res['count']) . ' ' . $phrase['_new_bids_were_placed_on_your_product_auction'] . ' <span class="blue"><a href="' . $ilpage['merch'] . '?id=' . $projects['project_id'] . '">' . stripslashes($projects['project_title']) . '</a></span></div><hr size="1" width="100%" style="color:#cccccc" />';
								}
								break;
							}
						}
					}
				}
			}
		}
		
		return $html;
	}
	
	/*
	* Function to fetch any bids award activity and notifications for the currently logged in member
	*
	* @param      integer       user id
	* @param      string        viewing type (buying or selling)
	* @param      string        category type (service or product)
	* @param      integer       days ago range (default 7)
	*
	* @return     string        Returns HTML formatted details of bidding award activity or actions required by member
	*/
	function bids_award_activity($userid = 0, $viewtype = 'buying', $cattype = 'service', $daysago = 7)
	{
		global $ilance, $myapi, $phrase, $ilconfig, $ilpage;
		
		$html = '';
		
		if ($viewtype == 'buying')
		{
			// #### buying a product as a buyer
			if ($cattype == 'product')
			{
				$sql = $ilance->db->query("
					SELECT bid_id, project_id, bidamount, qty, date_awarded
					FROM " . DB_PREFIX . "project_bids
					WHERE user_id = '" . $userid . "'
						AND state = '" . $cattype . "'
						AND (bidstatus = 'awarded' AND bidstate = 'wait_approval'
							OR bidstatus = 'placed' AND bidstate = 'wait_approval'
							OR bidstatus = 'awarded' AND bidstate = '')
						AND date_awarded > DATE_SUB('" . DATETIME24H . "', INTERVAL $daysago DAY)
				", 0, null, __FILE__, __LINE__);
				if ($ilance->db->num_rows($sql) > 0)
				{
					while ($res = $ilance->db->fetch_array($sql))
					{
						$date = '<strong>' . print_date($res['date_awarded'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 0, 0) . '</strong>';
						$cost = '<strong>' . $ilance->currency->format($res['bidamount']) . '</strong>';
						$name = fetch_auction('project_title', $res['project_id']);
						$bidid = $res['bid_id'];
						$html .= '<div><strong>' . $phrase['_congratulations'] . '</strong> ' . $ilance->language->construct_phrase($phrase['_your_bid_for_x_was_awarded_on_x_for_the_x_x_auction'], array($cost, $date, '<span class="blue"><a href="' . $ilpage['buying'] . '?cmd=management&amp;bidsub=awarded#product">' . $name . '</a></span>', $cattype)) . '</div><hr size="1" width="100%" style="color:#cccccc" />';
					}
				}
				
				// #### lowest unique bid auction ##############
				$sql = $ilance->db->query("
					SELECT u.uid, u.project_id, u.project_user_id, u.user_id, u.uniquebid, u.response, u.date, u.status, u.totalbids
					FROM " . DB_PREFIX . "projects_uniquebids AS u,
					" . DB_PREFIX . "projects AS p
					WHERE p.project_id = u.project_id
						AND u.user_id = '" . $userid . "'
						AND u.status = 'lowestunique'
						AND u.date > DATE_SUB('" . DATETIME24H . "', INTERVAL $daysago DAY)
						AND p.status != 'open'
						AND p.haswinner = '1'
						AND p.winner_user_id = '" . $userid . "'
				", 0, null, __FILE__, __LINE__);
				if ($ilance->db->num_rows($sql) > 0)
				{
					while ($res = $ilance->db->fetch_array($sql))
					{
						$date = '<strong>' . print_date($res['date'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 0, 0) . '</strong>';
						$cost = '<strong>' . $ilance->currency->format($res['uniquebid']) . '</strong>';
						$name = fetch_auction('project_title', $res['project_id']);
						$bidid = $res['uid'];
						$html .= '<div><strong>' . $phrase['_congratulations'] . '</strong> ' . $ilance->language->construct_phrase($phrase['_your_bid_for_x_was_awarded_on_x_for_the_x_x_auction'], array($cost, $date, '<span class="blue"><a href="' . $ilpage['buying'] . '?cmd=management&amp;subcmd=lub&amp;bidsub=awarded#product">' . $name . '</a></span>', mb_strtolower($phrase['_lowest_unique_bid']))) . '</div><hr size="1" width="100%" style="color:#cccccc" />';
					}
				}
			}
		}
		else if ($viewtype == 'selling')
		{
			// #### selling services to a buyer
			if ($cattype == 'product')
			{
				$sql2 = $ilance->db->query("
					SELECT bid_id, project_id, bidamount, qty, date_awarded
					FROM " . DB_PREFIX . "project_bids
					WHERE project_user_id = '" . $userid . "'
						AND state = '" . $cattype . "'
						AND (bidstatus = 'awarded' AND bidstate = 'wait_approval'
							OR bidstatus = 'placed' AND bidstate = 'wait_approval'
							OR bidstatus = 'awarded' AND bidstate = '')
						AND date_awarded > DATE_SUB('" . DATETIME24H . "', INTERVAL $daysago DAY)
				", 0, null, __FILE__, __LINE__);
				if ($ilance->db->num_rows($sql2) > 0)
				{
					while ($res = $ilance->db->fetch_array($sql2))
					{
						$date = '<strong>' . print_date($res['date_awarded'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 0, 0) . '</strong>';
						$cost = '<strong>' . $ilance->currency->format($res['bidamount']) . '</strong>';
						$name = fetch_auction('project_title', $res['project_id']);
						$bidid = $res['bid_id'];
						$html .= '<div><strong>' . $phrase['_congratulations'] . '</strong> ' . $phrase['_your_item']. ' <span class="blue"><a href="' . $ilpage['selling'] . '?cmd=management&amp;sub=sold">' . $name . '</a></span> ' . $phrase['_sold_to_the_highest_winning_bidder_for'] . ' ' . $cost . ' ' . $phrase['_on'] . ' ' . $date . '</div><hr size="1" width="100%" style="color:#cccccc" />';
					}
				}
				
				$sql2 = $ilance->db->query("
					SELECT u.uid, u.project_id, u.project_user_id, u.user_id, u.uniquebid, u.response, u.date, u.status, u.totalbids
					FROM " . DB_PREFIX . "projects_uniquebids AS u,
					" . DB_PREFIX . "projects AS p
					WHERE p.project_id = u.project_id
						AND u.project_user_id = '" . $userid . "'
						AND u.status = 'lowestunique'
						AND u.date > DATE_SUB('" . DATETIME24H . "', INTERVAL $daysago DAY)
						AND p.status != 'open'
						AND p.haswinner = '1'
				", 0, null, __FILE__, __LINE__);
				if ($ilance->db->num_rows($sql2) > 0)
				{
					while ($res = $ilance->db->fetch_array($sql2))
					{
						$date = '<strong>' . print_date($res['date'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 0, 0) . '</strong>';
						$cost = '<strong>' . $ilance->currency->format($res['uniquebid']) . '</strong>';
						$name = fetch_auction('project_title', $res['project_id']);
						$bidid = $res['uid'];
						$html .= '<div><strong>' . $phrase['_congratulations'] . '</strong> ' . $phrase['_your_item']. ' <span class="blue"><a href="' . $ilpage['selling'] . '?cmd=management&amp;sub=sold">' . $name . '</a></span> ' . $phrase['_sold_to_the_lowest_unique_winning_bidder_for'] . ' ' . $cost . ' ' . $phrase['_on'] . ' ' . $date . '</div><hr size="1" width="100%" style="color:#cccccc" />';
					}
				}
			}
			
			// #### inform a seller that one or more auctions have sold to a winning bidder
			// #### inform a provider that one or more bids have been awarded and waiting for response via accept or reject
			else if ($cattype == 'service')
			{
				$sqlextra = "
					     AND (bidstatus = 'awarded' AND bidstate = 'wait_approval'
					       OR bidstatus = 'placed'  AND bidstate = 'wait_approval'
					       OR bidstatus = 'awarded' AND bidstate = '')
				";
				$sql2 = $ilance->db->query("
					SELECT bid_id, project_id, bidamount, qty, date_awarded
					FROM " . DB_PREFIX . "project_bids
					WHERE user_id = '" . $userid . "'
						AND state = '" . $cattype . "'
						$sqlextra
						AND date_awarded > DATE_SUB('" . DATETIME24H . "', INTERVAL $daysago DAY)
				", 0, null, __FILE__, __LINE__);
				if ($ilance->db->num_rows($sql2) > 0)
				{
					while ($res = $ilance->db->fetch_array($sql2))
					{
						$date = '<strong>' . print_date($res['date_awarded'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 0, 0) . '</strong>';
						$cost = '<strong>' . $ilance->currency->format($res['bidamount']) . '</strong>';
						$name = fetch_auction('project_title', $res['project_id']);
						$bidid = $res['bid_id'];
						$html .= '<div>' . $ilance->language->construct_phrase($phrase['_your_bid_for_x_was_awarded_on_x_for_the_x_x_auction'], array($cost, $date, '<span class="blue"><a href="' . $ilpage['selling'] . '?cmd=management&amp;bidsub=awarded#servicebidding">' . $name . '</a></span>', $cattype)) . '</div><hr size="1" width="100%" style="color:#cccccc" />';
					}
				}
			}
		}
		
		return $html;
	}
	
	/*
	* Function to fetch any feedback actions or related activity and notifications for the currently logged in member
	*
	* @param      integer       user id
	*
	* @return     string        Returns HTML formatted details of feedback activity or actions required by member
	*/
	function feedback_activity($userid = 0, $daysago = 7)
	{
		global $ilance, $myapi, $ilpage, $phrase, $ilconfig;
		
		$html = '';
		
		// #### AS A PRODUCT BUYER BUYING BUY NOW ITEMS ################
		// does the buyer need to leave feedback for any seller purchased via buy now?
		$query = $ilance->db->query("
			SELECT project_id, owner_id
			FROM " . DB_PREFIX . "buynow_orders
			WHERE buyer_id = '" . intval($userid) . "'
				AND buyerfeedback = '0'
		", 0, null, __FILE__, __LINE__);
		if ($ilance->db->num_rows($query) > 0)
		{
			while ($res = $ilance->db->fetch_array($query))
			{
				$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/cart.gif" border="0" alt="' . $phrase['_buy_now'] . '" /> ' . $phrase['_buy_now_item'] . ': <span class="blue"><a href="' . $ilpage['merch'] . '?id=' . $res['project_id'] . '">' . fetch_auction('project_title', $res['project_id']) . '</a></span>: ' . $phrase['_seller_is_waiting_for_your_feedback'] . ' [ <span class="blue"><a href="' . $ilpage['buying'] . '?cmd=management&amp;sub=buynow-escrow">' . $phrase['_leave_feedback'] . '</a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
			}
		}
		
		// #### AS A PRODUCT SELLER SELLING BUY NOW ITEMS ##############
		// does the seller need to leave feedback for any buyer purchased via buy now?
		$query = $ilance->db->query("
			SELECT project_id, buyer_id
			FROM " . DB_PREFIX . "buynow_orders
			WHERE owner_id = '" . intval($userid) . "'
				AND sellerfeedback = '0'
		", 0, null, __FILE__, __LINE__);
		if ($ilance->db->num_rows($query) > 0)
		{
			while ($res = $ilance->db->fetch_array($query))
			{
				$html .= '<div><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/cart.gif" border="0" alt="' . $phrase['_buy_now'] . '" /> ' . $phrase['_buy_now_item'] . ': <span class="blue"><a href="' . $ilpage['merch'] . '?id=' . $res['project_id'] . '">' . fetch_auction('project_title', $res['project_id']) . '</a></span>: ' . $phrase['_buyer_is_waiting_for_your_feedback'] . ' [ <span class="blue"><a href="' . $ilpage['selling'] . '?cmd=management&amp;sub=sold">' . $phrase['_leave_feedback'] . '</a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
			}
		}
		
		// #### AS A PRODUCT SELLER SELLING LOWEST UNIQUE BID ITEMS ####
		// does the seller need to leave feedback for any buyer who won via LUB auction?
		$query = $ilance->db->query("
			SELECT ub.project_id
			FROM " . DB_PREFIX . "projects_uniquebids AS ub,
			" . DB_PREFIX . "projects AS p
			WHERE ub.project_id = p.project_id
				AND ub.status = 'lowestunique'
				AND ub.project_user_id = '" . intval($userid) . "'
				AND p.sellerfeedback = '0'
				AND p.haswinner = '1'
				AND p.status != 'open'
		", 0, null, __FILE__, __LINE__);
		if ($ilance->db->num_rows($query) > 0)
		{
			while ($res = $ilance->db->fetch_array($query))
			{
				$html .= '<div>' . $phrase['_lowest_unique_bid'] . ' ' . $phrase['_item'] . ': <span class="blue"><a href="' . $ilpage['merch'] . '?id=' . $res['project_id'] . '">' . fetch_auction('project_title', $res['project_id']) . '</a></span>: ' . $phrase['_buyer_is_waiting_for_your_feedback'] . ' [ <span class="blue"><a href="' . $ilpage['selling'] . '?cmd=management&amp;sub=sold">' . $phrase['_leave_feedback'] . '</a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
			}
		}
		
		// #### AS A PRODUCT BUYER BUYING LOWEST UNIQUE BID ITEMS ######
		// does the buyer need to leave feedback for any seller who sold via LUB auction?
		$query = $ilance->db->query("
			SELECT ub.project_id
			FROM " . DB_PREFIX . "projects_uniquebids AS ub,
			" . DB_PREFIX . "projects AS p
			WHERE ub.project_id = p.project_id
				AND ub.status = 'lowestunique'
				AND ub.user_id = '" . intval($userid) . "'
				AND p.buyerfeedback = '0'
				AND p.haswinner = '1'
				AND p.status != 'open'
				AND p.winner_user_id = '" . intval($userid) . "'
		", 0, null, __FILE__, __LINE__);
		if ($ilance->db->num_rows($query) > 0)
		{
			while ($res = $ilance->db->fetch_array($query))
			{
				$html .= '<div>' . $phrase['_lowest_unique_bid'] . ' ' . $phrase['_item'] . ': <span class="blue"><a href="' . $ilpage['merch'] . '?id=' . $res['project_id'] . '">' . fetch_auction('project_title', $res['project_id']) . '</a></span>: ' . $phrase['_seller_is_waiting_for_your_feedback'] . ' [ <span class="blue"><a href="' . $ilpage['buying'] . '?cmd=management&amp;subcmd=lub&amp;bidsub=awarded">' . $phrase['_leave_feedback'] . '</a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
			}
		}
		
		// #### AS A SERVICE BUYER #####################################
		// does this buyer need to leave feedback for any provider?
		$query = $ilance->db->query("
			SELECT project_id, user_id
			FROM " . DB_PREFIX . "projects
			WHERE user_id = '" . intval($userid) . "'
				AND project_state = 'service'
				AND status = 'approval_accepted'
				AND buyerfeedback = '0'
		", 0, null, __FILE__, __LINE__);
		if ($ilance->db->num_rows($query) > 0)
		{
			while ($res = $ilance->db->fetch_array($query))
			{
				$html .= '<div>' . $phrase['_project'] . ': <span class="blue"><a href="' . $ilpage['rfp'] . '?id=' . $res['project_id'] . '">' . fetch_auction('project_title', $res['project_id']) . '</a></span>: ' . $phrase['_provider_is_waiting_for_your_feedback'] . ' [ <span class="blue"><a href="' . $ilpage['buying'] . '?cmd=management">' . $phrase['_leave_feedback'] . '</a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
			}
		}
		
		// #### AS A SERVICE PROVIDER ##################################
		// does this provider need to leave feedback for any buyer?
		$query = $ilance->db->query("
			SELECT p.project_id, p.user_id
			FROM " . DB_PREFIX . "projects AS p,
			" . DB_PREFIX . "project_bids AS b
			WHERE b.user_id = '" . intval($userid) . "'
				AND b.project_user_id = p.user_id
				AND p.project_state = 'service'
				AND b.bidstatus = 'awarded'
				AND b.project_id = p.project_id
				AND p.sellerfeedback = '0'
		", 0, null, __FILE__, __LINE__);
		if ($ilance->db->num_rows($query) > 0)
		{
			while ($res = $ilance->db->fetch_array($query))
			{
				$html .= '<div>' . $phrase['_project'] . ': <span class="blue"><a href="' . $ilpage['rfp'] . '?id=' . $res['project_id'] . '">' . fetch_auction('project_title', $res['project_id']) . '</a></span>: ' . $phrase['_buyer_is_waiting_for_your_feedback'] . ' [ <span class="blue"><a href="' . $ilpage['selling'] . '?cmd=management&amp;bidsub=awarded#servicebidding">' . $phrase['_leave_feedback'] . '</a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
			}
		}
		
		// #### AS A PRODUCT BUYER #####################################
		// does this buyer need to leave feedback for any seller?
		$query = $ilance->db->query("
			SELECT p.project_id, p.user_id
			FROM " . DB_PREFIX . "projects AS p,
			" . DB_PREFIX . "project_bids AS b
			WHERE b.user_id = '" . intval($userid) . "'
				AND b.project_user_id = p.user_id
				AND p.project_state = 'product'
				AND b.bidstatus = 'awarded'
				AND b.project_id = p.project_id
				AND p.buyerfeedback = '0'
		", 0, null, __FILE__, __LINE__);
		if ($ilance->db->num_rows($query) > 0)
		{
			while ($res = $ilance->db->fetch_array($query))
			{
				$html .= '<div>' . $phrase['_item'] . ': <span class="blue"><a href="' . $ilpage['merch'] . '?id=' . $res['project_id'] . '">' . fetch_auction('project_title', $res['project_id']) . '</a></span>: ' . $phrase['_seller_is_waiting_for_your_feedback'] . ' [ <span class="blue"><a href="' . $ilpage['buying'] . '?cmd=management&amp;bidsub=awarded#product">' . $phrase['_leave_feedback'] . '</a></span> ]</div><hr size="1" width="100%" style="color:#cccccc" />';
			}
		}
		
		// #### AS A SELLER ############################################
		// does this seller need to leave feedback for any buyer?
		$query = $ilance->db->query("
			SELECT project_id, user_id
			FROM " . DB_PREFIX . "projects
			WHERE user_id = '" . intval($userid) . "'
				AND project_state = 'product'
				AND status = 'expired'
				AND sellerfeedback = '0'
		", 0, null, __FILE__, __LINE__);
		if ($ilance->db->num_rows($query) > 0)
		{
			while ($res = $ilance->db->fetch_array($query))
			{
				//$html .= '<div>' . $phrase['_item'] . ': <a href="' . $ilpage['merch'] . '?id=' . $res['project_id'] . '">' . fetch_auction('project_title', $res['project_id']) . '</a>: ' . $phrase['_buyer_is_waiting_for_your_feedback'] . ' - <a href="' . $ilpage['selling'] . '?cmd=management">' . $phrase['_leave_feedback'] . '</a></div><hr size="1" width="100%" style="color:#cccccc" />';
			}
		}
		
		return $html;
	}
    
	/*
	* Function to construct a profile input form based on a particular question id being supplied as the argument
	*
	* @param      integer       question id       
	*
	* @return     string 
	*/
	function construct_profile_input($qid = 0)
	{
		global $ilance, $myapi, $ilconfig, $phrase, $page_title, $area_title, $ilpage;
		
		$sql = $ilance->db->query("
			SELECT questionid, inputtype, multiplechoice
			FROM " . DB_PREFIX . "profile_questions
			WHERE questionid = '" . intval($qid) . "'
			LIMIT 1
		", 0, null, __FILE__, __LINE__);
		if ($ilance->db->num_rows($sql) > 0)
		{
			$res = $ilance->db->fetch_array($sql);
			
			$sql2 = $ilance->db->query("
				SELECT *
				FROM " . DB_PREFIX . "profile_answers
				WHERE questionid = '" . $res['questionid'] . "'
				    AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
				LIMIT 1
			", 0, null, __FILE__, __LINE__);
			if ($ilance->db->num_rows($sql2) > 0)
			{
				$res2 = $ilance->db->fetch_array($sql2);
				
				// is answer verified?
				if ($res2['isverified'])
				{
					// does admin allow answer updates after verification?
					if ($ilconfig['verificationupdateafter'])
					{
						$res2['disabled'] = '';
					}
					else
					{
						$res2['disabled'] = 'disabled="disabled"';    
					}
				}
				else
				{
					$res2['disabled'] = '';
				}
				switch ($res['inputtype'])
				{
					case 'yesno':
					{
						$selected1 = '';
						$selected2 = '';
						if ($res2['answer'] == '1')
						{
							$selected1 = 'checked="checked"';
						}
						else if ($res2['answer'] == '')
						{
							$selected1 = 'checked="checked"';
						}
						
						$input = $phrase['_yes'].' <input type="radio" name="question['.$res['questionid'].']" value="1" '.$selected1.' '.$res2['disabled'].' />&nbsp;&nbsp;';
						if ($res2['answer'] == '0')
						{
							$selected2 = 'checked="checked"';
						}
						else if ($res2['answer'] == '')
						{
							$selected1 = 'checked="checked"';
						}
						$input .= $phrase['_no'] .'<input type="radio" name="question['.$res['questionid'].']" value="0" '.$selected2.' '.$res2['disabled'].' />';
						break;
					}					 
					case 'int':
					{
						$input = '<input type="text" id="question'.$res['questionid'].'" name="question['.$res['questionid'].']" value="'.stripslashes($res2['answer']).'" style="width:60px" '.$res2['disabled'].' />';
						break;
					}					 
					case 'textarea':
					{
						$input = '<textarea id="question'.$res['questionid'].'" name="question['.$res['questionid'].']" style="width: 425px; height: 84px; font-family: Verdana;" wrap="physical" '.$res2['disabled'].'>'.stripslashes($res2['answer']).'</textarea>';
						break;
					}					 
					case 'text':
					{
						$input = '<input type="text" id="question'.$res['questionid'].'" name="question['.$res['questionid'].']" value="'.stripslashes($res2['answer']).'" class="input" '.$res2['disabled'].' />';
						break;
					}				    
					case 'multiplechoice':
					{
						if (!empty($res['multiplechoice']))
						{
							$choices = explode('|', $res['multiplechoice']);
							$input = $phrase['_hold_down_the_ctrl_key_on_your_keyboard_to_select_multiple_choices'] . '<br /><select style="width:425px; height:90px;" multiple name="question['.$res['questionid'].'][]" id="question'.$res['questionid'].'">';
							$input .= '<optgroup label="'.$phrase['_select'].':">';
							if (empty($res2['answer']))
							{
								$answers = array();
							}
							else
							{
								$answers = unserialize(stripslashes($res2['answer']));
							}
							foreach ($choices as $choice)
							{
								if (in_array($choice, $answers))
								{
									$input .= '<option value="'.trim($choice).'" selected="selected">'.$choice.'</option>';
								}
								else
								{
									$input .= '<option value="'.trim($choice).'">'.$choice.'</option>';
								}
							}
							$input .= '</optgroup>';
							$input .= '</select>';
						}
						else
						{
							$input .= '-- Not available --';    
						}
						break;
					}		    
					case 'pulldown':
					{
						if (!empty($res['multiplechoice']))
						{
							$choices = explode('|', $res['multiplechoice']);
							$input = '<select name="question[' . $res['questionid'] . ']" id="question' . $res['questionid'] . '" style="font-family: verdana">';
							foreach ($choices as $choice)
							{
								if (!empty($choice))
								{
									if ($res2['answer'] == $choice)
									{
										$input .= '<option value="' . trim($choice) . '" selected="selected">' . $choice . '</option>';
									}
									else
									{
										$input .= '<option value="' . trim($choice) . '">' . $choice . '</option>';
									}                                                                
								}
							}
							
							$input .= '</select>';
						}
						break;
					}
				}
			}
			else
			{
				switch ($res['inputtype'])
				{
					case 'yesno':
					{
						$input = '<label for="yes">'.$phrase['_yes'].'</label><input type="radio" id="yes" name="question['.$res['questionid'].']" value="1" checked="checked" />&nbsp;&nbsp;';
						$input .= '<label for="no">'.$phrase['_no'].'</label><input type="radio" id="no" name="question['.$res['questionid'].']" value="0" />';
						break;
					}					
					case 'int':
					{
						$input = '<input type="text" id="question'.$res['questionid'].'" name="question['.$res['questionid'].']" value="" class="input" />';
						break;
					}					
					case 'textarea':
					{
						$input = '<textarea id="question'.$res['questionid'].'" name="question['.$res['questionid'].']" style="width: 425px; height: 84px; font-family: Verdana;" wrap="physical"></textarea>';
						break;
					}					
					case 'text':
					{
						$input = '<input type="text" id="question'.$res['questionid'].'" name="question['.$res['questionid'].']" value="" class="input" />';
						break;
					}				    
					case 'multiplechoice':
					{
						if (!empty($res['multiplechoice']))
						{
							$choices = explode('|', $res['multiplechoice']);
							$input = $phrase['_hold_down_the_ctrl_key_on_your_keyboard_to_select_multiple_choices'] . '<br /><select style="width:425px; height:90px;" multiple name="question['.$res['questionid'].'][]" id="question'.$res['questionid'].'">';
							$input .= '<optgroup label="'.$phrase['_select'].':">';
							foreach ($choices as $choice)
							{
								if (!empty($choice))
								{
									$input .= '<option value="'.trim($choice).'">'.$choice.'</option>';
								}
							}
							$input .= '</optgroup>';
							$input .= '</select>';
						}
						else
						{
							$input .= '-- Not available --';    
						}
						break;
					}		    
					case 'pulldown':
					{
						if (!empty($res['multiplechoice']))
						{
							$choices = explode('|', $res['multiplechoice']);
							$input = '<select name="question[' . $res['questionid'] . ']" id="question' . $res['questionid'] . '" style="font-family: verdana">';
							foreach ($choices as $choice)
							{
								if (!empty($choice))
								{
									$input .= '<option value="' . trim($choice) . '">' . $choice . '</option>';
								}
							}
							$input .= '</select>';
						}
						break;
					}
				}
			}
			
			return $input;
		}
	}
	
	function unpaid_p2b_activity($userid = 0, $type = '', $period = -1)
	{
		global $ilance, $ilpage, $phrase, $ilconfig;
		
		$html = '';
		
		if ($type == 'buying')
		{
			$sql = $ilance->db->query("
				SELECT *
				FROM " . DB_PREFIX . "invoices
				WHERE user_id = '" . intval($userid) . "'
					AND invoicetype = 'p2b'
					AND status = 'unpaid'
			");	
		}
		else if ($type == 'selling')
		{
			$sql = $ilance->db->query("
				SELECT *
				FROM " . DB_PREFIX . "invoices
				WHERE p2b_user_id = '" . intval($userid) . "'
					AND invoicetype = 'p2b'
					AND status = 'unpaid'
			");	
		}
		
		// does auction have pending provider to buyer invoices that are unpaid?
		
		if ($ilance->db->num_rows($sql) > 0)
		{
			$pendinvoices = '';
			$invoices = 0;
			while ($res_inv = $ilance->db->fetch_array($sql))
			{
				$title = fetch_auction('project_title', $res_inv['projectid']);
				$projectid = $res_inv['projectid'];
				$providerid = $res_inv['p2b_user_id'];
				$buyerid = $res_inv['user_id'];
				$crypted = array('id' => $res_inv['invoiceid']);
				$pendinvoices .= '<span class="blue"><a href="' . $ilpage['invoicepayment'] . '?cmd=view&amp;txn=' . $res_inv['transactionid'] . '" title="">#' . $res_inv['invoiceid'] . '</a></span>, ';
				$invoices++;
			}
			
			if (!empty($pendinvoices))
			{
				$pendinvoices = mb_substr($pendinvoices, 0, -2);
			}
			
			$invoicephrase = $phrase['_invoices_lower'];
			if ($invoices == 1)
			{
				$invoicephrase = $phrase['_invoice_lower'];	
			}
			
			if ($type == 'buying')
			{
				$html = '<div><span style="float:left; padding-top:1px; padding-right:3px"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/invoice.gif" border="0" alt="" /></span> ' . $invoices . ' ' . $invoicephrase . ': ' . $pendinvoices . ' generated by service provider <span class="blue"><a href="' . $ilpage['members'] . '?id=' . $providerid . '">' . fetch_user('username', $providerid) . '</a></span> is waiting on payment for the <span class="blue"><a href="' . $ilpage['rfp'] . '?id=' . $projectid . '">' . $title . '</a></span> listing.</div><hr size="1" width="100%" style="color:#cccccc" />';
			}
			else if ($type == 'selling')
			{
				$html = '<div><span style="float:left; padding-top:1px; padding-right:3px"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/invoice.gif" border="0" alt="" /></span> ' . $invoices . ' ' . $invoicephrase . ': ' . $pendinvoices . ' generated to service buyer <span class="blue"><a href="' . $ilpage['members'] . '?id=' . $buyerid . '">' . fetch_user('username', $buyerid) . '</a></span> for the <span class="blue"><a href="' . $ilpage['rfp'] . '?id=' . $projectid . '">' . $title . '</a></span> listing still pending payment.</div><hr size="1" width="100%" style="color:#cccccc" />';
			}
		}
		
		return $html;
	}
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: class.mycp.inc.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>