<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

/**
* Watchlist class to perform the majority of watchlist and notification tasks within ILance.
*
* @package      iLance
* @version	$Revision: 1.0.0 $
* @author       ILance
*/
class watchlist
{
        /*
        * ...
        *
        * @param       
        *
        * @return      
        */
        function send_notification($bidderid, $type = 'lowbidnotify', $id, $bidamount = '')
        {
                global $ilance, $myapi, $ilconfig;
                
                if ($type == 'lowbidnotify')
                {
                        // select all bidders that are watching this auction with lowbidnotify enabled
                        $sql = $ilance->db->query("
                                SELECT user_id FROM " . DB_PREFIX . "watchlist
                                WHERE lowbidnotify = '1'
                                    AND subscribed = '1'
                                    AND watching_project_id = '".intval($id)."'
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($sql) > 0)
                        {
                                while ($bidders = $ilance->db->fetch_array($sql))
                                {
                                        $sql_low = $ilance->db->query("
                                                SELECT bidamount FROM " . DB_PREFIX . "project_bids
                                                WHERE project_id = '".intval($id)."'
                                                    AND user_id = '".$bidders['user_id']."'
                                                LIMIT 1
                                        ", 0, null, __FILE__, __LINE__);
                                        if ($ilance->db->num_rows($sql_low) > 0)
                                        {
                                                $result_low = $ilance->db->fetch_array($sql_low);
                                                if (isset($bidamount) AND $bidamount < $result_low['bidamount'])
                                                {
                                                        // new bid is lower than this bidders
                                                        $sel_email = $ilance->db->query("
                                                                SELECT email FROM " . DB_PREFIX . "users
                                                                WHERE user_id = '".$bidders['user_id']."'
                                                                LIMIT 1
                                                        ", 0, null, __FILE__, __LINE__);
                                                        if ($ilance->db->num_rows($sel_email) > 0)
                                                        {
                                                                while ($result_email = $ilance->db->fetch_array($sel_email))
                                                                {
                                                                        #######################################
                                                                        ## ILANCE => EMAIL TEMPLATE ENGINE V1.0
                                                                        #######################################
                                                                        ## GRAB EMAIL: ID=33, NAME=Lower Bid Notification Alert to Provider
                                                                        $query1="SELECT ";
                                                                        $query1.="subject_".$_SESSION['ilancedata']['user']['slng'].", ";
                                                                        $query1.="message_".$_SESSION['ilancedata']['user']['slng']." ";
                                                                        $query1.="FROM ";
                                                                        $query1.=DB_PREFIX."email ";
                                                                        $query1.="WHERE ";
                                                                        $query1.="varname='lower_bid_notification_alert'";
                                                                        $runit=$ilance->db->query($query1, 0, null, __FILE__, __LINE__);
                                                                        $rs1=$ilance->db->fetch_array($runit);
                                    
                                                                        $subject=stripslashes(trim($rs1[0]));
                                                                        $message=stripslashes(trim($rs1[1]));
                                    
                                                                        $subject=str_replace("{{p_id}}", $id, $subject);
                                                                        $subject=str_replace("{{site_name}}", SITE_NAME, $subject);
                                                                        $subject=str_replace("{{https_server}}", HTTPS_SERVER, $subject);
                                                                        $subject=str_replace("{{http_server}}", HTTP_SERVER, $subject);
                                                                        $subject=str_replace("{{generate_date}}", print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0), $subject);
                                    
                                                                        $message=str_replace("{{p_id}}", $id, $message);
                                                                        $message=str_replace("{{site_name}}", SITE_NAME, $message);
                                                                        $message=str_replace("{{site_email}}", SITE_EMAIL, $message);
                                                                        $message=str_replace("{{site_phone}}", SITE_PHONE, $message);
                                                                        $message=str_replace("{{site_address}}", SITE_ADDRESS, $message);
                                                                        $message=str_replace("{{http_server_admin}}", HTTP_SERVER_ADMIN, $message);
                                                                        $message=str_replace("{{https_server_admin}}", HTTPS_SERVER_ADMIN, $message);
                                                                        $message=str_replace("{{https_server}}", HTTPS_SERVER, $message);
                                                                        $message=str_replace("{{http_server}}", HTTP_SERVER, $message);
                                                                        $message=str_replace("{{generate_date}}", print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0), $message);
                                                                        $message=str_replace("{{email_id}}", "33", $message);
                                                                        send_email($result_email['email'], $subject, $message, SITE_EMAIL);
                                                                }
                                                        }
                                                }
                                        }
                                }
                        }
                }
                else if ($type == 'highbidnotify')
                {
                        // select all bidders that are watching this auction with lowbidnotify enabled
                        $sql = $ilance->db->query("
                                SELECT user_id FROM " . DB_PREFIX . "watchlist
                                WHERE highbidnotify = '1'
                                    AND subscribed = '1'
                                    AND watching_project_id = '".intval($id)."'
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($sql) > 0)
                        {
                                while ($bidders = $ilance->db->fetch_array($sql))
                                {
                                        // fetch last bid placed by this user
                                        $sql_high = $ilance->db->query("
                                                SELECT bidamount FROM " . DB_PREFIX . "project_bids
                                                WHERE project_id = '".intval($id)."'
                                                    AND user_id = '".$bidders['user_id']."'
                                                ORDER BY bid_id DESC
                                                LIMIT 1
                                        ", 0, null, __FILE__, __LINE__);
                                        if ($ilance->db->num_rows($sql_high) > 0)
                                        {
                                                $result = $ilance->db->fetch_array($sql_high);
                                                if (isset($bidamount) AND $bidamount > $result['bidamount'])
                                                {
                                                        // new bid is higher than this bidders last bid
                                                        $sel_email = $ilance->db->query("
                                                                SELECT email FROM " . DB_PREFIX . "users
                                                                WHERE user_id = '".$bidders['user_id']."'
                                                                LIMIT 1
                                                        ", 0, null, __FILE__, __LINE__);
                                                        if ($ilance->db->num_rows($sel_email) > 0)
                                                        {
                                                                while ($result_email = $ilance->db->fetch_array($sel_email))
                                                                {
                                                                        #######################################
                                                                        ## ILANCE => EMAIL TEMPLATE ENGINE V1.0
                                                                        #######################################
                                                                        ## GRAB EMAIL: ID=33, NAME=Higher Bid Notification Alert
                                                                        $query1="SELECT ";
                                                                        $query1.="subject_".fetch_user_slng($bidders['user_id']).", ";
                                                                        $query1.="message_".fetch_user_slng($bidders['user_id'])." ";
                                                                        $query1.="FROM ";
                                                                        $query1.=DB_PREFIX."email ";
                                                                        $query1.="WHERE ";
                                                                        $query1.="varname='higher_bid_notification_alert'";
                                                                        $runit=$ilance->db->query($query1, 0, null, __FILE__, __LINE__);
                                                                        $rs1=$ilance->db->fetch_array($runit);
                                    
                                                                        $subject=stripslashes(trim($rs1[0]));
                                                                        $message=stripslashes(trim($rs1[1]));
                                    
                                                                        $subject=str_replace("{{p_id}}", $id, $subject);
                                                                        $subject=str_replace("{{site_name}}", SITE_NAME, $subject);
                                                                        $subject=str_replace("{{https_server}}", HTTPS_SERVER, $subject);
                                                                        $subject=str_replace("{{http_server}}", HTTP_SERVER, $subject);
                                                                        $subject=str_replace("{{generate_date}}", print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0), $subject);
                                    
                                                                        $message=str_replace("{{p_id}}", $id, $message);
                                                                        $message=str_replace("{{site_name}}", SITE_NAME, $message);
                                                                        $message=str_replace("{{site_email}}", SITE_EMAIL, $message);
                                                                        $message=str_replace("{{site_phone}}", SITE_PHONE, $message);
                                                                        $message=str_replace("{{site_address}}", SITE_ADDRESS, $message);
                                                                        $message=str_replace("{{http_server_admin}}", HTTP_SERVER_ADMIN, $message);
                                                                        $message=str_replace("{{https_server_admin}}", HTTPS_SERVER_ADMIN, $message);
                                                                        $message=str_replace("{{https_server}}", HTTPS_SERVER, $message);
                                                                        $message=str_replace("{{http_server}}", HTTP_SERVER, $message);
                                                                        $message=str_replace("{{generate_date}}", print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0), $message);
                                                                        $message=str_replace("{{email_id}}", "332", $message);
                                                                        send_email($result_email['email'], $subject, $message, SITE_EMAIL);
                                                                }
                                                        }
                                                }
                                        }
                                }
                        }
                }
        }

        /*
        * ...
        *
        * @param       
        *
        * @return      
        */
        function insert_item($userid = 0, $watchingid = 0, $watchtype = '', $comment = '', $lowbidnotify = 0, $highbidnotify = 0, $hourleftnotify = 0, $subscribed = 0)
        {
                global $ilance, $myapi, $phrase, $ilconfig;
                
                if ($watchingid > 0 AND $userid > 0)
                {
                        if (empty($comment))
                        {
                                $comment = $phrase['_added'] . ' ' . print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
                        }
                        
                        if ($watchtype == 'mprovider')
                        {
                                $sql = $ilance->db->query("
                                        SELECT watchlistid
                                        FROM " . DB_PREFIX . "watchlist
                                        WHERE watching_user_id = '" . intval($watchingid) . "'
                                            AND user_id = '" . intval($userid) . "'
                                            AND state = 'mprovider'
                                ", 0, null, __FILE__, __LINE__);
                                if ($ilance->db->num_rows($sql) == 0)
                                {
                                        $ilance->db->query("
                                                INSERT INTO " . DB_PREFIX . "watchlist
                                                (watchlistid, user_id, watching_user_id, comment, state)
                                                VALUES(
                                                NULL,
                                                '" . intval($userid) . "',
                                                '" . intval($watchingid) . "',
                                                '" . $ilance->db->escape_string($comment) . "',
                                                'mprovider')
                                        ", 0, null, __FILE__, __LINE__);
                                        
                                        return true;
                                }
                                else
                                {
                                        return false;
                                }
                        }
                        else if ($watchtype == 'sprovider')
                        {
                                $sql = $ilance->db->query("
                                        SELECT watchlistid
                                        FROM " . DB_PREFIX . "watchlist
                                        WHERE watching_user_id = '" . intval($watchingid) . "'
                                            AND user_id = '" . intval($userid) . "'
                                            AND state = 'sprovider'
                                ", 0, null, __FILE__, __LINE__);
                                if ($ilance->db->num_rows($sql) == 0)
                                {
                                        $ilance->db->query("
                                                INSERT INTO " . DB_PREFIX . "watchlist
                                                (watchlistid, user_id, watching_user_id, comment, state)
                                                VALUES(
                                                NULL,
                                                '" . intval($userid) . "',
                                                '" . intval($watchingid) . "',
                                                '" . $ilance->db->escape_string($comment) . "',
                                                'sprovider')
                                        ", 0, null, __FILE__, __LINE__);
                                        
                                        return true;
                                }
                                else
                                {
                                        return false;
                                }
                        }
                        else if ($watchtype == 'buyer')
                        {
                                $sql = $ilance->db->query("
                                        SELECT watchlistid
                                        FROM " . DB_PREFIX . "watchlist
                                        WHERE watching_user_id = '" . intval($watchingid) . "'
                                            AND user_id = '" . intval($userid) . "'
                                            AND state = 'buyer'
                                ", 0, null, __FILE__, __LINE__);
                                if ($ilance->db->num_rows($sql) == 0)
                                {
                                        $ilance->db->query("
                                                INSERT INTO " . DB_PREFIX . "watchlist
                                                (watchlistid, user_id, watching_user_id, comment, state)
                                                VALUES(
                                                NULL,
                                                '" . intval($userid) . "',
                                                '" . intval($watchingid) . "',
                                                '" . $ilance->db->escape_string($comment) . "',
                                                'buyer')
                                        ", 0, null, __FILE__, __LINE__);
                                        
                                        return true;
                                }
                                else
                                {
                                        return false;
                                }
                        }
                        else if ($watchtype == 'auction')
                        {
                                $sql = $ilance->db->query("
                                        SELECT watchlistid
                                        FROM " . DB_PREFIX . "watchlist
                                        WHERE watching_project_id = '" . intval($watchingid) . "'
                                            AND user_id = '" . intval($userid) . "'
                                            AND state = 'auction'
                                        LIMIT 1
                                ", 0, null, __FILE__, __LINE__);
                                if ($ilance->db->num_rows($sql) == 0)
                                {
                                        $ilance->db->query("
                                                INSERT INTO " . DB_PREFIX . "watchlist
                                                (watchlistid, user_id, watching_project_id, comment, state)
                                                VALUES(
                                                NULL,
                                                '" . intval($userid) . "',
                                                '" . intval($watchingid) . "',
                                                '" . $ilance->db->escape_string($comment) . "',
                                                'auction')
                                        ", 0, null, __FILE__, __LINE__);
                                        $insertid = $ilance->db->insert_id();
                                }
                                else
                                {
                                         while ($res = $ilance->db->fetch_array($sql))
                                         {
                                               $insertid = $res['watchlistid'];
                                         }
                                }
                                
                                // notification elements
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "watchlist
                                        SET lowbidnotify = '" . $lowbidnotify . "',
                                        highbidnotify = '" . $highbidnotify . "',
                                        hourleftnotify = '" . $hourleftnotify . "',
                                        subscribed = '" . $subscribed . "'
                                        WHERE watchlistid = '" . intval($insertid) . "'
                                        LIMIT 1
                                        ", 0, null, __FILE__, __LINE__);
                                
                                return true;  
                        }
                        else if ($watchtype == 'category')
                        {
                                $sql = $ilance->db->query("
                                        SELECT watchlistid
                                        FROM " . DB_PREFIX . "watchlist
                                        WHERE watching_category_id = '" . intval($watchingid) . "'
                                            AND user_id = '" . intval($userid) . "'
                                            AND state = 'category'
                                ", 0, null, __FILE__, __LINE__);
                                if ($ilance->db->num_rows($sql) == 0)
                                {
                                        $ilance->db->query("
                                                INSERT INTO " . DB_PREFIX . "watchlist
                                                (watchlistid, user_id, watching_category_id, comment, state)
                                                VALUES(
                                                NULL,
                                                '" . intval($userid) . "',
                                                '" . intval($watchingid) . "',
                                                '" . $ilance->db->escape_string($comment) . "',
                                                'cat')
                                        ", 0, null, __FILE__, __LINE__);
                                        
                                        return true;
                                }
                                else
                                {
                                        return false;
                                }
                        }
                }
                else
                {
                        return false;
                }
        }
        
        /*
        * ...
        *
        * @param       
        *
        * @return      
        */
        function update_item($userid, $watchingid, $watchtype, $comment)
        {
                global $ilance, $myapi, $phrase, $ilconfig;
                
                if ($watchingid > 0 AND $userid > 0 AND !empty($watchtype))
                {
                        if (empty($comment))
                        {
                                $comment = $phrase['_added'] . ' ' . print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
                        }
                        else
                        {
                                $comment = $comment;
                        }
                        if ($watchtype == 'mprovider')
                        {
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "watchlist
                                        SET comment = '" . $ilance->db->escape_string($comment) . "'
                                        WHERE watching_user_id = '" . intval($watchingid) . "'
                                            AND user_id = '" . intval($userid) . "'
                                            AND state = 'mprovider'
                                ", 0, null, __FILE__, __LINE__);
                                
                                return true;
                        }
                        else if ($watchtype == 'sprovider')
                        {
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "watchlist
                                        SET comment = '" . $ilance->db->escape_string($comment) . "'
                                        WHERE watching_user_id = '" . intval($watchingid) . "'
                                            AND user_id = '" . intval($userid) . "'
                                            AND state = 'sprovider'
                                ", 0, null, __FILE__, __LINE__);
                                
                                return true;
                        }
                        else if ($watchtype == 'buyer')
                        {
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "watchlist
                                        SET comment = '" . $ilance->db->escape_string($comment) . "'
                                        WHERE watching_user_id = '" . intval($watchingid) . "'
                                            AND user_id = '" . intval($userid) . "'
                                            AND state = 'buyer'
                                ", 0, null, __FILE__, __LINE__);
                                
                                return true;
                        }
                        else if ($watchtype == 'auction')
                        {
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "watchlist
                                        SET comment = '" . $ilance->db->escape_string($comment) . "'
                                        WHERE watching_project_id = '" . intval($watchingid) . "'
                                            AND user_id = '" . intval($userid) . "'
                                            AND state = 'auction'
                                ", 0, null, __FILE__, __LINE__);
                                
                                return true;
                        }
                        else if ($watchtype == 'category')
                        {
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "watchlist
                                        SET comment = '" . $ilance->db->escape_string($comment) . "'
                                        WHERE watching_category_id = '" . intval($watchingid) . "'
                                            AND user_id = '" . intval($userid) . "'
                                            AND state = 'cat'
                                ", 0, null, __FILE__, __LINE__);
                                
                                return true;
                        }
                }
                else
                {
                        return false;
                }
        }
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: class.watchlist.inc.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>