<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

/**
* Core Attachment functions in ILance.
*
* @package      iLance
* @version	$Revision: 1.0.0 $
* @author       ILance
*/

/**
* Function fetch the full attachment path for the specified attachment type
*
* @param	string		attachment type
*
* @return	string          attachment folder
*/
function fetch_attachment_path($attachtype)
{
        if ($attachtype == 'profile')
        {
                $filedata = DIR_PROFILE_ATTACHMENTS;
        }
        else if ($attachtype == 'portfolio')
        {
                $filedata = DIR_PORTFOLIO_ATTACHMENTS;
        }
        else if ($attachtype == 'project')
        {
                $filedata = DIR_AUCTION_ATTACHMENTS;
        }
        else if ($attachtype == 'itemphoto')
        {
                $filedata = DIR_AUCTION_ATTACHMENTS;
        }
        else if ($attachtype == 'bid')
        {
                $filedata = DIR_BID_ATTACHMENTS;
        }
        else if ($attachtype == 'pmb')
        {
                $filedata = DIR_PMB_ATTACHMENTS;
        }
        else if ($attachtype == 'ws')
        {
                $filedata = DIR_WS_ATTACHMENTS;
        }
        else if ($attachtype == 'kb')
        {
                $filedata = DIR_KB_ATTACHMENTS;
        }
        else if ($attachtype == 'stores')
        {
                $filedata = DIR_STORE_ATTACHMENTS;
        }
        else if ($attachtype == 'ads')
        {
                $filedata = DIR_ADS_ATTACHMENTS;
        }
        else if ($attachtype == 'digital')
        {
                $filedata = DIR_AUCTION_ATTACHMENTS;
        }
        else if ($attachtype == 'slideshow')
        {
                $filedata = DIR_AUCTION_ATTACHMENTS;
        }
        return $filedata;    
}

/**
* Function fetch the full attachment path and actual file(name) for the specified attachment type
*
* @param	string		attachment type
* @param        string          actual filehash
*
* @return	string          full path and filename to the attachment
*/
function fetch_attachment_file($attachtype, $filehash)
{
        if ($attachtype == 'profile')
        {
                $filedata = DIR_PROFILE_ATTACHMENTS . $filehash . '.attach';
        }
        else if ($attachtype == 'portfolio')
        {
                $filedata = DIR_PORTFOLIO_ATTACHMENTS . $filehash . '.attach';
        }
        else if ($attachtype == 'project')
        {
                $filedata = DIR_AUCTION_ATTACHMENTS . $filehash . '.attach';
        }
        else if ($attachtype == 'itemphoto')
        {
                $filedata = DIR_AUCTION_ATTACHMENTS . $filehash . '.attach';
        }
        else if ($attachtype == 'bid')
        {
                $filedata = DIR_BID_ATTACHMENTS . $filehash . '.attach';
        }
        else if ($attachtype == 'pmb')
        {
                $filedata = DIR_PMB_ATTACHMENTS . $filehash . '.attach';
        }
        else if ($attachtype == 'ws')
        {
                $filedata = DIR_WS_ATTACHMENTS . $filehash . '.attach';
        }
        else if ($attachtype == 'kb')
        {
                $filedata = DIR_KB_ATTACHMENTS . $filehash . '.attach';
        }
        else if ($attachtype == 'stores')
        {
                $filedata = DIR_STORE_ATTACHMENTS . $filehash . '.attach';
        }
        else if ($attachtype == 'ads')
        {
                $filedata = DIR_ADS_ATTACHMENTS . $filehash . '.attach';
        }   
        else if ($attachtype == 'digital')
        {
                $filedata = DIR_AUCTION_ATTACHMENTS . $filehash . '.attach';
        }
        else if ($attachtype == 'slideshow')
        {
                $filedata = DIR_AUCTION_ATTACHMENTS . $filehash . '.attach';
        }
        return $filedata;
}

/**
* Function returns logic of attachment storage system and returns back required raw attachment data
*
* @param	array 	        attachment array
* @param        boolean         (true/false) determines if this attachment is "external" (true) which would indicate a "url" to display an "image/picture".
*
* @return	string          Returns raw attachment file data
*/
function fetch_attachment_rawdata($attachment, $isexternal = false)
{
        global $ilconfig;
        
        if ($ilconfig['attachment_dbstorage'])
        {
                return $attachment['filedata'];
        }
        else
        {
                if ($isexternal == false)
                {
                        $attachment['filepath'] = fetch_attachment_file($attachment['attachtype'], $attachment['filehash']);
                        $attachment['filedata'] = file_get_contents($attachment['filepath']);
                }
                
                return $attachment['filedata'];
        }
}

/**
* Function to print out the captcha via GD + FreeType
*
* @param	integer 	length of captcha phrase
*
* @return	string          Returns image data
*/
function print_captcha($length = 5)
{
        $src = 'abcdefghjkmnpqrstuvwxyz23456789';
        if (mt_rand(0, 1) == 0)
        {
                $src = mb_strtoupper($src);
        }
        $srclen = mb_strlen($src)-1;
    
        // what font file to use
        $font = DIR_FONTS.'AppleGaramond.ttf';
    
        // captcha output type (jpeg, png, gif)
        $output_type = 'png';
    
        // font size range, angle range, character padding
        $min_font_size = 25;
        $max_font_size = 35;
        $min_angle = -15;
        $max_angle = 15;
    
        // font character padding
        $char_padding = 1;
    
        $data = array();
        $image_width = $image_height = 0;
    
        // build the data array of the characters, size, placement, etc.
        $_SESSION['ilancedata']['user']['captcha'] = '';
        for ($i=0; $i < $length; $i++)
        {
                $char = mb_strtoupper(mb_substr($src, mt_rand(0, $srclen), 1));
                $_SESSION['ilancedata']['user']['captcha'] .= "$char";
                
                $size = mt_rand($min_font_size, $max_font_size);
                $angle = mt_rand($min_angle, $max_angle);        
                $bbox = imagettfbbox($size, $angle, $font, $char);
                $char_width = max($bbox[2],$bbox[4]) - min($bbox[0],$bbox[6]);
                $char_height = max($bbox[1],$bbox[3]) - min($bbox[7],$bbox[5]);
        
                $image_width += $char_width + $char_padding;
                $image_height = max($image_height, $char_height);
                $data[] = array('char' => $char, 'size' => $size, 'angle' => $angle, 'height' => $char_height, 'width' => $char_width,);
        }
    
        // calculate the final image size, add some padding
        $x_padding = 12;
        $image_width += ($x_padding * 2);
        $image_height = ($image_height * 1.5) + 2;
    
        // build the image, and allocte the colors
        $im = imagecreate($image_width, $image_height);
        $r = 51 * mt_rand(4,5);
        $g = 51 * mt_rand(4,5);
        $b = 51 * mt_rand(4,5);
        $color_bg = imagecolorallocate($im,  $r,  $g,  $b);
    
        $r = 51 * mt_rand(3,4);
        $g = 51 * mt_rand(3,4);
        $b = 51 * mt_rand(3,4);
        $color_line0 = imagecolorallocate($im,  $r,  $g,  $b);
    
        $r = 51 * mt_rand(3,4);
        $g = 51 * mt_rand(3,4);
        $b = 51 * mt_rand(3,4);
        $color_line1 = imagecolorallocate($im,  $r,  $g,  $b);
    
        $r = 51 * mt_rand(1,2);
        $g = 51 * mt_rand(1,2);
        $b = 51 * mt_rand(1,2);
    
        $color_text = imagecolorallocate($im,  $r,  $g,  $b);
        $color_border = imagecolorallocate($im,   0,   0,   0);
    
        // make the random background lines
        for ($l=0; $l < 10; $l++)
        {
                $c = 'color_line' . ($l%2);
                $lx = mt_rand(0, $image_width+$image_height);
                $lw = mt_rand(0, 3);
                if ($lx > $image_width)
                {
                        $lx -= $image_width;
                        imagefilledrectangle($im, 0, $lx, $image_width-1, $lx+$lw, $$c );
                }
                else
                {
                        imagefilledrectangle($im, $lx, 0, $lx+$lw, $image_height-1, $$c );
                }
        }
    
        // output each character
        $pos_x = $x_padding + ($char_padding / 2);
        foreach($data as $d)
        {
                $pos_y = (($image_height+$d['height'])/2);
                imagettftext($im, $d['size'], $d['angle'], $pos_x, $pos_y, $color_text, $font, $d['char']);
                $pos_x += $d['width'] + $char_padding;
        }
    
        // create a border
        imagerectangle($im, 0, 0, $image_width - 1, $image_height - 1, $color_border);
    
        switch ($output_type)
        {
                case 'jpeg':
                header('Content-type: image/jpeg');
                imagejpeg($im, null, 100);
                break;
            
                case 'png':
                header('Content-type: image/png');
                imagepng($im);
                break;
            
                case 'gif':
                header('Content-type: image/gif');
                imagegif($im);
                break;
        }
        imagedestroy($im);
}

/*
* Function for determining if a particular attachment id is associated with a private workspace folder.
*
* @param       integer        attachment id
*
* @return      bool           true or false if attachment exists to a private workspace folder
*/
function is_private_workspace_attachment($attachid)
{
	global $ilance, $myapi;
	$sql = $ilance->db->query("
		SELECT tblfolder_ref
		FROM ".DB_PREFIX."attachment
		WHERE attachid = '".intval($attachid)."'
		LIMIT 1
	", 0, null, __FILE__, __LINE__);
	if ($ilance->db->num_rows($sql) > 0)
	{
		$res = $ilance->db->fetch_array($sql);
		if ($res['tblfolder_ref'] > 0)
		{
			$sql2 = $ilance->db->query("
				SELECT folder_type
				FROM ".DB_PREFIX."attachment_folder
				WHERE id = '".$res['tblfolder_ref']."'
				LIMIT 1
			", 0, null, __FILE__, __LINE__);
			if ($ilance->db->num_rows($sql2) > 0)
			{
				$res2 = $ilance->db->fetch_array($sql2);
				if ($res2['folder_type'] == '1')
				{
					// attachment related to private workspace
					return 1;
				}
				else
				{
					return 0;
				}
			}
		}
	}
	return 0;
}

/*
* Function to fetch the attachment type
*
* @param       string         type
* @param       integer        project id
*
* @return      string         Returns the attachment type
*/
function fetch_attachment_type($type, $projectid = '')
{
        global $ilance, $phrase;
        
        switch ($type)
        {
                case 'profile':
                {
                        return $phrase['_profile_logo'];
                        break;
                }            
                case 'portfolio':
                {
                        return $phrase['_portfolio_item'];
                        break;
                }            
                case 'project':
                {
                        return $phrase['_listing_attachment'] . '<div class="smaller">' . $projectid . '</div>';
                        break;
                }            
                case 'itemphoto':
                {
                        return $phrase['_item_photo'] . '<div class="smaller">' . $projectid . '</div>';
                        break;
                }            
                case 'bid':
                {
                        return $phrase['_bid_attachment'] . '<div class="smaller">' . $projectid . '</div>';
                        break;
                }            
                case 'pmb':
                {
                        return $phrase['_pmb_attachment'];
                        break;
                }            
                case 'ws':
                {
                        return $phrase['_mediashare'] . '<div class="smaller">' . $projectid . '</div>';
                        break;
                }            
                case 'digital':
                {
                        return $phrase['_digital_download'] . '<div class="smaller">' . $projectid . '</div>';
                        break;
                }            
                case 'slideshow':
                {
                        return $phrase['_slideshow_photo'] . '<div class="smaller">' . $projectid . '</div>';
                        break;
                }
        }
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: functions_attachment.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>