<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

/**
* Core Search functions for ILance.
*
* @package      iLance
* @version	$Revision: 1.0.0 $
* @author       ILance
*/

function handle_search_verbose($text = '')
{
	$GLOBALS['verbose'][] = $text;
}

function handle_search_verbose_filters($text = '')
{
	$GLOBALS['verbose_filter'][] = $text;
}

function handle_search_verbose_save($text = '')
{
	$GLOBALS['verbose_save'][] = $text;
}

function print_search_verbose_saved($filter = '')
{
        $html = '';
        if (!empty($GLOBALS["$filter"]))
        {
                foreach ($GLOBALS["$filter"] AS $key => $text)
                {
                        $html .= $text;
                }
        }
        
        return $html;
}

/*
* Function to save search keywords inputted by users from the search menu input boxes throughout the marketplace into the db.
* Additionally, this function will work with multiple keywords separated via comma (ie: keyword1, keyword2, etc)
*
* @param       string         keywords
* @param       string         search mode
*
* @return      nothing
*/
function handle_search_keywords($keywords = '', $mode = '')
{
        global $ilance, $myapi;
        
        // allow the following modes only
        $staticmodes = array('service','product','experts');
        if (!in_array($mode, $staticmodes))
        {
                $mode = '';
        }
        
        // use api hook below if you need to update $staticmodes for your custom code
        ($apihook = $ilance->api('handle_search_keywords_start')) ? eval($apihook) : false;
        
        if (!empty($keywords) AND strchr($keywords, ','))
        {
                $keywords = explode(',', $keywords);
                if (sizeof($keywords) > 1)
                {
                        for ($i = 0; $i < sizeof($keywords); $i++)
                        {
                                $sql = $ilance->db->query("
                                        SELECT *
                                        FROM " . DB_PREFIX . "search
                                        WHERE keyword = '" . trim($ilance->db->escape_string($keywords[$i])) . "'
                                                AND searchmode = '" . $ilance->db->escape_string($mode) . "'
                                        LIMIT 1
                                ", 0, null, __FILE__, __LINE__);
                                if ($ilance->db->num_rows($sql) == 0)
                                {
                                        $ilance->db->query("
                                                INSERT INTO " . DB_PREFIX . "search
                                                (id, keyword, searchmode, count)
                                                VALUES(
                                                NULL,
                                                '" . trim($ilance->db->escape_string($keywords[$i])) . "',
                                                '" . $ilance->db->escape_string($mode) . "',
                                                '0')
                                        ", 0, null, __FILE__, __LINE__);
                                }
                                else
                                {
                                        $ilance->db->query("
                                                UPDATE " . DB_PREFIX . "search
                                                SET count = count + 1
                                                WHERE keyword = '" . trim($ilance->db->escape_string($keywords[$i])) . "'
                                                        AND searchmode = '" . $ilance->db->escape_string($mode) . "'
                                        ", 0, null, __FILE__, __LINE__);
                                }
                                
                                // keep history of a registered users search patterns
                                if (!empty($_SESSION['ilancedata']['user']['userid']))
                                {
                                        $ilance->db->query("
                                                INSERT INTO " . DB_PREFIX . "search_users
                                                (id, user_id, keyword, searchmode, added)
                                                VALUES(
                                                NULL,
                                                '" . $_SESSION['ilancedata']['user']['userid'] . "',
                                                '" . trim($ilance->db->escape_string($keywords[$i])) . "',
                                                '" . $ilance->db->escape_string($mode) . "',
                                                '" . DATETIME24H . "')
                                        ", 0, null, __FILE__, __LINE__);        
                                }
                        }
                }
        }
        else 
        {
                if (!empty($keywords))
                {
                        $sql = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "search
                                WHERE keyword = '" . trim($ilance->db->escape_string($keywords)) . "'
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($sql) == 0)
                        {
                                $ilance->db->query("
                                        INSERT INTO " . DB_PREFIX . "search
                                        (id, keyword, searchmode, count)
                                        VALUES(
                                        NULL,
                                        '" . trim($ilance->db->escape_string($keywords)) . "',
                                        '" . $ilance->db->escape_string($mode) . "',
                                        '0')
                                ", 0, null, __FILE__, __LINE__);
                        }
                        else
                        {
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "search
                                        SET count = count + 1
                                        WHERE keyword = '" . trim($ilance->db->escape_string($keywords)) . "'
                                                AND searchmode = '" . $ilance->db->escape_string($mode) . "'
                                ", 0, null, __FILE__, __LINE__);
                        }
                        
                        // keep history of a registered users search patterns
                        if (!empty($_SESSION['ilancedata']['user']['userid']))
                        {
                                $ilance->db->query("
                                        INSERT INTO " . DB_PREFIX . "search_users
                                        (id, user_id, keyword, searchmode, added)
                                        VALUES(
                                        NULL,
                                        '" . $_SESSION['ilancedata']['user']['userid'] . "',
                                        '" . trim($ilance->db->escape_string($keywords)) . "',
                                        '" . $ilance->db->escape_string($mode) . "',
                                        '" . DATETIME24H . "')
                                ", 0, null, __FILE__, __LINE__);        
                        }
                }
        }
}

/*
* Function to print the active countries pulldown menu
*
* @param       string         fieldname
* @param       string         selected option value (if applicable)
* @param       string         short form language code (eng, ger, pol, etc)
*
* @return      string         Returns HTML representation of the pulldown menu
*/
function print_active_countries_pulldown($fieldname = '', $selected = '', $slng = 'eng', $showworldwide = true, $id = '')
{
        global $ilance, $myapi, $phrase;
        
        $html = '<select name="' . $fieldname . '" id="' . $id . '" style="font-family: verdana">';
        
        if ($showworldwide)
        {
                if ($selected == 'all')
                {
                        $html .= '<option value="all" selected="selected">' . (($showworldwide) ? $phrase['_worldwide'] : '-') . '</option>';
                }
                else
                {
                        $html .= '<option value="all">' . (($showworldwide) ? $phrase['_worldwide'] : '-') . '</option>';
                }
        }
        
        $sql = $ilance->db->query("
                SELECT u.country, c.locationid, c.location_$slng AS location
                FROM " . DB_PREFIX . "users AS u,
                " . DB_PREFIX . "locations AS c
                WHERE u.country = c.locationid
                GROUP by u.country
        ", 0, null, __FILE__, __LINE__);
        while ($crow = $ilance->db->fetch_array($sql))
        {
                if ((isset($ilance->GPC['country']) OR isset($ilance->GPC['radiuscountry'])) AND $crow['locationid'] == $selected)
                {
                        $html .= '<option value="' . $crow['locationid'] . '" selected="selected">' . stripslashes($crow['location']) . '</option>';
                }
                else if ((!isset($ilance->GPC['country']) OR !isset($ilance->GPC['radiuscountry'])) AND $crow['locationid'] == $selected)
                {
                        $html .= '<option value="' . $crow['locationid'] . '" selected="selected">' . stripslashes($crow['location']) . '</option>';
                }
                else
                {
                        $html .= '<option value="' . $crow['locationid'] . '">' . stripslashes($crow['location']) . '</option>';
                }
        }
        $html .= '</select>';
        
        return $html;
}

/*
* Function to print the bid range pulldown menu.
*
* @param       string         selected option value (if applicable)
* @param       string         fieldname
*
* @return      string         Returns HTML representation of the pulldown menu
*/
function print_bid_range_pulldown($selected = '', $fieldname = 'bidrange', $id = '')
{
        global $ilance, $myapi, $phrase;
        
        $html = '<select name="' . $fieldname . '" id="' . $id . '" style="font-family: verdana">';
        
        if (empty($selected))
        {
                $html .= '<option value="-1" selected="selected">';
        }
        else
        {
                $html .= '<option value="-1">';
        }       
        $html .= $phrase['_any_number_of_bids_upper'] . '</option>';
        
        $html .= '<option value="1"';
        if (isset($selected) AND $selected == '1')
        {
                $html .= 'selected="selected"';
        }
        $html .= '>' . $phrase['_less_than_10_upper'] . '</option>';
        
        $html .= '<option value="2"';
        if (isset($selected) AND $selected == '2')
        {
                $html .= 'selected="selected"';
        }
        $html .= '>' . $phrase['_between_10_and_20_upper'] . '</option>';
        
        $html .= '<option value="3"';
        if (isset($selected) AND $selected == '3')
        {
                $html .= 'selected="selected"';
        }
        $html .= '>' . $phrase['_more_than_20_upper'] . '</option></select>';
        
        return $html;
}

/*
* Function to print the award range pulldown menu.
*
* @param       string         selected option value (if applicable)
* @param       string         fieldname
*
* @return      string         Returns HTML representation of the pulldown menu
*/
function print_award_range_pulldown($selected = '', $fieldname = 'projectrange', $id = '')
{
        global $ilance, $myapi, $phrase;
        
        $html = '<select name="' . $fieldname . '" id="' . $id . '" style="font-family: verdana">';
        
        if (empty($selected))
        {
                $html .= '<option value="-1" selected="selected">' . $phrase['_any'] . '</option>';
        }
        else
        {
                $html .= '<option value="-1">' . $phrase['_any'] . '</option>';
        }
        
        $html .= '<option value="1"';
        if (isset($selected) AND $selected == '1')
        {
                $html .= 'selected="selected"';
        }
        $html .= '>' . $phrase['_less_than_10_upper'] . '</option>';
        
        $html .= '<option value="2"';
        if (isset($selected) AND $selected == '2')
        {
                $html .= 'selected="selected"';
        }
        $html .= '>' . $phrase['_between_10_and_20_upper'] . '</option>';
        
        $html .= '<option value="3"';
        if (isset($selected) AND $selected == '3')
        {
                $html .= 'selected="selected"';
        }
        $html .= '>' . $phrase['_more_than_20_upper'] . '</option></select>';
        
        return $html;
}

/*
* Function to print the rating range pulldown menu.
*
* @param       string         selected option value (if applicable)
* @param       string         fieldname
*
* @return      string         Returns HTML representation of the pulldown menu
*/
function print_rating_range_pulldown($selected = '', $fieldname = 'rating', $id = 'rating')
{
        global $ilance, $myapi, $phrase;
        
        $html = '<select name="' . $fieldname . '" id="' . $id . '" style="font-family: verdana">';
        
        if (empty($selected))
        {
                $html .= '<option value="0" selected="selected">' . $phrase['_all_ratings_upper'] . '</option>';
        }
        else
        {
                $html .= '<option value="0">' . $phrase['_all_ratings_upper'] . '</option>';
        }
        
        $html .= '<option value="5"';
        if (isset($selected) AND $selected == 5)
        {
                $html .= 'selected="selected"';
        }
        $html .= '>' . $phrase['_five_stars_upper'] . '</option>';
        
        $html .= '<option value="4"';
        if (isset($selected) AND $selected == 4)
        {
                $html .= 'selected="selected"';
        }
        $html .= '>' . $phrase['_at_least_four_stars_upper'] . '</option>';
        
        $html .= '<option value="3"';
        if (isset($selected) AND $selected == 3)
        {
                $html .= 'selected="selected"';
        }
        $html .= '>' . $phrase['_at_least_three_stars_upper'] . '</option>';
        
        $html .= '<option value="2"';
        if (isset($selected) AND $selected == 2)
        {
                $html .= 'selected="selected"';
        }
        $html .= '>' . $phrase['_at_least_two_stars_upper'] . '</option>';
        
        $html .= '<option value="1"';
        if (isset($selected) AND $selected == 1)
        {
                $html .= 'selected="selected"';
        }
        $html .= '>' . $phrase['_one_star_upper'] . '</option></select>';
        
        return $html;
}

/*
* Function for fetching the state date / end date SQL condition for the search system.
*
* @param       integer        filter that is selected (-1 = any date), 1 = 1 hour, 2 = 2 hours, etc.
* @param       string         MySQL function to use (DATEADD, DATESUB), etc
* @param       string         field name in the database table to use
* @param       string         operator (>, <, =, etc)
*
* @return      string         Valid SQL condition code to include in main SQL code to parse
*/
function fetch_startend_sql($endstart_filter, $mysqlfunction, $field, $operator)
{
	global $ilance, $myapi;
        
        $sql = '';
	switch ($endstart_filter)
	{
		case '-1':
                {
                        // any date
                        $sql = "";
                        break;
                }	    
		case '1':
                {
                        // 1 hour
                        $sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL \"01:00\" HOUR_MINUTE) ";
                        break;
                }	    
		case '2':
                {
                        // 2 hours
                        $sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL \"02:00\" HOUR_MINUTE) ";
                        break;
                }	    
		case '3':
                {
                        // 3 hours
                        $sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL \"03:00\" HOUR_MINUTE) ";
                        break;
                }	    
		case '4':
                {
                        // 4 hours
                        $sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL \"04:00\" HOUR_MINUTE) ";
                        break;
                }	    
		case '5':
                {
                        // 5 hours
                        $sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL \"05:00\" HOUR_MINUTE) ";
                        break;
                }	    
		case '6':
                {
                        // 12 hours
                        $sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL \"12:00\" HOUR_MINUTE) ";
                        break;
                }	    
		case '7':
                {
                        // 24 hours
                        $sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL \"24:00\" HOUR_MINUTE) ";
                        break;
                }	    
		case '8':
                {
                        // 2 days
                        $sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL 2 DAY) ";
                        break;
                }	    
		case '9':
                {
                        // 3 days
                        $sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL 3 DAY) ";
                        break;
                }	    
		case '10':
                {
                        // 4 days
                	$sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL 4 DAY) ";
                	break;
                }	    
		case '11':
                {
                        // 5 days
                        $sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL 5 DAY) ";
                        break;
                }	    
		case '12':
                {
                        // 6 days
                        $sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL 6 DAY) ";
                        break;
                }	    
		case '13':
                {
                        // 7 days
                        $sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL 7 DAY) ";
                        break;
                }	    
		case '14':
                {
                        // 2 weeks
                        $sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL 14 DAY) ";
                        break;
                }	    
		case '15':
                {
                        // 1 month
                        $sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL 1 MONTH) ";
                        break;
                }
                case '16':
                {
                        // 2 months
                        $sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL 2 MONTH) ";
                        break;
                }
                case '17':
                {
                        // 3 months
                        $sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL 3 MONTH) ";
                        break;
                }
                case '18':
                {
                        // 6 months
                        $sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL 6 MONTH) ";
                        break;
                }
                case '19':
                {
                        // 1 year
                        $sql = " AND $field $operator $mysqlfunction('" . DATETIME24H . "', INTERVAL 1 YEAR) ";
                        break;
                }
	}
        
	return $sql;
}

/*
* Function for fetching the state date / end date phrase.
*
* @param       integer        filter that is selected (-1 = any date), 1 = 1 hour, 2 = 2 hours, etc.
*
* @return      string         HTML representation of the question title
*/
function fetch_startend_phrase($endstart_filter)
{
	global $ilance, $myapi, $phrase;
        
	switch ($endstart_filter)
	{
		case '-1':
		$sql = $phrase['_any_date'];
		break;
	    
		case '1':
		$sql = '1 ' . $phrase['_hour'];
		break;
	    
		case '2':
		$sql = '2 ' . $phrase['_hours'];
		break;
	    
		case '3':
		$sql = '3 ' . $phrase['_hours'];
		break;
	    
		case '4':
		$sql = '4 ' . $phrase['_hours'];
		break;
	    
		case '5':
		$sql = '5 ' . $phrase['_hours'];
		break;
	    
		case '6':
		$sql = '12 ' . $phrase['_hours'];
		break;
	    
		case '7':
		$sql = '24 ' . $phrase['_hours'];
		break;
	    
		case '8':
		$sql = '2 ' . $phrase['_days'];
		break;
	    
		case '9':
		$sql = '3 ' . $phrase['_days'];
		break;
	    
		case '10':
		$sql = '4 ' . $phrase['_days'];
		break;
	    
		case '11':
		$sql = '5 ' . $phrase['_days'];
		break;
	    
		case '12':
		$sql = '6 ' . $phrase['_days'];
		break;
	    
		case '13':
		$sql = '7 ' . $phrase['_days'];
		break;
	    
		case '14':
		$sql = '2 ' . $phrase['_weeks'];
		break;
	    
		case '15':
		$sql = '1 ' . $phrase['_month'];
		break;
	}
        
	return $sql;
}


/*
* Function to update default search options for a particular user who is registered and logged in.  This function will also update the existing session of the
* logged in user so it's realtime.
*
* @param        integer      user id
* @param        array        array with default search options
*
* @return	nothing
*/
function update_default_searchoptions($userid = 0, $defaultoptions = '')
{
        global $ilance;
        
        if (isset($userid) AND $userid > 0)
        {
                $ilance->db->query("
                        UPDATE " . DB_PREFIX . "users
                        SET searchoptions = '" . $ilance->db->escape_string($defaultoptions) . "'
                        WHERE user_id = '" . intval($userid) . "'
                ");
        }
        
        $_SESSION['ilancedata']['user']['searchoptions'] = $defaultoptions;
}

/*
* Function to update default search options for all guests and visitors connecting to the marketplace
*
* @param        integer      user id
* @param        array        array with default search options
*
* @return	nothing
*/
function update_default_searchoptions_guests($defaultoptions = '')
{
        global $ilance;
        
        if (isset($defaultoptions))
        {
                $ilance->db->query("
                        UPDATE " . DB_PREFIX . "configuration
                        SET value = '" . $ilance->db->escape_string($defaultoptions) . "'
                        WHERE name = 'searchdefaultcolumns'
                ");
        }
}

/*
* Function to update default search options for all members in the system
*
* @param        array        array with default search options
*
* @return	nothing
*/
function update_default_searchoptions_users($defaultoptions = '')
{
        global $ilance;
        
        if (isset($defaultoptions))
        {
                $ilance->db->query("
                        UPDATE " . DB_PREFIX . "users
                        SET searchoptions = '" . $ilance->db->escape_string($defaultoptions) . "'
                ");
        }
}

/*
* Function to print the per-page search option logic
*
* @param        string        css class to use
*
* @return	string        Returns HTML per page pulldown menu
*/
function print_perpage_searchoption($class = '')
{
        global $phrase;
        
        if (!empty($_SESSION['ilancedata']['user']['searchoptions']))
        {
                $pptemp = unserialize($_SESSION['ilancedata']['user']['searchoptions']);
                $perpagevalue = (int)$pptemp['perpage'];

                $perpage = '
                <select name="perpage" style="font-family: verdana" class="' . $class . '">
                <optgroup label="' . $phrase['_list'] . '">
                <option value="5" ' . (($perpagevalue == 5) ? 'selected="selected"' : '') . '>5</option>
                <option value="10" ' . (($perpagevalue == 10) ? 'selected="selected"' : '') . '>10</option>
                <option value="25" ' . (($perpagevalue == 25) ? 'selected="selected"' : '') . '>25</option>
                <option value="50" ' . (($perpagevalue == 50) ? 'selected="selected"' : '') . '>50</option>
                <option value="100" ' . (($perpagevalue == 100) ? 'selected="selected"' : '') . '>100</option>
                <option value="200" ' . (($perpagevalue == 200) ? 'selected="selected"' : '') . '>200</option>
                </optgroup>
                <optgroup label="' . $phrase['_gallery'] . '">
                <option value="6" ' . (($perpagevalue == 6) ? 'selected="selected"' : '') . '>6</option>
                <option value="9" ' . (($perpagevalue == 9) ? 'selected="selected"' : '') . '>9</option>
                <option value="12" ' . (($perpagevalue == 12) ? 'selected="selected"' : '') . '>12</option>
                <option value="24" ' . (($perpagevalue == 24) ? 'selected="selected"' : '') . '>24</option>
                <option value="48" ' . (($perpagevalue == 48) ? 'selected="selected"' : '') . '>48</option>
                <option value="96" ' . (($perpagevalue == 96) ? 'selected="selected"' : '') . '>96</option>
                <option value="192" ' . (($perpagevalue == 192) ? 'selected="selected"' : '') . '>192</option>
                </optgroup>
                </select>';
        }
        else
        {
                $perpage = '
                <select name="perpage" style="font-family: verdana">
                <option value="5">5</option>
                <option value="10" selected="selected">10</option>
                <option value="25">25</option>
                <option value="50">50</option>
                <option value="100">100</option>
                <option value="200">200</option>
                </select>';
        }
        
        return $perpage;
}

/*
* ...
*
* @param       
*
* @return      
*/
function print_checkbox_status($cbname)
{
        $cb = '';
        if (!empty($_SESSION['ilancedata']['user']['searchoptions']))
        {
                $cbtemp = unserialize($_SESSION['ilancedata']['user']['searchoptions']);
                if (isset($cbtemp[$cbname]))
                {
                        $cb = $cbtemp[$cbname];
                }
                if (isset($cb) AND $cb == 'true')
                {
                        $cb = 'checked="checked"';
                }
                else if (isset($cb) AND $cb == 'false')
                {
                        $cb = '';        
                }
        }
        
        return $cb;        
}

/*
* ...
*
* @param       
*
* @return      
*/
function print_time_static_radiobox_status()
{
        $rb = 'checked="checked"';
        if (!empty($_SESSION['ilancedata']['user']['searchoptions']))
        {
                $rbtemp = unserialize($_SESSION['ilancedata']['user']['searchoptions']);
                if (isset($rbtemp['showtimeas']))
                {
                        $rb = $rbtemp['showtimeas'];
                        if (isset($rb) AND $rb == 'static')
                        {
                                $rb = 'checked="checked"';
                        }
                }
        }
        
        return $rb;
}

/*
* ...
*
* @param       
*
* @return      
*/
function print_time_flash_radiobox_status()
{
        $rb = '';
        if (!empty($_SESSION['ilancedata']['user']['searchoptions']))
        {
                $rbtemp = unserialize($_SESSION['ilancedata']['user']['searchoptions']);
                if (isset($rbtemp['showtimeas']))
                {
                        $rb = $rbtemp['showtimeas'];
                }
                if (isset($rb) AND $rb == 'flash')
                {
                        $rb = 'checked="checked"';
                }
                else
                {
                        $rb = '';
                }
        }
        
        return $rb;
}

/*
* ...
*
* @param       
*
* @return      
*/
function print_list_gallery_radiobox_status()
{
        $rb = '';
        if (!empty($_SESSION['ilancedata']['user']['searchoptions']))
        {
                $rbtemp = unserialize($_SESSION['ilancedata']['user']['searchoptions']);
                if (isset($rbtemp['list']))
                {
                        $rb = $rbtemp['list'];
                }
                if (isset($rb) AND $rb == 'gallery')
                {
                        $rb = 'checked="checked"';
                }
                else
                {
                        $rb = '';
                }
        }
        
        return $rb;
}

/*
* ...
*
* @param       
*
* @return      
*/
function print_list_list_radiobox_status()
{
        $rb = 'checked="checked"';
        if (!empty($_SESSION['ilancedata']['user']['searchoptions']))
        {
                $rbtemp = unserialize($_SESSION['ilancedata']['user']['searchoptions']);
                if (isset($rbtemp['list']))
                {
                        $rb = $rbtemp['list'];
                        if (isset($rb) AND $rb == 'list')
                        {
                                $rb = 'checked="checked"';
                        }
                }
        }
        
        return $rb;
}

/*
* ...
*
* @param       
*
* @return      
*/
function sortable_array_handler($mode = 'listings')
{
        global $ilconfig;
        
        $array = array(
                // time_ending_soonest
                '01' => array(
                        'field' => 'p.date_end',
                        'sort' => 'ASC',
                        'extra' => ''
                ),
                // time_newly_listed
                '02' => array(
                        'field' => 'p.date_starts',
                        'sort' => 'DESC',
                        'extra' => ''
                ),
                // price_lowest_first
                '11' => array(
                        'field' => 'p.currentprice',
                        'sort' => 'ASC',
                        'extra' => ''
                ),
                // price_highest_first
                '12' => array(
                        'field' => 'p.currentprice',
                        'sort' => 'DESC',
                        'extra' => ''
                ),
                // bids_sort_up
                '21' => array(
                        'field' => 'p.bids',
                        'sort' => 'ASC',
                        'extra' => ''
                ),
                // bids_sort_down
                '22' => array(
                        'field' => 'p.bids',
                        'sort' => 'DESC',
                        'extra' => ''
                ),
                // category
                '31' => array(
                        'field' => 'p.cid',
                        'sort' => 'ASC',
                        'extra' => ''
                ),
                // feedback_lowest_first
                '41' => array(
                        'field' => 'u.feedback',
                        'sort' => 'ASC',
                        'extra' => ''
                ),
                // feedback_highest_first
                '42' => array(
                        'field' => 'u.feedback',
                        'sort' => 'DESC',
                        'extra' => ''
                ),
                // rated_lowest_first
                '51' => array(
                        'field' => 'u.rating',
                        'sort' => 'ASC',
                        'extra' => ''
                ),
                // rated_highest_first
                '52' => array(
                        'field' => 'u.rating',
                        'sort' => 'DESC',
                        'extra' => ''
                ),
                // expert_sort_up
                '61' => array(
                        'field' => 'u.username',
                        'sort' => 'ASC',
                        'extra' => ''
                ),
                // expert_sort_down
                '62' => array(
                        'field' => 'u.username',
                        'sort' => 'DESC',
                        'extra' => ''
                ),
                // city_sort_up
                '71' => array(
                        'field' => 'u.city',
                        'sort' => 'ASC',
                        'extra' => ''
                ),
                // city_sort_down
                '72' => array(
                        'field' => 'u.city',
                        'sort' => 'DESC',
                        'extra' => ''
                ),
                // country_sort_up
                '81' => array(
                        'field' => 'u.country',
                        'sort' => 'ASC',
                        'extra' => ''
                ),
                // country_sort_down
                '82' => array(
                        'field' => 'u.country',
                        'sort' => 'DESC',
                        'extra' => ''
                ),
                // zip_sort_up
                '91' => array(
                        'field' => 'u.zip_code',
                        'sort' => 'ASC',
                        'extra' => ''
                ),
                // zip_sort_down
                '92' => array(
                        'field' => 'u.zip_code',
                        'sort' => 'DESC',
                        'extra' => ''
                ),
                // earnings_lowest_first
                '101' => array(
                        'field' => 'u.income_reported',
                        'sort' => 'ASC',
                        'extra' => ''
                ),
                // earnings_highest_first
                '102' => array(
                        'field' => 'u.income_reported',
                        'sort' => 'DESC',
                        'extra' => ''
                ),
                // awards_lowest_first
                '111' => array(
                        'field' => 'u.serviceawards',
                        'sort' => 'ASC',
                        'extra' => ''
                ),
                // awards_highest_first
                '112' => array(
                        'field' => 'u.serviceawards',
                        'sort' => 'DESC',
                        'extra' => ''
                ),
                // distance
                '121' => array (
                        'field' => 'distance',
                        'sort' => 'ASC',
                        'extra' => ''
                ),
                '122' => array(
                        'field' => 'distance',
                        'sort' => 'DESC',
                        'extra' => ''
                ),
        );
        
        if ($ilconfig['globalserver_enabledistanceradius'] == false OR ($ilconfig['globalserver_enabledistanceradius'] AND !isset($ilance->GPC['radiuscountry']) AND !isset($ilance->GPC['radiuszip']) AND !isset($ilance->GPC['radius'])))
        {
                if ($mode == 'listings')
                {
                        $array['121'] = array(
                                 'field' => 'p.date_end',
                                 'sort' => 'ASC',
                                 'extra' => ''
                        );
                        
                        $array['122'] = array(
                                 'field' => 'p.date_end',
                                 'sort' => 'DESC',
                                 'extra' => ''
                        );
                }
                else if ($mode == 'experts')
                {
                        $array['121'] = array(
                                 'field' => 'u.income_reported',
                                 'sort' => 'ASC',
                                 'extra' => ''
                        );
                        
                        $array['122'] = array(
                                 'field' => 'u.income_reported',
                                 'sort' => 'DESC',
                                 'extra' => ''
                        );        
                }
        }
        
        return $array;
}

/*
* ...
*
* @param       
*
* @return      
*/
function fetch_sort_options($mode = 'service')
{
        global $ilance, $ilconfig;
        
        if ($mode == 'experts')
        {
                $sortoptions = array(
                        '41' => '_feedback_lowest_first',
                        '42' => '_feedback_highest_first',
                        '51' => '_rated_lowest_first',
                        '52' => '_rated_highest_first',
                        '61' => '_expert_sort_up',
                        '62' => '_expert_sort_down',
                        '71' => '_city_sort_up',
                        '72' => '_city_sort_down',
                        '81' => '_country_sort_up',
                        '82' => '_country_sort_down',
                        '91' => '_zip_sort_up',
                        '92' => '_zip_sort_down',
                        '101' => '_earnings_lowest_first',
                        '102' => '_earnings_highest_first',
                        '111' => '_awards_lowest_first',
                        '112' => '_awards_highest_first'
                );
                
                if ($ilconfig['globalserver_enabledistanceradius'])
                {
                        $sortoptions['121'] = '_distance_closest_first';
                        $sortoptions['122'] = '_distance_furthest_first';
                }
        }
        else if ($mode == 'service')
        {
                $sortoptions = array(
                        '01' => '_time_ending_soonest',
                        '02' => '_time_newly_listed',
                        '21' => '_bids_sort_up',
                        '22' => '_bids_sort_down',
                        '71' => '_city_sort_up',
                        '72' => '_city_sort_down',
                        '81' => '_country_sort_up',
                        '82' => '_country_sort_down',
                        '91' => '_zip_sort_up',
                        '92' => '_zip_sort_down',
                        '31' => '_category'
                );
                
                if ($ilconfig['globalserver_enabledistanceradius'])
                {
                        $sortoptions['121'] = '_distance_closest_first';
                        $sortoptions['122'] = '_distance_furthest_first';
                }
        }
        else if ('product')
        {
                $sortoptions = array(
                        '01' => '_time_ending_soonest',
                        '02' => '_time_newly_listed',
                        '11' => '_price_lowest_first',
                        '12' => '_price_highest_first',
                        '21' => '_bids_sort_up',
                        '22' => '_bids_sort_down',
                        '71' => '_city_sort_up',
                        '72' => '_city_sort_down',
                        '81' => '_country_sort_up',
                        '82' => '_country_sort_down',
                        '91' => '_zip_sort_up',
                        '92' => '_zip_sort_down',
                        '31' => '_category'
                );
                
                if ($ilconfig['globalserver_enabledistanceradius'])
                {
                        $sortoptions['121'] = '_distance_closest_first';
                        $sortoptions['122'] = '_distance_furthest_first';
                }
        }
        
        ($apihook = $ilance->api('print_sort_options_end')) ? eval($apihook) : false;
        
        return $sortoptions;
}

/*
* ...
*
* @param       
*
* @return      
*/
function print_sort_pulldown($selected = '', $fieldname = 'sort', $mode = 'service')
{
        global $phrase, $show;
        
        if (!empty($_SESSION['ilancedata']['user']['searchoptions']))
        {
                $temp = unserialize($_SESSION['ilancedata']['user']['searchoptions']);
                
                $options = array();
                $options = fetch_sort_options($mode);
                
                $html = '<select name="' . $fieldname . '" style="font-family: verdana">';
                foreach ($options AS $key => $value)
                {
                        if (isset($selected) AND $selected == $key)
                        {                                
                                $html .= '<option value="' . $key . '" selected="selected">' . $phrase[$options[$key]] . '</option>';
                        }
                        else
                        {
                                if (isset($temp['sort']) AND $temp['sort'] == $key)
                                {
                                        $html .= '<option value="' . $key . '" selected="selected">' . $phrase[$options[$key]] . '</option>';
                                }
                                else
                                {
                                        $html .= '<option value="' . $key . '">' . $phrase[$options[$key]] . '</option>';
                                }
                        }
                }
                $html .= '</select>';
        }
        else
        {
                $options = array();
                $options = fetch_sort_options($mode);
                
                $html = '<select name="' . $fieldname . '" style="font-family: verdana">';
                foreach ($options AS $key => $value)
                {
                        if (isset($selected) AND $selected == $key)
                        {
                                $html .= '<option value="' . $key . '" selected="selected">' . $phrase["$value"] . '</option>';
                        }
                        else
                        {
                                $html .= '<option value="' . $key . '">' . $phrase["$value"] . '</option>';
                        }
                }
                $html .= '</select>';
        }
        
        return $html;
}

/*
* ...
*
* @param       
*
* @return      
*/
function fetch_perpage()
{
        global $ilance, $ilconfig;
        
        // set the default per page limit
        $perpage = $ilconfig['globalfilters_maxrowsdisplay'];
        
        // check if we're a user logged with existing search parameters setup
        if (!empty($_SESSION['ilancedata']['user']['searchoptions']))
        {
                if (empty($ilance->GPC['pp']))
                {
                        // user hasn't specified a url base per page value .. use default from existing search setup
                        $pptemp = unserialize($_SESSION['ilancedata']['user']['searchoptions']);
                        $perpage = (int)$pptemp['perpage'];
                }
                else
                {
                        // user is requesting a specific per page limit
                        $perpage = intval($ilance->GPC['pp']);
                        if ($perpage == 0 OR $perpage < 0)
                        {
                                // if user get's fancy with pp url value we'll use the safest option available.. the default!
                                $perpage = $ilconfig['globalfilters_maxrowsdisplay'];
                        }
                }
        }
        else
        {
                if (!empty($ilance->GPC['pp']) AND $ilance->GPC['pp'] > 0)
                {
                        // user is requesting a specific per page limit
                        $perpage = intval($ilance->GPC['pp']);
                        if ($perpage == 0 OR $perpage < 0)
                        {
                                // if user get's fancy with pp url value we'll use the safest option available.. the default!
                                $perpage = $ilconfig['globalfilters_maxrowsdisplay'];
                        }
                }
        }
        
        if ($perpage < 0)
        {
                $perpage = $ilconfig['globalfilters_maxrowsdisplay'];
        }
        
        return $perpage;
}

/*
* Function to return the opposite value of the perpage result limit when switching between list view and gallery view.  This function
* will prevent "blocks" in the search results (when viewing gallery mode) from being blank and will fill up with all results available.
*
* @param        string       list viewing type currently selected (list/gallery)
* @param        integer      actual per page value being used
*
* @return       integer      Returns integer with opposite per page value
*/
function fetch_proper_perpage($listview = '')
{
        global $ilance;
        
        $pp = fetch_perpage();
        
        $array = array();        
        if ($listview == 'gallery')
        {
                $array = array(
                        '1' => '6',
                        '2' => '6',
                        '3' => '6',
                        '4' => '6',
                        '5' => '6',
                        '6' => '6',
                        '10' => '12',
                        '12' => '12',
                        '24' => '24',
                        '25' => '24',
                        '48' => '48',
                        '50' => '48',
                        '96' => '96',
                        '100' => '96',
                        '192' => '192',
                        '200' => '192'
                );
        }
        else if ($listview == 'list')
        {
                $array = array(
                        '1' => '5',
                        '2' => '5',
                        '3' => '5',
                        '4' => '5',
                        '5' => '5',
                        '6' => '5',
                        '10' => '10',
                        '12' => '10',
                        '24' => '25',
                        '25' => '25',
                        '48' => '50',
                        '50' => '50',
                        '96' => '100',
                        '100' => '100',
                        '192' => '200',
                        '200' => '200'
                );
        }
        
        return $array["$pp"];
}

/*
* Function responsible for printing the main search results table within the search system.  This function handles
* all logic for building custom searchable display columns, gallery view, list view and more.
*
* @param        array        search results array
* @param        string       category type (service/product)
* @param        string       constructed pagnation output
*
* @return      
*/
function print_search_results_table($searchresults = array(), $mode = 'service', $prevnext = '')
{
        global $ilance, $ilconfig, $phrase, $show, $textgenre, $ilpage, $php_self_urlencoded;
        
        $ilance->template_columns = construct_object('api.template_columns');
        
        //$tdclass = ($mode == 'service' OR $mode == 'experts') ? 'tablehead_alt' : 'tablehead_alt2';
        //$tdfooterclass = ($mode == 'service' OR $mode == 'experts') ? 'tfooter' : 'tfooter2';
        
        $tdclass = '';
        $tdfooterclass = '';
        
        if ($mode == 'service')
        {
                $tdphrase = $phrase['_service_auction_listings'];
        }
        else if ($mode == 'product')
        {
                $tdphrase = $phrase['_items'];
        }
        else if ($mode == 'experts')
        {
                $tdphrase = $phrase['_experts'];
        }
        
        $scriptpage = $ilpage['search'] . print_hidden_fields($string = true, $excluded = array('budget','list'), $questionmarkfirst = true, $prepend_text = '', $append_text = '', $htmlentities = true);
        
        // user is overriding his/her list preference for a moment.. 
        if (isset($ilance->GPC['list']) AND $ilance->GPC['list'] == 'list')
        {
                $listviewtype = '<span style="float:right" class="smaller"><a href="' . $scriptpage . '&amp;list=list" title="' . $phrase['_list_view'] . '"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/list_current.gif" border="0" alt="' . $phrase['_list_view'] . '" /></a><a href="' . $scriptpage . '&amp;list=gallery" title="' . $phrase['_gallery_view'] . '"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/gallery.gif" border="0" alt="' . $phrase['_gallery_view'] . '" /></a></span>';
                $forcepp = fetch_proper_perpage('list');
                $_SESSION['ilancedata']['user']['searchoptions'] = unserialize($_SESSION['ilancedata']['user']['searchoptions']);
                $_SESSION['ilancedata']['user']['searchoptions']['list'] = 'list';
                $_SESSION['ilancedata']['user']['searchoptions']['perpage'] = $forcepp;
                $_SESSION['ilancedata']['user']['searchoptions'] = serialize($_SESSION['ilancedata']['user']['searchoptions']);
        }
        else if (isset($ilance->GPC['list']) AND $ilance->GPC['list'] == 'gallery')
        {
                $listviewtype = '<span style="float:right" class="smaller"><a href="' . $scriptpage . '&amp;list=list" title="' . $phrase['_list_view'] . '"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/list.gif" border="0" alt="' . $phrase['_list_view'] . '" /></a><a href="' . $scriptpage . '&amp;list=gallery" title="' . $phrase['_gallery_view'] . '"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/gallery_current.gif" border="0" alt="' . $phrase['_gallery_view'] . '" /></a></span>';
                $forcepp = fetch_proper_perpage('gallery');
                $_SESSION['ilancedata']['user']['searchoptions'] = unserialize($_SESSION['ilancedata']['user']['searchoptions']);
                $_SESSION['ilancedata']['user']['searchoptions']['list'] = 'gallery';
                $_SESSION['ilancedata']['user']['searchoptions']['perpage'] = $forcepp;
                $_SESSION['ilancedata']['user']['searchoptions'] = serialize($_SESSION['ilancedata']['user']['searchoptions']);
        }
        
        // generate list view or gallery view icons
        $opts = array();
        if (!empty($_SESSION['ilancedata']['user']['searchoptions']))
        {
                $opts = unserialize($_SESSION['ilancedata']['user']['searchoptions']);
                if (isset($opts['list']) AND $opts['list'] == 'list')
                {
                        $forcepp = fetch_proper_perpage('gallery');
                        $listviewtype = '<span style="float:right" class="smaller"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/list_current.gif" border="0" alt="' . $phrase['_list_view'] . '" /><a href="' . $scriptpage . '&amp;list=gallery&amp;pp=' . $forcepp . '" title="' . $phrase['_gallery_view'] . '"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/gallery.gif" border="0" alt="' . $phrase['_gallery_view'] . '" /></a></span>';
                }
                else if (isset($opts['list']) AND $opts['list'] == 'gallery')
                {
                        $forcepp = fetch_proper_perpage('list');
                        $listviewtype = '<span style="float:right" class="smaller"><a href="' . $scriptpage . '&amp;list=list&amp;pp=' . $forcepp . '" title="' . $phrase['_list_view'] . '"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/list.gif" border="0" alt="' . $phrase['_list_view'] . '" /></a><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/gallery_current.gif" border="0" alt="' . $phrase['_gallery_view'] . '" /></span>';
                }
        }
        else
        {
                $opts = fetch_default_searchoptions();
                $opts = unserialize($opts);
                $listviewtype = '<span style="float:right" class="smaller"><a href="' . $scriptpage . '&amp;list=list" title="' . $phrase['_list_view'] . '"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/list_current.gif" border="0" alt="' . $phrase['_list_view'] . '" /></a><a href="' . $scriptpage . '&amp;list=gallery" title="' . $phrase['_gallery_view'] . '"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/gallery.gif" border="0" alt="' . $phrase['_gallery_view'] . '" /></a></span>';
                if (!isset($ilance->GPC['list']))
                {
                    $opts['list'] = 'list';
                }
                else
                {
                    $opts['list'] = $ilance->GPC['list'];
                }
                
                if ($opts['list'] == 'list')
                {
                        $forcepp = fetch_proper_perpage('gallery');
                        $listviewtype = '<span style="float:right" class="smaller"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/list_current.gif" border="0" alt="' . $phrase['_list_view'] . '" /> <a href="' . $scriptpage . '&amp;list=gallery&amp;pp=' . $forcepp . '" title="' . $phrase['_gallery_view'] . '"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/gallery.gif" border="0" alt="' . $phrase['_gallery_view'] . '" /></a></span>';
                }
                else if ($opts['list'] == 'gallery')
                {
                        $forcepp = fetch_proper_perpage('list');
                        $listviewtype = '<span style="float:right" class="smaller"><a href="' . $scriptpage . '&amp;list=list&amp;pp=' . $forcepp . '" title="' . $phrase['_list_view'] . '"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/list.gif" border="0" alt="' . $phrase['_list_view'] . '" /></a><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/gallery_current.gif" border="0" alt="' . $phrase['_gallery_view'] . '" /></span>';
                }        
        }
        
        // fetch html columns for printing along with the colspan info
        $data = $ilance->template_columns->print_table_head_columns($searchresults, $mode, $opts['list']);

        $tablecolumns = $data['columns'];
        $tablerows = $data['rows'];
        $colspan = $data['colspan'];
                
        // free up some memory
        unset($data);
        
        // #### SEARCH HEADER TABS #############################################
        $html = '';
        $blockcss = '2';
        $blockclass = 'block2-content-blue';
        if ($mode == 'product')
        {
                $blockcss = '';
                $blockclass = 'block-content-yellow';
                if (isset($ilance->GPC['buynow']) AND $ilance->GPC['buynow'] == '1')
                {
                        $sel1 = '';
                        $sel2 = 'on';
                        $sel3 = '';
                        
                        $url1 = $ilpage['search'] . '?mode=product&amp;sort=10';
                        $url2 = 'javascript:void(0)';
                        $url3 = $ilpage['search'] . '?mode=product&amp;auctiontype=4&amp;sort=10';
                }
                else if (isset($ilance->GPC['auctiontype']) AND $ilance->GPC['auctiontype'] == '4' AND $ilconfig['enable_uniquebidding'])
                {
                        $sel1 = '';
                        $sel2 = '';
                        $sel3 = 'on';
                        
                        $url1 = $ilpage['search'] . '?mode=product&amp;sort=10';
                        $url2 = $ilpage['search'] . '?mode=product&amp;buynow=1&amp;sort=10';
                        $url3 = 'javascript:void(0)';
                }
                else
                {
                        $sel1 = 'on';
                        $sel2 = '';
                        $sel3 = '';
                        
                        $url1 = 'javascript:void(0)';
                        $url2 = $ilpage['search'] . '?mode=product&amp;buynow=1&amp;sort=10';
                        $url3 = $ilpage['search'] . '?mode=product&amp;auctiontype=4&amp;sort=10';
                }
                
                $html .= '
<div class="bigtabs" style="padding-bottom:10px; padding-top:10px">
<div class="bigtabsheader">
<ul>
        <li id="" title="" class="' . $sel1 . '"><a href="' . $url1 . '">' . $phrase['_all_listings'] . '</a></li>
        <li id="" title="" class="' . $sel2 . '"><a href="' . $url2 . '">' . $phrase['_fixed_price'] . ' <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/money.gif" border="0" alt="" /></a></li>';
        
if ($ilconfig['enable_uniquebidding'])
{
        $html .= '<li id="" title="" class="' . $sel3 . '"><a href="' . $url3 . '">' . $phrase['_lowest_unique_bid'] . '</a></li>';
}

$html .= '
</ul>
</div>
</div>
<div style="clear:both;"></div>';
        }
        
        // #### SEARCH HEADER TABLE ############################################
        $html .= '
        <div class="block-wrapper">

                <div class="block' . $blockcss . '">
                
                                <div class="block' . $blockcss . '-top">
                                        <div class="block' . $blockcss . '-right">
                                                <div class="block' . $blockcss . '-left"></div>
                                        </div>
                                </div>
                                
                                <div class="block' . $blockcss . '-header">' . $listviewtype . $tdphrase . '</div>
                                <div class="block' . $blockcss . '-content" style="padding:0px">
                                
                                <table width="100%" border="0" align="center" cellpadding="9" cellspacing="1">';
                                
        // parse and print user generated table head columns
        $html .= $tablecolumns;
        
        // parse and print generate user column display data rows
        $html .= $tablerows;
        
        // determine if we need to display " -- no results found -- "
        if (isset($show['no_rows_returned']) AND $show['no_rows_returned'])
        {
                $html .= '
                                <tr class="alt1">
                                        <td colspan="' . $colspan . '" align="center">
                                                <div style="padding-top:8px; padding-bottom:8px">' . $phrase['_no_results_found'] . '</div></td>
                                </tr>
                                <tr class="alt1">
                                        <td colspan="' . $colspan . '" align="center">';
                                        
                $html .= ((isset($ilconfig['fulltextsearch']) AND $ilconfig['fulltextsearch']) ? '<div align="left"><span style="font-size:14px; font-weight:bold">' . $phrase['_learn_more_about_searching'] . ':</span> <span class="blue"><a href="' . $ilpage['search'] . '?cmd=help">' . $phrase['_advanced_search_commands'] . '</a></span></div>' : '');
                $html .= '              </td>
                                </tr>';
        }
        
        // print our table footer which includes any pulldown menus and/or selection menu buttons / controls or widgets
        if (isset($show['no_rows_returned']) AND $show['no_rows_returned'] == false AND !empty($_SESSION['ilancedata']['user']['userid']))
        {
                $html .= '
                                <tr class="alt1"> 
                                        <td colspan="' . $colspan . '" class="' . $tdfooterclass . '">
                                                <span style="float:left; padding-top:4px;">
                                                        <input type="button" onclick="inlineCB.check_all(true)" class="buttons" value="' . $phrase['_select_all'] . '" /> 
                                                        <input type="button" onclick="inlineCB.check_all(false)" class="buttons" value="' . $phrase['_deselect_all'] . '" />
                                                        <input type="button" onclick="inlineCB.check_all(\'invert\')" class="buttons" value="' . $phrase['_invert'] . '" />
                                                </span>
                                                <span style="float:right;">';
                                                
                                                if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0 AND isset($show['no_rows_returned']) AND $show['no_rows_returned'] == false)
                                                {
                                                        $html .= '
                                                        <select name="action" style="font-family: verdana">
                                                        <optgroup label="' . $phrase['_select_action'] . '">
                                                        ' .  ($mode != 'experts' ? '<option value="compare">' . $phrase['_compare'] . '</option>' : '')  . '
                                                        <option value="watchlist">' . $phrase['_add_to_watchlist'] . '</option>
                                                        ' .  ($mode == 'experts' ? '<option value="invite">' . $phrase['_invite_to_bid'] . '</option>' : '')  . '
                                                        </optgroup>
                                                        </select>&nbsp;
                                                        <input type="submit" class="buttons" value=" ' . $phrase['_go'] . ' " id="inlinebutton" />
                                                        <script type="text/javascript">
                                                        <!--
                                                        inlineCB = new iL_Inline(\'inlineCB\', \'' . $mode . '\', \'searchform\', \'' . $phrase['_go'] . '\');
                                                        //-->
                                                        </script>';
                                                }
                                                
                                                $html .= '
                                                </span>
                                        </td>
                                </tr>';
        }
        
        $html .= '              <tr>
                                        <td colspan="' . $colspan . '" class="' . $tdfooterclass . '">' . $prevnext . '</td>
                                </tr>';
               
        ($apihook = $ilance->api('print_search_results_table_end')) ? eval($apihook) : false;
        
        $html .= '              </table>                        
                                </div>
                                
                                <div class="block' . $blockcss . '-footer">
                                        <div class="block' . $blockcss . '-right">
                                                <div class="block' . $blockcss . '-left"></div>
                                        </div>
                                </div>
                                
                </div>
        </div>';
        
        return $html;
}

/*
* Function to print skills used within the provider search results.
*
* @param       integer       user id
* @param       integer       maximum number of skills to display (default 100)
* @param       boolean       no url links (default false)
*
* @return      
*/
function print_skills($userid = 0, $showmaxskills = 100, $nourls = false)
{
        global $ilance, $phrase, $ilpage, $ilconfig;
        
        $html = $phrase['_pending'];
        
        $sql = $ilance->db->query("
                SELECT a.cid, s.title_" . $_SESSION['ilancedata']['user']['slng'] . " AS title
                FROM " . DB_PREFIX . "skills_answers a
                LEFT JOIN " . DB_PREFIX . "skills s ON s.cid = a.cid
                WHERE a.user_id = '" . intval($userid) . "'
                ORDER BY a.cid ASC
                LIMIT $showmaxskills
        ");
        if ($ilance->db->num_rows($sql) > 0)
        {
                $html = '';
                
                if (defined('PHP_SELF'))
                {
                        $scriptpage = PHP_SELF;
                }
                else
                {
                        $scriptpage = $ilpage['search'];
                }
                while ($res = $ilance->db->fetch_array($sql))
                {
                        $title = stripslashes($res['title']);
                        if (!empty($ilance->GPC['sid'][$res['cid']]))
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'sid[' . $ilance->GPC['sid'][$res['cid']] . ']=true');
                        }
                        else
                        {
                                $removeurl = $scriptpage;
                        }
                        
                        if ($nourls == false)
                        {
                                if (isset($ilance->GPC['sid']) AND !empty($ilance->GPC['sid'][$res['cid']]))
                                {
                                        $html .= '<span style="color:#000"><strong>' . $title . '</strong></span>, ';
                                }
                                else
                                {
                                        $html .= '<a href="' . $removeurl  . '&amp;sid[' . $res['cid'] . ']=true" title="' . $phrase['_show_only_providers_skilled_in'] . ' ' . $title . '" class="gray">' . $title . '</a>, ';
                                }
                        }
                        else
                        {
                                $html .= $title . ', ';
                        }
                                
                }
                if (!empty($html))
                {
                        $html = mb_substr($html, 0, -2);
                }
        }
        
        return $html;
}

/*
* Function to print out the skill title based on a particular category id.
*
* @param       integer         category id
*
* @return      
*/
function print_skill_title($sid = 0)
{
        global $ilance, $phrase;
        
        $html = $ilance->db->fetch_field(DB_PREFIX . "skills", "cid = '" . $sid . "'", "title_" . $_SESSION['ilancedata']['user']['slng']);
         
        return $html;
}

/*
* Function to actually do all the independent searching based on a user entering many keywords for their search pattern.
* Additionally, this function will output a formatted <li></li> result set allowing the user to click those links to refine
* their search.
*
* @param       array         keywords being used (array)
* @param       string        category type (service/product)
* @param       integer       results found     
*
* @return      
*/
function fetch_fewer_keyword_links($keywords = array(), $cattype = '', $limit = 4)
{
        global $ilance, $ilpage, $phrase;
        
        $html = array('html' => '', 'count' => '4');
        if (isset($keywords) AND is_array($keywords))
        {
                // ie: "50 Double Dual Layer Blank Disk"
                // 1. "Double Dual Layer Blank Disk"
                // 2. "50 Double Dual Layer"
                // 3. "Double Dual Layer Blank"
                // 4. "Double Dual Blank Disk"
                
                $html['html'] = '<ul>';
                $num = 0;
                foreach ($keywords as $keyword)
                {
                        if ($num <= $limit)
                        {
                                $html['html'] .= '<li><span><a href="' . $ilpage['search'] .'?mode=' . $cattype . '&amp;q=' . urlencode($keyword) . '"><strong>4 items</strong></a> found for ' . $keyword . ' <b>50</b> <b>Double</b> <b>Dual</b> <b>Layer</b> <strike>Blank</strike> <strike>Disk</strike></li>';
                                //$html['html'] = '<li><span><a href="#" style="text-decoration:none"><strong>1 items</strong></a> found for <b>50</b> <b>Double</b> <b>Dual</b> <b>Layer</b> <strike>Blank</strike> <strike>Disk</strike> </span></li><li><span><a href="#" style="text-decoration:none"><strong>4 items</strong></a> found for <strike>50</strike> <b>Double</b> <b>Dual</b> <b>Layer</b> <b>Blank</b> <strike>Disk</strike> </span></li><li><span><a href="#" style="text-decoration:none"><strong>4 items</strong></a> found for <strike>50</strike> <b>Double</b> <b>Dual</b> <strike>Layer</strike> <b>Blank</b> <b>Disk</b> </span></li>';
                                $num++;
                        }
                        
                }
                $html['html'] .= '</ul>';
                
                /*
                <li><span><a href="#" style="text-decoration:none"><strong>1 items</strong></a> found for <b>50</b> <b>Double</b> <b>Dual</b> <b>Layer</b> <strike>Blank</strike> <strike>Disk</strike> </span></li>
                <li><span><a href="#" style="text-decoration:none"><strong>4 items</strong></a> found for <strike>50</strike> <b>Double</b> <b>Dual</b> <b>Layer</b> <b>Blank</b> <strike>Disk</strike> </span></li>
                <li><span><a href="#" style="text-decoration:none"><strong>4 items</strong></a> found for <strike>50</strike> <b>Double</b> <b>Dual</b> <strike>Layer</strike> <b>Blank</b> <b>Disk</b> </span></li>                 
                */
        }
                
        return $html;
}

/*
* This function will display a few links if the user entered many keywords allowing them to refine their search.
* For example, if a user searches for "50 Double Dual Layer Blank Disk", the search system will attempt to independently
* find other results (with count > 0) based on various mixing and matching of the various keywords.
*
* Example keyword: "50 Double Dual Layer Blank Disk"
*
* 1. "Double Dual Layer Blank Disk"
* 2. "50 Double Dual Layer"
* 3. "Double Dual Layer Blank"
* 4. "Double Dual Blank Disk"
*
* @param       array         keywords being used (array)
* @param       string        category type (service/product)
* @param       integer       results found
*
* @return      
*/
function print_fewer_keywords_search($keywords = array(), $cattype = '', $resultsfound = 0)
{
        global $ilance, $phrase, $show;
        
        $show['showfewerkeywords'] = false;
        
        return; // not ready
        
        $html = '';
        
        // checks if keywords array is not empty, if more than 2 keywords and results equal to zero or results less than 5
        // we will search and find more matches for user based on fewer keywords
        if (isset($keywords) AND is_array($keywords) AND count($keywords) >= 2 AND ($resultsfound == 0 OR $resultsfound < 5))
        {
                $temp = fetch_fewer_keyword_links($keywords, $cattype, $limit = 4);
                
                // html of the links returned from other fewer results found
                $fewerhtml = $temp['html'];
                
                // number of fewer result links found
                $count = $temp['count'];
                
                if ($count > 0)
                {
                        $show['showfewerkeywords'] = true;
                        $html = '<div class="bluehlite"><div><strong>' . $phrase['_get_more_results_with_fewer_keywords'] . '</strong></div>' . $fewerhtml . '</div>';
                }
                else
                {
                        $show['showfewerkeywords'] = false;
                }
                unset($temp);
        }
        
        return $html;
}

function fetch_filtered_searchoptions()
{
        global $ilance, $ilconfig, $phrase;
        
	$filtercolumns = array();
	
        $sql = $ilance->db->query("
                SELECT questionid, question, filtertype
                FROM " . DB_PREFIX . "profile_questions
                WHERE isfilter = '1'
                ORDER BY sort ASC
        ");
        if ($ilance->db->num_rows($sql) > 0)
        {
                while ($res = $ilance->db->fetch_array($sql))
                {
                        $filtercolumns['profile_' . $res['questionid']] = stripslashes($res['question']);
                }
        }
        
        return $filtercolumns;
}

function build_expert_search_exclusion_sql($fieldidentifier = '', $permission = '')
{
        global $ilance, $ilconfig, $phrase;
        
        $ilance->subscription = construct_object('api.subscription');
        
        $html = '';
        
        $sql = $ilance->db->query("
                SELECT user_id
                FROM " . DB_PREFIX . "users
                WHERE status = 'active'
        ");
        if ($ilance->db->num_rows($sql) > 0)
        {
                $excluded = 0;
                
                while ($res = $ilance->db->fetch_array($sql))
                {
                        if ($ilance->subscription->check_access($res['user_id'], $permission) == 'yes' AND display_profile($res['user_id']))
                        {
                                $ids[] = $res['user_id'];
                                $excluded++;
                        }
                }
                
                if (isset($ids) AND count($ids) > 0)
                {
                        $html = "AND " . $fieldidentifier . "user_id IN (" . implode(',', $ids) . ") ";
                }
        }
        
        return $html;
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: functions_search.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>