<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

define('ILANCEVERSION', '3.1.8'); // this should match installer.php
define('VERSIONSTRING', str_replace('.', '', ILANCEVERSION));
define('SVNVERSION', '1006');

/**
* Define our line-break pattern (Windows: \r\n or Linux: \n)
*/
define('LINEBREAK', "\r\n");

/**
* defines if we have multibyte encoding available
*/
define('MULTIBYTE', (extension_loaded('mbstring') AND function_exists('mb_detect_encoding')) ? true : false);

/**
* Initialize our $show array for template conditionals
*/
$show = array();

/**
* Begin $myapi array so that developers can use {myapi[xxx]} in templates
* by assigning them like $myapi['xxx'] = 'something'; in the php
*/
$myapi = array();

/**
* Paths
*/
require_once('./paths.php');

/**
* Initialize core functions
*/
require_once(DIR_FUNCTIONS . 'connect.php');
require_once(DIR_CORE . 'functions.php');
require_once(DIR_FUNCTIONS . 'init.php');

/**
* Used only when installing the software.
*/
if (defined('LOCATION') AND LOCATION == 'installer')
{
	// define templates folder based on the style currently selected
	define('DIR_TEMPLATES', DIR_SERVER_ROOT . 'templates/');
	return;
}

/**
* Initialize session datastore
*/
session_start();

/**
* Determine and handle a user selected language or style switch
* This function also sets the default currency for the visitor
*/
$ilance->sessions->handle_language_style_changes();

/**
* This will remember users that have selected to be rememberd
* It basically checks and reads $_COOKIE['userid'], $_COOKIE['username'] and $_COOKIE['password']
* and when found, attempts to auto-login and set proper user sessions
*/
$ilance->sessions->init_remembered_session();

/**
* Initialize locale environment (helpful for languages other than english)
*/
$locale = $ilance->fetch_language_locale($_SESSION['ilancedata']['user']['languageid']);
setlocale(LC_TIME, $locale['locale']);
unset($locale);

$ilconfig['official_time'] = print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], true, false);
$ilconfig['template_charset'] = $ilance->language->cache[$_SESSION['ilancedata']['user']['languageid']]['charset'];
$ilconfig['template_languagecode'] = $ilance->language->cache[$_SESSION['ilancedata']['user']['languageid']]['languageiso'];
$ilconfig['template_textdirection'] = $ilance->language->cache[$_SESSION['ilancedata']['user']['languageid']]['textdirection'];

/**
* Handle cookies and template collapsable expand/deflate icons
* For each cookie identifier in the list, this code will hide those elements
*/
$ilcollapse = array();
if (!empty($_COOKIE[COOKIE_PREFIX . 'collapse']))
{
	$cookiedata = explode('|', $_COOKIE[COOKIE_PREFIX . 'collapse']);
	foreach ($cookiedata as $cookiekey)
	{
		$ilcollapse["collapseobj_$cookiekey"] = 'display: none;';
		$ilcollapse["collapseimg_$cookiekey"] = '_collapsed';
	}
}
unset($cookiedata, $cookiekey);

/**
* Handle cookies and template collapsable deflate boxes
* For each cookie identifier in the list, this code will show those elements
*/
if (!empty($_COOKIE[COOKIE_PREFIX . 'deflate']))
{	
	$cookiedata = explode('|', $_COOKIE[COOKIE_PREFIX . 'deflate']);
	foreach ($cookiedata as $cookiekey)
	{
		$ilcollapse["$cookiekey"] = 'display: inline;';
	}	
}
unset($cookiedata, $cookiekey);

($apihook = $ilance->api('global_start')) ? eval($apihook) : false;

/**
* Initialize language phrases datastore
*/
$phrase = $ilance->language->init_phrases();

/**
* Initialize main breadcrumb phrases
*/
$ilcrumbs = fetch_breadcrumb_titles();

/**
* Initialize styles and template variables backend
*/
$ilance->styles = construct_object('api.styles');

// this style may require a different template folder for html files
define('DIR_TEMPLATES', DIR_SERVER_ROOT . $ilconfig['template_folder']);
define('DIR_TEMPLATES_ADMIN', DIR_SERVER_ROOT . $ilconfig['template_folder'] . 'admincp/');

/*
* Initialize ip banning backend
*/
$ilance->ipban = construct_object('api.ipban');

/**
* Initialize admin control panel breadcrumb and login info
*/
if (defined('LOCATION') AND LOCATION == 'admin')
{
	$ilance->admincp = construct_object('api.admincp');
	
	$login_include_admin = $ilance->common->admin_login_include();
	$ilanceversion = $ilance->admincp->print_version();
}

/**
* Initialize client breadcrumb and login info
*/
if (defined('LOCATION') AND LOCATION == 'registration')
{
	$login_include = '';
	if (!empty($_SESSION['ilancedata']['user']['builduser']))
	{
		$login_include = $ilance->common->login_include();
	}
}
else
{
	$login_include = $ilance->common->login_include();
}

/**
* Initalize referral system tracker
*/
init_referral_tracker();

/**
* Initalize multibyte character encoding
*/
if (MULTIBYTE)
{
	mb_internal_encoding($ilconfig['template_charset']);
}

($apihook = $ilance->api('global_end')) ? eval($apihook) : false;

header('Content-type: text/html; charset="' . $ilconfig['template_charset'] . '"');  
header('Cache-control: private');

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: global.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>