<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/
if (!isset($GLOBALS['ilance']->db))
{
    die('<strong>Warning:</strong> This script does not appear to have database functions loaded.  Operation aborted.');
}

function import_distance_data($schema = '')
{
    global $ilance;
    
    if (empty($schema))
    {
            return false;
    }
    
    $title = $table = $filename = '';
    $count = 0;
    
    if ($schema == 'au')
    {
        $title = 'Australia';
        $count = number_format(16079);
        $table = DB_PREFIX . 'distance_au';
        $filename = 'distance_au.php';
    }
    else if ($schema == 'be')
    {
        $title = 'Belgium';
        $count = number_format(3778);
        $table = DB_PREFIX . 'distance_be';
        $filename = 'distance_be.php';
    }
    else if ($schema == 'canada')
    {
        $title = 'Canada';
        $count = number_format(774014);
        $table = DB_PREFIX . 'distance_canada';
        $filename = 'distance_canada.php';
    }
    else if ($schema == 'de')
    {
        $title = 'Germany';
        $count = number_format(16375);
        $table = DB_PREFIX . 'distance_de';
        $filename = 'distance_de.php';
    }
    else if ($schema == 'in')
    {
        $title = 'India';
        $count = number_format(14568);
        $table = DB_PREFIX . 'distance_in';
        $filename = 'distance_in.php';
    }
    else if ($schema == 'nl')
    {
        $title = 'Netherlands';
        $count = number_format(435296);
        $table = DB_PREFIX . 'distance_nl';
        $filename = 'distance_nl.php';
    }
    else if ($schema == 'pl')
    {
        $title = 'Poland';
        $count = number_format(21987);
        $table = DB_PREFIX . 'distance_pl';
        $filename = 'distance_pl.php';
    }
    else if ($schema == 'sp')
    {
        $title = 'Spain';
        $count = number_format(54116);
        $table = DB_PREFIX . 'distance_sp';
        $filename = 'distance_sp.php';
    }
    else if ($schema == 'uk')
    {
        $title = 'UK';
        $count = number_format(1969257);
        $table = DB_PREFIX . 'distance_uk';
        $filename = 'distance_uk.php';
    }
    else if ($schema == 'usa')
    {
        $title = 'USA';
        $count = number_format(70706);
        $table = DB_PREFIX . 'distance_usa';
        $filename = 'distance_usa.php';
    }
    
    if (!empty($title) AND !empty($count) AND !empty($table) AND !empty($filename))
    {
        print_progress_begin('<b>Importing ' . $count . ' longitude and lattitude coordinates for ' . $title . '</b>, please wait.', '.', 'progressspanimportdistance' . $table);
        
        // sql logic here...
        $newfile = DIR_SERVER_ROOT . 'install/importers/' . $filename;
        if (file_exists($newfile))
        {
            require_once($newfile);
        }
        else
        {
            echo '<span style="color:red">Distance import file for ' . $title . ' not found.</span>';
        }
        
        print_progress_end();
    }
}
?>