<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

// #### NOTE #1: THIS SCRIPT SHOULD BE MOVED TO THE MAIN ILANCE ROOT FOLDER BEFORE EXECUTING

// this will be the default subscription id for the ilance user just in case a user in vb does not match any of the below user groups we'll be assigning.
$defaultsubscriptionid = 1;

/*
vBulletin Forum Usergroups example:
> Registered: 2
> Gold: 19
> Platinum: 20
> Exclusive: 21
*/

// we'll format like usergroupid => ilance subscription plan usergroupid
$forumusergroups = array(
	// Registered
	'2' => '4',
	// Gold
	'19' => '3',
	// Platinum
	'20' => '2',
	// Exclusive
	'21' => '1'
	// here we'll capture 
);

// ilance database details
$ilhostname = 'localhost'; // ilance hostname of database (usually localhost)
$ilportname = '3306'; // ilance database port
$ilusername = ''; // ilance database user
$ilpassword = ''; // ilance database pass
$ildbname   = ''; // ilance database name
$iltbpref   = 'ilance_'; // ilance database table prefix (example il_ like il_users) - you may also leave blank..

// #############################################################################

// vbulletin database details
$vbhostname = 'localhost'; // vbulletin hostname database (usually localhost)
$vbportname = '3306'; // vbulletin database port
$vbusername = ''; // vbulletin database user
$vbpassword = ''; // vbulletin database pass
$vbdbname   = 'vb'; // vbulletin database name
$vbtbpref   = ''; // vbulletin database table prefix (example vb_ like vb_user) - you may also leave blank..

// #############################################################################

// some pre-checkups to avoid weirdness
if (empty($ilhostname) OR empty($vbhostname) OR empty($ilusername) OR empty($vbusername) OR empty($ildbname) OR empty($vbdbname))
{
	echo 'This script has not yet been configured.  Please open this script and set default database settings before usage.';
	exit;
}

/**
* Function to determine if an email record being supplied to the function already exists within the ILance database.
*
* @param       string      email address
*
* @return      boolean     Returns true or false if the email address exists
*/
function email_exists($email = '')
{
	global $il_dbh, $iltbpref, $ilhostname, $ilportname, $ilusername, $ilpassword, $ildbname;
	
	// connect and select the ilance database
	$il_dbh = mysql_connect($ilhostname . ':' . $ilportname, $ilusername, $ilpassword) or die ('I cannot connect to the ilance database because: ' . mysql_error($il_dbh));
	mysql_select_db($ildbname, $il_dbh);

	$email = trim($email);
	
	$result = mysql_query("
		SELECT username
		FROM " . $iltbpref . "users
		WHERE email = '" . mysql_real_escape_string($email) . "'
		LIMIT 1
	", $il_dbh) or die ('I cannot select the ilance user table because: ' . mysql_error($il_dbh));
	if (mysql_num_rows($result) > 0)
	{
		return 1;
	}
	
	// close database connection
	mysql_close($il_dbh);
	
	return 0;
}

/**
* Function to determine if a username record being supplied to the function already exists within the ILance database.
*
* @param       string      username
*
* @return      boolean     Returns true or false if the username exists
*/
function username_exists($user = '')
{
	global $il_dbh, $iltbpref, $ilhostname, $ilportname, $ilusername, $ilpassword, $ildbname;
	
	// connect and select the ilance database
	$il_dbh = mysql_connect($ilhostname . ':' . $ilportname, $ilusername, $ilpassword) or die ('I cannot connect to the ilance database because: ' . mysql_error($il_dbh));
	mysql_select_db($ildbname, $il_dbh);
	
	$user = trim($user);
	
	$result = mysql_query("
		SELECT user_id
		FROM " . $iltbpref . "users
		WHERE username = '" . mysql_real_escape_string($user)  . "'
		LIMIT 1
	", $il_dbh) or die ('I cannot select the ilance user table because: ' . mysql_error($il_dbh));
	if (mysql_num_rows($result) > 0)
	{
		return 1;
	}
	
	// close database connection
	mysql_close($il_dbh);
	
	return 0;
}

/**
* Function to create a new user in ILance based on a supplied username, email address, password and salt from a vbulletin record set.
*
* @param       string      username from vb
* @param       string      email address from vb
* @param       string      password (md5 hash'ed already) from vb
* @param       string      password salt record from vb
*
* @return      boolean     Returns true or false if the username exists
*/
function insert_member($username = '', $email = '', $password = '', $salt = '', $usergroupid = '')
{
	global $forumusergroups, $ilance, $ilconfig, $defaultsubscriptionid;
	
	if (empty($username) OR empty($email) OR empty($password) OR empty($salt))
	{
		return '';
	}
	
	$usergroupid = isset($usergroupid) ? intval($usergroupid) : '-1';
	if ($usergroupid != '-1' AND $usergroupid > 0)
	{
		// we'll ensure that the user coming from vb's usergroup will be inserted into the appropriate ilance subscription plan usergroup
		if (isset($forumusergroups["$usergroupid"]) AND !empty($forumusergroups["$usergroupid"]))
		{
			$usergroupid = $forumusergroups["$usergroupid"];
		}
		else
		{
			$usergroupid = $defaultsubscriptionid;
		}
	}
	
	// construct desired ilance classes to build a user
	$ilance->admincp = construct_object('api.admincp');
	$ilance->registration = construct_object('api.registration');
	
	$ilance->GPC['username'] = trim($username);
	$ilance->GPC['password_md5'] = $password;
	$ilance->GPC['salt'] = $salt;
	$ilance->GPC['secretquestion'] = 'What is my email address?';
	$ilance->GPC['secretanswer'] = md5($email);
	$ilance->GPC['email'] = trim($email);
	$ilance->GPC['firstname'] = 'Unknown';
	$ilance->GPC['lastname'] = 'Unknown';
	$ilance->GPC['address'] = 'Unknown';
	$ilance->GPC['address2'] = 'Unknown';
	$ilance->GPC['city'] = 'Unknown';
	$ilance->GPC['state'] = 'Unknown';
	$ilance->GPC['zipcode'] = '00000';
	$ilance->GPC['phone'] = '+0';
	$ilance->GPC['countryid'] = '500';
	$ilance->GPC['dob'] = '0000-00-00';
	$ilance->GPC['ridcode'] = create_referral_code(6);	
	$ilance->GPC['subscriptionid'] = $usergroupid;
	$ilance->GPC['subscriptionpaymethod'] = 'account';
	$ilance->GPC['promocode'] = '';
	$ilance->GPC['roleid'] = '-1';
	$ilance->GPC['isadmin'] = '0';
	
	$ilance->GPC['newuserid'] = $ilance->admincp->construct_new_member(
		$ilance->GPC['username'],
		$ilance->GPC['password_md5'],
		$ilance->GPC['salt'],
		$ilance->GPC['secretquestion'],
		md5($ilance->GPC['secretanswer']),
		$ilance->GPC['email'],
		$ilance->GPC['firstname'],
		$ilance->GPC['lastname'],
		$ilance->GPC['address'],
		$ilance->GPC['address2'],
		$ilance->GPC['city'],
		$ilance->GPC['state'],
		$ilance->GPC['zipcode'],
		$ilance->GPC['phone'],
		$ilance->GPC['countryid'],
		$ilance->GPC['dob'],
		$ilance->GPC['ridcode'],
		$ilconfig['globalserverlanguage_defaultlanguage'],
		$ilconfig['globalserverlocale_defaultcurrency'],
		$ilconfig['globalserverlocale_officialtimezone'],
		$usertimezone_dst = 0,
		$categories = '',
		$ilance->GPC['isadmin']
	);
	
	// let's build users subscription
	$ilance->registration->build_user_subscription($ilance->GPC['newuserid'], $ilance->GPC['subscriptionid'], $ilance->GPC['subscriptionpaymethod'], $ilance->GPC['promocode'], $ilance->GPC['roleid'], $skipsession = 1);
	
	return;
}

/**
* Function to read vbulletin users and return a formatted array with results.
*/
function fetch_users() 
{
	global $vb_dbh, $vbtbpref, $vbdbname, $vbhostname, $vbportname, $vbusername, $vbpassword;
	
	// connects to the vbulletin db
	$vb_dbh = mysql_connect($vbhostname . ':' . $vbportname, $vbusername, $vbpassword) or die ('I cannot connect to the vbulletin database because: ' . mysql_error($vb_dbh));
	mysql_select_db($vbdbname, $vb_dbh);
	
	$res = mysql_query("
		SELECT username, email, password, salt, usergroupid
		FROM " . $vbtbpref . "user
	", $vb_dbh) or die ('I cannot select the vbulletin user table because: ' . mysql_error($vb_dbh));
	
	// loop through the vbulletin users	
	$count = 0;
	
	while ($row = mysql_fetch_assoc($res)) 
	{
		$users[] = $row;
	}
	
	// close database connection
	mysql_close($vb_dbh);
	
	return $users;
}

// #### BEGIN IMPORT ###########################################################
$users = array();
$users = fetch_users();
/*
 Array
(
    [0] => Array
        (
            [username] => Peter
            [email] => peter@ilance.com
            [password] => xxx
            [salt] => xxx
            [usergroupid] => 6
        )
        print_r($users);
*/

require_once('./functions/config.php');
require_once(DIR_CORE . 'functions_install.php');

$count = $skipped = 0;

print_progress_begin('<b>Importing users from vbulletin into ilance</b>, please wait.', '.', 'progressspan');

foreach ($users AS $key => $userarray)
{
	$halt = false;
	
	// some check ups
        $unicode_name = preg_replace('/&#([0-9]+);/esiU', "convert_int2utf8('\\1')", $userarray['username']);
        $unicode_email = preg_replace('/&#([0-9]+);/esiU', "convert_int2utf8('\\1')", $userarray['email']);
                
	// username check
	$sql = $ilance->db->query("
		SELECT user_id
		FROM " . DB_PREFIX . "users
		WHERE
		username IN ('" . addslashes(htmlspecialchars_uni($userarray['username'])) . "', '" . addslashes(htmlspecialchars_uni($unicode_name)) . "')
		OR email IN ('" . addslashes(htmlspecialchars_uni($userarray['email'])) . "', '" . addslashes(htmlspecialchars_uni($unicode_email)) . "')
	");
	if ($ilance->db->num_rows($sql) > 0)
	{
		$halt = true;
		$skipped++;
	}
	
	if ($halt == false)
	{
		echo insert_member($userarray['username'], $userarray['email'], $userarray['password'], $userarray['salt'], $userarray['usergroupid']);
		$count++;
	}
}

print_progress_end();

echo '<p>' . $count . ' vbulletin users successfully added into the ilance database.<br />' . $skipped . ' users skipped.</p>';

?>