<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

error_reporting(E_ALL);
@set_time_limit(0);
@ini_set('memory_limit', '32M');

define('VERSION', '3.1.8'); // this should match global.php
define('SQLVERSION', '12');

define('LOCATION', 'installer');
define('ILMIME', '.php');

/*
* pre-installation folder checkup
*/
if (@file_exists('../functions/connect.php.dist') OR @file_exists('../functions/config.php.dist'))
{
        if ($_SERVER['REMOTE_ADDR'] != '127.0.0.1')
	{
		die('<strong>Fatal</strong>: There are pre-installation steps that require your attention.  Please review <a href="install/how-to-install.txt">how-to-install.txt</a> step 3.');
	}
}

session_start();

include('../functions/core/functions_install.php');

if (empty($_REQUEST['step']))
{
	// include our db settings file
	include('../functions/connect.php');
	
	if (DB_SERVER == '')
	{
                echo "<strong>Fatal:</strong> <em>DB_SERVER</em> is not setup in <em>../functions/connect.php</em>.  Please set this value before installation can continue.";
                exit();
	}
	else
	{
                $_SESSION['DB_SERVER'] = DB_SERVER;
	}
	
	if (DB_SERVER_PORT == '')
	{
                echo "<strong>Fatal:</strong> <em>DB_SERVER_PORT</em> is not setup in <em>../functions/connect.php</em>.  Please set this value before installation can continue.";
                exit();
	}
	else
	{
                $_SESSION['DB_SERVER_PORT'] = DB_SERVER_PORT;
	}
	
	if (DB_SERVER_USERNAME == '')
	{
                echo "<strong>Fatal:</strong> <em>DB_SERVER_USERNAME</em> is not setup in <em>../functions/connect.php</em>.  Please set this value before installation can continue.";
                exit();
	}
	else
	{
                $_SESSION['DB_SERVER_USERNAME'] = DB_SERVER_USERNAME;
	}
	
	if (DB_SERVER_PASSWORD == '')
	{
                $_SESSION['DB_SERVER_PASSWORD'] = '';
	}
	else
	{
                $_SESSION['DB_SERVER_PASSWORD'] = DB_SERVER_PASSWORD;
	}
	
	if (DB_DATABASE == '')
	{
                echo "<strong>Fatal:</strong> DB_DATABASE is not setup in <em>../functions/connect.php</em>.  Please set this value before installation can continue.";
                exit();
	}
	else
	{
                $_SESSION['DB_DATABASE'] = DB_DATABASE;
                
                // also set our table prefix for this database (can be blank or filled in)
                $_SESSION['DB_PREFIX'] = DB_PREFIX;
	}	
}
	

if (!empty($_REQUEST['step']))
{
	$step = $_REQUEST['step'];
}

if (empty($_REQUEST['do']) OR !$_REQUEST['do'])
{
	$_REQUEST['do'] = 'install';
}

if (empty($step))
{
	$step = '0';
}

echo print_install_header();

// ######################### Start the install #######################
if (isset($step) AND $step == '0')
{
	include('../functions/config.php');
	
	$ver = $ilance->db->query_fetch("
		SELECT value
		FROM " . DB_PREFIX . "configuration
		WHERE name = 'current_version'
	", 1, null, __FILE__, __LINE__); // 1 denotes we should hide any db errors
	$version = $ver['value'];
	
	$sql = $ilance->db->query_fetch("
		SELECT value
		FROM " . DB_PREFIX . "configuration
		WHERE name = 'current_sql_version'
	", 1, null, __FILE__, __LINE__);  // 1 denotes we should hide any db errors
	$sqlversion = $sql['value'];
	
	if (empty($version) OR empty($sqlversion))
	{
		$version = VERSION;
		$sqlversion = SQLVERSION;
	}
	
	echo "<p><span style='float:right; color:#777; align:right'>Current Version: <strong>$version</strong><br />Current DB Version: <strong>$sqlversion</strong></span><span class=header>Welcome to ILance ".VERSION." Installation System</span><p>";
	echo "<strong>Install a fresh version of ILance ".VERSION."</strong><br /><br />";
	echo "<a href=installer.php?do=install&step=1><span style=color:green><strong>Begin Fresh Installation</strong></span></a><br />";
	
	echo "<hr size=1 width=100% />";
	
	echo "<br /><strong>Upgrade from older versions of ILance to current</strong><br /><br />";
	
	if ($version == '3.0.6')
	{ // upgrade 3.0.6 to 3.0.7
		echo "<li /> <a href=installer.php?do=install&step=14><strong><span style='color:green'>Upgrade 3.0.6 to 3.0.7</strong></span></a><br />";
	}
	
	else if ($version == '3.0.7')
	{ // upgrade 3.0.7 to 3.0.8		
		echo "<li /> <a href=installer.php?do=install&step=15><strong><span style='color:green'>Upgrade 3.0.7 to 3.0.8</strong></span></a><br />";
	}
	
	else if ($version == '3.0.8')
	{ // upgrade 3.0.8 to 3.0.9
		echo "<li /> <a href=installer.php?do=install&step=16><strong><span style='color:green'>Upgrade 3.0.8 to 3.0.9</strong></span></a><br />";
	}
	
	else if ($version == '3.0.9')
	{ // upgrade 3.0.9 to 3.1.0
		echo "<li /> <a href=installer.php?do=install&step=17><span style='color:green'><strong>Upgrade 3.0.9 to 3.1.0</strong></span></a><br />";
	}
        
	else if (($version == '3.1.0' OR $version == '3.1.1' OR $version == '3.1.2') AND $sqlversion == '5')
	{ // upgrade 3.1.0 or 3.1.1 or 3.1.2 to 3.1.3 (sql version 6)
		echo "<li /> <a href=installer.php?do=install&step=23><strong><span style='color:green'>Upgrade from $version to 3.1.3</span></a><br />";
	}
	
        else if ($version == '3.1.3')
	{ // upgrade 3.1.3 to 3.1.4 (sql version 7)
		echo "<li /> <a href=installer.php?do=install&step=24><strong><span style='color:green'>Upgrade from 3.1.3 to 3.1.4</span></a><br />";
	}
        
        else if (($version == '3.1.4' OR $version == '3.1.4 PL 1'))
	{ // upgrade 3.1.4 to 3.1.5 (sql version 9)
		echo "<li /> <a href=installer.php?do=install&step=25><strong><span style='color:green'>Upgrade from 3.1.4 to 3.1.5</span></a><br />";
	}
        
        else if (($version == '3.1.5' OR $version == '3.1.5 PL 1'))
	{ // upgrade 3.1.5 to 3.1.6 (sql version 10)
		echo "<li /> <a href=installer.php?do=install&step=26><strong><span style='color:green'>Upgrade from 3.1.5 to 3.1.6</span></a><br />";
	}
        
        else if ($version == '3.1.6')
	{ // upgrade 3.1.6 to 3.1.7 (sql version 11)
		echo "<li /> <a href=installer.php?do=install&step=27><strong><span style='color:green'>Upgrade from 3.1.6 to 3.1.7</span></a><br />";
	}
        
        else if ($version == '3.1.7')
	{ // upgrade 3.1.7 to 3.1.8 (sql version 12)
		echo "<li /> <a href=installer.php?do=install&step=28><strong><span style='color:green'>Upgrade from 3.1.7 to 3.1.8</span></a><br />";
	}
        
	else
	{
		echo "<img src='../images/default/icons/checkmark.gif' border='0' /> <span style=color:#777>You have upgraded ILance to the latest stable version.  There is nothing to upgrade.</span>";
	}
}

// #### INSTALLATION ###########################################################

if (isset($step) AND $step == 1)
{
	if ($_REQUEST['do'] == 'install')
	{
		// Step 1: Check Server Requirements
		echo '<p><span class="header">Check Server Requirements</span><br />Entries marked in red should be reviewed by your host administrator for review and details on activating a module or extension for your PHP build.</p>';
        
		// #### PHP VERSION ############################################
		if (function_exists("version_compare") AND version_compare(phpversion(), "4.3.0", ">="))
		{
			echo '<div class="bluehlite"><span class="smaller"><b><font color="#000000">PHP Version: >= 4.3.0</font><br />
			</b></span>Your server supports the PHP functions available in PHP 4.3.0 and higher.</div>';
			$dontcontinue = 0;
		}
		else
		{
			echo '<div class="redhlite"><span class="smaller"><b><font color="red">PHP Version: >= 4.3.0</font><br />
			</b></span>Your server requires PHP 4.3.0 or later installed.</div>';
			$dontcontinue = 1;
		}
                
                // #### BC MATH ################################################
                if (function_exists("bcmod"))
		{
			echo '<div class="bluehlite"><span class="smaller"><b><font color="#000000">PHP Function: bcmod()</font><br />
			</b></span>Your PHP build supports the math functions in PHP.</div>';
			$dontcontinue = 0;
		}
		else
		{
			echo '<div class="redhlite"><span class="smaller"><b><font color="red">PHP Function: bcmod()</font><br />
			</b></span>Your PHP build requires the math functions.  These functions are only available if PHP was configured with --enable-bcmath.</div>';
			$dontcontinue = 1;
		}
		
		// #### GD #####################################################
		if (extension_loaded('gd'))
		{
			echo '<div class="bluehlite"><span class="smaller"><b><font color="#000000">PHP Extension: GD</font><br />
			</b></span>Your PHP build supports GD Library (thumbnail generation, re-size/scale, etc).</div>';
			$dontcontinue = 0;
		}
		else
		{
			echo '<div class="redhlite"><span class="smaller"><b><font color="red">PHP Extension: GD</font><br />
			</b></span>Your PHP build does not support GD Library and cannot use (thumbnail generation, re-size/scale, etc).</div>';
			$dontcontinue = 0;
		}

		// #### MBSTRING ###############################################
		if(extension_loaded('mbstring'))
		{
			echo '<div class="bluehlite"><span class="smaller"><b><font color="#000000">PHP Function: mb_detect_encoding()</font><br />
			</b></span>Your PHP build supports multibyte character encoding.</div>';			
			$_SESSION['noencoding'] = '0';
		}
		else
		{
			echo '<div class="redhlite"><span class="smaller"><b><font color="red">PHP Function: mb_detect_encoding()</font><br />
			</b></span>Your PHP build does not support multibyte character encoding.  If English will be the only primary marketplace language, this should be of no concern.</div>';
			$_SESSION['noencoding'] = '1';
		}

		// #### OPENSSL ################################################
		if (extension_loaded('openssl'))
		{
			echo '<div class="bluehlite"><span class="smaller"><b><font color="#000000">PHP Extension: openssl()</font><br />
			</b></span>Your PHP build supports openssl().</div>';
		}
		else
		{
			echo '<div class="redhlite"><span class="smaller"><b><font color="red">PHP Extension: openssl()</font><br />
			</b></span>Your PHP build does not support openssl().</div>';
			
			// do we at least have curl?
			if (extension_loaded('curl'))
			{
				echo '<div class="yellowhlite"><span class="smaller"><b><font color="#000000">PHP Extension: curl()</font><br />
				</b></span>Your PHP build supports curl().</div>';	
			}
		}
		
		if ($dontcontinue)
		{
			echo "<p><strong>Installation Cannot Continue (fix red items above)</strong>: <a href=installer.php?do=install&step=1>Step 1: Check Server Requirements</a></p><br />";
		}
		else
		{
			echo '<form method="post" action="installer.php" accept-charset="UTF-8">
			<input type="hidden" name="step" value="2">
			<input type="hidden" name="do" value="install">';
			echo '<input type="submit" value=" Next Step " style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" /></form>';
		}
	}
}

if (isset($step) AND $step == 2)
{
	if ($_REQUEST['do'] == 'install')
	{
		// Step 2: Check Database
		echo '<p><span class="header">Check Database</span><br />Entries marked as fatal should be reviewed by your host administrator for details on connecting to your database server. When installing ILance, you should have the following ready:<br /><br />
		<li>Database Hostname (usually localhost)</li><li>Database Host Port (usually 3306)</li><li>Database Username</li><li>Database Password</li></p><strong>Information Returned From Your Server</strong><br /><br />';
		
		if (mysql_connect($_SESSION['DB_SERVER'] . ':' . $_SESSION['DB_SERVER_PORT'], $_SESSION['DB_SERVER_USERNAME'], $_SESSION['DB_SERVER_PASSWORD']))
		{
			$db_connected = 1;
			echo '<div class="bluehlite"><span class="smaller"><b><font color="#000000">Success</font><br />
			</b></span>Database server host connection to <strong>' . $_SESSION['DB_SERVER'] . ':' . $_SESSION['DB_SERVER_PORT'] . '</strong> is ready for connections</div>';
            
			if (mysql_select_db($_SESSION['DB_DATABASE']))
			{
				echo '<div class="bluehlite"><span class="smaller"><b><font color="#000000">Success</font><br />
				</b></span>Database <strong>' . $_SESSION['DB_DATABASE'] . '</strong> is ready for connections</div>';
			}
			else
			{
				$db_connected = 0;
				echo '<div class="redhlite"><span class="smaller"><b><font color="#000000">Warning</font><br />
				</b></span>Database <strong>' . $_SESSION['DB_DATABASE'] . '</strong> could not be selected (check <em>DB_DATABASE</em> in <em>../functions/connect.php</em>)</div>';
			}
		}
		else
		{
			$db_connected = 0;
			echo '<div class="redhlite"><span class="smaller"><b><font color="#000000">Warning</font><br />
			</b></span>Database server host connection to <strong>' . $_SESSION['DB_DATABASE'] . '</strong> could not be selected (check <em>DB_DATABASE</em> in <em>../functions/connect.php</em>)</div>';
		}

		if ($db_connected)
		{
			// include our db settings to fetch the db table prefix we'll be using
			include('../functions/connect.php');
			if (DB_PREFIX == '')
			{
				//echo "<strong>Optional Notice:</strong> You have not defined a table prefix - change <em>DB_PREFIX</em> to something like <strong>v3_</strong><br />";
				echo '<div class="yellowhlite"><span class="smaller"><b><font color="#000000">Optional</font><br />
				</b></span>You have not defined a database table prefix - change <em>DB_PREFIX</em> to something like <strong>v3_</strong> in <em>../functions/connect.php</em>)</div>';
			}
            
			echo '<form method="post" action="installer.php" accept-charset="UTF-8">';
			echo '<input type="hidden" name="step" value="4">';
			echo '<input type="hidden" name="do" value="install">';
			echo '<input type="submit" value=" Next Step " style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" /></form>';
		}
		else
		{
			echo '<form method="post" action="installer.php" accept-charset="UTF-8">';
			echo '<input type="hidden" name="step" value="4">';
			echo '<input type="hidden" name="do" value="install">';
			echo '<input type="submit" value=" Retry " style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" /></form>';
		}
	}
}



if (isset($step) AND $step == 4)
{
	if ($_REQUEST['do'] == 'install')
	{
		include('../functions/config.php');
		
		// Step 4: Check Administrator Settings
		echo '<p><span class="header">Configure Default Administrator</span><br />This account will be your main administrator account as well as your main buyer or seller account in your marketplace.  This user account will be able to gain access to the admin control panel area as well as the front end areas (as if you were a regular member).</p>';

		if (empty($_REQUEST['check']))
		{
			echo '
                        <script type="text/javascript" src="' . HTTP_SERVER . 'functions/javascript/functions_password_strength.js"></script> 
			<form method="post" name="add_admin" action="installer.php" accept-charset="UTF-8" onsubmit="return validatePwd()">
			<input type="hidden" name="step" value="4">
			<input type="hidden" name="do" value="install">
			<input type="hidden" name="check" value="1">
	        
			<table width="400" border="0" cellspacing="1" cellpadding="2">
			<tr>
				<td width="1%" nowrap="nowrap"><span style="size:16px; color:red">*</span>Email Address: </td>
				<td width="1%"><input type="text" value="' . ((!empty($_SESSION['admin_email'])) ? $_SESSION['admin_email'] : '') . '" name="admin_email" class="input" style="width:210px" /></td>
			</tr>
			<tr>
				<td width="1%" nowrap="nowrap"><span style="size:16px; color:red">*</span>Admin Sign-In Username: </td>
				<td width="1%"><input type="text" value="' . ((!empty($_SESSION['admin_username'])) ? $_SESSION['admin_username'] : '') . '" name="username" class="input" style="width:210px" /></td>
			</tr>
			<tr>
				<td width="1%" nowrap="nowrap"><span style="size:16px; color:red">*</span>Admin Sign-In Password: </td>
				<td width="1%"><input type="password" onKeyUp="checkPassword(this.value)" value="' . ((!empty($_SESSION['admin_password'])) ? $_SESSION['admin_password'] : '') . '" name="password" class="input" style="width:210px" /></td>
				<td><div style="border: 1px solid gray; width: 100px;"> 
				<div id="progressBar" style="font-size: 1px; height: 20px; width: 0px; border: 1px solid white;"></div>
				</div>
				</td>
				<td>
				<p>Strength</p>
				</td>
			</tr>
			<tr>
				<td width="1%" nowrap="nowrap"><span style="size:16px; color:red">*</span>Re-Confirm Password: </td>
				<td width="1%"><input type="password" value="' . ((!empty($_SESSION['admin_password2'])) ? $_SESSION['admin_password2'] : '') . '" name="password2" class="input" style="width:210px" /></td>
			</tr>
			<tr>
				<td width="1%" nowrap="nowrap"><span style="size:16px; color:red">*</span>Ask yourself a secret question</td>
				<td width="1%"><input type="text" value="' . ((!empty($_SESSION['admin_secretquestion'])) ? $_SESSION['admin_secretquestion'] : '') . '" name="secretquestion" class="input" style="width:210px" /></td>
			</tr>
			<tr>
				<td width="1%" nowrap="nowrap"><span style="size:16px; color:red">*</span>Answer your secret question</td>
				<td width="1%"><input type="password" value="' . ((!empty($_SESSION['admin_secretanswer'])) ? $_SESSION['admin_secretanswer'] : '') . '" name="secretanswer" class="input" style="width:210px" /></td>
			</tr>
			</table>
                        <br />
			<input type="submit" value=" Next Step " style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" />
			</form>';
		}
		
		if (isset($_REQUEST['check']) AND $_REQUEST['check'] == 1)
		{
			if (empty($_REQUEST['admin_email']))
			{
				echo "<strong>Fatal:</strong> <em>Admin Email</em> was not entered.<br />";
				$adminfatal = 1;
			}
			else
			{
                                $_SESSION['admin_email'] = $_REQUEST['admin_email'];
                                echo 'Site Email Address <strong>' . $_SESSION['admin_email'] . '</strong> has been configured<br />';
			}
	        
			if (empty($_REQUEST['username']))
			{
                                echo "<strong>Fatal:</strong> <em>AdminCP Sign-In Username</em> was not entered.<br />";
                                $adminfatal = 1;
			}
			else
			{
                                $_SESSION['admin_username'] = $_REQUEST['username'];
                                echo 'AdminCP Sign-In Username <strong>' . $_SESSION['admin_username'] . '</strong> has been configured<br />';
			}
			
			if (empty($_REQUEST['password']))
			{
                                echo "<strong>Fatal:</strong> <em>Password</em> was not entered.<br />";
                                $adminfatal = 1;
			}
			else
			{
				if ($_REQUEST['password'] == $_REQUEST['password2'])
				{
					$_SESSION['admin_password'] = $_REQUEST['password'];
					echo 'Sign-In Password <strong>*****************</strong> has been configured<br />';
				}
				else
				{
					echo 'The passwords entered do not match.  Please retry your password.';
					$adminfatal = 1;
				}
			}
	        
			if (empty($_REQUEST['secretquestion']))
			{
                                echo "<strong>Fatal:</strong> <em>Secret Question</em> was not entered.<br />";
                                $adminfatal = 1;
			}
			else
			{
                                $_SESSION['admin_secretquestion'] = $_REQUEST['secretquestion'];
                                echo 'Secret Question <strong>' . $_SESSION['admin_secretquestion'] . '</strong> has been configured<br />';
			}
			
			if (empty($_REQUEST['secretanswer']))
			{
                                echo "<strong>Fatal:</strong> <em>Secret Answer</em> was not entered.<br />";
                                $adminfatal = 1;
			}
			else
			{
                                $_SESSION['admin_secretanswer'] = $_REQUEST['secretanswer'];
                                echo 'Secret Question Answer <strong>*****************</strong> has been configured<br />';
			}
		
			if (isset($adminfatal) AND $adminfatal)
			{
                                echo '<form method="post" action="installer.php" accept-charset="UTF-8">';
                                echo '<input type="hidden" name="step" value="4">';
                                echo '<input type="hidden" name="do" value="install">';
                                echo '<input type="submit" value=" Retry " style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" /></form>';
			}
			else
			{
                                echo '<form method="post" action="installer.php" accept-charset="UTF-8">';
                                echo '<input type="hidden" name="step" value="5">';
                                echo '<input type="hidden" name="do" value="install">';
                                echo '<input type="submit" value=" Next Step " style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" /></form>';
			}			
		}
	}
}

if (isset($step) AND $step == 5)
{
	if ($_REQUEST['do'] == 'install')
	{
		// Step 5: Check Company / Licenee Information
		echo '<p><span class="header">Company and Site Name Details</span><br />When setting up settings in this area please have the following ready:<br /><br /><li>Company Name</li><li>Site Name / Title</li><li>Company Address</li><li>Company Email (address to send email from)</li></p><p><strong>Additional Information</strong><br />Please remember to specify the company email address (where all emails will go out to customers from your marketplace) ie: support@mydomain.com.  This email should not be a personal email address.  When the marketplace sends an invoice or other related email to a member, this will be the email address the user will see.<br /><br />Once installed you can manage more email departments using the email department manager built into the AdminCP.</p>';

		if (empty($_REQUEST['check']))
		{
			echo '<form method="post" action="installer.php" accept-charset="UTF-8">
			<input type="hidden" name="step" value="5">
			<input type="hidden" name="do" value="install">
			<input type="hidden" name="check" value="1">
	        
			<table width="400" border="0" cellspacing="1" cellpadding="2">
			<tr>
				<td width="1%" nowrap="nowrap"><span style="size:16px; color:red">*</span>Company Name: </td>
				<td width="1%"><input type="text" value="' . ((!empty($_SESSION['company_name'])) ? $_SESSION['company_name'] : '') . '" name="company_name" class="input" /></td>
			</tr>
			<tr>
				<td width="1%" nowrap="nowrap"><span style="size:16px; color:red">*</span>Web Site Name / Title: </td>
				<td width="1%"><input type="text" value="' . ((!empty($_SESSION['site_name'])) ? $_SESSION['site_name'] : '') . '" name="site_name" class="input" /></td>
			</tr>
			<tr>
				<td width="1%" nowrap="nowrap"><span style="size:16px; color:red">*</span>Company / Site Address </td>
				<td width="1%"><input type="text" value="' . ((!empty($_SESSION['site_address'])) ? $_SESSION['site_address'] : '') . '" name="site_address" class="input" /></td>
			</tr>
			<tr>
				<td width="1%" nowrap="nowrap"><span style="size:16px; color:red">*</span>Company Email </td>
				<td width="1%"><input type="text" value="' . ((!empty($_SESSION['site_email'])) ? $_SESSION['site_email'] : '') . '" name="site_email" class="input" /></td>
			</tr>
			</table>
			<input type="submit" value=" Next Step " style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" />
			</form>';
		}
		
		if (isset($_REQUEST['check']) AND $_REQUEST['check'] == 1)
		{
			if (empty($_REQUEST['company_name']))
			{
				echo "<strong>Fatal:</strong> <em>Company Name</em> was not entered.<br />";
				$adminfatal = 1;
			}
			else
			{
				$_SESSION['company_name'] = $_REQUEST['company_name'];
				echo '<strong>Success:</strong> Company Name <strong>' . $_SESSION['company_name'] . '</strong> has been configured<br />';
			}
			
			if (empty($_REQUEST['site_name']))
			{
				echo "<strong>Fatal:</strong> <em>Site Title / Name</em> was not entered.<br />";
				$adminfatal = 1;
			}
			else
			{
				$_SESSION['site_name'] = $_REQUEST['site_name'];
				echo '<strong>Success:</strong> Company Slogan/Title <strong>' . $_SESSION['site_name'] . '</strong> has been configured<br />';
			}
			
			if (empty($_REQUEST['site_address']))
			{
				echo "<strong>Fatal:</strong> <em>Company / Site Address</em> was not entered.<br />";
				$adminfatal = 1;
			}
			else
			{
				$_SESSION['site_address'] = $_REQUEST['site_address'];
				echo '<strong>Success:</strong> Company / Site Address <strong>' . $_SESSION['site_address'] . '</strong> has been configured<br />';
			}
			
			if (empty($_REQUEST['site_email']))
			{
				echo "<strong>Fatal:</strong> <em>Company Email</em> was not entered.<br />";
				$adminfatal = 1;
			}
			else
			{
				$_SESSION['site_email'] = $_REQUEST['site_email'];
				echo '<strong>Success:</strong> Company Email <strong>' . $_SESSION['site_email'] . '</strong> has been configured<br />';
			}
			
			if (isset($adminfatal) AND $adminfatal == 1)
			{
				echo '<form method="post" action="installer.php" accept-charset="UTF-8">';
				echo '<input type="hidden" name="step" value="5">';
				echo '<input type="hidden" name="do" value="install">';
				echo '<input type="submit" value=" Retry " style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" /></form>';
			}
			else
			{
				echo '<form method="post" action="installer.php" accept-charset="UTF-8">';
				echo '<input type="hidden" name="step" value="6">';
				echo '<input type="hidden" name="do" value="install">';
				echo '<input type="submit" value=" Next Step " style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" /></form>';
			}
		}
	}
}

if (isset($step) AND $step == 6)
{
	if ($_REQUEST['do'] == 'install')
	{
		// Step 6: Check Web Server Path Settings
		echo '<p><span class="header">Check Web Server Paths</span><br />Entries marked as fatal should be reviewed carefully and changed accordingly to your server path configuration. Failure to set the server paths correctly may result in "blank pages" being shown after installation. Have the following ready:<br /><br /><li>Full Root Path to ILance files</li><li>Full http:// URL to ILance</li></p>
		<p><strong>Additional Information</strong><br />Before you continue below, you should have <b>already opened</b> /functions/<b>config.php</b> and set <b>3</b> variables in that file. The variables to edit are:
		<br /><br />
		<li><em><b>HTTP_SERVER</b></em><br />This is a url like http://www.ilance.com/ notice the <b>ending slash</b>.</li><br /><br />
		<li><em><b>HTTPS_SERVER</b></em><br />This is a url like http<b>s</b>://www.ilance.com/ notice the <b>ending slash</b>.  Notice - If you do not have SSL (yet) please set this the same as the HTTP_SERVER</li><br /><br />
		<li><em><b>DIR_SERVER_ROOT</b></em><br />This is a full server path like /home/domain/www/ notice the <b>start and ending slashs</b>.  On a Windows machine, this would look like: C:/Web Server/www/upload/</li><br /><br />
		
		Optionally, if you would like to move the default Admin CP files/folder to something other than /admincp/ then
		you can also edit the variable:<br /><br />
		<li><em><b>DIR_ADMIN_NAME</b></em></li><br />
		But be sure to rename the folder /admincp/ to the desired name in the value above.
		</p>';
		
		echo '<li><a href="pathxp.txt" target="_blank">View (in popup window) an example path configuration scenerio for a <strong>Windows XP server</strong> running apache</a></li>';
		echo '<li><a href="pathlinux.txt" target="_blank">View (in popup window) an example path configuration scenerio for a <strong>Linux server</strong> running apache</a></li><br /><br />';
		echo 'To make this process easier for you, ILance installer will give you best results for your server below.  You may or may not need to change anything.  This is just for overview:<br /><br />';
		echo '<li>(installer thinks) <b>HTTP_SERVER</b> could be <strong>http://' . $_SERVER['SERVER_NAME'] . '/</strong></li><br />';
		echo '<li>(installer thinks) <b>HTTPS_SERVER</b> could be <strong>http://' . $_SERVER['SERVER_NAME'] . '/</strong></li><br />';
		echo '<li>(installer thinks) <b>DIR_SERVER_ROOT</b> could be <strong>' . $_SERVER['DOCUMENT_ROOT'] . '/</strong></li>';
		echo '<br /><br />Please verify your setup before continuing.<br /><br />';
		
		echo '<form method="post" action="installer.php" accept-charset="UTF-8">';
		echo '<input type="hidden" name="step" value="7">';
		echo '<input type="hidden" name="do" value="install">';
		echo '<input type="submit" value=" Next Step " style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" /></form>';
	}
}

if (isset($step) AND $step == 7)
{
	if ($_REQUEST['do'] == 'install')
	{
		// Step 7: Save Settings to Main Configuration File
		echo '<p><span class="header">Writable Files and Folders</span><br />View the following list of folders and files that require read and write permissions:<br /><br /><li>CHMOD 777 ./cache/ and all contents within</li><li>CHMOD 777 ./uploads/</li><li>CHMOD 777 ./uploads/attachments/ and all folders within</li></p>';
		$fatal = 0;
		
		if (!is_writable('../cache/'))
		{
			$fatal = 1;	
		}
		if (!is_writable('../uploads/'))
		{
			$fatal = 1;	
		}
		if (!is_writable('../uploads/attachments/'))
		{
			$fatal = 1;	
		}
		if (!is_writable('../uploads/attachments/ads/'))
		{
			$fatal = 1;	
		}
		if (!is_writable('../uploads/attachments/auctions/'))
		{
			$fatal = 1;	
		}
		if (!is_writable('../uploads/attachments/bids/'))
		{
			$fatal = 1;	
		}
		if (!is_writable('../uploads/attachments/buynow/'))
		{
			$fatal = 1;	
		}
		if (!is_writable('../uploads/attachments/kb/'))
		{
			$fatal = 1;	
		}
		if (!is_writable('../uploads/attachments/pmbs/'))
		{
			$fatal = 1;	
		}
		if (!is_writable('../uploads/attachments/portfolios/'))
		{
			$fatal = 1;	
		}
		if (!is_writable('../uploads/attachments/profiles/'))
		{
			$fatal = 1;	
		}
		if (!is_writable('../uploads/attachments/stores/'))
		{
			$fatal = 1;	
		}
		if (!is_writable('../uploads/attachments/ws/'))
		{
			$fatal = 1;	
		}
		if ($fatal == 0)
		{
			echo '<strong>All folder and file permissions appear to be properly set!</strong>';
			echo '<form method="post" action="installer.php" accept-charset="UTF-8">';
			echo '<input type="hidden" name="step" value="8">';
			echo '<input type="hidden" name="do" value="install">';
			echo '<input type="submit" value=" Next Step " style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" /></form>';
		}
		else
		{
			echo '<form method="post" action="installer.php" accept-charset="UTF-8">';
			echo '<input type="hidden" name="step" value="7">';
			echo '<input type="hidden" name="do" value="install">';
			echo '<input type="submit" value=" Retry " style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" /></form>';
		}
	}
}

if (isset($step) AND $step == 8)
{
	if ($_REQUEST['do'] == 'install')
	{
		// Step 8: Create Database Table Schema
		echo '<p><span class="header">Create Database Schema</span><br />Entries marked as warning should be reviewed carefully. This step will allow you to choose if you would like to install a fresh database schema (tables) or skip this step entirely (no new tables will be created).<br /><br /><strong>Please select one of the following options</strong><br /><br />';
	
		echo '<form method="post" action="installer.php" accept-charset="UTF-8">';
		echo '<input type="hidden" name="do" value="install">';
	
		echo '<label for="schema1"><input type="radio" name="step" id="schema1" value="8.1" checked="checked"> Install Fresh ' . VERSION . ' DB table schema <!--[ <a href="../functions/xml/database_schema.xml" target="_blank">view xml version</a> ]--></label><br />';
		echo '<label for="schema2"><input type="radio" name="step" id="schema2" value="9"> Skip this step (do not install schema)</label><br /><br /><input type="submit" value="Continue" style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" /></form>';
	}
}

if (isset($step) AND $step == '8.1')
{
	if ($_REQUEST['do'] == 'install')
	{
		// load our main core config (this script will die within init.php so it doesn't 
		// continue to load all the default configuration values since we haven't created
		// them just yet.
		include('../functions/config.php');
		
		// Step 8: Create Database Table Schema
		echo '<p><span class="header">Database Table Schema Creation</span><br />From the previous menu, you selected create new database table schema.  Please find the results below for this operation:<br /><br /><strong>Please review output of the database table creation below</strong><br /><br />';
        
		// let's create the tables
		if (!empty($_SESSION['admin_username'])
			AND !empty($_SESSION['admin_password'])
			AND !empty($_SESSION['company_name'])
			AND !empty($_SESSION['site_name'])
			AND !empty($_SESSION['site_address'])
			AND !empty($_SESSION['site_email']))
		{
			echo create_db_schema();
			
			echo '<form method="post" action="installer.php" accept-charset="UTF-8">';
                        echo '<input type="hidden" name="step" value="9" />';
			echo '<input type="hidden" name="do" value="install" />';
			echo '<input type="submit" value=" Next Step " style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" /></form>';
		}
		else
		{
                        echo 'Installer cannot create new database tables due to one or more sessions from the installation system not available.  To avoid seeing this message, please ensure you start the installation process from the beginning (ie: Step 1) and continue through all steps.<br />';
                        echo '<form method="post" action="installer.php" accept-charset="UTF-8">';
                        echo '<input type="hidden" name="do" value="install">';
                        echo '<input type="submit" value=" Return to Step 1 " style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" /></form>';
		}
	}
}

if (isset($step) AND $step == '9')
{
	if ($_REQUEST['do'] == 'install')
	{
		// Step 9: Import v".VERSION." Language Phrases
		echo '<p><span class="header">Import v' . VERSION . ' Language Phrases and CSS Templates</span><br />This process will import language phrases into your database.  The valid language files exist within <em><strong>/install/xml/</strong></em> folder.<br /><br /><strong>Please review and make desired selections from the following options.  <span style="color:#990000">Warning</span> - this import process consumes server memory & resources. If you experience a blank page during this step, please configure your php.ini by allocating additional memory resources or you may specify how many phrases to import at once (in bulk) below.</strong><br /><br />';
	
		echo '<form method="post" action="installer.php" accept-charset="UTF-8">';
		echo '<input type="hidden" name="do" value="install" />';
		echo '<label for="eng"><input type="checkbox" name="importenglish" id="eng" value="1" checked="checked" /> Import English (US) Phrases</label><br /><br />';
		echo '<label for="schema1"><input type="radio" name="step" id="schema1" value="9.1" checked="checked" /> Proceed and import selected language phrases into my database</label><br />';
		echo '<label for="schema2"><input type="radio" name="step" id="schema2" value="10" /> Skip this step and continue to Step 10: Import v'.VERSION.' Email Templates</label><br />
		<br /><table><tr><td>Phrases to import at once:</td><td><input type="text" name="perpage" value="5000" size="5" /></td></tr></table>
		<br /><input type="submit" value=" Import " style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" /></form>';
	}
}

if (isset($step) AND $step == '9.1')
{
	if ($_REQUEST['do'] == 'install')
	{
		include('../functions/config.php');
        
		// Step 9.1: Import Template / Phrases
		echo '<p><span class="header">Import Language Phrases and CSS Templates</span><br />From the previous menu, you selected import selected language phrases into the database.  Please find the results below for this operation:<br /><br /><strong>Please review output of the language phrase import below</strong><br /><br />';
	
		// let's import the languages
		if (empty($_REQUEST['importenglish']))
		{
			echo 'Installer cannot import any phrases since you did not select any language phrases from the previous menu.  <br /><br /><strong><a href="installer.php?do=install&step=9">Return to previous menu to make selections using the checkboxes</a>.</strong><br />';
		}
	
		// start from phrase (if none specified, it will start from 0 -> xxxx)
		$fromphrase = 0;
		if (isset($_REQUEST['fromphrase']))
		{
			$fromphrase = intval($_REQUEST['fromphrase']);
		}
		
		$perpage = 5000;
		if (isset($_REQUEST['perpage']))
		{
			// user wants to only import so many phrases per page
			$perpage = intval($_REQUEST['perpage']);
		}

		// import styles and templates
		echo import_templates();
		
		// english
		if (isset($_REQUEST['importenglish']) AND $_REQUEST['importenglish'] == 1)
		{
                        echo import_language_phrases(5000, 0);
		}
                
                echo '<form method="get" action="installer.php" accept-charset="UTF-8">';
                echo '<input type="hidden" name="step" value="10" />';
                echo '<input type="hidden" name="do" value="install" />';
                echo '<input type="submit" value=" Next Step " style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" /></form>';
	}
}

if (isset($step) AND $step == '10')
{
	if ($_REQUEST['do'] == 'install')
	{
		// Step 10: Import v".VERSION." Email Templates
		echo '<p><span class="header">Import v' . VERSION . ' Email Templates</span><br />This process will allow you to import fresh email templates into your database (for all existing languages within your database).  The valid email files exist within <em><strong>/install/xml/</strong></em> folder.<br /><br /><strong>Please review and make desired selections from the following options</strong><br /><br />';
                
		echo '<form method="post" action="installer.php" accept-charset="UTF-8">';
		echo '<input type="hidden" name="do" value="install" />';
		echo '<label for="eng"><input type="checkbox" name="importenglish" id="eng" value="1" checked="checked" /> Import English (US) Email Templates</label><br /><br />';
		echo '<label for="schema1"><input type="radio" name="step" id="schema1" value="10.1" checked="checked" /> Proceed and import selected email templates into my database</label><br />';
		echo '<label for="schema2"><input type="radio" name="step" id="schema2" value="12" /> Skip this step and read final installation notes</label><br /><br /><input type="submit" value="Continue" style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" /></form>';
	}
}

if (isset($step) AND $step == '10.1')
{
	if ($_REQUEST['do'] == 'install')
	{
		include('../functions/config.php');
		
		// Step 9.1: Import Template / Phrases
		echo '<p><span class="header">Import Email Templates</span><br />From the previous menu, you selected import selected email templates into the database.  Please find the results below for this operation:<br /><br /><strong>Please review output of the email templates import below</strong><br /><br />';
	
		// let's import the templates
		if (empty($_REQUEST['importenglish']))
		{
                        echo 'Installer cannot import any email templates since you did not select any language from the previous menu.  <br /><br /><strong><a href="installer.php?do=install&step=10">Return to previous menu to make selections using the checkboxes</a>.</strong><br />';
		}
	
		// english
		if (isset($_REQUEST['importenglish']) AND $_REQUEST['importenglish'] == 1)
		{
                        echo import_email_templates();
		}
	
		echo '<form method="post" action="installer.php" accept-charset="UTF-8">';
		echo '<input type="hidden" name="step" value="12" />';
		echo '<input type="hidden" name="do" value="install" />';
		echo '<input type="submit" value=" Next Step " style="font-size:9pt; font-weight: bold; height:25px; font-family: verdana" /></form>';
	}
}

if (isset($step) AND $step == '12')
{
	if ($_REQUEST['do'] == 'install')
	{
		// Step 12: Final Installation Notes
		echo '<p><span class="header">Final Installation Notes</span><br /> Please review the following installation notes:<br /><br /><strong>Final Installation Notes</strong><br /><br />';
                
		echo '<li> Please remember to <strong>delete</strong> the installation folder (./install/)</li>';
		echo '<li> Please remember to register on the <a href="http://www.ilance.com/forum/" target="_blank">ILance Forum</a> to stay current with the latest updates and software releases</li>';
		echo "<br /><br /><a href=\"../main.php\"><b>Launch ILance " . VERSION . "</b></a> or <a href=\"../admincp/login.php\"><b>Launch ILance " . VERSION . " Admin CP</b></a><br /><br />\n";
	}
}

// #### UPGRADE 3.0.6 to 3.0.7 #################################################
if (isset($step) AND $step == '14')
{
	if ($_REQUEST['do'] == 'install')
	{
		include('../functions/config.php');
		include(DIR_SERVER_ROOT . 'install/functions/3.0.6-3.0.7.php');
	}
}

// #### UPGRADE 3.0.7 to 3.0.8 #################################################
if (isset($step) AND $step == '15')
{
	if ($_REQUEST['do'] == 'install')
	{
		include('../functions/config.php');
		include(DIR_SERVER_ROOT . 'install/functions/3.0.7-3.0.8.php');
	}
}

// #### UPGRADE 3.0.8 to 3.0.9 #################################################
if (isset($step) AND $step == '16')
{
	if ($_REQUEST['do'] == 'install')
	{
		include('../functions/config.php');
		include(DIR_SERVER_ROOT . 'install/functions/3.0.8-3.0.9.php');
	}
}

// #### UPGRADE 3.0.9 to 3.1.0 #################################################
if (isset($step) AND $step == '17')
{
	if ($_REQUEST['do'] == 'install')
	{
		include('../functions/config.php');
		include(DIR_SERVER_ROOT . 'install/functions/3.0.9-3.1.0.php');
	}
}

// #### UPGRADE 3.1.0 to 3.1.3 #################################################
if (isset($step) AND $step == '23')
{
	if ($_REQUEST['do'] == 'install')
	{
		include('../functions/config.php');
		include(DIR_SERVER_ROOT . 'install/functions/3.1.0-3.1.3.php');
	}
}

// #### UPGRADE 3.1.3 to 3.1.4 #################################################
if (isset($step) AND $step == '24')
{
	if ($_REQUEST['do'] == 'install')
	{
		include('../functions/config.php');
		include(DIR_SERVER_ROOT . 'install/functions/3.1.3-3.1.4.php');
	}
}

// #### UPGRADE 3.1.4 to 3.1.5 #################################################
if (isset($step) AND $step == '25')
{
	if ($_REQUEST['do'] == 'install')
	{
		include('../functions/config.php');
		include(DIR_SERVER_ROOT . 'install/functions/3.1.4-3.1.5.php');
	}
}

// #### UPGRADE 3.1.5 to 3.1.6 #################################################
if (isset($step) AND $step == '26')
{
	if ($_REQUEST['do'] == 'install')
	{
		include('../functions/config.php');
		include(DIR_SERVER_ROOT . 'install/functions/3.1.5-3.1.6.php');
	}
}

// #### UPGRADE 3.1.6 to 3.1.7 #################################################
if (isset($step) AND $step == '27')
{
	if ($_REQUEST['do'] == 'install')
	{
		include('../functions/config.php');
		include(DIR_SERVER_ROOT . 'install/functions/3.1.6-3.1.7.php');
	}
}

// #### UPGRADE 3.1.7 to 3.1.8 #################################################
if (isset($step) AND $step == '28')
{
	if ($_REQUEST['do'] == 'install')
	{
		include('../functions/config.php');
		include(DIR_SERVER_ROOT . 'install/functions/3.1.7-3.1.8.php');
	}
}

echo print_install_footer();

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: installer.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>