<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/
include('../../functions/config.php');

@set_time_limit(0);
@ini_set('memory_limit', '1000M');

class RecursiveSearch
{
    var $basedir = '';
    var $files;
    var $folders;
    var $keyword;
    var $matches = array();
    var $match = 0;
    var $totalphrases = 0;
    var $orphanphrases = 0;
    var $query = '';

    function RecursiveSearch($root)
    {
            global $ilance;
            
            $this->basedir = $root;
            $this->files = 0;
            $this->folders = array();
            
            $sql = $ilance->db->query("SELECT phraseid, varname FROM " . DB_PREFIX . "language_phrases ORDER BY phraseid ASC");
            $this->totalphrases = $ilance->db->num_rows($sql);
            $this->query = "DELETE FROM " . DB_PREFIX . "language_phrases WHERE";
            while ($res = $ilance->db->fetch_array($sql, DB_ASSOC))
            {
                    $this->__search('', $res['varname']);
                    //echo "<li><strong>".$this->matches[$res['varname']]." matches found for <font color='blue'>".$res['varname']."</font></strong></li>";
                    if ($this->matches[$res['varname']] == 0)
                    {
                        $this->orphanphrases = $this->orphanphrases + 1;
                        $this->query .= " varname = '" . $res['varname'] . "' OR";
                        echo "<li><strong>" . $this->matches[$res['varname']] . " matches found for <font color='red'>".$res['varname']." (orphan) - (phraseid ".$res['phraseid']." of ".$this->totalphrases.")</font></strong></li>";
                    }
                    flush();
            }
            
            $tmp = $this->query;
            $this->query = mb_substr($tmp, 0, -3);
            unset($tmp);
            
            echo "<p>" . $this->query . "</p>";
    }
    
    function __search($dir = '', $varname = '')
    {
            global $ilance;
            $path = $dir == '' ? $this->basedir : "{$this->basedir}/$dir";
            
            foreach (scandir($path) as $found)
            {
                    if (!$this->__isdot($found) AND !$this->__issvn($found) AND !$this->__isimg($found) AND !$this->__isinstall($found))
                    {
                            $absolute = "$path/$found";
                            $relative = $dir == '' ? $found : "$dir/$found";                  
                            if (is_dir($absolute))
                            {
                                    $this->folders[] = $relative;
                                    $this->__search($relative, $varname);
                            }
                            else if (is_file($absolute))
                            {
                                    $filecontents = file_get_contents($absolute, "r");
                                    $match = preg_match_all("/$varname/i", $filecontents, $matches, PREG_SET_ORDER);
                                    if (!$match)
                                    {
                                            //echo "<li><font color='#aaaaaa'>no match for $varname in $relative</font></li>";
                                            if (!empty($this->matches[$varname]))
                                            {
                                                    $this->matches[$varname] = $this->matches[$varname]+$match;
                                            }
                                            else
                                            {
                                                    $this->matches[$varname] = $match;    
                                            }
                                            flush();
                                    }
                                    else
                                    {
                                        //echo "<li><strong>$match matches found for <font color='blue'>$varname</font> in $absolute</strong></li>";
                                            if (!empty($this->matches[$varname]))
                                            {
                                                    $this->matches[$varname] = $this->matches[$varname]+$match;
                                            }
                                            else
                                            {
                                                    $this->matches[$varname] = $match;    
                                            }
                                            //$this->html .= "<li><strong>$match matches found for <font color='blue'>$varname</font> in $absolute</strong></li>";
                                            flush();
                                    }
                                    unset($filecontents, $match);
                            }
                    }
                    flush();
            }
    }
   
    function __isdot($s)
    {
        return ($s == '.' || $s == '..');
    }
    
    function __issvn($s)
    {
        return ($s == '.svn');
    }
    
    function __isimg($s)
    {
        return ($s == 'images');
    }
    
    function __isinstall($s)
    {
        return ($s == 'install');
    }
}

echo "<b>Orphan Phrases:</b>\n<ul>\n";
$search = new RecursiveSearch('c:/wamp/www/ilance/');
echo "</ul>\n",
     "<br /><table border='0'>\n",
     "<tr><td><i>Total number of phrases found: <strong>".$search->totalphrases."</strong>, Total number of orphan phrases found:</i></td><td><strong>".$search->orphanphrases."</strong></td></tr>\n",
     "</table>";
?>