<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

// #### load required phrase groups ############################################
$phrase['groups'] = array(
	'accounting',
	'subscription',
	'buying',
	'selling',
	'rfp'
);

// #### define top header nav ##################################################
$topnavlink = array(
        'invoicepayment'
);

// #### setup script location ##################################################
define('LOCATION','invoicepayment');

// #### require backend ########################################################
require_once('./functions/config.php');

$ilance->subscription = construct_object('api.subscription');

// #### setup default breadcrumb ###############################################
$navcrumb = array("$ilpage[invoicepayment]" => $ilcrumbs["$ilpage[invoicepayment]"]);

if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
{
	if (!empty($ilance->GPC['crypted']))
	{
		$uncrypted = decrypt_url($ilance->GPC['crypted']);
	}
	
        // #### USER WHO GENERATED AN INVOICE IS UPDATING THE STATUS ###########        
        if (isset($uncrypted['cmd']) AND $uncrypted['cmd'] == 'p2baction')
        {
                // #### mark as paid ###########################################
                if (isset($uncrypted['subcmd']) AND $uncrypted['subcmd'] == 'markaspaid' AND isset($uncrypted['invoiceid']) AND $uncrypted['invoiceid'] > 0 AND isset($uncrypted['txn']) AND $uncrypted['txn'] != '')
                {
                        $ilance->db->query("
                                UPDATE " . DB_PREFIX . "invoices
                                SET p2b_markedaspaid = '1',
                                status = 'paid',
                                paiddate = '" . DATETIME24H . "',
                                paid = totalamount
                                WHERE invoiceid = '" . intval($uncrypted['invoiceid']). "'
                                        AND p2b_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                        ");
                        
                        $area_title = $phrase['_marking_provider_generated_invoice_as_paid'];
			$page_title = SITE_NAME . ' - ' . $phrase['_marking_provider_generated_invoice_as_paid'];
			
			print_notice($phrase['_invoice_marked_as_paid'], $phrase['_you_have_successfully_confirmed_payment_status_on_this_generated_invoice'], $ilpage['invoicepayment'] . '?cmd=view&txn=' . $uncrypted['txn'], $phrase['_return_to_previous_menu']);
			exit(); 
                }
                
                // #### mark as unpaid #########################################
                else if (isset($uncrypted['subcmd']) AND $uncrypted['subcmd'] == 'markasunpaid' AND isset($uncrypted['invoiceid']) AND $uncrypted['invoiceid'] > 0 AND isset($uncrypted['txn']) AND $uncrypted['txn'] != '')
                {
                        $ilance->db->query("
                                UPDATE " . DB_PREFIX . "invoices
                                SET p2b_markedaspaid = '0',
                                status = 'unpaid',
                                paiddate = '0000-00-00 00:00:00',
                                paid = '0.00'
                                WHERE invoiceid = '" . intval($uncrypted['invoiceid']). "'
                                        AND p2b_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                        ");
                        
                        $area_title = $phrase['_marking_provider_generated_invoice_as_unpaid'];
			$page_title = SITE_NAME . ' - ' . $phrase['_marking_provider_generated_invoice_as_unpaid'];
			
			print_notice($phrase['_invoice_marked_as_unpaid'], $phrase['_you_have_set_the_payment_status_of_this_transaction_to_unpaid'], $ilpage['invoicepayment'] . '?cmd=view&txn=' . $uncrypted['txn'], $phrase['_return_to_previous_menu']);
			exit(); 
                }
                
                // #### mark as cancelled ######################################
                else if (isset($uncrypted['subcmd']) AND $uncrypted['subcmd'] == 'markascancelled' AND isset($uncrypted['invoiceid']) AND $uncrypted['invoiceid'] > 0 AND isset($uncrypted['txn']) AND $uncrypted['txn'] != '')
                {
                        $ilance->db->query("
                                UPDATE " . DB_PREFIX . "invoices
                                SET p2b_markedaspaid = '0',
                                status = 'cancelled',
                                paiddate = '0000-00-00 00:00:00',
                                paid = '0.00'
                                WHERE invoiceid = '" . intval($uncrypted['invoiceid']). "'
                                        AND p2b_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                        ");
                        
                        $area_title = $phrase['_marking_provider_generated_invoice_as_cancelled'];
			$page_title = SITE_NAME . ' - ' . $phrase['_marking_provider_generated_invoice_as_cancelled'];
			
			print_notice($phrase['_invoice_marked_as_cancelled'], $phrase['_you_have_set_the_payment_status_of_this_transaction_as_cancelled'], $ilpage['invoicepayment'] . '?cmd=view&txn=' . $uncrypted['txn'], $phrase['_return_to_previous_menu']);
			exit(); 
                }
        }
        
	// #### PRINTABLE INVOICE PREVIEW ######################################
	else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'print' AND (isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0 OR isset($ilance->GPC['txn']) AND $ilance->GPC['txn'] != ''))
	{
		// are we admin?
		if ($_SESSION['ilancedata']['user']['isadmin'] == '1' AND isset($ilance->GPC['uid']) AND $ilance->GPC['uid'] > 0)
		{
			// admin views invoice popup via admin cp
			if (isset($ilance->GPC['txn']) AND $ilance->GPC['txn'] != '')
			{
				// via transaction order id
				$sql = $ilance->db->query("
					SELECT *
					FROM " . DB_PREFIX . "invoices
					WHERE user_id = '" . intval($ilance->GPC['uid']) . "'
						AND transactionid = '" . $ilance->db->escape_string($ilance->GPC['txn']) . "'
					LIMIT 1
				");
			}
			else if (isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0)
			{
				// via invoice id
				$sql = $ilance->db->query("
					SELECT *
					FROM " . DB_PREFIX . "invoices
					WHERE user_id = '" . intval($ilance->GPC['uid']) . "'
						AND invoiceid = '" . intval($ilance->GPC['id']) . "'
					LIMIT 1
				");
			}
		}
		else
		{
                        // client views his own invoice popup
                        if (isset($ilance->GPC['txn']) AND $ilance->GPC['txn'] != '')
                        {
                                    // via transaction order id
                                    $sql = $ilance->db->query("
                                            SELECT *
                                            FROM " . DB_PREFIX . "invoices
                                            WHERE (user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "' OR p2b_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "')
                                                    AND transactionid = '" . $ilance->db->escape_string($ilance->GPC['txn']) . "'
                                            LIMIT 1
                                    ");
                        }
                        else if (isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0)
                        {
                                    // via invoice id
                                    // via transaction order id
                                    $sql = $ilance->db->query("
                                            SELECT *
                                            FROM " . DB_PREFIX . "invoices
                                            WHERE (user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "' OR p2b_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "')
                                                    AND invoiceid = '" . intval($ilance->GPC['id']) . "'
                                            LIMIT 1
                                    ");
                        }
		}
            
		if ($ilance->db->num_rows($sql) > 0)
		{
			while ($res = $ilance->db->fetch_array($sql))
			{
				// invoice that do not show a provider or merchant
				$invoice['siteaddress'] = SITE_ADDRESS;
				$invoice['sitebusinessnumber'] = '';		
				$invoice['providerfullname'] = '--';
				$invoice['providerbusinessnumber'] = '--';
				$invoice['providerusername'] = '--';
				$invoice['providerfulladdress'] = '--';
		
				if ($ilconfig['globalserversettings_registrationnumber'] != '')
				{
					$invoice['sitebusinessnumber'] .= '<br /><br /><strong>'.$phrase['_company_registration_number'].'</strong> <br /> ' . $ilconfig['globalserversettings_registrationnumber'];
				}
		
				if ($ilconfig['globalserversettings_vatregistrationnumber'] != '')
				{
					$invoice['sitebusinessnumber'] .= '<br /><br /><strong>'.$phrase['_vat_registration_number'].'</strong> <br /> ' . $ilconfig['globalserversettings_vatregistrationnumber'];
				}
				
				// customer info
				$invoice['fullname'] = fetch_user('fullname', $res['user_id']);
				$invoice['username'] = fetch_user('username', $res['user_id']);
				$invoice['businessnumber'] = fetch_business_numbers($res['user_id'], 1);
				$invoice['fulladdress'] = print_shipping_address_text($res['user_id']);
				
				// invoice info
				$invoice['purchasedate'] = print_date($res['createdate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, $res['createdate']);
				$invoice['maxpaymentdays'] = $ilconfig['invoicesystem_maximumpaymentdays'];
				$invoice['duedate'] = $res['duedate'];
		
				if ($invoice['duedate'] == '0000-00-00 00:00:00')
				{
					$invoice['duedate'] = '--';
				}
				else
				{
					$invoice['duedate'] = print_date($res['duedate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, $res['duedate']);
				}
		
				$invoice['txn'] = $res['transactionid'];
				$invoice['invoiceid'] = $res['invoiceid'];
				$invoice['comments'] = isset($res['comments']) ? stripslashes($res['comments']) : $phrase['_thank_you_for_your_business'];
				$invoice['description'] = stripslashes($res['description']);
				$invoice['amount'] = $ilance->currency->format($res['amount']);
				
				if ($res['istaxable'])
				{
					$invoice['totalamount'] = $ilance->currency->format($res['amount']+$res['taxamount']);
				}
				else
				{
					$invoice['totalamount'] = $ilance->currency->format($res['amount']);
				}
		
				$invoice['totalpaid'] = isset($res['paid']) ? $ilance->currency->format($res['paid']) : $ilance->currency->format(0);
				$invoice['notaxlogic'] = 0;
				$invoice['taxlogic'] = '';
		
				// for printable invoice view, show if overall invoice was credit or debit
				switch ($res['invoicetype'])
				{
					case 'storesubscription':
					{
						$invoice['type'] = $phrase['_debit'] . ' / ' . $phrase['_subscription'];
						break;
					}		
					case 'subscription':
					{
						$invoice['type'] = $phrase['_debit'] . ' / ' . $phrase['_subscription'];
						break;
					}		
					case 'commission':
					{
						$invoice['type'] = $phrase['_debit'] . ' / ' . $phrase['_commission'];
						break;
					}		
					case 'p2b':
					{
						$invoice['type'] = $phrase['_debit'] . ' / ' . $phrase['_provider_to_buyer_generated_invoice'];
						$invoice['notaxlogic'] = 1;
						break;
					}		
					case 'buynow':
					{
						$invoice['type'] = $phrase['_debit'] . ' / ' . $phrase['_escrow'];
						$invoice['notaxlogic'] = 1;
						break;
					}		
					case 'credential':
					{
						$invoice['type'] = $phrase['_debit'];
						break;
					}		
					case 'debit':
					{
						$invoice['type'] = $phrase['_debit'];
						break;
					}		
					case 'credit':
					{
						$invoice['type'] = $phrase['_credit'];
						$invoice['notaxlogic'] = 1;
						break;
					}		
					case 'escrow':
					{
						$invoice['type'] = $phrase['_debit'] . ' / ' . $phrase['_escrow'];
						$invoice['notaxlogic'] = 1;
						break;
					}
				}
		
				if ($invoice['notaxlogic'] == 0)
				{
					$taxinfo = $res['taxinfo'];
		    
					// create the tax bit in html
					if (!empty($taxinfo))
					{
						    $invoice['taxlogic'] = '
						    <tr>
							   <td class="tablehead" align="right"> ' . $phrase['_applicable_tax'] . ': &nbsp;&nbsp;</td>
							   <td class="tablehead" width="150" align="center">' . $taxinfo . '</td>
						    </tr>
						    ';
					}
				}
		
				// invoice type settings (show or not show another opponent on invoice page)
				if ($res['invoicetype'] == 'p2b')
				{
					$invoice['providerfullname'] = fetch_user('fullname', $res['p2b_user_id']);
					$invoice['providerbusinessnumber'] = fetch_business_numbers($res['p2b_user_id'], 1);
					$invoice['providerusername'] = fetch_user('username', $res['p2b_user_id']);
					$invoice['providerfulladdress'] = print_shipping_address_text($res['p2b_user_id']);
				}
				else if ($res['invoicetype'] == 'buynow')
				{
					$invoice['providerfullname'] = fetch_user('fullname', $res['p2b_user_id']);
					$invoice['providerbusinessnumber'] = fetch_business_numbers($res['p2b_user_id'], 1);
					$invoice['providerusername'] = fetch_user('username', $res['p2b_user_id']);
					$invoice['providerfulladdress'] = print_shipping_address_text($res['p2b_user_id']);
				}
				else if ($res['invoicetype'] == 'escrow')
				{
					$ilance->auction = construct_object('api.auction');
					$ilance->escrow = construct_object('api.escrow');
					
					if ($ilance->auction->fetch_auction_type($res['projectid']) == 'service')
					{
						$invoice['providerusername'] = $ilance->escrow->fetch_escrow_opponent($res['projectid'], $res['invoiceid'], 'service');
						$invoice['providerfullname'] = fetch_user('fullname', fetch_user('user_id', '', $invoice['providerusername']));
						$invoice['providerbusinessnumber'] = fetch_business_numbers(fetch_user('user_id', '', $invoice['providerusername']), 1);
						$invoice['providerfulladdress'] = print_shipping_address_text(fetch_user('user_id', '', $invoice['providerusername']));
					}
					else if ($ilance->auction->fetch_auction_type($res['projectid']) == 'product')
					{
						$invoice['providerusername'] = $ilance->escrow->fetch_escrow_opponent($res['projectid'], $res['invoiceid'], 'product');
						$invoice['providerfullname'] = fetch_user('fullname', fetch_user('user_id', '', $invoice['providerusername']));
						$invoice['providerbusinessnumber'] = fetch_business_numbers(fetch_user('user_id', '', $invoice['providerusername']), 1);
						$invoice['providerfulladdress'] = print_shipping_address_text(fetch_user('user_id', '', $invoice['providerusername']));
					}
				}
				$invoice[] = $invoice;
			}
		}
	
		$ilance->template->load_popup('main', 'invoicepayment_print.html');
		$ilance->template->parse_loop('main', 'invoice');
		$ilance->template->parse_hash('main', array('ilpage' => $ilpage));
		$ilance->template->parse_if_blocks('main');
		$ilance->template->pprint('main', array('login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
		exit();
    }
	
	// #### INVOICE DOWNLOAD ACTION ########################################
	else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_do-invoice-action' AND isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0 AND isset($ilance->GPC['invcmd']))
	{
		switch ($ilance->GPC['invcmd'])
		{
                        case 'csv':
			{
				header('Content-type: application/csv; charset="' . $ilconfig['template_charset'] . '"');
				header("Content-Disposition: \"inline; filename=invoice-(".date('Y')."-".date('m')."-".date('d').").csv");
				
				echo $phrase['_invoice_pound'].",".$phrase['_userid'].",".$phrase['_description'].",".$phrase['_amount'].",".$phrase['_paid'].",".$phrase['_invoice_status'].",".$phrase['_invoice_type'].",".$phrase['_pay_method'].",".$phrase['_ip_address'].",".$phrase['_create_date'].",".$phrase['_due_date'].",".$phrase['_paid_date'].",".$phrase['_invoice_notes']."\n";
				
				$csv_results = array();
				
				$csv_query = $ilance->db->query("
					SELECT *
					FROM " . DB_PREFIX . "invoices
					WHERE (user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "' OR p2b_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "')
						AND invoiceid = '" . intval($ilance->GPC['id']) . "'
					LIMIT 1
				", 0, null, __FILE__, __LINE__);
				while ($csv_results = $ilance->db->fetch_array($csv_query))
				{
					echo $csv_results['invoiceid'].",".$csv_results['user_id'].",".stripslashes($csv_results['description']).",".$ilance->currency->format($csv_results['amount']).",".$ilance->currency->format($csv_results['paid']).",".mb_strtoupper($csv_results['status']).",".mb_strtoupper(print_transaction_type($csv_results['invoicetype'])).",".mb_strtoupper($csv_results['paymethod']).",".$csv_results['ipaddress'].",".$csv_results['createdate'].",".$csv_results['duedate'].",".$csv_results['paiddate'].",".stripslashes($csv_results['custommessage'])."\n";
				}
				
				$area_title = $phrase['_downloading_csv_invoice_reports'];
				$page_title = SITE_NAME . ' - ' . $phrase['_downloading_csv_invoice_reports'];
				break;
			}		    
                        case 'txt':
			{
				break;
			}                
                        case 'pdf':
			{
				break;
			}
		}
		exit();
	}

	// #### PROVIDER GENERATING BUYER INVOICE ##############################
	else if (isset($uncrypted['cmd']) AND $uncrypted['cmd'] == '_generate-invoice' AND isset($uncrypted['buyer_id']) AND $uncrypted['buyer_id'] > 0 AND isset($uncrypted['seller_id']) AND $uncrypted['seller_id'] > 0 AND isset($uncrypted['project_id']) AND $uncrypted['project_id'] > 0)
	{
		$ilance->subscription = construct_object('api.subscription');
                $ilance->auction = construct_object('api.auction');
                $ilance->auction_post = construct_object('api.auction_post');
		
		if ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'generateinvoices') == 'no')
		{
                        $area_title = $phrase['_access_denied_to_invoice_generation'];
			$page_title = SITE_NAME . ' - ' . $phrase['_access_denied_to_invoice_generation'];
			
			print_notice($phrase['_access_denied'], $phrase['_your_current_subscription_level_does_not_permit_you_to_use_this_marketplace_resource']." <a href='".$ilpage['subscription']."'><strong>".$phrase['_click_here']."</strong></a>", $ilpage['subscription'], ucwords($phrase['_click_here']), fetch_permission_name('generateinvoices'));
			exit();        
                }
                
                // verify that the provider generating the invoice to the buyer is actually him!
                if ($uncrypted['seller_id'] != $_SESSION['ilancedata']['user']['userid'])
		{
                        $area_title = $phrase['_access_denied_to_invoice_generation'];
			$page_title = SITE_NAME . ' - ' . $phrase['_access_denied_to_invoice_generation'];
			
			print_notice($phrase['_access_denied'], $phrase['_this_action_can_only_be_executed_by_the_awarded_service_provider'], $ilpage['main'], ucwords($phrase['_main_menu']));
			exit();        
                }
                
                $area_title = $phrase['_generating_new_invoice_to_service_buyer'];
                $page_title = SITE_NAME . ' - ' . $phrase['_generating_new_invoice_to_service_buyer'];
                
                $navcrumb = array();
                $navcrumb["$ilpage[main]?cmd=cp"] = $phrase['_my_cp'];
                $navcrumb["$ilpage[accounting]?cmd=management"] = $phrase['_accounting'];
                $navcrumb["$ilpage[selling]?cmd=management"] = $phrase['_selling_activity'];
                $navcrumb[] = $phrase['_invoice_generation_to_buyer'];

                $currency = print_left_currency_symbol();
                
                if ($ilconfig['invoicesystem_enablep2btransactionfees'])
                {
                        $show['p2b_transaction_fee'] = true;				
                        if ($ilconfig['invoicesystem_p2bfeesfixed'])
                        {
                                // fixed amount transaction commission logic
                                $commissionfee = $ilance->currency->format($ilconfig['invoicesystem_p2bfee']);
                        }
                        else
                        {
                                // percentage transaction commission logic
                                $commissionfee = $ilconfig['invoicesystem_p2bfee'] . '%';
                        }
                        
                        if (!empty($commissionfee))
                        {
                                $txnfee = $commissionfee;
                        }
                        else 
                        {
                                $txnfee = 0;	
                        }
                }
                else
                {
                        $show['p2b_transaction_fee'] = false;
                }
                
                // auction information
                $sql_auction = $ilance->db->query("
                        SELECT *
                        FROM " . DB_PREFIX . "projects
                        WHERE project_id = '" . $uncrypted['project_id'] . "' 
                                AND user_id = '" . $uncrypted['buyer_id'] . "'
                ");
                if ($ilance->db->num_rows($sql_auction) > 0)
                {
                        $result_auction = $ilance->db->fetch_array($sql_auction);
                        
                        $project_id = $result_auction['project_id'];
                        $project_title = stripslashes($result_auction['project_title']);
                        
                        // auction owner
                        $sql_owner = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "users
                                WHERE user_id = '" . $uncrypted['buyer_id'] . "'
                        ");
                        if ($ilance->db->num_rows($sql_owner) > 0)
                        {
                                $result_owner = $ilance->db->fetch_array($sql_owner);
                                $customer = stripslashes($result_owner['username']);
                                $buyer_id = $uncrypted['buyer_id'];
                                
                                // service provider info
                                $sql_provider = $ilance->db->query("
                                        SELECT *
                                        FROM " . DB_PREFIX . "users
                                        WHERE user_id = '" . $uncrypted['seller_id'] . "'
                                ");
                                if ($ilance->db->num_rows($sql_provider) > 0)
                                {
                                        $result_provider = $ilance->db->fetch_array($sql_provider);
                                        $seller_id = $uncrypted['seller_id'];
                                        
                                        // related invoices association and links to view them
                                        $inv_assoc = $ilance->db->query("
                                                SELECT *
                                                FROM " . DB_PREFIX . "invoices
                                                WHERE projectid = '" . $uncrypted['project_id'] . "' 
                                                        AND p2b_user_id = '" . $uncrypted['seller_id'] . "' 
                                                        AND user_id = '" . $uncrypted['buyer_id'] . "'
                                        ");
                                        if ($ilance->db->num_rows($inv_assoc) > 0)
                                        {
                                                $show['other_invoices'] = true;
                                                
                                                $invoiceassociation = '';
                                                while ($inv_results = $ilance->db->fetch_array($inv_assoc))
                                                {
                                                        if ($inv_results['status'] == 'paid')
                                                        {
                                                                $invoiceassociation .= '<div style="padding-top:3px"><a href="' . $ilpage['invoicepayment'] . '?cmd=view&amp;txn=' . $inv_results['transactionid'] . '">' . $ilance->currency->format($inv_results['amount']) . ' : ' . $inv_results['transactionid'] . '</a> : <strong>' . $phrase['_paid'] . '</strong></div>';
                                                        }
                                                        else if ($inv_results['status'] == 'unpaid')
                                                        {
                                                                $invoiceassociation .= '<div style="padding-top:3px"><a href="' . $ilpage['invoicepayment'] . '?cmd=view&amp;txn=' . $inv_results['transactionid'] . '">' . $ilance->currency->format($inv_results['amount']) . ' : ' . $inv_results['transactionid'] . '</a> : <span style="color:red"><strong>' . $phrase['_unpaid'] . '</strong></span></div>';
                                                        }
                                                        else if ($inv_results['status'] == 'scheduled')
                                                        {
                                                                $invoiceassociation .= '<div style="padding-top:3px"><a href="' . $ilpage['invoicepayment'] . '?cmd=view&amp;txn=' . $inv_results['transactionid'] . '">' . $ilance->currency->format($inv_results['amount']) . ' : ' . $inv_results['transactionid'] . '</a> : <strong>' . $phrase['_scheduled'] . '</strong></div>';
                                                        }
                                                        else if ($inv_results['status'] == 'complete')
                                                        {
                                                                $invoiceassociation .= '<div style="padding-top:3px"><a href="' . $ilpage['invoicepayment'] . '?cmd=view&amp;txn=' . $inv_results['transactionid'] . '">' . $ilance->currency->format($inv_results['amount']) . ' : ' . $inv_results['transactionid'] . '</a> : <strong>' . $phrase['_paid'] . '</strong></div>';
                                                        }
                                                        else if ($inv_results['status'] == 'cancelled')
                                                        {
                                                                $invoiceassociation .= '<div style="padding-top:3px"><a href="' . $ilpage['invoicepayment'] . '?cmd=view&amp;txn=' . $inv_results['transactionid'] . '">' . $ilance->currency->format($inv_results['amount']) . ' : ' . $inv_results['transactionid'] . '</a> : <strong>' . $phrase['_cancelled'] . '</strong></div>';
                                                        }
                                                }
                                        }
                                        else
                                        {
                                                $show['other_invoices'] = false;
                                        }
                                        
                                        // latest last bid amount placed
                                        $sql_bidamount = $ilance->db->query("
                                                SELECT *
                                                FROM " . DB_PREFIX . "project_bids
                                                WHERE user_id = '" . $uncrypted['seller_id'] . "'
                                                        AND project_id = '" . $uncrypted['project_id'] . "'
                                                ORDER BY bid_id DESC
                                        ");
                                        if ($ilance->db->num_rows($sql_bidamount) > 0)
                                        {
                                                $result_bidamount = $ilance->db->fetch_array($sql_bidamount);
                                                $bidamount = $ilance->currency->format($result_bidamount['bidamount']);
                                        }
                                        
                                        $paymentstatuspulldown = '<select name="paymentstatus" style="font-family: verdana"><option value="unpaid" selected="selected">' . $phrase['_mark_as_unpaid'] . '</option><option value="paid">' . $phrase['_mark_as_paid'] . '</option></select>';
                                        
                                        $paymentmethodpulldown = $ilance->auction_post->print_payment_method('p2b_paymethod', 'p2b_paymethod');
                                        
                                        // specific javascript includes
                                        $headinclude .= '
<script type="text/javascript">
<!--
function validatep2binvoice(f)
{
        var Chars = "0123456789.,";
        haveerrors = 0;
        (f.amount.value.length < 1) ? showImage("amounterror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("amounterror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        for (var i = 0; i < f.amount.value.length; i++)
        {
            if (Chars.indexOf(f.amount.value.charAt(i)) == -1)
            {
                    alert(phrase[\'_invalid_currency_characters_only_numbers_and_a_period_are_allowed_in_this_field\']);
                    haveerrors = 1;
            }
        }
        if (f.amount.value == "0.00" || f.amount.value == "0")
        {
            alert(phrase[\'_cannot_place_value_for_your_bid_amount_your_bid_amount_must_be_greater_than_the_minimum_bid_amount\']);
            haveerrors = 1;
        }				    
        return (!haveerrors);
}
//-->
</script>';
                                        $ilance->template->load_file('main', 'invoicepayment_p2b.html');
                                        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                                        $ilance->template->parse_if_blocks('main');
                                        $ilance->template->pprint('main', array('paymentstatuspulldown','paymentmethodpulldown','bidamount','invoiceassociation','project_title','project_id','customer','txnfee','session_amount','session_comments','currency','buyer_id','seller_id','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                                        exit();
                                }
                        }
                }
	}
	
	// #### PROVIDER INVOICE TO BUYER PREVIEW ##############################
	else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_do-generate-preview' AND isset($ilance->GPC['amount']) AND $ilance->GPC['amount'] != "" AND isset($ilance->GPC['seller_id']) AND $ilance->GPC['seller_id'] > 0 AND isset($ilance->GPC['buyer_id']) AND $ilance->GPC['buyer_id'] > 0 AND isset($ilance->GPC['project_id']) AND $ilance->GPC['project_id'] > 0)
	{
		$area_title = $phrase['_preview_generation_of_new_invoice_to_buyer'];
		$page_title = SITE_NAME . ' - ' . $phrase['_preview_generation_of_new_invoice_to_buyer'];

		$navcrumb = array();
		$navcrumb["$ilpage[accounting]?cmd=management"] = $phrase['_accounting'];
		$navcrumb["$ilpage[selling]?cmd=management"] = $phrase['_selling_activity'];
		$navcrumb[] = $phrase['_invoice_generation_to_buyer'];
		
		$ilance->subscription = construct_object('api.subscription');
        
		// can this service provider generate invoices to their buyers?
		if ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'generateinvoices') == 'no')
		{
                        $area_title = $phrase['_access_denied_to_invoice_generation'];
			$page_title = SITE_NAME . ' - ' . $phrase['_access_denied_to_invoice_generation'];
			
			print_notice($phrase['_access_denied'], $phrase['_your_current_subscription_level_does_not_permit_you_to_use_this_marketplace_resource']." <a href='".$ilpage['subscription']."'><strong>".$phrase['_click_here']."</strong></a>", $ilpage['subscription'], ucwords($phrase['_click_here']), fetch_permission_name('generateinvoices'));
			exit();        
                }
                
                if ($ilconfig['invoicesystem_enablep2btransactionfees'])
                {
                        $show['p2b_transaction_fee'] = true;
                        if ($ilconfig['invoicesystem_p2bfeesfixed'])
                        {
                                // fixed amount transaction commission logic
                                $commissionfee = $ilconfig['invoicesystem_p2bfee'];
                        }
                        else
                        {
                                // percentage transaction commission logic
                                $commissionfee = ($ilance->GPC['amount'] * $ilconfig['invoicesystem_p2bfee'] / 100);
                        }
                        
                        if (!empty($commissionfee))
                        {
                                $txn_fee_hidden = '<input type="hidden" name="transaction_fee" value="' . $commissionfee . '" />';
                                $transaction_fee_formatted = $ilance->currency->format($commissionfee);
                        }
                        else 
                        {
                                $txn_fee_hidden = '';
                                $transaction_fee_formatted = $ilance->currency->format(0);	
                        }
                }
                else
                {
                        $show['p2b_transaction_fee'] = false;
                        $txn_fee_hidden = '';
                }
                
                $amount = $ilance->GPC['amount'];
                $amount_formatted = $ilance->currency->format($ilance->GPC['amount']);
                
                // fetch auction information
                $sql_auction = $ilance->db->query("
                        SELECT *
                        FROM " . DB_PREFIX . "projects
                        WHERE project_id = '" . intval($ilance->GPC['project_id']) . "'
                                AND user_id = '" . intval($ilance->GPC['buyer_id']) . "'
                        LIMIT 1
                ");
                if ($ilance->db->num_rows($sql_auction) > 0)
                {
                        $result_auction = $ilance->db->fetch_array($sql_auction);
                        $project_id = $result_auction['project_id'];
                        $project_title = stripslashes($result_auction['project_title']);
                        
                        // fetch service auction buyer
                        $sql_owner = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "users
                                WHERE user_id = '" . intval($ilance->GPC['buyer_id']) . "'
                                LIMIT 1
                        ");
                        if ($ilance->db->num_rows($sql_owner) > 0)
                        {
                                $result_owner = $ilance->db->fetch_array($sql_owner);
                                $customer = stripslashes($result_owner['username']);
                                $buyer_id = $result_owner['user_id'];
                                
                                // service provider information
                                $sql_provider = $ilance->db->query("
                                        SELECT *
                                        FROM " . DB_PREFIX . "users
                                        WHERE user_id = '" . intval($ilance->GPC['seller_id']) . "'
                                        LIMIT 1
                                ");
                                if ($ilance->db->num_rows($sql_provider) > 0)
                                {
                                        $result_provider = $ilance->db->fetch_array($sql_provider);
                                        $seller_id = intval($ilance->GPC['seller_id']);
                                        
                                        // service provider opting to pay commission fee instantly?
                                        if (isset($ilance->GPC['instantpay']) AND $ilance->GPC['instantpay'] > 0)
                                        {
                                                $instantpay = 1;
                                        }
                                        else
                                        {
                                                $instantpay = 0;
                                        }
                                        if (isset($ilance->GPC['comments']) AND $ilance->GPC['comments'] != "")
                                        {
                                                $comments = $ilance->GPC['comments'];
                                        }
                                        else
                                        {
                                                $comments = $phrase['_no_comments_available'];
                                        }
                                        
                                        $paymentstatus = $ilance->GPC['paymentstatus'];
                                        $paymentstatus_formatted = ucwords($ilance->GPC['paymentstatus']);
                                        
                                        $paymentmethod = $ilance->GPC['p2b_paymethod'];
                                        $paymentmethod_formatted = $ilance->GPC['p2b_paymethod'];
                                        
                                        $ilance->template->load_file('main', 'invoicepayment_p2b_preview.html');
                                        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                                        $ilance->template->parse_if_blocks('main');
                                        $ilance->template->pprint('main', array('paymentmethod_formatted','paymentstatus_formatted','paymentstatus','paymentmethod','comments','instantpay','description','amount_formatted','txn_fee_hidden','amount','transaction_fee_formatted','transaction_amount','project_title','project_id','customer','txnfee','currency','buyer_id','seller_id','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                                        exit();
                                }
                        }
                }
	}
	
	// #### SERVICE PROVIDER INVOICE TO BUYER HANDLER ######################
	else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_do-generate-submit' AND isset($ilance->GPC['amount']) AND !empty($ilance->GPC['amount']) AND isset($ilance->GPC['seller_id']) AND $ilance->GPC['seller_id'] > 0 AND isset($ilance->GPC['buyer_id']) AND $ilance->GPC['buyer_id'] > 0 AND isset($ilance->GPC['project_id']) AND $ilance->GPC['project_id'] > 0)
	{
		$area_title = $phrase['_new_invoice_was_generated_to_buyer'];
		$page_title = SITE_NAME . ' - ' . $phrase['_new_invoice_was_generated_to_buyer'];
		
		$ilance->accounting = construct_object('api.accounting');
		
		$navcrumb = array();
		$navcrumb["$ilpage[main]?cmd=cp"] = $phrase['_my_cp'];
		$navcrumb["$ilpage[accounting]?cmd=management"] = $phrase['_accounting'];
		$navcrumb["$ilpage[selling]?cmd=management"] = $phrase['_selling_activity'];
		$navcrumb[] = $phrase['_invoice_generation_to_buyer'];
		
                $txnfee = 0;
		if (isset($ilance->GPC['transaction_fee']) AND $ilance->GPC['transaction_fee'] != '' AND $ilance->GPC['transaction_fee'] != '0' AND $ilance->GPC['transaction_fee'] != '0.00' AND $ilance->GPC['transaction_fee'] != '0.0')
		{
			$txnfee = $ilance->GPC['transaction_fee'];
                        if ($txnfee < 0)
                        {
                                $txnfee = 0;
                        }
		}

		$comments = $phrase['_no_comments_available'];		
		if (isset($ilance->GPC['comments']) AND !empty($ilance->GPC['comments']))
		{
			$comments = $ilance->GPC['comments'];
		}
		
                $instantpay = 0;
		if (isset($ilance->GPC['instantpay']) AND $ilance->GPC['instantpay'] > 0)
		{
			$instantpay = 1;
		}
                
                $ilance->GPC['paymentstatus'] = isset($ilance->GPC['paymentstatus']) ? $ilance->GPC['paymentstatus'] : 'unpaid';
                $ilance->GPC['paymentmethod'] = isset($ilance->GPC['paymentmethod']) ? $ilance->GPC['paymentmethod'] : '';
		
		$ilance->accounting->construct_p2b_transaction($ilance->GPC['amount'], intval($ilance->GPC['seller_id']), (int)$ilance->GPC['buyer_id'], (int)$ilance->GPC['project_id'], $comments, $txnfee, $instantpay, $ilance->GPC['paymentstatus'], $ilance->GPC['paymentmethod']);
		
		print_notice($phrase['_invoice_generation_complete'], $phrase['_you_have_successfully_generated_an_invoice_to_your_customer'] . '<br /><br />' . $phrase['_please_remember_if_you_have_not_paid_your_transaction_fee_for_the_generation_of_this_invoice_your_account_may_become_inactive_after_a_specific_period_of_time'], $ilpage['accounting'], $phrase['_my_account']);
		exit();
	}
	
	// #### INVOICE PREVIEW ################################################
	else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_do-invoice-preview' AND isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0)
	{
		$area_title = $phrase['_invoice_payment_preview_menu'];
		$page_title = SITE_NAME . ' - ' . $phrase['_invoice_payment_preview_menu'];
		
                if (!isset($ilance->GPC['account_id']) OR empty($ilance->GPC['account_id']))
                {
                        $area_title = $phrase['_invoice_payment_menu_denied_payment'];
			$page_title = SITE_NAME . ' - ' . $phrase['_invoice_payment_menu_denied_payment'];
			
			print_notice($phrase['_invoice_error'], 'No payment method was selected.', $ilpage['accounting'], $phrase['_my_account']);
			exit();
                }
                
		$navcrumb = array();
		$navcrumb["$ilpage[accounting]"] = $phrase['_accounting'];
		$navcrumb["$ilpage[invoicepayment]?id=" . intval($ilance->GPC['id'])] = $phrase['_invoice_payment_preview_menu'];
		$navcrumb[""] = $phrase['_invoice'] . ' #' . intval($ilance->GPC['id']);

		$id = isset($ilance->GPC['id']) ? intval($ilance->GPC['id']) : 0;
			
		$sql = $ilance->db->query("
			SELECT *
			FROM " . DB_PREFIX . "invoices
			WHERE invoiceid = '" . intval($ilance->GPC['id']) . "' 
				AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
		");
		if ($ilance->db->num_rows($sql) > 0)
		{
			$res = $ilance->db->fetch_array($sql);
			
			// invoice type
			$invoicetype = $res['invoicetype'];
			
			// invoice description
			$description = stripslashes($res['description']);
			
			// amount
			$amount = $res['amount'];
			
			// preview the amount
			$totalpreviewamount = $ilance->currency->format($amount);
			$previewamount = $ilance->currency->format($res['amount']);
			
			$taxlogic = '';
			
			// do we pay taxes?
			if ($res['istaxable'] > 0 AND $res['totalamount'] > 0)
			{
				$taxinfo = $res['taxinfo'];
	    
				// change regular amount to total amount (including added taxes)
				$amount = $res['totalamount'];
				
				$totalpreviewamount = $ilance->currency->format($res['totalamount']);
				
				// create the tax bit in html
				if (!empty($taxinfo))
				{
					$taxlogic = '
					<tr>
					       <td align="right">' . $phrase['_applicable_tax'] . ':</td>
					       <td align="left">' . $taxinfo . '</td>
					</tr>
					';
				}
			}
			
			$createdate = print_date($res['createdate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
			if ($res['duedate'] == '0000-00-00 00:00:00')
			{
				$duedate = '--';
			}
			else
			{
				$duedate = print_date($res['duedate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
			}
			
			if ($res['paiddate'] == '0000-00-00 00:00:00')
			{
				$paiddate = '--';
			}
			else
			{
				$paiddate = print_date($res['paiddate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
			}
			
			$account_id = $ilance->GPC['account_id'];
			$custommessage = stripslashes($res['custommessage']);
			$invoiceid = intval($ilance->GPC['id']);
		}

		// #### INVOICE PAYMENT VIA ONLINE ACCOUNT #####################
		if ($ilance->GPC['account_id'] == 'account')
		{
			$show['transactionfees'] = 0;
			$show['directpayment'] = 0;
			$payment_method = $phrase['_online_account_instant_payment'];
			
			$directpaymentform = '';
			
			$ilance->template->load_file('main', 'invoicepayment_preview.html');
			$ilance->template->parse_hash('main', array('ilpage' => $ilpage));
			$ilance->template->parse_if_blocks('main');
			$ilance->template->pprint('main', array('directpaymentform','totalpreviewamount','taxlogic','account_id','txn_fee_hidden','totalpreviewamount','previewamount','payment_method','invoiceid','invoicetype','description','amount','amountpaid','createdate','duedate','paiddate','custommessage','transaction_fee_formatted','account_id','ip','referer','transaction_fee_notice','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
			exit();
		}
		
		// #### INVOICE PAYMENT VIA PAYPAL #############################
		else if ($ilance->GPC['account_id'] == 'paypal')
		{
			$show['transactionfees'] = 0;
			$show['directpayment'] = 1;
			
			$payment_method = $phrase['_paypal'];
			$transaction_fee = 0;
			$txn_fee_hidden = '';
			$transaction_fee_formatted = $ilance->currency->format($transaction_fee);
			
			if ($ilconfig['paypal_transaction_fee'] > 0 OR $ilconfig['paypal_transaction_fee2'] > 0)
			{
				$show['transactionfees'] = 1;
				
				$fee_a = $ilconfig['paypal_transaction_fee'];
				$fee_b = $ilconfig['paypal_transaction_fee2'];
				$transaction_fee = ($amount * $fee_a) + $fee_b;
				$txn_fee_hidden = '<input type="hidden" name="transaction_fee" value="' . $transaction_fee . '" />';
				$transaction_fee_formatted = $ilance->currency->format($transaction_fee);
			}
			
			$totalpreviewamount = ($amount + $transaction_fee);
			$totalamount = sprintf("%01.2f", $totalpreviewamount);
			
			$totalpreviewamount = $ilance->currency->format($totalpreviewamount);
			$previewamount = $ilance->currency->format($amount);
			
			$customencrypted = 'DIRECT|' . $_SESSION['ilancedata']['user']['userid'] . '|' . intval($ilance->GPC['id']) . '|' . $invoicetype . '|0|0|0|0|0';
			
			$ilance->paypal = construct_object('api.paypal', $ilance->GPC);
			$directpaymentform = $ilance->paypal->print_payment_form($_SESSION['ilancedata']['user']['userid'], '', $totalamount, intval($ilance->GPC['id']), 0, $description, $ilconfig['paypal_business_email'], $ilconfig['paypal_master_currency'], '', $customencrypted, 0);
			
			$ilance->template->load_file('main', 'invoicepayment_preview.html');
			$ilance->template->parse_hash('main', array('ilpage' => $ilpage));
			$ilance->template->parse_if_blocks('main');
			$ilance->template->pprint('main', array('directpaymentform','totalpreviewamount','taxlogic','account_id','txn_fee_hidden','previewamount','payment_method','invoiceid','invoicetype','description','amount','amountpaid','createdate','duedate','paiddate','custommessage','transaction_fee_formatted','account_id','ip','referer','transaction_fee_notice','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
			exit();
		}
		
		// #### INVOICE PAYMENT VIA STORMPAY ###########################
		else if ($ilance->GPC['account_id'] == 'stormpay')
		{
			$show['transactionfees'] = 0;
			$show['directpayment'] = 1;
			
			$customencrypted = 'DIRECT|' . $_SESSION['ilancedata']['user']['userid'] . '|' . intval($ilance->GPC['id']) . '|' . $invoicetype . '|0|0|0|0|0';
			$payment_method = $phrase['_stormpay'];
						
			$ilance->stormpay = construct_object('api.stormpay', $ilance->GPC);
			$directpaymentform = $ilance->stormpay->print_payment_form($_SESSION['ilancedata']['user']['userid'], '', $amount, intval($ilance->GPC['id']), 0, $description, $ilconfig['stormpay_business_email'], $ilconfig['stormpay_master_currency'], $ilconfig['stormpay_secret_code'], $customencrypted, 0);
			
			$ilance->template->load_file('main', 'invoicepayment_preview.html');
			$ilance->template->parse_hash('main', array('ilpage' => $ilpage));
			$ilance->template->parse_if_blocks('main');
			$ilance->template->pprint('main', array('directpaymentform','totalpreviewamount','taxlogic','account_id','txn_fee_hidden','totalpreviewamount','previewamount','payment_method','invoiceid','invoicetype','description','amount','amountpaid','createdate','duedate','paiddate','custommessage','transaction_fee_formatted','account_id','ip','referer','transaction_fee_notice','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
			exit();
		}
		
		// #### INVOICE PAYMENT VIA CASHU ##############################
		else if ($ilance->GPC['account_id'] == 'cashu')
		{
			$show['transactionfees'] = 0;
			$show['directpayment'] = 1;
			
			$customencrypted = 'DIRECT|' . $_SESSION['ilancedata']['user']['userid'] . '|' . intval($ilance->GPC['id']) . '|' . $invoicetype . '|0|0|0|0|0';
			$payment_method = $phrase['_cashu'];
			
			$ilance->cashu = construct_object('api.cashu', $ilance->GPC);
			$directpaymentform = $ilance->cashu->print_payment_form($_SESSION['ilancedata']['user']['userid'], $_SESSION['ilancedata']['user']['email'], $amount, intval($ilance->GPC['id']), 0, $description, $ilconfig['cashu_business_email'], $ilconfig['cashu_master_currency'], $ilconfig['cashu_secret_code'], $customencrypted, $ilconfig['cashu_testmode']);
			
			$ilance->template->load_file('main', 'invoicepayment_preview.html');
			$ilance->template->parse_hash('main', array('ilpage' => $ilpage));
			$ilance->template->parse_if_blocks('main');
			$ilance->template->pprint('main', array('directpaymentform','totalpreviewamount','taxlogic','account_id','txn_fee_hidden','totalpreviewamount','previewamount','payment_method','invoiceid','invoicetype','description','amount','amountpaid','createdate','duedate','paiddate','custommessage','transaction_fee_formatted','account_id','ip','referer','transaction_fee_notice','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
			exit();
		}
		
		// #### INVOICE PAYMENT VIA MONEYBOOKERS #######################
		else if ($ilance->GPC['account_id'] == 'moneybookers')
		{
			$show['transactionfees'] = 0;
			$show['directpayment'] = 1;
			
			$customencrypted = 'DIRECT|' . $_SESSION['ilancedata']['user']['userid'] . '|' . intval($ilance->GPC['id']) . '|' . $invoicetype . '|0|0|0|0|0';
			$payment_method = $phrase['_moneybookers'];
						
			$ilance->moneybookers = construct_object('api.moneybookers', $ilance->GPC);
			$directpaymentform = $ilance->moneybookers->print_payment_form($_SESSION['ilancedata']['user']['userid'], '', $amount, intval($ilance->GPC['id']), 0, $description, $ilconfig['moneybookers_business_email'], $ilconfig['moneybookers_master_currency'], $ilconfig['moneybookers_secret_code'], $customencrypted, 0);
			
			$ilance->template->load_file('main', 'invoicepayment_preview.html');
			$ilance->template->parse_hash('main', array('ilpage' => $ilpage));
			$ilance->template->parse_if_blocks('main');
			$ilance->template->pprint('main', array('directpaymentform','totalpreviewamount','taxlogic','account_id','txn_fee_hidden','totalpreviewamount','previewamount','payment_method','invoiceid','invoicetype','description','amount','amountpaid','createdate','duedate','paiddate','custommessage','transaction_fee_formatted','account_id','ip','referer','transaction_fee_notice','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
			exit();
		}

		// #### INVOICE PAYMENT VIA CREDIT CARD ########################
		else
		{
			$show['directpayment'] = 0;
			
			$invoiceid = intval($ilance->GPC['id']);
			
			$result_active_cards = $ilance->db->query("
				SELECT *
				FROM " . DB_PREFIX . "creditcards
				WHERE cc_id = '" . intval($ilance->GPC['account_id']) . "'
					AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
					AND creditcard_status = 'active'
					AND authorized = 'yes'
				LIMIT 1
			");
			if ($ilance->db->num_rows($result_active_cards) > 0)
			{
				$res_cc = $ilance->db->fetch_array($result_active_cards);
				
				$dec_CardNumber = $ilance->crypt->three_layer_decrypt($res_cc['creditcard_number'], $ilconfig['key1'], $ilconfig['key2'], $ilconfig['key3']);
				$dec_CardNumber = str_replace(' ', '', $dec_CardNumber);
				
				$ccnum_hidden = substr_replace($dec_CardNumber, 'XX XXXX XXXX ', 2, (mb_strlen($dec_CardNumber) - 6));
				$payment_method = mb_strtoupper($res_cc['creditcard_type']) . '# ' . $ccnum_hidden;
				
				$sql_invoice = $ilance->db->query("
					SELECT *
					FROM " . DB_PREFIX . "invoices
					WHERE invoiceid = '" . intval($ilance->GPC['id']) . "'
						AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
					LIMIT 1
				");
				if ($ilance->db->num_rows($sql_invoice) > 0)
				{
					$res_invoice = $ilance->db->fetch_array($sql_invoice);
					
					$invoicetype = $res_invoice['invoicetype'];
					$description = stripslashes($res_invoice['description']);
				
					$transaction_fee_formatted = '';
					$transaction_fee = 0;

					$show['transactionfees'] = false;
					if ($ilconfig['cc_transaction_fee'] > 0 OR $ilconfig['cc_transaction_fee2'] > 0)
					{
						$txn_fee_hidden = '<input type="hidden" name="transaction_fee" value="'.sprintf("%01.2f", (($res_invoice['amount'] * $ilconfig['cc_transaction_fee']) +  $ilconfig['cc_transaction_fee2'])).'" />';
						$transaction_fee = sprintf("%01.2f", (($res_invoice['amount'] * $ilconfig['cc_transaction_fee']) + $ilconfig['cc_transaction_fee2']));
						$transaction_fee_formatted = ($ilconfig['cc_transaction_fee'] * 100) . '% + ' . $ilance->currency->format($ilconfig['cc_transaction_fee2']);
						
						$show['transactionfees'] = true;
					}
					
					$previewamount = $ilance->currency->format($res_invoice['amount']);
					$totalpreviewamount = $ilance->currency->format($res_invoice['amount'] + $transaction_fee);
					
					$taxlogic = '';
					
					// do we pay taxes?
					if ($res_invoice['istaxable'] > 0 AND $res_invoice['totalamount'] > 0)
					{
						$taxinfo = $res_invoice['taxinfo'];
			    
						// change regular amount to total amount (including added taxes)
						$amount = ($res_invoice['totalamount'] + $transaction_fee);
			    
						$totalpreviewamount = $ilance->currency->format($res_invoice['totalamount']+$transaction_fee);
						
						// create the tax bit in html
						if (!empty($taxinfo))
						{
							$taxlogic = '<tr><td align="right"> '.$phrase['_applicable_tax'].':</td><td align="left">'.$taxinfo.'</td></tr>';
						}
					}
					else
					{
						$amount = $res_invoice['amount'];
					}
					
					$createdate = print_date($res_invoice['createdate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 1, 0);
					
					$duedate = '--';
					if ($res_invoice['duedate'] != '0000-00-00 00:00:00')
					{
						$duedate = print_date($res_invoice['duedate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 1, 0);
					}
					
					$paiddate = '--';
					if ($res_invoice['paiddate'] != '0000-00-00 00:00:00')
					{
						$paiddate = print_date($res_invoice['paiddate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 1, 0);
					}
				}				
				
				$ilance->template->load_file('main', 'invoicepayment_preview.html');
				$ilance->template->parse_hash('main', array('ilpage' => $ilpage));
				$ilance->template->parse_if_blocks('main');
				$ilance->template->pprint('main', array('taxlogic','directpaymentform','txn_fee_hidden','totalpreviewamount','previewamount','payment_method','invoiceid','invoicetype','description','amount','amountpaid','createdate','duedate','paiddate','custommessage','transaction_fee_formatted','account_id','ip','referer','transaction_fee_notice','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
				exit();
			}
		}
	}
	
	// #### INVOICE PAYMENT HANDLER ########################################
	else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_do-invoice-payment' AND isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0 AND isset($ilance->GPC['amount']) AND isset($ilance->GPC['account_id']) AND isset($ilance->GPC['invoicetype']))
	{
		// #### SUBSCRIPTION PAYMENTS HANDLER ##########################
		switch ($ilance->GPC['invoicetype'])
		{
			case 'subscription':
			{
				// #### PAYMENT VIA ONLINE ACCOUNT #####################
			
				$ilance->subscription = construct_object('api.subscription');
				
				if ($ilance->GPC['account_id'] == 'account')
				{				
					$ilance->subscription->payment($_SESSION['ilancedata']['user']['userid'], intval($ilance->GPC['id']), 'account');
					exit();
				}
				break;
			}
			// #### ESCROW PAYMENT HANDLER #########################
			case 'escrow':
			{
				// #### PAYMENT VIA ONLINE ACCOUNT #############
			
				$ilance->escrow = construct_object('api.escrow');
				
				if ($ilance->GPC['account_id'] == 'account' AND $ilconfig['escrowsystem_enabled'])
				{
					$ilance->escrow->payment($_SESSION['ilancedata']['user']['userid'], intval($ilance->GPC['id']), 'escrow', $ilance->GPC['amount'], 'account');
					exit();
				}
				break;
			}
			// #### DEBIT OR COMMISSION HANDLER ####################
			case 'commission':
			case 'debit':
			{
				// #### PAYMENT VIA ONLINE ACCOUNT #####################
			
				$ilance->accounting = construct_object('api.accounting');
				
				if (isset($ilance->GPC['account_id']) AND $ilance->GPC['account_id'] == 'account')
				{
					$ilance->accounting->process_debit_payment($_SESSION['ilancedata']['user']['userid'], intval($ilance->GPC['id']), $ilance->GPC['invoicetype'], $ilance->GPC['amount'], 'account');
					exit();
				}
				break;
			}
			// #### PROVIDER GENERATE INVOICE TO BUYER HANDLER #####
			case 'p2b':
			{
				// #### PAYMENT VIA ONLINE ACCOUNT #####################			
				$ilance->accounting = construct_object('api.accounting');
				
				if ($ilance->GPC['account_id'] == 'account')
				{
					$ilance->accounting->process_p2b_payment($_SESSION['ilancedata']['user']['userid'], intval($ilance->GPC['id']), $ilance->GPC['invoicetype'], $ilance->GPC['amount'], 'account');
					exit();
				}
				break;
			}
		}
	}
	
	// #### DETAILED TRANSACTION VIEW ##############################
	else
	{
		$txn = $securekey_hidden = '';
		$id  = 0;
                
		if (isset($uncrypted['id']) AND $uncrypted['id'] > 0)
		{
			$id  = intval($uncrypted['id']);
		}
		else if (isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0)
		{
			$id  = intval($ilance->GPC['id']);
		}
		else if (isset($uncrypted['txn']) AND $uncrypted['txn'] != '')
		{
			$txn = $uncrypted['txn'];
		}
		else if (isset($ilance->GPC['txn']) AND $ilance->GPC['txn'] != '')
		{
			$txn  = $ilance->GPC['txn'];
		}
		else
		{
			$area_title = $phrase['_invoice_payment_menu_denied_payment'];
			$page_title = SITE_NAME . ' - ' . $phrase['_invoice_payment_menu_denied_payment'];
			
			print_notice($phrase['_invoice_error'], $phrase['_were_sorry_this_invoice_does_not_exist'] . "<br /><br />" . $phrase['_please_contact_customer_support'], $ilpage['accounting'], $phrase['_my_account']);
			exit();
		}
                
                ($apihook = $ilance->api('invoicepayment_start')) ? eval($apihook) : false;
	
		if (!empty($txn))
		{
			$sql_invoice = $ilance->db->query("
				SELECT *
				FROM " . DB_PREFIX . "invoices
				WHERE transactionid = '" . $ilance->db->escape_string($txn) . "'
					AND (user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "' OR p2b_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "')
			");
		    
			$sqlinvoice = $ilance->db->query("
				SELECT *
				FROM " . DB_PREFIX . "invoices
				WHERE transactionid = '" . $ilance->db->escape_string($txn) . "'
					AND (user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "' OR p2b_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "')
			");
			if ($ilance->db->num_rows($sqlinvoice) > 0)
			{
				$res = $ilance->db->fetch_array($sqlinvoice);
				$id = $res['invoiceid'];
                        }
                        
			$securekey_hidden .= '<input type="hidden" name="id" value="' . $id . '" />';
			$securekey_hidden .= '<input type="hidden" name="txn" value="' . $txn . '" />';
		}
		else if (isset($id) AND $id > 0)
		{
			$sql_invoice = $ilance->db->query("
				SELECT *
				FROM " . DB_PREFIX . "invoices
				WHERE invoiceid = '" . intval($id) . "'
					AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
			");
		    
			$sqlinvoice = $ilance->db->query("
				SELECT *
				FROM " . DB_PREFIX . "invoices
				WHERE invoiceid = '" . intval($id) . "'
					AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
			");
			if ($ilance->db->num_rows($sqlinvoice) > 0)
			{
				$res = $ilance->db->fetch_array($sqlinvoice);
				$txn = $res['transactionid'];
			}
                        
			$securekey_hidden .= '<input type="hidden" name="id" value="' . $id . '" />';
			$securekey_hidden .= '<input type="hidden" name="txn" value="' . $txn . '" />';
		}
	
		// are we viewing or paying this invoice?
		if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'view')
		{
			// we are viewing payment / saving as csv, pdf, etc.
			$headtitle = $phrase['_review_invoice_details'] . ' (' . $id . ')';
			$headmessage = $phrase['_you_can_review_download_and_print_this_invoice_page_for_your_records'];
		}
		else
		{
			// we are making payment
			$headtitle = $phrase['_secure_payment_preview'];
			$headmessage = $phrase['_make_a_secure_payment_using_our_billing'];
		}
		
		$area_title = $phrase['_invoice_payment_menu'] . ' #' . $txn;
		$page_title = SITE_NAME . ' - ' . $phrase['_invoice_payment_menu'];
		
		$navcrumb = array();
		$navcrumb["$ilpage[accounting]"] = $phrase['_accounting'];
		$navcrumb[""] = $phrase['_transaction'] . ' #' . $txn;
		
		if ($ilance->db->num_rows($sql_invoice) > 0)
		{
			$show['invoicecancelled'] = 0;
                        
			$res_invoice = $ilance->db->fetch_array($sql_invoice);
			if ($res_invoice['status'] == 'unpaid' OR $res_invoice['status'] == 'scheduled')
			{
                                if ($res_invoice['p2b_user_id'] == $_SESSION['ilancedata']['user']['userid'])
                                {
                                        $show['paymentpulldown'] = 0;
                                        $cmd = '_do-invoice-action';
                                }
                                else if ($res_invoice['user_id'] == $_SESSION['ilancedata']['user']['userid'])
                                {
                                        $show['paymentpulldown'] = 1;
                                        $cmd = '_do-invoice-preview';
                                }
			}
			else if ($res_invoice['status'] == 'cancelled')
			{
				$show['invoicecancelled'] = 1;
			}
			else
			{
				$show['paymentpulldown'] = 0;
				$cmd = '_do-invoice-action';
			}
                        
                        $paymethod = ucwords($res_invoice['paymethod']);
                        $paystatus = ucwords($res_invoice['status']);
                        $providername = $phrase['_billing_and_payments'];
                        $provider = SITE_NAME;
                        $providerinfo = SITE_ADDRESS;
                        
                        $show['viewingasprovider'] = $show['escrowblock'] = false;
                        
			if ($res_invoice['invoicetype'] == 'subscription')
			{
				$show['providerblock'] = false;
				$customer = fetch_user('username', $res_invoice['user_id']);
				$invoicetype = print_transaction_type($res_invoice['invoicetype']);
				$customerinfo = print_shipping_address_text($res_invoice['user_id']) . fetch_business_numbers($res_invoice['user_id']);
				$customername = fetch_user('fullname', $res_invoice['user_id']);
			}
			else if ($res_invoice['invoicetype'] == 'commission')
			{
				$show['providerblock'] = false;
				$customer = fetch_user('username', $res_invoice['user_id']);
				$invoicetype = print_transaction_type($res_invoice['invoicetype']);
				$customerinfo = print_shipping_address_text($res_invoice['user_id']) . fetch_business_numbers($res_invoice['user_id']);
				$customername = fetch_user('fullname', $res_invoice['user_id']);
			}
			else if ($res_invoice['invoicetype'] == 'p2b')
			{
				$show['providerblock'] = true;
				$customer = fetch_user('username', $res_invoice['user_id']);
				$provider = fetch_user('username', $res_invoice['p2b_user_id']);
				$invoicetype = $phrase['_generated_invoice'];
				$customerinfo = print_shipping_address_text($res_invoice['user_id']) . fetch_business_numbers($res_invoice['user_id']);
				$providerinfo = print_shipping_address_text($res_invoice['p2b_user_id']) . fetch_business_numbers($res_invoice['p2b_user_id']);
				$customername = fetch_user('fullname', $res_invoice['user_id']);
				$providername = fetch_user('fullname', $res_invoice['p2b_user_id']);
                                $paymethod = $res_invoice['p2b_paymethod'];
                                
                                if ($res_invoice['p2b_user_id'] == $_SESSION['ilancedata']['user']['userid'])
                                {
                                        $show['viewingasprovider'] = true;
                                        
                                        $crypted = array(
                                                'cmd' => 'p2baction',
                                                'subcmd' => 'markaspaid',
                                                'invoiceid' => $res_invoice['invoiceid'],
                                                'txn' => $res_invoice['transactionid'],
                                        );
                                        
                                        $markedaspaidurl = HTTPS_SERVER . $ilpage['invoicepayment'] . '?crypted=' . encrypt_url($crypted);
                                        unset($crypted);
                                        
                                        $crypted = array(
                                                'cmd' => 'p2baction',
                                                'subcmd' => 'markasunpaid',
                                                'invoiceid' => $res_invoice['invoiceid'],
                                                'txn' => $res_invoice['transactionid'],
                                        );
                                        
                                        $markedasunpaidurl = HTTPS_SERVER . $ilpage['invoicepayment'] . '?crypted=' . encrypt_url($crypted);
                                        unset($crypted);
                                        
                                        $crypted = array(
                                                'cmd' => 'p2baction',
                                                'subcmd' => 'markascancelled',
                                                'invoiceid' => $res_invoice['invoiceid'],
                                                'txn' => $res_invoice['transactionid'],
                                        );
                                        
                                        $markedascancelledurl = HTTPS_SERVER . $ilpage['invoicepayment'] . '?crypted=' . encrypt_url($crypted);
                                        unset($crypted);
                                }
                                
                                if (empty($res_invoice['p2b_paymethod']) OR $res_invoice['p2b_paymethod'] == '')
                                {
                                        $paymethod = $phrase['_contact_trading_partner'];
                                }
			}
			else if ($res_invoice['invoicetype'] == 'buynow')
			{
				$show['providerblock'] = true;
				$customer = fetch_user('username', $res_invoice['user_id']);
				$provider = fetch_user('username', $res_invoice['p2b_user_id']);
				$invoicetype = print_transaction_type($res_invoice['invoicetype']);
				$customerinfo = print_shipping_address_text($res_invoice['user_id']) . fetch_business_numbers($res_invoice['user_id']);
				$providerinfo = print_shipping_address_text($res_invoice['p2b_user_id']) . fetch_business_numbers($res_invoice['p2b_user_id']);
				$customername = fetch_user('fullname', $res_invoice['user_id']);
				$providername = fetch_user('fullname', $res_invoice['p2b_user_id']);
			}
			else if ($res_invoice['invoicetype'] == 'credential')
			{
				$show['providerblock'] = false;
				$customer = fetch_user('username', $res_invoice['user_id']);
				$invoicetype = print_transaction_type($res_invoice['invoicetype']);
				$customerinfo = print_shipping_address_text($res_invoice['user_id']) . fetch_business_numbers($res_invoice['user_id']);
				$customername = fetch_user('fullname', $res_invoice['user_id']);
			}
			else if ($res_invoice['invoicetype'] == 'debit')
			{
				$show['providerblock'] = false;
				$customer = fetch_user('username', $res_invoice['user_id']);
				$invoicetype = print_transaction_type($res_invoice['invoicetype']);
				$customerinfo = print_shipping_address_text($res_invoice['user_id']) . fetch_business_numbers($res_invoice['user_id']);
				$customername = fetch_user('fullname', $res_invoice['user_id']);
			}
			else if ($res_invoice['invoicetype'] == 'credit')
			{
				$show['providerblock'] = false;
				$customer = fetch_user('username', $res_invoice['user_id']);
				$invoicetype = print_transaction_type($res_invoice['invoicetype']);
				$customerinfo = print_shipping_address_text($res_invoice['user_id']) . fetch_business_numbers($res_invoice['user_id']);
				$customername = fetch_user('fullname', $res_invoice['user_id']);
			}
			else if ($res_invoice['invoicetype'] == 'escrow')
			{
				// escrow handling
				$show['providerblock'] = true;
                                $show['escrowblock'] = true;
				
				// quick auction checkup
				$sql_auction = $ilance->db->query("
					SELECT *
					FROM " . DB_PREFIX . "projects
					WHERE project_id = '" . $res_invoice['projectid'] . "'
					LIMIT 1
				");
				if ($ilance->db->num_rows($sql_auction) == 0)
				{
                                        $area_title = $phrase['_invoice_payment_menu_denied_payment'];
                                        $page_title = SITE_NAME . ' - ' . $phrase['_invoice_payment_menu_denied_payment'];
					
                                        print_notice($phrase['_invoice_error'], $phrase['_were_sorry_this_invoice_does_not_exist']."<br /><br />".$phrase['_please_contact_customer_support'], $ilpage['accounting'], $phrase['_my_account']);
                                        exit();
				}
				
				$ilance->auction = construct_object('api.auction');
				$ilance->escrow = construct_object('api.escrow');
				
				if ($ilance->auction->fetch_auction_type($res_invoice['projectid']) == 'service')
				{
                                        // buyer is about to pay service escrow invoice to service provider escrow account held by site owner
                                        $customer = $ilance->escrow->fetch_escrow_owner($res_invoice['projectid'], $res_invoice['invoiceid'], 'service');
                                        $provider = $ilance->escrow->fetch_escrow_opponent($res_invoice['projectid'], $res_invoice['invoiceid'], 'service');
                                        $customerinfo = print_shipping_address_text(fetch_user('user_id', '', $customer)) . fetch_business_numbers(fetch_user('user_id', '', $customer));
                                        $providerinfo = print_shipping_address_text(fetch_user('user_id', '', $provider)) . fetch_business_numbers(fetch_user('user_id', '', $provider));
                                        $customername = fetch_user('fullname', fetch_user('user_id', '', $customer));
                                        $providername = fetch_user('fullname', fetch_user('user_id', '', $provider));
				}
				else if ($ilance->auction->fetch_auction_type($res_invoice['projectid']) == 'product')
				{
                                        // bidder/winner is about to pay product escrow invoice to merchant provider held by site owner
                                        $customer = $ilance->escrow->fetch_escrow_opponent($res_invoice['projectid'], $res_invoice['invoiceid'], 'product');
                                        $provider = $ilance->escrow->fetch_escrow_owner($res_invoice['projectid'], $res_invoice['invoiceid'], 'product');
                                        $customerinfo = print_shipping_address_text(fetch_user('user_id', '', $customer)) . fetch_business_numbers(fetch_user('user_id', '', $customer));
                                        $providerinfo = print_shipping_address_text(fetch_user('user_id', '', $provider)) . fetch_business_numbers(fetch_user('user_id', '', $provider));
                                        $customername = fetch_user('fullname', fetch_user('user_id', '', $customer));
                                        $providername = fetch_user('fullname', fetch_user('user_id', '', $provider));
				}
						
				// display invoice type on invoice payment form
				$invoicetype = print_transaction_type($res_invoice['invoicetype']);
			}
		
                        // transaction description
                        $description = stripslashes($res_invoice['description']);
                        
                        // transaction identifier
                        $transactionid = $res_invoice['transactionid'];
                        
                        // comments left by invoicer / receiver
                        $comments = stripslashes($res_invoice['custommessage']);
                        
                        // invoice amount
                        $amount = $ilance->currency->format($res_invoice['amount']);
                        
                        // total invoice amount (after taxes what customer will pay)
                        $show['taxes'] = 0;
                        if ($res_invoice['istaxable'])
                        {
				$totalamount = $ilance->currency->format(($res_invoice['amount'] + $res_invoice['taxamount']));
				$show['taxes'] = 1;
			}
			else
			{
				$totalamount = $ilance->currency->format($res_invoice['amount']);
			}
            
			// total amount paid for this invoice
			$amountpaid = $ilance->currency->format($res_invoice['paid']);
			
			// invoice creation date
			$createdate = print_date($res_invoice['createdate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);

			// invoice due date
			if ($res_invoice['duedate'] == "0000-00-00 00:00:00")
			{
				$duedate = '--';		
			}
			else
			{
				$duedate = print_date($res_invoice['duedate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
			}
			// invoice paid date
			if ($res_invoice['paiddate'] == "0000-00-00 00:00:00")
			{
				$paiddate = '--';
			}
			else
			{
				$paiddate = print_date($res_invoice['paiddate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
			}
                        
			// custom invoice message
			$custommessage = stripslashes($res_invoice['custommessage']);
			$show['comments'] = 1;
			if (empty($custommessage))
			{
				$show['comments'] = 0;
			}
                        
                        $show['listing'] = 0;
                        $project_id = 0;
			if ($res_invoice['projectid'] > 0)
			{
				$show['listing'] = 1;
                                $listing = fetch_auction('project_title', $res_invoice['projectid']);
                                $project_id = $res_invoice['projectid'];
			}
			
			// invoice identifier
			$invoiceid = $id;

			// payment method pulldown
			$payment_method_pulldown = print_paymethod_pulldown('invoicepayment', 'account_id', $_SESSION['ilancedata']['user']['userid']);
			
			// tax information
			$taxinfo = $res_invoice['taxinfo'];
			$taxamount = $ilance->currency->format($res_invoice['taxamount']);
			
			$show['ispaid'] = $show['isunpaid'] = $show['isscheduled'] = $show['iscomplete'] = $show['iscancelled'] = 0;
			
			if ($res_invoice['status'] == 'paid')
			{
				$show['ispaid'] = 1;
			}
			if ($res_invoice['status'] == 'unpaid')
			{
				$show['isunpaid'] = 1;
			}
			if ($res_invoice['status'] == 'scheduled')
			{
				$show['isscheduled'] = 1;
			}
			if ($res_invoice['status'] == 'complete')
			{
				$show['iscomplete'] = 1;
			}
			if ($res_invoice['status'] == 'cancelled')
			{
				$show['iscancelled'] = 1;
			}			
			if ($res_invoice['invoicetype'] == 'subscription')
			{
				$show['subscriptionpayment'] = true;
			}
			else
			{
				$show['subscriptionpayment'] = false;
			}
                        
                        $pprint_array = array('project_id','paystatus','markedascancelledurl','markedaspaidurl','markedasunpaidurl','paymethod','listing','headtitle','headmessage','cmd','customername','providername','customerinfo','providerinfo','totalamount','taxinfo','taxamount','transactionid','comments','provider','customer','payment_method_pulldown','invoiceid','invoicetype','description','amount','amountpaid','createdate','duedate','paiddate','custommessage','securekey_hidden','countdrafts','countarchived','rfpescrow','rfpvisible','countdelisted','prevnext','input_style','redirect','referer','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
                        
                        ($apihook = $ilance->api('invoicepayment_end')) ? eval($apihook) : false;
			
			$ilance->template->load_file('main', 'invoicepayment.html');
			$ilance->template->parse_hash('main', array('ilpage' => $ilpage));
			$ilance->template->parse_if_blocks('main');
			$ilance->template->pprint('main', $pprint_array);
			exit();
		}
		else
		{
			$area_title = $phrase['_invoice_payment_menu_denied_payment'];
			$page_title = SITE_NAME . ' - ' . $phrase['_invoice_payment_menu_denied_payment'];
			
			print_notice($phrase['_invoice_error'], $phrase['_were_sorry_this_invoice_does_not_exist']."<br /><br />".$phrase['_please_contact_customer_support'], $ilpage['accounting'], $phrase['_my_account']);
			exit();
		}
	}
}
else
{
	refresh($ilpage['login'] . '?redirect=' . urlencode($ilpage['invoicepayment'] . print_hidden_fields($string = true, $excluded = array(), $questionmarkfirst = true)));
	exit();
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: invoicepayment,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>