<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

// #### load required phrase groups ############################################
$phrase['groups'] = array(
        'wantads',
        'search',
        'feedback',
        'lancebb',
        'buying',
        'selling',
        'accounting',
        'rfp'
);

// #### load required javascript ###############################################
$jsinclude = array(
        'mootools'
);

// #### setup script location ##################################################
define('LOCATION','main');

// #### require backend ########################################################
require_once('./functions/config.php');

// #### setup default breadcrumb ###############################################
$navcrumb = array("$ilpage[main]" => $ilcrumbs["$ilpage[main]"]);

$ilance->categories_parser = construct_object('api.categories_parser');        
$ilance->auction = construct_object('api.auction');
$ilance->bid = construct_object('api.bid');
$ilance->bid_lowest_unique = construct_object('api.bid_lowest_unique');

// #### SEO related ############################################################
$seoproductcategories = print_seo_url($ilconfig['productcatmapidentifier']);
$seoservicecategories = print_seo_url($ilconfig['servicecatmapidentifier']);
$seolistings = print_seo_url($ilconfig['listingsidentifier']);
$seocategories = print_seo_url($ilconfig['categoryidentifier']);

// #### MEMBERS CONTROL PANEL DASHBOARD ########################################
if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'cp')
{
        // #### define top header nav ##########################################
        $topnavlink = array(
                'dashboard'
        );

        $show['widescreen'] = true;
        
        if (isset($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
        {
                $area_title = $phrase['_member_control_panel'];
                $page_title = SITE_NAME . ' - ' . $phrase['_member_control_panel'];
                
                // construct breadcrumb trail
                $navcrumb = array();
                $navcrumb[""] = $phrase['_my_control_panel'];
        
                $ilance->mycp = construct_object('api.mycp');
                $ilance->subscription = construct_object('api.subscription');
                $ilance->calendar = construct_object('api.calendar');
                $ilance->calendar->generate_calendar(date('Y'), date('m'), date('d'));
                $ilance->calendar->setTableWidth('100%');
                $ilance->calendar->setDayNameFormat('%A');
                
                ($apihook = $ilance->api('main_cp')) ? eval($apihook) : false;
                
                // until we figure out the best method to use for the calendar widget, it will be temporarily disabled. -Peter
                //$ilance->calendar->addEvent('21', 'Invoice for Escrow Account #12090239', '');
                //$ilance->calendar->addEvent('23', 'test', 'test');
                
                $mycalendar = '
                <div class="block-wrapper">

                        <div class="block">
                        
                                <div class="block-top">
                                        <div class="block-right">
                                                <div class="block-left"></div>
                                        </div>
                                </div>
                                
                                <div class="block-header">My Calendar &amp; Events</div>
                                <div class="block-content-yellow" style="padding:9px"><div class="smaller">For the month of <strong>' . $ilance->calendar->getFullMonthName() . ' ' . date('Y') . '</strong></div></div>
                                <div class="block-content" style="padding:0px">
                                        
                                <table cellpadding="9" cellspacing="1" border="0" width="100%" align="center">
                                ' . $ilance->calendar->display() . '
                                </table>
                                        
                                </div>
                                
                                <div class="block-footer">
                                        <div class="block-right">
                                                <div class="block-left"></div>
                                        </div>
                                </div>
                                        
                        </div>
                </div>';
        
                $mycalendar = '';
        
                $ilance->GPC['period'] = isset($ilance->GPC['period']) ? intval($ilance->GPC['period']) : '7';
        
                $messagesactivity = $ilance->mycp->fetch_unread_messages($_SESSION['ilancedata']['user']['userid']);
                //$accountingactivity = $ilance->mycp->accounting_activity($_SESSION['ilancedata']['user']['userid']);
                
                $breminder = $sreminder = '';

                // #### buying reminders panel #################################
                $breminder .= $ilance->mycp->bids_award_activity($_SESSION['ilancedata']['user']['userid'], 'buying', 'service', $ilance->GPC['period']); 
                $breminder .= $ilance->mycp->bids_award_activity($_SESSION['ilancedata']['user']['userid'], 'buying', 'product', $ilance->GPC['period']);
                $breminder .= $ilance->mycp->bids_activity($_SESSION['ilancedata']['user']['userid'], 'buying', $ilance->GPC['period']);
                $breminder .= $ilance->mycp->unpaid_p2b_activity($_SESSION['ilancedata']['user']['userid'], 'buying', $ilance->GPC['period']);
                $breminder .= ($ilconfig['escrowsystem_enabled']) ? $ilance->mycp->escrow_activity($_SESSION['ilancedata']['user']['userid'], 'buying', $ilance->GPC['period']) : '';
                
                ($apihook = $ilance->api('main_mycp_buying_reminders')) ? eval($apihook) : false;
                
                // #### selling reminders panel ################################
                $sreminder .= $ilance->mycp->bids_award_activity($_SESSION['ilancedata']['user']['userid'], 'selling', 'service', $ilance->GPC['period']);
                $sreminder .= $ilance->mycp->bids_award_activity($_SESSION['ilancedata']['user']['userid'], 'selling', 'product', $ilance->GPC['period']);
                $sreminder .= $ilance->mycp->bids_activity($_SESSION['ilancedata']['user']['userid'], 'selling', $ilance->GPC['period']);
                $sreminder .= $ilance->mycp->unpaid_p2b_activity($_SESSION['ilancedata']['user']['userid'], 'selling', $ilance->GPC['period']);
                $sreminder .= ($ilconfig['escrowsystem_enabled']) ? $ilance->mycp->escrow_activity($_SESSION['ilancedata']['user']['userid'], 'selling', $ilance->GPC['period']) : '';
                
                ($apihook = $ilance->api('main_mycp_selling_reminders')) ? eval($apihook) : false;
                
                // invited to auction activity
                $invitationactivity = $ilance->mycp->invitation_activity($_SESSION['ilancedata']['user']['userid']);
                
                // feedback activity
                $feedbackactivity = $ilance->mycp->feedback_activity($_SESSION['ilancedata']['user']['userid']);
                
                // referral activity
                $referalactivity = $ilance->mycp->referal_activity($_SESSION['ilancedata']['user']['userid']);
                $ridlink = HTTP_SERVER . $ilpage['main'] . '?rid=' . $_SESSION['ilancedata']['user']['ridcode'];
                
                // bids left today
                $bidtotal = $ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'bidlimitperday');
                $bidsleft = max(0, ($bidtotal - fetch_bidcount_today($_SESSION['ilancedata']['user']['userid'])));        
                $datereset = print_date($ilance->datetime->fetch_datetime_from_timestamp($ilance->db->fetch_field(DB_PREFIX . "cron", "varname = 'dailyrfp'", 'nextrun')), $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
                
                // $wantadsactivity = $ilance->mycp->wantads_activity($_SESSION['ilancedata']['user']['userid']);
                
                if (!empty($sreminder))
                {
                        $sellingreminders = mb_substr($sreminder, 0, -50);
                }
                else
                {
                        $sellingreminders = '<div class="gray">' . $phrase['_no_activity_found'] . '</div>';        
                }
                
                if (!empty($breminder))
                {
                        $buyingreminders = mb_substr($breminder, 0, -50);
                }
                else
                {
                        $buyingreminders = '<div class="gray">' . $phrase['_no_activity_found'] . '</div>';        
                }
                
                if (!empty($feedbackactivity))
                {
                        $feedbackactivity = mb_substr($feedbackactivity, 0, -50);   
                }
                else
                {
                        $feedbackactivity = '<div class="gray">' . $phrase['_no_feedback_activity_found'] . '</div>';
		}
                
                unset($sreminder, $breminder);
                
                $unpaidinvoices = '0';
                $unpaidamount = $ilance->currency->format(0);
                $subscriptiondaysleft = '30';
                $subscriptionexpirydate = 'xxx xxx';
                
                $flashstats = print_flash_stats('referrals', 'stats');
                
                $pprint_array = array('subscriptiondaysleft','subscriptionexpirydate','unpaidinvoices','unpaidamount','flashstats','sellingreminders','buyingreminders','datereset','bidsleft','bidsawardactivity','ridlink','referalactivity','invitationactivity','wantadsactivity','storefrontactivity','feedbackactivity','bidsactivity','escrowactivity','accountingactivity','messagesactivity','mycalendar','main_servicecats','main_productcats','lanceads_folder','profiles_created_count','escrow_deposit_count','sub_payments_count','two_column_category_buyers','two_column_service_categories','two_column_category_products','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
                
                ($apihook = $ilance->api('main_mycp_end')) ? eval($apihook) : false;
                
                $ilance->template->fetch('main', 'main_mycp.html', 0, 1);
                $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                $ilance->template->parse_if_blocks('main');
                $ilance->template->pprint('main', $pprint_array);
                exit();
        }
        else
        {
                refresh($ilpage['login'], HTTPS_SERVER . $ilpage['login']);
                exit();
        }
}

// #### BUYING SERVICES LANDING PAGE ###########################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'buying')
{
        // #### define top header nav ##########################################
        $topnavlink = array(
                'main_buying'
        );
        
        $area_title = $phrase['_buying_products_and_services'];
        $page_title = $phrase['_buy'] . ' &gt; ' . SITE_NAME;
    
        $navcrumb = array();
        $navcrumb[""] = $phrase['_buy'];
        
        $ilance->auction_post = construct_object('api.auction_post');
        $ilance->subscription = construct_object('api.subscription');
        
        $categoryresults = $category = '';
        
        if ($ilconfig['globalauctionsettings_productauctionsenabled'] OR $ilconfig['globalauctionsettings_serviceauctionsenabled'])
        {
                $categorycache = $ilance->categories->build_array($cattype = 'product', $_SESSION['ilancedata']['user']['slng'], $mode = 0, $propersort = true);
                $categoryresults = $ilance->categories_parser->print_subcategory_columns($columns = 4, $cattype = 'product', $dosubcats = 1, $_SESSION['ilancedata']['user']['slng'], 0, $extra = '', $ilconfig['globalfilters_enablecategorycount'], $iscatmap = 1, $titlestyle = 'font-weight: bold;', $ilconfig['globalauctionsettings_catmapdepth'], $categorycache);
                unset($categorycache);
        }
        
        $title = $ilance->auction_post->print_title_input();
        
        $pprint_array = array('recursivecategory','categoryresults','title','two_column_category_products','wantads_category_pulldown','js','two_column_category_products','two_column_category_vendors','session_project_title','rfp_category_left','rfp_category_js','prevnext','two_column_category_buyers','two_column_service_categories','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
        
        ($apihook = $ilance->api('main_buying')) ? eval($apihook) : false;        
    
        $ilance->template->fetch('main', 'buying.html');
        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
        $ilance->template->parse_loop('main', 'wantads');
        $ilance->template->parse_loop('main', 'featuredserviceauctions');
        $ilance->template->parse_loop('main', 'featuredproductauctions');
        $ilance->template->parse_if_blocks('main');
        $ilance->template->pprint('main', $pprint_array);
        exit();
}

// #### SELLING SERVICES LANDING PAGE ##########################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'selling')
{
        // #### define top header nav ##########################################
        $topnavlink = array(
                'main_selling'
        );
        
        $area_title = $phrase['_sell_products_and_services'];
        $page_title = $phrase['_sell'] . ' &gt; ' . SITE_NAME;
    
        $navcrumb = array();
        $navcrumb["$ilpage[main]?cmd=selling"] = $phrase['_sell'];
        $navcrumb[""] = 'Bulk';
        
        if (isset($ilance->GPC['mode']) AND $ilance->GPC['mode'] == 'bulk')
        {
                if (empty($_SESSION['ilancedata']['user']['userid']) OR $_SESSION['ilancedata']['user']['userid'] == 0)
                {
                        refresh(HTTPS_SERVER . $ilpage['login'] . '?redirect=' . urlencode($ilpage['main'] . print_hidden_fields($string = true, $excluded = array(), $questionmarkfirst = true)));
                        exit();
                }
        }
        
        $ilance->auction_post = construct_object('api.auction_post');
        $ilance->subscription = construct_object('api.subscription');
        
        if (isset($ilance->GPC['mode']) AND $ilance->GPC['mode'] == 'service' OR empty($ilance->GPC['mode']) AND $ilconfig['globalauctionsettings_productauctionsenabled'] == false)
        {
                $categoryresults = $category = '';
                
                if ($ilconfig['globalauctionsettings_serviceauctionsenabled'])
                {
                        $categorycache = $ilance->categories->build_array($cattype = 'service', $_SESSION['ilancedata']['user']['slng'], $mode = 0, $propersort = true);
                        $categoryresults = $ilance->categories_parser->print_subcategory_columns($columns = 4, $cattype = 'service', $dosubcats = 1, $_SESSION['ilancedata']['user']['slng'], 0, $extra = '', $ilconfig['globalfilters_enablecategorycount'], $iscatmap = 1, $titlestyle = 'font-weight: bold;', $ilconfig['globalauctionsettings_catmapdepth'], $categorycache);
                        unset($categorycache);
                }
        }
        
        $title = $ilance->auction_post->print_title_input();
        
        $columns = array('project_title', 'description', 'startprice', 'buynow_price', 'reserve_price', 'ship_costs', 'paymethod', 'cid', 'sample');
                
        $columnphrases = array(
                'project_title' => $phrase['_title'],
                'description' => $phrase['_description'],
                'startprice' => $phrase['_starting_price'],
                'buynow_price' => $phrase['_buy_now_price'],
                'reserve_price' => $phrase['_reserve_price'],
                'ship_costs' => $phrase['_shipping'],
                'paymethod' => $phrase['_payment_method'],
                'cid' => $phrase['_category_id'],
                'sample' => $phrase['_sample'],
        );
        
        $coloumncount = count($columns);
        
        if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'assign')
        {
                $show['widescreen'] = true;
                
                $navcrumb = array();
                $navcrumb["$ilpage[main]?cmd=selling"] = $phrase['_sell'];
                $navcrumb["$ilpage[main]?cmd=selling&mode=bulk"] = 'Bulk';
                $navcrumb[""] = $phrase['_preview'];
                
                $ilance->csv = construct_object('api.csv');
                
                if (empty($_FILES['csv_file']['name']))
                {
                        // print error about uploaded results.. nothing found!
                        print_notice($phrase['_invalid_bulk_import_file'], $phrase['_the_bulk_file_you_uploaded_was_not_correct_please_try_again'], 'javascript:history.go(-1)', $phrase['_retry']);
                        exit();        
                }
                else
                {
                        // check if the extension is valid (.csv only)
                        $extension = mb_strtolower(mb_strrchr($_FILES['csv_file']['name'], '.'));
                        if ($extension != '.csv')
                        {
                                print_notice($phrase['_invalid_file_extension'], $phrase['_the_bulk_file_you_uploaded_did_not_have_the_correct_file_extension'], 'javascript:history.go(-1)', $phrase['_retry']);
                                exit();         
                        }
                        
                }
                
                while (list($key, $value) = each($_FILES))
		{
			$GLOBALS[$key] = $value;
			foreach ($_FILES AS $key => $value)
			{
				$GLOBALS[$key] = $_FILES[$key]['tmp_name'];
				foreach ($value AS $ext => $value2)
				{
					$key2 = $key . '_' . $ext;
					$GLOBALS[$key2] = $value2;
				}
			}
		}
                
                $data = $ilance->csv->csv_import($csv_file, $columns);
                if (isset($data) AND is_array($data) AND count($data) > 0 AND !empty($csv_file))
                {
                        $dataencrypted = serialize($data);
                        $dataencrypted = base64_encode($dataencrypted);
                        
                        $response = $data['response'];
                        $arr = $data['array'];
                        
                        $itemuploadcount = count($arr);
                        
                        if ($itemuploadcount == 0 OR $itemuploadcount < 0)
                        {
                                // print error about uploaded results.. nothing found!
                                print_notice($phrase['_invalid_bulk_import_file'], $phrase['_the_bulk_file_you_uploaded_was_not_correct_please_try_again'], 'javascript:history.go(-1)', $phrase['_retry']);
                                exit();        
                        }
                        
                        if ($itemuploadcount > 0 AND $itemuploadcount > $ilconfig['globalfilters_bulkuploadlimit'])
                        {
                                // print error about uploaded results.. nothing found!
                                print_notice($phrase['_invalid_bulk_import_file'], $phrase['_it_appears_you_are_importing_more_listings_than_your_account_permits_which_is_currently'] . ': <strong>' . $ilconfig['globalfilters_bulkuploadlimit'] . '</strong>', 'javascript:history.go(-1)', $phrase['_retry']);
                                exit();        
                        }
                        
                        //print_r($arr); exit;
                        //$response .= '<p>' . $data['query'] . '</p>';
                        
                        $eachline = array();
                        $z = 1;
                        foreach ($arr AS $itemstring)
                        {
                                //if ($z < $coloumncount)
                                //{
                                        $eachitem = explode(',', $itemstring);
                                        $column = 1;
                                        foreach ($eachitem AS $itemcolumn)
                                        {
                                                $itemcolumn = str_replace('\\', '', $itemcolumn);
                                                $eachline[$column][$z] = str_replace("'", '', $itemcolumn);
                                                $column++;
                                        }
                                        $z++;
                                //}
                        }
                        
                        //print_r($eachline); exit;
                        $col = '<form name="ilform" method="post" action="' . $ilpage['main'] . '" accept-charset="UTF-8" style="margin:0px">';
                        $col .= '<input type="hidden" name="cmd" value="selling" />';
                        $col .= '<input type="hidden" name="mode" value="bulk" />';
                        $col .= '<input type="hidden" name="do" value="assign-preview" />';
                        $col .= '<input type="hidden" name="data" value="' . $dataencrypted . '" />';
                        $col .= '<table cellpadding="9" cellspacing="1" width="100%">';
                        $col .= '<tr class="alt2">';
                        for ($i = 1; $i <= $coloumncount; $i++)
                        {
                                $col .= '<td><div><select name="col[' . $i . ']" style="font-family: verdana" class="smaller"><option value="">-</option>';
                                foreach ($columns AS $key)
                                {
                                        if (isset($columnphrases["$key"]) AND !empty($columnphrases["$key"]))
                                        {
                                                $col .= '<option value="' . $key . '">' . $columnphrases["$key"] . '</option>';
                                        }
                                }
                                $col .= '</select></div></td>';
                        }

                        $col .= '</tr>';
                        
                        if (!isset($ilance->GPC['pp']) OR empty($ilance->GPC['pp']))
                        {
                                //$perpagelimit = $itemuploadcount;
                                $perpagelimit = 5;
                        }
                        else
                        {
                                if (isset($ilance->GPC['pp']) AND $ilance->GPC['pp'] <= 0)
                                {
                                        $perpagelimit = $itemuploadcount;
                                }
                                else
                                {
                                        $perpagelimit = intval($ilance->GPC['pp']);
                                }
                        }
                        
                        for ($y = 1; $y <= $itemuploadcount; $y++)
                        {
                                if ($y <= $perpagelimit)
                                {
                                        $col .= '<tr class="alt1">';
                                        for ($i = 1; $i <= $coloumncount; $i++)
                                        {
                                                
                                                        if ($i == 9) // picture/sample
                                                        {
                                                                if (empty($eachline[$i][$y]))
                                                                {
                                                                        $col .= '<td align="center">&nbsp;</td>';
                                                                }
                                                                else
                                                                {
                                                                        $col .= '<td align="center"><img src="' . $eachline[$i][$y] . '" width="60" height="50" border="0" alt="" id="" /></td>';
                                                                }
                                                        }
                                                        else
                                                        {
                                                                if (empty($eachline[$i][$y]))
                                                                {
                                                                        $col .= '<td>&nbsp;</td>';
                                                                }
                                                                else
                                                                {
                                                                        $col .= '<td>' . $eachline[$i][$y] . '</td>';
                                                                }
                                                        }
                                        }
                                        //$col .= '<td>$x</td></tr>';
                                        $col .= '</tr>';
                                }
                        }
                        $col .= '</table>';
                        $col .= '<div style="clear:both;"></div><div style="padding-top:9px; padding-bottom:25px"><span><input type="submit" value=" ' . $phrase['_continue'] . ' " style="font-size:15px" class="buttons" /></span></div>';
                        $col .= '</form>';
                }
                else
                {
                        // print error about uploaded results.. nothing found!
                        print_notice($phrase['_invalid_bulk_import_file'], $phrase['_the_bulk_file_you_uploaded_was_not_correct_please_try_again'], 'javascript:history.go(-1)', $phrase['_retry']);
                        exit();
                }
        }
        
        else if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'assign-preview')
        {
                $show['widescreen'] = true;
                
                $navcrumb = array();
                $navcrumb["$ilpage[main]?cmd=selling"] = $phrase['_sell'];
                $navcrumb["$ilpage[main]?cmd=selling&mode=bulk"] = 'Bulk';
                $navcrumb[""] = $phrase['_preview'];
                               
                //print_r($ilance->GPC); exit;
                
                // #### READ BULK SESSION FROM DATASTORE CACHE #################
                if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0 AND isset($ilance->GPC['bulksessionid']) AND !empty($ilance->GPC['bulksessionid']) AND $ilance->GPC['bulksessionid'] > 0)
                {
                        $sql = $ilance->db->query("
                                SELECT col, data, dateupload, visible, completed
                                FROM " . DB_PREFIX . "sessions_bulkupload
                                WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                        AND bulkid = '" . intval($ilance->GPC['bulksessionid']) . "'
                        ");
                        if ($ilance->db->num_rows($sql) > 0)
                        {
                                $res = $ilance->db->fetch_array($sql, DB_ASSOC);
                                
                                //print_r($res); exit;
                                
                                $res['col'] = base64_decode($res['col']);
                                $res['data'] = base64_decode($res['data']);
                                                             
                                if (is_serialized($res['data']))
                                {
                                        $ilance->GPC['data'] = unserialize($res['data']);
                                }
                                
                                if (is_serialized($res['col']))
                                {
                                        $ilance->GPC['col'] = unserialize($res['col']);
                                }
                                
                                $response = $ilance->GPC['data']['response'];
                                $arr = $ilance->GPC['data']['array'];
                                
                                $itemuploadcount = count($arr);
                                
                                $bulkid = intval($ilance->GPC['bulksessionid']);
                                
                                if (!isset($ilance->GPC['pp']) OR empty($ilance->GPC['pp']))
                                {
                                        $perpagelimit = $itemuploadcount;
                                }
                                else
                                {
                                        if (isset($ilance->GPC['pp']) AND $ilance->GPC['pp'] <= 0)
                                        {
                                                $perpagelimit = $itemuploadcount;
                                        }
                                        else
                                        {
                                                $perpagelimit = intval($ilance->GPC['pp']);
                                        }
                                }
                        }
                }
                
                // #### NEW BULK SESSION FROM USER UPLOADED CSV FILE ###########
                else
                {
                        $dataserialized = $ilance->GPC['data'];
                        $data = base64_decode($dataserialized);
                        if (is_serialized($data))
                        {
                                $data = unserialize($data);
                        }
                        $ilance->GPC['data'] = $data;
                        
                        $response = $ilance->GPC['data']['response'];
                        $arr = $ilance->GPC['data']['array'];
                        $itemuploadcount = count($arr);

                        $serializedcol = serialize($ilance->GPC['col']);
                        $serializedcol = base64_encode($serializedcol);
                        
                        // #### save upload session to database ########################
                        $ilance->db->query("
                                INSERT INTO " . DB_PREFIX . "sessions_bulkupload
                                (bulkid, user_id, col, data, dateupload, visible, completed)
                                VALUES(
                                NULL,
                                '" . $_SESSION['ilancedata']['user']['userid'] . "',
                                '" . $ilance->db->escape_string($serializedcol) . "',
                                '" . $ilance->db->escape_string($dataserialized) . "',
                                '" . DATETIME24H . "',
                                '1',
                                '0'
                                )
                        ");
                        
                        $bulkid = $ilance->db->insert_id();
                        
                        if (!isset($ilance->GPC['pp']) OR empty($ilance->GPC['pp']))
                        {
                                $perpagelimit = $itemuploadcount;
                        }
                        else
                        {
                                if (isset($ilance->GPC['pp']) AND $ilance->GPC['pp'] <= 0)
                                {
                                        $perpagelimit = $itemuploadcount;
                                }
                                else
                                {
                                        $perpagelimit = intval($ilance->GPC['pp']);
                                }
                        }
                }
               
                $ilance->auction = construct_object('api.auction');
                $ilance->auction_post = construct_object('api.auction_post');
                $ilance->auction_rfp = construct_object('api.auction_rfp');
                
                // #### duration code logic ####################################
                $duration = $ilance->auction_post->duration('duration', false);
		$durationbits = $ilance->auction_post->print_duration_logic('duration_unit', false);
                
                // #### sum of individual fees applied
                $insertiontotal = $buynowtotal = $reservetotal = 0;
                
                // #### listing enhancements ###################################
                //$enhancements = $ilance->auction_post->print_listing_enhancements('product', 'bulk');
                
                $eachline = array();
                $z = 1;
                foreach ($arr AS $itemstring)
                {
                        if ($z <= $perpagelimit)
                        {
                                $eachitem = explode(',', $itemstring);
                                $column = 1;
                                foreach ($eachitem AS $itemcolumn)
                                {
                                        $itemcolumn = str_replace('\\', '', $itemcolumn);
                                        $eachline[$column][$z] = str_replace("'", '', $itemcolumn);
                                        $column++;
                                }
                                $z++;
                        }
                }
                unset($z);
                
                // #### column titles ##########################################
                $col = '';
                $col .= '<table cellpadding="9" cellspacing="1" width="100%">';
                $col .= '<tr class="alt2">';
                if (isset($ilance->GPC['col']) AND !empty($ilance->GPC['col']) AND is_array($ilance->GPC['col']))
                {
                        $empty = $notempty = 0;
                        foreach ($ilance->GPC['col'] AS $key => $field)
                        {
                                if (empty($field))
                                {
                                        $empty++;
                                }
                                else
                                {
                                        $col .= '<td><div>' . $columnphrases["$field"] . '</div></td>';
                                        $identifier["$key"] = $field;
                                        $notempty++;
                                }
                        }
                        //$col .= '<td><div>Enhance</div></td>';
                }
                $col .= '</tr>';
                
                // seller must have required fields selected from the pulldown
                $passrequirement = false;
                if (isset($identifier) AND !empty($identifier) AND is_array($identifier))
                {
                        if (in_array('project_title', $identifier) AND in_array('description', $identifier) AND in_array('startprice', $identifier) AND in_array('ship_costs', $identifier) AND in_array('paymethod', $identifier) AND in_array('cid', $identifier))
                        {
                                $passrequirement = true;
                        }
                }
                
                if ($passrequirement == false)
                {
                        print_notice('You did not assign required pulldown fields', 'Sorry, you must re-upload your CSV file and select the proper columns assigned to your data from the pulldown menus.  Required fields you must select from the pulldown menu include Title, Description, Starting Price, Shipping Cost, Payment Method and Category ID.<br /><br />Optional fields include Buy Now Price, Reserve Price and Photo/Sample.', $ilpage['main'] . '?cmd=selling&mode=bulk', $phrase['_back']);
                        exit();
                }
                
                // #### results ################################################
                $ilance->categories->build_array('product', $_SESSION['ilancedata']['user']['slng'], 0, true);
                
                $startingprice = $reserveprice = $buynowprice = $sumfees = $canpost = 0;
                $z = 1;
                for ($y = 1; $y <= $itemuploadcount; $y++)
                {
                        if ($z <= $perpagelimit)
                        {
                                for ($g = 1; $g <= $coloumncount; $g++)
                                {
                                        if ($identifier[$g] == 'cid')
                                        {
                                                if ($eachline[$g][$y] > 0)
                                                {
                                                        //echo $startingprice; 
                                                        // determine if we can post into this selected category
                                                        $canpost = $ilance->categories->can_post($_SESSION['ilancedata']['user']['slng'], 'product', $eachline[$g][$y]);
                                                }
                                        }
                                }
                                
                                $fontclass1 = ($canpost) ? 'blue'   : 'red';
                                $fontclass2 = ($canpost) ? 'gray'   : 'red';
                                $fontclass3 = ($canpost) ? 'green'  : 'red';
                                $fontclass4 = ($canpost) ? 'purple' : 'red';
                                
                                // enhancement/checkbox column
                                $col .= '<tr class="alt1">';
                                
                                for ($i = 1; $i <= $coloumncount; $i++)
                                {
                                        if ($identifier[$i] == 'cid')
                                        {
                                                if ($eachline[$i][$y] > 0)
                                                {
                                                        //echo $startingprice; 
                                                        // determine if we can post into this selected category
                                                        //$canpost = $ilance->categories->can_post($_SESSION['ilancedata']['user']['slng'], 'product', $eachline[$i][$y]);
                                                        if ($canpost)
                                                        {
                                                                // check for category insertion fees
                                                                if ($reserveprice > $startingprice)
                                                                {
                                                                        $startingprice = $reserveprice;
                                                                }
                                                                
                                                                if ($buynowprice > $startingprice)
                                                                {
                                                                        $startingprice = $buynowprice;
                                                                }
                                                                
                                                                $insertionfees = $ilance->auction_rfp->calculate_insertion_fee($eachline[$i][$y], 'product', $startingprice, 0, $_SESSION['ilancedata']['user']['userid'], 0, 0);
                                                                $insertionfeesformatted = $feebit = '';
                                                                
                                                                if ($insertionfees > 0)
                                                                {
                                                                        $sumfees += $insertionfees;
                                                                        $insertionfeesformatted = $ilance->currency->format($insertionfees);
                                                                        $feebit = '<div class="smaller gray" style="padding-top:3px">' . $phrase['_insertion_fee'] . ': <span class="blue">' . $insertionfeesformatted . '</span></div>';
                                                                        $insertiontotal += $insertionfees;
                                                                }
                                                                
                                                                // convert category id number into actual category title..
                                                                $col .= '<td class="alt1" valign="top"><div class="blue">' . $ilance->categories->title($_SESSION['ilancedata']['user']['slng'], 'product', $eachline[$i][$y]) . ' <!--<span class="blue">(# ' . $eachline[$i][$y] . ')</span>--></div>' . $feebit . '</td>';
                                                        }
                                                        else
                                                        {
                                                                $col .= '<td class="alt1" valign="top"><span style="color:red">' . $phrase['_cannot_be_listed_in_this_category'] . ' (#<strong>' . $eachline[$i][$y] . '</strong>)</span></td>';        
                                                        }
                                                }
                                                else
                                                {
                                                        $col .= '<td class="alt2"><span style="color:red">' . $phrase['_unknown'] . '- ' . $phrase['_cannot_be_listed_in_this_category'] . '</span></td>';        
                                                }
                                        }
                                        else if ($identifier[$i] == 'startprice')
                                        {
                                                $startingprice = $eachline[$i][$y];
                                                
                                                if ($eachline[$i][$y] > 0)
                                                {
                                                        $col .= '<td valign="top"><span class="' . $fontclass3 . '">' . $ilance->currency->format(intval($eachline[$i][$y])) . '</span></td>';
                                                }
                                                else
                                                {
                                                        $col .= '<td valign="top"><span class="' . $fontclass3 . '">' . $ilance->currency->format('0.01') . '</span></td>';
                                                }
                                        }
                                        
                                        // make sure buynow price only contains numbers; if used, check if upsell price exists.
                                        else if ($identifier[$i] == 'buynow_price')
                                        {
                                                $buynowprice = $eachline[$i][$y];
                                                
                                                if ($eachline[$i][$y] > 0)
                                                {
                                                        $feebit = '';
                                                        if ($ilconfig['productupsell_buynowcost'] > 0 AND $canpost)
                                                        {
                                                                $sumfees += $ilconfig['productupsell_buynowcost'];
                                                                $feebit = '<div class="smaller gray" style="padding-top:3px">' . $phrase['_fee'] . ': <span class="blue">' . $ilance->currency->format($ilconfig['productupsell_buynowcost']) . '</span></div>';
                                                                
                                                                $buynowtotal += $ilconfig['productupsell_buynowcost'];
                                                        }
                                                        $col .= '<td valign="top"><span class="' . $fontclass3 . '">' . $ilance->currency->format(intval($eachline[$i][$y])) . '</span>' . $feebit . '</td>';
                                                }
                                                else if ($eachline[$i][$y] <= 0)
                                                {
                                                        $col .= '<td valign="top"><span class="' . $fontclass2 . '">' . $phrase['_none'] . '</span></td>';        
                                                }
                                        }
                                        
                                        // make sure reserve price only contains numbers; if used, check if upsell price exists.
                                        else if ($identifier[$i] == 'reserve_price')
                                        {
                                                $reserveprice = $eachline[$i][$y]; 
                                                if ($eachline[$i][$y] > 0)
                                                {
                                                        $feebit = '';
                                                        if ($ilconfig['productupsell_reservepricecost'] > 0 AND $canpost)
                                                        {
                                                                $sumfees += $ilconfig['productupsell_reservepricecost'];
                                                                $feebit = '<div class="smaller gray" style="padding-top:3px">' . $phrase['_fee'] . ': <span class="blue">' . $ilance->currency->format($ilconfig['productupsell_reservepricecost']) . '</span></div>';
                                                                $reservetotal += $ilconfig['productupsell_reservepricecost'];
                                                        }
                                                        $col .= '<td valign="top"><span class="' . $fontclass3 . '">' . $ilance->currency->format(intval($eachline[$i][$y])) . '</span>' . $feebit . '</td>';
                                                        
                                                }
                                                else if ($eachline[$i][$y] <= 0)
                                                {
                                                        $col .= '<td valign="top"><span class="' . $fontclass2 . '">' . $phrase['_none'] . '</span></td>';        
                                                }
                                        }
                                        
                                        // make sure shipping cost is not empty and contains only numbers
                                        else if ($identifier[$i] == 'ship_costs')
                                        {
                                                if ($eachline[$i][$y] > 0)
                                                {
                                                        $col .= '<td valign="top"><span class="' . $fontclass3 . '">' . $ilance->currency->format(intval($eachline[$i][$y])) . '</span></td>';
                                                }
                                                else if ($eachline[$i][$y] <= 0 OR $eachline[$i][$y] == '')
                                                {
                                                        $col .= '<td valign="top"><span class="' . $fontclass2 . '">' . $phrase['_none'] . '</span></td>';        
                                                }
                                        }
                                        
                                        // make sure payment method is not empty
                                        else if ($identifier[$i] == 'paymethod')
                                        {
                                                if ($eachline[$i][$y] != '')
                                                {
                                                        $col .= '<td valign="top"><span style="color:' . $fontclass4 . '">' . strip_tags($eachline[$i][$y]) . '</span></td>';
                                                }
                                                else
                                                {
                                                        $col .= '<td valign="top"><span class="' . $fontclass2 . '">' . $phrase['_unknown'] . '</span></td>';        
                                                }
                                        }
                                        
                                        else if ($identifier[$i] == 'description')
                                        {
                                                $col .= '<td class="alt1" valign="top"><div class="' . $fontclass2 . '">' . $eachline[$i][$y] . '</td>';     
                                        }
                                        else if ($identifier[$i] == 'project_title')
                                        {
                                                $col .= '<td class="alt1" valign="top"><div class="' . $fontclass1 . '">' . $eachline[$i][$y] . '</td>';
                                        }
                                        else if ($identifier[$i] == 'sample')
                                        {
                                                if (empty($eachline[$i][$y]))
                                                {
                                                        $col .= '<td align="center" valign="top">&nbsp;</td>';
                                                }
                                                else
                                                {
                                                        $col .= '<td align="center" valign="top"><img src="' . $eachline[$i][$y] . '" width="60" height="50" border="0" alt="" id="" /></td>';
                                                }
                                        }
                                        else
                                        {
                                                if (!empty($eachline[$i][$y]))
                                                {
                                                        $col .= '<td>' . $eachline[$i][$y] . '</td>';
                                                }
                                                else
                                                {
                                                        $col .= '<td valign="top">&nbsp;</td>';
                                                }
                                        }
                                }
                                
                                //$col .= ($canpost) ? '<td align="center" valign="top"><div align="center"><input type="checkbox" name="enhance[]" value="' . $y . '" checked="checked" /></div></td></tr>' : '<td align="center" valign="top"><div align="center"><input type="checkbox" name="enhance[]" value="' . $y . '" disabled="disabled" /></div></td></tr>';
                                $z++;
                        }
                }
                unset($z);
                
                $sumfees = $ilance->currency->format($sumfees);
                $insertiontotal = '<div class="gray">Insertion Fees</div>' . $ilance->currency->format($insertiontotal) . '';
                $buynowtotal = '<div class="gray">Buy Now Fees</div>' . $ilance->currency->format($buynowtotal) . '';
                $reservetotal = '<div class="gray">Reserve Price Fees</div>' . $ilance->currency->format($reservetotal) . '';
                
                //$col .= '<tr class="alt2"><td colspan="10" style="padding-top:22px; padding-bottom:22px"><div style="font-size:15px"><strong>Showing results ' . $perpagelimit . ' ' . $phrase['_of'] . ' ' . $itemuploadcount . ' &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span class="blue"><a href="' . $ilpage['main'] . '?cmd=selling&amp;mode=bulk&amp;do=assign-preview&amp;bulksessionid=' . $bulkid . '">' . $phrase['_show_all'] . '</a></span></strong></div></td></tr>';
                $col .= '<tr class="alt1"><td colspan="3" style="padding-top:22px; padding-bottom:22px"><span style="font-size:16px" class="gray">Fee Breakdown</span></td><td><span class="blue" style="font-size:16px">' . $buynowtotal . '</span></td><td><span class="blue" style="font-size:16px">' . $reservetotal . '</span></td><td></td><td></td><td><span class="blue" style="font-size:16px">' . $insertiontotal . '</span></td><td></td></tr>';
                $col .= '<tr><td colspan="10" style="padding-top:12px"><div><span style="font-size:17px" class="black">Bulk Listing Fees Grand Total: <span class="blue"><strong>' . $sumfees . '</strong></span></span></div><div class="gray">Grand total fees include Buy Now Price, Reserve Price and may also include a Category Insertion Fee.</div></td></tr>';
                $col .= '</table>';
                
                $data = $ilance->GPC['data'];
                $data = serialize($data);
                $data = base64_encode($data);
                
                $coldata = $ilance->GPC['col'];
                $coldata = serialize($coldata);
                $coldata = base64_encode($coldata);
        }
        else if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'assign-import')
        {
                $navcrumb = array();
                $navcrumb[""] = $phrase['_sell_bulk_items'];
                
                //print_r($ilance->GPC); exit;
                // [data], [col], [duration], [duration_unit]
                $ilance->auction_rfp = construct_object('api.auction_rfp');
                
                $data = $ilance->GPC['data'];
                $data = base64_decode($data);
                $data = unserialize($data);
                //print_r($data); exit;
                
                $area_title = 'Saving Bulk Item Import Data<div class="smaller">' . $phrase['_adding'] . ': <strong>' . count($data['array']) . '</strong> ' . $phrase['_items'] . '</div>';
                $page_title = SITE_NAME . ' - Saving Bulk Item Import Data';
                
                foreach ($data AS $listing => $array)
                {
                        
                }
                
                // construct a new listing id number
                $ilance->GPC['rfpid'] = $ilance->auction_rfp->construct_new_auctionid();
                
                //echo $ilance->GPC['rfpid']; exit;

                $ilance->GPC['startprice'] = (isset($ilance->GPC['startprice']) AND $ilance->GPC['startprice'] > 0) ? sprintf("%01.2f", $ilance->GPC['startprice']) : '0.01';
                $ilance->GPC['reserve_price'] = (isset($ilance->GPC['reserve_price'])) ? sprintf("%01.2f", $ilance->GPC['reserve_price']) : 0;
                $ilance->GPC['reserve'] = ($ilance->GPC['reserve_price'] > 0) ? '1' : '0';
                $ilance->GPC['buynow_price'] = (isset($ilance->GPC['buynow_price']) AND $ilance->GPC['buynow_price'] > 0) ? sprintf("%01.2f", $ilance->GPC['buynow_price']) : '0';
                $ilance->GPC['buynow_qty'] = (isset($ilance->GPC['buynow_qty'])) ? intval($ilance->GPC['buynow_qty']) : '1';
                $ilance->GPC['buynow'] = ($ilance->GPC['buynow_price'] > 0) ? '1' : '0';
                
                // #### SHIPPING INFORMATION ###################################
                $ilance->GPC['ship_handling'] = isset($ilance->GPC['ship_handling']) ? $ilance->GPC['ship_handling'] : 'none';
                $ilance->GPC['ship_shipperid'] = isset($ilance->GPC['ship_shipperid']) ? intval($ilance->GPC['ship_shipperid']) : 0;
                $ilance->GPC['ship_country'] = isset($ilance->GPC['ship_country']) ? $ilance->GPC['ship_country'] : 'custom';
                $ilance->GPC['ship_countries'] = isset($ilance->GPC['ship_countries']) ? $ilance->GPC['ship_countries'] : '';
                $ilance->GPC['ship_costs'] = isset($ilance->GPC['ship_costs']) ? $ilance->GPC['ship_costs'] : 0;
                if ($ilance->GPC['ship_costs'] <= 0)
                {
                        $ilance->GPC['ship_costs'] = 0;
                        $ilance->GPC['ship_handling'] = 'none';
                }
                
                // #### BIDDING FILTERS ########################################
                $ilance->GPC['filter_rating'] = isset($ilance->GPC['filter_rating']) ? intval($ilance->GPC['filter_rating']) : '0';
                $ilance->GPC['filtered_rating'] = isset($ilance->GPC['filtered_rating']) ? $ilance->GPC['filtered_rating'] : '';
                $ilance->GPC['filter_country'] = isset($ilance->GPC['filter_country']) ? intval($ilance->GPC['filter_country']) : '0';
                $ilance->GPC['filtered_country'] = isset($ilance->GPC['filtered_country']) ? $ilance->GPC['filtered_country'] : '';
                $ilance->GPC['filter_state'] = isset($ilance->GPC['filter_state']) ? intval($ilance->GPC['filter_state']) : '0';
                $ilance->GPC['filtered_state'] = isset($ilance->GPC['filtered_state']) ? $ilance->GPC['filtered_state'] : '';
                $ilance->GPC['filter_city'] = isset($ilance->GPC['filter_city']) ? intval($ilance->GPC['filter_city']) : '0';
                $ilance->GPC['filtered_city'] = isset($ilance->GPC['filtered_city']) ? $ilance->GPC['filtered_city'] : '';
                $ilance->GPC['filter_zip'] = isset($ilance->GPC['filter_zip']) ? intval($ilance->GPC['filter_zip']) : '0';
                $ilance->GPC['filtered_zip'] = isset($ilance->GPC['filtered_zip']) ? $ilance->GPC['filtered_zip'] : '';
                $ilance->GPC['filter_underage'] = isset($ilance->GPC['filter_underage']) ? intval($ilance->GPC['filter_underage']) : '0';
                $ilance->GPC['filter_escrow'] = isset($ilance->GPC['filter_escrow']) ? intval($ilance->GPC['filter_escrow']) : '0';
                $ilance->GPC['filter_businessnumber'] = isset($ilance->GPC['filter_businessnumber']) ? $ilance->GPC['filter_businessnumber'] : '0';
                $ilance->GPC['filter_publicboard'] = isset($ilance->GPC['filter_publicboard']) ? intval($ilance->GPC['filter_publicboard']) : '0';
                $ilance->GPC['filtered_auctiontype'] = isset($ilance->GPC['filtered_auctiontype']) ? $ilance->GPC['filtered_auctiontype'] : 'regular';
                
                // ### OTHER DETAILS ###########################################
                $ilance->GPC['project_type'] = 'forward';
                $ilance->GPC['project_state'] = 'product';
                $ilance->GPC['retailprice'] = (isset($ilance->GPC['retailprice'])) ? sprintf("%01.2f", $ilance->GPC['retailprice']) : '0';
                $ilance->GPC['uniquebidcount'] = (isset($ilance->GPC['uniquebidcount']) AND $ilance->GPC['uniquebidcount'] > 0) ? intval($ilance->GPC['uniquebidcount']) : '0';
                $ilance->GPC['additional_info'] = isset($ilance->GPC['additional_info']) ? $ilance->GPC['additional_info'] : '';
                $ilance->GPC['keywords'] = isset($ilance->GPC['keywords']) ? $ilance->GPC['keywords'] : '';
                $ilance->GPC['paymethod'] = isset($ilance->GPC['paymethod']) ? $ilance->GPC['paymethod'] : '';
                $ilance->GPC['status'] = 'open';
                $ilance->GPC['bid_details'] = 'open';
                
                // #### RETURN POLICIES ########################################
                $ilance->GPC['returnaccepted'] = isset($ilance->GPC['returnaccepted']) ? intval($ilance->GPC['returnaccepted']) : '0';
                $ilance->GPC['returnwithin'] = isset($ilance->GPC['returnwithin']) ? intval($ilance->GPC['returnwithin']) : '0';
                $ilance->GPC['returngivenas'] = isset($ilance->GPC['returngivenas']) ? $ilance->GPC['returngivenas'] : 'none';
                $ilance->GPC['returnshippaidby'] = isset($ilance->GPC['returnshippaidby']) ? $ilance->GPC['returnshippaidby'] : 'none';
                $ilance->GPC['returnpolicy'] = isset($ilance->GPC['returnpolicy']) ? $ilance->GPC['returnpolicy'] : '';
                
                // #### SAVE AS DRAFT ##########################################
                $ilance->GPC['draft'] = '0';
                
                // #### CUSTOM INFORMATION #####################################
                $ilance->GPC['custom'] = (!empty($ilance->GPC['custom']) ? $ilance->GPC['custom'] : array());
                $ilance->GPC['profileanswer'] = (!empty($ilance->GPC['profileanswer']) ? $ilance->GPC['profileanswer'] : array());
                $ilance->GPC['enhancements'] = (!empty($ilance->GPC['enhancements']) ? $ilance->GPC['enhancements'] : array());
                
                // #### SCHEDULED AUCTION ONLY #################################
                $ilance->GPC['year'] = (isset($ilance->GPC['year'])) ? $ilance->GPC['year'] : '';
                $ilance->GPC['month'] = (isset($ilance->GPC['month'])) ? $ilance->GPC['month'] : '';
                $ilance->GPC['day'] = (isset($ilance->GPC['day'])) ? $ilance->GPC['day'] : '';
                $ilance->GPC['hour'] = (isset($ilance->GPC['hour'])) ? $ilance->GPC['hour'] : '';
                $ilance->GPC['min'] = (isset($ilance->GPC['min'])) ? $ilance->GPC['min'] : '';
                $ilance->GPC['sec'] = (isset($ilance->GPC['sec'])) ? $ilance->GPC['sec'] : '';
                
                print_r($ilance->GPC); exit;
                
                $apihookcustom = array();
                
                ($apihook = $ilance->api('selling_submit_end')) ? eval($apihook) : false;
                
                // #### CREATE AUCTION #################################
                $ilance->auction_rfp->insert_product_auction(
                        $_SESSION['ilancedata']['user']['userid'],
                        $ilance->GPC['project_type'],
                        $ilance->GPC['status'],
                        $ilance->GPC['project_state'],
                        $ilance->GPC['cid'],
                        $ilance->GPC['rfpid'],
                        $ilance->GPC['project_title'],
                        $ilance->GPC['bbcode_holder'],
                        $ilance->GPC['description_videourl'],
                        $ilance->GPC['additional_info'],
                        $ilance->GPC['keywords'],
                        $ilance->GPC['custom'],
                        $ilance->GPC['profileanswer'],
                        $ilance->GPC['filtered_auctiontype'],
                        $ilance->GPC['startprice'],
                        $ilance->GPC['project_details'],
                        $ilance->GPC['bid_details'],
                        $ilance->GPC['filter_rating'],
                        $ilance->GPC['filter_country'],
                        $ilance->GPC['filter_state'],
                        $ilance->GPC['filter_city'],
                        $ilance->GPC['filter_zip'],
                        $ilance->GPC['filtered_rating'],
                        $ilance->GPC['filtered_country'],
                        $ilance->GPC['filtered_state'],
                        $ilance->GPC['filtered_city'],
                        $ilance->GPC['filtered_zip'],
                        $ilance->GPC['ship_costs'],
                        $ilance->GPC['ship_country'],
                        $ilance->GPC['ship_countries'],
                        $ilance->GPC['ship_handling'],
                        $ilance->GPC['ship_shipperid'],
                        $ilance->GPC['buynow'],
                        $ilance->GPC['buynow_price'],
                        $ilance->GPC['buynow_qty'],
                        $ilance->GPC['enhancements'],
                        $ilance->GPC['reserve'],
                        $ilance->GPC['reserve_price'],
                        $ilance->GPC['filter_underage'],
                        $ilance->GPC['filter_escrow'],
                        $ilance->GPC['filter_publicboard'],
                        $ilance->GPC['invitelist'],
                        $ilance->GPC['invitemessage'],
                        $ilance->GPC['year'],
                        $ilance->GPC['month'],
                        $ilance->GPC['day'],
                        $ilance->GPC['hour'],
                        $ilance->GPC['min'],
                        $ilance->GPC['sec'],
                        $ilance->GPC['duration'],
                        $ilance->GPC['duration_unit'],
                        $ilance->GPC['paymethod'],
                        $ilance->GPC['retailprice'],
                        $ilance->GPC['uniquebidcount'],
                        $ilance->GPC['draft'],
                        $ilance->GPC['returnaccepted'],
                        $ilance->GPC['returnwithin'],
                        $ilance->GPC['returngivenas'],
                        $ilance->GPC['returnshippaidby'],
                        $ilance->GPC['returnpolicy'],
                        $skipemailprocess = 1,
                        $apihookcustom
                );
                exit();
        }
        
        $pprint_array = array('sumfees','itemuploadcount','enhancements','coldata','data','duration','durationbits','feetotal','col','response','title','categoryresults','wantads_category_pulldown','two_column_categories','js','two_column_product_categories','prevnext','remote_addr','rid','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
    
        ($apihook = $ilance->api('main_selling')) ? eval($apihook) : false;
        
        $ilance->template->fetch('main', 'selling.html');
        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
        $ilance->template->parse_loop('main', 'featuredserviceauctions');
        $ilance->template->parse_loop('main', 'featuredproductauctions');
        $ilance->template->parse_if_blocks('main');
        $ilance->template->pprint('main', $pprint_array);
        exit();
}

// #### CATEGORIES LANDING #####################################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'categories')
{
        // #### define top header nav ##########################################
        $topnavlink = array(
                'main_categories'
        );
        
        $area_title = $phrase['_categories'];
        $page_title = $phrase['_categories'] . ' &gt; ' . SITE_NAME;
    
        $navcrumb = array();
        $navcrumb[""] = $phrase['_categories'];
        
        $show['widescreen'] = true;
        
        $popularcategories = $popularlistingcategories = $trendcategories = $latestawardedcategories = $viewingnowcategories = $watchlistcategories = $savedsearchcategories = '';
        
        // #### popular categories #############################################
        $extra = '';
        if ($ilconfig['globalauctionsettings_serviceauctionsenabled'] AND $ilconfig['globalauctionsettings_productauctionsenabled'])
        {
                $extra .= "AND (cattype = 'service' OR cattype = 'product')";        
        }
        else if ($ilconfig['globalauctionsettings_productauctionsenabled'] AND $ilconfig['globalauctionsettings_serviceauctionsenabled'] == false)
        {
                $extra .= "AND cattype = 'product'";        
        }
        else if ($ilconfig['globalauctionsettings_productauctionsenabled'] == false AND $ilconfig['globalauctionsettings_serviceauctionsenabled'])
        {
                $extra .= "AND cattype = 'service'";        
        }
        
        $sql = $ilance->db->query("
                SELECT *
                FROM " . DB_PREFIX . "categories
                WHERE visible = '1'
                $extra
                ORDER BY views DESC
                LIMIT 10
        ");
        if ($ilance->db->num_rows($sql) > 0)
        {
                $popularcategories .= '<ol style="padding-top:7px">';
                
                $i = 1;
                while ($res = $ilance->db->fetch_array($sql))
                {
                        $style = '';
                        if ($i == 1)
                        {
                                $style = 'style="font-weight:bold"';
                        }
                        
                        if ($res['cattype'] == 'service')
                        {
                                $url = ($ilconfig['globalauctionsettings_seourls']) ? construct_seo_url('servicecatplain', $res['cid'], $auctionid = 0, $res['title_' . $_SESSION['ilancedata']['user']['slng']], $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) : $ilpage['rfp'] . '?cid=' . $res['cid'];
                        }
                        else if ($res['cattype'] == 'product')
                        {
                                $url = ($ilconfig['globalauctionsettings_seourls']) ? construct_seo_url('productcatplain', $res['cid'], $auctionid = 0, $res['title_' . $_SESSION['ilancedata']['user']['slng']], $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) : $ilpage['merch'] . '?cid=' . $res['cid'];
                        }

                        $popularcategories .= '<li><span class="blue"><a href="' . $url . '" ' . $style . '>' . $res['title_' . $_SESSION['ilancedata']['user']['slng']] . '</a></span></li>';
                        $i++;
                }
                
                $popularcategories .= '</ol>';
        }
        
        // #### popular categories #############################################
        $sql = $ilance->db->query("
                SELECT *
                FROM " . DB_PREFIX . "categories
                WHERE visible = '1'
                $extra
                ORDER BY auctioncount DESC
                LIMIT 10
        ");
        if ($ilance->db->num_rows($sql) > 0)
        {
                $popularlistingcategories .= '<ol style="padding-top:7px">';
                
                $i = 1;
                while ($res = $ilance->db->fetch_array($sql))
                {
                        $style = '';
                        if ($i == 1)
                        {
                                $style = 'style="font-weight:bold"';
                        }
                        
                        if ($res['cattype'] == 'service')
                        {
                                $url = ($ilconfig['globalauctionsettings_seourls']) ? construct_seo_url('servicecatplain', $res['cid'], $auctionid = 0, $res['title_' . $_SESSION['ilancedata']['user']['slng']], $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) : $ilpage['rfp'] . '?cid=' . $res['cid'];
                        }
                        else if ($res['cattype'] == 'product')
                        {
                                $url = ($ilconfig['globalauctionsettings_seourls']) ? construct_seo_url('productcatplain', $res['cid'], $auctionid = 0, $res['title_' . $_SESSION['ilancedata']['user']['slng']], $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) : $ilpage['merch'] . '?cid=' . $res['cid'];
                        }
                        
                        $popularlistingcategories .= '<li><span class="blue"><a href="' . $url . '" ' . $style . '>' . $res['title_' . $_SESSION['ilancedata']['user']['slng']] . '</a></span></li>';
                        $i++;
                }
                
                $popularlistingcategories .= '</ol>';
        }
        
        $ilance->categories->build_array('service', $_SESSION['ilancedata']['user']['slng'], 0, $propersort = true);
        $categorycacheservice = $ilance->categories->fetch;
        
        $ilance->categories->build_array('product', $_SESSION['ilancedata']['user']['slng'], 0, $propersort = true);
        $categorycacheproduct = $ilance->categories->fetch;
        
        // #### FEATURE SPOTLIGHT AUCTIONS #####################################
        $show['featuredserviceauctions'] = $show['featuredproductauctions'] = $show['latestproductauctions'] = $show['latestserviceauctions'] = false;
        $featuredserviceauctions = $featuredproductauctions = $latestproductauctions = $latestserviceauctions = array();
        
        if ($ilconfig['globalauctionsettings_serviceauctionsenabled'])
        {
                $featuredserviceauctions = $ilance->auction->fetch_featured_auctions('service', 3, 1, 0, '');
                $latestserviceauctions = $ilance->auction->fetch_latest_auctions('service', 5);
        }
        if ($ilconfig['globalauctionsettings_productauctionsenabled'])
        {
                $featuredproductauctions = $ilance->auction->fetch_featured_auctions('product', 3, 1, 0, '');
                $latestproductauctions = $ilance->auction->fetch_latest_auctions('product', 5);
        }
        
        $recentlyviewedflash = print_flash_gallery('recentlyviewed');
        
        $pprint_array = array('seoservicecategories','seoproductcategories','seolistings','seocategories','popularlistingcategories','recentlyviewedflash','trendcategories','popularcategories','title','categoryresults','wantads_category_pulldown','two_column_categories','js','two_column_product_categories','prevnext','remote_addr','rid','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
        
        ($apihook = $ilance->api('main_categories')) ? eval($apihook) : false;
        
        $ilance->template->fetch('main', 'main_categories.html');
        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
        $ilance->template->parse_loop('main', 'featuredserviceauctions');
        $ilance->template->parse_loop('main', 'featuredproductauctions');
        $ilance->template->parse_loop('main', 'latestserviceauctions');
        $ilance->template->parse_loop('main', 'latestproductauctions');
        $ilance->template->parse_if_blocks('main');
        $ilance->template->pprint('main', $pprint_array);
        exit();
}

// #### CATEGORIES LANDING #####################################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'listings')
{
        $show['widescreen'] = false;
        
        // #### define top header nav ##########################################
        $topnavlink = array(
                'main_listings'
        );
        
        $area_title = $phrase['_listings'];
        $page_title = $phrase['_listings'] . ' &gt; ' . SITE_NAME;
    
        $navcrumb = array();
        $navcrumb[""] = $phrase['_listings'];
        
        $pprint_array = array('seoservicecategories','seoproductcategories','seolistings','seocategories','trendcategories','popularcategories','title','categoryresults','wantads_category_pulldown','two_column_categories','js','two_column_product_categories','prevnext','remote_addr','rid','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
        
        ($apihook = $ilance->api('main_listings')) ? eval($apihook) : false;
        
        $ilance->template->fetch('main', 'main_listings.html');
        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
        $ilance->template->parse_loop('main', 'featuredserviceauctions');
        $ilance->template->parse_loop('main', 'featuredproductauctions');
        $ilance->template->parse_if_blocks('main');
        $ilance->template->pprint('main', $pprint_array);
        exit();
}

// #### XML FEED RESOURCES LANDING PAGE ########################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'resources')
{
        // #### define top header nav ##########################################
        $topnavlink = array(
                'main'
        );
        
        $area_title = $phrase['_resources_menu'];
        $page_title = SITE_NAME . ' - ' . $phrase['_resources_menu'];
    
        $navcrumb = array();
        $navcrumb[""] = $phrase['_resources'];
        
        $feedoptions = '';
        $rssfeeds = $ilance->db->query("
                SELECT rssid, rssname, rssurl, sort
                FROM " . DB_PREFIX . "rssfeeds
                ORDER BY sort
        ", 0, null, __FILE__, __LINE__);
        if ($ilance->db->num_rows($rssfeeds) == 0)
        {
                $feedoptions = '<option value="0">' . $phrase['_no_feeds_currently_exist'] . '</option>';
        }
        else
        {
                while ($feed = $ilance->db->fetch_array($rssfeeds))
                {
                        $feedoptions .= '<option value="' . $feed['rssid'] . '">' . stripslashes($feed['rssname']) . '</option>';
                }
        }
    
        if (isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0)
        {
                $feed = $ilance->db->query_fetch("
                        SELECT rssid, rssname, rssurl, sort
                        FROM " . DB_PREFIX . "rssfeeds
                        WHERE rssid = '" . intval($ilance->GPC['id']) . "'
                ", 0, null, __FILE__, __LINE__);
                
                $rss = $feed['rssurl'];
                $rssname = $feed['rssname'];
                $headline_style = $description_style = $tag = $title = $description = $link = $image = $code2 = '';
                $show_detail = $insideitem = $insideimage = false;
                $max = 10;
                $count = 0;
                
                construct_feed($rss, true, 'news', 'news', $max);
        }
        else 
        {
                $code2 = $phrase['_please_select_a_live_rss_feed'];
        }
        
        $pprint_array = array('rssname','code2','feedoptions','remote_addr','rid','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
        
        ($apihook = $ilance->api('main_resources')) ? eval($apihook) : false;
    
        $ilance->template->fetch('main', 'main_resources.html');
        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
        $ilance->template->parse_if_blocks('main');
        $ilance->template->pprint('main', $pprint_array);
        exit();
}

// #### HIDE ADMINCP NOTICE UNDER BREADCRUMB ###################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'hideacpnag')
{
        if (!empty($_SESSION['ilancedata']['user']['isadmin']) AND $_SESSION['ilancedata']['user']['isadmin'] == '1')
        {
                set_cookie('hideacpnag', 'true', true);
                
                print_notice($phrase['_admincp_nag_notice_removed'], $phrase['_you_have_removed_the_admincp_clientside_nag_notice'], $ilpage['main'], $phrase['_home']);
                exit();
        }
}

// #### DYNAMIC TEMPLATE PARSER ################################################
if (isset($ilance->GPC['cmd']) AND !empty($ilance->GPC['cmd']))
{
        // #### define top header nav ##########################################
        $topnavlink = array(
                'main'
        );
        
        // these would be the template files residing in the ./templates/default/ folder (resources.html, terms.html, etc)
        $accepted = array('terms', 'contact', 'about', 'news');
        
        $pprint_array = array('login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
        
        // custom hook in the case you would like to expand your array above via array_merge()
        ($apihook = $ilance->api('main_external_template')) ? eval($apihook) : false;
        
        if (in_array($ilance->GPC['cmd'], $accepted))
        {
                $area_title = ucfirst($ilance->GPC['cmd']);
                $page_title = SITE_NAME . ' - ' . ucfirst($ilance->GPC['cmd']);
                
                $navcrumb = array();
                $navcrumb[""] = $area_title;
                
                $ilance->template->fetch_parsed_template('main', 'main_' . mb_strtolower($ilance->GPC['cmd']), $_SESSION['ilancedata']['user']['styleid']);
                $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                $ilance->template->parse_if_blocks('main');
                $ilance->template->pprint('main', $pprint_array);
                exit();
        }
        else
        {
                print_notice($phrase['_invalid_page_request'], $phrase['_were_sorry_the_page_you_requested_could_not_be_found'], $ilpage['main'], $phrase['_main_menu']);
                exit();
        }
}

// #### MAIN MENU LANDING PAGE #################################################
else
{
        // #### define top header nav ##########################################
        $topnavlink = array(
                'main'
        );
        
        $show['widescreen'] = false;
        
        $area_title = $phrase['_main_menu'];
        $page_title = SITE_NAME . ' - ' . $phrase['_main_menu'];
        
        $ilance->categories_parser = construct_object('api.categories_parser');
        $ilance->mycp = construct_object('api.mycp');
        
        $ilance->categories->build_array($cattype = 'service', $_SESSION['ilancedata']['user']['slng'], $mode = 0, $propersort = true);
        $categorycacheservice = $ilance->categories->fetch;
        
        $ilance->categories->build_array($cattype = 'product', $_SESSION['ilancedata']['user']['slng'], $mode = 0, $propersort = true);
        $categorycacheproduct = $ilance->categories->fetch;
        
        $navcrumb = array();
        $navcrumb[""] = $phrase['_marketplace'];
        
        // #### FEATURE AUCTIONS ###############################################
        $show['featuredserviceauctions'] = $show['featuredproductauctions'] = false;
        $featuredserviceauctions = $featuredproductauctions = array();
        
        if ($ilconfig['globalauctionsettings_serviceauctionsenabled'])
        {
                $featuredserviceauctions = $ilance->auction->fetch_featured_auctions('service', 3, 1, 0, '', true);
        }
        if ($ilconfig['globalauctionsettings_productauctionsenabled'])
        {
                $featuredproductauctions = $ilance->auction->fetch_featured_auctions('product', 3, 1, 0, '', true);
        }
        
        // #### LATEST AUCTIONS ################################################
        $show['latestserviceauctions'] = $show['latestproductauctions'] = false;
        $latestserviceauctions = $latestproductauctions = array();
        
        if ($ilconfig['globalauctionsettings_serviceauctionsenabled'])
        {
                $latestserviceauctions = $ilance->auction->fetch_latest_auctions('service', 3, 1, 0, '', true);
        }
        if ($ilconfig['globalauctionsettings_productauctionsenabled'])
        {
                $latestproductauctions = $ilance->auction->fetch_latest_auctions('product', 3, 1, 0, '', true);
        }
        
        // #### ENDING SOON AUCTIONS ###########################################
        $servicesendingsoon = $productsendingsoon = array();
        
        if ($ilconfig['globalauctionsettings_serviceauctionsenabled'])
        {
                $servicesendingsoon = $ilance->auction->fetch_ending_soon_auctions('service', 3, 1, 0, '', true);
        }
        if ($ilconfig['globalauctionsettings_productauctionsenabled'])
        {
                $productsendingsoon = $ilance->auction->fetch_ending_soon_auctions('product', 3, 1, 0, '', true);
        }
        
        // #### RECENTLY VIEWED AUCTIONS #######################################
        $recentreviewedserviceauctions = $recentreviewedproductauctions = array();
        
        $show['recentlyreviewed'] = true;
        $show['recentlyviewedservices'] = $show['recentlyviewedproducts'] = false;
        
        if ($ilconfig['globalauctionsettings_serviceauctionsenabled'])
        {
                $recentreviewedserviceauctions = $ilance->auction->fetch_recently_viewed_auctions('service', 3, 1, 0, '', true);
        }
        if ($ilconfig['globalauctionsettings_productauctionsenabled'])
        {
                $recentreviewedproductauctions = $ilance->auction->fetch_recently_viewed_auctions('product', 3, 1, 0, '', true);
        }
        
        // #### TAG CLOUD OF RECENT SEARCH KEYWORD TERMS #######################
        $tagcloud = print_tag_cloud();

        // define custom left nav menu
        if ($ilconfig['globalauctionsettings_serviceauctionsenabled'] AND $ilconfig['globalauctionsettings_productauctionsenabled'])
        {
                $v3left_nav = $ilance->template->print_left_nav('service', 0, $dosubcats = 1, $displayboth = 1, $showcount = 0, $categorycacheservice, $categorycacheproduct);
        }
        else if ($ilconfig['globalauctionsettings_serviceauctionsenabled'] AND $ilconfig['globalauctionsettings_productauctionsenabled'] == 0)
        {
                $v3left_nav = $ilance->template->print_left_nav('service', 0, $dosubcats = 1, $displayboth = 0, $showcount = 0, $categorycacheservice, $categorycacheproduct);
        }
        else if ($ilconfig['globalauctionsettings_productauctionsenabled'] AND $ilconfig['globalauctionsettings_serviceauctionsenabled'] == 0)
        {
                $v3left_nav = $ilance->template->print_left_nav('product', 0, $dosubcats = 1, $displayboth = 0, $showcount = 0, $categorycacheservice, $categorycacheproduct);
        }
        unset($categorycacheservice, $categorycacheproduct);        
        
        $recentlyviewedflash = print_flash_gallery('recentlyviewed');
        
        $show['messageactivity'] = false;
        if (!empty($_SESSION['ilancedata']['user']['userid']))
        {
                $show['messageactivity'] = $show['reminders'] = true;
                $messagesactivity = $ilance->mycp->fetch_unread_messages($_SESSION['ilancedata']['user']['userid']);
        }
        
        // #### stats overview #################################################
        $stats = fetch_stats_overview();
        $jobcount = number_format($stats['jobcount']);
        $expertcount = number_format($stats['expertcount']);
        $expertsearch = number_format((($stats['expertsearch'] / $expertcount)), 1);
        $expertsrevenue = $ilance->currency->format($stats['expertsrevenue']);
        $itemcount = number_format($stats['itemcount']);
        $itemsworth = $ilance->currency->format($stats['itemsworth']);
        unset($stats);
        
        // #### determine if we should show the 3rd right column on the main menu
        $show['hiderightcolumn'] = false;
        if (isset($show['messageactivity']) AND $show['messageactivity'] == false AND isset($show['tagcloud']) AND $show['tagcloud'] == false)
        {
                if ($jobcount == 0 AND $expertcount == 0 AND $itemcount == 0)
                {
                        $show['hiderightcolumn'] = true;
                }
        }

        $pprint_array = array('itemsworth','expertsrevenue','expertsearch','jobcount','expertcount','itemcount','feedbackactivity','messagesactivity','recentlyviewedflash','tagcloud','main_servicecats_img','main_productcats_img','main_servicecats','main_productcats','lanceads_folder','two_column_category_buyers','two_column_service_categories','two_column_product_categories','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');

        ($apihook = $ilance->api('main_start')) ? eval($apihook) : false;  
    
        $ilance->template->fetch('main', 'main.html', 0, 1);
        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
        $ilance->template->parse_loop('main', 'featuredserviceauctions');
        $ilance->template->parse_loop('main', 'featuredproductauctions');
        $ilance->template->parse_loop('main', 'latestserviceauctions');
        $ilance->template->parse_loop('main', 'latestproductauctions');
        $ilance->template->parse_loop('main', 'productsendingsoon');
        $ilance->template->parse_loop('main', 'servicesendingsoon');
        $ilance->template->parse_loop('main', 'recentreviewedproductauctions');
        $ilance->template->parse_loop('main', 'recentreviewedserviceauctions');
        
        ($apihook = $ilance->api('main_end')) ? eval($apihook) : false;
        
        $ilance->template->parse_if_blocks('main');
        $ilance->template->pprint('main', $pprint_array);
        exit();
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: main.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>