<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

// #### load required phrase groups ############################################
$phrase['groups'] = array(
        'rfp',
        'buying',
        'selling',
        'search',
        'feedback',
        'portfolio',
        'javascript'
);

// #### define top header nav ##################################################
$topnavlink = array(
        'main'
);

// #### setup script location ##################################################
define('LOCATION','vendors');

// #### require backend ########################################################
require_once('./functions/config.php');

// #### setup default breadcrumb ###############################################
$navcrumb = array("$ilpage[members]" => $ilcrumbs["$ilpage[members]"]);

// #### PROVIDER LISTINGS VIA CATEGORY #########################################
if (!empty($ilance->GPC['cid']) AND $ilance->GPC['cid'] > 0 AND empty($ilance->GPC['id']))
{        
        $urlbit = print_hidden_fields($string = true, $excluded = array('mode'));
        
        header('Location: ' . HTTP_SERVER . $ilpage['search'] . '?mode=experts' . $urlbit);
        exit();
}

$show['widescreen'] = true;

// #### PREPARE DEFAULT URLS ###########################################
$scriptpage = $ilpage['members'] . print_hidden_fields($string = true, $excluded = array('feedback','page'), $questionmarkfirst = true);

$php_self = $scriptpage;
$php_self_urlencoded = urlencode($php_self);

define('PHP_SELF', HTTP_SERVER . $php_self);

$ilance->feedback = construct_object('api.feedback');
$ilance->subscription = construct_object('api.subscription');
$ilance->bid = construct_object('api.bid');

// specifying a particular category?
$cid = 0;
if (isset($ilance->GPC['cid']) AND !empty($ilance->GPC['cid']))
{
        $cid = intval($ilance->GPC['cid']);
}

if (!isset($ilance->GPC['id']))
{
        $area_title = $phrase['_invalid_vendor_id_warning_menu'];
        $page_title = SITE_NAME . ' - ' . $phrase['_invalid_vendor_id_warning_menu'];
        
        print_notice($phrase['_invalid_vendor_profile_id'], $phrase['_your_requested_action_cannot_be_completed_due_to_an_invalid_vendors_id']."<br /><br />".$phrase['_please_contact_customer_support'], $ilpage['main'], $phrase['_main_menu']);
        exit();
}

$sql_vendor = $ilance->db->query("
        SELECT *
        FROM " . DB_PREFIX . "users
        WHERE username = '" . $ilance->db->escape_string($ilance->GPC['id']) . "' OR user_id = '" . $ilance->db->escape_string($ilance->GPC['id']) . "'
        LIMIT 1
");

// #### MEMBER PROFILE REVIEW ##################################################
if (isset($ilance->GPC['id']) AND isset($ilance->GPC['profile']) AND $ilance->GPC['profile'])
{
        if ($ilance->db->num_rows($sql_vendor) > 0)
        {
                $ilance->categories_pulldown = construct_object('api.categories_pulldown');
                
                $res_vendor = $ilance->db->fetch_array($sql_vendor);
                
                $vendorname_plain = stripslashes($res_vendor['username']);
                $vendorname = print_username($res_vendor['user_id'], 'href');
                $uid = $res_vendor['user_id'];
                
                $area_title = $phrase['_viewing_feedback_profile_for'] . ' ' . $vendorname_plain;
		$page_title = SITE_NAME . ' - ' . $phrase['_viewing_feedback_profile_for'] . ' ' . $vendorname_plain;
                
                $navcrumb = array();
                $navcrumb["$ilpage[members]?id=$vendorname_plain"] = $phrase['_members'];
                $navcrumb[""] = $vendorname_plain;
                
                // let's determine if this member has an active profile and active subscription
                if (!$ilance->subscription->has_active_subscription($res_vendor['user_id']) OR $res_vendor['status'] != 'active')
                {
                        print_notice($phrase['_profile_temporarily_inactive'], $phrase['_sorry_the_enhanced_profile_page_for_this_member_is_temporarily_inactive'], 'javascript:history.back(1);', $phrase['_back']);
                        exit();        
                }
                
                // subscription title and role name
                $subscription = $ilance->subscription->print_subscription_title($res_vendor['user_id']);
		$rolename = print_role(fetch_user_roleid($res_vendor['user_id']));
                
                // member start date
                $membersince = print_date(fetch_user('date_added', $uid), '%d-%b-%Y', 0, 0);
                
                // do we display "view portfolio" link under logo?
		$show['portfoliolink'] = 0;
                if (has_portfolio($res_vendor['user_id']) > 0)
                {
                        $show['portfoliolink'] = 1;
                }
                
                $show['categorypulldown'] = 0;
                if (has_answered_profile_questions($uid))
                {
                        $show['categorypulldown'] = 1;
                }
                
                // selling (or buying) profile logo / image
		$profile_logo = $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'nophoto.gif';
		$sql_attach = $ilance->db->query("
                        SELECT attachid, filehash
                        FROM " . DB_PREFIX . "attachment
                        WHERE user_id = '" . intval($res_vendor['user_id']) . "'
                                AND visible = '1'
                                AND attachtype = 'profile'
                        LIMIT 1
                ");
		if ($ilance->db->num_rows($sql_attach) > 0)
                {
			$res_attach = $ilance->db->fetch_array($sql_attach);
			$profile_logo = HTTPS_SERVER . $ilpage['attachment'] . '?cmd=profile&amp;id=' . $res_attach['filehash'];
		}
                
                // display city & state to members only
		$city_state = '';
                if (!empty($res_vendor['city']))
                {
                        $city_state = '<span class="blue"><a href="' . HTTP_SERVER . $ilpage['search'] . '?mode=experts&amp;sort=42&amp;city=' . ucfirst(stripslashes($res_vendor['city'])) . '" title="' . $phrase['_show_other_experts_from_this_city'] . '" rel="nofollow">' . ucfirst(stripslashes($res_vendor['city'])) . '</a></span>';
                }
                if (!empty($res_vendor['state']))
                {
                        if (!empty($res_vendor['city']))
                        {
                                $city_state .=  ' &gt; <span class="blue"><a href="' . HTTP_SERVER . $ilpage['search'] . '?mode=experts&amp;sort=42&amp;state=' . ucfirst(stripslashes($res_vendor['state'])) . '" title="' . $phrase['_show_other_experts_from_this_state_province'] . '" rel="nofollow">' . ucfirst(stripslashes($res_vendor['state'])) . '</a></span>';
                        }
                        else
                        {
                                $city_state .= ucfirst(stripslashes($res_vendor['state']));
                        }
                }
                else
                {
                        $city_state = $phrase['_unknown'];
                }
		
		// country
                $country = '<span class="blue"><a href="' . HTTP_SERVER . $ilpage['search'] . '?mode=experts&amp;sort=42&amp;country=' . $res_vendor['country'] . '" title="' . $phrase['_show_other_experts_from_this_country'] . '" rel="nofollow">' . print_country_name($res_vendor['country'], $_SESSION['ilancedata']['user']['slng']) . '</a></span>';

		// last seen
		$lastseen = $ilance->common->last_seen($res_vendor['user_id']);
		
		// is online?
		$isonline = '<span class="blue"><a href="' . HTTP_SERVER . $ilpage['search'] . '?mode=experts&amp;sort=42&amp;isonline=1" title="' . $phrase['_show_other_experts_that_are_online_only'] . '" rel="nofollow">' . print_online_status($res_vendor['user_id']) . '</a></span>';
		
		// verified credentials
		$credentials_verified = fetch_verified_credentials($res_vendor['user_id']);
                
                // default profile answers
                $default_profile_question_groups = array();
                
                $sqlprofilegroups2 = $ilance->db->query("
                        SELECT *
                        FROM " . DB_PREFIX . "profile_groups
                        WHERE canremove = '0'
                                AND visible = '1'
                ");
                if ($ilance->db->num_rows($sqlprofilegroups2) > 0)
                {
                        $row_count2 = 0;
                        while ($row2 = $ilance->db->fetch_array($sqlprofilegroups2))
                        {
                                $sqlquestions2 = $ilance->db->query("
                                        SELECT q.description, q.canverify, q.sort, q.inputtype, a.answer, a.isverified
                                        FROM " . DB_PREFIX . "profile_questions q
                                        LEFT JOIN " . DB_PREFIX . "profile_answers a ON (q.questionid = a.questionid)
                                        WHERE q.groupid = '" . $row2['groupid'] . "'
                                                AND a.user_id = '" . $res_vendor['user_id'] . "'
                                                AND a.answer != ''
                                                AND a.visible = '1'
                                        ORDER BY q.sort ASC
                                ");
                                if ($ilance->db->num_rows($sqlquestions2) > 0)
                                {
                                        while ($resqa = $ilance->db->fetch_array($sqlquestions2))
                                        {
                                                if (!empty($_SESSION['ilancedata']['user']['userid']))
                                                {
                                                        switch ($resqa['inputtype'])
                                                        {
                                                                case 'yesno':
                                                                {
                                                                        if ($resqa['answer'])
                                                                        {
                                                                                $resqa['answer'] = $phrase['_yes'];
                                                                        }
                                                                        else
                                                                        {
                                                                                $resqa['answer'] = $phrase['_no'];
                                                                        }
                                                                        break;
                                                                }							
                                                                case 'int':
                                                                {
                                                                        $resqa['answer'] = stripslashes($resqa['answer']);
                                                                        break;
                                                                }							
                                                                case 'textarea':
                                                                {
                                                                        $resqa['answer'] = stripslashes($resqa['answer']);
                                                                        break;
                                                                }							
                                                                case 'text':
                                                                {
                                                                        $resqa['answer'] = stripslashes($resqa['answer']);
                                                                        break;
                                                                }							
                                                                case 'pulldown':
                                                                {
                                                                        $answers = $resqa['answer'];
                                                                        if (isset($answers) AND is_serialized($resqa['answer']))
                                                                        {
                                                                                $answers = unserialize($resqa['answer']);
                                                                        }
                                                                        
                                                                        $ansval = '';
                                                                        if (isset($answers) AND is_array($answers))
                                                                        {
                                                                                foreach ($answers as $ans)
                                                                                {
                                                                                        $ansval .= stripslashes($ans) . ', ';
                                                                                }
                                                                        }
                                                                        else
                                                                        {
                                                                                $ansval .= $answers . ', ';
                                                                        }
                                                                        
                                                                        $resqa['answer'] = mb_substr($ansval, 0, -2);
                                                                        break;
                                                                }							
                                                                case 'multiplechoice':
                                                                {
                                                                        $answers = $resqa['answer'];
                                                                        if (isset($answers) AND is_serialized($resqa['answer']))
                                                                        {
                                                                                $answers = unserialize($resqa['answer']);
                                                                        }
                                                                        
                                                                        $ansval = '';
                                                                        if (isset($answers) AND is_array($answers))
                                                                        {
                                                                                foreach ($answers as $ans)
                                                                                {
                                                                                        $ansval .= stripslashes($ans) . ', ';
                                                                                }
                                                                        }
                                                                        else
                                                                        {
                                                                                $ansval .= $answers . ', ';       
                                                                        }
                                                                        
                                                                        $resqa['answer'] = mb_substr($ansval, 0, -2);
                                                                        break;
                                                                }
                                                        }
                                                }
                                                else
                                                {
                                                        $resqa['answer'] = '= ' . $phrase['_subscribers_only'] . ' =';
                                                }
                                                
                                                $resqa['question'] = stripslashes($resqa['description']);
                                                if ($resqa['canverify'] AND $resqa['isverified'])
                                                {
                                                        $resqa['is_verified'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'verified_icon.gif" alt="Verified" border="0" />';
                                                }
                                                else if ($resqa['canverify'] AND $resqa['isverified'] == 0)
                                                {
                                                        $resqa['is_verified'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'not_verified.gif" alt="Unverified" border="0" />';
                                                }
                                                else if ($resqa['canverify'] == 0)
                                                {
                                                        $resqa['is_verified'] = '';
                                                }
                                                
                                                $resqa['daysago'] = '3';
                                                $resqa['class2'] = ($row_count2 % 2) ? 'alt2' : 'alt1';
                                                $resqa['description'] = $phrase['_get_an_in_depth_look_based_on_questions_answered_by_this_user_below'];
                                                
                                                $GLOBALS['default_profile_questions' . $row2['groupid']][] = $resqa;
                                                $row_count2++;
                                        }
                                }
                                else
                                {
                                        $GLOBALS['no_default_profile_questions' . $row2['groupid']][] = 1;        
                                }
                                
                                $row2['groupname'] = stripslashes($ilance->db->fetch_field(DB_PREFIX . "profile_groups", "groupid=" . $row2['groupid'], "name"));
                                $row2['class'] = ($row_count2 % 2) ? 'alt2' : 'alt1';
                                
                                $default_profile_question_groups[] = $row2;
                                $row_count2++;
                        }
                }
                else
                {
                        $no_profile_question_groups2 = 1;
                }
                
                $row_count = 0;
                $profile_question_groups = array();
                
                $sqlprofilegroups = $ilance->db->query("
                        SELECT *
                        FROM " . DB_PREFIX . "profile_groups
                        WHERE canremove = '1'
                                AND visible = '1'
                ");
		if ($ilance->db->num_rows($sqlprofilegroups) > 0)
                {
			while ($row = $ilance->db->fetch_array($sqlprofilegroups, DB_ASSOC))
                        {
                                $row_count2 = 0;
                                
                                $sqlquestions = $ilance->db->query("
                                        SELECT
                                        q.description,
                                        q.canverify,
                                        q.sort,
                                        q.inputtype,
                                        a.answer,
                                        a.isverified
                                        FROM " . DB_PREFIX . "profile_questions q
                                        LEFT JOIN " . DB_PREFIX . "profile_answers a ON (q.questionid = a.questionid)
                                        WHERE q.groupid = '" . $row['groupid'] . "'
                                                AND a.user_id = '" . $res_vendor['user_id'] . "'
                                                AND a.answer != ''
                                                AND a.visible = '1'
                                        ORDER BY q.sort ASC
                                ");
				if ($ilance->db->num_rows($sqlquestions) > 0)
                                {
					while ($rows = $ilance->db->fetch_array($sqlquestions))
                                        {
						$rows['question'] = stripslashes($rows['description']);
						if ($rows['canverify'])
                                                {
                                                        switch ($rows['inputtype'])
                                                        {
                                                                case 'yesno':
                                                                {
                                                                        if ($rows['answer'])
                                                                        {
                                                                                $rows['answer'] = $phrase['_yes'];
                                                                        }
                                                                        else
                                                                        {
                                                                                $rows['answer'] = $phrase['_no'];
                                                                        }
                                                                        break;
                                                                }                            
                                                                case 'int':
                                                                {
                                                                        $rows['answer'] = stripslashes($rows['answer']);
                                                                        break;
                                                                }
                                                                case 'textarea':
                                                                {
                                                                        $rows['answer'] = stripslashes($rows['answer']);
                                                                        $rows['answer'] = nl2br($rows['answer']);
                                                                        break;
                                                                }                                
                                                                case 'text':
                                                                {
                                                                        $rows['answer'] = stripslashes($rows['answer']);
                                                                        break;
                                                                }							
								case 'pulldown':
                                                                {
                                                                        $answers = unserialize($rows['answer']);
                                                                        $ansval = '';
                                                                        foreach ($answers as $ans)
                                                                        {
                                                                                $ansval .= stripslashes($ans).', ';
                                                                        }
                                                                        $ansval = mb_substr($ansval, 0, -2);
                                                                        $rows['answer'] = $ansval;
                                                                        break;
                                                                }							
								case 'multiplechoice':
                                                                {
                                                                        $answers = unserialize($rows['answer']);
                                                                        $ansval = '';
                                                                        foreach ($answers as $ans)
                                                                        {
                                                                                $ansval .= stripslashes($ans).', ';
                                                                        }
                                                                        $ansval = mb_substr($ansval, 0, -2);
                                                                        $rows['answer'] = $ansval;
                                                                        break;
                                                                }
                                                        }
							if ($rows['canverify'] AND $rows['isverified'])
                                                        {
								$rows['is_verified'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'verified_icon.gif" alt="Verified" border="0" />';
							}
							else if ($rows['canverify'] AND $rows['isverified'] == 0)
                                                        {
								$rows['is_verified'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'not_verified.gif" alt="Unverified" border="0" />';
							}
							else if ($rows['canverify'] == 0 AND $rows['isverified'] == 0)
                                                        {
								$rows['is_verified'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'not_verified.gif" alt="Unverified" border="0" />';
							}
						}
						else
                                                {
							$rows['is_verified'] = '';
                                                        switch ($rows['inputtype'])
                                                        {
                                                                case 'yesno':
                                                                {
                                                                        if ($rows['answer'])
                                                                        {
                                                                                $rows['answer'] = $phrase['_yes'];
                                                                        }
                                                                        else
                                                                        {
                                                                                $rows['answer'] = $phrase['_no'];
                                                                        }
                                                                        break;
                                                                }							
                                                                case 'int':
                                                                {
                                                                        $rows['answer'] = stripslashes($rows['answer']);
                                                                        break;
                                                                }
                                                                case 'textarea':
                                                                {
                                                                        $rows['answer'] = stripslashes($rows['answer']);
                                                                        break;
                                                                }							
                                                                case 'text':
                                                                {
                                                                        $rows['answer'] = stripslashes($rows['answer']);
                                                                        break;
                                                                }							
								case 'pulldown':
                                                                {
                                                                        $rows['answer'] = stripslashes($rows['answer']);
                                                                        break;
                                                                }							
								case 'multiplechoice':
                                                                {
                                                                        $answers = unserialize($rows['answer']);
                                                                        $ansval = '';
                                                                        foreach ($answers as $ans)
                                                                        {
                                                                                $ansval .= stripslashes($ans).', ';
                                                                        }
                                                                        $rows['answer'] = mb_substr($ansval, 0, -2);
                                                                        break;
                                                                }
                                                        }
						}
						$rows['class2'] = ($row_count2 % 2) ? 'alt2' : 'alt1';
                                                $rows['daysago'] = '3';
						$GLOBALS['profile_questions' . $row['groupid']][] = $rows;
						$row_count2++;
					}
				}
				else
                                {
					$GLOBALS['no_profile_questions' . $row['groupid']][] = 1;
				}
                                
                                $row['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
				$row['groupname'] = stripslashes($ilance->db->fetch_field(DB_PREFIX . "profile_groups", "groupid=" . $row['groupid'], "name"));
				
				$profile_question_groups[] = $row;
				$row_count++;
			}
		}
		else
                {
			$no_profile_question_groups = 1;
		}
                
                $memberinfo[] = $ilance->feedback->datastore($uid);
                
                // #### SKILLS #################################################
                require_once(DIR_CORE . 'functions_search.php');
                
                $skills = print_skills($uid, $showmaxskills = 500, $nourls = true);        
        
                // #### REGISTRATION QUESTIONS AND ANSWERS #####################
                $apihook_query_fields = $apihook_query_joins = $apihook_query_where = '';
                
                ($apihook = $ilance->api('vendors_registration_questions_start')) ? eval($apihook) : false;
                
                $sqlreg = $ilance->db->query("
                        SELECT q.guests, q.inputtype, q.question_" . $_SESSION['ilancedata']['user']['slng'] . " AS question, a.answer
                        $apihook_query_fields
                        FROM " . DB_PREFIX . "register_answers AS a,
                        " . DB_PREFIX . "register_questions AS q
                        $apihook_query_joins
                        WHERE a.user_id = '".intval($uid)."'
                                AND a.questionid = q.questionid
                                AND q.visible = '1'
                                AND q.profile = '1'
                                $apihook_query_where
                ");
                if ($ilance->db->num_rows($sqlreg) > 0)
                {
                        while ($reg = $ilance->db->fetch_array($sqlreg))
                        {
                                // show this answer to guests?
                                if ((!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0 OR $reg['guests'] == '1' AND empty($_SESSION['ilancedata']['user']['userid'])))
                                {
                                        $reg['question'] = stripslashes($reg['question']);
                                        switch ($reg['inputtype'])
                                        {
                                                case 'yesno':
                                                {
                                                        if ($reg['answer'])
                                                        {
                                                                $reg['answer'] = $phrase['_yes'];
                                                        }
                                                        else
                                                        {
                                                                $reg['answer'] = $phrase['_no'];
                                                        }
                                                        break;
                                                }                                       
                                                case 'int':
                                                {
                                                        $reg['answer'] = stripslashes($reg['answer']);
                                                        break;
                                                }                                        
                                                case 'textarea':
                                                {
                                                        $reg['answer'] = stripslashes($reg['answer']);
                                                        break;
                                                }                                        
                                                case 'text':
                                                {
                                                        $reg['answer'] = stripslashes($reg['answer']);
                                                        break;
                                                }                                        
                                                case 'pulldown':
                                                {
                                                        if (!empty($reg['answer']))
                                                        {
                                                                $answers = unserialize($reg['answer']);
                                                                $answer = '';
                                                                foreach ($answers as $answered)
                                                                {
                                                                        $answer .= stripslashes($answered).', ';
                                                                }
                                                                $reg['answer'] = mb_substr($answer, 0, -2);
                                                        }
                                                        else
                                                        {
                                                                $reg['answer'] = '&nbsp;';
                                                        }
                                                        break;
                                                }                                        
                                                case 'multiplechoice':
                                                {
                                                        if (!empty($reg['answer']) AND mb_strlen($reg['answer']) > 5)
                                                        {
                                                                $answers = unserialize($reg['answer']);
                                                                $answer = '';
                                                                foreach ($answers as $answered)
                                                                {
                                                                        $answer .= stripslashes($answered).', ';
                                                                }
                                                                $reg['answer'] = mb_substr($answer, 0, -2);
                                                        }
                                                        else
                                                        {
                                                                $reg['answer'] = '&nbsp;';
                                                        }
                                                        break;
                                                }
                                        }
                                }
                                else
                                {
                                        $reg = array();
                                }
                                $registration_questions[] = $reg;
                        }
                }
                
                if ($ilconfig['globalauctionsettings_seourls'])
                {
                        $allprofilesurl = print_username($uid, 'url') . '?cid=-1#categories';
                }
                else
                {
                        $allprofilesurl = print_username($uid, 'url') . '&amp;cid=-1#categories';
                }
                
                $profilevideo = print_profile_video($uid);
                $rateperhour = fetch_user('rateperhour', $uid);
                $rateperhour = $ilance->currency->format($rateperhour);
                
                $show['openingstatement'] = false;
                $openingstatement = fetch_user('profileintro', $uid);
                if (!empty($openingstatement))
                {
                        $show['openingstatement'] = true;
                        $openingstatement = stripslashes($openingstatement);
                }
                
                $fullprofileurl = HTTP_SERVER . $ilpage['members'] . '?id=' . $uid;
                if ($ilconfig['globalauctionsettings_seourls'])
                {
                        $vendorname_plain = construct_seo_url_name($vendorname_plain);
                        $fullprofileurl = HTTP_SERVER . 'members/' . $vendorname_plain;
                }
                
                $pprint_array = array('uid','fullprofileurl','openingstatement','vendorname_plain','skills','columnas','feedbacktabs','membersince','rateperhour','profilevideo','city_state','feedback_pulldown2','allprofilesurl','rolename','dba','dba_pulldown','feedbackviewtype','feedback_pulldown','category_pulldown','subscription','overall_rating','contact_number','profile_logo','credentials_verified','title','firstname','lastname','prevnext','reviews','currency','profile_summary','profile_category','vendorname','vendor_id','isonline','lastseen','country','revenue','stars','id','remote_addr','rid','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
                
                ($apihook = $ilance->api('members_feedback_end')) ? eval($apihook) : false;
                
                $ilance->template->load_file('main', 'member_full_profile.html');
                $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                $ilance->template->parse_loop('main', 'registration_questions');
                $ilance->template->parse_loop('main', 'memberinfo');
                $ilance->template->parse_loop('main', 'profile_question_groups');
                $ilance->template->parse_loop('main', 'default_profile_question_groups');
                @reset($default_profile_question_groups);
                while ($i = @each($default_profile_question_groups))
                {
                        $ilance->template->parse_loop('main', 'default_profile_questions' . $i['value']['groupid']);
                }                        
                @reset($profile_question_groups);
                while ($i = @each($profile_question_groups))
                {
                        $ilance->template->parse_loop('main', 'profile_questions' . $i['value']['groupid']);
                }
                $ilance->template->parse_loop('main', 'feedback');
                $ilance->template->parse_if_blocks('main');
                $ilance->template->pprint('main', $pprint_array);
                exit();
        }
        else
        {
                $area_title = $phrase['_invalid_vendor_id_warning_menu'];
                $page_title = SITE_NAME . ' - ' . $phrase['_invalid_vendor_id_warning_menu'];
                
                print_notice($phrase['_invalid_vendor_profile_id'], $phrase['_your_requested_action_cannot_be_completed_due_to_an_invalid_vendors_id'] . "<br /><br />" . $phrase['_please_contact_customer_support'], $ilpage['main'], $phrase['_main_menu']);
                exit();
        }
}

// #### MEMBER FEEDBACK REVIEW #################################################
else if (isset($ilance->GPC['id']) AND !isset($ilance->GPC['profile']))
{
        $ilance->GPC['feedback'] = isset($ilance->GPC['feedback']) ? $ilance->GPC['feedback'] : '1';
        
	if ($ilance->db->num_rows($sql_vendor) > 0)
        {
		$res_vendor = $ilance->db->fetch_array($sql_vendor);
                
                $vendorname_plain = stripslashes($res_vendor['username']);
                $vendorname = print_username($res_vendor['user_id'], 'href');
                $uid = $res_vendor['user_id'];

                $area_title = $phrase['_viewing_profile_for_vendor'] . ' ' . $vendorname_plain;
		$page_title = SITE_NAME . ' - ' . $phrase['_viewing_profile_for_vendor'] . ' ' . $vendorname_plain;
                
                $navcrumb = array();
                $navcrumb["$ilpage[members]?id=$vendorname_plain"] = $phrase['_members'];
                $navcrumb[""] = $vendorname_plain;
                
                // let's determine if this member has an active profile and active subscription
                if (!$ilance->subscription->has_active_subscription($res_vendor['user_id']) OR $res_vendor['status'] != 'active')
                {
                        print_notice($phrase['_profile_temporarily_inactive'], $phrase['_sorry_the_enhanced_profile_page_for_this_member_is_temporarily_inactive'], 'javascript:history.back(1);', $phrase['_back']);
                        exit();        
                }
		
		// do we display "view portfolio" link under logo?
		$show['portfoliolink'] = 0;
                if (has_portfolio($res_vendor['user_id']) > 0)
                {
                        $show['portfoliolink'] = 1;
                }
		
		// selling (or buying) profile logo / image
		$profile_logo = $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'nophoto.gif';
		$sql_attach = $ilance->db->query("
                        SELECT attachid, filehash
                        FROM " . DB_PREFIX . "attachment
                        WHERE user_id = '" . intval($res_vendor['user_id']) . "'
                                AND visible = '1'
                                AND attachtype = 'profile'
                        LIMIT 1
                ");
		if ($ilance->db->num_rows($sql_attach) > 0)
                {
			$res_attach = $ilance->db->fetch_array($sql_attach);
			$profile_logo = HTTPS_SERVER . $ilpage['attachment'] . '?cmd=profile&amp;id=' . $res_attach['filehash'];
		}
		
                // member start date
                $membersince = print_date(fetch_user('date_added', $uid), '%d-%b-%Y', 0, 0);

		// feedback results
                if (!isset($ilance->GPC['page']) OR isset($ilance->GPC['page']) AND $ilance->GPC['page'] <= 0) 
                { 
                        $page = 1; 
                } 
                else 
                { 
                        $page = intval($ilance->GPC['page']); 
                }
                
                $memberinfo[] = $ilance->feedback->datastore($uid);
                $critera[] = $ilance->feedback->criteria($uid, $_SESSION['ilancedata']['user']['slng']);
                
                $limit = ' ORDER BY id DESC LIMIT ' . (($page - 1) * $ilconfig['globalfilters_maxrowsdisplay']) . ',' . $ilconfig['globalfilters_maxrowsdisplay'];
                $groupby = ' GROUP BY project_id';
                $counter = ($page - 1) * $ilconfig['globalfilters_maxrowsdisplay'];
                
                $show['no_feedback_results'] = true;
                
                // #### FEEDBACK OVERVIEW LOGIC ################################
                if (isset($ilance->GPC['feedback']))
                {
                        switch ($ilance->GPC['feedback'])
                        {
                                // All feedback
                                default:
                                case 1:
                                {
                                        $sqlquery['fields'] = "from_user_id AS uid, response, project_id, comments, date_added, type";
                                        $sqlquery['where'] = "for_user_id = '" . intval($uid) . "'";
                                        break;
                                }
                                // Feedback as a seller
                                case 2:
                                {
                                        $sqlquery['fields'] = "from_user_id AS uid, response, project_id, comments, date_added, type";
                                        $sqlquery['where'] = "for_user_id = '" . intval($uid) . "' AND type = 'seller'";
                                        break;
                                }
                                // Feedback as a buyer
                                case 3:
                                {
                                        $sqlquery['fields'] = "from_user_id AS uid, response, project_id, comments, date_added, type";
                                        $sqlquery['where'] = "for_user_id = '" . intval($uid) . "' AND type = 'buyer'";
                                        break;
                                }
                                // Feedback left for others
                                case 4:
                                {
                                        $sqlquery['fields'] = "for_user_id AS uid, response, project_id, comments, date_added, type";
                                        $sqlquery['where'] = "from_user_id = '" . intval($uid) . "'";
                                        break;
                                }
                        }
                }
                
                $result2 = $ilance->db->query("
                        SELECT $sqlquery[fields]
                        FROM " . DB_PREFIX . "feedback
                        WHERE $sqlquery[where]
                        $groupby
                ");
                $number = $ilance->db->num_rows($result2);
                
                $sqlres = $ilance->db->query("
                        SELECT $sqlquery[fields]
                        FROM " . DB_PREFIX . "feedback
                        WHERE $sqlquery[where]
                        $groupby
                        $limit
                ");
                if ($ilance->db->num_rows($sqlres) > 0)
                {
                        $row_count = 0;
                        $feedback = array();
                        
                        require_once(DIR_CORE . 'functions_bid.php');
                        
                        while ($row = $ilance->db->fetch_array($sqlres))
                        {
                                $sql_project = $ilance->db->query("
                                        SELECT project_title, project_state, project_details, ship_handling, ship_costs, user_id, filtered_auctiontype, buynow, buynow_price, buynow_qty, reserve, cid
                                        FROM " . DB_PREFIX . "projects
                                        WHERE project_id = '" . $row['project_id'] . "'
                                ");
                                if ($ilance->db->num_rows($sql_project) > 0)
                                {
                                        $res_project = $ilance->db->fetch_array($sql_project);
                                        
                                        // todo: check for seo
                                        if ($res_project['project_state'] == 'service')
                                        {
                                                $pagetype = $ilpage['rfp'];
                                                $row['listingtype'] = $phrase['_service_listing'] . '<div class="smaller gray">' . print_auction_bit($row['project_id'], $res_project['filtered_auctiontype'], $res_project['project_details'], $res_project['project_state'], $res_project['buynow_price'], $res_project['buynow_qty'], $res_project['reserve'], $res_project['cid']) . '</div>';
                                        }
                                        else
                                        {
                                                $pagetype = $ilpage['merch'];
                                                $row['listingtype'] = $phrase['_product_listing'] . '<div class="smaller gray">' . print_auction_bit($row['project_id'], $res_project['filtered_auctiontype'], $res_project['project_details'], $res_project['project_state'], $res_project['buynow_price'], $res_project['buynow_qty'], $res_project['reserve'], $res_project['cid']) . '</div>';
                                        }
                                        $row['project_title'] = stripslashes($res_project['project_title']);
                                        $row['viewitem'] = '<a href="' . HTTP_SERVER .  $pagetype . '?id=' . $row['project_id'] . '">' . $phrase['_view_listing'] . '</a>';
                                        
                                        switch ($ilance->GPC['feedback'])
                                        {
                                                // All feedback
                                                default:
                                                case 1:
                                                {
                                                        if ($res_project['project_state'] == 'product')
                                                        {
                                                                $seller_id = intval($uid);
                                                                $buyer_id = $row['uid'];
                                                        }
                                                        else
                                                        {
                                                                $seller_id = $row['uid'];
                                                                $buyer_id = intval($uid);
                                                        }
                                                        $row['wintype'] = $ilance->bid->fetch_auction_win_type($row['project_id'], $res_project['project_state'], $res_project['filtered_auctiontype'], $res_project['project_details'], $seller_id, $buyer_id);
                                                        break;
                                                }
                                                // Feedback as a seller
                                                case 2:
                                                {
                                                        if ($res_project['project_state'] == 'product')
                                                        {
                                                                $seller_id = intval($uid);
                                                                $buyer_id = $row['uid'];
                                                        }
                                                        else
                                                        {
                                                                $seller_id = $row['uid'];
                                                                $buyer_id = intval($uid);
                                                        }
                                                        $row['wintype'] = $ilance->bid->fetch_auction_win_type($row['project_id'], $res_project['project_state'], $res_project['filtered_auctiontype'], $res_project['project_details'], $seller_id, $buyer_id);
                                                        break;
                                                }
                                                // Feedback as a buyer
                                                case 3:
                                                {
                                                        if ($res_project['project_state'] == 'product')
                                                        {
                                                                $seller_id = $row['uid'];
                                                                $buyer_id = intval($uid);
                                                        }
                                                        else
                                                        {
                                                                $seller_id = intval($uid);
                                                                $buyer_id = $row['uid'];
                                                        }
                                                        $row['wintype'] = $ilance->bid->fetch_auction_win_type($row['project_id'], $res_project['project_state'], $res_project['filtered_auctiontype'], $res_project['project_details'], $seller_id, $buyer_id);
                                                        break;
                                                }
                                                // Feedback left for others
                                                case 4:
                                                {
                                                        if ($res_project['project_state'] == 'product')
                                                        {
                                                                $seller_id = intval($uid);
                                                                $buyer_id = $row['uid'];
                                                        }
                                                        else
                                                        {
                                                                $seller_id = $row['uid'];
                                                                $buyer_id = intval($uid);
                                                        }
                                                        $row['wintype'] = $ilance->bid->fetch_auction_win_type($row['project_id'], $res_project['project_state'], $res_project['filtered_auctiontype'], $res_project['project_details'], $seller_id, $buyer_id);
                                                        break;
                                                }
                                        }
                                        
                                        $row['membertype'] = $ilance->feedback->print_from_column_bit($ilance->GPC['feedback'], $res_project['project_state'], $row['type']);
                                        $row['member'] = print_username($row['uid'], 'href');
                                        $row['commentresponse'] = '';
                                        $row['mutuallywithdrawresponse'] = '';
                                        //$row['commentresponse'] = '<div style="padding-left:25px; padding-top:10px; padding-bottom:10px">Reply by ' . $row['member'] . ' (Mar-14-08 06:51):<div class="gray">When you don\'t pay, we let the site know, so we can get our fees back.</div></div>';
                                        
                                        // #### shipping total (if applicable)
                                        if ($res_project['project_state'] == 'product' AND $res_project['ship_handling'] == 'flatrate' AND $res_project['ship_costs'] > 0)
                                        {
                                                $row['shippingtotal'] = $ilance->currency->format($res_project['ship_costs']);
                                        }
                                        else
                                        {
                                                $row['shippingtotal'] = '-';
                                        }
                                        
                                        $amount = $ilance->bid->fetch_auction_win_amount($row['project_id'], $seller_id, $buyer_id);
                                        $row['total'] = $ilance->currency->format($amount);
                                }
                                else
                                {
                                        $res_project = array();
                                        $row['date'] = '-';
                                        $row['project_title'] = $phrase['_delisted'];
                                        $row['viewitem'] = '<span class="gray">' . $phrase['_delisted'] . '</span>';
                                        $row['listingtype'] = '-';
                                        $row['icon'] = '-';
                                        
                                        $row['commentresponse'] = '';
                                        $row['mutuallywithdrawresponse'] = '';
                                        $row['wintype'] = '-';
                                        $row['membertype'] = '';
                                        $row['member'] = '-';
                                        $row['shippingtotal'] = '-';
                                        $row['total'] = $phrase['_unknown'];
                                }
                                
                                $row['comment'] = stripslashes($row['comments']);
                                $row['date'] = print_date($row['date_added'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
                                
                                // rating response
                                switch ($row['response'])
                                {
                                        case 'positive':
                                        {
                                                $row['icon'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/biggrin.gif" align="absmiddle" alt="' . $phrase['_positive'] . '" />';
                                                break;
                                        }                                        
                                        case 'neutral':
                                        {
                                                $row['icon'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/question.gif" align="absmiddle" alt="' . $phrase['_neutral'] . '" />';
                                                break;
                                        }                                        
                                        case 'negative':
                                        {
                                                $row['icon'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/mad.gif" align="absmiddle" alt="' . $phrase['_negative'] . '" />';
                                                break;
                                        }                                        
                                        default:
                                        {
                                                $row['icon'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/question.gif" align="absmiddle" alt="' . $phrase['_pending'] . '" />';
                                                break;
                                        }
                                }
                                
                                $row['class'] = ($row_count % 2) ? 'alt2' : 'alt1';                                
                                
                                $feedback[] = $row;
                                $row_count++;
                        }
                        
                        $show['no_feedback_results'] = false;
                }

                if ($ilconfig['globalauctionsettings_seourls'])
                {
                        $feedbackbit = '';
                        $cidbit = '?cid=0';
                        if (isset($cid) AND $cid > 0)
                        {
                                $cidbit = '?cid=' . $cid;
                        }
                        
                        if (isset($ilance->GPC['feedback']) AND $ilance->GPC['feedback'] > 1)
                        {
                                $feedbackbit = '-feedback-' . intval($ilance->GPC['feedback']);
                        }
        
                        $scriptpage = HTTP_SERVER . 'members/' . $ilance->GPC['id'] . $feedbackbit . $cidbit;
                        $prevnext = print_pagnation($number, $ilconfig['globalfilters_maxrowsdisplay'], $page, $counter, $scriptpage, '');        
                }
                else
                {
                        $cidbit = $feedbackbit = '';
                        if (isset($cid) AND $cid > 0)
                        {
                                $cidbit = '&amp;cid=' . $cid;
                        }
                        
                        if (isset($ilance->GPC['feedback']) AND $ilance->GPC['feedback'] > 1)
                        {
                                $feedbackbit = '&amp;feedback=' . $ilance->GPC['feedback'];
                        }
        
                        $scriptpage = $ilpage['members'] . '?id=' . $ilance->GPC['id'] . $feedbackbit . $cidbit;
                        
                        
                        $prevnext = print_pagnation($number, $ilconfig['globalfilters_maxrowsdisplay'], $page, $counter, $scriptpage, '');        
                }

                $feedbackviewtype = $phrase['_all_feedback_received'];
                
                $tab = intval($ilance->GPC['feedback']);
                if ($tab == 0)
                {
                        $tab = 1;
                }
                $feedbacktabs = $ilance->feedback->print_feedback_tabs($tab, $vendorname_plain);
                $columnas = $ilance->feedback->print_feedback_columnbit($tab);
                
                $show['openingstatement'] = false;
                $openingstatement = fetch_user('profileintro', $uid);
                if (!empty($openingstatement))
                {
                        $show['openingstatement'] = true;
                        $openingstatement = stripslashes($openingstatement);
                }
                
                $fullprofileurl = HTTP_SERVER . $ilpage['members'] . '?id=' . $uid . '&amp;profile=1';
                if ($ilconfig['globalauctionsettings_seourls'])
                {
                        $vendorname_plain = construct_seo_url_name($vendorname_plain);
                        $fullprofileurl = HTTP_SERVER . 'members/' . $vendorname_plain . '-profile';
                }
                
                $pprint_array = array('uid','fullprofileurl','openingstatement','vendorname_plain','skills','columnas','feedbacktabs','membersince','rateperhour','profilevideo','city_state','feedback_pulldown2','allprofilesurl','rolename','dba','dba_pulldown','feedbackviewtype','feedback_pulldown','category_pulldown','subscription','overall_rating','contact_number','profile_logo','credentials_verified','title','firstname','lastname','prevnext','reviews','currency','profile_summary','profile_category','vendorname','vendor_id','isonline','lastseen','country','revenue','stars','id','remote_addr','rid','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
                
                ($apihook = $ilance->api('members_feedback_end')) ? eval($apihook) : false;
                
                $ilance->template->load_file('main', 'member_feedback_profile.html');
                $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                $ilance->template->parse_loop('main', 'criteria');
                $ilance->template->parse_loop('main', 'memberinfo');
                $ilance->template->parse_loop('main', 'feedback');
                $ilance->template->parse_if_blocks('main');
                $ilance->template->pprint('main', $pprint_array);
                exit();
	}
	else
        {
		$area_title = $phrase['_invalid_vendor_id_warning_menu'];
		$page_title = SITE_NAME . ' - ' . $phrase['_invalid_vendor_id_warning_menu'];
		
                print_notice($phrase['_invalid_vendor_profile_id'], $phrase['_your_requested_action_cannot_be_completed_due_to_an_invalid_vendors_id']."<br /><br />".$phrase['_please_contact_customer_support'], $ilpage['main'], $phrase['_main_menu']);
		exit();
	}
}
else
{
	$area_title = $phrase['_invalid_vendor_id_warning_menu'];
	$page_title = SITE_NAME . ' - ' . $phrase['_invalid_vendor_id_warning_menu'];
        
        print_notice($phrase['_invalid_vendor_profile_id'], $phrase['_your_requested_action_cannot_be_completed_due_to_an_invalid_vendors_id'] . "<br /><br />" . $phrase['_please_contact_customer_support'], $ilpage['main'], $phrase['_main_menu']);
	exit();
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: members.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>