<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

// #### load required phrase groups ############################################
$phrase['groups'] = array(
        'rfp',
        'search',
        'accounting',
        'buying',
        'selling',
        'subscription',
        'feedback'
);

// #### load required javascript ###############################################
$jsinclude = array(
        'mootools',
        'modal',
        'jquery'
);

// #### define top header nav ##########################################
$topnavlink = array(
	'main_listings'
);

// #### setup script location ##################################################
define('LOCATION','merch');

// #### require backend ########################################################
require_once('./functions/config.php');

// #### setup default breadcrumb ###############################################
$navcrumb = array("$ilpage[merch]" => $ilcrumbs["$ilpage[merch]"]);

if (!empty($ilance->GPC['crypted']))
{
        $uncrypted = decrypt_url($ilance->GPC['crypted']);
}
else
{
        $uncrypted = array();
}

// #### PREVIEW UNIQUE BID #####################################################
if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'preview-unique-bid' AND isset($ilance->GPC['project_id']) AND $ilance->GPC['project_id'] > 0)
{
        $area_title = $phrase['_preview_my_unique_bid'];
        $page_title = SITE_NAME . ' - ' . $phrase['_preview_my_unique_bid'];
        
        $navcrumb = array("$ilpage[merch]" => $phrase['_preview_my_unique_bid']);
        
        if (empty($_SESSION['ilancedata']['user']['userid']) OR $_SESSION['ilancedata']['user']['userid'] == 0)
        {
                print_notice($area_title, $phrase['_your_session_has_expired_please_login'], 'javascript:history.back(1);', $phrase['_back']);
                exit();         
        }
        
        $project_id = intval($ilance->GPC['project_id']);
        $bidamountformatted = $ilance->currency->format($ilance->GPC['uniquebid']);
        $uniquebid = sprintf("%01.2f", $ilance->GPC['uniquebid']);
        $owner_id = intval($ilance->GPC['owner_id']);
        
        // check bids per day limit
	$ilance->subscription = construct_object('api.subscription');
	
        $bidtotal = $ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'bidlimitperday');
        $bidsleft = max(0, ($bidtotal - fetch_bidcount_today($_SESSION['ilancedata']['user']['userid'])));
        
        if ($ilance->GPC['uniquebid'] <= 0.001)
        {
                print_notice($phrase['_your_offer_is_less_than_1_penny'], $phrase['_you_must_bid_1_penny_or_more_go_back_and_bid_again'] . ' <a href=' . $ilpage['merch'] . '?id=' . intval($ilance->GPC['project_id']) . '>' . $phrase['_click_here'] . '</a>', 'javascript: history.go(-1)', ucwords($phrase['_retry']));
                exit();
        }
        if ($bidsleft == 0)
        {
                $area_title = $phrase['_access_to_bid_is_denied'];
                $page_title = SITE_NAME . ' - ' . $phrase['_access_to_bid_is_denied'];
                
                print_notice($phrase['_access_denied'], $phrase['_your_current_subscription_level_does_not_permit_you_to_use_this_marketplace_resource']." <a href='".$ilpage['subscription']."'><strong>".$phrase['_click_here']."</strong></a>", $ilpage['subscription'], ucwords($phrase['_click_here']), fetch_permission_name('bidlimitperday'));
                exit();        
        }
        
        $ilance->template->load_file('main', 'merch_placeuniquebid_preview.html', 0, 0);
        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
        $ilance->template->parse_if_blocks('main');
        $ilance->template->pprint('main', array('owner_id','uniquebid','bidamountformatted','project_id','input_style','redirect','referer','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
        exit();
}

// #### SUBMIT UNIQUE BID ######################################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'submit-unique-bid' AND isset($ilance->GPC['project_id']) AND $ilance->GPC['project_id'] > 0 AND isset($ilance->GPC['owner_id']) AND $ilance->GPC['owner_id'] > 0 AND isset($ilance->GPC['uniquebid']) AND $ilance->GPC['uniquebid'] > 0 AND isset($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
{
        $ilance->bid = construct_object('api.bid');
        $ilance->bid_lowest_unique = construct_object('api.bid_lowest_unique');
        $ilance->bid_lowest_unique->insert_unique_bid($_SESSION['ilancedata']['user']['userid'], intval($ilance->GPC['owner_id']), intval($ilance->GPC['project_id']), $ilance->GPC['uniquebid']);
        
        // todo: check for seo
        refresh($ilpage['merch'] . '?id=' . intval($ilance->GPC['project_id']));
        exit();
}

// #### INSERT NEW PUBLIC MESSAGE ##############################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'insertmessage' AND isset($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
{
	if (empty($ilance->GPC['message']))
	{
		print_notice($phrase['_message_cannot_be_empty'], $phrase['_please_retry_your_action'], 'javascript: history.go(-1)', $phrase['_retry']);
		exit();
	}
	
	insert_public_message(intval($ilance->GPC['pid']), intval($ilance->GPC['sellerid']), $_SESSION['ilancedata']['user']['userid'], $_SESSION['ilancedata']['user']['username'], $ilance->GPC['message'], $visible = '1');
        
        // todo: check for seo
	refresh($ilpage['merch'] . '?id=' . intval($ilance->GPC['pid']) . '#messages');
	exit();
}
// #### REMOVE PUBLIC MESSAGE ##################################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'removemessage' AND $_SESSION['ilancedata']['user']['isadmin'] == '1')
{
	if (empty($ilance->GPC['messageid']))
	{
		print_notice($phrase['_message_does_not_exist'], $phrase['_please_retry_your_action'], 'javascript: history.go(-1)', $phrase['_retry']);
		exit();
	}
        
	$sql = $ilance->db->query("
                DELETE FROM " . DB_PREFIX . "messages
                WHERE messageid = '" . intval($ilance->GPC['messageid']) . "'
                    AND project_id = '" . intval($ilance->GPC['pid']) . "'
                LIMIT 1
        ", 0, null, __FILE__, __LINE__);
        
        // todo: check for seo
	refresh($ilpage['merch'] . '?id=' . intval($ilance->GPC['pid']) . '#messages');
	exit();
}

// #### BUYNOW INSTANT PAYMENT PROCESS HANDLER #################################
else if (isset($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0
        AND (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_instant-purchase-process' 
	AND isset($ilance->GPC['project_id']) AND $ilance->GPC['project_id'] > 0 
	AND isset($ilance->GPC['seller_id']) AND $ilance->GPC['seller_id'] > 0
        AND isset($ilance->GPC['buyer_id']) AND $ilance->GPC['buyer_id'] > 0
        AND isset($ilance->GPC['qty']) AND $ilance->GPC['qty'] > 0)
        
	OR isset($uncrypted['cmd']) AND $uncrypted['cmd'] == '_instant-purchase-process' 
	AND isset($uncrypted['project_id']) AND $uncrypted['project_id'] > 0 
	AND isset($uncrypted['seller_id']) AND $uncrypted['seller_id'] > 0
        AND isset($uncrypted['buyer_id']) AND $uncrypted['buyer_id'] > 0
        AND isset($uncrypted['qty']) AND $uncrypted['qty'] > 0)
{
        $ilance->escrow = construct_object('api.escrow');
        $ilance->categories->build_array($cattype = 'product', $_SESSION['ilancedata']['user']['slng'], $mode = 0, $propersort = true);
        
        $success = 0;
        
        $status = fetch_auction('status', $uncrypted['project_id']);
        if ($status != 'open')
        {
                print_notice($phrase['_access_denied'], $phrase['_this_listing_has_ended'], 'javascript:history.back(2);', $phrase['_back']);
                exit();         
        }
        
	// does the seller use escrow?
	$show['filter_escrow'] = fetch_auction('filter_escrow', $uncrypted['project_id']);
        if ($ilconfig['escrowsystem_enabled'] AND $show['filter_escrow'])
        {
                // instant purchase via online account?
                if ($ilance->GPC['account_id'] == 'account')
                {
                        $success = $ilance->escrow->instant_purchase_now('account', $uncrypted['project_id'], $uncrypted['qty'], $uncrypted['amount'], $uncrypted['total'], $uncrypted['seller_id'], $_SESSION['ilancedata']['user']['userid'], $ilance->GPC['shipping_address_required'], $ilance->GPC['shipping_address_id'], $ilance->GPC['account_id']);
                        if ($success)
                        {
                                $area_title = $phrase['_instant_purchase_to_escrow_via_online_account_complete'];
                                $page_title = SITE_NAME . ' - ' . $phrase['_instant_purchase_to_escrow_via_online_account_complete'];
                                
                                print_notice($phrase['_invoice_payment_complete'], $phrase['_your_invoice_has_been_paid_in_full'], $ilpage['buying'].'?cmd=management&sub=buynow-escrow', $phrase['_escrow_management']);
                                exit();
                        }
                        else
                        {
                                $area_title = $phrase['_no_funds_available_in_online_account'];
                                $page_title = SITE_NAME . ' - ' . $phrase['_no_funds_available_in_online_account'];
                                
                                print_notice($phrase['_invoice_payment_warning_insufficient_funds'], $phrase['_were_sorry_this_invoice_can_not_be_paid_due_to_insufficient_funds']."<br /><br />".$phrase['_please_contact_customer_support'], $ilpage['accounting'], $phrase['_my_account']);
                                exit();
                        }
                }
                else
                {
                        // instant purchase via credit card on file?
                        if ($ilconfig['use_internal_gateway'] != 'none')
                        {
                                $success = $ilance->escrow->instant_purchase_now('creditcard', $uncrypted['project_id'], $uncrypted['qty'], $uncrypted['amount'], $uncrypted['total'], $uncrypted['seller_id'], $_SESSION['ilancedata']['user']['userid'], $ilance->GPC['shipping_address_required'], $ilance->GPC['shipping_address_id'], $ilance->GPC['account_id']);
                                if ($success)
                                {
                                        $area_title = $phrase['_instant_purchase_to_escrow_via_online_account_complete'];
                                        $page_title = SITE_NAME . ' - ' . $phrase['_instant_purchase_to_escrow_via_online_account_complete'];
                                        
                                        print_notice($phrase['_invoice_payment_complete'], $phrase['_your_invoice_has_been_paid_in_full'], $ilpage['buying'].'?cmd=management&sub=buynow-escrow', $phrase['_escrow_management']);
                                        exit();
                                }
                                else
                                {
                                        $area_title = $phrase['_escrow_payment_payment_denied'];
                                        $page_title = SITE_NAME . ' - ' . $phrase['_escrow_payment_payment_denied'];
                                        
                                        print_notice($phrase['_invoice_error'], "There was a problem communicating with the merchant gateway.  Please Try again later.<br /><br />".$phrase['_please_contact_customer_support'], $ilpage['accounting'], $phrase['_my_account']);
                                        exit();
                                }
                        }
                        else
                        {
                                refresh($ilpage['merch'].'?id='.$uncrypted['project_id'], $ilpage['merch'].'?id='.$uncrypted['project_id']);
                                exit();
                        }
                }    
        }
        else
        {
                // no escrow enabled: assuming outside payment communications
                // because of this we'll make sure that the seller has funds to cover this "FVF" if applicable in this category
                // if he does we'll debit it right away
                // if he does not we'll generate unpaid invoice as a last alternative to get that commission fee!
                $success = $ilance->escrow->instant_purchase_now('offline', $uncrypted['project_id'], $uncrypted['qty'], $uncrypted['amount'], $uncrypted['total'], $uncrypted['seller_id'], $_SESSION['ilancedata']['user']['userid'], $ilance->GPC['shipping_address_required'], $ilance->GPC['shipping_address_id'], 0);
                if ($success)
                {
                        $area_title = $phrase['_congratulations_you_purchased_this_item'];
                        $page_title = SITE_NAME . ' - ' . $phrase['_congratulations_you_purchased_this_item'];
                        
                        print_notice($phrase['_you_confirmed_a_purchase_now_order'], $phrase['_congratulations_you_have_successfully_confirmed_the_purchase_of_this_item_we_have_dispatched_you_an_email'], $ilpage['buying'] . '?cmd=management&sub=buynow-escrow', $phrase['_buying_activity']);
                        exit();
                }
        }
}

// #### BUYNOW CONFIMRATION PAGE AND ITEM ORDER DISPLAY ########################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'purchase-confirm' AND isset($ilance->GPC['pid']) AND $ilance->GPC['pid'] > 0 AND isset($ilance->GPC['qty']) AND $ilance->GPC['qty'] > 0)
{
        if (!empty($_COOKIE[COOKIE_PREFIX . 'username']))
        {
                $user_cookie = $ilance->crypt->three_layer_decrypt($_COOKIE[COOKIE_PREFIX . 'username'], $ilconfig['key1'], $ilconfig['key2'], $ilconfig['key3']);
        }
        
        $project_id = intval($ilance->GPC['pid']);
        $seller_id = fetch_auction('user_id', $project_id);
        $amount = fetch_auction('buynow_price', $project_id);
        $qty = (isset($ilance->GPC['qty']) AND $ilance->GPC['qty'] > 0) ? number_format(intval($ilance->GPC['qty']), '') : 1;
        
        $area_title = $phrase['_access_denied'];
        $page_title = SITE_NAME . ' - ' . $phrase['_access_denied'];
        
        $qtyleft = fetch_auction('buynow_qty', $project_id);
        if ($qty > $qtyleft)
        {
                print_notice($area_title, $phrase['_it_appears_you_are_trying_to_purchase_more_quantity_than_this_seller_is_currently_offering'], 'javascript:history.back(1);', $phrase['_back']);
                exit();         
        }
    
        // make sure we are not the seller of this auction!
        if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0 AND $_SESSION['ilancedata']['user']['userid'] == $seller_id)
        {
                print_notice($area_title, $phrase['_it_appears_you_are_the_seller_of_this_listing_in_this_case_you_cannot_bid_or_purchase_items_from_your_own_listing'], 'javascript:history.back(1);', $phrase['_back']);
                exit();       
        }
        
        /*
        if (empty($_SESSION['ilancedata']['user']['userid']) OR $_SESSION['ilancedata']['user']['userid'] == 0)
        {
                print_notice($area_title, $phrase['_your_session_has_expired_please_login'], 'javascript:history.back(1);', $phrase['_back']);
                exit();         
        }*/
        
        if (empty($_SESSION['ilancedata']['user']['userid']) OR $_SESSION['ilancedata']['user']['userid'] == 0)
        {
                refresh(HTTPS_SERVER . $ilpage['login'] . '?redirect=' . urlencode($ilpage['merch'] . print_hidden_fields($string = true, $excluded = array(), $questionmarkfirst = true)));
                exit();
        }
        
        $area_title = $phrase['_purchase_now_order_confirmation'];
        $page_title = SITE_NAME . ' - ' . $phrase['_purchase_now_order_confirmation'];
        
        // do we have anything left to purchase?
        $sql = $ilance->db->query("
                SELECT filtered_auctiontype, buynow_qty, ship_handling, ship_costs, project_title
                FROM " . DB_PREFIX . "projects
                WHERE project_id = '" . $project_id . "'
                    AND buynow_qty > 0
                LIMIT 1
        ", 0, null, __FILE__, __LINE__);
        if ($ilance->db->num_rows($sql) == 0)
        {
                print_notice($phrase['_this_item_has_sold_out'], $phrase['_were_sorry_either_one_or_more_customers_have_already_purchased_this_item_and_the_qty'].'<br /><br />'.$phrase['_please_contact_customer_support'], $ilpage['merch'].'?cmd=listings', $phrase['_view_other_merchandise']);
                exit();
        }
        
        $res = $ilance->db->fetch_array($sql);
        
        $show['filter_escrow'] = fetch_auction('filter_escrow', intval($project_id));
        $paymethod = fetch_auction('paymethod', intval($project_id));
        
        $show['sellerusingescrow'] = $show['filter_escrow'];
        $show['noshipping'] = $show['digitaldownload'] = 0;
        
        $cb_shipping_address_required0 = $digitalfile = '';
        $cb_shipping_address_required1 = 'checked="checked"';
        $seller = print_username($seller_id, 'href');
        $amount_formatted = $ilance->currency->format($amount);
        $ship_handling = $res['ship_handling'];
        
        switch ($ship_handling)
        {
                case 'flatrate':
                {
                        $samount = $ilance->currency->format($res['ship_costs']);
                        $topay = $ilance->currency->format(($amount * $qty) + $res['ship_costs']);
                        $total = ($amount * $qty) + $res['ship_costs'];
                        
                        break;
                }
                case 'digital':
                {
                        $show['noshipping'] = $show['digitaldownload'] = 1;
                        
                        $samount = $ilance->currency->format(0);
                        $topay = $ilance->currency->format($amount * $qty);
                        $total = ($amount * $qty);
                
                        $dquery = $ilance->db->query("
                                SELECT filename, filesize, attachid
                                FROM " . DB_PREFIX . "attachment
                                WHERE project_id = '" . intval($project_id) . "'
                                    AND attachtype = 'digital'
                                    AND user_id = '" . intval($seller_id) . "'
                                LIMIT 1
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($dquery) > 0)
                        {
                                $dfile = $ilance->db->fetch_array($dquery);
                                $digitalfile = stripslashes($dfile['filename']) . ' (' . print_filesize($dfile['filesize']) . ')';
                        }
                        
                        $cb_shipping_address_required1 = '';
                        $cb_shipping_address_required0 = 'checked="checked"';
                        
                        break;
                }
                case 'none':
                case 'sellerpays':
                {
                        $samount = $ilance->currency->format(0);
                        $topay = $ilance->currency->format($amount * $qty);
                        $total = ($amount * $qty);
                        
                        break;
                }
        }
        
        $project_title = stripslashes($res['project_title']);
        
        // thumbnail dimension logic
        $attachment = print_item_photo('javascript:void(0)', 'thumb', $project_id);
        
        $show['requestlogin'] = 1;
        $show['makepayment'] = $fee = 0;
        
        $tax = $ilance->currency->format(0);
        
        // #### PRODUCT BUYER ESCROW FEES ##########################
        // we'll populate the fee2 field which denotes any fees the buyer of this buynow purchase
        // must pay the site owner .. we'll also calculate any tax if applicable to ensure that the
        // fee to the buyer will include the full fee amount + any applicable taxes (for commission txns)
   
        // escrow commission fees to auction owner enabled
        if ($show['filter_escrow'] AND $ilconfig['escrowsystem_bidderfixedprice'] > 0)
        {
                // fixed escrow cost to buyer
                $fee = sprintf("%01.2f", $ilconfig['escrowsystem_bidderfixedprice']);
        }
        else
        {
                if ($show['filter_escrow'] AND $ilconfig['escrowsystem_bidderpercentrate'] > 0)
                {
                        // percentage rate of total winning bid amount
                        // which would be the same as the amount being forwarded into escrow
                        $fee = sprintf("%01.2f", ($total * $ilconfig['escrowsystem_bidderpercentrate'] / 100));
                }
        }
        
        $show['taxbit'] = false;
        
        if ($fee > 0)
        {
                $taxamount = 0;
                $ilance->tax = construct_object('api.tax');
                if ($ilance->tax->is_taxable($_SESSION['ilancedata']['user']['userid'], 'commission'))
                {
                        // fetch tax amount to charge for this invoice type
                        $taxamount = $ilance->tax->fetch_amount($_SESSION['ilancedata']['user']['userid'], $fee, 'commission', 0);
                        $tax = $ilance->currency->format($taxamount);
                        
                        $show['taxbit'] = true;
                }
                
                // exact amount to charge buyer
                $fee = sprintf("%01.2f", ($fee + $taxamount));
        }
        
        // total plus escrow fee
        $total = ($total + $fee);
        $topay = $ilance->currency->format($total);
        $fees = '-';
        if ($fee > 0)
        {
                $fees = $ilance->currency->format($fee);
        }
        
        // display the log-in block to gusts who may be already a member (to just login)
        if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
        {
                $show['requestlogin'] = 0;
                $show['makepayment'] = 1;    			
                $forceredirect = '';
        }
        else
        {
                $show['requestlogin'] = 1;
                $show['makepayment'] = 0;
                
                $crypted = array(
                        'cmd' => '_purchase-confirm',
                        'project_id' => $project_id,
                        'seller_id' => $seller_id,
                        'qty' => $qty,
                        'amount' => $amount,
                );
                
        }
        
        $payment_method_pulldown = print_paymethod_pulldown('account', 'account_id', $_SESSION['ilancedata']['user']['userid']);
        $shipping_address_pulldown = print_shipping_address_pulldown($_SESSION['ilancedata']['user']['userid']);
        
        $hiddeninput = array(
                'cmd' => '_instant-purchase-process',
                'project_id' => $project_id,
                'buyer_id' => $_SESSION['ilancedata']['user']['userid'],
                'seller_id' => $seller_id,
                'fee' => $fee,
                'qty' => $qty,
                'total' => sprintf("%01.2f", $total),
                'amount' => $amount,
        );
        
        $encrypted = encrypt_url($hiddeninput);
        
        $returnurl = urlencode($ilpage['merch'] . '?cmd=purchase-confirm&amp;pid=' . intval($project_id) . '&amp;qty=' . intval($ilance->GPC['qty']));
        
        $ilance->template->load_file('main', 'merch_buynow.html');
        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
        $ilance->template->parse_if_blocks('main');
        $ilance->template->pprint('main', array('returnurl','tax','paymethod','fees','digitalfile','cb_shipping_address_required1','cb_shipping_address_required0','encrypted','samount','amount_formatted','total','shipping_address_pulldown','forceredirect','payment_method_pulldown','attachment','project_id','seller_id','buyer_id','user_cookie','project_title','seller','qty','topay','amount','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','category','subcategory'));
        exit();
}

// #### ITEM CATEGORY LISTINGS #################################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'listings')
{
        $show['widescreen'] = true;
        
        $area_title = $phrase['_buy'] . ' - ' . $phrase['_viewing_all_categories'];
	$page_title = SITE_NAME . ' - ' . $phrase['_buy'] . ' - ' . $phrase['_viewing_all_categories'];
	
	// #### define top header nav ##########################################
        $topnavlink = array(
                'main_categories'
        );

        $cid = !empty($ilance->GPC['cid']) ? intval($ilance->GPC['cid']) : 0;
        
        $ilance->categories_parser = construct_object('api.categories_parser');
        $ilance->categories_pulldown = construct_object('api.categories_pulldown');
	$ilance->auction = construct_object('api.auction');
	$ilance->bid = construct_object('api.bid');
	$ilance->subscription = construct_object('api.subscription');
        
        $categorycache = $ilance->categories->build_array($cattype = 'product', $_SESSION['ilancedata']['user']['slng'], $mode = 0, $propersort = true);
        $seoproductcategories = print_seo_url($ilconfig['categoryidentifier']);
        
        if ($cid > 0)
        {
                $navcrumb = array();
                $ilance->categories->breadcrumb($cid, 'productcatmap', $_SESSION['ilancedata']['user']['slng'], $categorycache);
                
                // update category view count
                add_category_viewcount($cid);
        }
        else
        {
                if ($ilconfig['globalauctionsettings_seourls'])
                {
                        $navurl = HTTP_SERVER . $seoproductcategories;
                }
                else
                {
                        $navurl = HTTP_SERVER . $ilpage['main'] . '?cmd=categories';
                }
                
                $navcrumb = array();
                $navcrumb["$navurl"] = $phrase['_categories'];
                $navcrumb[""] = $phrase['_buy'];
        }
        
        $cathtml = $ilance->categories->recursive($cid, 'productcatmap', $_SESSION['ilancedata']['user']['slng'], $nourls = 0, $customlink = '', $ilconfig['globalauctionsettings_seourls']);
        
        $recursivecategory = $auctioncount = '';
        $show['canpost'] = false;
        
        if (!empty($cathtml))
        {
                $metatitle = $ilance->categories->title($_SESSION['ilancedata']['user']['slng'], 'product', $cid);
                $metadescription = $ilance->categories->description($_SESSION['ilancedata']['user']['slng'], 'product', $cid);
                $metakeywords = $ilance->categories->keywords($_SESSION['ilancedata']['user']['slng'], 'product', $cid);
                
                if (empty($metadescription))
                {
                        $metadescription = $phrase['_find_new_and_used_items_in'] . ' ' . $metatitle;
                }
                
                $area_title = $phrase['_categories'] . ' - ' . $metatitle;
                $page_title = SITE_NAME . ' - ' . $metadescription;
        
                $temp = $ilance->categories->fetch[$_SESSION['ilancedata']['user']['slng']]['product'][$cid];                
                if ($ilconfig['globalfilters_enablecategorycount'])
                {
                        $auctioncount = '<span class="gray">(' . $temp['auctioncount'] . ')</span>';
                }
                
                if ($ilance->categories->can_post($_SESSION['ilancedata']['user']['slng'], 'product', $cid))
                {
                        $show['canpost'] = true;
                }
                else 
                {
                        $show['categorycolumn'] = true;
                }
        }
        
        $categoryresults = $ilance->categories_parser->print_subcategory_columns($columns = 4, $cattype = 'product', $dosubcats = 1, $_SESSION['ilancedata']['user']['slng'], $cid, $extra = '', $ilconfig['globalfilters_enablecategorycount'], $iscatmap = 1, $titlestyle = 'font-weight: bold;', $ilconfig['globalauctionsettings_catmapdepth'], $categorycache);
	$category = $description = '';
        $text = $phrase['_browse_product_auctions_via_marketplace_categories'];
	
	if ($cid > 0)
	{
		$category = $ilance->categories->title($_SESSION['ilancedata']['user']['slng'], 'product', $cid);
                $description = $ilance->categories->description($_SESSION['ilancedata']['user']['slng'], 'product', $cid);
                $text = $phrase['_categories_within'] . ' ' . $category;
	}
        
        $recursivecategory = $ilconfig['globalauctionsettings_seourls'] ? '<div style="padding-left:6px; padding-top:6px"><span class="blue"><a href="' . construct_seo_url('productcatplain', $cid, $auctionid = 0, $category, $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) . '"><strong>' . $phrase['_see_all_listings_in_this_category'] . '</strong></a></span>: <span><strong>' . $category . '</strong></span> ' . $auctioncount . '</div>' : '<div style="padding-left:6px; padding-top:6px"><span class="blue"><a href="' . $ilpage['search'] . '?mode=product&amp;cid=' . $cid . '"><strong>' . $phrase['_see_all_listings_in_this_category'] . '</strong></a></span>: <span><strong>' . $category . '</strong></span> ' . $auctioncount . '</div>';
        $latestproductauctions = array();
        $show['searchbar'] = false;
        
        if (empty($recursivecategory) OR $cid == 0)
        {
                $show['searchbar'] = true;
                $recursivecategory = '<div class="gray" style="padding-left:5px; padding-top:6px; font-size:16px;"><strong>' . $phrase['_viewing_all_categories'] . '</strong></div>';
        }
	else
	{
		// latest featured product auctions from selected category
		$latestproductauctions = $ilance->auction->fetch_latest_auctions('product', 5, 1, $cid);
	}
        
        // if we have no children, redirect user to the appropriate result listings pages for this category
        if (isset($cid) AND $cid > 0 AND $ilance->categories->fetch_children_ids($cid, 'product') == '')
        {
                $url = ($ilconfig['globalauctionsettings_seourls']) ? construct_seo_url('productcatplain', $cid, $auctionid = 0, $category, $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) : $ilpage['search'] . '?mode=product&cid=' . $cid;
                header("Location: $url");
        }
        
        if ($ilconfig['multilevelpulldown'])
        {
                $search_category_pulldown = $ilance->categories_pulldown->print_cat_pulldown($cid, $cattype = 'product', $type = 'level', $fieldname = 'cid', $showpleaseselectoption = 1, $_SESSION['ilancedata']['user']['slng'], $nooptgroups = 1, $prepopulate = '', $mode = 0, $showallcats = 1, $dojs = 0, $width = '540px', $uid = 0, $forcenocount = 1, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = true, $ilance->categories->cats);
        }
        else
        {
                $search_category_pulldown = $ilance->categories_pulldown->print_root_category_pulldown($cid, 'product', 'cid', $_SESSION['ilancedata']['user']['slng'], $ilance->categories->cats);
        }
        unset($categorycache);
        
        // #### SEO related ####################################################
        $seoproductcategories = print_seo_url($ilconfig['productcatmapidentifier']);
        $seoservicecategories = print_seo_url($ilconfig['servicecatmapidentifier']);
        $seolistings = print_seo_url($ilconfig['listingsidentifier']);
        $seocategories = print_seo_url($ilconfig['categoryidentifier']);
        
        $pprint_array = array('seoservicecategories','seoproductcategories','seolistings','seocategories','search_category_pulldown','description','text','categorypulldown','recursivecategory','category','cid','php_self','categoryresults','three_column_subcategory_results','category','number','prevnext','input_style','keywords','search_country_pulldown','search_jobtype_pulldown','five_last_keywords_buynow','five_last_keywords_projects','five_last_keywords_providers','search_ratingrange_pulldown','search_awardrange_pulldown','search_bidrange_pulldown','search_listed_pulldown','search_closing_pulldown','search_category_pulldown','input_style','distance','subcategory_name','text','prevnext','prevnext2','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
        
	$ilance->template->load_file('main', 'merch_listings.html');
        $ilance->template->parse_loop('main', 'latestproductauctions');
	$ilance->template->parse_hash('main', array('ilpage' => $ilpage));
        $ilance->template->parse_if_blocks('main');
	$ilance->template->pprint('main', $pprint_array);
	exit();
}

// #### PRODUCT AUCTION CATEGORY LISTINGS VIA CATEGORY ID ######################
else if (!empty($ilance->GPC['cid']) AND $ilance->GPC['cid'] > 0 AND empty($ilance->GPC['cmd']))
{
        // update category view count
        add_category_viewcount(intval($ilance->GPC['cid']));
        
        $ilance->categories->build_array($cattype = 'product', $_SESSION['ilancedata']['user']['slng'], $mode = 0, $propersort = false);
        
        if ($ilance->categories->can_post($_SESSION['ilancedata']['user']['slng'], 'product', intval($ilance->GPC['cid'])))
        {
                $urlbit = print_hidden_fields($string = true, $excluded = array(), $questionmarkfirst = false);
                header('Location: ' . $ilpage['search'] . '?mode=product' . $urlbit);
                exit();
        }
        
        $urlbit = print_hidden_fields($string = true, $excluded = array('cid'), $questionmarkfirst = false);
        header('Location: ' . $ilpage['merch'] . '?cmd=listings&cid=' . intval($ilance->GPC['cid']) . $urlbit);
        exit();
}
// #### ITEM REVISION LOG ######################################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'revisionlog' AND isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0)
{
        $page_title = SITE_NAME . ' - ' . $phrase['_listing_revision_details'];
	$area_title = $phrase['_listing_revision_details'];

        $id = isset($ilance->GPC['id']) ? intval($ilance->GPC['id']) : 0;

        $navcrumb = array();
        $navcrumb["$ilpage[merch]?id=" . $id] = $id;
        $navcrumb[""] = $phrase['_listing_revision_details'];
        
        $returnurl = $ilpage['merch'] . '?id=' . $id;
        
        $sql = $ilance->db->query("
                SELECT datetime, changelog
                FROM " . DB_PREFIX . "projects_changelog
                WHERE project_id = '" . $id . "'
                ORDER BY id DESC
        ", 0, null, __FILE__, __LINE__);
        if ($ilance->db->num_rows($sql) > 0)
        {
                $show['revision'] = true;
                $row_count = 0;
                while ($rows = $ilance->db->fetch_array($sql))
                {
                        $rows['datetime'] = print_date($rows['datetime'], $ilconfig['globalserverlocale_globaltimeformat'], 1, 1, 0, 1);
                        $rows['info'] = stripslashes($rows['changelog']);
                        $rows['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                        $revisions[] = $rows;
                        $row_count++;
                }
        }
        else
        {
                $show['revision'] = false;
        }
        
        $ilance->template->load_file('main', 'revisionlog.html');
        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
        $ilance->template->parse_loop('main', 'revisions');
        $ilance->template->parse_if_blocks('main');
        $ilance->template->pprint('main', array('returnurl','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
        exit();
}
else
{
	// #### BAD AUCTION ID PAGE ############################################
	if (empty($ilance->GPC['id']) OR $ilance->GPC['id'] == 0)
	{
		$area_title = $phrase['_bad_rfp_warning_menu'];
		$page_title = SITE_NAME . ' - ' . $phrase['_bad_rfp_warning_menu'];
                
		print_notice($phrase['_invalid_rfp_specified'], $phrase['_your_request_to_review_or_place_a_bid_on_a_valid_request_for_proposal'], $ilpage['search'], $phrase['_search_rfps']);
                exit();
	}
        
        // #### DETAILED AUCTION LISTING #######################################
	else
	{
                $show['widescreen'] = true;
		
		$ilance->bid = construct_object('api.bid');
		$ilance->bid_lowest_unique = construct_object('api.bid_lowest_unique');
		$ilance->bid_proxy = construct_object('api.bid_proxy');
		$ilance->subscription = construct_object('api.subscription');
		$ilance->feedback = construct_object('api.feedback');
                $ilance->feedback_rating = construct_object('api.feedback_rating');
		$ilance->auction = construct_object('api.auction');
                $categorycache = $ilance->categories->build_array($cattype = 'product', $_SESSION['ilancedata']['user']['slng'], $mode = 0, $propersort = true);
		
		$project_id = intval($ilance->GPC['id']);
		
		$sql = $ilance->db->query("
			SELECT *, UNIX_TIMESTAMP(date_end) - UNIX_TIMESTAMP('" . DATETIME24H . "') AS mytime
			FROM " . DB_PREFIX . "projects
			WHERE project_id = '" . intval($ilance->GPC['id']) . "'
			    AND project_state = 'product'
			    " . (($ilconfig['globalauctionsettings_payperpost']) ? "AND visible = '1' AND (insertionfee = 0 OR (insertionfee > 0 AND ifinvoiceid > 0 AND isifpaid = '1'))" : "AND visible = '1'") . "
			LIMIT 1
		", 0, null, __FILE__, __LINE__);
		if ($ilance->db->num_rows($sql) > 0)
		{
                        $res = $ilance->db->fetch_array($sql);
                        
                        // #### prevent duplicate content from search engines 
                        if ($ilconfig['globalauctionsettings_seourls'] AND (!isset($ilance->GPC['sef']) OR empty($ilance->GPC['sef'])))
                        {
                                $seourl = construct_seo_url('productauctionplain', $res['cid'], $res['project_id'], stripslashes($res['project_title']), $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0, $removevar = '');
                                $view = isset($ilance->GPC['view']) ? '?view=' . $ilance->GPC['view'] : '';
                                header('Location: ' . $seourl . $view);
                                unset($seourl);
                                exit();
                        }
                        
                        ($apihook = $ilance->api('merch_detailed_start')) ? eval($apihook) : false;
                        
                        $metakeywords =  $ilance->categories->keywords($_SESSION['ilancedata']['user']['slng'], 'product', $res['cid']);
                        $metadescription = $ilance->categories->description($_SESSION['ilancedata']['user']['slng'], 'product', $res['cid']);
	    
                        $views = $res['views'];
                        
                        // #### revision details ###############################
                        $updateid = $res['updateid'];
                        $show['revision'] = false;
                        if ($updateid > 0)
                        {
                                $show['revision'] = true;
                                $updateid = '<a href="' . $ilpage['merch'] . '?cmd=revisionlog&amp;id=' . $res['project_id'] . '" style="text-decoration:underline">' . ($res['updateid']) . '</a>';
                        }
                        
                        // #### bid increments in this category ################
                        $show['increments'] = false;
                        $increment = '';
                        $cbid = $ilance->bid->fetch_current_bid($res['project_id'], $noformat = 1);

                        $incrementgroup = $ilance->categories->fetch[$_SESSION['ilancedata']['user']['slng']]['product'][$res['cid']]['incrementgroup'];
                        $sqlincrements = $ilance->db->query("
                                SELECT amount
                                FROM " . DB_PREFIX . "increments
                                WHERE ((increment_from <= $cbid
                                        AND increment_to >= $cbid)
                                                OR (increment_from < $cbid
                                        AND increment_to < $cbid))
                                        AND groupname = '" . $ilance->db->escape_string($incrementgroup) . "'
                                ORDER BY amount DESC
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($sqlincrements) > 0)
                        {
                                $show['increments'] = true;
                                
                                // increment
                                $resincrement = $ilance->db->fetch_array($sqlincrements);
                                $increment = $ilance->currency->format($resincrement['amount']) . ' - <span class="blue"><a href="javascript:void(0)" onclick="Attach(\'' . HTTP_SERVER . $ilpage['rfp'] . '?msg=bid-increments&amp;c=' . $res['cid'] . '\')">' . $phrase['_view'] . ' ' . $phrase['_bid_increments'] . '</a></span>';
                        }
                        
			// #### payment methods accepted #######################
			if ($ilconfig['escrowsystem_enabled'] AND $res['filter_escrow'])
			{
				$paymentmethods = SITE_NAME . ' ' . $phrase['_escrow_service'];
			}
			else
			{
				$paymentmethods = stripslashes($res['paymethod']);	
			}
			
			// #### recently viewed auction cookie saver ###########
			if (!empty($_COOKIE[COOKIE_PREFIX . 'productauctions']))
			{
				$arr = explode('|', $_COOKIE[COOKIE_PREFIX . 'productauctions']);
				if (!in_array(intval($ilance->GPC['id']), $arr))
				{
					$_COOKIE[COOKIE_PREFIX . 'productauctions'] = $_COOKIE[COOKIE_PREFIX . 'productauctions'] . '|' . intval($ilance->GPC['id']);
					set_cookie('productauctions', $_COOKIE[COOKIE_PREFIX . 'productauctions'], true);
				}
			}
			else
			{
				$_COOKIE[COOKIE_PREFIX . 'productauctions'] = intval($ilance->GPC['id']);
				set_cookie('productauctions', $_COOKIE[COOKIE_PREFIX . 'productauctions'], true);
			}
				    
			// #### public message board ###########################
			$show['publicboard'] = $msgcount = 0;
			if ($res['filter_publicboard'])
			{
				$show['publicboard'] = 1;
                                
				$sqlmessages = $ilance->db->query("
					SELECT date, message, project_id, user_id, username
					FROM " . DB_PREFIX . "messages
					WHERE project_id = '" . $res['project_id'] . "'
					ORDER BY messageid ASC
				", 0, null, __FILE__, __LINE__);
				if ($ilance->db->num_rows($sqlmessages) > 0)
				{
					$msgcount = 0;
					while ($message = $ilance->db->fetch_array($sqlmessages))
					{
						$message['date'] = print_date($message['date'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
                                                if ($message['user_id'] == $res['user_id'])
                                                {
                                                        $message['message'] = '<span class="green">[' . $phrase['_seller'] . ']</span> ' . strip_vulgar_words(ilance_htmlentities($message['message'])) . '';
                                                }
                                                else
                                                {
                                                        $message['message'] = '<span class="blue">[' . $phrase['_bidder'] . ']</span> ' . strip_vulgar_words(ilance_htmlentities($message['message'])) . '';
                                                }
						$message['message'] = strip_vulgar_words($message['message']);
						$message['class'] = ($msgcount % 2) ? 'alt2' : 'alt1';
						$messages[] = $message;	
						$msgcount++;
					}
				}
			}
				    
			$ilance->db->query("
				UPDATE " . DB_PREFIX . "projects
				SET views = views + 1
				WHERE project_id = '" . intval($ilance->GPC['id']) . "'
				    AND status != 'draft'
			", 0, null, __FILE__, __LINE__);
				    
                        $area_title = $phrase['_viewing_detailed_item'] . ' ' . stripslashes($res['project_title']) . ' (' . intval($ilance->GPC['id']) . ')';
                        $page_title = stripslashes($res['project_title']) . ' (' . intval($ilance->GPC['id']) . ') - ' . SITE_NAME;
	    
			$row_count = 0;
	    
			// photo slideshow
			// we use '-5' to determine the image as the main product auction image so let's not include in slideshow
			$show['slideshow'] = false;
                        
			$slideimage1 = $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'nophoto.gif';
			$slideshowpulldown = '<select id="slidepulldown" name="slide" onchange="change();" style="font-family: verdana" class="smaller">';
			$project_attachment = $phrase['_no_attachments_available'];
			$firstslide = '';
			$imagecount = 0;
			
			$sql_attachments = $ilance->db->query("
				SELECT attachid, attachtype, user_id, portfolio_id, project_id, pmb_id, category_id, date, filename, filetype, visible, counter, filesize, filehash, ipaddress, tblfolder_ref
				FROM " . DB_PREFIX . "attachment
				WHERE project_id = '" . intval($ilance->GPC['id']) . "'
				    AND tblfolder_ref != '-5'
                                    AND attachtype != 'digital'
			", 0, null, __FILE__, __LINE__);
			if ($ilance->db->num_rows($sql_attachments) > 0)
			{
                                $show['slideshow'] = true;
                                
				while ($res2 = $ilance->db->fetch_array($sql_attachments))
				{
					$imagecount++;
					if ($imagecount == 1)
					{
						$firstslide = 'selected="selected"';
						$slideimage1 = $ilpage['attachment'] . '?cmd=thumb&id=' . $res2['filehash'] . '&w=' . $ilconfig['portfoliodisplay_popups_width'] . '&h=' . $ilconfig['portfoliodisplay_popups_height'];
					}
					
					if ($res2['visible'])
					{
						switch (fetch_extension($res2['filename']))
						{
							case 'gif':
                                                        {
                                                                $slideshowpulldown .= '<option value="' . $ilpage['attachment'] . '?id=' . $res2['filehash'] . '&w=' . $ilconfig['portfoliodisplay_popups_width'] . '&h=' . $ilconfig['portfoliodisplay_popups_height'] . '" ' . $firstslide . '>' . $res2['filename'] . ' (' . $res2['filesize'] . ' ' . $phrase['_bytes'] . ')</option>';
                                                                break;
                                                        }			    
							case 'jpg':
                                                        {
                                                                $slideshowpulldown .= '<option value="' . $ilpage['attachment'] . '?cmd=thumb&id=' . $res2['filehash'] . '&w=' . $ilconfig['portfoliodisplay_popups_width'] . '&h=' . $ilconfig['portfoliodisplay_popups_height'] . '" ' . $firstslide . '>' . $res2['filename'] . ' (' . $res2['filesize'] . ' ' . $phrase['_bytes'] . ')</option>';
                                                                break;
                                                        }			    
							case 'png':
                                                        {
                                                                $slideshowpulldown .= '<option value="' . $ilpage['attachment'] . '?id=' . $res2['filehash'] . '&w=' . $ilconfig['portfoliodisplay_popups_width'] . '&h=' . $ilconfig['portfoliodisplay_popups_height'] . '" ' . $firstslide . '>' . $res2['filename'] . ' (' . $res2['filesize'] . ' ' . $phrase['_bytes'] . ')</option>';
                                                                break;
                                                        }			    
							default:
                                                        {
                                                                // not an image -- send to normal attachments box for user to click and download
                                                                $project_attachment .= '<a href="' . $ilpage['attachment'] . '?id=' . $res2['filehash'] . '" target="_blank">' . $res2['filename'] . '</a> (' . $res2['filesize'] . ' ' . $phrase['_bytes'] . ')<br />';
                                                                break;
                                                        }
						}
					}
					else
					{
						if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
						{
							// are we owner?
							if ($_SESSION['ilancedata']['user']['userid'] == $res['user_id'])
							{
								// viewing auction as owner (and the images are not moderated as of yet.. show to owner anyways!)
								switch (fetch_extension($res2['filename']))
								{
									case 'gif':
                                                                        {
                                                                                $slideshowpulldown .= '<option value="'.$ilpage['attachment'].'?id='.$res2['filehash'].'&w=' . $ilconfig['portfoliodisplay_popups_width'] . '&h=' . $ilconfig['portfoliodisplay_popups_height'] . '" '.$firstslide.'>'.$res2['filename'].' ('.$res2['filesize'].' '.$phrase['_bytes'].') ['.$phrase['_review_in_progress'].']</option>';
                                                                                break;
                                                                        }				    
									case 'jpg':
                                                                        {
                                                                                $slideshowpulldown .= '<option value="'.$ilpage['attachment'].'?id='.$res2['filehash'].'&w=' . $ilconfig['portfoliodisplay_popups_width'] . '&h=' . $ilconfig['portfoliodisplay_popups_height'] . '" '.$firstslide.'>'.$res2['filename'].' ('.$res2['filesize'].' '.$phrase['_bytes'].') ['.$phrase['_review_in_progress'].']</option>';
                                                                                break;
                                                                        }				    
									case 'png':
                                                                        {
                                                                                $slideshowpulldown .= '<option value="'.$ilpage['attachment'].'?id='.$res2['filehash'].'&w=' . $ilconfig['portfoliodisplay_popups_width'] . '&h=' . $ilconfig['portfoliodisplay_popups_height'] . '" '.$firstslide.'>'.$res2['filename'].' ('.$res2['filesize'].' '.$phrase['_bytes'].') ['.$phrase['_review_in_progress'].']</option>';
                                                                                break;
                                                                        }				    
									default:
                                                                        {
                                                                                // not an image -- send to normal attachments box for user to click and download
                                                                                $project_attachment .= '<a href="'.$ilpage['attachment'].'?id='.$res2['filehash'].'" target="_blank">'.$res2['filename'].'</a> ('.$res2['filesize'].' '.$phrase['_bytes'].') [<em>'.$phrase['_review_in_progress'].'</em>]<br />';
                                                                                break;
                                                                        }
								}
							}
							else
							{
								// some guest or member viewing .. images are not yet moderated by staff... don't show
								$project_attachment .= $res2['filename'] . ' (' . $res2['filesize'] . ' ' . $phrase['_bytes'] . ') [<em>' . $phrase['_review_in_progress'] . '</em>]<br />';
							}
						}
					}
				}
			}
			else
			{
				$slideshowpulldown .= '<option value="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'nophoto.gif">' . $phrase['_no_attachments_available'] . '</option>';
			}
                        
			$slideshowpulldown .= '</select>';
                        
                        if (isset($imagecount) AND $imagecount == 0 OR $imagecount == 1)
                        {
                                $show['slideshow'] = false;        
                        }
	    
			// double check to see if media exists other than images (for attachments box)
			if ($project_attachment == '')
			{
				$project_attachment = $phrase['_no_attachments_available'];
			}
	    
                        $date_starts = print_date($res['date_starts'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
            
			$show['startprice'] = $show['currentbid'] = 0;
                        
                        // starting bid price
			$startprice = $ilance->currency->format($res['startprice']);
			
			if ($ilance->bid->has_bids($res['project_id']) > 0)
			{
				$show['currentbid'] = 1;
				
				// current bid amount display
				$currentbid = '<strong>'.$ilance->bid->fetch_current_bid($res['project_id']).'</strong>';
					
				$proxybit = '';
				if (!empty($_SESSION['ilancedata']['user']['userid']))
				{
					$pbit = $ilance->bid_proxy->fetch_user_proxy_bid($res['project_id'], $_SESSION['ilancedata']['user']['userid']);
					if ($pbit > 0)
					{
                                                $proxybit = $phrase['_your_maximum_bid'] . ': ' . $ilance->currency->format($pbit) . ' - <em>' . $phrase['_invisible']. '</em>';
					}
				}
			}
			else 
			{
				$show['startprice'] = true;
			}
			
			// additional auction information
			$additional_info = stripslashes($res['additional_info']);
			
			$show['livebid'] = false;
			$show['bidderuninvited'] = false;
                        
			switch ($res['project_details'])
			{
				case 'public':
                                {
                                        // does admin require members to be logged in before viewing full description?
                                        /*
                                        if ()
                                        {
                                            
                                        }
                                        else
                                        {
                                            
                                        }
                                        */
                                        $ilance->bbcode = construct_object('api.bbcode');
                                        $description = strip_vulgar_words($res['description']);
                                        $description = $ilance->bbcode->bbcode_to_html($description);
                                        $description = print_string_wrap($description, 50);
                                        break;
                                }			    
				case 'invite_only':
                                {
                                        // does admin require members to be logged in before viewing full description?
                                        /*
                                        if ()
                                        {
                                            
                                        }
                                        else
                                        {
                                            
                                        }
                                        */
                                        $show['bidderuninvited'] = true;
                                        if (empty($_SESSION['ilancedata']['user']['userid']))
                                        {
                                                $ilance->bbcode = construct_object('api.bbcode');
                                                $description = strip_vulgar_words($res['description']);
                                                $description = $ilance->bbcode->bbcode_to_html($description);
                                                $description = print_string_wrap($description, 50);
                                        }
                                        else
                                        {
                                                // fetch invites
                                                $sql_invites = $ilance->db->query("
                                                        SELECT *
                                                        FROM " . DB_PREFIX . "project_invitations
                                                        WHERE project_id = '" . intval($ilance->GPC['id']) . "'
                                                            AND seller_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                ", 0, null, __FILE__, __LINE__);
                                                if ($ilance->db->num_rows($sql_invites) > 0)
                                                {
                                                        $show['bidderuninvited'] = false;
                                                        $ilance->bbcode = construct_object('api.bbcode');
                                                        $description = strip_vulgar_words($res['description']);
                                                        $description = $ilance->bbcode->bbcode_to_html($description);
                                                        $description = print_string_wrap($description, 50);
                                                }
                                                else
                                                {
                                                        $ilance->bbcode = construct_object('api.bbcode');
                                                        $description = strip_vulgar_words($res['description']);
                                                        $description = $ilance->bbcode->bbcode_to_html($description);
                                                        $description = print_string_wrap($description, 50);
                                                }                                       
                                        }
                                        break;
                                }			    
				case 'realtime':
                                {
                                        // does admin require members to be logged in before viewing full description?
                                        /*
                                        if ()
                                        {
                                            
                                        }
                                        else
                                        {
                                            
                                        }
                                        */
                                        // is realtime auction (show flash mx applet)?
                                        $show['livebid'] = 1;
                                        
                                        // livebid flash applet
                                        if (!empty($_SESSION['ilancedata']['user']['userid']))
                                        {
                                                $bidapplet = '<div id="applet' . $res['project_id'] . '"></div>
<script type="text/javascript">
var fo2 = new FlashObject("' . DIR_LIVEBID_NAME . '/livebid.swf", "applet' . $res['project_id'] . '", "730", "530", "8,0,0,0", "#ffffff");
fo2.addParam("quality", "high");
fo.addParam("allowScriptAccess", "sameDomain");
fo2.addParam("flashvars", "languageConfig=' . DIR_FUNCT_NAME . '/' . DIR_XML_NAME . '/livebid_' . $_SESSION['ilancedata']['user']['slng'] . '.xml&prId=' . $res['project_id'] . '&sId=' . session_id() . '&rand=' . rand(100000, 999999) . '");
fo2.addParam("menu", "false");
</script>';
                                        }
                                        else 
                                        {
                                                $bidapplet = '<span class="blue"><a href="' . HTTPS_SERVER . $ilpage['login'] . '">' . $phrase['_become_a_registered_member_to_view_and_place_realtime_bids_using_our_brand_new_realtime_bid_interface'] . '</a></span>';	
                                        }
                                        
                                        $ilance->bbcode = construct_object('api.bbcode');
                                        $description = strip_vulgar_words($res['description']);
                                        $description = $ilance->bbcode->bbcode_to_html($description);
                                        $description = print_string_wrap($description, 50);
                                        break;
                                }			    
				case 'unique':
                                {
                                        $retailprice = $ilance->currency->format($res['retailprice']);
                                        $ilance->bbcode = construct_object('api.bbcode');
                                        $description = strip_vulgar_words($res['description']);
                                        $description = $ilance->bbcode->bbcode_to_html($description);
                                        $description = print_string_wrap($description, 50);
                                        break;
                                }
			}
				    
			// vulgar censor for description
			$description = isset($description) ? $description : $phrase['_no_description'];
	    
			// filtered auction type specified by seller
			// used as an template if condition
			if ($res['filtered_auctiontype'] == 'fixed')
			{
				$auctiontype = 'fixed';
                                $transactionstatus = $ilance->bid->fetch_transaction_status(intval($ilance->GPC['id']));
			}
			else if ($res['filtered_auctiontype'] == 'regular')
			{
				$auctiontype = 'regular';
                                $transactionstatus = $ilance->bid->fetch_transaction_status(intval($ilance->GPC['id']));
			}
			if ($res['project_details'] == 'unique')
			{
				$auctiontype = 'unique';
                                $transactionstatus = $ilance->bid_lowest_unique->fetch_transaction_status(intval($ilance->GPC['id']));
			}
			
			// does seller require bidders to use escrow to purchase item?
			$show['seller_using_escrow'] = $show['filter_escrow'] = false;
			$escrowbit = '';
			if ($res['filter_escrow'] AND $ilconfig['escrowsystem_enabled'])
			{
				$show['filter_escrow'] = $show['seller_using_escrow'] = true;
				$escrowbit = $phrase['_seller_ships_item_after_secure_payment_via_escrow'] . ' <img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'escrow.gif" border="0" alt="" />';
			}
			
			// #### is reserve price ###############################
			$show['reserve_auction'] = false;
			if ($res['reserve'])
			{
				$show['reserve_auction'] = true;
                                
				$highest_amount = '';
				$sql_highest = $ilance->db->query("
					SELECT MAX(bidamount) AS highest
					FROM " . DB_PREFIX . "project_bids
					WHERE project_id = '".$res['project_id']."'
					ORDER BY highest
					LIMIT 1
				");
				if ($ilance->db->num_rows($sql_highest) > 0)
				{
					$res_highest = $ilance->db->fetch_array($sql_highest);
                                        if ($res_highest['highest'] >= $res['reserve_price'])
                                        { 
                                                $reserve_met = $phrase['_yes_reserve_price_met'];
                                        }
                                        else
                                        {
                                                $reserve_met = '<span style="color:#ff6600">' . $phrase['_no_reserve_price_not_met'] . '</span>';
                                        }
				}
				else
                                {
                                        $reserve_met = '<span style="color:#ff6600">' . $phrase['_no_reserve_price_not_met'] . '</span>';
                                }
                                unset($highest_amount);
			}
			
			// #### is buynowable? #################################
			$show['buynow_available'] = $show['buynow'] = false;
                        $buynow_qty = $buynow_price = 0;
                        
			if ($res['buynow_price'] > 0)
			{
                                $show['buynow'] = true;
                                
				if ($res['buynow_qty'] >= 1)
				{
					$show['buynow_available'] = true;
                                        
					$buynow_price = $ilance->currency->format($res['buynow_price']);
                                        $buynow_qty = intval($res['buynow_qty']);
					$amount = $res['buynow_price'];
					$qty_pulldown = '<select name="qty" style="font-family: verdana">';
                                        $maxqty = 100;
					for ($i = 1; $i <= $buynow_qty; $i++)
                                        {
                                                if ($i <= $maxqty)
                                                {
                                                        $qty_pulldown .= '<option value="' . $i . '">' . $i . '</option>';
                                                }
					}
					$qty_pulldown .= '</select>';
				}
				
				// #### purchase now activity ##################
				$result_orders = $ilance->db->query("
					SELECT *
					FROM " . DB_PREFIX . "buynow_orders
					WHERE owner_id = '" . $res['user_id'] . "'
						AND project_id = '" . $res['project_id'] . "'
				");
				if ($ilance->db->num_rows($result_orders) > 0)
				{
					$no_purchase_now_activity = 0;
					$order_count = 0;
					while ($orderrows = $ilance->db->fetch_array($result_orders))
					{
						$orderrows['orderbuyer'] = print_username($orderrows['buyer_id'], 'href', 0, '', '');
						$orderrows['orderamount'] = $ilance->currency->format($res['buynow_price']);
						$orderrows['orderdate'] = print_date($orderrows['orderdate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 1, 0);
						$orderrows['orderqty'] = $orderrows['qty'];
						
						// escrow order status
						if ($orderrows['status'] == 'paid')
						{
							// started - funds forwarded by bidder into escrow for item
						}
						else if ($orderrows['status'] == 'pending_delivery')
						{
							// started - funds forwarded by bidder into escrow for item
						}
						else if ($orderrows['status'] == 'delivered')
						{
							// started - funds forwarded by bidder into escrow for item
						}
						else if ($orderrows['status'] == 'cancelled')
						{
							// started - funds forwarded by bidder into escrow for item
						}
						else if ($orderrows['status'] == 'offline')
						{
							// offline delivery - user to user (nothing to do with site)
						}
						else if ($orderrows['status'] == 'offline_delivered')
						{
							// offline delivery completed
						}                                                                
						if ($orderrows['ship_required'])
						{
							$ship_handling = fetch_auction('ship_handling', $orderrows['project_id']);
							if ($ship_handling == 'sellerpays' OR $ship_handling == 'none')
							{
								$ship_costs = 0;	
							}
							else
							{
								$ship_costs = fetch_auction('ship_costs', $orderrows['project_id']);
							}
						}
						else
						{
							$ship_costs = 0;
						}
						
						$orderrows['total'] = $ilance->currency->format(($orderrows['amount'] * $orderrows['orderqty']) + $ship_costs);
						$orderrows['class'] = ($order_count % 2) ? 'alt2' : 'alt1';
						$GLOBALS['purchase_now_activity'][] = $orderrows;
						$order_count++;
					}
				}
				else
				{
					$no_purchase_now_activity = 1;
				}
			}
						
			// #### seller information #############################
			$sql_user_results = $ilance->db->query("
				SELECT *
				FROM " . DB_PREFIX . "users
				WHERE user_id = '" . $res['user_id'] . "'
				LIMIT 1
			", 0, null, __FILE__, __LINE__);
			if ($ilance->db->num_rows($sql_user_results) > 0)
			{
				$res_project_user  = $ilance->db->fetch_array($sql_user_results);
			}
			else
			{
				print_notice($phrase['_owner_delisted'], $phrase['_sorry_the_owner_of_this_auction_has_been_delisted'], $ilpage['main'], $phrase['_main_menu']);
				exit();
			}
			
			$project_user_id = $res_project_user['user_id'];
			$seller = print_username($res_project_user['user_id'], 'href', 0, '', '');
                        $sellerplain = fetch_user('username', $res_project_user['user_id']);
			
			$memberinfo = $ilance->feedback->datastore($res['user_id']);
                        $merchantscore = $memberinfo['pcnt'];
                        
			$project_title = strip_vulgar_words(stripslashes($res['project_title']));
			$icons = $ilance->auction->auction_icons($res['project_id'], $res['user_id']);
			
			// auction type
			if ($res['project_type'] == 'reverse')
			{
				$project_type = $phrase['_reverse_auction'];
			}
			
			if ($res['project_type'] == 'forward')
			{
				$project_type = $phrase['_standard_auction'];
			}
			
			if ($res['project_type'] == 'dutch')
			{
				$project_type = $phrase['_dutch_auction'];
			}
			
			if ($res['project_type'] == 'quote')
			{
				$project_type = $phrase['_rfp_quote_only'];
			}
			
			if ($res['project_type'] == 'trade')
			{
				$project_type = $phrase['_trade_only'];
			}
			
			if ($res['project_type'] == 'resume')
			{
				$project_type = $phrase['_resume_listing'];
			} 
			
			// auction details
                        $uniquebidcount = 0;
			if ($res['project_details'] == 'public')
			{
				$project_details = $phrase['_public_viewing'];
			}            
			if ($res['project_details'] == 'invite_only')
			{
				$project_details = $phrase['_by_invitation_only'];
			}
			if ($res['project_details'] == 'realtime')
			{
				$project_details = $phrase['_realtime'];
			}
			if ($res['project_details'] == 'unique')
			{
				$project_details = $phrase['_lowest_unique_bid_event'];
                                $uniquebidcount = $res['uniquebidcount'];
			}
			
			// auction bid details
			if ($res['bid_details'] == 'sealed')
			{
				$bid_details = $phrase['_sealed_bidding_hidden'];
			}
			
			if ($res['bid_details'] == 'open')
			{
				$bid_details = $phrase['_public_bidding'];
			}
			
			if ($res['bid_details'] == 'blind')
			{
				$bid_details = $phrase['_blind_bidding'];
			}
			
			if ($res['bid_details'] == 'full')
			{
				$bid_details = $phrase['_full_bidding_privacy'];
			}
	    
			// #### distance calculation ###########################
			$distance = '-';
			if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0 AND $ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], $accessname='distance') == "yes")
			{
				$ilance->distance = construct_object('api.distance');
				$distance = $ilance->distance->print_distance_results($res_project_user['user_id'], $res_project_user['country'], $res_project_user['zip_code'], $_SESSION['ilancedata']['user']['countryid'], $_SESSION['ilancedata']['user']['postalzip'], $_SESSION['ilancedata']['user']['userid']);
			}
			
			// #### UNIQUE BID HISTORY OVERVIEW ####################
			if ($res['project_details'] == 'unique')
			{
				if (empty($_SESSION['ilancedata']['user']['userid']))
				{
					$userid = 0;
				}
				else
				{
					$userid = $_SESSION['ilancedata']['user']['userid'];
				}
				
				// is user sorting by status?
				if (isset($ilance->GPC['sortby']) AND $ilance->GPC['sortby'] == 'status' AND isset($ilance->GPC['sort']))
				{
					$ilance->GPC['sort'] = mb_strtoupper($ilance->GPC['sort']);
				}
				else
				{
					$ilance->GPC['sort'] = 'DESC';
				}
				
				// #### unique bidders query ###################
				$result = $ilance->db->query("
					SELECT *
					FROM " . DB_PREFIX . "projects_uniquebids
					WHERE user_id = '" . $userid . "'
					    AND project_id = '" . $res['project_id'] . "'
					ORDER BY status " . $ilance->db->escape_string($ilance->GPC['sort']) . "
				", 0, null, __FILE__, __LINE__);
				if ($ilance->db->num_rows($result) > 0)
				{
					while ($resbids = $ilance->db->fetch_array($result))
					{
						$resbids['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
						
						// date of placed bid
						$resbids['date'] = print_date($resbids['date'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
						if ($resbids['status'] == 'lowestunique' AND $res['status'] != 'open')
						{
							$resbids['award'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid_awarded.gif" border="0" alt="" />';
						}
						else
						{
							$resbids['award'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid_awarded_gray.gif" border="0" alt="" />';
						}
						if ($resbids['status'] == 'unique')
						{
							$resbids['amountstatus'] = '<strong><em>'.$phrase['_unique_bid'].'</em></strong>';
							$resbids['response'] = $phrase['_your_bid'].': '.$ilance->currency->format($resbids['uniquebid']).' '.$phrase['_is_unique_but_there_is_currently'].' <strong>'.$ilance->bid_lowest_unique->fetch_lower_unique_bids($resbids['user_id'], $resbids['project_id'], $resbids['uniquebid']).'</strong> '.$phrase['_lower_unique_bids_placed_than_yours'];
						}
						else if ($resbids['status'] == 'nonunique')
						{
							$resbids['amountstatus'] = $phrase['_non_unique'];
							$resbids['response'] = $phrase['_your_bid'].': '.$ilance->currency->format($resbids['uniquebid']).' is <strong>not-unique</strong> because there is currently <strong>'.$resbids['totalbids'].'</strong> other bids with the same amount placed.';
						}
						else if ($resbids['status'] == 'lowestunique')
						{
							$resbids['amountstatus'] = '<span style="font-size:15px; color:green"><strong>'.$phrase['_lowest_unique'].'</strong></span>';
							$resbids['response'] = $phrase['_your_bid'].': '.$ilance->currency->format($resbids['uniquebid']).' '.$phrase['_is_currently_the_lowest_unique_bid_placed'];
						}
						$resbids['uniquebid'] = $ilance->currency->format($resbids['uniquebid']);
						$unique_bid_results_rows[] = $resbids;
						$row_count++;
					}
				}
				else
				{
					$show['no_unique_bid_rows_returned'] = true;
				}    
			}
                        
                        // #### bidders query ##################################
			else
			{
				$result = $ilance->db->query("
					SELECT b.bid_id, b.user_id, b.project_id, b.project_user_id, b.proposal, b.bidamount, b.estimate_days, b.date_added AS bidadded, b.date_updated, b.date_awarded, b.bidstatus, b.bidstate, b.qty, p.project_id, p.escrow_id, p.cid, p.description, p.date_added, p.buynow_qty, p.date_end, p.user_id, p.views, p.project_title, p.bids, p.additional_info, p.status, p.close_date, p.project_details, p.project_type, p.bid_details, u.user_id, u.username, u.city, u.state, u.zip_code
					FROM " . DB_PREFIX . "project_bids AS b,
					" . DB_PREFIX . "projects AS p,
					" . DB_PREFIX . "users AS u
					WHERE b.project_id = '".intval($ilance->GPC['id'])."'
					    AND b.project_id = p.project_id
					    AND u.user_id = b.user_id
					    AND b.bidstatus != 'declined'
					    AND b.bidstate != 'retracted'
					ORDER by b.bidamount DESC, b.bid_id DESC
				", 0, null, __FILE__, __LINE__);
				if ($ilance->db->num_rows($result) > 0)
				{
					while ($resbids = $ilance->db->fetch_array($result))
					{
						// date of placed bid
						$resbids['bid_datetime'] = print_date($resbids['bidadded'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
						
						// bidder information
						$sql_user_results = $ilance->db->query("
							SELECT *
							FROM " . DB_PREFIX . "users
							WHERE user_id = '" . $resbids['project_user_id'] . "'
							LIMIT 1
						", 0, null, __FILE__, __LINE__);
						$res_project_user = $ilance->db->fetch_array($sql_user_results);
						
						if ($resbids['bid_details'] == 'open' AND !empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] != $resbids['user_id'])
						{
							// allow currency conversion?
							if ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], $accessname='enablecurrencyconversion') == 'yes')
							{
								$rowbeforeexchange = $resbids['bidamount'];
								$resbids['bidamount'] = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $rowbeforeexchange);
							}
							else
							{
								$rowbeforeexchange = $resbids['bidamount'];
								$resbids['bidamount'] = $ilance->currency->format($rowbeforeexchange);
							}
						}
						else if ($resbids['bid_details'] == 'open' AND !empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] == $resbids['user_id'])
						{
							if ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], $accessname='enablecurrencyconversion') == 'yes')
							{
								$rowbeforeexchange = $resbids['bidamount'];
								$resbids['bidamount'] = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $rowbeforeexchange);
							}
							else
							{
								$rowbeforeexchange = $resbids['bidamount'];
								$resbids['bidamount'] = $ilance->currency->format($rowbeforeexchange);
							}
						}
						else if ($resbids['bid_details'] == 'sealed' AND !empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] != $resbids['user_id'] AND $_SESSION['ilancedata']['user']['userid'] != $res_project_user['user_id'])
						{
							$resbids['bidamount'] = '= ' . $phrase['_sealed'] . ' =';
						}
						else if ($resbids['bid_details'] == 'sealed' AND !empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] == $resbids['user_id'])
						{
							if ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], $accessname='enablecurrencyconversion') == 'yes')
							{
								$rowbeforeexchange = $resbids['bidamount'];
								$resbids['bidamount'] = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $rowbeforeexchange);
							}
							else
							{
								$rowbeforeexchange = $resbids['bidamount'];
								$resbids['bidamount'] = $ilance->currency->format($rowbeforeexchange);
							}
						}
						else if ($resbids['bid_details'] == 'sealed' AND !empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] == $res_project_user['user_id'])
						{
							$resbids['bidamount'] = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $resbids['bidamount']);
						}
                                                else
                                                {
                                                        $resbids['bidamount'] = $ilance->currency->format($resbids['bidamount']);
                                                }
						
						$resbids['isonline'] = print_online_status($resbids['user_id']);
						$resbids['provider'] = print_username($resbids['user_id'], 'href', 0, '', '');
						$resbids['city'] = ucfirst($resbids['city']);
						$resbids['state'] = ucfirst($resbids['state']);
						$resbids['zip'] = trim(mb_strtoupper($resbids['zip_code']));
						$resbids['location'] = $resbids['state'].', '.print_user_country($resbids['user_id']);
						$resbids['awarded'] = print_username($resbids['user_id'], 'custom', 0, '', '', fetch_user('serviceawards', $resbids['user_id']) . ' ' . $phrase['_awards']);
						$resbids['reviews'] = fetch_product_reviews_reported($resbids['user_id']);
						if ($resbids['bidstatus'] == 'awarded')
						{
							$resbids['award'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid_awarded.gif" border="0" alt="" />';
							$awarded_vendor = stripslashes($resbids['username']);
						}
						else
						{
							$resbids['award'] = '';
						}
                                                
                                                if ($resbids['qty'] == 0)
                                                {
                                                        $resbids['qty'] = '-';
                                                }
                                                
                                                if (!empty($resbids['proposal']))
                                                {
                                                        // proxy bid
                                                        $resbids['class'] = 'featured_highlight';
                                                        $resbids['provider'] = '<span class="gray">' . $resbids['provider'] . '</span>';
                                                        $resbids['bidamount'] = '<span class="gray">' . $resbids['bidamount'] . '</span>';
                                                        $resbids['qty'] = '<span class="gray">' . $resbids['qty'] . '</span>';
                                                        $resbids['bid_datetime'] = '<span class="gray">' . $resbids['bid_datetime'] . '</span>';
                                                }
                                                else
                                                {
                                                        // user bid
                                                        $resbids['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                                                }
                                                
						$bid_results_rows[] = $resbids;
						$row_count++;
					}
				}
				else
				{
					$show['no_bid_rows_returned'] = true;
				}    
			}
				    
			$filter_permissions = $ilance->bid->construct_bidfilter_permissions('product', intval($ilance->GPC['id']));
			
			// #### bidders sql query ##############################
			$result_bidtop = $ilance->db->query("
				SELECT *, UNIX_TIMESTAMP(date_end) - UNIX_TIMESTAMP('" . DATETIME24H . "') AS mytime, UNIX_TIMESTAMP(date_starts) - UNIX_TIMESTAMP('" . DATETIME24H . "') AS starttime
				FROM " . DB_PREFIX . "projects
				WHERE project_id = '" . intval($ilance->GPC['id']) . "'
				    AND project_state = 'product'
				    AND visible = '1'
			", 0, null, __FILE__, __LINE__);
			if ($ilance->db->num_rows($result_bidtop) > 0)
			{
				while ($row = $ilance->db->fetch_array($result_bidtop))
				{
					if ($row['project_details'] == 'unique')
					{
						$bids = $ilance->bid_lowest_unique->fetch_bid_count($row['project_id']);
                                                
                                                if ($uniquebidcount > 0 AND $bids > 0)
                                                {
                                                        $left = ($uniquebidcount - $bids);
                                                        
                                                        if ($left <= 0)
                                                        {
                                                                $show['ended'] = true;
                                                                $uniquebidcount = $left;
                                                        }
                                                        else
                                                        {
                                                                $uniquebidcount = $left;
                                                        }
                                                }
					}
					else
					{
						$bids = $row['bids'];
					}
					
					// seller information
					$sql_user_results = $ilance->db->query("
						SELECT *
						FROM " . DB_PREFIX . "users
						WHERE user_id = '" . $row['user_id'] . "'
						LIMIT 1
					", 0, null, __FILE__, __LINE__);
					$res_project_user = $ilance->db->fetch_array($sql_user_results);
					
					// fetch highest bidder info
					$sql_highest_bidder = $ilance->db->query("
						SELECT user_id
						FROM " . DB_PREFIX . "project_bids
						WHERE project_id = '" . $row['project_id'] . "'
						ORDER BY bidamount DESC
					", 0, null, __FILE__, __LINE__);
					if ($ilance->db->num_rows($sql_highest_bidder) > 0)
					{
						$res_highest_bidder = $ilance->db->fetch_array($sql_highest_bidder);						
						// is bid placed?
						if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
						{
							$sql_bidplaced = $ilance->db->query("
								SELECT *
								FROM " . DB_PREFIX . "project_bids
								WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
								    AND project_id = '" . $row['project_id'] . "'
							", 0, null, __FILE__, __LINE__);
							if ($ilance->db->num_rows($sql_bidplaced) > 0)
							{
								$row['bidplaced'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid.gif" border="0" alt="' . $phrase['_you_have_placed_a_bid_on_this_auction'] . '" />';
							}
							else
							{
								$row['bidplaced'] = '';
							}
						}
						else
						{
							$row['bidplaced'] = '';
						}
									
						// format average, lowest and highest amounts
						$sel_bids_av = $ilance->db->query("
							SELECT AVG(bidamount) AS average, MIN(bidamount) AS lowest, MAX(bidamount) AS highest
							FROM " . DB_PREFIX . "project_bids
							WHERE project_id = '" . $row['project_id'] . "'
                                                                AND bidstate != 'retracted'
                                                                AND bidstatus != 'declined'
							ORDER BY highest
							LIMIT 1
						", 0, null, __FILE__, __LINE__);
						if ($ilance->db->num_rows($sel_bids_av) > 0)
						{
							$res_bids_av = $ilance->db->fetch_array($sel_bids_av);
							
							// fetch highest bidders username
							$highbidderid = $ilance->bid->fetch_highest_bidder($row['project_id']);
							$highbidder = print_username($highbidderid, 'href', 0, '', '');
						}
						else
						{
							$res_bids_av['average'] = $res_bids_av['lowest'] = $res_bids_av['highest']= '';
							$highbidder = $highbidderid = $highbidderscore = $merchantstars = '';
						}
					}
					else
					{
						$res_bids_av['average'] = $res_bids_av['lowest'] = $res_bids_av['highest'] = $row['bidplaced'] = '';
						$highbidder = $highbidderid = $highbidderscore = $merchantstars = '';
					}
                                        
					$cid = $row['cid'];
					if ($row['bid_details'] == 'open')
					{
						if (!empty($_SESSION['ilancedata']['user']['currencyid']))
						{
							$average = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $res_bids_av['average']);
							$lowest = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $res_bids_av['lowest']);
							$highest = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $res_bids_av['highest']);
						}
						else
						{
							$average = print_currency_conversion('', $res_bids_av['average']);
							$lowest  = print_currency_conversion('', $res_bids_av['lowest']);
							$highest = print_currency_conversion('', $res_bids_av['highest']);
						}
					}
					else if ($row['bid_details'] == 'sealed')
					{
						// is auction owner viewing?
						if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0 AND $_SESSION['ilancedata']['user']['userid'] == $res_project_user['user_id'])
						{
							$average = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $res_bids_av['average']);
							$lowest = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $res_bids_av['lowest']);
							$highest = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $res_bids_av['highest']);
						}
						else
						{
							// auction owner not viewing
							$average = "= " . $phrase['_sealed'] . " =";
							$lowest = "= " . $phrase['_sealed'] . " =";
							$highest = "= " . $phrase['_sealed'] . " =";
						}
					}
					
                                        // template if condition
                                        $show['ended'] = false;
                                        
					if ($row['date_starts'] > DATETIME24H)
					{
						// auction has not begun yet
						$placeabid = '<input type="button" name="bid" value="' . $phrase['_place_a_bid'] . '" onclick="location.href=\'' . $ilpage['rfp'] . '?cmd=bid&amp;id=' . $row['project_id'] . '&amp;state=product\'" class="buttons" /> ';
                                                
						$dif = $row['starttime'];
						$ndays = floor($dif / 86400);
						$dif -= $ndays * 86400;
						$nhours = floor($dif / 3600);
						$dif -= $nhours * 3600;
						$nminutes = floor($dif / 60);
						$dif -= $nminutes * 60;
						$nseconds = $dif;
						$sign = '+';
						if ($row['starttime'] < 0)
						{
							$row['starttime'] = - $row['starttime'];
							$sign = '-';
						}
									
						if ($sign == '-')
						{
							$show['buynow_available'] = false;
						}
						else
						{
							if ($ndays != '0')
							{
								$project_time_left = $ndays . $phrase['_d_shortform'] . ', ';	
								$project_time_left .= $nhours . $phrase['_h_shortform'] . ', ';
								$project_time_left .= $nminutes . $phrase['_m_shortform'] . ', ';
								$project_time_left .= $nseconds . $phrase['_s_shortform'] . '+';
							}
							else if ($nhours != '0')
							{
								$project_time_left = $nhours . $phrase['_h_shortform'] . ', ';
								$project_time_left .= $nminutes . $phrase['_m_shortform'] . ', ';
								$project_time_left .= $nseconds . $phrase['_s_shortform'] . '+';
							}
							else
							{
								$project_time_left = $nminutes . $phrase['_m_shortform'] . ', ';
								$project_time_left .= $nseconds . $phrase['_s_shortform'] . '+';	
							}
						}
                                                
						$row['timetostart'] = $project_time_left;
						$started = $phrase['_starts'] . ': ' . $row['timetostart'];
						$ends = print_date($row['date_end'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
						$timeleft = '--';
						if ($row['status'] == 'open')
						{
							$project_status = $started;
						}
					}
					else
					{
						$placeabid = '<input type="button" name="bid" value="' . $phrase['_place_a_bid'] . '" onclick="location.href=\'' . $ilpage['rfp'] . '?cmd=bid&amp;id=' . $row['project_id'] . '&amp;state=product\'" class="buttons" /> ';
									
						$started = print_date($row['date_starts'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
						$ends = print_date($row['date_end'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
						
						$dif = $row['mytime'];
						$ndays = floor($dif / 86400);
						$dif -= $ndays * 86400;
						$nhours = floor($dif / 3600);
						$dif -= $nhours * 3600;
						$nminutes = floor($dif / 60);
						$dif -= $nminutes * 60;
						$nseconds = $dif;
						$sign = '+';
						if ($row['mytime'] < 0)
						{
							$row['mytime'] = - $row['mytime'];
							$sign = '-';
						}						
						if ($sign == '-')
						{
							$project_time_left = $phrase['_ended'];
							$show['buynow_available'] = false;
						}
						else
						{
							if ($ndays != '0')
							{
								$project_time_left = $ndays . $phrase['_d_shortform'] . ', ';	
								$project_time_left .= $nhours . $phrase['_h_shortform'] . ', ';
								$project_time_left .= $nminutes . $phrase['_m_shortform'] . ', ';
								$project_time_left .= $nseconds . $phrase['_s_shortform'] . '+';
							}
							else if ($nhours != '0')
							{
								$project_time_left = $nhours . $phrase['_h_shortform'] . ', ';
								$project_time_left .= $nminutes . $phrase['_m_shortform'] . ', ';
								$project_time_left .= $nseconds . $phrase['_s_shortform'] . '+';
							}
							else
							{
								$project_time_left = $nminutes . $phrase['_m_shortform'] . ', ';
								$project_time_left .= $nseconds . $phrase['_s_shortform'] . '+';
							}
						}
						$timeleft = $project_time_left;
						if ($row['status'] == 'open')
						{
							$project_status = $phrase['_event_open_for_bids'];
						}
						else
						{
							$project_status = print_auction_status($row['status']);
                                                        $show['ended'] = true;
						}
					}
					
					$winningbidder = $winningbid = '';
                                        $winningbidderid = $ilance->bid->fetch_highest_bidder(intval($ilance->GPC['id']));
                                        if ($winningbidderid > 0)
                                        {
                                                $winningbidder = print_username($winningbidderid, 'href', 0, '', '');
                                                $winningbid = $ilance->bid->fetch_awarded_bid_amount(intval($ilance->GPC['id']));
                                                $winningbid = $ilance->currency->format($winningbid);
                                        }
                                        
                                        if ($row['status'] == 'finished')
					{
						$placeabid = '<input type="button" name="bid" value="' . $phrase['_place_a_bid'] . '" onclick="location.href=\'' . $ilpage['rfp'] . '?cmd=bid&amp;id=' . $row['project_id'] . '&amp;state=product\'" class="buttons" disabled="disabled" /> ';
						$ends = print_auction_status($row['status']) . ': ' . print_date($row['close_date'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
                                                $show['ended'] = true;
					}
					else if ($row['status'] == 'expired')
					{
						$placeabid = '<input type="button" name="bid" value="' . $phrase['_place_a_bid'] . '" onclick="location.href=\'' . $ilpage['rfp'] . '?cmd=bid&amp;id=' . $row['project_id'] . '&amp;state=product\'" class="buttons" disabled="disabled" /> ';
                                                $show['ended'] = true;
					}
                                        else if ($row['status'] != 'open' AND $row['close_date'] != '0000-00-00 00:00:00')
					{
						$placeabid = '<input type="button" name="bid" value="' . $phrase['_place_a_bid'] . '" onclick="location.href=\'' . $ilpage['rfp'] . '?cmd=bid&amp;id=' . $row['project_id'] . '&amp;state=product\'" class="buttons" disabled="disabled" /> ';
						$ends = print_auction_status($row['status']) . ': ' . print_date($row['close_date'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
						$timeleft = $phrase['_ended_early'];
                                                $show['ended'] = true;
					}
                                        
					if ($row['project_details'] == 'unique')
					{
						if (!empty($_SESSION['ilancedata']['user']['userid']))
						{
							if ($row['status'] == 'open')
							{
								$placeabid = '
								<form method="post" action="' . $ilpage['merch'] . '" name="uniquebid" accept-charset="UTF-8" style="margin:0px">
								<input type="hidden" name="cmd" value="preview-unique-bid" />
								<input type="hidden" name="project_id" value="' . intval($ilance->GPC['id']) . '" />
								<input type="hidden" name="owner_id" value="' . $row['user_id'] . '" />
								<div><strong>' . $phrase['_enter_lowest_unique_bid'] . '</strong>: <input type="text" name="uniquebid" value="" size="5" /> <input type="submit" value="'.$phrase['_preview_bid'].'" name="submit" class="buttons" /></div>
								<div class="smaller">' . $phrase['_place_your_bid_below_for_example_enter_25_for_25_cents'].'</div>
								</form>';       
							}
							else
							{
								$placeabid = '--';
                                                                $show['ended'] = true;
							}
						}
						else
						{
							$placeabid = '';
						}
					}
					else
					{
						if (empty($_SESSION['ilancedata']['user']['userid']))
						{
							$placeabid = '';
						}
					}
					
					// invited buyers listings
					$invite_list = '';
					$externalbidders = $registeredbidders = 0;
					
					$sql_invitations = $ilance->db->query("
						SELECT *
						FROM " . DB_PREFIX . "project_invitations
						WHERE project_id = '" . $row['project_id'] . "'
					", 0, null, __FILE__, __LINE__);
					if ($ilance->db->num_rows($sql_invitations) > 0)
					{
						while ($res_invitations = $ilance->db->fetch_array($sql_invitations))
						{
							if ($res_invitations['buyer_user_id'] != '-1')
							{
								$sql_vendor = $ilance->db->query("
									SELECT user_id
									FROM " . DB_PREFIX . "users
									WHERE user_id = '" . $res_invitations['buyer_user_id'] . "'
									LIMIT 1
								", 0, null, __FILE__, __LINE__);
								if ($ilance->db->num_rows($sql_vendor) > 0)
								{
									$registeredbidders++;
									$res_vendor = $ilance->db->fetch_array($sql_vendor);
									if ($res_invitations['bid_placed'] == '0')
									{
										$invite_list .= print_username($res_vendor['user_id'], 'href');
										$invite_list .= ' [ <em>' . $phrase['_not_placed'] . '</em> ], ';
									}
									else if ($res_invitations['bid_placed'] == '1')
									{
										$invite_list .= print_username($res_vendor['user_id'], 'href');
										$invite_list .= ' [ <strong>' . $phrase['_placed'] . '</strong> ], ';
									}        
								}        
							}
							else
							{
								// this invited bidder appears to be an external bidder
								// so we only have their email address to work with...
								$externalbidders++;
							}
						}        
					}
		    
					if ($externalbidders > 0 OR $registeredbidders > 0)
					{
						if ($res['bid_details'] == 'blind' OR $res['bid_details'] == 'full')
						{
							if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['isadmin'] == '1')
							{
								// admin
								$invite_list = mb_substr($invite_list, 0, -2);        
							}
							else if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] == $row['user_id'])
							{
								// owner
								$invite_list = mb_substr($invite_list, 0, -2);        
							}
							else if (empty($_SESSION['ilancedata']['user']['userid']))
							{
								// guest
								$invite_list = '= '.$phrase['_sealed'].' =';        
							}
							else if (!empty($_SESSION['ilancedata']['user']['userid']))
							{
								// member
								$invite_list = '= '.$phrase['_sealed'].' =';        
							}
						}
						else
						{
							$invite_list = mb_substr($invite_list, 0, -2);         
						}
						
						// formatted invite list display
						$invite_list = $invite_list . '<ul style="margin:18px; padding:0px;"><li>' . $externalbidders . ' ' . $phrase['_bidders_invited_via_email'] . '</li><li>' . $registeredbidders . ' ' . $phrase['_registered_members_invited'] . '</li></ul>';
					}
					else
					{
						$invite_list = $phrase['_no_bidders_invited'];		
					}
							    
					// shipping and handling display logic
					switch ($row['ship_handling'])
					{
						case 'flatrate':
                                                {
                                                        $ship_handling = $phrase['_paid_by_winning_bidder'];
                                                        $ship_costs = $ilance->currency->format($row['ship_costs']);
                                                        $ship_partner = $ilance->db->fetch_field(DB_PREFIX."shippers", "shipperid = '" . $row['ship_shipperid'] . "'", "title");
                                                        if (empty($ship_partner))
                                                        {
                                                                $ship_partner = '-';
                                                        }
                                                        break;
                                                }						
						case 'sellerpays':
                                                {
                                                        $ship_handling = $phrase['_paid_or_waived_by_product_merchant'] . ' <img src="'.$ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'freeshipping.gif" border="0" alt="' . $phrase['_free_shipping_delivery'] . '" />';
                                                        $ship_costs = $phrase['_free'];
                                                        $ship_partner = $ilance->db->fetch_field(DB_PREFIX . "shippers", "shipperid = '" . $row['ship_shipperid'] . "'", "title");
                                                        if (empty($ship_partner))
                                                        {
                                                                $ship_partner = '-';
                                                        }
                                                        break;
                                                }
						case 'digital':
                                                {
                                                        $ship_handling = $phrase['_digital_download_delivery'];
                                                        $ship_costs = $phrase['_free'];
                                                        $ship_partner = '-';
                                                        break;
                                                }
                                                case 'none':
                                                {
                                                        $ship_handling = '';
                                                        $ship_costs = $phrase['_free'];
                                                        $ship_partner = $ilance->db->fetch_field(DB_PREFIX . "shippers", "shipperid = '" . $row['ship_shipperid'] . "'", "title");
                                                        if (empty($ship_partner))
                                                        {
                                                                $ship_partner = '-';
                                                        }
                                                        break;        
                                                }
					}
							    
					// shipping country logic
					switch ($row['ship_country'])
					{
						case 'worldwide':
                                                {
                                                        $ship_countries = $phrase['_everywhere'];
                                                        break;
                                                }
						case 'pickup':
                                                {
                                                        $ship_handling = $phrase['_local_pickup_only'];
                                                        $ship_countries = $phrase['_local_to_seller'];
                                                        break;
                                                }
						case 'custom':
                                                {
                                                        $ship_countries = $row['ship_countries'];
                                                        break;
                                                }
                                                case 'none':
                                                {
                                                        $ship_countries = '-';
                                                        break;
                                                }
					}
							    
					// product auction image
					$checkup = print_item_photo('', 'checkup', $row['project_id']);
					
					$show['productimage'] = 0;
					$product_image = $product_image_thumb = '';
					if ($checkup == '1')
					{
						$show['productimage'] = 1;
                                                $product_image_thumb = print_item_photo('javascript:void(0)', 'thumb', $row['project_id'], $borderwidth = '0', $bordercolor = '');
					}
					
					$feedback_score = $positive = $negative = '';
					$memberstart = print_date(fetch_user('date_added', $row['user_id']), '%d-%b-%Y', 0, 0);
                                        
					$state = fetch_user('state', $row['user_id']);
					$location = '<a href="' . $ilpage['search'] . '?mode=product&amp;state=' . $state . '&amp;country=' . fetch_user('country', $row['user_id']) . '" title="Find other items from ' . $state . '">' . $state . '</a>, ' . '<a href="' . $ilpage['search'] . '?mode=product&amp;country=' . fetch_user('country', $row['user_id']) . '" title="' . $phrase['_find_other_items_from'] . ' ' . print_user_country($row['user_id']) . '">' . print_user_country($row['user_id']);
					$owner_id = $row['user_id'];
				}
			}
                        
                        // template if conditionals: admin viewing
			if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['isadmin'] == '1')
			{
                                $show['is_owner'] = false;
                                $show['cannot_bid'] = true;
				if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0 AND $_SESSION['ilancedata']['user']['userid'] == $owner_id)
				{
					$show['is_owner'] = true;
				}
                                
				if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
				{
					$show['cannot_bid'] = false;
				}
			}
                        // template if conditionals: registered member viewing
			else if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
			{
                                $show['is_owner'] = false;
				$show['cannot_bid'] = false;
				if ($_SESSION['ilancedata']['user']['userid'] == $owner_id)
				{
					$show['is_owner'] = true;
					$show['cannot_bid'] = false;
				}
			}
                        // template if conditionals: guest viewing
			else
			{
				$show['is_owner'] = false;
				$show['cannot_bid'] = true;
			}
			
                        $purchases = fetch_buynow_ordercount(intval($ilance->GPC['id']));
                        if ($purchases == 0)
                        {
                                //$purchases = '-';
                        }
                        
                        $show['soldbypurchase'] = $purchases;
                        $show['soldbyauction'] = $ilance->bid->has_winning_bidder(intval($ilance->GPC['id']));
                        
			$auctionridcode = fetch_user('rid', intval($owner_id));
			
			// purchase now logic
			if (isset($show['buynow_available']) AND $show['buynow_available'] AND isset($amount) AND $amount > 0)
			{
				// is there a highest bid placed?
				if ($res_bids_av['highest'] > 0)
				{
					// is the highest bid placed greater than the purchase now price?
                                        // make sure there is 1 or less qty available to purchase also.. we don't want to remove buy now option
                                        // if the seller has 2 or more items being sold via fixed price... 
					if ($res_bids_av['highest'] > $amount AND $res['buynow_qty'] <= 1)
					{
                                                // it is.. so let's remove buy now option!
						$show['buynow_available'] = false;
					}
				}
			}
			else
			{
				$show['buynow_available'] = false;
			}
			
			$categoryname = $ilance->categories->recursive($cid, 'product', $_SESSION['ilancedata']['user']['slng'], $nourls = 0, $customurl = '', $ilconfig['globalauctionsettings_seourls']);
			$listingcategory = $categoryname;

                        // prevent the top cats in breadcrumb to contain any fields from this form
			$show['nourlbit'] = true;
                        $navcrumb = array();
                        if ($ilconfig['globalauctionsettings_seourls'])
                        {
                                $catmap = print_seo_url($ilconfig['productcatmapidentifier']);
                                $navcrumb["$catmap"] = $phrase['_buy'];
                                unset($catmap);
                        }
                        else
                        {
                                $navcrumb["$ilpage[merch]?cmd=listings"] = $phrase['_buy'];
                        }
                        
			$ilance->categories->breadcrumb($cid, 'product', $_SESSION['ilancedata']['user']['slng'], $categorycache);
			$navcrumb[""] = $project_title;
			
			// custom category questions
			$ilance->auction_questions = construct_object('api.auction_questions');
			$project_questions = $ilance->auction_questions->construct_auction_questions($cid, intval($ilance->GPC['id']), 'output', 'product', $columns = 4);
			
                        // template if conditionals
			$show['is_winner'] = $show['is_high_bidder'] = $show['is_outbid'] = false;
			
			if (!empty($_SESSION['ilancedata']['user']['userid']) AND $ilance->bid->fetch_highest_bidder(intval($ilance->GPC['id'])) == $_SESSION['ilancedata']['user']['userid'])
			{
				$show['is_high_bidder'] = true;
			}
			if (!empty($_SESSION['ilancedata']['user']['userid']))
			{
				$show['is_outbid'] = $ilance->bid->is_outbidded($_SESSION['ilancedata']['user']['userid'], intval($ilance->GPC['id']));
                                
                                // this will also populate $show['wonbyauction'] and/or $show['wonbypurchase'] so we can present proper url link to user
				$show['is_winner'] = $ilance->bid->is_winner($_SESSION['ilancedata']['user']['userid'], intval($ilance->GPC['id']));
			}
			
			if ($res['project_details'] == 'unique')
			{
                                $show['lowestuniquebidalert'] = false;
                                
				$uniquebidstatus = '<div style="font-family: arial; font-size:15px;"><strong>' . $phrase['_lowest_unique_bid'] . '</strong></div><div class="gray">' . $phrase['_place_your_bid_below_for_example_enter_25_for_25_cents'] . '</div>';
				if (empty($_SESSION['ilancedata']['user']['userid']))
				{
					// bids left today
					$bidtotal = 0;
					$bidsleft = max(0,($bidtotal - fetch_bidcount_today(0)));
					$lastuniquebid = $ilance->bid_lowest_unique->fetch_last_unique_bid_amount(0, intval($ilance->GPC['id']));
				}
				else
				{
                                        $show['lowestuniquebidalert'] = true;
                                        
					$bidtotal = $ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'bidlimitperday');
					$bidsleft = max(0,($bidtotal-fetch_bidcount_today($_SESSION['ilancedata']['user']['userid'])));
					$lastuniquebid = $ilance->bid_lowest_unique->fetch_last_unique_bid_amount($_SESSION['ilancedata']['user']['userid'], intval($ilance->GPC['id']));
                                        
					if ($lastuniquebid > 0)
					{
                                                $uniquebidstatus = (isset($show['is_owner']) AND $show['is_owner']) ? '' : $ilance->bid_lowest_unique->print_unique_bid_response($_SESSION['ilancedata']['user']['userid'], intval($ilance->GPC['id']), $lastuniquebid);
						$uniquewinner = ($res['status'] != 'open' AND $ilance->bid_lowest_unique->has_unique_bid_winner($res['project_id'])) ? $ilance->bid_lowest_unique->fetch_lowest_unique_bid_winner($res['project_id']) : '';
					}
				}
			}
			
                        $returnpolicy = $returnsaccepted = $returnwithin = $returngivenas = $returnshippingpaidby = $additional_info = '';
                        if (!empty($res['returnpolicy']))
                        {
                                $returnpolicy = stripslashes($res['returnpolicy']);
                        }
                        else
                        {
                                $returnpolicy = $phrase['_there_appears_to_be_no_related_return_policy_information_for_this_item'];
                        }
                        
                        $show['returnpolicy'] = false;
                        $returnsaccepted = $phrase['_no'];
                        if ($res['returnaccepted'])
                        {
                                $show['returnpolicy'] = true;
                                
                                $returnsaccepted = $phrase['_yes'];
                                $returnwithin = intval($res['returnwithin']);
                                $returngivenas = ucwords($res['returngivenas']);
                                $returnshippingpaidby = ucwords($res['returnshippaidby']);
                        }
                        
                        $min_bidamount = sprintf("%.02f", '0.01');
                        $min_bidamountformatted = $ilance->currency->format('0.01');
                        $highestbid = 0;
                                        
                        if ($res['bids'] <= 0)
                        {
                                // do we have starting price?
                                if ($res['startprice'] > 0)
                                {
                                        $min_bidamount = sprintf("%.02f", $res['startprice']);
                                        $min_bidamountformatted = $ilance->currency->format($res['startprice']);
                                }
                        }
                        else if ($res['bids'] > 0)
                        {
                                // highest bid amount placed for this auction
                                $highestbid = $ilance->bid->fetch_highest_bid($res['project_id']);
                                
                                // if we have more than 1 bid start the bid increments since the first bidder cannot bid against the opening bid
                                if (isset($resincrement['amount']) AND !empty($resincrement['amount']) AND $resincrement['amount'] > 0)
                                {
                                        $min_bidamount = sprintf("%.02f", $highestbid + $resincrement['amount']);
                                        $min_bidamountformatted = $ilance->currency->format($highestbid + $resincrement['amount']);
                                }
                                else
                                {
                                        $min_bidamount = sprintf("%.02f", $highestbid);
                                        $min_bidamountformatted = $ilance->currency->format($highestbid);
                                }
                        }
                        
                        // #### sellers other items ############################
                        $otherlistings = $ilance->auction->fetch_users_other_listings($res['user_id'], 'product', 5, $excludelist = array($res['project_id']), true);
                        
                        // #### last viewed items ##############################
                        $lastviewedlistings = $ilance->auction->fetch_recently_viewed_auctions('product', 5, 1, 0, '', true);
                        
                        $show['categoryuseproxybid'] = false;
			if ($ilconfig['productbid_enableproxybid'] AND $ilance->categories->useproxybid($_SESSION['ilancedata']['user']['slng'], 'product', $res['cid']))
                        {
                                $show['categoryuseproxybid'] = true;
                        }
                        
                        $show['donation'] = false;
                        $donationtransaction = '<span class="gray">' . $phrase['_the_donation_associated_with_this_nonprofit_has_not_been_marked'] . '</span>';
                        if ($res['donation'] AND $res['charityid'] > 0)
                        {
                                $show['donation'] = true;
                                $charity = fetch_charity_details($res['charityid']);
                                $donationto = '<a href="' . $ilpage['nonprofits'] . '?id=' . $res['charityid'] . '">' . $charity['title'] . '</a>';
                                $donationurl = $charity['url'];
                                $donationpercentage = intval($res['donationpercentage']);
                                
                                if ($res['donermarkedaspaid'] AND $res['donermarkedaspaiddate'] != '0000-00-00 00:00:00')
                                {
                                        $donationtransaction = '' . $phrase['_the_donation_assoicated_with_this_nonprofit_was_marked_as_paid_on'] . ' <strong>' . print_date($res['donermarkedaspaiddate']) . '</strong>';        
                                }
                        }
                        
                        // page url
                        $pageurl = urlencode($ilpage['merch'] . '?id=' . $res['project_id']);
                        
                        // trackbacks
                        $trackbacks = '<span class="gray">' . $phrase['_no_referring_sites'] . '</span>';
                        
                        // video description
                        $videodescription = print_listing_video($res['project_id'], $videowidth = '490', $videoheight = '364');
                        
			$headinclude .= '<script language="javascript" type="text/javascript" src="' . $ilconfig['template_relativeimagepath'] . DIR_FUNCT_NAME . '/javascript/functions_slideshow.js"></script>' . "\n";
                        
                        // update category view count
                        add_category_viewcount($cid);
                        
                        $onload .= (isset($show['ended']) AND $show['ended']) ? '' : 'window.setInterval(\'refresh_item_details(\\\'' . $auctiontype . '\\\')\', \'5000\');';
                        $jsend = '
<script language="javascript" type="text/javascript">
<!--
refresh_item_details(\'' . $auctiontype . '\');
//-->
</script>';
                        //$headinclude .= (isset($show['ended']) AND $show['ended']) ? '' : '
                        $headinclude .= '
<script language="javascript" type="text/javascript">
<!--
if (!window.XMLHttpRequest)
{
        var reqObj = 
        [
                function() {return new ActiveXObject("Msxml2.XMLHTTP");},
                function() {return new ActiveXObject("Microsoft.XMLHTTP");},
                function() {return window.createRequest();}
        ];
        for(a = 0, z = reqObj.length; a < z; a++)
        {
                try
                {
                        window.XMLHttpRequest = reqObj[a];
                        break;
                }
                catch(e)
                {
                        window.XMLHttpRequest = null;
                }
        }
}
 
var req = new XMLHttpRequest();

window.onload = function()
{
        if (req == null)
        {
                //alert(\'Your browser currently does not support the XMLHttpRequest object\');
                return;
        }

        refresh_item_details(\'' . $auctiontype . '\');
        window.setInterval("refresh_item_details(\'' . $auctiontype . '\')", \'5000\');
}
 
function refresh_item_details(type)
{
        req.abort();
        req.open(\'GET\', \'' . HTTP_SERVER . $ilpage['ajax'] . '?do=refreshitemdetails&id=' . $res['project_id'] . '&type=' . $auctiontype . '\');
        req.onreadystatechange = function()
        {
                if (req.readyState != 4)
                {
                        return;
                }
                
                if (req.status == 200)
                {
                        var myString;
                        myString = req.responseText;
                        
                        //alert(myString);
                        
                        myString = myString.split("|");
                        
                        // myString[0]  = timeleft text
                        // myString[1]  = bids
                        // myString[2]  = starting price
                        // myString[3]  = current bid price
                        // myString[4]  = reserve price text
                        // myString[5]  = min bid amount allowed to be placed (formatted)
                        // myString[6]  = min bid amount allowed to be placed (non-formatted)
                        // myString[7]  = number of buy now purchases
                        // myString[8]  = highest bidder name
                        // myString[9]  = HIDE buy now row?
                        // myString[10] = HIDE buy now button action?
                        // myString[11] = HIDE place a bid row?
                        // myString[12] = HIDE current price, start price & place a bid row?
                        // myString[13] = ??????????
                        // myString[14] = SHOW winning bidder row?
                        // myString[15] = SHOW block header as ended listing?
                        // myString[16] = winning bid amount
                        
                        if (type == \'regular\')
                        {
                                
                                fetch_js_object(\'timelefttext\').innerHTML = myString[0];
                                fetch_js_object(\'timelefttext_modal\').innerHTML = myString[0];
                                fetch_js_object(\'bidstext\').innerHTML = myString[1];
                                fetch_js_object(\'bidstext_modal\').innerHTML = myString[1];

                                if (myString[2] != \'\')
                                {
                                        fetch_js_object(\'startbidtext\').innerHTML = myString[2];
                                        fetch_js_object(\'startbidtext_modal\').innerHTML = myString[2];
                                        
                                        toggle_show(\'startpricerow\');
                                        toggle_show(\'startpricerow_modal\');
                                        toggle_show(\'placebidrow\');
                                        
                                        toggle_hide(\'currentpricerow\');
                                        toggle_hide(\'currentpricerow_modal\');
                                        toggle_hide(\'highbidderrow\');
                                        
                                        if (myString[9] == \'1\')
                                        {
                                                toggle_hide(\'buynowactionrow\');
                                                toggle_hide(\'buynowrow\');
                                                
                                                fetch_js_object(\'blockheadertext\').innerHTML = \'' . $phrase['_place_a_bid_on_this_item_now'] . '\';
                                        }
                                        
                                        if (myString[9] == \'0\')
                                        {
                                                toggle_show(\'buynowactionrow\');
                                                toggle_show(\'buynowrow\');
                                                toggle_show(\'purchasesrow\');
                                                
                                                fetch_js_object(\'blockheadertext\').innerHTML = \'' . $phrase['_take_action_on_this_item'] . '\';
                                        }
                                }
                                else if (myString[3] != \'\' && myString[1] > 0)
                                {
                                        fetch_js_object(\'currentbidtext\').innerHTML = myString[3];
                                        fetch_js_object(\'currentbidtext_modal\').innerHTML = myString[3];
                                        
                                        toggle_hide(\'startpricerow\');
                                        toggle_hide(\'startpricerow_modal\');
                                        
                                        toggle_show(\'placebidrow\');
                                        toggle_show(\'currentpricerow\');
                                        toggle_show(\'currentpricerow_modal\');
                                        
                                        if (myString[8] != \'\')
                                        {
                                                toggle_show(\'highbidderrow\');
                                                fetch_js_object(\'highbiddertext\').innerHTML = myString[8];
                                        }
                                        
                                        if (myString[9] == \'1\')
                                        {
                                                toggle_hide(\'buynowactionrow\');
                                                fetch_js_object(\'blockheadertext\').innerHTML = \'' . $phrase['_place_a_bid_on_this_item_now'] . '\';
                                        }
                                        
                                        if (myString[9] == \'0\')
                                        {
                                                toggle_show(\'buynowrow\');
                                                toggle_show(\'buynowactionrow\');
                                                toggle_show(\'purchasesrow\');
                                                
                                                fetch_js_object(\'blockheadertext\').innerHTML = \'' . $phrase['_take_action_on_this_item'] . '\';
                                        }
                                }
                                
                                if (myString[4] != \'\')
                                {
                                        fetch_js_object(\'reservemettext\').innerHTML = myString[4];
                                        fetch_js_object(\'reservemettext_modal\').innerHTML = myString[4];
                                        
                                        if (myString[8] != \'\')
                                        {
                                                toggle_show(\'highbidderrow\');
                                                toggle_hide(\'winningbidderrow\');
                                                
                                                fetch_js_object(\'highbiddertext\').innerHTML = myString[8];
                                        }
                                        
                                        if (myString[9] == \'1\')
                                        {
                                                toggle_hide(\'buynowactionrow\');
                                                fetch_js_object(\'blockheadertext\').innerHTML = \'' . $phrase['_place_a_bid_on_this_item_now'] . '\';
                                        }
                                        
                                        if (myString[9] == \'0\')
                                        {
                                                toggle_show(\'buynowactionrow\');
                                                toggle_hide(\'winningbidderrow\');
                                                fetch_js_object(\'blockheadertext\').innerHTML = \'' . $phrase['_take_action_on_this_item'] . '\';
                                        }
                                }
                                
                                if (myString[5] != \'\' && myString[6] != \'\')
                                {
                                        fetch_js_object(\'minimumbidtext\').innerHTML = myString[5];
                                        fetch_js_object(\'minimumbidtext_modal\').innerHTML = myString[5];
                                        fetch_js_object(\'hiddenfieldminimum\').value = myString[6];
                                }
                                
                                
                                if (myString[7] != \'\')
                                {
                                        if (myString[7] > 0)
                                        {
                                                toggle_show(\'purchasesrow\');        
                                        }
                                        fetch_js_object(\'purchasestext\').innerHTML = myString[7];
                                }
                                
                                if (myString[14] == \'1\')
                                {
                                        fetch_js_object(\'blockheadertext\').innerHTML = \'' . $phrase['_this_listing_has_ended'] . '\';
                                        fetch_js_object(\'winningbidamounttext\').innerHTML = myString[17];
                                
                                        toggle_show(\'winningbidderrow\');
                                        toggle_show(\'winningbidrow\');
                                        
                                        toggle_hide(\'currentpricerow\');
                                        toggle_hide(\'startpricerow\');
                                        toggle_hide(\'placebidrow\');
                                        toggle_hide(\'highbidderrow\');
                                        toggle_hide(\'winninguniquebidderrow\');
                                        toggle_hide(\'buynowactionrow\');
                                }
                                
                                if (myString[14] == \'0\')
                                {
                                        toggle_hide(\'winningbidderrow\');
                                        toggle_hide(\'winningbidrow\');
                                }
                                
                                if (myString[16] == \'1\')
                                {
                                        fetch_js_object(\'blockheadertext\').innerHTML = \'' . $phrase['_this_listing_has_ended'] . '\';
                                        
                                }
                                
                                if (myString[12] == \'1\')
                                {
                                        toggle_hide(\'currentpricerow\');
                                        toggle_hide(\'startpricerow\');
                                        toggle_hide(\'placebidrow\');
                                }
                                
                                if (myString[10] == \'1\')
                                {
                                        toggle_hide(\'placebidrow\');
                                        toggle_hide(\'buynowactionrow\');
                                }
                        }
                        else if (type == \'fixed\')
                        {
                                fetch_js_object(\'timelefttext\').innerHTML = myString[0];
                                fetch_js_object(\'timelefttext_modal\').innerHTML = myString[0];
                                fetch_js_object(\'purchasestext\').innerHTML = myString[1];
                                
                                toggle_show(\'endsrow\');
                                toggle_show(\'buynowrow\');
                                toggle_show(\'buynowactionrow\');
                                toggle_show(\'purchasesrow\');
                                
                                toggle_hide(\'placeuniquebidrow\');
                                toggle_hide(\'winninguniquebidderrow\');
                                toggle_hide(\'placebidrow\');
                                toggle_hide(\'highbidderrow\');
                                toggle_hide(\'winningbidderrow\');
                                toggle_hide(\'currentpricerow\');
                                toggle_hide(\'startpricerow\');
                                toggle_hide(\'retailpricerow\');
                                toggle_hide(\'bidsrow\');
                                
                                if (myString[2] == \'1\')
                                {
                                        toggle_hide(\'buynowactionrow\');
                                }
                                
                                if (myString[3] == \'1\')
                                {
                                        fetch_js_object(\'blockheadertext\').innerHTML = \'' . $phrase['_this_listing_has_ended'] . '\';
                                        
                                }
                        }
                        else if (type == \'unique\')
                        {
                                fetch_js_object(\'timelefttext\').innerHTML = myString[0];
                                fetch_js_object(\'timelefttext_modal\').innerHTML = myString[0];
                                fetch_js_object(\'bidstext\').innerHTML = myString[1];
                                fetch_js_object(\'bidstext_modal\').innerHTML = myString[1];
                                
                                if (myString[3] > 0)
                                {
                                        fetch_js_object(\'uniquebidcounttext\').innerHTML = myString[3];
                                        toggle_show(\'uniquebiduntilendtext\');
                                }
                                else
                                {
                                        toggle_hide(\'uniquebiduntilendtext\');
                                }
                                
                                toggle_show(\'retailpricerow\');
                                toggle_show(\'bidsrow\');
                                toggle_show(\'endsrow\');
                                
                                if (myString[4] == \'1\')
                                {
                                        fetch_js_object(\'blockheadertext\').innerHTML = \'' . $phrase['_this_listing_has_ended'] . '\';
                                        toggle_hide(\'placeuniquebidrow\');
                                        toggle_hide(\'uniquebiduntilendtext\');
                                        
                                        if (myString[7] != \'\')
                                        {
                                                fetch_js_object(\'winningbidamounttext\').innerHTML = myString[7];
                                                toggle_show(\'winningbidrow\');
                                                toggle_show(\'winninguniquebidderrow\');
                                        }
                                        
                                        if (myString[6] != \'\')
                                        {
                                                fetch_js_object(\'lowestuniquebiddertext\').innerHTML = myString[6];
                                                toggle_show(\'winninguniquebidderrow\');
                                        }
                                }
                                else
                                {
                                        toggle_show(\'placeuniquebidrow\');
                                        toggle_hide(\'winninguniquebidderrow\');
                                }
                                
                                toggle_hide(\'placebidrow\');
                                toggle_hide(\'buynowrow\');
                                toggle_hide(\'purchasesrow\');
                                toggle_hide(\'highbidderrow\');
                                toggle_hide(\'winningbidderrow\');
                                toggle_hide(\'currentpricerow\');
                                toggle_hide(\'startpricerow\');
                        }
                }
        }
        
        req.send(null);	
}

function validate_place_bid(f)
{
        var Chars = "0123456789.,";
        
        haveerrors = 0;
        
        (f.bidamount.value.length < 1) ? showImage("bidamounterror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("bidamounterror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        
        for (var i = 0; i < f.bidamount.value.length; i++)
        {
                if (Chars.indexOf(f.bidamount.value.charAt(i)) == -1)
                {
                        alert(phrase[\'_invalid_currency_characters_only_numbers_and_a_period_are_allowed_in_this_field\']);
                        haveerrors = 1;
                }
        }
        
        if (haveerrors != 1)
        {
                val = fetch_js_object(\'bidamount_modal\').value;
                var bid = string_to_number(val);
                //bid = bid.toFixed(2);
                
                val2 = fetch_js_object(\'hiddenfieldminimum\').value;
                var minimumbid = string_to_number(val2);
                //minimumbid = minimumbid.toFixed(2);
                //alert(bid);
                
                if (bid == \'0.00\' || bid < minimumbid)
                {
                        alert(phrase[\'_cannot_place_value_for_your_bid_amount_your_bid_amount_must_be_greater_than_the_minimum_bid_amount\']);
                        haveerrors = 1;
                }
                
                if (bid != \'\' && bid != \'NaN\')
                {
                        fetch_js_object(\'bidamount_modal\').value = bid;
                }
        }
        
        return (!haveerrors);
}

function update_bid_amount_modal()
{
        price = fetch_js_object(\'bidamount_temp\').value;
        fetch_js_object(\'bidamount_modal\').value = price;
}

function update_bid_amount()
{
        setTimeout("update_bid_amount_modal()", 500);
}
//-->
</script>';
                        $pprint_array = array('donationtransaction','donationto','donationurl','donationpercentage','transactionstatus','winningbid','winningbidder','videodescription','pageurl','jsend','purchases','trackbacks','min_bidamountformatted','min_bidamount','date_starts','returnsaccepted','returnwithin','returngivenas','returnshippingpaidby','additional_info','returnpolicy','uniquebidcount','updateid','lastrevision','ship_partner','msgcount','product_image_thumb','increment','views','feed1','uniquewinner','uniquebidstatus','bidsleft','retailprice','buynow_qty','paymentmethods','maincid','proxybit','escrowbit','icons','merchantstars','merchantscore','highbidderscore','currentbid','startprice','listingcategory','slideshowpulldown','slideimage1','slideimage1caption','project_attachment','project_questions','auctionridcode','countdownapplet','bidapplet','questionhiddeninput','questionsubmit','questions','questionpulldown','collapseobj_livebid_auctiontab','collapseimg_livebid_auctiontab','collapseimg_merch_shipping','collapseobj_merch_shipping','collapseobj_askquestion','collapseimg_askquestion','product_image','ship_countries','ship_costs','merchantstars','feed1','feed6','feed12','realtime','qty_pulldown','placeabid','cid','reserve_met','buynow','buynow_price','amount','reserve','featured','highest','timeleft','started','ends','average','ship_handling','ship_insurance','bids','highbidder','highbidderid','location','memberstart','countryname','collapserfpinfo_id','invite_list','rfpposted','rfpawards','additional_info','project_user_id','lowest_bidder','highest_bidder','filter_permissions','awarded_vendor','project_status','bid_controls','buyer_incomespent','buyer_stars','project_title','description','project_type','project_details','project_distance','project_id','bid_details','pmb','seller','sellerplain','projects_posted','projects_awarded','project_currency','project_attachment','distance','subcategory_name','text','prevnext','prevnext2','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','category','subcategory');
			
			($apihook = $ilance->api('merch_detailed_end')) ? eval($apihook) : false;
			
                        $ilance->template->load_file('main', 'listing_forward_auction.html');
			$ilance->template->parse_hash('main', array('ilpage' => $ilpage));
			$ilance->template->parse_loop('main', 'bid_results_rows');
			$ilance->template->parse_loop('main', 'unique_bid_results_rows');
			$ilance->template->parse_loop('main', 'messages');
			$ilance->template->parse_loop('main', 'purchase_now_activity');
                        $ilance->template->parse_loop('main', 'otherlistings');
                        $ilance->template->parse_loop('main', 'lastviewedlistings');
			
			($apihook = $ilance->api('merch_detailed_loop')) ? eval($apihook) : false;
			
			$ilance->template->parse_if_blocks('main');
			$ilance->template->pprint('main', $pprint_array);
			exit();
		}
		else
		{
			$area_title = $phrase['_bad_rfp_warning_menu'];
			$page_title = SITE_NAME . ' - ' . $phrase['_bad_rfp_warning_menu'];
                        
			print_notice($phrase['_invalid_rfp_specified'], $phrase['_your_request_to_review_or_place_a_bid_on_a_valid_request_for_proposal'], $ilpage['search'], $phrase['_search_rfps']);
			exit();
		}
	}
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: merch.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>