<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

// #### load required phrase groups ############################################
$phrase['groups'] = array(
        'registration',
        'preferences',
        'subscription',
        'javascript'
);

// #### load required javascript ###############################################
$jsinclude = array(
        'countries'
);

// #### define top header nav ##################################################
$topnavlink = array(
        'registration'
);

// #### setup script location ##################################################
define('LOCATION','registration');

// #### require backend ########################################################
require_once('./functions/config.php');

// #### setup default breadcrumb ###############################################
$navcrumb = array("$ilpage[registration]" => $ilcrumbs["$ilpage[registration]"]);

$area_title = $phrase['_user_registration'];
$page_title = SITE_NAME . ' - ' . $phrase['_user_registration'];

($apihook = $ilance->api('registration_start')) ? eval($apihook) : false;

// #### REDIRECTION HANDLER ####################################################
if (isset($ilance->GPC['redirect']) AND !empty($ilance->GPC['redirect']))
{
        $ilance->GPC['redirect'] = strip_tags($ilance->GPC['redirect']);
}

// new member email verification process
if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'activate')
{
        if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == 'resend')
        {
                // member requests that ilance resend their email link code verification
                if (!empty($ilance->GPC['email']))
                {
                        // resend email activation code to member
                        $ilance->registration = construct_object('api.registration');
                        
                        if ($ilance->registration->send_email_activation($ilance->GPC['email']))
                        {
                                refresh(HTTPS_SERVER . $ilpage['login'] . '?error=checkemail');
                                exit();
                        }
                        else
                        {
                                refresh(HTTPS_SERVER . $ilpage['login'] . '?error=1');
                                exit();
                        }
                }
                else
                {
                        refresh(HTTPS_SERVER . $ilpage['login'] . '?error=1');
                        exit();
                }
        }
        else
        {
                // member appears to be validating his/her registration
                if (!empty($ilance->GPC['u']))
                {
                        $ilance->GPC['u'] = $ilance->crypt->three_layer_decrypt($ilance->GPC['u'], $ilconfig['key1'], $ilconfig['key2'], $ilconfig['key3']);
                        
                        $sql = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "users 
                                WHERE user_id = '" . intval($ilance->GPC['u']) . "'
                                        AND status = 'unverified'
                                LIMIT 1
                        ");
                        if ($ilance->db->num_rows($sql) > 0)
                        {
                                $user = $ilance->db->fetch_array($sql);
                                
                                // does admin manually verify new members before they can login?
                                $status = 'active';
                                if ($ilconfig['registrationdisplay_moderation'])
                                {
                                        $status = 'moderated';
                                }
                                
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "users
                                        SET status = '" . $status . "'
                                        WHERE user_id = '" . intval($ilance->GPC['u']) . "'
                                ");

                                $ilance->email = construct_dm_object('email', $ilance);
                                
                                // if we are active, send new email to user
                                if ($status == 'active')
                                {
                                        // if an account credit bonus was active we should dispatch that email to new user now
                                        // and update his account balance with new credit accordingly
                                        $registerbonus = '0.00';
                                        if ($ilconfig['registrationupsell_bonusactive'])
                                        {
                                                // lets construct a little payment bonus for new member, we will:
                                                // - create a transaction and send email to user and admin
                                                // - return the bonus amount so we can update the users account
                                                $registerbonus = construct_account_bonus($user['user_id'], $status);
                                                if ($registerbonus > 0)
                                                {
                                                        // update register bonus credit to online account data
                                                        $ilance->db->query("
                                                                UPDATE " . DB_PREFIX . "users
                                                                SET total_balance = total_balance + $registerbonus,
                                                                available_balance = available_balance + $registerbonus
                                                                WHERE user_id = '" . $user['user_id'] . "'
                                                        ");
                                                }
                                        }
                                        
                                        // admin activates new members after their email link code verification
                                        // so in this case, let's dispatch a new welcome email to the member
                                        $ilance->email->mail = $user['email'];
                                        $ilance->email->slng = fetch_user_slng($user['user_id']);
                                        
                                        $ilance->email->get('register_welcome_email');		
                                        $ilance->email->set(array(
                                                '{{username}}' => $user['username'],
                                                '{{user_id}}' => $user['user_id'],
                                                '{{first_name}}' => $user['first_name'],
                                                '{{last_name}}' => $user['last_name'],
                                                '{{phone}}' => $user['phone'],
                                                '{{email}}' => $user['email'],
                                        ));
                                        
                                        $ilance->email->send();
                                }
                
                                // regardless of the moderation status for new users, the admin will
                                // receive this new user registration email so they can activate the new user
                                
                                $ilance->email->mail = SITE_EMAIL;
                                $ilance->email->slng = fetch_site_slng();
                                
                                $ilance->email->get('register_welcome_email_admin');		
                                $ilance->email->set(array(
                                        '{{username}}' => $user['username'],
                                        '{{user_id}}' => $user['user_id'],
                                        '{{first_name}}' => $user['first_name'],
                                        '{{last_name}}' => $user['last_name'],
                                        '{{phone}}' => $user['phone'],
                                        '{{email}}' => $user['email'],
                                ));
                                
                                $ilance->email->send();
                                
                                if ($status == 'active')
                                {
                                        // display welcome to marketplace template for active members
                                        print_notice($phrase['_registration_complete'], $phrase['_thank_you_for_registering_we_are_glad_you_have_chosen'], $ilpage['login'], $phrase['_please_log_in']);
                                        exit();
                                }
                                else
                                {
                                        // display thanks for verifying email, admin will moderate you shortly ..
                                        // at this point the user still has not been sent the welcome to the marketplace
                                        // nor has he received any "account bonus" credit for signing up
                                        // these emails will be dispatched from the admin control panel
                                        print_notice($phrase['_registration_complete'], $phrase['_thanks_for_verifying_your_email_sddress_credentials_all_new_accounts_are_currently_under_moderated_review_you_will_receive_an_email_very_shortly'], $ilpage['search'], $phrase['_search']);
                                        exit();
                                }
                        }
                        else
                        {
                                refresh(HTTPS_SERVER . $ilpage['login'] . '?error=1');
                                exit();
                        }
                }
                else
                {
                        refresh(HTTPS_SERVER . $ilpage['login'] . '?error=1');
                        exit();
                }
        }
}

// are we returning to registration from a previous invitation or registration attempt?
if (!empty($_COOKIE[COOKIE_PREFIX . 'invitedid']) AND $_COOKIE[COOKIE_PREFIX . 'invitedid'] > 0)
{
        $_SESSION['ilancedata']['user']['invited'] = 1;
        $_SESSION['ilancedata']['user']['invitedid'] = intval($_COOKIE[COOKIE_PREFIX . 'invitedid']);
}
else
{
        // are we being externally invited?
        if (isset($ilance->GPC['invited']) AND $ilance->GPC['invited'] AND isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0)
        {
                // member has clicked link from within auction page
                $_SESSION['ilancedata']['user']['invited'] = 1;
                $_SESSION['ilancedata']['user']['invitedid'] = intval($ilance->GPC['id']);
                
                set_cookie('invitedid', $_SESSION['ilancedata']['user']['invitedid'], true);
        }
}

// #### BEGIN REGISTRATION #####################################################
if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'register')
{
        if (!isset($ilance->GPC['step']))
        {
                $ilance->GPC['step'] = 1;
                
                // disable some cookies so we don't auto-login
                set_cookie('userid', '', false);
                set_cookie('password', '', false);
        }
        
        // ########### STEP 1 ##################################################
        if ($ilance->GPC['step'] == '1')
        {
                $navcrumb = array();
                $navcrumb["$ilpage[registration]"] = $phrase['_registration'];
                $navcrumb[""] = $phrase['_account'];
        
                // if conditions
                $show['error_username'] = $show['error_username2'] = $show['error_email'] = $show['error_email2'] = $show['error_email3'] = $show['error_turing'] = false;
                $username = $password = $password2 = $email = $email2 = $secretquestion = $secretanswer = '';
                
                // set agreed if user decides to come back later
                if (isset($ilance->GPC['agreement']) AND $ilance->GPC['agreement'] == 1)
                {
                        $_SESSION['ilancedata']['user']['agreeterms'] = 1;
                }
        
                if (!empty($ilance->GPC['year']) AND !empty($ilance->GPC['month']) AND !empty($ilance->GPC['day']) AND $ilconfig['registrationdisplay_dob'])
                {
                        $_SESSION['ilancedata']['user']['dob'] = intval($ilance->GPC['year']) . '-' . intval($ilance->GPC['month']) . '-' . intval($ilance->GPC['day']);
                    
                        // does admin require members to be over 18?
                        if ($ilconfig['registrationdisplay_dobunder18'] == 0)
                        {
                                // are we under the age of 18?
                                if ($ilance->GPC['year'] > (gmdate('Y') - 18) OR ($ilance->GPC['year'] == (gmdate('Y') - 18) AND $ilance->GPC['month'] < gmdate('m')) OR ($ilance->GPC['year'] == (gmdate('Y') - 18) AND $ilance->GPC['month'] == gmdate('m') AND $ilance->GPC['day'] < gmdate('d')))
                                {
                                        print_notice($phrase['_you_must_be_over_18'], $phrase['_were_sorry_you_must_be_over_the_age_of_18_to_register_on_this_marketplace'], $ilpage['main'], $phrase['_main_menu']);
                                        exit();
                                }
                        }
                }
                else
                {
                        $_SESSION['ilancedata']['user']['dob'] = '0000-00-00';
                }
        
                if ($ilconfig['registrationdisplay_dob'] != 1)
                {
                        $_SESSION['ilancedata']['user']['dob'] = '0000-00-00';
                }
        
                if (!empty($_SESSION['ilancedata']['user']['agreeterms']) AND $_SESSION['ilancedata']['user']['agreeterms'] == 1)
                {
                        // captcha logic (does server support image creation)?
                        if (extension_loaded('gd'))
                        {
                                $captcha = '<img src="attachment.php?do=captcha" alt="'.$phrase['_please_enter_the_security_code_shown_on_the_image_to_continue_registration'].'" border="0" />';
                        }
                        else
                        {
                                // captcha set? reset it!
                                $_SESSION['ilancedata']['user']['captcha'] = '';
                
                                // no l, i or o / O / 0
                                $src = 'abcdefghjkmnpqrstuvwxyz23456789';
                
                                if (mt_rand(0,1) == 0)
                                {
                                        $src = mb_strtoupper($src);
                                }
                                $srclen = mb_strlen($src)-1;
                
                                $length = 5;
                                for ($i=0; $i<$length; $i++)
                                {
                                        $char = mb_substr($src, mt_rand(0, $srclen), 1);
                                        $_SESSION['ilancedata']['user']['captcha'] .= $char;
                                }
                                $captcha = '<div class="yellowhlite" style="width:95px; float:left"><div class="header" style="color:#ff6600; text-align: center;">'.$_SESSION['ilancedata']['user']['captcha'].'</div></div>';
                        }
            
                        $js = '
<script type="text/javascript">
<!--
verify = new verifynotify();
verify.field1 = fetch_js_object(\'password\');
verify.field2 = fetch_js_object(\'password2\');
verify.result_id = "password_result";
verify.match_html = "<span style=\"color:blue\"><img src=\"' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/checkmark.gif\" border=\"0\" alt=\"\" /></span>";
verify.nomatch_html = "";
verify.check();
//-->
</script>
';
                        
                        // custom registration questions [page 1]
                        $ilance->registration_questions = construct_object('api.registration_questions');
                        $customquestions = $ilance->registration_questions->construct_register_questions(1, 'input', 0);
                                    
                        // specific javascript includes
                        $headinclude .= '
<script type="text/javascript">
<!--
function verifynotify(field1, field2, result_id, match_html, nomatch_html)
{
        this.field1 = field1;
        this.field2 = field2;
        this.result_id = result_id;
        this.match_html = match_html;
        this.nomatch_html = nomatch_html;
        
        this.check = function() 
        {
                if (!this.result_id) 
                {	 
                        return false; 
                }
                
                if (!document.getElementById)
                { 
                        return false; 
                }
                
                r = fetch_js_object(this.result_id);
                if (!r)
                { 
                        return false; 
                }
                
                if (this.field1.value != "" && this.field1.value == this.field2.value) 
                {
                        r.innerHTML = this.match_html;
                } 
                else 
                {
                        r.innerHTML = this.nomatch_html;
                }
        }
}
            
function register1(f)
{
        haveerrors = 0;
        (f.username.value.length < 1) ? showImage("usernameerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("usernameerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.password.value.length < 1) ? showImage("passworderror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("passworderror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.password2.value.length < 1) ? showImage("password2error", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("password2error", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.secretquestion.value.length < 1) ? showImage("secretquestionerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("secretquestionerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.secretanswer.value.length < 1) ? showImage("secretanswererror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("secretanswererror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.email.value.search("@") == -1 || f.email.value.search("[.*]") == -1) ? showImage("emailerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("emailerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.email2.value.search("@") == -1 || f.email2.value.search("[.*]") == -1) ? showImage("email2error", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("email2error", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        ' . ($ilconfig['registrationdisplay_turingimage'] ? '(f.turing.value.length < 1) ? showImage("turingerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("turingerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);' : '') . '
        return (!haveerrors);
}
//-->
</script>
';
                        
                        $roleselected = isset($ilance->GPC['roleid']) ? intval($ilance->GPC['roleid']) : '';
                        $rolepulldown = print_role_pulldown($roleselected, 0, 0);
                        
                        $ilance->template->load_file('main', 'register1.html');
                        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                        $ilance->template->parse_if_blocks('main');
                        $ilance->template->pprint('main',   array('rolepulldown','customquestions','password','password2','secretquestion','secretanswer','js','captcha','username','email','email2','js','captcha','first_name','last_name','input_style','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                        exit();
                }
                else
                {
                        // terms of agreements
                        $area_title = $phrase['_registration_terms_and_agreements_review'];
                        $page_title = SITE_NAME . ' - ' . $phrase['_registration_terms_and_agreements_review'];
                        
                        $ilance->template->load_file('main', 'registration.html');
                        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                        $ilance->template->parse_if_blocks('main');
                        $ilance->template->pprint('main', array('first_name','last_name','input_style','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                        exit();
                }
        }
        
        // ########### STEP 2 ##################################################
        else if ($ilance->GPC['step'] == '2')
        {
                // construct breadcrumb trail
                $navcrumb = array();
                $navcrumb["$ilpage[registration]"] = $phrase['_registration'];
                $navcrumb[""] = $phrase['_contact'];
        
                // if conditions
                $show['error_username'] = $show['error_username2'] = $show['error_password'] = $show['error_email'] = $show['error_email2'] = $show['error_email3'] = $show['error_turing'] = false;
                $username = $password = $password2 = $email = $email2 = $secretquestion = $secretanswer = '';
                $error_secret = 0;
                
                // handle custom questions in this section
                if (isset($ilance->GPC['custom']) AND is_array($ilance->GPC['custom']))
                {
                        foreach ($ilance->GPC['custom'] AS $questionid => $answerarray)
                        {
                                foreach ($answerarray AS $formname => $answer)
                                {
                                        $_SESSION['ilancedata']['questions'][$formname] = $answer;
                                }
                        }
                }
                
                // role selection
                if (isset($ilance->GPC['roleid']) AND $ilance->GPC['roleid'] > 0)
                {
                        $_SESSION['ilancedata']['user']['roleid'] = intval($ilance->GPC['roleid']);
                }
                else
                {
                        $_SESSION['ilancedata']['user']['roleid'] = '-1';
                }
                       
                // quick username checkup
                if (isset($ilance->GPC['username']) AND $ilance->GPC['username'] != '')
                {
                        $unicode_name = preg_replace('/&#([0-9]+);/esiU', "convert_int2utf8('\\1')", $ilance->GPC['username']);
                        
                        // username ban checkup
                        if ($ilance->common->is_username_banned($ilance->GPC['username']) OR $ilance->common->is_username_banned($unicode_name))
                        {
                                $show['error_username2'] = true;
                                $username = $ilance->GPC['username'];
                        }
                        else
                        {
                                $sqlusercheck = $ilance->db->query("
                                        SELECT *
                                        FROM " . DB_PREFIX . "users
                                        WHERE username IN ('" . addslashes(htmlspecialchars_uni($ilance->GPC['username'])) . "', '" . addslashes(htmlspecialchars_uni($unicode_name)) . "')
                                ");
                                if ($ilance->db->num_rows($sqlusercheck) > 0)
                                {
                                        $show['error_username'] = true;
                                        $username = stripslashes(strip_tags(trim($ilance->GPC['username'])));
                                }
                                else
                                {
                                        $_SESSION['ilancedata']['user']['username'] = trim($ilance->GPC['username']);
                                        $username = $_SESSION['ilancedata']['user']['username'];
                                }
                        }
                }
                else
                {
                        $show['error_username'] = true;
                }
                
                // quick password checkup
                if (isset($ilance->GPC['password']) AND $ilance->GPC['password'] != '' AND isset($ilance->GPC['password2']) AND $ilance->GPC['password2'] != '')
                {
                        if ($ilance->GPC['password'] != $ilance->GPC['password2'])
                        {
                                $show['error_password'] = true;
                                
                                $password = trim($ilance->GPC['password']);
                                $password2 = trim($ilance->GPC['password2']);
                        }
                        else
                        {
                                // store password and salt
                                $_SESSION['ilancedata']['user']['salt'] = construct_password_salt($length = 5);
                                $_SESSION['ilancedata']['user']['password_md5'] = md5(md5($ilance->GPC['password']) . $_SESSION['ilancedata']['user']['salt']);
                                
                                $password = trim($ilance->GPC['password']);
                                $password2 = trim($ilance->GPC['password2']);
                        }
                }
                else
                {
                        $show['error_password'] = true;
                }
                
                // quick secret question/answer checkup
                if (isset($ilance->GPC['secretquestion']) AND $ilance->GPC['secretquestion'] != '' AND isset($ilance->GPC['secretanswer']) AND $ilance->GPC['secretanswer'] != '')
                {
                        $_SESSION['ilancedata']['user']['secretquestion'] = $ilance->GPC['secretquestion'];
                        $_SESSION['ilancedata']['user']['secretanswer'] = md5($ilance->GPC['secretanswer']);
                        
                        $secretquestion = $_SESSION['ilancedata']['user']['secretquestion'];
                        $secretanswer = $_SESSION['ilancedata']['user']['secretanswer'];
                }
                else
                {
                        $error_secret = 1;
                        $secretquestion = $ilance->GPC['secretquestion'];
                        $secretanswer = '';
                }
                
                // quick email checkup
                if (isset($ilance->GPC['email']) AND $ilance->GPC['email'] != '' AND isset($ilance->GPC['email2']) AND $ilance->GPC['email2'] != '')
                {
                        if ($ilance->GPC['email'] != $ilance->GPC['email2'])
                        {
                                $show['error_email2'] = true;
                                $email = $ilance->GPC['email'];
                                $email2 = $ilance->GPC['email2'];
                        }
                        
                        // final email checks (check mx record, check list of banned free emails, etc)
                        if ($ilance->common->is_email_banned(trim($ilance->GPC['email'])))
                        {
                                $show['error_email3'] = true;
                                $email = $ilance->GPC['email'];
                                $email2 = $ilance->GPC['email2'];
                        }
                        
                        // email is good check if it's duplicate
                        $sqlemailcheck = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "users
                                WHERE email = '" . $ilance->db->escape_string($ilance->GPC['email']) . "'
                        ");
                        if ($ilance->db->num_rows($sqlemailcheck) > 0)
                        {
                                $show['error_email'] = true;
                                $email = trim($ilance->GPC['email']);
                        }
                        else
                        {
                                $_SESSION['ilancedata']['user']['email'] = trim($ilance->GPC['email']);
                                $email = $ilance->GPC['email'];
                                $email2 = $ilance->GPC['email2'];
                        }
                }
                else
                {
                        $show['error_email2'] = true;
                        $email = $email2 = '';
                }
                
                // does admin use captcha?
                if ($ilconfig['registrationdisplay_turingimage'])
                {
                        // user supplied turing captcha
                        if (isset($ilance->GPC['turing']) AND $ilance->GPC['turing'] != '' AND !empty($_SESSION['ilancedata']['user']['captcha']))
                        {
                                $turing = mb_strtoupper(trim($ilance->GPC['turing']));
                                if ($turing != $_SESSION['ilancedata']['user']['captcha'])
                                {
                                        $show['error_turing'] = true;
                                }
                        }
                        else
                        {
                                $show['error_turing'] = true;
                        }
                }
                
                // final checkups for step 1
                if (isset($show['error_username']) AND $show['error_username'] OR isset($show['error_username2']) AND $show['error_username2'] OR isset($show['error_password']) AND $show['error_password'] OR isset($error_secret) AND $error_secret == 1 OR isset($show['error_email']) AND $show['error_email'] OR isset($show['error_email2']) AND $show['error_email2'] OR isset($show['error_email3']) AND $show['error_email3'] OR isset($show['error_turing']) AND $show['error_turing'])
                {
                        // ########### ERRORS: BACK TO STEP 1 ##############################
                        
                        $navcrumb = array();
                        $navcrumb["$ilpage[registration]?cmd=register"] = $phrase['_registration'];
                        $navcrumb["$ilpage[registration]"] = $phrase['_account'];
            
                        // captcha set? reset it!
                        $_SESSION['ilancedata']['user']['captcha'] = '';
            
                        // no l, i or o / O / 0
                        $src  = '';
                        $src .= 'abcdefghjkmnpqrstuvwxyz';
                        $src .= '23456789';
                        if (mt_rand(0,1) == 0)
                        {
                                $src = mb_strtoupper($src);
                        }
                        $srclen = mb_strlen($src)-1;
            
                        // how long is the turing string?
                        $length = 5;
                        for ($i=0; $i<$length; $i++)
                        {
                                $char = mb_substr($src, mt_rand(0,$srclen), 1);
                                $_SESSION['ilancedata']['user']['captcha'] .= $char;
                        }
            
                        // captcha logic (does server support image creation)?
                        if (extension_loaded('gd'))
                        {
                                $captcha = '<img src="attachment.php?do=captcha" alt="'.$phrase['_please_enter_the_security_code_shown_on_the_image_to_continue_registration'].'" border="0" />';
                        }
                        else
                        {
                                $captcha = '<div class="yellowhlite" style="width:95px; float:left"><div class="header" style="color:#ff6600; text-align: center;">'.$_SESSION['ilancedata']['user']['captcha'].'</div></div>';
                        }
            
                        $headinclude .= '
<script type="text/javascript">
<!--
function verifynotify(field1, field2, result_id, match_html, nomatch_html)
{
        this.field1 = field1;
        this.field2 = field2;
        this.result_id = result_id;
        this.match_html = match_html;
        this.nomatch_html = nomatch_html;
        this.check = function() 
        {
                if (!this.result_id) 
                {	 
                        return false; 
                }
                if (!document.getElementById)
                { 
                        return false; 
                }
                r = fetch_js_object(this.result_id);
                if (!r)
                { 
                        return false; 
                }

                if (this.field1.value != "" && this.field1.value == this.field2.value) 
                {
                    r.innerHTML = this.match_html;
                } 
                else 
                {
                    r.innerHTML = this.nomatch_html;
                }
        }
}

function register1(f)
{
        haveerrors = 0;
        (f.username.value.length < 1) ? showImage("usernameerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("usernameerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.password.value.length < 1) ? showImage("passworderror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("passworderror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.password2.value.length < 1) ? showImage("password2error", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("password2error", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.secretquestion.value.length < 1) ? showImage("secretquestionerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("secretquestionerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.secretanswer.value.length < 1) ? showImage("secretanswererror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("secretanswererror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.email.value.search("@") == -1 || f.email.value.search("[.*]") == -1) ? showImage("emailerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("emailerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.email2.value.search("@") == -1 || f.email2.value.search("[.*]") == -1) ? showImage("email2error", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("email2error", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        ' . ($ilconfig['registrationdisplay_turingimage'] ? '(f.turing.value.length < 1) ? showImage("turingerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("turingerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);' : '') . '
        return (!haveerrors);
}
//-->
</script>
';

$js = '
<script type="text/javascript">
<!--
verify = new verifynotify();
verify.field1 = fetch_js_object(\'password\');
verify.field2 = fetch_js_object(\'password2\');
verify.result_id = "password_result";
verify.match_html = "<span style=\"color:blue\"><img src=\"' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/checkmark.gif\" border=\"0\" alt=\"\" /></span>";
verify.nomatch_html = "";
verify.check();
//-->
</script>
';            
                        // custom registration questions [page 1]
                        $ilance->registration_questions = construct_object('api.registration_questions');
                        $customquestions = $ilance->registration_questions->construct_register_questions(1, 'input', 0);
                        
                        $roleselected = isset($ilance->GPC['roleid']) ? intval($ilance->GPC['roleid']) : '';
                        $rolepulldown = print_role_pulldown($roleselected, 0, 1);
                        
                        $ilance->template->load_file('main', 'register1.html');
                        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                        $ilance->template->parse_if_blocks('main');
                        $ilance->template->pprint('main', array('rolepulldown','customquestions','password','password2','secretquestion','secretanswer','js','captcha','username','email','email2','rid','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                        exit();
                }
                else
                {
                        // ########### STEP 3 ##################################
                        // construct breadcrumb trail
                        $navcrumb = array();
                        $navcrumb["$ilpage[registration]"] = $phrase['_registration'];
                        $navcrumb[""] = $phrase['_contact'];
                        
                        $error_firstname = $error_lastname = $error_phone = $error_address = $error_city = $error_zipcode = 0;
                        $first_name = $last_name = $address = $address2 = $city = $zipcode = $companyname = '';
                        
                        // unused
                        //$companyname_checkbox = '<input type="checkbox" name="usecompanyname" value="1" />';
                        
                        // construct countries / states pulldown
                        $jscity = $ilconfig['registrationdisplay_defaultcity'];
                        $formid = 'forms[' . SEARCHBOXHEADER . ']';
                        
                        $countryid = fetch_country_id($ilconfig['registrationdisplay_defaultcountry'], $_SESSION['ilancedata']['user']['slng']);
                        $country_js_pulldown = construct_country_pulldown($countryid, $ilconfig['registrationdisplay_defaultcountry']);
                        $state_js_pulldown = '<div id="stateid" style="height:20px">' . construct_state_pulldown($countryid, $ilconfig['registrationdisplay_defaultstate']) . '</div>';
                        
                        // currency pulldown menu
                        $currency_pulldown = $ilance->currency->pulldown('registration');
            
                        // language pulldown menu
                        $language_pulldown = $ilance->language->construct_language_pulldown();
            
                        // newsletter selection boxes
                        $ilance->categories_pulldown = construct_object('api.categories_pulldown');
                        if ($ilconfig['globalauctionsettings_serviceauctionsenabled'])
                        {
                                $ilance->categories->build_array($cattype = 'service', $_SESSION['ilancedata']['user']['slng'], $mode = 3, $propersort = true);
                                $service_newsletter = $ilance->categories_pulldown->print_cat_pulldown(0, $cattype = 'service', $type = 'levelmulti', $fieldname = 'subcategories', $showpleaseselectoption = 0, $_SESSION['ilancedata']['user']['slng'], $nooptgroups = 1, $prepopulate = '', $mode = 3, $showallcats = 0, $dojs = 0, $width = '99%', $uid = 0, $forcenocount = 1, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = false, $ilance->categories->cats);
                        }
                            
                        if ($ilconfig['globalauctionsettings_productauctionsenabled'])
                        {
                                $ilance->categories->build_array($cattype = 'product', $_SESSION['ilancedata']['user']['slng'], $mode = 3, $propersort = true);
                                $product_newsletter = $ilance->categories_pulldown->print_cat_pulldown(0, $cattype = 'product', $type = 'levelmulti', $fieldname = 'subcategories2', $showpleaseselectoption = 0, $_SESSION['ilancedata']['user']['slng'], $nooptgroups = 1, $prepopulate = '', $mode = 3, $showallcats = 0, $dojs = 0, $width = '99%', $uid = 0, $forcenocount = 1, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = false, $ilance->categories->cats);
                        }
            
                        // timezone pulldown menu
                        $timezone_pulldown  = $ilance->datetime->construct_timezone_pulldown('registration');
                        $timezone_dst_checkbox = '<input type="checkbox" name="user_timezone_dst" value="1" id="user_timezone_dst" />';
            
                        // display which phone format?
                        $show['us_phone_format'] = false;
                        if ($ilconfig['registrationdisplay_phoneformat'] == 'US')
                        {
                                $show['us_phone_format'] = true;
                        }
                        
                        // custom registration questions [page 2]
                        $ilance->registration_questions = construct_object('api.registration_questions');
                        $customquestions = $ilance->registration_questions->construct_register_questions(2, 'input', 0);
                                    
                        // specific javascript includes
                        $headinclude .= '
<script type="text/javascript">
<!--
function register2(f)
{
        haveerrors = 0;
        (f.first_name.value.length < 1) ? showImage("first_nameerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("first_nameerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.last_name.value.length < 1) ? showImage("last_nameerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("last_nameerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.address.value.length < 1) ? showImage("addresserror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("addresserror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.city.value.length < 1) ? showImage("cityerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("cityerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.zipcode.value.length < 1) ? showImage("zipcodeerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("zipcodeerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        ' . (($ilconfig['registrationdisplay_phoneformat'] == 'US') ? '(f.phone1.value.length < 1 || f.phone2.value.length < 1 || f.phone3.value.length < 1 || f.phone4.value.length < 1) ? showImage("phoneerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("phoneerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);' : '(f.phone1.value.length < 2) ? showImage("phoneerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("phoneerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);' ).'
        return (!haveerrors);
}
//-->
</script>
';                        
                        $ilance->template->load_file('main', 'register2.html');
                        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                        $ilance->template->parse_if_blocks('main');
                        $ilance->template->pprint('main', array('companyname_checkbox','companyname','service_newsletter','product_newsletter','customquestions','address','address2','city','zipcode','onsubmit','onload','currency_pulldown','language_pulldown','timezone_dst_checkbox','timezone_pulldown','onsubmit','dynamic_js_bodyend','state_js_pulldown','country_js_pulldown','js','first_name','last_name','input_style','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                        exit();
                }
        }
        
        // ########### STEP 3 ##################################################
        else if ($ilance->GPC['step'] == '3')
        {
                /*
                 [cmd] => register
                 [step] => 3
                 [categories] => 44,51,45,46,2,52,38,84,39,37,48,3,50,56,54,55
                 [categories2] => 44,51,45,46,2,52,38,84,39,37,48,3,50,56,54,55
                 [first_name] => 1
                 [last_name] => 1
                 [companyname] => 
                 [address] => address
                 [address2] =>
                 [phone1] => +
                 [phone2] => 111
                 [phone3] =>
                 [phone4] =>
                 [city] => city
                 [country] => Canada
                 [state] => Ontario
                 [zipcode] => 123123
                 [timezone] => -5
                 [currencyid] => 1
                 [languageid] => 1
                 [notifyservicescats] => 1
                 [notifyproductscats] => 1
                 [submit] => Continue Registration
                 */
                 
                 if (empty($_SESSION['ilancedata']['user']['username']) OR empty($_SESSION['ilancedata']['user']['agreeterms']))
                 {
                        $area_title = $phrase['_your_session_has_expired_please_login'];
                        $page_title = SITE_NAME . ' - '.$phrase['_your_session_has_expired_please_login'];
                        
                        $navcrumb = array("$ilpage[main]" => $phrase['_your_session_has_expired_please_login']);
                        print_notice($phrase['_your_session_has_expired_please_login'], $phrase['_either_your_session_has_expired_or_you_are_a_guest_attempting_to_access_a_member_resource'], $ilpage['registration']."?cmd=register&amp;step=1", $phrase['_register_to_login_here']);
                        exit();
                 }
                 
                 // construct breadcrumb trail
                 $navcrumb = array();
                 $navcrumb["$ilpage[registration]"] = $phrase['_registration'];
                 $navcrumb[""] = $phrase['_user_registration'];
                 
                 $error_firstname = 0;
                 $error_lastname = 0;
                 $error_phone = 0;
                 $error_address = 0;
                 $error_city = 0;
                 $error_zipcode = 0;
                 
                 // handle custom questions in this section
                 if (isset($ilance->GPC['custom']) AND is_array($ilance->GPC['custom']))
                 {
                        foreach ($ilance->GPC['custom'] as $questionid => $answerarray)
                        {
                                foreach ($answerarray as $formname => $answer)
                                {
                                        $_SESSION['ilancedata']['questions']["$formname"] = $answer;
                                }
                        }
                 }
                 
                 // set desired language for new user
                 if (isset($ilance->GPC['languageid']) AND $ilance->GPC['languageid'] > 0)
                 {
                        $_SESSION['ilancedata']['preferences']['languageid'] = intval($ilance->GPC['languageid']);
                        
                        // update existing user session language
                        // if the language was changed this should begin the switch to the desired language
                        $_SESSION['ilancedata']['user']['languageid'] = intval($ilance->GPC['languageid']);
                        $_SESSION['ilancedata']['user']['languagecode'] = $ilance->language->print_language_code(intval($ilance->GPC['languageid']));
                 }
                 
                 if ($ilconfig['registrationdisplay_phoneformat'] == 'US')
                 {
                        $show['us_phone_format'] = true;
                        if (empty($ilance->GPC['phone1']) OR empty($ilance->GPC['phone2']) OR empty($ilance->GPC['phone3']) OR empty($ilance->GPC['phone4']))
                        {
                                $error_phone = 1;
                        }
                        else
                        {
                                $_SESSION['ilancedata']['user']['phone'] = trim($ilance->GPC['phone1'] . $ilance->GPC['phone2'] . $ilance->GPC['phone3'] . $ilance->GPC['phone4']);
                        }
                 }
                 else
                 {
                        $show['us_phone_format'] = false;
                        if (empty($ilance->GPC['phone1']))
                        {
                                $error_phone = 1;
                        }
                        else
                        {
                                $_SESSION['ilancedata']['user']['phone'] = trim($ilance->GPC['phone1']);
                        }
                 }
                 
                 if (isset($ilance->GPC['first_name']) AND !empty($ilance->GPC['first_name']))
                 {
                        $_SESSION['ilancedata']['user']['firstname'] = ucwords($ilance->GPC['first_name']);
                        $first_name = $_SESSION['ilancedata']['user']['firstname'];
                 }
                 else
                 {
                        $error_firstname = 1;
                        $first_name = '';
                 }
         
                 if (isset($ilance->GPC['last_name']) AND !empty($ilance->GPC['last_name']))
                 {
                        $_SESSION['ilancedata']['user']['lastname'] = ucwords($ilance->GPC['last_name']);
                        $last_name = $_SESSION['ilancedata']['user']['lastname'];
                 }
                 else
                 {
                        $error_lastname = 1;
                        $last_name = '';
                 }
         
                 if (isset($ilance->GPC['address']) AND !empty($ilance->GPC['address']))
                 {
                        $_SESSION['ilancedata']['user']['address'] = ucwords($ilance->GPC['address']);
                        $address = $_SESSION['ilancedata']['user']['address'];
                 }
                 else
                 {
                        $error_address = 1;
                        $address = '';
                 }
         
                 if (isset($ilance->GPC['address2']) AND !empty($ilance->GPC['address2']))
                 {
                        $_SESSION['ilancedata']['user']['address2'] = ucwords($ilance->GPC['address2']);
                        $address2 = $_SESSION['ilancedata']['user']['address2'];
                 }
                 else
                 {
                        $_SESSION['ilancedata']['user']['address2'] = '';
                        $address2 = '';
                 }
         
                 if (isset($ilance->GPC['city']) AND !empty($ilance->GPC['city']))
                 {
                        $_SESSION['ilancedata']['user']['city'] = ucwords($ilance->GPC['city']);
                        $city = $_SESSION['ilancedata']['user']['city'];
                 }
                 else
                 {
                        $error_city = 1;
                        $city = '';
                 }
         
                 if (isset($ilance->GPC['zipcode']) AND !empty($ilance->GPC['zipcode']))
                 {
                        $_SESSION['ilancedata']['user']['zipcode'] = trim($ilance->GPC['zipcode']);
                        $zipcode = $_SESSION['ilancedata']['user']['zipcode'];
                 }
                 else
                 {
                        $error_zipcode = 1;
                        $zipcode = '';
                 }
                 
                 if (isset($ilance->GPC['country']) AND !empty($ilance->GPC['country']))
                 {
                        $_SESSION['ilancedata']['user']['country'] = trim($ilance->GPC['country']);
                        $_SESSION['ilancedata']['user']['countryid'] = fetch_country_id($_SESSION['ilancedata']['user']['country'], $_SESSION['ilancedata']['user']['slng']);
                        $country = $_SESSION['ilancedata']['user']['country'];
                 }
                 else
                 {
                        $country = '';
                 }
                 
                 if (isset($ilance->GPC['state']) AND !empty($ilance->GPC['state']))
                 {
                        $_SESSION['ilancedata']['user']['state'] = $ilance->GPC['state'];
                        $state = $_SESSION['ilancedata']['user']['state'];
                 }
                 else
                 {
                        $state = '';
                 }
                 
                 // build user preferences
                 $_SESSION['ilancedata']['preferences']['notifyservicescats'] = '';
                 $_SESSION['ilancedata']['preferences']['notifyservices'] = 0;
                 $notifyservicescats = '';
                 $selectedcats = '';
                 if (isset($ilance->GPC['subcategories']) AND $ilance->GPC['subcategories'] != '')
                 {
                        foreach ($ilance->GPC['subcategories'] as $key => $cid)
                        {
                                $selectedcats .= $cid . ',';
                        }
                        $selectedcats = mb_substr($selectedcats, 0, -1);
                        
                        $_SESSION['ilancedata']['preferences']['notifyservicescats'] = $selectedcats;
                        $notifyservicescats = $_SESSION['ilancedata']['preferences']['notifyservicescats'];
                        
                        $_SESSION['ilancedata']['preferences']['notifyservices'] = 0;
                        if (isset($ilance->GPC['notifyservices']) AND $ilance->GPC['notifyservices'])
                        {
                                $_SESSION['ilancedata']['preferences']['notifyservices'] = 1;
                        }
                 }
         
                 $_SESSION['ilancedata']['preferences']['notifyproductscats'] = '';
                 $_SESSION['ilancedata']['preferences']['notifyproducts'] = 0;
                 $notifyproductscats = '';
                 $selected2cats = '';
                 if (isset($ilance->GPC['subcategories2']) AND $ilance->GPC['subcategories2'] != '')
                 {
                        foreach ($ilance->GPC['subcategories2'] as $key => $cid)
                        {
                                $selected2cats .= $cid . ',';
                        }
                        $selected2cats = mb_substr($selected2cats, 0, -1);
                            
                        $_SESSION['ilancedata']['preferences']['notifyproductscats'] = $selectedcats;
                        $notifyproductscats = $_SESSION['ilancedata']['preferences']['notifyproductscats'];
                        
                        $_SESSION['ilancedata']['preferences']['notifyproducts'] = 0;
                        if (isset($ilance->GPC['notifyproducts']) AND $ilance->GPC['notifyproducts'])
                        {
                                $_SESSION['ilancedata']['preferences']['notifyproducts'] = 1;
                        }
                 }
                 
                 // currency
                 if (isset($ilance->GPC['currencyid']) AND $ilance->GPC['currencyid'] > 0)
                 {
                        $_SESSION['ilancedata']['preferences']['currencyid'] = intval($ilance->GPC['currencyid']);
                 }
         
                 // timezone
                 if (isset($ilance->GPC['timezone']) AND $ilance->GPC['timezone'] != '')
                 {
                        $_SESSION['ilancedata']['preferences']['usertimezone'] = trim($ilance->GPC['timezone']);
                 }
                 else
                 {
                        $_SESSION['ilancedata']['preferences']['usertimezone'] = '0';
                 }
                 
                 // daylight savings time offset enabled?
                 if (isset($ilance->GPC['user_timezone_dst']) AND $ilance->GPC['user_timezone_dst'] > 0)
                 {
                        $_SESSION['ilancedata']['preferences']['usertimezone_dst'] = 1;
                 }
                 else
                 {
                        $_SESSION['ilancedata']['preferences']['usertimezone_dst'] = 0;
                 }      
                 
                 // company name
                 if (isset($ilance->GPC['companyname']) AND !empty($ilance->GPC['companyname']))
                 {
                        $_SESSION['ilancedata']['preferences']['companyname'] = trim($ilance->GPC['companyname']);
                        $companyname = $_SESSION['ilancedata']['preferences']['companyname'];
                 }
                 else
                 {
                        $_SESSION['ilancedata']['preferences']['companyname'] = '';
                        $companyname = '';
                 }
         
                 // final checkups
                 if (isset($error_firstname) AND $error_firstname OR isset($error_lastname) AND $error_lastname OR isset($error_address) AND $error_address OR isset($error_city) AND $error_city OR isset($error_zipcode) AND $error_zipcode OR isset($error_phone) AND $error_phone)
                 {
                        // ########### ERRORS: BACK TO STEP 2 ##################
                        $navcrumb = array();
                        $navcrumb["$ilpage[registration]"] = $phrase['_registration'];
                        $navcrumb[""] = $phrase['_contact'];
            
                        // construct countries / states pulldown
                        $jscity = $ilconfig['registrationdisplay_defaultcity'];
                        $formid = 'forms[' . SEARCHBOXHEADER . ']';
                        
                        $countryid = fetch_country_id($ilconfig['registrationdisplay_defaultcountry'], $_SESSION['ilancedata']['user']['slng']);
                        $country_js_pulldown = construct_country_pulldown($countryid, $ilconfig['registrationdisplay_defaultcountry']);
                        $state_js_pulldown = '<div id="stateid" style="height:20px">' . construct_state_pulldown($countryid, $ilconfig['registrationdisplay_defaultstate']) . '</div>';

                        // currency pulldown menu
                        $currency_pulldown = $ilance->currency->pulldown('registration');
            
                        // language pulldown menu
                        $language_pulldown = $ilance->language->construct_language_pulldown();
            
                        // newsletter selection boxes
                        $ilance->categories_pulldown = construct_object('api.categories_pulldown');
                        if ($ilconfig['globalauctionsettings_serviceauctionsenabled'])
                        {
                                $ilance->categories->build_array($cattype = 'service', $_SESSION['ilancedata']['user']['slng'], $mode = 3, $propersort = true);
                                $service_newsletter = $ilance->categories_pulldown->print_cat_pulldown(0, $cattype = 'service', $type = 'levelmulti', $fieldname = 'subcategories', $showpleaseselectoption = 0, $_SESSION['ilancedata']['user']['slng'], $nooptgroups = 1, $prepopulate = '', $mode = 3, $showallcats = 0, $dojs = 0, $width = '99%', $uid = 0, $forcenocount = 1, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = false, $ilance->categories->cats);
                        }
                            
                        if ($ilconfig['globalauctionsettings_productauctionsenabled'])
                        {
                                $ilance->categories->build_array($cattype = 'product', $_SESSION['ilancedata']['user']['slng'], $mode = 3, $propersort = true);
                                $product_newsletter = $ilance->categories_pulldown->print_cat_pulldown(0, $cattype = 'product', $type = 'levelmulti', $fieldname = 'subcategories2', $showpleaseselectoption = 0, $_SESSION['ilancedata']['user']['slng'], $nooptgroups = 1, $prepopulate = '', $mode = 3, $showallcats = 0, $dojs = 0, $width = '99%', $uid = 0, $forcenocount = 1, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = false, $ilance->categories->cats);
                        }
            
                        // timezone pulldown menu
                        $timezone_pulldown  = $ilance->datetime->construct_timezone_pulldown('registration');
                        $timezone_dst_checkbox = '<input type="checkbox" name="user_timezone_dst" value="1" id="user_timezone_dst" />';
            
                        // custom registration questions [page 2]
                        $ilance->registration_questions = construct_object('api.registration_questions');
                        $customquestions = $ilance->registration_questions->construct_register_questions(2, 'input', 0);
                        
                        // specific javascript includes
                        $headinclude .= '
<script type="text/javascript">
<!--
function register2(f)
{
        haveerrors = 0;
        (f.first_name.value.length < 1) ? showImage("first_nameerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("first_nameerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.last_name.value.length < 1) ? showImage("last_nameerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("last_nameerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.address.value.length < 1) ? showImage("addresserror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("addresserror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.city.value.length < 1) ? showImage("cityerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("cityerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.zipcode.value.length < 1) ? showImage("zipcodeerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("zipcodeerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        '.(($ilconfig['registrationdisplay_phoneformat'] == 'US') ? '(f.phone1.value.length < 1 || f.phone2.value.length < 3 || f.phone3.value.length < 3 || f.phone4.value.length < 4) ? showImage("phoneerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("phoneerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);' : '(f.phone1.value.length < 1) ? showImage("phoneerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("phoneerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);' ).'
        return (!haveerrors);
}
//-->
</script>
';                                    
                        $ilance->template->load_file('main', 'register2.html');
                        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                        $ilance->template->parse_if_blocks('main');
                        $ilance->template->pprint('main', array('companyname','service_newsletter','product_newsletter','customquestions','address','address2','city','zipcode','onsubmit','onload','currency_pulldown','language_pulldown','timezone_dst_checkbox','timezone_pulldown','onsubmit','dynamic_js_bodyend','state_js_pulldown','country_js_pulldown','js','first_name','last_name','input_style','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                        exit();
                 }
                 else
                 {
                        // construct breadcrumb trail
                        $navcrumb = array();
                        $navcrumb["$ilpage[registration]"] = $phrase['_registration'];
                        $navcrumb[""] = $phrase['_subscription'];
                        
                        // fetch subscription plans within selected role type customer selected on page 1
                        $result = $ilance->db->query("
                                SELECT subscriptionid, title, description, cost, length, units, subscriptiongroupid, roleid
                                FROM " . DB_PREFIX . "subscription
                                WHERE visible = '1'
                                ORDER BY cost ASC");
                        if ($ilance->db->num_rows($result) > 0)
                        {
                                $row_count = 0;
                                while ($row = $ilance->db->fetch_array($result))
                                {
                                        if ($row['roleid'] == $_SESSION['ilancedata']['user']['roleid'])
                                        {
                                                $row['class'] = 'featured_highlight';
                                                if ($row['cost'] > 0)
                                                {
                                                        $onload .= 'return toggle_paid(\'paid\');';
                                                        $row['action'] = '<input type="radio" name="subscriptionid" value="' . $row['subscriptionid'] . '" onclick="toggle_paid(\'paid\')" checked="checked" />';
                                                }
                                                else
                                                {
                                                        $row['action'] = '<input type="radio" name="subscriptionid" value="' . $row['subscriptionid'] . '" onclick="toggle_free(\'paid\')" checked="checked" />';    					
                                                }
                                        }
                                        else
                                        {
                                                $row['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                                                if ($row['cost'] > 0)
                                                {
                                                        $row['action'] = '<input type="radio" name="subscriptionid" value="' . $row['subscriptionid'] . '" onclick="toggle_paid(\'paid\')" />';
                                                }
                                                else
                                                {
                                                        $row['action'] = '<input type="radio" name="subscriptionid" value="' . $row['subscriptionid'] . '" onclick="toggle_free(\'paid\')" />';    					
                                                }
                                        }
                                        $row['title'] = stripslashes($row['title']);
                                        $row['description'] = stripslashes($row['description']);
                                        if ($row['cost'] > 0)
                                        {
                                                $row['cost'] = print_currency_conversion($_SESSION['ilancedata']['preferences']['currencyid'], $row['cost']);
                                        }
                                        else
                                        {
                                                $row['cost'] = $phrase['_free'];
                                        }
                                        $row['units'] = print_unit($row['units']);
                                        $row['access'] = '<a href="javascript:void(0)" onclick=Attach("' . $ilpage['subscription'] . '?cmd=access&gid=' . $row['subscriptiongroupid'] . '&s=' . session_id() . '")>' . $phrase['_view_access'] . '</a>';
                                        $row['roletype'] = print_role($row['roleid']);
                                        $subscription[] = $row;
                                        $row_count++;
                                }
                                
                                $show['no_subscription'] = false;
                        }
                        else
                        {
                                $show['no_subscription'] = true;
                        }
            
                        // subscription payment pulldown
                        $payment_method_pulldown = print_paymethod_pulldown('registration', 'paymethod');
                        
                        // custom registration questions [page 3]
                        $ilance->registration_questions = construct_object('api.registration_questions');
                        $customquestions = $ilance->registration_questions->construct_register_questions(3, 'input', 0);
                                    
                        // specific javascript includes
                        $headinclude .= '
<script language="JavaScript">
<!--
function subscription_check()
{
        var radio_choice = false;
        if (document.forms['.SEARCHBOXHEADER.'].subscriptionid.length == undefined)
        {
                // single subscription plan detected
                if (document.forms['.SEARCHBOXHEADER.'].subscriptionid.checked == true)
                {
                        radio_choice = true;
                }
        }
        else
        {
                // multiple subscription plans to choose from
                for (counter = 0; counter < document.forms['.SEARCHBOXHEADER.'].subscriptionid.length; counter++)
                {
                        if (document.forms['.SEARCHBOXHEADER.'].subscriptionid[counter].checked)
                        {
                                radio_choice = true;
                        }
                }
        }
        if (!radio_choice)
        {
                alert(phrase[\'_you_did_not_select_a_subscription_plan_above\'])
                return (false);
        }
        return (true);
}
//-->
</script>
';                        
                        // expire any existing member cookies so our next page can create fresh ones
                        set_cookie('userid', '', false);
                        set_cookie('password', '', false);
                        set_cookie('username', '', false);
                        
                        $ilance->template->load_file('main', 'register3.html');
                        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                        $ilance->template->parse_loop('main', 'subscription');
                        $ilance->template->parse_if_blocks('main');
                        $ilance->template->pprint('main', array('customquestions','payment_method_pulldown','onload','js','input_style','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                        exit();
                 }
        }
        
        // ########### STEP 4 ##################################################
        else if ($ilance->GPC['step'] == '4')
        {
                if (empty($_SESSION['ilancedata']['user']['username']))
                {
                        $area_title = $phrase['_your_session_has_expired_please_login'];
                        $page_title = SITE_NAME . ' - ' . $phrase['_your_session_has_expired_please_login'];
                        
                        $navcrumb = array("$ilpage[main]" => $phrase['_your_session_has_expired_please_login']);
                        print_notice($phrase['_your_session_has_expired_please_login'], $phrase['_either_your_session_has_expired_or_you_are_a_guest_attempting_to_access_a_member_resource'], $ilpage['registration']."?cmd=register&amp;step=1", $phrase['_register_to_login_here']);
                        exit();
                }
                
                // handle custom questions from page 3
                if (isset($ilance->GPC['custom']) AND is_array($ilance->GPC['custom']))
                {
                        foreach ($ilance->GPC['custom'] as $questionid => $answerarray)
                        {
                                foreach ($answerarray as $formname => $answer)
                                {
                                        $_SESSION['ilancedata']['questions']["$formname"] = $answer;
                                }
                        }
                }
                
                // build subscription plan session
                if ($ilance->GPC['subscriptionid'] > 0)
                {
                        $_SESSION['ilancedata']['subscription']['subscriptionid'] = intval($ilance->GPC['subscriptionid']);
                        $_SESSION['ilancedata']['subscription']['subscriptionpaymethod'] = mb_strtolower(trim($ilance->GPC['paymethod']));
                }
                else
                {
                        $_SESSION['ilancedata']['subscription']['subscriptionid'] = '1';
                        $_SESSION['ilancedata']['subscription']['subscriptionpaymethod'] = 'account';
                }       
        
                // support promotional code feature
                if (!empty($ilance->GPC['promocode']))
                {
                        $_SESSION['ilancedata']['subscription']['promocode'] = trim($ilance->GPC['promocode']);
                }
                else
                {
                        $_SESSION['ilancedata']['subscription']['promocode'] = '';
                }
        
                $navcrumb = array();
                $navcrumb["$ilpage[registration]"] = $phrase['_registration'];
                $navcrumb[""] = $phrase['_message'];
                
                // find out if we had any questions to answer
                if (empty($_SESSION['ilancedata']['questions']))
                {
                        $_SESSION['ilancedata']['questions'] = array();    
                }       
                
                // notes: you may send 3 custom arguments:
                // return_userid        : returns only the new user ID
                // return_userstatus    : returns the new users status (login status, active, unverified, etc)
                // return_userarray     : returns the full user array of the created member
                $dowhat = 'return_userarray';
        
                $ilance->registration = construct_object('api.registration');
                
                $final = $ilance->registration->build_user_datastore($_SESSION['ilancedata']['user'], $_SESSION['ilancedata']['preferences'], $_SESSION['ilancedata']['subscription'], $_SESSION['ilancedata']['questions'], $dowhat);
                if (!empty($final))
                {
                        // set new user cookies
                        set_cookie('userid', $ilance->crypt->three_layer_encrypt($final['userid'], $ilconfig['key1'], $ilconfig['key2'], $ilconfig['key3']), true);
                        set_cookie('username', $ilance->crypt->three_layer_encrypt($final['username'], $ilconfig['key1'], $ilconfig['key2'], $ilconfig['key3']), true);
                        set_cookie('password', $ilance->crypt->three_layer_encrypt($final['password'], $ilconfig['key1'], $ilconfig['key2'], $ilconfig['key3']), true);
                        set_cookie('lastvisit', DATETIME24H, true);
                        set_cookie('lastactivity', DATETIME24H, true);
                                    
                        switch ($final['status'])
                        {
                                case 'active':
                                {
                                        // make sure we have a valid password session
                                        if (!empty($_SESSION['ilancedata']['user']['password_md5']))
                                        {
                                                $_SESSION['ilancedata']['user']['password'] = $_SESSION['ilancedata']['user']['password_md5'];
                                                session_unregister($_SESSION['ilancedata']['user']['password_md5']);
                                        }
                                        
                                        // display final registration information
                                        print_notice($phrase['_registration_complete'], $phrase['_thank_you_your_registration_is_now_complete'], $ilpage['main'] . '?cmd=cp', $phrase['_my_cp']);
                                        break;
                                }                            
                                case 'unverified':
                                {
                                        // display email link code information
                                        print_notice($phrase['_registration_not_completed'], $phrase['_thank_you_for_registering_an_email_has_been_dispatched_to_you'], $ilpage['login'], $phrase['_sign_in']);
                                        break;
                                }
                                case 'moderated':
                                {
                                        // display email link code information
                                        print_notice($phrase['_registration_complete'], $phrase['_thank_you_your_registration_is_now_complete_and_is_pending_verification'], $ilpage['main'], $phrase['_main_menu']);
                                        break;
                                }
                        }
                        exit();
                }
                else
                {
                        print_notice($phrase['_registration_error_occured'], $phrase['_were_sorry_we_only_allow_forms_to_be_securely_processed_via_our_web_site'], $ilpage['registration'] . '?cmd=register&step=1', $phrase['_register_to_login_here']);
                        exit();
                }
        }
}
else
{
        $area_title = $phrase['_registration_terms_and_agreements_review'];
        $page_title = SITE_NAME . ' - ' . $phrase['_registration_terms_and_agreements_review'];
        
        $navcrumb = array();
        $navcrumb["$ilpage[registration]"] = $phrase['_registration'];
        $navcrumb[""] = $phrase['_terms'];
        
        $ilance->template->load_file('main', 'registration.html');
        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
        $ilance->template->parse_if_blocks('main');
        $ilance->template->pprint('main', array('first_name','last_name','input_style','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
        exit();
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: registration.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>