<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

// #### load required phrase groups ############################################
$phrase['groups'] = array(
        'search',
        'stores',
        'wantads',
        'subscription',
        'preferences',
        'javascript'
);

// #### load required javascript ###############################################
$jsinclude = array(
        'search',
        'tabfx',
        'jquery',
        'modal',
        'yahoo'
);

// #### define top header nav ##################
$topnavlink = array(
        'main_listings'
);

// #### setup script location ##################################################
define('LOCATION','search');


// #### require backend ########################################################
require_once('./functions/config.php');
require_once(DIR_CORE . 'functions_search.php');
require_once(DIR_CORE . 'functions_search_prefs.php');

// #### setup default breadcrumb ###############################################
$navcrumb = array("$ilpage[search]" => $ilcrumbs["$ilpage[search]"]);

$tab = '0';
if (isset($ilance->GPC['tab']))
{
        $tab = intval($ilance->GPC['tab']);
}

// #### SEARCH HELP : FULLTEXT BOOLEAN INFO ####################################
if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'help')
{
        $pprint_array = array('profilebidfilters','skills_selection','returnurl','js_start','perpage','sortpulldown','sortpulldown2','rb_list_gallery','rb_list_list','rb_showtimeas_flash','rb_showtimeas_static','cb_username','cb_latestfeedback','cb_online','cb_description','cb_icons','cb_currencyconvert','cb_displayfeatured','cb_hidelisted','cb_proxybit','cb_hideverbose','serviceavailable','serviceselected','productavailable','productselected','expertavailable','expertselected','keywords','searcherror','fromprice','toprice','budgetfilter','tab','search_offersrange_pulldown','search_wantedsincerange_pulldown','wantads_category_selection','search_country_pulldown2','search_soldrange_pulldown','search_itemsrange_pulldown','search_opensincerange_pulldown','stores_category_selection','product_category_selection','service_category_selection','search_serviceauctions_img','search_serviceauctions_collapse','search_productauctions_img','search_productauctions_collapse','search_experts_collapse','search_experts_img','pfp_category_left','rfp_category_left','input_style','search_country_pulldown','search_jobtype_pulldown','search_ratingrange_pulldown','search_awardrange_pulldown','search_bidrange_pulldown','search_listed_pulldown','search_closing_pulldown','input_style','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
        
        $ilance->template->load_file('main', 'search_help.html');
        $ilance->template->parse_if_blocks('main');
        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
        $ilance->template->pprint('main', $pprint_array);
        exit();
}

// #### TIMER TO PREVENT SEARCH FLOODING #######################################
$show['searcherror'] = 0;
$searchwait = $ilconfig['searchflooddelay'];
$searchwaitleft = 0;
if (!empty($ilance->GPC['mode']) AND $ilconfig['searchfloodprotect'] AND isset($ilance->GPC['q']) AND $ilance->GPC['q'] != '')
{
        if (empty($_SESSION['ilancedata']['user']['searchexpiry']))
        {
                // start timer
                $_SESSION['ilancedata']['user']['searchexpiry'] = TIMESTAMPNOW;
        }
        else
        {
                if (($timeexpired = TIMESTAMPNOW - $_SESSION['ilancedata']['user']['searchexpiry']) < $searchwait AND $searchwait != 0)
                {
                        $show['searcherror'] = 1;
                        $searchwaitleft = ($searchwait - $timeexpired);
                }
                else
                {
                        // restart timer
                        $_SESSION['ilancedata']['user']['searchexpiry'] = TIMESTAMPNOW;
                }
        }
}

// #### SEARCH ENGINE HANDLER ##################################################
$sqlquery = array();

// construct our common classes
$ilance->auction = construct_object('api.auction');
$ilance->categories_parser = construct_object('api.categories_parser');
$ilance->categories_skills = construct_object('api.categories_skills');
$ilance->categories_pulldown = construct_object('api.categories_pulldown');
$ilance->distance = construct_object('api.distance');
$ilance->subscription = construct_object('api.subscription');
$ilance->feedback = construct_object('api.feedback');
$ilance->feedback_rating = construct_object('api.feedback_rating');  
$ilance->auction_post = construct_object('api.auction_post');                      

// build our service category cache
$categorycacheservice = $ilance->categories->build_array($cattype = 'service', $_SESSION['ilancedata']['user']['slng'], $mode = 0, $propersort = true);
$ilance->categories->catservice = $ilance->categories->cats;
$ilance->categories->catservicefetch = $ilance->categories->fetch;

// selected category id
$cid = isset($ilance->GPC['cid']) ? intval($ilance->GPC['cid']) : 0;

// print multiple selection category menu
$service_category_selection = $product_category_selection = $provider_category_selection = '';
if ($ilconfig['globalauctionsettings_serviceauctionsenabled'])
{
        if ($ilconfig['multilevelpulldown'] == false)
        {
                $service_category_selection = $ilance->categories_pulldown->print_root_category_pulldown($cid, 'service', 'cid', $_SESSION['ilancedata']['user']['slng'], $ilance->categories->catservice);
        }
        else
        {
                $service_category_selection = $ilance->categories_pulldown->print_cat_pulldown(0, $cattype = 'service', $type = 'levelmultisearch', $fieldname = 'cid', $showpleaseselectoption = 0, $_SESSION['ilancedata']['user']['slng'], $nooptgroups = 1, $prepopulate = '', $mode = 0, $showallcats = 1, $dojs = 0, $width = '100%', $uid = 0, $forcenocount = 0, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = false, $ilance->categories->catservice);
        }
        
        $provider_category_selection = $ilance->categories_pulldown->print_cat_pulldown(0, $cattype = 'service', $type = 'levelmultisearch', $fieldname = 'cid', $showpleaseselectoption = 0, $_SESSION['ilancedata']['user']['slng'], $nooptgroups = 1, $prepopulate = '', $mode = 0, $showallcats = 1, $dojs = 0, $width = '350px', $uid = 0, $forcenocount = 0, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = false, $ilance->categories->catservice, $onclickjs = true);
}
if (isset($ilance->GPC['mode']) AND ($ilance->GPC['mode'] == 'service' OR $ilance->GPC['mode'] == 'experts'))
{
        if ($ilconfig['multilevelpulldown'] == false)
        {
                // admin would like to show single pulldown category menu
                $search_category_pulldown = $ilance->categories_pulldown->print_root_category_pulldown($cid, 'service', 'cid', $_SESSION['ilancedata']['user']['slng'], $ilance->categories->catservice);
        }
        else
        {
                $search_category_pulldown = $ilance->categories_pulldown->print_cat_pulldown($cid, 'service', 'level', 'cid', $showpleaseselectoption = 1, $_SESSION['ilancedata']['user']['slng'], $nooptgroups = 1, $prepopulate = '', $mode = 0, $showallcats = 1, $dojs = 0, $width = '540px', $uid = 0, $forcenocount = 1, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = true, $ilance->categories->catservice);
        }
}

$profilebidfilters = '<div id="profile_filters_text">' . $ilance->auction_post->print_profile_bid_filters($cid, 'input', 'service') . '</div>';

// build our product category cache
$categorycacheproduct = $ilance->categories->build_array($cattype = 'product', $_SESSION['ilancedata']['user']['slng'], $mode = 0, $propersort = true);
$ilance->categories->catproduct = $ilance->categories->cats;
$ilance->categories->catproductfetch = $ilance->categories->fetch;

if ($ilconfig['globalauctionsettings_productauctionsenabled'])
{
        if ($ilconfig['multilevelpulldown'] == false)
        {
                $product_category_selection = $ilance->categories_pulldown->print_root_category_pulldown($cid, 'product', 'cid', $_SESSION['ilancedata']['user']['slng'], $ilance->categories->catproduct);        
        }
        else
        {
                $product_category_selection = $ilance->categories_pulldown->print_cat_pulldown(0, $cattype = 'product', $type = 'levelmultisearch', $fieldname = 'cid', $showpleaseselectoption = 0, $_SESSION['ilancedata']['user']['slng'], $nooptgroups = 1, $prepopulate = '', $mode = 0, $showallcats = 1, $dojs = 0, $width = '100%', $uid = 0, $forcenocount = 0, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = false, $ilance->categories->catproduct);
        }
}

if (isset($ilance->GPC['mode']) AND $ilance->GPC['mode'] == 'product')
{
        if ($ilconfig['multilevelpulldown'] == false)
        {
                // admin would like to show single pulldown category menu
                $search_category_pulldown = $ilance->categories_pulldown->print_root_category_pulldown($cid, 'product', 'cid', $_SESSION['ilancedata']['user']['slng'], $ilance->categories->catproduct);
        }
        else
        {
                $search_category_pulldown = $ilance->categories_pulldown->print_cat_pulldown($cid, 'product', 'level', 'cid', $showpleaseselectoption = 1, $_SESSION['ilancedata']['user']['slng'], $nooptgroups = 1, $prepopulate = '', $mode = 0, $showallcats = 1, $dojs = 0, $width = '540px', $uid = 0, $forcenocount = 1, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = true, $ilance->categories->catproduct);
        }
}

if (!empty($ilance->GPC['mode']) AND $show['searcherror'] == 0)
{
        // #### PREPARE DEFAULT URLS ###########################################
        $scriptpage = $ilpage['search'] . print_hidden_fields($string = true, $excluded = array('page','budget'), $questionmarkfirst = true, $prepend_text = '', $append_text = '', $htmlentities = true, $urldecode = false);
        
        $php_self = $scriptpage;
        $php_self_urlencoded = urlencode($php_self);
        
        define('PHP_SELF', HTTP_SERVER . $php_self);
        
        $show['widescreen'] = true;
        
        switch ($ilance->GPC['mode'])
        {
                // #### SEARCHING FOR PROJECT ID ###############################
                case 'rfpid':
                {
                        if (empty($ilance->GPC['q']) OR !isset($ilance->GPC['q']))
                        {
                                header("Location: " . $ilpage['search'] . "?tab=0");
                                exit();
                        }
                        
                        header("Location: " . $ilpage['rfp'] . "?id=" . intval($ilance->GPC['q']) . "");
                        exit();
                }
                
                // #### SEARCHING FOR ITEM ID ##################################
                case 'itemid':
                {
                        if (empty($ilance->GPC['q']) OR !isset($ilance->GPC['q']))
                        {
                                header("Location: " . $ilpage['search'] . "?tab=1");
                                exit();
                        }
                        
                        header("Location: " . $ilpage['merch'] . "?id=" . intval($ilance->GPC['q']) . "");
                        exit();
                }
                
                // #### SEARCHING SERVICE AND PRODUCT AUCTIONS #################
                case 'service':
                case 'product':
                {
                        $ilance->bid = construct_object('api.bid');
                        $ilance->bid_lowest_unique = construct_object('api.bid_lowest_unique');
                        $ilance->bid_proxy = construct_object('api.bid_proxy');
                        $ilance->auction = construct_object('api.auction');
                        $ilance->auction_post = construct_object('api.auction_post');
                        
                        if (!isset($ilance->GPC['page']) OR isset($ilance->GPC['page']) AND $ilance->GPC['page'] <= 0)
                        {
                                $ilance->GPC['page'] = 1;
                        }
                        else
                        {
                                $ilance->GPC['page'] = intval($ilance->GPC['page']);
                        }
                        
                        // search mode logic
                        $show['mode_product'] = $show['mode_providers'] = $show['mode_service'] = false;
                        
                        if ($ilance->GPC['mode'] == 'service')
                        {
                                $navcrumb[""] = $phrase['_services'];
                                
                                $show['mode_service'] = true;
                                $project_state = 'service';
                                $sqlquery['projectstate'] = "AND (project_state = 'service')";
                        }
                        else if ($ilance->GPC['mode'] == 'product')
                        {
                                $navcrumb[""] = $phrase['_products'];
                                
                                $show['mode_product'] = true;
                                $project_state = 'product';
                                $sqlquery['projectstate'] = "AND (project_state = 'product')";
                        }
                        
                        // here we should take the user to "all category listings" if he chose a "mode" but didn't select a category and keyword.
                        if (!empty($ilance->GPC['mode']) AND empty($ilance->GPC['searchuser']) AND empty($ilance->GPC['state']) AND empty($ilance->GPC['country']) AND empty($ilance->GPC['sort']) AND (empty($ilance->GPC['q']) AND (empty($ilance->GPC['cid']) OR !empty($ilance->GPC['cid']) AND $ilance->GPC['cid'] == 0)))
                        {
                                switch ($ilance->GPC['mode'])
                                {
                                        case 'service':
                                        {
                                                $reurl = '';
                                                $reurl = ($ilconfig['globalauctionsettings_seourls']) ? HTTP_SERVER . print_seo_url($ilconfig['servicecatmapidentifier']) : $ilpage['rfp'] . '?cmd=listings';
                                                break;
                                        }
                                        case 'product':
                                        {
                                                $reurl = '';
                                                $reurl = ($ilconfig['globalauctionsettings_seourls']) ? HTTP_SERVER . print_seo_url($ilconfig['productcatmapidentifier']) : $ilpage['merch'] . '?cmd=listings';
                                                break;
                                        }
                                }
                                
                                header("Location: " . $reurl . "");
                                exit();                
                        }
                        
                        
                        // init verbose search engine text, favorite searches text, etc
                        $text = $showtext = $favtext = $keyword_text = '';
                        
                        if (!empty($ilance->GPC['q']))
                        {
                                $keyword_text = $ilance->GPC['q'];
                                $keyword_text = $ilance->common->xss_clean($keyword_text);
                        }
                        
                        // popular keyword search handler
                        if (!empty($keyword_text))
                        {
                                // build's a usable database of recent search keywords
                                handle_search_keywords($keyword_text, $ilance->GPC['mode']);
                        }
                        
                        // #### BEGIN SEARCH SQL QUERY #########################
                        $sqlquery['groupby'] = "GROUP BY p.project_id";
                        $sqlquery['orderby'] = "ORDER BY p.date_end ASC";
                        $sqlquery['limit'] = 'LIMIT ' . (($ilance->GPC['page'] - 1) * fetch_perpage()) . ',' . fetch_perpage();
                        
                        $acceptedsort = array('01','02','11','12','21','22','31','41','42','51','52','61','62','71','72','81','82','91','92','101','102','111','112');
                        if ($ilconfig['globalserver_enabledistanceradius'])
                        {
                                $acceptedsort['121'] = '';
                                $acceptedsort['122'] = '';
                        }
                        
                        if (!empty($ilance->GPC['sort']) AND in_array($ilance->GPC['sort'], $acceptedsort))
                        {
                                $sortconditions = sortable_array_handler('listings');
                                $sqlquery['orderby'] = 'ORDER BY ' . $sortconditions[$ilance->GPC['sort']]['field'] . ' ' . $sortconditions[$ilance->GPC['sort']]['sort'] . ' ' . $sortconditions[$ilance->GPC['sort']]['extra'];
                                $sqlquery['limit'] = 'LIMIT ' . (($ilance->GPC['page'] - 1) * fetch_perpage()) . ',' . fetch_perpage();
                        }
                        
                        // build our core sql search pattern fields and store them in an array for later usage
                        $sqlquery['fields'] = "p.featured, p.reserve, p.bold, p.highlite, p.buynow_qty, p.buynow, p.buynow_price, p.currentprice, p.project_id, p.cid, p.description, p.date_starts, p.date_added, p.date_end, p.user_id, p.visible, p.views, p.project_title, p.additional_info, p.bids, p.status, p.close_date, p.project_details, p.project_type, p.bid_details, p.startprice, p.retailprice, p.ship_handling, p.ship_costs, p.filtered_auctiontype, p.filtered_budgetid, UNIX_TIMESTAMP(p.date_end)-UNIX_TIMESTAMP('".DATETIME24H."') AS mytime, UNIX_TIMESTAMP(p.date_starts) - UNIX_TIMESTAMP('".DATETIME24H."') AS starttime, u.country, u.city, u.zip_code, u.rating, u.score";
                        $sqlquery['from'] = "FROM " . DB_PREFIX . "projects AS p";
                        $sqlquery['leftjoin'] = "LEFT JOIN " . DB_PREFIX . "users u ON p.user_id = u.user_id " . ((isset($ilance->GPC['images']) AND $ilance->GPC['images']) ? "LEFT JOIN " . DB_PREFIX . "attachment a ON p.project_id = a.project_id" : "");
                        
                        // hook below is useful for changing any specifics from the above                        
                        ($apihook = $ilance->api('search_query_fields')) ? eval($apihook) : false;

                        // #### SEARCH RESULT DISPLAY ORDER ####################
                        if (isset($ilance->GPC['sort']) AND !empty($ilance->GPC['sort']) AND in_array($ilance->GPC['sort'], $acceptedsort))
                        {
                                $sphrase = fetch_sort_options($project_state);
                                $tphrase = $sphrase[$ilance->GPC['sort']];
                                
                                handle_search_verbose(mb_strtolower($phrase['_display_order']) . ': <strong>' . $phrase[$tphrase] . '</strong>, ');
                                handle_search_verbose_save($phrase['_display_order'] . ': <strong>' . $phrase[$tphrase] . '</strong>, ');
                                
                                unset($sphrase, $tphrase);
                        }
                        else
                        {
                                $sphrase = fetch_sort_options($project_state);
                                $tphrase = $sphrase['01'];
                                
                                handle_search_verbose(mb_strtolower($phrase['_display_order']) . ': <strong>' . $phrase[$tphrase] . '</strong>, ');
                                handle_search_verbose_save($phrase['_display_order'] . ': <strong>' . $phrase[$tphrase] . '</strong>, ');
                                
                                unset($sphrase, $tphrase);
                        }
                        
                        // search options: is user hiding their own results?
                        $sqlquery['hidequery'] = '';
                        if ($selected['hidelisted'] == 'true')
                        {
                                if (!empty($_SESSION['ilancedata']['user']['userid']))
                                {
                                        $sqlquery['hidequery'] = "AND (u.user_id != '" . intval($_SESSION['ilancedata']['user']['userid']) . "')";
                                        
                                        handle_search_verbose($phrase['_excluding_results_that_are_listed_by_me'] . ', ');
                                        handle_search_verbose_save($phrase['_filter'] . ': <strong>' . $phrase['_excluding_results_that_are_listed_by_me_uppercase'] . '</strong>, ');
                                }
                        }
                        
                        // filter search method (titles only or everything)
                        $titlesonly = isset($ilance->GPC['titlesonly']) ? intval($ilance->GPC['titlesonly']) : '-1';
                        if ($titlesonly == '-1')
                        {
                                handle_search_verbose($phrase['_searching_keywords_in_titles_and_descriptions'] . ', ');
                                handle_search_verbose_save($phrase['_filter'] . ': <strong>' . $phrase['_search_entire_auctions'] . '</strong>, ');
                        }
                        else
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'titlesonly=' . $ilance->GPC['titlesonly']);
                                
                                handle_search_verbose($phrase['_searching_keywords_in_titles_only'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_filter'] . ': <strong>' . $phrase['_search_auction_titles_only'] . '</strong>, ');
                        }
                        
                        // search exact username?
                        $sqlquery['userquery'] = '';
                        if (isset($ilance->GPC['searchuser']) AND !empty($ilance->GPC['searchuser']))
                        {
                                $searchuser = $ilance->GPC['searchuser'];
                                $searchuser = $ilance->common->xss_clean($searchuser);
                                $removeurl = rewrite_url($scriptpage, $remove = 'searchuser=' . urlencode($searchuser));
                                $favexactphrase = '';
                                
                                if (isset($ilance->GPC['exactname']) AND $ilance->GPC['exactname'])
                                {
                                        $removeurl = rewrite_url($removeurl, $remove = 'exactname=' . $ilance->GPC['exactname']);
                                        $exactphrase = '<strong>' . $phrase['_exactly_match'] . '</strong>';
                                        $favexactphrase = '( <strong>' . $phrase['_exact_matches'] . '</strong> )';
                                        
                                        $sqlquery['userquery'] = "AND (u.username = '" . $ilance->db->escape_string($searchuser) . "')";
                                }
                                else
                                {
                                        $exactphrase = $phrase['_match'];
                                        $sqlquery['userquery'] = "AND (u.username LIKE '%" . $ilance->db->escape_string($searchuser) . "%')";
                                }
                                
                                handle_search_verbose($phrase['_searching_all_members_that'] . ' ' . $exactphrase . ' <span class="blue"><strong>' . $searchuser . '</strong></span> <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_username'] . ': <strong>' . $searchuser . '</strong> ' . $favexactphrase . ', ');
                        }
                        
                        // search via auction type
                        $sqlquery['projectdetails'] = '';
                        if (isset($ilance->GPC['auctiontype']) AND $ilance->GPC['auctiontype'] == '-1')
                        {
                                handle_search_verbose($phrase['_showing_all_auction_types'].', ');
                                handle_search_verbose_save($phrase['_auction_type'] . ': <strong>' . $phrase['_all'] . '</strong>, ');
                        }
                        else if (isset($ilance->GPC['auctiontype']) AND $ilance->GPC['auctiontype'] == 0)
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'auctiontype=' . $ilance->GPC['auctiontype']);
                                $sqlquery['projectdetails'] = "AND (p.project_details = 'public')";
                                
                                handle_search_verbose($ilance->language->construct_phrase($phrase['_showing_x_auctions'], $phrase['_public']) . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_auction_type'] . ': <strong>' . $phrase['_public'] . '</strong>, ');
                        }
                        else if (isset($ilance->GPC['auctiontype']) AND $ilance->GPC['auctiontype'] == 2)
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'auctiontype=' . $ilance->GPC['auctiontype']);
                                $sqlquery['projectdetails'] = "AND (p.project_details = 'invite_only')";
                                
                                handle_search_verbose($ilance->language->construct_phrase($phrase['_showing_x_auctions'], $phrase['_invite_only']) . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_auction_type'] . ': <strong>' . $phrase['_invite_only'] . '</strong>, ');
                        }
                        else if (isset($ilance->GPC['auctiontype']) AND $ilance->GPC['auctiontype'] == 3)
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'auctiontype=' . $ilance->GPC['auctiontype']);
                                $sqlquery['projectdetails'] = "AND (p.project_details = 'realtime')";
                                
                                handle_search_verbose($ilance->language->construct_phrase($phrase['_showing_x_auctions'], $phrase['_realtime']) . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_auction_type'] . ': <strong>' . $phrase['_realtime'] . '</strong>, ');
                        }
                        else if (isset($ilance->GPC['auctiontype']) AND $ilance->GPC['auctiontype'] == 4)
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'auctiontype=' . $ilance->GPC['auctiontype']);
                                $sqlquery['projectdetails'] = "AND (p.project_details = 'unique')";
                                
                                handle_search_verbose($ilance->language->construct_phrase($phrase['_showing_x_auctions'], $phrase['_lowest_unique_bid']) . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_auction_type'] . ': <strong>' . $phrase['_lowest_unique_bid'] . '</strong>, ');
                        }
                        else
                        {
                                handle_search_verbose($phrase['_showing_all_auction_types'] . ', ');
                                handle_search_verbose_save($phrase['_auction_type'] . ': <strong>' . $phrase['_all'] . '</strong>, ');
                        }
                        
                        // handle keyword(s) input
                        $sqlquery['keywords'] = $keyword_formatted = '';
                        $keywords_array = array();
                        
                        if (isset($keyword_text) AND !empty($keyword_text))
                        {
                                // #### FULLTEXT MODE ##########################
                                if ($ilconfig['fulltextsearch'])
                                {
                                        $keyword_formatted .= '<strong>' . $keyword_text . '</strong>, ';
                                        $keyword_formatted = mb_substr($keyword_formatted, 0, -2) . '';
                                        $keyword_formatted_favtext = $keyword_formatted;
                                        
                                        if ($titlesonly == '-1')
                                        {
                                                $sqlquery['keywords'] .= "AND MATCH (p.project_title,p.description,p.additional_info,p.keywords) AGAINST ('" . $ilance->db->escape_string($keyword_text) . "' IN BOOLEAN MODE)";
                                        }
                                        else
                                        {
                                                $sqlquery['keywords'] .= "AND MATCH (p.project_title,p.keywords) AGAINST ('" . $ilance->db->escape_string($keyword_text) . "' IN BOOLEAN MODE)";
                                        }        
                                }
                                
                                // #### NON-FULLTEXT MODE ######################
                                else
                                {
                                        // splits spaces and commas into array
                                        $keyword_text = preg_split("/[\s,]+/", trim($keyword_text));
                                        
                                        // #### MULTIPLE KEYWORDS ##############
                                        if (sizeof($keyword_text) > 1)
                                        {
                                                $sqlquery['keywords'] .= 'AND (';
                                                for ($i = 0; $i < sizeof($keyword_text); $i++)
                                                {
                                                        $keyword_formatted .= '<strong>' . $keyword_text[$i] . '</strong>, ';
                                                        $sqlquery['keywords'] .= "p.project_title LIKE '%" . $ilance->db->escape_string($keyword_text[$i]) . "%' OR p.keywords LIKE '%" . $ilance->db->escape_string($keyword_text[$i]) . "%' OR ";
                                                        $keywords_array[] = $keyword_text[$i];
                                                        
                                                        if ($titlesonly == '-1')
                                                        {
                                                                // search everything
                                                                $sqlquery['keywords'] .= "p.project_title LIKE '%" . $ilance->db->escape_string($keyword_text[$i]) . "%' OR p.description LIKE '%" . $ilance->db->escape_string($keyword_text[$i]) . "%' OR p.additional_info LIKE '%" . $ilance->db->escape_string($keyword_text[$i]) . "%' OR p.keywords LIKE '%" . $ilance->db->escape_string($keyword_text[$i]) . "%' OR ";
                                                        }
                                                }				
                                                $sqlquery['keywords'] = mb_substr($sqlquery['keywords'], 0, -4) . ')';
                                                $keyword_formatted = mb_substr($keyword_formatted, 0, -2) . '';
                                                $keyword_formatted_favtext = $keyword_formatted;
                                        }
                                        
                                        // #### SINGLE KEYWORD #################
                                        else
                                        {
                                                $keyword_formatted = '<strong>' . $keyword_text[0] . '</strong>';
                                                $keyword_formatted_favtext = '<strong>' . $keyword_text[0] . '</strong>';
                                                $keywords_array[] = $keyword_text[0];
                                                if ($titlesonly == '-1')
                                                {
                                                        $sqlquery['keywords'] .= "AND (p.project_title LIKE '%" . $ilance->db->escape_string($keyword_text[0]) . "%' OR p.description LIKE '%" . $ilance->db->escape_string($keyword_text[0]) . "%' OR p.additional_info LIKE '%" . $ilance->db->escape_string($keyword_text[0]) . "%' OR p.keywords LIKE '%" . $ilance->db->escape_string($keyword_text[0]) . "%')";
                                                }
                                                else
                                                {
                                                        $sqlquery['keywords'] .= "AND (p.project_title LIKE '%" . $ilance->db->escape_string($keyword_text[0]) . "%' OR p.keywords LIKE '%" . $ilance->db->escape_string($keyword_text[0]) . "%')";
                                                }
                                        }        
                                }
                        }
                        
                        // categories
                        $sqlquery['categories'] = '';
                        
                        // #### SEARCHING VIA ADVANCED SEARCH MENU #####################
                        if (empty($ilance->GPC['cid']) OR (!empty($ilance->GPC['cid']) AND $ilance->GPC['cid'] == 0))
                        {
                                // we are here because the searcher chose no categories to search within
                                $cid = 0;
                                
                                $subcategorylist = $ilance->categories->fetch_children_ids('all', $ilance->GPC['mode']);
                                $count = count(explode(',', $subcategorylist));
                                if (!empty($subcategorylist) AND $count > 1)
                                {
                                        $sqlquery['categories'] .= "AND (FIND_IN_SET(p.cid, '$subcategorylist'))";
                                }
                                
                                handle_search_verbose(mb_strtolower($phrase['_best_matching_categories']) . ', ');
                                handle_search_verbose_save($phrase['_category'] . ': <strong>' . $phrase['_best_matching'] . '</strong>, ');
                        }
                        else
                        {
                                $subcategorylist = $subcatname = '';
                                $cid = isset($ilance->GPC['cid']) ? intval($ilance->GPC['cid']) : '0';
                                
                                // category visibility checkup
                                if ($ilance->categories->visible($_SESSION['ilancedata']['user']['slng'], $ilance->GPC['mode'], $cid) == 0)
                                {
                                        $area_title = $phrase['_category_not_available'];
                                        $page_title = SITE_NAME . ' - ' . $phrase['_category_not_available'];
                                        
                                        print_notice($phrase['_invalid_category'], $phrase['_this_category_is_currently_unavailable_please_choose_a_different_category'], $ilpage['search'], $phrase['_search']);
                                        exit();
                                }
                                
                                if (isset($ilance->GPC['cid']))
                                {
                                        if ($ilance->GPC['cid'] == 0)
                                        {
                                                $cid = 0;
                                                
                                                // we are here because the searcher chose the category name "All Categories"
                                                handle_search_verbose($phrase['_available_in_all_categories'] . ', ');
                                                handle_search_verbose_save($phrase['_categories'] . ': <strong>' . $phrase['_all_categories'] . '</strong>, ');
                                        }
                                        else
                                        {
                                                if ($ilconfig['globalauctionsettings_seourls'])
                                                {
                                                        $cmode = $ilance->GPC['mode'] . 'cat';
                                                        $subcatname .= ', <span class="blue">' . construct_seo_url($cmode, intval($ilance->GPC['cid']), $auctionid = 0, $ilance->categories->title($_SESSION['ilancedata']['user']['slng'], $ilance->GPC['mode'], intval($ilance->GPC['cid'])), $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) . '</span>';
                                                }
                                                else 
                                                {
                                                        if ($ilance->GPC['mode'] == 'service')
                                                        {
                                                                $subcatname .= ', <span class="blue"><a href="' . $ilpage['rfp'] . '?cid=' . intval($ilance->GPC['cid']) . '" rel="nofollow">' . $ilance->categories->title($_SESSION['ilancedata']['user']['slng'], 'service', intval($ilance->GPC['cid'])) . '</a></span>';
                                                        }
                                                        else
                                                        {
                                                                $subcatname .= ', <span class="blue"><a href="' . $ilpage['merch'] . '?cid=' . intval($ilance->GPC['cid']) . '" rel="nofollow">' . $ilance->categories->title($_SESSION['ilancedata']['user']['slng'], 'product', intval($ilance->GPC['cid'])) . '</a></span>';
                                                        }
                                                }
                                                
                                                $childrenids = $ilance->categories->fetch_children_ids($ilance->GPC['cid'], $ilance->GPC['mode']);
                                                
                                                if (!empty($childrenids))
                                                {
                                                        $subcategorylist .= $ilance->GPC['cid'] . ',' . $childrenids;
                                                }
                                                else
                                                {
                                                        $subcategorylist .= $ilance->GPC['cid'] . ',';
                                                }
                                        }
                                        
                                        if (!empty($subcatname))
                                        {
                                                handle_search_verbose($phrase['_located_in'] . ' ' . mb_substr($subcatname, 1) . ', ');
                                                handle_search_verbose_save($phrase['_categories'] . ': ' . mb_substr($subcatname, 1) . ', ');
                                        }
                                        
                                        $sqlquery['categories'] .= "AND (FIND_IN_SET(p.cid, '$subcategorylist'))";
                                        
                                        // update category view count
                                        add_category_viewcount(intval($ilance->GPC['cid']));
                                }	    
                        }
                        
                        $show['allowlisting'] = $ilance->categories->can_post($_SESSION['ilancedata']['user']['slng'], $ilance->GPC['mode'], $cid);
                        
                        $sqlquery['options'] = '';
                        
                        // filter escrow secured auctions
                        if (isset($ilance->GPC['filter_escrow']) AND $ilance->GPC['filter_escrow'])
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'filter_escrow=' . $ilance->GPC['filter_escrow']);
                                $sqlquery['options'] .= "AND (filter_escrow = '1') ";
                                
                                handle_search_verbose($phrase['_showing_services_that_require_secure_escrow'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_filter'] . ': <strong>' . $phrase['_showing_services_that_require_secure_escrow'] . '</strong>, ');
                        }
                        // filter auctions with public message boards
                        if (isset($ilance->GPC['filter_publicboard']) AND $ilance->GPC['filter_publicboard'])
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'filter_publicboard=' . $ilance->GPC['filter_publicboard']);
                                $sqlquery['options'] .= "AND (filter_publicboard = '1') ";
                                
                                handle_search_verbose($phrase['_showing_listings_that_allow_public_message_board'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_filter'] . ': <strong>' . $phrase['_showing_listings_that_allow_public_message_board'] . '</strong>, ');
                        }
                        // filter auctions with buynow available
                        if (isset($ilance->GPC['buynow']) AND $ilance->GPC['buynow'] == '1')
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'buynow=' . $ilance->GPC['buynow']);
                                $sqlquery['options'] .= "AND (buynow = '1') ";
                                
                                handle_search_verbose($phrase['_including_purchase_now_availability'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_filter'] . ': <strong>' . $phrase['_including_purchase_now_availability'] . '</strong>, ');
                        }
                        // filter auctions with purchase now availability
                        if (isset($ilance->GPC['filter_underage']) AND $ilance->GPC['filter_underage'])
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'filter_underage=' . $ilance->GPC['filter_underage']);
                                $sqlquery['options'] .= "AND (filter_underage = '1') ";
                                
                                handle_search_verbose($phrase['_showing_services_that_allow_underage_bidders_to_participate'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_filter'] . ': <strong>' . $phrase['_showing_services_that_allow_underage_bidders_to_participate'] . '</strong>, ');
                        }
                        // filter auctions with free shipping
                        if (isset($ilance->GPC['freeshipping']) AND $ilance->GPC['freeshipping'])
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'freeshipping=' . $ilance->GPC['freeshipping']);
                                $sqlquery['options'] .= "AND (ship_costs = '0.00' OR ship_costs = '' OR ship_costs = '0') ";
                                
                                handle_search_verbose($phrase['_listing_items_with_free_shipping'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_filter'] . ': <strong>' . $phrase['_listing_items_with_free_shipping'] . '</strong>, ');
                        }
                        // filter auctions listed in lots format
                        if (isset($ilance->GPC['listedaslots']) AND $ilance->GPC['listedaslots'])
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'listedaslots=' . $ilance->GPC['listedaslots']);
                                $sqlquery['options'] .= "AND (filtered_auctiontype = 'fixed' AND buynow_price > 0 AND buynow_qty > 0) ";
                                
                                handle_search_verbose($phrase['_showing_items_listed_as_lots'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_filter'] . ': <strong>' . $phrase['_showing_items_listed_as_lots'] . '</strong>, ');
                        }
                        // filter auctions only with images?
                        if (isset($ilance->GPC['images']) AND $ilance->GPC['images'])
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'images=' . $ilance->GPC['images']);
                                $sqlquery['options'] .= "AND (a.attachtype = 'itemphoto' AND a.user_id = p.user_id) ";
                                
                                handle_search_verbose($phrase['_showing_only_items_with_images'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_filter'] . ': <strong>' . $phrase['_showing_only_items_with_images'] . '</strong>, ');
                        }            
                        // start / end date range filter
                        if (isset($ilance->GPC['endstart']))
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'endstart=' . $ilance->GPC['endstart']);
                                switch ($ilance->GPC['endstart'])
                                {
                                        case '1':
                                        {
                                                // ending within
                                                if (isset($ilance->GPC['endstart_filter']) AND $ilance->GPC['endstart_filter'] != '-1')
                                                {
                                                        $sqlquery['options'] .= " " . fetch_startend_sql($ilance->GPC['endstart_filter'], 'DATE_ADD', 'p.date_end', '<=');
                                                }
                                                
                                                handle_search_verbose($phrase['_ending_within_lower'] . ' <strong>' . fetch_startend_phrase($ilance->GPC['endstart_filter']) . '</strong>' . (($ilance->GPC['endstart_filter'] != '-1') ? ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ' : ', '));
                                                handle_search_verbose_save($phrase['_listings'] . ': ' . $phrase['_ending_within_lower'] . ' <strong>' . fetch_startend_phrase($ilance->GPC['endstart_filter']) . '</strong>, ');
                                                break;
                                        }                                    
                                        case '2':
                                        {
                                                // ending in more than
                                                if (isset($ilance->GPC['endstart_filter']) AND $ilance->GPC['endstart_filter'] != '-1')
                                                {
                                                        $sqlquery['options'] .= " " . fetch_startend_sql($ilance->GPC['endstart_filter'], 'DATE_ADD', 'p.date_end', '>=');
                                                }
                                                
                                                handle_search_verbose($phrase['_ending_in_more_than_lower'] . ' <strong>' . fetch_startend_phrase($ilance->GPC['endstart_filter']) . '</strong> <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                                handle_search_verbose_save($phrase['_listings'].': '.$phrase['_ending_in_more_than_lower'].' <strong>'.fetch_startend_phrase($ilance->GPC['endstart_filter']).'</strong>, ');
                                                break;
                                        }                                    
                                        case '3':
                                        {
                                                // started within
                                                if (isset($ilance->GPC['endstart_filter']) AND $ilance->GPC['endstart_filter'] != '-1')
                                                {
                                                        $sqlquery['options'] .= " " . fetch_startend_sql($ilance->GPC['endstart_filter'], 'DATE_SUB', 'p.date_added', '>=');
                                                }
                                                
                                                handle_search_verbose($phrase['_started_within_lower'] . ' <strong>'.fetch_startend_phrase($ilance->GPC['endstart_filter']) . '</strong> <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                                handle_search_verbose_save($phrase['_listings'] . ': ' . $phrase['_started_within_lower'] . ' <strong>'.fetch_startend_phrase($ilance->GPC['endstart_filter']) . '</strong>, ');
                                                break;
                                        }
                                }    
                        }
                        
                        // filter listings with non-disclosed budgets
                        if (isset($ilance->GPC['budget']) AND $ilance->GPC['budget'] == '-1' AND isset($ilance->GPC['cid']) AND $ilance->GPC['cid'] > 0)
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'budget=' . intval($ilance->GPC['budget']));
                                $sqlquery['options'] .= "AND (p.filter_budget = '0') ";
                                
                                handle_search_verbose($phrase['_showing_services_with_nondisclosed_budgets'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_filter'] . ' <strong>' . $phrase['_showing_services_with_nondisclosed_budgets'] . '</strong>, ');
                        }
                        else if (isset($ilance->GPC['budget']) AND $ilance->GPC['budget'] > 0 AND isset($ilance->GPC['cid']) AND $ilance->GPC['cid'] > 0)
                        {
                                $overview = $ilance->auction->construct_budget_overview(intval($ilance->GPC['cid']), intval($ilance->GPC['budget']));
                                $removeurl = rewrite_url($scriptpage, $remove = 'budget=' . intval($ilance->GPC['budget']));
                                $sqlquery['options'] .= "AND (p.filter_budget = '1' AND p.filtered_budgetid = '" . intval($ilance->GPC['budget']) . "') ";
                                
                                handle_search_verbose($phrase['_within_budget_range'] . ': <strong>' . $overview . '</strong> <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_filter'] . ' <strong>' . $phrase['_budget'] . ': ' . $overview . '</strong>, ');
                                unset($overview);
                        }
                        else
                        {
                                $ilance->GPC['budget'] = '';
                        }
                        
                        // search number of bids range
                        if (!empty($ilance->GPC['bidrange']) AND $ilance->GPC['bidrange'] != '-1')
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'bidrange=' . $ilance->GPC['bidrange']);
                                switch ($ilance->GPC['bidrange'])
                                {
                                        case '1':
                                        {
                                                $sqlquery['options'] .= "AND (p.bids < 10) ";
                                                
                                                handle_search_verbose($phrase['_with_less_than_ten_bids_placed'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                                handle_search_verbose_save($phrase['_filter'] . ': <strong>' . $phrase['_with_less_than_ten_bids_placed'] . '</strong>, ');
                                                break;
                                        }                                        
                                        case '2':
                                        {
                                                $sqlquery['options'] .= "AND (p.bids BETWEEN 10 AND 20) ";
                                                
                                                handle_search_verbose($phrase['_between_ten_and_twenty_bids_placed'] . ', ');
                                                handle_search_verbose_save($phrase['_filter'] . ': <strong>'.$phrase['_between_ten_and_twenty_bids_placed'] . '</strong> <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                                break;
                                        }                                        
                                        case '3':
                                        {
                                                $sqlquery['options'] .= "AND (p.bids > 20) ";
                                                
                                                handle_search_verbose($phrase['_with_more_than_twenty_bids_placed'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                                handle_search_verbose_save($phrase['_filter'] . ': <strong>'.$phrase['_with_more_than_twenty_bids_placed'] . '</strong>, ');
                                                break;
                                        }
                               }
                        }
                        else
                        {
                                handle_search_verbose($phrase['_with_any_number_of_bids_placed'] . ', ');
                                handle_search_verbose_save($phrase['_bids'] . ': <strong>' . $phrase['_any'] . '</strong>, ');
                        } 
                        
                        // search via price range
                        $sqlquery['pricerange'] = '';
                        if ($show['mode_product'])
                        {
                                if (!empty($ilance->GPC['fromprice']) AND $ilance->GPC['fromprice'] > 0)
                                {
                                        $sqlquery['pricerange'] .= "AND (p.currentprice >= " . intval($ilance->GPC['fromprice']) . " ";
                                        
                                        handle_search_verbose($phrase['_min_price'] . ': <strong>' . $ilance->common->xss_clean($ilance->currency->format($ilance->GPC['fromprice'])) . '</strong>, ');
                                        handle_search_verbose_save($phrase['_min_price'] . ': <strong>' . $ilance->common->xss_clean($ilance->currency->format($ilance->GPC['fromprice'])) . '</strong>, ');
                                }
                                else
                                {
                                        $sqlquery['pricerange'] .= "AND (p.currentprice >= 0 ";
                                        
                                        handle_search_verbose($phrase['_min_price'] . ': <strong>' . $ilance->currency->format(0) . '</strong>, ');
                                        handle_search_verbose_save($phrase['_min_price'] . ': <strong>' . $ilance->currency->format(0) . '</strong>, ');
                                }
                                
                                if (!empty($ilance->GPC['toprice']) AND $ilance->GPC['toprice'] > 0)
                                {
                                        $removeurl = rewrite_url($scriptpage, $remove = 'toprice=' . urldecode($ilance->GPC['toprice']));
                                        if (isset($ilance->GPC['fromprice']) AND $ilance->GPC['fromprice'] > 0)
                                        {
                                                $removeurl = rewrite_url($removeurl, $remove = 'fromprice=' . urldecode($ilance->GPC['fromprice']));
                                        }
                                        
                                        $sqlquery['pricerange'] .= "AND p.currentprice <= " . intval($ilance->GPC['toprice']) . ") ";
                                        
                                        handle_search_verbose($phrase['_max_price'] . ': <strong>' . $ilance->common->xss_clean($ilance->currency->format($ilance->GPC['toprice'])) . '</strong> <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                        handle_search_verbose_save($phrase['_max_price'] . ': <strong>' . $ilance->common->xss_clean($ilance->currency->format($ilance->GPC['toprice'])) . '</strong>, ');
                                }
                                else
                                {
                                        $sqlquery['pricerange'] .= ")";
                                        
                                        handle_search_verbose($phrase['_max_price'] . ': <strong>' . $phrase['_unlimited'] . '</strong>, ');
                                        handle_search_verbose_save($phrase['_max_price'] . ': <strong>' . $phrase['_unlimited'] . '</strong>, ');
                                }
                        }
                        
                        // #### SEARCH VIA RADIUS ##############################
                        $show['radiussearch'] = false;
                        $sqlquery['location'] = $sqlquery['radius'] = '';
                        if ($ilconfig['globalserver_enabledistanceradius'] AND !empty($ilance->GPC['radiuscountry']) AND $ilance->GPC['radiuscountry'] > 0 AND !empty($ilance->GPC['radiuszip']) AND isset($ilance->GPC['radius']) AND $ilance->GPC['radius'] > 0)
                        {
                                $show['radiussearch'] = true;
                                
                                // user supplied a radius.  did they also select a countryid and zip code?
                                $ilance->GPC['radiuscountry'] = intval($ilance->GPC['radiuscountry']);
                                $ilance->GPC['radiuszip'] = mb_strtoupper(trim($ilance->GPC['radiuszip']));
                                
                                // We can not use this is europe so it needs to be removed
                				// So user needs to be aware what is he adding
                                //$ilance->GPC['radiuszip'] = str_replace(' ', '', $ilance->GPC['radiuszip']);
                                //$ilance->GPC['radiuszip'] = str_replace('-', '', $ilance->GPC['radiuszip']);
                                $ilance->GPC['radius'] = intval($ilance->GPC['radius']);
                                $ilance->GPC['radiusstate'] = '';
                                
                                $removeurl = rewrite_url($scriptpage, $remove = 'radiuscountry=' . $ilance->GPC['radiuscountry']);
                                $removeurl = rewrite_url($removeurl, $remove = 'radiuszip=' . $ilance->GPC['radiuszip']);
                                $removeurl = rewrite_url($removeurl, $remove = 'radius=' . $ilance->GPC['radius']);
                                
                                $radiusresult = $ilance->distance->fetch_zips_in_range($ilance->GPC['radiuszip'], $ilance->GPC['radius'], $ilance->GPC['radiuscountry'], $includedistance = false, $leftjoinonly = true, $radiusjoin = false);
                                if (!empty($radiusresult) AND is_array($radiusresult))
                                {
                                        //print_r($radiusresult); exit;
                                        // the proper zipcode + country id was selected..       
                                        $sqlquery['leftjoin'] .= $radiusresult['leftjoin'];
                                        $sqlquery['fields'] .= $radiusresult['fields'];
                                        $sqlquery['radius'] = $radiusresult['condition'];
                                        
                                        $zipcodesrange = $ilance->distance->fetch_zips_in_range($ilance->GPC['radiuszip'], $ilance->GPC['radius'], $ilance->GPC['radiuscountry'], $includedistance = false, $leftjoinonly = false, $radiusjoin = true);
                                        if (isset($zipcodesrange) AND is_array($zipcodesrange))
                                        {
                                                $sqlquery['radius'] .= $zipcodesrange['condition'];
                                        }
                                        
                                        handle_search_verbose($phrase['_located_within_a'] . ' <strong>' . number_format($ilance->GPC['radius']) . '</strong> ' . $phrase['_mile_radius_from'] . ' ' . (!empty($ilance->GPC['city']) ? '<strong>' . ucwords($ilance->GPC['city']) . '</strong>, ' : '') . '<strong>' . $ilance->GPC['radiuszip'] . '</strong> <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                        handle_search_verbose_save($phrase['_radius'] . ': <strong>' . number_format($ilance->GPC['radius']) . '</strong> ' . $phrase['_mile_radius_from'] . ' ' . (!empty($ilance->GPC['city']) ? '<strong>' . ucwords($ilance->GPC['city']) . '</strong>, ' : '') . '<strong>' . $ilance->GPC['radiuszip'] . '</strong>, ');
                                }
                        }
                        else
                        {
                                
                                // because we're not using the radius zip code logic we still need to obtain
                                // the query to fetch desired tables so the user can still sort via distance furthest or closest
                                //if (!empty($_SESSION['ilancedata']['user']['postalzip']))
                                if (!empty($ilance->GPC['zip_code']))
                                {
                                        $ilance->GPC['zip_code'] = mb_strtoupper(trim($ilance->GPC['zip_code']));
                                        //$ilance->GPC['zip_code'] = str_replace(' ', '', $ilance->GPC['zip_code']);
                                        //$ilance->GPC['zip_code'] = str_replace('-', '', $ilance->GPC['zip_code']);
                                        
                                        $distanceresult = $ilance->distance->fetch_sql_as_distance($ilance->GPC['zip_code'], $ilance->GPC['country']);
                                        if (is_array($distanceresult))
                                        {
                                                $sqlquery['leftjoin'] .= $distanceresult['leftjoin'];
                                                $sqlquery['fields'] .= $distanceresult['fields'];
                                        }
                                }
                                
                                // normal search (no radius): does user search in cities?
                                if (!empty($ilance->GPC['city']))
                                {
                                        // does user enter a city in search?
                                        $removeurl = rewrite_url($scriptpage, $remove = 'city=' . $ilance->GPC['city']);
                                        
                                        $ilance->GPC['city'] = ucfirst(trim($ilance->GPC['city']));
                                        $sqlquery['location'] .= "AND (u.city LIKE '%" . $ilance->db->escape_string($ilance->GPC['city']) . "%') ";
                                        
                                        handle_search_verbose($phrase['_located_in'] . ' ' . $phrase['_city'] . ': <strong>' . ucwords($ilance->GPC['city']) . '</strong> <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                        handle_search_verbose_save($phrase['_city'] . ': <strong>' . ucwords($ilance->GPC['city']) . '</strong>, ');
                                }
                                    
                                // does user search in state or provinces?
                                if (!empty($ilance->GPC['state']))
                                {
                                        // does user enter a city in search?
                                        $removeurl = rewrite_url($scriptpage, $remove = 'state=' . $ilance->GPC['state']);
                                        
                                        $ilance->GPC['state'] = ucfirst(trim($ilance->GPC['state']));
                                        $sqlquery['location'] .= "AND (u.state LIKE '%" . $ilance->db->escape_string($ilance->GPC['state']) . "%') ";
                                        
                                        handle_search_verbose($phrase['_located_in'] . ' ' . $phrase['_state_or_province'] . ': <strong>' . ucwords($ilance->GPC['state']) . '</strong> <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                        handle_search_verbose_save($phrase['_state'] . ': <strong>' . ucwords($ilance->GPC['state']) . '</strong>, ');
                                }
                                    
                                // does user search in zip codes?
                                if (!empty($ilance->GPC['zip_code']))
                                {
                                        //$ilance->GPC['zip_code'] = str_replace(' ', '', $ilance->GPC['zip_code']);
                                        //$ilance->GPC['zip_code'] = str_replace('-', '', $ilance->GPC['zip_code']);
                                        $ilance->GPC['zip_code'] = mb_strtoupper(trim($ilance->GPC['zip_code']));
                                        
                                        $removeurl = rewrite_url($scriptpage, $remove = 'zip_code=' . $ilance->GPC['zip_code']);
                                        $sqlquery['location'] .= "AND (u.zip_code LIKE '%" . $ilance->db->escape_string($ilance->GPC['zip_code']) . "%') ";
                                        
                                        handle_search_verbose($phrase['_located_in'] . ' ' . $phrase['_zip_slash_postal_code'] . ': <strong>' . ucwords($ilance->GPC['zip_code']) . '</strong> <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                        handle_search_verbose_save($phrase['_zip_slash_postal_code'] . ': <strong>' . ucwords($ilance->GPC['zip_code']) . '</strong>, ');
                                }
                        }
                        //if (is_array($selected["{$project_state}selected"]) AND !empty($_SESSION['ilancedata']['user']['postalzip']) AND in_array('distance', $selected["{$project_state}selected"]))
                        if (is_array($selected['expertselected']) AND (!empty($_SESSION['ilancedata']['user']['postalzip']) OR !empty($ilance->GPC['zip_code']) OR !empty($ilance->GPC['radiuszip'])) AND in_array('distance', $selected["expertselected"]))
                        {
                                $show['distancecolumn'] = 1;
                                
                                //handle_search_verbose($phrase['_showing_distance_calculation_from'] . ' <strong>' . $_SESSION['ilancedata']['user']['postalzip'] . '</strong>, <strong>' . $_SESSION['ilancedata']['user']['country'] . '</strong>, ');
                                //handle_search_verbose_save($phrase['_showing_distance_calculation_from'] . ' <strong>' . $_SESSION['ilancedata']['user']['postalzip'] . '</strong>, <strong>' . $_SESSION['ilancedata']['user']['country'] . '</strong>, ');
                        }
                        
                        // #### SEARCHABLE CATEGORY QUESTIONS ##################
                        $sqlquery['genrequery'] = '';
                        if (!empty($ilance->GPC['qid']) AND is_array($ilance->GPC['qid']))
                        {
                                foreach ($ilance->GPC['qid'] AS $keyquestionid => $keyanswerid)
                                {
                                        if (isset($keyanswerid) AND !empty($keyanswerid))
                                        {
                                                $questiontitle = fetch_searchable_question_title(intval($keyquestionid), $project_state);
                                                $answertitle = fetch_searchable_answer_title(intval($keyquestionid), $keyanswerid, $project_state);
                                                $showqidurl = ($ilconfig['globalauctionsettings_seourls']) ? construct_seo_url("{$project_state}catplain", intval($ilance->GPC['cid']), $auctionid = 0, $ilance->categories->title($_SESSION['ilancedata']['user']['slng'], $ilance->GPC['mode'], intval($ilance->GPC['cid'])), $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) : $ilpage['search'] . print_hidden_fields($string = true, $excluded = array('page'), $questionmarkfirst = true, $prepend_text = '', $append_text = '', $htmlentities = true, $urldecode = true);
                                                $showqidurl = rewrite_url($showqidurl, $remove = 'qid[' . $keyquestionid . ']=' . $keyanswerid);
                                                
                                                $sqlquery['genrequery'] .= "AND (" . fetch_searchable_sql_condition(intval($keyquestionid), $keyanswerid, $project_state, 'p.project_id') . ") ";

                                                handle_search_verbose_filters($questiontitle . ': <strong>' . $answertitle . '</strong> <a href="' . $showqidurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');                                                
                                                handle_search_verbose_save(', <strong>' . $phrase['_filter'] . '</strong>: ' . $questiontitle . ': <strong>' . $answertitle . '</strong>, ');
                                        }
                                }
                                unset($questiontitle, $answertitle);
                        }
                        
                        // ensure auctions shown in result have not yet expired..
                        $sqlquery['timestamp'] = "AND (UNIX_TIMESTAMP(date_end) > UNIX_TIMESTAMP('" . DATETIME24H . "'))";
                        
                        // ensure auctions are still open.. (double check)..
                        $sqlquery['projectstatus'] = "AND (p.status = 'open')";
                        
                        // complete final search query parameters
                        $sqlquery['select'] = "SELECT $sqlquery[fields] $sqlquery[from] $sqlquery[leftjoin] WHERE p.user_id = u.user_id " . (($ilconfig['globalauctionsettings_payperpost']) ? "AND p.visible = '1' AND (p.insertionfee = 0 OR (p.insertionfee > 0 AND p.ifinvoiceid > 0 AND p.isifpaid = '1'))" : "AND p.visible = '1'") . "";
                        
                        $SQL  = "$sqlquery[select] $sqlquery[timestamp] $sqlquery[projectstatus] $sqlquery[keywords] $sqlquery[categories] $sqlquery[projectdetails] $sqlquery[projectstate] $sqlquery[options] $sqlquery[pricerange] $sqlquery[location] $sqlquery[radius] $sqlquery[userquery] $sqlquery[hidequery] $sqlquery[genrequery] $sqlquery[groupby] $sqlquery[orderby] $sqlquery[limit]";
                        $SQL2 = "$sqlquery[select] $sqlquery[timestamp] $sqlquery[projectstatus] $sqlquery[keywords] $sqlquery[categories] $sqlquery[projectdetails] $sqlquery[projectstate] $sqlquery[options] $sqlquery[pricerange] $sqlquery[location] $sqlquery[radius] $sqlquery[userquery] $sqlquery[hidequery] $sqlquery[genrequery] $sqlquery[groupby] $sqlquery[orderby]";
                        
                        $numberrows = $ilance->db->query($SQL2);
                        $number = $ilance->db->num_rows($numberrows);
                        $counter = (intval($ilance->GPC['page']) - 1) * fetch_perpage();
                        $row_count = 0;

                        if (!empty($keyword_text))
                        {
                                $favtext = '<div>' . $phrase['_keywords'] . ': <strong>' . stripslashes($keyword_formatted_favtext) . '</strong></div>' . print_search_verbose_saved('verbose_save');
                                $favtext = mb_substr($favtext, 0, -2) . '';
                                
                                if (!empty($selected['hideverbose']) AND $selected['hideverbose'] == 'true')
                                {
                                        $text = '<span class="header">' . $number . '</span> ' . $phrase['_listings_found_with_keywords'] . ': ' . stripslashes($keyword_formatted) . '';
                                }
                                else
                                {
                                        $text = '<span class="header">' . $number . '</span> ' . $phrase['_listings_found_with_keywords'] . ': ' . stripslashes($keyword_formatted) . ', ' . print_search_verbose_saved('verbose');
                                        $text = mb_substr($text, 0, -2) . '';
                                }
                        }
                        else
                        {
                                // favorite search text results
                                $favtext = '<div>' . $phrase['_keywords'] . ': <strong>' . $phrase['_none'] . '</strong></div>' . print_search_verbose_saved('verbose_save');
                                $favtext = mb_substr($favtext, 0, -2) . '';
                                
                                if (!empty($selected['hideverbose']) AND $selected['hideverbose'] == 'true')
                                {
                                        $text = '<span class="header">' . $number . '</span> ' . $phrase['_listings_found_with_no_keywords'] . '';
                                }
                                else
                                {
                                        $text = '<span class="header">' . $number . '</span> ' . $phrase['_listings_found_with_no_keywords'] . ', ' . print_search_verbose_saved('verbose');
                                        $text = mb_substr($text, 0, -2) . '';        
                                }
                        }
                        
                        if ($ilconfig['globalauctionsettings_seourls'])
                        {
                                $categoryname = $ilance->categories->title($_SESSION['ilancedata']['user']['slng'], $project_state, intval($cid));
                                $showallurl = construct_seo_url("{$project_state}catplain", $cid, $auctionid = 0, $categoryname, $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0, $removevar = 'qid');
                        }
                        else
                        {
                                $showallurl = $ilpage['search'] . print_hidden_fields($string = true, $excluded = array('page','qid','sid'), $questionmarkfirst = true, $prepend_text = '', $append_text = '', $htmlentities = true, $urldecode = true);                                
                        }
                        
                        define('PHP_SELF_NOQID', $showallurl);
                        
                        $showtext = print_search_verbose_saved('verbose_filter');
                        if (!empty($showtext))
                        {
                                $showtext = mb_substr($showtext, 0, -2) . ' &nbsp;&nbsp;<span class="smaller gray">[ <span class="blue"><a href="' . $showallurl . '" rel="nofollow">' . $phrase['_show_all'] . '</a></span> ]</span>';
                                $text .= '<div style="padding-top:12px"><strong>' . $phrase['_other'] . '</strong></div><div>' . $showtext . '</div>';
                        }
                        
                        $metatitle = $phrase['_browse'] . ' ' . (!empty($keyword_text) ? $phrase['_for'] . ' ' . $keyword_text : '');
                        if ($cid > 0)
                        {
                                $metatitle = $ilance->categories->title($_SESSION['ilancedata']['user']['slng'], $project_state, $cid);
                                $metadescription = $ilance->categories->description($_SESSION['ilancedata']['user']['slng'], $project_state, $cid);
                                $metakeywords = $ilance->categories->keywords($_SESSION['ilancedata']['user']['slng'], $project_state, $cid, $commaafter = true, $showinputkeywords = true);
                        }
                        
                        $area_title = $phrase['_search_results_display'] . ': ' . $metatitle . ' (' . $number . ' ' . $phrase['_results_found'] . ')';
                        $page_title = $metatitle . '' . (!empty($metadescription) ? ', ' . $metadescription : '') . ' ' . $phrase['_on'] . ' ' . SITE_NAME;
                        
                        $search_results_rows = $excludelist = array();
                        $result = $ilance->db->query($SQL);
                        if ($ilance->db->num_rows($result) > 0)
                        {
                                $ilance->bbcode = construct_object('api.bbcode');
                                
                                while ($row = $ilance->db->fetch_array($result, DB_ASSOC))
                                {
                                        $excludelist[] = $row['project_id'];
                                        
                                        $td['featured'] = $row['featured'];
                                        $td['bold'] = $row['bold'];
                                        $td['highlite'] = $row['highlite'];
                                        $td['project_id'] = $row['project_id'];
                                        $td['distance'] = (isset($show['distancecolumn']) AND $show['distancecolumn']) ? '<div class="gray">' . $ilance->distance->print_distance_results($row['user_id'], $row['country'], $row['zip_code'], $_SESSION['ilancedata']['user']['countryid'], $_SESSION['ilancedata']['user']['postalzip'], $_SESSION['ilancedata']['user']['userid']) . '</div>' : '-';
                                        
                                        // #### SERVICE AUCTION LOGIC ##############################
                                        if ($show['mode_service'])
                                        {
                                                $row['project_state'] = 'service';
                                                $td['project_state'] = $row['project_state'];
                                                
                                                if ($row['bold'])
                                                {
                                                        $td['title'] = ($ilconfig['globalauctionsettings_seourls']) ? construct_seo_url('serviceauction', 0, $row['project_id'], $row['project_title'], $customlink = '', $bold = 1, $searchquestion = '', $questionid = 0, $answerid = 0) : '<a href="' . $ilpage['rfp'] . '?id=' . $row['project_id'] . '"><strong>' . stripslashes($row['project_title']).'</strong></a>';
                                                }
                                                else
                                                {
                                                        $td['title'] = ($ilconfig['globalauctionsettings_seourls']) ? construct_seo_url('serviceauction', 0, $row['project_id'], $row['project_title'], $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) : '<a href="' . $ilpage['rfp'] . '?id=' . $row['project_id'] . '">' . stripslashes($row['project_title']).'</a>';
                                                }
                                                                
                                                // auction description (may contain bbcode)
                                                switch ($row['project_details'])
                                                {
                                                        case 'public':
                                                        {
                                                                // guest
                                                                // vulgar censor
                                                                $td['description'] = strip_vulgar_words($row['description']);
                                                                $td['description'] = $ilance->bbcode->bbcode_to_html($td['description']);
                                                                $td['description'] = short_string(print_string_wrap($td['description'], 50), 50);
                                                                $td['additional_info'] = short_string($row['additional_info'], 75);
                                                                break;
                                                        }                                                        
                                                        case 'invite_only':
                                                        {
                                                                // guests
                                                                $description = "= " . $phrase['_full_description_available_to_invited_providers_only'] . " =";
                                                                if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
                                                                {
                                                                        $sqlinvites = $ilance->db->query("
                                                                                SELECT *
                                                                                FROM " . DB_PREFIX . "project_invitations
                                                                                WHERE project_id = '" . $row['project_id'] . "'
                                                                                    AND seller_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                        ");
                                                                        if ($ilance->db->num_rows($sqlinvites) > 0)
                                                                        {
                                                                                // member invited
                                                                                
                                                                                // vulgar censor
                                                                                $td['description'] = strip_vulgar_words($row['description']);
                                                                                $td['description'] = $ilance->bbcode->bbcode_to_html($td['description']);
                                                                                $td['description'] = short_string(print_string_wrap($td['description'], 50), 50);
                                                                                $td['additional_info'] = short_string($row['additional_info'], 75);
                                                                        }
                                                                        unset($sqlinvites);
                                                                }
                                                                break;
                                                        }                                                        
                                                        case 'realtime':
                                                        {
                                                                // guests
                                                                
                                                                // vulgar censor
                                                                $td['description'] = strip_vulgar_words($row['description']);
                                                                $td['description'] = $ilance->bbcode->bbcode_to_html($td['description']);
                                                                $td['description'] = short_string(print_string_wrap($td['description'], 50), 50);
                                                                $td['additional_info'] = short_string($row['additional_info'], 75);
                                                                break;
                                                        }
                                                }

                                                $td['description'] = strip_tags($td['description']);
                                                $td['additional_info'] = strip_tags($td['additional_info']);
                                                
                                                if ($ilconfig['globalauctionsettings_seourls'])
                                                {
                                                        $td['category'] = construct_seo_url('servicecat', $row['cid'], $auctionid = 0, $ilance->categories->title($_SESSION['ilancedata']['user']['slng'], 'service', $row['cid']), $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0);
                                                        $td['category'] = '<span class="blue">' . $td['category'] . '</span>';
                                                }
                                                else
                                                {
                                                        $td['category'] = '<a href="' . $ilpage['rfp'] . '?cid=' . $row['cid'] . '">' . $ilance->categories->title($_SESSION['ilancedata']['user']['slng'], 'service', $row['cid']) . '</a>';
                                                        $td['category'] = '<span class="blue">' . $td['category'] . '</span>';
                                                }
                                                
                                                $td['username'] = fetch_user('username', $row['user_id']);
                                                $td['city'] = ucfirst(fetch_user('city', $row['user_id']));
                                                $td['zipcode'] = mb_strtoupper(fetch_user('zip_code', $row['user_id']));
                                                $td['state'] = ucfirst(fetch_user('state', $row['user_id']));
                                                $td['country'] = print_user_country($row['user_id'], $_SESSION['ilancedata']['user']['slng']);
                                                                
                                                // hide average bid amount on results page if auction is "sealed"
                                                if ($row['bid_details'] == 'open' OR $row['bid_details'] == 'blind')
                                                {
                                                        $avg = $ilance->bid->fetch_average_bid($row['project_id'], true, $row['bid_details'], true);
                                                        if ($avg > 0)
                                                        {
                                                                $td['averagebid'] = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $avg);
                                                                $td['averagebid_plain'] = $ilance->currency->format($avg);
                                                        }
                                                        else
                                                        {
                                                                $td['averagebid'] = '-';
                                                                $td['averagebid_plain'] = '-';
                                                        }
                                                        unset($avg);
                                                }
                                                else
                                                {
                                                        $td['averagebid'] = $td['averagebid_plain'] = '= ' . $phrase['_sealed'] . ' =';
                                                }
                                
                                                $td['sel'] = (!empty($_SESSION['ilancedata']['user']['userid'])) ? '<input type="checkbox" name="project_id[]" value="' . $row['project_id'] . '" id="' . $row['project_state'] . '_' . $row['project_id'] . '" />' : '<input type="checkbox" name="project_id[]" value="' . $row['project_id'] . '" id="' . $row['project_state'] . '_' . $row['project_id'] . '" disabled="disabled" />';
                                                $td['class'] = ($row['highlite']) ? $ilconfig['serviceupsell_highlightcolor'] : (($row_count % 2) ? 'alt1' : 'alt1');
                                                $td['timeleft'] = $ilance->auction->auction_timeleft($row['project_id'], $td['class'], 'center');
                                                $td['icons'] = $ilance->auction->auction_icons($row['project_id'], $row['user_id']);
                                                $td['bids'] = ($row['bids'] > 0) ? $row['bids'] : '-';                                                
                                                $td['views'] = $row['views'];
                                                $td['budget'] = '<div class="gray">' . $ilance->auction->construct_budget_overview($row['cid'], $row['filtered_budgetid'], $notext = true, $nobrackets = true, $forcenocategory = true) . '</div>';
                                                
                                                ($apihook = $ilance->api('search_results_services_loop')) ? eval($apihook) : false;
                                                
                                                $search_results_rows[] = $td;
                                                $row_count++;
                                        }
                                        
                                        // #### PRODUCT AUCTION LOGIC ##########
                                        else if ($show['mode_product'])
                                        {
                                                $row['project_state'] = 'product';
                                                $td['project_state'] = $row['project_state'];
                                                $td['username'] = (!empty($_SESSION['ilancedata']['user']['userid'])) ? fetch_user('username', $row['user_id']) : '';
                                                $td['city'] = ucfirst(fetch_user('city', $row['user_id']));
                                                $td['zipcode'] = mb_strtoupper(fetch_user('zip_code', $row['user_id']));
                                                $td['state'] = ucfirst(fetch_user('state', $row['user_id']));
                                                $td['country'] = print_user_country($row['user_id'], $_SESSION['ilancedata']['user']['slng']);
                                                
                                                // auction description (may contain bbcode)
                                                switch ($row['project_details'])
                                                {
                                                        case 'public':
                                                        {
                                                                $td['description'] = strip_vulgar_words($row['description']);
                                                                $td['description'] = $ilance->bbcode->bbcode_to_html($td['description']);
                                                                $td['description'] = short_string(print_string_wrap($td['description'], 50), 50);
                                                                break;
                                                        }                                                        
                                                        case 'invite_only':
                                                        {
                                                                $description = '= ' . $phrase['_full_description_available_to_invited_providers_only'] . ' =';
                                                                if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
                                                                {
                                                                        $sql_invites = $ilance->db->query("
                                                                                SELECT *
                                                                                FROM " . DB_PREFIX . "project_invitations
                                                                                WHERE project_id = '" . $row['project_id'] . "'
                                                                                    AND seller_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                        ");
                                                                        if ($ilance->db->num_rows($sql_invites) > 0)
                                                                        {
                                                                                // member invited
                                                                                
                                                                                // vulgar censor
                                                                                $td['description'] = strip_vulgar_words($row['description']);
                                                                                $td['description'] = $ilance->bbcode->bbcode_to_html($td['description']);
                                                                                $td['description'] = short_string(print_string_wrap($td['description'], 50), 50);
                                                                        }
                                                                }
                                                                break;
                                                        }                                                        
                                                        case 'realtime':
                                                        {
                                                                // guests
                                                                // vulgar censor
                                                                $td['description'] = strip_vulgar_words($row['description']);
                                                                $td['description'] = $ilance->bbcode->bbcode_to_html($td['description']);
                                                                $td['description'] = short_string(print_string_wrap($td['description'], 50), 50);
                                                                break;
                                                        }
                                                }
                                                
                                                if (!empty($td['description']))
                                                {
                                                        $td['description'] = strip_tags($td['description']);
                                                }
                                                
                                                $td['category'] = ($ilconfig['globalauctionsettings_seourls']) ? construct_seo_url('productcat', $row['cid'], $auctionid = 0, $ilance->categories->title($_SESSION['ilancedata']['user']['slng'], 'product', $row['cid']), $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) : '<a href="' . $ilpage['merch'] . '?cid=' . $row['cid'] . '">' . $ilance->categories->title($_SESSION['ilancedata']['user']['slng'], 'product', $row['cid']) . '</a>';
                                                $td['category'] = '<span class="blue">' . $td['category'] . '</span>';
                                                
                                                // display thumbnail
                                                if ($ilconfig['globalauctionsettings_seourls'])
                                                {
                                                        $url = construct_seo_url('productauctionplain', 0, $row['project_id'], stripslashes($row['project_title']), '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0);
                                                        $td['sample'] = print_item_photo($url, 'thumb', $row['project_id']);
                                                        unset($url);
                                                        //$td['sample'] .= '<div class="smaller"><a href="#">Enlarge</a></div>';
                                                }
                                                else
                                                {
                                                        $td['sample'] = print_item_photo($ilpage['merch'] . '?id=' . $row['project_id'], 'thumb', $row['project_id']);
                                                        //$td['sample'] .= '<div class="smaller"><a href="#">Enlarge</a></div>';
                                                }
                                                
                                                // is buynow available for this auction listing?
                                                $td['proxybit'] = '';
                                                $td['filtered_auctiontype'] = $row['filtered_auctiontype'];

                                                if ($selected['list'] == 'list')
                                                {
                                                        $td['buynow'] = $td['buynowimg'] = $td['buynowtxt'] = '';
                                                        
                                                        // #### unique bid auction
                                                        if ($row['project_details'] == 'unique')
                                                        {
                                                                $td['description'] = strip_vulgar_words($row['description']);
                                                                $td['description'] = $ilance->bbcode->bbcode_to_html($td['description']);
                                                                $td['description'] = short_string(print_string_wrap($td['description'], 50), 50);
                                                                $td['bids'] = $ilance->bid_lowest_unique->fetch_bid_count($row['project_id']);
                                                                $td['price'] = ($selected['currencyconvert'] == 'true') ? print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $row['retailprice']) : $ilance->currency->format($row['retailprice']);
                                                        }
                                                        
                                                        // #### regular auction
                                                        else
                                                        {
                                                                if ($row['buynow_price'] > 0 AND $row['filtered_auctiontype'] == 'fixed' OR $row['buynow_price'] > 0 AND $row['filtered_auctiontype'] == 'regular')
                                                                {
                                                                        $td['price'] = '';
                                                                        if ($row['filtered_auctiontype'] == 'regular')
                                                                        {
                                                                                // current price & buy now price
                                                                                if ($row['bids'] > 0)
                                                                                {
                                                                                        $td['price'] = ($selected['currencyconvert'] == 'true') ? '<div class="blue"><strong>' . print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $row['currentprice']) . '</strong></div>' : '<div class="blue"><strong>' . $ilance->currency->format($row['currentprice']) . '</strong></div>';
                                                                                        $td['price'] .= ($selected['currencyconvert'] == 'true') ? '<div class="green" style="padding-top:3px"><strong>' . print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $row['buynow_price']) . '</strong></div>' : '<div class="green" style="padding-top:3px"><strong>' . $ilance->currency->format($row['buynow_price']) . '</strong></div>';
                                                                                }
                                                                                else
                                                                                {
                                                                                        $td['price'] = ($selected['currencyconvert'] == 'true') ? '<div class="blue">' . print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $row['currentprice']) . '</div>' : '<div class="blue">' . $ilance->currency->format($row['currentprice']) . '</div>';
                                                                                        $td['price'] .= ($selected['currencyconvert'] == 'true') ? '<div class="green" style="padding-top:3px">' . print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $row['buynow_price']) . '</div>' : '<div class="green" style="padding-top:3px">' . $ilance->currency->format($row['buynow_price']) . '</div>';
                                                                                }
                                                                                
                                                                                $td['bids'] = ($row['bids'] > 0) ? '<div>' . $row['bids'] . '</div>' : '-';
                                                                                
                                                                                // proxy bid information
                                                                                if (!empty($_SESSION['ilancedata']['user']['userid']))
                                                                                {
                                                                                        $pbit = $ilance->bid_proxy->fetch_user_proxy_bid($row['project_id'], $_SESSION['ilancedata']['user']['userid']);
                                                                                        if ($pbit > 0)
                                                                                        {
                                                                                                $td['proxybit'] = (!empty($selected['proxybit']) AND $selected['proxybit'] == 'true') ? '<div class="smaller gray">' . $phrase['_your_maximum_bid'] . ': ' . $ilance->currency->format($pbit) . ' - <em>' . $phrase['_invisible'] . '</em></div>' : '';
                                                                                        }
                                                                                        unset($pbit);
                                                                                }
                                                                        }
                                                                        else if ($row['filtered_auctiontype'] == 'fixed')
                                                                        {
                                                                                // buy now price
                                                                                $td['price'] = ($selected['currencyconvert'] == 'true') ? '<div class="green">' . print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $row['buynow_price']) . '</div>' : '<div class="green">' . $ilance->currency->format($row['buynow_price']) . '</div>';
                                                                                $td['bids'] = '-';
                                                                        }
                                                                }
                                                                
                                                                // #### no buy now
                                                                else
                                                                {
                                                                        if ($ilance->bid->has_bids($row['project_id']) > 0)
                                                                        {
                                                                                $currentbid = $ilance->bid->fetch_current_bid($row['project_id'], 1);
                                                                                $td['price'] = ($selected['currencyconvert'] == 'true') ? '<span class="blue"><strong>' . print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $currentbid) . '</strong></span>' : '<span class="blue"><strong>' . $ilance->currency->format($currentbid) . '</strong></span>';
                                                                                
                                                                                if (!empty($_SESSION['ilancedata']['user']['userid']))
                                                                                {
                                                                                        $pbit = $ilance->bid_proxy->fetch_user_proxy_bid($row['project_id'], $_SESSION['ilancedata']['user']['userid']);
                                                                                        if ($pbit > 0)
                                                                                        {
                                                                                                $td['proxybit'] = (!empty($selected['proxybit']) AND $selected['proxybit'] == 'true') ? '<div class="smaller gray">' . $phrase['_your_maximum_bid'] . ': ' . $ilance->currency->format($pbit) . ' - <em>' . $phrase['_invisible'] . '</em></div>' : '';
                                                                                        }
                                                                                        unset($pbit);
                                                                                }
                                                                                
                                                                                $td['bids'] = ($row['bids'] > 0) ? $row['bids'] : '-';
                                                                        }
                                                                        else 
                                                                        {
                                                                                // starting bid price
                                                                                $td['price'] = ($selected['currencyconvert'] == 'true') ? '<div class="blue">' . print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $row['startprice']) . '</div>' : '<div class="blue">' . $ilance->currency->format($row['startprice']) . '</div>';
                                                                                $td['bids'] = ($row['bids'] > 0) ? $row['bids'] : '-';
                                                                        }
                                                                }
                                                        }
                                                }
                                                else if ($selected['list'] == 'gallery')
                                                {
                                                        $td['buynow'] = $td['buynowimg'] = $td['buynowtxt'] = '';
                                                        
                                                        // #### lowest unique bid
                                                        if ($row['project_details'] == 'unique')
                                                        {
                                                                $td['description'] = strip_vulgar_words($row['description']);
                                                                $td['description'] = $ilance->bbcode->bbcode_to_html($td['description']);
                                                                $td['description'] = short_string(print_string_wrap($td['description'], 50), 50);
                                                        	$td['bids'] = $ilance->bid_lowest_unique->fetch_bid_count($row['project_id']);
                                                                $td['price'] = $phrase['_retail'] . ': <span class="blue">' . $ilance->currency->format($row['retailprice']) . '</span>';
                                                        }
                                                        
                                                        // #### regular auction
                                                        else
                                                        {
                                                                if ($row['buynow_price'] > 0 AND $row['filtered_auctiontype'] == 'fixed' OR $row['buynow_price'] > 0 AND $row['filtered_auctiontype'] == 'regular')
                                                                {
                                                                        if ($row['filtered_auctiontype'] == 'regular')
                                                                        {
                                                                                $td['bids'] = ($row['bids'] > 0) ? $row['bids'] : '0';
                                                                                $td['buynow'] = '<span class="green">' . $ilance->currency->format($row['buynow_price']) . '</span>';
                                                                                $td['buynowimg'] = '';
                                                                                $td['buynowtxt'] = '';
                                                                        }
                                                                        else if ($row['filtered_auctiontype'] == 'fixed')
                                                                        {
                                                                                $td['bids'] = '0';
                                                                                $td['buynow'] = '<span class="green">' . $ilance->currency->format($row['buynow_price']) . '</span>';
                                                                                $td['buynowimg'] = '';
                                                                                $td['buynowtxt'] = '';
                                                                        }
                                                                }
                                                                
                                                                // #### no buy now
                                                                else
                                                                {
                                                                        $td['bids'] = ($row['bids'] > 0) ? $row['bids'] : '0';
                                                                }
                                                                
                                                                $td['price'] = '<span class="blue">' . $ilance->currency->format($row['currentprice']) . '</span>';
                                                        }
                                                }                                                
                                                               
                                                // display auction checkbox "action"
                                                $td['sel'] = (!empty($_SESSION['ilancedata']['user']['userid'])) ? '<input type="checkbox" name="project_id[]" value="' . $row['project_id'] . '" id="' . $row['project_state'] . '_' . $row['project_id'] . '" />' : '<input type="checkbox" name="project_id[]" value="' . $row['project_id'] . '" id="' . $row['project_state'] . '_' . $row['project_id'] . '" disabled="disabled" />';
                                                                
                                                // is bold feature enabled?
                                                if ($row['bold'])
                                                {
                                                        $td['title'] = ($ilconfig['globalauctionsettings_seourls']) ? construct_seo_url('productauction', 0, $row['project_id'], htmlspecialchars_uni($row['project_title']), $customlink = '', $bold = 1, $searchquestion = '', $questionid = 0, $answerid = 0) : '<a href="' . $ilpage['merch'] . '?id=' . $row['project_id'] . '"><strong>' . htmlspecialchars_uni($row['project_title']) . '</strong></a>';
                                                }
                                                else
                                                {
                                                        $td['title'] = ($ilconfig['globalauctionsettings_seourls']) ? construct_seo_url('productauction', 0, $row['project_id'], htmlspecialchars_uni($row['project_title']), $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) : '<a href="' . $ilpage['merch'] . '?id=' . $row['project_id'] . '">' . htmlspecialchars_uni($row['project_title']) . '</a>';
                                                }
                                                                
                                                $td['class'] = ($row['highlite']) ? $ilconfig['productupsell_highlightcolor'] : (($row_count % 2) ? 'alt1' : 'alt1');
                                                $td['timeleft'] = $ilance->auction->auction_timeleft($row['project_id'], $td['class'], 'center');
                                                $td['icons'] = $ilance->auction->auction_icons($row['project_id'], $row['user_id']);
                                                
                                                if ($row['ship_handling'] == 'flatrate')
                                                {
                                                        $td['shipping'] = '<div class="gray">' . $ilance->currency->format($row['ship_costs']) . '</div>';
                                                }
                                                else if ($row['ship_handling'] == 'sellerpays')
                                                {
                                                        $td['shipping'] = '<div class="gray">' . $phrase['_free'] . '</div>';
                                                }
                                                else if ($row['ship_handling'] == 'digital')
                                                {
                                                        $td['shipping'] = '<div class="gray">' . $phrase['_digital_download'] . '</div>';
                                                }
                                                else if ($row['ship_handling'] == 'none')
                                                {
                                                        $td['shipping'] = '<div class="gray">-</div>';
                                                }
                                                else
                                                {
                                                        $td['shipping'] = '<div class="gray">' . $phrase['_not_specified'] . '</div>';
                                                }
                                                
                                                $td['views'] = $row['views'];
                        
                                                ($apihook = $ilance->api('search_results_products_loop')) ? eval($apihook) : false;
                                                
                                                $search_results_rows[] = $td;
                                                $row_count++;
                                        }
                                }
                                
                                $show['no_rows_returned'] = false;
                        }
                        else
                        {
                                $show['no_rows_returned'] = true;
                        }
                        
                        // #### featured spotlight auction listings ############
                        $featuredserviceauctions = $featuredproductauctions = array();
                        if ($show['mode_service'])
                        {
                                $featuredserviceauctions = $ilance->auction->fetch_featured_auctions('service', 4, 1, $cid, $keyword_text, false, $excludelist);
                        }
                        if ($show['mode_product'])
                        {
                                $featuredproductauctions = $ilance->auction->fetch_featured_auctions('product', 4, 1, $cid, $keyword_text, false, $excludelist);
                        }
                        
                        // #### BUILD OUR PAGNATOR #############################
                        $prevnext = print_pagnation($number, fetch_perpage(), intval($ilance->GPC['page']), $counter, $scriptpage, $custompagename = '');
                        
                        // #### PRINT OUR SEARCH RESULTS TABLE #################
                        $search_results_table = print_search_results_table($search_results_rows, $project_state, $prevnext);
                        
                        $ilance->GPC['bidrange'] = !empty($ilance->GPC['bidrange']) ? $ilance->GPC['bidrange'] : '';
                        $search_bidrange_pulldown_product = print_bid_range_pulldown($ilance->GPC['bidrange'], 'bidrange', 'productbidrange');
                        $search_bidrange_pulldown_service = print_bid_range_pulldown($ilance->GPC['bidrange'], 'bidrange', 'servicebidrange');
                        
                        // live country listing pulldown
                        $country = isset($ilance->GPC['country']) ? intval($ilance->GPC['country']) : 'all';
                        $search_country_pulldown_product = print_active_countries_pulldown('country', $country, $_SESSION['ilancedata']['user']['slng'], $showworldwide = false, 'productcountry');
                        $search_country_pulldown_service = print_active_countries_pulldown('country', $country, $_SESSION['ilancedata']['user']['slng'], $showworldwide = false, 'servicecountry');
                        
                        $radiuscountry = (isset($ilance->GPC['radiuscountry']) AND $ilance->GPC['radiuscountry'] > 0) ? $ilance->GPC['radiuscountry'] : (!empty($_SESSION['ilancedata']['user']['countryid']) ? $_SESSION['ilancedata']['user']['countryid'] : 'all');
                        
                        $search_radius_country_pulldown_product = print_active_countries_pulldown('radiuscountry', $radiuscountry, $_SESSION['ilancedata']['user']['slng'], $showworldwide = false, 'productradiuscountry');
                        $search_radius_country_pulldown_service = print_active_countries_pulldown('radiuscountry', $radiuscountry, $_SESSION['ilancedata']['user']['slng'], $showworldwide = false, 'serviceradiuscountry');
                        
                        $keywords = (!empty($ilance->GPC['q'])) ? un_htmlspecialchars($ilance->GPC['q']) : '';
                        
                        // fewer keywords search
                        $fewer_keywords = print_fewer_keywords_search($keywords_array, $ilance->GPC['mode'], $number);
                        
                        // category budget
                        $budget = isset($ilance->GPC['budget']) ? intval($ilance->GPC['budget']) : '';
                        
                        // $budgetfilter = $ilance->auction_post->print_budget_logic_type_links($cid, $cattype = 'service', $budget);
                        $budgettemp = $ilance->auction_post->print_budget_logic_type_js($cid, $ilance->GPC['mode'], $budget);
                        if ($show['budgetgroups'] AND is_array($budgettemp))
                        {
                                $budget_slider_1 = $budgettemp[0];
                                $budget_slider_2 = $budgettemp[1];
                        }
                        unset($budgettemp);
                        
                        if (isset($show['mode_service']) AND $show['mode_service'] OR isset($show['mode_providers']) AND $show['mode_providers'])
                        {
                                $v3left_nav = $ilance->template->print_left_nav('service', $cid, $dosubcats = 1, $displayboth = 0, $showcount = $ilconfig['globalfilters_enablecategorycount'], $ilance->categories->catservicefetch, $ilance->categories->catproductfetch);
                                $v3left_nav .= $ilance->template->print_search_nav('service', $cid);
                        }
                        else 
                        {
                                // pre-populate from price and to price field inputs for left nav search menu
                                $fromprice = isset($ilance->GPC['fromprice']) ? sprintf("%01.2f", $ilance->GPC['fromprice']) : '';
                                $toprice = isset($ilance->GPC['toprice']) ? sprintf("%01.2f", $ilance->GPC['toprice']) : '';
                                
                                $v3left_nav = $ilance->template->print_left_nav('product', $cid, $dosubcats = 0, $displayboth = 0, $showcount = $ilconfig['globalfilters_enablecategorycount'], $ilance->categories->catservicefetch, $ilance->categories->catproductfetch);
                                $v3left_nav .= $ilance->template->print_search_nav('product', $cid);
                        }
                        
                        // #### SAVE AS FAVORITE SEARCH OPTION #################
                        if ($ilconfig['savedsearches'])
                        {
                                // build search request parameters
                                $favorites = array();
                                foreach ($ilance->GPC AS $search => $option)
                                {
                                        if ($search != 'submit' AND $search != 'search' AND $search != 'page')
                                        {
                                                $favorites[] = array($search => $option);
                                        }
                                }
                                if (!empty($favorites) AND is_array($favorites))
                                {
                                        $encrypt = serialize($favorites);
                                        $encrypt = urlencode($encrypt);
                                }
                                
                                $favoritesearchurl = $encrypt;
                                $favoritesearch = '<span class="smaller">[ <span class="blue"><a href="javascript:void(0)" rel="nofollow" onclick="javascript:jQuery(\'#saved_search_modal\').jqm({modal: false}).jqmShow();" onmouseover="Tip(\'' . $phrase['_saved_searches_can_be_used_when_you_are_viewing_search_results_from_the_marketplace'] . '\', BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()">' . $phrase['_save_as_favorite_search'] . '</a></span> ]</span>&nbsp;&nbsp;&nbsp;';
                                $favtext = ilance_htmlentities($favtext);
                                //echo $favtext;
                        }
                        else
                        {
                                $favoritesearch = $favtext = '';
                        }
                        
                        if ($show['mode_service'])
                        {
                                $sortmode = 'service';
                                $mode = 'service';
                                $navcrumb = array();
                                $ilance->categories->breadcrumb($cid, 'servicecatmap', $_SESSION['ilancedata']['user']['slng'], $categorycacheservice);
                                if (empty($cid) OR $cid == 0 OR $cid == '')
                                {
                                        $navcrumb["$ilpage[search]?tab=0"] = $phrase['_search'];
                                        $navcrumb[""] = $phrase['_services'];
                                }
                        }
                        else if ($show['mode_product'])
                        {
                                $sortmode = 'product';
                                $mode = 'product';
                                $navcrumb = array();
                                $ilance->categories->breadcrumb($cid, 'productcatmap', $_SESSION['ilancedata']['user']['slng'], $categorycacheproduct);
                                if (empty($cid) OR $cid == 0 OR $cid == '')
                                {
                                        $navcrumb["$ilpage[search]?tab=1"] = $phrase['_search'];
                                        $navcrumb[""] = $phrase['_products'];
                                }
                        }
                        
                        $ilance->GPC['sort'] = isset($ilance->GPC['sort']) ? $ilance->GPC['sort'] : '';
                        $sortpulldown = print_sort_pulldown($ilance->GPC['sort'], 'sort', $sortmode);
                        
                        $hiddenfields = print_hidden_fields(false, $excluded = array('cid','buynow','images','freeshipping','listedaslots','filter_budget','filter_publicboard','filter_escrow','filter_underage','endstart','endstart_filter','sort','q','page'), $questionmarkfirst = false, $prepend_text = '', $append_text = '', $htmlentities = true, $urldecode = true);
                        $hiddenfields_leftnav = print_hidden_fields(false, $excluded = array('exactname','searchuser','budget','country','auctiontype','buynow','images','freeshipping','listedaslots','fromprice','toprice','filter_budget','filter_publicboard','filter_escrow','filter_underage','endstart','endstart_filter','page','radius','radiuscountry','radiuszip','q'), $questionmarkfirst = false, $prepend_text = '', $append_text = '', $htmlentities = true, $urldecode = true);
                        
                        $city = isset($ilance->GPC['city']) ? strip_tags($ilance->GPC['city']) : '';
                        $state = isset($ilance->GPC['state']) ? strip_tags($ilance->GPC['state']) : '';
                        $zip_code = isset($ilance->GPC['zip_code']) ? strip_tags($ilance->GPC['zip_code']) : '';
                        
                        $radiuszip = isset($ilance->GPC['radiuszip']) ? strip_tags($ilance->GPC['radiuszip']) : '';                        
                        if (empty($radiuszip) AND !empty($_SESSION['ilancedata']['user']['postalzip']))
                        {
                                $radiuszip = $_SESSION['ilancedata']['user']['postalzip'];
                        }
                        
                        // #### init our budget range slider ###################
                        if (!empty($budgetfilter) OR $show['budgetgroups'])
                        {
                                $onload .= "init_budgetSlider();";
                                if (isset($ilance->GPC['budget']))
                                {
                                        $onload .= " set_budgetSlider('" . intval($ilance->GPC['budget']) . "');";
                                }
                        }
                        
                        ($apihook = $ilance->api('search_results_auctions_end')) ? eval($apihook) : false;                     
                       
                        // #### DISPLAY SEARCH RESULTS VIA XML #################
                        if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'xml')
                        {
                                if (!empty($search_results_rows) AND is_array($search_results_rows))
                                {
                                        $ilance->xml = construct_object('api.xml');
                                
                                        $xml = $ilance->xml->search_to_xml($search_results_rows, false);
                                        echo $xml;
                                }
                                exit();
                        }
                        
                        // #### DISPLAY SEARCH RESULTS VIA SERIALIZED ARRAY ####
                        else if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'array')
                        {
                                if (!empty($search_results_rows) AND is_array($search_results_rows))
                                {
                                        echo urlencode(serialize($search_results_rows));
                                }
                                exit();
                        }
                        
                        // #### DISPLAY SEARCH RESULTS TEMPLATE ################
                        else
                        {
                                $ilance->template->load_file('main', 'search_results.html', 0, 1);
                                $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                                $ilance->template->parse_loop('main', 'featuredproductauctions');
                                $ilance->template->parse_loop('main', 'featuredserviceauctions');
                                $ilance->template->parse_if_blocks('main');
                                
                                $pprint_array = array('searchuser','search_bidrange_pulldown_service','search_bidrange_pulldown_product','search_country_pulldown_product','search_country_pulldown_service','search_radius_country_pulldown_product','search_radius_country_pulldown_service','budget_slider_1','budget_slider_2','favtext','profilebidfilters','fewer_keywords','budgetfilter','hiddenfields_leftnav','city','state','zip_code','radiuszip','mode','hiddenfields','fromprice','toprice','search_results_table','sortpulldown','keywords','favoritesearch','favoritesearchurl','keywords','search_product_category_pulldown','php_self','php_self_urlencoded','pfp_category_left','pfp_category_js','rfp_category_left','rfp_category_js','input_style','search_country_pulldown','search_country_pulldown2','search_jobtype_pulldown','search_ratingrange_pulldown','search_awardrange_pulldown','search_bidrange_pulldown','search_listed_pulldown','search_closing_pulldown','search_category_pulldown','input_style','distance','subcategory_name','text','prevnext','prevnext2','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
                                
                                ($apihook = $ilance->api('search_results_auctions_template')) ? eval($apihook) : false;
         
                                $ilance->template->pprint('main', $pprint_array);
                                exit();
                        }
                        
                        break;
                }
            
                // #### SEARCHING SERVICE PROVIDERS ############################
                //case 'providers':
                case 'experts':
                {
                        $show['mode_service'] = false;
                        $show['mode_providers'] = true;
                        
                        $text = $favtext = $subcatname = $keyword_text = '';
                        
                        $mode = 'experts';
                        $mode_buynow = 0;
                        
                        // page we're on
                        if (!isset($ilance->GPC['page']) OR isset($ilance->GPC['page']) AND $ilance->GPC['page'] <= 0) 
                        { 
                                $ilance->GPC['page'] = 1; 
                        } 
                        else 
                        { 
                                $ilance->GPC['page'] = intval($ilance->GPC['page']); 
                        }
                        
                        $sqlquery['groupby'] = "GROUP BY user_id";
                        $sqlquery['orderby'] = "ORDER BY u.rating DESC";
                        $sqlquery['limit'] = 'LIMIT ' . (($ilance->GPC['page'] - 1) * fetch_perpage()) . ',' . fetch_perpage();
                        
                        $acceptedsort = array('01','02','11','12','21','22','31','41','42','51','52','61','62','71','72','81','82','91','92','101','102','111','112');
                        if ($ilconfig['globalserver_enabledistanceradius'])
                        {
                                $acceptedsort['121'] = '';
                                $acceptedsort['122'] = '';
                        }
                        
                        if (!empty($ilance->GPC['sort']) AND in_array($ilance->GPC['sort'], $acceptedsort))
                        {
                                $sortconditions = sortable_array_handler('experts');
                                $sqlquery['orderby'] = 'ORDER BY ' . $sortconditions[$ilance->GPC['sort']]['field'] . ' ' . $sortconditions[$ilance->GPC['sort']]['sort'] . ' ' . $sortconditions[$ilance->GPC['sort']]['extra'];
                                $sqlquery['limit'] = 'LIMIT ' . (($ilance->GPC['page'] - 1) * fetch_perpage()) . ',' . fetch_perpage();        
                        }
                        
                        // put our keyword text in a temporary variable
                        if (!empty($ilance->GPC['q']))
                        {
                                $keyword_text = $ilance->GPC['q'];
                                $keyword_text = $ilance->common->xss_clean($keyword_text);
                        }
                            
                        // handle keywords and add new words/phrases to our search index table
                        if (!empty($keyword_text))
                        {
                                handle_search_keywords($keyword_text, 'experts');
                        }
                            
                        // #### EXCLUDED EXPERTS SQL QUERY BUILDER #############
                        // subscription permissions checkup for 'searchresults'
                        // this will build a list of user id's not to include in the search
                        // this will also build a list of user id's that do not wish to be listed in search
                        // the 'u.' represents the table field identifier (example: u.user_id vs no identifier: user_id) - useful for TABLE JOINS
                        $sqlquery['userquery'] = build_expert_search_exclusion_sql('u.', 'searchresults');
                        
                        // #### BEGIN SEARCH SQL QUERY #########################
                        $sqlquery['timestamp'] = $sqlquery['projectstatus'] = $sqlquery['projectdetails'] = $sqlquery['projectstate'] = $sqlquery['pricerange'] = '';
                        $sqlquery['fields'] = "u.user_id, u.username, u.city, u.state, u.zip_code, u.country, u.status, u.serviceawards, u.rating, u.score, u.profileintro, p.cid";
                        $sqlquery['from'] = "
                                FROM " . DB_PREFIX . "users u";
                        $sqlquery['leftjoin'] = "
                                LEFT JOIN " . DB_PREFIX . "profile_categories p ON u.user_id = p.user_id
                                LEFT JOIN " . DB_PREFIX . "portfolio o ON p.user_id = o.user_id
                                LEFT JOIN " . DB_PREFIX . "attachment l ON u.user_id = l.user_id
                                LEFT JOIN " . DB_PREFIX . "locations c ON u.country = c.locationid
                        ";
                        
                        // hook below is useful for changing any specifics from the above                        
                        ($apihook = $ilance->api('search_experts_query_fields')) ? eval($apihook) : false;

                        $sqlquery['genrequery'] = $sqlquery['keywords'] = $keyword_formatted = '';
                        
                        // #### HANDLE KEYWORDS ENTERED ########################
                        $keywords_array = array();
                        if (isset($keyword_text) AND !empty($keyword_text))
                        {
                                // #### FULLTEXT MODE ##########################
                                if ($ilconfig['fulltextsearch'])
                                {
                                        $keyword_formatted .= '<strong>' . $keyword_text . '</strong>, ';
                                        $keyword_formatted = mb_substr($keyword_formatted, 0, -2) . '';
                                        $keyword_formatted_favtext = $keyword_formatted;
                                        
                                        if (isset($ilance->GPC['portfolios']) AND $ilance->GPC['portfolios'])
                                        {
                                                $sqlquery['keywords'] .= "AND MATCH (u.username, u.profileintro, o.description, o.caption, c.location_" . $_SESSION['ilancedata']['user']['slng'] . ") AGAINST ('" . $ilance->db->escape_string($keyword_text) . "' IN BOOLEAN MODE)";
                                        }
                                        else
                                        {
                                                $sqlquery['keywords'] .= "AND MATCH (u.username, u.profileintro, c.location_" . $_SESSION['ilancedata']['user']['slng'] . ") AGAINST ('" . $ilance->db->escape_string($keyword_text) . "' IN BOOLEAN MODE)";
                                        }        
                                }
                                
                                // #### NON-FULLTEXT MODE ######################
                                else
                                {
                                        // splits spaces and commas into array
                                        $keyword_text = preg_split("/[\s,]+/", trim($keyword_text));
                                        
                                        // #### MULTIPLE KEYWORDS ##############
                                        if (sizeof($keyword_text) > 1)
                                        {
                                                $sqlquery['keywords'] .= 'AND (';
                                                for ($i = 0; $i < sizeof($keyword_text); $i++)
                                                {
                                                        $keyword_formatted .= '<strong>' . $keyword_text[$i] . '</strong>, ';
                                                        if (isset($ilance->GPC['portfolios']) AND $ilance->GPC['portfolios'])
                                                        {
                                                                $sqlquery['keywords'] .= " u.username LIKE '%" . $ilance->db->escape_string($keyword_text[$i]) . "%' OR o.description LIKE '%" . $ilance->db->escape_string($keyword_text[$i]) . "%' OR o.caption LIKE '%" . $ilance->db->escape_string($keyword_text[$i]) . "%' OR ";
                                                        }
                                                        else
                                                        {
                                                                $sqlquery['keywords'] .= " u.username LIKE '%" . $ilance->db->escape_string($keyword_text[$i]) . "%' OR ";
                                                        }
                                                }				
                                                $sqlquery['keywords'] = mb_substr($sqlquery['keywords'], 0, -4) . ')';
                                                $keyword_formatted = mb_substr($keyword_formatted, 0, -2) . '';
                                                $keyword_formatted_favtext = $keyword_formatted;
                                        }
                                        
                                        // #### SINGLE KEYWORD #################
                                        else
                                        {
                                                $keyword_formatted = '<strong>' . $keyword_text[0] . '</strong>';
                                                $keyword_formatted_favtext = '<strong>' . $keyword_text[0] . '</strong>';
                                                if (isset($ilance->GPC['portfolios']) AND $ilance->GPC['portfolios'])
                                                {
                                                        $sqlquery['keywords'] .= "AND (u.username LIKE '%" . $ilance->db->escape_string($keyword_text[0]) . "%' OR o.description LIKE '%" . $ilance->db->escape_string($keyword_text[0]) . "%' OR o.caption LIKE '%" . $ilance->db->escape_string($keyword_text[0]) . "%') ";
                                                }
                                                else
                                                {	
                                                        $sqlquery['keywords'] .= "AND (u.username LIKE '%" . $ilance->db->escape_string($keyword_text[0]) . "%') ";
                                                }
                                        }
                                }
                        }
                           
                        // display order verbose
                        if (isset($ilance->GPC['sort']) AND !empty($ilance->GPC['sort']))
                        {
                                $sphrase = fetch_sort_options('experts');
                                $tphrase = $sphrase[$ilance->GPC['sort']];
                                
                                handle_search_verbose(mb_strtolower($phrase['_display_order']) . ': <strong>' . $phrase[$tphrase] . '</strong>, ');
                                handle_search_verbose_save($phrase['_display_order'] . ': <strong>' . $phrase[$tphrase] . '</strong>, ');
                                unset($sphrase, $tphrase);
                        }
                        
                        // search options: is user hiding their own results?
                        $sqlquery['hidequery'] = '';
                        if ($selected['hidelisted'] == 'true')
                        {
                                if (!empty($_SESSION['ilancedata']['user']['userid']))
                                {
                                        $sqlquery['hidequery'] = "AND (u.user_id != '" . intval($_SESSION['ilancedata']['user']['userid']) . "')";
                                }
                                
                                handle_search_verbose($phrase['_excluding_results_that_are_listed_by_me'] . ', ');
                                handle_search_verbose_save($phrase['_filter'] . ': <strong>' . $phrase['_excluding_results_that_are_listed_by_me_uppercase'] . '</strong>, ');
                        }
                         
                        // user searching keywords within portfolio titles and descriptions?
                        if (isset($ilance->GPC['portfolios']) AND $ilance->GPC['portfolios'])
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'portfolios=' . $ilance->GPC['portfolios']);
                                
                                handle_search_verbose($phrase['_including_service_experts_portfolios'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_filter'] . ': <strong>' . $phrase['_titles_and_descriptions_within_portfolios'] . '</strong>, ');
                        }
                        
                        // categories
                        $sqlquery['categories'] = '';
                        
                        // #### SEARCHING VIA ADVANCED SEARCH MENU #####################
                        if (empty($ilance->GPC['cid']) OR (!empty($ilance->GPC['cid']) AND $ilance->GPC['cid'] == 0))
                        {
                                // we are here because the searcher chose no categories to search within
                                $cid = 0;
                                $subcategorylist = $ilance->categories->fetch_children_ids('all', 'service');
                                
                                $count = count(explode(',', $subcategorylist));
                                if (!empty($subcategorylist) AND $count > 1)
                                {
                                        $sqlquery['categories'] .= "AND (FIND_IN_SET(p.cid, '$subcategorylist'))";
                                }
                                
                                handle_search_verbose(mb_strtolower($phrase['_best_matching_categories']) . ', ');
                                handle_search_verbose_save($phrase['_category'] . ': <strong>' . $phrase['_best_matching'] . '</strong>, ');
                        }
                        else
                        {
                                $subcategorylist = $subcatname = '';
                                $cid = isset($ilance->GPC['cid']) ? intval($ilance->GPC['cid']) : '0';
                                
                                // category visibility checkup
                                if ($ilance->categories->visible($_SESSION['ilancedata']['user']['slng'], $mode = 'service', $cid) == 0)
                                {
                                        $area_title = $phrase['_category_not_available'];
                                        $page_title = SITE_NAME . ' - ' . $phrase['_category_not_available'];
                                        
                                        print_notice($phrase['_invalid_category'], $phrase['_this_category_is_currently_unavailable_please_choose_a_different_category'], $ilpage['search'], $phrase['_search']);
                                        exit();
                                }
                                
                                if (isset($ilance->GPC['cid']) AND !empty($ilance->GPC['cid']))
                                {
                                        if ($ilance->GPC['cid'] == 0)
                                        {
                                                $cid = 0;
                                                handle_search_verbose($phrase['_available_in_all_categories'] . ', ');
                                                handle_search_verbose_save($phrase['_categories'] . ': <strong>' . $phrase['_all_categories'] . '</strong>, ');
                                        }
                                        else
                                        {
                                                if ($ilconfig['globalauctionsettings_seourls'])
                                                {
                                                        $subcatname .= ', <span class="blue">' . construct_seo_url('servicecat', intval($ilance->GPC['cid']), $auctionid = 0, $ilance->categories->title($_SESSION['ilancedata']['user']['slng'], 'service', intval($ilance->GPC['cid'])), $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) . '</span>';
                                                }
                                                else 
                                                {
                                                        $subcatname .= ', <span class="blue"><a href="' . $ilpage['rfp'] . '?cid=' . intval($ilance->GPC['cid']) . '" rel="nofollow">' . $ilance->categories->title($_SESSION['ilancedata']['user']['slng'], 'service', intval($ilance->GPC['cid'])) . '</a></span>';
                                                }
                                                
                                                $ilance->categories->fetch = $ilance->categories->catservicefetch;
                                                $childrenids = $ilance->categories->fetch_children_ids($ilance->GPC['cid'], 'service');
                                                $subcategorylist .= $cid . ',';
                                        }
                                        
                                        if (!empty($subcatname))
                                        {
                                                $removeurl = rewrite_url($scriptpage, $remove = 'cid=' . $ilance->GPC['cid']);
                                                
                                                handle_search_verbose($phrase['_located_in'] . ' ' . mb_substr($subcatname, 1) . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                                handle_search_verbose_save($phrase['_categories'] . ': ' . mb_substr($subcatname, 1) . ', ');
                                        }
                                        
                                        $sqlquery['categories'] .= "AND (FIND_IN_SET(p.cid, '$subcategorylist'))";
                                        
                                        // update category view count
                                        add_category_viewcount($cid);
                                }	    
                        }
                        
                        $navcrumb = array();
                        $ilance->categories->breadcrumb($cid, 'experts', $_SESSION['ilancedata']['user']['slng'], $categorycacheservice);
                        if (empty($cid) OR $cid == 0 OR $cid == '')
                        {
                                $navcrumb["$ilpage[search]?tab=0"] = $phrase['_search'];
                                $navcrumb[""] = $phrase['_providers'];
                        }
                                  
                        // filtering search via number of service auction awards
                        $sqlquery['options'] = '';
                        if (!empty($ilance->GPC['projectrange']) AND $ilance->GPC['projectrange'] != '-1')
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'projectrange=' . $ilance->GPC['projectrange']);
                                switch ($ilance->GPC['projectrange'])
                                {
                                        case '1':
                                        {
                                                $sqlquery['options'] .= "AND (u.serviceawards < 10) ";
                                                
                                                handle_search_verbose($phrase['_with_less_than_ten_awards'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                                handle_search_verbose_save($phrase['_awards'] . ': <strong>' . $phrase['_with_less_than_ten_awards'] . '</strong>, ');
                                                break;
                                        }
                                        case '2':
                                        {
                                                $sqlquery['options'] .= "AND (u.serviceawards BETWEEN 10 AND 20) ";
                                                
                                                handle_search_verbose($phrase['_between_ten_and_twenty_awards'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                                handle_search_verbose_save($phrase['_awards'] . ': <strong>' . $phrase['_between_ten_and_twenty_awards'] . '</strong>, ');
                                                break;        
                                        }                                    
                                        case '3':
                                        {
                                                $sqlquery['options'] .= "AND (u.serviceawards > 20) ";
                                                
                                                handle_search_verbose($phrase['_with_more_than_twenty_awards'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                                handle_search_verbose_save($phrase['_awards'] . ': <strong>' . $phrase['_with_more_than_twenty_awards'] . '</strong>, ');
                                                break;       
                                        }
                                }
                        }
                        else
                        {
                                handle_search_verbose($phrase['_with_any_number_of_awards'] . ', ');
                                handle_search_verbose_save($phrase['_awards'] . ': <strong>' . $phrase['_any'] . '</strong>, ');
                        }
                        
                        // search filter via rating?
                        if (!empty($ilance->GPC['rating']) AND $ilance->GPC['rating'] != '0')
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'rating=' . $ilance->GPC['rating']);
                                switch ($ilance->GPC['rating'])
                                {
                                        case '5':
                                        {
                                                $sqlquery['options'] .= "AND (u.rating >= '" . $ilconfig['min_5_stars_value'] . "') ";
                                                
                                                handle_search_verbose($phrase['_with_at_least_a_five_star_rating'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                                handle_search_verbose_save($phrase['_rating'] . ': <strong>' . $phrase['_with_at_least_a_five_star_rating'] . '</strong>, ');
                                                break;        
                                        }
                                        case '4':
                                        {
                                                $sqlquery['options'] .= "AND (u.rating >= '" . $ilconfig['min_4_stars_value'] . "') ";
                                                
                                                handle_search_verbose($phrase['_with_at_least_a_four_star_rating'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                                handle_search_verbose_save($phrase['_rating'] . ': <strong>' . $phrase['_with_at_least_a_four_star_rating'] . '</strong>, ');
                                                break;        
                                        }
                                        case '3':
                                        {
                                                $sqlquery['options'] .= "AND (u.rating >= '" . $ilconfig['min_3_stars_value'] . "') ";
                                                
                                                handle_search_verbose($phrase['_with_at_least_a_three_star_rating'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                                handle_search_verbose_save($phrase['_rating'] . ': <strong>' . $phrase['_with_at_least_a_three_star_rating'] . '</strong>, ');
                                                break;        
                                        }
                                        case '2':
                                        {
                                                $sqlquery['options'] .= "AND (u.rating >= '" . $ilconfig['min_2_stars_value'] . "') ";
                                                
                                                handle_search_verbose($phrase['_with_at_least_a_two_star_rating'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                                handle_search_verbose_save($phrase['_rating'] . ': <strong>' . $phrase['_with_at_least_a_two_star_rating'] . '</strong>, ');
                                                break;        
                                        }
                                        case '1':
                                        {
                                                $sqlquery['options'] .= "AND (u.rating >= '" . $ilconfig['min_1_stars_value'] . "') ";
                                                
                                                handle_search_verbose($phrase['_with_at_least_a_one_star_rating'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                                handle_search_verbose_save($phrase['_rating'] . ': <strong>' . $phrase['_with_at_least_a_one_star_rating'] . '</strong>, ');
                                                break;        
                                        }
                                }
                        }
                        else
                        {
                                handle_search_verbose($phrase['_with_any_ratings'] . ', ');
                                handle_search_verbose_save($phrase['_rating'] . ': <strong>' . $phrase['_with_any_ratings'] . '</strong>, ');
                        }
                        
                        // #### SEARCH VIA RADIUS ##############################
                        $show['radiussearch'] = false;
                        $sqlquery['location'] = $sqlquery['radius'] = '';
                        if ($ilconfig['globalserver_enabledistanceradius'] AND !empty($ilance->GPC['radiuscountry']) AND $ilance->GPC['radiuscountry'] > 0 AND !empty($ilance->GPC['radiuszip']) AND isset($ilance->GPC['radius']) AND $ilance->GPC['radius'] > 0)
                        {
                                $show['radiussearch'] = true;
                                
                                // user supplied a radius.  did they also select a countryid and zip code?
                                $ilance->GPC['radiuscountry'] = intval($ilance->GPC['radiuscountry']);
                                $ilance->GPC['radiuszip'] = mb_strtoupper(trim($ilance->GPC['radiuszip']));
                                //$ilance->GPC['radiuszip'] = str_replace(' ', '', $ilance->GPC['radiuszip']);
                                //$ilance->GPC['radiuszip'] = str_replace('-', '', $ilance->GPC['radiuszip']);
                                $ilance->GPC['radius'] = intval($ilance->GPC['radius']);
                                $ilance->GPC['radiusstate'] = '';
                                
                                $removeurl = rewrite_url($scriptpage, $remove = 'radiuscountry=' . $ilance->GPC['radiuscountry']);
                                $removeurl = rewrite_url($removeurl, $remove = 'radiuszip=' . $ilance->GPC['radiuszip']);
                                $removeurl = rewrite_url($removeurl, $remove = 'radius=' . $ilance->GPC['radius']);
                                
                                $radiusresult = $ilance->distance->fetch_zips_in_range($ilance->GPC['radiuszip'], $ilance->GPC['radius'], $ilance->GPC['radiuscountry'], $includedistance = false, $leftjoinonly = true, $radiusjoin = false);
                                if (!empty($radiusresult) AND is_array($radiusresult))
                                {
                                        //print_r($radiusresult); exit;
                                        // the proper zipcode + country id was selected..       
                                        $sqlquery['leftjoin'] .= $radiusresult['leftjoin'];
                                        $sqlquery['fields'] .= $radiusresult['fields'];
                                        $sqlquery['radius'] = $radiusresult['condition'];
                                        
                                        $zipcodesrange = $ilance->distance->fetch_zips_in_range($ilance->GPC['radiuszip'], $ilance->GPC['radius'], $ilance->GPC['radiuscountry'], $includedistance = false, $leftjoinonly = false, $radiusjoin = true);
                                        if (isset($zipcodesrange) AND is_array($zipcodesrange))
                                        {
                                                $sqlquery['radius'] .= $zipcodesrange['condition'];
                                        }
                                        
                                        handle_search_verbose($phrase['_located_within_a'] . ' <strong>' . number_format($ilance->GPC['radius']) . '</strong> ' . $phrase['_mile_radius_from'] . ' ' . (!empty($ilance->GPC['city']) ? '<strong>' . ucwords($ilance->GPC['city']) . '</strong>, ' : '') . '<strong>' . $ilance->GPC['radiuszip'] . '</strong> <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                        handle_search_verbose_save($phrase['_radius'] . ': <strong>' . number_format($ilance->GPC['radius']) . '</strong> ' . $phrase['_mile_radius_from'] . ' ' . (!empty($ilance->GPC['city']) ? '<strong>' . ucwords($ilance->GPC['city']) . '</strong>, ' : '') . '<strong>' . $ilance->GPC['radiuszip'] . '</strong>, ');
                                }
                        }
                        else
                        {
                                
                                // because we're not using the radius zip code logic we still need to obtain
                                // the query to fetch desired tables so the user can still sort via distance furthest or closest
                                //if (!empty($_SESSION['ilancedata']['user']['postalzip']))
                                if (!empty($ilance->GPC['zip_code']))
                                {
                                        $ilance->GPC['zip_code'] = mb_strtoupper(trim($ilance->GPC['zip_code']));
                                        //$ilance->GPC['zip_code'] = str_replace(' ', '', $ilance->GPC['zip_code']);
                                        //$ilance->GPC['zip_code'] = str_replace('-', '', $ilance->GPC['zip_code']);
                                        
                                        $distanceresult = $ilance->distance->fetch_sql_as_distance($ilance->GPC['zip_code'], $ilance->GPC['country']);
                                        if (is_array($distanceresult))
                                        {
                                                $sqlquery['leftjoin'] .= $distanceresult['leftjoin'];
                                                $sqlquery['fields'] .= $distanceresult['fields'];
                                        }
                                }
                                
                                // normal search (no radius): does user search in cities?
                                if (!empty($ilance->GPC['city']))
                                {
                                        // does user enter a city in search?
                                        $removeurl = rewrite_url($scriptpage, $remove = 'city=' . $ilance->GPC['city']);
                                        
                                        $ilance->GPC['city'] = ucfirst(trim($ilance->GPC['city']));
                                        $sqlquery['location'] .= "AND (u.city LIKE '%" . $ilance->db->escape_string($ilance->GPC['city']) . "%') ";
                                        
                                        handle_search_verbose($phrase['_located_in'] . ' ' . $phrase['_city'] . ': <strong>' . ucwords($ilance->GPC['city']) . '</strong> <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                        handle_search_verbose_save($phrase['_city'] . ': <strong>' . ucwords($ilance->GPC['city']) . '</strong>, ');
                                }
                                    
                                // does user search in state or provinces?
                                if (!empty($ilance->GPC['state']))
                                {
                                        // does user enter a city in search?
                                        $removeurl = rewrite_url($scriptpage, $remove = 'state=' . $ilance->GPC['state']);
                                        
                                        $ilance->GPC['state'] = ucfirst(trim($ilance->GPC['state']));
                                        $sqlquery['location'] .= "AND (u.state LIKE '%" . $ilance->db->escape_string($ilance->GPC['state']) . "%') ";
                                        
                                        handle_search_verbose($phrase['_located_in'] . ' ' . $phrase['_state_or_province'] . ': <strong>' . ucwords($ilance->GPC['state']) . '</strong> <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                        handle_search_verbose_save($phrase['_state'] . ': <strong>' . ucwords($ilance->GPC['state']) . '</strong>, ');
                                }
                                    
                                // does user search in zip codes?
                                if (!empty($ilance->GPC['zip_code']))
                                {
                                        //$ilance->GPC['zip_code'] = str_replace(' ', '', $ilance->GPC['zip_code']);
                                        //$ilance->GPC['zip_code'] = str_replace('-', '', $ilance->GPC['zip_code']);
                                        $ilance->GPC['zip_code'] = mb_strtoupper(trim($ilance->GPC['zip_code']));
                                        
                                        $removeurl = rewrite_url($scriptpage, $remove = 'zip_code=' . $ilance->GPC['zip_code']);
                                        $sqlquery['location'] .= "AND (u.zip_code LIKE '%" . $ilance->db->escape_string($ilance->GPC['zip_code']) . "%') ";
                                        
                                        handle_search_verbose($phrase['_located_in'] . ' ' . $phrase['_zip_slash_postal_code'] . ': <strong>' . ucwords($ilance->GPC['zip_code']) . '</strong> <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                        handle_search_verbose_save($phrase['_zip_slash_postal_code'] . ': <strong>' . ucwords($ilance->GPC['zip_code']) . '</strong>, ');
                                }
                        }
                        
                        // search via country
                        if ((!empty($ilance->GPC['country']) OR !empty($ilance->GPC['radiuscountry'])))
                        {
                                if (!empty($ilance->GPC['radiuscountry']))
                                {
                                        $ilance->GPC['country'] = $ilance->GPC['radiuscountry'];
                                }
                                
                                $removeurl = rewrite_url($scriptpage, $remove = 'country=' . urlencode($ilance->GPC['country']));
                                
                                if (!is_numeric($ilance->GPC['country']) AND $ilance->GPC['country'] != 'all')
                                {
                                        $ilance->GPC['country'] = $ilance->common->xss_clean($ilance->GPC['country']);
                                        $ilance->GPC['country'] = strip_tags(trim($ilance->GPC['country']));
                                        $bycountryname = true;
                                }
                                else
                                {
                                        $ilance->GPC['country'] = intval($ilance->GPC['country']);
                                        $bycountryname = false;
                                }
                                
                                if ($bycountryname == false AND $ilance->GPC['country'] > 0)
                                {
                                        $sqlquery['location'] .= "AND (u.country = '" . intval($ilance->GPC['country']) . "') ";
                                }
                                else
                                {
                                        $country = $ilance->db->fetch_field(DB_PREFIX . "locations", "location_" . fetch_site_slng() . " LIKE '%" . $ilance->db->escape_string($ilance->GPC['country']) . "%'", "locationid");
                                        if ($country > 0)
                                        {
                                                $sqlquery['location'] .= "AND (u.country = '" . intval($country) . "') ";
                                        }
                                }
                                
                                if ($ilance->GPC['country'] > 0)
                                {
                                        handle_search_verbose($phrase['_located_in'] . ' ' . $phrase['_country'] . ': <strong>' . print_country_name(intval($ilance->GPC['country'])) . '</strong> <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                        handle_search_verbose_save($phrase['_country'] . ': <strong>' . print_country_name(intval($ilance->GPC['country'])) . '</strong>, ');
                                }
                                else
                                {
                                        handle_search_verbose($phrase['_country'] . '/' . $phrase['_location_lc'] . ': <strong>' . $phrase['_worldwide'] . '</strong>, ');
                                        handle_search_verbose_save($phrase['_location'] . ': <strong>' . $phrase['_worldwide'] . '</strong>, ');
                                }
                        }
                        
                        //if (is_array($selected['expertselected']) AND !empty($_SESSION['ilancedata']['user']['postalzip']) AND in_array('distance', $selected["expertselected"]))
                        if (is_array($selected['expertselected']) AND (!empty($_SESSION['ilancedata']['user']['postalzip']) OR !empty($ilance->GPC['zip_code']) OR !empty($ilance->GPC['radiuszip'])) AND in_array('distance', $selected["expertselected"]))
                        {
                                $show['distancecolumn'] = 1;
                                
                                //handle_search_verbose($phrase['_showing_distance_calculation_from'] . ' <strong>' . $_SESSION['ilancedata']['user']['postalzip'] . '</strong>, <strong>' . $_SESSION['ilancedata']['user']['country'] . '</strong>, ');
                                //handle_search_verbose_save($phrase['_showing_distance_calculation_from'] . ' <strong>' . $_SESSION['ilancedata']['user']['postalzip'] . '</strong>, <strong>' . $_SESSION['ilancedata']['user']['country'] . '</strong>, ');
                        }
                        
                        // show only with active profile logos
                        if (isset($ilance->GPC['images']) AND $ilance->GPC['images'])
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'images=' . $ilance->GPC['images']);
                                $sqlquery['options'] .= "AND (l.user_id = u.user_id AND l.visible = '1' AND l.attachtype = 'profile') ";
                                
                                handle_search_verbose($phrase['_with_active_profile_logos_only'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_filter'] . ': <strong>' . $phrase['_with_active_profile_logos_only'] . '</strong>, ');
                        }
                        
                        // show only online logged in members
                        if (isset($ilance->GPC['isonline']) AND $ilance->GPC['isonline'])
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'isonline=' . $ilance->GPC['isonline']);
                                $sqlquery['options'] .= "AND (s.userid = u.user_id) ";
                                
                                handle_search_verbose($phrase['_showing_members_online_and_logged_in'] . ' <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_filter'] . ': <strong>' . $phrase['_showing_members_online_and_logged_in'] . '</strong>, ');
                        }
                        
                        if (!empty($ilance->GPC['fromprice']) AND $ilance->GPC['fromprice'] > 0)
                        {
                                $sqlquery['pricerange'] .= "AND (u.rateperhour >= ".intval($ilance->GPC['fromprice']) . " ";
                                
                                handle_search_verbose($phrase['_min_hourly_rate'] . ': <strong>' . $ilance->currency->format($ilance->GPC['fromprice']) . '</strong>, ');
                                handle_search_verbose_save($phrase['_min_hourly_rate'] . ': <strong>' . $ilance->currency->format($ilance->GPC['fromprice']) . '</strong>, ');
                        }
                        else
                        {
                                $sqlquery['pricerange'] .= "AND (u.rateperhour >= 0 ";
                                
                                //handle_search_verbose($phrase['_min_hourly_rate'] . ': <strong>' . $ilance->currency->format(0) . '</strong>, ');
                                //handle_search_verbose_save($phrase['_min_hourly_rate'] . ': <strong>' . $ilance->currency->format(0) . '</strong>, ');
                        }
                        
                        if (!empty($ilance->GPC['toprice']) AND $ilance->GPC['toprice'] > 0)
                        {
                                $removeurl = rewrite_url($scriptpage, $remove = 'toprice=' . $ilance->GPC['toprice']);
                                $sqlquery['pricerange'] .= "AND u.rateperhour <= ".intval($ilance->GPC['toprice']) . ") ";
                                
                                handle_search_verbose($phrase['_max_hourly_rate'] . ': <strong>' . $ilance->currency->format($ilance->GPC['toprice']) . '</strong> <a href="' . $removeurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save($phrase['_max_hourly_rate'] . ': <strong>' . $ilance->currency->format($ilance->GPC['toprice']) . '</strong>, ');
                        }
                        else
                        {
                                $sqlquery['pricerange'] .= ")";
                                
                                //handle_search_verbose($phrase['_max_hourly_rate'] . ': <strong>' . $phrase['_unlimited'] . '</strong>, ');
                                //handle_search_verbose_save($phrase['_max_hourly_rate'] . ': <strong>' . $phrase['_unlimited'] . '</strong>, ');
                        }
                        
                        $fromprice = isset($ilance->GPC['fromprice']) ? sprintf("%01.2f", $ilance->GPC['fromprice']) : '';
                        $toprice = isset($ilance->GPC['toprice']) ? sprintf("%01.2f", $ilance->GPC['toprice']) : '';
                        
                        // #### SKILLS LOGIC ###################################
                        $sqlquery['skillsquery'] = "";
                        if (isset($ilance->GPC['sid']) AND is_array($ilance->GPC['sid']))
                        {
                                $sqlquery['leftjoin'] .= " LEFT JOIN " . DB_PREFIX . "skills_answers a ON a.user_id = u.user_id ";
                                $findinset = $showtextskills = $favtextskills = '';
                                
                                foreach ($ilance->GPC['sid'] as $sid => $value)
                                {
                                        if (isset($sid) AND $sid > 0 AND isset($value) AND !empty($value))
                                        {
                                                $answertitle = print_skill_title($sid);
                                                $showqidurl = $ilpage['search'] . print_hidden_fields($string = true, $excluded = array('page'), $questionmarkfirst = true, $prepend_text = '', $append_text = '', $htmlentities = true, $urldecode = true, $showsid = true);
                                                $showqidurl = rewrite_url($showqidurl, $remove = 'sid[' . $sid . ']=' . $value);
                                                
                                                $showtextskills .= '<strong>' . $answertitle . '</strong> <a href="' . $showqidurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ';
                                                $favtextskills .= '<strong>' . $answertitle . '</strong>, ';
                                                
                                                $findinset .= "$sid,";
                                        }
                                }
                                
                                $sqlquery['skillsquery'] = "AND (FIND_IN_SET(a.cid, '$findinset'))";
                                
                                handle_search_verbose_filters($phrase['_skills'] . ': ' . $showtextskills);
                                handle_search_verbose_save($phrase['_skills'] . ': ' . $favtextskills);
                        }
                        else if (isset($ilance->GPC['sid']) AND $ilance->GPC['sid'] > 0 AND !is_array($ilance->GPC['sid']))
                        {
                                $answertitle = print_skill_title($ilance->GPC['sid']);
                                $showqidurl = $ilpage['search'] . print_hidden_fields($string = true, $excluded = array('page','sid'), $questionmarkfirst = true, $prepend_text = '', $append_text = '', $htmlentities = true, $urldecode = true);
                                
                                $sqlquery['leftjoin'] .= " LEFT JOIN " . DB_PREFIX . "skills_answers a ON a.user_id = u.user_id ";
                                $sqlquery['skillsquery'] = "AND (a.cid = '" . intval($ilance->GPC['sid']) . "')";
                                
                                handle_search_verbose_filters($phrase['_skills'] . ': <strong>' . $answertitle . '</strong> <a href="' . $showqidurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                handle_search_verbose_save(', <strong>' . $phrase['_other'] . '</strong>: ' . $phrase['_skills'] . ': <strong>' . $answertitle . '</strong>, ');
                        }
                        
                        // #### PROFILE ANSWERS LOGIC ##########################
                        $sqlquery['profileanswersquery'] = $sqlquery['profileanswersqueryextra'] = "";
                        if (isset($ilance->GPC['pa']) AND is_array($ilance->GPC['pa']))
                        {
                                $showtextprofiles = $favtextprofiles = $profiletitle = '';
                                $showtextpro = $emptypa = array();
                                $qs = 0;
                                
                                foreach ($ilance->GPC['pa'] as $profileqid)
                                {
                                        if (isset($profileqid) AND is_array($profileqid))
                                        {
                                                foreach ($profileqid AS $profileid => $profileoptions)
                                                {
                                                        $emptypa[$profileid] = 'false';
                                                        $profiletitle = $ilance->db->fetch_field(DB_PREFIX . "profile_questions", "questionid = '" . intval($profileid) . "'", "question");
                                                        $showtextpro[$profileid]['title'] = $profiletitle;
                                                        
                                                        if (isset($profileoptions) AND is_array($profileoptions))
                                                        {
                                                                $pass = false;
                                                                foreach ($profileoptions AS $profilekey => $profilevalue)
                                                                {
                                                                        if (isset($profilevalue) AND !empty($profilevalue))
                                                                        {
                                                                                if ($profilekey == 'from')
                                                                                {
                                                                                        $fromrange = $profilevalue;
                                                                                }
                                                                                if ($profilekey == 'to')
                                                                                {
                                                                                        $torange = $profilevalue;
                                                                                }
                                                                                if ($profilekey == 'custom')
                                                                                {
                                                                                        $custom = $profilevalue;
                                                                                        
                                                                                        $showpidurl = $ilpage['search'] . print_hidden_fields($string = true, $excluded = array('page'), $questionmarkfirst = true, $prepend_text = '', $append_text = '', $htmlentities = true, $urldecode = true, $showsid = true);
                                                                                        $showpidurl = rewrite_url($showpidurl, $remove = 'pa[choice_' . str_replace(' ', '_', mb_strtolower($custom)) . '][' . $profileid . '][custom]=' . $custom);
                                                                                        $showtextpro[$profileid]['options'][] = '<strong>' . $custom . '</strong> <a href="' . $showpidurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ';
                                                                                }
                                                                                $pass = true;
                                                                        }
                                                                }
                                                        }
                                                        
                                                        // range integer type
                                                        if (!empty($fromrange) AND !empty($torange) AND !empty($profileid) AND empty($custom) AND $pass)
                                                        {
                                                                $sqlquery['profileanswersquery'] .= "(pa.user_id = u.user_id AND pa.questionid = '" . intval($profileid) . "' AND pa.answer BETWEEN $fromrange AND $torange) OR ";
                                                                
                                                                $showpidurl = $ilpage['search'] . print_hidden_fields($string = true, $excluded = array('page'), $questionmarkfirst = true, $prepend_text = '', $append_text = '', $htmlentities = true, $urldecode = true, $showsid = true);
                                                                $showpidurl = rewrite_url($showpidurl, $remove = '&pa[range][' . $profileid . '][from]=' . $fromrange . '&pa[range][' . $profileid . '][to]=' . $torange);
                                                                
                                                                $showtextpro[$profileid]['title'] = $profiletitle;
                                                                $showtextpro[$profileid]['options'][] = '<strong>' . $phrase['_between_upper'] . ' ' . $fromrange . ' ' . $phrase['_and'] . ' ' . $torange . '</strong> <a href="' . $showpidurl . '" rel="nofollow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ';
                                                        }
                                                        
                                                        // multiple choices
                                                        else if (!empty($custom) AND $pass)
                                                        {
                                                                $sqlquery['profileanswersquery'] .= "(pa.user_id = u.user_id AND pa.questionid = '" . intval($profileid) . "' AND pa.answer LIKE '%" . $ilance->db->escape_string($custom) . "%') OR ";
                                                        }
                                                        else
                                                        {
                                                                $emptypa[$profileid] = 'true';
                                                        }
                                                        $qs++;
                                                }
                                        }
                                }
                                
                                // #############################################
                                // handle display of custom profile questions used on the advanced search form
                                if (!empty($showtextpro) AND is_array($showtextpro))
                                {
                                        foreach ($showtextpro AS $profilequestionid => $profilearray)
                                        {
                                                if ($emptypa[$profilequestionid] == 'false')
                                                {
                                                        $showtextprofiles .= $showtextpro[$profilequestionid]['title'] . ': ';
                                                        foreach ($profilearray AS $vv => $values)
                                                        {
                                                                if (isset($values) AND is_array($values))
                                                                {
                                                                        foreach ($values AS $choice)
                                                                        {
                                                                                $showtextprofiles .= $choice;        
                                                                        }
                                                                }
                                                        }
                                                }
                                        }
                                }
                                
                                if (!empty($sqlquery['profileanswersquery']) AND !empty($profiletitle))
                                {
                                        $sqlquery['fields'] .= ", pa.questionid, pa.answer";
                                        $sqlquery['leftjoin'] .= " LEFT JOIN " . DB_PREFIX . "profile_answers pa ON u.user_id = pa.user_id ";
                                        $sqlquery['profileanswersquery'] = "AND (" . mb_substr($sqlquery['profileanswersquery'], 0, -4) . ')';
                                        
                                        //handle_search_verbose_filters($phrase['_other'] . ': <strong>' . $profiletitle . '</strong> <a href="' . $showpidurl . '"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/delete_small.gif" border="0" alt="' . $phrase['_remove_this_item_specific_from_your_search'] . '" /></a>, ');
                                        //handle_search_verbose_save(', <strong>' . $phrase['_other'] . '</strong>: <strong>' . $profiletitle . '</strong>, ');
                                }
                                else
                                {
                                        $sqlquery['profileanswersquery'] = '';        
                                }
                        }
                        
                        // #### BUILD MAIN SEARCH SQL QUERY ####################
                        $sqlquery['select'] = "SELECT $sqlquery[fields] $sqlquery[from] $sqlquery[leftjoin] " . ((isset($ilance->GPC['isonline']) AND $ilance->GPC['isonline']) ? "LEFT JOIN " . DB_PREFIX . "sessions s ON u.user_id = s.userid" : "") . " WHERE u.user_id = p.user_id ";
                        
                        $SQL  = "$sqlquery[select] $sqlquery[keywords] $sqlquery[categories] $sqlquery[options] $sqlquery[location] $sqlquery[radius] $sqlquery[userquery] $sqlquery[hidequery] $sqlquery[pricerange] $sqlquery[genrequery] $sqlquery[profileanswersquery] $sqlquery[skillsquery] $sqlquery[groupby] $sqlquery[orderby] $sqlquery[limit]";
                        $SQL2 = "$sqlquery[select] $sqlquery[keywords] $sqlquery[categories] $sqlquery[options] $sqlquery[location] $sqlquery[radius] $sqlquery[userquery] $sqlquery[hidequery] $sqlquery[pricerange] $sqlquery[genrequery] $sqlquery[profileanswersquery] $sqlquery[skillsquery] $sqlquery[groupby] $sqlquery[orderby]";
                        //echo $SQL; exit;
                        
                        $row_count = 0;
                        $numberrows = $ilance->db->query($SQL2);
                        $number = $ilance->db->num_rows($numberrows);
                        $counter = ($ilance->GPC['page'] - 1) * fetch_perpage();
                        
                        if (!empty($keyword_text))
                        {
                                $favtext = '<div>' . $phrase['_keywords'] . ': <strong>' . stripslashes($keyword_formatted_favtext) . '</strong></div>' . print_search_verbose_saved('verbose_save');
                                $favtext = mb_substr($favtext, 0, -2) . '';
                                
                                // favorite search text results
                                if (!empty($selected['hideverbose']) AND $selected['hideverbose'] == 'true')
                                {
                                        $text = '<span class="header">' . $number . '</span> ' . $phrase['_experts_found_with_keywords'] . ': ' . stripslashes(trim($keyword_formatted)) . '';        
                                }
                                else
                                {
                                        // search text results
                                        $text = '<span class="header">' . $number . '</span> ' . $phrase['_experts_found_with_keywords'] . ': ' . stripslashes(trim($keyword_formatted)) . ', ' . print_search_verbose_saved('verbose');
                                        $text = mb_substr($text, 0, -2) . '';
                                }
                        }
                        else
                        {
                                // favorite search text results
                                $favtext = '<div>' . $phrase['_keywords'] . ': <strong>' . $phrase['_none'] . '</strong></div>' . print_search_verbose_saved('verbose_save');
                                $favtext = mb_substr($favtext, 0, -2) . '';
                                
                                if (!empty($selected['hideverbose']) AND $selected['hideverbose'] == 'true')
                                {
                                        $text = '<span class="header">' . $number . '</span> ' . $phrase['_experts_found_with_no_keywords'] . '';
                                }
                                else
                                {                                
                                        // search text results
                                        $text = '<span class="header">' . $number . '</span> ' . $phrase['_experts_found_with_no_keywords'] . ', ' . print_search_verbose_saved('verbose');
                                        $text = mb_substr($text, 0, -2) . '.';
                                }
                        }
                        
                        $showallurl = $ilpage['search'] . print_hidden_fields($string = true, $excluded = array('page','qid','q','sid','pa'), $questionmarkfirst = true, $prepend_text = '', $append_text = '', $htmlentities = true, $urldecode = false);
                        define('PHP_SELF_NOQID', $showallurl);
                        
                        $showtext = print_search_verbose_saved('verbose_filter');
                        if (!empty($showtext))
                        {
                                $showtext = mb_substr($showtext, 0, -2) . ' &nbsp;&nbsp;&nbsp;<span class="smaller gray">[ <a href="' . $showallurl . '" rel="nofollow">' . $phrase['_show_all'] . '</a> ]</span>';
                                $text .= '<div class="smaller"><hr size="1" width="100%" style="color:#ebebeb" /><strong>' . $phrase['_other'] . '</strong>:</div><div>' . $showtext . '</div>';
                        }
                        
                        if (!empty($showtextprofiles))
                        {
                                $showtextprofiles = mb_substr($showtextprofiles, 0, -2) . ' &nbsp;&nbsp;&nbsp;<span class="smaller gray">[ <a href="' . $showallurl . '" rel="nofollow">' . $phrase['_show_all'] . '</a> ]</span>';
                                $text .= '<div class="smaller"><hr size="1" width="100%" style="color:#ebebeb" /><strong>Profile Filters</strong>:</div><div>' . $showtextprofiles . '</div>';
                        }
                        
                        $metatitle = $phrase['_browse'];
                        if ($cid > 0)
                        {
                                $metatitle = $ilance->categories->title($_SESSION['ilancedata']['user']['slng'], 'service', $cid);
                                $metadescription = $ilance->categories->description($_SESSION['ilancedata']['user']['slng'], 'service', $cid);
                                $metakeywords = $ilance->categories->keywords($_SESSION['ilancedata']['user']['slng'], 'service', $cid, $commaafter = true, $showinputkeywords = true);
                        }
                        
                        $area_title = $phrase['_experts_search_results'] . ': ' . $metatitle . ' (' . $number . ' ' . $phrase['_results_found'] . ')';
                        $page_title = $phrase['_experts'] . ' - ' . $metatitle . ' ' . (!empty($metadescription) ? '- ' . $metadescription : '') . ' - ' . SITE_NAME;
                                                
                        $search_results_rows = array();
                        $result = $ilance->db->query($SQL);
                        if ($ilance->db->num_rows($result) > 0)
                        {
                                while ($row = $ilance->db->fetch_array($result, DB_ASSOC))
                                {
                                        $td['latestfeedback'] = short_string(print_latest_feedback_received($row['user_id'], 'provider', $shownone = true), 75);
                                        $td['isonline'] = print_online_status($row['user_id']);
                                        $td['expert'] = print_username($row['user_id'], 'href');
                                        $td['username'] = $td['expert'];
                                        $td['user_id'] = $row['user_id'];
                                        $td['city'] = ucfirst(fetch_user('city', $row['user_id']));
                                        $td['zipcode'] = mb_strtoupper(fetch_user('zip_code', $row['user_id']));
                                        $td['country'] = print_user_country($row['user_id'], $_SESSION['ilancedata']['user']['slng']);
                                        $td['state'] = fetch_user('state', $row['user_id']);
                                        
                                        // feedback
                                        $memberinfo = array();
                                        $memberinfo = $ilance->feedback->datastore($row['user_id']);
                                        if ($memberinfo['rating'] == 0)
                                        {
                                                $td['rated'] = '-';       
                                        }
                                        else
                                        {
                                                $td['rated'] = number_format($memberinfo['rating'], 2, '.', '') . ' / 5.00';
                                        }
                                        $td['feedback'] = $memberinfo['pcnt'] . '% ' . $phrase['_positive'];
                                        $td['credentials'] = fetch_verified_credentials($row['user_id']);
                                        $td['reviews'] = print_username($row['user_id'], 'custom', 0, '', '', fetch_service_reviews_reported($row['user_id']) . ' ' . $phrase['_reviews']);
                                        $td['awards'] = fetch_user('serviceawards', $row['user_id']);
                                        if ($td['awards'] == 0)
                                        {
                                                $td['awards'] = '-';
                                        }
                                        $td['earnings'] = print_income_reported($row['user_id']);
                                        if (has_portfolio($row['user_id']) > 0)
                                        {
                                                $td['portfolio'] = '<span class="blue"><a href="' . $ilpage['portfolio'] . '?id=' . $row['user_id'] . '" rel="nofollow">' . $phrase['_portfolio'] . '</a></span>';
                                        }
                                        else
                                        {
                                                $td['portfolio'] = '-';
                                        }
                                        
                                        // distance api
                                        $td['distance'] = '<span class="smaller gray">' . $phrase['_specify_zip_code'] . '</span>';
                                        if (isset($show['distancecolumn']) AND $show['distancecolumn'] AND isset($ilance->GPC['radiuscountry']) AND $ilance->GPC['radiuscountry'] > 0 AND isset($ilance->GPC['radius']) AND isset($ilance->GPC['radiuszip']) AND !empty($ilance->GPC['radiuszip']))
                                        {
                                                $td['distance'] = '<div class="gray">' . $ilance->distance->print_distance_results($row['user_id'], $row['country'], $row['zip_code'], $ilance->GPC['radiuscountry'], $ilance->GPC['radiuszip'], 0) . '</div>';
                                        }
                                        else if (isset($show['distancecolumn']) AND $show['distancecolumn'] AND isset($ilance->GPC['country']) AND $ilance->GPC['country'] > 0 AND isset($ilance->GPC['zip_code']) AND !empty($ilance->GPC['zip_code']))
                                        {
                                                $td['distance'] = '<div class="gray">' . $ilance->distance->print_distance_results($row['user_id'], $row['country'], $row['zip_code'], $ilance->GPC['country'], $ilance->GPC['zip_code'], 0) . '</div>';
                                        }
                                        
                                        if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
                                        {
                                                $td['sel'] = '<input type="checkbox" name="vendor_id[]" value="'.$row['user_id'].'" id="experts_'.$row['user_id'].'" />';
                                        }
                                        else
                                        {
                                                $td['sel'] = '<input type="checkbox" name="vendor_id[]" value="'.$row['user_id'].'" id="experts_'.$row['user_id'].'" disabled="disabled" />';
                                        }
                                        
                                        // profile logo
                                        $td['profilelogo'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'nophoto.gif' . '" border="0" alt="" />';
                                        
                                        $sqlattach = $ilance->db->query("
                                                SELECT attachid, filehash
                                                FROM " . DB_PREFIX . "attachment
                                                WHERE user_id = '" . $row['user_id'] . "' 
                                                    AND visible = '1'
                                                    AND attachtype = 'profile'
                                                LIMIT 1
                                        ");
                                        if ($ilance->db->num_rows($sqlattach) > 0)
                                        {
                                                $resattach = $ilance->db->fetch_array($sqlattach);
                                                $td['profilelogo'] = '<img src="' . $ilpage['attachment'] . '?cmd=thumb&amp;subcmd=results&amp;id=' . $resattach['filehash'] . '" border="0" alt="" />';
                                        }
                                        unset($sqlattach, $resattach);
                                        
                                        $hourlyrate = fetch_user('rateperhour', $row['user_id']);
                                        if ($hourlyrate > 0)
                                        {
                                                $td['rateperhour'] = $ilance->currency->format($hourlyrate);
                                        }
                                        else
                                        {
                                                $td['rateperhour'] = '-';
                                        }
                                        
                                        $td['skills'] = print_skills($row['user_id']);
                                        $td['level'] = $ilance->subscription->print_subscription_icon($row['user_id']);
                                        
                                        $td['class'] = ($row_count % 2) ? 'alt1' : 'alt1';
                                        
                                        ($apihook = $ilance->api('search_results_providers_loop')) ? eval($apihook) : false;
                                        
                                        $search_results_rows[] = $td;
                                        $row_count++;
                                }
                                
                                $show['no_rows_returned'] = false;
                        }
                        else
                        {
                                $show['no_rows_returned'] = true;
                        }
                        
                        // #### BUILD OUR PAGNATOR #############################
                        $prevnext = print_pagnation($number, fetch_perpage(), intval($ilance->GPC['page']), $counter, $scriptpage);
                        
                        // #### PRINT OUR SEARCH RESULTS TABLE #################
                        $search_results_table = print_search_results_table($search_results_rows, 'experts', $prevnext);
                    
                        // #### SEARCH FORM ELEMENTS: CATEGORY PULLDOWN ####################
                        $cid = isset($ilance->GPC['cid']) ? intval($ilance->GPC['cid']) : 0;
                        
                        if (isset($ilance->GPC['radiuscountry']) AND $ilance->GPC['radiuscountry'] > 0)
                        {
                                $radiuscountry = $ilance->GPC['radiuscountry'];
                        }
                        else
                        {
                                $radiuscountry = !empty($_SESSION['ilancedata']['user']['countryid']) ? $_SESSION['ilancedata']['user']['countryid'] : 'all';
                        }
                        
                        $search_radius_country_pulldown_experts = print_active_countries_pulldown('radiuscountry', $radiuscountry, $_SESSION['ilancedata']['user']['slng'], $showworldwide = false, 'expertradiuscountry');
                        
                        $ilance->GPC['rating'] = isset($ilance->GPC['rating']) ? $ilance->GPC['rating'] : '';
                        $search_ratingrange_pulldown = print_rating_range_pulldown($ilance->GPC['rating'], 'rating', 'rating');
                        
                        $ilance->GPC['projectrange'] = isset($ilance->GPC['projectrange']) ? $ilance->GPC['projectrange'] : '';
                        $search_awardrange_pulldown = print_award_range_pulldown($ilance->GPC['projectrange'], 'projectrange', 'projectrange');
                        
                        if (!empty($ilance->GPC['q']))
                        {
                                $keywords = htmlspecialchars($ilance->GPC['q']);
                        }
                        
                        // fewer keywords search
                        $fewer_keywords = print_fewer_keywords_search($keywords_array, 'experts', $number);
                        
                        // #### SAVE AS FAVORITE SEARCH OPTION #############################
                        if ($ilconfig['savedsearches'])
                        {
                                // build search request parameters
                                $favorites = array();
                                foreach ($ilance->GPC as $search => $option)
                                {
                                        if ($search != 'submit' AND $search != 'search' AND $search != 'page')
                                        {
                                                $favorites[] = array($search => $option);
                                        }
                                }
                                if (!empty($favorites) AND is_array($favorites))
                                {
                                        $encrypt = serialize($favorites);
                                        $encrypt = urlencode($encrypt);
                                }
                                
                                $favoritesearchurl = $encrypt;
                                $favoritesearch = '<span class="smaller">[ <span class="blue"><a href="javascript:void(0)" rel="nofollow" onclick="javascript:jQuery(\'#saved_search_modal\').jqm({modal: false}).jqmShow();" onmouseover="Tip(\'' . $phrase['_saved_searches_can_be_used_when_you_are_viewing_search_results_from_the_marketplace'] . '\', BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()">' . $phrase['_save_as_favorite_search'] . '</a></span> ]</span>&nbsp;&nbsp;&nbsp;';
                                $favtext = ilance_htmlentities($favtext);
                        }
                        else
                        {
                                $favoritesearch = $favtext = '';        
                        }
                        
                        $v3left_nav = $ilance->template->print_left_nav('serviceprovider', $cid, $dosubcats = 1, $displayboth = 0, $showcount = $ilconfig['globalfilters_enablecategorycount'], $ilance->categories->catservicefetch, $ilance->categories->catproductfetch);
                        $v3left_nav .= $ilance->template->print_search_nav('serviceprovider', $cid);
                        
                        ($apihook = $ilance->api('search_results_providers_end')) ? eval($apihook) : false;
                        
                        $ilance->GPC['sort'] = isset($ilance->GPC['sort']) ? $ilance->GPC['sort'] : '';
                        $sortpulldown2 = print_sort_pulldown($ilance->GPC['sort'], 'sort', $expertsmode = true);
                        
                        $hiddenfields = print_hidden_fields(false, $excluded = array('cid','isonline','images','portfolios','city','state','zip_code','endstart','endstart_filter','q','sort','page'), $questionmarkfirst = false, $prepend_text = '', $append_text = '', $htmlentities = true, $urldecode = true);
                        $hiddenfields_leftnav = print_hidden_fields(false, $excluded = array('country','fromprice','toprice','isonline','images','portfolios','city','state','zip_code','endstart','endstart_filter','q','page','radius','radiuscountry','radiuszip'), $questionmarkfirst = false, $prepend_text = '', $append_text = '', $htmlentities = true, $urldecode = true);
                        
                        if (isset($ilance->GPC['country']) AND !empty($ilance->GPC['country']))
                        {
                                $country = intval($ilance->GPC['country']);
                        }
                        else
                        {
                                //$country = !empty($_SESSION['ilancedata']['user']['countryid']) ? $_SESSION['ilancedata']['user']['countryid'] : 'all';
                                $country = 'all';
                        }
                        
                        //$search_country_pulldown = print_active_countries_pulldown('country', $country, $_SESSION['ilancedata']['user']['slng'], true, '');
                        $search_country_pulldown_experts = print_active_countries_pulldown('country', $country, $_SESSION['ilancedata']['user']['slng'], $showworldwide = false, 'expertcountry');
                        
                        $city = isset($ilance->GPC['city']) ? strip_tags($ilance->GPC['city']) : '';
                        $state = isset($ilance->GPC['state']) ? strip_tags($ilance->GPC['state']) : '';
                        $zip_code = isset($ilance->GPC['zip_code']) ? strip_tags($ilance->GPC['zip_code']) : '';
                        $radiuszip = isset($ilance->GPC['radiuszip']) ? strip_tags($ilance->GPC['radiuszip']) : '';
                        
                        if (empty($radiuszip) AND !empty($_SESSION['ilancedata']['user']['postalzip']))
                        {
                                $radiuszip = $_SESSION['ilancedata']['user']['postalzip'];
                        }
                        
                        // #### DISPLAY SEARCH RESULTS VIA XML #################
                        if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'xml')
                        {
                                if (!empty($search_results_rows) AND is_array($search_results_rows))
                                {
                                        $ilance->xml = construct_object('api.xml');
                                
                                        $xml = $ilance->xml->search_to_xml($search_results_rows, false);
                                        echo $xml;
                                }
                                exit();
                        }
                        
                        // #### DISPLAY SEARCH RESULTS VIA SERIALIZED ARRAY ####
                        else if (isset($ilance->GPC['do']) AND $ilance->GPC['do'] == 'array')
                        {
                                if (!empty($search_results_rows) AND is_array($search_results_rows))
                                {
                                        echo urlencode(serialize($search_results_rows));
                                }
                                exit();
                        }
                        
                        // #### DISPLAY SEARCH RESULTS TEMPLATE ################
                        else
                        {
                                $ilance->template->load_file('main', 'search_results.html', 0, 1);
                                $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                                $ilance->template->parse_if_blocks('main');
                                
                                $pprint_array = array('search_radius_country_pulldown_experts','search_country_pulldown_experts','favtext','favoritesearchurl','profilebidfilters','fewer_keywords','fromprice','toprice','hiddenfields_leftnav','city','state','zip_code','radiuszip','mode','search_country_pulldown2','hiddenfields','search_results_table','sortpulldown2','keywords','favoritesearch','two_column_category_vendors','keywords','php_self','php_self_urlencoded','pfp_category_left','pfp_category_js','rfp_category_left','rfp_category_js','input_style','search_country_pulldown','search_jobtype_pulldown','five_last_keywords_buynow','five_last_keywords_projects','five_last_keywords_providers','search_ratingrange_pulldown','search_awardrange_pulldown','search_bidrange_pulldown','search_listed_pulldown','search_closing_pulldown','search_category_pulldown','input_style','distance','subcategory_name','text','prevnext','prevnext2','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
                                
                                ($apihook = $ilance->api('search_results_providers_template')) ? eval($apihook) : false;
 
                                $ilance->template->pprint('main', $pprint_array);
                                exit();
                        }
                        
                        break;
                }
        }
}

// #### ADVANCED SEARCH MENU ###################################################

$area_title = $phrase['_search_the_marketplace'];
$page_title = SITE_NAME . ' - ' . $phrase['_search_the_marketplace'];

$search_bidrange_pulldown_service = print_bid_range_pulldown('', 'bidrange', 'servicebidrange');
$search_bidrange_pulldown_product = print_bid_range_pulldown('', 'bidrange', 'productbidrange');
$search_awardrange_pulldown = print_award_range_pulldown('', 'projectrange', 'projectrange');
$search_ratingrange_pulldown = print_rating_range_pulldown('', 'rating', 'rating');

if (isset($ilance->GPC['country']) AND $ilance->GPC['country'] > 0)
{
        $country = $ilance->GPC['country'];
}
else
{
        $country = !empty($_SESSION['ilancedata']['user']['countryid']) ? $_SESSION['ilancedata']['user']['countryid'] : 'all';
}
$search_country_pulldown_experts = print_active_countries_pulldown('country', $country, $_SESSION['ilancedata']['user']['slng'], $showworldwide = false, 'expertcountry');
$search_country_pulldown_service = print_active_countries_pulldown('country', $country, $_SESSION['ilancedata']['user']['slng'], $showworldwide = false, 'servicecountry');
$search_country_pulldown_product = print_active_countries_pulldown('country', $country, $_SESSION['ilancedata']['user']['slng'], $showworldwide = false, 'productcountry');

//$radiuscountry = !empty($_SESSION['ilancedata']['user']['countryid']) ? $_SESSION['ilancedata']['user']['countryid'] : 'all';
if (isset($ilance->GPC['radiuscountry']) AND $ilance->GPC['radiuscountry'] > 0)
{
        $radiuscountry = $ilance->GPC['radiuscountry'];
}
else
{
        $radiuscountry = !empty($_SESSION['ilancedata']['user']['countryid']) ? $_SESSION['ilancedata']['user']['countryid'] : 'all';
}
$search_radius_country_pulldown_experts = print_active_countries_pulldown('radiuscountry', $radiuscountry, $_SESSION['ilancedata']['user']['slng'], $showworldwide = false, 'expertradiuscountry');
$search_radius_country_pulldown_service = print_active_countries_pulldown('radiuscountry', $radiuscountry, $_SESSION['ilancedata']['user']['slng'], $showworldwide = false, 'serviceradiuscountry');
$search_radius_country_pulldown_product = print_active_countries_pulldown('radiuscountry', $radiuscountry, $_SESSION['ilancedata']['user']['slng'], $showworldwide = false, 'productradiuscountry');

if (isset($ilance->GPC['q']))
{
        if (!empty($ilance->GPC['q']))
        {
                $q = ilance_htmlentities($ilance->GPC['q']);
        }
}

($apihook = $ilance->api('search_menu_start')) ? eval($apihook) : false;

$searcherror = $ilance->language->construct_phrase($phrase['_we_require_that_you_wait_x_seconds_between_searches_please_try_again_in_x_seconds'], array($searchwait, $searchwaitleft));

// #### SEARCH OPTIONS #########################################################
$js_start = print_searchoptions_js();

// #### SEARCH OPTION CONTROLS #################################################
$perpage = print_perpage_searchoption();
$sortpulldown = print_sort_pulldown();

$cb_username = print_checkbox_status('username');
$cb_latestfeedback = print_checkbox_status('latestfeedback');
$cb_online = print_checkbox_status('online');
$cb_description = print_checkbox_status('description');
$cb_icons = print_checkbox_status('icons');
$cb_currencyconvert = print_checkbox_status('currencyconvert');
$cb_displayfeatured = print_checkbox_status('displayfeatured');
$cb_hidelisted = print_checkbox_status('hidelisted');
$cb_hideverbose = print_checkbox_status('hideverbose');
$cb_proxybit = print_checkbox_status('proxybit');
$rb_showtimeas_static = print_time_static_radiobox_status();
$rb_showtimeas_flash = print_time_flash_radiobox_status();
$rb_list_gallery = print_list_gallery_radiobox_status();
$rb_list_list = print_list_list_radiobox_status();

// #### SAVING SEARCH OPTIONS ##################################################
if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'saveoptions')
{
        if (is_array($ilance->GPC))
        {
                $options = array();
                foreach ($ilance->GPC as $search => $option)
                {
                        if ($search != 'defaultupdate' AND $search != 'membersupdate' AND $search != 'tab' AND $search != 'search' AND $search != 'cmd' AND $search != 'returnurl' AND $search != 'redirect')
                        {
                                $options["$search"] = $option;
                        }
                }
                if (empty($options['online']))
                {
                        $options['online'] = 'false';
                }
                if (empty($options['latestfeedback']))
                {
                        $options['latestfeedback'] = 'false';
                }
                if (empty($options['username']))
                {
                        $options['username'] = 'false';
                }
                if (empty($options['description']))
                {
                        $options['description'] = 'false';
                }
                if (empty($options['icons']))
                {
                        $options['icons'] = 'false';
                }
                if (empty($options['currencyconvert']))
                {
                        $options['currencyconvert'] = 'false';
                }
                if (empty($options['displayfeatured']))
                {
                        $options['displayfeatured'] = 'false';
                }
                if (empty($options['hidelisted']))
                {
                        $options['hidelisted'] = 'false';
                }
                if (empty($options['hideverbose']))
                {
                        $options['hideverbose'] = 'false';
                }
                if (empty($options['proxybit']))
                {
                        $options['proxybit'] = 'false';
                }
                
                ($apihook = $ilance->api('search_saveoptions_submit_end')) ? eval($apihook) : false;
                
                $searchoptions = serialize($options);
                $uid = 0;
                if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
                {
                        $uid = $_SESSION['ilancedata']['user']['userid'];
                }
                update_default_searchoptions($uid, $searchoptions);
                
                if (isset($ilance->GPC['defaultupdate']) AND $ilance->GPC['defaultupdate'] == 'true')
                {
                        update_default_searchoptions_guests($searchoptions);
                }
                
                if (isset($ilance->GPC['membersupdate']) AND $ilance->GPC['membersupdate'] == 'true')
                {
                        update_default_searchoptions_users($searchoptions);
                }
                
                if (!empty($ilance->GPC['returnurl']))
                {
                        refresh($ilance->GPC['returnurl']);
                        exit();
                }
                
                refresh($ilpage['search'] . '?tab=3');
                exit();
        }
        else
        {
                refresh($ilpage['login']);
                exit();      
        }
}

$show['widescreen'] = $show['leftnav'] = false;

$ilance->GPC['sort'] = isset($ilance->GPC['sort']) ? $ilance->GPC['sort'] : '';
$sortpulldown2 = print_sort_pulldown($ilance->GPC['sort'], 'sort', $expertsmode = true);

$returnurl = !empty($ilance->GPC['returnurl']) ? $ilance->GPC['returnurl'] : '';

$skills_selection = $ilance->categories_skills->print_skills_columns($_SESSION['ilancedata']['user']['slng'], $showcount = 1, $prepopulate = false);

$headinclude .= '
<script language="javascript" type="text/javascript">
<!-- 
function print_profile_filters()
{
	var ajaxRequest;
	
	try
	{
		ajaxRequest = new XMLHttpRequest();
	} 
	catch (e)
	{
		// Internet Explorer Browsers
		try
		{
			ajaxRequest = new ActiveXObject("Msxml2.XMLHTTP");
		} 
		catch (e) 
		{
			try
			{
				ajaxRequest = new ActiveXObject("Microsoft.XMLHTTP");
			} 
			catch (e)
			{
				return false;
			}
		}
	}
	// Create a function that will receive data sent from the server
	ajaxRequest.onreadystatechange = function()
	{
			if (ajaxRequest.readyState == 4)
			{
					var ajaxDisplay = fetch_js_object(\'profile_filters_text\');
					ajaxDisplay.innerHTML = ajaxRequest.responseText;
			}
	}
	
        var selected_cid = fetch_js_object(\'cid_list\').options[fetch_js_object(\'cid_list\').selectedIndex].value;
	var queryString = "&cid=" + selected_cid;
	
	ajaxRequest.open("GET", "' . HTTPS_SERVER . 'ajax.php?s=" + ILSESSION + "&do=profilefilters" + queryString, true);
	ajaxRequest.send(null); 
}

//-->
</script>';

($apihook = $ilance->api('search_start')) ? eval($apihook) : false;

$ilance->template->load_file('main', 'search.html');
$ilance->template->parse_if_blocks('main');
$ilance->template->parse_hash('main', array('ilpage' => $ilpage));

$pprint_array = array('search_bidrange_pulldown_service','search_bidrange_pulldown_product','search_radius_country_pulldown_service','search_radius_country_pulldown_product','search_country_pulldown_service','search_country_pulldown_product','search_country_pulldown_experts','search_radius_country_pulldown_experts','provider_category_selection','profilebidfilters','skills_selection','returnurl','js_start','perpage','sortpulldown','sortpulldown2','rb_list_gallery','rb_list_list','rb_showtimeas_flash','rb_showtimeas_static','cb_username','cb_latestfeedback','cb_online','cb_description','cb_icons','cb_currencyconvert','cb_displayfeatured','cb_hidelisted','cb_proxybit','cb_hideverbose','serviceavailable','serviceselected','productavailable','productselected','expertavailable','expertselected','keywords','searcherror','fromprice','toprice','budgetfilter','tab','search_offersrange_pulldown','search_wantedsincerange_pulldown','wantads_category_selection','search_country_pulldown2','search_soldrange_pulldown','search_itemsrange_pulldown','search_opensincerange_pulldown','stores_category_selection','product_category_selection','service_category_selection','search_serviceauctions_img','search_serviceauctions_collapse','search_productauctions_img','search_productauctions_collapse','search_experts_collapse','search_experts_img','pfp_category_left','rfp_category_left','input_style','search_country_pulldown','search_jobtype_pulldown','search_ratingrange_pulldown','search_awardrange_pulldown','search_bidrange_pulldown','search_listed_pulldown','search_closing_pulldown','input_style','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');

($apihook = $ilance->api('search_start_template')) ? eval($apihook) : false;
 
$ilance->template->pprint('main', $pprint_array);
exit();

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: search.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>