<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

// #### load required phrase groups ############################################
$phrase['groups'] = array(
        'watchlist'
);

// #### load required javascript ###############################################
$jsinclude = array(
        'tabfx'
);

// #### define top header nav ##################################################
$topnavlink = array(
	'watchlist'
);

// #### setup script location ##################################################
define('LOCATION','watchlist');

// #### require backend ########################################################
require_once('./functions/config.php');

// #### setup default breadcrumb ###############################################
$navcrumb = array("$ilpage[watchlist]" => $ilcrumbs["$ilpage[watchlist]"]);

$ilance->watchlist = construct_object('api.watchlist');
$ilance->feedback = construct_object('api.feedback');

$show['widescreen'] = true;
						
if (isset($ilance->GPC['wtype']) AND $ilance->GPC['wtype'] == 'rfp' AND isset($ilance->GPC['cmd']) AND ($ilance->GPC['cmd'] == 'add' OR $ilance->GPC['cmd'] == 'upd') AND isset($ilance->GPC['id']))
{
	if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
	{
		$id = intval($ilance->GPC['id']);
		if ($ilance->GPC['cmd'] == 'add')
		{
			$area_title = $phrase['_adding_rfp'].' ('.$id.') '.$phrase['_information_to_watchlist'];
			$page_title = SITE_NAME . ' - ' . $phrase['_adding_rfp'].' ('.$id.') '.$phrase['_information_to_watchlist'];
			$ilance->GPC['cmd'] = 'insert';
		}
		else if ($ilance->GPC['cmd'] == 'upd')
		{
			$area_title = $phrase['_updating'].' RFP ('.$id.') '.$phrase['_information_to_watchlist'];
			$page_title = SITE_NAME . ' - ' . $phrase['_updating'].' RFP ('.$id.')';
			$ilance->GPC['cmd'] = 'update';
		}
		
		$cmd = $ilance->GPC['cmd'];
		$wtype = $ilance->GPC['wtype'];
		$comment = '';
                
		$sql_users = $ilance->db->query("
                        SELECT *
                        FROM " . DB_PREFIX . "watchlist
                        WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                AND watching_project_id = '" . $id . "'
                                AND state = 'auction'
                ");
		if ($ilance->db->num_rows($sql_users) > 0)
		{
			$res = $ilance->db->fetch_array($sql_users);
			$comment = stripslashes($res['comment']);
		}
		
		$ilance->template->load_popup('popupheader', 'popup_header.html');
		$ilance->template->load_popup('popupmain', 'popup_watchlist_add.html');
		$ilance->template->load_popup('popupfooter', 'popup_footer.html');
		$ilance->template->parse_hash('popupmain', array('ilpage' => $ilpage));
		$ilance->template->parse_hash('popupheader', array('ilpage' => $ilpage));
		$ilance->template->parse_hash('popupfooter', array('ilpage' => $ilpage));
		$ilance->template->parse_if_blocks('popupheader');
		$ilance->template->parse_if_blocks('popupmain');
		$ilance->template->parse_if_blocks('popupfooter');
		$ilance->template->pprint('popupheader', array('headinclude','onload','onbeforeunload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','meta_desc','meta_keyw','official_time'));
		$ilance->template->pprint('popupmain', array('comment','wtype','cmd','id','input_style','remote_addr','rid','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
		$ilance->template->pprint('popupfooter', array('headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','finaltime','finalqueries'));
		exit();
	}
	else
	{
		$area_title = $phrase['_access_denied_to_watchlist_resource'];
		$page_title = SITE_NAME . ' - ' . $phrase['_access_denied_to_watchlist_resource'];

		$ilance->template->load_popup('popupheader', 'popup_header.html');
		$ilance->template->load_popup('popupmain', 'popup_denied.html');
		$ilance->template->load_popup('popupfooter', 'popup_footer.html');
		$ilance->template->parse_hash('popupmain', array('ilpage' => $ilpage));
		$ilance->template->parse_hash('popupheader', array('ilpage' => $ilpage));
		$ilance->template->parse_hash('popupfooter', array('ilpage' => $ilpage));
		$ilance->template->parse_if_blocks('popupheader');
		$ilance->template->parse_if_blocks('popupmain');
		$ilance->template->parse_if_blocks('popupfooter');
		$ilance->template->pprint('popupheader', array('headinclude','onload','onbeforeunload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','meta_desc','meta_keyw','official_time') );
		$ilance->template->pprint('popupmain', array('input_style','remote_addr','rid','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
		$ilance->template->pprint('popupfooter', array('headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','finaltime','finalqueries'));
		exit();
	}
}

// #### ADDING SERVICE PROVIDER INTO WATCHLIST #################################
else if (isset($ilance->GPC['wtype']) AND ($ilance->GPC['wtype'] == 'mprovider' OR $ilance->GPC['wtype'] == 'sprovider' OR $ilance->GPC['wtype'] == 'buyer') AND isset($ilance->GPC['cmd']) AND ($ilance->GPC['cmd'] == 'add' OR $ilance->GPC['cmd'] == 'upd') AND isset($ilance->GPC['id']) AND !empty($ilance->GPC['id']))
{
	if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
	{
		$id = intval($ilance->GPC['id']);
		$area_title = $phrase['_adding_rfp'].' ('.$id.') '.$phrase['_information_to_watchlist'];
		$page_title = SITE_NAME . ' - ' . $phrase['_adding_rfp'].' ('.$id.') '.$phrase['_information_to_watchlist'];
	
		if ($ilance->GPC['cmd'] == 'add')
		{
			$ilance->GPC['cmd'] = 'insert';
		}
		elseif ($ilance->GPC['cmd'] == 'upd')
		{
			$ilance->GPC['cmd'] = 'update';
		}
			
		$cmd = $ilance->GPC['cmd'];
		$wtype = strtolower(trim($ilance->GPC['wtype']));
		$comment = '';
		$state = 'sprovider';
                
		$sql_users = $ilance->db->query("
                        SELECT *
                        FROM " . DB_PREFIX . "watchlist
                        WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                AND watching_user_id = '" . $id . "'
                                AND state = '" . $ilance->db->escape_string($wtype) . "'
                ");
		if ($ilance->db->num_rows($sql_users) > 0)
		{
			$res = $ilance->db->fetch_array($sql_users);
			$comment = stripslashes($res['comment']);
			$state = $res['state']; 
		}
                
		$ilance->template->load_popup('popupheader', 'popup_header.html');
		$ilance->template->load_popup('popupmain', 'popup_watchlist_add.html');
		$ilance->template->load_popup('popupfooter', 'popup_footer.html');
		$ilance->template->parse_hash('popupmain', array('ilpage' => $ilpage));
		$ilance->template->parse_hash('popupheader', array('ilpage' => $ilpage));
		$ilance->template->parse_hash('popupfooter', array('ilpage' => $ilpage));
		$ilance->template->parse_if_blocks('popupheader');
		$ilance->template->parse_if_blocks('popupmain');
		$ilance->template->parse_if_blocks('popupfooter');
		$ilance->template->pprint('popupheader', array('headinclude','onload','onbeforeunload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','meta_desc','meta_keyw','official_time'));
		$ilance->template->pprint('popupmain', array('comment','wtype','cmd','id','input_style','remote_addr','rid','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
		$ilance->template->pprint('popupfooter', array('headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','finaltime','finalqueries'));
		exit();
	}	
	else
	{
		$area_title = $phrase['_access_denied_to_watchlist_resource'];
		$page_title = SITE_NAME . ' - ' . $phrase['_access_denied_to_watchlist_resource'];

		$ilance->template->load_popup('popupheader', 'popup_header.html');
		$ilance->template->load_popup('popupmain', 'popup_denied.html');
		$ilance->template->load_popup('popupfooter', 'popup_footer.html');
		$ilance->template->parse_hash('popupmain', array('ilpage' => $ilpage));
		$ilance->template->parse_hash('popupheader', array('ilpage' => $ilpage));
		$ilance->template->parse_hash('popupfooter', array('ilpage' => $ilpage));
		$ilance->template->parse_if_blocks('popupheader');
		$ilance->template->parse_if_blocks('popupmain');
		$ilance->template->parse_if_blocks('popupfooter');
		$ilance->template->pprint('popupheader', array('headinclude','onload','onbeforeunload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','meta_desc','meta_keyw','official_time') );
		$ilance->template->pprint('popupmain', array('input_style','remote_addr','rid','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
		$ilance->template->pprint('popupfooter', array('headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','finaltime','finalqueries'));
		exit();
	}
}

if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
{
        $ilance->subscription = construct_object('api.subscription');
	if ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], $accessname='addtowatchlist') == "yes")
	{
		// #### ADD AUCTION TO WATCHLIST ###############################
		if (isset($ilance->GPC['wtype']) AND $ilance->GPC['wtype'] == 'rfp' AND isset($ilance->GPC['cmd']) AND ($ilance->GPC['cmd'] == 'insert' OR $ilance->GPC['cmd'] == 'update') AND isset($ilance->GPC['id']) AND !empty($ilance->GPC['id']))
		{
			if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'insert')
			{
				$id = intval($ilance->GPC['id']);
				$area_title = $phrase['_adding_rfp_pound'].$id.' '.$phrase['_to_watchlist'];
				$page_title = SITE_NAME . ' - ' . $phrase['_adding_rfp_pound'].$id.' '.$phrase['_to_watchlist'];
				$ilance->watchlist->insert_item($_SESSION['ilancedata']['user']['userid'], $id, 'auction', $ilance->GPC['comment']);
			}
			else if ($ilance->GPC['cmd'] == 'update')
			{
				$id = intval($ilance->GPC['id']);
				$area_title = $phrase['_updating'].' ('.$id.')';
				$page_title= SITE_NAME . ' - ' . $phrase['_updating'].' ('.$id.')';
				$ilance->watchlist->update_item($_SESSION['ilancedata']['user']['userid'], $id, 'auction', $ilance->GPC['comment']);
			}
			
			$ilance->template->load_popup('popupheader', 'popup_header.html');
			$ilance->template->load_popup('popupmain', 'popup_watchlist_added.html');
			$ilance->template->load_popup('popupfooter', 'popup_footer.html');
			$ilance->template->parse_hash('popupmain', array('ilpage' => $ilpage));
			$ilance->template->parse_hash('popupheader', array('ilpage' => $ilpage));
			$ilance->template->parse_hash('popupfooter', array('ilpage' => $ilpage));
			$ilance->template->parse_if_blocks('popupheader');
			$ilance->template->parse_if_blocks('popupmain');
			$ilance->template->parse_if_blocks('popupfooter');
			$ilance->template->pprint('popupheader', array('headinclude','onload','onbeforeunload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','meta_desc','meta_keyw','official_time'));
			$ilance->template->pprint('popupmain', array('input_style','remote_addr','rid','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
			$ilance->template->pprint('popupfooter', array('headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','finaltime','finalqueries'));
			exit();
		}		
		else if (isset($ilance->GPC['wtype']) AND ($ilance->GPC['wtype'] == 'mprovider' OR $ilance->GPC['wtype'] == 'sprovider' OR $ilance->GPC['wtype'] == 'buyer') AND isset($ilance->GPC['cmd']) AND ($ilance->GPC['cmd'] == 'insert' OR $ilance->GPC['cmd'] == 'update') AND isset($ilance->GPC['id']) AND !empty($ilance->GPC['id']))
		{
			if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'insert')
			{
				$id = intval($ilance->GPC['id']);
				$area_title = $phrase['_adding'].' UserID ('.$id.') '.$phrase['_to_watchlist'];
				$page_title = SITE_NAME . ' - ' . $phrase['_adding'].' UserID ('.$id.') '.$phrase['_to_watchlist'];
				$watchtype = mb_strtolower(trim($ilance->GPC['wtype']));
				$ilance->watchlist->insert_item($_SESSION['ilancedata']['user']['userid'], $id, $watchtype, $ilance->GPC['comment']);
			}
			else if ($ilance->GPC['cmd'] == 'update')
			{
				$id = intval($ilance->GPC['id']);
				$area_title = $phrase['_updating'].' UserID ('.$id.')';
				$page_title = SITE_NAME . ' - ' . $phrase['_updating'].' UserID ('.$id.')';
				$watchtype = mb_strtolower(trim($ilance->GPC['wtype']));
				$ilance->watchlist->update_item($_SESSION['ilancedata']['user']['userid'], $id, $watchtype, $ilance->GPC['comment']);
			}
			
			$ilance->template->load_popup('popupheader', 'popup_header.html');
			$ilance->template->load_popup('popupmain', 'popup_watchlist_added.html');
			$ilance->template->load_popup('popupfooter', 'popup_footer.html');
			$ilance->template->parse_hash('popupmain', array('ilpage' => $ilpage));
			$ilance->template->parse_hash('popupheader', array('ilpage' => $ilpage));
			$ilance->template->parse_hash('popupfooter', array('ilpage' => $ilpage));
			$ilance->template->parse_if_blocks('popupheader');
			$ilance->template->parse_if_blocks('popupmain');
			$ilance->template->parse_if_blocks('popupfooter');
			$ilance->template->pprint('popupheader', array('headinclude','onload','onbeforeunload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','meta_desc','meta_keyw','official_time'));
			$ilance->template->pprint('popupmain',   array('input_style','remote_addr','rid','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
			$ilance->template->pprint('popupfooter', array('headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','finaltime','finalqueries'));
			exit();
		}
		else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_do-watch-cmd')
		{
			// remove auctions
			if (isset($ilance->GPC['state']) AND $ilance->GPC['state'] == 'auction' AND isset($ilance->GPC['rfpcmd']) AND $ilance->GPC['rfpcmd'] == 'delete')
			{
				if (isset($ilance->GPC['rfpcmd']) AND $ilance->GPC['rfpcmd'] == 'delete')
				{
					if (isset($ilance->GPC['project_id']))
					{
						foreach($ilance->GPC['project_id'] as $value)
						{
							$ilance->db->query("
                                                                DELETE FROM " . DB_PREFIX . "watchlist
                                                                WHERE watching_project_id = '".intval($value)."'
                                                                        AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                        AND state = '".$ilance->GPC['state']."'
                                                        ");
						}
                                                
						refresh($ilpage['watchlist']);
						exit();
					}
					else
					{
						refresh($ilpage['watchlist']);
						exit();
					}
				}
			}
			else if (isset($ilance->GPC['state']) AND $ilance->GPC['state'] == 'buyer' AND isset($ilance->GPC['buyercmd']) AND ($ilance->GPC['buyercmd'] == 'delete' OR $ilance->GPC['buyercmd'] == 'invite'))
			{
				if (isset($ilance->GPC['buyercmd']) AND $ilance->GPC['buyercmd'] == 'watchlist')
				{
					if (isset($ilance->GPC['vendor_id']))
					{
						$watchtype = $ilance->GPC['state'];
						$comment = "";
						foreach($ilance->GPC['vendor_id'] as $value)
						{
							$ilance->watchlist->insert_item($_SESSION['ilancedata']['user']['userid'], intval($value), $watchtype, $comment);
						}
						refresh($ilpage['watchlist']);
						exit();
					}
					else
					{
						refresh($ilpage['watchlist']);
						exit();
					}
				}
				else if ($ilance->GPC['buyercmd'] == 'delete')
				{
					if (isset($ilance->GPC['vendor_id']))
					{
						foreach ($ilance->GPC['vendor_id'] as $value)
						{
							$ilance->db->query("
                                                                DELETE FROM " . DB_PREFIX . "watchlist
                                                                WHERE watching_user_id = '".intval($value)."'
                                                                        AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                        AND state = '".$ilance->GPC['state']."'
                                                        ");
						}
                                                
						refresh($ilpage['watchlist']);
						exit();
					}
					else
					{
						refresh($ilpage['watchlist']);
						exit();
					}
				}
				else if ($ilance->GPC['buyercmd'] == 'invite')
				{
					if (isset($ilance->GPC['vendor_id']))
					{
						if ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'inviteprovider') == 'no')
						{
                                                        $area_title = $phrase['_provider_invitation_denied_upgrade_subscription'];
                                                        $page_title = SITE_NAME . ' - ' . $phrase['_provider_invitation_denied_upgrade_subscription'];
                                                        
                                                        print_notice($phrase['_access_denied'], $phrase['_your_current_subscription_level_does_not_permit_you_to_use_this_marketplace_resource'] . ' <a href="' . $ilpage['subscription'] . '"><strong>' . $phrase['_click_here'] . '</strong></a>', $ilpage['subscription'], ucwords($phrase['_click_here']), fetch_permission_name('inviteprovider'));
                                                        exit();
                                                }
                                                
                                                $area_title = $phrase['_inviting_a_provider_to_a_new_or_existing_rfp'];
                                                $page_title = SITE_NAME . ' - ' . $phrase['_inviting_a_provider_to_a_new_or_existing_rfp'];
                                                
                                                $hidden_invitations = "";
                                                $count = count($ilance->GPC['vendor_id']);
                                                if ($count > 1)
                                                {
                                                        for ($i=0; $i<$count; $i++)
                                                        {
                                                                $sql_vendor = $ilance->db->query("
                                                                        SELECT *
                                                                        FROM " . DB_PREFIX . "users
                                                                        WHERE user_id = '".intval($ilance->GPC['vendor_id'][$i])."'
                                                                                AND status = 'active'
                                                                ");
                                                                if ($ilance->db->num_rows($sql_vendor) > 0)
                                                                {
                                                                        $res_vendor = $ilance->db->fetch_array($sql_vendor);
                                                                        $invitationid = $res_vendor['user_id'];
                                                                        $provider .= print_username($invitationid, 'href').' ';
                                                                        $hidden_invitations .= '<input type="hidden" name="invitationid[]" value="'.$invitationid.'" />';
                                                                }
                                                        }
                                                }
                                                else
                                                {
                                                        $sql_vendor = $ilance->db->query("
                                                                SELECT * FROM " . DB_PREFIX . "users
                                                                WHERE user_id = '".intval($ilance->GPC['vendor_id'][0])."'
                                                                        AND status='active'
                                                        ");
                                                        if ($ilance->db->num_rows($sql_vendor) > 0)
                                                        {
                                                                $res_vendor = $ilance->db->fetch_array($sql_vendor);
                                                                $invitationid = $res_vendor['user_id'];
                                                                $provider .= print_username($invitationid, 'href'). ' ';
                                                                $hidden_invitations .= '<input type="hidden" name="invitationid" value="'.$invitationid.'">';
                                                        }
                                                }
                                                
                                                $sql_projects = $ilance->db->query("
                                                        SELECT *
                                                        FROM " . DB_PREFIX . "projects
                                                        WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                AND status = 'open'
                                                                AND project_state = 'product'
                                                ");
                                                $invite_pulldown = '<select name="project_id">';
                                                $invite_pulldown .= '<option value="">'.$phrase['_select_rfp'].':</option>';
                                                if ($ilance->db->num_rows($sql_projects) > 0)
                                                {
                                                        while ($res = $ilance->db->fetch_array($sql_projects))
                                                        {
                                                                $invite_pulldown .= '<option value="' . $res['project_id'] . '">' . $phrase['_item'] . ' ('.$res['project_id'].'): '.short_string(stripslashes($res['project_title']),35).' ('.$phrase['_bids'].': '.$res['bids'].') ('.$phrase['_ends'].': '.print_date($res['date_end'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0).')</option>';
                                                        }
                                                }
                                                else
                                                {
                                                        $invite_pulldown .= '<option value="">--- ' . $phrase['_no_rfps_available'] . ' ---</option>';
                                                }
                                                $invite_pulldown .= '</select>';
                                                
                                                $ilance->template->load_file('main', 'rfp_invitetobid.html');
                                                $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                                                $ilance->template->parse_if_blocks('main');
                                                $ilance->template->pprint('main', array('hidden_invitations','invite_pulldown','provider','project_user_id','cid','currency_id','project_id','portfolio_id','bid_id','filehash','category_id','user_id','attachtype','max_filesize','category','current_proposal','current_bidamount','current_estimate_days','delivery_pulldown','currency','input_style','title','description','bid_controls','buyer_incomespent','buyer_stars','project_title','description','project_type','project_details','project_distance','project_id','bid_details','pmb','project_buyer','projects_posted','projects_awarded','project_currency','project_attachment','distance','subcategory_name','text','prevnext','prevnext2','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                                                exit();                                                
					}
					else
					{
						refresh($ilpage['watchlist']);
						exit();
					}
				}
			}
			else if (isset($ilance->GPC['state']) AND $ilance->GPC['state'] == 'mprovider' AND isset($ilance->GPC['action']) AND ($ilance->GPC['action'] == 'delete' OR $ilance->GPC['action'] == 'invite'))
			{
				if ($ilance->GPC['action'] == 'watchlist')
				{
					if (isset($ilance->GPC['vendor_id']))
					{
						$watchtype = $ilance->GPC['state'];
						$comment = "";
						foreach ($ilance->GPC['vendor_id'] as $value)
						{
							$ilance->watchlist->insert_item($_SESSION['ilancedata']['user']['userid'], intval($value), $watchtype, $comment);
						}
						refresh($ilpage['watchlist']);
						exit();
					}
					else
					{
						refresh($ilpage['watchlist']);
						exit();
					}
				}
				else if ($ilance->GPC['action'] == 'delete')
				{
					if (isset($ilance->GPC['vendor_id']))
					{
						foreach ($ilance->GPC['vendor_id'] as $value)
						{
							$ilance->db->query("
                                                                DELETE FROM " . DB_PREFIX . "watchlist
                                                        	WHERE watching_user_id = '".intval($value)."'
                                                                	AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                	AND state = '".$ilance->GPC['state']."'
                                                        ");
						}
                                                
						refresh($ilpage['watchlist']);
						exit();
					}
					else
					{
						refresh($ilpage['watchlist']);
						exit();
					}
				}
				else if ($ilance->GPC['action'] == 'invite')
				{
					if (isset($ilance->GPC['vendor_id']))
					{
                                                if ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'inviteprovider') == 'no')
						{
                                                        $area_title = $phrase['_provider_invitation_denied_upgrade_subscription'];
                                                        $page_title = SITE_NAME . ' - ' . $phrase['_provider_invitation_denied_upgrade_subscription'];
                                                        
                                                        print_notice($phrase['_access_denied'], $phrase['_your_current_subscription_level_does_not_permit_you_to_use_this_marketplace_resource'] . ' <a href="' . $ilpage['subscription'] . '"><strong>' . $phrase['_click_here'] . '</strong></a>', $ilpage['subscription'], ucwords($phrase['_click_here']), fetch_permission_name('inviteprovider'));
                                                        exit();
                                                }
							
                                                $area_title = $phrase['_inviting_a_provider_to_a_new_or_existing_rfp'];
                                                $page_title = SITE_NAME . ' - ' . $phrase['_inviting_a_provider_to_a_new_or_existing_rfp'];

                                                $hidden_invitations = $provider = '';
                                                $count = count($ilance->GPC['vendor_id']);
                                                if ($count > 1)
                                                {
                                                        for ($i=0; $i<$count; $i++)
                                                        {
                                                                $sql_vendor = $ilance->db->query("
                                                                        SELECT *
                                                                        FROM " . DB_PREFIX . "users
                                                                        WHERE user_id = '".intval($ilance->GPC['vendor_id'][$i])."'
                                                                                AND status = 'active'
                                                                ");
                                                                if ($ilance->db->num_rows($sql_vendor) > 0)
                                                                {
                                                                        $res_vendor = $ilance->db->fetch_array($sql_vendor);
                                                                        $invitationid = $res_vendor['user_id'];
                                                                        $provider .= print_username($invitationid, 'href'). ' ';
                                                                        $hidden_invitations .= '<input type="hidden" name="invitationid[]" value="'.$invitationid.'" />';
                                                                }
                                                        }
                                                }
                                                else
                                                {
                                                        $sql_vendor = $ilance->db->query("
                                                                SELECT *
                                                                FROM " . DB_PREFIX . "users
                                                                WHERE user_id = '" . intval($ilance->GPC['vendor_id'][0]) . "'
                                                                        AND status = 'active'
                                                        ");
                                                        if ($ilance->db->num_rows($sql_vendor) > 0)
                                                        {
                                                                $res_vendor = $ilance->db->fetch_array($sql_vendor);
                                                                $invitationid = $res_vendor['user_id'];
                                                                $provider .= print_username($invitationid, 'href') . ' ';
                                                                $hidden_invitations .= '<input type="hidden" name="invitationid" value="'.$invitationid.'">';
                                                        }
                                                }
                                                
                                                $sql_projects = $ilance->db->query("
                                                        SELECT *
                                                        FROM " . DB_PREFIX . "projects
                                                        WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "' 
                                                                AND status = 'open'
                                                                AND project_state = 'product'
                                                ");
                                                
                                                $invite_pulldown = '<select name="project_id">';
                                                $invite_pulldown .= '<option value="">'.$phrase['_select_rfp'].':</option>';
                                                
                                                if ($ilance->db->num_rows($sql_projects) > 0)
                                                {
                                                        while ($res = $ilance->db->fetch_array($sql_projects))
                                                        {
                                                                $invite_pulldown .= '<option value="'.$res['project_id'].'">' . $phrase['_item'] . ' ('.$res['project_id'].'): '.short_string(stripslashes($res['project_title']),35).' ('.$phrase['_bids'].': '.$res['bids'].') ('.$phrase['_ends'].': '.print_date($res['date_end'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0).')</option>';
                                                        }
                                                }
                                                else
                                                {
                                                        $invite_pulldown .= '<option value="">--- '.$phrase['_no_rfps_available'].' ---</option>';
                                                }
                                                
                                                $invite_pulldown .= '</select>';

                                                $ilance->template->load_file('main', 'rfp_invitetobid.html');
                                                $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                                                $ilance->template->parse_if_blocks('main');
                                                $ilance->template->pprint('main', array('hidden_invitations','invite_pulldown','provider','project_user_id','cid','currency_id','project_id','portfolio_id','bid_id','filehash','category_id','user_id','attachtype','max_filesize','category','current_proposal','current_bidamount','current_estimate_days','delivery_pulldown','currency','input_style','title','description','bid_controls','buyer_incomespent','buyer_stars','project_title','description','project_type','project_details','project_distance','project_id','bid_details','pmb','project_buyer','projects_posted','projects_awarded','project_currency','project_attachment','distance','subcategory_name','text','prevnext','prevnext2','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                                                exit();
					}
					else
					{
						refresh($ilpage['watchlist']);
						exit();
					}
				}
			}
			else if (isset($ilance->GPC['state']) AND $ilance->GPC['state'] == 'sprovider' AND isset($ilance->GPC['action']) AND ($ilance->GPC['action'] == 'delete' OR $ilance->GPC['action'] == 'invite' OR $ilance->GPC['action'] == 'watchlist'))
			{
				if ($ilance->GPC['action'] == 'watchlist')
				{
					if (isset($ilance->GPC['vendor_id']))
					{
						$watchtype = $ilance->GPC['state'];
						$comment = "";
						foreach($ilance->GPC['vendor_id'] as $value)
						{
							$ilance->watchlist->insert_item($_SESSION['ilancedata']['user']['userid'], intval($value), $watchtype, $comment);
						}
						refresh($ilpage['watchlist']);
						exit();
					}
					else
					{
						refresh($ilpage['watchlist']);
						exit();
					}
				}
				else if ($ilance->GPC['action'] == 'delete')
				{
					if (isset($ilance->GPC['vendor_id']))
					{
						foreach ($ilance->GPC['vendor_id'] as $value)
						{
							$ilance->db->query("
                                                                DELETE FROM " . DB_PREFIX . "watchlist
                                                                WHERE watching_user_id = '".intval($value)."'
                                                                        AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                        AND state = '".$ilance->GPC['state']."'
                                                        ");
						}
                                                
						refresh($ilpage['watchlist']);
						exit();
					}
					else
					{
						refresh($ilpage['watchlist']);
						exit();
					}
				}
				else if ($ilance->GPC['action'] == 'invite')
				{
					if (isset($ilance->GPC['vendor_id']))
					{
                                                if ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'inviteprovider') == 'no')
						{
                                                        $area_title = $phrase['_provider_invitation_denied_upgrade_subscription'];
                                                        $page_title = SITE_NAME . ' - ' . $phrase['_provider_invitation_denied_upgrade_subscription'];
                                                        
                                                        print_notice($phrase['_access_denied'], $phrase['_your_current_subscription_level_does_not_permit_you_to_use_this_marketplace_resource'] . ' <a href="' . $ilpage['subscription'] . '"><strong>' . $phrase['_click_here'] . '</strong></a>', $ilpage['subscription'], ucwords($phrase['_click_here']), fetch_permission_name('inviteprovider'));
                                                        exit();
                                                }
                                                
                                                $area_title = $phrase['_inviting_a_provider_to_a_new_or_existing_rfp'];
                                                $page_title = SITE_NAME . ' - ' . $phrase['_inviting_a_provider_to_a_new_or_existing_rfp'];

                                                $hidden_invitations = "";
                                                $count = count($ilance->GPC['vendor_id']);
                                                $provider = '';
                                                if ($count > 1)
                                                {
                                                        for ($i=0; $i<$count; $i++)
                                                        {
                                                                $sql_vendor = $ilance->db->query("
                                                                        SELECT *
                                                                        FROM " . DB_PREFIX . "users
                                                                        WHERE user_id = '".intval($ilance->GPC['vendor_id'][$i])."'
                                                                                AND status = 'active'
                                                                ");
                                                                if ($ilance->db->num_rows($sql_vendor) > 0)
                                                                {
                                                                        $res_vendor = $ilance->db->fetch_array($sql_vendor);
                                                                        $invitationid = $res_vendor['user_id'];
                                                                        $provider .= print_username($invitationid, 'href').' ';
                                                                        $hidden_invitations .= '<input type="hidden" name="invitationid[]" value="' . $invitationid . '" />';
                                                                }
                                                        }
                                                }
                                                else
                                                {
                                                        $sql_vendor = $ilance->db->query("
                                                                SELECT *
                                                                FROM " . DB_PREFIX . "users
                                                                WHERE user_id = '" . intval($ilance->GPC['vendor_id'][0]) . "'
                                                                        AND status = 'active'
                                                        ");
                                                        if ($ilance->db->num_rows($sql_vendor) > 0)
                                                        {
                                                                $res_vendor = $ilance->db->fetch_array($sql_vendor);
                                                                $invitationid = $res_vendor['user_id'];
                                                                $provider .= print_username($invitationid, 'href'). ' ';
                                                                $hidden_invitations .= '<input type="hidden" name="invitationid[]" value="' . $invitationid . '" />';
                                                        }
                                                }
                                                
                                                $sql_projects = $ilance->db->query("
                                                        SELECT *
                                                        FROM " . DB_PREFIX . "projects
                                                        WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                AND status = 'open'
                                                                AND project_state = 'service'
                                                ");
                                                
                                                $invite_pulldown = '<select name="project_id" style="font-family: verdana">';
                                                $invite_pulldown .= '<option value="">' . $phrase['_select_rfp'] . ':</option>';
                                                
                                                if ($ilance->db->num_rows($sql_projects) > 0)
                                                {
                                                        while ($res = $ilance->db->fetch_array($sql_projects))
                                                        {
                                                                $invite_pulldown .= '<option value="'.$res['project_id'].'">RFP ('.$res['project_id'].'): '.short_string(stripslashes($res['project_title']),35).' ('.$phrase['_bids'].': '.$res['bids'].') ('.$phrase['_ends'].': '.print_date($res['date_end'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0).')</option>';
                                                        }
                                                }
                                                else
                                                {
                                                        $invite_pulldown .= '<option value="">--- ' . $phrase['_no_rfps_available'] . ' ---</option>';
                                                }
                                                
                                                $invite_pulldown .= '</select>';
                                                
                                                $ilance->template->load_file('main', 'rfp_invitetobid.html');
                                                $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                                                $ilance->template->parse_if_blocks('main');
                                                $ilance->template->pprint('main', array('hidden_invitations','invite_pulldown','provider','project_user_id','cid','currency_id','project_id','portfolio_id','bid_id','filehash','category_id','user_id','attachtype','max_filesize','category','current_proposal','current_bidamount','current_estimate_days','delivery_pulldown','currency','input_style','title','description','bid_controls','buyer_incomespent','buyer_stars','project_title','description','project_type','project_details','project_distance','project_id','bid_details','pmb','project_buyer','projects_posted','projects_awarded','project_currency','project_attachment','distance','subcategory_name','text','prevnext','prevnext2','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                                                exit();
					}
					else
					{
						refresh($ilpage['watchlist']);
						exit();
					}
				}
			}
		}
		else
		{
			$area_title = $phrase['_watchlist_menu'];
			$page_title = SITE_NAME . ' - ' . $phrase['_watchlist_menu'];
			
			$navcrumb = array();
			$navcrumb["$ilpage[main]?cmd=cp"] = $phrase['_my_cp'];
			$navcrumb[""] = $phrase['_watchlist_menu'];
			
                        // inline auction ajax controls
                        $headinclude .= "
<script type=\"text/javascript\">
<!--
var watchlistid = 0;
var type = '';
var value = '';
var imgtag = '';
var watchlisticon = '';
var status = '';
function reset_image()
{
        imgtag.src = watchlisticon;
}
function reset_image2()
{
        imgtag.src = watchlisticon2;
}
function fetch_response(type)
{
        if (xmldata.handler.readyState == 4 && xmldata.handler.status == 200 && xmldata.handler.responseXML)
        {
                // format response
                response = fetch_tags(xmldata.handler.responseXML, 'status')[0];
                phpstatus = xmldata.fetch_data(response);
                
                watchiconsrc = fetch_js_object('inline_watchlist_' + xmldata.type + '_' + xmldata.watchlistid).src;
                status = watchiconsrc.match(/\/unchecked.gif/gi);
                if (status == '/unchecked.gif')
                {
                       status = 'unchecked';
                }
                else
                {
                       status = 'checked';
                }
                if (status == 'unchecked')
                {
                        if (phpstatus == 'on' || phpstatus == 'off')
                        {
                                // updating from enabled to disabled
                                watchlisticonsrc = fetch_js_object('inline_watchlist_' + xmldata.type + '_' + xmldata.watchlistid).src;
                                imgtag = fetch_js_object('inline_watchlist_' + xmldata.type + '_' + xmldata.watchlistid);
                                
                                watchlisticon2 = watchlisticonsrc.replace(/unchecked.gif/gi, 'working.gif');
                                imgtag.src = watchlisticon2;
                                
                                watchlisticon = watchlisticonsrc.replace(/unchecked.gif/gi, 'checked.gif');
                                var t = window.setTimeout('reset_image()', 700);
                                
                                if (xmldata.type != 'subscribed')
                                {
                                        watchlisticonsrc2 = fetch_js_object('inline_watchlist_subscribed_' + xmldata.watchlistid).src;
                                        imgtag2 = fetch_js_object('inline_watchlist_subscribed_' + xmldata.watchlistid);
                                        
                                        substatus = watchlisticonsrc2.match(/\/unchecked.gif/gi);
                                        if (substatus == '/unchecked.gif')
                                        {
                                                imgtag2.src = watchlisticonsrc2.replace(/unchecked.gif/gi, 'checked.gif');
                                        }
                                }
                                
                        }
                        else
                        {
                                alert(phpstatus);
                        }

                }
                else if (status == 'checked')
                {
                        if (phpstatus == 'on' || phpstatus == 'off')
                        {
                                // updating from disabled to enabled
                                watchlisticonsrc = fetch_js_object('inline_watchlist_' + xmldata.type + '_' + xmldata.watchlistid).src;
                                imgtag = fetch_js_object('inline_watchlist_' + xmldata.type + '_' + xmldata.watchlistid);
                                
                                watchlisticon2 = watchlisticonsrc.replace(/checked.gif/gi, 'working.gif');
                                imgtag.src = watchlisticon2;
        
                                watchlisticon = watchlisticonsrc.replace(/checked.gif/gi, 'unchecked.gif');
                                var t = window.setTimeout('reset_image()', 700);
                        }
                        else
                        {
                                alert(phpstatus);
                        }

                }
                xmldata.handler.abort();
        }
}
function update_watchlist(type, watchlistid)
{                        
        // set ajax handler
        xmldata = new AJAX_Handler(true);
        
        // url encode the vars
        watchlistid = urlencode(watchlistid);
        xmldata.watchlistid = watchlistid;
        type = urlencode(type);
        xmldata.type = type;
        
        watchiconsrc = fetch_js_object('inline_watchlist_' + type + '_' + watchlistid).src;
        status = watchiconsrc.match(/\/unchecked.gif/gi);
        if (status == '/unchecked.gif')
        {
               value = 'on';
        }
        else
        {
               value = 'off';
        }
        xmldata.onreadystatechange(fetch_response);

        // send data to php
        xmldata.send('ajax.php', 'do=watchlist&type=' + type + '&value=' + value + '&watchlistid=' + watchlistid);                        
}
//-->
</script>";
                        
			// service providers
			$sql_users = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "watchlist
                                WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                        AND watching_user_id != '0'
                                        AND state = 'sprovider'
                                ORDER BY watchlistid DESC
                        ");
			if ($ilance->db->num_rows($sql_users) > 0)
			{
                                require_once(DIR_CORE . 'functions_search.php');
                                
                                $show['no_watchlist_sproviders'] = false;
                                $row_count = 0;
				while ($row = $ilance->db->fetch_array($sql_users))
				{
					$row['watchlistid'] = $row['watchlistid'];
                                        
					$sql_providers = $ilance->db->query("
                                                SELECT *
                                                FROM " . DB_PREFIX . "users
                                                WHERE user_id = '" . $row['watching_user_id'] . "'
                                        ");
					if ($ilance->db->num_rows($sql_providers) > 0)
					{						
						while ($row2 = $ilance->db->fetch_array($sql_providers))
						{
							$row2['watchlistid'] = $row['watchlistid'];
							$row2['provider'] = print_username($row['watching_user_id'], 'href', 0);
                                                        $row2['provider_plain'] = fetch_user('username', $row['watching_user_id']);
							$row2['id'] = $row2['user_id'];
							$row2['feedback'] = print_username($row['watching_user_id'], 'custom', 0, '', '', fetch_service_reviews_reported($row['watching_user_id']).' '.$phrase['_reviews']);
							$row2['earnings'] = print_income_reported($row['watching_user_id'], $doupdate = 0);
							$row2['online'] = print_online_status($row['watching_user_id']);
                                                        
                                                        $memberinfo = array();
                                                        $memberinfo = $ilance->feedback->datastore($row['watching_user_id']);
							$row2['rating'] = $memberinfo['rating'] . ' / 5.00';
                                                        $row2['score'] = $memberinfo['pcnt'];                                                        
                                                        unset($memberinfo);
                                                        
                                                        $row2['hourlyrate'] = $ilance->currency->format(fetch_user('rateperhour', $row['watching_user_id']));
                                                        $row2['skills'] = print_skills($row['watching_user_id'], $showmaxskills = 500, $nourls = true);
							$row2['comment'] = stripslashes($row['comment']);
							$row2['action'] = '<input type="checkbox" name="vendor_id[]" value="' . $row['watching_user_id'] . '" />';
							$row2['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
							$watchlist_sproviders[] = $row2;
						}
					}
                                        $row_count++;
				}
			}
			else
			{
				$show['no_watchlist_sproviders'] = true;
			}
			
			// merchants / sellers
                        $show['no_watchlist_mproviders'] = false;
                        
			$sql_users = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "watchlist
                                WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                        AND watching_user_id != '0'
                                        AND state = 'mprovider'
                                ORDER BY watchlistid DESC
                        ");
			if ($ilance->db->num_rows($sql_users) > 0)
			{
				while ($row = $ilance->db->fetch_array($sql_users))
				{
					$sql_providers = $ilance->db->query("
                                                SELECT *
                                                FROM " . DB_PREFIX . "users
                                                WHERE user_id = '" . $row['watching_user_id'] . "'
                                        ");
					if ($ilance->db->num_rows($sql_providers) > 0)
					{
						$row_count = 0;
						while ($row2 = $ilance->db->fetch_array($sql_providers))
						{
							$row2['watchlistid'] = $row['watchlistid'];
							$row2['provider'] = print_username($row['watching_user_id'], 'href', 0);
                                                        $row2['provider_plain'] = fetch_user('username', $row['watching_user_id']);
							$row2['id'] = $row2['user_id'];
							$row2['feedback'] = print_username($row['watching_user_id'], 'custom', 0, '', '', fetch_service_reviews_reported($row['watching_user_id']).' '.$phrase['_reviews']);
							$row2['earnings'] = print_income_reported($row['watching_user_id'], $doupdate=0);
							$row2['online'] = print_online_status($row['watching_user_id']);
                                                        $memberinfo = array();
                                                        $memberinfo = $ilance->feedback->datastore($row['watching_user_id']);
							$row2['rating'] = $memberinfo['rating'] . ' / 5.00';
                                                        $row2['score'] = $memberinfo['pcnt'];                                                        
                                                        unset($memberinfo);
                                                        
							$row2['comment'] = stripslashes($row['comment']);
							$row2['action'] = '<input type="checkbox" name="vendor_id[]" value="' . $row['watching_user_id'] . '" />';
                                                        $row2['flashgallery'] = print_flash_gallery('favoriteseller', $row['watching_user_id']);
							$row2['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
							$watchlist_mproviders[] = $row2;
							$row_count++;
						}
					}
					else
					{
						$show['no_watchlist_mproviders'] = true;
					}
				}
			}
			else
			{
				$show['no_watchlist_mproviders'] = true;
			}
			
			// #### AUCTIONS #######################################
			$sqlauctions = $ilance->db->query("
				SELECT *
				FROM " . DB_PREFIX . "watchlist
				WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
					AND watching_project_id != '0'
                                ORDER BY watchlistid DESC
			");
			if ($ilance->db->num_rows($sqlauctions) > 0)
			{
				$show['no_watchlist_rfp'] = false;
				
				$row_count = 0;
				while ($row = $ilance->db->fetch_array($sqlauctions))
				{
					$result = $ilance->db->query("
						SELECT *, UNIX_TIMESTAMP(date_end)-UNIX_TIMESTAMP('" . DATETIME24H . "') AS mytime, UNIX_TIMESTAMP(date_starts) - UNIX_TIMESTAMP('" . DATETIME24H . "') AS starttime
						FROM " . DB_PREFIX . "projects
						WHERE project_id = '" . $row['watching_project_id'] . "'
						ORDER BY date_end ASC
					");
					if ($ilance->db->num_rows($result) > 0)
					{
						$rows = $ilance->db->fetch_array($result);
                                                if ($rows['bids'] == 0)
                                                {
                                                        $row['bids'] = '-';
                                                }
                                                else
                                                {
                                                        $row['bids'] = $rows['bids'];
                                                }
                                                
						$row['action'] = '<input type="checkbox" name="project_id[]" value="' . $row['watching_project_id'] . '" />';
						$row['comment'] = stripslashes($row['comment']);
						
						$sql_attach = $ilance->db->query("
							SELECT filename
							FROM " . DB_PREFIX . "attachment
							WHERE project_id = '" . $rows['project_id'] . "'
								AND user_id = '" . $rows['user_id'] . "'
								AND visible = '1'
						");
						if ($ilance->db->num_rows($sql_attach) > 0)
						{
							$res_attach = $ilance->db->fetch_array($sql_attach);
							$row['attach'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'paperclip.gif" alt="'.$phrase['_attachment'].': '.stripslashes($res_attach['filename']).'" />';
						}
						else
						{
							$row['attach'] = '';
						}
						
                                                if ($rows['project_state'] == 'service')
						{
							$row['auctionpage'] = $ilpage['rfp'];
                                                        $row['sample'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'spacer.gif" alt="" />';
                                                        $row['title'] = ($ilconfig['globalauctionsettings_seourls']) ? construct_seo_url('serviceauction', 0, $row['watching_project_id'], stripslashes($rows['project_title']), $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0) : '<a href="' . $row['auctionpage'] . '?id=' . $row['watching_project_id'] . '">' . stripslashes($rows['project_title']) . '</a>';
						}
						else if ($rows['project_state'] == 'product')
						{
                                                        $row['attach'] = '';
							$row['auctionpage'] = $ilpage['merch'];
                                                        
                                                        // display thumbnail
                                                        if ($ilconfig['globalauctionsettings_seourls'])
                                                        {
                                                                $url = construct_seo_url('productauctionplain', 0, $rows['project_id'], stripslashes($rows['project_title']), '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0);
                                                                
                                                                $row['sample'] = print_item_photo($url, 'thumb', $rows['project_id']);
                                                                $row['title'] = construct_seo_url('productauction', 0, $row['watching_project_id'], stripslashes($rows['project_title']), $customlink = '', $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0);
                                                        }
                                                        else
                                                        {
                                                                $row['sample'] = print_item_photo($ilpage['merch'] . '?id=' . $rows['project_id'], 'thumb', $rows['project_id']);
                                                                $row['title'] = '<a href="' . $row['auctionpage'] . '?id=' . $row['watching_project_id'] . '">' . stripslashes($rows['project_title']) . '</a>';
                                                        }
						}

						$row['description'] = short_string(stripslashes($rows['description']), 100);
						$row['status'] = print_auction_status($rows['status']);
						
						// is bid placed?
						$sql_bidplaced = $ilance->db->query("
							SELECT *
							FROM " . DB_PREFIX . "project_bids
							WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "' 
								AND project_id = '" . $rows['project_id'] . "'
						");
                                                $row['bidplaced'] = ($ilance->db->num_rows($sql_bidplaced) > 0) ? '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid.gif" border="0" alt="' . $phrase['_you_have_placed_a_bid_on_this_auction'] . '" />' : '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid_gray.gif" border="0" alt="' . $phrase['_place_a_bid'] . '" />';
						
						// is realtime auction?
                                                $row['realtime'] = ($rows['project_details'] == 'realtime') ? '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'realtime.gif" alt="'.$phrase['_realtime_auction'].'" border="0" alt="" />' : '';
						
						// auction owner info
						$sql_user_results = $ilance->db->query("
							SELECT *
							FROM " . DB_PREFIX . "users
							WHERE user_id = '" . $row['user_id'] . "'
						");
						$res_project_user = $ilance->db->fetch_array($sql_user_results);
						
						$row['city'] = ucfirst($res_project_user['city']);
						$row['zip'] = trim(mb_strtoupper($res_project_user['zip_code']));
						
						// category
						$ilance->categories->build_array($rows['project_state'], $_SESSION['ilancedata']['user']['slng'], $mode = 0, $propersort = true);
						$row['category'] = stripslashes($ilance->categories->title($_SESSION['ilancedata']['user']['slng'], $rows['project_state'], $rows['cid']));
                                                
                                                // time left
						if ($rows['date_starts'] > DATETIME24H)
						{
							$dif = $row['starttime'];
							$ndays = floor($dif / 86400);
							$dif -= $ndays * 86400;
							$nhours = floor($dif / 3600);
							$dif -= $nhours * 3600;
							$nminutes = floor($dif / 60);
							$dif -= $nminutes * 60;
							$nseconds = $dif;
							$sign = '+';
							if ($rows['starttime'] < 0)
							{
								$row['starttime'] = - $row['starttime'];
								$sign = '-';
							}
							if ($sign != '-')
							{
								if ($ndays != '0')
								{
									$project_time_left = $ndays . $phrase['_d_shortform'] . ', ';	
									$project_time_left .= $nhours . $phrase['_h_shortform'] . '+';
								}
								else if ($nhours != '0')
								{
									$project_time_left = $nhours . $phrase['_h_shortform'] . ', ';
									$project_time_left .= $nminutes . $phrase['_m_shortform'] . '+';
								}
								else
								{
									$project_time_left = $nminutes . $phrase['_m_shortform'] . ', ';
									$project_time_left .= $nseconds . $phrase['_s_shortform'] . '+';	
								}
							}
							$row['timetostart'] = $project_time_left;
							$row['timeleft'] = $phrase['_starts'].': '.$row['timetostart'];
						}
						else
						{
							$dif = $rows['mytime'];
							$ndays = floor($dif / 86400);
							$dif -= $ndays * 86400;
							$nhours = floor($dif / 3600);
							$dif -= $nhours * 3600;
							$nminutes = floor($dif / 60);
							$dif -= $nminutes * 60;
							$nseconds = $dif;
							$sign = '+';
							if ($rows['mytime'] < 0)
							{
								$row['mytime'] = - $rows['mytime'];
								$sign = '-';
							}
							
							if ($sign == '-')
							{
								$project_time_left = $phrase['_ended'];
							}
							else
							{
								if ($ndays != '0')
								{
									$project_time_left = $ndays . $phrase['_d_shortform'] . ', ';	
									$project_time_left .= $nhours . $phrase['_h_shortform'] . '+';
								}
								else if ($nhours != '0')
								{
									$project_time_left = $nhours . $phrase['_h_shortform'] . ', ';
									$project_time_left .= $nminutes . $phrase['_m_shortform'] . '+';
								}
								else
								{
									$project_time_left = $nminutes . $phrase['_m_shortform'] . ', ';
									$project_time_left .= $nseconds . $phrase['_s_shortform'] . '+';	
								}
							}
                                                        
							$row['timeleft'] = $project_time_left;
						}
                                                
						// watchlist auction notification subscriptions
                                                if ($rows['project_state'] == 'service')
                                                {
                                                        $row['ajax_lowbidnotify'] = ($row['lowbidnotify']) ? '<tr><td width="1%" align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'checked.gif" alt="' . $phrase['_click_to_enable_disable'] . '" border="0" id="inline_watchlist_lowbid_'.$row['watchlistid'].'" onclick="update_watchlist(\'lowbid\', '.$row['watchlistid'].');" style="cursor:hand" onmouseover="this.style.cursor=\'pointer\'" /></td><td width="99%">&nbsp;{_notify_me_via_email_when_a_lower_bid_is_placed}</td></tr>' : '<tr><td width="1%" align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'unchecked.gif" alt="' . $phrase['_click_to_enable_disable'] . '" border="0" id="inline_watchlist_lowbid_'.$row['watchlistid'].'" onclick="update_watchlist(\'lowbid\', '.$row['watchlistid'].');" style="cursor:hand" onmouseover="this.style.cursor=\'pointer\'" /></td><td width="99%">&nbsp;{_notify_me_via_email_when_a_lower_bid_is_placed}</td></tr>';
						}
						else
						{
                                                        $row['ajax_lowbidnotify'] = '';
						}
						
                                                if ($rows['project_state'] == 'product')
                                                {
                                                        $row['ajax_highbidnotify'] = ($row['highbidnotify']) ? '<tr><td width="1%" align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'checked.gif" alt="' . $phrase['_click_to_enable_disable'] . '" border="0" id="inline_watchlist_highbid_'.$row['watchlistid'].'" onclick="update_watchlist(\'highbid\', '.$row['watchlistid'].');" style="cursor:hand" onmouseover="this.style.cursor=\'pointer\'" /></td><td width="99%">&nbsp;{_notify_me_via_email_when_a_higher_bid_is_placed}</td></tr>' : '<tr><td width="1%" align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'unchecked.gif" alt="' . $phrase['_click_to_enable_disable'] . '" border="0" id="inline_watchlist_highbid_'.$row['watchlistid'].'" onclick="update_watchlist(\'highbid\', '.$row['watchlistid'].');" style="cursor:hand" onmouseover="this.style.cursor=\'pointer\'" /></td><td width="99%">&nbsp;{_notify_me_via_email_when_a_higher_bid_is_placed}</td></tr>';
						}
						else
						{
                                                        $row['ajax_highbidnotify'] = '';
						}
						
                                                $row['ajax_lasthournotify'] = ($row['hourleftnotify']) ? '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'checked.gif" alt="' . $phrase['_click_to_enable_disable'] . '" border="0" id="inline_watchlist_lasthour_'.$row['watchlistid'].'" onclick="update_watchlist(\'lasthour\', '.$row['watchlistid'].');" style="cursor:hand" onmouseover="this.style.cursor=\'pointer\'" />' : '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'unchecked.gif" alt="' . $phrase['_click_to_enable_disable'] . '" border="0" id="inline_watchlist_lasthour_'.$row['watchlistid'].'" onclick="update_watchlist(\'lasthour\', '.$row['watchlistid'].');" style="cursor:hand" onmouseover="this.style.cursor=\'pointer\'" />';
						$row['ajax_subscribed'] = ($row['subscribed']) ? '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'checked.gif" alt="' . $phrase['_click_to_enable_disable'] . '" border="0" id="inline_watchlist_subscribed_'.$row['watchlistid'].'" onclick="update_watchlist(\'subscribed\', '.$row['watchlistid'].');" style="cursor:hand" onmouseover="this.style.cursor=\'pointer\'" />' : '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'unchecked.gif" alt="' . $phrase['_click_to_enable_disable'] . '" border="0" id="inline_watchlist_subscribed_'.$row['watchlistid'].'" onclick="update_watchlist(\'subscribed\', '.$row['watchlistid'].');" style="cursor:hand" onmouseover="this.style.cursor=\'pointer\'" />';
                                                
                                                ($apihook = $ilance->api('show_watchlist_options')) ? eval($apihook) : false;
                                                
						$row['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
						$watchlist_rfp[] = $row;
						$row_count++;
					}
				}
			}
			else
			{
				$show['no_watchlist_rfp'] = true;
			}
			
			$tab = '0';
                        if (isset($ilance->GPC['tab']))
                        {
                                $tab = intval($ilance->GPC['tab']);
                        }
                        
			$ilance->template->load_file('main', 'watchlist.html', 0, 1);
			$ilance->template->parse_hash('main', array('ilpage' => $ilpage));
			$ilance->template->parse_loop('main', 'watchlist_sproviders');
			$ilance->template->parse_loop('main', 'watchlist_mproviders');
			$ilance->template->parse_loop('main', 'watchlist_buyers');
			$ilance->template->parse_loop('main', 'watchlist_rfp');
			$ilance->template->parse_if_blocks('main');
			$ilance->template->pprint('main', array('tab','input_style','remote_addr','rid','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
			exit();
		}
	}
	else
	{
		$area_title = $phrase['_access_denied_to_watchlist_resource'];
		$page_title = SITE_NAME . ' - ' . $phrase['_access_denied_to_watchlist_resource'];
		
		// construct breadcrumb trail
		$navcrumb = array();
		$navcrumb["$ilpage[main]?cmd=cp"] = $phrase['_my_cp'];
		$navcrumb["$ilpage[watchlist]"] = $phrase['_watchlist'];
		$navcrumb[""] = $phrase['_access_denied_to_watchlist_resource'];
		
		print_notice($phrase['_access_denied'], $phrase['_your_current_subscription_level_does_not_permit_you_to_use_this_marketplace_resource'] . " <span class=\"blue\"><a href='" . $ilpage['subscription'] . "'><strong>" . $phrase['_click_here'] . "</strong></a></span>.<div style=\"padding-top:9px\" class=\"gray\">" . $phrase['_additionally_you_may_be_seeing_this_message_due_to_an_unpaid'] . "</div>", $ilpage['subscription'], ucwords($phrase['_subscription_manager']), fetch_permission_name('addtowatchlist'));
		exit();
	}
}
else
{
	refresh($ilpage['login'] . '?redirect=' . urlencode($ilpage['watchlist'] . print_hidden_fields($string = true, $excluded = array(), $questionmarkfirst = true)));
	exit();
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: watchlist.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>