<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/
define('LOCATION', 'upload');

include('./functions.inc.php');

$ilance->subscription = construct_object('api.subscription');

$navcrumb = array("$ilpage[upload]" => $ilcrumbs["$ilpage[upload]"]);

if (!empty($ilance->GPC['crypted']))
{
        $cryptedws = decrypt_url($ilance->GPC['crypted']);
}
else
{
        $cryptedws = array();
}

$ilmedia['project_state'] = fetch_auction('project_state', $cryptedws['project_id']);

if (!empty($_FILES['ufile']['size']) AND $_FILES['ufile']['size'] > $ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'uploadlimit'))
{
	$crypted = array(
                'project_id' => intval($cryptedws['project_id']),
                'buyer_id' => intval($cryptedws['buyer_id']),
                'seller_id' => intval($cryptedws['seller_id']),
                'fold_id' => intval($cryptedws['fold_id']),
                'error_code' => '3'
        );
        
	header("Location: " . $ilpage['mediashare'] . "?crypted=" . encrypt_url($crypted));
	exit();
}

// check if the total attachment limit for this subscription group has exceeded for this users upload
$sqlsum = $ilance->db->query("
        SELECT SUM(filesize) AS attach_usage_total
        FROM " . DB_PREFIX . "attachment 
        WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
");
if ($ilance->db->num_rows($sqlsum) > 0)
{
        $res_file_sum = $ilance->db->fetch_array($sqlsum);
        $futuresize = ($res_file_sum['attach_usage_total'] + $_FILES['ufile']['size']);
}
else
{
        $futuresize = $_FILES['ufile']['size'];
}

$totalpercentage = round(($futuresize / $ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'attachlimit')) * 100);

if ($totalpercentage > 100)
{
        // we've gone over our subscription plan limit do not let the upload continue
	$crypted = array(
                'project_id' => intval($cryptedws['project_id']),
                'buyer_id' => intval($cryptedws['buyer_id']),
                'seller_id' => intval($cryptedws['seller_id']),
                'fold_id' => intval($cryptedws['fold_id']),
                'error_code' => '3'
        );
        
	header("Location: " . $ilpage['mediashare'] . "?crypted=" . encrypt_url($crypted));
	exit();
}
else 
{
        // file upload size and attachment total storage is good
	$filehash = md5(uniqid(microtime()));
	$filetype = $_FILES['ufile']['type'];
	$upload_dir = DIR_WS_ATTACHMENTS;
        
        $newfilename = $upload_dir . $filehash . '.attach';
        
        // these two native php functions may cause issues with servers that have
        // safe_mode enabled.  for best results disable safe_mode.
	if (@is_uploaded_file($_FILES['ufile']['tmp_name'])) 
	{
		if (@move_uploaded_file($_FILES['ufile']['tmp_name'], $newfilename))
		{
			$upload_file_size = @filesize($newfilename);
                        
                        $filedata = '';
			if ($ilconfig['attachment_dbstorage'])
			{
                                // we are storing media in the database let's remove the uploaded file
                                // and store the guts of the file in $filedata
				$filedata = addslashes(fread(fopen($newfilename, 'rb'), filesize($newfilename)));
				@unlink($newfilename);
			}
			
			if ($ilconfig['attachment_mediasharemoderationdisabled'] == 0)
			{
				######################################
				### ILANCE => EMAIL TEMPLATE ENGINE V1.0
				#######################################
				## GRAB EMAIL: ID=193, NAME=Email Mediashare File Pickup Alert (Moderation) - Sender
				$query1="SELECT ";
				$query1.="subject_".$_SESSION['ilancedata']['user']['slng'].", ";
				$query1.="message_".$_SESSION['ilancedata']['user']['slng']." ";
				$query1.="FROM ";
				$query1.=DB_PREFIX."email ";
				$query1.="WHERE ";
				$query1.="varname='mediashare_pickup_alert'";
				$runit=$ilance->db->query($query1);
				$rs1=$ilance->db->fetch_array($runit);

				$subject=stripslashes(trim($rs1[0]));
				$message=stripslashes(trim($rs1[1]));
				
				$subject=str_replace("{{username}}", $_SESSION['ilancedata']['user']['username'], $subject);
				$subject=str_replace("{{filename}}", $_FILES['ufile']['name'], $subject);
				$subject=str_replace("{{filesize}}", $_FILES['ufile']['size'], $subject);
				$subject=str_replace("{{filetype}}", $_FILES['ufile']['type'], $subject);
				$subject=str_replace("{{project_title}}", fetch_auction('project_title', $cryptedws['project_id']), $subject);
				$subject=str_replace("{{site_name}}", SITE_NAME, $subject);
				$subject=str_replace("{{https_server}}", HTTPS_SERVER, $subject);
				$subject=str_replace("{{http_server}}", HTTP_SERVER, $subject);
				$subject=str_replace("{{generate_date}}", print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0), $subject);
				
				$message=str_replace("{{username}}", $_SESSION['ilancedata']['user']['username'], $message);
				$message=str_replace("{{filename}}", $_FILES['ufile']['name'], $message);
				$message=str_replace("{{filesize}}", $_FILES['ufile']['size'], $message);
				$message=str_replace("{{filetype}}", $_FILES['ufile']['type'], $message);
				$message=str_replace("{{project_title}}", fetch_auction('project_title', $cryptedws['project_id']), $message);
				$message=str_replace("{{site_name}}", SITE_NAME, $message);
				$message=str_replace("{{site_email}}", SITE_EMAIL, $message);
				$message=str_replace("{{site_phone}}", SITE_PHONE, $message);
				$message=str_replace("{{site_address}}", SITE_ADDRESS, $message);
				$message=str_replace("{{http_server_admin}}", HTTP_SERVER_ADMIN, $message);
				$message=str_replace("{{https_server_admin}}", HTTPS_SERVER_ADMIN, $message);
				$message=str_replace("{{https_server}}", HTTPS_SERVER, $message);
				$message=str_replace("{{http_server}}", HTTP_SERVER, $message);
				$message=str_replace("{{generate_date}}", print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0), $message);
				$message=str_replace("{{email_id}}", "193", $message);
				send_email(fetch_user('email', $cryptedws['seller_id']), $subject, $message, SITE_EMAIL);
				
				######################################
				### ILANCE => EMAIL TEMPLATE ENGINE V1.0
				#######################################
				## GRAB EMAIL: ID=194, NAME=Email Mediashare File Pickup Alert (Moderation) - Admin
				$query1="SELECT ";
				$query1.="subject_".fetch_site_slng().", ";
				$query1.="message_".fetch_site_slng()." ";
				$query1.="FROM ";
				$query1.=DB_PREFIX."email ";
				$query1.="WHERE ";
				$query1.="varname='mediashare_pickup_alert_admin'";
				$runit=$ilance->db->query($query1);
				$rs1=$ilance->db->fetch_array($runit);
                                
				$subject=stripslashes(trim($rs1[0]));
				$message=stripslashes(trim($rs1[1]));
				
				$subject=str_replace("{{username}}", $_SESSION['ilancedata']['user']['username'], $subject);
				$subject=str_replace("{{filename}}", $_FILES['ufile']['name'], $subject);
				$subject=str_replace("{{filesize}}", $_FILES['ufile']['size'], $subject);
				$subject=str_replace("{{filetype}}", $_FILES['ufile']['type'], $subject);
				$subject=str_replace("{{project_title}}", fetch_auction('project_title', $cryptedws['project_id']), $subject);
				$subject=str_replace("{{site_name}}", SITE_NAME, $subject);
				$subject=str_replace("{{https_server}}", HTTPS_SERVER, $subject);
				$subject=str_replace("{{http_server}}", HTTP_SERVER, $subject);
				$subject=str_replace("{{generate_date}}", print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0), $subject);
				
				$message=str_replace("{{username}}", $_SESSION['ilancedata']['user']['username'], $message);
				$message=str_replace("{{filename}}", $_FILES['ufile']['name'], $message);
				$message=str_replace("{{filesize}}", $_FILES['ufile']['size'], $message);
				$message=str_replace("{{filetype}}", $_FILES['ufile']['type'], $message);
				$message=str_replace("{{project_title}}", fetch_auction('project_title', $cryptedws['project_id']), $message);
				$message=str_replace("{{site_name}}", SITE_NAME, $message);
				$message=str_replace("{{site_email}}", SITE_EMAIL, $message);
				$message=str_replace("{{site_phone}}", SITE_PHONE, $message);
				$message=str_replace("{{site_address}}", SITE_ADDRESS, $message);
				$message=str_replace("{{http_server_admin}}", HTTP_SERVER_ADMIN, $message);
				$message=str_replace("{{https_server_admin}}", HTTPS_SERVER_ADMIN, $message);
				$message=str_replace("{{https_server}}", HTTPS_SERVER, $message);
				$message=str_replace("{{http_server}}", HTTP_SERVER, $message);
				$message=str_replace("{{generate_date}}", print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0), $message);
				$message=str_replace("{{email_id}}", "194", $message);
				send_email(SITE_EMAIL, $subject, $message, SITE_EMAIL);
			}
			else 
			{
				// email mediashare alerts to the customers respectively
				if ($ilance->db->fetch_field(DB_PREFIX . "attachment_folder", "id = '" . intval($cryptedws['fold_id']) . "'", "folder_type") == '2') 
				{
					######################################
					### ILANCE => EMAIL TEMPLATE ENGINE V1.0
					#######################################
					## GRAB EMAIL: ID=195, NAME=Email Mediashare File Pickup Alert - Sender
					$query1="SELECT ";
					$query1.="subject_".$_SESSION['ilancedata']['user']['slng'].", ";
					$query1.="message_".$_SESSION['ilancedata']['user']['slng']." ";
					$query1.="FROM ";
					$query1.=DB_PREFIX."email ";
					$query1.="WHERE ";
					$query1.="varname='mediashare_pickup_alert_nomoderation'";
					$runit=$ilance->db->query($query1);
					$rs1=$ilance->db->fetch_array($runit);
                                        
					$subject=stripslashes(trim($rs1[0]));
					$message=stripslashes(trim($rs1[1]));
					
					$subject=str_replace("{{username}}", $_SESSION['ilancedata']['user']['username'], $subject);
					$subject=str_replace("{{filename}}", $_FILES['ufile']['name'], $subject);
					$subject=str_replace("{{filesize}}", $_FILES['ufile']['size'], $subject);
					$subject=str_replace("{{filetype}}", $_FILES['ufile']['type'], $subject);
					$subject=str_replace("{{project_title}}", fetch_auction('project_title', $cryptedws['project_id']), $subject);
					$subject=str_replace("{{site_name}}", SITE_NAME, $subject);
					$subject=str_replace("{{https_server}}", HTTPS_SERVER, $subject);
					$subject=str_replace("{{http_server}}", HTTP_SERVER, $subject);
					$subject=str_replace("{{generate_date}}", print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0), $subject);
                                        
					$message=str_replace("{{username}}", $_SESSION['ilancedata']['user']['username'], $message);
					$message=str_replace("{{filename}}", $_FILES['ufile']['name'], $message);
					$message=str_replace("{{filesize}}", $_FILES['ufile']['size'], $message);
					$message=str_replace("{{filetype}}", $_FILES['ufile']['type'], $message);
					$message=str_replace("{{project_title}}", fetch_auction('project_title', $cryptedws['project_id']), $message);
					$message=str_replace("{{site_name}}", SITE_NAME, $message);
					$message=str_replace("{{site_email}}", SITE_EMAIL, $message);
					$message=str_replace("{{site_phone}}", SITE_PHONE, $message);
					$message=str_replace("{{site_address}}", SITE_ADDRESS, $message);
					$message=str_replace("{{http_server_admin}}", HTTP_SERVER_ADMIN, $message);
					$message=str_replace("{{https_server_admin}}", HTTPS_SERVER_ADMIN, $message);
					$message=str_replace("{{https_server}}", HTTPS_SERVER, $message);
					$message=str_replace("{{http_server}}", HTTP_SERVER, $message);
					$message=str_replace("{{generate_date}}", print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0), $message);
					$message=str_replace("{{email_id}}", "195", $message);
					send_email($_SESSION['ilancedata']['user']['email'],$subject,$message,SITE_EMAIL);
					
					######################################
					### ILANCE => EMAIL TEMPLATE ENGINE V1.0
					#######################################
					## GRAB EMAIL: ID=196, NAME=Email Mediashare File Pickup Alert - Receiver
					$query1="SELECT ";
					$query1.="subject_".$_SESSION['ilancedata']['user']['slng'].", ";
					$query1.="message_".$_SESSION['ilancedata']['user']['slng']." ";
					$query1.="FROM ";
					$query1.=DB_PREFIX."email ";
					$query1.="WHERE ";
					$query1.="varname='mediashare_pickup_alert_receiver'";
					$runit=$ilance->db->query($query1);
					$rs1=$ilance->db->fetch_array($runit);
                                        
					$subject=stripslashes(trim($rs1[0]));
					$message=stripslashes(trim($rs1[1]));
					
					if ($ilmedia['project_state'] == 'service')
					{
						$subject=str_replace("{{username}}", fetch_user('username', $cryptedws['buyer_id']), $subject);
					}
					else
					{
						$subject=str_replace("{{username}}", fetch_user('username', $cryptedws['seller_id']), $subject);
					}
					
					$subject=str_replace("{{sender}}", $_SESSION['ilancedata']['user']['username'], $subject);
                                        $subject=str_replace("{{username}}", $_SESSION['ilancedata']['user']['username'], $subject);
					$subject=str_replace("{{filename}}", $_FILES['ufile']['name'], $subject);
					$subject=str_replace("{{filesize}}", $_FILES['ufile']['size'], $subject);
					$subject=str_replace("{{filetype}}", $_FILES['ufile']['type'], $subject);
					$subject=str_replace("{{project_title}}", fetch_auction('project_title', $cryptedws['project_id']), $subject);
					$subject=str_replace("{{site_name}}", SITE_NAME, $subject);
					$subject=str_replace("{{https_server}}", HTTPS_SERVER, $subject);
					$subject=str_replace("{{http_server}}", HTTP_SERVER, $subject);
					$subject=str_replace("{{generate_date}}", print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0), $subject);
                                        
					if ($ilmedia['project_state'] == 'service')
					{
						$message=str_replace("{{username}}", fetch_user('username', $cryptedws['buyer_id']), $message);
					}
					else
					{
						$message=str_replace("{{username}}", fetch_user('username', $cryptedws['seller_id']), $message);
					}
					
					$message=str_replace("{{sender}}", $_SESSION['ilancedata']['user']['username'], $message);
                                        $message=str_replace("{{username}}", $_SESSION['ilancedata']['user']['username'], $message);
					$message=str_replace("{{filename}}", $_FILES['ufile']['name'], $message);
					$message=str_replace("{{filesize}}", $_FILES['ufile']['size'], $message);
					$message=str_replace("{{filetype}}", $_FILES['ufile']['type'], $message);
					$message=str_replace("{{project_title}}", fetch_auction('project_title', $cryptedws['project_id']), $message);
					$message=str_replace("{{site_name}}", SITE_NAME, $message);
					$message=str_replace("{{site_email}}", SITE_EMAIL, $message);
					$message=str_replace("{{site_phone}}", SITE_PHONE, $message);
					$message=str_replace("{{site_address}}", SITE_ADDRESS, $message);
					$message=str_replace("{{http_server_admin}}", HTTP_SERVER_ADMIN, $message);
					$message=str_replace("{{https_server_admin}}", HTTPS_SERVER_ADMIN, $message);
					$message=str_replace("{{https_server}}", HTTPS_SERVER, $message);
					$message=str_replace("{{http_server}}", HTTP_SERVER, $message);
					$message=str_replace("{{generate_date}}", print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0), $message);
					$message=str_replace("{{email_id}}", "196", $message);
                                        
					if ($ilmedia['project_state'] == 'service')
					{
						send_email(fetch_user('email', $cryptedws['buyer_id']), $subject, $message, SITE_EMAIL);
					}
					else
					{
						send_email(fetch_user('email', $cryptedws['seller_id']), $subject, $message, SITE_EMAIL);
					}
					
					######################################
					### ILANCE => EMAIL TEMPLATE ENGINE V1.0
					#######################################
					## GRAB EMAIL: ID=194, NAME=Email Mediashare File Pickup Alert - Admin
					$query1="SELECT ";
					$query1.="subject_".fetch_site_slng().", ";
					$query1.="message_".fetch_site_slng()." ";
					$query1.="FROM ";
					$query1.=DB_PREFIX."email ";
					$query1.="WHERE ";
					$query1.="varname='mediashare_pickup_alert_admin'";
					$runit=$ilance->db->query($query1);
					$rs1=$ilance->db->fetch_array($runit);
                                        
					$subject=stripslashes(trim($rs1[0]));
					$message=stripslashes(trim($rs1[1]));
					
					if ($ilmedia['project_state'] == 'service')
					{
						$subject=str_replace("{{receiver}}", fetch_user('username', $cryptedws['buyer_id']), $subject);
					}
					else
					{
						$subject=str_replace("{{receiver}}", fetch_user('username', $cryptedws['seller_id']), $subject);
					}
					
					$subject=str_replace("{{sender}}", $_SESSION['ilancedata']['user']['username'], $subject);
                                        $subject=str_replace("{{username}}", $_SESSION['ilancedata']['user']['username'], $subject);
					$subject=str_replace("{{filename}}", $_FILES['ufile']['name'], $subject);
					$subject=str_replace("{{filesize}}", $_FILES['ufile']['size'], $subject);
					$subject=str_replace("{{filetype}}", $_FILES['ufile']['type'], $subject);
					$subject=str_replace("{{project_title}}", fetch_auction('project_title', $cryptedws['project_id']), $subject);
					$subject=str_replace("{{site_name}}", SITE_NAME, $subject);
					$subject=str_replace("{{https_server}}", HTTPS_SERVER, $subject);
					$subject=str_replace("{{http_server}}", HTTP_SERVER, $subject);
					$subject=str_replace("{{generate_date}}", print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0), $subject);
					
					if ($ilmedia['project_state'] == 'service')
					{
						$message=str_replace("{{receiver}}", fetch_user('username', $cryptedws['buyer_id']), $message);
					}
					else
					{
						$message=str_replace("{{receiver}}", fetch_user('username', $cryptedws['seller_id']), $message);
					}
					
					$message=str_replace("{{sender}}", $_SESSION['ilancedata']['user']['username'], $message);
                                        $message=str_replace("{{username}}", $_SESSION['ilancedata']['user']['username'], $message);
					$message=str_replace("{{filename}}", $_FILES['ufile']['name'], $message);
					$message=str_replace("{{filesize}}", $_FILES['ufile']['size'], $message);
					$message=str_replace("{{filetype}}", $_FILES['ufile']['type'], $message);
					$message=str_replace("{{project_title}}", fetch_auction('project_title', $cryptedws['project_id']), $message);
					$message=str_replace("{{site_name}}", SITE_NAME, $message);
					$message=str_replace("{{site_email}}", SITE_EMAIL, $message);
					$message=str_replace("{{site_phone}}", SITE_PHONE, $message);
					$message=str_replace("{{site_address}}", SITE_ADDRESS, $message);
					$message=str_replace("{{http_server_admin}}", HTTP_SERVER_ADMIN, $message);
					$message=str_replace("{{https_server_admin}}", HTTPS_SERVER_ADMIN, $message);
					$message=str_replace("{{https_server}}", HTTPS_SERVER, $message);
					$message=str_replace("{{http_server}}", HTTP_SERVER, $message);
					$message=str_replace("{{generate_date}}", print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0), $message);
					$message=str_replace("{{email_id}}", "194", $message);
					send_email(SITE_EMAIL, $subject, $message, SITE_EMAIL);
				}
			}
			
                        // construct the attachment within the database
			$ilance->db->query("
                                INSERT INTO " . DB_PREFIX . "attachment
                                (attachid, attachtype, user_id, project_id, category_id, date, filename, filedata, filetype, visible, counter, filesize, filehash, ipaddress, tblfolder_ref)
                                VALUES(
                                NULL,
                                'ws',
                                '" . intval($_SESSION['ilancedata']['user']['userid']) . "',
                                '" . intval($cryptedws['project_id']) . "',
                                '0',
                                '" . DATETIME24H . "',
                                '" . $ilance->db->escape_string($_FILES['ufile']['name']) . "',
                                '" . $filedata . "',
                                '" . $ilance->db->escape_string($_FILES['ufile']['type']) . "',
                                '" . $ilconfig['attachment_mediasharemoderationdisabled'] . "',
                                '0',
                                '" . $ilance->db->escape_string($_FILES['ufile']['size']) . "',
                                '" . $ilance->db->escape_string($filehash) . "',
                                '" . $ilance->db->escape_string($_SERVER['REMOTE_ADDR']) . "',
                                '" . intval($cryptedws['fold_id']) . "')
                        ");
                        
			$fileId = $ilance->db->insert_id();
			
			// old size
			$nSize = $ilance->db->fetch_field(DB_PREFIX . "attachment_folder", "id = '" . intval($cryptedws['fold_id']) . "'", "folder_size");
			
			// update new size
			$nSize = ($nSize + $_FILES['ufile']['size']);
                        
			update_record(DB_PREFIX . "attachment_folder", "id = '" . intval($cryptedws['fold_id']) . "'", array('folder_size' => $nSize,));
                        
			$crypted = array(
                                'project_id' => intval($cryptedws['project_id']),
                                'buyer_id' => intval($cryptedws['buyer_id']),
                                'seller_id' => intval($cryptedws['seller_id']),
                                'fold_id' => intval($cryptedws['fold_id'])
                        );
                        
			header("Location: " . $ilpage['mediashare'] . "?crypted=" . encrypt_url($crypted));
			exit();
		}
		else
		{
			$crypted = array(
                                'project_id' => intval($cryptedws['project_id']),
                                'buyer_id' => intval($cryptedws['buyer_id']),
                                'seller_id' => intval($cryptedws['seller_id']),
                                'fold_id' => intval($cryptedws['fold_id']),
                                'error_code' => '3'
                        );
                        
			header("Location: " . $ilpage['mediashare'] . "?crypted=".encrypt_url($crypted));
			exit();
		}
	}
	else 
	{
		// temp file was not uploaded
		$crypted = array(
                        'project_id' => intval($cryptedws['project_id']),
                        'buyer_id' => intval($cryptedws['buyer_id']),
                        'seller_id' => intval($cryptedws['seller_id']),
                        'fold_id' => intval($cryptedws['fold_id']),
                        'error_code' => '3'
                );
                
		header("Location: " . $ilpage['mediashare'] . "?crypted=" . encrypt_url($crypted));	
		exit();
	}
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: upload.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>