<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/
$phrase['groups'] = array(
	'mediashare',
	'rfp',
	'buying',
	'selling',
	'feedback',
	'javascript'
);

define('LOCATION','workspace');

include('functions.inc.php');

$ilance->workspace = construct_object('api.workspace');

$navcrumb = array("$ilpage[workspace]" => $ilcrumbs["$ilpage[workspace]"]);

if (empty($_SESSION['ilancedata']['user']['userid']) OR !isset($_SESSION['ilancedata']['user']['userid']))
{
	refresh($ilpage['login'], HTTPS_SERVER . $ilpage['login']);
	exit();
}

// #### MOVE FILES OR FOLDERS ##########################################
if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_move-file-folder')
{
	$rs = $ilance->db->query("
		SELECT id
		FROM " . DB_PREFIX . "attachment_folder
	");
	while ($row = $ilance->db->fetch_array($rs))
	{
		$temp = 'fold' . $row['id'];
		if (!empty($ilance->GPC[$temp]) AND $ilance->GPC[$temp] == 'on')
		{
			update_record(DB_PREFIX . "attachment_folder", "id = '" . $row['id'] . "'", array('p_id' => intval($ilance->GPC['newFolderId']),));
		}
	}
	
	$rs = $ilance->db->query("
		SELECT attachid, attachtype, user_id, portfolio_id, project_id, pmb_id, category_id, date, filename, filetype, visible, counter, filesize, filehash, ipaddress, tblfolder_ref
		FROM " . DB_PREFIX . "attachment
	");
	while ($row = $ilance->db->fetch_array($rs))
	{
		$temp = 'file' . $row['attachid'];
		if (!empty($ilance->GPC[$temp]) AND $ilance->GPC[$temp] == 'on')
		{
			// this folder size file is in
			$nSize = ($ilance->db->fetch_field(DB_PREFIX . "attachment_folder", "id = '" . $row['tblfolder_ref'] . "'", "folder_size") - $row['filesize']);
			
			// updating new folder size
			update_record(DB_PREFIX . "attachment_folder", "id = '" . $row['tblfolder_ref'] . "'", array('folder_size' => $nSize,));
			
			// get new folder size and add moved file size
			$nSize = ($ilance->db->fetch_field(DB_PREFIX . "attachment_folder", "id = '" . intval($ilance->GPC['newFolderId']) . "'", "folder_size") + $row['filesize']);
			
			// updating new folder id with new filesize
			update_record(DB_PREFIX . "attachment_folder", "id = '" . intval($ilance->GPC['newFolderId']) . "'", array('folder_size' => $nSize,));
			
			// assign to new folder
			update_record(DB_PREFIX . "attachment", "attachid = '" . $row['attachid'] . "'", array('tblfolder_ref' => intval($ilance->GPC['newFolderId']),));
		}
	}
	
	$crypted = decrypt_url($ilance->GPC['crypted']);
	$cryptedws = array(
		'project_id' => (int)$crypted['project_id'],
		'buyer_id' => (int)$crypted['buyer_id'],
		'seller_id' => (int)$crypted['seller_id'],
		'fold_id' => (int)$crypted['fold_id']
	);
	
	header("Location: " . HTTPS_WS . $ilpage['mediashare'] . "?crypted=" . encrypt_url($cryptedws));
}

// #### SAVE FOLDER COMMENTS ###########################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_save-comments')
{
	$crypted = decrypt_url($ilance->GPC['crypted']);
	$cryptedws = array(
		'project_id' => (int)$crypted['project_id'],
		'buyer_id' => (int)$crypted['buyer_id'],
		'seller_id' => (int)$crypted['seller_id'],
		'fold_id' => (int)$crypted['fold_id']
	);
	
	update_record(DB_PREFIX . "attachment_folder", "id=" . $fold_id, array('comments' => addslashes($ilance->GPC['folder_comments']),));
	
	header("Location: " . HTTPS_WS . $ilpage['mediashare'] . "?crypted=" . encrypt_url($cryptedws));
}

// #### SAVE NEW FOLDER ################################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_save-folder')
{
	$crypted = decrypt_url($ilance->GPC['crypted']);
	$cryptedws = array(
		'project_id' => $crypted['project_id'],
		'buyer_id' => $crypted['buyer_id'],
		'seller_id' => $crypted['seller_id'],
		'fold_id' => $crypted['fold_id']
	);
	
	$folder_type = $ilance->db->fetch_field(DB_PREFIX . "attachment_folder", "id = '" . $crypted['fold_id'] . "'", "folder_type");
	
	construct_attachment_folder($ilance->GPC['folder_name'], $ilance->GPC['folder_comments'], $crypted['fold_id'], 0, 0, 0, 0, $folder_type);
	
	header("Location: " . HTTPS_WS . $ilpage['mediashare'] . "?crypted=" . encrypt_url($cryptedws));
}

// #### SAVE COPY FILES TO NEW FOLDER ##################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_save-copy-files')
{
	$crypted = decrypt_url($ilance->GPC["crypted"]);
	
	$cryptedws = array(
		'project_id' => $crypted['project_id'],
		'buyer_id' => $crypted['buyer_id'],
		'seller_id' => $crypted['seller_id'],
		'fold_id' => $crypted['fold_id']
	);
	
	$encodedws = serialize($cryptedws);
	
	$query = $ilance->db->query("SELECT * FROM " . DB_PREFIX . "attachment_folder");
	if ($ilance->db->num_rows($query) > 0)
	{
		while ($row = $ilance->db->fetch_array($query))
		{
			$foldtemp = 'fold' . $row['id'];
			if (!empty($ilance->GPC[$foldtemp]) AND $ilance->GPC[$foldtemp] == 'on')
			{
				$created_folder_id = construct_attachment_folder($row['name'], $row['comments'], $ilance->GPC['newFolderId'], -1, -1, -1, $row['folder_size'], -1);
				
				copyFiles($row['id'], $created_folder_id);
				copyIntFolders($row['id'], $created_folder_id);
			}
		}
	}
	
	$query2 = $ilance->db->query("
		SELECT *
		FROM " . DB_PREFIX . "attachment
	");
	if ($ilance->db->num_rows($query2) > 0)
	{
		while ($row = $ilance->db->fetch_array($query2))
		{
			$filetemp = 'file' . $row['attachid'];
			if (!empty($ilance->GPC[$filetemp]) AND $ilance->GPC[$filetemp] == 'on')
			{
				$ilance->db->query("
					INSERT INTO " . DB_PREFIX . "attachment
					(attachid, attachtype, user_id, project_id, date, filename, filedata, filetype, visible, counter, filesize, filehash, ipaddress, tblfolder_ref)
					VALUES(
					NULL,
					'ws',
					'" . intval($_SESSION['ilancedata']['user']['userid']) . "',
					'" . intval($ilmedia['project_id']) . "',
					'" . DATETIME24H . "',
					'" . addslashes($row['filename']) . "',
					'" . addslashes($row['filedata']) . "',
					'" . addslashes($row['filetype']) . "',
					'1',
					'0',
					'" . $row['filesize'] . "',
					'" . $row['filehash'] . "',
					'" . addslashes($_SERVER['REMOTE_ADDR']) . "',
					'" . intval($ilance->GPC['newFolderId']) . "')
				");
				
				//get size of folder file is copying to
				$nSize = ($ilance->db->fetch_field(DB_PREFIX . "attachment_folder", "id = '" . intval($ilance->GPC['newFolderId']) . "'", "folder_size")+$row['filesize']);
				
				// updating new folder id with new filesize
				update_record(DB_PREFIX . "attachment_folder", "id = '" . intval($ilance->GPC['newFolderId']) . "'", array('folder_size' => $nSize,));
			}
		}
	}
	
	header("Location: " . HTTPS_WS . $ilpage['mediashare'] . "?crypted=" . encrypt_url($cryptedws));
}

// #### RENAME FOLDER ##########################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_save-rename')
{
	$crypted = decrypt_url($ilance->GPC['crypted']);
	
	$cryptedws = array(
		'project_id' => (int)$crypted['project_id'],
		'buyer_id' => (int)$crypted['buyer_id'],
		'seller_id' => (int)$crypted['seller_id'],
		'fold_id' => (int)$crypted['fold_id']
	);
	
	if (!empty($ilance->GPC['rfoldId']))
	{ // we are renaming a folder
		update_record(DB_PREFIX . "attachment_folder", "id=" . (int)$ilance->GPC['rfoldId'], array('name' => addslashes($ilance->GPC['re_name']),));
	}
	else
	{ // we are renaming a file
		if ($ilconfig['attachment_dbstorage'])
		{
			update_record(DB_PREFIX . "attachment", "attachid=" . (int)$ilance->GPC['nfile_id'], array('filename' => addslashes($ilance->GPC['re_name']),));
		}
		else
		{
			update_record(DB_PREFIX . "attachment", "attachid=" . (int)$ilance->GPC['nfile_id'], array('filename' => addslashes($ilance->GPC['re_name']),));
		}
	}
	
	header("Location: " . HTTPS_WS . $ilpage['mediashare'] . "?crypted=" . encrypt_url($cryptedws));
}

// #### MOVE FILES OR FOLDERS ##################################
else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_move-file-folder')
{
	$crypted = decrypt_url($ilance->GPC['crypted']);
	
	$cryptedws = array(
		'project_id' => $crypted['project_id'],
		'buyer_id' => $crypted['buyer_id'],
		'seller_id' => $crypted['seller_id'],
		'fold_id' => $crypted['fold_id']
	);
	
	$rs = $ilance->db->query("
		SELECT *
		FROM " . DB_PREFIX . "attachment_folder
	");
	if ($ilance->db->num_rows($rs) > 0)
	{
		while ($row = $ilance->db->fetch_array($rs))
		{
			$temp = 'fold' . $row['id'];
			if (!empty($ilance->GPC[$temp]) AND $ilance->GPC[$temp] == 'on')
			{
				update_record(DB_PREFIX . "attachment_folder", "id=" . (int)$row['id'], array('p_id' => $ilance->GPC['newFolderId'],));
			}
		}
		
		$rs = $ilance->db->query("
			SELECT attachid, attachtype, user_id, portfolio_id, project_id, pmb_id, category_id, date, filename, filetype, visible, counter, filesize, filehash, ipaddress, tblfolder_ref
			FROM " . DB_PREFIX . "attachment
		");
		if ($ilance->db->num_rows($rs) > 0)
		{
			while ($row = $ilance->db->fetch_array($rs))
			{
				$temp = 'file' . $row['attachid'];
				if (!empty($ilance->GPC[$temp]) AND $ilance->GPC[$temp] == 'on')
				{
					//this folder size file is in
					$nSize = $ilance->db->fetch_field(DB_PREFIX . "attachment_folder", "id = '" . $row["tblfolder_ref"] . "'", "folder_size")-$row["filesize"];
					
					// updating new folder size
					update_record(DB_PREFIX . "attachment_folder", "id = '" . $row["tblfolder_ref"] . "'", array("folder_size" => $nSize,));
					
					// get new folder size and add moved file size
					$nSize = $ilance->db->fetch_field(DB_PREFIX . "attachment_folder", "id = '" . $ilance->GPC['newFolderId'] . "'", "folder_size")+$row["filesize"];
					
					// updating new folder id with new filesize
					update_record(DB_PREFIX . "attachment_folder", "id = '" . $ilance->GPC['newFolderId'] . "'", array("folder_size" => $nSize,));
					
					// assign to new folder
					update_record(DB_PREFIX . "attachment", "attachid=" . $row["attachid"], array("tblfolder_ref" => $ilance->GPC['newFolderId'],));
				}
			}					
		}
	}
	
	header("Location: " .  HTTPS_WS . $ilpage['mediashare'] . "?crypted=" . encrypt_url($cryptedws));
}



include(DIR_WS_TEMPLATES . 'header.php');

// check our folders (create if need be)
checkPrivateFolder($ilmedia['seller_id'], $ilmedia['buyer_id']);
checkSharedFolder($ilmedia['project_id']);

?>
<!-- intro folder selection -->
<div class="block-content" style="padding:0px">
	
<table cellpadding="9" cellspacing="1" border="0" width="100%" align="center">
<tr>
	<td colspan="2" valign="top"> 
	<div>
	
		<table width="100%" cellpadding="0" cellspacing="0" border="0">
		<tr>
			<td width="25" height="30" align="center"><img src="<?php echo $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder']; ?>rfolder.gif" width="16"  height="13" /></td>
			<td>
<?php
if ($_SESSION['ilancedata']['user']['userid'] == $ilmedia['seller_id'])
{
	$cond = "seller_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'";
}
else
{
	$cond = "buyer_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'";
}

$fold_id = $ilance->db->fetch_field(DB_PREFIX . "attachment_folder", $cond, 'id');
$cryptedws = array(
	'project_id' => $ilmedia['project_id'],
	'buyer_id' => $ilmedia['buyer_id'],
	'seller_id' => $ilmedia['seller_id'],
	'fold_id' => $fold_id,
	'cond' => $cond
);
?>
			<span class="blue"><a href="<?php echo HTTPS_WS . $ilpage['mediashare']; ?>?crypted=<?php echo encrypt_url($cryptedws); ?>"><?php echo $phrase['_private']; ?></a></span>
			</td>
		</tr>
        	<tr>
          		<td width="25" height="30" align="center"><img src="<?php echo $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder']; ?>folder.gif" width="16"  height="14"></td>
          		<td>
<?php
				$fold_id = $ilance->db->fetch_field(DB_PREFIX . "attachment_folder", "project_id = '" . $ilmedia['project_id'] . "' AND folder_type = '2'", 'id');
				$cryptedws2 = array(
					'project_id' => $ilmedia['project_id'],
					'buyer_id' => $ilmedia['buyer_id'],
					'seller_id' => $ilmedia['seller_id'],
					'fold_id' => $fold_id,
					'cond' => $cond
				);
?>
			<span class="blue"><a href="<?php echo HTTPS_WS . $ilpage['mediashare']; ?>?crypted=<?php echo encrypt_url($cryptedws2); ?>"><?php echo $phrase['_shared']; ?></a></span>
			</td>
        	</tr>
		</table>
	  
	</div>
	</td>
</tr>
</table>

</div>
<!-- intro folder selection -->

<div class="block-footer">
	<div class="block-right">
		<div class="block-left"></div>
	</div>
</div>
			
</div>
</div>
</form>

<?php
$ilance->template->construct_footer('msfooter');
$ilance->template->parse_hash('msfooter', array('ilpage' => $ilpage));
$ilance->template->parse_if_blocks('msfooter');
$ilance->template->pprint('msfooter', array('area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer','finaltime','finalqueries'));

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: workspace.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>