<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/
if (!isset($GLOBALS['ilance']->db))
{
    die('<strong>Warning:</strong> This script does not appear to have database functions loaded.  Operation aborted.');
}

function create_city_locations_schema($dbengine, $dbtype)
{
    global $ilance;
    
    $ilance->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "locations_cities`", 0, null, __FILE__, __LINE__);
    $ilance->db->query("
            CREATE TABLE `" . DB_PREFIX . "locations_cities` (
            `state` VARCHAR(150) NOT NULL,
            `city` VARCHAR(150) NOT NULL default '',
            KEY location (`city`)
            ) " . $dbengine . "=" . $dbtype . " DEFAULT CHARACTER SET " . DB_CHARSET . "
    ", 0, null, __FILE__, __LINE__);
    echo "<li>" . DB_PREFIX . "locations_cities</li>";
    flush();
    
    // ** All cities within the state of Ontario, Canada **************************************************************
    print_progress_begin('<b>Importing 3,330 default cities</b>, please wait.', '.', 'progressspancitiesontario');
    
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Aberarder')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Abitibi Canyon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Acton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Adolphustown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ailsa Craig')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ajax')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Alban')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Alderville First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Alexandria')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Alfred')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Algoma Mills')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Alliston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Almonte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Alvinston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Amherstburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ancaster')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Angus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Apsley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Arden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Arkell')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Arkona')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Armstrong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Arnprior')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Arthur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Athens')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Atikokan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Attawapiskat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Atwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Auburn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Aurora')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Avonmore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ayr')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ayton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Azilda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Baden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bailieboro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Balmertown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Baltimore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bancroft')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Barrie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Barry''s Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Barwick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Batawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Batchawana Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bath')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bayfield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Baysville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Beachburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Beachville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Beamsville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Beardmore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bearskin Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bearskin Lake First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bear''s Passage')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Beaverton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Beeton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Belle River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Belleville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Belmont')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bethany')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bethesda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Big Trout Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Binbrook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Birch Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Biscotasing')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Blackstock')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Blenheim')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Blezard Valley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Blind River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bloomfield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Blyth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bobcaygeon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bolton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bonfield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bothwell')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bourget')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bowmanville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bracebridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bradford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bradford West Gwillimbury')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Braeside')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Brampton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Brantford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Brechin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Breslau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bridgenorth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Brigden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bright')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Brighton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Brights Grove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Britt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Brockville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Brooklin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Brownsville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Bruce Mines')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Brussels')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Buckhorn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Burford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Burgessville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Burk''s Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Burleigh Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Burlington')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cache Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Calabogie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Caledon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Caledon East')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Caledonia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Callander')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Calstock')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cambray')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cambridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cameron')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Camlachie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Campbellford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Campbellville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cannington')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Capreol')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Caradoc First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Caramat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cardiff')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cardinal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cargill')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Carleton Place')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Carnarvon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Carp')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cartier')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Casselman')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Castlemore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Castleton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cat Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cavan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cayuga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Centralia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Chalk River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Chapleau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Charlton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Chatham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Chatsworth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Chelmsford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Chesley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Chiefs Point First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Chippewas of Kettle/Stony Poin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Chippewas Of Sarnia First Nati')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Christian Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Claremont')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Clarence Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Clarence-Rockland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Clarington')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Clarkson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Clearwater Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Clifford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Clinton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cloud Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cobalt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cobden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Coboconk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cobourg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cochenour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cochrane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Coe Hill')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Colborne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Colchester')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cold Springs')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Coldwater')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Collingwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Comber')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Concord')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Coniston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Connaught')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Constance Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Constance Lake First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cookstown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cooksville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Corunna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cottam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Courtice')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Courtright')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Crediton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Creemore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Crysler')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Crystal Beach')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Cumberland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dashwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Deep River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Deer Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Deerbrook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Delaware of the Thames (Moravia)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Delhi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Delta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Denbigh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Desbarats')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Deseronto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Deux-Rivieres')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Devlin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dokis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dokis First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dorchester')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dorion')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dorset')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Douglas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Douglastown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Drayton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dresden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Drumbo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dryden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dublin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dubreuilville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dunchurch')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dundalk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dundas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dungannon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dunnville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dunsford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Durham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dutton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dwight')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Dyer''s Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Eagle Lake First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Eagle River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ear Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Earlton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'East Gwillimbury')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'East York')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Eastwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Echo Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Eganville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Elgin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Elizabethtown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Elk Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Elliot Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Elmira')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Elmvale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Elora')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Embro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Embrun')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Emeryville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Emo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Emsdale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Englehart')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Enterprise')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Erin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Espanola')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Essex')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Estaire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Etobicoke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Eugenia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Exeter')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Fauquier')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Fenelon Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Fenwick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Fergus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Feversham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Field')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Finch')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Fingal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Fisherville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Flamborough')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Flanders')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Flesherton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Foley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Foleyet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Forest')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Fort Albany')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Fort Erie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Fort Frances')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Fort Hope')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Fort Severn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Fort Severn First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Fort William First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Foxboro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Foymount')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Frankford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Freelton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'French River First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Galt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Gananoque')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Garden Hill')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Garden River First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Garson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Georgina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Geraldton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Gilmour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Glen Robertson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Glen Water')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Glen Williams')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Glencoe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Gloucester')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Goderich')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Gogama')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Golden Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Gooderham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Gore Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Gormley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Gorrie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Goulais River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Gowganda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Grafton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Grand Bend')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Grand Valley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Granton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Grassy Narrows')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Grassy Narrows First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Gravenhurst')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Greensville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Grimsby')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Guelph')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Gull Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Gull Bay First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Hagersville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Haileybury')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Haldimand')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Haliburton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Halton Hills')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Hamilton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Hampton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Hanmer')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Hanover')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Harrietsville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Harriston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Harrow')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Harrowsmith')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Hastings')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Havelock')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Hawk Junction')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Hawkesbury')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Hearst')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Hemlo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Hensall')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Henvey Inlet First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Hepworth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Hespeler')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Hickson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Highgate')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Hillsburgh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Holland Landing')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Holstein')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Honey Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Hornepayne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Humphrey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Huntsville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ignace')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ilderton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ingersoll')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ingleside')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Innerkip')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Innisfil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Inverary')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Inwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Iron Bridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Iroquois')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Iroquois Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Jaffray Melick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Jarvis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Jasper')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Jellicoe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Jockvale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Johnstown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Jordan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kaministiquia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kamiskotia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kanata')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kapuskasing')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kasabonika First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kashechewan First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kearney')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Keene')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Keewatin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kemptville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kenora')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kent Centre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kerwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Keswick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Killaloe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Killarney')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kincardine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'King City')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kingfisher Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kingfisher Lake First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kingston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kingsville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kinmount')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kintore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kirkfield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kirkland Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kirkton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kitchener')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Kleinburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lac la Croix')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lac Seul First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lagoon City')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lakefield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lambeth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lanark')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lancaster')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Langton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lansdowne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lansdowne House')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Larder Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Latchford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Leamington')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lefroy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Levack')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lincoln')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lindsay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Linwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lion''s Head')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Listowel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Little Britain')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Little Current')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lively')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lombardy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'London')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Long Lac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Long Lake First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Long Point')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Long Sault')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Longlac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lorne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lucan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lucknow')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lyn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Lynden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'L''Orignal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Maberly')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Macdiarmid')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'MacTier')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Madoc')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Madsen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Magnetawan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Magnetawan First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Maitland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Mallorytown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Malton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Manitouwadge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Manitowaning')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Manotick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Maple')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Marathon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Markdale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Markham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Markstay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Marmora')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Marten Falls First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Marten River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Martintown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Massey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Matachewan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Matheson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Mattawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Mattice')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Maxville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Maynooth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'McDonalds Corners')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'McGregor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'McKellar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Meaford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Merlin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Merrickville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Metcalfe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Midland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Mildmay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Milford Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Millbrook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Millhaven')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Milton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Milverton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Minaki')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Mindemoya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Minden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Mine Centre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Missanabie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Mississauga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Mitchell')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Mohawks Of The Bay of Quinte F')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Monkton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Moonbeam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Moonstone')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Mooretown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Moose Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Moose Factory')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Moosonee')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Morrisburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Morson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Mount Albert')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Mount Brydges')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Mount Forest')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Mount Hope')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Mount Pleasant')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Muskoka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Muskoka Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Muskrat Dam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Muskrat Dam First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'M''Chigeeng')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Nairn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Naiscoutaing First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Nakina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Nanticoke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Napanee')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Navan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Nepean')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Nephton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Nestor Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Neustadt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'New Dundee')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'New Hamburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'New Liskeard')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'New Tecumseth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Newburgh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Newcastle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Newmarket')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Newtonville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Niagara Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Niagara-on-the-Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Nickel Centre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Nipigon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Nipissing First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Nobel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Nobleton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Noelville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'North Augusta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'North Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'North Gower')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'North Spirit Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'North York')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Northbrook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Norval')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Norwich')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Norwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Oak Ridges')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Oakville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Oakwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Oba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ogoki')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ohsweken')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Oil Springs')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ojibways of Hiawatha First Nat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ojibways of Walpole Island Fir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Omemee')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Onaping Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Oneida First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Opasatika')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ophir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Orangeville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Orillia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Orleans')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Oro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Orono')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Orrville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Osgoode')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Oshawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ottawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Otterville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Owen Sound')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Oxdrift')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Oxford Mills')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Paisley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Pakenham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Palgrave')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Palmer Rapids')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Palmerston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Paquette Corner')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Parham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Paris')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Parkhill')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Parry Sound')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Pass Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Peawanuck')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Pefferlaw')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Pelee Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Pelham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Pembroke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Penetanguishene')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Perrault Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Perth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Petawawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Peterborough')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Petrolia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Pickering')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Pickle Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Picton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Pikangikum First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Pineal Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Plantagenet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Plattsville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Pleasant Park')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Plevna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Point Grondine First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Point Pelee')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Pointe au Baril')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Port Burwell')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Port Carling')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Port Colborne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Port Credit')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Port Cunnington')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Port Dover')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Port Elgin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Port Franks')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Port Hope')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Port Lambton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Port Loring')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Port McNicoll')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Port Perry')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Port Robinson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Port Rowan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Port Stanley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Port Sydney')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Portland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Powassan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Prescott')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Preston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Princeton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Puce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Queenston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Queensville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Rainy Lake First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Rainy River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Raith')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ramore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Rayside-Balfour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Red Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Red Rock')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Redbridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Redditt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Renfrew')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Restoule')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Richmond Hill')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ridgetown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ridgeway')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ripley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Rockland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Rockwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Rodney')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Rolphton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Rondeau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Roseneath')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Rosseau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Russell')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Ruthven')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sachigo First Nation Reserve 1')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Saint Clair Beach')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Salem')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sandwich')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sandy Cove Acres')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sandy Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sandy Lake First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sapawe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sarnia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sauble Beach')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Saugeen First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sault Ste. Marie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Savant Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Scarborough')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Schomberg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Schreiber')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Scotland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Seaforth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Searchmont')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sebright')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sebringville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Seeleys Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Selby')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Selkirk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Serpent River First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Severn Bridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Shakespeare')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Shannonville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sharbot Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Shawanaga First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Shebandowan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Shedden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Shelburne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Silver Water')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Simcoe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sioux Lookout')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sioux Narrows')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Six Nations of the Grand River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Smiths Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Smithville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Smooth Rock Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Snelgrove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sombra')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'South Mountain')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'South River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Southampton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Spanish')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sparta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Spencerville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sprucedale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'St-Eugene')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'St. Catharines')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'St. Charles')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'St. Clements')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'St. Davids')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'St. George')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'St. Isidore de Prescott')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'St. Jacobs')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'St. Marys')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'St. Regis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'St. Thomas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Stayner')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Stevensville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Stewarttown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Stirling')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Stoke''s Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Stoney Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Stoney Point')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Stouffville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Straffordville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Strathroy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Stratton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Streetsville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Stroud')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sturgeon Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sudbury')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sultan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Summer Beaver')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sunderland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sundridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Swastika')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Sydenham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Tamworth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Tara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Tavistock')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Taylor Corners')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Tecumseh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Teeswater')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Temagami')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Terrace Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Thamesford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Thamesville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'The Eabametoong (Fort Hope) Fi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Thedford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Thessalon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Thessalon First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Thornbury')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Thorndale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Thorne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Thornhill')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Thorold')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Thunder Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Thurlow')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Tilbury')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Tillsonburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Timmins')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Tiverton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Tobermory')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Toledo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Toronto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Toronto Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Tottenham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Trenton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Trout Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Trowbridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Tweed')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Udora')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Uniondale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Unionville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Upsala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Utterson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Uxbridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Valley East')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Vankleek Hill')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Vaughan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Vermilion Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Verner')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Verona')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Victoria')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Vineland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Virginiatown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Wabigoon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Wainfleet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Walden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Walkerton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Wallaceburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Wapekeka First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Wardsville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Warkworth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Warren')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Wasaga Beach')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Waterdown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Waterford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Watford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Waubaushene')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Wawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Webbwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Webequie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Welcome')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Welland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Wellandport')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Wellesley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'West Guilford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'West Lincoln')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'West Lorne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Westmeath')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Westport')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Westree')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Wheatley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Whitby')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Whitchurch-Stouffville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'White River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Whitefish')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Whitefish Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Whitefish River First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Whitney')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Wiarton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Wikwemikong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Wilberforce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Williamsburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Winchester')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Windermere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Wingham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Winona')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Woodbridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Woodstock')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Woodville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Wooler')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Wunnummin Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Wyoming')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Yarker')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'York')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Ontario', 'Zurich')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Acadia Valley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Acme')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Airdrie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Alberta Beach')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Alder Flats')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Alix')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Alliance')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Altario')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Andrew')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Anzac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Ardrossan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Arrowwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Ashmont')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Assumption')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Athabasca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Banff')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Barons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Barrhead')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Bashaw')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Bassano')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Bawlf')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Bear Canyon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Beaverlodge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Beiseker')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Bentley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Berwyn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Big Valley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Bindloss')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Black Diamond')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Blackfalds')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Blackie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Blue Ridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Bon Accord')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Bonanza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Bonnyville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Bow Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Bowden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Boyle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Bragg Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Breton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Brocket')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Brooks')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Brownvale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Bruderheim')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Burdett')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Byemoor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Cadomin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Calgary')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Calling Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Calmar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Camrose')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Canmore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Carbon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Cardston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Carmangay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Caroline')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Carseland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Carstairs')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Castor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Cayley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Cereal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Cessford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Champion')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Chauvin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Chestermere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Chipewyan Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Clairmont')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Claresholm')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Clive')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Clyde')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Coaldale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Coalhurst')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Cold Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Conklin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Consort')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Coronation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Coutts')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Cowley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Craigmyle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Cremona')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Crossfield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Crowsnest Pass')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Czar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Daysland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'DeBolt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Delburne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Delia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Derwent')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Devon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Dewberry')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Didsbury')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Dixonville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Donalda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Donnelly')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Drayton Valley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Drumheller')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Duchess')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Eaglesham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'East Coulee')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Eckville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Edgerton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Edmonton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Edson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Elk Point')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Elkwater')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Elnora')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Empress')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Enchant')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Etzikom')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Evansburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Exshaw')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Fairview')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Falher')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Faust')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Ferintosh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Flatbush')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Foremost')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Forestburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Fort Assiniboine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Fort Chipewyan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Fort MacKay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Fort Macleod')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Fort McMurray')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Fort Saskatchewan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Fort Vermilion')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Fox Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Fox Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Gadsby')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Galahad')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Gibbons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Gift Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Girouxville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Gleichen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Glendon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Grand Centre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Grande Cache')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Grande Prairie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Granum')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Grassland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Grassy Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Grimshaw')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Grouard')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Hairy Hill')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Halkirk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Hanna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Hardisty')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Hay Lakes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Hays')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Heinsburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Heisler')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'High Level')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'High Prairie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'High River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Hilda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Hines Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Hinton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Hobbema')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Holden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Hughenden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Hussar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Hythe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Innisfail')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Innisfree')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Irma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Iron Springs')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Irricana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Irvine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Islay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Jarvie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Jenner')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Joussard')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Kananaskis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Keephills')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Keg River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Killam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Kinuso')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Kitscoty')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'La Crete')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Lac La Biche')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Lacombe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Lake Louise')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Lamont')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Langdon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Lavoy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Leduc')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Legal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Leslieville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Lethbridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Lodgepole')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Lomond')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Longview')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Lougheed')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Ma-Me-O Beach')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Magrath')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Manning')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Mannville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Manyberries')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Marlboro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Marwayne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Mayerthorpe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'McLennan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Meander River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Medicine Hat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Milk River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Millet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Milo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Minburn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Mirror')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Morinville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Morley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Morrin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Mulhurst')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Mundare')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Myrnam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Namao')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Nampa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Nanton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'New Dayton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'New Norway')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'New Sarepta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Newbrook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Nisku')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Niton Junction')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Nobleford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Nordegg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Okotoks')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Olds')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Onoway')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Oyen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Paradise Valley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Peace River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Peerless Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Peers')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Penhold')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Picture Butte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Pincher Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Plamondon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Ponoka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Provost')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Radway')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Rainbow Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Ralston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Raymond')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Red Deer')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Redcliff')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Redwater')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Rimbey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Robb')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Rochester')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Rocky Mountain House')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Rockyford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Rolling Hills')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Rosalind')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Rosebud')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Rumsey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Rycroft')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Ryley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Sangudo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Saskatchewan River Crossing')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Schuler')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Seba Beach')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Sedgewick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Seven Persons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Sexsmith')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Sherwood Park')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Sibbald')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Silver Valley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Slave Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Smith')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Smoky Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Spirit River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Spruce Grove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Spruce View')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'St. Albert')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'St. Michael')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'St. Paul')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Stand Off')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Standard')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Stavely')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Stettler')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Stony Plain')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Strathmore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Strome')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Sundre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Swan Hills')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Sylvan Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Taber')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Thorhild')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Thorsby')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Three Hills')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Tilley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Tofield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Tomahawk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Torrington')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Trochu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Turner Valley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Two Hills')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Valleyview')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Vauxhall')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Vegreville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Vermilion')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Veteran')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Viking')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Vilna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Vulcan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Wabamun')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Wainwright')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Walsh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Wandering River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Wanham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Warburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Warner')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Warspite')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Waskatenau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Wembley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Westlock')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Wetaskiwin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Whitecourt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Whitelaw')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Widewater')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Wildwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Willingdon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Woking')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Worsley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Wrentham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Alberta', 'Youngstown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', '108 Mile House')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', '108 Mile Ranch')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', '150 Mile House')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Abbotsford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Agassiz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Ahousat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Aldergrove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Alert Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Alexis Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Alkali Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Ashcroft')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Atlin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Avola')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Balfour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Bamfield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Barriere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Beach Grove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Bear Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Beaver Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Beaverdell')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Bella Bella')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Bella Coola')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Black Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Black Point')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Blue River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Bob Quinn Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Boston Bar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Boswell')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Bowen Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Bowser')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Bridge Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Britannia Beach')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Burnaby')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Burns Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Cache Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Campbell River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Canal Flats')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Cassiar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Castlegar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Celista')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Chase')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Chemainus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Chetwynd')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Chilliwack')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Christina Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Clearwater')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Cobble Hill')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Colwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Comox')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Coquitlam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Courtenay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Cowichan Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Cranbrook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Crawford Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Crescent Beach')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Creston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Dawson Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Dease Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Donald')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Douglas Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Duncan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Dunster')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'D`Arcy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'East Pine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Elkford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Elko')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Enderby')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Estevan Point')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Fairmont Hot Springs')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Falkland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Fernie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Forest Grove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Fort Fraser')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Fort Nelson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Fort St. James')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Fort St. John')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Fraser Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Fruitvale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Gabriola')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Galiano Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Ganges')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Gibsons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Giscome')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Gold Bridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Gold River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Golden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Good Hope Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Grand Forks')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Granisle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Grasmere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Grassy Plains')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Greenville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Hartley Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Hazelton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Hedley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Hemlock Valley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Hendrix Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Hixon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Holberg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Hope')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Horsefly')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Houston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Hudson`s Hope')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Invermere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Iskut')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Jaffray')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Kamloops')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Kaslo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Kelowna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Kemano')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Keremeos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Kimberley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Kincolith')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Kitimat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Kitkatla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Kitsault')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Kitwanga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Klemtu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Kyuquot')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Lac la Hache')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Ladysmith')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Lake Cowichan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Langara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Langley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Lantzville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Likely')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Lillooet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Little Fort')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Logan Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Loos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Lower Post')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Lumby')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Lytton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Mackenzie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Maple Ridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Masset')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'McBride')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'McLeese Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'McLeod Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Merritt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Mica Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Midway')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Mission')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Montney')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Moyie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Muncho Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Nakusp')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Nanaimo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Naramata')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Nelson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'New Aiyansh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'New Denver')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'New Westminster')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Nimpo Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'North Saanich')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'North Vancouver')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Ocean Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Ocean Park')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Okanagan Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Oliver')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Osoyoos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Oyama')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Parksville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Parson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Peachland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Pemberton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Penticton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Pitt Meadows')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Port Alberni')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Port Alice')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Port Clements')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Port Coquitlam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Port Edward')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Port Hardy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Port McNeill')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Port Mellon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Port Moody')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Port Renfrew')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Pouce Coupe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Powell River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Prespatou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Prince George')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Prince Rupert')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Prophet River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Quadra Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Qualicum Beach')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Queen Charlotte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Quesnel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Radium Hot Springs')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Revelstoke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Riondel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Riske Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Rock Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Rolla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Rossland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Saanich')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Salmo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Salmon Arm')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Salmon Valley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Sandspit')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Savona')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Sayward')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Sechelt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Shalalth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Sicamous')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Skookumchuck')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Slocan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Smithers')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Sointula')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Sooke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Sorrento')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'South Slocan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Sparwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Spences Bridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Spillimacheen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Squamish')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Stewart')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Summerland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Summit Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Surrey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Tachie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Tahsis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Tatla Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Taylor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Telegraph Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Telkwa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Terrace')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Thrums')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Toad River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Tofino')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Topley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Trail')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Tsay Keh Dene')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Tumbler Ridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Ucluelet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Valemount')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Vallican')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Van Anda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Vancouver')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Vanderhoof')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Vavenby')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Vernon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'View Royal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Wells')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'West Vancouver')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Westbank')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Westwold')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Whistler')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'White Rock')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Williams Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Willowbrook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Winfield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Winter Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Wonowon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Wynndel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Yahk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Yale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Youbou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('British Columbia', 'Zeballos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Agassiz Provincial Forest')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Alexander')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Alonsa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Altona')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Arborg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Ashern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Austin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Baldur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Basswood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Beausejour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Benito')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Berens River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Beulah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Binscarth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Birtle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Bissett')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Boissevain')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Brandon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Brochet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Brookdale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Camperville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Carberry')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Carman')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Churchill')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Cormorant')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Cowan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Cranberry Portage')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Crandall')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Cross Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Crystal City')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Cypress River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Darlingford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Dauphin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Deloraine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Dominion City')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Dugald')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Easterville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Eddystone')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Edwin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Elie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Elkhorn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Elm Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Emerson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Erickson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Eriksdale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Ethelbert')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Falcon Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Fisher Branch')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Fisher River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Flin Flon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Fork River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Foxwarren')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Gilbert Plains')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Gillam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Gimli')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Gladstone')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Glenboro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Glenella')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Gods Lake Narrows')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Grand Beach')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Grand Rapids')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Grandview')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Gretna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Gypsumville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Hadashville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Hamiota')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Hartney')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Hecla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Holland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Ilford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Island Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Kelwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Kenton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'La Broquerie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Lac Brochet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Lac du Bonnet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Langruth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Leaf Rapids')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Libau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Little Grand Rapids')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Lockport')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Lundar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Lynn Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'MacGregor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Mafeking')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Manigotagan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Manitou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'McAuley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'McCreary')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Melita')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Miami')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Miniota')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Minnedosa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Moose Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Morden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Morris')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Neepawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Nelson House')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Newdale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Niverville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Norway House')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Oak Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Oak River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Ochre River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Oxford House')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Peguis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Pelican Rapids')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Pikwitonei')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Pilot Mound')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Pinawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Pine Dock')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Pine Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Pine River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Piney')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Plum Coulee')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Plumas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Pointe du Bois')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Poplar River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Poplarfield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Portage la Prairie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Rapid City')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Rathwell')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Red Sucker Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Rennie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Reston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Rivers')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Riverton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Roblin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Roland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Rorketon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Rossburn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Sanford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Shamattawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Shilo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Shoal Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Sidney')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Sifton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Snow Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Snowflake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Somerset')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'South Indian Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Sperling')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Split Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Sprague')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'St-Pierre-Jolys')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'St. Claude')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'St. Francois Xavier')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'St. Jean Baptiste')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'St. Laurent')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'St. Lazare')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Starbuck')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Ste. Agathe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Ste. Rose du Lac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Steep Rock')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Steinbach')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Stonewall')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Strathclair')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Swan Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Swan River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Tadoule Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Teulon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'The Pas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Thicket Portage')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Thompson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Treherne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Virden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Vita')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Waasagomach')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Wabowden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Wanless')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Wasagaming')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Waterhen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Wawanesa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Whitemouth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Winkler')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Winnipeg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Winnipeg Beach')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Winnipegosis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Manitoba', 'Woodridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Albert')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Albert Mines')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Allardville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Baie-Ste-Anne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Baker Brook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Balmoral')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Bathurst')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Belledune')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Beresford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Blacks Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Blackville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Boiestown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Bouctouche')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Browns Flat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Campobello Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Canterbury')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Cap-Pele')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Caraquet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Centreville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Chipman')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Clair')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Clarks Corners')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Cocagne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Dalhousie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Debec')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Dieppe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Doaktown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Edmundston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Florenceville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Fords Mills')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Fredericton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Fredericton Junction')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Gagetown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Glassville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Grand Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Grand Manan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Grand-Sault')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Grande-Anse')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Harewood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Hartland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Hillsborough')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Hoyt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Jacquet River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Kedgwick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Lameque')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Maces Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'McAdam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Meductic')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Memramcook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Millville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Minto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Miramichi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Miscou Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Moncton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Nackawic')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Neguac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'New Denmark')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Norton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Oromocto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Paquetville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Perth-Andover')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Petit Rocher')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Petitcodiac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Plaster Rock')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Quispamsis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Red Bank')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Richibucto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Riverview')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Rogersville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Rothesay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Sackville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Saint Andrews')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Saint John')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Salisbury')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Shediac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Shippagan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'St-Basile')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'St-Isidore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'St-Louis de Kent')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'St-Quentin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'St. Leonard')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'St. Martins')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'St. Stephen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Stanley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Ste-Anne-de-Madawaska')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Summerville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Sussex')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Tabusintac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Tobique First Nation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Tracadie-Sheila')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Welsford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Westfield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('New Brunswick', 'Young`s Cove Road')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Appleton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Argentia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Arnold`s Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Avondale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Badger')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Baie Verte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Batteau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Battle Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Bauline')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Bay Bulls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Bay de Verde')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Bay L`Argent')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Bay Roberts')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Bell Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Belleoram')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Bellevue')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Benoit`s Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Birchy Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Bishop`s Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Black Duck Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Black Tickle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Bonavista')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Botwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Boyd`s Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Branch')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Brent`s Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Brigus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Buchans')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Burgeo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Burin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Burnt Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Campbellton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Cape Broyle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Carbonear')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Carmanville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Cartwright')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Catalina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Centreville-Wareham-Trinity')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Chance Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Change islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Chapel Arm')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Churchill Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Clarenville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Clarenville-Shoal Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Clarke`s Beach')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Codroy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Colliers')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Come By Chance')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Comfort Cove-Newstead')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Conception Bay South')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Conception Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Conche')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Conne River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Cook`s Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Corner Brook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Cottlesville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Cow Head')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Cupids')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Daniel`s Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Davis Inlet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Dover')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Eastport')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Elliston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Embree')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Englee')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'English Harbour East')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Fair Haven')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Fermeuse')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Flatrock')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Fleur de Lys')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Flower`s Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Fogo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Forteau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Fortune')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Fox Cove-Mortier')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Frenchmans Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Freshwater')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Gambo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Gander')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Garnish')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Gaultois')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Glenwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Glovertown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Goose Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Grand Bank')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Grand Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Grand Falls-Windsor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Great Harbour Deep')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Green Island Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Greenspond')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Hampden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Hant`s Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Happy Valley-Goose Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Harbour Breton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Harbour Grace')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Harbour Main-Chapel Cove-Lakev')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Hare Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Hawke`s Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Heart`s Content')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Heart`s Delight-Islington')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Heart`s Desire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Hickman`s Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Hillgrade')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Hillview')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Holyrood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Hopedale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Howley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Humber Arm South')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Indian Tickle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Island Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Isle aux Morts')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Jackson`s Arm')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Jamestown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Joe Batt`s Arm-Barr`d Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'King`s Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'King`s Point')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Kippens')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'La Scie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Labrador City')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Ladle Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Lamaline')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Lark Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Lawn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Lewisporte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Little Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Little Bay Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Little Burnt Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Little Catalina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Little Heart`s Ease')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Logy Bay-Middle Cove-Outer Cov')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Long Harbour-Mount Arlington H')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Long Pond')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Lourdes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Lower Island Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'L`Anse-au-Loup')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Main Brook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Makkovik')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Marystown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Mary`s Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Massey Drive')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'McIver`s')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Millertown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Milltown-Head of Bay D`Espoir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Ming`s Bight')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Monkstown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Mount Carmel-Mitchells Brook-S')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Mount Moriah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Mount Pearl')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Musgrave Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Musgravetown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Nain')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'New Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'New Perlican')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'New-Wes-Valley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Nippers Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Norman`s Cove-Long Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Norris Arm')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'North West River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Northern Arm')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Old Perlican')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Packs Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Pacquet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Paradise')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Paradise River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Pasadena')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Peterview')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Petty Harbour-Maddox Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Placentia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Plate Cove East')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Point Leamington')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Pool`s Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Port au Choix')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Port au Port West-Aguathuna-Fe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Port Aux Basques')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Port Blandford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Port Hope Simpson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Port Rexton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Port Saunders')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Port Union')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Portugal Cove-St. Philip`s')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Postville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Pouch Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Raleigh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Ramea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Red Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Reefs Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Rencontre East')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Rigolet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'River of Ponds')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Robert`s Arm')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Rocky Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Roddickton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Rose Blanche-Harbour Le Cou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Rushoon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Salmon Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Salvage')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Seal Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Seldom-Little Seldom')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Small Point-Broad Cove-Blackhe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'South Brook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Southern Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Spaniard`s Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Spotted Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Springdale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'St. Alban`s')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'St. Anthony')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'St. Bernard`s-Jacques Fontaine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'St. Brendan`s')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'St. Bride`s')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'St. George`s')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'St. Jacques-Coomb`s Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'St. John`s')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'St. Lawrence')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'St. Lewis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'St. Lunaire-Griquet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'St. Mary`s')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'St. Vincent`s-St. Stephen`s-Pe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Steady Brook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Stephenville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Stephenville Crossing')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Summerford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Sunnyside')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Terra Nova')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Terrenceville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Torbay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Trepassey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Triton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Trout River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Twillingate')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Upper Island Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Wabana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Wabush')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Wesleyville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Western Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Whitbourne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Winterton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Witless Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Newfoundland', 'Woody Point')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Aklavik')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Edzo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Fort Good Hope')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Fort Liard')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Fort McPherson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Fort Providence')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Fort Simpson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Fort Smith')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Hay River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Inuvik')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Jean Marie River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Kakisa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Kugluktuk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Nahanni Butte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Norman Wells')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Rae')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Rae Lakes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Trout Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Tsiigehtchic')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Tuktoyaktuk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Wrigley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Northwest Territories', 'Yellowknife')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Advocate Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Amherst')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Annapolis Royal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Antigonish')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Argyle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Arichat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Aylesford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Baddeck')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Bass River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Bear River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Berwick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Blandford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Boisdale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Boularderie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Bridgetown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Bridgewater')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Brookfield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Canning')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Canso')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Caribou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Chester')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Cheticamp')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Cheverie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Clarksville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Clark`s Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Collingwood Corner')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Dartmouth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Debert')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Digby')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Dingwall')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Dundee')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'East Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Ecum Secum')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Elmsdale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Eskasoni')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Freeport')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'French Village')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Gabarus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Glace Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Goldboro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Goshen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Grand Etang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Grand Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Grand Narrows')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Great Village')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Greenwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Guysborough')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Halifax')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Hantsport')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Heatherton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Hopewell')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Hubbards')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Ingonish')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Kennetcook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Kentville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Kenzieville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Ketch Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'LaHave')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Lake Charlotte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Larrys River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Lawrencetown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Liverpool')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Lockeport')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Louisbourg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Louisdale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Lunenburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'L`Ardoise')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Mabou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Maccan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Mahone Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Margaree Forks')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Marion Bridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Melrose')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Merigomish')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Meteghan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Middleton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Monastery')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Mount Uniacke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Mulgrave')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Musquodoboit Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'New Germany')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'New Ross')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'New Waterford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Noel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'North Sydney')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Oxford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Parrsboro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Peggy`s Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Pictou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Port Bickerton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Port Dufferin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Port Greville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Port Hawkesbury')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Port Hood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Port La Tour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Port Maitland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Port Morien')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Port Mouton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Pubnico')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Pugwash')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Queensport')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'River Hebert')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'River John')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Riverport')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Salt Springs')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Saulnierville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Shubenacadie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Springfield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Springhill')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'St. Margaret Village')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'St. Peter`s')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Stellarton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Stewiacke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Sydney')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Tangier')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Tatamagouche')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Thorburn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Truro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Tusket')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Upper Musquodoboit')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Upper Stewiacke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Wallace')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Walton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Waverley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Wedgeport')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Westville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Weymouth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Whycocomagh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Wolfville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nova Scotia', 'Yarmouth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nunavut', 'Arviat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nunavut', 'Baker Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nunavut', 'Cambridge Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nunavut', 'Cape Dorset')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nunavut', 'Chesterfield Inlet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nunavut', 'Coral Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nunavut', 'Gjoa Haven')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nunavut', 'Iqaluit')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nunavut', 'Rankin Inlet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nunavut', 'Resolute')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Nunavut', 'Whale Cove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Alberton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Bedeque')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Cardigan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Charlottetown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Cornwall')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Covehead')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Crapaud')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'East Point')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Eldon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Georgetown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Hunter River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Kensington')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Montague')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Morell')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Mount Stewart')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Murray River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'New Haven')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'New London')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'O`Leary')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Rusticoville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Souris')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'South Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'St. Peters')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Summerside')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Tignish')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Tyne Valley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Vernon River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Prince Edward Island', 'Wellington')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Abercorn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Acton Vale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Adamsville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Aguanish')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Albanel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Alma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Alouette')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Amos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Amqui')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Angliers')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Anjou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Anse-Saint-Jean')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Armagh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Arundel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Asbestos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ascot')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ascot Corner')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ashuapmushuan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Aston-Jonction')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ayer`s Cliff')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Aylmer')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Bagotville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Baie-Comeau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Baie-de-Shawinigan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Baie-des-Sables')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Baie-du-Febvre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Baie-d`Urfe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Baie-Johan-Beetz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Baie-Sainte-Catherine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Baie-St-Paul')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Baie-Trinite')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Barachois')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Barkmere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Barraute')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Batiscan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Beaconsfield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Beaucanton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Beauceville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Beauharnois')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Beaulac-Garthby')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Beaumont')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Beauport')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Beaupre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Becancour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Bedford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Belle Neige')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Bellefeuille')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Belleterre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Beloeil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Bergeronnes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Berthierville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Betsiamites')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Biencourt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Bishopton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Black Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Blainville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Blanc-Sablon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Bois-des-Filion')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Boisbriand')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Boischatel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Bonaventure')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Bonne-Esperance')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Boucherville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Bouchette')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Breakeyville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Brigham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Brome')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Bromont')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Bromptonville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Brossard')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Brownsburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Bryson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Buckingham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Bury')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Cabano')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Cacouna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Calumet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Campbell`s Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Candiac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Cantley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Cap-a-l`Aigle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Cap-aux-Meules')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Cap-Chat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Cap-de-la-Madeleine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Cap-des-Rosiers')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Cap-Rouge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Cap-Saint-Ignace')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Caplan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Carignan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Carillon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Carleton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Causapscal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Chambly')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Chambord')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Champlain')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Chandler')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Chapais')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Chapeau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Charette')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Charlemagne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Charlesbourg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Charlevoix')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Charny')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Chartierville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Chateau-Richer')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Chateauguay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Chelsea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Cheneville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Chesterville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Chevery')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Chibougamau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Chicoutimi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Chisasibi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Chomedey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Chute-aux-Outardes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Chute-des-Passes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Clericy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Clermont')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Cloridorme')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Clova')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Coaticook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Colombier')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Compton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Contrecoeur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Cookshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Cote-St-Luc')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Coteau-du-Lac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Courcelette')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Courcelles')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Cowansville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Crabtree')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Danville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Daveluyville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Deauville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Degelis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Delson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Desbiens')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Deschaillons-sur-Saint-Laurent')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Deux-Montagnes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Disraeli')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Dolbeau-Mistassini')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Dollard-des-Ormeaux')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Donnacona')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Dorval')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Drummondville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Dubuisson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Dunham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Duparquet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Dupuy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Duvernay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'East Angus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'East Broughton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'East Farnham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'East Hereford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Eastmain')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Eastman')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Entrelacs')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Esterel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Evain')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Fabre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Fabreville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Falardeau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Farnham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Fassett')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ferland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ferme-Neuve')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Fermont')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Fleurimont')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Forestville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Fort-Coulonge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Fortierville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Fossambault-sur-le-Lac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Frampton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Franklin Centre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Frelighsburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Fugereville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Gaspe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Gatineau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Gentilly')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Girardville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Godbout')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Gracefield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Granby')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Grand-Mere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Grand-Remous')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Grande-Entree')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Grande-Riviere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Grande-Vallee')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Grandes-Bergeronnes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Grandes-Piles')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Greenfield Park')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Grenville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Guigues')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ham-Nord')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Hammond')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Hampstead')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Harrington Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Havre-Aubert')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Havre-aux-Maisons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Havre-St-Pierre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Hebertville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Hebertville-Station')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Hemmingford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Henryville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Howick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Hudson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Hull')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Huntingdon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Iberville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ile-aux-Coudres')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Iles-de-la-Madeleine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Inukjuak')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Inverness')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Joliette')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Jonquiere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Joutel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Kangiqsualujjuaq')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Kangirsuk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Kateville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Kazabazua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Kingsbury')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Kingsey Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Kirkland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Knowlton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Kuujjuaq')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'La Baie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'La Corne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'La Dore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'La Grande')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'La Guadeloupe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'La Malbaie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'La Martre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'La Minerve')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'La Patrie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'La Plaine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'La Pocatiere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'La Prairie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'La Reine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'La Romaine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'La Sarre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'La Tuque')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Labelle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lac Kenogami')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lac-au-Saumon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lac-aux-Sables')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lac-Bouchette')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lac-Brome')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lac-Delage')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lac-des-Ecorces')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lac-Drolet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lac-du-Cerf')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lac-Edouard')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lac-Etchemin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lac-Frontiere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lac-Poulin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lac-Saguay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lac-Sergent')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lac-St-Joseph')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lachenaie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lachine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lachute')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lacolle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lafontaine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lake Megantic')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lambton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lanoraie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'LaSalle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Laterriere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Latulipe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Laurentides')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Laurier-Station')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Laurierville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Laval')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Laval des Rapides')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Laval Ouest')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lavaltrie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Laverlochere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lawrenceville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Le Bic')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Le Gardeur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lebel-sur-Quevillon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Leclercville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'LeMoyne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lennoxville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lery')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Les Boules')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Les Cedres')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Les Coteaux')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Les Eboulements')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Les Escoumins')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Les Mechins')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Levis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Longueuil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Loretteville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lorraine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lorrainville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Louiseville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lourdes de Blanc Sablon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Louvicourt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Low')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Luceville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Luskville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Lyster')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'L`Acadie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'L`Ancienne-Lorette')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'L`Ange-Gardien')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'L`Annonciation')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'L`Assomption')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'L`Avenir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'L`Epiphanie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'L`Ile-Aux-Noix')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'L`Ile-Bizard')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'L`Ile-Cadieux')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'L`Ile-Dorval')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'L`Ile-d`Entree')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'L`Ile-Perrot')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'L`&Icirc;le-Verte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'L`Islet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Macamic')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Magog')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Malartic')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Manic-Cinq')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Maniwaki')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Manouane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Manseau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mansonville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Maple Grove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Maria')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Marieville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Marsoui')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mascouche')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Maskinonge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Masson-Angers')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Massueville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mastigouche')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Matagami')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Matane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Matapedia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mcmasterville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Melbourne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mellin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Melocheville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mercier')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Metabetchouan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Metis-sur-Mer')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mirabel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mistassini')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Moisie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mont Bechervaise')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mont St Gr&eacute;goire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mont-Joli')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mont-Laurier')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mont-Louis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mont-Rolland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mont-Royal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mont-St-Hilaire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mont-St-Pierre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mont-Tremblant')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Montebello')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Montmagny')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Montreal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Montreal - Est')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Montr&eacute;al - Nord')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Montr&eacute;al - Ouest')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Morin-Heights')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Murdochville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Mutton Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Nantes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Napierville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Natashquan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Nedelec')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Neuville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'New Carlisle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'New Glasgow')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'New Richmond')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Newport')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Nicolet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Norbertville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Normandin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Normetal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'North Hatley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Notre Dame de Bonsecours')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Notre Dame de Lourdes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Notre Dame De L`Ile Perrot')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Notre Dame des Laurentides')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Notre Dame Des Prairies')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Notre Dame Du Portage')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Notre-Dame-de-la-Paix')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Notre-Dame-de-la-Salette')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Notre-Dame-de-Stanbridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Notre-Dame-du-Bon-Conseil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Notre-Dame-du-Lac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Notre-Dame-du-Laus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Notre-Dame-du-Nord')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Nouvelle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Oka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Omerville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Orford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ormstown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Otterburn Park')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Outremont')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Palmarolle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Papineauville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Parent')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Perce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Peribonka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Perkins')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Petite-Riviere-St-Francois')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Philipsburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Pierrefonds')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Pierreville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Pincourt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Pintendre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Plaisance')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Plessisville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Pohenegamook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Pointe Aux Trembles')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Pointe-a-la-Croix')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Pointe-au-Pere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Pointe-aux-Outardes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Pointe-Calumet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Pointe-Claire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Pointe-des-Cascades')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Pointe-des-Monts')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Pointe-Fortune')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Pointe-Lebel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Pont-Rouge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Pont-Viau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Pontiac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Port-Cartier')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Port-Daniel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Port-Menier')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Portage-du-Fort')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Portneuf')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Poste-de-la-Baleine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Prevost')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Price')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Princeville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Puvirnituq')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Quebec')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Quyon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Rawdon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Remigny')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Repentigny')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'R&eacute;serve faunique de Rimouski')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'R&eacute;serve faunique la V&eacute;rendrye')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'R&eacute;serves fauniques de Matane e')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Richelieu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Richmond')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Rigaud')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Rimouski')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Rimouski-Est')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ripon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Riviere-a-Pierre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Riviere-au-Renard')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Riviere-au-Tonnerre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Riviere-Beaudette')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Riviere-Bleue')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Riviere-du-Loup')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Riviere-Heva')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Riviere-St-Jean')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Robertsonville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Roberval')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Rochebaucourt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Rock Forest')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Rollet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Rosemere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Rougemont')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Rouyn-Noranda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Roxboro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Roxton Falls')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Roxton Pond')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sabrevois')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sacre Coeur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Alexandre D`Iberville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Alphonse de Granby')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Amable')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Antoine Des Laurentides')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Antoine Sur Richelieu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Antonin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Athanase')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Calixte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Charles Borromee')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Charles Sur Richelieu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Christophe D`Arthabaska')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Colomban')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Denis De Brompton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Denis Sur Richelieu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Esprit')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Etienne de Beauharnois')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Etienne de Lauzon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Gerard Majella')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Isidore de la Prairie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Jean Baptiste')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Jean D`Orleans')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Joachim')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Joseph De La Pointe De L')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Laurent D`Orleans')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Lazare De Vaudreuil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Lin Laurentides')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Marc Sur Richelieu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Mathias Sur Richelieu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Mathieu de Beloeil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Mathieu de la Prairie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Maurice')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Norbert D`Arthabaska')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Paul D`Industrie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Philippe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Pierre D`Orleans')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Robert')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Roch De L`Achigan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Roch De Richelieu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Sulpice')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Thomas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Urbain Premier')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Valere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint Victoire de Sorel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint-Alexis-de-Montcalm')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint-C&ocirc;me')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint-Donat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint-&Eacute;lie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint-&Eacute;lie-d`Orford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint-Ferdinand')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint-Ferr&eacute;ol-les-neiges')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint-Hubert')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint-Hyacinthe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Saint-Michel-des-Saints')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sainte Angele De Monnoir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sainte Ann De Sorel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sainte Brigide D`Iberville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sainte Cecile De Milton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sainte Dorothe&eacute;')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sainte Famille')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sainte Marie Salome')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sainte Marthe Du Cap')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sainte Sophie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sainte Therese De Blainville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Salaberry-de-Valleyfield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Salluit')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sanmaur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sault-au-Mouton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sawyerville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sayabec')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Schefferville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Scotstown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Senneterre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Senneville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sept-Iles')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Shawbridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Shawinigan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Shawinigan-Sud')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Shawville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Shefford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sherbrooke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Shigawake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Shipshaw')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sillery')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sorel-Tracy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Squatec')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Adelphe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Adolphe-de-Dudswell')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Adolphe-d`Howard')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Agapit')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Aime')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Albert')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Alexandre-de-Kamouraska')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Alexis-de-Matapedia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Alexis-des-Monts')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Alphonse-Rodriguez')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Andre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Andre-Avellin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Andre-du-Lac-St-Jean')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Andre-Est')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Anselme')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Antoine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Antoine-de-Tilly')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Apollinaire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Augustin-de-Desmaures')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Barnabe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Barthelemy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Basile-le-Grand')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Basile-Sud')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Blaise-sur-Richelieu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Boniface-de-Shawinigan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Bruno')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Bruno-de-Montarville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Calixte-de-Kilkenny')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Casimir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Celestin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Cesaire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Charles-de-Bellechasse')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Chrysostome')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Clet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Constant')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Cyrille-de-Wendover')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Damase')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Damien-de-Buckland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Denis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Edouard-de-Lotbiniere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Eleuthere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Emile')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Emile-de-Suffolk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Ephrem-de-Beauce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Ephrem-de-Tring')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Eugene-de-Guigues')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Eustache')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Fabien-de-Panet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Felicien')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Felix-de-Kingsey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Felix-de-Valois')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Fidele-de-Mont-Murray')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Flavien')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Francois-du-Lac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Fulgence')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Gabriel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Gabriel-de-Brandon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Gedeon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Georges')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Georges-de-Beauce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Georges-de-Cacouna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Gerard')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Germain-de-Grantham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Gregoire-de-Greenlay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Guillaume')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Hilarion')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Hippolyte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Honore-de-Beauce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Honore-de-Chicoutimi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Hugues')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Irenee')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Jacques')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Jean-Chrysostome')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Jean-de-Dieu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Jean-de-Matha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Jean-Port-Joli')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Jean-sur-Richelieu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Jerome')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Joseph-de-Beauce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Joseph-de-la-Rive')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Joseph-de-Sorel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Jovite')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Jude')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Just-de-Bretenieres')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Lambert')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Lambert-de-Lauzon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Laurent')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Leon-le-Grand')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Leonard')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Leonard-d`Aston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Liboire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Lin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Louis-de-France')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Luc')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Ludger')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Magloire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Malachie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Malo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Marc-des-Carrieres')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Methode-de-Frontenac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Michel-de-Bellechasse')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Moose')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Nazaire-d`Acton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Nicolas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Noel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Odilon-de-Cranbourne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Ours')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Pacome')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Pamphile')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Pascal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Patrice-de-Beaurivage')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Paul-de-Montminy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Paul-d`Abbotsford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Paulin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Philippe-de-Neri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Pie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Pie-de-Guire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Pierre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Pierre-de-Wakefield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Pierre-les-Becquets')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Polycarpe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Prime')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Prosper-de-Dorchester')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Raymond')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Redempteur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Remi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Rene-de-Matane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Roch-de-Mekinac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Roch-des-Aulnaies')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Romuald')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Sauveur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Sauveur-des-Monts')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Simeon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Simon-de-Bagot')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Simon-de-Rimouski')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Sylvere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Sylvestre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Theophile')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Thomas-d`Aquin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Timothee')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Tite')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Tite-des-Caps')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Ubalde')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Ulric')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Urbain')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Victor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Wenceslas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Zacharie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Zenon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Zephirin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St-Zotique')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Ambroise de Chicoutimi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Basile de Portneuf')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Bernard de Dorchester')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Come de Kennebec')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Edouard de Frampton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Fabien de Rimouski')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Ferdinand d`Halifax')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Fidele')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Gabriel de Rimouski')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Gedeon de Beauce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Gregoire de Nicolet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Henri de Levis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Honore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Leon De Chic.')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Martin de Beauce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Moise')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Raphael de Bellechasse')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Sebastien')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Stanislas de Champlain')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Theodore de Chertsey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Victor de Beauce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'St. Vincent de Paul')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Stanstead')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Adele')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Agathe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Agathe-des-Monts')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Agathe-Sud')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Anne-de-Beaupre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Anne-de-Bellevue')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Anne-de-la-Perade')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Anne-de-Portneuf')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Anne-des-Monts')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Anne-des-Plaines')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Anne-du-Lac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Blandine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Brigitte-de-Laval')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Catherine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Clotilde-de-Horton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Eulalie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Felicite')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Foy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Genevieve')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Helene-de-Bagot')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Henedine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Jeanne-d`Arc')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Julie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Julie-de-Vercheres')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Julienne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Justine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Lucie-de-Beauregard')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Madeleine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Marguerite')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Marie-de-Beauce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Marie-de-Blandford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Marthe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Marthe-sur-le-Lac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Perpetue')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Petronille')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Rosalie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Rose')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Rose-de-Watford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Rose-du-Nord')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Sophie-de-Levrard')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Thecle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Therese')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Veronique')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste-Victoire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste. Agathe de Lotbiniere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste. Angele de Laval')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste. Cecile Masham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste. Claire de Dorchester')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste. Croix de Lotbiniere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste. Gertrude')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste. Justine de Newton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste. Martine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste. Methode de Frontenac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ste. Monique de Nicolet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Stoke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Stoneham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Stratford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Stukely-Sud')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Sutton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Tadoussac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Taschereau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Tasiujaq')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Temiscaming')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Terrasse Vaudreuil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Terrebonne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Tete-a-la-Baleine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Thetford Mines')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Thurso')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Tingwick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Tremblay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Tring-Jonction')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Trois-Pistoles')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Trois-Rivieres')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Umiujaq')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Upton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Val-Alain')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Val-Barrette')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Val-Belair')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Val-Brillant')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Val-David')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Val-des-Bois')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Val-d`Or')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Valcartier')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Valcourt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Vallee-Jonction')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Vanier')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Varennes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Vaudreuil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Vaudreuil Dorion')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Vaudreuil-sur-le-Lac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Venise-en-Quebec')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Vercheres')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Verdun')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Victoriaville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Ville-Marie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Vimont')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Wakefield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Warden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Warwick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Waskaganish')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Waswanipi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Waterloo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Waterville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Weedon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Weedon Centre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Wemindji')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Wendover')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'West Brome')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Westbury')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Westmount')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Wickham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Windsor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Woburn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Wotton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Yamachiche')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Yamaska')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Quebec', 'Yamaska-Est')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Abbey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Aberdeen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Abernethy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Alameda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Alida')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Allan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Alsask')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Alvena')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Aneroid')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Arborfield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Archerwill')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Arcola')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Asquith')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Assiniboia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Avonlea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Balcarres')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Balgonie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Battleford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Beauval')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Beechy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Bengough')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Bethune')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Bienfait')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Big River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Biggar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Birch Hills')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Birsay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Blaine Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Borden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Bredenbury')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Briercrest')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Broadview')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Brock')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Bruno')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Buchanan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Buffalo Narrows')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Burstall')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Cabri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Cadillac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Calder')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Canoe Narrows')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Canora')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Canwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Carievale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Carlyle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Carnduff')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Caron')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Carrot River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Central Butte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Ceylon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Chaplin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Choiceland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Christopher Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Churchbridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Clavet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Climax')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Cochin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Coderre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Coleville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Colonsay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Conquest')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Consul')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Coronach')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Craik')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Creelman')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Creighton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Cudworth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Cumberland House')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Cupar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Cut Knife')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Dalmeny')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Davidson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Debden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Delisle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Denzil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Dillon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Dinsmore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Dodsland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Domremy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Drake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Dubuc')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Duck Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Dundurn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Dysart')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Earl Grey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Eastend')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Eatonia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Edam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Elbow')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Elfros')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Elrose')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Esterhazy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Estevan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Eston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Eyebrow')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Fillmore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Fleming')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Foam Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Fond-du-Lac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Fort Qu`Appelle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Fox Valley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Francis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Frobisher')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Frontier')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Gainsborough')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Glaslyn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Glen Ewen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Glenavon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Goodeve')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Goodsoil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Govan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Gravelbourg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Grayson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Green Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Grenfell')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Gull Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Hafford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Hague')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Hanley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Harris')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Hawarden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Hazlet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Hepburn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Herbert')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Herschel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Hodgeville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Holdfast')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Hudson Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Humboldt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Ile-a-la-Crosse')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Imperial')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Indian Head')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Invermay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Ituna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Jansen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Kamsack')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Kelliher')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Kelvington')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Kenaston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Kennedy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Kenosee')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Kerrobert')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Key Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Kincaid')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Kindersley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Kinistino')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Kipling')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Kisbey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Kyle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'La Loche')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'La Ronge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Lafleche')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Laird')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Lake Alma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Lake Lenore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Lampman')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Landis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Lang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Langenburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Langham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Lanigan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Lashburn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Leader')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Leask')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Lemberg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Leoville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Leroy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Lestock')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Liberty')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Limerick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Lintlaw')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Lipton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Lloydminster')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Loon Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Loreburn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Lucky Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Lumsden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Luseland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Macklin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Macrorie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Maidstone')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Mankota')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Manor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Maple Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Marcelin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Margo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Marquis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Marsden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Marshall')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Martensville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Maryfield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Maymont')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Meacham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Meadow Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Meath Park')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Melfort')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Melville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Meota')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Midale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Middle Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Milden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Milestone')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Minton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Mistatim')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Molanosa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Montmartre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Moose Jaw')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Moosomin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Morse')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Mortlach')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Mossbank')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Naicam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Neidpath')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Neilburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Neudorf')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Neville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Nipawin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Nokomis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Norquay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'North Battleford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'North Portal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Odessa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Ogema')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Ormiston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Osler')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Outlook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Oxbow')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Paddockwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Pangman')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Paradise Hill')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Patuanak')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Paynton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Pelican Narrows')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Pelly')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Pennant')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Pense')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Perdue')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Piapot')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Pierceland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Pilot Butte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Pinehouse')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Plato')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Plenty')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Ponteix')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Porcupine Plain')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Preeceville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Prelate')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Prince Albert')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Prud`homme')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Punnichy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Quill Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Qu`Appelle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Rabbit Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Radisson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Radville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Raymore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Redvers')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Regina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Regina Beach')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Rhein')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Riceton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Richmound')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Ridgedale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Riverhurst')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Rocanville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Rockglen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Rose Valley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Rosetown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Rosthern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Rouleau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Saltcoats')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Sandy Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Saskatoon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Sceptre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Scott')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Sedley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Semans')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Shaunavon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Sheho')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Shell Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Shellbrook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Simpson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Sintaluta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Smeaton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Smiley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Southend')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Southey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Spalding')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Speers')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Spiritwood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Springside')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Spy Hill')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'St. Benedict')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'St. Brieux')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'St. Gregor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'St. Louis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'St. Walburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Stanley Mission')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Star City')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Stockholm')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Stony Rapids')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Storthoaks')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Stoughton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Strasbourg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Strongfield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Sturgis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Swift Current')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Tantallon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Theodore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Tisdale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Togo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Tompkins')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Torquay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Tramping Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Tribune')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Turnor Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Turtleford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Unity')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Uranium City')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Val Marie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Vanguard')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Vanscoy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Vibank')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Viscount')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Vonda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Wadena')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Wakaw')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Waldheim')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Wapella')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Warman')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Waskesiu Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Watrous')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Watson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Wawota')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Webb')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Welwyn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Weyburn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'White Fox')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Whitewood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Wilcox')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Wilkie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Willow Bunch')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Windthorst')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Wiseton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Wishart')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Wollaston Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Wolseley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Wood Mountain')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Wynyard')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Yellow Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Yellow Grass')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Yorkton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Young')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Zealandia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Saskatchewan', 'Zenon Park')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Yukon Territory', 'Beaver Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Yukon Territory', 'Burwash Landing')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Yukon Territory', 'Carcross')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Yukon Territory', 'Carmacks')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Yukon Territory', 'Dawson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Yukon Territory', 'Destruction Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Yukon Territory', 'Faro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Yukon Territory', 'Haines Junction')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Yukon Territory', 'Marsh Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Yukon Territory', 'Mayo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Yukon Territory', 'Old Crow')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Yukon Territory', 'Pelly Crossing')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Yukon Territory', 'Ross River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Yukon Territory', 'Swift River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Yukon Territory', 'Tagish')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Yukon Territory', 'Teslin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Yukon Territory', 'Watson Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_cities` (`state`, `city`) VALUES('Yukon Territory', 'Whitehorse')", 0, null, __FILE__, __LINE__);
    
    print_progress_end();
}
?>