<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/
if (!isset($GLOBALS['ilance']->db))
{
    die('<strong>Warning:</strong> This script does not appear to have database functions loaded.  Operation aborted.');
}

function create_locations_schema($dbengine, $dbtype)
{
    global $ilance;
    
    $ilance->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "locations`", 0, null, __FILE__, __LINE__);
    $ilance->db->query("
            CREATE TABLE `" . DB_PREFIX . "locations` (
            `locationid` INT(100) NOT NULL AUTO_INCREMENT,
            `location_eng` VARCHAR(150) NOT NULL default '',
            `cc` CHAR(2) NOT NULL default '',
            PRIMARY KEY  (`locationid`),
            KEY location (`location_eng`),
            INDEX (`location_eng`)
            ) " . $dbengine . "=" . $dbtype . " DEFAULT CHARACTER SET " . DB_CHARSET . "
    ", 0, null, __FILE__, __LINE__);
    echo "<li>" . DB_PREFIX . "locations</li>";
    flush();
    
    print_progress_begin('<b>Importing 252 countries</b>, please wait.', '.', 'progressspancountries');
    
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (501, 'Afghanistan', 'AF')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (184, 'Albania', 'AL')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (301, 'Algeria', 'AG')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (502, 'American Samoa', 'AS')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (302, 'Angola', 'AO')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (303, 'Anguilla', 'AV')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (503, 'Antartica', 'AN')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (304, 'Antigua and Barbuda', 'AC')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (305, 'Argentina', 'AR')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (185, 'Armenia', 'AM')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (306, 'Aruba', 'AA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (504, 'Ashmore and Cartier Island', 'AS')", 0, null, __FILE__, __LINE__);    
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (307, 'Australia', 'AS')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (308, 'Austria', 'AU')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (186, 'Azerbaijan', 'AJ')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (309, 'Bahamas', 'BF')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (310, 'Bahrain', 'BA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (311, 'Bangladesh', 'BG')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (312, 'Barbados', 'BB')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (315, 'Belgium', 'BE')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (316, 'Belize', 'BH')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (314, 'Belarus', 'BO')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (317, 'Benin', 'BN')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (318, 'Bermuda', 'BD')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (319, 'Bhutan', 'BT')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (320, 'Bolivia', 'BL')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (188, 'Bosnia-Hercegovina', 'BK')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (322, 'Botswana', 'BC')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (506, 'Burma', 'BU')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (324, 'British Virgin Islands', 'VI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (323, 'Brazil', 'BR')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (325, 'Brunei', 'BX')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (326, 'Bulgaria', 'BU')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (327, 'Burkina Faso', 'UV')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (328, 'Burundi', 'BY')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (329, 'Cameroon', 'CM')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (330, 'Canada', 'CA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (331, 'Cape Verde', 'CV')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (332, 'Cayman Islands', 'CJ')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (333, 'Central African Repu', 'CT')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (334, 'Chad', 'CD')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (336, 'Chile', 'CI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (337, 'China', 'CH')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (508, 'Christmas Island', 'CI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (509, 'Clipperton Island', 'CL')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (510, 'Cocos (Keeling) Islands', 'CO')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (511, 'Comoros', 'CM')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (512, 'Cuba', 'CU')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (338, 'Colombia', 'CO')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (339, 'Congo', 'CG')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (242, 'Cook Islands', 'CW')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (340, 'Costa Rica', 'CS')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (193, 'Cote D''Ivoire', 'IV')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (194, 'Croatia', 'HR')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (342, 'Cyprus', 'CY')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (343, 'Czech Republic', 'EZ')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (344, 'Denmark', 'DA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (345, 'Djibouti', 'DJ')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (346, 'Dominica', 'DO')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (347, 'Dominican Republic', 'DR')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (348, 'Ecuador', 'EC')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (349, 'Egypt', 'EG')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (513, 'Eritrea', 'ER')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (514, 'Europa Island', 'EI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (350, 'El Salvador', 'ES')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (352, 'Equatorial Guinea', 'EK')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (353, 'Estonia', 'EN')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (354, 'Ethiopia', 'ET')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (515, 'Falkland Islands', 'FI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (516, 'Faroe Islands', 'FI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (355, 'Fiji', 'FJ')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (356, 'Finland', 'FI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (357, 'France', 'FR')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (358, 'French Guiana', 'FG')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (243, 'French Polynesia', 'FP')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (517, 'Gabon', 'GA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (518, 'Gaza Strip', 'GS')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (360, 'Gambia', 'GA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (215, 'Georgia', 'GG')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (361, 'Germany', 'GM')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (362, 'Ghana', 'GH')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (216, 'Gibraltar', 'GI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (519, 'Glorioso Islands', 'GI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (363, 'Greece', 'GR')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (364, 'Grenada', 'GJ')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (217, 'Greenland', 'GL')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (365, 'Guadeloupe', 'GP')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (521, 'Guam', 'GU')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (522, 'Guernsey', 'GU')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (367, 'Guatemala', 'GT')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (368, 'Guinea', 'GV')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (369, 'Guinea-Bissau', 'PU')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (370, 'Guyana', 'GY')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (195, 'Haiti', 'HA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (523, 'Heard Island', 'HI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (371, 'Honduras', 'HO')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (524, 'Holy Sea (Vatican City)', 'HS')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (372, 'Hong Kong', 'HK')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (525, 'Howland Island', 'HI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (373, 'Hungary', 'HU')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (374, 'Iceland', 'IC')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (375, 'India', 'IN')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (376, 'Indonesia', 'ID')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (377, 'Iran', 'IR')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (196, 'Iraq', 'IZ')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (526, 'Ireland', 'EI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (378, 'Ireland, Northern', 'EI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (197, 'Isle of Man', 'IM')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (380, 'Israel', 'IS')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (381, 'Italy', 'IT')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (383, 'Jamaica', 'JM')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (384, 'Japan', 'JA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (527, 'Jarvis Island', 'JI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (528, 'Jersey', 'JY')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (529, 'Johnston Atoll', 'JA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (385, 'Jordan', 'JO')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (530, 'Juan de Nova Island', 'JD')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (199, 'Kazakhstan', 'KZ')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (386, 'Kenya', 'KE')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (219, 'Kiribati', 'KR')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (531, 'Korea, North', 'KN')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (532, 'Korea, South', 'KS')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (388, 'Kuwait', 'KU')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (200, 'Kyrgyzstan', 'KG')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (220, 'Laos', 'LA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (389, 'Latvia', 'LG')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (390, 'Lebanon', 'LE')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (391, 'Lesotho', 'LT')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (221, 'Liberia', 'LI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (533, 'Libya', 'LY')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (392, 'Liechtenstein', 'LS')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (393, 'Lithuania', 'LH')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (394, 'Luxembourg', 'LU')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (395, 'Macau', 'MC')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (222, 'Macedonia', 'MK')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (396, 'Madagascar', 'MA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (397, 'Malawi', 'MI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (398, 'Malaysia', 'MY')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (399, 'Maldives', 'MV')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (100, 'Mali', 'ML')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (101, 'Malta', 'MT')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (102, 'Marshall Islands', 'RM')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (103, 'Martinique', 'MB')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (104, 'Mauritania', 'MR')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (105, 'Mauritius', 'MP')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (535, 'Mayotte', 'MY')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (106, 'Mexico', 'MX')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (107, 'Micronesia', 'FM')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (536, 'Midway Islands', 'MI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (203, 'Moldova', 'MD')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (108, 'Monaco', 'MN')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (223, 'Mongolia', 'MG')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (109, 'Montserrat', 'MH')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (110, 'Morocco', 'MO')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (111, 'Mozambique', 'MZ')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (112, 'Namibia', 'WA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (225, 'Nauru', 'NR')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (113, 'Nepal', 'NP')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (114, 'Netherlands', 'NL')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (537, 'Netherlands Antilles', 'NA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (116, 'New Caledonia', 'NC')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (117, 'New Zealand', 'NZ')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (118, 'Nicaragua', 'NU')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (119, 'Niger', 'NG')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (120, 'Nigeria', 'NI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (226, 'Niue', 'NE')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (258, 'Norfolk Island', 'NF')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (538, 'Northern Mariana Islands', 'NM')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (121, 'Norway', 'NO')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (122, 'Oman', 'MU')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (123, 'Pakistan', 'PK')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (124, 'Palau', 'PS')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (125, 'Panama', 'PM')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (126, 'Papua New Guinea', 'PP')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (127, 'Paraguay', 'PA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (539, 'Pitcaim Islands', 'PI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (540, 'Puerto Rico', 'PR')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (128, 'Peru', 'PE')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (129, 'Philippines', 'RP')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (130, 'Poland', 'PL')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (131, 'Portugal', 'PO')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (132, 'Qatar', 'QA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (133, 'Reunion', 'RE')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (134, 'Romania', 'RP')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (135, 'Russia', 'RS')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (136, 'Rwanda', 'RW')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (541, 'Saint Helena', 'SH')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (542, 'Saint Kitts and Nevis', 'SK')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (543, 'Saint Lucia', 'SL')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (544, 'Saint Pierre and Miquelon', 'SP')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (545, 'Saint Vincent', 'SV')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (546, 'Samoa', 'SA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (228, 'San Marino', 'SM')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (229, 'Sao Tome', 'TP')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (148, 'Saudi Arabia', 'SA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (547, 'Scotland', 'SC')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (150, 'Senegal', 'SG')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (207, 'Serbia', 'YI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (151, 'Seychelles', 'SE')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (152, 'Sierra Leone', 'SL')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (153, 'Singapore', 'SN')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (208, 'Slovakia', 'LO')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (209, 'Slovenia', 'SI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (210, 'Solomon Islands', 'BP')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (154, 'Somalia', 'SO')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (155, 'South Africa', 'SF')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (548, 'South Georgia', 'SG')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (156, 'Spain', 'SP')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (549, 'Spratly Islands', 'SI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (157, 'Sri Lanka', 'CE')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (158, 'Sudan', 'SU')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (159, 'Suriname', 'NS')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (160, 'Swaziland', 'WZ')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (161, 'Sweden', 'SW')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (162, 'Switzerland', 'SZ')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (163, 'Syria', 'SY')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (550, 'Svalbard', 'SV')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (164, 'Taiwan', 'TW')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (211, 'Tajikistan', 'TI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (165, 'Tanzania', 'TZ')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (166, 'Thailand', 'TH')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (551, 'Tobago', 'TO')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (167, 'Togo', 'TO')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (552, 'Tokelau', 'TO')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (249, 'Tonga', 'TN')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (168, 'Trinidad and Tobago', 'TD')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (169, 'Tunisia', 'TS')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (170, 'Turkey', 'TU')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (212, 'Turkmenistan', 'TX')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (231, 'Tuvalu', 'TV')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (172, 'Uganda', 'UG')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (173, 'Ukraine', 'UP')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (174, 'United Arab Emirates', 'AE')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (262, 'United Kingdom', 'UK')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (176, 'Uruguay', 'UY')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (500, 'USA', 'US')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (232, 'Uzbekistan', 'UZ')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (233, 'Vanuatu', 'NH')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (177, 'Vatican City', 'VT')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (178, 'Venezuela', 'VE')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (234, 'Vietnam', 'VW')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (553, 'Virgin Islands', 'VI')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (554, 'Wales', 'WA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (253, 'Wallis Island', 'WF')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (555, 'West Bank', 'WB')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (556, 'Western Sahara', 'WS')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (180, 'Yemen, Republic of', 'YM')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (213, 'Yugoslavia', 'MK')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (182, 'Zambia', 'ZA')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations` VALUES (183, 'Zimbabwe', 'ZI')", 0, null, __FILE__, __LINE__);
    
    print_progress_end();
    
    $ilance->db->query("DROP TABLE IF EXISTS `" . DB_PREFIX . "locations_states`", 0, null, __FILE__, __LINE__);
    $ilance->db->query("
            CREATE TABLE `" . DB_PREFIX . "locations_states` (
            `locationid` INT(100) NOT NULL,
            `state` VARCHAR(150) NOT NULL default '',
            KEY location (`state`)
            ) " . $dbengine . "=" . $dbtype . " DEFAULT CHARACTER SET " . DB_CHARSET . "
    ", 0, null, __FILE__, __LINE__);
    echo "<li>" . DB_PREFIX . "locations_states</li>";
    flush();
    
    print_progress_begin('<b>Importing 4,386 states</b>, please wait.', '.', 'progressspanstates');
    
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Badakhshan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Badghis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Baghlan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Balkh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Bamian')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Farah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Faryab')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Ghazni')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Ghowr')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Helmand')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Herat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Jowzjan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Kabol')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Kandahar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Kapisa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Konar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Kondoz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Laghman')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Lowgar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Nangarhar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Nimruz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Oruzgan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Paktia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Paktika')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Parvan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Samangan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Sar-e Pol')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Takhar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Vardak')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (501, 'Zabol')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Berat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Bulqize')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Delvine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Devoll (Bilisht)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Diber (Peshkopi)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Durres')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Elbasan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Fier')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Gjirokaster')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Gramsh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Has (Krume)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Kavaje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Kolonje (Erseke)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Korce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Kruje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Kucove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Kukes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Kurbin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Lezhe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Librazhd')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Lushnje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Malesi e Madhe (Koplik)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Mallakaster (Ballsh)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Mat (Burrel)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Mirdite (Rreshen)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Peqin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Permet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Pogradec')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Puke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Sarande')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Shkoder')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Skrapar (Corovode)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Tepelene')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Tirane (Tirana)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Tirane (Tirana)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Tropoje (Bajram Curri)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (184, 'Vlore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Adrar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Ain Defla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Ain Temouchent')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Alger')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Annaba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Batna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Bechar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Bejaia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Biskra')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Blida')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Bordj Bou Arreridj')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Bouira')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Boumerdes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Chlef')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Constantine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Djelfa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'El Bayadh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'El Oued')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'El Tarf')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Ghardaia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Guelma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Illizi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Jijel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Khenchela')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Laghouat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'M''Sila')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Mascara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Medea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Mila')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Mostaganem')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Naama')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Oran')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Ouargla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Oum el Bouaghi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Relizane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Saida')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Setif')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Sidi Bel Abbes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Skikda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Souk Ahras')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Tamanghasset')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Tebessa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Tiaret')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Tindouf')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Tipaza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Tissemsilt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Tizi Ouzou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (301, 'Tlemcen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (502, 'Eastern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (502, 'Manu''a')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (502, 'Rose Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (502, 'Swains Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (502, 'Western')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Andorra la Vella')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Bengo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Benguela')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Bie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Cabinda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Canillo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Cuando Cubango')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Cuanza Norte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Cuanza Sul')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Cunene')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Encamp')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Escaldes-Engordany')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Huambo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Huila')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'La Massana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Luanda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Lunda Norte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Lunda Sul')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Malanje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Moxico')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Namibe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Ordino')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Sant Julia de Loria')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Uige')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (302, 'Zaire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (303, 'Anguilla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (503, 'Antartica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (304, 'Barbuda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (304, 'Redonda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (304, 'Saint George')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (304, 'Saint John')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (304, 'Saint Mary')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (304, 'Saint Paul')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (304, 'Saint Peter')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (304, 'Saint Philip')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Antartica e Islas del Atlantico Sur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Buenos Aires')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Buenos Aires Capital Federal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Catamarca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Chaco')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Chubut')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Cordoba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Corrientes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Entre Rios')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Formosa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Jujuy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'La Pampa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'La Rioja')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Mendoza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Misiones')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Neuquen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Rio Negro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Salta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'San Juan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'San Luis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Santa Cruz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Santa Fe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Santiago del Estero')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Tierra del Fuego')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (305, 'Tucuman')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (185, 'Aragatsotn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (185, 'Ararat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (185, 'Armavir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (185, 'Geghark''unik''')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (185, 'Kotayk''')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (185, 'Lorri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (185, 'Shirak')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (185, 'Syunik''')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (185, 'Tavush')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (185, 'Vayots'' Dzor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (185, 'Yerevan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (306, 'Aruba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (504, 'Ashmore and Cartier Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (307, 'Australian Capital Territory')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (307, 'New South Wales')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (307, 'Northern Territory')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (307, 'Queensland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (307, 'South Australia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (307, 'Tasmania')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (307, 'Victoria')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (307, 'Western Australia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (308, 'Burgenland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (308, 'Kaernten')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (308, 'Niederoesterreich')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (308, 'Oberoesterreich')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (308, 'Salzburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (308, 'Steiermark')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (308, 'Tirol')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (308, 'Vorarlberg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (308, 'Wien')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Abseron Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Agcabadi Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Agdam Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Agdas Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Agstafa Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Agsu Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Ali Bayramli Sahari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Astara Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Baki Sahari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Balakan Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Barda Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Beylaqan Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Bilasuvar Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Cabrayil Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Calilabad Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Daskasan Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Davaci Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Fuzuli Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Gadabay Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Ganca Sahari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Goranboy Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Haciqabul Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Imisli Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Kalbacar Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Kurdamir Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Lacin Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Lankaran Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Lankaran Sahari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Lerik Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Masalli Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Mingacevir Sahari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Naftalan Sahari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Naxcivan Muxtar Respublikasi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Neftcala Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Oguz Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Qabala Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Qax Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Qazax Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Qobustan Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Quba Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Qubadli Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Qusar Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Saatli Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Sabirabad Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Saki Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Saki Sahari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Salyan Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Samaxi Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Samkir Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Samux Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Siyazan Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Sumqayit Sahari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Susa Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Susa Sahari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Tartar Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Tovuz Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Ucar Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Xacmaz Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Xankandi Sahari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Xanlar Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Xizi Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Xocali Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Xocavand Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Yardimli Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Yevlax Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Yevlax Sahari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Zangilan Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Zaqatala Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (186, 'Zardab Rayonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'Acklins and Crooked Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'Bimini')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'Cat Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'Exuma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'Freeport')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'Fresh Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'Governor''s Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'Green Turtle Cay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'Harbour Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'High Rock')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'Inagua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'Kemps Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'Long Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'Marsh Harbour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'Mayaguana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'New Providence')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'Nicholls Town and Berry Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'Ragged Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'Rock Sound')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'San Salvador and Rum Cay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (309, 'Sandy Point')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (310, 'Al Hadd')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (310, 'Al Manamah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (310, 'Al Mintaqah al Gharbiyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (310, 'Al Mintaqah al Wusta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (310, 'Al Mintaqah ash Shamaliyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (310, 'Al Muharraq')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (310, 'Ar Rifa'' wa al Mintaqah al Janubiyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (310, 'Jidd Hafs')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (310, 'Juzur Hawar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (310, 'Madinat ''Isa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (310, 'Madinat Hamad')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (310, 'Sitrah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (311, 'Barisal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (311, 'Chittagong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (311, 'Dhaka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (311, 'Khulna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (311, 'Rajshahi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (311, 'Sylhet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (312, 'Bridgetown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (312, 'Christ Church')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (312, 'Saint Andrew')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (312, 'Saint George')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (312, 'Saint James')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (312, 'Saint John')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (312, 'Saint Joseph')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (312, 'Saint Lucy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (312, 'Saint Michael')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (312, 'Saint Peter')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (312, 'Saint Philip')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (312, 'Saint Thomas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (314, 'Brestskaya (Brest)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (314, 'Homyel''skaya (Homyel'')')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (314, 'Horad Minsk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (314, 'Hrodzyenskaya (Hrodna)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (314, 'Mahilyowskaya (Mahilyow)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (314, 'Minskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (314, 'Vitsyebskaya (Vitsyebsk)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (315, 'Antwerpen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (315, 'Brabant Wallon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (315, 'Brussels Capitol Region')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (315, 'Hainaut')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (315, 'Liege')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (315, 'Limburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (315, 'Luxembourg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (315, 'Namur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (315, 'Oost-Vlaanderen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (315, 'Vlaams Brabant')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (315, 'West-Vlaanderen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (316, 'Belize')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (316, 'Cayo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (316, 'Corozal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (316, 'Orange Walk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (316, 'Stann Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (316, 'Toledo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (317, 'Alibori')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (317, 'Atakora')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (317, 'Atlantique')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (317, 'Borgou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (317, 'Collines')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (317, 'Couffo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (317, 'Donga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (317, 'Littoral')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (317, 'Mono')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (317, 'Oueme')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (317, 'Plateau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (317, 'Zou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (318, 'Devonshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (318, 'Hamilton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (318, 'Hamilton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (318, 'Paget')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (318, 'Pembroke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (318, 'Saint George')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (318, 'Saint Georges')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (318, 'Sandys')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (318, 'Smiths')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (318, 'Southampton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (318, 'Warwick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (319, 'Bumthang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (319, 'Chhukha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (319, 'Chirang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (319, 'Daga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (319, 'Geylegphug')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (319, 'Ha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (319, 'Lhuntshi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (319, 'Mongar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (319, 'Paro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (319, 'Pemagatsel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (319, 'Punakha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (319, 'Samchi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (319, 'Samdrup Jongkhar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (319, 'Shemgang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (319, 'Tashigang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (319, 'Thimphu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (319, 'Tongsa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (319, 'Wangdi Phodrang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (320, 'Beni')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (320, 'Chuquisaca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (320, 'Cochabamba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (320, 'La Paz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (320, 'Oruro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (320, 'Pando')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (320, 'Potosi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (320, 'Santa Cruz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (320, 'Tarija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (188, 'Federation of Bosnia and Herzegovina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (188, 'Republika Srpska')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (322, 'Central')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (322, 'Chobe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (322, 'Francistown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (322, 'Gaborone')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (322, 'Ghanzi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (322, 'Kgalagadi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (322, 'Kgatleng')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (322, 'Kweneng')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (322, 'Lobatse')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (322, 'Ngamiland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (322, 'North-East')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (322, 'Selebi-Pikwe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (322, 'South-East')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (322, 'Southern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Acre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Alagoas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Amapa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Amazonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Bahia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Ceara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Distrito Federal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Espirito Santo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Goias')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Maranhao')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Mato Grosso')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Mato Grosso do Sul')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Minas Gerais')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Para')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Paraiba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Parana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Pernambuco')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Piaui')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Rio de Janeiro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Rio Grande do Norte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Rondonia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Roraima')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Santa Catarina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Sao Paulo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Sergipe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (323, 'Tocantins')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (324, 'Anegada')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (324, 'Jost Van Dyke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (324, 'Tortola')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (324, 'Virgin Gorda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (325, 'Belait')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (325, 'Brunei and Muara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (325, 'Temburong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (325, 'Tutong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Blagoevgrad')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Burgas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Dobrich')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Gabrovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Khaskovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Kurdzhali')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Kyustendil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Lovech')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Montana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Pazardzhik')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Pernik')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Pleven')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Plovdiv')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Razgrad')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Ruse')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Shumen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Silistra')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Sliven')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Smolyan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Sofiya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Sofiya-Grad')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Stara Zagora')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Turgovishte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Varna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Veliko Turnovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Vidin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Vratsa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (326, 'Yambol')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Bale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Bam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Banwa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Bazega')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Bougouriba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Boulgou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Boulkiemde')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Comoe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Ganzourgou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Gnagna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Gourma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Houet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Ioba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Kadiogo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Kenedougou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Komandjari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Kompienga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Kossi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Koupelogo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Kouritenga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Kourweogo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Leraba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Loroum')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Mouhoun')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Nahouri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Namentenga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Naumbiel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Nayala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Oubritenga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Oudalan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Passore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Poni')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Samentenga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Sanguie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Seno')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Sissili')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Soum')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Sourou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Tapoa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Tuy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Yagha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Yatenga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Ziro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Zondomo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (327, 'Zoundweogo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (506, 'Ayeyarwady')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (506, 'Bago')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (506, 'Chin State')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (506, 'Kachin State')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (506, 'Kayah State')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (506, 'Kayin State')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (506, 'Magway')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (506, 'Mandalay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (506, 'Mon State')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (506, 'Rakhine State')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (506, 'Sagaing')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (506, 'Shan State')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (506, 'Tanintharyi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (506, 'Yangon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (328, 'Bubanza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (328, 'Bujumbura')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (328, 'Bururi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (328, 'Cankuzo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (328, 'Cibitoke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (328, 'Gitega')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (328, 'Karuzi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (328, 'Kayanza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (328, 'Kirundo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (328, 'Makamba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (328, 'Muramvya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (328, 'Muyinga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (328, 'Mwaro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (328, 'Ngozi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (328, 'Rutana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (328, 'Ruyigi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Banteay Mean Cheay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Batdambang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Kampong Cham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Kampong Chhnang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Kampong Spoe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Kampong Thum')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Kampot')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Kandal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Kaoh Kong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Keb')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Kracheh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Mondol Kiri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Otdar Mean Cheay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Pailin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Phnum Penh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Pouthisat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Preah Seihanu (Sihanoukville)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Preah Vihear')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Prey Veng')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Rotanah Kiri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Siem Reab')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Stoeng Treng')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Svay Rieng')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (507, 'Takev')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (329, 'Adamaoua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (329, 'Centre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (329, 'Est')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (329, 'Extreme-Nord')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (329, 'Littoral')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (329, 'Nord')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (329, 'Nord-Ouest')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (329, 'Ouest')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (329, 'Sud')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (329, 'Sud-Ouest')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (330, 'Alberta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (330, 'British Columbia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (330, 'Manitoba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (330, 'New Brunswick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (330, 'Newfoundland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (330, 'Northwest Territories')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (330, 'Nova Scotia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (330, 'Nunavut')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (330, 'Ontario')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (330, 'Prince Edward Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (330, 'Quebec')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (330, 'Saskatchewan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (330, 'Yukon Territory')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (331, 'Boa Vista')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (331, 'Brava')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (331, 'Maio')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (331, 'Mosteiros')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (331, 'Paul')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (331, 'Porto Novo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (331, 'Praia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (331, 'Ribeira Grande')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (331, 'Sal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (331, 'Santa Catarina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (331, 'Santa Cruz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (331, 'Sao Domingos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (331, 'Sao Filipe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (331, 'Sao Nicolau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (331, 'Sao Vicente')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (331, 'Tarrafal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (332, 'Creek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (332, 'Eastern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (332, 'Midland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (332, 'South Town')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (332, 'Spot Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (332, 'Stake Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (332, 'West End')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (332, 'Western')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (333, 'Bamingui-Bangoran')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (333, 'Bangui')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (333, 'Basse-Kotto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (333, 'Gribingui')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (333, 'Haut-Mbomou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (333, 'Haute-Kotto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (333, 'Haute-Sangha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (333, 'Kemo-Gribingui')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (333, 'Lobaye')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (333, 'Mbomou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (333, 'Nana-Mambere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (333, 'Ombella-Mpoko')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (333, 'Ouaka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (333, 'Ouham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (333, 'Ouham-Pende')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (333, 'Sangha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (333, 'Vakaga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (334, 'Batha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (334, 'Biltine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (334, 'Borkou-Ennedi-Tibesti')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (334, 'Chari-Baguirmi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (334, 'Guera')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (334, 'Kanem')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (334, 'Lac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (334, 'Logone Occidental')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (334, 'Logone Oriental')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (334, 'Mayo-Kebbi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (334, 'Moyen-Chari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (334, 'Ouaddai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (334, 'Salamat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (334, 'Tandjile')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (336, 'Aisen del General Carlos Ibanez del Campo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (336, 'Antofagasta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (336, 'Araucania')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (336, 'Atacama')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (336, 'Bio-Bio')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (336, 'Coquimbo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (336, 'Libertador General Bernardo O''Higgins')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (336, 'Los Lagos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (336, 'Magallanes y de la Antartica Chilena')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (336, 'Maule')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (336, 'Region Metropolitana (Santiago)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (336, 'Tarapaca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (336, 'Valparaiso')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Anhui')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Beijing')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Chongqing')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Fujian')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Gansu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Guangdong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Guangxi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Guizhou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Hainan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Hebei')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Heilongjiang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Henan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Hubei')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Hunan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Jiangsu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Jiangxi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Jilin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Liaoning')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Nei Mongol')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Ningxia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Qinghai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Shaanxi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Shandong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Shanghai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Shanxi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Sichuan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Tianjin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Xinjiang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Xizang (Tibet)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Yunnan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (337, 'Zhejiang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (508, 'Christmas Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (509, 'Clipperton Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (510, 'Direction Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (510, 'Home Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (510, 'Horsburgh Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (510, 'North Keeling Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (510, 'South Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (510, 'West Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Amazonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Antioquia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Arauca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Atlantico')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Bolivar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Boyaca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Caldas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Caqueta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Casanare')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Cauca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Cesar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Choco')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Cordoba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Cundinamarca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Distrito Capital de Santa Fe de Bogota')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Guainia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Guaviare')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Huila')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'La Guajira')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Magdalena')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Meta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Narino')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Norte de Santander')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Putumayo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Quindio')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Risaralda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'San Andres y Providencia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Santander')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Sucre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Tolima')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Valle del Cauca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Vaupes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (338, 'Vichada')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (511, 'Anjouan (Nzwani)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (511, 'Domoni')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (511, 'Fomboni')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (511, 'Grande Comore (Njazidja)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (511, 'Moheli (Mwali)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (511, 'Moroni')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (511, 'Moutsamoudou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Bandundu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Bas-Congo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Equateur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Kasai-Occidental')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Kasai-Oriental')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Katanga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Kinshasa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Maniema')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Nord-Kivu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Orientale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Sud-Kivu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Bouenza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Brazzaville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Cuvette')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Kouilou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Lekoumou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Likouala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Niari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Plateaux')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Pool')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (339, 'Sangha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (242, 'Aitutaki')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (242, 'Atiu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (242, 'Avarua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (242, 'Mangaia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (242, 'Manihiki')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (242, 'Manuae')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (242, 'Mauke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (242, 'Mitiaro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (242, 'Nassau Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (242, 'Palmerston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (242, 'Penrhyn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (242, 'Pukapuka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (242, 'Rakahanga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (242, 'Rarotonga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (242, 'Suwarrow')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (242, 'Takutea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (340, 'Alajuela')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (340, 'Cartago')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (340, 'Guanacaste')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (340, 'Heredia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (340, 'Limon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (340, 'Puntarenas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (340, 'San Jose')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Abengourou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Abidjan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Aboisso')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Adiake''')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Adzope')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Agboville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Agnibilekrou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Ale''pe''')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Bangolo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Beoumi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Biankouma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Bocanda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Bondoukou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Bongouanou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Bouafle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Bouake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Bouna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Boundiali')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Dabakala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Dabon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Daloa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Danane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Daoukro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Dimbokro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Divo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Duekoue')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Ferkessedougou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Gagnoa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Grand Bassam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Grand-Lahou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Guiglo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Issia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Jacqueville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Katiola')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Korhogo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Lakota')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Man')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Mankono')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Mbahiakro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Odienne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Oume')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Sakassou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'San-Pedro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Sassandra')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Seguela')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Sinfra')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Soubre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Tabou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Tanda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Tiassale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Tiebissou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Tingrela')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Touba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Toulepleu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Toumodi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Vavoua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Yamoussoukro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (193, 'Zuenoula')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Bjelovarsko-Bilogorska Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Brodsko-Posavska Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Dubrovacko-Neretvanska Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Istarska Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Karlovacka Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Koprivnicko-Krizevacka Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Krapinsko-Zagorska Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Licko-Senjska Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Medimurska Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Osjecko-Baranjska Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Pozesko-Slavonska Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Primorsko-Goranska Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Sibensko-Kninska Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Sisacko-Moslavacka Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Splitsko-Dalmatinska Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Varazdinska Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Viroviticko-Podravska Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Vukovarsko-Srijemska Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Zadarska Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Zagreb')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (194, 'Zagrebacka Zupanija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (512, 'Camaguey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (512, 'Ciego de Avila')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (512, 'Cienfuegos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (512, 'Ciudad de La Habana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (512, 'Granma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (512, 'Guantanamo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (512, 'Holguin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (512, 'Isla de la Juventud')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (512, 'La Habana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (512, 'Las Tunas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (512, 'Matanzas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (512, 'Pinar del Rio')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (512, 'Sancti Spiritus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (512, 'Santiago de Cuba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (512, 'Villa Clara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (342, 'Famagusta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (342, 'Kyrenia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (342, 'Larnaca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (342, 'Limassol')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (342, 'Nicosia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (342, 'Paphos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (343, 'Brnensky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (343, 'Budejovicky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (343, 'Jihlavsky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (343, 'Karlovarsky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (343, 'Kralovehradecky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (343, 'Liberecky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (343, 'Olomoucky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (343, 'Ostravsky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (343, 'Pardubicky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (343, 'Plzensky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (343, 'Praha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (343, 'Stredocesky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (343, 'Ustecky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (343, 'Zlinsky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (344, 'Arhus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (344, 'Bornholm')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (344, 'Fredericksberg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (344, 'Frederiksborg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (344, 'Fyn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (344, 'Kobenhavn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (344, 'Kobenhavns')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (344, 'Nordjylland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (344, 'Ribe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (344, 'Ringkobing')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (344, 'Roskilde')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (344, 'Sonderjylland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (344, 'Storstrom')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (344, 'Vejle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (344, 'Vestsjalland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (344, 'Viborg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (345, '''Ali Sabih')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (345, 'Dikhil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (345, 'Djibouti')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (345, 'Obock')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (345, 'Tadjoura')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (346, 'Saint Andrew')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (346, 'Saint David')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (346, 'Saint George')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (346, 'Saint John')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (346, 'Saint Joseph')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (346, 'Saint Luke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (346, 'Saint Mark')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (346, 'Saint Patrick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (346, 'Saint Paul')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (346, 'Saint Peter')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Azua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Baoruco')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Barahona')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Dajabon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Distrito Nacional')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Duarte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'El Seibo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Elias Pina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Espaillat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Hato Mayor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Independencia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'La Altagracia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'La Romana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'La Vega')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Maria Trinidad Sanchez')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Monsenor Nouel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Monte Cristi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Monte Plata')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Pedernales')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Peravia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Puerto Plata')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Salcedo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Samana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'San Cristobal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'San Juan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'San Pedro de Macoris')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Sanchez Ramirez')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Santiago')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Santiago Rodriguez')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (347, 'Valverde')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Azuay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Bolivar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Canar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Carchi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Chimborazo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Cotopaxi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'El Oro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Esmeraldas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Galapagos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Guayas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Imbabura')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Loja')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Los Rios')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Manabi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Morona-Santiago')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Napo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Orellana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Pastaza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Pichincha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Sucumbios')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Tungurahua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (348, 'Zamora-Chinchipe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Ad Daqahliyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Al Bahr al Ahmar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Al Buhayrah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Al Fayyum')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Al Gharbiyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Al Iskandariyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Al Isma''iliyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Al Jizah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Al Minufiyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Al Minya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Al Qahirah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Al Qalyubiyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Al Wadi al Jadid')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'As Suways')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Ash Sharqiyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Aswan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Asyut')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Bani Suwayf')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Bur Sa''id')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Dumyat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Janub Sina''')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Kafr ash Shaykh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Matruh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Qina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Shamal Sina''')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (349, 'Suhaj')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (350, 'Ahuachapan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (350, 'Cabanas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (350, 'Chalatenango')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (350, 'Cuscatlan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (350, 'La Libertad')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (350, 'La Paz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (350, 'La Union')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (350, 'Morazan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (350, 'San Miguel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (350, 'San Salvador')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (350, 'San Vicente')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (350, 'Santa Ana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (350, 'Sonsonate')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (350, 'Usulutan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (352, 'Annobon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (352, 'Bioko Norte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (352, 'Bioko Sur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (352, 'Centro Sur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (352, 'Kie-Ntem')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (352, 'Litoral')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (352, 'Wele-Nzas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (513, 'Akale Guzay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (513, 'Barka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (513, 'Denkel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (513, 'Hamasen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (513, 'Sahil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (513, 'Semhar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (513, 'Senhit')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (513, 'Seraye')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (353, 'Harjumaa (Tallinn)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (353, 'Hiiumaa (Kardla)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (353, 'Ida-Virumaa (Johvi)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (353, 'Jarvamaa (Paide)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (353, 'Jogevamaa (Jogeva)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (353, 'Laane-Virumaa (Rakvere)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (353, 'Laanemaa (Haapsalu)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (353, 'Parnumaa (Parnu)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (353, 'Polvamaa (Polva)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (353, 'Raplamaa (Rapla)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (353, 'Saaremaa (Kuessaare)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (353, 'Tartumaa (Tartu)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (353, 'Valgamaa (Valga)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (353, 'Viljandimaa (Viljandi)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (353, 'Vorumaa (Voru)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (354, 'Adis Abeba (Addis Ababa)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (354, 'Afar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (354, 'Amara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (354, 'Dire Dawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (354, 'Gambela Hizboch')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (354, 'Hareri Hizb')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (354, 'Oromiya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (354, 'Sumale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (354, 'Tigray')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (354, 'YeDebub Biheroch Bihereseboch na Hizboch')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (514, 'Europa Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (515, 'Falkland Islands (Islas Malvinas)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (516, 'Bordoy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (516, 'Eysturoy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (516, 'Mykines')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (516, 'Sandoy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (516, 'Skuvoy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (516, 'Streymoy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (516, 'Suduroy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (516, 'Tvoroyri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (516, 'Vagar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (355, 'Central')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (355, 'Eastern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (355, 'Northern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (355, 'Rotuma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (355, 'Western')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (356, 'Aland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (356, 'Etela-Suomen Laani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (356, 'Ita-Suomen Laani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (356, 'Lansi-Suomen Laani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (356, 'Lappi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (356, 'Oulun Laani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Alsace')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Aquitaine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Auvergne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Basse-Normandie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Bourgogne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Bretagne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Centre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Champagne-Ardenne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Corse')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Franche-Comte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Haute-Normandie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Ile-de-France')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Languedoc-Roussillon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Limousin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Lorraine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Midi-Pyrenees')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Nord-Pas-de-Calais')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Pays de la Loire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Picardie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Poitou-Charentes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Provence-Alpes-Cote d''Azur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (357, 'Rhone-Alpes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (358, 'French Guiana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (243, 'Archipel des Marquises')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (243, 'Archipel des Tuamotu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (243, 'Archipel des Tubuai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (243, 'Iles du Vent')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (243, 'Iles Sous-le-Vent')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (517, 'Estuaire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (517, 'Haut-Ogooue')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (517, 'Moyen-Ogooue')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (517, 'Ngounie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (517, 'Nyanga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (517, 'Ogooue-Ivindo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (517, 'Ogooue-Lolo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (517, 'Ogooue-Maritime')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (517, 'Woleu-Ntem')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (360, 'Banjul')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (360, 'Central River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (360, 'Lower River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (360, 'North Bank')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (360, 'Upper River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (360, 'Western')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (518, 'Gaza Strip')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Abashis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Abkhazia or Ap''khazet''is Avtonomiuri Respublika (Sokhumi)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Adigenis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Ajaria or Acharis Avtonomiuri Respublika (Bat''umi)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Akhalgoris')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Akhalk''alak''is')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Akhalts''ikhis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Akhmetis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Ambrolauris')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Aspindzis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Baghdat''is')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Bolnisis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Borjomis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Ch''khorotsqus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Ch''okhatauris')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Chiat''ura')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Dedop''listsqaros')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Dmanisis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Dushet''is')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Gardabanis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Gori')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Goris')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Gurjaanis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Javis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'K''arelis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'K''ut''aisi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Kaspis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Kharagaulis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Khashuris')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Khobis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Khonis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Lagodekhis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Lanch''khut''is')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Lentekhis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Marneulis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Martvilis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Mestiis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Mts''khet''is')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Ninotsmindis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Onis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Ozurget''is')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'P''ot''i')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Qazbegis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Qvarlis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Rust''avi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Sach''kheris')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Sagarejos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Samtrediis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Senakis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Sighnaghis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'T''bilisi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'T''elavis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'T''erjolis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'T''et''ritsqaros')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'T''ianet''is')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Tqibuli')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Ts''ageris')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Tsalenjikhis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Tsalkis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Tsqaltubo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Vanis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Zestap''onis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Zugdidi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (215, 'Zugdidis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (361, 'Baden-Wuerttemberg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (361, 'Bayern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (361, 'Berlin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (361, 'Brandenburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (361, 'Bremen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (361, 'Hamburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (361, 'Hessen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (361, 'Mecklenburg-Vorpommern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (361, 'Niedersachsen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (361, 'Nordrhein-Westfalen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (361, 'Rheinland-Pfalz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (361, 'Saarland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (361, 'Sachsen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (361, 'Sachsen-Anhalt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (361, 'Schleswig-Holstein')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (361, 'Thueringen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (362, 'Ashanti')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (362, 'Brong-Ahafo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (362, 'Central')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (362, 'Eastern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (362, 'Greater Accra')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (362, 'Northern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (362, 'Upper East')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (362, 'Upper West')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (362, 'Volta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (362, 'Western')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (216, 'Gibraltar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (519, 'Ile du Lys')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (519, 'Ile Glorieuse')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Aitolia kai Akarnania')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Akhaia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Argolis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Arkadhia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Arta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Attiki')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Ayion Oros (Mt. Athos)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Dhodhekanisos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Drama')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Evritania')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Evros')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Evvoia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Florina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Fokis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Fthiotis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Grevena')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Ilia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Imathia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Ioannina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Irakleion')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Kardhitsa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Kastoria')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Kavala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Kefallinia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Kerkyra')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Khalkidhiki')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Khania')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Khios')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Kikladhes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Kilkis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Korinthia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Kozani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Lakonia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Larisa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Lasithi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Lesvos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Levkas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Magnisia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Messinia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Pella')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Pieria')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Preveza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Rethimni')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Rodhopi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Samos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Serrai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Thesprotia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Thessaloniki')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Trikala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Voiotia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Xanthi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (363, 'Zakinthos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (217, 'Avannaa (Nordgronland)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (217, 'Kitaa (Vestgronland)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (217, 'Tunu (Ostgronland)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (364, 'Carriacou and Petit Martinique')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (364, 'Saint Andrew')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (364, 'Saint David')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (364, 'Saint George')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (364, 'Saint John')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (364, 'Saint Mark')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (364, 'Saint Patrick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (365, 'Basse-Terre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (365, 'Grande-Terre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (365, 'Iles de la Petite Terre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (365, 'Iles des Saintes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (365, 'Marie-Galante')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (521, 'Guam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Alta Verapaz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Baja Verapaz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Chimaltenango')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Chiquimula')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'El Progreso')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Escuintla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Guatemala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Huehuetenango')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Izabal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Jalapa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Jutiapa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Peten')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Quetzaltenango')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Quiche')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Retalhuleu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Sacatepequez')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'San Marcos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Santa Rosa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Solola')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Suchitepequez')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Totonicapan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (367, 'Zacapa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (522, 'Castel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (522, 'Forest')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (522, 'St. Andrew')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (522, 'St. Martin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (522, 'St. Peter Port')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (522, 'St. Pierre du Bois')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (522, 'St. Sampson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (522, 'St. Saviour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (522, 'Torteval')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (522, 'Vale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Beyla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Boffa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Boke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Conakry')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Coyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Dabola')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Dalaba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Dinguiraye')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Dubreka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Faranah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Forecariah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Fria')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Gaoual')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Gueckedou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Kankan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Kerouane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Kindia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Kissidougou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Koubia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Koundara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Kouroussa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Labe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Lelouma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Lola')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Macenta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Mali')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Mamou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Mandiana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Nzerekore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Pita')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Siguiri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Telimele')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Tougue')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (368, 'Yomou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (369, 'Bafata')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (369, 'Biombo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (369, 'Bissau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (369, 'Bolama-Bijagos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (369, 'Cacheu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (369, 'Gabu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (369, 'Oio')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (369, 'Quinara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (369, 'Tombali')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (370, 'Barima-Waini')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (370, 'Cuyuni-Mazaruni')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (370, 'Demerara-Mahaica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (370, 'East Berbice-Corentyne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (370, 'Essequibo Islands-West Demerara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (370, 'Mahaica-Berbice')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (370, 'Pomeroon-Supenaam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (370, 'Potaro-Siparuni')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (370, 'Upper Demerara-Berbice')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (370, 'Upper Takutu-Upper Essequibo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (195, 'Artibonite')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (195, 'Centre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (195, 'Grand''Anse')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (195, 'Nord')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (195, 'Nord-Est')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (195, 'Nord-Ouest')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (195, 'Ouest')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (195, 'Sud')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (195, 'Sud-Est')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (523, 'Heard Island and McDonald Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (524, 'Holy See (Vatican City)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (371, 'Atlantida')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (371, 'Choluteca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (371, 'Colon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (371, 'Comayagua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (371, 'Copan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (371, 'Cortes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (371, 'El Paraiso')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (371, 'Francisco Morazan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (371, 'Gracias a Dios')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (371, 'Intibuca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (371, 'Islas de la Bahia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (371, 'La Paz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (371, 'Lempira')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (371, 'Ocotepeque')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (371, 'Olancho')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (371, 'Santa Barbara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (371, 'Valle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (371, 'Yoro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (372, 'Hong Kong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (525, 'Howland Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Bacs-Kiskun')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Baranya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Bekes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Bekescsaba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Borsod-Abauj-Zemplen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Budapest')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Csongrad')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Debrecen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Dunaujvaros')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Eger')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Fejer')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Gyor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Gyor-Moson-Sopron')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Hajdu-Bihar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Heves')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Hodmezovasarhely')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Jasz-Nagykun-Szolnok')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Kaposvar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Kecskemet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Komarom-Esztergom')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Miskolc')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Nagykanizsa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Nograd')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Nyiregyhaza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Pecs')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Pest')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Somogy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Sopron')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Szabolcs-Szatmar-Bereg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Szeged')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Szekesfehervar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Szolnok')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Szombathely')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Tatabanya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Tolna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Vas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Veszprem')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Veszprem')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Zala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (373, 'Zalaegerszeg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Akranes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Akureyri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Arnessysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Austur-Bardhastrandarsysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Austur-Hunavatnssysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Austur-Skaftafellssysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Borgarfjardharsysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Dalasysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Eyjafjardharsysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Gullbringusysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Hafnarfjordhur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Husavik')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Isafjordhur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Keflavik')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Kjosarsysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Kopavogur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Myrasysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Neskaupstadhur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Nordhur-Isafjardharsysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Nordhur-Mulasys-la')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Nordhur-Thingeyjarsysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Olafsfjordhur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Rangarvallasysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Reykjavik')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Saudharkrokur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Seydhisfjordhur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Siglufjordhur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Skagafjardharsysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Snaefellsnes-og Hnappadalssysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Strandasysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Sudhur-Mulasysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Sudhur-Thingeyjarsysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Vesttmannaeyjar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Vestur-Bardhastrandarsysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Vestur-Hunavatnssysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Vestur-Isafjardharsysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (374, 'Vestur-Skaftafellssysla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Andaman and Nicobar Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Andhra Pradesh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Arunachal Pradesh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Assam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Bihar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Chandigarh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Chhattisgarh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Dadra and Nagar Haveli')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Daman and Diu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Delhi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Goa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Gujarat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Haryana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Himachal Pradesh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Jammu and Kashmir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Jharkhand')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Karnataka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Kerala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Lakshadweep')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Madhya Pradesh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, '|Maharashtra')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Manipur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Meghalaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Mizoram')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Nagaland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Orissa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Pondicherry')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Punjab')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Rajasthan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Sikkim')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Tamil Nadu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Tripura')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Uttar Pradesh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'Uttaranchal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (375, 'West Bengal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Aceh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Bali')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Banten')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Bengkulu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'East Timor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Gorontalo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Irian Jaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Jakarta Raya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Jambi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Jawa Barat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Jawa Tengah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Jawa Timur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Kalimantan Barat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Kalimantan Selatan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Kalimantan Tengah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Kalimantan Timur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Kepulauan Bangka Belitung')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Lampung')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Maluku')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Maluku Utara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Nusa Tenggara Barat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Nusa Tenggara Timur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Riau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Sulawesi Selatan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Sulawesi Tengah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Sulawesi Tenggara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Sulawesi Utara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Sumatera Barat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Sumatera Selatan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Sumatera Utara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (376, 'Yogyakarta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Ardabil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Azarbayjan-e Gharbi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Azarbayjan-e Sharqi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Bushehr')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Chahar Mahall va Bakhtiari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Esfahan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Fars')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Gilan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Golestan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Hamadan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Hormozgan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Ilam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Kerman')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Kermanshah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Khorasan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Khuzestan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Kohgiluyeh va Buyer Ahmad')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Kordestan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Lorestan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Markazi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Mazandaran')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Qazvin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Qom')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Semnan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Sistan va Baluchestan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Tehran')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Yazd')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (377, 'Zanjan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (196, 'Al Anbar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (196, 'Al Basrah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (196, 'Al Muthanna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (196, 'Al Qadisiyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (196, 'An Najaf')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (196, 'Arbil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (196, 'As Sulaymaniyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (196, 'At Ta''mim')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (196, 'Babil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (196, 'Baghdad')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (196, 'Dahuk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (196, 'Dhi Qar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (196, 'Diyala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (196, 'Karbala''')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (196, 'Maysan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (196, 'Ninawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (196, 'Salah ad Din')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (196, 'Wasit')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Carlow')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Cavan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Clare')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Cork')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Donegal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Dublin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Galway')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Kerry')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Kildare')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Kilkenny')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Laois')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Leitrim')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Limerick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Longford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Louth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Mayo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Meath')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Monaghan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Offaly')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Roscommon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Sligo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Tipperary')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Waterford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Westmeath')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Wexford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (526, 'Wicklow')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Antrim')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Ards')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Armagh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Ballymena')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Ballymoney')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Banbridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Belfast')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Carrickfergus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Castlereagh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Coleraine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Cookstown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Craigavon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Derry')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Down')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Dungannon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Fermanagh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Larne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Limavady')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Lisburn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Magherafelt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Moyle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Newry and Mourne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Newtownabbey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'North Down')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Omagh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (378, 'Strabane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (380, 'Central')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (380, 'Haifa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (380, 'Jerusalem')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (380, 'Northern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (380, 'Southern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (380, 'Tel Aviv')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (197, 'Isle of Man')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Asti')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Avellino')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Bari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Barletta-Andria-Trani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Belluno')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Benevento')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Bergamo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Biella')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Bologna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Bolzano')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Brescia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Brindisi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Cagliari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Caltanissetta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Campobasso')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Caserta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Catania')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Catanzaro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Chieti')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Como')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Cosenza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Cremona')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Crotone')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Cuneo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Enna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Fermo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Ferrara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Firenze')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Foggia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Forli-Cesena')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Frosinone')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Genova')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Gorizia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Grosseto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Imperia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Isernia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'La-Spezia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Latina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Lecce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Lecco')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Livorno')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Lodi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Lucca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Macerata')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Mantova')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Massa-Carrara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Matera')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Messina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Milano')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Modena')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Monza-Brianza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Napoli')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Novara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Nuoro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Oristano')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Padova')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Palermo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Parma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Pavia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Perugia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Pesaro-Urbino')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Pescara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Piacenza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Pisa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Pistoia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Pordenone')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Potenza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Prato')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Ragusa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Ravenna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Reggio-Calabria')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Reggio-Emilia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Rieti')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Rimini')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Roma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Rovigo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Salerno')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Sassari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Savona')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Siena')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Siracusa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Sondrio')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Taranto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Teramo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Terni')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Torino')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Trapani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Trento')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Treviso')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Trieste')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Udine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Varese')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Venezia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Verbania')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Vercelli')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Verona')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Vibo-Valentia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Vicenza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (381, 'Viterbo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (383, 'Clarendon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (383, 'Hanover')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (383, 'Kingston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (383, 'Manchester')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (383, 'Portland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (383, 'Saint Andrew')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (383, 'Saint Ann')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (383, 'Saint Catherine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (383, 'Saint Elizabeth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (383, 'Saint James')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (383, 'Saint Mary')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (383, 'Saint Thomas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (383, 'Trelawny')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (383, 'Westmoreland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Aichi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Akita')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Aomori')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Chiba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Ehime')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Fukui')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Fukuoka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Fukushima')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Gifu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Gumma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Hiroshima')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Hokkaido')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Hyogo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Ibaraki')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Ishikawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Iwate')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Kagawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Kagoshima')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Kanagawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Kochi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Kumamoto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Kyoto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Mie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Miyagi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Miyazaki')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Nagano')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Nagasaki')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Nara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Niigata')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Oita')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Okayama')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Okinawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Osaka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Saga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Saitama')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Shiga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Shimane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Shizuoka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Tochigi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Tokushima')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Tokyo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Tottori')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Toyama')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Wakayama')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Yamagata')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Yamaguchi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (384, 'Yamanashi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (527, 'Jarvis Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (528, 'Jersey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (529, 'Johnston Atoll')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (385, '''Amman')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (385, 'Ajlun')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (385, 'Al ''Aqabah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (385, 'Al Balqa''')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (385, 'Al Karak')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (385, 'Al Mafraq')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (385, 'At Tafilah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (385, 'Az Zarqa''')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (385, 'Irbid')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (385, 'Jarash')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (385, 'Ma''an')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (385, 'Madaba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (530, 'Juan de Nova Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (199, 'Almaty')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (199, 'Aqmola')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (199, 'Aqtobe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (199, 'Astana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (199, 'Atyrau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (199, 'Batys Qazaqstan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (199, 'Bayqongyr')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (199, 'Mangghystau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (199, 'Ongtustik Qazaqstan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (199, 'Pavlodar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (199, 'Qaraghandy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (199, 'Qostanay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (199, 'Qyzylorda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (199, 'Shyghys Qazaqstan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (199, 'Soltustik Qazaqstan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (199, 'Zhambyl')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (386, 'Central')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (386, 'Coast')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (386, 'Eastern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (386, 'Nairobi Area')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (386, 'North Eastern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (386, 'Nyanza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (386, 'Rift Valley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (386, 'Western')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Abaiang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Abemama')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Aranuka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Arorae')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Banaba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Banaba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Beru')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Butaritari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Central Gilberts')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Gilbert Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Kanton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Kiritimati')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Kuria')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Line Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Line Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Maiana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Makin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Marakei')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Nikunau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Nonouti')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Northern Gilberts')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Onotoa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Phoenix Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Southern Gilberts')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Tabiteuea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Tabuaeran')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Tamana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Tarawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Tarawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (219, 'Teraina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (531, 'Chagang-do (Chagang Province)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (531, 'Hamgyong-bukto (North Hamgyong Province)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (531, 'Hamgyong-namdo (South Hamgyong Province)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (531, 'Hwanghae-bukto (North Hwanghae Province)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (531, 'Hwanghae-namdo (South Hwanghae Province)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (531, 'Kaesong-si (Kaesong City)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (531, 'Kangwon-do (Kangwon Province)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (531, 'Namp''o-si (Namp''o City)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (531, 'P''yongan-bukto (North P''yongan Province)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (531, 'P''yongan-namdo (South P''yongan Province)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (531, 'P''yongyang-si (P''yongyang City)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (531, 'Yanggang-do (Yanggang Province)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (532, 'Ch''ungch''ong-bukto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (532, 'Ch''ungch''ong-namdo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (532, 'Cheju-do')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (532, 'Cholla-bukto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (532, 'Cholla-namdo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (532, 'Inch''on-gwangyoksi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (532, 'Kangwon-do')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (532, 'Kwangju-gwangyoksi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (532, 'Kyonggi-do')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (532, 'Kyongsang-bukto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (532, 'Kyongsang-namdo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (532, 'Pusan-gwangyoksi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (532, 'Soul-t''ukpyolsi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (532, 'Taegu-gwangyoksi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (532, 'Taejon-gwangyoksi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (532, 'Ulsan-gwangyoksi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (388, 'Al ''Asimah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (388, 'Al Ahmadi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (388, 'Al Farwaniyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (388, 'Al Jahra''')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (388, 'Hawalli')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (200, 'Batken Oblasty')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (200, 'Bishkek Shaary')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (200, 'Chuy Oblasty (Bishkek)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (200, 'Jalal-Abad Oblasty')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (200, 'Naryn Oblasty')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (200, 'Osh Oblasty')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (200, 'Talas Oblasty')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (200, 'Ysyk-Kol Oblasty (Karakol)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (220, 'Attapu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (220, 'Bokeo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (220, 'Bolikhamxai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (220, 'Champasak')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (220, 'Houaphan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (220, 'Khammouan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (220, 'Louangnamtha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (220, 'Louangphabang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (220, 'Oudomxai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (220, 'Phongsali')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (220, 'Salavan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (220, 'Savannakhet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (220, 'Viangchan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (220, 'Viangchan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (220, 'Xaignabouli')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (220, 'Xaisomboun')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (220, 'Xekong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (220, 'Xiangkhoang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Aizkraukles Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Aluksnes Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Balvu Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Bauskas Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Cesu Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Daugavpils')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Daugavpils Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Dobeles Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Gulbenes Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Jekabpils Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Jelgava')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Jelgavas Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Jurmala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Kraslavas Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Kuldigas Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Leipaja')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Liepajas Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Limbazu Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Ludzas Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Madonas Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Ogres Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Preilu Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Rezekne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Rezeknes Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Riga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Rigas Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Saldus Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Talsu Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Tukuma Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Valkas Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Valmieras Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Ventspils')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (389, 'Ventspils Rajons')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (390, 'Beyrouth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (390, 'Ech Chimal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (390, 'Ej Jnoub')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (390, 'El Bekaa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (390, 'Jabal Loubnane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (391, 'Berea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (391, 'Butha-Buthe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (391, 'Leribe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (391, 'Mafeteng')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (391, 'Maseru')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (391, 'Mohales Hoek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (391, 'Mokhotlong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (391, 'Qacha''s Nek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (391, 'Quthing')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (391, 'Thaba-Tseka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (221, 'Bomi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (221, 'Bong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (221, 'Grand Bassa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (221, 'Grand Cape Mount')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (221, 'Grand Gedeh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (221, 'Grand Kru')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (221, 'Lofa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (221, 'Margibi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (221, 'Maryland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (221, 'Montserrado')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (221, 'Nimba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (221, 'River Cess')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (221, 'Sinoe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Ajdabiya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Al ''Aziziyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Al Fatih')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Al Jabal al Akhdar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Al Jufrah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Al Khums')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Al Kufrah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'An Nuqat al Khams')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Ash Shati''')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Awbari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Az Zawiyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Banghazi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Darnah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Ghadamis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Gharyan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Misratah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Murzuq')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Sabha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Sawfajjin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Surt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Tarabulus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Tarhunah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Tubruq')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Yafran')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (533, 'Zlitan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (392, 'Balzers')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (392, 'Eschen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (392, 'Gamprin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (392, 'Mauren')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (392, 'Planken')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (392, 'Ruggell')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (392, 'Schaan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (392, 'Schellenberg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (392, 'Triesen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (392, 'Triesenberg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (392, 'Vaduz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Akmenes Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Alytaus Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Alytus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Anyksciu Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Birstonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Birzu Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Druskininkai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Ignalinos Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Jonavos Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Joniskio Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Jurbarko Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Kaisiadoriu Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Kaunas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Kauno Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Kedainiu Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Kelmes Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Klaipeda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Klaipedos Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Kretingos Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Kupiskio Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Lazdiju Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Marijampole')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Marijampoles Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Mazeikiu Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Moletu Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Neringa Pakruojo Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Palanga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Panevezio Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Panevezys')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Pasvalio Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Plunges Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Prienu Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Radviliskio Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Raseiniu Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Rokiskio Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Sakiu Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Salcininku Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Siauliai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Siauliu Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Silales Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Silutes Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Sirvintu Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Skuodo Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Svencioniu Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Taurages Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Telsiu Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Traku Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Ukmerges Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Utenos Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Varenos Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Vilkaviskio Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Vilniaus Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Vilnius')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (393, 'Zarasu Rajonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (394, 'Diekirch')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (394, 'Grevenmacher')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (394, 'Luxembourg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (395, 'Macau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Aracinovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Bac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Belcista')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Berovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Bistrica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Bitola')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Blatec')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Bogdanci')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Bogomila')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Bogovinje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Bosilovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Brvenica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Cair (Skopje)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Capari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Caska')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Cegrane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Centar (Skopje)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Centar Zupa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Cesinovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Cucer-Sandevo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Debar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Delcevo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Delogozdi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Demir Hisar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Demir Kapija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Dobrusevo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Dolna Banjica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Dolneni')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Dorce Petrov (Skopje)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Drugovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Dzepciste')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Gazi Baba (Skopje)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Gevgelija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Gostivar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Gradsko')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Ilinden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Izvor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Jegunovce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Kamenjane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Karbinci')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Karpos (Skopje)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Kavadarci')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Kicevo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Kisela Voda (Skopje)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Klecevce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Kocani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Konce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Kondovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Konopiste')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Kosel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Kratovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Kriva Palanka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Krivogastani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Krusevo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Kuklis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Kukurecani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Kumanovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Labunista')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Lipkovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Lozovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Lukovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Makedonska Kamenica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Makedonski Brod')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Mavrovi Anovi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Meseista')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Miravci')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Mogila')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Murtino')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Negotino')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Negotino-Poloska')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Novaci')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Novo Selo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Oblesevo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Ohrid')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Orasac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Orizari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Oslomej')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Pehcevo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Petrovec')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Plasnia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Podares')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Prilep')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Probistip')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Radovis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Rankovce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Resen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Rosoman')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Rostusa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Samokov')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Saraj')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Sipkovica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Sopiste')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Sopotnika')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Srbinovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Star Dojran')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Staravina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Staro Nagoricane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Stip')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Struga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Strumica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Studenicani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Suto Orizari (Skopje)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Sveti Nikole')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Tearce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Tetovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Topolcani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Valandovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Vasilevo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Veles')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Velesta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Vevcani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Vinica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Vitoliste')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Vranestica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Vrapciste')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Vratnica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Vrutok')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Zajas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Zelenikovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Zileno')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Zitose')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Zletovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (222, 'Zrnovci')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (396, 'Antananarivo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (396, 'Antsiranana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (396, 'Fianarantsoa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (396, 'Mahajanga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (396, 'Toamasina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (396, 'Toliara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Balaka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Blantyre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Chikwawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Chiradzulu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Chitipa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Dedza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Dowa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Karonga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Kasungu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Likoma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Lilongwe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Machinga (Kasupe)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Mangochi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Mchinji')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Mulanje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Mwanza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Mzimba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Nkhata Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Nkhotakota')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Nsanje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Ntcheu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Ntchisi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Phalombe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Rumphi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Salima')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Thyolo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (397, 'Zomba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (398, 'Johor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (398, 'Kedah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (398, 'Kelantan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (398, 'Labuan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (398, 'Melaka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (398, 'Negeri Sembilan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (398, 'Pahang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (398, 'Perak')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (398, 'Perlis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (398, 'Pulau Pinang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (398, 'Sabah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (398, 'Sarawak')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (398, 'Selangor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (398, 'Terengganu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (398, 'Wilayah Persekutuan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Alifu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Baa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Dhaalu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Faafu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Gaafu Alifu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Gaafu Dhaalu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Gnaviyani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Haa Alifu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Haa Dhaalu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Kaafu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Laamu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Lhaviyani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Maale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Meemu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Noonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Raa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Seenu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Shaviyani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Thaa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (399, 'Vaavu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (100, 'Gao')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (100, 'Kayes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (100, 'Kidal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (100, 'Koulikoro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (100, 'Mopti')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (100, 'Segou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (100, 'Sikasso')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (100, 'Tombouctou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (101, 'Valletta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Ailinginae')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Ailinglaplap')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Ailuk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Arno')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Aur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Bikar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Bikini')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Bokak')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Ebon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Enewetak')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Erikub')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Jabat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Jaluit')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Jemo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Kili')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Kwajalein')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Lae')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Lib')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Likiep')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Majuro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Maloelap')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Mejit')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Mili')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Namorik')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Namu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Rongelap')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Rongrik')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Toke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Ujae')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Ujelang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Utirik')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Wotho')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (102, 'Wotje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (103, 'Martinique')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (104, 'Adrar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (104, 'Assaba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (104, 'Brakna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (104, 'Dakhlet Nouadhibou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (104, 'Gorgol')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (104, 'Guidimaka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (104, 'Hodh Ech Chargui')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (104, 'Hodh El Gharbi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (104, 'Inchiri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (104, 'Nouakchott')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (104, 'Tagant')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (104, 'Tiris Zemmour')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (104, 'Trarza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (105, 'Agalega Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (105, 'Black River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (105, 'Cargados Carajos Shoals')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (105, 'Flacq')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (105, 'Grand Port')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (105, 'Moka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (105, 'Pamplemousses')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (105, 'Plaines Wilhems')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (105, 'Port Louis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (105, 'Riviere du Rempart')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (105, 'Rodrigues')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (105, 'Savanne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (535, 'Mayotte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Aguascalientes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Baja California')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Baja California Sur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Campeche')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Chiapas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Chihuahua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Coahuila de Zaragoza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Colima')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Distrito Federal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Durango')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Guanajuato')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Guerrero')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Hidalgo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Jalisco')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Mexico')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Michoacan de Ocampo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Morelos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Nayarit')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Nuevo Leon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Oaxaca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Puebla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Queretaro de Arteaga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Quintana Roo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'San Luis Potosi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Sinaloa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Sonora')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Tabasco')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Tamaulipas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Tlaxcala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Veracruz-Llave')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Yucatan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (106, 'Zacatecas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (107, 'Chuuk (Truk)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (107, 'Kosrae')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (107, 'Pohnpei')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (107, 'Yap')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (536, 'Midway Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (203, 'Balti')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (203, 'Cahul')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (203, 'Chisinau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (203, 'Chisinau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (203, 'Dubasari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (203, 'Edinet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (203, 'Gagauzia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (203, 'Lapusna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (203, 'Orhei')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (203, 'Soroca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (203, 'Tighina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (203, 'Ungheni')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (108, 'Fontvieille')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (108, 'La Condamine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (108, 'Monaco-Ville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (108, 'Monte-Carlo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Arhangay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Bayan-Olgiy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Bayanhongor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Bulgan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Darhan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Dornod')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Dornogovi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Dundgovi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Dzavhan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Erdenet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Govi-Altay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Hentiy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Hovd')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Hovsgol')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Omnogovi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Ovorhangay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Selenge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Suhbaatar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Tov')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Ulaanbaatar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (223, 'Uvs')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (109, 'Saint Anthony')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (109, 'Saint Georges')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (109, 'Saint Peter''s')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Agadir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Al Hoceima')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Azilal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Ben Slimane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Beni Mellal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Boulemane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Casablanca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Chaouen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'El Jadida')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'El Kelaa des Srarhna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Er Rachidia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Essaouira')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Fes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Figuig')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Guelmim')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Ifrane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Kenitra')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Khemisset')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Khenifra')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Khouribga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Laayoune')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Larache')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Marrakech')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Meknes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Nador')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Ouarzazate')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Oujda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Rabat-Sale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Safi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Settat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Sidi Kacem')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Tan-Tan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Tanger')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Taounate')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Taroudannt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Tata')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Taza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Tetouan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (110, 'Tiznit')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (111, 'Cabo Delgado')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (111, 'Gaza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (111, 'Inhambane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (111, 'Manica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (111, 'Maputo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (111, 'Nampula')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (111, 'Niassa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (111, 'Sofala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (111, 'Tete')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (111, 'Zambezia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (112, 'Caprivi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (112, 'Erongo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (112, 'Hardap')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (112, 'Karas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (112, 'Khomas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (112, 'Kunene')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (112, 'Ohangwena')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (112, 'Okavango')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (112, 'Omaheke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (112, 'Omusati')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (112, 'Oshana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (112, 'Oshikoto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (112, 'Otjozondjupa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (225, 'Aiwo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (225, 'Anabar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (225, 'Anetan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (225, 'Anibare')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (225, 'Baiti')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (225, 'Boe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (225, 'Buada')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (225, 'Denigomodu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (225, 'Ewa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (225, 'Ijuw')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (225, 'Meneng')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (225, 'Nibok')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (225, 'Uaboe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (225, 'Yaren')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (113, 'Bagmati')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (113, 'Bheri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (113, 'Dhawalagiri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (113, 'Gandaki')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (113, 'Janakpur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (113, 'Karnali')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (113, 'Kosi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (113, 'Lumbini')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (113, 'Mahakali')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (113, 'Mechi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (113, 'Narayani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (113, 'Rapti')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (113, 'Sagarmatha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (113, 'Seti')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (114, 'Drenthe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (114, 'Flevoland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (114, 'Friesland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (114, 'Gelderland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (114, 'Groningen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (114, 'Limburg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (114, 'Noord-Brabant')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (114, 'Noord-Holland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (114, 'Overijssel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (114, 'Utrecht')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (114, 'Zeeland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (114, 'Zuid-Holland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (537, 'Netherlands Antilles')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (116, 'Iles Loyaute')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (116, 'Nord')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (116, 'Sud')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Akaroa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Amuri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Ashburton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Bay of Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Bruce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Buller')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Chatham Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Cheviot')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Clifton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Clutha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Cook')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Dannevirke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Egmont')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Eketahuna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Ellesmere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Eltham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Eyre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Featherston')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Franklin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Golden Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Great Barrier Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Grey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Hauraki Plains')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Hawera')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Hawke''s Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Heathcote')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Hikurangi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Hobson')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Hokianga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Horowhenua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Hurunui')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Hutt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Inangahua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Inglewood')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Kaikoura')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Kairanga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Kiwitea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Lake')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Mackenzie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Malvern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Manaia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Manawatu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Mangonui')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Maniototo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Marlborough')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Masterton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Matamata')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Mount Herbert')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Ohinemuri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Opotiki')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Oroua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Otamatea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Otorohanga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Oxford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Pahiatua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Paparua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Patea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Piako')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Pohangina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Raglan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Rangiora')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Rangitikei')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Rodney')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Rotorua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Runanga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Saint Kilda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Silverpeaks')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Southland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Stewart Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Stratford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Strathallan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Taranaki')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Taumarunui')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Taupo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Tauranga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Thames-Coromandel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Tuapeka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Vincent')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Waiapu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Waiheke')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Waihemo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Waikato')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Waikohu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Waimairi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Waimarino')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Waimate')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Waimate West')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Waimea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Waipa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Waipawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Waipukurau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Wairarapa South')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Wairewa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Wairoa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Waitaki')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Waitomo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Waitotara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Wallace')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Wanganui')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Waverley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Westland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Whakatane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Whangarei')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Whangaroa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (117, 'Woodville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (118, 'Atlantico Norte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (118, 'Atlantico Sur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (118, 'Boaco')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (118, 'Carazo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (118, 'Chinandega')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (118, 'Chontales')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (118, 'Esteli')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (118, 'Granada')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (118, 'Jinotega')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (118, 'Leon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (118, 'Madriz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (118, 'Managua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (118, 'Masaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (118, 'Matagalpa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (118, 'Nueva Segovia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (118, 'Rio San Juan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (118, 'Rivas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (119, 'Agadez')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (119, 'Diffa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (119, 'Dosso')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (119, 'Maradi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (119, 'Niamey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (119, 'Tahoua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (119, 'Tillaberi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (119, 'Zinder')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Abia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Abuja Federal Capital Territory')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Adamawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Akwa Ibom')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Anambra')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Bauchi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Bayelsa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Benue')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Borno')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Cross River')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Delta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Ebonyi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Edo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Ekiti')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Enugu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Gombe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Imo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Jigawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Kaduna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Kano')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Katsina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Kebbi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Kogi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Kwara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Lagos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Nassarawa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Niger')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Ogun')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Ondo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Osun')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Oyo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Plateau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Rivers')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Sokoto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Taraba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Yobe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (120, 'Zamfara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (226, 'Niue')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (258, 'Norfolk Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (538, 'Northern Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (538, 'Rota')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (538, 'Saipan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (538, 'Tinian')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'Akershus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'Aust-Agder')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'Buskerud')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'Finnmark')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'Hedmark')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'Hordaland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'More og Romsdal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'Nord-Trondelag')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'Nordland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'Oppland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'Oslo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'Ostfold')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'Rogaland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'Sogn og Fjordane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'Sor-Trondelag')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'Telemark')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'Troms')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'Vest-Agder')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (121, 'Vestfold')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (122, 'Ad Dakhiliyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (122, 'Al Batinah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (122, 'Al Wusta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (122, 'Ash Sharqiyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (122, 'Az Zahirah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (122, 'Masqat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (122, 'Musandam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (122, 'Zufar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (123, 'Balochistan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (123, 'Federally Administered Tribal Areas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (123, 'Islamabad Capital Territory')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (123, 'North-West Frontier Province')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (123, 'Punjab')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (123, 'Sindh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (124, 'Aimeliik')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (124, 'Airai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (124, 'Angaur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (124, 'Hatobohei')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (124, 'Kayangel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (124, 'Koror')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (124, 'Melekeok')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (124, 'Ngaraard')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (124, 'Ngarchelong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (124, 'Ngardmau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (124, 'Ngatpang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (124, 'Ngchesar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (124, 'Ngeremlengui')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (124, 'Ngiwal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (124, 'Palau Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (124, 'Peleliu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (124, 'Sonsoral')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (124, 'Tobi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (125, 'Bocas del Toro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (125, 'Chiriqui')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (125, 'Cocle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (125, 'Colon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (125, 'Darien')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (125, 'Herrera')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (125, 'Los Santos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (125, 'Panama')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (125, 'San Blas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (125, 'Veraguas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'Bougainville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'Central')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'Chimbu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'East new Britain')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'East Sepik')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'Eastern Highlands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'Enga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'Gulf')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'Madang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'Manus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'Milne Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'Morobe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'National Capital')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'New Ireland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'Northern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'Sandaun')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'Southern Highlands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'West New Britain')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'Western')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (126, 'Western Highlands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (127, 'Alto Paraguay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (127, 'Alto Parana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (127, 'Amambay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (127, 'Asuncion (city)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (127, 'Boqueron')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (127, 'Caaguazu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (127, 'Caazapa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (127, 'Canindeyu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (127, 'Central')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (127, 'Concepcion')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (127, 'Cordillera')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (127, 'Guaira')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (127, 'Itapua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (127, 'Misiones')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (127, 'Neembucu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (127, 'Paraguari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (127, 'Presidente Hayes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (127, 'San Pedro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Amazonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Ancash')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Apurimac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Arequipa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Ayacucho')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Cajamarca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Callao')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Cusco')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Huancavelica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Huanuco')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Ica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Junin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'La Libertad')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Lambayeque')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Lima')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Loreto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Madre de Dios')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Moquegua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Pasco')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Piura')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Puno')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'San Martin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Tacna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Tumbes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (128, 'Ucayali')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Abra')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Agusan del Norte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Agusan del Sur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Aklan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Albay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Angeles')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Antique')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Aurora')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Bacolod')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Bago')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Baguio')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Bais')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Basilan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Basilan City')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Bataan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Batanes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Batangas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Batangas City')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Benguet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Bohol')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Bukidnon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Bulacan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Butuan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Cabanatuan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Cadiz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Cagayan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Cagayan de Oro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Calbayog')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Caloocan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Camarines Norte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Camarines Sur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Camiguin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Canlaon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Capiz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Catanduanes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Cavite')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Cavite City')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Cebu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Cebu City')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Cotabato')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Dagupan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Danao')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Dapitan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Davao City Davao')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Davao del Sur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Davao Oriental')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Dipolog')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Dumaguete')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Eastern Samar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'General Santos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Gingoog')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Ifugao')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Iligan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Ilocos Norte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Ilocos Sur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Iloilo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Iloilo City')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Iriga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Isabela')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Kalinga-Apayao')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'La Carlota')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'La Union')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Laguna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Lanao del Norte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Lanao del Sur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Laoag')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Lapu-Lapu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Legaspi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Leyte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Lipa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Lucena')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Maguindanao')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Mandaue')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Manila')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Marawi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Marinduque')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Masbate')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Mindoro Occidental')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Mindoro Oriental')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Misamis Occidental')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Misamis Oriental')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Mountain')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Naga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Negros Occidental')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Negros Oriental')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'North Cotabato')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Northern Samar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Nueva Ecija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Nueva Vizcaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Olongapo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Ormoc')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Oroquieta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Ozamis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Pagadian')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Palawan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Palayan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Pampanga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Pangasinan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Pasay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Puerto Princesa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Quezon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Quezon City')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Quirino')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Rizal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Romblon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Roxas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Samar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'San Carlos (in Negros Occidental)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'San Carlos (in Pangasinan)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'San Jose')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'San Pablo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Silay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Siquijor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Sorsogon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'South Cotabato')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Southern Leyte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Sultan Kudarat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Sulu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Surigao')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Surigao del Norte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Surigao del Sur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Tacloban')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Tagaytay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Tagbilaran')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Tangub')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Tarlac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Tawitawi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Toledo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Trece Martires')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Zambales')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Zamboanga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Zamboanga del Norte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (129, 'Zamboanga del Sur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (539, 'Pitcaim Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (130, 'Dolnoslaskie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (130, 'Kujawsko-Pomorskie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (130, 'Lodzkie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (130, 'Lubelskie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (130, 'Lubuskie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (130, 'Malopolskie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (130, 'Mazowieckie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (130, 'Opolskie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (130, 'Podkarpackie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (130, 'Podlaskie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (130, 'Pomorskie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (130, 'Slaskie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (130, 'Swietokrzyskie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (130, 'Warminsko-Mazurskie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (130, 'Wielkopolskie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (130, 'Zachodniopomorskie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Acores (Azores)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Aveiro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Beja')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Braga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Braganca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Castelo Branco')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Coimbra')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Evora')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Faro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Guarda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Leiria')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Lisboa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Madeira')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Portalegre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Porto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Santarem')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Setubal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Viana do Castelo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Vila Real')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (131, 'Viseu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Adjuntas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Aguada')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Aguadilla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Aguas Buenas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Aibonito')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Anasco')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Arecibo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Arroyo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Barceloneta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Barranquitas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Bayamon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Cabo Rojo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Caguas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Camuy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Canovanas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Carolina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Catano')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Cayey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Ceiba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Ciales')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Cidra')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Coamo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Comerio')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Corozal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Culebra')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Dorado')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Fajardo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Florida')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Guanica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Guayama')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Guayanilla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Guaynabo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Gurabo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Hatillo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Hormigueros')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Humacao')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Isabela')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Jayuya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Juana Diaz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Juncos')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Lajas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Lares')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Las Marias')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Las Piedras')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Loiza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Luquillo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Manati')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Maricao')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Maunabo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Mayaguez')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Moca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Morovis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Naguabo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Naranjito')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Orocovis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Patillas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Penuelas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Ponce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Quebradillas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Rincon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Rio Grande')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Sabana Grande')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Salinas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'San German')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'San Juan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'San Lorenzo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'San Sebastian')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Santa Isabel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Toa Alta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Toa Baja')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Trujillo Alto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Utuado')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Vega Alta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Vega Baja')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Vieques')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Villalba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Yabucoa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (540, 'Yauco')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (132, 'Ad Dawhah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (132, 'Al Ghuwayriyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (132, 'Al Jumayliyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (132, 'Al Khawr')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (132, 'Al Wakrah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (132, 'Ar Rayyan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (132, 'Jarayan al Batinah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (132, 'Madinat ash Shamal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (132, 'Umm Salal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (133, 'Reunion')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Alba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Arad')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Arges')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Bacau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Bihor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Bistrita-Nasaud')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Botosani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Braila')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Brasov')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Bucuresti')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Buzau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Calarasi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Caras-Severin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Cluj')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Constanta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Covasna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Dimbovita')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Dolj')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Galati')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Giurgiu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Gorj')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Harghita')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Hunedoara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Ialomita')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Iasi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Maramures')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Mehedinti')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Mures')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Neamt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Olt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Prahova')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Salaj')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Satu Mare')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Sibiu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Suceava')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Teleorman')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Timis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Tulcea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Vaslui')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Vilcea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (134, 'Vrancea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Adygeya (Maykop)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Aginskiy Buryatskiy (Aginskoye)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Altay (Gorno-Altaysk)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Altayskiy (Barnaul)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Amurskaya (Blagoveshchensk)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Arkhangel''skaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Astrakhanskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Bashkortostan (Ufa)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Belgorodskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Bryanskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Buryatiya (Ulan-Ude)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Chechnya (Groznyy)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Chelyabinskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Chitinskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Chukotskiy (Anadyr'')')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Chuvashiya (Cheboksary)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Dagestan (Makhachkala)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Evenkiyskiy (Tura)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Ingushetiya (Nazran'')')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Irkutskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Ivanovskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Kabardino-Balkariya (Nal''chik)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Kaliningradskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Kalmykiya (Elista)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Kaluzhskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Kamchatskaya (Petropavlovsk-Kamchatskiy)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Karachayevo-Cherkesiya (Cherkessk)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Kareliya (Petrozavodsk)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Kemerovskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Khabarovskiy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Khakasiya (Abakan)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Khanty-Mansiyskiy (Khanty-Mansiysk)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Kirovskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Komi (Syktyvkar)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Komi-Permyatskiy (Kudymkar)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Koryakskiy (Palana)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Kostromskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Krasnodarskiy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Krasnoyarskiy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Kurganskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Kurskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Leningradskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Lipetskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Magadanskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Mariy-El (Yoshkar-Ola)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Mordoviya (Saransk)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Moskovskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Moskva (Moscow)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Murmanskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Nenetskiy (Nar''yan-Mar)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Nizhegorodskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Novgorodskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Novosibirskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Omskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Orenburgskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Orlovskaya (Orel)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Penzenskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Permskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Primorskiy (Vladivostok)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Pskovskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Rostovskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Ryazanskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Sakha (Yakutsk)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Sakhalinskaya (Yuzhno-Sakhalinsk)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Samarskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Sankt-Peterburg (Saint Petersburg)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Saratovskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Severnaya Osetiya-Alaniya [North Ossetia] (Vladikavkaz)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Smolenskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Stavropol''skiy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Sverdlovskaya (Yekaterinburg)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Tambovskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Tatarstan (Kazan'')')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Taymyrskiy (Dudinka)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Tomskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Tul''skaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Tverskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Tyumenskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Tyva (Kyzyl)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Udmurtiya (Izhevsk)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Ul''yanovskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Ust''-Ordynskiy Buryatskiy (Ust''-Ordynskiy)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Vladimirskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Volgogradskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Vologodskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Voronezhskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Yamalo-Nenetskiy (Salekhard)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Yaroslavskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (135, 'Yevreyskaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (136, 'Butare')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (136, 'Byumba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (136, 'Cyangugu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (136, 'Gikongoro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (136, 'Gisenyi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (136, 'Gitarama')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (136, 'Kibungo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (136, 'Kibuye')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (136, 'Kigali Rurale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (136, 'Kigali-ville')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (136, 'Ruhengeri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (136, 'Umutara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (541, 'Ascension')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (541, 'Saint Helena')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (541, 'Tristan da Cunha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (542, 'Christ Church Nichola Town')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (542, 'Saint Anne Sandy Point')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (542, 'Saint George Basseterre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (542, 'Saint George Gingerland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (542, 'Saint James Windward')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (542, 'Saint John Capisterre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (542, 'Saint John Figtree')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (542, 'Saint Mary Cayon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (542, 'Saint Paul Capisterre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (542, 'Saint Paul Charlestown')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (542, 'Saint Peter Basseterre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (542, 'Saint Thomas Lowland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (542, 'Saint Thomas Middle Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (542, 'Trinity Palmetto Point')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (543, 'Anse-la-Raye')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (543, 'Castries')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (543, 'Choiseul')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (543, 'Dauphin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (543, 'Dennery')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (543, 'Gros Islet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (543, 'Laborie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (543, 'Micoud')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (543, 'Praslin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (543, 'Soufriere')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (543, 'Vieux Fort')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (544, 'Miquelon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (544, 'Saint Pierre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (545, 'Charlotte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (545, 'Grenadines')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (545, 'Saint Andrew')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (545, 'Saint David')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (545, 'Saint George')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (545, 'Saint Patrick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (546, 'A''ana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (546, 'Aiga-i-le-Tai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (546, 'Atua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (546, 'Fa''asaleleaga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (546, 'Gaga''emauga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (546, 'Gagaifomauga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (546, 'Palauli')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (546, 'Satupa''itea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (546, 'Tuamasaga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (546, 'Va''a-o-Fonoti')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (546, 'Vaisigano')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (228, 'Acquaviva')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (228, 'Borgo Maggiore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (228, 'Chiesanuova')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (228, 'Domagnano')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (228, 'Faetano')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (228, 'Fiorentino')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (228, 'Monte Giardino')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (228, 'San Marino')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (228, 'Serravalle')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (229, 'Principe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (229, 'Sao Tome')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (148, '''Asir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (148, 'Al Bahah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (148, 'Al Hudud ash Shamaliyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (148, 'Al Jawf|Al Madinah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (148, 'Al Qasim')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (148, 'Ar Riyad')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (148, 'Ash Sharqiyah (Eastern Province)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (148, 'Ha''il')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (148, 'Jizan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (148, 'Makkah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (148, 'Najran')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (148, 'Tabuk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Aberdeen City')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Aberdeenshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Angus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Argyll and Bute')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'City of Edinburgh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Clackmannanshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Dumfries and Galloway')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Dundee City')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'East Ayrshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'East Dunbartonshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'East Lothian')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'East Renfrewshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Eilean Siar (Western Isles)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Falkirk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Fife')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Glasgow City')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Highland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Inverclyde')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Midlothian')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Moray')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'North Ayrshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'North Lanarkshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Orkney Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Perth and Kinross')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Renfrewshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Shetland Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'South Ayrshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'South Lanarkshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'Stirling')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'The Scottish Borders')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'West Dunbartonshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (547, 'West Lothian')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (150, 'Dakar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (150, 'Diourbel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (150, 'Fatick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (150, 'Kaolack')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (150, 'Kolda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (150, 'Louga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (150, 'Saint-Louis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (150, 'Tambacounda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (150, 'Thies')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (150, 'Ziguinchor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (207, 'Serbia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Anse aux Pins')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Anse Boileau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Anse Etoile')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Anse Louis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Anse Royale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Baie Lazare')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Baie Sainte Anne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Beau Vallon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Bel Air')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Bel Ombre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Cascade')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Glacis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Grand'' Anse (on Mahe)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Grand'' Anse (on Praslin)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'La Digue')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'La Riviere Anglaise')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Mont Buxton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Mont Fleuri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Plaisance')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Pointe La Rue')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Port Glaud')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Saint Louis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (151, 'Takamaka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (152, 'Eastern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (152, 'Northern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (152, 'Southern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (152, 'Western')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (153, 'Singapore')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (208, 'Banskobystricky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (208, 'Bratislavsky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (208, 'Kosicky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (208, 'Nitriansky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (208, 'Presovsky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (208, 'Trenciansky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (208, 'Trnavsky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (208, 'Zilinsky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Ajdovscina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Beltinci')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Bled')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Bohinj')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Borovnica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Bovec')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Brda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Brezice')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Brezovica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Cankova-Tisina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Celje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Cerklje na Gorenjskem')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Cerknica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Cerkno')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Crensovci')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Crna na Koroskem')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Crnomelj')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Destrnik-Trnovska Vas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Divaca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Dobrepolje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Dobrova-Horjul-Polhov Gradec')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Dol pri Ljubljani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Domzale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Dornava')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Dravograd')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Duplek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Gorenja Vas-Poljane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Gorisnica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Gornja Radgona')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Gornji Grad')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Gornji Petrovci')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Grosuplje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Hodos Salovci')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Hrastnik')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Hrpelje-Kozina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Idrija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Ig')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Ilirska Bistrica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Ivancna Gorica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Izola')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Jesenice')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Jursinci')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Kamnik')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Kanal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Kidricevo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Kobarid')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Kobilje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Kocevje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Komen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Koper')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Kozje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Kranj')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Kranjska Gora')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Krsko')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Kungota')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Kuzma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Lasko')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Lenart')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Lendava')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Litija')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Ljubljana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Ljubno')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Ljutomer')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Logatec')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Loska Dolina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Loski Potok')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Luce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Lukovica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Majsperk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Maribor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Medvode')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Menges')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Metlika')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Mezica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Miren-Kostanjevica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Mislinja')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Moravce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Moravske Toplice')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Mozirje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Murska Sobota')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Muta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Naklo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Nazarje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Nova Gorica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Novo Mesto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Odranci')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Ormoz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Osilnica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Pesnica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Piran')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Pivka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Podcetrtek')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Podvelka-Ribnica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Postojna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Preddvor')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Ptuj')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Puconci')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Race-Fram')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Radece')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Radenci')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Radlje ob Dravi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Radovljica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Ravne-Prevalje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Ribnica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Rogasevci')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Rogaska Slatina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Rogatec')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Ruse')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Semic')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Sencur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Sentilj')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Sentjernej')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Sentjur pri Celju')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Sevnica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Sezana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Skocjan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Skofja Loka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Skofljica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Slovenj Gradec')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Slovenska Bistrica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Slovenske Konjice')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Smarje pri Jelsah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Smartno ob Paki')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Sostanj')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Starse')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Store')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Sveti Jurij')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Tolmin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Trbovlje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Trebnje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Trzic')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Turnisce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Velenje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Velike Lasce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Videm')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Vipava')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Vitanje')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Vodice')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Vojnik')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Vrhnika')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Vuzenica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Zagorje ob Savi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Zalec')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Zavrc')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Zelezniki')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Ziri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (209, 'Zrece')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (210, 'Bellona')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (210, 'Central')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (210, 'Choiseul (Lauru)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (210, 'Guadalcanal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (210, 'Honiara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (210, 'Isabel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (210, 'Makira')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (210, 'Malaita')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (210, 'Rennell')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (210, 'Temotu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (210, 'Western')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (154, 'Awdal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (154, 'Bakool')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (154, 'Banaadir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (154, 'Bari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (154, 'Bay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (154, 'Galguduud')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (154, 'Gedo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (154, 'Hiiraan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (154, 'Jubbada Dhexe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (154, 'Jubbada Hoose')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (154, 'Mudug')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (154, 'Nugaal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (154, 'Sanaag')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (154, 'Shabeellaha Dhexe')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (154, 'Shabeellaha Hoose')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (154, 'Sool')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (154, 'Togdheer')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (154, 'Woqooyi Galbeed')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (155, 'Eastern Cape')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (155, 'Free State')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (155, 'Gauteng')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (155, 'KwaZulu-Natal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (155, 'Mpumalanga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (155, 'North-West')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (155, 'Northern Cape')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (155, 'Northern Province')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (155, 'Western Cape')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (548, 'Bird Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (548, 'Bristol Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (548, 'Clerke Rocks')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (548, 'Montagu Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (548, 'Saunders Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (548, 'South Georgia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (548, 'Southern Thule')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (548, 'Traversay Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Andalucia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Aragon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Asturias')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Baleares (Balearic Islands)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Canarias (Canary Islands)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Cantabria')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Castilla y Leon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Castilla-La Mancha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Cataluna')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Ceuta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Communidad Valencian')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Extremadura')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Galicia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Islas Chafarinas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'La Rioja')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Madrid')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Melilla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Murcia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Navarra')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Pais Vasco (Basque Country)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Penon de Alhucemas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (156, 'Penon de Velez de la Gomera')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (549, 'Spratly Islands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (157, 'Central')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (157, 'Eastern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (157, 'North Central')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (157, 'North Eastern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (157, 'North Western')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (157, 'Northern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (157, 'Sabaragamuwa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (157, 'Southern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (157, 'Uva')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (157, 'Western')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'A''ali an Nil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Al Bahr al Ahmar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Al Buhayrat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Al Jazirah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Al Khartum')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Al Qadarif')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Al Wahdah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'An Nil al Abyad')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'An Nil al Azraq')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Ash Shamaliyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Bahr al Jabal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Gharb al Istiwa''iyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Gharb Bahr al Ghazal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Gharb Darfur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Gharb Kurdufan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Janub Darfur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Janub Kurdufan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Junqali')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Kassala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Nahr an Nil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Shamal Bahr al Ghazal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Shamal Darfur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Shamal Kurdufan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Sharq al Istiwa''iyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Sinnar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (158, 'Warab')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (159, 'Brokopondo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (159, 'Commewijne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (159, 'Coronie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (159, 'Marowijne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (159, 'Nickerie')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (159, 'Para')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (159, 'Paramaribo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (159, 'Saramacca')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (159, 'Sipaliwini')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (159, 'Wanica')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (550, 'Barentsoya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (550, 'Bjornoya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (550, 'Edgeoya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (550, 'Hopen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (550, 'Kvitoya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (550, 'Nordaustandet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (550, 'Prins Karls Forland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (550, 'Spitsbergen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (160, 'Hhohho')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (160, 'Lubombo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (160, 'Manzini')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (160, 'Shiselweni')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Blekinge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Dalarnas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Gavleborgs')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Gotlands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Hallands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Jamtlands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Jonkopings')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Kalmar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Kronobergs')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Norrbottens')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Orebro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Ostergotlands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Skane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Sodermanlands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Stockholms')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Uppsala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Varmlands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Vasterbottens')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Vasternorrlands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Vastmanlands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (161, 'Vastra Gotalands')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Aargau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Ausser-Rhoden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Basel-Landschaft')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Basel-Stadt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Bern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Fribourg')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Geneve')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Glarus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Graubunden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Inner-Rhoden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Jura')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Luzern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Neuchatel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Nidwalden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Obwalden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Sankt Gallen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Schaffhausen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Schwyz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Solothurn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Thurgau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Ticino')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Uri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Valais')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Vaud')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Zug')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (162, 'Zurich')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (163, 'Al Hasakah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (163, 'Al Ladhiqiyah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (163, 'Al Qunaytirah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (163, 'Ar Raqqah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (163, 'As Suwayda''')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (163, 'Dar''a')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (163, 'Dayr az Zawr')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (163, 'Dimashq')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (163, 'Halab')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (163, 'Hamah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (163, 'Hims')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (163, 'Idlib')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (163, 'Rif Dimashq')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (163, 'Tartus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'Chang-hua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'Chi-lung')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'Chia-i')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'Chung-hsing-hsin-ts''un')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'Hsin-chu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'Hua-lien')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'I-lan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'Kao-hsiung')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'Kao-hsiung')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'Miao-li')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'Nan-t''ou')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'P''eng-hu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'P''ing-tung')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'T''ai-chung')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'T''ai-chung')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'T''ai-nan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'T''ai-nan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'T''ai-pei')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'T''ai-pei')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'T''ai-tung')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'T''ao-yuan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (164, 'Yun-lin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (211, 'Viloyati Khatlon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (211, 'Viloyati Leninobod')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (211, 'Viloyati Mukhtori Kuhistoni Badakhshon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Arusha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Dar es Salaam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Dodoma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Iringa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Kagera')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Kigoma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Kilimanjaro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Lindi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Mara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Mbeya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Morogoro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Mtwara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Mwanza')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Pemba North')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Pemba South')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Pwani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Rukwa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Ruvuma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Shinyanga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Singida')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Tabora')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Tanga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Zanzibar Central/South')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Zanzibar North')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (165, 'Zanzibar Urban/West')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Amnat Charoen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Ang Thong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Buriram')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Chachoengsao')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Chai Nat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Chaiyaphum')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Chanthaburi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Chiang Mai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Chiang Rai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Chon Buri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Chumphon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Kalasin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Kamphaeng Phet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Kanchanaburi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Khon Kaen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Krabi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Krung Thep Mahanakhon (Bangkok)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Lampang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Lamphun')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Loei')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Lop Buri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Mae Hong Son')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Maha Sarakham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Mukdahan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Nakhon Nayok')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Nakhon Pathom')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Nakhon Phanom')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Nakhon Ratchasima')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Nakhon Sawan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Nakhon Si Thammarat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Nan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Narathiwat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Nong Bua Lamphu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Nong Khai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Nonthaburi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Pathum Thani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Pattani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Phangnga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Phatthalung')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Phayao')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Phetchabun')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Phetchaburi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Phichit')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Phitsanulok')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Phra Nakhon Si Ayutthaya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Phrae')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Phuket')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Prachin Buri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Prachuap Khiri Khan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Ranong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Ratchaburi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Rayong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Roi Et')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Sa Kaeo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Sakon Nakhon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Samut Prakan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Samut Sakhon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Samut Songkhram')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Sara Buri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Satun')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Sing Buri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Sisaket')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Songkhla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Sukhothai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Suphan Buri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Surat Thani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Surin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Tak')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Trang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Trat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Ubon Ratchathani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Udon Thani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Uthai Thani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Uttaradit')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Yala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (166, 'Yasothon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (551, 'Tobago')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (167, 'De La Kara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (167, 'Des Plateaux')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (167, 'Des Savanes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (167, 'Du Centre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (167, 'Maritime')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (552, 'Atafu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (552, 'Fakaofo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (552, 'Nukunonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (249, 'Ha''apai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (249, 'Tongatapu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (249, 'Vava''u')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (168, 'Arima')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (168, 'Caroni')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (168, 'Mayaro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (168, 'Nariva')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (168, 'Port-of-Spain')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (168, 'Saint Andrew')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (168, 'Saint David')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (168, 'Saint George')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (168, 'Saint Patrick')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (168, 'San Fernando')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (168, 'Victoria')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Ariana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Beja')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Ben Arous')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Bizerte')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'El Kef')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Gabes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Gafsa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Jendouba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Kairouan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Kasserine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Kebili')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Mahdia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Medenine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Monastir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Nabeul')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Sfax')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Sidi Bou Zid')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Siliana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Sousse')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Tataouine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Tozeur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Tunis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (169, 'Zaghouan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Adana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Adiyaman')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Afyon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Agri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Aksaray')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Amasya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Ankara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Antalya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Ardahan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Artvin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Aydin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Balikesir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Bartin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Batman')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Bayburt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Bilecik')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Bingol')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Bitlis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Bolu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Burdur')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Bursa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Canakkale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Cankiri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Corum')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Denizli')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Diyarbakir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Duzce')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Edirne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Elazig')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Erzincan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Erzurum')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Eskisehir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Gaziantep')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Giresun')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Gumushane')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Hakkari')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Hatay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Icel')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Igdir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Isparta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Istanbul')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Izmir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Kahramanmaras')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Karabuk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Karaman')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Kars')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Kastamonu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Kayseri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Kilis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Kirikkale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Kirklareli')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Kirsehir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Kocaeli')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Konya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Kutahya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Malatya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Manisa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Mardin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Mugla')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Mus')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Nevsehir')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Nigde')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Ordu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Osmaniye')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Rize')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Sakarya')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Samsun')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Sanliurfa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Siirt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Sinop')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Sirnak')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Sivas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Tekirdag')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Tokat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Trabzon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Tunceli')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Usak')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Van')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Yalova')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Yozgat')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (170, 'Zonguldak')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (212, 'Ahal Welayaty')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (212, 'Balkan Welayaty')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (212, 'Dashhowuz Welayaty')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (212, 'Lebap Welayaty')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (212, 'Mary Welayaty')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (231, 'Tuvalu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Adjumani')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Apac')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Arua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Bugiri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Bundibugyo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Bushenyi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Busia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Gulu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Hoima')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Iganga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Jinja')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Kabale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Kabarole')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Kalangala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Kampala')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Kamuli')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Kapchorwa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Kasese')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Katakwi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Kibale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Kiboga')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Kisoro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Kitgum')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Kotido')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Kumi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Lira')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Luwero')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Masaka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Masindi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Mbale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Mbarara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Moroto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Moyo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Mpigi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Mubende')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Mukono')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Nakasongola')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Nebbi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Ntungamo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Pallisa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Rakai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Rukungiri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Sembabule')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Soroti')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (172, 'Tororo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Avtonomna Respublika Krym (Simferopol'')')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Cherkas''ka (Cherkasy)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Chernihivs''ka (Chernihiv)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Chernivets''ka (Chernivtsi)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Dnipropetrovs''ka (Dnipropetrovs''k)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Donets''ka (Donets''k)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Ivano-Frankivs''ka (Ivano-Frankivs''k)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Kharkivs''ka (Kharkiv)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Khersons''ka (Kherson)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Khmel''nyts''ka (Khmel''nyts''kyy)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Kirovohrads''ka (Kirovohrad)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Kyyiv')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Kyyivs''ka (Kiev)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'L''vivs''ka (L''viv)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Luhans''ka (Luhans''k)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Mykolayivs''ka (Mykolayiv)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Odes''ka (Odesa)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Poltavs''ka (Poltava)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Rivnens''ka (Rivne)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Sevastopol''')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Sums''ka (Sumy)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Ternopil''s''ka (Ternopil'')')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Vinnyts''ka (Vinnytsya)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Volyns''ka (Luts''k)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Zakarpats''ka (Uzhhorod)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Zaporiz''ka (Zaporizhzhya)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (173, 'Zhytomyrs''ka (Zhytomyr)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (174, '''Ajman')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (174, 'Abu Zaby (Abu Dhabi)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (174, 'Al Fujayrah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (174, 'Ash Shariqah (Sharjah)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (174, 'Dubayy (Dubai)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (174, 'Ra''s al Khaymah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (174, 'Umm al Qaywayn')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Barking and Dagenham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Barnet')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Barnsley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Bath and North East Somerset')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Bedfordshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Bexley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Birmingham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Blackburn with Darwen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Blackpool')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Bolton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Bournemouth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Bracknell Forest')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Bradford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Brent')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Brighton and Hove')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Bromley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Buckinghamshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Bury')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Calderdale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Cambridgeshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Camden')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Cheshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'City of Bristol')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'City of Kingston upon Hull')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'City of London')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Cornwall')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Coventry')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Croydon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Cumbria')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Darlington')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Derby')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Derbyshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Devon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Doncaster')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Dorset')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Dudley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Durham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Ealing')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'East Riding of Yorkshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'East Sussex')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Enfield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Essex')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Gateshead')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Gloucestershire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Greenwich')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Hackney')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Halton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Hammersmith and Fulham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Hampshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Haringey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Harrow')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Hartlepool')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Havering')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Herefordshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Hertfordshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Hillingdon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Hounslow')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Isle of Wight')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Islington')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Kensington and Chelsea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Kent')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Kingston upon Thames')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Kirklees')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Knowsley')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Lambeth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Lancashire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Leeds')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Leicester')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Leicestershire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Lewisham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Lincolnshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Liverpool')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Luton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Manchester')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Medway')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Merton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Middlesbrough')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Milton Keynes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Newcastle upon Tyne')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Newham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Norfolk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'North East Lincolnshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'North Lincolnshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'North Somerset')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'North Tyneside')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'North Yorkshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Northamptonshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Northumberland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Nottingham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Nottinghamshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Oldham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Oxfordshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Peterborough')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Plymouth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Poole')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Portsmouth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Reading')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Redbridge')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Redcar and Cleveland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Richmond upon Thames')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Rochdale')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Rotherham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Rutland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Salford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Sandwell')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Sefton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Sheffield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Shropshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Slough')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Solihull')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Somerset')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'South Gloucestershire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'South Tyneside')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Southampton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Southend-on-Sea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Southwark')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'St. Helens')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Staffordshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Stockport')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Stockton-on-Tees')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Stoke-on-Trent')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Suffolk')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Sunderland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Surrey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Sutton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Swindon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Tameside')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Telford and Wrekin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Thurrock')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Torbay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Tower Hamlets')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Trafford')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Wakefield')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Walsall')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Waltham Forest')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Wandsworth')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Warrington')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Warwickshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'West Berkshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'West Sussex')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Westminster')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Wigan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Wiltshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Windsor and Maidenhead')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Wirral')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Wokingham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Wolverhampton')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'Worcestershire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (262, 'York')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'Artigas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'Canelones')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'Cerro Largo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'Colonia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'Durazno')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'Flores')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'Florida')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'Lavalleja')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'Maldonado')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'Montevideo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'Paysandu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'Rio Negro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'Rivera')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'Rocha')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'Salto')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'San Jose')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'Soriano')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'Tacuarembo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (176, 'Treinta y Tres')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Alabama')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Alaska')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Arizona')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Arkansas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'California')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Colorado')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Connecticut')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Delaware')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'District of Columbia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Florida')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Georgia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Hawaii')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Idaho')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Illinois')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Indiana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Iowa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Kansas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Kentucky')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Louisiana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Maine')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Maryland')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Massachusetts')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Michigan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Minnesota')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Mississippi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Missouri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Montana')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Nebraska')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Nevada')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'New Hampshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'New Jersey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'New Mexico')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'New York')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'North Carolina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'North Dakota')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Ohio')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Oklahoma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Oregon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Pennsylvania')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Rhode Island')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'South Carolina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'South Dakota')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Tennessee')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Texas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Utah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Vermont')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Virginia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Washington')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'West Virginia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Wisconsin')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (500, 'Wyoming')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (232, 'Andijon Wiloyati')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (232, 'Bukhoro Wiloyati')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (232, 'Farghona Wiloyati')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (232, 'Jizzakh Wiloyati')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (232, 'Khorazm Wiloyati (Urganch)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (232, 'Namangan Wiloyati')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (232, 'Nawoiy Wiloyati')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (232, 'Qashqadaryo Wiloyati (Qarshi)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (232, 'Qoraqalpoghiston (Nukus)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (232, 'Samarqand Wiloyati')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (232, 'Sirdaryo Wiloyati (Guliston)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (232, 'Surkhondaryo Wiloyati (Termiz)')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (232, 'Toshkent Shahri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (232, 'Toshkent Wiloyati')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (233, 'Malampa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (233, 'Penama')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (233, 'Sanma')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (233, 'Shefa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (233, 'Tafea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (233, 'Torba')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (177, 'Vatican City')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Amazonas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Anzoategui')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Apure')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Aragua')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Barinas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Bolivar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Carabobo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Cojedes')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Delta Amacuro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Dependencias Federales')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Distrito Federal')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Falcon')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Guarico')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Lara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Merida')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Miranda')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Monagas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Nueva Esparta')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Portuguesa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Sucre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Tachira')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Trujillo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Vargas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Yaracuy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (178, 'Zulia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'An Giang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Ba Ria-Vung Tau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Bac Giang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Bac Kan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Bac Lieu')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Bac Ninh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Ben Tre')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Binh Dinh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Binh Duong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Binh Phuoc')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Binh Thuan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Ca Mau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Can Tho')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Cao Bang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Da Nang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Dac Lak')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Dong Nai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Dong Thap')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Gia Lai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Ha Giang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Ha Nam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Ha Noi')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Ha Tay')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Ha Tinh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Hai Duong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Hai Phong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Ho Chi Minh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Hoa Binh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Hung Yen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Khanh Hoa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Kien Giang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Kon Tum')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Lai Chau')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Lam Dong')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Lang Son')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Lao Cai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Long An')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Nam Dinh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Nghe An')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Ninh Binh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Ninh Thuan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Phu Tho')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Phu Yen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Quang Binh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Quang Nam')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Quang Ngai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Quang Ninh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Quang Tri')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Soc Trang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Son La')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Tay Ninh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Thai Binh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Thai Nguyen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Thanh Hoa')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Thua Thien-Hue')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Tien Giang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Tra Vinh')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Tuyen Quang')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Vinh Long')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Vinh Phuc')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (234, 'Yen Bai')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (553, 'Saint Croix')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (553, 'Saint John')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (553, 'Saint Thomas')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Blaenau Gwent')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Bridgend')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Caerphilly')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Cardiff')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Carmarthenshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Ceredigion')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Conwy')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Denbighshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Flintshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Gwynedd')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Isle of Anglesey')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Merthyr Tydfil')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Monmouthshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Neath Port Talbot')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Newport')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Pembrokeshire')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Powys')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Rhondda Cynon Taff')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Swansea')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'The Vale of Glamorgan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Torfaen')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (554, 'Wrexham')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (253, 'Alo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (253, 'Sigave')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (253, 'Wallis')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (555, 'West Bank')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (556, 'Western Sahara')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (180, '''Adan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (180, '''Ataq')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (180, 'Abyan')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (180, 'Al Bayda''')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (180, 'Al Hudaydah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (180, 'Al Jawf')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (180, 'Al Mahrah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (180, 'Al Mahwit')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (180, 'Dhamar')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (180, 'Hadhramawt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (180, 'Hajjah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (180, 'Ibb')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (180, 'Lahij')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (180, 'Ma''rib')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (180, 'Sa''dah')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (180, 'San''a''')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (180, 'Ta''izz')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (213, 'Kosovo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (213, 'Montenegro')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (213, 'Serbia')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (213, 'Vojvodina')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (182, 'Central')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (182, 'Copperbelt')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (182, 'Eastern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (182, 'Luapula')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (182, 'Lusaka')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (182, 'North-Western')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (182, 'Northern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (182, 'Southern')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (182, 'Western')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (183, 'Bulawayo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (183, 'Harare')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (183, 'ManicalandMashonaland Central')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (183, 'Mashonaland East')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (183, 'Mashonaland West')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (183, 'Masvingo')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (183, 'Matabeleland North')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (183, 'Matabeleland South')", 0, null, __FILE__, __LINE__);
    $ilance->db->query("INSERT INTO `" . DB_PREFIX . "locations_states` VALUES (183, 'Midlands')", 0, null, __FILE__, __LINE__);
    
    print_progress_end();    
}
?>