<?php
/*==========================================================================*\
|| ######################################################################## ||
|| # ILance Marketplace Software
|| # -------------------------------------------------------------------- # ||
|| # Copyright ©2000–2009 ILance Inc. All Rights Reserved.	          # ||
|| # This file may not be redistributed in whole or significant part. 	  # ||
|| # ----------------- ILANCE IS NOT FREE SOFTWARE ---------------------- # ||
|| # http://www.ilance.com | http://www.ilance.com/eula	| info@ilance.com # ||
|| # -------------------------------------------------------------------- # ||
|| ######################################################################## ||
\*==========================================================================*/

// #### load required phrase groups ############################################
$phrase['groups'] = array(
        'buying',
        'selling',
        'rfp',
        'search',
        'feedback',
        'accounting',
        'javascript'
);

// #### load required javascript ###############################################
$jsinclude = array(
        'countries',
        'tabfx',
        'editinline'
);

// #### setup script location ##################################################
define('LOCATION','selling');

// #### require backend ########################################################
require_once('./functions/config.php');

// #### setup default breadcrumb ###############################################
$navcrumb = array("$ilpage[selling]" => $ilcrumbs["$ilpage[selling]"]);

if (!empty($_SESSION['ilancedata']['user']['userid']) AND $_SESSION['ilancedata']['user']['userid'] > 0)
{
	if (!empty($ilance->GPC['crypted']))
	{
		$uncrypted = decrypt_url($ilance->GPC['crypted']);
	}
		
        // #### CREATING OR UPDATING PRODUCT AUCTION ###########################
        if ((isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'new-item' AND isset($ilance->GPC['cid']) AND $ilance->GPC['cid'] > 0 OR isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'product-management' AND (isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0 OR isset($ilance->GPC['rfpid']) AND $ilance->GPC['rfpid'] > 0)))
	{
                if ($ilance->GPC['cmd'] == 'new-item')
                {
                        // #### define top header nav ##########################
                        $topnavlink = array(
                                'main_selling'
                        );
                }
                else
                {
                        // set top nav link to "My CP" hover state
                        // #### define top header nav ##########################
                        $topnavlink = array(
                                'mycp'
                        );
                }

		if ($ilconfig['globalauctionsettings_productauctionsenabled'] == 0 AND !empty($_SESSION['ilancedata']['user']['isadmin']) AND $_SESSION['ilancedata']['user']['isadmin'] == '0')
		{
			print_notice($phrase['_disabled'], $phrase['_were_sorry_this_feature_is_currently_disabled'], $ilpage['main'], $phrase['_main_menu']);
			exit();
		}
                
		$ilance->auction = construct_object('api.auction');
                $ilance->auction_rfp = construct_object('api.auction_rfp');
                $ilance->auction_post = construct_object('api.auction_post');
                $ilance->auction_questions = construct_object('api.auction_questions');
                $ilance->subscription = construct_object('api.subscription');
                $ilance->categories_pulldown = construct_object('api.categories_pulldown');
                
                if ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'createproductauctions') == 'no')
                {
                        $area_title = $phrase['_viewing_access_denied_menu'];
                        $page_title = SITE_NAME . ' - ' . $phrase['_viewing_access_denied_menu'];
                        
                        print_notice($phrase['_access_denied'], $phrase['_your_current_subscription_level_does_not_permit_you_to_use_this_marketplace_resource']." <a href='".$ilpage['subscription']."'><strong>".$phrase['_click_here']."</strong></a>", $ilpage['subscription'], ucwords($phrase['_click_here']), fetch_permission_name('createproductauctions'));
                        exit();
                }
                
                $show['eventtypechange'] = $show['escrowchange'] = $show['titlechange'] = $show['returnpolicychange'] = true;
                
                $categorycache = $ilance->categories->build_array($cattype = 'product', $_SESSION['ilancedata']['user']['slng'], $mode = 0, $propersort = true);
                
                $navcrumb = array();
                if ($ilconfig['globalauctionsettings_seourls'])
                {
                        $navcrumb["sell"] = $phrase['_sell'];
                }
                else
                {
                        $navcrumb["$ilpage[main]?cmd=selling"] = $phrase['_sell'];
                }
                
                $show['bidsplaced'] = false;
                
                // #### SUBMIT NEW PRODUCT AUCTION #############################
                if (isset($ilance->GPC['dosubmit']))
                {
                        $_SESSION['ilancedata']['tmp']['new_project_id'] = '';
                        unset($_SESSION['ilancedata']['tmp']['new_project_id']);
                        
			$area_title = $phrase['_saving_new_product_auction'];
			$page_title = SITE_NAME . ' - ' . $phrase['_saving_new_product_auction'];

                        // #### ONLINE AUCTION #################################                        
			if ($ilance->GPC['filtered_auctiontype'] == 'regular')
			{
				$ilance->GPC['startprice'] = (isset($ilance->GPC['startprice']) AND $ilance->GPC['startprice'] > 0) ? sprintf("%01.2f", $ilance->GPC['startprice']) : '0.01';
                                $ilance->GPC['reserve_price'] = (isset($ilance->GPC['reserve_price'])) ? sprintf("%01.2f", $ilance->GPC['reserve_price']) : 0;
                                $ilance->GPC['reserve'] = ($ilance->GPC['reserve_price'] > 0) ? '1' : '0';
                                $ilance->GPC['buynow_price'] = (isset($ilance->GPC['buynow_price']) AND $ilance->GPC['buynow_price'] > 0) ? sprintf("%01.2f", $ilance->GPC['buynow_price']) : '0';
                                $ilance->GPC['buynow_qty'] = (isset($ilance->GPC['buynow_qty'])) ? intval($ilance->GPC['buynow_qty']) : '1';
                                $ilance->GPC['buynow'] = ($ilance->GPC['buynow_price'] > 0) ? '1' : '0';
			}
                        
                        // #### FIXED PRICE AUCTION ############################
			else if ($ilance->GPC['filtered_auctiontype'] == 'fixed')
			{
				// fixed price only
                                $ilance->GPC['buynow'] = '1';
                                $ilance->GPC['reserve_price'] = '0';
                                $ilance->GPC['reserve'] = '0';
				$ilance->GPC['buynow_price'] = (isset($ilance->GPC['buynow_price_fixed']) AND $ilance->GPC['buynow_price_fixed'] > 0) ? sprintf("%01.2f", $ilance->GPC['buynow_price_fixed']) : '0';
                                $ilance->GPC['buynow_qty'] = (isset($ilance->GPC['buynow_qty_fixed'])) ? intval($ilance->GPC['buynow_qty_fixed']) : '1';
                                $ilance->GPC['startprice'] = sprintf("%01.2f", $ilance->GPC['buynow_price']);
			}
                        
                        // #### OTHER (perhaps addon product) ##################
                        else
                        {
                                $ilance->GPC['buynow'] = '0';
                                $ilance->GPC['reserve_price'] = '0';
                                $ilance->GPC['reserve'] = '0';
				$ilance->GPC['buynow_price'] = '0';
                                $ilance->GPC['buynow_qty'] = '0';
                                $ilance->GPC['startprice'] = '0';
                        }
			
			// #### SHIPPING INFORMATION ###########################
                        $ilance->GPC['ship_handling'] = isset($ilance->GPC['ship_handling']) ? $ilance->GPC['ship_handling'] : 'none';
                        $ilance->GPC['ship_shipperid'] = isset($ilance->GPC['ship_shipperid']) ? intval($ilance->GPC['ship_shipperid']) : 0;
                        $ilance->GPC['ship_country'] = isset($ilance->GPC['ship_country']) ? $ilance->GPC['ship_country'] : 'custom';
                        $ilance->GPC['ship_countries'] = isset($ilance->GPC['ship_countries']) ? $ilance->GPC['ship_countries'] : '';
			$ilance->GPC['ship_costs'] = isset($ilance->GPC['ship_costs']) ? $ilance->GPC['ship_costs'] : 0;
                        if ($ilance->GPC['ship_costs'] <= 0)
                        {
                                $ilance->GPC['ship_costs'] = 0;
                                $ilance->GPC['ship_handling'] = 'none';
                        }
                        
			// #### BIDDING FILTERS ################################
			$ilance->GPC['filter_rating'] = isset($ilance->GPC['filter_rating']) ? intval($ilance->GPC['filter_rating']) : '0';
			$ilance->GPC['filtered_rating'] = isset($ilance->GPC['filtered_rating']) ? $ilance->GPC['filtered_rating'] : '';
			$ilance->GPC['filter_country'] = isset($ilance->GPC['filter_country']) ? intval($ilance->GPC['filter_country']) : '0';
			$ilance->GPC['filtered_country'] = isset($ilance->GPC['filtered_country']) ? $ilance->GPC['filtered_country'] : '';
			$ilance->GPC['filter_state'] = isset($ilance->GPC['filter_state']) ? intval($ilance->GPC['filter_state']) : '0';
			$ilance->GPC['filtered_state'] = isset($ilance->GPC['filtered_state']) ? $ilance->GPC['filtered_state'] : '';
			$ilance->GPC['filter_city'] = isset($ilance->GPC['filter_city']) ? intval($ilance->GPC['filter_city']) : '0';
			$ilance->GPC['filtered_city'] = isset($ilance->GPC['filtered_city']) ? $ilance->GPC['filtered_city'] : '';
			$ilance->GPC['filter_zip'] = isset($ilance->GPC['filter_zip']) ? intval($ilance->GPC['filter_zip']) : '0';
			$ilance->GPC['filtered_zip'] = isset($ilance->GPC['filtered_zip']) ? $ilance->GPC['filtered_zip'] : '';
                        $ilance->GPC['filter_underage'] = isset($ilance->GPC['filter_underage']) ? intval($ilance->GPC['filter_underage']) : '0';
                        $ilance->GPC['filter_escrow'] = isset($ilance->GPC['filter_escrow']) ? intval($ilance->GPC['filter_escrow']) : '0';
                        $ilance->GPC['filter_businessnumber'] = isset($ilance->GPC['filter_businessnumber']) ? $ilance->GPC['filter_businessnumber'] : '0';
                        $ilance->GPC['filter_publicboard'] = isset($ilance->GPC['filter_publicboard']) ? intval($ilance->GPC['filter_publicboard']) : '0';
                        $ilance->GPC['filtered_auctiontype'] = isset($ilance->GPC['filtered_auctiontype']) ? $ilance->GPC['filtered_auctiontype'] : 'regular';
                        
                        // ### OTHER DETAILS ###################################
                        $ilance->GPC['project_type'] = 'forward';
                        $ilance->GPC['project_state'] = 'product';
                        $ilance->GPC['retailprice'] = (isset($ilance->GPC['retailprice'])) ? sprintf("%01.2f", $ilance->GPC['retailprice']) : '0';
                        $ilance->GPC['uniquebidcount'] = (isset($ilance->GPC['uniquebidcount']) AND $ilance->GPC['uniquebidcount'] > 0) ? intval($ilance->GPC['uniquebidcount']) : '0';
                        $ilance->GPC['additional_info'] = isset($ilance->GPC['additional_info']) ? $ilance->GPC['additional_info'] : '';
                        $ilance->GPC['description_videourl'] = isset($ilance->GPC['description_videourl']) ? strip_tags($ilance->GPC['description_videourl']) : '';
                        $ilance->GPC['keywords'] = isset($ilance->GPC['keywords']) ? $ilance->GPC['keywords'] : '';
                        $ilance->GPC['paymethod'] = isset($ilance->GPC['paymethod']) ? $ilance->GPC['paymethod'] : '';
                        $ilance->GPC['status'] = 'open';
                        $ilance->GPC['bid_details'] = 'open';
                        
                        // #### RETURN POLICIES ################################
                        $ilance->GPC['returnaccepted'] = isset($ilance->GPC['returnaccepted']) ? intval($ilance->GPC['returnaccepted']) : '0';
                        $ilance->GPC['returnwithin'] = isset($ilance->GPC['returnwithin']) ? intval($ilance->GPC['returnwithin']) : '0';
                        $ilance->GPC['returngivenas'] = isset($ilance->GPC['returngivenas']) ? $ilance->GPC['returngivenas'] : 'none';
                        $ilance->GPC['returnshippaidby'] = isset($ilance->GPC['returnshippaidby']) ? $ilance->GPC['returnshippaidby'] : 'none';
                        $ilance->GPC['returnpolicy'] = isset($ilance->GPC['returnpolicy']) ? $ilance->GPC['returnpolicy'] : '';
                        
                        // #### SAVE AS DRAFT ##################################                        
                        $ilance->GPC['draft'] = '0';
                        if (isset($ilance->GPC['saveasdraft']) AND $ilance->GPC['saveasdraft'])
                        {
				$ilance->GPC['draft'] = '1';
                                $ilance->GPC['status'] = 'draft';
                        }
                        
                        // #### CUSTOM INFORMATION #############################
                        $ilance->GPC['custom'] = (!empty($ilance->GPC['custom']) ? $ilance->GPC['custom'] : array());
                        $ilance->GPC['profileanswer'] = (!empty($ilance->GPC['profileanswer']) ? $ilance->GPC['profileanswer'] : array());
			$ilance->GPC['enhancements'] = (!empty($ilance->GPC['enhancements']) ? $ilance->GPC['enhancements'] : array());
                        
                        // #### SCHEDULED AUCTION ONLY #########################
                        $ilance->GPC['year'] = (isset($ilance->GPC['year'])) ? $ilance->GPC['year'] : '';
                        $ilance->GPC['month'] = (isset($ilance->GPC['month'])) ? $ilance->GPC['month'] : '';
                        $ilance->GPC['day'] = (isset($ilance->GPC['day'])) ? $ilance->GPC['day'] : '';
                        $ilance->GPC['hour'] = (isset($ilance->GPC['hour'])) ? $ilance->GPC['hour'] : '';
                        $ilance->GPC['min'] = (isset($ilance->GPC['min'])) ? $ilance->GPC['min'] : '';
                        $ilance->GPC['sec'] = (isset($ilance->GPC['sec'])) ? $ilance->GPC['sec'] : '';
                        
                        $apihookcustom = array();
                        
                        ($apihook = $ilance->api('selling_submit_end')) ? eval($apihook) : false;
                        
                        // #### CREATE AUCTION #################################
			$ilance->auction_rfp->insert_product_auction(
                                $_SESSION['ilancedata']['user']['userid'],
                                $ilance->GPC['project_type'],
                                $ilance->GPC['status'],
                                $ilance->GPC['project_state'],
                                $ilance->GPC['cid'],
                                $ilance->GPC['rfpid'],
                                $ilance->GPC['project_title'],
                                $ilance->GPC['bbcode_holder'],
                                $ilance->GPC['description_videourl'],
                                $ilance->GPC['additional_info'],
                                $ilance->GPC['keywords'],
                                $ilance->GPC['custom'],
                                $ilance->GPC['profileanswer'],
                                $ilance->GPC['filtered_auctiontype'],
                                $ilance->GPC['startprice'],
                                $ilance->GPC['project_details'],
                                $ilance->GPC['bid_details'],
                                $ilance->GPC['filter_rating'],
                                $ilance->GPC['filter_country'],
                                $ilance->GPC['filter_state'],
                                $ilance->GPC['filter_city'],
                                $ilance->GPC['filter_zip'],
                                $ilance->GPC['filtered_rating'],
                                $ilance->GPC['filtered_country'],
                                $ilance->GPC['filtered_state'],
                                $ilance->GPC['filtered_city'],
                                $ilance->GPC['filtered_zip'],
                                $ilance->GPC['ship_costs'],
                                $ilance->GPC['ship_country'],
                                $ilance->GPC['ship_countries'],
                                $ilance->GPC['ship_handling'],
                                $ilance->GPC['ship_shipperid'],
                                $ilance->GPC['buynow'],
                                $ilance->GPC['buynow_price'],
                                $ilance->GPC['buynow_qty'],
                                $ilance->GPC['enhancements'],
                                $ilance->GPC['reserve'],
                                $ilance->GPC['reserve_price'],
                                $ilance->GPC['filter_underage'],
                                $ilance->GPC['filter_escrow'],
                                $ilance->GPC['filter_publicboard'],
                                $ilance->GPC['invitelist'],
                                $ilance->GPC['invitemessage'],
                                $ilance->GPC['year'],
                                $ilance->GPC['month'],
                                $ilance->GPC['day'],
                                $ilance->GPC['hour'],
                                $ilance->GPC['min'],
                                $ilance->GPC['sec'],
                                $ilance->GPC['duration'],
                                $ilance->GPC['duration_unit'],
                                $ilance->GPC['paymethod'],
                                $ilance->GPC['retailprice'],
                                $ilance->GPC['uniquebidcount'],
                                $ilance->GPC['draft'],
                                $ilance->GPC['returnaccepted'],
                                $ilance->GPC['returnwithin'],
                                $ilance->GPC['returngivenas'],
                                $ilance->GPC['returnshippaidby'],
                                $ilance->GPC['returnpolicy'],
                                $skipemailprocess = 0,
                                $apihookcustom
                        );
                        exit();
                }
                
                // #### SAVE EXISTING PRODUCT AUCTION ##########################
                else if (isset($ilance->GPC['dosave']))
                {
                        if (empty($ilance->GPC['rfpid']) OR empty($ilance->GPC['bbcode_holder']) OR empty($ilance->GPC['date_end']) OR !mb_ereg("([0-9]{4})-([0-9]{2})-([0-9]{2}) ([0-9]{2}):([0-9]{2}):([0-9]{2})", $ilance->GPC['date_end']))
                        {
                                $area_title = $phrase['_rfp_details_update_error'];
                                $page_title = SITE_NAME . ' - ' . $phrase['_rfp_details_update_error'];
                                
                                print_notice($phrase['_rfp_was_not_updated'], '<p>' . $phrase['_were_sorry_there_was_a_problem_updating_your_request_for_proposal'] . '</p><ul><li />' . $phrase['_description_can_not_be_empty'] . '<li />' . $phrase['_budget_can_not_be_empty'] . '<li />' . $phrase['_verify_the_end_date_for_your_rfp_is_formatted_correctly'] . '</ul><p>' . $phrase['_please_contact_customer_support'] . '</p>', 'javascript:history.back(1);', $phrase['_retry']);
                                exit();
                        }
                        else
                        {
                                //print_r($ilance->GPC); exit;
                                // handle updating any category questions for this auction (if changed)
                                if (isset($ilance->GPC['custom']) AND is_array($ilance->GPC['custom']))
                                {
                                        $ilance->auction_post->process_custom_questions($ilance->GPC['custom'], $ilance->GPC['rfpid'], 'product');
                                }
                                
                                // handle listing differences and store into revision log
                                $ilance->auction_post->handle_revision_log_changes('product');
                                
                                if (isset($ilance->GPC['old']['bids']) AND $ilance->GPC['old']['bids'] > 0)
                                {
                                        if (!empty($_SESSION['ilancedata']['user']['isadmin']) AND $_SESSION['ilancedata']['user']['isadmin'] AND isset($ilance->GPC['admincp']) AND $ilance->GPC['admincp'])
                                        {
                                                // this is so admin can update all fields of the listing
                                                $show['bidsplaced'] = false;
                                        }
                                        else
                                        {
                                                $show['bidsplaced'] = true;
                                        }                                                
                                }
                                else
                                {
                                        $show['bidsplaced'] = false;
                                }
                                
                                // #### HANDLE AUCTION LISTING ENHANCEMENTS ####################
                                // this will attempt to debit the acocunt of the users account balance if possible
                                $ilance->GPC['featured'] = $ilance->GPC['old']['featured'];
                                $ilance->GPC['highlite'] = $ilance->GPC['old']['highlite'];
                                $ilance->GPC['bold'] = $ilance->GPC['old']['bold'];  
                                $ilance->GPC['enhancements'] = (!empty($ilance->GPC['enhancements']) ? $ilance->GPC['enhancements'] : array());
                                if (is_array($ilance->GPC['enhancements']))
                                {
                                        $enhance = $ilance->auction_rfp->process_listing_enhancements_transaction($ilance->GPC['enhancements'], $_SESSION['ilancedata']['user']['userid'], intval($ilance->GPC['rfpid']), 'update', 'product');
                                        if (is_array($enhance))
                                        {
                                                $ilance->GPC['featured'] = (int)$enhance['featured'];
                                                $ilance->GPC['highlite'] = (int)$enhance['highlite'];
                                                $ilance->GPC['bold'] = (int)$enhance['bold'];
                                        }
                                }
                                if ($ilance->GPC['featured'] AND isset($ilance->GPC['old']['featured_date']) AND $ilance->GPC['old']['featured_date'] == '0000-00-00 00:00:00')
                                {
                                        $ilance->GPC['featured_date'] = DATETIME24H;
                                }
                                else
                                {
                                        $ilance->GPC['featured_date'] = '0000-00-00 00:00:00';
                                }
                                
                                // does owner extend the auction?
                                $sqlextend = '';
                                if (isset($ilance->GPC['extend']) AND $ilance->GPC['extend'] > 0)
                                {
                                        $sqlextend = "date_end = DATE_ADD(date_end, INTERVAL " . intval($ilance->GPC['extend']) . " DAY),";
                                }
                                
                                $sqltitle = '';
                                if (($show['bidsplaced'] == false AND $ilconfig['globalfilters_changeauctiontitle']) OR ($ilconfig['globalfilters_changeauctiontitle'] == false AND $_SESSION['ilancedata']['user']['isadmin']))
                                {
                                        if (isset($ilance->GPC['project_title']) AND !empty($ilance->GPC['project_title']))
                                        {
                                                $ilance->GPC['project_title'] = strip_tags($ilance->GPC['project_title']);
                                                $sqltitle = "project_title = '" . $ilance->db->escape_string($ilance->GPC['project_title']) . "',";
                                        }
                                        else
                                        {
                                                if (isset($ilance->GPC['old']['project_title']) AND !empty($ilance->GPC['old']['project_title']))
                                                {
                                                        $ilance->GPC['project_title'] = $ilance->GPC['old']['project_title'];
                                                }
                                        }
                                }
                                
                                $ilance->GPC['filter_rating'] = isset($ilance->GPC['filter_rating']) ? $ilance->GPC['filter_rating'] : $ilance->GPC['old']['filter_rating'];
                                $ilance->GPC['filter_country'] = isset($ilance->GPC['filter_country']) ? $ilance->GPC['filter_country'] : $ilance->GPC['old']['filter_country'];
                                $ilance->GPC['filter_state'] = isset($ilance->GPC['filter_state']) ? $ilance->GPC['filter_state'] : $ilance->GPC['old']['filter_state'];
                                $ilance->GPC['filter_city'] = isset($ilance->GPC['filter_city']) ? $ilance->GPC['filter_city'] : $ilance->GPC['old']['filter_city'];
                                $ilance->GPC['filter_zip'] = isset($ilance->GPC['filter_zip']) ? $ilance->GPC['filter_zip'] : $ilance->GPC['old']['filter_zip'];
                                $ilance->GPC['filter_underage'] = isset($ilance->GPC['filter_underage']) ? $ilance->GPC['filter_underage'] : $ilance->GPC['old']['filter_underage'];
                                $ilance->GPC['filter_businessnumber'] = isset($ilance->GPC['filter_businessnumber']) ? $ilance->GPC['filter_businessnumber'] : $ilance->GPC['old']['filter_businessnumber'];
                                $ilance->GPC['filter_publicboard'] = isset($ilance->GPC['filter_publicboard']) ? $ilance->GPC['filter_publicboard'] : $ilance->GPC['old']['filter_publicboard'];
                                $ilance->GPC['filter_bidtype'] = isset($ilance->GPC['filter_bidtype']) ? $ilance->GPC['filter_bidtype'] : $ilance->GPC['old']['filter_bidtype'];
                                $ilance->GPC['filter_budget'] = isset($ilance->GPC['filter_budget']) ? $ilance->GPC['filter_budget'] : $ilance->GPC['old']['filter_budget'];
                                $ilance->GPC['filter_escrow'] = isset($ilance->GPC['filter_escrow']) ? $ilance->GPC['filter_escrow'] : $ilance->GPC['old']['filter_escrow'];                                
                                $ilance->GPC['filtered_rating'] = isset($ilance->GPC['filtered_rating']) ? $ilance->GPC['filtered_rating'] : $ilance->GPC['old']['filtered_rating'];
                                $ilance->GPC['filtered_country'] = isset($ilance->GPC['filtered_country']) ? $ilance->GPC['filtered_country'] : $ilance->GPC['old']['filtered_country'];
                                $ilance->GPC['filtered_state'] = isset($ilance->GPC['filtered_state']) ? $ilance->GPC['filtered_state'] : $ilance->GPC['old']['filtered_state'];
                                $ilance->GPC['filtered_city'] = isset($ilance->GPC['filtered_city']) ? $ilance->GPC['filtered_city'] : $ilance->GPC['old']['filtered_city'];
                                $ilance->GPC['filtered_zip'] = isset($ilance->GPC['filtered_zip']) ? $ilance->GPC['filtered_zip'] : $ilance->GPC['old']['filtered_zip'];
                                $ilance->GPC['filtered_bidtype'] = isset($ilance->GPC['filtered_bidtype']) ? $ilance->GPC['filtered_bidtype'] : $ilance->GPC['old']['filtered_bidtype'];
                                $ilance->GPC['filtered_budgetid'] = isset($ilance->GPC['filtered_budgetid']) ? $ilance->GPC['filtered_budgetid'] : $ilance->GPC['old']['filtered_budgetid'];
                                $ilance->GPC['additional_info'] = isset($ilance->GPC['additional_info']) ? $ilance->GPC['additional_info'] : (isset($ilance->GPC['old']['additional_info']) ? $ilance->GPC['old']['additional_info'] : '');
                                $ilance->GPC['keywords'] = isset($ilance->GPC['keywords']) ? strip_tags($ilance->GPC['keywords']) : strip_tags($ilance->GPC['old']['keywords']);
                                $ilance->GPC['paymethod'] = isset($ilance->GPC['paymethod']) ? strip_tags($ilance->GPC['paymethod']) : strip_tags($ilance->GPC['old']['paymethod']);
                                $ilance->GPC['filtered_auctiontype'] = isset($ilance->GPC['filtered_auctiontype']) ? $ilance->GPC['filtered_auctiontype'] : $ilance->GPC['old']['filtered_auctiontype'];
                                $ilance->GPC['project_details'] = isset($ilance->GPC['project_details']) ? $ilance->GPC['project_details'] : $ilance->GPC['old']['project_details'];
                                $ilance->GPC['startprice'] = isset($ilance->GPC['startprice']) ? $ilance->GPC['startprice'] : $ilance->GPC['old']['startprice'];
                                $ilance->GPC['currentprice'] = isset($ilance->GPC['startprice']) ? $ilance->GPC['startprice'] : $ilance->GPC['old']['startprice'];
                                $ilance->GPC['bid_details'] = isset($ilance->GPC['bid_details']) ? $ilance->GPC['bid_details'] : $ilance->GPC['old']['bid_details'];
                                $ilance->GPC['buynow_price'] = isset($ilance->GPC['buynow_price']) ? $ilance->GPC['buynow_price'] : $ilance->GPC['old']['buynow_price'];
                                $ilance->GPC['description_videourl'] = isset($ilance->GPC['description_videourl']) ? strip_tags($ilance->GPC['description_videourl']) : $ilance->GPC['old']['description_videourl'];
                                
                                if (!empty($ilance->GPC['buynow_price_fixed']))
                                {
                                        $ilance->GPC['buynow_price'] = $ilance->GPC['buynow_price_fixed'];
                                }
                                
                                $ilance->GPC['buynow_qty'] = isset($ilance->GPC['buynow_qty']) ? $ilance->GPC['buynow_qty'] : $ilance->GPC['old']['buynow_qty'];
                                if (!empty($ilance->GPC['buynow_qty_fixed']))
                                {
                                        $ilance->GPC['buynow_qty'] = $ilance->GPC['buynow_qty_fixed'];
                                }                                
                                
                                $ilance->GPC['reserve_price'] = isset($ilance->GPC['reserve_price']) ? $ilance->GPC['reserve_price'] : $ilance->GPC['old']['reserve_price'];
                                $ilance->GPC['retailprice'] = isset($ilance->GPC['retailprice']) ? $ilance->GPC['retailprice'] : $ilance->GPC['old']['retailprice'];
                                $ilance->GPC['uniquebidcount'] = isset($ilance->GPC['uniquebidcount']) ? $ilance->GPC['uniquebidcount'] : $ilance->GPC['old']['uniquebidcount'];
                                
                                // #### SHIPPING LOGIC #########################
                                $ilance->GPC['ship_handling'] = isset($ilance->GPC['ship_handling']) ? $ilance->GPC['ship_handling'] : $ilance->GPC['old']['ship_handling'];
                                $ilance->GPC['ship_costs'] = isset($ilance->GPC['ship_costs']) ? $ilance->GPC['ship_costs'] : $ilance->GPC['old']['ship_costs'];
                                $ilance->GPC['ship_country'] = isset($ilance->GPC['ship_country']) ? $ilance->GPC['ship_country'] : $ilance->GPC['old']['ship_country'];
                                $ilance->GPC['ship_countries'] = isset($ilance->GPC['ship_countries']) ? $ilance->GPC['ship_countries'] : $ilance->GPC['old']['ship_countries'];
                                $ilance->GPC['ship_shipperid'] = isset($ilance->GPC['ship_shipperid']) ? $ilance->GPC['ship_shipperid'] : $ilance->GPC['old']['ship_shipperid'];
                                
                                // #### RETURN POLICIES ########################
                                $ilance->GPC['returnaccepted'] = isset($ilance->GPC['returnaccepted']) ? intval($ilance->GPC['returnaccepted']) : $ilance->GPC['old']['returnaccepted'];
                                $ilance->GPC['returnwithin'] = isset($ilance->GPC['returnwithin']) ? intval($ilance->GPC['returnwithin']) : $ilance->GPC['old']['returnwithin'];
                                $ilance->GPC['returngivenas'] = isset($ilance->GPC['returngivenas']) ? $ilance->GPC['returngivenas'] : $ilance->GPC['old']['returngivenas'];
                                $ilance->GPC['returnshippaidby'] = isset($ilance->GPC['returnshippaidby']) ? $ilance->GPC['returnshippaidby'] : $ilance->GPC['old']['returnshippaidby'];
                                $ilance->GPC['returnpolicy'] = isset($ilance->GPC['returnpolicy']) ? $ilance->GPC['returnpolicy'] : $ilance->GPC['old']['returnpolicy'];
                                
                                $query_field_data = '';
                                
                                ($apihook = $ilance->api('update_auction_submit_start')) ? eval($apihook) : false;
                                
                                // update auction
                                $ilance->db->query("
                                        UPDATE " . DB_PREFIX . "projects 
                                        SET $sqlextend
                                        cid = '" . intval($ilance->GPC['cid']) . "',
                                        $sqltitle
                                        description = '" . $ilance->db->escape_string($ilance->GPC['bbcode_holder']) . "',
                                        description_videourl = '" . $ilance->db->escape_string($ilance->GPC['description_videourl']) . "',
                                        keywords = '" . $ilance->db->escape_string($ilance->GPC['keywords']) . "',
                                        additional_info = '" . $ilance->db->escape_string($ilance->GPC['additional_info']) . "',
                                        startprice = '" . $ilance->db->escape_string($ilance->GPC['startprice']) . "',
                                        currentprice = '" . $ilance->db->escape_string($ilance->GPC['currentprice']) . "',
                                        paymethod = '" . $ilance->db->escape_string($ilance->GPC['paymethod']) . "',
                                        bid_details = '" . $ilance->db->escape_string($ilance->GPC['bid_details']) . "',
                                        project_details = '" . $ilance->db->escape_string($ilance->GPC['project_details']) . "',
                                        buynow_price = '" . $ilance->db->escape_string($ilance->GPC['buynow_price']) . "',
                                        buynow_qty = '" . intval($ilance->GPC['buynow_qty']) . "',
                                        reserve_price = '" . $ilance->db->escape_string($ilance->GPC['reserve_price']) . "',
                                        retailprice = '" . $ilance->db->escape_string($ilance->GPC['retailprice']) . "',
                                        uniquebidcount = '" . intval($ilance->GPC['uniquebidcount']) . "',
                                        ship_handling = '" . $ilance->db->escape_string($ilance->GPC['ship_handling']) . "',
                                        ship_costs = '" . $ilance->db->escape_string($ilance->GPC['ship_costs']) . "',
                                        ship_country = '" . $ilance->db->escape_string($ilance->GPC['ship_country']) . "',
                                        ship_countries = '" . $ilance->db->escape_string($ilance->GPC['ship_countries']) . "',
                                        ship_shipperid = '" . intval($ilance->GPC['ship_shipperid']) . "',
                                        returnaccepted = '" . intval($ilance->GPC['returnaccepted']) . "',
                                        returnwithin = '" . intval($ilance->GPC['returnwithin']) . "',
                                        returngivenas = '" . $ilance->db->escape_string($ilance->GPC['returngivenas']) . "',
                                        returnpolicy = '" . $ilance->db->escape_string($ilance->GPC['returnpolicy']) . "',
                                        filter_rating = '" . intval($ilance->GPC['filter_rating']) . "',
                                        filter_country = '" . intval($ilance->GPC['filter_country']) . "',
                                        filter_state = '" . intval($ilance->GPC['filter_state']) . "',
                                        filter_city = '" . intval($ilance->GPC['filter_city']) . "',
                                        filter_zip = '" . intval($ilance->GPC['filter_zip']) . "',
                                        filter_underage = '" . intval($ilance->GPC['filter_underage']) . "',
                                        filter_businessnumber = '" . intval($ilance->GPC['filter_businessnumber']) . "',
                                        filter_publicboard = '" . intval($ilance->GPC['filter_publicboard']) . "',
                                        filter_bidtype = '" . intval($ilance->GPC['filter_bidtype']) . "',
                                        filter_budget = '" . intval($ilance->GPC['filter_budget']) . "',
                                        filter_escrow = '" . intval($ilance->GPC['filter_escrow']) . "',
                                        filtered_rating = '" . $ilance->db->escape_string($ilance->GPC['filtered_rating']) . "',
                                        filtered_country = '" . $ilance->db->escape_string($ilance->GPC['filtered_country']) . "',
                                        filtered_state = '" . ucfirst($ilance->db->escape_string($ilance->GPC['filtered_state'])) . "',
                                        filtered_city = '" . ucfirst($ilance->db->escape_string($ilance->GPC['filtered_city'])) . "',
                                        filtered_zip = '" . mb_strtoupper($ilance->db->escape_string($ilance->GPC['filtered_zip'])) . "',
                                        filtered_bidtype = '" . mb_strtoupper($ilance->db->escape_string($ilance->GPC['filtered_bidtype'])) . "',
                                        filtered_budgetid = '" . intval($ilance->GPC['filtered_budgetid']) . "',
                                        filtered_auctiontype = '" . $ilance->db->escape_string($ilance->GPC['filtered_auctiontype']) . "',
                                        featured = '" . intval($ilance->GPC['featured']) . "',
                                        featured_date = '" . $ilance->db->escape_string($ilance->GPC['featured_date']) . "',
                                        highlite = '" . intval($ilance->GPC['highlite']) . "',
                                        bold = '" . intval($ilance->GPC['bold']) . "',
                                        returnaccepted = '" . intval($ilance->GPC['returnaccepted']) . "',
                                        returnwithin = '" . intval($ilance->GPC['returnwithin']) . "',
                                        returngivenas = '" . $ilance->db->escape_string($ilance->GPC['returngivenas']) . "',
                                        returnshippaidby = '" . $ilance->db->escape_string($ilance->GPC['returnshippaidby']) . "',
                                        returnpolicy = '" . $ilance->db->escape_string($ilance->GPC['returnpolicy']) . "',
                                        $query_field_data
                                        updateid = updateid + 1
                                        WHERE project_id = '" . intval($ilance->GPC['rfpid']) . "'
                                                AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                        LIMIT 1
                                ");
				
                                ($apihook = $ilance->api('update_auction_submit')) ? eval($apihook) : false;
                                
                                $area_title = $phrase['_rfp_detailed_information_updated'];
                                $page_title = SITE_NAME . ' - ' . $phrase['_rfp_detailed_information_updated'];
                                   
                                print_notice($phrase['_rfp_successfully_updated'], $phrase['_you_have_successfully_updated_your_request_for_proposal'] . " " . $phrase['_if_you_have_entered_a_new_ending_date_for_your_rfp_this_change_would_take_effect_immediately'] . "<br /><br />" . $phrase['_please_contact_customer_support'] . "<br /><br />", $ilpage['merch'] . '?id=' . intval($ilance->GPC['rfpid']), $phrase['_return_to_the_previous_menu']);
                                exit();                        
                        }
                }
                else
                {
                        if ($ilance->GPC['cmd'] == 'new-item')
                        {
                                $area_title = $phrase['_sell_new_item'];
                                $page_title = SITE_NAME . ' - ' . $phrase['_sell_new_item'];
                                
                                // main category being posted in
                                $cid = isset($ilance->GPC['cid']) ? intval($ilance->GPC['cid']) : 0;
                                
                                if ($ilance->categories->can_post($_SESSION['ilancedata']['user']['slng'], $cattype = 'product', $ilance->GPC['cid']) == false)
                                {
                                        print_notice($phrase['_this_is_a_nonposting_category'], $phrase['_please_choose_another_category_to_list_your_auction_under_this_category_is_currently_reserved_for_postable_subcategories_and_does_not_allow_any_auction_postings'], $ilpage['rfp'] . '?cmd=listings', $phrase['_categories']);
                                        exit();
                                }
                                
                                // ### double check to see if this category supports proxy bidding
                                // if so, check to see if bid increments are setup properly..
                                // if not, show error message advising user to contact admin to setup bid increments in this category
                                if ($ilance->categories->proxy_bid_ready($_SESSION['ilancedata']['user']['slng'], $cattype = 'product', $ilance->GPC['cid']) == false)
                                {
                                        print_notice($phrase['_no_bid_increments_found_in_this_category'], $phrase['_we_are_sorry_for_the_trouble_but_it_appears_this_category_is_a_proxy'], $ilpage['rfp'] . '?cmd=listings', $phrase['_categories']);
                                        exit();        
                                }
                                                                    
                                // prevent the top cats in breadcrumb to contain any fields from this form
                                $show['nourlbit'] = true;
                                $ilance->categories->breadcrumb($cid, 'product', $_SESSION['ilancedata']['user']['slng'], $categorycache);
                                $navcrumb[""] = $phrase['_sell_new_item'];
                        
                                if (!empty($_SESSION['ilancedata']['tmp']['new_project_id']))
                                {
                                        $project_id = $_SESSION['ilancedata']['tmp']['new_project_id'];
                                }
                                else
                                {
                                        $project_id = $ilance->auction_rfp->construct_new_auctionid();
                                        $_SESSION['ilancedata']['tmp']['new_project_id'] = $project_id;
                                }
                                
                                // saving as draft?
				$draft = '';
				if (isset($ilance->GPC['saveasdraft']) AND $ilance->GPC['saveasdraft'])
				{
					$draft = 'checked="checked"';
				}
                                
                                $wysiwyg_area = print_wysiwyg_editor($fieldname = 'description', $text = '', $instanceid = 'bbeditor', $ilconfig['globalfilters_enablewysiwyg'], $ilconfig['globalfilters_enablewysiwyg']);
                                $project_questions = $ilance->auction_questions->construct_auction_questions($cid, $project_id, 'input', 'product', $columns = 4);
                                $bidfilters = $ilance->auction_post->print_bid_filters();
                                $profilebidfilters = $ilance->auction_post->print_profile_bid_filters($cid, 'input', 'product');       
                        }
                        
                        // #### UPDATE PRODUCT AUCTION #########################
                        else
                        {
                                $area_title = $phrase['_update_item'];
                                $page_title = SITE_NAME . ' - ' . $phrase['_update_item'];
                                
                                $project_id = intval($ilance->GPC['id']);
                                
                                $sql = $ilance->db->query("
                                        SELECT *
                                        FROM " . DB_PREFIX . "projects
                                        WHERE project_id = '" . intval($ilance->GPC['id']) . "'
                                                AND project_state = 'product'
                                ");
                                if ($ilance->db->num_rows($sql) > 0)
                                {
                                        $ilance->GPC = array_merge($ilance->GPC, $ilance->db->fetch_array($sql, DB_ASSOC));
                                        
                                        // can we update auction?
                                        if ($ilance->GPC['status'] == 'open' OR $ilance->GPC['status'] == 'draft')
                                        {
                                                $show['noupdateauction'] = 0;
                                        }
                                        else
                                        {
                                                $show['noupdateauction'] = 1;
                                        }
                                        
                                        $date_end = $ilance->GPC['date_end'];
                                }
                                else
                                {
                                        print_notice($phrase['_disabled'], $phrase['_were_sorry_this_feature_is_currently_disabled'], $ilpage['main'], $phrase['_main_menu']);
                                        exit();
                                }
                                
                                // #### ADMIN UPDATING LISTING? ################
                                if (!empty($_SESSION['ilancedata']['user']['isadmin']) AND $_SESSION['ilancedata']['user']['isadmin'] AND isset($ilance->GPC['admincp']) AND $ilance->GPC['admincp'])
                                {
                                        // admin updating listing: show additional details
                                        $ilance->admincp = construct_object('api.admincp');
                                        $ilance->feedback = construct_object('api.feedback');
                                        
                                        // inline auction ajax controls
                                        $headinclude .= "
<script type=\"text/javascript\">
<!--
var searchid = 0;
var value = '';
var type = '';
var imgtag = '';
var favoriteicon = '';
var status = '';
function reset_image()
{
        imgtag.src = favoriteicon;
}
function fetch_response()
{
        if (xmldata.handler.readyState == 4 && xmldata.handler.status == 200 && xmldata.handler.responseXML)
        {
                // format response
                response = fetch_tags(xmldata.handler.responseXML, 'status')[0];
                phpstatus = xmldata.fetch_data(response);
                
                searchiconsrc = fetch_js_object('inline_enhancement_' + xmldata.searchid + '_' + xmldata.type + '').src;
                status = searchiconsrc.match(/\/unchecked.gif/gi);
                if (status == '/unchecked.gif')
                {
                       status = 'unchecked';
                }
                else
                {
                       status = 'checked';
                }                                
                if (status == 'unchecked')
                {
                        if (phpstatus == 'on' || phpstatus == 'off')
                        {
                                favoriteiconsrc = fetch_js_object('inline_enhancement_' + xmldata.searchid + '_' + xmldata.type + '').src;
                                imgtag = fetch_js_object('inline_enhancement_' + xmldata.searchid + '_' + xmldata.type + '');
                                
                                favoriteicon2 = favoriteiconsrc.replace(/unchecked.gif/gi, 'working.gif');
                                imgtag.src = favoriteicon2;
                                
                                favoriteicon = favoriteiconsrc.replace(/unchecked.gif/gi, 'checked.gif');
                                var t = window.setTimeout('reset_image()', 700);
                        }
                        else
                        {
                                alert(phpstatus);
                        }
                }
                else if (status == 'checked')
                {
                        if (phpstatus == 'on' || phpstatus == 'off')
                        {
                                favoriteiconsrc = fetch_js_object('inline_enhancement_' + xmldata.searchid + '_' + xmldata.type + '').src;
                                imgtag = fetch_js_object('inline_enhancement_' + xmldata.searchid + '_' + xmldata.type + '');
                                
                                favoriteicon2 = favoriteiconsrc.replace(/checked.gif/gi, 'working.gif');
                                imgtag.src = favoriteicon2;
        
                                favoriteicon = favoriteiconsrc.replace(/checked.gif/gi, 'unchecked.gif');
                                var t = window.setTimeout('reset_image()', 700);
                        }
                        else
                        {
                                alert(phpstatus); 
                        }
                }
                xmldata.handler.abort();
        }
}
function update_enhancement(searchid, type)
{                        
        // set ajax handler
        xmldata = new AJAX_Handler(true);
        
        // url encode the vars
        searchid = urlencode(searchid);
        xmldata.searchid = searchid;
        
        type = urlencode(type);
        xmldata.type = type;
        
        searchiconsrc = fetch_js_object('inline_enhancement_' + searchid + '_' + type + '').src;
        status = searchiconsrc.match(/\/unchecked.gif/gi);
        if (status == '/unchecked.gif')
        {
               value = 'on';
        }
        else
        {
               value = 'off';
        }
        xmldata.onreadystatechange(fetch_response);

        // send data to php
        xmldata.send('ajax.php', 'do=acpenhancements&value=' + value + '&id=' + searchid + '&type=' + type + '');                        
}
//-->
</script>
";                                        
                                        if ($ilance->GPC['buynow_price'] > 0)
                                        {
                                                $show['purchase_now'] = 1;
                                        }
                                        else
                                        {
                                                $show['purchase_now'] = 0;
                                        }
                                        
                                        // purchase now activity information (product auction view)
                                        $result_orders = $ilance->db->query("
                                                SELECT *
                                                FROM " . DB_PREFIX . "buynow_orders
                                                WHERE owner_id = '" . intval($ilance->GPC['user_id']) . "'
                                                        AND project_id = '" . intval($ilance->GPC['project_id']) . "'
                                        ");
                                        if ($ilance->db->num_rows($result_orders) > 0)
                                        {
                                                $order_count = 0;
                                                while ($orderrows = $ilance->db->fetch_array($result_orders))
                                                {
                                                        $orderrows['orderbuyer'] = fetch_user('username', $orderrows['buyer_id']);
                                                        $orderrows['orderbuyer_id'] = $orderrows['buyer_id'];
                                                        $orderrows['orderphone'] = fetch_user('phone', $orderrows['buyer_id']);
                                                        $orderrows['orderemail'] = fetch_user('email', $orderrows['buyer_id']);
                                                        $orderamount = fetch_auction('buynow_price', $orderrows['project_id']);
                                                        $orderrows['orderamount'] = $ilance->currency->format($orderamount);
                                                        $orderrows['escrowamount'] = '<strong>'.$ilance->currency->format($orderrows['amount']).'</strong>';
                                                        $orderrows['orderdate'] = print_date($orderrows['orderdate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 1, 0);
                                                        $orderrows['orderqty'] = $orderrows['qty'];
                                                        $orderrows['orderinvoiceid'] = $orderrows['invoiceid'];
                                                        $orderrows['orderid'] = $orderrows['orderid'];
                                                        $orderrows['escrowfee'] = $ilance->currency->format($orderrows['escrowfee']);
                                                        $orderrows['fvf'] = $ilance->currency->format($orderrows['fvf']);
                                                        
                                                        // does seller need to give feedback to buyer for this buy now escrow?
                                                        $leftfeedback = 0;
                                                        if ($ilance->feedback->has_left_feedback($for_user_id = $orderrows['orderbuyer_id'], $from_user_id = $orderrows['owner_id'], $project_id = $orderrows['project_id'], $type = 'buyer'))
                                                        {
                                                                // seller already rated buyer!
                                                                $leftfeedback = 1;
                                                                $orderrows['feedback2'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/checkmark.gif" border="0" alt="' . $phrase['_feedback_submitted__thank_you'] . '" />';
                                                        }
                                                        else
                                                        {
                                                                $crypted = array(
                                                                        'cmd' => '_leave-feedback',
                                                                        'type' => 'buyer',
                                                                        'project_id' => $orderrows['project_id'],
                                                                        'for_user_id' => $orderrows['orderbuyer_id'],
                                                                        'from_user_id' => $orderrows['owner_id']
                                                                );
                                                                
                                                                $orderrows['feedback2'] = '<span class="gray">' . $phrase['_next'] . ':</span> <span class="blue"><a href="' . $ilpage['feedback'] . '?crypted=' . encrypt_url($crypted) . '"><strong>' . $phrase['_submit_feedback_for'] . ' ' . fetch_user('username', $orderrows['buyer_id']) . '</strong></a></span>';
                                                        }
                                                        
                                                        // escrow order status
                                                        if ($orderrows['status'] == 'paid')
                                                        {
                                                                // started - funds forwarded by bidder into escrow for item
                                                                $orderrows['bgcolclass'] = '#FEFFE5';
                                                                $orderrows['orderstatus'] = $phrase['_funds_secured'];
        
                                                                // secured - show release funds back to the customer or confirm delivery
                                                                $crypted = array(
                                                                        'cmd' => 'management',
                                                                        'sub' => 'buynow-escrow',
                                                                        'subcmd' => '_confirm-delivery',
                                                                        'id' => $orderrows['orderid']
                                                                );
                                                                
                                                                $orderrows['orderactions'] = '<a href="' . $ilpage['selling'] . '?crypted=' . encrypt_url($crypted) . '" onclick="return confirm_js(phrase[\'_confirm_delivery_the_items_have_already_been_shipped_to_buyers_location_additionally\'])">' . $phrase['_mark_as_shipped'] . '</a><div style="padding-top:4px; padding-bottom:4px"><strong>OR</strong></div>';
        
                                                                $crypted = array(
                                                                        'cmd' => 'management',
                                                                        'sub' => 'buynow-escrow',
                                                                        'subcmd' => '_cancel-delivery',
                                                                        'id' => $orderrows['orderid']
                                                                );
                                                                
                                                                $orderrows['orderactions'] .= '<a href="' . $ilpage['selling'] . '?crypted=' . encrypt_url($crypted) . '" target="_self" onclick="return confirm_js(phrase[\'_cancel_delivery_return_funds_in_escrow_back_to_this_buyer_continue\'])">' . $phrase['_cancel_order'] . '</a>';
                                                                
                                                                $orderrows['pmb2'] = $ilance->auction->construct_pmb_icon(intval($ilance->GPC['user_id']), $orderrows['orderbuyer_id'], $orderrows['project_id']);
                                                                $orderrows['share2'] = $ilance->auction->construct_mediashare_icon(intval($ilance->GPC['user_id']), $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                                $orderrows['work2'] = $ilance->auction->construct_mediashare_icon(intval($ilance->GPC['user_id']), $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                                
                                                                $show['escrowcolumn']['project_id'] = 1;
                                                        }
                                                        else if ($orderrows['status'] == 'pending_delivery')
                                                        {
                                                                // started - funds forwarded by bidder into escrow for item
                                                                $orderrows['bgcolcolor'] = '#FFFFED';
                                                                $orderrows['orderactions'] = '<strong>' . $phrase['_pending_release'] . '</strong> <a href="javascript:void(0);" onmouseover="Tip(\'' . $phrase['_waiting_for_buyer_to_release_funds_into_my_online_account'] . '\', BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a>';
                                                                $orderrows['pmb2'] = $ilance->auction->construct_pmb_icon(intval($ilance->GPC['user_id']), $orderrows['orderbuyer_id'], $orderrows['project_id']);
                                                                $orderrows['share2'] = $ilance->auction->construct_mediashare_icon(intval($ilance->GPC['user_id']), $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                                $orderrows['work2'] = $ilance->auction->construct_mediashare_icon(intval($ilance->GPC['user_id']), $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                                $show['escrowcolumn']['project_id'] = 1;
                                                        }
                                                        else if ($orderrows['status'] == 'delivered')
                                                        {
                                                                // started - funds forwarded by bidder into escrow for item
                                                                $orderrows['bgcolcolor'] = '#EAFFE5';
                                                                if ($leftfeedback)
                                                                {
                                                                        $orderrows['orderactions'] = '<strong>' . $phrase['_completed'] . '</strong>';
                                                                }
                                                                else
                                                                {
                                                                        $orderrows['bgcolcolor'] = '#FFFFED';
                                                                        $orderrows['orderactions'] = $phrase['_leave_feedback'] . ' <a href="javascript:void(0);" onmouseover="Tip(\'' . $phrase['_leave_feedback_lets_you_rate_the_service_provider_and_provide_feedback'] . '\', BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a>';
                                                                }
                                                                $orderrows['pmb2'] = $ilance->auction->construct_pmb_icon(intval($ilance->GPC['user_id']), $orderrows['orderbuyer_id'], $orderrows['project_id']);
                                                                $orderrows['share2'] = $ilance->auction->construct_mediashare_icon(intval($ilance->GPC['user_id']), $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                                $orderrows['work2'] = $ilance->auction->construct_mediashare_icon(intval($ilance->GPC['user_id']), $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                                $show['escrowcolumn']['project_id'] = 1;
                                                        }
                                                        else if ($orderrows['status'] == 'cancelled')
                                                        {
                                                                // started - funds forwarded by bidder into escrow for item
                                                                $orderrows['orderactions'] = $phrase['_cancelled'];
                                                                $orderrows['bgcolcolor'] = '#FCF2F2';
                                                                $orderrows['pmb2'] = $ilance->auction->construct_pmb_icon(intval($ilance->GPC['user_id']), $orderrows['orderbuyer_id'], $orderrows['project_id']);
                                                                $orderrows['share2'] = $ilance->auction->construct_mediashare_icon(intval($ilance->GPC['user_id']), $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = false);
                                                                $orderrows['work2'] = $ilance->auction->construct_mediashare_icon(intval($ilance->GPC['user_id']), $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = false);
                                                                $show['escrowcolumn']['project_id'] = 1;
                                                        }
                                                        else if ($orderrows['status'] == 'offline')
                                                        {
                                                                $orderrows['escrowamount'] = '-';
                                                                $orderrows['fees'] = '-';
                                                                $orderrows['bgcolcolor'] = '#FEFFE5';
                                                                
                                                                $crypted = array(
                                                                        'cmd' => 'management',
                                                                        'sub' => 'buynow-escrow',
                                                                        'subcmd' => '_confirm-offline-delivery',
                                                                        'id' => $orderrows['orderid']
                                                                );
                                                                
                                                                $orderrows['orderactions'] = '<a href="' . $ilpage['selling'] . '?crypted=' . encrypt_url($crypted) . '" onclick="return confirm_js(phrase[\'_confirm_delivery_the_items_have_already_been_shipped_to_buyers_location_additionally\'])"><strong>' . $phrase['_mark_as_shipped'] . '</strong></a> <a href="javascript:void(0);" onmouseover="Tip(phrase[\'_confirm_delivery_means_that_it_is_up_to_you_as_the_merchant_to_confirm_the_delivery\'], BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a>';
                                                                
                                                                $orderrows['pmb2'] = $ilance->auction->construct_pmb_icon(intval($ilance->GPC['user_id']), $orderrows['owner_id'], $orderrows['project_id']);
                                                                $orderrows['share2'] = $ilance->auction->construct_mediashare_icon(intval($ilance->GPC['user_id']), $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                                $orderrows['work2'] = $ilance->auction->construct_mediashare_icon(intval($ilance->GPC['user_id']), $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                        }
                                                        else if ($orderrows['status'] == 'offline_delivered')
                                                        {
                                                                $orderrows['escrowamount'] = '-';
                                                                $orderrows['fees'] = '-';
                                                                $orderrows['bgcolcolor'] = '#FFFFED';
                                                                
                                                                if ($leftfeedback == 1)
                                                                {
                                                                        $orderrows['bgcolcolor'] = '#EAFFE5';
                                                                        $orderrows['orderactions'] = '<strong>' . $phrase['_completed'] . '</strong>';
                                                                }
                                                                else
                                                                {
                                                                        $orderrows['orderactions'] = $phrase['_leave_feedback'] . ' <a href="javascript:void(0);" onmouseover="Tip(\'' . $phrase['_leave_feedback_lets_you_rate_the_service_provider_and_provide_feedback'] . '\', BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a>';
                                                                }
                                                                
                                                                $orderrows['pmb2'] = $ilance->auction->construct_pmb_icon(intval($ilance->GPC['user_id']), $orderrows['owner_id'], $orderrows['project_id']);
                                                                $orderrows['share2'] = $ilance->auction->construct_mediashare_icon(intval($ilance->GPC['user_id']), $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                                $orderrows['work2'] = $ilance->auction->construct_mediashare_icon(intval($ilance->GPC['user_id']), $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                        }
                                                        
                                                        if ($orderrows['ship_required'])
                                                        {
                                                                $ship_handling = fetch_auction('ship_handling', $orderrows['project_id']);
                                                                if ($ship_handling == 'sellerpays' OR $ship_handling == 'none')
                                                                {
                                                                        $ship_costs = 0;	
                                                                }
                                                                else
                                                                {
                                                                        $ship_costs = fetch_auction('ship_costs', $orderrows['project_id']);
                                                                }
                                                                
                                                                $orderrows['shippinginfo'] = $ilance->currency->format($ship_costs);
                                                                $orderrows['orderlocation'] = stripslashes($orderrows['ship_location']);
                                                        }
                                                        else
                                                        {
                                                                $ship_costs = 0;
                                                                
                                                                $orderrows['shippinginfo'] = $ilance->currency->format($ship_costs);
                                                                $dquery = $ilance->db->query("
                                                                        SELECT filename, counter, filesize, attachid
                                                                        FROM " . DB_PREFIX . "attachment
                                                                        WHERE project_id = '".intval($orderrows['project_id'])."'
                                                                                AND attachtype = 'digital'
                                                                                AND user_id = '".intval($ilance->GPC['user_id'])."'
                                                                        LIMIT 1
                                                                ");
                                                                if ($ilance->db->num_rows($dquery) > 0)
                                                                {
                                                                        $dfile = $ilance->db->fetch_array($dquery);
                                                                        $digitalfile = '<strong>' . stripslashes($dfile['filename']) . '</strong> (' . print_filesize($dfile['filesize']) . ')';
                                                                }
                                                                
                                                                $orderrows['orderlocation'] = $phrase['_digital_delivery'] . ': ' . $digitalfile;
                                                        }
                                                        
                                                        $orderrows['total'] = $ilance->currency->format(($orderamount * $orderrows['orderqty']) + $ship_costs);
                                                        $orderrows['class'] = ($order_count % 2) ? 'alt2' : 'alt1';
                                                        $GLOBALS['purchase_now_activity'][] = $orderrows;
                                                        $order_count++;
                                                }
                                        }
                                        else
                                        {
                                                $GLOBALS['no_purchase_now_activity'][] = 1;
                                        }
                                        
                                        $category_pulldown = $ilance->categories_pulldown->print_cat_pulldown($ilance->GPC['cid'], $cattype = 'product', $type = 'level', $fieldname = 'cid', 0, $_SESSION['ilancedata']['user']['slng'], $nooptgroups = 1, $prepopulate = 0, $mode = 0, $showallcats = 1, $dojs = 0, $width = '540px', $uid = 0, $forcenocount = 1, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = false, $ilance->categories->cats);
                                        if ($ilance->GPC['visible'])
                                        {
                                                if ($ilance->GPC['status'] == 'draft')
                                                {
                                                        $auctionvisible = '<label for="visible1"><input type="radio" name="visible" value="1" disabled="disabled" id="visible1" /> ' . $phrase['_yes'] . '</label> <label for="visible0"><input type="radio" name="visible" value="0" checked="checked" id="visible0" /> ' . $phrase['_no'] . '</label>';
                                                }
                                                else
                                                {
                                                        $auctionvisible = '<label for="visible1"><input type="radio" name="visible" value="1" checked="checked" id="visible1" /> ' . $phrase['_yes'] . '</label> <label for="visible0"><input type="radio" name="visible" value="0" id="visible0" /> ' . $phrase['_no'] . '</label>';
                                                }
                                        }
                                        else
                                        {
                                                $auctionvisible = '<label for="visible1"><input type="radio" name="visible" value="1" id="visible1" /> ' . $phrase['_yes'] . '</label> <label for="visible0"><input type="radio" name="visible" value="0" checked="checked" id="visible0" /> ' . $phrase['_no'] . '</label>';
                                        }
                                        
                                        $project_state_pulldown = $ilance->admincp->auction_state_pulldown($ilance->GPC['project_id']);
                                        $project_details_pulldown = $ilance->admincp->auction_details_pulldown($ilance->GPC['project_details'], 0, 'product');
                                        $status_pulldown = $ilance->admincp->auction_status_pulldown($ilance->GPC['status'], false, 'product');
                                        $enhancement_list = $ilance->admincp->fetch_auction_enhancements_list($ilance->GPC['project_id']);
                                        $date_added = $ilance->GPC['date_added'];
                                        $date_starts = $ilance->GPC['date_starts'];
                                }
                                
                                // main category being posted in
                                $cid = isset($ilance->GPC['cid']) ? intval($ilance->GPC['cid']) : 0;
                                
                                $show['nourlbit'] = true;
                                $ilance->categories->breadcrumb($cid, 'product', $_SESSION['ilancedata']['user']['slng'], $categorycache);
                                $navcrumb[""] = $phrase['_update_item'];
                                
                                // saving as draft?
                                $draft = '';
                                if ($ilance->GPC['status'] == 'draft')
                                {
                                        $draft = 'checked="checked"';
                                }
                                
				$hiddenfields = print_hidden_fields($string = false, $excluded = array('invoiceid','escrow_id','bids','budgetgroup','transfer_to_userid','transfer_from_userid','cmd','project_id','project_type','rfpid','cid','state','updateid','fvf','insertionfee','currentprice','project_state','transfertype','close_date','status','views','visible','user_id','date_added','id','isfvfpaid','isifpaid','ifinvoiceid','fvfinvoiceid'), $questionmarkfirst = false, $prepend_text = 'old[', $append_text = ']');
                                
                                // #### init wysiwyg editor ####################
                                $wysiwyg_area = print_wysiwyg_editor('description', htmlspecialchars_uni($ilance->GPC['description']), 'bbeditor', $ilconfig['globalfilters_enablewysiwyg'], $ilconfig['globalfilters_enablewysiwyg']);
                                
                                // #### custom listing questions ###############
                                $project_questions = $ilance->auction_questions->construct_auction_questions($cid, $project_id, 'update', 'product', 4);
                                
                                // #### custom bid filters #####################
                                $bidfilters = $ilance->auction_post->print_bid_filters();
                                
                                // #### custom profile bid filters #############
                                $profilebidfilters = $ilance->auction_post->print_profile_bid_filters($cid, 'input', 'product');
                                
                                $date_end = $ilance->GPC['date_end'];
                                $extendauction = $ilance->auction_post->print_extend_auction('extend');
                                
                                // rebuild selected auction enhancements
                                $show['disableselectedenhancements'] = true;
                                if ($ilance->GPC['featured'])
                                {
                                        $ilance->GPC['enhancements']['featured'] = 1;
                                }
                                if ($ilance->GPC['highlite'])
                                {
                                        $ilance->GPC['enhancements']['highlite'] = 1;
                                }
                                if ($ilance->GPC['bold'])
                                {
                                        $ilance->GPC['enhancements']['bold'] = 1;
                                }
                                 if ($ilance->GPC['autorelist'])
                                {
                                        $ilance->GPC['enhancements']['autorelist'] = 1;
                                }
                                
                                // repopulate the invitation user list
                                $invitesql = $ilance->db->query("
                                        SELECT invite_message, email, name
                                        FROM " . DB_PREFIX . "project_invitations
                                        WHERE project_id = '" . intval($project_id) . "'
                                                AND email != ''
                                                AND name != ''
                                ");
                                if ($ilance->db->num_rows($invitesql) > 0)
                                {
                                        while ($inviteres = $ilance->db->fetch_array($invitesql, DB_ASSOC))
                                        {
                                                $ilance->GPC['invitelist']['email'][] = $inviteres['email'];
                                                $ilance->GPC['invitelist']['name'][] = $inviteres['name'];
                                                $ilance->GPC['invitemessage'] = $inviteres['invite_message'];
                                        }
                                }
                                
                                if ($ilance->GPC['bids'] > 0)
                                {
                                        if (!empty($_SESSION['ilancedata']['user']['isadmin']) AND $_SESSION['ilancedata']['user']['isadmin'] AND isset($ilance->GPC['admincp']) AND $ilance->GPC['admincp'])
                                        {
                                                // this is so admin can update all fields of the listing
                                                $show['bidsplaced'] = false;
                                        }
                                        else
                                        {
                                                $show['bidsplaced'] = true;
                                                $show['eventtypechange'] = $show['escrowchange'] = $show['titlechange'] = $show['returnpolicychange'] = false;
                                        }                                                
                                }
                        }
                }
                
                // auction listing defaults
                $status = 'open';
                $project_type = 'forward';
                
		// can user attach media?
                $attachment_style = '';
		if ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'attachments') == 'no')
		{
			$attachment_style = 'disabled="disabled"';
		}
                
		// #### slideshow upload button ################################
		$hiddeninput = array(
                        'attachtype' => 'slideshow',
                        'project_id' => $project_id,
                        'user_id' => $_SESSION['ilancedata']['user']['userid'],
                        'category_id' => $cid,
                        'filehash' => md5(time()),
                        'max_filesize' => $ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], $accessname = 'uploadlimit'),
                        'attachmentlist' => 'slideshow_attachmentlist'
                );
                
		$uploadbutton = '<input name="attachment" onclick=Attach("' . $ilpage['upload'] . '?crypted=' . encrypt_url($hiddeninput) . '") type="button" value="' . $phrase['_upload'] . '" class="buttons" ' . $attachment_style . ' />';
                unset($hiddeninput);
                
                // #### item photo upload button ###############################
		$hiddeninput = array(
                        'attachtype' => 'itemphoto',
                        'project_id' => $project_id,
                        'user_id' => $_SESSION['ilancedata']['user']['userid'],
                        'category_id' => $cid,
                        'filehash' => md5(time()),
                        'max_filesize' => $ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], $accessname = 'uploadlimit'),
                        'attachmentlist' => 'itemphoto_attachmentlist'
                );
                
		$uploadproductbutton = '<input name="attachment" onclick=Attach("' . $ilpage['upload'] . '?crypted=' . encrypt_url($hiddeninput) . '") type="button" value="' . $phrase['_upload'] . '" class="buttons" ' . $attachment_style . ' />';
                unset($hiddeninput);
                
                // #### fetch slideshow attachments uploaded ###################
                $slideshow_attachmentlist = fetch_inline_attachment_filelist($_SESSION['ilancedata']['user']['userid'], $project_id, 'slideshow', $printimage = true);
                
                // #### fetch product photo attachments uploaded ###############
                $itemphoto_attachmentlist = fetch_inline_attachment_filelist($_SESSION['ilancedata']['user']['userid'], $project_id, 'itemphoto', $printimage = true);
                
                // #### slideshow picture cost #################################
                $slideshowcost = $phrase['_free'];
                if ($ilconfig['productupsell_slideshowcost'] > 0)
                {
                        $slideshowcost = $ilance->currency->format($ilconfig['productupsell_slideshowcost']);
                }
                
                // #### attachment limitations #################################
		$productimageinfo = $phrase['_max_files'] . ': <strong>1</strong>, ' . $phrase['_max_width'] . ': <strong>' . $ilconfig['attachmentlimit_productphotomaxwidth'] . 'px</strong>, ' . $phrase['_max_height'] . ': <strong>' . $ilconfig['attachmentlimit_productphotomaxheight'] . 'px</strong>, '.$phrase['_max_filesize'] . ': <strong>' . print_filesize($ilconfig['attachmentlimit_productphotomaxsize']) . '</strong><br /> ' . $phrase['_file_extensions'] . ': <strong>' . $ilconfig['attachmentlimit_productphotoextensions'] . '</strong>';
		$slideshowinfo = $phrase['_max_files'] . ': <strong>5</strong>, ' . $phrase['_max_width'] . ': <strong>' . $ilconfig['attachmentlimit_slideshowmaxwidth'] . 'px</strong>, ' . $phrase['_max_height'] . ': <strong>' . $ilconfig['attachmentlimit_slideshowmaxheight'] . 'px</strong>, ' . $phrase['_max_filesize'] . ': <strong>' . print_filesize($ilconfig['attachmentlimit_slideshowmaxsize']) . '</strong><br /> ' . $phrase['_file_extensions'] . ': <strong>' . $ilconfig['attachmentlimit_slideshowextensions'] . '</strong>';
                
                // #### some javascript above the template (not between <head>..)
                $js_start = $ilance->auction_post->print_js('product');
                
                // #### build an if condition to either show advanced profile filters or hide them if none available
                $filter_quantity = $ilance->auction_post->get_filters_quantity($cid);
                
                // #### auction title ##########################################
                $title = $ilance->auction_post->print_title_input($fieldname = 'project_title', $disabled = $show['bidsplaced']);
                
                // #### video description ######################################
                $description_videourl = $ilance->auction_post->print_video_description_input($fieldname = 'description_videourl', $disabled = $show['bidsplaced']);
                
                // #### keywords input #########################################
                $keywordinput = $ilance->auction_post->print_keywords_input($fieldname = 'keywords', $disabled = $show['bidsplaced']);
                
                // #### auction event access ###################################
                $auctioneventtype = $ilance->auction_post->print_event_type_filter('product', $fieldname = 'project_details', $disabled = $show['bidsplaced']);
                
                // #### duration code logic ####################################
                $duration = $ilance->auction_post->duration($fieldname = 'duration', $disabled = $show['bidsplaced']);

		// #### realtime scheduled event date/time #####################
		$durationbits = $ilance->auction_post->print_duration_logic($fieldname = 'duration_unit', $disabled = $show['bidsplaced']);
                
                // #### invitation options and controls ########################
                $inviteoptions = $ilance->auction_post->print_invitation_controls();
                
                // #### bidding privacy ########################################
		$biddingprivacy = $ilance->auction_post->print_bid_privacy($fieldname = 'bid_details', $disabled = $show['bidsplaced']);
                
                // #### selling format #########################################
                $sellingformat = $ilance->auction_post->print_selling_format_logic($disabled = $show['bidsplaced']);
                
                // #### escrow filter (if enabled, javascript will hide the payment methods input box on preview also)
                $escrowfilter = $ilance->auction_post->print_escrow_filter($cid, 'product', 'productmerchant', $disabled = $show['bidsplaced']);
                
                // #### merchants accepted payment methods (if escrow will not be used)
                $paymentmethods = $ilance->auction_post->print_payment_method('paymethod', 'paymethod');
                
		// #### shipping ###############################################
		$shipping = $ilance->auction_post->print_shipping_logic($disabled = $show['bidsplaced']);
                
                // #### item return policy #####################################
                $returnpolicy = $ilance->auction_post->print_return_policy($disabled = $show['bidsplaced']);
		
		// #### public message boards? #################################
                $publicboard = $ilance->auction_post->print_public_board($fieldname = 'filter_publicboard');
		
		// #### handle listing enhancement upsell fees #################
		$enhancements = $ilance->auction_post->print_listing_enhancements('product');
		
		// #### custom final value fees logic ##########################
		$finalvaluefees = $ilance->auction_post->print_final_value_fees($cid, 'product');
		$insertionfees = $ilance->auction_post->print_insertion_fees($cid, 'product');
		
                $project_details = isset($ilance->GPC['project_details']) ? $ilance->GPC['project_details'] : 'public';
                
                // #### charities for donations ################################
                $charitiespulldown = print_charities_pulldown(0);
		
		// #### construct countries / states pulldown ##################
		$jscountry = isset($ilance->GPC['filtered_country']) ? $ilance->GPC['filtered_country'] : $ilconfig['registrationdisplay_defaultcountry'];
		$jsstate = isset($ilance->GPC['filtered_state']) ? $ilance->GPC['filtered_state'] : $ilconfig['registrationdisplay_defaultstate'];
                $jscity = isset($ilance->GPC['filtered_city']) ? $ilance->GPC['filtered_city'] : $ilconfig['registrationdisplay_defaultcity'];
                
                $countryid = fetch_country_id($jscountry, $_SESSION['ilancedata']['user']['slng']);
                $country_js_pulldown = construct_country_pulldown($countryid, $jscountry, 'filtered_country');
                $state_js_pulldown = '<div id="stateid" style="height:20px">' . construct_state_pulldown($countryid, $jsstate, 'filtered_state') . '</div>';
                
                // #### fee totals #############################################
                $feetotal = '0.00';
                
		$ilance->template->load_file('main', 'postrfpproduct2_details.html');
		$ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                $ilance->template->parse_loop('main', 'purchase_now_activity');
		$ilance->template->parse_if_blocks('main');
                
                $pprint_array = array('feetotal','slideshowcost','charitiespulldown','description_videourl','returnpolicy','date_added','date_starts','enhancement_list','status_pulldown','project_details_pulldown','project_state_pulldown','auctionvisible','category_pulldown','tab','hiddenfields','extendauction','date_end','slideshow_attachmentlist','itemphoto_attachmentlist','uploadproductbutton','inviteoptions','keywordinput','title','finalvaluefees','profilebidfilters','js_start','js_end','wysiwyg_area','insertionfees','additionalcategory','keywords','listingfees','invoicebit','slideshowinfo','productimageinfo','shipping','sellingformat','digitalfile','enhancements','saveasdraft','maincategory','pid','paymentmethods','attachmentlist','bidfilters','publicboard','biddingprivacy','durationbits','auctioneventtype','escrowfilter','budgetfilter','bidtypefilter','attachmentlist','additional_info','description','preview_pane','cid','js','state_js_pulldown','country_js_pulldown','bidamounttype_pulldown','moderationalert','project_questions','uploadbutton','project_title','budget_pulldown','duration','year','month','day','hour','min','sec','invitation','invitationid','country_pulldown','category','subcategory','filehash','max_filesize','attachment_style','user_id','state','catid','subcatid','currency','project_id','input_style','remote_addr','rid','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
                
                ($apihook = $ilance->api('new_product_auction_end')) ? eval($apihook) : false;
                
                $ilance->template->pprint('main', $pprint_array);
                exit();
	}
	
        // #### BID MANAGEMENT: ACCEPT AWARD, DECLINE AWARD, ETC ###############
        else if ((isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'bid-management' OR isset($uncrypted['cmd']) AND $uncrypted['cmd'] == 'bid-management'))
        {
                // #### define top header nav ##################################
                $topnavlink = array(
                        'mycp'
                );
                
                if (isset($uncrypted['sub']) AND $uncrypted['sub'] == '_accept-award' AND isset($uncrypted['id']) AND $uncrypted['id'] > 0)
                {
                        $area_title = $phrase['_bid_service_auction_acceptance_menu'];
                        $page_title = SITE_NAME . ' - ' . $phrase['_bid_service_auction_acceptance_menu'];
                        
                        // awarding bid_id
                        $bidid = intval($uncrypted['id']);
                        
                        // construct auction system
                        // the service auction award accept feature will engage the final value fee
                        // for the total amount originally awarded and accepted by both parties
                        $ilance->auction = construct_object('api.auction');
                        $ilance->auction_award = construct_object('api.auction_award');
                        
                        if ($ilance->auction_award->service_auction_award_accept($bidid, $_SESSION['ilancedata']['user']['userid']))
                        {
                                $show['escrow'] = 0;
                                
                                $projectid = $ilance->db->fetch_field(DB_PREFIX . "project_bids", "bid_id = '" . $bidid . "'", "project_id");
                                $usingescrow = fetch_auction('filter_escrow', $projectid);
                                if ($usingescrow)
                                {
                                        $show['escrow'] = 1;
                                }
                                
                                $pprint_array = array('remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
                                
                                $ilance->template->load_file('main', 'selling_award_accepted.html');
                                $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                                $ilance->template->parse_if_blocks('main');
                                $ilance->template->pprint('main', $pprint_array);
                                exit();
                        }
                        else
                        {
                                print_notice($phrase['_invalid_award_request_and_or_auction_state'], $phrase['_were_sorry_your_request_cannot_be_completed_due_to_invalid_credentials_for_the_action_you_are_attempting_to_make']."<br /><br />".$phrase['_please_contact_customer_support'], $ilpage['buying'], $phrase['_buying_activity']);
                                exit();
                        }
                }
                else if (isset($uncrypted['sub']) AND $uncrypted['sub'] == '_decline-award' AND isset($uncrypted['id']) AND $uncrypted['id'] > 0)
                {
                        $area_title = $phrase['_bid_service_auction_decline_menu'];
                        $page_title = SITE_NAME . ' - ' . $phrase['_bid_service_auction_decline_menu'];
                        $bidid = intval($uncrypted['id']);
                        
                        // construct auction system
                        $ilance->auction = construct_object('api.auction');
                        $ilance->auction_award = construct_object('api.auction_award');
                        if ($ilance->auction_award->service_auction_award_decline($bidid, $_SESSION['ilancedata']['user']['userid']))
                        {
                                $show['escrow'] = 0;
                                
                                $projectid = $ilance->db->fetch_field(DB_PREFIX . "project_bids", "bid_id = '".intval($bidid)."'", "project_id");
                                $usingescrow = fetch_auction('filter_escrow', intval($projectid));
                                if ($usingescrow)
                                {
                                        $show['escrow'] = 1;
                                }
                                
                                $ilance->template->load_file('main', 'selling_award_declined.html');
                                $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                                $ilance->template->parse_if_blocks('main');
                                $ilance->template->pprint('main', array('remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                                exit();
                        }
                        else
                        {
                                print_notice($phrase['_invalid_award_request_and_or_auction_state'], $phrase['_were_sorry_your_request_cannot_be_completed_due_to_invalid_credentials_for_the_action_you_are_attempting_to_make']."<br /><br />".$phrase['_please_contact_customer_support'], $ilpage['buying'], $phrase['_buying_activity']);
                                exit();
                        }
                }
        }
        
        // #### SELLING PROFILE MENU: SKILLS ###################################
        else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'skills')
        {
                // #### define top header nav ##################################
                $topnavlink = array(
                        'mycp',
                        'skills'
                );
                
                $area_title = $phrase['_skills'];
                $page_title = SITE_NAME . ' - ' . $phrase['_skills'];
                
                $navcrumb = array();
                $navcrumb["$ilpage[main]?cmd=cp"] = $phrase['_my_cp'];
                $navcrumb[""] = $phrase['_skills'];
                
                $ilance->subscription = construct_object('api.subscription');
                $ilance->categories_skills = construct_object('api.categories_skills');

                // selling profile subscription checkup
                if ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'createserviceprofile') == 'yes')
                {
                        if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == 'update')
                        {
                                $selectedsids = !empty($ilance->GPC['sid']) ? count($ilance->GPC['sid']) : 0;
                                
                                if (!($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'maxskillscat') >= $selectedsids))
                                {
                                        print_notice($phrase['_access_denied'], "You selected more categories than your current subscription permits.  Click back on your browser to change the amount or upgrade: <a href='" . $ilpage['subscription'] . "'><strong>" . $phrase['_click_here'] . "</strong></a>", $ilpage['subscription'], ucwords($phrase['_click_here']), fetch_permission_name('maxskillscat'));
                                        exit();
                                }
                                
                                if (!empty($ilance->GPC['sid']) AND is_array($ilance->GPC['sid']))
                                {
                                        // delete all current skills for this user
                                        $ilance->db->query("
                                                DELETE FROM " . DB_PREFIX . "skills_answers
                                                WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                        ");
                                        
                                        // insert skills based on user selection
                                        foreach ($ilance->GPC['sid'] as $cid => $value)
                                        {
                                                $ilance->db->query("
                                                        INSERT INTO " . DB_PREFIX . "skills_answers
                                                        (aid, cid, user_id)
                                                        VALUES
                                                        (NULL,
                                                        '" . intval($cid) . "',
                                                        '" . $_SESSION['ilancedata']['user']['userid'] . "')
                                                ");
                                        }
                                        
                                        print_notice($phrase['_updated'], $phrase['_you_have_successfully_updated_your_skill_attributes'], $ilpage['selling'].'?cmd=skills', $phrase['_skills']);
                                        exit();
                                }
                        }
                        
                        // skills category limit (based on maxskillscat subscription permission)
                        $maxskillscat = $ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'maxskillscat');
                        
                        $skills_selection = $ilance->categories_skills->print_skills_columns($_SESSION['ilancedata']['user']['slng'], $showcount = 0, $prepopulate = true);
                        
                        $ilance->template->load_file('main', 'selling_profile_skills.html', 0, 1);
                        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                        $ilance->template->parse_loop('main', 'profile_question_groups');
                        $ilance->template->parse_loop('main', 'default_profile_question_groups');
                        $ilance->template->parse_if_blocks('main');
                        
                        $pprint_array = array('maxskillscat','skills_selection','profilecatlimit','rateperhour','uploadlogo','profilevideourl','displayprofile_cb','displayprofile','category_pulldown','profile_logo','multiple_category_select','question_answer_js','attachment_style','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
                        
                        ($apihook = $ilance->api('selling_profile_skills_start')) ? eval($apihook) : false;
                        
                        $ilance->template->pprint('main', $pprint_array);
                        exit();
                }
                else
                {
                        $area_title = $phrase['_access_denied_to_service_profile_menu'];
                        $page_title = SITE_NAME . ' - ' . $phrase['_access_denied_to_service_profile_menu'];
                        
                        print_notice($phrase['_access_denied'], $phrase['_your_current_subscription_level_does_not_permit_you_to_use_this_marketplace_resource']." <a href='".$ilpage['subscription']."'><strong>".$phrase['_click_here']."</strong></a>", $ilpage['subscription'], ucwords($phrase['_click_here']), fetch_permission_name('createserviceprofile'));
                        exit();
                }
        }
        
        // #### SELLING PROFILE MENU ###########################################
        else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'profile')
        {
                // #### define top header nav ##################################
                $topnavlink = array(
                        'mycp',
                        'profile'
                );
                
                $area_title = $phrase['_service_selling_profile_creation_menu'];
                $page_title = SITE_NAME . ' - ' . $phrase['_service_selling_profile_creation_menu'];
                
                $navcrumb = array();
                $navcrumb["$ilpage[main]?cmd=cp"] = $phrase['_my_cp'];
                $navcrumb[""] = $phrase['_selling_profile'];
                
                $ilance->subscription = construct_object('api.subscription');
                $ilance->categories->build_array($cattype = 'service', $_SESSION['ilancedata']['user']['slng'], $mode = 0, $propersort = true);
                
                $headinclude .= "
<script type=\"text/javascript\">
<!--
function customImage(imagename, imageurl, errors)
{
    document[imagename].src = imageurl;
    if (!haveerrors && errors)
    {
        haveerrors = errors;
        alert(phrase['_please_fix_the_fields_marked_with_a_warning_icon_and_retry_your_action']);
    }
}
//-->
</script>
";
                
                // selling profile subscription checkup
                if ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'createserviceprofile') == 'yes')
                {
                        $ilance->mycp = construct_object('api.mycp');
                        
                        $headinclude .= "
<script type=\"text/javascript\">
<!--
function validatecustomform(f)
{
    haveerrors = 0;
";
                            
                        // profile category
                        $cid = 0;
                        if (isset($ilance->GPC['cid']) AND $ilance->GPC['cid'] > 0)
                        {
                                $cid = intval($ilance->GPC['cid']);
                        }
                        
                        // check for selling profile logo
                        $profile_logo = $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'].'nophoto.gif';
                        
                        $sql_attach = $ilance->db->query("
                                SELECT attachid, filehash
                                FROM " . DB_PREFIX . "attachment
                                WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                        AND visible = '1'
                                        AND attachtype = 'profile'
                                LIMIT 1
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($sql_attach) > 0)
                        {
                                $res_attach = $ilance->db->fetch_array($sql_attach);
                                $profile_logo = $ilpage['attachment'] . '?cmd=profile&amp;id=' . $res_attach['filehash'];
                        }
                        
                        // default profile questions defined by admin (required fields)
                        $sqlprofilegroups2 = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "profile_groups
                                WHERE canremove = '0'
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($sqlprofilegroups2) > 0)
                        {
                                $row_count2 = 0;
                                while ($row2 = $ilance->db->fetch_array($sqlprofilegroups2))
                                {
                                        $sqlquestions2 = $ilance->db->query("
                                                SELECT *
                                                FROM " . DB_PREFIX . "profile_questions
                                                WHERE groupid = '".$row2['groupid']."'
                                                        AND visible = '1'
                                                ORDER BY sort ASC
                                        ", 0, null, __FILE__, __LINE__);
                                        if ($ilance->db->num_rows($sqlquestions2) > 0)
                                        {
                                                $show['defaultprofilequestions'] = true;
                                                
                                                $row_count2 = 0;
                                                while ($rows2 = $ilance->db->fetch_array($sqlquestions2))
                                                {
                                                        $rows2['question_description'] = stripslashes($rows2['description']);
                                                        $rows2['question_answer_error'] = '<img name="question' . $rows2['questionid'] . 'error" src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif" width="21" height="13" border="0" alt="'.$phrase['_this_form_field_is_required'].'" />';
                                                        if ($rows2['required'])
                                                        {
                                                                $headinclude .= "(fetch_js_object('question" . $rows2['questionid'] . "').value.length < 1) ? customImage(\"question".$rows2['questionid']."error\", \"" . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . "icons/fieldempty.gif\", true) : customImage(\"question".$rows2['questionid']."error\", \"" . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . "icons/blankimage.gif\", false); ";
                                                        }
                                                        
                                                        // fetch answer
                                                        $sqlqa = $ilance->db->query("
                                                                SELECT *
                                                                FROM " . DB_PREFIX . "profile_answers
                                                                WHERE questionid = '".$rows2['questionid']."'
                                                                        AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                        AND visible = '1'
                                                        ", 0, null, __FILE__, __LINE__);
                                                        if ($ilance->db->num_rows($sqlqa) > 0)
                                                        {
                                                                $resqa = $ilance->db->fetch_array($sqlqa);
                                                                $rows2['question_answer_input'] = $ilance->mycp->construct_profile_input($rows2['questionid']);
                                                        }
                                                        else
                                                        {
                                                                $rows2['question_answer_input'] = $ilance->mycp->construct_profile_input($rows2['questionid']);
                                                        }
                                                        
                                                        // can question be verified?
                                                        if ($rows2['canverify'])
                                                        {
                                                                // fetch answer to the question
                                                                $sqla = $ilance->db->query("
                                                                        SELECT *
                                                                        FROM " . DB_PREFIX . "profile_answers
                                                                        WHERE questionid = '".$rows2['questionid']."'
                                                                                AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                                AND visible = '1'
                                                                ", 0, null, __FILE__, __LINE__);
                                                                if ($ilance->db->num_rows($sqla) > 0)
                                                                {
                                                                        $resq = $ilance->db->fetch_array($sqla);
                                                                        
                                                                        $rows2['question_answer_input'] = $ilance->mycp->construct_profile_input($rows2['questionid']);
                                                                        if ($resq['isverified'] AND $resq['invoiceid'] > 0)
                                                                        {
                                                                                $date1split = explode(' ', $resq['verifyexpiry']);
                                                                                $date2split = explode('-', $date1split[0]);
                                                                                $expiredays = $ilance->datetime->fetch_days_between(gmdate('m'), gmdate('d'), gmdate('Y'), $date2split[1], $date2split[2], $date2split[0]);
                                                                                
                                                                                $rows2['is_verified'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'verified_icon.gif" alt="" border="0" />';
                                                                                $rows2['action'] = '';
                                                                                $rows2['renew'] = $ilance->language->construct_phrase($phrase['_expires_in_x_days'], $expiredays);
                                                                        }
                                                                        else if ($resq['isverified'] == 0 AND $resq['invoiceid'] > 0)
                                                                        {
                                                                                $rows2['is_verified'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'not_verified.gif" alt="" border="0" />';
                                                                                $rows2['action'] = $phrase['_pending'];
                                                                                $rows2['renew'] = '';
                                                                        }
                                                                        else if ($rows2['canverify'] AND $resq['isverified'] == 0 AND !empty($resq['answer']))
                                                                        {
                                                                                $rows2['is_verified'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'not_verified.gif" alt="" border="0" />';
                                                                                $rows2['action'] = '<input type="submit" name="verifyprofile[' . $rows2['questionid'] . '|' . $rows2['verifycost'] . ']" value="' . $ilance->currency->format($rows2['verifycost']) . '" class="buttons_smaller" />';
                                                                                $rows2['renew'] = '';
                                                                        }
                                                                        else if ($rows2['canverify'] AND $resq['isverified'] == 0 AND empty($resq['answer']))
                                                                        {
                                                                                $rows2['is_verified'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'not_verified.gif" alt="" border="0" />';
                                                                                $rows2['action'] = $ilance->currency->format($rows2['verifycost']);
                                                                                $rows2['renew'] = '';
                                                                        }
                                                                        
                                                                        $rows2['verify1'] = '<fieldset class="fieldset" style="width:150px; padding:9px"><legend>' . $rows2['is_verified'] . '</legend><div align="left" class="gray">' . $rows2['action'] . '</div><div class="gray" align="left">' . $rows2['renew'] . '</div></fieldset>';
                                                                }
                                                                else
                                                                {
                                                                        // no answer exists
                                                                        $rows2['question_answer_input'] = $ilance->mycp->construct_profile_input($rows2['questionid']);
                                                                        $rows2['is_verified'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'not_verified.gif" alt="" border="0" />';
                                                                        $rows2['action'] = '<input type="submit" name="verifyprofile[' . $rows2['questionid'] . '|' . $rows2['verifycost'] . ']" value="' . $ilance->currency->format($rows2['verifycost']) . '" class="buttons_smaller" disabled="disabled" />';
                                                                        $rows2['verify1'] = '<fieldset class="fieldset" style="width:150px; padding:9px"><legend>' . $rows2['is_verified'] . '</legend><div align="left" style="padding:3px">' . $rows2['action'] . '</div></fieldset>';
                                                                }
                                                        }
                                                        else
                                                        {
                                                                // select answer to this question
                                                                $sqla = $ilance->db->query("
                                                                        SELECT *
                                                                        FROM " . DB_PREFIX . "profile_answers
                                                                        WHERE questionid = '" . $rows2['questionid'] . "'
                                                                                AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                                AND visible = '1'
                                                                ", 0, null, __FILE__, __LINE__);
                                                                if ($ilance->db->num_rows($sqla) > 0)
                                                                {
                                                                        $resq = $ilance->db->fetch_array($sqla);
                                                                        $rows2['question_answer_input'] = $ilance->mycp->construct_profile_input($rows2['questionid']);
                                                                        $rows2['action'] = $rows2['is_verified'] = $rows2['verify1'] = '';
                                                                }
                                                                else
                                                                {
                                                                        $rows2['is_verified'] = $rows2['action'] = $rows2['verify1'] = '';
                                                                        $rows2['question_answer_input'] = $ilance->mycp->construct_profile_input($rows2['questionid']);
                                                                }
                                                                
                                                        }
                                                        
                                                        $rows2['class2'] = ($row_count2 % 2) ? 'alt2' : 'alt1';
                                                        $GLOBALS['default_profile_questions' . $row2['groupid']][] = $rows2;
                                                        $row_count2++;
                                                }
                                        }
                                        else
                                        {
                                                $show['defaultprofilequestions'] = false;
                                        }
                                        
                                        $row2['groupname'] = stripslashes($ilance->db->fetch_field(DB_PREFIX . "profile_groups", "groupid = '" . $row2['groupid'] . "'", "name"));
                                        $row2['class'] = ($row_count2 % 2) ? 'alt2' : 'alt1';
                                        $default_profile_question_groups[] = $row2;
                                        $row_count2++;
                                }
                        }
                        else
                        {
                                $no_profile_question_groups2 = 1;
                        }
                        
                        // category pulldown
                        $ilance->categories_pulldown = construct_object('api.categories_pulldown');
                        $cid = isset($ilance->GPC['cid']) ? intval($ilance->GPC['cid']) : 0;
                        $multiple_category_select = $ilance->categories_pulldown->print_cat_pulldown($cid, $cattype = 'service', $type = 'levelmulti', $fieldname = 'subcategories', $showpleaseselectoption = 0, $_SESSION['ilancedata']['user']['slng'], $nooptgroups = 1, $prepopulate = 'sellingprofile', $mode = 0, $showallcats = 0, $dojs = 0, $width = '540px', $uid = 0, $forcenocount = 0, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = false, $ilance->categories->cats);
                        
                        // check attachment permissions for customer (for company/logo upload)
                        $attachment_style = '';
                        if ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'attachments') == 'yes')
                        {
                                $hiddeninput = array(
                                        'attachtype' => 'profile',
                                        'project_id' => 0,
                                        'user_id' => $_SESSION['ilancedata']['user']['userid'],
                                        'category_id' => 0,
                                        'filehash' => md5(time()),
                                        'max_filesize' => $ilconfig['attachmentlimit_profilemaxsize'],
                                );
                                
                                $uploadlogo = '<input name="attachment" onclick=Attach("' . $ilpage['upload'] . '?crypted=' . encrypt_url($hiddeninput) . '") type="button" value="'.$phrase['_upload_logo'].'" class="buttons" '.$attachment_style.' />';
                        }
                        else
                        {
                                $attachment_style = 'disabled="disabled"';
                                $uploadlogo = '<a href="' . HTTPS_SERVER . $ilpage['subscription'] . '" title="' . $phrase['_upgrade_subscription_to_upload'] . '">' . $phrase['_upgrade_subscription_to_upload'] . '</a>';
                        }
                        
                        $headinclude .= "
return (!haveerrors);
}
//-->
</script>
";                        
                        $cid = 0;
                        if (!empty($ilance->GPC['cid']))
                        {
                             $cid = intval($ilance->GPC['cid']);
                        }
                        $category_pulldown = $ilance->categories_pulldown->print_cat_pulldown($cid, 'service', 'levelprofile', 'cid', $showpleaseselectoption = 1, $_SESSION['ilancedata']['user']['slng'], $nooptgroups = 1, $prepopulate = 0, $mode = 0, $showallcats = 1, $dojs = 1, '', $_SESSION['ilancedata']['user']['userid'], $forcenocount = 0, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = false, $ilance->categories->cats);
                        
                        $displayprofile_cb = '';
                        $displayprofile = fetch_user('displayprofile', $_SESSION['ilancedata']['user']['userid']);
                        if ($displayprofile > 0)
                        {
                                $displayprofile_cb = 'checked="checked"';
                        }
                        
                        // profile video url
                        $profilevideourl = fetch_user('profilevideourl', $_SESSION['ilancedata']['user']['userid']);
                        $profilevideourl = ilance_htmlentities($profilevideourl);
                        
                        // rate per hour
                        $rateperhour = fetch_user('rateperhour', $_SESSION['ilancedata']['user']['userid']);
                        $profileintro = fetch_user('profileintro', $_SESSION['ilancedata']['user']['userid'], '', '', $showunknown = false);
                        $profileintro = ilance_htmlentities($profileintro);
                        
                        // profile category limit (based on maxprofilegroups subscription permission)
                        $profilecatlimit = $ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'maxprofilegroups');
                        
                        $ilance->template->load_file('main', 'selling_profile.html', 0, 1);
                        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                        $ilance->template->parse_loop('main', 'profile_question_groups');
                        $ilance->template->parse_loop('main', 'default_profile_question_groups');
                        if (!isset($default_profile_question_groups))
                        {
                                $default_profile_question_groups = array();
                        }
                        @reset($default_profile_question_groups);
                        while ($i = @each($default_profile_question_groups))
                        {
                                $ilance->template->parse_loop('main', 'default_profile_questions' . $i['value']['groupid']);
                        }
                        if (!isset($profile_question_groups))
                        {
                                $profile_question_groups = array();
                        }
                        @reset($profile_question_groups);
                        while ($i = @each($profile_question_groups))
                        {
                                $ilance->template->parse_loop('main', 'profile_questions' . $i['value']['groupid']);
                        }
                        $ilance->template->parse_if_blocks('main');
                        
                        $pprint_array = array('profileintro','profilecatlimit','rateperhour','uploadlogo','profilevideourl','displayprofile_cb','displayprofile','category_pulldown','profile_logo','multiple_category_select','question_answer_js','attachment_style','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
                        
                        ($apihook = $ilance->api('selling_profile_start')) ? eval($apihook) : false;
                        
                        $ilance->template->pprint('main', $pprint_array);
                        exit();
                }
                else
                {
                        $area_title = $phrase['_access_denied_to_service_profile_menu'];
                        $page_title = SITE_NAME . ' - ' . $phrase['_access_denied_to_service_profile_menu'];
                        
                        print_notice($phrase['_access_denied'], $phrase['_your_current_subscription_level_does_not_permit_you_to_use_this_marketplace_resource']." <a href='".$ilpage['subscription']."'><strong>".$phrase['_click_here']."</strong></a>", $ilpage['subscription'], ucwords($phrase['_click_here']), fetch_permission_name('createserviceprofile'));
                        exit();
                }
        }
        
        // #### SELLING PROFILE MENU ###########################################
        else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'profile-specifics')
        {
                // #### define top header nav ##################################
                $topnavlink = array(
                        'mycp',
                        'profile_specifics'
                );
                
                $area_title = $phrase['_service_selling_profile_creation_menu'];
                $page_title = SITE_NAME . ' - ' . $phrase['_service_selling_profile_creation_menu'];
                
                $navcrumb = array();
                $navcrumb["$ilpage[main]?cmd=cp"] = $phrase['_my_cp'];
                $navcrumb[""] = $phrase['_selling_profile'];
                
                $ilance->subscription = construct_object('api.subscription');
                $ilance->categories->build_array($cattype = 'service', $_SESSION['ilancedata']['user']['slng'], $mode = 0, $propersort = true);
                $ilance->categories_pulldown = construct_object('api.categories_pulldown');
                
                $headinclude .= "
<script type=\"text/javascript\">
<!--
function customImage(imagename, imageurl, errors)
{
    document[imagename].src = imageurl;
    if (!haveerrors && errors)
    {
        haveerrors = errors;
        alert(phrase['_please_fix_the_fields_marked_with_a_warning_icon_and_retry_your_action']);
    }
}
//-->
</script>
";
                
                // selling profile subscription checkup
                if ($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'createserviceprofile') == 'yes')
                {
                        $ilance->mycp = construct_object('api.mycp');
                        
                        $headinclude .= "
<script type=\"text/javascript\">
<!--
function validatecustomform(f)
{
    haveerrors = 0;
";                            
                        // profile category
                        $cid = 0;
                        if (isset($ilance->GPC['cid']) AND $ilance->GPC['cid'] > 0)
                        {
                                $cid = intval($ilance->GPC['cid']);
                        }
                        
                        // profile settings, categories and questions
                        $sqlprofilegroups = $ilance->db->query("
                                SELECT *
                                FROM " . DB_PREFIX . "profile_groups
                                WHERE canremove = '1'
                                        AND cid = '".intval($cid)."'
                        ", 0, null, __FILE__, __LINE__);
                        if ($ilance->db->num_rows($sqlprofilegroups) > 0)
                        {
                                $row_count = 0;
                                while ($row = $ilance->db->fetch_array($sqlprofilegroups))
                                {
                                        $sqlquestions = $ilance->db->query("
                                                SELECT *
                                                FROM " . DB_PREFIX . "profile_questions
                                                WHERE groupid = '" . $row['groupid'] . "'
                                                        AND visible = '1'
                                                ORDER BY sort ASC
                                        ", 0, null, __FILE__, __LINE__);
                                        if ($ilance->db->num_rows($sqlquestions) > 0)
                                        {
                                                $row_count2 = 0;
                                                while ($rows = $ilance->db->fetch_array($sqlquestions))
                                                {
                                                        $rows['question'] = stripslashes($rows['question']);
                                                        $rows['question_description'] = stripslashes($rows['description']);
                                                        $rows['question_answer_error'] = '<img name="question'.$rows['questionid'].'error" src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif" width="21" height="13" border="0" alt="' . $phrase['_this_form_field_is_required'] . '" />';
                                                        if ($rows['required'])
                                                        {
                                                                $headinclude .= "(fetch_js_object('question" . $rows['questionid'] . "').value.length < 1) ? customImage(\"question" . $rows['questionid'] . "error\", \"" . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . "icons/fieldempty.gif\", true) : customImage(\"question" . $rows['questionid'] . "error\", \"" . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . "icons/blankimage.gif\", false); ";
                                                        }
                                                        
                                                        // can this question be verified?
                                                        if ($rows['canverify'])
                                                        {
                                                                $rows['action'] = '<input type="submit" name="verifyprofile[' . $rows['questionid'] . '|' . $rows['verifycost'] . ']" value="' . $ilance->currency->format($rows['verifycost']) . '" class="buttons_smaller" />';
                                                                
                                                                // fetch answer
                                                                $sqla = $ilance->db->query("
                                                                        SELECT *
                                                                        FROM " . DB_PREFIX . "profile_answers
                                                                        WHERE questionid = '" . $rows['questionid'] . "'
                                                                                AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                                AND visible = '1'
                                                                ", 0, null, __FILE__, __LINE__);
                                                                if ($ilance->db->num_rows($sqla) > 0)
                                                                {
                                                                        $resq = $ilance->db->fetch_array($sqla);
                                                                        $rows['question_answer_input'] = $ilance->mycp->construct_profile_input($rows['questionid']);
                                                                        
                                                                        if ($resq['isverified'] AND $resq['invoiceid'] > 0)
                                                                        {
                                                                                $date1split = explode(' ', $resq['verifyexpiry']);
                                                                                $date2split = explode('-', $date1split[0]);
                                                                                $expiredays = $ilance->datetime->fetch_days_between(gmdate('m'), gmdate('d'), gmdate('Y'), $date2split[1], $date2split[2], $date2split[0]);
                                                                                
                                                                                $rows['is_verified'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'verified_icon.gif" alt="" border="0" />';
                                                                                $rows['action'] = '';
                                                                                $rows['renew'] = $ilance->language->construct_phrase($phrase['_expires_in_x_days'], $expiredays);
                                                                        }
                                                                        else if ($resq['isverified'] AND $resq['invoiceid'] == 0)
                                                                        {
                                                                                $date1split = explode(' ', $resq['verifyexpiry']);
                                                                                $date2split = explode('-', $date1split[0]);
                                                                                $expiredays = $ilance->datetime->fetch_days_between(gmdate('m'), gmdate('d'), gmdate('Y'), $date2split[1], $date2split[2], $date2split[0]);
                                                                                
                                                                                $rows['is_verified'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'verified_icon.gif" alt="" border="0" />';
                                                                                $rows['action'] = '';
                                                                                $rows['renew'] = $ilance->language->construct_phrase($phrase['_expires_in_x_days'], $expiredays);
                                                                        }
                                                                        else if ($resq['isverified'] == 0 AND $resq['invoiceid'] == 0  AND !empty($resq['answer']))
                                                                        {
                                                                                $rows['is_verified'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'not_verified.gif" alt="" border="0" />';
                                                                                $rows['action'] = '<input type="submit" name="verifyprofile[' . $rows['questionid'] . '|' . $rows['verifycost'] . ']" value="' . $ilance->currency->format($rows['verifycost']) . '" class="buttons" />';
                                                                                $rows['renew'] = '';
                                                                        }
                                                                        else if ($resq['isverified'] == 0 AND $resq['invoiceid'] > 0 AND !empty($resq['answer']))
                                                                        {
                                                                                $rows['is_verified'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'not_verified.gif" alt="" border="0" />';
                                                                                $rows['action'] = $phrase['_pending'];
                                                                                $rows['renew'] = '';
                                                                        }
                                                                        else if ($resq['isverified'] == 0 AND empty($resq['answer']))
                                                                        {
                                                                                $rows['is_verified'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'not_verified.gif" alt="" border="0" />';
                                                                                $rows['action'] = $ilance->currency->format($rows['verifycost']);
                                                                                $rows['renew'] = '';
                                                                        }
                                                                        
                                                                        $rows['verify2'] = '<fieldset class="fieldset" style="width:150px; padding:9px"><legend>' . $rows['is_verified'] . '</legend><div align="left" style="padding:3px">' . $rows['action'] . '</div><div align="left" class="gray">' . $rows['renew'] . '</div></fieldset>';
                                                                }
                                                                else
                                                                {
                                                                        $rows['is_verified'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'not_verified.gif" alt="" border="0" />';
                                                                        $rows['question_answer_input'] = $ilance->mycp->construct_profile_input($rows['questionid']);
                                                                        $rows['action'] = $ilance->currency->format($rows['verifycost']);
                                                                        $rows['verify2'] = '<fieldset class="fieldset" style="width:150px; padding:9px"><legend>' . $rows['is_verified'] . '</legend><div align="left" style="padding:3px">' . $rows['action'] . '</div></fieldset>';
                                                                }
                                                        }
                                                        else
                                                        {
                                                                // fetch answer
                                                                $sqla = $ilance->db->query("
                                                                        SELECT *
                                                                        FROM " . DB_PREFIX . "profile_answers
                                                                        WHERE questionid = '" . $rows['questionid'] . "'
                                                                                AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                                AND visible = '1'
                                                                ", 0, null, __FILE__, __LINE__);
                                                                if ($ilance->db->num_rows($sqla) > 0)
                                                                {
                                                                        $resq = $ilance->db->fetch_array($sqla);
                                                                        $rows['question_answer_input'] = $ilance->mycp->construct_profile_input($rows['questionid']);
                                                                        $rows['action'] = $rows['is_verified'] = $rows['verify2'] = '';
                                                                }
                                                                else
                                                                {
                                                                        $rows['is_verified'] = $rows['action'] = $rows['verify2'] = '';
                                                                        $rows['question_answer_input'] = $ilance->mycp->construct_profile_input($rows['questionid']);
                                                                }
                                                        }
                                                        
                                                        $rows['class2'] = ($row_count2 % 2) ? 'alt2' : 'alt1';
                                                        $GLOBALS['profile_questions' . $row['groupid']][] = $rows;
                                                        $row_count2++;
                                                }
                                        }
                                        else
                                        {
                                                $GLOBALS['no_profile_questions' . $row['groupid']][] = 1;
                                        }
                                        
                                        $row['groupname'] = stripslashes($ilance->db->fetch_field(DB_PREFIX . "profile_groups","groupid=".$row['groupid'],"name"));
                                        $row['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                                        $profile_question_groups[] = $row;
                                        $row_count++;
                                }
                        }
                        else
                        {
                                $no_profile_question_groups = 1;
                        }
                        
                        
                        $headinclude .= "
        return (!haveerrors);
}
//-->
</script>
";                        
                        $cid = 0;
                        if (!empty($ilance->GPC['cid']))
                        {
                             $cid = intval($ilance->GPC['cid']);
                        }
                        $category_pulldown = $ilance->categories_pulldown->print_cat_pulldown($cid, 'service', 'levelprofile', 'cid', $showpleaseselectoption = 1, $_SESSION['ilancedata']['user']['slng'], $nooptgroups = 1, $prepopulate = 0, $mode = 0, $showallcats = 1, $dojs = 1, '', $_SESSION['ilancedata']['user']['userid'], $forcenocount = 0, $expertspulldown = 0, $canassigntoall = false, $showbestmatching = false, $ilance->categories->cats);
                        
                        $ilance->template->load_file('main', 'selling_profile_specifics.html', 0, 1);
                        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                        $ilance->template->parse_loop('main', 'profile_question_groups');
                        $ilance->template->parse_loop('main', 'default_profile_question_groups');
                        if (!isset($profile_question_groups))
                        {
                                $profile_question_groups = array();
                        }
                        @reset($profile_question_groups);
                        while ($i = @each($profile_question_groups))
                        {
                                $ilance->template->parse_loop('main', 'profile_questions' . $i['value']['groupid']);
                        }
                        $ilance->template->parse_if_blocks('main');
                        
                        $pprint_array = array('profileintro','profilecatlimit','rateperhour','uploadlogo','profilevideourl','displayprofile_cb','displayprofile','category_pulldown','profile_logo','multiple_category_select','question_answer_js','attachment_style','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer');
                        
                        ($apihook = $ilance->api('selling_profile_start')) ? eval($apihook) : false;
                        
                        $ilance->template->pprint('main', $pprint_array);
                        exit();
                }
                else
                {
                        $area_title = $phrase['_access_denied_to_service_profile_menu'];
                        $page_title = SITE_NAME . ' - ' . $phrase['_access_denied_to_service_profile_menu'];
                        
                        print_notice($phrase['_access_denied'], $phrase['_your_current_subscription_level_does_not_permit_you_to_use_this_marketplace_resource']." <a href='".$ilpage['subscription']."'><strong>".$phrase['_click_here']."</strong></a>", $ilpage['subscription'], ucwords($phrase['_click_here']), fetch_permission_name('createserviceprofile'));
                        exit();
                }
        }
        
        // #### SELLER PROFILE PREVIEW MENU ####################################
        else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_do-profile-preview')
        {
                // #### define top header nav ##################################
                $topnavlink = array(
                        'mycp'
                );
                
                $area_title = $phrase['_service_selling_profile_creation_menu'];
                $page_title = SITE_NAME . ' - ' . $phrase['_service_selling_profile_creation_menu'];
                
                $navcrumb = array();
                $navcrumb["$ilpage[main]?cmd=cp"] = $phrase['_my_cp'];
                $navcrumb["$ilpage[selling]?cmd=profile"] = $phrase['_selling_profile'];
                
                $headinclude .= '
<script type="text/javascript">
<!--
function validateprofileverification(f)
{
        haveerrors = 0;
        (f.contactname.value.length < 1) ? showImage("contactnameerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("contactnameerror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false);
        (f.contactnumber.value.length < 1) ? showImage("contactnumbererror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true) : showImage("contactnumbererror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false); 
        (f.contactnotes.value.length < 1) ? showImage("contactnoteserror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/fieldempty.gif", true)  : showImage("contactnoteserror", "' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/blankimage.gif", false); 
        return (!haveerrors);
}
//-->
</script>
';
                if (isset($ilance->GPC['verifyprofile']) AND !empty($ilance->GPC['verifyprofile']) AND is_array($ilance->GPC['verifyprofile']))
                {
                        $navcrumb[""] = $phrase['_profile_verification_payment'];
                        
                        foreach ($ilance->GPC['verifyprofile'] AS $key => $value)
                        {
                                $options = explode('|', $key);
                                
                                $sql = $ilance->db->query("
                                        SELECT *
                                        FROM " . DB_PREFIX . "profile_answers
                                        WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                AND questionid = '" . intval($options[0]) . "' 
                                                AND visible = '1'
                                                AND isverified = '0'
                                                AND invoiceid = '0'
                                ", 0, null, __FILE__, __LINE__);
                                if ($ilance->db->num_rows($sql) > 0)
                                {
                                        $res = $ilance->db->fetch_array($sql);
                                        $questionid = $res['questionid'];
                                        $answerid = $res['answerid'];
                                        
                                        $profile_item = "<em><strong>" . stripslashes($ilance->db->fetch_field(DB_PREFIX . "profile_questions", "questionid = '" . intval($options[0]) . "'", "question")) . "</strong></em>: ";
                                        if (is_question_multiplechoice($questionid, 'profile'))
                                        {
                                                $answers = unserialize($res['answer']);
                                                foreach ($answers AS $ans)
                                                {
                                                        $profile_item .= stripslashes($ans) . ', ';
                                                }
                                                $profile_item = mb_substr($profile_item, 0, -2);
                                        }
                                        else
                                        {
                                                $answer = stripslashes($res['answer']);
                                                $profile_item .= stripslashes($res['answer']);
                                        }
                                        
                                        $payment_method_pulldown = print_paymethod_pulldown('account', 'account_id', $_SESSION['ilancedata']['user']['userid'], $javascript = '');
                                        
                                        $amount_formatted = $value;
                                        $total_formatted = $value;
                                        $amount = $options[1];
                                        
                                        $show['istaxable'] = 0;
                                        
                                        // find out if portfolios are taxable
                                        $ilance->tax = construct_object('api.tax');
                                        if ($ilance->tax->is_taxable($_SESSION['ilancedata']['user']['userid'], 'credential'))
                                        {
                                                $show['istaxable'] = 1;
                                                
                                                $taxamount = $ilance->tax->fetch_amount($_SESSION['ilancedata']['user']['userid'], $options[1], 'credential', 0);
                                                $tax_formatted = $ilance->currency->format($taxamount);
                                                $total_formatted = $ilance->currency->format($amount+$taxamount);
                                        }
                                        
                                        $days = $ilconfig['verificationlength'];
                                        $canupdate = ($ilconfig['verificationupdateafter'] == 1) ? $phrase['_can'] : $phrase['_cannot'];
                                        $notes = $ilance->language->construct_phrase($phrase['_once_this_profile_answer_is_paid_and_verified_you_x_update_it'], $canupdate);
                                        
                                        $ilance->template->load_file('main', 'selling_profile_verification.html');
                                        $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                                        $ilance->template->parse_if_blocks('main');
                                        $ilance->template->pprint('main', array('notes','days','tax_formatted','amount_formatted','answerid','questionid','answer','profile_item','total_formatted','amount_total','payment_method_pulldown','remote_addr','rid','default_exchange_rate','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                                        exit();
                                }
                                else
                                {
                                        print_notice($phrase['_access_denied'], $phrase['_were_sorry_your_profile_verification_process_could_not_be_completed'], 'javascript:history.back(1);', $phrase['_back']);
                                        exit();
                                }
                        }
                }
                
                if (isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == 'specifics')
                {
                        // handle profile answers to questions
                        if (isset($ilance->GPC['question']) AND !empty($ilance->GPC['question']) AND is_array($ilance->GPC['question']))
                        {
                                process_profile_questions($ilance->GPC['question'], $_SESSION['ilancedata']['user']['userid']);
                        }
                        
                        print_notice($phrase['_service_profile_was_updated'], $phrase['_thank_you_for_taking_the_time_to_create_your_service_profile_on_our_marketplace'], $ilpage['selling'] . '?cmd=profile-specifics', $phrase['_return_to_the_previous_menu']);
                        exit();
                }
                
                // handle profile answers to questions
                if (isset($ilance->GPC['question']) AND !empty($ilance->GPC['question']) AND is_array($ilance->GPC['question']))
                {
                        process_profile_questions($ilance->GPC['question'], $_SESSION['ilancedata']['user']['userid']);
                }

                $ilance->subscription = construct_object('api.subscription');                
                $max_user_profiles = isset($ilance->GPC['subcategories']) ? count($ilance->GPC['subcategories']) : 0;
                
                if (!($ilance->subscription->check_access($_SESSION['ilancedata']['user']['userid'], 'maxprofilegroups') >= $max_user_profiles))
                {
                        print_notice($phrase['_access_denied'], $phrase['_you_selected_more_categories_than_your_current_subscription_permits_click_back_on_your_browser_to_change'] . ': <a href="' . $ilpage['subscription'] . '"><strong>' . $phrase['_click_here'] . '</strong></a>', $ilpage['subscription'], ucwords($phrase['_click_here']), fetch_permission_name('maxprofilegroups'));
                        exit();
                }
		
                $profilevideourl = isset($ilance->GPC['profilevideourl']) ? $ilance->GPC['profilevideourl'] : '';
                $displayprofile = isset($ilance->GPC['displayprofile']) ? 1 : 0;
                $rateperhour = isset($ilance->GPC['rateperhour']) ? sprintf("%01.2f", $ilance->GPC['rateperhour']) : '0.00';
                $profileintro = isset($ilance->GPC['profileintro']) ? $ilance->GPC['profileintro'] : '';
                
                $ilance->db->query("
                        UPDATE " . DB_PREFIX . "users
                        SET displayprofile = '" . $displayprofile . "',
                        profilevideourl = '" . $ilance->db->escape_string($profilevideourl) . "',
                        rateperhour = '" . $rateperhour . "',
                        profileintro = '" . $ilance->db->escape_string($profileintro) . "'
                        WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                ", 0, null, __FILE__, __LINE__);
                
                
                ($apihook = $ilance->api('selling_profile_update_start')) ? eval($apihook) : false;
                
                // did provider click any of the categories on the profile page?
                // if so, let's update and/or add new entries
                // if no, we should delete all searchable categories for this user
                if (!empty($ilance->GPC['subcategories']))
                {
                        // provider is updating categories they will be searchable within
                        $count = count($ilance->GPC['subcategories']);
                        if (isset($count) AND $count > 0)
                        {
                                // we are updating searchable categories
                                // so let's remove our current entries
                                $ilance->db->query("
                                        DELETE FROM " . DB_PREFIX . "profile_categories
                                        WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                ", 0, null, __FILE__, __LINE__);
                                for ($i = 0; $i < $count; $i++)
                                {
                                        $cid = intval($ilance->GPC['subcategories'][$i]);
                                        if (isset($cid) AND $cid > 0)
                                        {
                                                $sql = $ilance->db->query("
                                                        SELECT *
                                                        FROM " . DB_PREFIX . "profile_categories
                                                        WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                AND cid = '" . intval($cid) . "'
                                                        LIMIT 1
                                                ", 0, null, __FILE__, __LINE__);
                                                if ($ilance->db->num_rows($sql) == 0)
                                                {
                                                        // adding themselves to a new searchable category
                                                        $ilance->db->query("
                                                                INSERT INTO " . DB_PREFIX . "profile_categories
                                                                (user_id, cid) VALUES (
                                                                '" . $_SESSION['ilancedata']['user']['userid'] . "',
                                                                '" . intval($cid) . "')
                                                        ", 0, null, __FILE__, __LINE__);
                                                }
                                        }

                                }        
                        }

                }
                else
                {
                        // user is either de-selecting all opt-in searchable categories
                        // or the user has not chosen to be listed at all within any category
                        // so what we'll do is remove any existing entries just in case
                        $ilance->db->query("
                                DELETE FROM " . DB_PREFIX . "profile_categories
                                WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                        ", 0, null, __FILE__, __LINE__);
                }
                
                $headertxt = $phrase['_service_profile_was_updated'];
                if (!empty($_SESSION['ilancedata']['user']['invited']) AND $_SESSION['ilancedata']['user']['invited'] == 1)
                {
                        print_notice($headertxt, $phrase['_thank_you_for_taking_the_time_to_create_your_service_profile_on_our_marketplace'], $ilpage['rfp'] . '?id=' . $_SESSION['ilancedata']['user']['invitedid'], $phrase['_proceed_to_bid_on_invited_project']);
                        exit();
                }
                else
                {
                        print_notice($headertxt, $phrase['_thank_you_for_taking_the_time_to_create_your_service_profile_on_our_marketplace'], $ilpage['selling'] . '?cmd=profile', $phrase['_return_to_the_previous_menu']);
                        exit();
                }
        }
        
        /// #### PROFILE VERIFICATION PAYMENT HANDLER ##########################
        else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_profile-verification-process' AND isset($ilance->GPC['answerid']) AND $ilance->GPC['answerid'] > 0 AND isset($ilance->GPC['questionid']) AND $ilance->GPC['questionid'] > 0 AND !empty($ilance->GPC['answer']) AND isset($ilance->GPC['contactname']) AND isset($ilance->GPC['contactnumber']) AND isset($ilance->GPC['contactnotes']))
        {
                // #### define top header nav ##################################
                $topnavlink = array(
                        'mycp'
                );
                
                $ilance->accounting = construct_object('api.accounting');
                $ilance->accounting->process_credential_payment($_SESSION['ilancedata']['user']['userid'], 'account', $ilance->GPC['answerid'], $ilance->GPC['questionid'], $ilance->GPC['answer'], $ilance->GPC['contactname'], $ilance->GPC['contactnumber'], $ilance->GPC['contactnotes']);
                exit();
        }
                        
        // #### SERVICE AUCTION ESCROW MANAGEMENT ##############################
        else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'management' AND isset($ilance->GPC['bidsub']) AND $ilance->GPC['bidsub'] == 'rfp-escrow' AND $ilconfig['escrowsystem_enabled'])
        {
                // #### define top header nav ##################################
                $topnavlink = array(
                        'mycp',
                        'servicesellingescrow'
                );
                
                $show['widescreen'] = true;
                
                if (!isset($ilance->GPC['page']) OR isset($ilance->GPC['page']) AND $ilance->GPC['page'] <= 0)
                {
                        $ilance->GPC['page'] = 1;
                }
                else
                {
                        $ilance->GPC['page'] = intval($ilance->GPC['page']);
                }
                $limit = ' ORDER BY p.date_added DESC LIMIT ' . (($ilance->GPC['page'] - 1) * $ilconfig['globalfilters_maxrowsdisplay']) . ',' . $ilconfig['globalfilters_maxrowsdisplay'];
                
                $numberrows = $ilance->db->query("
                        SELECT p.project_id, p.project_state, p.user_id as owner_id, p.project_title, p.description, u.username, e.project_user_id, e.user_id, e.escrowamount, e.bidamount, e.fee, e.fee2, e.date_awarded, e.date_paid, e.status, e.bid_id, e.project_id, e.invoiceid, e.escrow_id, b.bid_id, b.user_id as bidder_id, b.bidstatus, i.invoiceid, i.projectid, i.buynowid, i.paid, i.invoicetype, i.paiddate
                        FROM " . DB_PREFIX . "projects AS p,
                        " . DB_PREFIX . "users AS u,
                        " . DB_PREFIX . "projects_escrow AS e,
                        " . DB_PREFIX . "project_bids AS b,
                        " . DB_PREFIX . "invoices AS i
                        WHERE u.user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                AND e.user_id = u.user_id
                                AND e.status != 'cancelled'
                                AND e.bid_id = b.bid_id
                                AND e.user_id = b.user_id
                                AND e.project_id = p.project_id
                                AND e.invoiceid = i.invoiceid
                                AND i.invoicetype = 'escrow'
                                AND p.project_state = 'service'
                                AND i.projectid = e.project_id
                ", 0, null, __FILE__, __LINE__);
                $number = $ilance->db->num_rows($numberrows);
                
                $area_title = $phrase['_rfp_escrow_management'] . ' (' . $number . ' ' . $phrase['_rfps_found'] . ')';
                $page_title = SITE_NAME . ' - ' . $phrase['_rfp_escrow_management'] . ' (' . $number . ' ' . $phrase['_rfps_found'] . ')';
                $counter = ($ilance->GPC['page'] - 1) * $ilconfig['globalfilters_maxrowsdisplay'];
		
                require_once(DIR_CORE . 'functions_tabs.php');
		$servicetabs = print_selling_activity_tabs('escrow', 'service', $_SESSION['ilancedata']['user']['userid']);
                
                $row_count = 0;
                
                $result = $ilance->db->query("
                        SELECT p.project_id, p.project_state, p.user_id as owner_id, p.project_title, p.description, u.username, e.project_user_id, e.user_id, e.escrowamount, e.bidamount, e.fee, e.fee2, e.date_awarded, e.date_paid, e.status, e.bid_id, e.project_id, e.invoiceid, e.escrow_id, b.bid_id, b.user_id as bidder_id, b.bidstatus, i.invoiceid, i.projectid, i.buynowid, i.paid, i.invoicetype, i.paiddate
                        FROM " . DB_PREFIX . "projects AS p,
                        " . DB_PREFIX . "users AS u,
                        " . DB_PREFIX . "projects_escrow AS e,
                        " . DB_PREFIX . "project_bids AS b,
                        " . DB_PREFIX . "invoices AS i
                        WHERE u.user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                AND e.user_id = u.user_id
                                AND e.status != 'cancelled'
                                AND e.bid_id = b.bid_id
                                AND e.user_id = b.user_id
                                AND e.project_id = p.project_id
                                AND e.invoiceid = i.invoiceid
                                AND i.invoicetype = 'escrow'
                                AND p.project_state = 'service'
                                AND i.projectid = e.project_id
                        $limit
                ", 0, null, __FILE__, __LINE__);
                if ($ilance->db->num_rows($result) > 0)
                {
                        $altrows = 0;
                        while ($row = $ilance->db->fetch_array($result))
                        {
                                $altrows++;
                                if (floor($altrows/2) == ($altrows/2))
                                {
                                        $row['class'] = 'alt2';
                                }
                                else
                                {
                                        $row['class'] = 'alt1';
                                }
                                $row['taxinfo'] = fetch_escrow_taxinfo_bit($_SESSION['ilancedata']['user']['userid'], fetch_provider_escrow_fee($row['bidamount']), $row['project_id']);
                                
                                // escrow fee logic
                                // we are a service provider looking at our escrow payments from buyers
                                // let's determine what the admin has arranged for the escrow fees
                                $row['fee2'] = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $row['fee2']);
                                $row['job_title'] = stripslashes($row['project_title']);                                        
                                $row['buyer'] = fetch_user('username', $row['project_user_id']);
                                $row['buyer_id'] = $row['project_user_id'];
                                $row['awarddate'] = print_date($row['date_awarded'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 1, 0);
                                $row['bidamount'] = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $row['bidamount']);
                                $row['escrowamount'] = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $row['escrowamount']);
                                if ($row['status'] == 'pending')
                                {
                                        $row['status'] = $phrase['_pending_escrow'] . ' <a href="javascript:void(0);" onmouseover="Tip(\'' . $phrase['_pending_means_the_buyer_has_not_forwarded_funds_for_the_awarded_bid_amount'] . '\', BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a>';
                                        $row['actions'] = '-';
                                }
                                else if ($row['status'] == 'started')
                                {
                                        $row['status'] = $phrase['_funds_secured'] . ' <a href="javascript:void(0);" onmouseover="Tip(\'' . $phrase['_funds_secured_means_that_the_buyer_has_forwarded_funds'] . '\', BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a>';
                                        $row['actions'] = "<img src='" . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . "escrow_funded.gif' border='0' alt='" . $phrase['_funds_secured_in_escrow'] . "' />";
                                }
                                else if ($row['status'] == 'confirmed')
                                {
                                        $row['status'] = $phrase['_pending_release'] . ' <a href="javascript:void(0);" onmouseover="Tip(\'' . $phrase['_funds_within_this_escrow_account_are_pending_release_of_funds_from_your_buyer'] . '\', BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a>';
                                        $row['actions'] = "<img src='" . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . "wait_invoice.gif' border='0' alt='" . $phrase['_funds_within_this_escrow_account_are_pending_release_of_funds_from_your_buyer'] . "' />";
                                }
                                else if ($row['status'] == 'finished')
                                {
                                        $row['status'] = $phrase['_funds_released'];
                                        $row['actions'] = "<img src='" . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . "escrow_funded.gif' border='0' alt='" . $phrase['_funds_released_to_vendor'] . "' />";
                                }
                                $project_results_rows[] = $row;
                                $row_count++;
                        }
                }
                else
                {
                        $show['no_project_rows_returned'] = true;
                }
                
                $prevnext = print_pagnation($number, $ilconfig['globalfilters_maxrowsdisplay'], $ilance->GPC['page'], $counter, $ilpage['selling'].'?cmd=management&amp;sub=rfp-escrow');
                
                $ilance->template->load_file('main', 'selling_rfp_escrow.html', 0, 1);
                $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                $ilance->template->parse_loop('main', 'project_results_rows');
                $ilance->template->parse_if_blocks('main');
                $ilance->template->pprint('main', array('servicetabs','serviceescrow','rfpescrow','rfpvisible','prevnext','input_style','redirect','referer','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                exit();
        }
        
        // #### BUY NOW ESCROW MANAGEMENT ######################################
        else if ((isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'management' AND isset($ilance->GPC['sub']) AND $ilance->GPC['sub'] == 'buynow-escrow' OR isset($uncrypted['cmd']) AND $uncrypted['cmd'] == 'management' AND isset($uncrypted['sub']) AND $uncrypted['sub'] == 'buynow-escrow'))
        {
                // #### define top header nav ##################################
                $topnavlink = array(
                        'mycp'
                );
                
                // #### SELLER CONFIRMS OFFLINE DELIVERY FOR BUYER #############
                if ((isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_confirm-offline-delivery' AND isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0 OR isset($uncrypted['subcmd']) AND $uncrypted['subcmd'] == '_confirm-offline-delivery' AND isset($uncrypted['id']) AND $uncrypted['id'] > 0))
                {
                        if ($uncrypted['id'] != '' AND $uncrypted['id'] > 0)
                        {
                                $id = intval($uncrypted['id']);
                        }
                        else
                        {
                                $id = intval($ilance->GPC['id']);
                        }
                        
                        $ilance->escrow = construct_object('api.escrow');
                        if ($ilance->escrow->instant_purchase_now_confirmation_offline($id))
                        {
                                $area_title = $phrase['_merchant_product_delivery_confirmation'];
                                $page_title = SITE_NAME . ' - ' . $phrase['_merchant_product_delivery_confirmation'];
                                
                                print_notice($phrase['_offline_delivery_status_updated'], $phrase['_you_have_successfully_confirmed_delivery_status_for_this_particular_auctions_items_please_communicate'], $ilpage['selling'] . '?cmd=management&amp;sub=sold', $phrase['_selling_activity']);
                                exit();
                        }
                }
                
                // #### MERCHANT CONFIRMS DELIVERY #############################
                else if ((isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_confirm-delivery' AND isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0 OR isset($uncrypted['subcmd']) AND $uncrypted['subcmd'] == '_confirm-delivery' AND isset($uncrypted['id']) AND $uncrypted['id'] > 0))
                {
                        if ($uncrypted['id'] > 0)
                        {
                                $id = intval($uncrypted['id']);
                        }
                        else
                        {
                                $id = intval($ilance->GPC['id']);
                        }
                        
                        $ilance->escrow = construct_object('api.escrow');
                        if ($ilance->escrow->instant_purchase_now_confirmation($id))
                        {
                                $area_title = $phrase['_merchant_product_delivery_confirmation'];
                                $page_title = SITE_NAME . ' - ' . $phrase['_merchant_product_delivery_confirmation'];
                                
                                print_notice($phrase['_escrow_account_confirmed'], $phrase['_you_have_successfully_confirmed_delivery_status_for_this_particular_auctions_items_please_communicate'], $ilpage['selling'].'?cmd=management', $phrase['_escrow_management']);
                                exit();
                        }
                }
                
                // #### MERCHANT CANCELS DELIVERY - FUNDS RETURN TO BUYER ######
                // this returns all fees as well (escrow fee, fvf fee and buyer escrow fee)
                // fees unpaid will be cancelled
                else if ((isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_cancel-delivery' AND isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0 OR isset($uncrypted['subcmd']) AND $uncrypted['subcmd'] == '_cancel-delivery' AND isset($uncrypted['id']) AND $uncrypted['id'] > 0))
                {
                        if ($uncrypted['id'] > 0)
                        {
                                $id = intval($uncrypted['id']);
                        }
                        else
                        {
                                $id = intval($ilance->GPC['id']);
                        }
                        
                        $ilance->escrow = construct_object('api.escrow');
                        if ($ilance->escrow->instant_purchase_now_reversal($id))
                        {
                                $area_title = $phrase['_merchant_product_cancelled_delivery'];
                                $page_title = SITE_NAME . ' - ' . $phrase['_merchant_product_cancelled_delivery'];
                                
                                print_notice($phrase['_escrow_account_cancelled_funds_returned'], $phrase['_you_have_successfully_cancelled_delivery_for_this_particular_auctions_escrow_account'], $ilpage['selling'].'?cmd=management', $phrase['_escrow']);
                                exit();
                        }
                }	
        }
        
        // #### PRODUCT ESCROW: SELLER CONFIRMS DELIVERY VIA ESCROW ############
        else if ((isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == 'management' AND $ilconfig['escrowsystem_enabled'] AND isset($ilance->GPC['sub']) AND $ilance->GPC['sub'] == 'product-escrow' OR isset($uncrypted['cmd']) AND $uncrypted['cmd'] == 'management' AND isset($uncrypted['sub']) AND $uncrypted['sub'] == 'product-escrow'))
        {
                // #### define top header nav ##################################
                $topnavlink = array(
                        'mycp',
                        'productsellingescrow'
                );
                
                $show['widescreen'] = true;
                
		// #### CONFIRM DELIVERY #######################################
                if ((isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_confirm-delivery' AND isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0 OR isset($uncrypted['subcmd']) AND $uncrypted['subcmd'] == '_confirm-delivery' AND isset($uncrypted['id']) AND $uncrypted['id'] > 0))
                {
                        if ($uncrypted['id'] != '' AND $uncrypted['id'] > 0)
                        {
                                $id = intval($uncrypted['id']);
                        }
                        else
                        {
                                $id = intval($ilance->GPC['id']);
                        }
                        
                        // set escrow phase to confirmed
                        // the final phase will allow the bidder to release
                        // funds within escrow to this merchant
                        // at that point any escrow fees will be deducted
                        $ilance->db->query("
				UPDATE " . DB_PREFIX . "projects_escrow
				SET status = 'confirmed'
				WHERE escrow_id = '" . $id . "'
					AND project_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
					AND escrowamount != ''
				LIMIT 1
			");
            
                        $amount = 0;
                        
                        $sql = $ilance->db->query("
				SELECT *
				FROM " . DB_PREFIX . "projects_escrow
				WHERE escrow_id = '" . $id . "'
			");
                        if ($ilance->db->num_rows($sql) > 0)
                        {
                                $res_escrow = $ilance->db->fetch_array($sql);
                                $amount = $res_escrow['escrowamount'];
                                
                                // update as shipped (listing table)
                                mark_listing_as_shipped($res_escrow['project_id']);
                                
                                $ilance->email = construct_dm_object('email', $ilance);
                                
                                $ilance->email->mail = fetch_user('email', $res_escrow['user_id']);
                                $ilance->email->slng = $_SESSION['ilancedata']['user']['slng'];
                        
                                $ilance->email->get('product_escrow_delivery_confirmed_bidder');		
                                $ilance->email->set(array(
                                        '{{project_id}}' => $res_escrow['project_id'],
                                        '{{biddername}}' => fetch_user('username', $res_escrow['user_id']),
                                        '{{ownername}}' => fetch_user('username', $res_escrow['project_user_id']),
                                        '{{project_title}}' => stripslashes($ilance->db->fetch_field(DB_PREFIX.'projects','project_id='.$res_escrow['project_id'],'project_title')),
                                        '{{escrowamount}}' => $ilance->currency->format($amount),
                                ));
                                
                                $ilance->email->send();
                                
                                $ilance->email->get('product_escrow_delivery_confirmed_merchant');		
                                $ilance->email->set(array(
                                        '{{project_id}}' => $res_escrow['project_id'],
                                        '{{biddername}}' => fetch_user('username', $res_escrow['user_id']),
                                        '{{ownername}}' => fetch_user('username', $res_escrow['project_user_id']),
                                        '{{project_title}}' => stripslashes($ilance->db->fetch_field(DB_PREFIX.'projects','project_id='.$res_escrow['project_id'],'project_title')),
                                        '{{escrowamount}}' => $ilance->currency->format($amount),
                                ));
                                
                                $ilance->email->mail = fetch_user('email', $res_escrow['project_user_id']);
                                $ilance->email->slng = $_SESSION['ilancedata']['user']['slng'];
                                $ilance->email->send();
                                
                                $ilance->email->get('product_escrow_delivery_confirmed_admin');		
                                $ilance->email->set(array(
                                        '{{project_id}}' => $res_escrow['project_id'],
                                        '{{biddername}}' => fetch_user('username', $res_escrow['user_id']),
                                        '{{ownername}}' => fetch_user('username', $res_escrow['project_user_id']),
                                        '{{project_title}}' => stripslashes($ilance->db->fetch_field(DB_PREFIX.'projects','project_id='.$res_escrow['project_id'],'project_title')),
                                        '{{escrowamount}}' => $ilance->currency->format($amount),
                                ));
                                
                                $ilance->email->mail = SITE_EMAIL;
                                $ilance->email->slng = fetch_site_slng();
                                $ilance->email->send();
                                
                                $area_title = $phrase['_merchant_product_delivery_confirmation'];
                                $page_title = SITE_NAME . ' - ' . $phrase['_merchant_product_delivery_confirmation'];
                                
                                print_notice($phrase['_escrow_account_confirmed'], $phrase['_you_have_successfully_confirmed_delivery_status_for_this_particular_auctions_items_please_communicate'], $ilpage['selling'].'?cmd=management&sub=product-escrow', $phrase['_escrow']);
                                exit();
                        }
                }
                
		// #### CANCEL DELIVERY ########################################
		else if ((isset($ilance->GPC['subcmd']) AND $ilance->GPC['subcmd'] == '_cancel-delivery' AND isset($ilance->GPC['id']) AND $ilance->GPC['id'] > 0 OR isset($uncrypted['subcmd']) AND $uncrypted['subcmd'] == '_cancel-delivery' AND isset($uncrypted['id']) AND $uncrypted['id'] > 0))
                {
                        if ($uncrypted['id'] != '' AND $uncrypted['id'] > 0)
                        {
                                $id = intval($uncrypted['id']);
                        }
                        else
                        {
                                $id = intval($ilance->GPC['id']);
                        }
                        
                        $sql_escrow_amount = $ilance->db->query("
				SELECT *
				FROM " . DB_PREFIX . "projects_escrow
				WHERE escrow_id = '" . $id . "'
					AND project_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
					AND escrowamount != ''
				LIMIT 1
			");
                        if ($ilance->db->num_rows($sql_escrow_amount) > 0)
                        { 
                                $res_escrow = $ilance->db->fetch_array($sql_escrow_amount);
                                $amount = $res_escrow['escrowamount'];
                                
                                $sql_account = $ilance->db->query("
					SELECT available_balance, total_balance
					FROM " . DB_PREFIX . "users
					WHERE user_id = '" . $res_escrow['user_id'] . "'
				");
                                if ($ilance->db->num_rows($sql_account) > 0)
                                {
                                        $res_account = $ilance->db->fetch_array($sql_account);
                                        $avail_balance = $res_account['available_balance'];
                                        $total_balance = $res_account['total_balance'];
                                        
                                        $new_avail_balance = ($avail_balance + $amount);
                                        $new_total_balance = ($total_balance + $amount);
                                        
                                        $ilance->db->query("
						UPDATE " . DB_PREFIX . "users
						SET total_balance = '" . $new_total_balance . "',
						available_balance = '" . $new_avail_balance . "'
						WHERE user_id = '" . $res_escrow['user_id'] . "'
					");
                                        
                                        // adjust bidders total amount spent to this merchant > debit the spendings for this refund
                                        insert_income_spent($res_escrow['user_id'], sprintf("%01.2f", $amount), 'debit');
                                        
                                        // adjust merchants total amount received from this bidder > debit the spendings for this refund
                                        insert_income_reported($_SESSION['ilancedata']['user']['userid'], sprintf("%01.2f", $amount), 'debit');
                                        
                                        // create transaction credit
                                        $ilance->accounting = construct_object('api.accounting');
                                                $ilance->accounting->insert_transaction(
                                                0,
                                                $res_escrow['project_id'],
                                                0,
                                                $res_escrow['user_id'],
                                                0,
                                                0,
                                                0,
                                                $phrase['_product_escrow_delivery_cancellation'] . ': (' . $res_escrow['project_id'] . '): ' . $phrase['_refund_from_escrow_to_online_account'],
                                                sprintf("%01.2f", $amount),
                                                sprintf("%01.2f", $amount),
                                                'paid',
                                                'credit',
                                                'account',
                                                DATETIME24H,
                                                DATETIME24H,
                                                DATETIME24H,
                                                $phrase['_merchant_cancelled_delivery_on'] . ' ' . DATETIME24H,
                                                0,
                                                0,
                                                0
                                        );
                                        
                                        // update escrow as cancelled
                                        $ilance->db->query("
						UPDATE " . DB_PREFIX . "projects_escrow
						SET status = 'cancelled',
						escrowamount = NULL,
						date_cancelled = '" . DATETIME24H . "'
						WHERE escrow_id = '" . intval($id) . "'
							AND user_id = '" . intval($res_escrow['user_id']) . "'
					");
                                        
                                        // mark as unshipped (listing table)
                                        mark_listing_as_unshipped($res_escrow['project_id']);
                                        
                                        $ilance->email = construct_dm_object('email', $ilance);
                                        
                                        $ilance->email->mail = fetch_user('email', $res_escrow['user_id']);
                                        $ilance->email->slng = $_SESSION['ilancedata']['user']['slng'];
                
                                        $ilance->email->get('product_escrow_delivery_cancelled_bidder');		
                                        $ilance->email->set(array(
                                                '{{project_id}}' => $res_escrow['project_id'],
                                                '{{biddername}}' => fetch_user('username', $res_escrow['user_id']),
                                                '{{ownername}}' => fetch_user('username', $res_escrow['project_user_id']),
                                                '{{project_title}}' => stripslashes($ilance->db->fetch_field(DB_PREFIX.'projects','project_id='.$res_escrow['project_id'],'project_title')),
                                                '{{escrowamount}}' => $ilance->currency->format($amount),
                                        ));
                                        
                                        $ilance->email->send();
                                        
                                        $ilance->email->get('product_escrow_delivery_cancelled_merchant');		
                                        $ilance->email->set(array(
                                                '{{project_id}}' => $res_escrow['project_id'],
                                                '{{biddername}}' => fetch_user('username', $res_escrow['user_id']),
                                                '{{ownername}}' => fetch_user('username', $res_escrow['project_user_id']),
                                                '{{project_title}}' => stripslashes($ilance->db->fetch_field(DB_PREFIX.'projects','project_id='.$res_escrow['project_id'],'project_title')),
                                                '{{escrowamount}}' => $ilance->currency->format($amount),
                                        ));
                                        
                                        $ilance->email->mail = fetch_user('email', $res_escrow['project_user_id']);
                                        $ilance->email->slng = $_SESSION['ilancedata']['user']['slng'];
                                        $ilance->email->send();
                                        
                                        $ilance->email->get('product_escrow_delivery_cancelled_admin');		
                                        $ilance->email->set(array(
                                                '{{project_id}}' => $res_escrow['project_id'],
                                                '{{biddername}}' => fetch_user('username', $res_escrow['user_id']),
                                                '{{ownername}}' => fetch_user('username', $res_escrow['project_user_id']),
                                                '{{project_title}}' => stripslashes($ilance->db->fetch_field(DB_PREFIX.'projects','project_id='.$res_escrow['project_id'],'project_title')),
                                                '{{escrowamount}}' => $ilance->currency->format($amount),
                                        ));
                                        
                                        $ilance->email->mail = SITE_EMAIL;
                                        $ilance->email->slng = fetch_site_slng();
                                        $ilance->email->send();
                                        
                                        $area_title = $phrase['_merchant_product_cancelled_delivery'];
                                        $page_title = SITE_NAME . ' - ' . $phrase['_merchant_product_cancelled_delivery'];
                                        
                                        print_notice($phrase['_escrow_account_cancelled_funds_returned'], $phrase['_you_have_successfully_cancelled_delivery_for_this_particular_auctions_escrow_account'], $ilpage['selling'].'?cmd=management&sub=product-escrow', $phrase['_escrow']);
                                        exit();
                                }
                        }	
                }
                
                // #### PRODUCT ESCROW SELLER MANAGEMENT #######################
                if (!isset($ilance->GPC['page']) OR isset($ilance->GPC['page']) AND $ilance->GPC['page'] <= 0)
                {
                        $ilance->GPC['page'] = 1;
                }
                else
                {
                        $ilance->GPC['page'] = intval($ilance->GPC['page']);
                }
                
                // #### listing period #########################################
                require_once(DIR_CORE . 'functions_search.php');
                
                // #### listing period #########################################
                $ilance->GPC['period'] = (isset($ilance->GPC['period']) ? intval($ilance->GPC['period']) : -1);
                $extra = '&amp;period=' . $ilance->GPC['period'];
                $periodsql = fetch_startend_sql($ilance->GPC['period'], 'DATE_SUB', 'e.date_awarded', '>=');
                
                // #### ordering by fields defaults ############################
                $orderbyfields = array('date_awarded');
                $orderby = '&amp;orderby=date_awarded';
                $orderbysql = 'e.date_awarded';
                if (isset($ilance->GPC['orderby']) AND in_array($ilance->GPC['orderby'], $orderbyfields))
                {
                        $orderby = '&amp;orderby=' . $ilance->GPC['orderby'];
                        $orderbysql = 'e.' . $ilance->GPC['orderby'];
                }
                
                // #### display order defaults #################################
                $displayorderfields = array('asc', 'desc');
                $displayorder = '&amp;displayorder=asc';
                $currentdisplayorder = $displayorder;
                $displayordersql = 'DESC';
                if (isset($ilance->GPC['displayorder']) AND $ilance->GPC['displayorder'] == 'asc')
                {
                        $displayorder = '&amp;displayorder=desc';
                        $currentdisplayorder = '&amp;displayorder=asc';
                }
                else if (isset($ilance->GPC['displayorder']) AND $ilance->GPC['displayorder'] == 'desc')
                {
                        $displayorder = '&amp;displayorder=asc';
                        $currentdisplayorder = '&amp;displayorder=desc';
                }
                if (isset($ilance->GPC['displayorder']) AND in_array($ilance->GPC['displayorder'], $displayorderfields))
                {
                        $displayordersql = mb_strtoupper($ilance->GPC['displayorder']);
                }
                if (!empty($ilance->GPC['sub']))
                {
                        $extra .= '&amp;sub=' . $ilance->GPC['sub'];
                }
                
		$limit = ' ORDER BY ' . $orderbysql . ' ' . $displayordersql . ' LIMIT ' . (($ilance->GPC['page'] - 1) * $ilconfig['globalfilters_maxrowsdisplay']) . ',' . $ilconfig['globalfilters_maxrowsdisplay'];
                
                // used within templates
                $php_self = $ilpage['selling'] . '?cmd=management' . $displayorder . $extra;
                
                // used within prev / next page nav
                $scriptpage = $ilpage['selling'] . '?cmd=management' . $currentdisplayorder . $orderby . $extra;
                 
                $SQL = "
			SELECT p.project_id, p.user_id, p.project_title, p.description, u.username, u.user_id, e.project_user_id, e.user_id, e.escrowamount, e.date_awarded, e.date_paid, e.status, e.bid_id, e.project_id, e.invoiceid, e.escrow_id, e.fee, e.fee2, b.bid_id, b.user_id, b.project_user_id, b.bidstatus, b.bidamount, i.invoiceid, i.projectid, i.buynowid, i.user_id, i.paid, i.invoicetype, i.paiddate
			FROM " . DB_PREFIX . "projects AS p,
			" . DB_PREFIX . "users AS u,
			" . DB_PREFIX . "projects_escrow AS e,
			" . DB_PREFIX . "project_bids AS b,
			" . DB_PREFIX . "invoices AS i
			WHERE p.user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
				AND u.user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
				AND e.project_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                $periodsql
				AND e.status != 'cancelled'
				AND e.bid_id = b.bid_id
				AND e.user_id = b.user_id
				AND e.project_id = p.project_id
				AND e.invoiceid = i.invoiceid
				AND i.invoicetype = 'escrow'
				AND i.projectid = e.project_id 
				AND p.project_state = 'product'
			$limit
		";
                
                $SQL2 = "
			SELECT p.project_id, p.user_id, p.project_title, p.description, u.username, u.user_id, e.project_user_id, e.user_id, e.escrowamount, e.date_awarded, e.date_paid, e.status, e.bid_id, e.project_id, e.invoiceid, e.escrow_id, e.fee, e.fee2, b.bid_id, b.user_id, b.project_user_id, b.bidstatus, b.bidamount, i.invoiceid, i.projectid, i.buynowid, i.user_id, i.paid, i.invoicetype, i.paiddate
			FROM " . DB_PREFIX . "projects AS p,
			" . DB_PREFIX . "users AS u,
			" . DB_PREFIX . "projects_escrow AS e,
			" . DB_PREFIX . "project_bids AS b,
			" . DB_PREFIX . "invoices AS i
			WHERE p.user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
				AND u.user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
				AND e.project_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                $periodsql
				AND e.status != 'cancelled'
				AND e.bid_id = b.bid_id
				AND e.user_id = b.user_id
				AND e.project_id = p.project_id
				AND e.invoiceid = i.invoiceid
				AND i.invoicetype = 'escrow'
				AND i.projectid = e.project_id
				AND p.project_state = 'product'
		";
		
                $condition = $condition2 = '';
                
                $numberrows = $ilance->db->query($SQL2);
                $number = $ilance->db->num_rows($numberrows);
                
                $area_title = $phrase['_product_escrow_management'] . ' (' . $number . ' ' . $phrase['_rfps_found'] . ')';
                $page_title = SITE_NAME . ' - ' . $phrase['_product_escrow_management'] . ' (' . $number . ' ' . $phrase['_rfps_found'] . ')';
                
                $navcrumb = array();
                $navcrumb["$ilpage[main]?cmd=cp"] = $phrase['_my_cp'];
                $navcrumb["$ilpage[selling]?cmd=management"] = $phrase['_selling_activity'];
                $navcrumb[""] = $phrase['_product_escrow_management'];
                
                require_once(DIR_CORE . 'functions_tabs.php');
		$producttabs = print_selling_activity_tabs('escrow', 'product', $_SESSION['ilancedata']['user']['userid'], $extra = '', $style = 'height:21px');
		
                $counter = ($ilance->GPC['page'] - 1) * $ilconfig['globalfilters_maxrowsdisplay'];
                $row_count = 0;
                $result = $ilance->db->query($SQL);
                if ($ilance->db->num_rows($result) > 0)
                {
                        while ($row = $ilance->db->fetch_array($result))
                        {
                                $row['job_title'] = strip_vulgar_words(stripslashes($row['project_title']));
                                $row['buyer'] = fetch_user('username', $row['user_id']);
                                $row['provider'] = stripslashes($row['username']);
                                $row['awarddate'] = print_date($row['date_awarded'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 1, 0);
                                $row['escrowamount'] = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $row['escrowamount']);
                                
                                // does bidder pay shipping?
                                $row['shipcosts'] = 0;
                                $noshippingfees = 1;
                                $ship_handling = fetch_auction('ship_handling', $row['project_id']);
                                switch ($ship_handling)
                                {
                                        case 'flatrate':
                                        {
                                                $noshippingfees = 0;
                                                $row['shipcosts'] = fetch_auction('ship_costs', $row['project_id']);
                                                $row['shipfees'] = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $row['shipcosts']);
                                                break;
                                        }
                                        case 'digital':
                                        {
                                                $row['shipfees'] = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], "0");
                                                break;
                                        }
                                        case 'none':
                                        case 'sellerpays':
                                        {
                                                $row['shipfees'] = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], "0");
                                                break;
                                        }
                                }
                                
                                // merchant viewing escrow information
                                if ($row['status'] == 'pending')
                                {
                                        // pending - waiting for buyer to forward funds
                                        $row['status'] = '<strong>'.$phrase['_do_not_ship_upper'].'</strong>';
                                        $row['actions'] = $phrase['_pending'];
                                }
                                else if ($row['status'] == 'started')
                                {
                                        // started - funds forwarded by buyer into escrow
                                        $row['status'] = $phrase['_funds_secured'];
                                        
                                        // funds secured - show release funds back to customer or confirm delivery
                                        $crypted = array(
                                                'cmd' => 'management',
                                                'sub' => 'product-escrow',
                                                'subcmd' => '_confirm-delivery',
                                                'id' => $row['escrow_id']
                                        );
                                        
                                        $row['actions'] = '<a href="' . $ilpage['selling'] . '?crypted=' . encrypt_url($crypted) . '" onclick="return confirm_js(\'' . $phrase['_confirm_the_product_has_been_shipped_or_delivered_to_the_highest_bidder'] . '\')" title="' . $phrase['_confirm_that_you_have_officially_shipped_or_delivered_any_digital_items_to_the_buyer'] . '"><strong>' . $phrase['_mark_as_shipped'] . '</strong></a><div class="smaller" style="padding-top:4px; padding-bottom:4px"><strong>OR</strong></div>';
                                        
                                        $crypted = array(
                                                'cmd' => 'management',
                                                'sub' => 'product-escrow',
                                                'subcmd' => '_cancel-delivery',
                                                'id' => $row['escrow_id']
                                        );
                                        
                                        $row['actions'] .= '<a href="' . $ilpage['selling'] . '?crypted=' . encrypt_url($crypted) . '" target="_self" onclick="return confirm_js(\'' . $phrase['_return_funds_in_escrow_back_to_highest_bidder'] . '\')" style="color:#990000" title="' . $phrase['_cancel_this_escrow_account_and_return_funds_within_escrow_back_to_buyers_online_account'] . '">' . $phrase['_cancel_order'] . '</a>';
                                }
                                else if ($row['status'] == 'confirmed')
                                {
                                        $row['status'] = $phrase['_pending_release'];
                                        $row['actions'] = '-';
                                }
                                else if ($row['status'] == 'finished')
                                {
                                        $row['status'] = $phrase['_funds_released'];
                                        $row['actions'] = '<a href="' . $ilpage['accounting'] . '?cmd=transactions"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/checkmark.gif" border="0" alt="' . $phrase['_funds_released_to_vendor'] . '"></a>';
                                }
                                
                                $row['taxinfo'] = fetch_escrow_taxinfo_bit($_SESSION['ilancedata']['user']['userid'], fetch_merchant_escrow_fee($row['bidamount']), $row['project_id']);
                                
                                // fee to seller
                                if ($noshippingfees == 0 AND $row['shipcosts'] > 0)
                                {
                                        $row['total'] = ($row['bidamount']+$row['shipcosts']);
                                }
                                else
                                {
                                        $row['total'] = $row['bidamount'];
                                }
                                
                                $row['total'] = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $row['total']);
                                $row['fee'] = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $row['fee']);
                                $row['bidamount'] = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $row['bidamount']);
                                $row['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                                $project_results_rows[] = $row;
                                $row_count++;
                        }
                }
                else
                {
                        $show['no_project_rows_returned'] = true;
                }
                
                $prevnext = print_pagnation($number, $ilconfig['globalfilters_maxrowsdisplay'], intval($ilance->GPC['page']), $counter, $ilpage['selling'].'?cmd=management&amp;sub=product-escrow');

                $ilance->template->load_file('main', 'selling_product_escrow.html', 0, 1);
                $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                $ilance->template->parse_loop('main', 'project_results_rows');
                $ilance->template->parse_if_blocks('main');
                $ilance->template->pprint('main', array('php_self','producttabs','rfpvisible','countdelisted','prevnext','input_style','redirect','referer','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                exit();
        }
        
        // #### ARCHIVING BIDS #################################################
        else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_do-item-action' AND isset($ilance->GPC['itemcmd']) AND isset($ilance->GPC['rfp']))
        {
                // #### define top header nav ##################################
                $topnavlink = array(
                        'mycp'
                );
                
                // #### ARCHIVE PRODUCT AUCTIONS ###############################
                if ($ilance->GPC['itemcmd'] == 'archive')
                {
                        // empty inline cookie
                        set_cookie('inlineproduct', '', false);
                        
                        if (count($ilance->GPC['rfp']) > 0)
                        {
                                $ilance->workspace = construct_object('api.workspace');
                                
                                for ($i = 0; $i < count($ilance->GPC['rfp']); $i++)
                                {
                                        $ilance->db->query("
                                                UPDATE " . DB_PREFIX . "projects
                                                SET status = 'archived'
                                                WHERE project_id = '" . intval($ilance->GPC['rfp'][$i]) . "'
                                                        AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                        AND (status = 'closed' OR status = 'expired' OR status = 'finished')
                                                        AND visible = '1'");
                                        
                                        $sql = $ilance->db->query("
                                                SELECT *
                                                FROM " . DB_PREFIX . "projects
                                                WHERE project_id = '" . intval($ilance->GPC['rfp'][$i]) . "'
                                                        AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                        AND status = 'archived'
                                        ");
                                        if ($ilance->db->num_rows($sql) == 0)
                                        {
                                                $area_title = $phrase['_archive_rfp_error_rfp_in_progress'] . ' (' . $ilance->GPC['rfp'][$i] . ')';
                                                $page_title = SITE_NAME . ' - ' . $phrase['_archive_rfp_error_rfp_in_progress'];
                                                
                                                print_notice($area_title, $phrase['_one_of_the_requested_rfps_you_are_trying_to_archive'], $ilpage['selling'], $phrase['_return_to_the_previous_menu']);
                                        }
                                        
                                        // purge mediashare items for this auction
                                        $ilance->workspace->remove_mediashare_data(intval($ilance->GPC['rfp'][$i]));
                                }
                                
                                $area_title = $phrase['_rfps_archive_display'];
                                $page_title = SITE_NAME . ' - ' . $phrase['_rfps_archive_display'];
                                
                                print_notice($phrase['_requested_rfps_have_been_archived'], $phrase['_you_will_now_be_able_to_review_these_rfps_from_your_archived_rfps_menu'], $ilpage['selling'].'?cmd=management', $phrase['_return_to_the_previous_menu']);
                        }
                        else
                        {
                                $area_title = $phrase['_archive_rfp_error_rfp_in_progress'];
                                $page_title = SITE_NAME . ' - ' . $phrase['_archive_rfp_error_rfp_in_progress'];
                                
                                print_notice($phrase['_invalid_items_selected'], $phrase['_your_requested_rfp_control_action_cannot_be_completed_because_one_or_more_rfps'].'</p><p>'.$phrase['_when_an_rfp_is_in_award_phase_rfp_control_features_such_as_archive'].'</p>', $ilpage['selling'], $phrase['_return_to_the_previous_menu']);
                        }
                }
                
                // #### CANCEL PRODUCT AUCTIONS ########################
                else if ($ilance->GPC['itemcmd'] == 'cancel')
                {
                        // does admin allow auction cancellation?
                        if ($ilconfig['globalfilters_enablerfpcancellation'])
                        {
                                // empty inline cookie
                                set_cookie('inlineproduct', '', false);
                                
                                if (count($ilance->GPC['rfp']) > 0)
                                {
                                        $ilance->workspace = construct_object('api.workspace');
                                        
                                        for ($i = 0; $i < count($ilance->GPC['rfp']); $i++)
                                        { 
                                                $delist_msg = $phrase['_delisted_by'] . ' ' . $_SESSION['ilancedata']['user']['username'] . ' ' . $phrase['_on'] . ' ' . print_date(DATETIME24H, $ilconfig['globalserverlocale_globaltimeformat'], 0, 0);
                                                
                                                $presql = $ilance->db->query("
                                                        SELECT cid
                                                        FROM " . DB_PREFIX . "projects
                                                        WHERE project_id = '" . intval($ilance->GPC['rfp'][$i]) . "'
                                                                AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                AND status = 'open'
                                                                AND visible = '1'
                                                ");
                                                if ($ilance->db->num_rows($presql) > 0)
                                                {
                                                        $auctioninfo = $ilance->db->fetch_array($presql);
                                                        
                                                        build_category_count($auctioninfo['cid'], 'subtract', "seller closing multiple listings from selling activity: subtracting increment count category id $auctioninfo[cid]");
                                                        
                                                        $ilance->db->query("
                                                                UPDATE " . DB_PREFIX . "projects
                                                                SET status = 'delisted',
                                                                additional_info = '" . $ilance->db->escape_string($delist_msg) . "'
                                                                close_date = '" . DATETIME24H . "'
                                                                WHERE project_id = '" . intval($ilance->GPC['rfp'][$i]) . "'
                                                                        AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                        ");
                                                        
                                                        // remove mediashare for this auction
                                                        $ilance->workspace->remove_mediashare_data($ilance->GPC['rfp'][$i]);                                                        
                                                }
                                                else
                                                {
                                                        $area_title = $phrase['_cancel_rfp_error_rfp_in_progress'];
                                                        $page_title = SITE_NAME . ' - ' . $phrase['_cancel_rfp_error_rfp_in_progress'];
                                                        
                                                        print_notice($area_title, $phrase['_your_requested_rfp_control_action_cannot_be_completed_because_one_or_more_rfps'].'</p><p>'.$phrase['_when_an_rfp_is_in_award_phase_rfp_control_features_such_as_archive'].'</p>', $ilpage['selling'], $phrase['_return_to_the_previous_menu']);
                                                }
                                        }
                                        
                                        $area_title = $phrase['_requested_rfps_have_been_cancelled'];
                                        $page_title = SITE_NAME . ' - ' . $phrase['_auctions_have_been_cancelled'];
                                        
                                        print_notice($area_title, $phrase['_you_have_successfully_delisted_cancelled_one_or_more_auctions_from_your_buying_activity_menu_no_more_bids_can_be_placed'].'</p><p>'.$phrase['_you_will_now_be_able_to_review_these_delisted_rfps_from_your'].' <a href="'.$ilpage['buying'].'?cmd=management&amp;sub=delisted">'.$phrase['_delisted_auctions'].'</a> '.$phrase['_menu'].'</p>', $ilpage['selling'], $phrase['_return_to_the_previous_menu']);
                                }
                                else
                                {
                                        $area_title = $phrase['_invalid_items_selected'];
                                        $page_title = SITE_NAME . ' - ' . $phrase['_cancel_rfp_error_rfp_in_progress'];
                                        
                                        print_notice($area_title, $phrase['_your_requested_rfp_control_action_cannot_be_completed_because_one_or_more_rfps'].'</p><p>'.$phrase['_when_an_rfp_is_in_award_phase_rfp_control_features_such_as_archive'].'</p>', $ilpage['selling'], $phrase['_return_to_the_previous_menu']);
                                }
                        }
                        else
                        {
                                $area_title = $phrase['_access_denied_cancel_rfp_feature_currently_disabled'];
                                $page_title = SITE_NAME . ' - ' . $phrase['_access_denied_cancel_rfp_feature_currently_disabled'];
                                
                                print_notice($phrase['_access_to_feature_denied'], $phrase['_were_sorry_this_feature_is_currently_disabled']."<br /><br />".$phrase['_please_contact_customer_support'], $ilpage['main'], $phrase['_main_menu']);
                                exit();
                        }
                }
        }

        // #### PERFORM BID ACTION FROM SERVICE AUCTION BIDDING ACTIVITY #######
        else if (isset($ilance->GPC['cmd']) AND $ilance->GPC['cmd'] == '_do-bid-action' AND isset($ilance->GPC['bidcmd']) AND empty($ilance->GPC['itemcmd']))
        {
                // #### define top header nav ##################################
                $topnavlink = array(
                        'mycp'
                );
                
                // #### ARCHIVING BIDS #########################################
                if ($ilance->GPC['bidcmd'] == 'archive')
                {
                        // empty inline cookie
                        set_cookie('inlineservice', '', false);
                        
                        if (isset($ilance->GPC['bidid']) AND count($ilance->GPC['bidid']) > 0)
                        {
                                $ilance->workspace = construct_object('api.workspace');
                                for ($i=0; $i < count($ilance->GPC['bidid']); $i++)
                                {
                                        $ilance->db->query("
                                                UPDATE " . DB_PREFIX . "project_bids
                                                SET bidstate = 'archived'
                                                WHERE bid_id = '".intval($ilance->GPC['bidid'][$i])."'
                                                        AND user_id = '".intval($_SESSION['ilancedata']['user']['userid'])."'
                                        ");
                                        
                                        // remove mediashare
                                        $ilance->workspace->remove_mediashare_data_bidid(intval($ilance->GPC['bidid'][$i]));
                                }
                                
                                $area_title = $phrase['_requested_bids_have_been_archived'];
                                $page_title = SITE_NAME . ' - ' . $phrase['_requested_bids_have_been_archived'];
                                
                                print_notice($area_title, $phrase['_you_have_successfully_archived_one_or_more_bid_proposals_from_your_service_auction_bidding_activity'], $ilpage['selling'].'?cmd=management', $phrase['_return_to_the_previous_menu']);
                                exit();
                        }
                        else
                        {
                                $area_title = $phrase['_there_was_an_error_archiving_your_bids'];
                                $page_title = SITE_NAME . ' - ' . $phrase['_there_was_an_error_archiving_your_bids'];
                                
                                print_notice($phrase['_invalid_items_selected'], $phrase['_in_order_to_successfully_archive_bids_you_must_first_select_the_checkbox'], $ilpage['selling'].'?cmd=management', $phrase['_return_to_the_previous_menu']);
                                exit();
                        }
                }
                
                // #### RETRACT BIDS ###################################
                else if ($ilance->GPC['bidcmd'] == 'retract')
                {
                        // empty inline cookie
                        set_cookie('inlineservice', '', false);
                        
			$ilance->bid = construct_object('api.bid');                        
                        $ilance->bid_retract = construct_object('api.bid_retract');
                        
                        if (isset($ilance->GPC['bidid']) AND count($ilance->GPC['bidid']) > 0)
                        {
                                for ($i = 0; $i < count($ilance->GPC['bidid']); $i++)
                                {
                                        $sql = $ilance->db->query("
                                                SELECT project_id, bidstatus
                                                FROM " . DB_PREFIX . "project_bids
                                                WHERE bid_id = '" . intval($ilance->GPC['bidid'][$i]) . "'
                                                LIMIT 1
                                        ");
                                        if ($ilance->db->num_rows($sql) > 0)
                                        {
                                                $res = $ilance->db->fetch_array($sql);
                                                if ($res['bidstatus'] == 'awarded')
                                                {
                                                        $res['isawarded'] = true;
                                                }
                                                else
                                                {
                                                        $res['isawarded'] = false;
                                                }
                                                
                                                if (!empty($ilance->GPC['bidretractreason']))
                                                {
                                                        $res['reason'] = ilance_htmlentities($ilance->GPC['bidretractreason']);
                                                }
                                                else
                                                {
                                                        $res['reason'] = $phrase['_no_reason_provided'];
                                                }
                                                
                                                $ilance->bid_retract->construct_bid_retraction($_SESSION['ilancedata']['user']['userid'], intval($ilance->GPC['bidid'][$i]), $res['project_id'], $res['reason'], $res['isawarded']);
                                        }
                                }
                        }
                        else
                        {
                                $area_title = $phrase['_access_denied'];
                                $page_title = SITE_NAME . ' - ' . $phrase['_access_denied'];
                                
                                print_notice($phrase['_access_denied'], $phrase['_you_did_not_select_a_valid_bid_to_retract_please_try_again_from_the_previous_menu'], 'javascript:history.back()', $phrase['_retry']);
                                exit();
                        }
                }
        }
        
        // #### SELLING ACTIVITY MENU ##########################################
        else
        {
                // #### define top header nav ##################################
                $topnavlink = array(
                        'mycp',
                        'selling'
                );
                
                $show['widescreen'] = true;
                
                $area_title = $phrase['_selling_activity_menu'];
                $page_title = SITE_NAME . ' - ' . $phrase['_selling_activity_menu'];
                    
                $navcrumb = array();
                $navcrumb["$ilpage[main]?cmd=cp"] = $phrase['_my_cp'];
                $navcrumb[""] = $phrase['_selling_activity'];
                
		$ilance->auction = construct_object('api.auction');
                $ilance->auction_tabs = construct_object('api.auction_tabs');
                $ilance->bid = construct_object('api.bid');
                $ilance->bid_tabs = construct_object('api.bid_tabs');
                $ilance->bid_lowest_unique = construct_object('api.bid_lowest_unique');
                $ilance->feedback = construct_object('api.feedback');
		
                if (isset($uncrypted['cmd']) AND $uncrypted['cmd'] == 'management' AND isset($uncrypted['subcmd']) AND $uncrypted['subcmd'] == 'markasshipped' AND isset($uncrypted['id']) AND $uncrypted['id'] > 0)
                {
                        mark_listing_as_shipped($uncrypted['id']);
                        
                        refresh($ilpage['selling'] . '?cmd=management&sub=' . $ilance->GPC['sub']);
                        exit();
                }
                else if (isset($uncrypted['cmd']) AND $uncrypted['cmd'] == 'management' AND isset($uncrypted['subcmd']) AND $uncrypted['subcmd'] == 'markasunshipped' AND isset($uncrypted['id']) AND $uncrypted['id'] > 0)
                {
                        mark_listing_as_unshipped($uncrypted['id']);
                        
                        refresh($ilpage['selling'] . '?cmd=management&sub=' . $ilance->GPC['sub']);
                        exit();
                }
                
                
                $number = $number2 = $number3 = $number4 = $counter = $counter2 = $counter3 = $counter4 = 0;
                
                if (!isset($ilance->GPC['page']) OR isset($ilance->GPC['page']) AND $ilance->GPC['page'] <= 0)
                {
                        $ilance->GPC['page']  = 1;
                }
                else
                {
                        $ilance->GPC['page']  = intval($ilance->GPC['page']);
                }
                
                if (!isset($ilance->GPC['page2']) OR isset($ilance->GPC['page2']) AND $ilance->GPC['page2'] <= 0)
                {
                        $ilance->GPC['page2'] = 1;
                }
                else
                {
                        $ilance->GPC['page2'] = intval($ilance->GPC['page2']);
                }
                
                if (!isset($ilance->GPC['page3']) OR isset($ilance->GPC['page3']) AND $ilance->GPC['page3'] <= 0)
                {
                        $ilance->GPC['page3'] = 1;
                }
                else
                {
                        $ilance->GPC['page3'] = intval($ilance->GPC['page3']);
                }
                
                if (!isset($ilance->GPC['page4']) OR isset($ilance->GPC['page4']) AND $ilance->GPC['page4'] <= 0)
                {
                        $ilance->GPC['page4'] = 1;
                }
                else
                {
                        $ilance->GPC['page4'] = intval($ilance->GPC['page4']);
                }
                
                $counter3 = ($ilance->GPC['page3'] - 1) * $ilconfig['globalfilters_maxrowsdisplay'];
                $counter4 = ($ilance->GPC['page4'] - 1) * $ilconfig['globalfilters_maxrowsdisplay'];
                
                $orderby = 'ORDER BY b.bid_id DESC';
                $orderby2 = 'ORDER BY p.project_id DESC';
                
                // #### LISTING PERIOD PRODUCT AUCTION RESULTS #################
                require_once(DIR_CORE . 'functions_search.php');
                require_once(DIR_CORE . 'functions_tabs.php');
                
                $ilance->GPC['period'] = (isset($ilance->GPC['period']) ? intval($ilance->GPC['period']) : -1);
                $periodsql = fetch_startend_sql($ilance->GPC['period'], 'DATE_SUB', 'date_added', '>=');
                $extra = '&amp;period=' . intval($ilance->GPC['period']);
                
                // #### RESULTS DISPLAY ORDER DEFAULTS #########################
                $displayorderfields = array('asc', 'desc');
                $displayorder = '&amp;displayorder=asc';
                $currentdisplayorder = $displayorder;
                $displayordersql = 'DESC';
                
                if (isset($ilance->GPC['displayorder']) AND $ilance->GPC['displayorder'] == 'asc')
                {
                        $displayorder = '&amp;displayorder=desc';
                        $currentdisplayorder = '&amp;displayorder=asc';
                }
                else if (isset($ilance->GPC['displayorder']) AND $ilance->GPC['displayorder'] == 'desc')
                {
                        $displayorder = '&amp;displayorder=asc';
                        $currentdisplayorder = '&amp;displayorder=desc';
                }
                if (isset($ilance->GPC['displayorder']) AND in_array($ilance->GPC['displayorder'], $displayorderfields))
                {
                        $displayordersql = mb_strtoupper($ilance->GPC['displayorder']);
                }
                if (!empty($ilance->GPC['sub']))
                {
                        $extra .= '&amp;sub=' . $ilance->GPC['sub'];
                }
                
                // #### RESULTS ORDERING BY COLUMN NAME DEFAULTS ###############
                $orderbyfields = array('project_title', 'date_added', 'date_end', 'bids', 'insertionfee');
                $orderby = '&amp;orderby=bids';
                $orderbysql = 'date_added';
                if (isset($ilance->GPC['orderby']) AND in_array($ilance->GPC['orderby'], $orderbyfields))
                {
                        $orderby = '&amp;orderby=' . $ilance->GPC['orderby'];
                        $orderbysql = $ilance->GPC['orderby'];
                }
                
                $limit = 'ORDER BY ' . $orderbysql . ' ' . $displayordersql . ' LIMIT ' . (($ilance->GPC['page'] - 1) * $ilconfig['globalfilters_maxrowsdisplay']) . ',' . $ilconfig['globalfilters_maxrowsdisplay'];
                $limit2 = 'LIMIT ' . (($ilance->GPC['page2'] - 1) * $ilconfig['globalfilters_maxrowsdisplay']) . ',' . $ilconfig['globalfilters_maxrowsdisplay'];
                $limit3 = 'ORDER BY b.bidamount DESC LIMIT ' . (($ilance->GPC['page3'] - 1) * $ilconfig['globalfilters_maxrowsdisplay']) . ',' . $ilconfig['globalfilters_maxrowsdisplay'];
                $limit4 = 'ORDER BY b.status DESC LIMIT ' . (($ilance->GPC['page4'] - 1) * $ilconfig['globalfilters_maxrowsdisplay']) . ',' . $ilconfig['globalfilters_maxrowsdisplay'];
                
                // used within templates
                $php_self = $ilpage['selling'] . '?cmd=management' . $displayorder . $extra;
                
                // used within prev / next page nav
                $scriptpage = $ilpage['selling'] . '?cmd=management' . $currentdisplayorder . $orderby . $extra;
                
                // does admin enable product auction support?
                if ($ilconfig['globalauctionsettings_productauctionsenabled'])
                {
                        // #### DRAFT AUCTION RESULTS ##########################
                        $ilance->GPC['sub'] = isset($ilance->GPC['sub']) ? $ilance->GPC['sub'] : '';
                        if (isset($ilance->GPC['sub']) AND $ilance->GPC['sub'] == 'drafts')
                        {
                                $sub_drafts = 1;
                                
                                $SQL = $ilance->auction_tabs->product_auction_tab_sql('drafts', 'string', $_SESSION['ilancedata']['user']['userid'], $periodsql) . " " . $limit;
                                $SQL2 = $ilance->auction_tabs->product_auction_tab_sql('drafts', 'string', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                                
                                $producttabs = print_selling_activity_tabs('drafts', 'product', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                        }
                        
                        // #### DELISTED AUCTION RESULTS #######################
                        else if (isset($ilance->GPC['sub']) AND $ilance->GPC['sub'] == 'delisted')
                        {
                                // construct breadcrumb trail
                                $navcrumb = array();
                                $navcrumb["$ilpage[main]?cmd=cp"] = $phrase['_my_cp'];
                                $navcrumb["$ilpage[selling]?cmd=management"] = $phrase['_selling_activity'];
                                $navcrumb[""] = $phrase['_delisted_items'];
                    
                                $sub_delisted = 1;
                                
                                $SQL = $ilance->auction_tabs->product_auction_tab_sql('delisted', 'string', $_SESSION['ilancedata']['user']['userid'], $periodsql) . " " . $limit;
                                $SQL2 = $ilance->auction_tabs->product_auction_tab_sql('delisted', 'string', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                                
                                $producttabs = print_selling_activity_tabs('delisted', 'product', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                        }
                        
                        // #### ARCHIVED AUCTION RESULTS #######################
                        else if (isset($ilance->GPC['sub']) AND $ilance->GPC['sub'] == 'archived')
                        {
                                // construct breadcrumb trail
                                $navcrumb = array();
                                $navcrumb["$ilpage[main]?cmd=cp"] = $phrase['_my_cp'];
                                $navcrumb["$ilpage[selling]?cmd=management"] = $phrase['_selling_activity'];
                                $navcrumb[""] = $phrase['_archived_items'];
                    
                                $sub_archived = 1;
				
                                $SQL = $ilance->auction_tabs->product_auction_tab_sql('archived', 'string', $_SESSION['ilancedata']['user']['userid'], $periodsql) . " " . $limit;
                                $SQL2 = $ilance->auction_tabs->product_auction_tab_sql('archived', 'string', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                                
                                $producttabs = print_selling_activity_tabs('archived', 'product', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                        }
                        
                        // #### EXPIRED AUCTION RESULTS ########################
                        else if (isset($ilance->GPC['sub']) AND $ilance->GPC['sub'] == 'expired')
                        {
                                // construct breadcrumb trail
                                $navcrumb = array();
                                $navcrumb["$ilpage[main]?cmd=cp"] = $phrase['_my_cp'];
                                $navcrumb["$ilpage[selling]?cmd=management"] = $phrase['_selling_activity'];
                                $navcrumb[""] = $phrase['_expired_items'];
				
                                $sub_expired = 1;
                                
                                $SQL = $ilance->auction_tabs->product_auction_tab_sql('expired', 'string', $_SESSION['ilancedata']['user']['userid'], $periodsql) . " " . $limit;
                                $SQL2 = $ilance->auction_tabs->product_auction_tab_sql('expired', 'string', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                                
                                $producttabs = print_selling_activity_tabs('expired', 'product', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                        }
                        
                        // #### PENDING AUCTION RESULTS ########################
                        else if (isset($ilance->GPC['sub']) AND $ilance->GPC['sub'] == 'pending')
                        {
                                $navcrumb = array();
                                $navcrumb["$ilpage[main]?cmd=cp"] = $phrase['_my_cp'];
                                $navcrumb["$ilpage[selling]?cmd=management"] = $phrase['_selling_activity'];
                                $navcrumb[""] = $phrase['_pending_items'];
                    
                                $sub_pending = 1;
                                
                                $SQL = $ilance->auction_tabs->product_auction_tab_sql('pending', 'string', $_SESSION['ilancedata']['user']['userid'], $periodsql) . " " . $limit;
                                $SQL2 = $ilance->auction_tabs->product_auction_tab_sql('pending', 'string', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                                
                                $producttabs = print_selling_activity_tabs('pending', 'product', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                        }
                        
                        // #### ITEMS I'VE SOLD ################################
                        else if (isset($ilance->GPC['sub']) AND $ilance->GPC['sub'] == 'sold')
                        {
                                $navcrumb = array();
                                $navcrumb["$ilpage[main]?cmd=cp"] = $phrase['_my_cp'];
                                $navcrumb["$ilpage[selling]?cmd=management"] = $phrase['_selling_activity'];
                                $navcrumb[""] = $phrase['_items_ive_sold'];
                    
                                $sub_sold = 1;
                                
                                $SQL = $ilance->auction_tabs->product_auction_tab_sql('sold', 'string', $_SESSION['ilancedata']['user']['userid'], $periodsql) . " " . $limit;
                                $SQL2 = $ilance->auction_tabs->product_auction_tab_sql('sold', 'string', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                                
                                $producttabs = print_selling_activity_tabs('sold', 'product', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                        }
                        
                        // #### ACTIVE AUCTION RESULTS #########################
                        else
                        {
                                $sub_active = 1;
                                
                                $SQL = $ilance->auction_tabs->product_auction_tab_sql('active', 'string', $_SESSION['ilancedata']['user']['userid'], $periodsql) . " " . $limit;
                                $SQL2 = $ilance->auction_tabs->product_auction_tab_sql('active', 'string', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                                
                                $producttabs = print_selling_activity_tabs('active', 'product', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                        }

                        $counter = ($ilance->GPC['page'] - 1) * $ilconfig['globalfilters_maxrowsdisplay'];
                        $row_count = 0;
                        
                        $numberrows = $ilance->db->query($SQL2);
                        $number = $ilance->db->num_rows($numberrows);
                        
                        $result = $ilance->db->query($SQL);
                        if ($ilance->db->num_rows($result) > 0)
                        {
                                while ($row = $ilance->db->fetch_array($result))
                                {
                                        // auction bit describing auction selling format..
                                        $row['auctionbit'] = '<span class="gray">' . print_auction_bit($row['project_id'], $row['filtered_auctiontype'], $row['project_details'], $row['project_state'], $row['buynow_price'], $row['buynow_qty'], $row['reserve'], $row['cid']) . '</span>';
                                        
                                        // reserve price
                                        if ($row['reserve'])
                                        {
                                                $row['reserveprice'] = $ilance->currency->format($row['reserve_price']);
                                        }
                                        else
                                        {
                                                $row['reserveprice'] = '-';
                                        }
                                        
                                        if ($row['bids'] == 0)
                                        {
                                                $row['bids'] = '-';
                                        }
    
                                        // highest bid
                                        $sel_highbid = $ilance->db->query("
                                                SELECT bidamount
                                                FROM " . DB_PREFIX . "project_bids
                                                WHERE project_id = '" . $row['project_id'] . "'
                                                        AND bidstatus != 'declined'
                                                ORDER BY bidamount ASC
                                                LIMIT 3
                                        ");
                                        if ($ilance->db->num_rows($sel_highbid) > 0)
                                        {
                                                while ($res_highbid = $ilance->db->fetch_array($sel_highbid))
                                                {
                                                        $row['highest_bid'] = '<a href="' . $ilpage['merch'] . '?id=' . $row['project_id'] . '#bids">'.$ilance->currency->format($res_highbid['bidamount']).'</a>';
                                                }
                                        }
                                        else
                                        {
                                                $row['highest_bid'] = '-';
                                        }
                                        $row['actions'] = '<input type="checkbox" name="rfp[]" value="' . $row['project_id'] . '" id="' . $row['project_state'] . '_' . $row['project_id'] . '" />';
    
                                        // archived, delisted and drafts tabs do not have action control
                                        if (isset($sub_archived) AND $sub_archived OR isset($sub_delisted) AND $sub_delisted OR isset($sub_drafts) AND $sub_drafts)
                                        {
                                                $row['actions'] = '<input type="checkbox" name="rfp[]" value="' . $row['project_id'] . '" id="' . $row['project_state'] . '_' . $row['project_id'] . '" disabled="disabled" />';
                                        }
    
                                        // live bid applet
                                        $row['livebid'] = '
<div id="applet' . $row['project_id'] . '"></div>
<script type="text/javascript">
var fo = new FlashObject("' . DIR_LIVEBID_NAME . '/livebid.swf", "applet' . $row['project_id'] . '", "730", "530", "8,0,0,0", "#ffffff");
fo.addParam("quality", "high");
fo.addParam("allowScriptAccess", "sameDomain");
fo.addParam("flashvars", "languageConfig=' . DIR_FUNCT_NAME . '/' . DIR_XML_NAME . '/livebid_' . $_SESSION['ilancedata']['user']['slng'] . '.xml&prId=' . $row['project_id'] . '&sId=' . session_id() . '&rand=' . rand(100000, 999999) . '");
fo.addParam("menu", "false");
fo.write("applet' . $row['project_id'] . '");
</script>';
                                        
                                        $row['provider'] = fetch_user('username', $row['user_id']);
                                        $row['icons'] = $ilance->auction->auction_icons($row['project_id'], $row['user_id']);
                                        $row['item_title'] = stripslashes($row['project_title']);
                                        
                                        if ($row['haswinner'] == '1')
                                        {
                                                $row['timeleft'] = '<span class="gray">' . $phrase['_ended'] . '</span>';
                                        }
                                        else
                                        {
                                                $row['timeleft'] = $ilance->auction->calculate_time_left($row['date_starts'], $row['starttime'], $row['mytime']);
                                        }
                                        $row['sales'] = fetch_buynow_ordercount($row['project_id']);
                                        if ($row['sales'] == 0)
                                        {
                                                $row['sales'] = '-';
                                        }
                                        
                                        if ($row['insertionfee'] > 0)
                                        {
                                                $row['insfee'] = $ilance->currency->format($row['insertionfee']);
                                                if ($row['isifpaid'])
                                                {
                                                        $row['insfee'] .= '<div class="smaller gray">[ <span class="blue"><a href="' . $ilpage['invoicepayment'] . '?cmd=view&amp;id=' . $row['ifinvoiceid'] . '">' . $phrase['_paid'] . '</a></span> ]</div>';        
                                                }
                                                else
                                                {
                                                        $row['insfee'] .= '<div class="smaller gray">[ <a href="' . $ilpage['invoicepayment'] . '?cmd=view&amp;id=' . $row['ifinvoiceid'] . '">' . $phrase['_unpaid'] . '</a> ]</div>';             
                                                }
                                        }
                                        else
                                        {
                                                $row['insfee'] = '-';
                                        }
                                                                                                                        
                                        // fvf status?
                                        if ($row['fvf'] > 0)
                                        {
                                                // final value bit
                                                $row['fvf'] = $ilance->currency->format($row['fvf']);
                                                if ($row['isfvfpaid'])
                                                {
                                                        $row['fvf'] .= '<div class="smaller gray">[ ' . $phrase['_paid'] . ' ]</div>';
                                                }
                                                else
                                                {
                                                        $row['fvf'] .= '<div class="smaller gray">[ <a href="' . $ilpage['invoicepayment'] . '?cmd=view&amp;id=' . $row['fvfinvoiceid'] . '">' . $phrase['_unpaid'] . '</a> ]</div>';
                                                }
                                        }
                                        else
                                        {
                                                // final value bit
                                                $row['fvf'] = '-';
                                        }
                                        
                                        // number of bids
                                        if ($row['project_details'] == 'unique')
                                        {
                                                $row['bids'] = $ilance->bid_lowest_unique->fetch_bid_count($row['project_id']);
                                                if ($row['bids'] == 0)
                                                {
                                                        $row['bids'] = '-';
                                                }
                                                $row['sales'] = $row['fvf'] = $row['insfee'] = '-';
                                        }
                                        
                                        $highbidamount = '0.00';
                                        $highbidder = $highbidderid = '';
                                        
                                        $sql_highest_bidder = $ilance->db->query("
                                                SELECT user_id
                                                FROM " . DB_PREFIX . "project_bids
                                                WHERE project_id = '" . $row['project_id'] . "'
                                                ORDER BY bidamount DESC
                                        ");
                                        if ($ilance->db->num_rows($sql_highest_bidder) > 0)
                                        {
                                                $res_highest_bidder = $ilance->db->fetch_array($sql_highest_bidder);
                                                
                                                // fetch highest bidders name
                                                $sel_bids_av = $ilance->db->query("
                                                        SELECT AVG(bidamount) AS average, MIN(bidamount) AS lowest, MAX(bidamount) AS highest
                                                        FROM " . DB_PREFIX . "project_bids
                                                        WHERE project_id = '" . $row['project_id'] . "'
                                                                AND bidstate != 'retracted'
                                                                AND bidstatus != 'declined'
                                                        ORDER BY highest
                                                        LIMIT 1
                                                ");
                                                if ($ilance->db->num_rows($sel_bids_av) > 0)
                                                {
                                                        $res_bids_av = $ilance->db->fetch_array($sel_bids_av);
                                                        
                                                        $row['highbidderid'] = $res_highest_bidder['user_id'];
                                                        $row['highbidder'] = print_username($row['highbidderid'], 'href', 1, '', '');
                                                        $highbidderid = $row['highbidderid'];
                                                        $highbidamount = $res_bids_av['highest'];
                                                }
                                        }
    
                                        // can we communicate? invoice? give or request feedback?
                                        $expiredauction = ($row['status'] == 'expired' ? 1 : 0);
                                        if ($highbidderid > 0 AND $row['status'] == 'expired')
                                        {
                                                // does this auction have a reserve price?
                                                if ($row['reserve'])
                                                {
                                                        // did the highest bidder bid over the reserve amount?
                                                        if ($row['reserve_price'] <= $highbidamount)
                                                        {
                                                                if ($expiredauction AND $row['haswinner'])
                                                                {
                                                                        //$row['timeleft'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid_awarded.gif" border="0" alt="" /></div>';
                                                                        $row['timeleft'] = '<span class="gray">' . $phrase['_ended'] . '</span>';
                                                                }
                                                                
                                                                $row['pmb'] = $ilance->auction->construct_pmb_icon($_SESSION['ilancedata']['user']['userid'], $highbidderid, $row['project_id']);
    
                                                                // enable escrow invoice icon to display
                                                                $row['invoice'] = '<a href="' . $ilpage['selling'] . '?cmd=management&amp;sub=product-escrow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/invoice.gif" border="0" alt=""></a>';
    
                                                                // is escrow system enabled?
                                                                if ($ilconfig['escrowsystem_enabled'])
                                                                {
                                                                        if ($row['filter_escrow'])
                                                                        {
                                                                                // if escrow account is paid and funds have been released
                                                                                $sql_escrowcheck = $ilance->db->query("
                                                                                        SELECT *
                                                                                        FROM " . DB_PREFIX . "projects_escrow
                                                                                        WHERE project_id = '" . $row['project_id'] . "'
                                                                                                AND user_id = '" . intval($highbidderid) . "'
                                                                                                AND project_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                                                AND date_paid != '0000-00-00 00:00:00'
                                                                                                AND status = 'finished'
                                                                                ");
                                                                                if ($ilance->db->num_rows($sql_escrowcheck) > 0)
                                                                                {
                                                                                        $provider_rated_buyer = $buyer_rated_provider = 0;
                                                                                        
                                                                                        // does this merchant need to give feedback to bidder?
                                                                                        if ($ilance->feedback->has_left_feedback($for_user_id = $highbidderid, $from_user_id = $_SESSION['ilancedata']['user']['userid'], $project_id = $row['project_id'], $type = 'buyer'))
                                                                                        {
                                                                                                // it appears the merchant already rated buyer and provided feedback!
                                                                                                $provider_rated_buyer = 1;
                                                                                                $row['feedback'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/checkmark.gif" border="0" alt="' . $phrase['_feedback_submitted__thank_you'] . '" /></div>';
                                                                                        }
                                                                                        else
                                                                                        {
                                                                                                // seller did not give feedback to buyer
                                                                                                $crypted = array(
                                                                                                        'cmd' => '_leave-feedback',
                                                                                                        'type' => 'buyer',
                                                                                                        'project_id' => $row['project_id'],
                                                                                                        'for_user_id' => intval($highbidderid),
                                                                                                        'from_user_id' => $_SESSION['ilancedata']['user']['userid']
                                                                                                );
                                                                                                
                                                                                                $row['feedback'] = '<span class="gray">' . $phrase['_next'] . ':</span> <span class="blue"><a href="' . $ilpage['feedback'] . '?crypted=' . encrypt_url($crypted) . '"><strong>' . $phrase['_submit_feedback_for'] . ' ' . fetch_user('username', $highbidderid) . '</strong></a></span>';
                                                                                        }
            
                                                                                        // does buyer need to give feedback to seller?
                                                                                        if ($ilance->feedback->has_left_feedback($for_user_id = $highbidderid, $from_user_id = $_SESSION['ilancedata']['user']['userid'], $project_id = $row['project_id'], $type = 'buyer'))
                                                                                        {
                                                                                                // it appears the buyer already left feedback and rating to seller
                                                                                                $buyer_rated_provider = 1;
                                                                                        }
                                                                                        else
                                                                                        {
                                                                                                // buyer needs to leave feedback                                                                                                
                                                                                                $row['timeleft'] = '<span class="gray">' . $phrase['_pending_feedback'] . '</span>';
                                                                                        }
            
                                                                                        // has both parties leave feedback for each other?
                                                                                        if ($provider_rated_buyer AND $buyer_rated_provider)
                                                                                        {
                                                                                                $row['timeleft'] = $phrase['_ended'];
            
                                                                                                // does admin allow mediashare after auction is finished?
                                                                                                if ($ilconfig['productaward_mediashareafterend'] == 0)
                                                                                                {
                                                                                                        $row['work'] = $ilance->auction->construct_mediashare_icon($row2['user_id'], $_SESSION['ilancedata']['user']['userid'], $row2['project_id'], 0);
                                                                                                }
            
                                                                                                // does admin allow PMB conversation after auction is finished?
                                                                                                if ($ilconfig['productaward_pmbafterend'] == 0)
                                                                                                {
                                                                                                        $row['pmb'] = '-';
                                                                                                }
                                                                                        }
                                                                                }
                                                                                else
                                                                                {
                                                                                        // disable feedback icon (we're not ready to leave feedback yet)
                                                                                        $row['feedback'] = '-';
                                                                                }        
                                                                        }
                                                                        else
                                                                        {
                                                                                $provider_rated_buyer = 0;
                                                                                
                                                                                // does this seller need to give feedback to buyer?
                                                                                if ($ilance->feedback->has_left_feedback($for_user_id = $highbidderid, $from_user_id = $_SESSION['ilancedata']['user']['userid'], $project_id = $row['project_id'], $type = 'buyer'))
                                                                                {
                                                                                        // it appears the seller already rated buyer and provided feedback!
                                                                                        $provider_rated_buyer = 1;
                                                                                        $row['feedback'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/checkmark.gif" border="0" alt="' . $phrase['_feedback_submitted__thank_you'] . '" /></div>';
                                                                                }
                                                                                else
                                                                                {
                                                                                        // this seller did not rate his buyer as of yet..
                                                                                        $crypted = array(
                                                                                                'cmd' => '_leave-feedback',
                                                                                                'type' => 'buyer',
                                                                                                'project_id' => $row['project_id'],
                                                                                                'for_user_id' => intval($highbidderid),
                                                                                                'from_user_id' => $_SESSION['ilancedata']['user']['userid']
                                                                                        );
                                                                                        
                                                                                        $row['feedback'] = '<span class="smaller blue"><a href="' . $ilpage['feedback'] . '?crypted=' . encrypt_url($crypted) . '"><strong>' . $phrase['_submit_feedback_for'] . ' ' . fetch_user('username', $highbidderid) . '</strong></a></span>';
                                                                                }        
                                                                        }
                                                                }
                                                                else
                                                                {
                                                                        $provider_rated_buyer = $buyer_rated_provider = 0;
                                                                        
                                                                        // no escrow system enabled
                                        
                                                                        // does this seller need to give feedback to buyer?
                                                                        if ($ilance->feedback->has_left_feedback($highbidderid, $_SESSION['ilancedata']['user']['userid'], $row['project_id'], 'buyer'))
                                                                        {
                                                                                // it appears the seller already rated buyer and provided feedback!
                                                                                $provider_rated_buyer = 1;
                                                                                $row['feedback'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/checkmark.gif" border="0" alt="' . $phrase['_feedback_submitted__thank_you'] . '" /></div>';
                                                                        }
                                                                        else
                                                                        {
                                                                                // this seller did not rate his buyer as of yet..
                                                                                $crypted = array(
                                                                                        'cmd' => '_leave-feedback',
                                                                                        'type' => 'buyer',
                                                                                        'project_id' => $row['project_id'],
                                                                                        'for_user_id' => intval($highbidderid),
                                                                                        'from_user_id' => $_SESSION['ilancedata']['user']['userid']
                                                                                );
                                                                                
                                                                                $row['feedback'] = '<span class="gray">' . $phrase['_next'] . ':</span> <span class="blue"><a href="' . $ilpage['feedback'] . '?crypted=' . encrypt_url($crypted) . '"><strong>' . $phrase['_submit_feedback_for'] . ' ' . fetch_user('username', $highbidderid) . '</strong></a></span>';
                                                                        }
    
                                                                        // does buyer need to give feedback to seller?
                                                                        if ($ilance->feedback->has_left_feedback($for_user_id = $_SESSION['ilancedata']['user']['userid'], $from_user_id = $highbidderid, $project_id = $row['project_id'], $type = 'seller'))
                                                                        {
                                                                                // it appears the buyer already left feedback and rating to merchant!
                                                                                $buyer_rated_provider = 1;
                                                                        }
                                                                        else
                                                                        {
                                                                                // buyer needs to leave feedback
                                                                                $row['timeleft'] = $phrase['_pending_feedback'];
                                                                        }
                                                                        
    
                                                                        // has both parties leave feedback for each other?
                                                                        if ($provider_rated_buyer AND $buyer_rated_provider)
                                                                        {
                                                                                $row['timeleft'] = $phrase['_ended'];
    
                                                                                // does admin allow mediashare after auction is finished?
                                                                                if ($ilconfig['productaward_mediashareafterend'] == 0)
                                                                                {
                                                                                        $row['work'] = $ilance->auction->construct_mediashare_icon($row2['user_id'], $_SESSION['ilancedata']['user']['userid'], $row2['project_id'], $active = false);
                                                                                }
    
                                                                                // does admin allow PMB conversation after auction is finished?
                                                                                if ($ilconfig['productaward_pmbafterend'] == 0)
                                                                                {
                                                                                        $row['pmb'] = '-';
                                                                                }
                                                                        }
                                                                }
                                                                
                                                                $row['work'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $highbidderid, $row['project_id'], $active = true);
                                                        }
                                                        else
                                                        {
                                                                // high bidder does exist, auction has expired, reserve price not met! (no winner)
                                                                if ($expiredauction)
                                                                {
                                                                        $row['timeleft'] = '<span class="gray">' . $phrase['_ended'] . '</span>';
                                                                        $row['pmb'] = $row['invoice'] = $row['feedback'] = '-';
                                                                        $row['work'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $highbidderid, $row['project_id'], $active = false);
                                                                }
                                                        }
                                                }
                                                else
                                                {
                                                        // reserve price was met, lets continue!
                                                        if (isset($expiredauction) AND $expiredauction AND $row['haswinner'])
                                                        {
                                                                //$row['timeleft'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid_awarded.gif" border="0" alt="' . $phrase['_awarded_to_high_bidder'] . '" /></div>';
                                                                $row['timeleft'] = '<span class="gray">' . $phrase['_ended'] . '</span>';
                                                        }
    
                                                        // allow PMB with highest bidder
                                                        $row['pmb'] = $ilance->auction->construct_pmb_icon($_SESSION['ilancedata']['user']['userid'], $highbidderid, $row['project_id']);
                                                        $row['invoice'] = '<a href="' . $ilpage['selling'] . '?cmd=management&amp;sub=product-escrow"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/invoice.gif" border="0" alt="" /></a>';
                                                        
                                                        if ($ilconfig['escrowsystem_enabled'] AND $row['filter_escrow'])
                                                        {
                                                                // has escrow account been paid and have funds been released?
                                                                $sql_escrowcheck = $ilance->db->query("
                                                                        SELECT *
                                                                        FROM " . DB_PREFIX . "projects_escrow
                                                                        WHERE project_id = '" . $row['project_id'] . "'
                                                                                AND user_id = '" . intval($highbidderid) . "'
                                                                                AND project_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                                AND date_paid != '0000-00-00 00:00:00'
                                                                                AND status = 'finished'
                                                                ");
                                                                if ($ilance->db->num_rows($sql_escrowcheck) > 0)
                                                                {
                                                                        $provider_rated_buyer = $buyer_rated_provider = 0;
                                                                        
                                                                        // does seller need to give feedback to buyer?
                                                                        if ($ilance->feedback->has_left_feedback($highbidderid, $_SESSION['ilancedata']['user']['userid'], $row['project_id'], 'buyer'))
                                                                        {
                                                                                $provider_rated_buyer = 1;
                                                                                $row['feedback'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/checkmark.gif" border="0" alt="' . $phrase['_feedback_submitted__thank_you'] . '" /></div>';
                                                                        }
                                                                        else
                                                                        {
                                                                                // the awarded provider did not rate his buyer
                                                                                $crypted = array(
                                                                                        'cmd' => '_leave-feedback',
                                                                                        'type' => 'buyer',
                                                                                        'project_id' => $row['project_id'],
                                                                                        'for_user_id' => intval($highbidderid),
                                                                                        'from_user_id' => $_SESSION['ilancedata']['user']['userid']
                                                                                );
                                                                                
                                                                                $row['feedback'] = '<span class="gray">' . $phrase['_next'] . ':</span> <span class="blue"><a href="' . $ilpage['feedback'] . '?crypted=' . encrypt_url($crypted) . '"><strong>' . $phrase['_submit_feedback_for'] . ' ' . fetch_user('username', $highbidderid) . '</strong></a></span>';
                                                                        }
    
                                                                        // does buyer need to give feedback to seller?
                                                                        if ($ilance->feedback->has_left_feedback($for_user_id = $_SESSION['ilancedata']['user']['userid'], $from_user_id = $highbidderid, $project_id = $row['project_id'], $type = 'seller'))
                                                                        {
                                                                                $buyer_rated_provider = 1;
                                                                        }
                                                                        else
                                                                        {
                                                                                $row['timeleft'] = $phrase['_pending_feedback'];
                                                                        }
    
                                                                        // auction finished> both parties left feedback rating
                                                                        if ($provider_rated_buyer AND $buyer_rated_provider)
                                                                        {
                                                                                $row['timeleft'] = $phrase['_ended'];
                                                                                
                                                                                if ($ilconfig['productaward_mediashareafterend'] == 0)
                                                                                {
                                                                                        $row['work'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $highbidderid, $row['project_id'], $active = false);
                                                                                }
                                                                                if ($ilconfig['productaward_pmbafterend'] == 0)
                                                                                {
                                                                                        $row['pmb'] = '-';
                                                                                }
                                                                        }
                                                                }
                                                                else
                                                                {
                                                                        $row['feedback'] = '-';
                                                                }
                                                        }
                                                        else
                                                        {
                                                                $provider_rated_buyer = $buyer_rated_provider = 0;
                                                                // escrow system disabled
                                                                
                                                                // does seller need to give feedback to buyer?
                                                                if ($ilance->feedback->has_left_feedback($for_user_id = $highbidderid, $from_user_id = $_SESSION['ilancedata']['user']['userid'], $project_id = $row['project_id'], $type = 'buyer'))
                                                                {
                                                                        $provider_rated_buyer = 1;
                                                                        $row['feedback'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/checkmark.gif" border="0" alt="' . $phrase['_feedback_submitted__thank_you'] . '" /></div>';
                                                                }
                                                                else
                                                                {
                                                                        // the awarded provider did not rate his buyer
                                                                        $crypted = array(
                                                                                'cmd' => '_leave-feedback',
                                                                                'type' => 'buyer',
                                                                                'project_id' => $row['project_id'],
                                                                                'for_user_id' => intval($highbidderid),
                                                                                'from_user_id' => $_SESSION['ilancedata']['user']['userid']
                                                                        );
                                                                        
                                                                        $row['feedback'] = '<span class="gray">' . $phrase['_next'] . ':</span> <span class="blue"><a href="' . $ilpage['feedback'] . '?crypted=' . encrypt_url($crypted) . '"><strong>' . $phrase['_submit_feedback_for'] . ' ' . fetch_user('username', $highbidderid) . '</strong></a></span>';
                                                                }
    
                                                                // does buyer need to give feedback to seller?
                                                                if ($ilance->feedback->has_left_feedback($for_user_id = $_SESSION['ilancedata']['user']['userid'], $from_user_id = $highbidderid, $project_id = $row['project_id'], $type = 'seller'))
                                                                {
                                                                        $buyer_rated_provider = 1;
                                                                }
                                                                else
                                                                {
                                                                        $row['timeleft'] = '<span class="smaller gray">' . $phrase['_pending_feedback_from'] . ' ' . fetch_user('username', $highbidderid) . '</span>';
                                                                }
    
                                                                // auction finished > both parties left feedback rating
                                                                if ($provider_rated_buyer AND $buyer_rated_provider)
                                                                {
                                                                        $row['timeleft'] = '<span class="gray">' . $phrase['_ended'] . '</span>';
                                                                        
                                                                        if ($ilconfig['productaward_mediashareafterend'] == 0)
                                                                        {
                                                                                $row['work'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $highbidderid, $row['project_id'], $active = false);
                                                                        }
                                                                        if ($ilconfig['productaward_pmbafterend'] == 0)
                                                                        {
                                                                            $row['pmb'] = '-';
                                                                        }
                                                                }
                                                        }
                                                        
                                                        $row['work'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $highbidderid, $row['project_id'], $active = true);
                                                }
                                        }
                                        else
                                        {
                                                $ilance->bid->bid_lowest_unique = construct_object('api.bid_lowest_unique');
                                                $lowbidderid = $ilance->bid->bid_lowest_unique->fetch_lowest_unique_bid_winner($row['project_id'], false);
                                                
                                                // check for LUB winner and adjust actions accordingly
                                                if ($row['project_details'] == 'unique' AND $row['haswinner'] AND $lowbidderid > 0)
                                                {
                                                        // the awarded provider did not rate his buyer
                                                        $crypted = array(
                                                                'cmd' => '_leave-feedback',
                                                                'type' => 'buyer',
                                                                'project_id' => $row['project_id'],
                                                                'for_user_id' => $lowbidderid,
                                                                'from_user_id' => $_SESSION['ilancedata']['user']['userid']
                                                        );
                                                        
                                                        if ($row['sellerfeedback'])
                                                        {
                                                                $row['feedback'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/checkmark.gif" border="0" alt="' . $phrase['_feedback_submitted__thank_you'] . '" /></div>';       
                                                        }
                                                        else
                                                        {
                                                                $row['feedback'] = '<span class="gray">' . $phrase['_next'] . ':</span> <span class="blue"><a href="' . $ilpage['feedback'] . '?crypted=' . encrypt_url($crypted) . '"><strong>' . $phrase['_submit_feedback_for'] . ' ' . fetch_user('username', $lowbidderid) . '</strong></a></span>';
                                                        }
                                                        
                                                        $row['work'] = '-';
                                                        $row['pmb'] = $ilance->auction->construct_pmb_icon($_SESSION['ilancedata']['user']['userid'], $lowbidderid, $row['project_id']);
                                                        $row['invoice'] = '-';
                                                }
                                                else
                                                {
                                                        $row['pmb'] = $row['invoice'] = $row['feedback'] = '-';
                                                        $row['work'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $highbidderid, $row['project_id'], $active = false);
                                                }
                                        }
    
                                        // highest bid amounts
                                        $sql_highest = $ilance->db->query("
                                                SELECT MAX(bidamount) AS highest FROM " . DB_PREFIX . "project_bids
                                                WHERE project_id = '" . $row['project_id'] . "'
                                                ORDER BY highest
                                                LIMIT 1
                                        ");
                                        if ($ilance->db->num_rows($sql_highest) > 0)
                                        {
                                                $res_highest = $ilance->db->fetch_array($sql_highest);
                                                $row['highest'] = $ilance->currency->format($res_highest['highest']);
                                        }
                                        else
                                        {
                                                $row['highest'] = '-';
                                        }
    
                                        // purchase now order activity
                                        if ($row['buynow_price'] > 0)
                                        {
                                                $GLOBALS['show_purchase_now' . $row['project_id']] = 1;
                                        }
                                        else
                                        {
                                                $GLOBALS['show_purchase_now' . $row['project_id']] = 0;
                                        }
    
                                        // realtime bidding activity
                                        if ($row['project_details'] == 'realtime')
                                        {
                                                $GLOBALS['show_realtime_bid' . $row['project_id']] = 1;
                                        }
                                        else
                                        {
                                                $GLOBALS['show_realtime_bid' . $row['project_id']] = 0;
                                        }
                                        
                                        // lowest unique bidding event
                                        if ($row['project_details'] == 'unique')
                                        {
                                                $GLOBALS['show_unique_bid' . $row['project_id']] = 1;
                                                $GLOBALS['show_regular_bid' . $row['project_id']] = 0;
                                        }
                                        else
                                        {
                                                $GLOBALS['show_unique_bid' . $row['project_id']] = 0;
                                                $GLOBALS['show_regular_bid' . $row['project_id']] = 1;
                                        }
                                        
                                        $sqlbit = "AND status != 'cancelled'";
                                        if (isset($ilance->GPC['cancelled']) AND $ilance->GPC['cancelled'])
                                        {
                                                $sqlbit = '';
                                        }
                                                                 
                                        // purchase now activity for this expanded auction
                                        $result_orders = $ilance->db->query("
                                                SELECT *
                                                FROM " . DB_PREFIX . "buynow_orders
                                                WHERE owner_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                        AND project_id = '" . $row['project_id'] . "'
                                                        $sqlbit
                                                        ORDER BY orderid DESC
                                        ");
                                        if ($ilance->db->num_rows($result_orders) > 0)
                                        {
                                                $order_count = 0;
                                                while ($orderrows = $ilance->db->fetch_array($result_orders))
                                                {
                                                        $orderrows['orderbuyer'] = fetch_user('username', $orderrows['buyer_id']);
                                                        $orderrows['orderbuyer_id'] = $orderrows['buyer_id'];
                                                        $orderrows['orderphone'] = fetch_user('phone', $orderrows['buyer_id']);
                                                        $orderrows['orderemail'] = fetch_user('email', $orderrows['buyer_id']);
                                                        $orderamount = fetch_auction('buynow_price', $orderrows['project_id']);
                                                        $orderrows['orderamount'] = $ilance->currency->format($orderamount);
                                                        $orderrows['escrowamount'] = $ilance->currency->format($orderrows['amount']);
                                                        $orderrows['orderdate'] = print_date($orderrows['orderdate'], $ilconfig['globalserverlocale_globaltimeformat'], 0, 0, 1, 0);
                                                        $orderrows['orderqty'] = $orderrows['qty'];
                                                        $orderrows['orderinvoiceid'] = $orderrows['invoiceid'];
                                                        $orderrows['orderid'] = $orderrows['orderid'];
                                                        
                                                        if ($orderrows['escrowfee'] > 0 AND $orderrows['isescrowfeepaid'] == 1 AND $orderrows['escrowfeeinvoiceid'] > 0)
                                                        {
                                                                $orderrows['escrowfee'] = $ilance->currency->format($orderrows['escrowfee']);
                                                                $orderrows['escrowfee'] .= ' <span class="smaller gray">[ <a href="' . $ilpage['invoicepayment'] . '?cmd=view&amp;id=' . $orderrows['escrowfeeinvoiceid'] . '">' . $phrase['_paid'] . '</a> ]</span>';
                                                        }
                                                        else
                                                        {
                                                                if ($orderrows['escrowfee'] > 0 AND $orderrows['isescrowfeepaid'] == 0 AND $orderrows['escrowfeeinvoiceid'] > 0)
                                                                {
                                                                        $orderrows['escrowfee'] = $ilance->currency->format($orderrows['escrowfee']);
                                                                        $orderrows['escrowfee'] .= ' <span class="smaller gray">[ <a href="' . $ilpage['invoicepayment'] . '?cmd=view&amp;id=' . $orderrows['escrowfeeinvoiceid'] . '">' . $phrase['_unpaid'] . '</a> ]</span>';
                                                                }
                                                                else
                                                                {
                                                                        $orderrows['escrowfee'] = '-';
                                                                }
                                                        }
                                                        
                                                        if ($orderrows['fvf'] > 0 AND $orderrows['isfvfpaid'] == 1 AND $orderrows['fvfinvoiceid'] > 0)
                                                        {
                                                                $orderrows['sellerfvf'] = $ilance->currency->format($orderrows['fvf']);
                                                                $orderrows['sellerfvf'] .= '<div class="smaller gray">[ <a href="' . $ilpage['invoicepayment'] . '?cmd=view&amp;id=' . $orderrows['fvfinvoiceid'] . '">' . $phrase['_paid'] . '</a> ]</div>';        
                                                        }
                                                        else
                                                        {
                                                                if ($orderrows['fvf'] > 0 AND $orderrows['isfvfpaid'] == 0 AND $orderrows['fvfinvoiceid'] > 0)
                                                                {
                                                                        $orderrows['sellerfvf'] = $ilance->currency->format($orderrows['fvf']);
                                                                        $orderrows['sellerfvf'] .= '<div class="smaller gray">[ <span><a href="' . $ilpage['invoicepayment'] . '?cmd=view&amp;id=' . $orderrows['fvfinvoiceid'] . '" style="color:#990000">' . $phrase['_unpaid'] . '</a></span> ]</div>';
                                                                }
                                                                else
                                                                {
                                                                        $orderrows['sellerfvf'] = '-';
                                                                }
                                                        }
                                                        
                                                        // does seller need to give feedback to buyer for this buy now escrow?
                                                        $leftfeedback = 0;
                                                        if ($ilance->feedback->has_left_feedback($for_user_id = $orderrows['orderbuyer_id'], $from_user_id = $orderrows['owner_id'], $project_id = $orderrows['project_id'], $type = 'buyer'))
                                                        {
                                                                // seller already rated buyer!
                                                                $leftfeedback = 1;
                                                                $orderrows['feedback2'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/checkmark.gif" border="0" alt="' . $phrase['_feedback_submitted__thank_you'] . '" />';
                                                        }
                                                        else
                                                        {
                                                                $crypted = array(
                                                                        'cmd' => '_leave-feedback',
                                                                        'type' => 'buyer',
                                                                        'project_id' => $orderrows['project_id'],
                                                                        'for_user_id' => $orderrows['orderbuyer_id'],
                                                                        'from_user_id' => $orderrows['owner_id']
                                                                );
                                                                
                                                                $orderrows['feedback2'] =  '<span class="gray">' . $phrase['_next'] . ':</span> <span class="blue"><a href="' . $ilpage['feedback'] . '?crypted=' . encrypt_url($crypted) . '"><strong>' . $phrase['_submit_feedback_for'] . ' ' . fetch_user('username', $orderrows['buyer_id']) . '</strong></a></span>';
                                                        }
                                                        
                                                        // escrow order status
                                                        if ($orderrows['status'] == 'paid')
                                                        {
                                                                // started - funds forwarded by bidder into escrow for item
                                                                $orderrows['bgcolclass'] = '#FEFFE5';
                                                                $orderrows['orderstatus'] = $phrase['_funds_secured'];
        
                                                                // secured - show release funds back to the customer or confirm delivery
                                                                $crypted = array(
                                                                        'cmd' => 'management',
                                                                        'sub' => 'buynow-escrow',
                                                                        'subcmd' => '_confirm-delivery',
                                                                        'id' => $orderrows['orderid']
                                                                );
                                                                
                                                                $orderrows['orderactions'] = '<span class="blue"><a href="' . $ilpage['selling'] . '?crypted=' . encrypt_url($crypted) . '" onclick="return confirm_js(phrase[\'_confirm_delivery_the_items_have_already_been_shipped_to_buyers_location_additionally\'])"><strong>' . $phrase['_mark_as_shipped'] . '</strong></a></span><div class="smaller gray">' . $phrase['_let_the_buyer_know_the_item_was_shipped'] . '</div>';
        
                                                                $crypted = array(
                                                                        'cmd' => 'management',
                                                                        'sub' => 'buynow-escrow',
                                                                        'subcmd' => '_cancel-delivery',
                                                                        'id' => $orderrows['orderid']
                                                                );
                                                                
                                                                $orderrows['orderactions'] .= '<div style="padding-top:3px; padding-bottom:3px"><strong>' . $phrase['_or_upper'] . '</strong></div><div class="blue"><a href="' . $ilpage['selling'] . '?crypted=' . encrypt_url($crypted) . '" target="_self" onclick="return confirm_js(phrase[\'_cancel_delivery_return_funds_in_escrow_back_to_this_buyer_continue\'])">' . $phrase['_cancel_order'] . '</a></div><div class="smaller gray">' . $phrase['_advise_the_buyer_there_was_a_problem'] . '</div>';
                                                                
                                                                $orderrows['pmb2'] = $ilance->auction->construct_pmb_icon($_SESSION['ilancedata']['user']['userid'], $orderrows['orderbuyer_id'], $orderrows['project_id']);
                                                                $orderrows['share2'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                                $orderrows['work2'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                                $show['escrowcolumn']['project_id'] = 1;
                                                        }
                                                        else if ($orderrows['status'] == 'pending_delivery')
                                                        {
                                                                // started - funds forwarded by bidder into escrow for item
                                                                $orderrows['bgcolcolor'] = '#FFFFED';
                                                                $orderrows['orderactions'] = '<strong>' . $phrase['_pending_release'] . '</strong> <a href="javascript:void(0);" onmouseover="Tip(\'' . $phrase['_waiting_for_buyer_to_release_funds_into_my_online_account'] . '\', BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a><div class="smaller gray">' . $phrase['_waiting_for_buyer_to_release_funds'] . '</div>';
                                                                $orderrows['pmb2'] = $ilance->auction->construct_pmb_icon($_SESSION['ilancedata']['user']['userid'], $orderrows['orderbuyer_id'], $orderrows['project_id']);
                                                                $orderrows['share2'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                                $orderrows['work2'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                                $show['escrowcolumn']['project_id'] = 1;
                                                        }
                                                        else if ($orderrows['status'] == 'delivered')
                                                        {
                                                                // started - funds forwarded by bidder into escrow for item
                                                                
                                                                // hide amount, it's released so there is no funds in escrow anymore.
                                                                $orderrows['escrowamount'] = '-';
                                                                $orderrows['bgcolcolor'] = '#EAFFE5';
                                                                if ($leftfeedback)
                                                                {
                                                                        $orderrows['orderactions'] = '<strong>' . $phrase['_completed'] . '</strong>';
                                                                }
                                                                else
                                                                {
                                                                        $orderrows['bgcolcolor'] = '#FFFFED';
                                                                        $orderrows['orderactions'] = $phrase['_leave_feedback'] . ' <a href="javascript:void(0);" onmouseover="Tip(\'' . $phrase['_leave_feedback_lets_you_rate_the_service_provider_and_provide_feedback'] . '\', BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a>';
                                                                }
                                                                $orderrows['pmb2'] = $ilance->auction->construct_pmb_icon($_SESSION['ilancedata']['user']['userid'], $orderrows['orderbuyer_id'], $orderrows['project_id']);
                                                                $orderrows['share2'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                                $orderrows['work2'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                                $show['escrowcolumn']['project_id'] = 1;
                                                        }
                                                        else if ($orderrows['status'] == 'cancelled')
                                                        {
                                                                $orderrows['escrowamount'] = '-';
                                                                $orderrows['orderactions'] = $phrase['_cancelled'];
                                                                $orderrows['bgcolcolor'] = '#FCF2F2';
                                                                $orderrows['pmb2'] = $ilance->auction->construct_pmb_icon($_SESSION['ilancedata']['user']['userid'], $orderrows['orderbuyer_id'], $orderrows['project_id']);
                                                                $orderrows['share2'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = false);
                                                                $orderrows['work2'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = false);
                                                                $show['escrowcolumn']['project_id'] = 1;
                                                        }
                                                        else if ($orderrows['status'] == 'offline')
                                                        {
                                                                $orderrows['escrowamount'] = '-';
                                                                $orderrows['bgcolcolor'] = '#FEFFE5';
                                                                
                                                                $crypted = array(
                                                                        'cmd' => 'management',
                                                                        'sub' => 'buynow-escrow',
                                                                        'subcmd' => '_confirm-offline-delivery',
                                                                        'id' => $orderrows['orderid']
                                                                );
                                                                
                                                                $orderrows['orderactions'] = '<span class="gray">' . $phrase['_next'] . ': </span><span class="blue"><a href="' . $ilpage['selling'] . '?crypted=' . encrypt_url($crypted) . '" onclick="return confirm_js(phrase[\'_confirm_delivery_the_items_have_already_been_shipped_to_buyers_location_additionally\'])"><strong>' . $phrase['_confirm_offline_delivery'] . '</strong></a></span> <a href="javascript:void(0);" onmouseover="Tip(phrase[\'_confirm_delivery_means_that_it_is_up_to_you_as_the_merchant_to_confirm_the_delivery\'], BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a><div class="smaller gray">' . $phrase['_advise_buyer_payment_has_cleared'] . '</div>';
                                                                
                                                                $orderrows['pmb2'] = $ilance->auction->construct_pmb_icon($_SESSION['ilancedata']['user']['userid'], $orderrows['owner_id'], $orderrows['project_id']);
                                                                $orderrows['share2'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                                $orderrows['work2'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                        }
                                                        else if ($orderrows['status'] == 'offline_delivered')
                                                        {
                                                                $orderrows['escrowamount'] = '-';
                                                                $orderrows['fees'] = '-';
                                                                $orderrows['bgcolcolor'] = '#FFFFED';
                                                                if ($leftfeedback == 1)
                                                                {
                                                                        $orderrows['bgcolcolor'] = '#EAFFE5';
                                                                        $orderrows['orderactions'] = '<strong>' . $phrase['_completed'] . '</strong>';
                                                                }
                                                                else
                                                                {
                                                                        $orderrows['orderactions'] = $phrase['_leave_feedback'] . ' <a href="javascript:void(0);" onmouseover="Tip(\'' . $phrase['_leave_feedback_lets_you_rate_the_service_provider_and_provide_feedback'] . '\', BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a>';
                                                                }
                                                                $orderrows['pmb2'] = $ilance->auction->construct_pmb_icon($_SESSION['ilancedata']['user']['userid'], $orderrows['owner_id'], $orderrows['project_id']);
                                                                $orderrows['share2'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                                $orderrows['work2'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $orderrows['orderbuyer_id'], $orderrows['project_id'], $active = true);
                                                        }                                                                
                                                        if ($orderrows['ship_required'])
                                                        {
                                                                $ship_handling = fetch_auction('ship_handling', $orderrows['project_id']);
                                                                if ($ship_handling == 'sellerpays' OR $ship_handling == 'none')
                                                                {
                                                                        $ship_costs = 0;	
                                                                }
                                                                else
                                                                {
                                                                        $ship_costs = fetch_auction('ship_costs', $orderrows['project_id']);
                                                                }
                                                                $orderrows['shipping'] = $ilance->currency->format($ship_costs);
                                                                $orderrows['orderlocation'] = stripslashes($orderrows['ship_location']);
                                                        }
                                                        else
                                                        {
                                                                $ship_costs = 0;
                                                                $orderrows['shipping'] = $ilance->currency->format($ship_costs);
                                                                $dquery = $ilance->db->query("
                                                                        SELECT filename, counter, filesize, attachid
                                                                        FROM " . DB_PREFIX . "attachment
                                                                        WHERE project_id = '" . intval($orderrows['project_id']) . "'
                                                                                AND attachtype = 'digital'
                                                                                AND user_id = '" . intval($_SESSION['ilancedata']['user']['userid']) . "'
                                                                        LIMIT 1
                                                                ");
                                                                if ($ilance->db->num_rows($dquery) > 0)
                                                                {
                                                                        $dfile = $ilance->db->fetch_array($dquery);
                                                                        $digitalfile = '<strong>' . stripslashes($dfile['filename']) . '</strong> (' . print_filesize($dfile['filesize']) . ')';
                                                                }
                                                                $orderrows['orderlocation'] = $phrase['_digital_delivery'] . ': ' . $digitalfile;
                                                        }                                                                
                                                        $orderrows['total'] = $ilance->currency->format(($orderamount * $orderrows['orderqty']) + $ship_costs);
                                                        $orderrows['class'] = ($order_count % 2) ? 'alt2' : 'alt1';
                                                        $GLOBALS['purchase_now_activity' . $row['project_id']][] = $orderrows;
                                                        $order_count++;
                                                }
                                        }
                                        else
                                        {
                                                $GLOBALS['no_purchase_now_activity' . $row['project_id']][] = 1;
                                        }
                                        
                                        // listing photo
                                        $row['photo'] = print_item_photo($ilpage['merch'] . '?id=' . $row['project_id'], 'thumb', $row['project_id']);
                                        
                                        // define the type of listing (regular or lowest unique bid)
                                        if ($row['project_details'] != 'unique')
                                        {
                                                // regular bid results
                                                
                                                // js to handle updating the shipping/tracking number inline edit
                                                $headinclude .= '
<script type="text/javascript">
<!--
var urlBase = \'ajax.php?do=inlineedit&action=sellershiptracking&id=\';
-->
</script>';
                                                // #### EXPANDED BIDDING ACTIVITY FOR THIS AUCTION ###########
                                                $resulttmp = $ilance->db->query("
                                                        SELECT b.bid_id, b.user_id as bidder_id, b.project_id, b.project_user_id, b.bidamount, b.date_added, b.date_updated, b.date_awarded, b.bidstatus, b.bidstate, b.qty, p.project_id, p.status AS project_status, p.ship_trackingnumber, p.buynow, p.buynow_price, p.sellermarkedasshipped, p.sellermarkedasshippeddate, p.charityid, p.donationpercentage, u.username, u.city, u.state, u.zip_code
                                                        FROM " . DB_PREFIX . "project_bids AS b,
                                                        " . DB_PREFIX . "projects AS p,
                                                        " . DB_PREFIX . "users AS u
                                                        WHERE b.project_id = '" . $row['project_id'] . "'
                                                                AND p.project_id = b.project_id
                                                                AND b.project_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                AND b.user_id = u.user_id
                                                                AND b.bidstatus != 'declined'
                                                                AND b.bidstate != 'retracted'
                                                        ORDER BY b.bidamount DESC
                                                ");
                                                
                                                $result2 = $ilance->db->query("
                                                        SELECT b.bid_id, b.user_id as bidder_id, b.project_id, b.project_user_id, b.bidamount, b.date_added, b.date_updated, b.date_awarded, b.bidstatus, b.bidstate, b.qty, p.project_id, p.status AS project_status, p.ship_trackingnumber, p.buynow, p.buynow_price, p.sellermarkedasshipped, p.sellermarkedasshippeddate, p.charityid, p.donationpercentage, u.username, u.city, u.state, u.zip_code
                                                        FROM " . DB_PREFIX . "project_bids AS b,
                                                        " . DB_PREFIX . "projects AS p,
                                                        " . DB_PREFIX . "users AS u
                                                        WHERE b.project_id = '" . $row['project_id'] . "'
                                                                AND p.project_id = b.project_id
                                                                AND b.project_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                AND b.user_id = u.user_id
                                                                AND b.bidstatus != 'declined'
                                                                AND b.bidstate != 'retracted'
                                                        $limit3
                                                ");
                                                
                                                $number3 = $ilance->db->num_rows($resulttmp);
                                                if ($ilance->db->num_rows($result2) > 0)
                                                {
                                                        $ilance->feedback = construct_object('api.feedback');
                                                        $ilance->auction = construct_object('api.auction');
                                                        
                                                        $rows_count = 0;
                                                        while ($rows = $ilance->db->fetch_array($result2))
                                                        {
                                                                $project_status = $rows['project_status'];
                                                                $p_id = $row['project_id'];
                                                                $rows['bidamount'] = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $rows['bidamount']);
                                                                $rows['isonline'] = print_online_status($rows['bidder_id']);
                                                                $rows['bidder'] = print_username($rows['bidder_id'], 'href', 0, '', '');
                                                                $rows['city'] = ucfirst($rows['city']);
                                                                $rows['state'] = ucfirst($rows['state']);
                                                                $rows['zip'] = trim(mb_strtoupper($rows['zip_code']));
                                                                $rows['location'] = ucfirst($rows['state']).' &gt; '.print_user_country($rows['bidder_id'], $_SESSION['ilancedata']['user']['slng']);
                                                                $rows['awarded'] = print_username($rows['bidder_id'], 'custom', 0, '', '', fetch_user('productawards', $rows['bidder_id']) . ' ' . $phrase['_awards']);
                                                                $rows['reviews'] = print_username($rows['bidder_id'], 'custom', 0, '', '', fetch_service_reviews_reported($rows['bidder_id']) . ' ' . $phrase['_reviews']); 
                                                                $rows['pmb2'] = $ilance->auction->construct_pmb_icon($_SESSION['ilancedata']['user']['userid'], $rows['bidder_id'], $row['project_id']);
                                                                $shiptracking = $phrase['_doubleclick_to_edit'];
                                                                
                                                                //$rows['shiptrack'] = $shiptracking;
                                                                $rows['shiptrack'] = '-';
                                                                $rows['payment'] = '-';
                                                                $rows['delivery'] = '-';
                                                                
                                                                switch ($project_status)
                                                                {
                                                                        case 'open':
                                                                        case 'expired':
                                                                        {
                                                                                if ($rows['bidstatus'] == 'awarded')
                                                                                {
                                                                                        $awarded_vendor = stripslashes($rows['username']);
                                                                                        $rows['award'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid_awarded.gif" border="0" alt="" /></div>';
                                                                                    
                                                                                        if (!empty($rows['ship_trackingnumber']))
                                                                                        {
                                                                                                $shiptracking = $rows['ship_trackingnumber'];
                                                                                        }
                                                                                        
                                                                                        $rows['shiptrack'] = '<div id="shiptracking_' . $row['project_id'] . '"><span id="phrase' . $row['project_id'] . 'inline"><span ondblclick="do_inline_edit(' . $row['project_id'] . ', this);">' . $shiptracking . '</span></span></div><span class="smaller gray">' . $phrase['_doubleclick_to_edit'] . '</span>';
                                                                                        //$rows['payment'] = $ilance->bid->fetch_transaction_status($row['project_id'], true, true);
                                                                                        $rows['payment'] = '-';
                                                                                        
                                                                                        if ($rows['sellermarkedasshipped'] AND $rows['sellermarkedasshippeddate'] != '0000-00-00 00:00:00')
                                                                                        {
                                                                                                $rows['delivery'] = '<span class="smaller gray">' . $phrase['_marked_as_shipped_on'] . ' ' . print_date($rows['sellermarkedasshippeddate']) . '</span>';
                                                                                                $crypted = array(
                                                                                                        'cmd' => 'management',
                                                                                                        'subcmd' => 'markasunshipped',
                                                                                                        'id' => $rows['project_id']
                                                                                                );
                                                                                                
                                                                                                $rows['delivery'] .= '<div class="blue" style="padding-top:3px"><a href="' . $ilpage['selling'] . '?crypted=' . encrypt_url($crypted) . '&amp;sub=' . $ilance->GPC['sub'] . '" onclick="return confirm_js(\'' . $phrase['_under_certain_circumstances_you_may_need_to_mark_an_item_that_has'] . '\');">' . $phrase['_mark_as_unshipped'] . '</a></div>';
                                                                                                unset($crypted);
                                                                                        }
                                                                                        else
                                                                                        {
                                                                                                $crypted = array(
                                                                                                        'cmd' => 'management',
                                                                                                        'subcmd' => 'markasshipped',
                                                                                                        'id' => $rows['project_id']
                                                                                                );
                                                                                                
                                                                                                $rows['delivery'] = '<span class="gray">' . $phrase['_next'] . ': </span><span class="blue"><a href="' . $ilpage['selling'] . '?crypted=' . encrypt_url($crypted) . '&amp;sub=' . $ilance->GPC['sub'] . '" onclick="return confirm_js(\'' . $phrase['_only_mark_as_shipped_once_you_have_physically_delivered_or_shipped'] . '\');"><strong>' . $phrase['_mark_as_shipped'] . '</strong></a></a>';
                                                                                                unset($crypted);
                                                                                        }
                                                                                        
                                                                                        if ($row['filter_escrow'] == '0')
                                                                                        {
                                                                                                if ($row['winnermarkedaspaid'] == '0')
                                                                                                {
                                                                                                        $row['payment'] = '<span class="gray">' . $phrase['_waiting_for'] . ' <span class="blue">' . $awarded_vendor . '</span> ' . $phrase['_to_mark_payment_as_sent'] . '</span>';
                                                                                                }
                                                                                                else
                                                                                                {
                                                                                                        $row['payment'] = '<div class="smaller gray"><span class="blue">' . $awarded_vendor . '</span> ' . $phrase['_marked_as_paid_on'] . ' ' . print_date($row['winnermarkedaspaiddate']) . '</div>';
                                                                                                }
                                                                                                
                                                                                        }
                                                                                        else
                                                                                        {
                                                                                                $rows['payment'] = '<span class="gray">' . $phrase['_view'] . ':</span> <span class="blue"><a href="' . $ilpage['selling'] . '?cmd=management&amp;sub=product-escrow">' . $phrase['_escrow'] . '</a></span>';
                                                                                                
                                                                                                // we will override delivery here to send link to escrow manager area instead of showing regular "mark as shipped"
                                                                                                $rows['delivery'] = '<span class="gray">' . $phrase['_view'] . ':</span> <span class="blue"><a href="' . $ilpage['selling'] . '?cmd=management&amp;sub=product-escrow">' . $phrase['_escrow'] . '</a></span>';
                                                                                                
                                                                                                // just in case seller marked as shipped.. let's show this info so he's not confused
                                                                                                if ($rows['sellermarkedasshipped'] AND $rows['sellermarkedasshippeddate'] != '0000-00-00 00:00:00')
                                                                                                {
                                                                                                        $rows['delivery'] = '<span class="smaller gray">' . $phrase['_marked_as_shipped_on'] . ' ' . print_date($rows['sellermarkedasshippeddate']) . '</span>';        
                                                                                                }
                                                                                        }
                                                                                        
                                                                                        if ($rows['charityid'] > 0)
                                                                                        {
                                                                                                $charity = fetch_charity_details($rows['charityid']);
                                                                                                $rows['donationto'] = '<span class="blue"><a href="' . $ilpage['nonprofits'] . '?id=' . $rows['charityid'] . '">' . $charity['title'] . '</a></span>';
                                                                                                $rows['donationpercent'] = $rows['donationpercentage'] . '%';
                                                                                        }
                                                                                        else
                                                                                        {
                                                                                                $rows['donationto'] = '-';
                                                                                                $rows['donationpercent'] = '-';
                                                                                        }
                                                                                        
                                                                                        
                                                                                }
                                                                                else
                                                                                {
                                                                                        $rows['award'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid_awarded_gray.gif" border="0" alt="" /></div>';
                                                                                }
                                                                                break;
                                                                        }                                                                
                                                                        case 'approval_accepted':
                                                                        {
                                                                                if ($rows['bidstatus'] == 'awarded')
                                                                                {
                                                                                        $awarded_vendor = stripslashes($rows['username']);
                                                                                        $rows['award'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid_awarded.gif" border="0" alt="" /></div>';
                                                                                        if (!empty($rows['ship_trackingnumber']))
                                                                                        {
                                                                                                $shiptracking = $rows['ship_trackingnumber'];
                                                                                        }
                                                                                        $rows['shiptrack'] = '<div id="shiptracking_' . $row['project_id'] . '"><span id="phrase' . $row['project_id'] . 'inline"><span ondblclick="do_inline_edit(' . $row['project_id'] . ', this);">' . $shiptracking . '</span></span></div>
                                                                                        <span class="smaller gray">' . $phrase['_doubleclick_to_edit'] . '</span>';
                                                                                }
                                                                                else if ($rows['bidstatus'] == 'placed' AND $rows['bidstate'] == 'reviewing' OR $rows['bidstatus'] == 'choseanother' AND $rows['bidstate'] == 'reviewing')
                                                                                {
                                                                                        $rows['award'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid_awarded_gray.gif" border="0" alt="" /></div>';
                                                                                }
                                                                                else if ($rows['bidstatus'] == 'placed' AND $rows['bidstate'] == 'wait_approval')
                                                                                {
                                                                                        $awarded_vendor = stripslashes($rows['username']);
                                                                                        $rows['award'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid_awarded.gif" border="0" alt="" /></div>';
                                                                                }
                                                                                else
                                                                                {
                                                                                        $rows['award'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid_awarded_gray.gif" border="0" alt="" /></div>';
                                                                                }
                                                                                break;
                                                                        }                                                                
                                                                        case 'wait_approval':
                                                                        {
                                                                                if ($rows['bidstatus'] == 'placed' AND $rows['bidstate'] == 'wait_approval')
                                                                                {
                                                                                        $awarded_vendor = stripslashes($rows['username']);
                                                                                }
                                                                                break;
                                                                        }                                                                
                                                                        case 'closed':
                                                                        case 'delisted':
                                                                        case 'finished':
                                                                        case 'archived':
                                                                        {
                                                                                if ($rows['bidstatus'] == 'awarded')
                                                                                {
                                                                                        $awarded_vendor = stripslashes($rows['username']);
                                                                                        $rows['award'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid_awarded.gif" border="0" alt="" /></div>';
                                                                                        if (!empty($rows['ship_trackingnumber']))
                                                                                        {
                                                                                                $shiptracking = $rows['ship_trackingnumber'];
                                                                                        }
                                                                                        $rows['shiptrack'] = '<div id="shiptracking_' . $row['project_id'] . '"><span id="phrase' . $row['project_id'] . 'inline"><span ondblclick="do_inline_edit(' . $row['project_id'] . ', this);">' . $shiptracking . '</span></span></div><span class="smaller gray">' . $phrase['_doubleclick_to_edit'] . '</span>';
                                                                                }
                                                                                else
                                                                                {
                                                                                        $rows['award'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid_awarded_gray.gif" border="0" alt="" /></div>';
                                                                                }
                                                                                break;
                                                                        }
                                                                }
                                                                
                                                                $rows['class2'] = ($rows_count % 2) ? 'alt1' : 'alt2';
                                                                
                                                                $GLOBALS['product_selling_bidding_activity' . $row['project_id']][] = $rows;
                                                                $rows_count++;
                                                        }
                                                }
                                                else
                                                {
                                                        $GLOBALS['no_product_selling_bidding_activity' . $row['project_id']][] = 1;
                                                }
                                                
                                                $row['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                                                $show['no_product_selling_activity'] = false;
                                                $product_selling_activity[] = $row;
                                                $show['itempulldownmenu'] = true;
                                                $row_count++;
                                        }
                                        
                                        // lowest unique bidding (admin/staff donation event type)
                                        else
                                        {
                                                // #### EXPANDED LOWEST UNIQUE BIDDING ACTIVITY FOR THIS AUCTION ###########
                                                $resulttmp = $ilance->db->query("
                                                        SELECT b.uid, b.user_id, b.response, b.project_id, b.project_user_id, b.uniquebid, b.date, b.status AS uniquestatus, p.project_id, p.status, p.donationpercentage, p.charityid, p.sellermarkedasshipped, p.sellermarkedasshippeddate, u.username
                                                        FROM " . DB_PREFIX . "projects_uniquebids AS b,
                                                        " . DB_PREFIX . "projects AS p,
                                                        " . DB_PREFIX . "users AS u
                                                        WHERE b.project_id = '" . $row['project_id'] . "'
                                                                AND p.project_id = b.project_id
                                                                AND b.project_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                AND b.user_id = u.user_id
                                                        ORDER BY b.uniquebid ASC
                                                ");
                                                $number4 = $ilance->db->num_rows($resulttmp);
                                                
                                                $result2 = $ilance->db->query("
                                                        SELECT b.uid, b.user_id, b.response, b.project_id, b.project_user_id, b.uniquebid, b.date, b.status AS uniquestatus, p.project_id, p.status, p.donationpercentage, p.charityid, p.sellermarkedasshipped, p.sellermarkedasshippeddate, u.username
                                                        FROM " . DB_PREFIX . "projects_uniquebids AS b,
                                                        " . DB_PREFIX . "projects AS p,
                                                        " . DB_PREFIX . "users AS u
                                                        WHERE b.project_id = '" . $row['project_id'] . "'
                                                                AND p.project_id = b.project_id
                                                                AND b.project_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                AND b.user_id = u.user_id
                                                        $limit4
                                                ");
                                                if ($ilance->db->num_rows($result2) > 0)
                                                {
                                                        $rows_count = 0;
                                                        while ($rows = $ilance->db->fetch_array($result2))
                                                        {
                                                                $rows['class2'] = ($rows_count % 2) ? 'alt1' : 'alt2';
                                                                $rows['award'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid_awarded_gray.gif" border="0" alt="" />';
                                                                $p_id = $row['project_id'];
                                                                $rows['bidamount'] = print_currency_conversion($_SESSION['ilancedata']['user']['currencyid'], $rows['uniquebid']);
                                                                $rows['response'] = $rows['response'];
                                                                $rows['delivery'] = '-';
                                                                $rows['payment'] = '-';
                                                                $rows['donationpercent'] = '-';
                                                                $rows['donationto'] = '-';
                                                                if ($rows['uniquestatus'] == 'lowestunique' AND $row['status'] == 'open')
                                                                {
                                                                        $rows['bidstatus'] = '<span class="blue"><strong>' . $phrase['_lowest_unique_bid'] . '</strong></span>';
                                                                }
                                                                else if ($rows['uniquestatus'] == 'lowestunique' AND $row['status'] == 'open')
                                                                {
                                                                        $rows['bidstatus'] = '<span class="blue"><strong>' . $phrase['_lowest_unique_bid'] . '</strong></span>';
                                                                        $rows['award'] = $rows['award'] = "<img src='" . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . "bid_awarded_gray.gif' border='0' alt='' />";
                                                                        $rows['class2'] = 'alt1 featured_highlight';
                                                                }
                                                                else if ($rows['uniquestatus'] == 'lowestunique' AND $row['status'] != 'open')
                                                                {
                                                                        $rows['bidstatus'] = '<span class="blue"><strong>' . $phrase['_lowest_unique_bid'] . '</strong></span>';
                                                                        $rows['award'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'bid_awarded.gif" border="0" alt="" /></div>';
                                                                        $rows['class2'] = 'alt1 featured_highlight';
                                                                        $rows['payment'] = $ilance->bid->fetch_transaction_status($row['project_id'], true, true);
                                                                        $rows['donationpercent'] = '' . $rows['donationpercentage'] . '%';
                                                                        
                                                                        $charity = fetch_charity_details($rows['charityid']);
                                                                        $rows['donationto'] = '<span class="blue"><a href="' . $ilpage['nonprofits'] . '?id=' . $rows['charityid'] . '">' . $charity['title'] . '</a></span>';
                                                                        
                                                                        if ($rows['sellermarkedasshipped'] AND $rows['sellermarkedasshippeddate'] != '0000-00-00 00:00:00')
                                                                        {
                                                                                $rows['delivery'] = '<span class="smaller gray">' . $phrase['_marked_as_shipped_on'] . ' ' . print_date($rows['sellermarkedasshippeddate']) . '</span>';
                                                                                $crypted = array(
                                                                                        'cmd' => 'management',
                                                                                        'subcmd' => 'markasunshipped',
                                                                                        'id' => $rows['project_id']
                                                                                );
                                                                                
                                                                                $rows['delivery'] .= '<div class="blue" style="padding-top:3px"><a href="' . $ilpage['selling'] . '?crypted=' . encrypt_url($crypted) . '&amp;sub=' . $ilance->GPC['sub'] . '" onclick="return confirm_js(\'' . $phrase['_under_certain_circumstances_you_may_need_to_mark_an_item_that_has'] . '\');">' . $phrase['_mark_as_unshipped'] . '</a></div>';
                                                                                unset($crypted);
                                                                        }
                                                                        else
                                                                        {
                                                                                $crypted = array(
                                                                                        'cmd' => 'management',
                                                                                        'subcmd' => 'markasshipped',
                                                                                        'id' => $rows['project_id']
                                                                                );
                                                                                
                                                                                $rows['delivery'] = '<span class="gray">' . $phrase['_next'] . ': </span><span class="blue"><a href="' . $ilpage['selling'] . '?crypted=' . encrypt_url($crypted) . '&amp;sub=' . $ilance->GPC['sub'] . '" onclick="return confirm_js(\'' . $phrase['_only_mark_as_shipped_once_you_have_physically_delivered_or_shipped'] . '\');"><strong>' . $phrase['_mark_as_shipped'] . '</strong></a></a>';
                                                                                unset($crypted);
                                                                        }
                                                                }
                                                                else if ($rows['uniquestatus'] == 'unique')
                                                                {
                                                                        $rows['bidstatus'] = '<span class="gray"><strong>' . $phrase['_unique'] . '</strong></span>';
                                                                        $rows['bidamount'] = '<span class="gray">' . $rows['bidamount'] . '</span>';
                                                                }
                                                                else if ($rows['uniquestatus'] == 'nonunique')
                                                                {
                                                                        $rows['bidstatus'] = '<span class="gray">' . $phrase['_nonunique'] . '</span>';
                                                                        $rows['bidamount'] = '<span class="gray">' . $rows['bidamount'] . '</span>';
                                                                }
                                                                
                                                                $rows['isonline'] = print_online_status($rows['user_id']);
                                                                $rows['bidder'] = print_username($rows['user_id'], 'href', 0, '', '');
                                                                $rows['awarded'] = print_username($rows['user_id'], 'custom', 0, '', '', fetch_user('productawards', $rows['user_id']) . ' ' . $phrase['_awards']);
                                                                $rows['date'] = print_date($rows['date']);
                                                                
                                                                $GLOBALS['product_selling_unique_bidding_activity' . $row['project_id']][] = $rows;
                                                                $rows_count++;
                                                        }
                                                        unset($rows);
                                                }
                                                else
                                                {
                                                        $GLOBALS['no_product_selling_unique_bidding_activity' . $row['project_id']][] = 1;
                                                }
                                                
                                                $row['class'] = ($row_count % 2) ? 'alt2' : 'alt1';
                                                $show['no_product_selling_activity'] = false;
                                                $product_selling_activity[] = $row;
                                                $show['itempulldownmenu'] = true;
                                                $row_count++;
                                        }
                                        unset($row);
                                }
                        }
                        else
                        {
                                $show['no_product_selling_activity'] = true;
                                $show['itempulldownmenu'] = false;
                        }
                }
                                        
                // #### LISTING PERIOD SERVICE BIDS RESULTS ####################
                $extra = '';
                $ilance->GPC['period2'] = (isset($ilance->GPC['period2']) ? intval($ilance->GPC['period2']) : -1);
                $periodsql = fetch_startend_sql($ilance->GPC['period2'], 'DATE_SUB', 'p.date_added', '>=');
                $extra .= '&amp;period2=' . $ilance->GPC['period2'];
                
                // #### ENABLE SERVICE AUCTION SUPPORT? ########################
                if ($ilconfig['globalauctionsettings_serviceauctionsenabled'])
                {
                        // #### DECLINED/DELISTED RESULTS ######################
                        if (isset($ilance->GPC['bidsub']) AND $ilance->GPC['bidsub'] == 'delisted')
                        {
                                $bids_delisted = 1;
                                
                                $SQL3 = $ilance->bid_tabs->fetch_bidtab_sql('delisted', 'string', '', '', $limit2, $_SESSION['ilancedata']['user']['userid']);
                                $SQL4 = $ilance->bid_tabs->fetch_bidtab_sql('delisted', 'string', '', '', '', $_SESSION['ilancedata']['user']['userid']);
                                
                                $servicetabs = print_selling_activity_tabs('delisted', 'service', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                        }
                        
                        // #### AWARDED SERVICE BID RESULTS ####################
                        else if (isset($ilance->GPC['bidsub']) AND $ilance->GPC['bidsub'] == 'awarded')
                        {
                                $bids_awarded = 1;
                                
                                $SQL3 = $ilance->bid_tabs->fetch_bidtab_sql('awarded', 'string', 'GROUP BY b.project_id', '', $limit2, $_SESSION['ilancedata']['user']['userid']);
                                $SQL4 = $ilance->bid_tabs->fetch_bidtab_sql('awarded', 'string', 'GROUP BY b.project_id', '', '', $_SESSION['ilancedata']['user']['userid']);
                                
                                $servicetabs = print_selling_activity_tabs('awarded', 'service', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                        }
                        
                        // #### INVITED TO BID SERVICE RESULTS #################
                        else if (isset($ilance->GPC['bidsub']) AND $ilance->GPC['bidsub'] == 'invited')
                        {
                                $bids_invited = 1;
                                
                                $SQL3 = $ilance->bid_tabs->fetch_bidtab_sql('invited', 'string', '', '', $limit2, $_SESSION['ilancedata']['user']['userid']);
                                $SQL4 = $ilance->bid_tabs->fetch_bidtab_sql('invited', 'string', '', '', '', $_SESSION['ilancedata']['user']['userid']);
                                
                                $servicetabs = print_selling_activity_tabs('invited', 'service', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                        }
                        
                        // #### EXPIRED RESULTS ################################
                        else if (isset($ilance->GPC['bidsub']) AND $ilance->GPC['bidsub'] == 'expired')
                        {
                                $bids_expired = 1;
                                
                                $SQL3 = $ilance->bid_tabs->fetch_bidtab_sql('expired', 'string', '', '', $limit2, $_SESSION['ilancedata']['user']['userid']);
                                $SQL4 = $ilance->bid_tabs->fetch_bidtab_sql('expired', 'string', '', '', '', $_SESSION['ilancedata']['user']['userid']);
                                
                                $servicetabs = print_selling_activity_tabs('expired', 'service', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                        }
                        
                        // #### ARCHIVED RESULTS ###############################
                        else if (isset($ilance->GPC['bidsub']) AND $ilance->GPC['bidsub'] == 'archived')
                        {
                                $bids_archived = 1;
                                
                                $SQL3 = $ilance->bid_tabs->fetch_bidtab_sql('archived', 'string', '', '', $limit2, $_SESSION['ilancedata']['user']['userid']);
                                $SQL4 = $ilance->bid_tabs->fetch_bidtab_sql('archived', 'string', '', '', '', $_SESSION['ilancedata']['user']['userid']);
                                
                                $servicetabs = print_selling_activity_tabs('archived', 'service', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                        }
			
                        // #### RETRACTED RESULTS ##############################
                        else if (isset($ilance->GPC['bidsub']) AND $ilance->GPC['bidsub'] == 'retracted')
                        {
                                $bids_retracted = 1;
                                
                                $SQL3 = $ilance->bid_tabs->fetch_bidtab_sql('retracted', 'string', '', '', $limit2, $_SESSION['ilancedata']['user']['userid']);
                                $SQL4 = $ilance->bid_tabs->fetch_bidtab_sql('retracted', 'string', '', '', '', $_SESSION['ilancedata']['user']['userid']);
                                
                                $servicetabs = print_selling_activity_tabs('retracted', 'service', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                        }
                        
                        // #### ACTIVE RESULTS #################################
                        else
                        {
                                $bids_active = 1;
                                
                                $SQL3 = $ilance->bid_tabs->fetch_bidtab_sql('active', 'string', 'GROUP BY b.project_id', '', $limit2, $_SESSION['ilancedata']['user']['userid']);
                                $SQL4 = $ilance->bid_tabs->fetch_bidtab_sql('active', 'string', 'GROUP BY b.project_id', '', '', $_SESSION['ilancedata']['user']['userid']);
                                
                                $servicetabs = print_selling_activity_tabs('active', 'service', $_SESSION['ilancedata']['user']['userid'], $periodsql);
                        }
                        
                        $counter2 = ($ilance->GPC['page2'] - 1) * $ilconfig['globalfilters_maxrowsdisplay'];
                        $number2 = $ilance->db->num_rows($ilance->db->query($SQL4));
                        
                        $result2 = $ilance->db->query($SQL3);
                        if ($ilance->db->num_rows($result2) > 0)
                        {
                                $row_count2 = 0;
                                while ($row2 = $ilance->db->fetch_array($result2))
                                {
                                        if ($row2['bids'] == 0)
                                        {
                                                $row2['bids'] = '-';        
                                        }
                                        
                                        // final value fee for awarded provider
                                        if ($row2['fvf'] > 0)
                                        {
                                                // final value bit
                                                $row2['fvf'] = $ilance->currency->format($row2['fvf']);
                                                if ($row2['isfvfpaid'])
                                                {
                                                        $row2['fvf'] .= '<div class="smaller gray">[ ' . $phrase['_paid'] . ' ]</div>';
                                                }
                                                else
                                                {
                                                        $row2['fvf'] .= '<div class="smaller gray">[ <a href="' . $ilpage['invoicepayment'] . '?cmd=view&amp;id=' . $row2['fvfinvoiceid'] . '">' . $phrase['_unpaid'] . '</a> ]</div>';
                                                }
                                        }
                                        else
                                        {
                                                // final value bit
                                                $row2['fvf'] = '-';
                                        }
                                        
                                        $isawarded = 0;
                                        $sqleli = $ilance->db->query("
                                                SELECT *
                                                FROM " . DB_PREFIX . "project_bids
                                                WHERE bidstatus = 'awarded'
                                                        AND bidstate != 'retracted'
                                                        AND user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                        AND project_id = '" . $row2['project_id'] . "'
                                        ");
                                        if ($ilance->db->num_rows($sqleli) > 0)
                                        {
                                                $isawarded = 1;
                                        }
                                        
                                        if (isset($ilance->GPC['bidsub']) AND $ilance->GPC['bidsub'] == 'expired' AND isset($isawarded) AND $isawarded == 1)
                                        {
                                                $show['no_service_bidding_activity'] = true;
                                                $show['bidpulldownmenu'] = false;
                                        }
                                        else
                                        {
                                                $row2['pmb'] = $ilance->auction->construct_pmb_icon($_SESSION['ilancedata']['user']['userid'], $row2['user_id'], $row2['project_id']);
                                                $highbidderid = isset($highbidderid) ? intval($highbidderid) : 0;
                                                
                                                $row['project_id'] = isset($row['project_id']) ? $row['project_id'] : 0;
                                                $row2['work'] = $ilance->auction->construct_mediashare_icon($_SESSION['ilancedata']['user']['userid'], $highbidderid, $row2['project_id'], $active = false);
                                                $row2['invoice'] = '-';
                                                $row2['feedback'] = '-';
                                                
                                                ###########################
                                                ## INVITED RESULT LISTINGS?
                                                if (isset($bids_invited) AND $bids_invited)
                                                {
                                                        $row2['bid_id'] = $row2['project_id'];
                                                        $row2['actions'] = '<input type="checkbox" name="bidid[]" value="'.$row2['bid_id'].'" disabled="disabled" />';
                                                        $row2['livebid'] = '
<div id="applet'.$row2['project_id'].'"></div>
<script type="text/javascript">
var fo = new FlashObject("' . DIR_LIVEBID_NAME . '/livebid.swf", "applet'.$row2['project_id'].'", "730", "530", "8,0,0,0", "#ffffff");
fo.addParam("quality", "high");
fo.addParam("allowScriptAccess", "sameDomain");
fo.addParam("flashvars", "languageConfig=' . DIR_FUNCT_NAME . '/' . DIR_XML_NAME . '/livebid_' . $_SESSION['ilancedata']['user']['slng'] . '.xml&prId=' . $row2['project_id'] . '&sId=' . session_id() . '&rand=' . rand(100000, 999999) . '");
fo.addParam("menu", "false");
fo.write("applet'.$row2['project_id'].'");
</script>';
                                                        $row2['buyer'] = fetch_user('username', $row2['user_id']);
                                                        $row2['buyer_id'] = $row2['user_id'];
                                                        $row2['job_title'] = stripslashes($row2['project_title']);
                                                        
                                                        $row2['realtime_icon'] = '';
                                                        if ($row2['project_details'] == 'realtime')
                                                        {
                                                                $row2['realtime_icon'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'realtime.gif" alt="'.$phrase['_realtime_auction'].'" border="0" />';
                                                        }
                                                        
                                                        $row2['featured_icon'] = '';
                                                        if ($row2['featured'])
                                                        {
                                                                $row2['featured_icon'] = '<img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/dollarsign.gif" alt="'.$phrase['_featured'].'" border="0" />';
                                                        }
                                                        
                                                        $row2['icons'] = $ilance->auction->auction_icons($row2['project_id'], $row2['user_id']);
                                                        $row2['timeleft'] = $ilance->auction->calculate_time_left($row2['date_starts'], $row2['starttime'], $row2['mytime']);
                                                        
                                                        $rfpstatus = $row2['status'];
                                                        
                                                        $row2['bidamounttype'] = $row2['estimate_days'] = '';
                                                        $row2['measure'] = '<a href="'.$ilpage['rfp'].'?id='.$row2['project_id'].'">'.$phrase['_place_a_bid'].'</a>';
                                                        
                                                        if ($rfpstatus == 'open')
                                                        {
                                                                $row2['status'] = $phrase['_open_for_bids'];
                                                                $row2['bidamount'] = $phrase['_no_bid_placed'];
                                                                if ($ilconfig['globalauctionsettings_seourls'])
                                                                {
                                                                        $row2['nextstep'] = construct_seo_url('serviceauction', 0, $row2['bid_id'], $row2['project_title'], $phrase['_place_a_bid'], $bold = 0, $searchquestion = '', $questionid = 0, $answerid = 0);
                                                                }
                                                                else
                                                                {
                                                                    $row2['nextstep'] = '<a href="'.$ilpage['rfp'].'?id='.$row2['bid_id'].'">'.$phrase['_place_a_bid'].'</a>';
                                                                }
                                                        }
                                                        else if ($rfpstatus == 'closed')
                                                        {
                                                                $row2['status'] = $phrase['_event_closed'];
                                                                $row2['bidamount'] = $phrase['_no_bid_placed'];
                                                                $row2['nextstep'] = '-';
                                                        }
                                                        else if ($rfpstatus == 'expired')
                                                        {
                                                                $row2['status'] = $phrase['_event_closed'];
                                                                $row2['bidamount'] = $phrase['_no_bid_placed'];
                                                                $row2['nextstep'] = '-';
                                                        }
                                                        else if ($rfpstatus == 'wait_approval')
                                                        {
                                                                $row2['status'] = $phrase['_event_closed'];
                                                                $row2['bidamount'] = $phrase['_no_bid_placed'];
                                                                $row2['nextstep'] = '-';
                                                        }
                                                        else if ($rfpstatus == 'approval_accepted')
                                                        {
                                                                $row2['status'] = $phrase['_event_closed'];
                                                                $row2['bidamount'] = $phrase['_no_bid_placed'];
                                                                $row2['nextstep'] = '-';
                                                        }
                                                        else if ($rfpstatus == 'frozen')
                                                        {
                                                                $row2['status'] = $phrase['_frozen'];
                                                                $row2['bidamount'] = $phrase['_no_bid_placed'];
                                                                $row2['nextstep'] = '-';
                                                        }
                                                        else if ($rfpstatus == 'closed')
                                                        {
                                                                $row2['status'] = $phrase['_event_closed'];
                                                                $row2['bidamount'] = $phrase['_no_bid_placed'];
                                                                $row2['nextstep'] = '-';
                                                        }
                                                        else if ($rfpstatus == 'finished')
                                                        {
                                                                $row2['status'] = $phrase['_event_closed'];
                                                                $row2['bidamount'] = $phrase['_no_bid_placed'];
                                                                $row2['nextstep'] = '-';
                                                        }
                                                        else if ($rfpstatus == 'archived')
                                                        {
                                                                $row2['status'] = $phrase['_event_closed'];
                                                                $row2['bidamount'] = $phrase['_no_bid_placed'];
                                                                $row2['nextstep'] = '-';
                                                        }
                                                }
                                                else
                                                {
                                                        if (isset($ilance->GPC['bidsub']) AND $ilance->GPC['bidsub'] == 'expired'
                                                                OR isset($ilance->GPC['bidsub']) AND $ilance->GPC['bidsub'] == 'invited'
                                                                OR isset($ilance->GPC['bidsub']) AND $ilance->GPC['bidsub'] == 'delisted'
                                                                OR isset($ilance->GPC['bidsub']) AND $ilance->GPC['bidsub'] == 'archived')
                                                        {
                                                                $row2['actions'] = '<input type="checkbox" name="bidid[]" value="'.$row2['bid_id'].'" disabled="disabled" />';
                                                                $row2['nextstep'] = '-';
                                                                $row2['invoice'] = '-';
                                                                $row2['work'] = $ilance->auction->construct_mediashare_icon(-1, -1, -1, 0);
                                                        }
                                                        else
                                                        {
                                                                $row2['actions'] = '<input type="checkbox" name="bidid[]" value="' . $row2['bid_id'] . '" />';
                                                        }
                                                        
                                                        // live bid applet
                                                        $row2['livebid'] = '
<div id="applet' . $row2['project_id'] . '"></div>
<script type="text/javascript">
var fo = new FlashObject("' . DIR_LIVEBID_NAME . '/livebid.swf", "applet' . $row2['project_id'] . '", "730", "530", "8,0,0,0", "#ffffff");
fo.addParam("quality", "high");
fo.addParam("allowScriptAccess", "sameDomain");
fo.addParam("flashvars", "languageConfig=' . DIR_FUNCT_NAME . '/' . DIR_XML_NAME . '/livebid_' . $_SESSION['ilancedata']['user']['slng'] . '.xml&prId=' . $row2['project_id'] . '&sId=' . session_id() . '&rand=' . rand(100000, 999999) . '");
fo.addParam("menu", "false");
fo.write("applet' . $row2['project_id'] . '");
</script>';
                                                        
                                                        $row2['buyer'] = print_username($row2['user_id'], 'href', '', '');
                                                        $row2['buyer_id'] = $row2['user_id'];
                                                        if ($row2['bidstatus'] == 'placed' AND $row2['bidstate'] != 'wait_approval' AND (isset($ilance->GPC['bidsub']) AND $ilance->GPC['bidsub'] != 'archived'))
                                                        {
                                                                $row2['status'] = $phrase['_placed'];
                                                                $row2['nextstep'] = '-';
                                                        }
                                                        else if ($row2['bidstatus'] == 'placed' AND $row2['bidstate'] == 'wait_approval' AND $ilance->GPC['bidsub'] != 'archived')
                                                        {
                                                                $row2['status'] = $phrase['_waiting_approval'];
                                                                
                                                                $enc['acceptcrypted'] = array('cmd' => 'bid-management', 'sub' => '_accept-award', 'id' => $row2['bid_id']);
                                                                $enc['declinecrypted'] = array('cmd' => 'bid-management', 'sub' => '_decline-award', 'id' => $row2['bid_id']);
                                                                
                                                                $row2['nextstep'] = '
                                                                <table width="100%" border="0" cellspacing="0" cellpadding="0">
                                                                <tr>
                                                                        <td><a href="' . $ilpage['selling'] . '?crypted=' . encrypt_url($enc['acceptcrypted']) . '" onclick="return confirm_js(\'' . $phrase['_accept_this_service_auction_award_for'] . ' ' . $ilance->currency->format($row2['bidamount']) . '?\')" style="color:green"><strong>' . $phrase['_accept_award'] . '<strong></a></td>
                                                                </tr>
                                                                <tr>
                                                                        <td><strong>' . $phrase['_or_upper'] . '</strong> <br /><a href="' . $ilpage['selling'] . '?crypted=' . encrypt_url($enc['declinecrypted']) . '" onclick="return confirm_js(\'' . $phrase['_decline_this_service_auction_award_for'] . ' ' . $ilance->currency->format($row2['bidamount']) . '?\')" style="color:red">' . $phrase['_decline_award'] . '</a></td>
                                                                </tr>
                                                                </table>';
                                                                $row2['pmb'] = $ilance->auction->construct_pmb_icon($_SESSION['ilancedata']['user']['userid'], $row2['user_id'], $row2['project_id']);
                                                        }
                                                        else if ($row2['bidstatus'] == 'awarded' AND $ilance->GPC['bidsub'] != 'archived')
                                                        {
                                                                $row2['status'] = $phrase['_awarded'];
                                                                $row2['pmb'] = $ilance->auction->construct_pmb_icon($_SESSION['ilancedata']['user']['userid'], $row2['user_id'], $row2['project_id']);
                                                                $row2['invoice'] = $ilance->auction->construct_invoice_icon($_SESSION['ilancedata']['user']['userid'], $row2['user_id'], $row2['project_id']);
                                                                $row2['work'] = $ilance->auction->construct_mediashare_icon($row2['user_id'], $_SESSION['ilancedata']['user']['userid'], $row2['project_id'], $active = true);
                                                                
                                                                // escrow system enabled?
                                                                if ($ilconfig['escrowsystem_enabled'] AND $row2['filter_escrow'])
                                                                {
                                                                        // next step: leave feedback if escrow is paid
                                                                        $sql_escrowchk = $ilance->db->query("
                                                                                SELECT *
                                                                                FROM " . DB_PREFIX . "projects_escrow
                                                                                WHERE user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                                        AND project_user_id = '" . $row2['user_id'] . "'
                                                                                        AND project_id = '" . $row2['project_id'] . "'
                                                                                        AND status = 'pending'
                                                                        ");
                                                                        if ($ilance->db->num_rows($sql_escrowchk) > 0)
                                                                        {
                                                                                // we are waiting for escrow payment
                                                                                $row2['nextstep'] = $phrase['_pending_escrow'] . ' <a href="javascript:void(0);" onmouseover="Tip(\'' . $phrase['_pending_means_the_buyer_has_not_forwarded_funds_for_the_awarded_bid_amount'] . '\', BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a>';
                                                                        }
                                                                        else
                                                                        {
                                                                                // does auction have pending provider generated invoices that are unpaid?
                                                                                $sql_invchk = $ilance->db->query("
                                                                                        SELECT *
                                                                                        FROM " . DB_PREFIX . "invoices
                                                                                        WHERE user_id = '" . $row2['user_id'] . "'
                                                                                                AND p2b_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                                                AND projectid = '" . $row2['project_id'] . "'
                                                                                                AND status = 'unpaid'
                                                                                ");
                                                                                if ($ilance->db->num_rows($sql_invchk) > 0)
                                                                                {
                                                                                        $pendinvoices = '';
                                                                                        while ($res_inv = $ilance->db->fetch_array($sql_invchk))
                                                                                        {
                                                                                                $crypted = array(
                                                                                                        'cmd' => 'view',
                                                                                                        'txn' => $res_inv['transactionid']
                                                                                                );
                                                                                                
                                                                                                $pendinvoices .= '<a href="' . $ilpage['invoicepayment'] . '?crypted=' . encrypt_url($crypted) . '" title="' . $phrase['_this_invoice_has_not_been_paid_yet'] . '">#' . $res_inv['invoiceid'] . '</a> ';
                                                                                        }
                                                                                        
                                                                                        $row2['nextstep'] = '<span class="gray">' . $phrase['_unpaid'] . ':</span> <span class="blue">' . $pendinvoices . '</span>';
                                                                                }
                                                                                else
                                                                                {
                                                                                        $provider_rated_buyer = $buyer_rated_provider = 0;
                                                                                        
                                                                                        // has the service provider provided any feedback to the buyer?
                                                                                        if ($ilance->feedback->has_left_feedback($row2['user_id'], $_SESSION['ilancedata']['user']['userid'], $row2['project_id'], 'buyer'))
                                                                                        {
                                                                                                $provider_rated_buyer = 1;
                                                                                                $row2['feedback'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/checkmark.gif" border="0" alt="' . $phrase['_you_have_already_provided_feedback_and_ratings'] . '" /></div>';        
                                                                                        }
                                                                                        else
                                                                                        {
                                                                                                $crypted = array(
                                                                                                        'cmd' => '_leave-feedback',
                                                                                                        'type' => 'buyer',
                                                                                                        'project_id' => $row2['project_id'],
                                                                                                        'for_user_id' => $row2['user_id'],
                                                                                                        'from_user_id' => $_SESSION['ilancedata']['user']['userid']
                                                                                                );
                                                                                                
                                                                                                $row2['feedback'] = '<span class="gray">' . $phrase['_next'] . ':</span> <span class="blue"><a href="' . $ilpage['feedback'] . '?crypted=' . encrypt_url($crypted) . '"><strong>' . $phrase['_submit_feedback_for'] . ' ' . fetch_user('username', $row2['user_id']) . '</strong></a></span>';
                                                                                                $row2['nextstep'] = $phrase['_leave_feedback'] . ' <a href="javascript:void(0);" onmouseover="Tip(\'' . $phrase['_leave_feedback_lets_you_rate_the_service_provider_and_provide_feedback'] . '\', BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a>';
                                                                                        }
                                                                                        
                                                                                        // did the buyer give feedback to the service provider?
                                                                                        if ($ilance->feedback->has_left_feedback($_SESSION['ilancedata']['user']['userid'], $row2['user_id'], $row2['project_id'], 'seller'))
                                                                                        {
                                                                                                $buyer_rated_provider = 1;
                                                                                        }
                                                                                        else
                                                                                        {
                                                                                                $crypted = array(
                                                                                                        'cmd' => '_leave-feedback',
                                                                                                        'type' => 'buyer',
                                                                                                        'project_id' => $row2['project_id'],
                                                                                                        'for_user_id' => $row2['user_id'],
                                                                                                        'from_user_id' => $_SESSION['ilancedata']['user']['userid']
                                                                                                );
                                                                                                
                                                                                                //$row2['feedback'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/checkmark.gif" border="0" alt="' . $phrase['_you_have_already_provided_feedback_and_ratings'] . '" /></div>';
                                                                                                $row2['nextstep'] = '<span class="gray">' . $phrase['_pending_feedback_from'] . ' ' . fetch_user('username', $row2['user_id']) . '</span>';
                                                                                                //$row2['feedback'] = '-';
                                                                                        }
                                                                                        
                                                                                        if ($provider_rated_buyer AND $buyer_rated_provider)
                                                                                        {
                                                                                                // feedback exists: set as finished
                                                                                                $row2['nextstep'] = $phrase['_completed'];
                                                                                        }
                                                                                }
                                                                        }
                                                                }
                                                                
                                                                // #### ESCROW SYSTEM DISABLED
                                                                else
                                                                {
                                                                        // escrow system disabled
                                                                        
                                                                        // does auction have pending provider generated invoices unpaid?
                                                                        $sql_invchk = $ilance->db->query("
                                                                                SELECT *
                                                                                FROM " . DB_PREFIX . "invoices
                                                                                WHERE user_id = '" . $row2['user_id'] . "'
                                                                                        AND p2b_user_id = '" . $_SESSION['ilancedata']['user']['userid'] . "'
                                                                                        AND projectid = '" . $row2['project_id'] . "'
                                                                                        AND status = 'unpaid'
                                                                        ");
                                                                        if ($ilance->db->num_rows($sql_invchk) > 0)
                                                                        {
                                                                                $pendinvoices = '';
                                                                                while ($res_inv = $ilance->db->fetch_array($sql_invchk))
                                                                                {
                                                                                        $crypted = array('cmd' => 'view', 'txn' => $res_inv['transactionid']);
                                                                                        $pendinvoices .= '<span class="blue"><a href="' . $ilpage['invoicepayment'] . '?crypted=' . encrypt_url($crypted) . '" title="' . $phrase['_this_invoice_has_not_been_paid_yet'] . '">#' . $res_inv['invoiceid'] . '</a></span> ';
                                                                                }
                                                                                
                                                                                // pending invoices for auction still exist!
                                                                                $row2['nextstep'] = $phrase['_unpaid'] . ': ' . $pendinvoices;
                                                                        }
                                                                        else
                                                                        {
                                                                                $provider_rated_buyer = 0;
                                                                                $buyer_rated_provider = 0;
                                                                                
                                                                                // did service provider provide feedback to buyer?
                                                                                if ($ilance->feedback->has_left_feedback($row2['user_id'], $_SESSION['ilancedata']['user']['userid'], $row2['project_id'], 'buyer'))
                                                                                {
                                                                                        $provider_rated_buyer = 1;
                                                                                        $row2['feedback'] = '<div align="center"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'icons/checkmark.gif" border="0" alt="' . $phrase['_feedback_submitted__thank_you'] . '" /></div>';
                                                                                }
                                                                                else
                                                                                {
                                                                                        $crypted = array(
                                                                                                'cmd' => '_leave-feedback',
                                                                                                'type' => 'buyer',
                                                                                                'project_id' => $row2['project_id'],
                                                                                                'for_user_id' => $row2['user_id'],
                                                                                                'from_user_id' => $_SESSION['ilancedata']['user']['userid']
                                                                                        );
                                                                                        
                                                                                        $row2['feedback'] = '<span class="gray">' . $phrase['_next'] . ':</span> <span class="blue"><a href="' . $ilpage['feedback'] . '?crypted=' . encrypt_url($crypted) . '"><strong>' . $phrase['_submit_feedback_for'] . ' ' . fetch_user('username', $row2['user_id']) . '</strong></a></span>';
                                                                                        $row2['nextstep'] = $phrase['_leave_feedback'] . ' <a href="javascript:void(0);" onmouseover="Tip(\'' . $phrase['_leave_feedback_lets_you_rate_the_service_provider_and_provide_feedback'] . '\', BALLOON, true, ABOVE, true, OFFSETX, -17, FADEIN, 600, FADEOUT, 600, PADDING, 8)" onmouseout="UnTip()"><img src="' . $ilconfig['template_relativeimagepath'] . $ilconfig['template_imagesfolder'] . 'tooltipicon.gif" border="0" alt="" /></a>';
                                                                                }
                                                                                
                                                                                // has service buyer provided feedback to the service provider?
                                                                                if ($ilance->feedback->has_left_feedback($for_user_id = $_SESSION['ilancedata']['user']['userid'], $from_user_id = $row2['user_id'], $project_id = $row2['project_id'], $type = 'seller'))
                                                                                {
                                                                                        $buyer_rated_provider = 1;
                                                                                }
                                                                                else
                                                                                {
                                                                                        $row2['nextstep'] = '<span class="gray">' . $phrase['_pending_feedback_from'] . ' ' . fetch_user('username', $row2['user_id']) . '</span>';
                                                                                        //$row2['feedback'] = '-';
                                                                                }
                                                                                
                                                                                if ($provider_rated_buyer AND $buyer_rated_provider)
                                                                                {
                                                                                        // feedback exists: set as finished
                                                                                        $row2['nextstep'] = $phrase['_completed'];
                                                                                }
                                                                        }
                                                                }
                                                        }
                                                        else if ($row2['bidstatus'] == 'declined' AND $ilance->GPC['bidsub'] != 'archived')
                                                        {
                                                                $row2['status'] = $phrase['_declined'];
                                                                $row2['nextstep'] = '-';
                                                        }                                                                
                                                        if (!isset($row2['nextstep']))
                                                        {
                                                                // show rebid link
                                                                if ($row2['status'] == 'open')
                                                                {
                                                                        $row2['nextstep'] = '<span class="blue"><a href="' . $ilpage['rfp'] . '?cmd=bid&amp;id=' . $row2['project_id'] . '">' . $phrase['_rebid'] . '</a></span>';
                                                                }
                                                                else
                                                                {
                                                                        $row2['nextstep'] = '-';
                                                                }
                                                                        
                                                        }                                                                
                                                        $row2['bidamount'] = $ilance->currency->format($ilance->db->fetch_field(DB_PREFIX . "project_bids", "bid_id = '".$row2['bid_id']."'", "bidamount"));
                                                        $row2['measure'] = $ilance->auction->construct_measure($row2['bidamounttype']);
                                                        $row2['bidamounttype'] = $ilance->auction->construct_bidamounttype($row2['bidamounttype']);                                                                
                                                        $row2['job_title'] = '<a href="'.$ilpage['rfp'].'?id='.$row2['project_id'].'" title="'.$phrase['_the_title_of_the_service_auction_you_are_bidding_on'].'">'.stripslashes($row2['project_title']).'</a>';
                                                        $row2['icons'] = $ilance->auction->auction_icons($row2['project_id'], $row2['user_id']);
                                                        $row2['date_starts'] = isset($row2['date_starts']) ? $row2['date_starts'] : '';
                                                        $row2['timeleft'] = $ilance->auction->calculate_time_left($row2['date_starts'], $row2['starttime'], $row2['mytime']);
                                                }
                                                
                                                $row2['class'] = ($row_count2 % 2) ? 'alt2' : 'alt1';
                                                $show['no_service_bidding_activity'] = false;
                                                $service_bidding_activity[] = $row2;
                                                $show['bidpulldownmenu'] = true;
                                                $row_count2++;
                                        }
                                }
                        }
                        else
                        {
                                $show['no_service_bidding_activity'] = true;
                                $show['bidpulldownmenu'] = false;
                        }
                }

                // build query string for prev / next controls
                if (!empty($ilance->GPC) AND is_array($ilance->GPC))
                {
                        foreach ($ilance->GPC as $key => $value)
                        {
                                if ($key != 'page' AND $key != 'pp')
                                {
                                        if (!isset($searchquery))
                                        {
                                                $searchquery = '?' . $key . '=' . $value;
                                        }
                                        else
                                        {
                                                $searchquery .= '&amp;' . $key . '=' . $value;
                                        }
                                }        
                        }
                        $prevnext = print_pagnation($number, $ilconfig['globalfilters_maxrowsdisplay'], intval($ilance->GPC['page']), $counter, $ilpage['selling'] . $searchquery, 'page', $class = 'tfooter2');
                }
                if (!empty($ilance->GPC) AND is_array($ilance->GPC))
                {
                        foreach ($ilance->GPC as $key => $value)
                        {
                                if ($key != 'page2' AND $key != 'pp')
                                {
                                        if (!isset($searchquery))
                                        {
                                                $searchquery = '?' . $key . '=' . $value;
                                        }
                                        else
                                        {
                                                $searchquery .= '&amp;' . $key . '=' . $value;
                                        }
                                }        
                        }
                        
                        $prevnext2 = print_pagnation($number2, $ilconfig['globalfilters_maxrowsdisplay'], intval($ilance->GPC['page2']), $counter2, $ilpage['selling'] . $searchquery, 'page2');                        
                }
                if (!empty($ilance->GPC) AND is_array($ilance->GPC))
                {
                        foreach ($ilance->GPC as $key => $value)
                        {
                                if ($key != 'page3' AND $key != 'pp')
                                {
                                        if (!isset($searchquery))
                                        {
                                                $searchquery = '?' . $key . '=' . $value;
                                        }
                                        else
                                        {
                                                $searchquery .= '&amp;' . $key . '=' . $value;
                                        }
                                }        
                        }
                        $bidprevnext = print_pagnation($number3, $ilconfig['globalfilters_maxrowsdisplay'], intval($ilance->GPC['page3']), $counter3, $ilpage['selling'] . $searchquery, 'page3', 'tfooter2');
                }
                if (!empty($ilance->GPC) AND is_array($ilance->GPC))
                {
                        foreach ($ilance->GPC AS $key => $value)
                        {
                                if ($key != 'page4' AND $key != 'pp')
                                {
                                        if (!isset($searchquery))
                                        {
                                                $searchquery = '?' . $key . '=' . $value;
                                        }
                                        else
                                        {
                                                $searchquery .= '&amp;' . $key . '=' . $value;
                                        }
                                }        
                        }
                        $uniquebidprevnext = print_pagnation($number4, $ilconfig['globalfilters_maxrowsdisplay'], intval($ilance->GPC['page4']), $counter4, $ilpage['selling'] . $searchquery, 'page4', 'tfooter2');
                }
                
                $page = isset($ilance->GPC['page']) ? intval($ilance->GPC['page']) : 1;
                $sub = isset($ilance->GPC['sub']) ? $ilance->GPC['sub'] : '';
                $bidsub = isset($ilance->GPC['bidsub']) ? $ilance->GPC['bidsub'] : '';
                
                if (empty($ilance->GPC['bidsub']) OR isset($ilance->GPC['bidsub']) AND $ilance->GPC['bidsub'] != 'retracted')
                {
                        $headinclude .= '
<script language="Javascript">
function showPrompt()
{
        if (document.servicebids.bidcmd[1].selected == true)
        {
                var prompttext = ilance_prompt(phrase[\'_please_enter_the_reason_for_retracting_the_selected_bids\']);
                if (prompttext != null && prompttext != false && prompttext != \'\')
                {
                        fetch_js_object(\'bidretractreason\').value = prompttext;
                        return true;   
                }
                else
                {
                        if (prompttext == null || prompttext == false)
                        {
                                alert(phrase[\'_in_order_to_retract_one_or_more_bids_placed_you_must_provide\']);
                        }
                        
                        return false;
                }
        }

}
</script>';
                }
                
                if (isset($ilance->GPC['bidsub']) AND ($ilance->GPC['bidsub'] == 'retracted' OR $ilance->GPC['bidsub'] == 'archived'))
                {
                        $show['bidpulldownmenu'] = false;
                }
                
                $ilance->template->load_file('main', 'selling_activity.html', 0, 1);
                $ilance->template->parse_hash('main', array('ilpage' => $ilpage));
                $ilance->template->parse_loop('main', 'product_selling_activity');
                if (!isset($product_selling_activity))
                {
                        $product_selling_activity = array();
                }
                @reset($product_selling_activity);
                while ($i = @each($product_selling_activity))
                {
                        $ilance->template->parse_loop('main', 'product_selling_bidding_activity' . $i['value']['project_id']);
                        $ilance->template->parse_loop('main', 'product_selling_unique_bidding_activity' . $i['value']['project_id']);
                        $ilance->template->parse_loop('main', 'purchase_now_activity' . $i['value']['project_id']);
                }
                $ilance->template->parse_loop('main', 'service_bidding_activity');
                $ilance->template->parse_if_blocks('main');
                $ilance->template->pprint('main', array('sub','page','bidsub','producttabs','servicetabs','uniquebidprevnext','bidprevnext','activebids','awardedbids','archivedbids','declinedbids','invitedbids','expiredbids','serviceescrow','activeitems','archiveditems','delisteditems','expireditems','pendingitems','productescrow','highbidder','highbidderid','highest','php_self','searchquery','p_id','rfpvisible','countdeclined','prevnext','prevnext2','input_style','redirect','referer','login_include','headinclude','onload','area_title','page_title','site_name','https_server','http_server','lanceads_header','lanceads_footer'));
                exit();
        }		
}
else
{
	refresh($ilpage['login'] . '?redirect=' . urlencode($ilpage['selling'] . print_hidden_fields($string = true, $excluded = array(), $questionmarkfirst = true)));
	exit();
}

/*======================================================================*\
|| ####################################################################
|| # CVS: $RCSfile: selling.php,v $ - $Revision: 1.00 $
|| ####################################################################
\*======================================================================*/
?>